/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(ne){for(var e=[],D=0,N=ne.length;D<N;D++)e[D]=le[ne[D]];return e};define(le[123],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class D{static get(){const L=new Map,j=new Map,O=new Map,C=new Map;function S(c,g){c.has(g.detail)||c.set(g.detail,-g.timestamp)}function b(c,g){const p=c.get(g.detail);p&&(p>=0||c.set(g.detail,p+g.timestamp))}let R=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(R=ne.getStats().slice(0).sort((c,g)=>c.timestamp-g.timestamp));for(const c of R)switch(c.type){case 10:S(L,c);break;case 11:case 12:b(L,c);break;case 21:S(j,c);break;case 22:b(j,c);break;case 33:S(O,c);break;case 34:b(O,c);break;case 31:S(C,c);break;case 32:b(C,c);break}let k=0;O.forEach(c=>k+=c);function $(c){const g=[];return c.forEach((p,w)=>g.push([w,p])),g}return{amdLoad:$(L),amdInvoke:$(j),nodeRequire:$(O),nodeEval:$(C),nodeRequireTotal:k}}static toMarkdownTable(L,j){let O="";const C=[];return L.forEach((S,b)=>{C[b]=S.length}),j.forEach(S=>{S.forEach((b,R)=>{typeof b>"u"&&(b=S[R]="-");const k=b.toString().length;C[R]=Math.max(k,C[R])})}),L.forEach((S,b)=>{O+=`| ${S+" ".repeat(C[b]-S.toString().length)} `}),O+=`|
`,L.forEach((S,b)=>{O+=`| ${"-".repeat(C[b])} `}),O+=`|
`,j.forEach(S=>{S.forEach((b,R)=>{typeof b<"u"&&(O+=`| ${b+" ".repeat(C[R]-b.toString().length)} `)}),O+=`|
`}),O}}e.$T=D}),define(le[124],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function D(p,w,l){const u=N(p,w);if(u!==-1)return p[u]}e.$eb=D;function N(p,w,l=p.length-1){for(let u=l;u>=0;u--){const h=p[u];if(w(h))return u}return-1}e.$fb=N;function L(p,w){const l=j(p,w);return l===-1?void 0:p[l]}e.$gb=L;function j(p,w,l=0,u=p.length){let h=l,d=u;for(;h<d;){const E=Math.floor((h+d)/2);w(p[E])?h=E+1:d=E}return h-1}e.$hb=j;function O(p,w){const l=C(p,w);return l===p.length?void 0:p[l]}e.$ib=O;function C(p,w,l=0,u=p.length){let h=l,d=u;for(;h<d;){const E=Math.floor((h+d)/2);w(p[E])?d=E:h=E+1}return h}e.$jb=C;function S(p,w,l=0,u=p.length){const h=C(p,w,l,u);return h===p.length?-1:h}e.$kb=S;class b{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(b.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!w(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const l=j(this.e,w,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$lb=b;function R(p,w){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const h=p[u];w(h,l)>0&&(l=h)}return l}e.$mb=R;function k(p,w){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const h=p[u];w(h,l)>=0&&(l=h)}return l}e.$nb=k;function $(p,w){return R(p,(l,u)=>-w(l,u))}e.$ob=$;function c(p,w){if(p.length===0)return-1;let l=0;for(let u=1;u<p.length;u++){const h=p[u];w(h,p[l])>0&&(l=u)}return l}e.$pb=c;function g(p,w){for(const l of p){const u=w(l);if(u!==void 0)return u}}e.$qb=g}),define(le[125],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function D(O,C){const S=Object.create(null);for(const b of O){const R=C(b);let k=S[R];k||(k=S[R]=[]),k.push(b)}return S}e.$J=D;function N(O,C){const S=[],b=[];for(const R of O)C.has(R)||S.push(R);for(const R of C)O.has(R)||b.push(R);return{removed:S,added:b}}e.$K=N;function L(O,C){const S=[],b=[];for(const[R,k]of O)C.has(R)||S.push(k);for(const[R,k]of C)O.has(R)||b.push(k);return{removed:S,added:b}}e.$L=L;function j(O,C){const S=new Set;for(const b of C)O.has(b)&&S.add(b);return S}e.$M=j}),define(le[84],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=e.$rh=void 0;function D(O){return(C,S,b)=>{let R=null,k=null;if(typeof b.value=="function"?(R="value",k=b.value):typeof b.get=="function"&&(R="get",k=b.get),!k)throw new Error("not supported");b[R]=O(k,S)}}function N(O,C,S){let b=null,R=null;if(typeof S.value=="function"?(b="value",R=S.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(b="get",R=S.get),!R)throw new Error("not supported");const k=`$memoize$${C}`;S[b]=function(...$){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,$)}),this[k]}}e.$rh=N;function L(O,C,S){return D((b,R)=>{const k=`$debounce$${R}`,$=`$debounce$result$${R}`;return function(...c){this[$]||(this[$]=S?S():void 0),clearTimeout(this[k]),C&&(this[$]=C(this[$],...c),c=[this[$]]),this[k]=setTimeout(()=>{b.apply(this,c),this[$]=S?S():void 0},O)}})}e.$sh=L;function j(O,C,S){return D((b,R)=>{const k=`$throttle$timer$${R}`,$=`$throttle$result$${R}`,c=`$throttle$lastRun$${R}`,g=`$throttle$pending$${R}`;return function(...p){if(this[$]||(this[$]=S?S():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),C&&(this[$]=C(this[$],...p)),this[g])return;const w=this[c]+O;w<=Date.now()?(this[c]=Date.now(),b.apply(this,[this[$]]),this[$]=S?S():void 0):(this[g]=!0,this[k]=setTimeout(()=>{this[g]=!1,this[c]=Date.now(),b.apply(this,[this[$]]),this[$]=S?S():void 0},w-Date.now()))}})}e.$th=j}),define(le[7],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class D{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?h.isErrorNoTelemetry(s)?new h(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(o=>{o(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$V=D,e.$W=new D;function N(E){e.$W.setUnexpectedErrorHandler(E)}e.setUnexpectedErrorHandler=N;function L(E){if(!E||typeof E!="object")return!1;const s=E;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.$Y=L;function j(E){b(E)||e.$W.onUnexpectedError(E)}e.$Z=j;function O(E){b(E)||e.$W.onUnexpectedExternalError(E)}e.$1=O;function C(E){if(E instanceof Error){const{name:s,message:o}=E,n=E.stacktrace||E.stack;return{$isError:!0,name:s,message:o,stack:n,noTelemetry:h.isErrorNoTelemetry(E)}}return E}e.$2=C;const S="Canceled";function b(E){return E instanceof R?!0:E instanceof Error&&E.name===S&&E.message===S}e.$3=b;class R extends Error{constructor(){super(S),this.name=this.message}}e.$4=R;function k(){const E=new Error(S);return E.name=E.message,E}e.$5=k;function $(E){return E?new Error(`Illegal argument: ${E}`):new Error("Illegal argument")}e.$6=$;function c(E){return E?new Error(`Illegal state: ${E}`):new Error("Illegal state")}e.$7=c;class g extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=g;function p(E){return E?E.message?E.message:E.stack?E.stack.split(`
`)[0]:String(E):"Error"}e.$9=p;class w extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$0=w;class l extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$$=l;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=u;class h extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof h)return s;const o=new h;return o.message=s.message,o.stack=s.stack,o}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$ab=h;class d extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$bb=d}),define(le[18],he([0,1,7,124]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function L(q,ee=0){return q[q.length-(1+ee)]}e.$rb=L;function j(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.$sb=j;function O(q,ee,H=(Z,ie)=>Z===ie){if(q===ee)return!0;if(!q||!ee||q.length!==ee.length)return!1;for(let Z=0,ie=q.length;Z<ie;Z++)if(!H(q[Z],ee[Z]))return!1;return!0}e.$tb=O;function C(q,ee){const H=q.length-1;ee<H&&(q[ee]=q[H]),q.pop()}e.$ub=C;function S(q,ee,H){return b(q.length,Z=>H(q[Z],ee))}e.$vb=S;function b(q,ee){let H=0,Z=q-1;for(;H<=Z;){const ie=(H+Z)/2|0,ce=ee(ie);if(ce<0)H=ie+1;else if(ce>0)Z=ie-1;else return ie}return-(H+1)}e.$wb=b;function R(q,ee,H){if(q=q|0,q>=ee.length)throw new TypeError("invalid index");const Z=ee[Math.floor(ee.length*Math.random())],ie=[],ce=[],oe=[];for(const fe of ee){const de=H(fe,Z);de<0?ie.push(fe):de>0?ce.push(fe):oe.push(fe)}return q<ie.length?R(q,ie,H):q<ie.length+oe.length?oe[0]:R(q-(ie.length+oe.length),ce,H)}e.$xb=R;function k(q,ee){const H=[];let Z;for(const ie of q.slice(0).sort(ee))!Z||ee(Z[0],ie)!==0?(Z=[ie],H.push(Z)):Z.push(ie);return H}e.$yb=k;function*$(q,ee){let H,Z;for(const ie of q)Z!==void 0&&ee(Z,ie)?H.push(ie):(H&&(yield H),H=[ie]),Z=ie;H&&(yield H)}e.$zb=$;function c(q,ee){for(let H=0;H<=q.length;H++)ee(H===0?void 0:q[H-1],H===q.length?void 0:q[H])}e.$Ab=c;function g(q,ee){for(let H=0;H<q.length;H++)ee(H===0?void 0:q[H-1],q[H],H+1===q.length?void 0:q[H+1])}e.$Bb=g;function p(q,ee,H){const Z=[];function ie(fe,de,we){if(de===0&&we.length===0)return;const ve=Z[Z.length-1];ve&&ve.start+ve.deleteCount===fe?(ve.deleteCount+=de,ve.toInsert.push(...we)):Z.push({start:fe,deleteCount:de,toInsert:we})}let ce=0,oe=0;for(;;){if(ce===q.length){ie(ce,0,ee.slice(oe));break}if(oe===ee.length){ie(ce,q.length-ce,[]);break}const fe=q[ce],de=ee[oe],we=H(fe,de);we===0?(ce+=1,oe+=1):we<0?(ie(ce,1,[]),ce+=1):we>0&&(ie(ce,0,[de]),oe+=1)}return Z}e.$Cb=p;function w(q,ee,H){const Z=p(q,ee,H),ie=[],ce=[];for(const oe of Z)ie.push(...q.slice(oe.start,oe.start+oe.deleteCount)),ce.push(...oe.toInsert);return{removed:ie,added:ce}}e.$Db=w;function l(q,ee,H){if(H===0)return[];const Z=q.slice(0,H).sort(ee);return h(q,ee,Z,H,q.length),Z}e.top=l;function u(q,ee,H,Z,ie){return H===0?Promise.resolve([]):new Promise((ce,oe)=>{(async()=>{const fe=q.length,de=q.slice(0,H).sort(ee);for(let we=H,ve=Math.min(H+Z,fe);we<fe;we=ve,ve=Math.min(ve+Z,fe)){if(we>H&&await new Promise(Ie=>setTimeout(Ie)),ie&&ie.isCancellationRequested)throw new D.$4;h(q,ee,de,we,ve)}return de})().then(ce,oe)})}e.$Fb=u;function h(q,ee,H,Z,ie){for(const ce=H.length;Z<ie;Z++){const oe=q[Z];if(ee(oe,H[ce-1])<0){H.pop();const fe=(0,N.$jb)(H,de=>ee(oe,de)<0);H.splice(fe,0,oe)}}}function d(q){return q.filter(ee=>!!ee)}e.$Gb=d;function E(q){let ee=0;for(let H=0;H<q.length;H++)q[H]&&(q[ee]=q[H],ee+=1);q.length=ee}e.$Hb=E;function s(q,ee,H){q.splice(H,0,q.splice(ee,1)[0])}e.$Ib=s;function o(q){return!Array.isArray(q)||q.length===0}e.$Jb=o;function n(q){return Array.isArray(q)&&q.length>0}e.$Kb=n;function i(q,ee=H=>H){const H=new Set;return q.filter(Z=>{const ie=ee(Z);return H.has(ie)?!1:(H.add(ie),!0)})}e.$Lb=i;function t(q){const ee=new Set;return H=>{const Z=q(H);return ee.has(Z)?!1:(ee.add(Z),!0)}}e.$Mb=t;function r(q,ee){return q.length>0?q[0]:ee}e.$Nb=r;function a(q,ee){return q.length>0?q[q.length-1]:ee}e.$Ob=a;function v(q,ee,H=(Z,ie)=>Z===ie){let Z=0;for(let ie=0,ce=Math.min(q.length,ee.length);ie<ce&&H(q[ie],ee[ie]);ie++)Z++;return Z}e.$Pb=v;function m(q){return[].concat(...q)}e.$Qb=m;function f(q,ee){let H=typeof ee=="number"?q:0;typeof ee=="number"?H=q:(H=0,ee=q);const Z=[];if(H<=ee)for(let ie=H;ie<ee;ie++)Z.push(ie);else for(let ie=H;ie>ee;ie--)Z.push(ie);return Z}e.$Rb=f;function y(q,ee,H){return q.reduce((Z,ie)=>(Z[ee(ie)]=H?H(ie):ie,Z),Object.create(null))}e.$Sb=y;function I(q,ee){return q.push(ee),()=>F(q,ee)}e.$Tb=I;function F(q,ee){const H=q.indexOf(ee);if(H>-1)return q.splice(H,1),ee}e.$Ub=F;function T(q,ee,H){const Z=q.slice(0,ee),ie=q.slice(ee);return Z.concat(H,ie)}e.$Vb=T;function M(q,ee){let H;if(typeof ee=="number"){let Z=ee;H=()=>{const ie=Math.sin(Z++)*179426549;return ie-Math.floor(ie)}}else H=Math.random;for(let Z=q.length-1;Z>0;Z-=1){const ie=Math.floor(H()*(Z+1)),ce=q[Z];q[Z]=q[ie],q[ie]=ce}}e.$Wb=M;function U(q,ee){const H=q.indexOf(ee);H>-1&&(q.splice(H,1),q.unshift(ee))}e.$Xb=U;function Y(q,ee){const H=q.indexOf(ee);H>-1&&(q.splice(H,1),q.push(ee))}e.$Yb=Y;function J(q,ee){for(const H of ee)q.push(H)}e.$Zb=J;function x(q,ee){return Array.isArray(q)?q.map(ee):ee(q)}e.$1b=x;function W(q){return Array.isArray(q)?q:[q]}e.$2b=W;function X(q){return q[Math.floor(Math.random()*q.length)]}e.$3b=X;function V(q,ee,H){const Z=te(q,ee),ie=q.length,ce=H.length;q.length=ie+ce;for(let oe=ie-1;oe>=Z;oe--)q[oe+ce]=q[oe];for(let oe=0;oe<ce;oe++)q[oe+Z]=H[oe]}e.$4b=V;function B(q,ee,H,Z){const ie=te(q,ee);let ce=q.splice(ie,H);return ce===void 0&&(ce=[]),V(q,ie,Z),ce}e.$5b=B;function te(q,ee){return ee<0?Math.max(ee+q.length,0):Math.min(ee,q.length)}var se;(function(q){function ee(ce){return ce<0}q.isLessThan=ee;function H(ce){return ce<=0}q.isLessThanOrEqual=H;function Z(ce){return ce>0}q.isGreaterThan=Z;function ie(ce){return ce===0}q.isNeitherLessOrGreaterThan=ie,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(se||(e.CompareResult=se={}));function _(q,ee){return(H,Z)=>ee(q(H),q(Z))}e.$6b=_;function re(...q){return(ee,H)=>{for(const Z of q){const ie=Z(ee,H);if(!se.isNeitherLessOrGreaterThan(ie))return ie}return se.neitherLessOrGreaterThan}}e.$7b=re;const K=(q,ee)=>q-ee;e.$8b=K;const z=(q,ee)=>(0,e.$8b)(q?1:0,ee?1:0);e.$9b=z;function P(q){return(ee,H)=>-q(ee,H)}e.$0b=P;class A{constructor(ee){this.g=ee,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let H=this.c;for(;H<this.g.length&&ee(this.g[H]);)H++;const Z=H===this.c?null:this.g.slice(this.c,H);return this.c=H,Z}takeFromEndWhile(ee){let H=this.d;for(;H>=0&&ee(this.g[H]);)H--;const Z=H===this.d?null:this.g.slice(H+1,this.d+1);return this.d=H,Z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ee=this.g[this.c];return this.c++,ee}removeLast(){const ee=this.g[this.d];return this.d--,ee}takeCount(ee){const H=this.g.slice(this.c,this.c+ee);return this.c+=ee,H}}e.$$b=A;class G{static{this.empty=new G(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(H=>(ee(H),!0))}toArray(){const ee=[];return this.iterate(H=>(ee.push(H),!0)),ee}filter(ee){return new G(H=>this.iterate(Z=>ee(Z)?H(Z):!0))}map(ee){return new G(H=>this.iterate(Z=>H(ee(Z))))}some(ee){let H=!1;return this.iterate(Z=>(H=ee(Z),!H)),H}findFirst(ee){let H;return this.iterate(Z=>ee(Z)?(H=Z,!1):!0),H}findLast(ee){let H;return this.iterate(Z=>(ee(Z)&&(H=Z),!0)),H}findLastMaxBy(ee){let H,Z=!0;return this.iterate(ie=>((Z||se.isGreaterThan(ee(ie,H)))&&(Z=!1,H=ie),!0)),H}}e.$_b=G}),define(le[126],he([0,1,7]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function N(S,b){if(!S)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=N;function L(S,b="Unreachable"){throw new Error(b)}e.$4c=L;function j(S){if(!S)throw new D.$bb("Assertion Failed")}e.$5c=j;function O(S){if(!S()){debugger;S(),(0,D.$Z)(new D.$bb("Assertion Failed"))}}e.$6c=O;function C(S,b){let R=0;for(;R<S.length-1;){const k=S[R],$=S[R+1];if(!b(k,$))return!1;R++}return!0}e.$7c=C}),define(le[85],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function D(N,L){const j=this;let O=!1,C;return function(){if(O)return C;if(O=!0,L)try{C=N.apply(j,arguments)}finally{L()}else C=N.apply(j,arguments);return C}}e.$cb=D}),define(le[61],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(N){function L(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}N.is=L;const j=Object.freeze([]);function O(){return j}N.empty=O;function*C(E){yield E}N.single=C;function S(E){return L(E)?E:C(E)}N.wrap=S;function b(E){return E||j}N.from=b;function*R(E){for(let s=E.length-1;s>=0;s--)yield E[s]}N.reverse=R;function k(E){return!E||E[Symbol.iterator]().next().done===!0}N.isEmpty=k;function $(E){return E[Symbol.iterator]().next().value}N.first=$;function c(E,s){for(const o of E)if(s(o))return!0;return!1}N.some=c;function g(E,s){for(const o of E)if(s(o))return o}N.find=g;function*p(E,s){for(const o of E)s(o)&&(yield o)}N.filter=p;function*w(E,s){let o=0;for(const n of E)yield s(n,o++)}N.map=w;function*l(...E){for(const s of E)for(const o of s)yield o}N.concat=l;function u(E,s,o){let n=o;for(const i of E)n=s(n,i);return n}N.reduce=u;function*h(E,s,o=E.length){for(s<0&&(s+=E.length),o<0?o+=E.length:o>E.length&&(o=E.length);s<o;s++)yield E[s]}N.slice=h;function d(E,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,E];const n=E[Symbol.iterator]();for(let i=0;i<s;i++){const t=n.next();if(t.done)return[o,N.empty()];o.push(t.value)}return[o,{[Symbol.iterator](){return n}}]}N.consume=d})(D||(e.Iterable=D={}))}),define(le[35],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var N;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var j;(function(s){s.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function O(s,o=!1){let n=0;const i=s.length;let t="",r=0,a=16,v=0;function m(U){let Y=0,J=0;for(;Y<U;){const x=s.charCodeAt(n);if(x>=48&&x<=57)J=J*16+x-48;else if(x>=65&&x<=70)J=J*16+x-65+10;else if(x>=97&&x<=102)J=J*16+x-97+10;else break;n++,Y++}return Y<U&&(J=-1),J}function f(U){n=U,t="",r=0,a=16,v=0}function y(){const U=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&b(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&b(s.charCodeAt(n)))for(n++;n<s.length&&b(s.charCodeAt(n));)n++;else return v=3,s.substring(U,n);let Y=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&b(s.charCodeAt(n))){for(n++;n<s.length&&b(s.charCodeAt(n));)n++;Y=n}else v=3;return s.substring(U,Y)}function I(){let U="",Y=n;for(;;){if(n>=i){U+=s.substring(Y,n),v=2;break}const J=s.charCodeAt(n);if(J===34){U+=s.substring(Y,n),n++;break}if(J===92){if(U+=s.substring(Y,n),n++,n>=i){v=2;break}switch(s.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const W=m(4);W>=0?U+=String.fromCharCode(W):v=4;break}default:v=5}Y=n;continue}if(J>=0&&J<=31)if(S(J)){U+=s.substring(Y,n),v=2;break}else v=6;n++}return U}function F(){if(t="",v=0,r=n,n>=i)return r=i,a=17;let U=s.charCodeAt(n);if(C(U)){do n++,t+=String.fromCharCode(U),U=s.charCodeAt(n);while(C(U));return a=15}if(S(U))return n++,t+=String.fromCharCode(U),U===13&&s.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(U){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=I(),a=10;case 47:{const Y=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!S(s.charCodeAt(n));)n++;return t=s.substring(Y,n),a=12}if(s.charCodeAt(n+1)===42){n+=2;const J=i-1;let x=!1;for(;n<J;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=s.substring(Y,n),a=13}return t+=String.fromCharCode(U),n++,a=16}case 45:if(t+=String.fromCharCode(U),n++,n===i||!b(s.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=y(),a=11;default:for(;n<i&&T(U);)n++,U=s.charCodeAt(n);if(r!==n){switch(t=s.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(U),n++,a=16}}function T(U){if(C(U)||S(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let U;do U=F();while(U>=12&&U<=15);return U}return{setPosition:f,getPosition:()=>n,scan:o?M:F,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$5m=O;function C(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function b(s){return s>=48&&s<=57}var R;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(R||(R={}));function k(s,o){const n=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function v(m,f,y,I){r.value=m,r.offset=f,r.length=y,r.type=I,r.colonOffset=void 0,t=r}try{h(s,{onObjectBegin:(m,f)=>{if(o<=m)throw i;t=void 0,a=o>m,n.push("")},onObjectProperty:(m,f,y)=>{if(o<f||(v(m,f,y,"property"),n[n.length-1]=m,o<=f+y))throw i},onObjectEnd:(m,f)=>{if(o<=m)throw i;t=void 0,n.pop()},onArrayBegin:(m,f)=>{if(o<=m)throw i;t=void 0,n.push(0)},onArrayEnd:(m,f)=>{if(o<=m)throw i;t=void 0,n.pop()},onLiteralValue:(m,f,y)=>{if(o<f||(v(m,f,y,E(m)),o<=f+y))throw i},onSeparator:(m,f,y)=>{if(o<=f)throw i;if(m===":"&&t&&t.type==="property")t.colonOffset=f,a=!1,t=void 0;else if(m===","){const I=n[n.length-1];typeof I=="number"?n[n.length-1]=I+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(m){if(m!==i)throw m}return{path:n,previousNode:t,isAtPropertyKey:a,matches:m=>{let f=0;for(let y=0;f<m.length&&y<n.length;y++)if(m[f]===n[y]||m[f]==="*")f++;else if(m[f]!=="**")return!1;return f===m.length}}}e.$6m=k;function $(s,o=[],n=j.DEFAULT){let i=null,t=[];const r=[];function a(m){Array.isArray(t)?t.push(m):i!==null&&(t[i]=m)}return h(s,{onObjectBegin:()=>{const m={};a(m),r.push(t),t=m,i=null},onObjectProperty:m=>{i=m},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const m=[];a(m),r.push(t),t=m,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(m,f,y)=>{o.push({error:m,offset:f,length:y})}},n),t[0]}e.$7m=$;function c(s,o=[],n=j.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(m){i.type==="property"&&(i.length=m-i.offset,i=i.parent)}function r(m){return i.children.push(m),m}h(s,{onObjectBegin:m=>{i=r({type:"object",offset:m,length:-1,parent:i,children:[]})},onObjectProperty:(m,f,y)=>{i=r({type:"property",offset:f,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:m,offset:f,length:y,parent:i})},onObjectEnd:(m,f)=>{i.length=m+f-i.offset,i=i.parent,t(m+f)},onArrayBegin:(m,f)=>{i=r({type:"array",offset:m,length:-1,parent:i,children:[]})},onArrayEnd:(m,f)=>{i.length=m+f-i.offset,i=i.parent,t(m+f)},onLiteralValue:(m,f,y)=>{r({type:E(m),offset:f,length:y,parent:i,value:m}),t(f+y)},onSeparator:(m,f,y)=>{i.type==="property"&&(m===":"?i.colonOffset=f:m===","&&t(f))},onError:(m,f,y)=>{o.push({error:m,offset:f,length:y})}},n);const v=i.children[0];return v&&delete v.parent,v}e.$8m=c;function g(s,o){if(!s)return;let n=s;for(const i of o)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===i){n=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$9m=g;function p(s){if(!s.parent||!s.parent.children)return[];const o=p(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;o.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&o.push(n)}return o}e.$0m=p;function w(s){switch(s.type){case"array":return s.children.map(w);case"object":{const o=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(o[n.children[0].value]=w(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$$m=w;function l(s,o,n=!1){return o>=s.offset&&o<s.offset+s.length||n&&o===s.offset+s.length}e.$_m=l;function u(s,o,n=!1){if(l(s,o,n)){const i=s.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=o;t++){const r=u(i[t],o,n);if(r)return r}return s}}e.$an=u;function h(s,o,n=j.DEFAULT){const i=O(s,!1);function t(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(_){return _?re=>_(re,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),v=r(o.onObjectProperty),m=t(o.onObjectEnd),f=t(o.onArrayBegin),y=t(o.onArrayEnd),I=r(o.onLiteralValue),F=r(o.onSeparator),T=t(o.onComment),M=r(o.onError),U=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function J(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:U||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(_){case 12:case 13:U?x(10):T();break;case 16:x(1);break;case 15:case 14:break;default:return _}}}function x(_,re=[],K=[]){if(M(_),re.length+K.length>0){let z=i.getToken();for(;z!==17;){if(re.indexOf(z)!==-1){J();break}else if(K.indexOf(z)!==-1)break;z=J()}}}function W(_){const re=i.getTokenValue();return _?I(re):v(re),J(),!0}function X(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(x(2),_=0)}catch{x(2)}I(_);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return J(),!0}function V(){return i.getToken()!==10?(x(3,[],[2,5]),!1):(W(!1),i.getToken()===6?(F(":"),J(),se()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function B(){a(),J();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),F(","),J(),i.getToken()===2&&Y)break}else _&&x(6,[],[]);V()||x(4,[],[2,5]),_=!0}return m(),i.getToken()!==2?x(7,[2],[]):J(),!0}function te(){f(),J();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),F(","),J(),i.getToken()===4&&Y)break}else _&&x(6,[],[]);se()||x(4,[],[4,5]),_=!0}return y(),i.getToken()!==4?x(8,[4],[]):J(),!0}function se(){switch(i.getToken()){case 3:return te();case 1:return B();case 10:return W(!0);default:return X()}}return J(),i.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):se()?(i.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$bn=h;function d(s,o){const n=O(s),i=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&i.push(s.substring(r,a)),o!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return i.join("")}e.$cn=d;function E(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$dn=E}),define(le[42],he([0,1,35]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GT=e.$FT=e.$ET=e.$DT=void 0;function N(b,R,k){let $,c,g,p,w;if(R){for(p=R.offset,w=p+R.length,g=p;g>0&&!S(b,g-1);)g--;let a=w;for(;a<b.length&&!S(b,a);)a++;c=b.substring(g,a),$=O(c,k)}else c=b,$=0,g=0,p=0,w=b.length;const l=C(k,b);let u=!1,h=0,d;k.insertSpaces?d=j(" ",k.tabSize||4):d="	";const E=(0,D.$5m)(c,!1);let s=!1;function o(){return l+j(d,$+h)}function n(){let a=E.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=E.scan();return s=a===16||E.getTokenError()!==0,a}const i=[];function t(a,v,m){!s&&v<w&&m>p&&b.substring(v,m)!==a&&i.push({offset:v,length:m-v,content:a})}let r=n();if(r!==17){const a=E.getTokenOffset()+g,v=j(d,$);t(v,g,a)}for(;r!==17;){let a=E.getTokenOffset()+E.getTokenLength()+g,v=n(),m="";for(;!u&&(v===12||v===13);){const y=E.getTokenOffset()+g;t(" ",a,y),a=E.getTokenOffset()+E.getTokenLength()+g,m=v===12?o():"",v=n()}if(v===2)r!==1&&(h--,m=o());else if(v===4)r!==3&&(h--,m=o());else{switch(r){case 3:case 1:h++,m=o();break;case 5:case 12:m=o();break;case 13:u?m=o():m=" ";break;case 6:m=" ";break;case 10:if(v===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?m=" ":v!==5&&v!==17&&(s=!0);break;case 16:s=!0;break}u&&(v===12||v===13)&&(m=o())}const f=E.getTokenOffset()+g;t(m,a,f),r=v}return i}e.$DT=N;function L(b,R){const k=JSON.stringify(b,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?k.replace(/\r\n|\r|\n/g,R.eol):k}e.$ET=L;function j(b,R){let k="";for(let $=0;$<R;$++)k+=b;return k}function O(b,R){let k=0,$=0;const c=R.tabSize||4;for(;k<b.length;){const g=b.charAt(k);if(g===" ")$++;else if(g==="	")$+=c;else break;k++}return Math.floor($/c)}function C(b,R){for(let k=0;k<R.length;k++){const $=R.charAt(k);if($==="\r")return k+1<R.length&&R.charAt(k+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return b&&b.eol||`
`}e.$FT=C;function S(b,R){return`\r
`.indexOf(b.charAt(R))!==-1}e.$GT=S}),define(le[86],he([0,1,35,42]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LT=e.$KT=e.$JT=e.$IT=e.$HT=void 0;function L(b,R,k){return j(b,R,void 0,k)}e.$HT=L;function j(b,R,k,$,c){const g=R.slice(),p=[],w=(0,D.$8m)(b,p);let l,u;for(;g.length>0&&(u=g.pop(),l=(0,D.$9m)(w,g),l===void 0&&k!==void 0);)typeof u=="string"?k={[u]:k}:k=[k];if(l)if(l.type==="object"&&typeof u=="string"&&Array.isArray(l.children)){const h=(0,D.$9m)(l,[u]);if(h!==void 0)if(k===void 0){if(!h.parent)throw new Error("Malformed AST");const d=l.children.indexOf(h.parent);let E,s=h.parent.offset+h.parent.length;if(d>0){const o=l.children[d-1];E=o.offset+o.length}else E=l.offset+1,l.children.length>1&&(s=l.children[1].offset);return O(b,{offset:E,length:s-E,content:""},$)}else return O(b,{offset:h.offset,length:h.length,content:JSON.stringify(k)},$);else{if(k===void 0)return[];const d=`${JSON.stringify(u)}: ${JSON.stringify(k)}`,E=c?c(l.children.map(o=>o.children[0].value)):l.children.length;let s;if(E>0){const o=l.children[E-1];s={offset:o.offset+o.length,length:0,content:","+d}}else l.children.length===0?s={offset:l.offset+1,length:0,content:d}:s={offset:l.offset+1,length:0,content:d+","};return O(b,s,$)}}else if(l.type==="array"&&typeof u=="number"&&Array.isArray(l.children))if(k!==void 0){const h=`${JSON.stringify(k)}`;let d;if(l.children.length===0||u===0)d={offset:l.offset+1,length:0,content:l.children.length===0?h:h+","};else{const E=u===-1||u>l.children.length?l.children.length:u,s=l.children[E-1];d={offset:s.offset+s.length,length:0,content:","+h}}return O(b,d,$)}else{const h=u,d=l.children[h];let E;if(l.children.length===1)E={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===h){const s=l.children[h-1],o=s.offset+s.length,n=l.offset+l.length;E={offset:o,length:n-2-o,content:""}}else E={offset:d.offset,length:l.children[h+1].offset-d.offset,content:""};return O(b,E,$)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${l.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return O(b,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(k)},$)}}e.$IT=j;function O(b,R,k){let $=C(b,R),c=R.offset,g=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;c>0&&!(0,N.$GT)($,c-1);)c--;for(;g<$.length&&!(0,N.$GT)($,g);)g++}const p=(0,N.$DT)($,{offset:c,length:g-c},k);for(let l=p.length-1;l>=0;l--){const u=p[l];$=C($,u),c=Math.min(c,u.offset),g=Math.max(g,u.offset+u.length),g+=u.content.length-u.length}const w=b.length-($.length-g)-c;return[{offset:c,length:w,content:$.substring(c,g)}]}e.$JT=O;function C(b,R){return b.substring(0,R.offset)+R.content+b.substring(R.offset+R.length)}e.$KT=C;function S(b,R){const k=R.slice(0).sort((c,g)=>{const p=c.offset-g.offset;return p===0?c.length-g.length:p});let $=b.length;for(let c=k.length-1;c>=0;c--){const g=k[c];if(g.offset+g.length<=$)b=C(b,g);else throw new Error("Overlapping edit");$=g.offset}return b}e.$LT=S}),define(le[52],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class D{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=D}),define(le[87],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(j){this.element=j,this.next=D.Undefined,this.prev=D.Undefined}}class N{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let j=this.a;for(;j!==D.Undefined;){const O=j.next;j.prev=D.Undefined,j.next=D.Undefined,j=O}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,O){const C=new D(j);if(this.a===D.Undefined)this.a=C,this.b=C;else if(O){const b=this.b;this.b=C,C.prev=b,b.next=C}else{const b=this.a;this.a=C,C.next=b,b.prev=C}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(C))}}shift(){if(this.a!==D.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==D.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==D.Undefined&&j.next!==D.Undefined){const O=j.prev;O.next=j.next,j.next.prev=O}else j.prev===D.Undefined&&j.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):j.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):j.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==D.Undefined;)yield j.element,j=j.next}}e.$2c=N}),define(le[34],he([0,1]),function(ne,e){"use strict";var D,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function j(u,h,d){let E=u.get(h);return E===void 0&&(E=d,u.set(h,E)),E}e.$wc=j;function O(u){const h=[];return u.forEach((d,E)=>{h.push(`${E} => ${d}`)}),`Map(${u.size}) {${h.join(", ")}}`}e.$xc=O;function C(u){const h=[];return u.forEach(d=>{h.push(d)}),`Set(${u.size}) {${h.join(", ")}}`}e.$yc=C;class S{constructor(h,d){this.uri=h,this.value=d}}function b(u){return Array.isArray(u)}class R{static{this.a=h=>h.toString()}constructor(h,d){if(this[D]="ResourceMap",h instanceof R)this.b=new Map(h.b),this.c=d??R.a;else if(b(h)){this.b=new Map,this.c=d??R.a;for(const[E,s]of h)this.set(E,s)}else this.b=new Map,this.c=h??R.a}set(h,d){return this.b.set(this.c(h),new S(h,d)),this}get(h){return this.b.get(this.c(h))?.value}has(h){return this.b.has(this.c(h))}get size(){return this.b.size}clear(){this.b.clear()}delete(h){return this.b.delete(this.c(h))}forEach(h,d){typeof d<"u"&&(h=h.bind(d));for(const[E,s]of this.b)h(s.value,s.uri,this)}*values(){for(const h of this.b.values())yield h.value}*keys(){for(const h of this.b.values())yield h.uri}*entries(){for(const h of this.b.values())yield[h.uri,h.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.b)yield[h.uri,h.value]}}e.$zc=R;class k{constructor(h,d){this[N]="ResourceSet",!h||typeof h=="function"?this.a=new R(h):(this.a=new R(d),h.forEach(this.add,this))}get size(){return this.a.size}add(h){return this.a.set(h,h),this}clear(){this.a.clear()}delete(h){return this.a.delete(h)}forEach(h,d){this.a.forEach((E,s)=>h.call(d,s,s,this))}has(h){return this.a.has(h)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=k;var $;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})($||(e.Touch=$={}));class c{constructor(){this[L]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(h){return this.a.has(h)}get(h,d=0){const E=this.a.get(h);if(E)return d!==0&&this.j(E,d),E.value}set(h,d,E=0){let s=this.a.get(h);if(s)s.value=d,E!==0&&this.j(s,E);else{switch(s={key:h,value:d,next:void 0,previous:void 0},E){case 0:this.h(s);break;case 1:this.g(s);break;case 2:this.h(s);break;default:this.h(s);break}this.a.set(h,s),this.d++}return this}delete(h){return!!this.remove(h)}remove(h){const d=this.a.get(h);if(d)return this.a.delete(h),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const h=this.b;return this.a.delete(h.key),this.i(h),this.d--,h.value}forEach(h,d){const E=this.e;let s=this.b;for(;s;){if(d?h.bind(d)(s.value,s.key,this):h(s.value,s.key,this),this.e!==E)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const h=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:E.key,done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}values(){const h=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:E.value,done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}entries(){const h=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(h.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:[E.key,E.value],done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(h){if(h>=this.size)return;if(h===0){this.clear();return}let d=this.b,E=this.size;for(;d&&E>h;)this.a.delete(d.key),d=d.next,E--;this.b=d,this.d=E,d&&(d.previous=void 0),this.e++}g(h){if(!this.b&&!this.c)this.c=h;else if(this.b)h.next=this.b,this.b.previous=h;else throw new Error("Invalid list");this.b=h,this.e++}h(h){if(!this.b&&!this.c)this.b=h;else if(this.c)h.previous=this.c,this.c.next=h;else throw new Error("Invalid list");this.c=h,this.e++}i(h){if(h===this.b&&h===this.c)this.b=void 0,this.c=void 0;else if(h===this.b){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.b=h.next}else if(h===this.c){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.c=h.previous}else{const d=h.next,E=h.previous;if(!d||!E)throw new Error("Invalid list");d.previous=E,E.next=d}h.next=void 0,h.previous=void 0,this.e++}j(h,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(h===this.b)return;const E=h.next,s=h.previous;h===this.c?(s.next=void 0,this.c=s):(E.previous=s,s.next=E),h.previous=void 0,h.next=this.b,this.b.previous=h,this.b=h,this.e++}else if(d===2){if(h===this.c)return;const E=h.next,s=h.previous;h===this.b?(E.previous=void 0,this.b=E):(E.previous=s,s.next=E),h.next=void 0,h.previous=this.c,this.c.next=h,this.c=h,this.e++}}}toJSON(){const h=[];return this.forEach((d,E)=>{h.push([E,d])}),h}fromJSON(h){this.clear();for(const[d,E]of h)this.set(d,E)}}e.$Bc=c;class g extends c{constructor(h,d=1){super(),this.k=h,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(h){this.k=h,this.m()}get ratio(){return this.l}set ratio(h){this.l=Math.min(Math.max(0,h),1),this.m()}get(h,d=2){return super.get(h,d)}peek(h){return super.get(h,0)}set(h,d){return super.set(h,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=g;class p{constructor(){this.a=new Map}add(h){return this.a.set(h,(this.a.get(h)||0)+1),this}delete(h){let d=this.a.get(h)||0;return d===0?!1:(d--,d===0?this.a.delete(h):this.a.set(h,d),!0)}has(h){return this.a.has(h)}}e.$Dc=p;class w{constructor(h){if(this.a=new Map,this.b=new Map,h)for(const[d,E]of h)this.set(d,E)}clear(){this.a.clear(),this.b.clear()}set(h,d){this.a.set(h,d),this.b.set(d,h)}get(h){return this.a.get(h)}getKey(h){return this.b.get(h)}delete(h){const d=this.a.get(h);return d===void 0?!1:(this.a.delete(h),this.b.delete(d),!0)}forEach(h,d){this.a.forEach((E,s)=>{h.call(d,E,s,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=w;class l{constructor(){this.a=new Map}add(h,d){let E=this.a.get(h);E||(E=new Set,this.a.set(h,E)),E.add(d)}delete(h,d){const E=this.a.get(h);E&&(E.delete(d),E.size===0&&this.a.delete(h))}forEach(h,d){const E=this.a.get(h);E&&E.forEach(d)}get(h){const d=this.a.get(h);return d||new Set}}e.$Fc=l}),define(le[2],he([0,1,18,125,34,85,61]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const C=!1;let S=null;class b{constructor(){this.b=new Map}static{this.a=0}c(I){let F=this.b.get(I);return F||(F={parent:null,source:null,isSingleton:!1,value:I,idx:b.a++},this.b.set(I,F)),F}trackDisposable(I){const F=this.c(I);F.source||(F.source=new Error().stack)}setParent(I,F){const T=this.c(I);T.parent=F}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,F){const T=F.get(I);if(T)return T;const M=I.parent?this.f(this.c(I.parent),F):I;return F.set(I,M),M}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,I).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(I=10,F){let T;if(F)T=F;else{const x=new Map,W=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,x).isSingleton);if(W.length===0)return;const X=new Set(W.map(V=>V.value));if(T=W.filter(V=>!(V.parent&&X.has(V.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function M(x){function W(V,B){for(;V.length>0&&B.some(te=>typeof te=="string"?te===V[0]:V[0].match(te));)V.shift()}const X=x.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return W(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const U=new L.$Fc;for(const x of T){const W=M(x);for(let X=0;X<=W.length;X++)U.add(W.slice(0,X).join(`
`),x)}T.sort((0,D.$6b)(x=>x.idx,D.$8b));let Y="",J=0;for(const x of T.slice(0,I)){J++;const W=M(x),X=[];for(let V=0;V<W.length;V++){let B=W[V];B=`(shared with ${U.get(W.slice(0,V+1).join(`
`)).size}/${T.length} leaks) at ${B}`;const se=U.get(W.slice(0,V).join(`
`)),_=(0,N.$J)([...se].map(re=>M(re)[V]),re=>re);delete _[W[V]];for(const[re,K]of Object.entries(_))X.unshift(`    - stacktraces of ${K.length} other leaks continue with ${re}`);X.unshift(B)}Y+=`


==================== Leaking disposable ${J}/${T.length}: ${x.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return T.length>I&&(Y+=`


... and ${T.length-I} more leaking disposables

`),{leaks:T,details:Y}}}e.$Gc=b;function R(y){S=y}if(e.$Hc=R,C){const y="__is_disposable_tracked__";R(new class{trackDisposable(I){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[y]||console.log(F)},3e3)}setParent(I,F){if(I&&I!==s.None)try{I[y]=!0}catch{}}markAsDisposed(I){if(I&&I!==s.None)try{I[y]=!0}catch{}}markAsSingleton(I){}})}function k(y){return S?.trackDisposable(y),y}e.$Ic=k;function $(y){S?.markAsDisposed(y)}e.$Jc=$;function c(y,I){S?.setParent(y,I)}function g(y,I){if(S)for(const F of y)S.setParent(F,I)}function p(y){return S?.markAsSingleton(y),y}e.$Kc=p;function w(y){return typeof y.dispose=="function"&&y.dispose.length===0}e.$Lc=w;function l(y){if(O.Iterable.is(y)){const I=[];for(const F of y)if(F)try{F.dispose()}catch(T){I.push(T)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}e.$Mc=l;function u(y){for(const I of y)w(I)&&I.dispose();return[]}e.$Nc=u;function h(...y){const I=d(()=>l(y));return g(y,I),I}e.$Oc=h;function d(y){const I=k({dispose:(0,j.$cb)(()=>{$(I),y()})});return I}e.$Pc=d;class E{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,k(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return c(I,this),this.g?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),c(I,null))}}e.$Qc=E;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new E,k(this),c(this.q,this)}dispose(){$(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Rc=s;class o{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&c(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&c(I,null),I}}e.$Sc=o;class n{constructor(I){this.a=new o,this.b=!1,this.a.value=I}get value(){return this.a.value}set value(I){this.b||I===this.a.value||(this.a.value=I)}dispose(){this.b=!0,this.a.dispose()}}e.$Tc=n;class i{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=i;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(I){let F=I;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,$(this))},this}}e.$Vc=t;class r{constructor(){this.a=new Map}acquire(I,...F){let T=this.a.get(I);T||(T={counter:0,object:this.b(I,...F)},this.a.set(I,T));const{object:M}=T,U=(0,j.$cb)(()=>{--T.counter===0&&(this.c(I,T.object),this.a.delete(I))});return T.counter++,{object:M,dispose:U}}}e.$Wc=r;class a{constructor(I){this.a=I}async acquire(I,...F){const T=this.a.acquire(I,...F);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(M){throw T.dispose(),M}}}e.$Xc=a;class v{constructor(I){this.object=I}dispose(){}}e.$Yc=v;function m(y){const I=new E;try{y(I)}finally{I.dispose()}}e.$Zc=m;class f{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,F,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(I)?.dispose(),this.a.set(I,F)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=f}),define(le[88],he([0,1,34]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.$yl=void 0;const N=new D.$Cc(1e4);function L(b){return S(b,"NFC",N)}e.$yl=L;const j=new D.$Cc(1e4);function O(b){return S(b,"NFD",j)}e.$zl=O;const C=/[^\u0000-\u0080]/;function S(b,R,k){if(!b)return b;const $=k.get(b);if($)return $;let c;return C.test(b)?c=b.normalize(R):c=b,k.set(b,c),c}e.$Al=function(){const b=/[\u0300-\u036f]/g;return function(R){return O(R).replace(b,"")}}()}),function(){function ne(L){const j=[];typeof L=="number"&&j.push("code/timeOrigin",L);function O(S){j.push(S,Date.now())}function C(){const S=[];for(let b=0;b<j.length;b+=2)S.push({name:j[b],startTime:j[b+1]});return S}return{mark:O,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))j.push({name:O.name,startTime:Math.round(L+O.startTime)});return j}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function D(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=D(N))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var N in D)(typeof exports=="object"?exports:ne)[N]=D[N]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function D(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return ne[N].call(L.exports,L,L.exports,D),L.l=!0,L.exports}return D.m=ne,D.c=e,D.d=function(N,L,j){D.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:j})},D.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},D.t=function(N,L){if(1&L&&(N=D(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var j=Object.create(null);if(D.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var O in N)D.d(j,O,function(C){return N[C]}.bind(null,O));return j},D.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return D.d(L,"a",L),L},D.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},D.p="",D(D.s=0)}([function(ne,e,D){(function(N){var L;e=ne.exports=K,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],S=e.src=[],b=0,R=b++;S[R]="0|[1-9]\\d*";var k=b++;S[k]="[0-9]+";var $=b++;S[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var c=b++;S[c]="("+S[R]+")\\.("+S[R]+")\\.("+S[R]+")";var g=b++;S[g]="("+S[k]+")\\.("+S[k]+")\\.("+S[k]+")";var p=b++;S[p]="(?:"+S[R]+"|"+S[$]+")";var w=b++;S[w]="(?:"+S[k]+"|"+S[$]+")";var l=b++;S[l]="(?:-("+S[p]+"(?:\\."+S[p]+")*))";var u=b++;S[u]="(?:-?("+S[w]+"(?:\\."+S[w]+")*))";var h=b++;S[h]="[0-9A-Za-z-]+";var d=b++;S[d]="(?:\\+("+S[h]+"(?:\\."+S[h]+")*))";var E=b++,s="v?"+S[c]+S[l]+"?"+S[d]+"?";S[E]="^"+s+"$";var o="[v=\\s]*"+S[g]+S[u]+"?"+S[d]+"?",n=b++;S[n]="^"+o+"$";var i=b++;S[i]="((?:<|>)?=?)";var t=b++;S[t]=S[k]+"|x|X|\\*";var r=b++;S[r]=S[R]+"|x|X|\\*";var a=b++;S[a]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[l]+")?"+S[d]+"?)?)?";var v=b++;S[v]="[v=\\s]*("+S[t]+")(?:\\.("+S[t]+")(?:\\.("+S[t]+")(?:"+S[u]+")?"+S[d]+"?)?)?";var m=b++;S[m]="^"+S[i]+"\\s*"+S[a]+"$";var f=b++;S[f]="^"+S[i]+"\\s*"+S[v]+"$";var y=b++;S[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=b++;S[I]="(?:~>?)";var F=b++;S[F]="(\\s*)"+S[I]+"\\s+",C[F]=new RegExp(S[F],"g");var T=b++;S[T]="^"+S[I]+S[a]+"$";var M=b++;S[M]="^"+S[I]+S[v]+"$";var U=b++;S[U]="(?:\\^)";var Y=b++;S[Y]="(\\s*)"+S[U]+"\\s+",C[Y]=new RegExp(S[Y],"g");var J=b++;S[J]="^"+S[U]+S[a]+"$";var x=b++;S[x]="^"+S[U]+S[v]+"$";var W=b++;S[W]="^"+S[i]+"\\s*("+o+")$|^$";var X=b++;S[X]="^"+S[i]+"\\s*("+s+")$|^$";var V=b++;S[V]="(\\s*)"+S[i]+"\\s*("+o+"|"+S[a]+")",C[V]=new RegExp(S[V],"g");var B=b++;S[B]="^\\s*("+S[a]+")\\s+-\\s+("+S[a]+")\\s*$";var te=b++;S[te]="^\\s*("+S[v]+")\\s+-\\s+("+S[v]+")\\s*$";var se=b++;S[se]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)L(_,S[_]),C[_]||(C[_]=new RegExp(S[_]));function re(ue,ge){if(ue instanceof K)return ue;if(typeof ue!="string"||ue.length>j||!(ge?C[n]:C[E]).test(ue))return null;try{return new K(ue,ge)}catch{return null}}function K(ue,ge){if(ue instanceof K){if(ue.loose===ge)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof K))return new K(ue,ge);L("SemVer",ue,ge),this.loose=ge;var be=ue.trim().match(ge?C[n]:C[E]);if(!be)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Re=+Se;if(Re>=0&&Re<O)return Re}return Se}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=re,e.valid=function(ue,ge){var be=re(ue,ge);return be?be.version:null},e.clean=function(ue,ge){var be=re(ue.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(ue){return L("SemVer.compare",this.version,this.loose,ue),ue instanceof K||(ue=new K(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},K.prototype.compareMain=function(ue){return ue instanceof K||(ue=new K(ue,this.loose)),P(this.major,ue.major)||P(this.minor,ue.minor)||P(this.patch,ue.patch)},K.prototype.comparePre=function(ue){if(ue instanceof K||(ue=new K(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],Se=ue.prerelease[ge];if(L("prerelease compare",ge,be,Se),be===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(be===void 0)return-1;if(be!==Se)return P(be,Se)}while(++ge)},K.prototype.inc=function(ue,ge){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,ge,be,Se){typeof be=="string"&&(Se=be,be=void 0);try{return new K(ue,be).inc(ge,Se).version}catch{return null}},e.diff=function(ue,ge){if(ee(ue,ge))return null;var be=re(ue),Se=re(ge);if(be.prerelease.length||Se.prerelease.length){for(var Re in be)if((Re==="major"||Re==="minor"||Re==="patch")&&be[Re]!==Se[Re])return"pre"+Re;return"prerelease"}for(var Re in be)if((Re==="major"||Re==="minor"||Re==="patch")&&be[Re]!==Se[Re])return Re},e.compareIdentifiers=P;var z=/^[0-9]+$/;function P(ue,ge){var be=z.test(ue),Se=z.test(ge);return be&&Se&&(ue=+ue,ge=+ge),be&&!Se?-1:Se&&!be?1:ue<ge?-1:ue>ge?1:0}function A(ue,ge,be){return new K(ue,be).compare(new K(ge,be))}function G(ue,ge,be){return A(ue,ge,be)>0}function q(ue,ge,be){return A(ue,ge,be)<0}function ee(ue,ge,be){return A(ue,ge,be)===0}function H(ue,ge,be){return A(ue,ge,be)!==0}function Z(ue,ge,be){return A(ue,ge,be)>=0}function ie(ue,ge,be){return A(ue,ge,be)<=0}function ce(ue,ge,be,Se){var Re;switch(ge){case"===":typeof ue=="object"&&(ue=ue.version),typeof be=="object"&&(be=be.version),Re=ue===be;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof be=="object"&&(be=be.version),Re=ue!==be;break;case"":case"=":case"==":Re=ee(ue,be,Se);break;case"!=":Re=H(ue,be,Se);break;case">":Re=G(ue,be,Se);break;case">=":Re=Z(ue,be,Se);break;case"<":Re=q(ue,be,Se);break;case"<=":Re=ie(ue,be,Se);break;default:throw new TypeError("Invalid operator: "+ge)}return Re}function oe(ue,ge){if(ue instanceof oe){if(ue.loose===ge)return ue;ue=ue.value}if(!(this instanceof oe))return new oe(ue,ge);L("comparator",ue,ge),this.loose=ge,this.parse(ue),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(ue,ge){return P(ge,ue)},e.major=function(ue,ge){return new K(ue,ge).major},e.minor=function(ue,ge){return new K(ue,ge).minor},e.patch=function(ue,ge){return new K(ue,ge).patch},e.compare=A,e.compareLoose=function(ue,ge){return A(ue,ge,!0)},e.rcompare=function(ue,ge,be){return A(ge,ue,be)},e.sort=function(ue,ge){return ue.sort(function(be,Se){return e.compare(be,Se,ge)})},e.rsort=function(ue,ge){return ue.sort(function(be,Se){return e.rcompare(be,Se,ge)})},e.gt=G,e.lt=q,e.eq=ee,e.neq=H,e.gte=Z,e.lte=ie,e.cmp=ce,e.Comparator=oe;var fe={};function de(ue,ge){if(ue instanceof de)return ue.loose===ge?ue:new de(ue.raw,ge);if(ue instanceof oe)return new de(ue.value,ge);if(!(this instanceof de))return new de(ue,ge);if(this.loose=ge,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function we(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function ve(ue,ge,be,Se,Re,ze,je,Ue,Te,ae,$e,me,pe){return((ge=we(be)?"":we(Se)?">="+be+".0.0":we(Re)?">="+be+"."+Se+".0":">="+ge)+" "+(Ue=we(Te)?"":we(ae)?"<"+(+Te+1)+".0.0":we($e)?"<"+Te+"."+(+ae+1)+".0":me?"<="+Te+"."+ae+"."+$e+"-"+me:"<="+Ue)).trim()}function Ie(ue,ge){for(var be=0;be<ue.length;be++)if(!ue[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<ue.length;be++)if(L(ue[be].semver),ue[be].semver!==fe&&ue[be].semver.prerelease.length>0){var Se=ue[be].semver;if(Se.major===ge.major&&Se.minor===ge.minor&&Se.patch===ge.patch)return!0}return!1}return!0}function Ne(ue,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(ue)}function Me(ue,ge,be,Se){var Re,ze,je,Ue,Te;switch(ue=new K(ue,Se),ge=new de(ge,Se),be){case">":Re=G,ze=ie,je=q,Ue=">",Te=">=";break;case"<":Re=q,ze=Z,je=G,Ue="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(ue,ge,Se))return!1;for(var ae=0;ae<ge.set.length;++ae){var $e=ge.set[ae],me=null,pe=null;if($e.forEach(function(ke){ke.semver===fe&&(ke=new oe(">=0.0.0")),me=me||ke,pe=pe||ke,Re(ke.semver,me.semver,Se)?me=ke:je(ke.semver,pe.semver,Se)&&(pe=ke)}),me.operator===Ue||me.operator===Te||(!pe.operator||pe.operator===Ue)&&ze(ue,pe.semver)||pe.operator===Te&&je(ue,pe.semver))return!1}return!0}oe.prototype.parse=function(ue){var ge=this.loose?C[W]:C[X],be=ue.match(ge);if(!be)throw new TypeError("Invalid comparator: "+ue);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new K(be[2],this.loose):this.semver=fe},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(ue){return L("Comparator.test",ue,this.loose),this.semver===fe||(typeof ue=="string"&&(ue=new K(ue,this.loose)),ce(ue,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(ue,ge){if(!(ue instanceof oe))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(ue.value,ge),Ne(this.value,be,ge);if(ue.operator==="")return be=new de(this.value,ge),Ne(ue.semver,be,ge);var Se=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),ze=this.semver.version===ue.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),Ue=ce(this.semver,"<",ue.semver,ge)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),Te=ce(this.semver,">",ue.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return Se||Re||ze&&je||Ue||Te},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ue){var ge=this.loose;ue=ue.trim(),L("range",ue,ge);var be=ge?C[te]:C[B];ue=ue.replace(be,ve),L("hyphen replace",ue),ue=ue.replace(C[V],"$1$2$3"),L("comparator trim",ue,C[V]),ue=(ue=(ue=ue.replace(C[F],"$1~")).replace(C[Y],"$1^")).split(/\s+/).join(" ");var Se=ge?C[W]:C[X],Re=ue.split(" ").map(function(ze){return function(je,Ue){return L("comp",je),je=function(Te,ae){return Te.trim().split(/\s+/).map(function($e){return function(me,pe){L("caret",me,pe);var ke=pe?C[x]:C[J];return me.replace(ke,function(Ce,Pe,Oe,De,Ae){var Fe;return L("caret",me,Ce,Pe,Oe,De,Ae),we(Pe)?Fe="":we(Oe)?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(De)?Fe=Pe==="0"?">="+Pe+"."+Oe+".0 <"+Pe+"."+(+Oe+1)+".0":">="+Pe+"."+Oe+".0 <"+(+Pe+1)+".0.0":Ae?(L("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=Pe==="0"?Oe==="0"?">="+Pe+"."+Oe+"."+De+Ae+" <"+Pe+"."+Oe+"."+(+De+1):">="+Pe+"."+Oe+"."+De+Ae+" <"+Pe+"."+(+Oe+1)+".0":">="+Pe+"."+Oe+"."+De+Ae+" <"+(+Pe+1)+".0.0"):(L("no pr"),Fe=Pe==="0"?Oe==="0"?">="+Pe+"."+Oe+"."+De+" <"+Pe+"."+Oe+"."+(+De+1):">="+Pe+"."+Oe+"."+De+" <"+Pe+"."+(+Oe+1)+".0":">="+Pe+"."+Oe+"."+De+" <"+(+Pe+1)+".0.0"),L("caret return",Fe),Fe})}($e,ae)}).join(" ")}(je,Ue),L("caret",je),je=function(Te,ae){return Te.trim().split(/\s+/).map(function($e){return function(me,pe){var ke=pe?C[M]:C[T];return me.replace(ke,function(Ce,Pe,Oe,De,Ae){var Fe;return L("tilde",me,Ce,Pe,Oe,De,Ae),we(Pe)?Fe="":we(Oe)?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(De)?Fe=">="+Pe+"."+Oe+".0 <"+Pe+"."+(+Oe+1)+".0":Ae?(L("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Fe=">="+Pe+"."+Oe+"."+De+Ae+" <"+Pe+"."+(+Oe+1)+".0"):Fe=">="+Pe+"."+Oe+"."+De+" <"+Pe+"."+(+Oe+1)+".0",L("tilde return",Fe),Fe})}($e,ae)}).join(" ")}(je,Ue),L("tildes",je),je=function(Te,ae){return L("replaceXRanges",Te,ae),Te.split(/\s+/).map(function($e){return function(me,pe){me=me.trim();var ke=pe?C[f]:C[m];return me.replace(ke,function(Ce,Pe,Oe,De,Ae,Fe){L("xRange",me,Ce,Pe,Oe,De,Ae,Fe);var Be=we(Oe),qe=Be||we(De),Ve=qe||we(Ae);return Pe==="="&&Ve&&(Pe=""),Be?Ce=Pe===">"||Pe==="<"?"<0.0.0":"*":Pe&&Ve?(qe&&(De=0),Ve&&(Ae=0),Pe===">"?(Pe=">=",qe?(Oe=+Oe+1,De=0,Ae=0):Ve&&(De=+De+1,Ae=0)):Pe==="<="&&(Pe="<",qe?Oe=+Oe+1:De=+De+1),Ce=Pe+Oe+"."+De+"."+Ae):qe?Ce=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":Ve&&(Ce=">="+Oe+"."+De+".0 <"+Oe+"."+(+De+1)+".0"),L("xRange return",Ce),Ce})}($e,ae)}).join(" ")}(je,Ue),L("xrange",je),je=function(Te,ae){return L("replaceStars",Te,ae),Te.trim().replace(C[se],"")}(je,Ue),L("stars",je),je}(ze,ge)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(ze){return!!ze.match(Se)})),Re=Re.map(function(ze){return new oe(ze,ge)})},de.prototype.intersects=function(ue,ge){if(!(ue instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Se){return ue.set.some(function(Re){return Re.every(function(ze){return Se.intersects(ze,ge)})})})})},e.toComparators=function(ue,ge){return new de(ue,ge).set.map(function(be){return be.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new K(ue,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Ie(this.set[ge],ue))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(ue,ge,be){var Se=null,Re=null;try{var ze=new de(ge,be)}catch{return null}return ue.forEach(function(je){ze.test(je)&&(Se&&Re.compare(je)!==-1||(Re=new K(Se=je,be)))}),Se},e.minSatisfying=function(ue,ge,be){var Se=null,Re=null;try{var ze=new de(ge,be)}catch{return null}return ue.forEach(function(je){ze.test(je)&&(Se&&Re.compare(je)!==1||(Re=new K(Se=je,be)))}),Se},e.validRange=function(ue,ge){try{return new de(ue,ge).range||"*"}catch{return null}},e.ltr=function(ue,ge,be){return Me(ue,ge,"<",be)},e.gtr=function(ue,ge,be){return Me(ue,ge,">",be)},e.outside=Me,e.prerelease=function(ue,ge){var be=re(ue,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ue,ge,be){return ue=new de(ue,be),ge=new de(ge,be),ue.intersects(ge)},e.coerce=function(ue){if(ue instanceof K)return ue;if(typeof ue!="string")return null;var ge=ue.match(C[y]);return ge==null?null:re((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,D(1))},function(ne,e){var D,N,L=ne.exports={};function j(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function C(w){if(D===setTimeout)return setTimeout(w,0);if((D===j||!D)&&setTimeout)return D=setTimeout,setTimeout(w,0);try{return D(w,0)}catch{try{return D.call(null,w,0)}catch{return D.call(this,w,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:j}catch{D=j}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var S,b=[],R=!1,k=-1;function $(){R&&S&&(R=!1,S.length?b=S.concat(b):k=-1,b.length&&c())}function c(){if(!R){var w=C($);R=!0;for(var l=b.length;l;){for(S=b,b=[];++k<l;)S&&S[k].run();k=-1,l=b.length}S=null,R=!1,function(u){if(N===clearTimeout)return clearTimeout(u);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(u);try{N(u)}catch{try{return N.call(null,u)}catch{return N.call(this,u)}}}(w)}}function g(w,l){this.fun=w,this.array=l}function p(){}L.nextTick=function(w){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];b.push(new g(w,l)),b.length!==1||R||C(c)},g.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=p,L.addListener=p,L.once=p,L.off=p,L.removeListener=p,L.removeAllListeners=p,L.emit=p,L.prependListener=p,L.prependOnceListener=p,L.listeners=function(w){return[]},L.binding=function(w){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(w){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(le[127],he([0,1]),function(ne,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=void 0;class N{constructor(C,S,b){this.level=C,this.key=S,this.value=b,this.forward=[]}}const L=void 0;class j{constructor(C,S=2**16){this.comparator=C,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new N(this.c,L,L)}get size(){return this.f}clear(){this.e=new N(this.c,L,L),this.f=0}has(C){return!!j.g(this,C,this.comparator)}get(C){return j.g(this,C,this.comparator)?.value}set(C,S){return j.h(this,C,S,this.comparator)&&(this.f+=1),this}delete(C){const S=j.k(this,C,this.comparator);return S&&(this.f-=1),S}forEach(C,S){let b=this.e.forward[0];for(;b;)C.call(S,b.value,b.key,this),b=b.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this.e.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this.e.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this.e.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",S=this.e.forward[0];for(;S;)C+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return C}static g(C,S,b){let R=C.e;for(let k=C.d-1;k>=0;k--)for(;R.forward[k]&&b(R.forward[k].key,S)<0;)R=R.forward[k];if(R=R.forward[0],R&&b(R.key,S)===0)return R}static h(C,S,b,R){const k=[];let $=C.e;for(let c=C.d-1;c>=0;c--){for(;$.forward[c]&&R($.forward[c].key,S)<0;)$=$.forward[c];k[c]=$}if($=$.forward[0],$&&R($.key,S)===0)return $.value=b,!1;{const c=j.j(C);if(c>C.d){for(let g=C.d;g<c;g++)k[g]=C.e;C.d=c}$=new N(c,S,b);for(let g=0;g<c;g++)$.forward[g]=k[g].forward[g],k[g].forward[g]=$;return!0}}static j(C,S=.5){let b=1;for(;Math.random()<S&&b<C.c;)b+=1;return b}static k(C,S,b){const R=[];let k=C.e;for(let $=C.d-1;$>=0;$--){for(;k.forward[$]&&b(k.forward[$].key,S)<0;)k=k.forward[$];R[$]=k}if(k=k.forward[0],!k||b(k.key,S)!==0)return!1;for(let $=0;$<C.d&&R[$].forward[$]===k;$++)R[$].forward[$]=k.forward[$];for(;C.d>0&&C.e.forward[C.d-1]===L;)C.d-=1;return!0}}e.$Ir=j}),define(le[62],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(j){return new N(j)}constructor(j){this.c=D&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Nd=N}),define(le[3],he([0,1,7,85,2,87,62]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.Event=void 0;const C=!1,S=!1;var b;(function(m){m.None=()=>L.$Rc.None;function f(ce){if(S){const{onDidAddListener:oe}=ce,fe=g.create();let de=0;ce.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),fe.print()),oe?.()}}}function y(ce,oe){return X(ce,()=>{},0,void 0,!0,void 0,oe)}m.defer=y;function I(ce){return(oe,fe=null,de)=>{let we=!1,ve;return ve=ce(Ie=>{if(!we)return ve?ve.dispose():we=!0,oe.call(fe,Ie)},null,de),we&&ve.dispose(),ve}}m.once=I;function F(ce,oe,fe){return x((de,we=null,ve)=>ce(Ie=>de.call(we,oe(Ie)),null,ve),fe)}m.map=F;function T(ce,oe,fe){return x((de,we=null,ve)=>ce(Ie=>{oe(Ie),de.call(we,Ie)},null,ve),fe)}m.forEach=T;function M(ce,oe,fe){return x((de,we=null,ve)=>ce(Ie=>oe(Ie)&&de.call(we,Ie),null,ve),fe)}m.filter=M;function U(ce){return ce}m.signal=U;function Y(...ce){return(oe,fe=null,de)=>{const we=(0,L.$Oc)(...ce.map(ve=>ve(Ie=>oe.call(fe,Ie))));return W(we,de)}}m.any=Y;function J(ce,oe,fe,de){let we=fe;return F(ce,ve=>(we=oe(we,ve),we),de)}m.reduce=J;function x(ce,oe){let fe;const de={onWillAddFirstListener(){fe=ce(we.fire,we)},onDidRemoveLastListener(){fe?.dispose()}};oe||f(de);const we=new h(de);return oe?.add(we),we.event}function W(ce,oe){return oe instanceof Array?oe.push(ce):oe&&oe.add(ce),ce}function X(ce,oe,fe=100,de=!1,we=!1,ve,Ie){let Ne,Me,ue,ge=0,be;const Se={leakWarningThreshold:ve,onWillAddFirstListener(){Ne=ce(ze=>{ge++,Me=oe(Me,ze),de&&!ue&&(Re.fire(Me),Me=void 0),be=()=>{const je=Me;Me=void 0,ue=void 0,(!de||ge>1)&&Re.fire(je),ge=0},typeof fe=="number"?(clearTimeout(ue),ue=setTimeout(be,fe)):ue===void 0&&(ue=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,Ne.dispose()}};Ie||f(Se);const Re=new h(Se);return Ie?.add(Re),Re.event}m.debounce=X;function V(ce,oe=0,fe){return m.debounce(ce,(de,we)=>de?(de.push(we),de):[we],oe,void 0,!0,void 0,fe)}m.accumulate=V;function B(ce,oe=(de,we)=>de===we,fe){let de=!0,we;return M(ce,ve=>{const Ie=de||!oe(ve,we);return de=!1,we=ve,Ie},fe)}m.latch=B;function te(ce,oe,fe){return[m.filter(ce,oe,fe),m.filter(ce,de=>!oe(de),fe)]}m.split=te;function se(ce,oe=!1,fe=[],de){let we=fe.slice(),ve=ce(Me=>{we?we.push(Me):Ne.fire(Me)});de&&de.add(ve);const Ie=()=>{we?.forEach(Me=>Ne.fire(Me)),we=null},Ne=new h({onWillAddFirstListener(){ve||(ve=ce(Me=>Ne.fire(Me)),de&&de.add(ve))},onDidAddFirstListener(){we&&(oe?setTimeout(Ie):Ie())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return de&&de.add(Ne),Ne.event}m.buffer=se;function _(ce,oe){return(de,we,ve)=>{const Ie=oe(new K);return ce(function(Ne){const Me=Ie.evaluate(Ne);Me!==re&&de.call(we,Me)},void 0,ve)}}m.chain=_;const re=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(oe){return this.f.push(oe),this}forEach(oe){return this.f.push(fe=>(oe(fe),fe)),this}filter(oe){return this.f.push(fe=>oe(fe)?fe:re),this}reduce(oe,fe){let de=fe;return this.f.push(we=>(de=oe(de,we),de)),this}latch(oe=(fe,de)=>fe===de){let fe=!0,de;return this.f.push(we=>{const ve=fe||!oe(we,de);return fe=!1,de=we,ve?we:re}),this}evaluate(oe){for(const fe of this.f)if(oe=fe(oe),oe===re)break;return oe}}function z(ce,oe,fe=de=>de){const de=(...Ne)=>Ie.fire(fe(...Ne)),we=()=>ce.on(oe,de),ve=()=>ce.removeListener(oe,de),Ie=new h({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}m.fromNodeEventEmitter=z;function P(ce,oe,fe=de=>de){const de=(...Ne)=>Ie.fire(fe(...Ne)),we=()=>ce.addEventListener(oe,de),ve=()=>ce.removeEventListener(oe,de),Ie=new h({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Ie.event}m.fromDOMEventEmitter=P;function A(ce){return new Promise(oe=>I(ce)(oe))}m.toPromise=A;function G(ce){const oe=new h;return ce.then(fe=>{oe.fire(fe)},()=>{oe.fire(void 0)}).finally(()=>{oe.dispose()}),oe.event}m.fromPromise=G;function q(ce,oe,fe){return oe(fe),ce(de=>oe(de))}m.runAndSubscribe=q;function ee(ce,oe){let fe=null;function de(ve){fe?.dispose(),fe=new L.$Qc,oe(ve,fe)}de(void 0);const we=ce(ve=>de(ve));return(0,L.$Pc)(()=>{we.dispose(),fe?.dispose()})}m.runAndSubscribeWithStore=ee;class H{constructor(oe,fe){this._observable=oe,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{oe.addObserver(this)},onDidRemoveLastListener:()=>{oe.removeObserver(this)}};fe||f(de),this.emitter=new h(de),fe&&fe.add(this.emitter)}beginUpdate(oe){this.f++}handlePossibleChange(oe){}handleChange(oe,fe){this.g=!0}endUpdate(oe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Z(ce,oe){return new H(ce,oe).emitter.event}m.fromObservable=Z;function ie(ce){return oe=>{let fe=0,de=!1;const we={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(ce.reportChanges(),de&&(de=!1,oe()))},handlePossibleChange(){},handleChange(){de=!0}};return ce.addObserver(we),ce.reportChanges(),{dispose(){ce.removeObserver(we)}}}}m.fromObservableLight=ie})(b||(e.Event=b={}));class R{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${R.f++}`,R.all.add(this)}start(f){this.g=new O.$Nd,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Pd=R;let k=-1;function $(m){const f=k;return k=m,{dispose(){k=f}}}e.$Qd=$;class c{constructor(f,y=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=y,this.g=0}dispose(){this.f?.clear()}check(f,y){const I=this.threshold;if(I<=0||y<I)return;this.f||(this.f=new Map);const F=this.f.get(f.value)||0;if(this.f.set(f.value,F+1),this.g-=1,this.g<=0){this.g=I*.5;let T,M=0;for(const[U,Y]of this.f)(!T||M<Y)&&(T=U,M=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${M}):`),console.warn(T)}return()=>{const T=this.f.get(f.value)||0;this.f.set(f.value,T-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class w{constructor(f){this.value=f,this.id=p++}}const l=2,u=(m,f)=>{if(m instanceof w)f(m);else for(let y=0;y<m.length;y++){const I=m[y];I&&f(I)}};class h{constructor(f){this.w=0,this.f=f,this.g=k>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(C){const f=this.t;queueMicrotask(()=>{u(f,y=>y.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,y,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Rc.None;if(this.m)return L.$Rc.None;y&&(f=f.bind(y));const F=new w(f);let T,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=g.create(),T=this.g.check(F.stack,this.w+1)),C&&(F.stack=M??g.create()),this.t?this.t instanceof w?(this.u??=new E,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const U=(0,L.$Pc)(()=>{T?.(),this.x(F)});return I instanceof L.$Qc?I.add(U):Array.isArray(I)&&I.push(U),U},this.q}x(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const y=this.t,I=y.indexOf(f);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,y[I]=void 0;const F=this.u.current===this;if(this.w*l<=y.length){let T=0;for(let M=0;M<y.length;M++)y[M]?y[T++]=y[M]:F&&(this.u.end--,T<this.u.i&&this.u.i--);y.length=T}}y(f,y){if(!f)return;const I=this.f?.onListenerError||D.$Z;if(!I){f.value(y);return}try{f.value(y)}catch(F){I(F)}}z(f){const y=f.current.t;for(;f.i<f.end;)this.y(y[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,f);else{const y=this.u;y.enqueue(this,f,this.t.length),this.z(y)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Rd=h;const d=()=>new E;e.$Sd=d;class E{constructor(){this.i=-1,this.end=0}enqueue(f,y,I){this.i=0,this.end=I,this.current=f,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends h{async fireAsync(f,y,I){if(this.t)for(this.h||(this.h=new j.$2c),u(this.t,F=>this.h.push([F.value,f]));this.h.size>0&&!y.isCancellationRequested;){const[F,T]=this.h.shift(),M=[],U={...T,token:y,waitUntil:Y=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");I&&(Y=I(Y,F)),M.push(Y)}};try{F(U)}catch(Y){(0,D.$Z)(Y);continue}Object.freeze(M),await Promise.allSettled(M).then(Y=>{for(const J of Y)J.status==="rejected"&&(0,D.$Z)(J.reason)})}}}e.$Td=s;class o extends h{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new j.$2c,this.A=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.A(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.w&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$Ud=o;class n extends o{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$Vd=n;class i extends h{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(y=>super.fire(y)),this.h=[]}))}}e.$Wd=i;class t{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const y={event:f,listener:null};this.h.push(y),this.g&&this.m(y);const I=()=>{this.g&&this.o(y);const F=this.h.indexOf(y);this.h.splice(F,1)};return(0,L.$Pc)((0,N.$cb)(I))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(y=>this.f.fire(y))}o(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.f.dispose()}}e.$Xd=t;class r{constructor(f,y,I,F){this.f=new L.$Qc;const T=this.f.add(new t),M=this.f.add(new L.$1c);function U(Y){M.set(Y,T.add(F(Y)))}for(const Y of f)U(Y);this.f.add(y(Y=>{U(Y)})),this.f.add(I(Y=>{M.deleteAndDispose(Y)})),this.event=T.event}dispose(){this.f.dispose()}}e.$Yd=r;class a{constructor(){this.f=[]}wrapEvent(f){return(y,I,F)=>f(T=>{const M=this.f[this.f.length-1];M?M.push(()=>y.call(I,T)):y.call(I,T)},void 0,F)}bufferEvents(f){const y=[];this.f.push(y);const I=f();return this.f.pop(),y.forEach(F=>F()),I}}e.$Zd=a;class v{constructor(){this.f=!1,this.g=b.None,this.h=L.$Rc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$1d=v}),define(le[26],he([0,1,3]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.CancellationToken=void 0;const N=Object.freeze(function(C,S){const b=setTimeout(C.bind(S),0);return{dispose(){clearTimeout(b)}}});var L;(function(C){function S(b){return b===C.None||b===C.Cancelled||b instanceof j?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}C.isCancellationToken=S,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new D.$Rd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=L.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=L.None}}e.$2d=O}),define(le[128],he([0,1,26]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=void 0;class N{constructor(C){this.b=C,this.a=null}get(){if(this.a)return this.a;const C=new D.$2d,S=this.b(C.token);return this.a={promise:S,dispose:()=>{this.a=null,C.cancel(),C.dispose()}},this.a}}e.$Ae=N;class L{constructor(C){this.c=C,this.a=void 0,this.b=void 0}get(C){const S=JSON.stringify(C);return this.b!==S&&(this.b=S,this.a=this.c(C)),this.a}}e.$Be=L;class j{get cachedValues(){return this.a}constructor(C){this.b=C,this.a=new Map}get(C){if(this.a.has(C))return this.a.get(C);const S=this.b(C);return this.a.set(C,S),S}}e.$Ce=j}),define(le[46],he([0,1,7,2]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function L(d){const E=d;return E?typeof E.read=="function":!1}e.$3d=L;function j(d){const E=d;return E?[E.on,E.pause,E.resume,E.destroy].every(s=>typeof s=="function"):!1}e.$4d=j;function O(d){const E=d;return E?j(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$5d=O;function C(d,E){return new S(d,E)}e.$6d=C;class S{constructor(E,s){this.e=E,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(s=>s(E))}h(E){this.c.error.length===0?(0,D.$Z)(E):this.c.error.slice(0).forEach(s=>s(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,s){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(E,s){if(this.a.destroyed)return;let o;switch(E){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(s);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(d,E){const s=[];let o;for(;(o=d.read())!==null;)s.push(o);return E(s)}e.$7d=b;function R(d,E,s){const o=[];let n;for(;(n=d.read())!==null&&o.length<s;)o.push(n);return n===null&&o.length>0?E(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return d.read()}}}e.$8d=R;function k(d,E){return new Promise((s,o)=>{const n=[];$(d,{onData:i=>{E&&n.push(i)},onError:i=>{E?o(i):s(void 0)},onEnd:()=>{s(E?E(n):void 0)}})})}e.$9d=k;function $(d,E,s){d.on("error",o=>{s?.isCancellationRequested||E.onError(o)}),d.on("end",()=>{s?.isCancellationRequested||E.onEnd()}),d.on("data",o=>{s?.isCancellationRequested||E.onData(o)})}e.$0d=$;function c(d,E){return new Promise((s,o)=>{const n=new N.$Qc,i=[],t=v=>{if(i.push(v),i.length>E)return n.dispose(),d.pause(),s({stream:d,buffer:i,ended:!1})},r=v=>(n.dispose(),o(v)),a=()=>(n.dispose(),s({stream:d,buffer:i,ended:!0}));n.add((0,N.$Pc)(()=>d.removeListener("error",r))),d.on("error",r),n.add((0,N.$Pc)(()=>d.removeListener("end",a))),d.on("end",a),n.add((0,N.$Pc)(()=>d.removeListener("data",t))),d.on("data",t)})}e.$$d=c;function g(d,E){const s=C(E);return s.end(d),s}e.$_d=g;function p(){const d=C(()=>{throw new Error("not supported")});return d.end(),d}e.$ae=p;function w(d){let E=!1;return{read:()=>E?null:(E=!0,d)}}e.$be=w;function l(d,E,s){const o=C(s);return $(d,{onData:n=>o.write(E.data(n)),onError:n=>o.error(E.error?E.error(n):n),onEnd:()=>o.end()}),o}e.$ce=l;function u(d,E,s){let o=!1;return{read:()=>{const n=E.read();return o?n:(o=!0,n!==null?s([d,n]):d)}}}e.$de=u;function h(d,E,s){let o=!1;const n=C(s);return $(E,{onData:i=>o?n.write(i):(o=!0,n.write(s([d,i]))),onError:i=>n.error(i),onEnd:()=>{o||(o=!0,n.write(d)),n.end()}}),n}e.$ee=h}),define(le[15],he([0,1,52,46]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const L=typeof Buffer<"u",j=new D.$U(()=>new Uint8Array(256));let O,C;class S{static alloc(y){return L?new S(Buffer.allocUnsafe(y)):new S(new Uint8Array(y))}static wrap(y){return L&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new S(y)}static fromString(y,I){return!(I?.dontUseNodeBuffer||!1)&&L?new S(Buffer.from(y)):(O||(O=new TextEncoder),new S(O.encode(y)))}static fromByteArray(y){const I=S.alloc(y.length);for(let F=0,T=y.length;F<T;F++)I.buffer[F]=y[F];return I}static concat(y,I){if(typeof I>"u"){I=0;for(let M=0,U=y.length;M<U;M++)I+=y[M].byteLength}const F=S.alloc(I);let T=0;for(let M=0,U=y.length;M<U;M++){const Y=y[M];F.set(Y,T),T+=Y.byteLength}return F}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=S.alloc(this.byteLength);return y.set(this),y}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(y,I){return new S(this.buffer.subarray(y,I))}set(y,I){if(y instanceof S)this.buffer.set(y.buffer,I);else if(y instanceof Uint8Array)this.buffer.set(y,I);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),I);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return $(this.buffer,y)}writeUInt32BE(y,I){c(this.buffer,y,I)}readUInt32LE(y){return g(this.buffer,y)}writeUInt32LE(y,I){p(this.buffer,y,I)}readUInt8(y){return w(this.buffer,y)}writeUInt8(y,I){l(this.buffer,y,I)}indexOf(y,I=0){return b(this.buffer,y instanceof S?y.buffer:y,I)}}e.$fe=S;function b(f,y,I=0){const F=y.byteLength,T=f.byteLength;if(F===0)return 0;if(F===1)return f.indexOf(y[0]);if(F>T-I)return-1;const M=j.value;M.fill(y.length);for(let x=0;x<y.length;x++)M[y[x]]=y.length-x-1;let U=I+y.length-1,Y=U,J=-1;for(;U<T;)if(f[U]===y[Y]){if(Y===0){J=U;break}U--,Y--}else U+=Math.max(y.length-Y,M[f[U]]),Y=y.length-1;return J}e.$ge=b;function R(f,y){return f[y+0]<<0>>>0|f[y+1]<<8>>>0}e.$he=R;function k(f,y,I){f[I+0]=y&255,y=y>>>8,f[I+1]=y&255}e.$ie=k;function $(f,y){return f[y]*2**24+f[y+1]*2**16+f[y+2]*2**8+f[y+3]}e.$je=$;function c(f,y,I){f[I+3]=y,y=y>>>8,f[I+2]=y,y=y>>>8,f[I+1]=y,y=y>>>8,f[I]=y}e.$ke=c;function g(f,y){return f[y+0]<<0>>>0|f[y+1]<<8>>>0|f[y+2]<<16>>>0|f[y+3]<<24>>>0}e.$le=g;function p(f,y,I){f[I+0]=y&255,y=y>>>8,f[I+1]=y&255,y=y>>>8,f[I+2]=y&255,y=y>>>8,f[I+3]=y&255}e.$me=p;function w(f,y){return f[y]}e.$ne=w;function l(f,y,I){f[I]=y}e.$oe=l;function u(f){return N.$7d(f,y=>S.concat(y))}e.$pe=u;function h(f){return N.$be(f)}e.$qe=h;function d(f){return N.$9d(f,y=>S.concat(y))}e.$re=d;async function E(f){return f.ended?S.concat(f.buffer):S.concat([...f.buffer,await d(f.stream)])}e.$se=E;function s(f){return N.$_d(f,y=>S.concat(y))}e.$te=s;function o(f){return N.$ce(f,{data:y=>typeof y=="string"?S.fromString(y):S.wrap(y)},y=>S.concat(y))}e.$ue=o;function n(f){return N.$6d(y=>S.concat(y),f)}e.$ve=n;function i(f,y){return N.$de(f,y,I=>S.concat(I))}e.$we=i;function t(f,y){return N.$ee(f,y,I=>S.concat(I))}e.$xe=t;function r(f){let y=0,I=0,F=0;const T=new Uint8Array(Math.floor(f.length/4*3)),M=Y=>{switch(I){case 3:T[F++]=y|Y,I=0;break;case 2:T[F++]=y|Y>>>2,y=Y<<6,I=3;break;case 1:T[F++]=y|Y>>>4,y=Y<<4,I=2;break;default:y=Y<<2,I=1}};for(let Y=0;Y<f.length;Y++){const J=f.charCodeAt(Y);if(J>=65&&J<=90)M(J-65);else if(J>=97&&J<=122)M(J-97+26);else if(J>=48&&J<=57)M(J-48+52);else if(J===43||J===45)M(62);else if(J===47||J===95)M(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${f[Y]}`)}}const U=F;for(;I>0;)M(0);return S.wrap(T).slice(0,U)}e.$ye=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:f},y=!0,I=!1){const F=I?v:a;let T="";const M=f.byteLength%3;let U=0;for(;U<f.byteLength-M;U+=3){const Y=f[U+0],J=f[U+1],x=f[U+2];T+=F[Y>>>2],T+=F[(Y<<4|J>>>4)&63],T+=F[(J<<2|x>>>6)&63],T+=F[x&63]}if(M===1){const Y=f[U+0];T+=F[Y>>>2],T+=F[Y<<4&63],y&&(T+="==")}else if(M===2){const Y=f[U+0],J=f[U+1];T+=F[Y>>>2],T+=F[(Y<<4|J>>>4)&63],T+=F[J<<2&63],y&&(T+="=")}return T}e.$ze=m}),define(le[27],he([0,1,128,52]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bf=e.$Af=e.$zf=e.$yf=e.GraphemeBreakType=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=void 0;function L(ae){return!ae||typeof ae!="string"?!0:ae.trim().length===0}e.$Fe=L;const j=/{(\d+)}/g;function O(ae,...$e){return $e.length===0?ae:ae.replace(j,function(me,pe){const ke=parseInt(pe,10);return isNaN(ke)||ke<0||ke>=$e.length?me:$e[ke]})}e.$Ge=O;const C=/{([^}]+)}/g;function S(ae,$e){return Object.keys($e).length===0?ae:ae.replace(C,(me,pe)=>$e[pe]??me)}e.$He=S;function b(ae){return ae.replace(/[<>&]/g,function($e){switch($e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return $e}})}e.$Ie=b;function R(ae){return ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Je=R;function k(ae,$e){let me=0;const pe=$e.charCodeAt(0);for(let ke=ae.length-1;ke>=0;ke--)ae.charCodeAt(ke)===pe&&me++;return me}e.$Ke=k;function $(ae,$e,me="\u2026"){return ae.length<=$e?ae:`${ae.substr(0,$e)}${me}`}e.$Le=$;function c(ae,$e=" "){const me=g(ae,$e);return p(me,$e)}e.$Me=c;function g(ae,$e){if(!ae||!$e)return ae;const me=$e.length;if(me===0||ae.length===0)return ae;let pe=0;for(;ae.indexOf($e,pe)===pe;)pe=pe+me;return ae.substring(pe)}e.$Ne=g;function p(ae,$e){if(!ae||!$e)return ae;const me=$e.length,pe=ae.length;if(me===0||pe===0)return ae;let ke=pe,Ce=-1;for(;Ce=ae.lastIndexOf($e,ke-1),!(Ce===-1||Ce+me!==ke);){if(Ce===0)return"";ke=Ce}return ae.substring(0,ke)}e.$Oe=p;function w(ae){return ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Pe=w;function l(ae){return ae.replace(/\*/g,"")}e.$Qe=l;function u(ae,$e,me={}){if(!ae)throw new Error("Cannot create regex from empty string");$e||(ae=R(ae)),me.wholeWord&&(/\B/.test(ae.charAt(0))||(ae="\\b"+ae),/\B/.test(ae.charAt(ae.length-1))||(ae=ae+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(ae,pe)}e.$Re=u;function h(ae){return ae.source==="^"||ae.source==="^$"||ae.source==="$"||ae.source==="^\\s*$"?!1:!!(ae.exec("")&&ae.lastIndex===0)}e.$Se=h;function d(ae){return ae.split(/\r\n|\r|\n/)}e.$Te=d;function E(ae){for(let $e=0,me=ae.length;$e<me;$e++){const pe=ae.charCodeAt($e);if(pe!==32&&pe!==9)return $e}return-1}e.$Ue=E;function s(ae,$e=0,me=ae.length){for(let pe=$e;pe<me;pe++){const ke=ae.charCodeAt(pe);if(ke!==32&&ke!==9)return ae.substring($e,pe)}return ae.substring($e,me)}e.$Ve=s;function o(ae,$e=ae.length-1){for(let me=$e;me>=0;me--){const pe=ae.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.$We=o;function n(ae,$e,me){const pe=[];let ke=0;for(const Ce of ae.matchAll($e)){if(pe.push(ae.slice(ke,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");ke=Ce.index+Ce[0].length,pe.push(me(Ce[0],...Ce.slice(1),Ce.index,ae,Ce.groups))}return pe.push(ae.slice(ke)),Promise.all(pe).then(Ce=>Ce.join(""))}e.$Xe=n;function i(ae,$e){return ae<$e?-1:ae>$e?1:0}e.$Ye=i;function t(ae,$e,me=0,pe=ae.length,ke=0,Ce=$e.length){for(;me<pe&&ke<Ce;me++,ke++){const De=ae.charCodeAt(me),Ae=$e.charCodeAt(ke);if(De<Ae)return-1;if(De>Ae)return 1}const Pe=pe-me,Oe=Ce-ke;return Pe<Oe?-1:Pe>Oe?1:0}e.$Ze=t;function r(ae,$e){return a(ae,$e,0,ae.length,0,$e.length)}e.$1e=r;function a(ae,$e,me=0,pe=ae.length,ke=0,Ce=$e.length){for(;me<pe&&ke<Ce;me++,ke++){let De=ae.charCodeAt(me),Ae=$e.charCodeAt(ke);if(De===Ae)continue;if(De>=128||Ae>=128)return t(ae.toLowerCase(),$e.toLowerCase(),me,pe,ke,Ce);m(De)&&(De-=32),m(Ae)&&(Ae-=32);const Fe=De-Ae;if(Fe!==0)return Fe}const Pe=pe-me,Oe=Ce-ke;return Pe<Oe?-1:Pe>Oe?1:0}e.$2e=a;function v(ae){return ae>=48&&ae<=57}e.$3e=v;function m(ae){return ae>=97&&ae<=122}e.$4e=m;function f(ae){return ae>=65&&ae<=90}e.$5e=f;function y(ae,$e){return ae.length===$e.length&&a(ae,$e)===0}e.$6e=y;function I(ae,$e){const me=$e.length;return $e.length>ae.length?!1:a(ae,$e,0,me)===0}e.$7e=I;function F(ae,$e){const me=Math.min(ae.length,$e.length);let pe;for(pe=0;pe<me;pe++)if(ae.charCodeAt(pe)!==$e.charCodeAt(pe))return pe;return me}e.$8e=F;function T(ae,$e){const me=Math.min(ae.length,$e.length);let pe;const ke=ae.length-1,Ce=$e.length-1;for(pe=0;pe<me;pe++)if(ae.charCodeAt(ke-pe)!==$e.charCodeAt(Ce-pe))return pe;return me}e.$9e=T;function M(ae){return 55296<=ae&&ae<=56319}e.$0e=M;function U(ae){return 56320<=ae&&ae<=57343}e.$$e=U;function Y(ae,$e){return(ae-55296<<10)+($e-56320)+65536}e.$_e=Y;function J(ae,$e,me){const pe=ae.charCodeAt(me);if(M(pe)&&me+1<$e){const ke=ae.charCodeAt(me+1);if(U(ke))return Y(pe,ke)}return pe}e.$af=J;function x(ae,$e){const me=ae.charCodeAt($e-1);if(U(me)&&$e>1){const pe=ae.charCodeAt($e-2);if(M(pe))return Y(pe,me)}return me}class W{get offset(){return this.e}constructor($e,me=0){this.c=$e,this.d=$e.length,this.e=me}setOffset($e){this.e=$e}prevCodePoint(){const $e=x(this.c,this.e);return this.e-=$e>=65536?2:1,$e}nextCodePoint(){const $e=J(this.c,this.d,this.e);return this.e+=$e>=65536?2:1,$e}eol(){return this.e>=this.d}}e.$bf=W;class X{get offset(){return this.c.offset}constructor($e,me=0){this.c=new W($e,me)}nextGraphemeLength(){const $e=ge.getInstance(),me=this.c,pe=me.offset;let ke=$e.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ce=me.offset,Pe=$e.getGraphemeBreakType(me.nextCodePoint());if(Me(ke,Pe)){me.setOffset(Ce);break}ke=Pe}return me.offset-pe}prevGraphemeLength(){const $e=ge.getInstance(),me=this.c,pe=me.offset;let ke=$e.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ce=me.offset,Pe=$e.getGraphemeBreakType(me.prevCodePoint());if(Me(Pe,ke)){me.setOffset(Ce);break}ke=Pe}return pe-me.offset}eol(){return this.c.eol()}}e.$cf=X;function V(ae,$e){return new X(ae,$e).nextGraphemeLength()}e.$df=V;function B(ae,$e){return new X(ae,$e).prevGraphemeLength()}e.$ef=B;function te(ae,$e){$e>0&&U(ae.charCodeAt($e))&&$e--;const me=$e+V(ae,$e);return[me-B(ae,me),me]}e.$ff=te;function se(ae){const $e=new X(ae);let me=0;for(;!$e.eol();)me++,$e.nextGraphemeLength();return me}e.$gf=se;let _;function re(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function K(ae){return _||(_=re()),_.test(ae)}e.$hf=K;const z=/^[\t\n\r\x20-\x7E]*$/;function P(ae){return z.test(ae)}e.$if=P,e.$jf=/[\u2028\u2029]/;function A(ae){return e.$jf.test(ae)}e.$kf=A;function G(ae){return ae>=11904&&ae<=55215||ae>=63744&&ae<=64255||ae>=65281&&ae<=65374}e.$lf=G;function q(ae){return ae>=127462&&ae<=127487||ae===8986||ae===8987||ae===9200||ae===9203||ae>=9728&&ae<=10175||ae===11088||ae===11093||ae>=127744&&ae<=128591||ae>=128640&&ae<=128764||ae>=128992&&ae<=129008||ae>=129280&&ae<=129535||ae>=129648&&ae<=129782}e.$mf=q;function ee(ae,$e){if(ae.length<$e)return ae;const me=/\b/g;let pe=0;for(;me.test(ae)&&!(ae.length-me.lastIndex<$e);)pe=me.lastIndex,me.lastIndex+=1;return ae.substring(pe).replace(/^\s/,"")}e.$nf=ee;const H=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Z=/\x1b\].*?\x07/g;function ie(ae){return ae&&(ae=ae.replace(H,"").replace(Z,"")),ae}e.$of=ie,e.$pf=String.fromCharCode(65279);function ce(ae){return!!(ae&&ae.length>0&&ae.charCodeAt(0)===65279)}e.$qf=ce;function oe(ae){return ce(ae)?ae.substr(1):ae}e.$rf=oe;function fe(ae,$e){if(!ae||!$e||ae.length<$e.length)return!1;const me=$e.length,pe=ae.toLowerCase();let ke=0,Ce=-1;for(;ke<me;){const Pe=pe.indexOf($e[ke],Ce+1);if(Pe<0)return!1;Ce=Pe,ke++}return!0}e.$sf=fe;function de(ae,$e=!1){return ae?($e&&(ae=ae.replace(/\\./g,"")),ae.toLowerCase()!==ae):!1}e.$tf=de;function we(ae){return ae.charAt(0).toUpperCase()+ae.slice(1)}e.$uf=we;function ve(ae,$e=1){if($e===0)return"";let me=-1;do me=ae.indexOf(`
`,me+1),$e--;while($e>0&&me>=0);return me===-1?ae:(ae[me-1]==="\r"&&me--,ae.substr(0,me))}e.$vf=ve;function Ie(ae){return ae=ae%(2*26),ae<26?String.fromCharCode(97+ae):String.fromCharCode(65+ae-26)}e.$wf=Ie;function Ne(ae){return ge.getInstance().getGraphemeBreakType(ae)}e.$xf=Ne;function Me(ae,$e){return ae===0?$e!==5&&$e!==7:ae===2&&$e===3?!1:ae===4||ae===2||ae===3||$e===4||$e===2||$e===3?!0:!(ae===8&&($e===8||$e===9||$e===11||$e===12)||(ae===11||ae===9)&&($e===9||$e===10)||(ae===12||ae===10)&&$e===10||$e===5||$e===13||$e===7||ae===1||ae===13&&$e===14||ae===6&&$e===6)}var ue;(function(ae){ae[ae.Other=0]="Other",ae[ae.Prepend=1]="Prepend",ae[ae.CR=2]="CR",ae[ae.LF=3]="LF",ae[ae.Control=4]="Control",ae[ae.Extend=5]="Extend",ae[ae.Regional_Indicator=6]="Regional_Indicator",ae[ae.SpacingMark=7]="SpacingMark",ae[ae.L=8]="L",ae[ae.V=9]="V",ae[ae.T=10]="T",ae[ae.LV=11]="LV",ae[ae.LVT=12]="LVT",ae[ae.ZWJ=13]="ZWJ",ae[ae.Extended_Pictographic=14]="Extended_Pictographic"})(ue||(e.GraphemeBreakType=ue={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType($e){if($e<32)return $e===10?3:$e===13?2:4;if($e<127)return 0;const me=this.d,pe=me.length/3;let ke=1;for(;ke<=pe;)if($e<me[3*ke])ke=2*ke;else if($e>me[3*ke+1])ke=2*ke+1;else return me[3*ke+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(ae,$e){if(ae===0)return 0;const me=Re(ae,$e);if(me!==void 0)return me;const pe=new W($e,ae);return pe.prevCodePoint(),pe.offset}e.$yf=Se;function Re(ae,$e){const me=new W($e,ae);let pe=me.prevCodePoint();for(;ze(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!q(pe))return;let ke=me.offset;return ke>0&&me.prevCodePoint()===8205&&(ke=me.offset),ke}function ze(ae){return 127995<=ae&&ae<=127999}var je;(function(ae){ae[ae.zwj=8205]="zwj",ae[ae.emojiVariantSelector=65039]="emojiVariantSelector",ae[ae.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$zf="\xA0";class Ue{static{this.c=new N.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Be($e=>{function me(Fe){const Be=new Map;for(let qe=0;qe<Fe.length;qe+=2)Be.set(Fe[qe],Fe[qe+1]);return Be}function pe(Fe,Be){const qe=new Map(Fe);for(const[Ve,_e]of Be)qe.set(Ve,_e);return qe}function ke(Fe,Be){if(!Fe)return Be;const qe=new Map;for(const[Ve,_e]of Fe)Be.has(Ve)&&qe.set(Ve,_e);return qe}const Ce=this.c.value;let Pe=$e.filter(Fe=>!Fe.startsWith("_")&&Fe in Ce);Pe.length===0&&(Pe=["_default"]);let Oe;for(const Fe of Pe){const Be=me(Ce[Fe]);Oe=ke(Oe,Be)}const De=me(Ce._common),Ae=pe(De,Oe);return new Ue(Ae)})}static getInstance($e){return Ue.d.get(Array.from($e))}static{this.e=new N.$U(()=>Object.keys(Ue.c.value).filter($e=>!$e.startsWith("_")))}static getLocales(){return Ue.e.value}constructor($e){this.f=$e}isAmbiguous($e){return this.f.has($e)}getPrimaryConfusable($e){return this.f.get($e)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Af=Ue;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter($e){return Te.e().has($e)}static get codePoints(){return Te.e()}}e.$Bf=Te}),define(le[53],he([0,1,27]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=void 0;function N(l){return L(l,0)}e.$Ni=N;function L(l,u){switch(typeof l){case"object":return l===null?j(349,u):Array.isArray(l)?S(l,u):b(l,u);case"string":return C(l,u);case"boolean":return O(l,u);case"number":return j(l,u);case"undefined":return j(937,u);default:return j(617,u)}}e.$Oi=L;function j(l,u){return(u<<5)-u+l|0}e.$Pi=j;function O(l,u){return j(l?433:863,u)}function C(l,u){u=j(149417,u);for(let h=0,d=l.length;h<d;h++)u=j(l.charCodeAt(h),u);return u}e.$Qi=C;function S(l,u){return u=j(104579,u),l.reduce((h,d)=>L(d,h),u)}function b(l,u){return u=j(181387,u),Object.keys(l).sort().reduce((h,d)=>(h=C(d,h),L(l[d],h)),u)}class R{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=L(u,this.g),this.g}}e.$Ri=R;var k;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function $(l,u,h=32){const d=h-u,E=~((1<<d)-1);return(l<<u|(E&l)>>>d)>>>0}function c(l,u=0,h=l.byteLength,d=0){for(let E=0;E<h;E++)l[u+E]=d}function g(l,u,h="0"){for(;l.length<u;)l=h+l;return l}function p(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(h=>h.toString(16).padStart(2,"0")).join(""):g((l>>>0).toString(16),u/4)}e.$Si=p;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const h=u.length;if(h===0)return;const d=this.p;let E=this.r,s=this.u,o,n;for(s!==0?(o=s,n=-1,s=0):(o=u.charCodeAt(0),n=0);;){let i=o;if(D.$0e(o))if(n+1<h){const t=u.charCodeAt(n+1);D.$$e(t)?(n++,i=D.$_e(o,t)):i=65533}else{s=o;break}else D.$$e(o)&&(i=65533);if(E=this.w(d,E,i),n++,n<h)o=u.charCodeAt(n);else break}this.r=E,this.u=s}w(u,h,d){return d<128?u[h++]=d:d<2048?(u[h++]=192|(d&1984)>>>6,u[h++]=128|(d&63)>>>0):d<65536?(u[h++]=224|(d&61440)>>>12,u[h++]=128|(d&4032)>>>6,u[h++]=128|(d&63)>>>0):(u[h++]=240|(d&1835008)>>>18,u[h++]=128|(d&258048)>>>12,u[h++]=128|(d&4032)>>>6,u[h++]=128|(d&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=w.g,h=this.q;for(let a=0;a<64;a+=4)u.setUint32(a,h.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,$(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let d=this.h,E=this.l,s=this.m,o=this.n,n=this.o,i,t,r;for(let a=0;a<80;a++)a<20?(i=E&s|~E&o,t=1518500249):a<40?(i=E^s^o,t=1859775393):a<60?(i=E&s|E&o|s&o,t=2400959708):(i=E^s^o,t=3395469782),r=$(d,5)+i+n+t+u.getUint32(a*4,!1)&4294967295,n=o,o=s,s=$(E,30),E=d,d=r;this.h=this.h+d&4294967295,this.l=this.l+E&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$Ti=w}),define(le[89],he([0,1,27]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const j="error",O="warning",C="warn",S="info",b="ignore";function R($){return $?D.$6e(j,$)?L.Error:D.$6e(O,$)||D.$6e(C,$)?L.Warning:D.$6e(S,$)?L.Info:L.Ignore:L.Ignore}L.fromValue=R;function k($){switch($){case L.Error:return j;case L.Warning:return O;case L.Info:return S;default:return b}}L.toString=k}(N||(N={})),e.default=N}),define(le[129],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(le[47],he([0,1,18,27]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=void 0;class L{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const g=c.charCodeAt(0),p=this.b.charCodeAt(this.c);return g-p}value(){return this.b[this.c]}}e.$2h=L;class j{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,N.$Ze)(c,this.b,0,c.length,this.c,this.d):(0,N.$2e)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$3h=j;class O{constructor(c=!0,g=!0){this.f=c,this.g=g}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let g=c.length-1;g>=0;g--,this.c--){const p=this.b.charCodeAt(g);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,N.$Ze)(c,this.b,0,c.length,this.d,this.e):(0,N.$2e)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$4h=O;var C;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(C||(C={}));class S{constructor(c,g){this.f=c,this.g=g,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(3)),this.g(c)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===1)return(0,N.$1e)(c,this.c.scheme);if(this.d[this.e]===2)return(0,N.$1e)(c,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(c);if(this.d[this.e]===4)return(0,N.$Ye)(c,this.c.query);if(this.d[this.e]===5)return(0,N.$Ye)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$5h=S;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(R||(R={}));class k{static forUris(c=()=>!1,g=()=>!1){return new k(new S(c,g))}static forPaths(c=!1){return new k(new O(void 0,!c))}static forStrings(){return new k(new L)}static forConfigKeys(){return new k(new j)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,g){if(g){const p=g.slice(0);(0,D.$Wb)(p);for(const w of p)this.set(w,c)}else{const p=c.slice(0);(0,D.$Wb)(p);for(const w of p)this.set(w[0],w[1])}}set(c,g){const p=this.b.reset(c);let w;this.c||(this.c=new b,this.c.segment=p.value());const l=[];for(w=this.c;;){const h=p.cmp(w.segment);if(h>0)w.left||(w.left=new b,w.left.segment=p.value()),l.push([-1,w]),w=w.left;else if(h<0)w.right||(w.right=new b,w.right.segment=p.value()),l.push([1,w]),w=w.right;else if(p.hasNext())p.next(),w.mid||(w.mid=new b,w.mid.segment=p.value()),l.push([0,w]),w=w.mid;else break}const u=w.value;w.value=g,w.key=c;for(let h=l.length-1;h>=0;h--){const d=l[h][1];d.updateHeight();const E=d.balanceFactor();if(E<-1||E>1){const s=l[h][0],o=l[h+1][0];if(s===1&&o===1)l[h][1]=d.rotateLeft();else if(s===-1&&o===-1)l[h][1]=d.rotateRight();else if(s===1&&o===-1)d.right=l[h+1][1]=l[h+1][1].rotateRight(),l[h][1]=d.rotateLeft();else if(s===-1&&o===1)d.left=l[h+1][1]=l[h+1][1].rotateLeft(),l[h][1]=d.rotateRight();else throw new Error;if(h>0)switch(l[h-1][0]){case-1:l[h-1][1].left=l[h][1];break;case 1:l[h-1][1].right=l[h][1];break;case 0:l[h-1][1].mid=l[h][1];break}else this.c=l[0][1]}}return u}get(c){return this.d(c)?.value}d(c){const g=this.b.reset(c);let p=this.c;for(;p;){const w=g.cmp(p.segment);if(w>0)p=p.left;else if(w<0)p=p.right;else if(g.hasNext())g.next(),p=p.mid;else break}return p}has(c){const g=this.d(c);return!(g?.value===void 0&&g?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,g){const p=this.b.reset(c),w=[];let l=this.c;for(;l;){const u=p.cmp(l.segment);if(u>0)w.push([-1,l]),l=l.left;else if(u<0)w.push([1,l]),l=l.right;else if(p.hasNext())p.next(),w.push([0,l]),l=l.mid;else break}if(l){if(g?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const u=this.f(l.right);if(u.key){const{key:h,value:d,segment:E}=u;this.e(u.key,!1),l.key=h,l.value=d,l.segment=E}}else{const u=l.left??l.right;if(w.length>0){const[h,d]=w[w.length-1];switch(h){case-1:d.left=u;break;case 0:d.mid=u;break;case 1:d.right=u;break}}else this.c=u}for(let u=w.length-1;u>=0;u--){const h=w[u][1];h.updateHeight();const d=h.balanceFactor();if(d>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),w[u][1]=h.rotateLeft()):d<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),w[u][1]=h.rotateRight()),u>0)switch(w[u-1][0]){case-1:w[u-1][1].left=w[u][1];break;case 1:w[u-1][1].right=w[u][1];break;case 0:w[u-1][1].mid=w[u][1];break}else this.c=w[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const g=this.b.reset(c);let p=this.c,w;for(;p;){const l=g.cmp(p.segment);if(l>0)p=p.left;else if(l<0)p=p.right;else if(g.hasNext())g.next(),w=p.value||w,p=p.mid;else break}return p&&p.value||w}findSuperstr(c){return this.g(c,!1)}g(c,g){const p=this.b.reset(c);let w=this.c;for(;w;){const l=p.cmp(w.segment);if(l>0)w=w.left;else if(l<0)w=w.right;else if(p.hasNext())p.next(),w=w.mid;else return w.mid?this.h(w.mid):g?w.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[g,p]of this)c(p,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const g=[];return this.j(c,g),g[Symbol.iterator]()}j(c,g){c&&(c.left&&this.j(c.left,g),c.value&&g.push([c.key,c.value]),c.mid&&this.j(c.mid,g),c.right&&this.j(c.right,g))}_isBalanced(){const c=g=>{if(!g)return!0;const p=g.balanceFactor();return p<-1||p>1?!1:c(g.left)&&c(g.right)};return c(this.c)}}e.$6h=k}),define(le[12],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=void 0;function D(E){return typeof E=="string"}e.$Cf=D;function N(E){return Array.isArray(E)&&E.every(s=>D(s))}e.$Df=N;function L(E){return typeof E=="object"&&E!==null&&!Array.isArray(E)&&!(E instanceof RegExp)&&!(E instanceof Date)}e.$Ef=L;function j(E){const s=Object.getPrototypeOf(Uint8Array);return typeof E=="object"&&E instanceof s}e.$Ff=j;function O(E){return typeof E=="number"&&!isNaN(E)}e.$Gf=O;function C(E){return!!E&&typeof E[Symbol.iterator]=="function"}e.$Hf=C;function S(E){return E===!0||E===!1}e.$If=S;function b(E){return typeof E>"u"}e.$Jf=b;function R(E){return!k(E)}e.$Kf=R;function k(E){return b(E)||E===null}e.$Lf=k;function $(E,s){if(!E)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$Mf=$;function c(E){if(k(E))throw new Error("Assertion Failed: argument is undefined or null");return E}e.$Nf=c;function g(...E){const s=[];for(let o=0;o<E.length;o++){const n=E[o];if(k(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);s.push(n)}return s}e.$Of=g;const p=Object.prototype.hasOwnProperty;function w(E){if(!L(E))return!1;for(const s in E)if(p.call(E,s))return!1;return!0}e.$Pf=w;function l(E){return typeof E=="function"}e.$Qf=l;function u(...E){return E.length>0&&E.every(l)}e.$Rf=u;function h(E,s){const o=Math.min(E.length,s.length);for(let n=0;n<o;n++)d(E[n],s[n])}e.$Sf=h;function d(E,s){if(D(s)){if(typeof E!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(l(s)){try{if(E instanceof s)return}catch{}if(!k(E)&&E.constructor===s||s.length===1&&s.call(void 0,E)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Tf=d}),define(le[30],he([0,1,12]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=void 0;function N(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([h,d])=>{u[h]=d&&typeof d=="object"?N(d):d}),u}e.$en=N;function L(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const h=u.shift();Object.freeze(h);for(const d in h)if(j.call(h,d)){const E=h[d];typeof E=="object"&&!Object.isFrozen(E)&&!(0,D.$Ff)(E)&&u.push(E)}}return l}e.$fn=L;const j=Object.prototype.hasOwnProperty;function O(l,u){return C(l,u,new Set)}e.$gn=O;function C(l,u,h){if((0,D.$Lf)(l))return l;const d=u(l);if(typeof d<"u")return d;if(Array.isArray(l)){const E=[];for(const s of l)E.push(C(s,u,h));return E}if((0,D.$Ef)(l)){if(h.has(l))throw new Error("Cannot clone recursive data-structure");h.add(l);const E={};for(const s in l)j.call(l,s)&&(E[s]=C(l[s],u,h));return h.delete(l),E}return l}function S(l,u,h=!0){return(0,D.$Ef)(l)?((0,D.$Ef)(u)&&Object.keys(u).forEach(d=>{d in l?h&&((0,D.$Ef)(l[d])&&(0,D.$Ef)(u[d])?S(l[d],u[d],h):l[d]=u[d]):l[d]=u[d]}),l):u}e.$hn=S;function b(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let h,d;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(h=0;h<l.length;h++)if(!b(l[h],u[h]))return!1}else{const E=[];for(d in l)E.push(d);E.sort();const s=[];for(d in u)s.push(d);if(s.sort(),!b(E,s))return!1;for(h=0;h<E.length;h++)if(!b(l[E[h]],u[E[h]]))return!1}return!0}e.$in=b;function R(l){const u=new Set;return JSON.stringify(l,(h,d)=>{if((0,D.$Ef)(d)||Array.isArray(d)){if(u.has(d))return"[Circular]";u.add(d)}return d})}e.$jn=R;function k(l,u){const h=Object.create(null);return!l||!u||Object.keys(u).forEach(E=>{const s=l[E],o=u[E];b(s,o)||(h[E]=o)}),h}e.$kn=k;function $(l,u){const h=u.toLowerCase(),d=Object.keys(l).find(E=>E.toLowerCase()===h);return d?l[d]:l[u]}e.$ln=$;function c(l,u){const h=Object.create(null);for(const[d,E]of Object.entries(l))u(d,E)&&(h[d]=E);return h}e.$mn=c;function g(l){let u=[];for(;Object.prototype!==l;)u=u.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return u}e.$nn=g;function p(l){const u=[];for(const h of g(l))typeof l[h]=="function"&&u.push(h);return u}e.$on=p;function w(l,u){const h=E=>function(){const s=Array.prototype.slice.call(arguments,0);return u(E,s)},d={};for(const E of l)d[E]=h(E);return d}e.$pn=w}),define(le[32],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kg=e.$jg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return D.test(L)}e.$jg=N,e.$kg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(C){for(let S=0;S<C.length;S++)C[S]=Math.floor(Math.random()*256);return C};const j=new Uint8Array(16),O=[];for(let C=0;C<256;C++)O.push(C.toString(16).padStart(2,"0"));return function(){L(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let S=0,b="";return b+=O[j[S++]],b+=O[j[S++]],b+=O[j[S++]],b+=O[j[S++]],b+="-",b+=O[j[S++]],b+=O[j[S++]],b+="-",b+=O[j[S++]],b+=O[j[S++]],b+="-",b+=O[j[S++]],b+=O[j[S++]],b+="-",b+=O[j[S++]],b+=O[j[S++]],b+=O[j[S++]],b+=O[j[S++]],b+=O[j[S++]],b+=O[j[S++]],b}}()}),define(le[130],he([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(O){const C=O.replace(/\-/g,":").toLowerCase();return!N.has(C)}function j(){const O=(0,D.networkInterfaces)();for(const C in O){const S=O[C];if(S){for(const{mac:b}of S)if(L(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$1m=j}),define(le[131],he([0,1,267,15]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2T=void 0;class L extends D.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const C=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=C.length===1?C[0]:C,this.c=C.length}}_transform(O,C,S){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let b=0;for(;b<this.a.length;){const R=typeof this.b=="number"?this.a.indexOf(this.b,b):(0,N.$ge)(this.a,this.b,b);if(R===-1)break;this.push(this.a.slice(b,R+this.c)),b=R+this.c}this.a=b===this.a.length?void 0:this.a.slice(b),S()}_flush(O){this.a&&this.push(this.a),O()}}e.$2T=L}),define(le[132],he([0,1,63]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=e.$mg=void 0;function N(C,S,b,R=1){let k=!1;return new Promise($=>{const c=setTimeout(()=>{if(!k)return k=!0,$(0)},b);L(C,S,R,g=>{if(!k)return k=!0,clearTimeout(c),$(g)})})}e.$mg=N;function L(C,S,b,R){if(S===0)return R(0);const k=new D.Socket;k.once("connect",()=>(O(k),L(C+b,S-1,b,R))),k.once("data",()=>{}),k.once("error",$=>(O(k),$.code!=="ECONNREFUSED"?L(C+b,S-1,b,R):R(C))),k.connect(C,"127.0.0.1")}e.$ng={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(C,S,b,R="127.0.0.1"){let k=!1,$,c=1;const g=D.createServer({pauseOnConnect:!0});function p(w,l){k||(k=!0,g.removeAllListeners(),g.close(),$&&clearTimeout($),l(w))}return new Promise(w=>{$=setTimeout(()=>{p(0,w)},b),g.on("listening",()=>{p(C,w)}),g.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&c<S?(C++,c++,g.listen(C,R)):p(0,w)}),g.on("close",()=>{p(0,w)}),g.listen(C,R)})}e.$og=j;function O(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(S){console.error(S)}}}),define(le[133],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fU=void 0;function D(N){return!!N.parentPort}e.$fU=D}),define(le[134],he([13,9]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(le[64],he([0,1,134]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=void 0;const N=60,L=N*60,j=L*24,O=j*7,C=j*30,S=j*365;function b(k,$,c,g){typeof k!="number"&&(k=k.getTime());const p=Math.round((new Date().getTime()-k)/1e3);if(p<-30)return(0,D.localize)(0,null,b(new Date().getTime()+p*1e3,!1));if(!g&&p<30)return(0,D.localize)(1,null);let w;return p<N?(w=p,$?w===1?c?(0,D.localize)(2,null,w):(0,D.localize)(3,null,w):c?(0,D.localize)(4,null,w):(0,D.localize)(5,null,w):w===1?c?(0,D.localize)(6,null,w):(0,D.localize)(7,null,w):c?(0,D.localize)(8,null,w):(0,D.localize)(9,null,w)):p<L?(w=Math.floor(p/N),$?w===1?c?(0,D.localize)(10,null,w):(0,D.localize)(11,null,w):c?(0,D.localize)(12,null,w):(0,D.localize)(13,null,w):w===1?c?(0,D.localize)(14,null,w):(0,D.localize)(15,null,w):c?(0,D.localize)(16,null,w):(0,D.localize)(17,null,w)):p<j?(w=Math.floor(p/L),$?w===1?c?(0,D.localize)(18,null,w):(0,D.localize)(19,null,w):c?(0,D.localize)(20,null,w):(0,D.localize)(21,null,w):w===1?c?(0,D.localize)(22,null,w):(0,D.localize)(23,null,w):c?(0,D.localize)(24,null,w):(0,D.localize)(25,null,w)):p<O?(w=Math.floor(p/j),$?w===1?(0,D.localize)(26,null,w):(0,D.localize)(27,null,w):w===1?(0,D.localize)(28,null,w):(0,D.localize)(29,null,w)):p<C?(w=Math.floor(p/O),$?w===1?c?(0,D.localize)(30,null,w):(0,D.localize)(31,null,w):c?(0,D.localize)(32,null,w):(0,D.localize)(33,null,w):w===1?c?(0,D.localize)(34,null,w):(0,D.localize)(35,null,w):c?(0,D.localize)(36,null,w):(0,D.localize)(37,null,w)):p<S?(w=Math.floor(p/C),$?w===1?c?(0,D.localize)(38,null,w):(0,D.localize)(39,null,w):c?(0,D.localize)(40,null,w):(0,D.localize)(41,null,w):w===1?c?(0,D.localize)(42,null,w):(0,D.localize)(43,null,w):c?(0,D.localize)(44,null,w):(0,D.localize)(45,null,w)):(w=Math.floor(p/S),$?w===1?c?(0,D.localize)(46,null,w):(0,D.localize)(47,null,w):c?(0,D.localize)(48,null,w):(0,D.localize)(49,null,w):w===1?c?(0,D.localize)(50,null,w):(0,D.localize)(51,null,w):c?(0,D.localize)(52,null,w):(0,D.localize)(53,null,w))}e.$nm=b;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$om=R}),define(le[135],he([13,9]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,18,12,135]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=void 0;function j(k,$){return $&&(k.stack||k.stacktrace)?L.localize(0,null,C(k),O(k.stack)||O(k.stacktrace)):C(k)}function O(k){return Array.isArray(k)?k.join(`
`):k}function C(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?L.localize(1,null,k.message):k.message||L.localize(2,null)}function S(k=null,$=!1){if(!k)return L.localize(3,null);if(Array.isArray(k)){const c=D.$Gb(k),g=S(c[0],$);return c.length>1?L.localize(4,null,g,c.length):g}if(N.$Cf(k))return k;if(k.detail){const c=k.detail;if(c.error)return j(c.error,$);if(c.exception)return j(c.exception,$)}return k.stack?j(k,$):k.message?k.message:L.localize(5,null)}e.$Ki=S;function b(k){const $=k;return $ instanceof Error&&Array.isArray($.actions)}e.$Li=b;function R(k,$){let c;return typeof k=="string"?c=new Error(k):c=k,c.actions=$,c}e.$Mi=R}),define(le[136],he([13,9]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(le[137],he([0,1,136]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;function N(L){switch(L){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.$Gp=N}),define(le[138],he([13,9]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(le[5],he([0,1,138]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let N=!1,L=!1,j=!1,O=!1,C=!1,S=!1,b=!1,R=!1,k=!1,$=!1,c,g=e.$g,p=e.$g,w,l;const u=globalThis;let h;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?h=u.vscode.process:typeof process<"u"&&(h=process);const d=typeof h?.versions?.electron=="string",E=d&&h?.type==="renderer";if(typeof navigator=="object"&&!E)l=navigator.userAgent,N=l.indexOf("Windows")>=0,L=l.indexOf("Macintosh")>=0,R=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=l.indexOf("Linux")>=0,$=l?.indexOf("Mobi")>=0,S=!0,c=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,g=c,p=navigator.language;else if(typeof h=="object"){N=h.platform==="win32",L=h.platform==="darwin",j=h.platform==="linux",O=j&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,b=d,k=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=e.$g,g=e.$g;const m=h.env.VSCODE_NLS_CONFIG;if(m)try{const f=JSON.parse(m),y=f.availableLanguages["*"];c=f.locale,p=f.osLocale,g=y||e.$g,w=f._translationsConfigFile}catch{}C=!0}else console.error("Unable to resolve platform.");var s;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(s||(e.Platform=s={}));function o(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let n=0;L?n=1:N?n=3:j&&(n=2),e.$i=N,e.$j=L,e.$k=j,e.$l=O,e.$m=C,e.$n=b,e.$o=S,e.$p=S&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=R,e.$s=$,e.$t=k,e.$u=n,e.$v=l,e.$w=g;var i;(function(m){function f(){return e.$w}m.value=f;function y(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}m.isDefaultVariant=y;function I(){return e.$w==="en"}m.isDefault=I})(i||(e.Language=i={})),e.$x=c,e.$y=p,e.$z=w,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const m=[];u.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let I=0,F=m.length;I<F;I++){const T=m[I];if(T.id===y.data.vscodeScheduleAsyncWork){m.splice(I,1),T.callback();return}}});let f=0;return y=>{const I=++f;m.push({id:I,callback:y}),u.postMessage({vscodeScheduleAsyncWork:I},"*")}}return m=>setTimeout(m)})();var t;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=L||R?2:N?1:3;let r=!0,a=!1;function v(){if(!a){a=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,r=new Uint16Array(m.buffer)[0]===(2<<8)+1}return r}e.$D=v,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(le[37],he([0,1,5]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const j=L.process;N={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$cc=N.platform,e.$dc=N.arch}),define(le[16],he([0,1,37]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const N=65,L=97,j=90,O=122,C=46,S=47,b=92,R=58,k=63;class $ extends Error{constructor(o,n,i){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof i}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function c(s,o){if(s===null||typeof s!="object")throw new $(o,"Object",s)}function g(s,o){if(typeof s!="string")throw new $(o,"string",s)}const p=D.$cc==="win32";function w(s){return s===S||s===b}function l(s){return s===S}function u(s){return s>=N&&s<=j||s>=L&&s<=O}function h(s,o,n,i){let t="",r=0,a=-1,v=0,m=0;for(let f=0;f<=s.length;++f){if(f<s.length)m=s.charCodeAt(f);else{if(i(m))break;m=S}if(i(m)){if(!(a===f-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==C||t.charCodeAt(t.length-2)!==C){if(t.length>2){const y=t.lastIndexOf(n);y===-1?(t="",r=0):(t=t.slice(0,y),r=t.length-1-t.lastIndexOf(n)),a=f,v=0;continue}else if(t.length!==0){t="",r=0,a=f,v=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${s.slice(a+1,f)}`:t=s.slice(a+1,f),r=f-a-1;a=f,v=0}else m===C&&v!==-1?++v:v=-1}return t}function d(s,o){c(o,"pathObject");const n=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${i}`:`${n}${s}${i}`:i}e.$ec={resolve(...s){let o="",n="",i=!1;for(let t=s.length-1;t>=-1;t--){let r;if(t>=0){if(r=s[t],g(r,"path"),r.length===0)continue}else o.length===0?r=D.cwd():(r=D.env[`=${o}`]||D.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===b)&&(r=`${o}\\`));const a=r.length;let v=0,m="",f=!1;const y=r.charCodeAt(0);if(a===1)w(y)&&(v=1,f=!0);else if(w(y))if(f=!0,w(r.charCodeAt(1))){let I=2,F=I;for(;I<a&&!w(r.charCodeAt(I));)I++;if(I<a&&I!==F){const T=r.slice(F,I);for(F=I;I<a&&w(r.charCodeAt(I));)I++;if(I<a&&I!==F){for(F=I;I<a&&!w(r.charCodeAt(I));)I++;(I===a||I!==F)&&(m=`\\\\${T}\\${r.slice(F,I)}`,v=I)}}}else v=1;else u(y)&&r.charCodeAt(1)===R&&(m=r.slice(0,2),v=2,a>2&&w(r.charCodeAt(2))&&(f=!0,v=3));if(m.length>0)if(o.length>0){if(m.toLowerCase()!==o.toLowerCase())continue}else o=m;if(i){if(o.length>0)break}else if(n=`${r.slice(v)}\\${n}`,i=f,f&&o.length>0)break}return n=h(n,!i,"\\",w),i?`${o}\\${n}`:`${o}${n}`||"."},normalize(s){g(s,"path");const o=s.length;if(o===0)return".";let n=0,i,t=!1;const r=s.charCodeAt(0);if(o===1)return l(r)?"\\":s;if(w(r))if(t=!0,w(s.charCodeAt(1))){let v=2,m=v;for(;v<o&&!w(s.charCodeAt(v));)v++;if(v<o&&v!==m){const f=s.slice(m,v);for(m=v;v<o&&w(s.charCodeAt(v));)v++;if(v<o&&v!==m){for(m=v;v<o&&!w(s.charCodeAt(v));)v++;if(v===o)return`\\\\${f}\\${s.slice(m)}\\`;v!==m&&(i=`\\\\${f}\\${s.slice(m,v)}`,n=v)}}}else n=1;else u(r)&&s.charCodeAt(1)===R&&(i=s.slice(0,2),n=2,o>2&&w(s.charCodeAt(2))&&(t=!0,n=3));let a=n<o?h(s.slice(n),!t,"\\",w):"";return a.length===0&&!t&&(a="."),a.length>0&&w(s.charCodeAt(o-1))&&(a+="\\"),i===void 0?t?`\\${a}`:a:t?`${i}\\${a}`:`${i}${a}`},isAbsolute(s){g(s,"path");const o=s.length;if(o===0)return!1;const n=s.charCodeAt(0);return w(n)||o>2&&u(n)&&s.charCodeAt(1)===R&&w(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,n;for(let r=0;r<s.length;++r){const a=s[r];g(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let i=!0,t=0;if(typeof n=="string"&&w(n.charCodeAt(0))){++t;const r=n.length;r>1&&w(n.charCodeAt(1))&&(++t,r>2&&(w(n.charCodeAt(2))?++t:i=!1))}if(i){for(;t<o.length&&w(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$ec.normalize(o)},relative(s,o){if(g(s,"from"),g(o,"to"),s===o)return"";const n=e.$ec.resolve(s),i=e.$ec.resolve(o);if(n===i||(s=n.toLowerCase(),o=i.toLowerCase(),s===o))return"";let t=0;for(;t<s.length&&s.charCodeAt(t)===b;)t++;let r=s.length;for(;r-1>t&&s.charCodeAt(r-1)===b;)r--;const a=r-t;let v=0;for(;v<o.length&&o.charCodeAt(v)===b;)v++;let m=o.length;for(;m-1>v&&o.charCodeAt(m-1)===b;)m--;const f=m-v,y=a<f?a:f;let I=-1,F=0;for(;F<y;F++){const M=s.charCodeAt(t+F);if(M!==o.charCodeAt(v+F))break;M===b&&(I=F)}if(F!==y){if(I===-1)return i}else{if(f>y){if(o.charCodeAt(v+F)===b)return i.slice(v+F+1);if(F===2)return i.slice(v+F)}a>y&&(s.charCodeAt(t+F)===b?I=F:F===2&&(I=3)),I===-1&&(I=0)}let T="";for(F=t+I+1;F<=r;++F)(F===r||s.charCodeAt(F)===b)&&(T+=T.length===0?"..":"\\..");return v+=I,T.length>0?`${T}${i.slice(v,m)}`:(i.charCodeAt(v)===b&&++v,i.slice(v,m))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const o=e.$ec.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===b){if(o.charCodeAt(1)===b){const n=o.charCodeAt(2);if(n!==k&&n!==C)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(u(o.charCodeAt(0))&&o.charCodeAt(1)===R&&o.charCodeAt(2)===b)return`\\\\?\\${o}`;return s},dirname(s){g(s,"path");const o=s.length;if(o===0)return".";let n=-1,i=0;const t=s.charCodeAt(0);if(o===1)return w(t)?s:".";if(w(t)){if(n=i=1,w(s.charCodeAt(1))){let v=2,m=v;for(;v<o&&!w(s.charCodeAt(v));)v++;if(v<o&&v!==m){for(m=v;v<o&&w(s.charCodeAt(v));)v++;if(v<o&&v!==m){for(m=v;v<o&&!w(s.charCodeAt(v));)v++;if(v===o)return s;v!==m&&(n=i=v+1)}}}}else u(t)&&s.charCodeAt(1)===R&&(n=o>2&&w(s.charCodeAt(2))?3:2,i=n);let r=-1,a=!0;for(let v=o-1;v>=i;--v)if(w(s.charCodeAt(v))){if(!a){r=v;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return s.slice(0,r)},basename(s,o){o!==void 0&&g(o,"ext"),g(s,"path");let n=0,i=-1,t=!0,r;if(s.length>=2&&u(s.charCodeAt(0))&&s.charCodeAt(1)===R&&(n=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let a=o.length-1,v=-1;for(r=s.length-1;r>=n;--r){const m=s.charCodeAt(r);if(w(m)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(m===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=n;--r)if(w(s.charCodeAt(r))){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){g(s,"path");let o=0,n=-1,i=0,t=-1,r=!0,a=0;s.length>=2&&s.charCodeAt(1)===R&&u(s.charCodeAt(0))&&(o=i=2);for(let v=s.length-1;v>=o;--v){const m=s.charCodeAt(v);if(w(m)){if(!r){i=v+1;break}continue}t===-1&&(r=!1,t=v+1),m===C?n===-1?n=v:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===i+1?"":s.slice(n,t)},format:d.bind(null,"\\"),parse(s){g(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const n=s.length;let i=0,t=s.charCodeAt(0);if(n===1)return w(t)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(w(t)){if(i=1,w(s.charCodeAt(1))){let I=2,F=I;for(;I<n&&!w(s.charCodeAt(I));)I++;if(I<n&&I!==F){for(F=I;I<n&&w(s.charCodeAt(I));)I++;if(I<n&&I!==F){for(F=I;I<n&&!w(s.charCodeAt(I));)I++;I===n?i=I:I!==F&&(i=I+1)}}}}else if(u(t)&&s.charCodeAt(1)===R){if(n<=2)return o.root=o.dir=s,o;if(i=2,w(s.charCodeAt(2))){if(n===3)return o.root=o.dir=s,o;i=3}}i>0&&(o.root=s.slice(0,i));let r=-1,a=i,v=-1,m=!0,f=s.length-1,y=0;for(;f>=i;--f){if(t=s.charCodeAt(f),w(t)){if(!m){a=f+1;break}continue}v===-1&&(m=!1,v=f+1),t===C?r===-1?r=f:y!==1&&(y=1):r!==-1&&(y=-1)}return v!==-1&&(r===-1||y===0||y===1&&r===v-1&&r===a+1?o.base=o.name=s.slice(a,v):(o.name=s.slice(a,r),o.base=s.slice(a,v),o.ext=s.slice(r,v))),a>0&&a!==i?o.dir=s.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const E=(()=>{if(p){const s=/\\/g;return()=>{const o=D.cwd().replace(s,"/");return o.slice(o.indexOf("/"))}}return()=>D.cwd()})();e.$fc={resolve(...s){let o="",n=!1;for(let i=s.length-1;i>=-1&&!n;i--){const t=i>=0?s[i]:E();g(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===S)}return o=h(o,!n,"/",l),n?`/${o}`:o.length>0?o:"."},normalize(s){if(g(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===S,n=s.charCodeAt(s.length-1)===S;return s=h(s,!o,"/",l),s.length===0?o?"/":n?"./":".":(n&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return g(s,"path"),s.length>0&&s.charCodeAt(0)===S},join(...s){if(s.length===0)return".";let o;for(let n=0;n<s.length;++n){const i=s[n];g(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$fc.normalize(o)},relative(s,o){if(g(s,"from"),g(o,"to"),s===o||(s=e.$fc.resolve(s),o=e.$fc.resolve(o),s===o))return"";const n=1,i=s.length,t=i-n,r=1,a=o.length-r,v=t<a?t:a;let m=-1,f=0;for(;f<v;f++){const I=s.charCodeAt(n+f);if(I!==o.charCodeAt(r+f))break;I===S&&(m=f)}if(f===v)if(a>v){if(o.charCodeAt(r+f)===S)return o.slice(r+f+1);if(f===0)return o.slice(r+f)}else t>v&&(s.charCodeAt(n+f)===S?m=f:f===0&&(m=0));let y="";for(f=n+m+1;f<=i;++f)(f===i||s.charCodeAt(f)===S)&&(y+=y.length===0?"..":"/..");return`${y}${o.slice(r+m)}`},toNamespacedPath(s){return s},dirname(s){if(g(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===S;let n=-1,i=!0;for(let t=s.length-1;t>=1;--t)if(s.charCodeAt(t)===S){if(!i){n=t;break}}else i=!1;return n===-1?o?"/":".":o&&n===1?"//":s.slice(0,n)},basename(s,o){o!==void 0&&g(o,"ext"),g(s,"path");let n=0,i=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let a=o.length-1,v=-1;for(r=s.length-1;r>=0;--r){const m=s.charCodeAt(r);if(m===S){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(m===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===S){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){g(s,"path");let o=-1,n=0,i=-1,t=!0,r=0;for(let a=s.length-1;a>=0;--a){const v=s.charCodeAt(a);if(v===S){if(!t){n=a+1;break}continue}i===-1&&(t=!1,i=a+1),v===C?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||i===-1||r===0||r===1&&o===i-1&&o===n+1?"":s.slice(o,i)},format:d.bind(null,"/"),parse(s){g(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const n=s.charCodeAt(0)===S;let i;n?(o.root="/",i=1):i=0;let t=-1,r=0,a=-1,v=!0,m=s.length-1,f=0;for(;m>=i;--m){const y=s.charCodeAt(m);if(y===S){if(!v){r=m+1;break}continue}a===-1&&(v=!1,a=m+1),y===C?t===-1?t=m:f!==1&&(f=1):t!==-1&&(f=-1)}if(a!==-1){const y=r===0&&n?1:r;t===-1||f===0||f===1&&t===a-1&&t===r+1?o.base=o.name=s.slice(y,a):(o.name=s.slice(y,t),o.base=s.slice(y,a),o.ext=s.slice(t,a))}return r>0?o.dir=s.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=p?e.$ec.normalize:e.$fc.normalize,e.$hc=p?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=p?e.$ec.join:e.$fc.join,e.$jc=p?e.$ec.resolve:e.$fc.resolve,e.$kc=p?e.$ec.relative:e.$fc.relative,e.$lc=p?e.$ec.dirname:e.$fc.dirname,e.$mc=p?e.$ec.basename:e.$fc.basename,e.$nc=p?e.$ec.extname:e.$fc.extname,e.$oc=p?e.$ec.format:e.$fc.format,e.$pc=p?e.$ec.parse:e.$fc.parse,e.$qc=p?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=p?e.$ec.sep:e.$fc.sep,e.$sc=p?e.$ec.delimiter:e.$fc.delimiter}),define(le[48],he([0,1,16,5,27,12]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function O(r){return r===47||r===92}e.$Uf=O;function C(r){return r.replace(/[\\/]/g,D.$fc.sep)}e.$Vf=C;function S(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Wf=S;function b(r,a=D.$fc.sep){if(!r)return"";const v=r.length,m=r.charCodeAt(0);if(O(m)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let y=3;const I=y;for(;y<v&&!O(r.charCodeAt(y));y++);if(I!==y&&!O(r.charCodeAt(y+1))){for(y+=1;y<v;y++)if(O(r.charCodeAt(y)))return r.slice(0,y+1).replace(/[\\/]/g,a)}}return a}else if(l(m)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<v;f++)if(O(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.$Xf=b;function R(r){if(!N.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let v=2;const m=v;for(;v<r.length&&(a=r.charCodeAt(v),a!==92);v++);return!(m===v||(a=r.charCodeAt(v+1),isNaN(a)||a===92))}e.$Yf=R;const k=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,a=N.$i){const v=a?k:$;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||a&&c.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$Zf=g;function p(r,a,v){const m=r===a;return!v||m?m:!r||!a?!1:(0,L.$6e)(r,a)}e.$1f=p;function w(r,a,v,m=D.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(v){if(!(0,L.$7e)(r,a))return!1;if(a.length===r.length)return!0;let y=a.length;return a.charAt(a.length-1)===m&&y--,r.charAt(y)===m}return a.charAt(a.length-1)!==m&&(a+=m),r.indexOf(a)===0}e.$2f=w;function l(r){return r>=65&&r<=90||r>=97&&r<=122}e.$3f=l;function u(r,a){return N.$i&&r.endsWith(":")&&(r+=D.sep),(0,D.$hc)(r)||(r=(0,D.$ic)(a,r)),r=(0,D.$gc)(r),N.$i?(r=(0,L.$Oe)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,L.$Oe)(r,D.sep),r||(r=D.sep)),r}e.$4f=u;function h(r){const a=(0,D.$gc)(r);return N.$i?r.length>3?!1:d(a)&&(r.length===2||a.charCodeAt(2)===92):a===D.$fc.sep}e.$5f=h;function d(r,a=N.$i){return a?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$6f=d;function E(r,a=N.$i){return d(r,a)?r[0]:void 0}e.$7f=E;function s(r,a,v){return a.length>r.length?-1:r===a?0:(v&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$8f=s;function o(r){const a=r.split(":");let v,m,f;for(const y of a){const I=Number(y);(0,j.$Gf)(I)?m===void 0?m=I:f===void 0&&(f=I):v=v?[v,y].join(":"):y}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:m!==void 0?m:void 0,column:f!==void 0?f:m!==void 0?1:void 0}}e.$9f=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,v=8){let m="";for(let y=0;y<v;y++){let I;y===0&&N.$i&&!a&&(v===3||v===4)?I=i:I=n,m+=I.charAt(Math.floor(Math.random()*I.length))}let f;return a?f=`${a}-${m}`:f=m,r?(0,D.$ic)(r,f):f}e.$0f=t}),define(le[139],he([0,1,16]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=e.$2r=e.$1r=e.$Zr=void 0,e.$Zr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(R){const k=(0,D.$nc)(R),$=N[k.toLowerCase()];return $!==void 0?$:O(R)}e.$1r=j;function O(R){const k=(0,D.$nc)(R);return L[k.toLowerCase()]}e.$2r=O;function C(R){for(const k in L)if(L[k]===R)return k}e.$3r=C;const S=/^(.+)\/(.+?)(;.+)?$/;function b(R,k){const $=S.exec(R);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:k?void 0:R}e.$4r=b}),define(le[90],he([0,1,5]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.TerminateResponseCode=e.Source=void 0;var N;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function j(C,...S){const b=S.reduce(($,c)=>($[c]=!0,$),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter($=>!b[$]).forEach($=>{for(let c=0;c<R.length;c++)if($.search(R[c])!==-1){delete C[$];break}})}e.$Jl=j;function O(C){C&&(delete C.DEBUG,D.$j&&delete C.DYLD_LIBRARY_PATH,D.$k&&delete C.LD_PRELOAD)}e.$Kl=O}),define(le[10],he([0,1,16,5]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,j=/^\//,O=/^\/\//;function C(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!j.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(i,t){return!i&&!t?"file":i}function b(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==k&&(t=k+t):t=k;break}return t}const R="",k="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(t){return t instanceof c?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,v,m,f=!1){typeof t=="object"?(this.scheme=t.scheme||R,this.authority=t.authority||R,this.path=t.path||R,this.query=t.query||R,this.fragment=t.fragment||R):(this.scheme=S(t,f),this.authority=r||R,this.path=b(this.scheme,a||R),this.query=v||R,this.fragment=m||R,C(this,f))}get fsPath(){return d(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:v,query:m,fragment:f}=t;return r===void 0?r=this.scheme:r===null&&(r=R),a===void 0?a=this.authority:a===null&&(a=R),v===void 0?v=this.path:v===null&&(v=R),m===void 0?m=this.query:m===null&&(m=R),f===void 0?f=this.fragment:f===null&&(f=R),r===this.scheme&&a===this.authority&&v===this.path&&m===this.query&&f===this.fragment?this:new w(r,a,v,m,f)}static parse(t,r=!1){const a=$.exec(t);return a?new w(a[2]||R,n(a[4]||R),n(a[5]||R),n(a[7]||R),n(a[9]||R),r):new w(R,R,R,R,R)}static file(t){let r=R;if(N.$i&&(t=t.replace(/\\/g,k)),t[0]===k&&t[1]===k){const a=t.indexOf(k,2);a===-1?(r=t.substring(2),t=k):(r=t.substring(2,a),t=t.substring(a)||k)}return new w("file",r,t,R,R)}static from(t,r){return new w(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&t.scheme==="file"?a=c.file(D.$ec.join(d(t,!0),...r)).path:a=D.$fc.join(t.path,...r),t.with({path:a})}toString(t=!1){return E(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof c)return t;{const r=new w(t);return r._formatted=t.external??null,r._fsPath=t._sep===p?t.fsPath??null:null,r}}else return t}}e.URI=c;function g(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$uc=g;const p=N.$i?1:void 0;class w extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(t=!1){return t?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=p),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,t,r){let a,v=-1;for(let m=0;m<i.length;m++){const f=i.charCodeAt(m);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47||r&&f===91||r&&f===93||r&&f===58)v!==-1&&(a+=encodeURIComponent(i.substring(v,m)),v=-1),a!==void 0&&(a+=i.charAt(m));else{a===void 0&&(a=i.substr(0,m));const y=l[f];y!==void 0?(v!==-1&&(a+=encodeURIComponent(i.substring(v,m)),v=-1),a+=y):v===-1&&(v=m)}}return v!==-1&&(a+=encodeURIComponent(i.substring(v))),a!==void 0?a:i}function h(i){let t;for(let r=0;r<i.length;r++){const a=i.charCodeAt(r);a===35||a===63?(t===void 0&&(t=i.substr(0,r)),t+=l[a]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function d(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,N.$i&&(r=r.replace(/\//g,"\\")),r}e.$vc=d;function E(i,t){const r=t?h:u;let a="",{scheme:v,authority:m,path:f,query:y,fragment:I}=i;if(v&&(a+=v,a+=":"),(m||v==="file")&&(a+=k,a+=k),m){let F=m.indexOf("@");if(F!==-1){const T=m.substr(0,F);m=m.substr(F+1),F=T.lastIndexOf(":"),F===-1?a+=r(T,!1,!1):(a+=r(T.substr(0,F),!1,!1),a+=":",a+=r(T.substr(F+1),!1,!0)),a+="@"}m=m.toLowerCase(),F=m.lastIndexOf(":"),F===-1?a+=r(m,!1,!0):(a+=r(m.substr(0,F),!1,!0),a+=m.substr(F))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const F=f.charCodeAt(1);F>=65&&F<=90&&(f=`/${String.fromCharCode(F+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const F=f.charCodeAt(0);F>=65&&F<=90&&(f=`${String.fromCharCode(F+32)}:${f.substr(2)}`)}a+=r(f,!0,!1)}return y&&(a+="?",a+=r(y,!1,!1)),I&&(a+="#",a+=t?I:u(I,!1,!1)),a}function s(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(o)?i.replace(o,t=>s(t)):i}}),define(le[140],he([0,1,10]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$0p=e.$9p=e.$8p=void 0;function N(b){const R=b;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$8p=N;function L(b){const R=[];let k;try{const $=JSON.parse(b.arguments),c=$[$.length-1];c&&c.__$stack&&($.pop(),k=c.__$stack),R.push(...$)}catch{R.push("Unable to log remote console arguments",b.arguments)}return{args:R,stack:k}}e.$9p=L;function j(b){if(typeof b!="string")return j(L(b).stack);const R=b;if(R){const k=O(R),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if($&&$.length===4)return{uri:D.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$0p=j;function O(b){if(!b)return b;const R=b.indexOf(`
`);return R===-1?b:b.substring(0,R)}function C(b,R){const{args:k,stack:$}=L(b),c=typeof k[0]=="string"&&k.length===1;let g=O($);g&&(g=`(${g.trim()})`);let p=[];if(typeof k[0]=="string"?g&&c?p=[`%c[${R}] %c${k[0]} %c${g}`,S("blue"),S(""),S("grey")]:p=[`%c[${R}] %c${k[0]}`,S("blue"),S(""),...k.slice(1)]:p=[`%c[${R}]%`,S("blue"),...k],g&&!c&&p.push(g),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,p)}e.log=C;function S(b){return`color: ${b}`}}),define(le[65],he([0,1,15,10]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=void 0;function L(S){return JSON.stringify(S,O)}e.$uh=L;function j(S){let b=JSON.parse(S);return b=C(b),b}e.$vh=j;function O(S,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function C(S,b=0){if(!S||b>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return N.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 17:return new Date(S.source)}if(S instanceof D.$fe||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let R=0;R<S.length;++R)S[R]=C(S[R],b+1);else for(const R in S)Object.hasOwnProperty.call(S,R)&&(S[R]=C(S[R],b+1))}return S}e.$wh=C}),define(le[23],he([0,1,7,5,27,10]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var O;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={}));function C($,c){return j.URI.isUri($)?(0,L.$6e)($.scheme,c):(0,L.$7e)($,c+":")}e.$$f=C;function S($,...c){return c.some(g=>C($,g))}e.$_f=S,e.$ag="vscode-tkn",e.$bg="tkn";class b{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${O.vscodeRemoteResource}`}set(c,g,p){this.a[c]=g,this.b[c]=p}setConnectionToken(c,g){this.c[c]=g}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(h){return D.$Z(h),c}const g=c.authority;let p=this.a[g];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const w=this.b[g],l=this.c[g];let u=`path=${encodeURIComponent(c.path)}`;return typeof l=="string"&&(u+=`&${e.$bg}=${encodeURIComponent(l)}`),j.URI.from({scheme:N.$o?this.d:O.vscodeRemoteResource,authority:`${p}:${w}`,path:this.f,query:u})}}e.$cg=new b,e.$dg="vs/../../extensions",e.$eg="vs/../../node_modules",e.$fg="vs/../../node_modules.asar",e.$gg="vs/../../node_modules.asar.unpacked",e.$hg="vscode-app";class R{static{this.a=e.$hg}asBrowserUri(c){const g=this.b(c,ne);return this.uriToBrowserUri(g)}uriToBrowserUri(c){return c.scheme===O.vscodeRemote?e.$cg.rewrite(c):c.scheme===O.file&&(N.$m||N.$q===`${O.vscodeFileResource}://${R.a}`)?c.with({scheme:O.vscodeFileResource,authority:c.authority||R.a,query:null,fragment:null}):c}asFileUri(c){const g=this.b(c,ne);return this.uriToFileUri(g)}uriToFileUri(c){return c.scheme===O.vscodeFileResource?c.with({scheme:O.file,authority:c.authority!==R.a?c.authority:null,query:null,fragment:null}):c}b(c,g){return j.URI.isUri(c)?c:j.URI.parse(g.toUrl(c))}}e.$ig=new R;var k;(function($){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(c.get("3"));const g="vscode-coi";function p(l){let u;typeof l=="string"?u=new URL(l).searchParams:l instanceof URL?u=l.searchParams:j.URI.isUri(l)&&(u=new URL(l.toString(!0)).searchParams);const h=u?.get(g);if(h)return c.get(h)}$.getHeadersFromQuery=p;function w(l,u,h){if(!globalThis.crossOriginIsolated)return;const d=u&&h?"3":h?"2":"1";l instanceof URLSearchParams?l.set(g,d):l[g]=d}$.addSearchParam=w})(k||(e.COI=k={}))}),define(le[141],he([0,1,123,23,5,10]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SC=void 0;class O{constructor($,c,g){this.id=$,this.dependencies=c,this.callback=g}}class C{static{this.INSTANCE=new C}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,c,g)=>{typeof $!="string"&&(g=c,c=$,$=null),(typeof c!="object"||!Array.isArray(c))&&(g=c,c=null),this.c.push(new O($,c,g))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const c=await(this.a?this.i($):this.b?this.h($):this.j($));if(!c)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}h($){return new Promise((c,g)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const w=()=>{p.removeEventListener("load",l),p.removeEventListener("error",u)},l=h=>{w(),c(this.c.pop())},u=h=>{w(),g(h)};p.addEventListener("load",l),p.addEventListener("error",u),this.f&&($=this.f.createScriptURL($)),p.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(p)})}i($){return new Promise((c,g)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),c(this.c.pop())}catch(p){g(p)}})}async j($){try{const c=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,w=j.URI.parse($).fsPath,l=c.readFileSync(w).toString(),u=p.wrap(l.replace(/^#!.*/,""));return new g.Script(u).runInThisContext().apply(),this.c.pop()}catch(c){throw c}}}const S=new Map;let b={};typeof globalThis.require=="object"&&(b=globalThis.require.paths??{});async function R(k,$,c){if(D.$S){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),b[k]&&(k=b[k]);const g=`${k}/${$}`;if(S.has(g))return S.get(g);let p;if(/^\w[\w\d+.-]*:\/\//.test(g))p=g;else{const h=`${c&&!L.$o?N.$fg:N.$eg}/${g}`;p=N.$ig.asBrowserUri(h).toString(!0)}const w=C.INSTANCE.load(p);return S.set(g,w),w}else return await new Promise((g,p)=>{ne([k],g,p)})}e.$SC=R}),define(le[19],he([0,1,48,23,16,5,27,10]),function(ne,e,D,N,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lg=e.DataUri=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=void 0;function S(c){return(0,C.$vc)(c,!0)}e.$pg=S;class b{constructor(g){this.a=g}compare(g,p,w=!1){return g===p?0:(0,O.$Ye)(this.getComparisonKey(g,w),this.getComparisonKey(p,w))}isEqual(g,p,w=!1){return g===p?!0:!g||!p?!1:this.getComparisonKey(g,w)===this.getComparisonKey(p,w)}getComparisonKey(g,p=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,p,w=!1){if(g.scheme===p.scheme){if(g.scheme===N.Schemas.file)return D.$2f(S(g),S(p),this.a(g))&&g.query===p.query&&(w||g.fragment===p.fragment);if((0,e.$Gg)(g.authority,p.authority))return D.$2f(g.path,p.path,this.a(g),"/")&&g.query===p.query&&(w||g.fragment===p.fragment)}return!1}joinPath(g,...p){return C.URI.joinPath(g,...p)}basenameOrAuthority(g){return(0,e.$yg)(g)||g.authority}basename(g){return L.$fc.basename(g.path)}extname(g){return L.$fc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let p;return g.scheme===N.Schemas.file?p=C.URI.file(L.$lc(S(g))).path:(p=L.$fc.dirname(g.path),g.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),p="/")),g.with({path:p})}normalizePath(g){if(!g.path.length)return g;let p;return g.scheme===N.Schemas.file?p=C.URI.file(L.$gc(S(g))).path:p=L.$fc.normalize(g.path),g.with({path:p})}relativePath(g,p){if(g.scheme!==p.scheme||!(0,e.$Gg)(g.authority,p.authority))return;if(g.scheme===N.Schemas.file){const u=L.$kc(S(g),S(p));return j.$i?D.$Vf(u):u}let w=g.path||"/";const l=p.path||"/";if(this.a(g)){let u=0;for(const h=Math.min(w.length,l.length);u<h&&!(w.charCodeAt(u)!==l.charCodeAt(u)&&w.charAt(u).toLowerCase()!==l.charAt(u).toLowerCase());u++);w=l.substr(0,u)+w.substr(u)}return L.$fc.relative(w,l)}resolvePath(g,p){if(g.scheme===N.Schemas.file){const w=C.URI.file(L.$jc(S(g),p));return g.with({authority:w.authority,path:w.path})}return p=D.$Wf(p),g.with({path:L.$fc.resolve(g.path,p)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,p){return g===p||g!==void 0&&p!==void 0&&(0,O.$6e)(g,p)}hasTrailingPathSeparator(g,p=L.sep){if(g.scheme===N.Schemas.file){const w=S(g);return w.length>D.$Xf(w).length&&w[w.length-1]===p}else{const w=g.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,p=L.sep){return(0,e.$Hg)(g,p)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,p=L.sep){let w=!1;if(g.scheme===N.Schemas.file){const l=S(g);w=l!==void 0&&l.length===D.$Xf(l).length&&l[l.length-1]===p}else{p="/";const l=g.path;w=l.length===1&&l.charCodeAt(l.length-1)===47}return!w&&!(0,e.$Hg)(g,p)?g.with({path:g.path+"/"}):g}}e.$qg=b,e.$rg=new b(()=>!1),e.$sg=new b(c=>c.scheme===N.Schemas.file?!j.$k:!0),e.$tg=new b(c=>!0),e.$ug=e.$rg.isEqual.bind(e.$rg),e.$vg=e.$rg.isEqualOrParent.bind(e.$rg),e.$wg=e.$rg.getComparisonKey.bind(e.$rg),e.$xg=e.$rg.basenameOrAuthority.bind(e.$rg),e.$yg=e.$rg.basename.bind(e.$rg),e.$zg=e.$rg.extname.bind(e.$rg),e.$Ag=e.$rg.dirname.bind(e.$rg),e.$Bg=e.$rg.joinPath.bind(e.$rg),e.$Cg=e.$rg.normalizePath.bind(e.$rg),e.$Dg=e.$rg.relativePath.bind(e.$rg),e.$Eg=e.$rg.resolvePath.bind(e.$rg),e.$Fg=e.$rg.isAbsolutePath.bind(e.$rg),e.$Gg=e.$rg.isEqualAuthority.bind(e.$rg),e.$Hg=e.$rg.hasTrailingPathSeparator.bind(e.$rg),e.$Ig=e.$rg.removeTrailingPathSeparator.bind(e.$rg),e.$Jg=e.$rg.addTrailingPathSeparator.bind(e.$rg);function R(c,g){const p=[];for(let w=0;w<c.length;w++){const l=g(c[w]);c.some((u,h)=>h===w?!1:(0,e.$vg)(l,g(u)))||p.push(c[w])}return p}e.$Kg=R;var k;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function g(p){const w=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(h=>{const[d,E]=h.split(":");d&&E&&w.set(d,E)});const u=p.path.substring(0,p.path.indexOf(";"));return u&&w.set(c.META_DATA_MIME,u),w}c.parseMetaData=g})(k||(e.DataUri=k={}));function $(c,g,p){if(g){let w=c.path;return w&&w[0]!==L.$fc.sep&&(w=L.$fc.sep+w),c.with({scheme:p,authority:g,path:w})}return c.with({scheme:p})}e.$Lg=$}),define(le[6],he([0,1,26,7,3,2,19,5,129,52]),function(ne,e,D,N,L,j,O,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.Promises=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=void 0;function R(H){return!!H&&typeof H.then=="function"}e.$Mg=R;function k(H){const Z=new D.$2d,ie=H(Z.token),ce=new Promise((oe,fe)=>{const de=Z.token.onCancellationRequested(()=>{de.dispose(),Z.dispose(),fe(new N.$4)});Promise.resolve(ie).then(we=>{de.dispose(),Z.dispose(),oe(we)},we=>{de.dispose(),Z.dispose(),fe(we)})});return new class{cancel(){Z.cancel()}then(oe,fe){return ce.then(oe,fe)}catch(oe){return this.then(void 0,oe)}finally(oe){return ce.finally(oe)}}}e.$Ng=k;function $(H,Z,ie){return new Promise((ce,oe)=>{const fe=Z.onCancellationRequested(()=>{fe.dispose(),ce(ie)});H.then(ce,oe).finally(()=>fe.dispose())})}e.$Og=$;function c(H,Z){return new Promise((ie,ce)=>{const oe=Z.onCancellationRequested(()=>{oe.dispose(),ce(new N.$4)});H.then(ie,ce).finally(()=>oe.dispose())})}e.$Pg=c;async function g(H){let Z=-1;const ie=H.map((ce,oe)=>ce.then(fe=>(Z=oe,fe)));try{return await Promise.race(ie)}finally{H.forEach((ce,oe)=>{oe!==Z&&ce.cancel()})}}e.$Qg=g;function p(H,Z,ie){let ce;const oe=setTimeout(()=>{ce?.(void 0),ie?.()},Z);return Promise.race([H.finally(()=>clearTimeout(oe)),new Promise(fe=>ce=fe)])}e.$Rg=p;function w(H){return new Promise((Z,ie)=>{const ce=H();R(ce)?ce.then(Z,ie):Z(ce)})}e.$Sg=w;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const ie=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(ie,ie).then(ce)})}return new Promise((ie,ce)=>{this.b.then(ie,ce)})}return this.a=Z(),new Promise((ie,ce)=>{this.a.then(oe=>{this.a=null,ie(oe)},oe=>{this.a=null,ce(oe)})})}dispose(){this.f=!0}}e.$Tg=l;class u{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$Ug=u;class h{constructor(){this.a=new Map}queue(Z,ie){const oe=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(Z)===oe&&this.a.delete(Z)});return this.a.set(Z,oe),oe}}e.$Vg=h;const d=(H,Z)=>{let ie=!0;const ce=setTimeout(()=>{ie=!1,Z()},H);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(ce),ie=!1}}},E=H=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,H())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class s{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,ie=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((oe,fe)=>{this.d=oe,this.f=fe}).then(()=>{if(this.b=null,this.d=null,this.g){const oe=this.g;return this.g=null,oe()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=ie===S.$Od?E(ce):d(ie,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Wg=s;class o{constructor(Z){this.a=new s(Z),this.b=new l}trigger(Z,ie){return this.a.trigger(()=>this.b.queue(Z),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Xg=o;class n{constructor(){this.a=!1,this.b=new Promise((Z,ie)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Yg=n;class i extends n{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Zg=i;function t(H,Z){return Z?new Promise((ie,ce)=>{const oe=setTimeout(()=>{fe.dispose(),ie()},H),fe=Z.onCancellationRequested(()=>{clearTimeout(oe),fe.dispose(),ce(new N.$4)})}):k(ie=>t(H,ie))}e.$1g=t;function r(H,Z=0,ie){const ce=setTimeout(()=>{H(),ie&&oe.dispose()},Z),oe=(0,j.$Pc)(()=>{clearTimeout(ce),ie?.deleteAndLeak(oe)});return ie?.add(oe),oe}e.$2g=r;function a(H){const Z=[];let ie=0;const ce=H.length;function oe(){return ie<ce?H[ie++]():null}function fe(de){de!=null&&Z.push(de);const we=oe();return we?we.then(fe):Promise.resolve(Z)}return Promise.resolve(null).then(fe)}e.$3g=a;function v(H,Z=ce=>!!ce,ie=null){let ce=0;const oe=H.length,fe=()=>{if(ce>=oe)return Promise.resolve(ie);const de=H[ce++];return Promise.resolve(de()).then(ve=>Z(ve)?Promise.resolve(ve):fe())};return fe()}e.$4g=v;function m(H,Z=ce=>!!ce,ie=null){if(H.length===0)return Promise.resolve(ie);let ce=H.length;const oe=()=>{ce=-1;for(const fe of H)fe.cancel?.()};return new Promise((fe,de)=>{for(const we of H)we.then(ve=>{--ce>=0&&Z(ve)?(oe(),fe(ve)):ce===0&&fe(ie)}).catch(ve=>{--ce>=0&&(oe(),de(ve))})})}e.$5g=m;class f{constructor(Z){this.a=0,this.d=Z,this.f=[],this.b=0,this.g=new L.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(Z){return this.a++,new Promise((ie,ce)=>{this.f.push({factory:Z,c:ie,e:ce}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Z=this.f.shift();this.b++;const ie=Z.factory();ie.then(Z.c,Z.e),ie.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$6g=f;class y extends f{constructor(){super(1)}}e.$7g=y;class I{constructor(){this.a=new B,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$8g=I;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new _;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueFor(Z,ie=O.$rg){const ce=ie.getComparisonKey(Z);let oe=this.a.get(ce);if(!oe){oe=new y;const fe=this.f++,de=L.Event.once(oe.onDrained)(()=>{oe?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$1c),this.d.set(fe,de),this.a.set(ce,oe)}return oe}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$9g=F;class T{constructor(Z,ie){this.a=-1,typeof Z=="function"&&typeof ie=="number"&&this.setIfNotSet(Z,ie)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,ie){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},ie)}setIfNotSet(Z,ie){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},ie))}}e.$0g=T;class M{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,ie,ce=globalThis){this.cancel();const oe=ce.setInterval(()=>{Z()},ie);this.d=(0,j.$Pc)(()=>{ce.clearInterval(oe),this.d=void 0})}dispose(){this.cancel()}}e.$$g=M;class U{constructor(Z,ie){this.b=-1,this.a=Z,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$_g=U;class Y{constructor(Z,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=Z,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ah=Y;class J extends U{constructor(Z,ie){super(Z,ie),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$bh=J;class x extends j.$Rc{constructor(Z,ie){super(),this.g=Z,this.h=ie,this.a=[],this.b=this.B(new j.$Sc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of Z)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ch=x,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$eh=(H,Z)=>{(0,C.$B)(()=>{if(ie)return;const ce=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$eh=(H,Z,ie)=>{const ce=H.requestIdleCallback(Z,typeof ie=="number"?{timeout:ie}:void 0);let oe=!1;return{dispose(){oe||(oe=!0,H.cancelIdleCallback(ce))}}},e.$dh=H=>(0,e.$eh)(globalThis,H)}();class W{constructor(Z,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$eh)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$fh=W;class X extends W{constructor(Z){super(globalThis,Z)}}e.$gh=X;async function V(H,Z,ie){let ce;for(let oe=0;oe<ie;oe++)try{return await H()}catch(fe){ce=fe,await t(Z)}throw ce}e.$hh=V;class B{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,ie,ce){return this.a={taskId:Z,cancel:()=>ce?.(),promise:ie},ie.then(()=>this.d(Z),()=>this.d(Z)),ie}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{let ie,ce;const oe=new Promise((fe,de)=>{ie=fe,ce=de});this.b={run:Z,promise:oe,promiseResolve:ie,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ih=B;class te{constructor(Z,ie=()=>Date.now()){this.d=Z,this.f=ie,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$jh=te;var se;(function(H){H[H.Resolved=0]="Resolved",H[H.Rejected=1]="Rejected"})(se||(se={}));class _{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Z,ie)=>{this.a=Z,this.b=ie})}complete(Z){return new Promise(ie=>{this.a(Z),this.d={outcome:0,value:Z},ie()})}error(Z){return new Promise(ie=>{this.b(Z),this.d={outcome:1,value:Z},ie()})}cancel(){return this.error(new N.$4)}}e.$kh=_;var re;(function(H){async function Z(ce){let oe;const fe=await Promise.all(ce.map(de=>de.then(we=>we,we=>{oe||(oe=we)})));if(typeof oe<"u")throw oe;return fe}H.settled=Z;function ie(ce){return new Promise(async(oe,fe)=>{try{await ce(oe,fe)}catch(de){fe(de)}})}H.withAsyncBody=ie})(re||(e.Promises=re={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new N.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$lh=K;class z{constructor(Z){this.b=Z,this.a=new b.$U(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$mh=z;var P;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(P||(P={}));class A{static fromArray(Z){return new A(ie=>{ie.emitMany(Z)})}static fromPromise(Z){return new A(async ie=>{ie.emitMany(await Z)})}static fromPromises(Z){return new A(async ie=>{await Promise.all(Z.map(async ce=>ie.emitOne(await ce)))})}static merge(Z){return new A(async ie=>{await Promise.all(Z.map(async ce=>{for await(const oe of ce)ie.emitOne(oe)}))})}static{this.EMPTY=A.fromArray([])}constructor(Z){this.a=0,this.b=[],this.d=null,this.f=new L.$Rd,queueMicrotask(async()=>{const ie={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(Z(ie)),this.j()}catch(ce){this.k(ce)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.f.event)}while(!0)}}}static map(Z,ie){return new A(async ce=>{for await(const oe of Z)ce.emitOne(ie(oe))})}map(Z){return A.map(this,Z)}static filter(Z,ie){return new A(async ce=>{for await(const oe of Z)ie(oe)&&ce.emitOne(oe)})}filter(Z){return A.filter(this,Z)}static coalesce(Z){return A.filter(Z,ie=>!!ie)}coalesce(){return A.coalesce(this)}static async toPromise(Z){const ie=[];for await(const ce of Z)ie.push(ce);return ie}toPromise(){return A.toPromise(this)}g(Z){this.a===0&&(this.b.push(Z),this.f.fire())}h(Z){this.a===0&&(this.b=this.b.concat(Z),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Z){this.a===0&&(this.a=2,this.d=Z,this.f.fire())}}e.$nh=A;class G extends A{constructor(Z,ie){super(ie),this.l=Z}cancel(){this.l.cancel()}}e.$oh=G;function q(H){const Z=new D.$2d,ie=H(Z.token);return new G(Z,async ce=>{const oe=Z.token.onCancellationRequested(()=>{oe.dispose(),Z.dispose(),ce.reject(new N.$4)});try{for await(const fe of ie){if(Z.token.isCancellationRequested)return;ce.emitOne(fe)}oe.dispose(),Z.dispose()}catch(fe){oe.dispose(),Z.dispose(),ce.reject(fe)}})}e.$ph=q;class ee{constructor(){this.a=new _,this.b=new A(ce=>{if(Z){ce.reject(Z);return}return ie&&ce.emitMany(ie),this.d=oe=>ce.reject(oe),this.f=oe=>ce.emitOne(oe),this.a.p});let Z,ie;this.f=ce=>{ie||(ie=[]),ie.push(ce)},this.d=ce=>{Z||(Z=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$qh=ee}),define(le[91],he([0,1,18,6,48,34,16,5,27]),function(ne,e,D,N,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=void 0;function b(){return Object.create(null)}e.$Bj=b,e.$Cj="**",e.$Dj="/";const R="[/\\\\]",k="[^/\\\\]",$=/\//g;function c(X,V){switch(X){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${V?`|${R}${k}+`:""})*?`}}function g(X,V){if(!X)return[];const B=[];let te=!1,se=!1,_="";for(const re of X){switch(re){case V:if(!te&&!se){B.push(_),_="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":se=!0;break;case"]":se=!1;break}_+=re}return _&&B.push(_),B}e.$Ej=g;function p(X){if(!X)return"";let V="";const B=g(X,e.$Dj);if(B.every(te=>te===e.$Cj))V=".*";else{let te=!1;B.forEach((se,_)=>{if(se===e.$Cj){if(te)return;V+=c(2,_===B.length-1)}else{let re=!1,K="",z=!1,P="";for(const A of se){if(A!=="}"&&re){K+=A;continue}if(z&&(A!=="]"||!P)){let G;A==="-"?G=A:(A==="^"||A==="!")&&!P?G="^":A===e.$Dj?G="":G=(0,S.$Je)(A),P+=G;continue}switch(A){case"{":re=!0;continue;case"[":z=!0;continue;case"}":{const q=`(?:${g(K,",").map(ee=>p(ee)).join("|")})`;V+=q,re=!1,K="";break}case"]":{V+="["+P+"]",z=!1,P="";break}case"?":V+=k;continue;case"*":V+=c(1);continue;default:V+=(0,S.$Je)(A)}}_<B.length-1&&(B[_+1]!==e.$Cj||_+2<B.length)&&(V+=R)}te=se===e.$Cj})}return V}const w=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,E=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new j.$Cc(1e4),o=function(){return!1},n=function(){return null};function i(X,V){if(!X)return n;let B;typeof X!="string"?B=X.pattern:B=X,B=B.trim();const te=`${B}_${!!V.trimForExclusions}`;let se=s.get(te);if(se)return t(se,X);let _;return w.test(B)?se=a(B.substr(4),B):(_=l.exec(r(B,V)))?se=v(_[1],B):(V.trimForExclusions?h:u).test(B)?se=m(B,V):(_=d.exec(r(B,V)))?se=f(_[1].substr(1),B,!0):(_=E.exec(r(B,V)))?se=f(_[1],B,!1):se=y(B),s.set(te,se),t(se,X)}function t(X,V){if(typeof V=="string")return X;const B=function(te,se){return(0,L.$2f)(te,V.base,!C.$k)?X((0,S.$Ne)(te.substr(V.base.length),O.sep),se):null};return B.allBasenames=X.allBasenames,B.allPaths=X.allPaths,B.basenames=X.basenames,B.patterns=X.patterns,B}function r(X,V){return V.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function a(X,V){return function(B,te){return typeof B=="string"&&B.endsWith(X)?V:null}}function v(X,V){const B=`/${X}`,te=`\\${X}`,se=function(re,K){return typeof re!="string"?null:K?K===X?V:null:re===X||re.endsWith(B)||re.endsWith(te)?V:null},_=[X];return se.basenames=_,se.patterns=[V],se.allBasenames=_,se}function m(X,V){const B=x(X.slice(1,-1).split(",").map(K=>i(K,V)).filter(K=>K!==n),X),te=B.length;if(!te)return n;if(te===1)return B[0];const se=function(K,z){for(let P=0,A=B.length;P<A;P++)if(B[P](K,z))return X;return null},_=B.find(K=>!!K.allBasenames);_&&(se.allBasenames=_.allBasenames);const re=B.reduce((K,z)=>z.allPaths?K.concat(z.allPaths):K,[]);return re.length&&(se.allPaths=re),se}function f(X,V,B){const te=O.sep===O.$fc.sep,se=te?X:X.replace($,O.sep),_=O.sep+se,re=O.$fc.sep+X;let K;return B?K=function(z,P){return typeof z=="string"&&(z===se||z.endsWith(_)||!te&&(z===X||z.endsWith(re)))?V:null}:K=function(z,P){return typeof z=="string"&&(z===se||!te&&z===X)?V:null},K.allPaths=[(B?"*/":"./")+X],K}function y(X){try{const V=new RegExp(`^${p(X)}$`);return function(B){return V.lastIndex=0,typeof B=="string"&&V.test(B)?X:null}}catch{return n}}function I(X,V,B){return!X||typeof V!="string"?!1:F(X)(V,void 0,B)}e.$Fj=I;function F(X,V={}){if(!X)return o;if(typeof X=="string"||T(X)){const B=i(X,V);if(B===n)return o;const te=function(se,_){return!!B(se,_)};return B.allBasenames&&(te.allBasenames=B.allBasenames),B.allPaths&&(te.allPaths=B.allPaths),te}return Y(X,V)}e.$Gj=F;function T(X){const V=X;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.$Hj=T;function M(X){return X.allBasenames||[]}e.$Ij=M;function U(X){return X.allPaths||[]}e.$Jj=U;function Y(X,V){const B=x(Object.getOwnPropertyNames(X).map(K=>J(K,X[K],V)).filter(K=>K!==n)),te=B.length;if(!te)return n;if(!B.some(K=>!!K.requiresSiblings)){if(te===1)return B[0];const K=function(A,G){let q;for(let ee=0,H=B.length;ee<H;ee++){const Z=B[ee](A,G);if(typeof Z=="string")return Z;(0,N.$Mg)(Z)&&(q||(q=[]),q.push(Z))}return q?(async()=>{for(const ee of q){const H=await ee;if(typeof H=="string")return H}return null})():null},z=B.find(A=>!!A.allBasenames);z&&(K.allBasenames=z.allBasenames);const P=B.reduce((A,G)=>G.allPaths?A.concat(G.allPaths):A,[]);return P.length&&(K.allPaths=P),K}const se=function(K,z,P){let A,G;for(let q=0,ee=B.length;q<ee;q++){const H=B[q];H.requiresSiblings&&P&&(z||(z=(0,O.$mc)(K)),A||(A=z.substr(0,z.length-(0,O.$nc)(K).length)));const Z=H(K,z,A,P);if(typeof Z=="string")return Z;(0,N.$Mg)(Z)&&(G||(G=[]),G.push(Z))}return G?(async()=>{for(const q of G){const ee=await q;if(typeof ee=="string")return ee}return null})():null},_=B.find(K=>!!K.allBasenames);_&&(se.allBasenames=_.allBasenames);const re=B.reduce((K,z)=>z.allPaths?K.concat(z.allPaths):K,[]);return re.length&&(se.allPaths=re),se}function J(X,V,B){if(V===!1)return n;const te=i(X,B);if(te===n)return n;if(typeof V=="boolean")return te;if(V){const se=V.when;if(typeof se=="string"){const _=(re,K,z,P)=>{if(!P||!te(re,K))return null;const A=se.replace("$(basename)",()=>z),G=P(A);return(0,N.$Mg)(G)?G.then(q=>q?X:null):G?X:null};return _.requiresSiblings=!0,_}}return te}function x(X,V){const B=X.filter(K=>!!K.basenames);if(B.length<2)return X;const te=B.reduce((K,z)=>{const P=z.basenames;return P?K.concat(P):K},[]);let se;if(V){se=[];for(let K=0,z=te.length;K<z;K++)se.push(V)}else se=B.reduce((K,z)=>{const P=z.patterns;return P?K.concat(P):K},[]);const _=function(K,z){if(typeof K!="string")return null;if(!z){let A;for(A=K.length;A>0;A--){const G=K.charCodeAt(A-1);if(G===47||G===92)break}z=K.substr(A)}const P=te.indexOf(z);return P!==-1?se[P]:null};_.basenames=te,_.patterns=se,_.allBasenames=te;const re=X.filter(K=>!K.basenames);return re.push(_),re}function W(X,V){return(0,D.$tb)(X,V,(B,te)=>typeof B=="string"&&typeof te=="string"?B===te:typeof B!="string"&&typeof te!="string"?B.base===te.base&&B.pattern===te.pattern:!1)}e.$Kj=W}),define(le[92],he([0,1,15,10]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=void 0;function L(k){return k.toJSON()}class j{constructor($){this.a=$}transformIncoming($){const c=this.a.transformIncoming($);return c===$?$:L(N.URI.from(c))}transformOutgoing($){const c=this.a.transformOutgoing($);return c===$?$:L(N.URI.from(c))}transformOutgoingURI($){const c=this.a.transformOutgoing($);return c===$?$:N.URI.from(c)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Vm=j,e.$Wm=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function O(k,$,c){if(!k||c>200)return null;if(typeof k=="object"){if(k instanceof N.URI)return $.transformOutgoing(k);for(const g in k)if(Object.hasOwnProperty.call(k,g)){const p=O(k[g],$,c+1);p!==null&&(k[g]=p)}}return null}function C(k,$){const c=O(k,$,0);return c===null?k:c}e.$Xm=C;function S(k,$,c,g){if(!k||g>200)return null;if(typeof k=="object"){if(k.$mid===1)return c?N.URI.revive($.transformIncoming(k)):$.transformIncoming(k);if(k instanceof D.$fe)return null;for(const p in k)if(Object.hasOwnProperty.call(k,p)){const w=S(k[p],$,c,g+1);w!==null&&(k[p]=w)}}return null}function b(k,$){const c=S(k,$,!1,0);return c===null?k:c}e.$Ym=b;function R(k,$){const c=S(k,$,!0,0);return c===null?k:c}e.$Zm=R}),define(le[142],he([0,1,36,47,32,130,5]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=e.$2m=void 0,e.$2m=new class{c($){return this.a||(this.a=N.$6h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,c=0;const g=(0,D.networkInterfaces)();for(const p in g){const w=g[p];if(w)for(const{mac:l,internal:u}of w)u||(c+=1,this.c(l.toUpperCase())&&($+=1))}this.b=c>0?$/c:0}return this.b}};let C;async function S($){return C||(C=(async()=>await b($)||L.$kg())()),C}e.$3m=S;async function b($){try{const c=await new Promise((p,w)=>{ne(["crypto"],p,w)}),g=(0,j.$1m)();return c.createHash("sha256").update(g,"utf8").digest("hex")}catch(c){$(c);return}}const R="Software\\Microsoft\\SQMClient";async function k($){if(O.$i){const c=await new Promise((g,p)=>{ne(["@vscode/windows-registry"],g,p)});try{return c.GetStringRegKey("HKEY_LOCAL_MACHINE",R,"MachineId")||""}catch(g){return $(g),""}}return""}e.$4m=k}),define(le[31],he([0,1,54,36,268,6,48,88,16,5,19,10]),function(ne,e,D,N,L,j,O,C,S,b,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function c(J,x=$.UNLINK,W){if((0,O.$5f)(J))throw new Error("rimraf - will refuse to recursively delete root");return x===$.UNLINK?p(J):g(J,W)}async function g(J,x=(0,O.$0f)((0,N.tmpdir)())){try{try{await D.promises.rename(J,x)}catch(W){return W.code==="ENOENT"?void 0:p(J)}p(x).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function p(J){return(0,L.promisify)(D.rm)(J,{recursive:!0,force:!0,maxRetries:3})}function w(J){if((0,O.$5f)(J))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function l(J,x){return d(await(x?u(J):(0,L.promisify)(D.readdir)(J)))}async function u(J){try{return await(0,L.promisify)(D.readdir)(J,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const x=[],W=await l(J);for(const X of W){let V=!1,B=!1,te=!1;try{const se=await e.Promises.lstat((0,S.$ic)(J,X));V=se.isFile(),B=se.isDirectory(),te=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}x.push({name:X,isFile:()=>V,isDirectory:()=>B,isSymbolicLink:()=>te})}return x}function h(J){return d(D.readdirSync(J))}e.readdirSync=h;function d(J){return J.map(x=>typeof x=="string"?b.$j?(0,C.$yl)(x):x:(x.name=b.$j?(0,C.$yl)(x.name):x.name,x))}async function E(J){const x=await l(J),W=[];for(const X of x)await o.existsDirectory((0,S.$ic)(J,X))&&W.push(X);return W}function s(J,x=1e3){return new Promise(W=>{let X=!1;const V=setInterval(()=>{X||(X=!0,D.access(J,B=>{X=!1,B&&(clearInterval(V),W(void 0))}))},x)})}e.whenDeleted=s;var o;(function(J){async function x(V){let B;try{if(B=await e.Promises.lstat(V),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(b.$i&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw se}throw te}}J.stat=x;async function W(V){try{const{stat:B,symbolicLink:te}=await J.stat(V);return B.isFile()&&te?.dangling!==!0}catch{}return!1}J.existsFile=W;async function X(V){try{const{stat:B,symbolicLink:te}=await J.stat(V);return B.isDirectory()&&te?.dangling!==!0}catch{}return!1}J.existsDirectory=X})(o||(e.SymlinkSupport=o={}));const n=new j.$9g;function i(J,x,W){return n.queueFor(k.URI.file(J),R.$sg).queue(()=>{const X=m(W);return new Promise((V,B)=>a(J,x,X,te=>te?B(te):V()))})}let t=!0;function r(J){t=J}e.configureFlushOnWrite=r;function a(J,x,W,X){if(!t)return D.writeFile(J,x,{mode:W.mode,flag:W.flag},X);D.open(J,W.flag,W.mode,(V,B)=>{if(V)return X(V);D.writeFile(B,x,te=>{if(te)return D.close(B,()=>X(te));D.fdatasync(B,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),r(!1)),D.close(B,_=>X(_))))})})}function v(J,x,W){const X=m(W);if(!t)return D.writeFileSync(J,x,{mode:X.mode,flag:X.flag});const V=D.openSync(J,X.flag,X.mode);try{D.writeFileSync(V,x);try{D.fdatasyncSync(V)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r(!1)}}finally{D.closeSync(V)}}e.writeFileSync=v;function m(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function f(J,x,W=6e4){if(J!==x)try{b.$i&&typeof W=="number"?await y(J,x,Date.now(),W):await(0,L.promisify)(D.rename)(J,x)}catch(X){if(J.toLowerCase()!==x.toLowerCase()&&X.code==="EXDEV"||J.endsWith("."))await I(J,x,{preserveSymlinks:!1}),await c(J,$.MOVE);else throw X}}async function y(J,x,W,X,V=0){try{return await(0,L.promisify)(D.rename)(J,x)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-W>=X)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${B}`),B;if(V===0){let te=!1;try{const{stat:se}=await o.stat(x);se.isFile()||(te=!0)}catch{}if(te)throw B}return await(0,j.$1g)(Math.min(100,V*10)),y(J,x,W,X,V+1)}}async function I(J,x,W){return T(J,x,{root:{source:J,target:x},options:W,handledSourcePaths:new Set})}const F=511;async function T(J,x,W){if(W.handledSourcePaths.has(J))return;W.handledSourcePaths.add(J);const{stat:X,symbolicLink:V}=await o.stat(J);if(V){if(W.options.preserveSymlinks)try{return await Y(J,x,W)}catch{}if(V.dangling)return}return X.isDirectory()?M(J,x,X.mode&F,W):U(J,x,X.mode&F)}async function M(J,x,W,X){await e.Promises.mkdir(x,{recursive:!0,mode:W});const V=await l(J);for(const B of V)await T((0,S.$ic)(J,B),(0,S.$ic)(x,B),X)}async function U(J,x,W){await e.Promises.copyFile(J,x),await e.Promises.chmod(x,W)}async function Y(J,x,W){let X=await e.Promises.readlink(J);(0,O.$2f)(X,W.root.source,!b.$k)&&(X=(0,S.$ic)(W.root.target,X.substr(W.root.source.length+1))),await e.Promises.symlink(X,x)}e.Promises=new class{get access(){return(0,L.promisify)(D.access)}get stat(){return(0,L.promisify)(D.stat)}get lstat(){return(0,L.promisify)(D.lstat)}get utimes(){return(0,L.promisify)(D.utimes)}get read(){return(J,x,W,X,V)=>new Promise((B,te)=>{D.read(J,x,W,X,V,(se,_,re)=>se?te(se):B({bytesRead:_,buffer:re}))})}get readFile(){return(0,L.promisify)(D.readFile)}get write(){return(J,x,W,X,V)=>new Promise((B,te)=>{D.write(J,x,W,X,V,(se,_,re)=>se?te(se):B({bytesWritten:_,buffer:re}))})}get appendFile(){return(0,L.promisify)(D.appendFile)}get fdatasync(){return(0,L.promisify)(D.fdatasync)}get truncate(){return(0,L.promisify)(D.truncate)}get copyFile(){return(0,L.promisify)(D.copyFile)}get open(){return(0,L.promisify)(D.open)}get close(){return(0,L.promisify)(D.close)}get symlink(){return(0,L.promisify)(D.symlink)}get readlink(){return(0,L.promisify)(D.readlink)}get chmod(){return(0,L.promisify)(D.chmod)}get mkdir(){return(0,L.promisify)(D.mkdir)}get unlink(){return(0,L.promisify)(D.unlink)}get rmdir(){return(0,L.promisify)(D.rmdir)}get realpath(){return(0,L.promisify)(D.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return E}get writeFile(){return i}get rm(){return c}get rename(){return f}get copy(){return I}}}),define(le[143],he([0,1,54,16,5,27,31]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.$dq=e.$cq=void 0;function C($){if(L.$k)return $;const c=(0,N.$lc)($);if($===c)return $;const g=((0,N.$mc)($)||$).toLowerCase();try{const w=(0,O.readdirSync)(c).filter(l=>l.toLowerCase()===g);if(w.length===1){const l=C(c);if(l)return(0,N.$ic)(l,w[0])}else if(w.length>1){const l=w.indexOf(g);if(l>=0){const u=C(c);if(u)return(0,N.$ic)(u,w[l])}}}catch{}return null}e.$cq=C;async function S($){if(L.$k)return $;const c=(0,N.$lc)($);if($===c)return $;const g=((0,N.$mc)($)||$).toLowerCase();try{const w=(await O.Promises.readdir(c)).filter(l=>l.toLowerCase()===g);if(w.length===1){const l=await S(c);if(l)return(0,N.$ic)(l,w[0])}else if(w.length>1){const l=w.indexOf(g);if(l>=0){const u=await S(c);if(u)return(0,N.$ic)(u,w[l])}}}catch{}return null}e.$dq=S;async function b($){try{return await O.Promises.realpath($)}catch{const g=k($);return await O.Promises.access(g,D.constants.R_OK),g}}e.$eq=b;function R($){try{return D.realpathSync($)}catch{const g=k($);return D.accessSync(g,D.constants.R_OK),g}}e.$fq=R;function k($){return(0,j.$Oe)((0,N.$gc)($),N.sep)}}),define(le[144],he([0,1,16,5,37,90,12,31]),function(ne,e,D,N,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ml=e.$Ll=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function S(k=L.env){return k.comspec||"cmd.exe"}e.$Ll=S;function b(k){let $=[],c=!1;const g=function(p){if(c){$.push(p);return}(!k.send(p,l=>{if(l&&console.error(l),c=!1,$.length>0){const u=$.slice(0);$=[],u.forEach(h=>g(h))}})||N.$i)&&(c=!0)};return{send:g}}e.$Ml=b;var R;(function(k){async function $(c,g,p){if(D.$hc(c))return c;if(g===void 0&&(g=L.cwd()),D.$lc(c)!=="."||(p===void 0&&O.$Cf(L.env.PATH)&&(p=L.env.PATH.split(D.$sc)),p===void 0||p.length===0))return D.$ic(g,c);async function l(u){if(await C.Promises.exists(u)){let h;try{h=await C.Promises.stat(u)}catch(d){d.message.startsWith("EACCES")&&(h=await C.Promises.lstat(u))}return h?!h.isDirectory():!1}return!1}for(const u of p){let h;if(D.$hc(u)?h=D.$ic(u,c):h=D.$ic(g,u,c),await l(h))return h;let d=h+".com";if(await l(d)||(d=h+".exe",await l(d)))return d}return D.$ic(g,c)}k.findExecutable=$})(R||(e.win32=R={}))}),define(le[145],he([0,1,66,23]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=void 0;function L(O){return new Promise((C,S)=>{let b;const R=new Map;function k(c,g,p,w,l){const u=R.get(g);if(c===O||u){const h={name:$(p),cmd:p,pid:c,ppid:g,load:w,mem:l};R.set(c,h),c===O&&(b=h),u&&(u.children||(u.children=[]),u.children.push(h),u.children.length>1&&(u.children=u.children.sort((d,E)=>d.pid-E.pid)))}}function $(c){const g=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,w=/--crashes-directory/i,l=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,h=/--type=([a-zA-Z-]+)/;if(w.exec(c))return"electron-crash-reporter";if(l.exec(c))return"winpty-agent";if(u.exec(c))return"conpty-agent";let d=h.exec(c);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?g.exec(c)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const E=/[a-zA-Z-]+\.js/g;let s="";do d=E.exec(c),d&&(s+=d+" ");while(d);return s&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${s})`:p.exec(c)?`electron-nodejs (${c})`:c}if(process.platform==="win32"){const c=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,p)=>{ne(["@vscode/windows-process-tree"],g,p)}).then(g=>{g.getProcessList(O,p=>{if(!p){S(new Error(`Root process ${O} not found`));return}g.getProcessCpuUsage(p,w=>{const l=new Map;w.forEach(u=>{const h=c(u.commandLine||"");l.set(u.pid,{name:$(h),cmd:h,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),b=l.get(O),b?(l.forEach(u=>{const h=l.get(u.ppid);h&&(h.children||(h.children=[]),h.children.push(u))}),l.forEach(u=>{u.children&&(u.children=u.children.sort((h,d)=>h.pid-d.pid))}),C(b)):S(new Error(`Root process ${O} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let c=function(){let g=[b];const p=[];for(;g.length;){const l=g.shift();l&&(p.push(l.pid),l.children&&(g=g.concat(l.children)))}let w=JSON.stringify(N.$ig.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+p.join(" "),(0,D.exec)(w,{},(l,u,h)=>{if(l||h)S(l||new Error(h.toString()));else{const d=u.toString().split(`
`);for(let E=0;E<p.length;E++){const s=R.get(p[E]);s.load=parseFloat(d[E])}if(!b){S(new Error(`Root process ${O} not found`));return}C(b)}})};(0,D.exec)("which ps",{},(g,p,w)=>{if(g||w)if(process.platform!=="linux")S(g||new Error(w.toString()));else{const l=JSON.stringify(N.$ig.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(l,{},(u,h,d)=>{u||d?S(u||new Error(d.toString())):(j(h,k),c())})}else{const l=p.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${l} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,d,E)=>{h||E&&!E.includes("screen size is bogus")?S(h||new Error(E.toString())):(j(d,k),process.platform==="linux"?c():b?C(b):S(new Error(`Root process ${O} not found`)))})}})}})}e.$Mr=L;function j(O,C){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=O.toString().split(`
`);for(const R of b){const k=S.exec(R.trim());k&&k.length===6&&C(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}});var ye=this&&this.__decorate||function(ne,e,D,N){var L=arguments.length,j=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,D):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ne,e,D,N);else for(var C=ne.length-1;C>=0;C--)(O=ne[C])&&(j=(L<3?O(j):L>3?O(e,D,j):O(e,D))||j);return L>3&&j&&Object.defineProperty(e,D,j),j};define(le[40],he([0,1,18,6,15,26,84,7,3,2,65,27,12]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.ProxyChannel=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.RequestInitiator=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=void 0;var c;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(c||(c={}));function g(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(p||(p={}));function w(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(l||(l={}));function u(V){let B=0;for(let te=0;;te+=7){const se=V.read(1);if(B|=(se.buffer[0]&127)<<te,!(se.buffer[0]&128))return B}}const h=n(0);function d(V,B){if(B===0){V.write(h);return}let te=0;for(let _=B;_!==0;_=_>>>7)te++;const se=L.$fe.alloc(te);for(let _=0;B!==0;_++)se.buffer[_]=B&127,B=B>>>7,B>0&&(se.buffer[_]|=128);V.write(se)}class E{constructor(B){this.b=B,this.a=0}read(B){const te=this.b.slice(this.a,this.a+B);return this.a+=te.byteLength,te}}e.$xh=E;class s{constructor(){this.a=[]}get buffer(){return L.$fe.concat(this.a)}write(B){this.a.push(B)}}e.$yh=s;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function n(V){const B=L.$fe.alloc(1);return B.writeUInt8(V,0),B}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(V,B){if(typeof B>"u")V.write(i.Undefined);else if(typeof B=="string"){const te=L.$fe.fromString(B);V.write(i.String),d(V,te.byteLength),V.write(te)}else if(t&&Buffer.isBuffer(B)){const te=L.$fe.wrap(B);V.write(i.Buffer),d(V,te.byteLength),V.write(te)}else if(B instanceof L.$fe)V.write(i.VSBuffer),d(V,B.byteLength),V.write(B);else if(Array.isArray(B)){V.write(i.Array),d(V,B.length);for(const te of B)r(V,te)}else if(typeof B=="number"&&(B|0)===B)V.write(i.Uint),d(V,B);else{const te=L.$fe.fromString(JSON.stringify(B));V.write(i.Object),d(V,te.byteLength),V.write(te)}}e.$zh=r;function a(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(u(V)).toString();case o.Buffer:return V.read(u(V)).buffer;case o.VSBuffer:return V.read(u(V));case o.Array:{const te=u(V),se=[];for(let _=0;_<te;_++)se.push(a(V));return se}case o.Object:return JSON.parse(V.read(u(V)).toString());case o.Int:return u(V)}}e.$Ah=a;class v{constructor(B,te,se=null,_=1e3){this.h=B,this.j=te,this.k=se,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:200})}registerChannel(B,te){this.b.set(B,te),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const te=this.o([B.type]);this.k?.logOutgoing(te,0,1,w(B.type));return}case 201:case 202:case 204:case 203:{const te=this.o([B.type,B.id],B.data);this.k?.logOutgoing(te,B.id,1,w(B.type),B.data);return}}}o(B,te=void 0){const se=new s;return r(se,B),r(se,te),this.p(se.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const te=new E(B),se=a(te),_=a(te),re=se[0];switch(re){case 100:return this.k?.logIncoming(B.byteLength,se[1],1,`${g(re)}: ${se[2]}.${se[3]}`,_),this.s({type:re,id:se[1],channelName:se[2],name:se[3],arg:_});case 102:return this.k?.logIncoming(B.byteLength,se[1],1,`${g(re)}: ${se[2]}.${se[3]}`,_),this.t({type:re,id:se[1],channelName:se[2],name:se[3],arg:_});case 101:return this.k?.logIncoming(B.byteLength,se[1],1,`${g(re)}`),this.u({type:re,id:se[1]});case 103:return this.k?.logIncoming(B.byteLength,se[1],1,`${g(re)}`),this.u({type:re,id:se[1]})}}s(B){const te=this.b.get(B.channelName);if(!te){this.v(B);return}const se=new j.$2d;let _;try{_=te.call(this.j,B.name,B.arg,se.token)}catch(z){_=Promise.reject(z)}const re=B.id;_.then(z=>{this.m({id:re,data:z,type:201})},z=>{z instanceof Error?this.m({id:re,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:re,data:z,type:203})}).finally(()=>{K.dispose(),this.d.delete(B.id)});const K=(0,b.$Pc)(()=>se.cancel());this.d.set(B.id,K)}t(B){const te=this.b.get(B.channelName);if(!te){this.v(B);return}const se=B.id,re=te.listen(this.j,B.name,B.arg)(K=>this.m({id:se,data:K,type:204}));this.d.set(B.id,re)}u(B){const te=this.d.get(B.id);te&&(te.dispose(),this.d.delete(B.id))}v(B){let te=this.g.get(B.channelName);te||(te=[],this.g.set(B.channelName,te));const se=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);te.push({request:B,timeoutTimer:se})}w(B){const te=this.g.get(B);if(te){for(const se of te)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.s(se.request);break;case 102:this.t(se.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Mc)(this.d.values()),this.d.clear()}}e.$Bh=v;var m;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class f{constructor(B,te=null){this.l=B,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$Rd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=te}getChannel(B){const te=this;return{call(se,_,re){return te.a?Promise.reject(new C.$4):te.m(B,se,_,re)},listen(se,_){return te.a?S.Event.None:te.o(B,se,_)}}}m(B,te,se,_=j.CancellationToken.None){const re=this.g++,z={id:re,type:100,channelName:B,name:te,arg:se};if(_.isCancellationRequested)return Promise.reject(new C.$4);let P;return new Promise((G,q)=>{if(_.isCancellationRequested)return q(new C.$4);const ee=()=>{const ce=oe=>{switch(oe.type){case 201:this.f.delete(re),G(oe.data);break;case 202:{this.f.delete(re);const fe=new Error(oe.data.message);fe.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,fe.name=oe.data.name,q(fe);break}case 203:this.f.delete(re),q(oe.data);break}};this.f.set(re,ce),this.p(z)};let H=null;this.b===l.Idle?ee():(H=(0,N.$Ng)(ce=>this.u()),H.then(()=>{H=null,ee()}));const Z=()=>{H?(H.cancel(),H=null):this.p({id:re,type:101}),q(new C.$4)},ie=_.onCancellationRequested(Z);P=(0,b.$Oc)((0,b.$Pc)(Z),ie),this.d.add(P)}).finally(()=>{P.dispose(),this.d.delete(P)})}o(B,te,se){const _=this.g++,K={id:_,type:102,channelName:B,name:te,arg:se};let z=null;const P=new S.$Rd({onWillAddFirstListener:()=>{z=(0,N.$Ng)(G=>this.u()),z.then(()=>{z=null,this.d.add(P),this.p(K)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(P),this.p({id:_,type:103}))}}),A=G=>P.fire(G.data);return this.f.set(_,A),P.event}p(B){switch(B.type){case 100:case 102:{const te=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(te,B.id,0,`${g(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const te=this.q([B.type,B.id]);this.j?.logOutgoing(te,B.id,0,g(B.type));return}}}q(B,te=void 0){const se=new s;return r(se,B),r(se,te),this.r(se.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const te=new E(B),se=a(te),_=a(te),re=se[0];switch(re){case 200:return this.j?.logIncoming(B.byteLength,0,0,w(re)),this.t({type:se[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,se[1],0,w(re),_),this.t({type:se[0],id:se[1],data:_})}}t(B){if(B.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Mc)(this.d.values()),this.d.clear()}}e.$Ch=f,ye([O.$rh],f.prototype,"onDidInitializePromise",null);class y{get connections(){const B=[];return this.f.forEach(te=>B.push(te)),B}constructor(B){this.a=new Map,this.f=new Set,this.g=new S.$Rd,this.onDidAddConnection=this.g.event,this.h=new S.$Rd,this.onDidRemoveConnection=this.h.event,this.j=new b.$Qc,this.j.add(B(({protocol:te,onDidClientDisconnect:se})=>{const _=S.Event.once(te.onMessage);this.j.add(_(re=>{const K=new E(re),z=a(K),P=new v(te,z),A=new f(te);this.a.forEach((q,ee)=>P.registerChannel(ee,q));const G={channelServer:P,channelClient:A,ctx:z};this.f.add(G),this.g.fire(G),this.j.add(se(()=>{P.dispose(),A.dispose(),this.f.delete(G),this.h.fire(G)}))}))}))}getChannel(B,te){const se=this;return{call(_,re,K){let z;if((0,$.$Qf)(te)){const A=(0,D.$3b)(se.connections.filter(te));z=A?Promise.resolve(A):S.Event.toPromise(S.Event.filter(se.onDidAddConnection,te))}else z=te.routeCall(se,_,re);const P=z.then(A=>A.channelClient.getChannel(B));return F(P).call(_,re,K)},listen(_,re){if((0,$.$Qf)(te))return se.k(B,te,_,re);const K=te.routeEvent(se,_,re).then(z=>z.channelClient.getChannel(B));return F(K).listen(_,re)}}}k(B,te,se,_){const re=this;let K;const z=new S.$Rd({onWillAddFirstListener:()=>{K=new b.$Qc;const P=new S.$Xd,A=new Map,G=ee=>{const Z=ee.channelClient.getChannel(B).listen(se,_),ie=P.add(Z);A.set(ee,ie)},q=ee=>{const H=A.get(ee);H&&(H.dispose(),A.delete(ee))};re.connections.filter(te).forEach(G),S.Event.filter(re.onDidAddConnection,te)(G,void 0,K),re.onDidRemoveConnection(q,void 0,K),P.event(z.fire,z,K),K.add(P)},onDidRemoveLastListener:()=>{K?.dispose(),K=void 0}});return z.event}registerChannel(B,te){this.a.set(B,te);for(const se of this.f)se.channelServer.registerChannel(B,te)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Dh=y;class I{constructor(B,te,se=null){const _=new s;r(_,te),B.send(_.buffer),this.a=new f(B,se),this.d=new v(B,te,se)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,te){this.d.registerChannel(B,te)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Eh=I;function F(V){return{call(B,te,se){return V.then(_=>_.call(B,te,se))},listen(B,te){const se=new S.$1d;return V.then(_=>se.input=_.listen(B,te)),se.event}}}e.$Fh=F;function T(V){let B=!1;return{call(te,se,_){return B?V.call(te,se,_):(0,N.$1g)(0).then(()=>B=!0).then(()=>V.call(te,se,_))},listen(te,se){if(B)return V.listen(te,se);const _=new S.$1d;return(0,N.$1g)(0).then(()=>B=!0).then(()=>_.input=V.listen(te,se)),_.event}}}e.$Gh=T;class M{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const te of B.connections)if(await Promise.resolve(this.a(te.ctx)))return Promise.resolve(te);return await S.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$Hh=M;var U;(function(V){function B(re,K,z){const P=re,A=z&&z.disableMarshalling,G=new Map;for(const q in P)se(q)&&G.set(q,S.Event.buffer(P[q],!0,void 0,K));return new class{listen(q,ee,H){const Z=G.get(ee);if(Z)return Z;if(_(ee)){const ie=P[ee];if(typeof ie=="function")return ie.call(P,H)}throw new C.$ab(`Event not found: ${ee}`)}call(q,ee,H){const Z=P[ee];if(typeof Z=="function"){if(!A&&Array.isArray(H))for(let ce=0;ce<H.length;ce++)H[ce]=(0,R.$wh)(H[ce]);let ie=Z.apply(P,H);return ie instanceof Promise||(ie=Promise.resolve(ie)),ie}throw new C.$ab(`Method not found: ${ee}`)}}}V.fromService=B;function te(re,K){const z=K&&K.disableMarshalling;return new Proxy({},{get(P,A){if(typeof A=="string")return K?.properties?.has(A)?K.properties.get(A):_(A)?function(G){return re.listen(A,G)}:se(A)?re.listen(A):async function(...G){let q;K&&!(0,$.$Lf)(K.context)?q=[K.context,...G]:q=G;const ee=await re.call(A,q);return z?ee:(0,R.$wh)(ee)};throw new C.$ab(`Property not found: ${String(A)}`)}})}V.toService=te;function se(re){return re[0]==="o"&&re[1]==="n"&&k.$5e(re.charCodeAt(2))}function _(re){return/^onDynamic/.test(re)&&k.$5e(re.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const B=V.toString();if(B!=="[object Object]")return B}return V}function x(V){return Array.isArray(V)?V.map(J):J(V)}function W(V,B,te,se,_,re,K){K=x(K);const z=Y[_],P=z[se%z.length];let A=[`%c[${V}]%c[${String(B).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(re)?(A=A.concat(K),A.push(")")):A.push(K),console.log.apply(console,A)}class X{constructor(B,te){this.d=B,this.f=te,this.a=0,this.b=0}logOutgoing(B,te,se,_,re){this.b+=B,W(this.d,this.b,B,te,se,_,re)}logIncoming(B,te,se,_,re){this.a+=B,W(this.f,this.a,B,te,se,_,re)}}e.$Ih=X}),define(le[67],he([0,1,15,3,2,40]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.ProtocolConstants=e.$Jh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var C;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function a(m,f){if(!t.has(m)){const y=String(++r);t.set(m,y)}return t.get(m)}function v(m,f,y,I){if(!i.enableDiagnostics)return;const F=a(m,f);if(I instanceof D.$fe||I instanceof Uint8Array||I instanceof ArrayBuffer||ArrayBuffer.isView(I)){const T=D.$fe.alloc(I.byteLength);T.set(I),i.records.push({timestamp:Date.now(),id:F,label:f,type:y,buff:T})}else i.records.push({timestamp:Date.now(),id:F,label:f,type:y,data:I})}i.traceSocketEvent=v})(C||(e.SocketDiagnostics=C={}));var S;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let b=null;function R(){return b||(b=D.$fe.alloc(0)),b}class k{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return R();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const f=this.a[0];return r&&(this.a.shift(),this.b-=t),f}if(this.a[0].byteLength>t){const f=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),f}const a=D.$fe.alloc(t);let v=0,m=0;for(;t>0;){const f=this.a[m];if(f.byteLength>t){const y=f.slice(0,t);a.set(y,v),v+=t,r&&(this.a[m]=f.slice(t),this.b-=t),t-=t}else a.set(f,v),v+=f.byteLength,r?(this.a.shift(),this.b-=f.byteLength):m++,t-=f.byteLength}return a}}e.$Jh=k;var $;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})($||($={}));function c(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class p{constructor(t,r,a,v){this.type=t,this.id=r,this.ack=a,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends L.$Rc{constructor(t){super(),this.f=this.B(new N.$Rd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new k,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:c(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,v=this.g.id,m=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new p(a,v,m,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=D.$fe.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:c(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=D.$fe.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class u extends L.$Rc{constructor(t){super(),this.f=new N.$Rd,this.onMessage=this.f.event,this.g=new N.$Rd,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new l(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new p(1,0,0,t))}}e.$Kh=u;class h extends j.$Eh{static fromSocket(t,r){return new h(new u(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Lh=h;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$Rd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Mh=d;class E{constructor(t){this.data=t,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new E(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let v=0;v<o.a;v++)t-this.c[v]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Qc,this.o=t.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new p(5,0,0,R());this.p.write(t),this.p.flush()}sendPause(){const t=new p(7,0,0,R());this.p.write(t)}sendResume(){const t=new p(8,0,0,R());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new L.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new p(3,0,this.h,R());this.p.write(t);const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new p(6,0,0,R())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new p(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new p(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&a>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const m=Math.max(2e4-r,2e4-a,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},m)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new p(3,0,this.h,R());this.p.write(t)}D(){this.h=this.g;const t=new p(9,0,this.h,R());this.p.write(t)}}e.$Nh=n}),define(le[93],he([0,1,66,6,15,26,140,7,3,2,30,144,90,40]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;class g extends c.$Bh{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",u=>L.$fe.wrap(Buffer.from(u,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$_p=g;class p{constructor(l,u){this.i=l,this.j=u,this.c=new Set,this.g=new Map,this.h=new S.$Rd,this.onDidProcessExit=this.h.event;const h=u&&u.timeout?u.timeout:6e4;this.b=new N.$Wg(h),this.d=null,this.f=null}getChannel(l){const u=this;return{call(h,d,E){return u.k(l,h,d,E)},listen(h,d){return u.l(l,h,d)}}}k(l,u,h,d=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(C.$5());this.b.cancel();const E=this.n(l),s=(0,N.$Ng)(i=>E.call(u,h,i)),o=d.onCancellationRequested(()=>s.cancel()),n=(0,b.$Pc)(()=>s.cancel());return this.c.add(n),s.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(l,u,h){if(!this.b)return S.Event.None;this.b.cancel();let d;const E=new S.$Rd({onWillAddFirstListener:()=>{d=this.n(l).listen(u,h)(E.fire,E),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return E.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,R.$en)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,$.$Kl)(u.env),this.d=(0,D.fork)(this.i,l,u);const h=new S.$Rd;S.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,O.$8p)(t)){(0,O.log)(t,`IPC Library: ${this.j.serverName}`);return}h.fire(L.$fe.wrap(Buffer.from(t,"base64")))});const E=this.j.useQueue?(0,k.$Ml)(this.d):this.d,s=t=>this.d&&this.d.connected&&E.send(t.buffer.toString("base64")),o=h.event,n={send:s,onMessage:o};this.f=new c.$Ch(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",i),this.c.forEach(a=>(0,b.$Mc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(l){let u=this.g.get(l);return u||(u=this.m.getChannel(l),this.g.set(l,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$aq=p}),define(le[146],he([0,1,133,15,40,3,12,18]),function(ne,e,D,N,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hU=e.$gU=void 0;class S{constructor($){this.a=$,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",c=>N.$fe.wrap(c.data)),$.start()}send($){this.a.postMessage($.buffer)}disconnect(){this.a.close()}}class b extends L.$Dh{static b($){(0,O.$Mf)((0,D.$fU)(process),"Electron Utility Process");const c=new j.$Rd;return process.parentPort.on("message",g=>{if($?.handledClientConnection(g))return;const p=(0,C.$Nb)(g.ports);p&&c.fire(p)}),j.Event.map(c.event,g=>({protocol:new S(g),onDidClientDisconnect:j.Event.fromNodeEventEmitter(g,"close")}))}constructor($){super(b.b($))}}e.$gU=b;function R(k,$,c){const g=p=>{p.data===$&&(k.removeListener("message",g),c())};k.on("message",g)}e.$hU=R}),define(le[68],he([0,1,6,3,2,65,12]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.StorageState=e.$$o=e.StorageHint=void 0;var C;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(e.StorageHint=C={}));function S($){const c=$;return c?.changed instanceof Map||c?.deleted instanceof Set}e.$$o=S;var b;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(b||(e.StorageState=b={}));class R extends L.$Rc{static{this.a=100}constructor(c,g=Object.create(null)){super(),this.r=c,this.s=g,this.b=this.B(new N.$Ud),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=this.B(new D.$Xg(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(c=>this.u(c)))}u(c){this.b.pause();try{c.changed?.forEach((g,p)=>this.w(p,g)),c.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(c,g){if(this.c===b.Closed)return;let p=!1;(0,O.$Lf)(g)?p=this.f.delete(c):this.f.get(c)!==g&&(this.f.set(c,g),p=!0),p&&this.b.fire({key:c,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.s.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(c,g){const p=this.f.get(c);return(0,O.$Lf)(p)?g:p}getBoolean(c,g){const p=this.get(c);return(0,O.$Lf)(p)?g:p==="true"}getNumber(c,g){const p=this.get(c);return(0,O.$Lf)(p)?g:parseInt(p,10)}getObject(c,g){const p=this.get(c);return(0,O.$Lf)(p)?g:(0,j.$vh)(p)}async set(c,g,p=!1){if(this.c===b.Closed)return;if((0,O.$Lf)(g))return this.delete(c,p);const w=(0,O.$Ef)(g)||Array.isArray(g)?(0,j.$uh)(g):String(g);if(this.f.get(c)!==w)return this.f.set(c,w),this.j.set(c,w),this.h.delete(c),this.b.fire({key:c,external:p}),this.D()}async delete(c,g=!1){if(!(this.c===b.Closed||!this.f.delete(c)))return this.h.has(c)||this.h.add(c),this.j.delete(c),this.b.fire({key:c,external:g}),this.D()}async optimize(){if(this.c!==b.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=b.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const c={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(c).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(c){if(this.z)return this.D(c)}async D(c){return this.s.hint===C.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),c)}async whenFlushed(){if(this.z)return new Promise(c=>this.n.push(c))}isInMemory(){return this.s.hint===C.STORAGE_IN_MEMORY}}e.$_o=R;class k{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(c){c.insert?.forEach((g,p)=>this.a.set(p,g)),c.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$ap=k}),define(le[147],he([13,9]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(le[69],he([0,1,54,6,16,12,31,147]),function(ne,e,D,N,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.zip=e.$vp=e.$up=void 0,e.$up="end of central directory record signature not found";const S=new RegExp(e.$up);class b extends Error{constructor(E,s){let o=s.message;switch(E){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=E,this.cause=s}}e.$vp=b;function R(d){const E=d.externalFileAttributes>>16||33188;return[448,56,7].map(s=>E&s).reduce((s,o)=>s+o,E&61440)}function k(d){if(d instanceof b)return d;let E;return S.test(d.message)&&(E="CorruptZip"),new b(E,d)}function $(d,E,s,o,n,i){const t=L.$lc(E),r=L.$ic(o,t);if(!r.startsWith(o))return Promise.reject(new Error(C.localize(0,null,E)));const a=L.$ic(o,E);let v;return i.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(O.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((m,f)=>{if(!i.isCancellationRequested)try{v=(0,D.createWriteStream)(a,{mode:s}),v.once("close",()=>m()),v.once("error",f),d.once("error",f),d.pipe(v)}catch(y){f(y)}}))}function c(d,E,s,o){let n=(0,N.$Ng)(()=>Promise.resolve()),i=0;const t=o.onCancellationRequested(()=>{n.cancel(),d.close()});return new Promise((r,a)=>{const v=new N.$Ug,m=f=>{f.isCancellationRequested||(i++,d.readEntry())};d.once("error",a),d.once("close",()=>n.then(()=>{o.isCancellationRequested||d.entryCount===i?r():a(new b("Incomplete",new Error(C.localize(1,null,i,d.entryCount))))},a)),d.readEntry(),d.on("entry",f=>{if(o.isCancellationRequested)return;if(!s.sourcePathRegex.test(f.fileName)){m(o);return}const y=f.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(y)){const T=L.$ic(E,y);n=(0,N.$Ng)(M=>O.Promises.mkdir(T,{recursive:!0}).then(()=>m(M)).then(void 0,a));return}const I=p(d,f),F=R(f);n=(0,N.$Ng)(T=>v.queue(()=>I.then(M=>$(M,y,F,E,s,T).then(()=>m(T)))).then(null,a))})}).finally(()=>t.dispose())}async function g(d,E=!1){const{open:s}=await new Promise((o,n)=>{ne(["yauzl"],o,n)});return new Promise((o,n)=>{s(d,E?{lazyEntries:!0}:void 0,(i,t)=>{i?n(k(i)):o((0,j.$Nf)(t))})})}function p(d,E){return new Promise((s,o)=>{d.openReadStream(E,(n,i)=>{n?o(k(n)):s((0,j.$Nf)(i))})})}async function w(d,E){const{ZipFile:s}=await new Promise((o,n)=>{ne(["yazl"],o,n)});return new Promise((o,n)=>{const i=new s;E.forEach(r=>{r.contents?i.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&i.addFile(r.localPath,r.path)}),i.end();const t=(0,D.createWriteStream)(d);i.outputStream.pipe(t),i.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(d))})}e.zip=w;function l(d,E,s={},o){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let i=g(d,!0);return s.overwrite&&(i=i.then(t=>O.Promises.rm(E).then(()=>t))),i.then(t=>c(t,E,{sourcePathRegex:n},o))}e.$xp=l;function u(d,E){return g(d).then(s=>new Promise((o,n)=>{s.on("entry",i=>{i.fileName===E&&p(s,i).then(t=>o(t),t=>n(t))}),s.once("close",()=>n(new Error(C.localize(2,null,E))))}))}function h(d,E){return u(d,E).then(s=>new Promise((o,n)=>{const i=[];s.once("error",n),s.on("data",t=>i.push(t)),s.on("end",()=>o(Buffer.concat(i)))}))}e.$yp=h}),define(le[148],he([13,9]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[149],he([13,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(le[150],he([13,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(le[151],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[152],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[153],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[154],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[155],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[156],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[157],he([13,9]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[158],he([13,9]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(le[159],he([13,9]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(le[160],he([13,9]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(le[161],he([13,9]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[162],he([13,9]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[163],he([13,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[164],he([13,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[165],he([13,9]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(le[166],he([13,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[167],he([13,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[168],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[169],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[170],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[171],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[172],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[173],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[174],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[175],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[176],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[177],he([13,9]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(le[178],he([0,1,7,150]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.TokenType=void 0;var L;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(L||(e.TokenType=L={}));function j(...b){switch(b.length){case 1:return(0,N.localize)(0,null,b[0]);case 2:return(0,N.localize)(1,null,b[0],b[1]);case 3:return(0,N.localize)(2,null,b[0],b[1],b[2]);default:return}}const O=(0,N.localize)(3,null),C=(0,N.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,D.$7)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const k=this.d,$=this.c.substring(this.d,this.e),c={type:19,offset:this.d,lexeme:$};this.g.push({offset:k,lexeme:$,additionalInfo:R}),this.f.push(c)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const k=this.c.substring(this.d,this.e),$=S.b.get(k);$?this.k($):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,k=!1,$=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(C);return}const g=this.c.charCodeAt(R);if(k)k=!1;else if(g===47&&!$){R++;break}else g===91?$=!0:g===92?k=!0:g===93&&($=!1);R++}for(;R<this.c.length&&S.a.has(this.c.charCodeAt(R));)R++;this.e=R;const c=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ui=S}),define(le[179],he([0,1,64,84,23,16,37,19,10]),function(ne,e,D,N,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=void 0,e.$pm=/^([^.]+\..+):(.+)$/;class b{get appRoot(){return(0,j.$lc)(L.$ig.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,j.$ic)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,C.$Bg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,C.$Bg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,D.$om)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$ic)(this.userDataPath,"logs",c)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.$Bg)(S.URI.file((0,j.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.$Bg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.$Bg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.$Bg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=O.env.VSCODE_PORTABLE;return c?S.URI.file((0,j.$ic)(c,"argv.json")):(0,C.$Bg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,j.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,j.$jc)(c):(0,j.$gc)((0,j.$ic)(L.$ig.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?S.URI.file((0,j.$jc)(c)):S.URI.file((0,j.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,j.$jc)(c);const g=O.env.VSCODE_EXTENSIONS;if(g)return g;const p=O.env.VSCODE_PORTABLE;return p?(0,j.$ic)(p,"extensions"):(0,C.$Bg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(g=>/^[^:/?#]+?:\/\//.test(g)?S.URI.parse(g):S.URI.file((0,j.$gc)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?S.URI.parse(c):S.URI.file((0,j.$gc)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.$pm.test(c))}get extensionLogLevel(){const c=[];for(const g of this.args.log||[]){const p=e.$pm.exec(g);p&&p[1]&&p[2]&&c.push([p[1],p[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,C.$Bg)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=O.env.VSCODE_PORTABLE;return c?S.URI.file((0,j.$ic)(c,"policy.json")):(0,C.$Bg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this.a}constructor(c,g,p){this.a=c,this.b=g,this.c=p,this.editSessionId=this.args.editSessionId}}e.$qm=b,ye([N.$rh],b.prototype,"appRoot",null),ye([N.$rh],b.prototype,"userHome",null),ye([N.$rh],b.prototype,"userDataPath",null),ye([N.$rh],b.prototype,"appSettingsHome",null),ye([N.$rh],b.prototype,"tmpDir",null),ye([N.$rh],b.prototype,"cacheHome",null),ye([N.$rh],b.prototype,"stateResource",null),ye([N.$rh],b.prototype,"userRoamingDataHome",null),ye([N.$rh],b.prototype,"userDataSyncHome",null),ye([N.$rh],b.prototype,"sync",null),ye([N.$rh],b.prototype,"machineSettingsResource",null),ye([N.$rh],b.prototype,"workspaceStorageHome",null),ye([N.$rh],b.prototype,"localHistoryHome",null),ye([N.$rh],b.prototype,"keyboardLayoutResource",null),ye([N.$rh],b.prototype,"argvResource",null),ye([N.$rh],b.prototype,"isExtensionDevelopment",null),ye([N.$rh],b.prototype,"untitledWorkspacesHome",null),ye([N.$rh],b.prototype,"builtinExtensionsPath",null),ye([N.$rh],b.prototype,"extensionsPath",null),ye([N.$rh],b.prototype,"extensionDevelopmentLocationURI",null),ye([N.$rh],b.prototype,"extensionDevelopmentKind",null),ye([N.$rh],b.prototype,"extensionTestsLocationURI",null),ye([N.$rh],b.prototype,"debugExtensionHost",null),ye([N.$rh],b.prototype,"logLevel",null),ye([N.$rh],b.prototype,"extensionLogLevel",null),ye([N.$rh],b.prototype,"serviceMachineIdResource",null),ye([N.$rh],b.prototype,"disableTelemetry",null),ye([N.$rh],b.prototype,"disableWorkspaceTrust",null),ye([N.$rh],b.prototype,"useInMemorySecretStorage",null),ye([N.$rh],b.prototype,"policyFile",null);function R($,c){return k($["inspect-extensions"],$["inspect-brk-extensions"],5870,c,$.debugId,$.extensionEnvironment)}e.$rm=R;function k($,c,g,p,w,l){const h=Number(c||$)||(p?null:g),d=h?!!c:!1;let E;if(l)try{E=JSON.parse(l)}catch{}return{port:h,break:d,debugId:w,env:E}}e.$sm=k}),function(){"use strict";function ne(e,D,N){function L(O,C){const S=j(O,C),b=[S];return e.isAbsolute(S)||b.unshift(N),e.resolve(...b)}function j(O,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,C);const R=O["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(k,"AppData","Roaming")}break;case"darwin":b=e.join(D.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,C)}return{getUserDataPath:L}}if(typeof define=="function")define(le[180],he([269,36,37]),function(e,D,N){return ne(e,D,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=ne(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[181],he([0,1,36,179,180]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=e.$tm=void 0;class j extends N.$qm{constructor(b,R){super(b,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,L.getUserDataPath)(b,R.nameShort)},R)}}e.$tm=j;function O(S,b){return(0,N.$sm)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,b,S.extensionEnvironment)}e.$um=O;function C(S,b){return(0,N.$sm)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,b,S.extensionEnvironment)}e.$vm=C}),define(le[182],he([0,1,12,153]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;function L(O,C,S,b){try{j(O,C,S,b)}catch(R){O.error(R?.message??R)}return C}e.$Hp=L;function j(O,C,S,b){const R=(k,$,c)=>{const g=k[$];if((0,D.$Cf)(g)){const p=g,w=p.length;if(w>1&&p[0]==="%"&&p[w-1]==="%"){const l=p.substr(1,w-2);let u=S[l];u===void 0&&b&&(u=b[l]);const h=typeof u=="string"?u:u?.message,d=b?.[l],E=typeof d=="string"?d:d?.message;if(!h){E||O.warn(`[${C.name}]: ${(0,N.localize)(0,null,l)}`);return}if(c&&($==="title"||$==="category")&&E&&E!==h){const s={value:h,original:E};k[$]=s}else k[$]=h}}else if((0,D.$Ef)(g))for(const p in g)g.hasOwnProperty(p)&&(p==="commands"?R(g,p,!0):R(g,p,c));else if(Array.isArray(g))for(let p=0;p<g.length;p++)R(g,p,c)};for(const k in C)C.hasOwnProperty(k)&&R(C,k)}}),define(le[183],he([0,1,69,156]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;function L(j){return(0,D.$yp)(j,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$Pp=L}),define(le[184],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s$b=e.$r$b=void 0;class D{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$r$b=D;class N{constructor(j){this.a=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,C){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(C[0])}throw new Error(`Call not found: ${O}`)}}e.$s$b=N}),define(le[70],he([0,1,19,89,157,55]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||O.test(l)}e.$Vo=S;function b(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(O);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$Wo=b;function R(l){if(!l)return null;const u=l.majorBase,h=l.majorMustEqual,d=l.minorBase;let E=l.minorMustEqual;const s=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(u===0||(E=!1),o=!1);let n=0;if(l.preRelease){const i=C.exec(l.preRelease);if(i){const[,t,r,a]=i;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:u,majorMustEqual:h,minorBase:d,minorMustEqual:E,patchBase:s,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:n}}e.$Xo=R;function k(l,u,h){let d;typeof l=="string"?d=R(b(l)):d=l;let E;u instanceof Date?E=u.getTime():typeof u=="string"&&(E=new Date(u).getTime());let s;if(typeof h=="string"?s=R(b(h)):s=h,!d||!s)return!1;const o=d.majorBase,n=d.minorBase,i=d.patchBase;let t=s.majorBase,r=s.minorBase,a=s.patchBase;const v=s.notBefore;let m=s.majorMustEqual,f=s.minorMustEqual,y=s.patchMustEqual;return s.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||E&&E<v?!1:i>=a:(o===1&&t===0&&(!m||!f||!y)&&(t=1,r=0,a=0,m=!0,f=!1,y=!1),o<t?!1:o>t?!m:n<r?!1:n>r?!f:i<a?!1:i>a?!y:!(E&&E<v))}e.$Yo=k;function $(l,u,h,d,E){const s=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return s.push([N.default.Error,L.localize(0,null)]),s;if(typeof d.name!="string")return s.push([N.default.Error,L.localize(1,null,"name")]),s;if(typeof d.version!="string")return s.push([N.default.Error,L.localize(2,null,"version")]),s;if(!d.engines)return s.push([N.default.Error,L.localize(3,null,"engines")]),s;if(typeof d.engines.vscode!="string")return s.push([N.default.Error,L.localize(4,null,"engines.vscode")]),s;if(typeof d.extensionDependencies<"u"&&!w(d.extensionDependencies))return s.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),s;if(typeof d.activationEvents<"u"){if(!w(d.activationEvents))return s.push([N.default.Error,L.localize(6,null,"activationEvents")]),s;if(typeof d.main>"u"&&typeof d.browser>"u")return s.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),s}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&s.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return s.push([N.default.Error,L.localize(9,null,"main")]),s;{const i=(0,D.$Bg)(h,d.main);(0,D.$vg)(i,h)||s.push([N.default.Warning,L.localize(10,null,i.path,h.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return s.push([N.default.Error,L.localize(11,null,"browser")]),s;{const i=(0,D.$Bg)(h,d.browser);(0,D.$vg)(i,h)||s.push([N.default.Warning,L.localize(12,null,i.path,h.path)])}}if(!j.valid(d.version))return s.push([N.default.Error,L.localize(13,null)]),s;const o=[];if(!c(l,u,d,E,o))for(const i of o)s.push([N.default.Error,i]);return s}e.$Zo=$;function c(l,u,h,d,E){return d||typeof h.main>"u"&&typeof h.browser>"u"?!0:p(l,u,h.engines.vscode,E)}e.$1o=c;function g(l,u,h){return l==="*"||p(u,h,l)}e.$2o=g;function p(l,u,h,d=[]){const E=R(b(h));if(!E)return d.push(L.localize(14,null,h)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return d.push(L.localize(15,null,h)),!1}else if(!E.majorMustEqual)return d.push(L.localize(16,null,h)),!1;return k(l,u,E)?!0:(d.push(L.localize(17,null,l,h)),!1)}function w(l){if(!Array.isArray(l))return!1;for(let u=0,h=l.length;u<h;u++)if(typeof l[u]!="string")return!1;return!0}}),define(le[43],he([0,1,15,32]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=void 0;async function L(j,O,C){let S=C&&C.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const R=(await O.readFile(j.serviceMachineIdResource)).value.toString();S=(0,N.$jg)(R)?R:null}catch{S=null}if(!S){S=(0,N.$kg)();try{await O.writeFile(j.serviceMachineIdResource,D.$fe.fromString(S))}catch{}}return C?.store("storage.serviceMachineId",S,-1,1),S}e.$jp=L}),define(le[71],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=void 0;class D{constructor(L,j=[],O=!1){this.ctor=L,this.staticArguments=j,this.supportsDelayedInstantiation=O}}e.$Wh=D}),define(le[185],he([0,1,71]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=e.InstantiationType=void 0;const N=[];var L;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function j(C,S,b){S instanceof D.$Wh||(S=new D.$Wh(S,[],!!b)),N.push([C,S])}e.$Gr=j;function O(){return N}e.$Hr=O}),define(le[186],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=void 0;class D{constructor(j,O){this.key=j,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$lq=D;class N{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const O of this.a.values())O.outgoing.size===0&&j.push(O);return j}insertEdge(j,O){const C=this.lookupOrInsertNode(j),S=this.lookupOrInsertNode(O);C.outgoing.set(S.key,S),S.incoming.set(C.key,C)}removeNode(j){const O=this.b(j);this.a.delete(O);for(const C of this.a.values())C.outgoing.delete(O),C.incoming.delete(O)}lookupOrInsertNode(j){const O=this.b(j);let C=this.a.get(O);return C||(C=new D(O,j),this.a.set(O,C)),C}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[O,C]of this.a)j.push(`${O}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,O]of this.a){const C=new Set([j]),S=this.c(O,C);if(S)return S}}c(j,O){for(const[C,S]of j.outgoing){if(O.has(C))return[...O,C].join(" -> ");O.add(C);const b=this.c(S,O);if(b)return b;O.delete(C)}}}e.$mq=N}),define(le[4],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.$Zh=e.$Yh=e._util=void 0;var D;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function C(S){return S[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=C})(D||(e._util=D={})),e.$Yh=L("instantiationService");function N(O,C,S){C[D.DI_TARGET]===C?C[D.DI_DEPENDENCIES].push({id:O,index:S}):(C[D.DI_DEPENDENCIES]=[{id:O,index:S}],C[D.DI_TARGET]=C)}function L(O){if(D.serviceIds.has(O))return D.serviceIds.get(O);const C=function(S,b,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(C,S,R)};return C.toString=()=>O,D.serviceIds.set(O,C),C}e.$Zh=L;function j(O){return O}e.$1h=j}),define(le[187],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$10b=void 0,e.$10b=(0,D.$Zh)("checksumService")}),define(le[20],he([0,1,12,10,4]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.ConfigurationTarget=e.$vi=e.$ui=e.$ti=void 0,e.$ti=(0,L.$Zh)("configurationService");function j(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof N.URI)}e.$ui=j;function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof N.URI)}e.$vi=O;var C;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(C||(e.ConfigurationTarget=C={}));function S(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$wi=S;function b(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.$xi=b;function R(l,u){const h=Object.create(null);for(const d in l)k(h,d,l[d],u);return h}e.$yi=R;function k(l,u,h,d){const E=u.split("."),s=E.pop();let o=l;for(let n=0;n<E.length;n++){const i=E[n];let t=o[i];switch(typeof t){case"undefined":t=o[i]=Object.create(null);break;case"object":break;default:d(`Ignoring ${u} as ${E.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[s]=h}catch{d(`Ignoring ${u} as ${E.join(".")} is ${JSON.stringify(o)}`)}else d(`Ignoring ${u} as ${E.join(".")} is ${JSON.stringify(o)}`)}e.$zi=k;function $(l,u){const h=u.split(".");c(l,h)}e.$Ai=$;function c(l,u){const h=u.shift();if(u.length===0){delete l[h];return}if(Object.keys(l).indexOf(h)!==-1){const d=l[h];typeof d=="object"&&!Array.isArray(d)&&(c(d,u),Object.keys(d).length===0&&delete l[h])}}function g(l,u,h){function d(o,n){let i=o;for(const t of n){if(typeof i!="object"||i===null)return;i=i[t]}return i}const E=u.split("."),s=d(l,E);return typeof s>"u"?h:s}e.$Bi=g;function p(l,u,h){Object.keys(u).forEach(d=>{d!=="__proto__"&&(d in l?D.$Ef(l[d])&&D.$Ef(u[d])?p(l[d],u[d],h):h&&(l[d]=u[d]):l[d]=u[d])})}e.$Ci=p;function w(l){return l.replace(/[\[\]]/g,"")}e.$Di=w}),define(le[94],he([0,1,5,27,178,4,149,7]),function(ne,e,D,N,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.ContextKeyExprType=e.$Vi=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",D.$j),S.set("isLinux",D.$k),S.set("isWindows",D.$i),S.set("isWeb",D.$o),S.set("isMacNative",D.$j&&!D.$o),S.set("isEdge",D.$H),S.set("isFirefox",D.$F),S.set("isChrome",D.$E),S.set("isSafari",D.$G);function b(z,P){if(S.get(z)!==void 0)throw(0,C.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(z,P)}e.$Vi=b;const R=Object.prototype.hasOwnProperty;var k;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const $={regexParsingWithErrorRecovery:!0},c=(0,O.localize)(0,null),g=(0,O.localize)(1,null),p=(0,O.localize)(2,null),w=(0,O.localize)(3,null),l=(0,O.localize)(4,null),u=(0,O.localize)(5,null),h=(0,O.localize)(6,null),d=(0,O.localize)(7,null);class E{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=$){this.k=P,this.d=new L.$Ui,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const A=this.l();if(!this.E()){const G=this.D(),q=G.type===17?u:void 0;throw this.h.push({message:l,offset:G.offset,lexeme:L.$Ui.getLexeme(G),additionalInfo:q}),E.c}return A}catch(A){if(A!==E.c)throw A;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const A=this.o();P.push(A)}return P.length===1?P[0]:s.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const A=this.s();P.push(A)}return P.length===1?P[0]:s.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const A=this.l();return this.A(1,w),A?.negate()}case 17:return this.z(),I.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const A=this.l();return this.A(1,w),A}case 17:{const A=P.lexeme;if(this.z(),this.y(9)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==10)throw this.B("REGEX",q);const ee=q.lexeme,H=ee.lastIndexOf("/"),Z=H===ee.length-1?void 0:this.w(ee.substring(H+1));let ie;try{ie=new RegExp(ee.substring(1,H),Z)}catch{throw this.B("REGEX",q)}return J.create(A,ie)}switch(q.type){case 10:case 19:{const ee=[q.lexeme];this.z();let H=this.D(),Z=0;for(let de=0;de<q.lexeme.length;de++)q.lexeme.charCodeAt(de)===40?Z++:q.lexeme.charCodeAt(de)===41&&Z--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:Z++;break;case 1:Z--;break;case 10:case 18:for(let de=0;de<H.lexeme.length;de++)H.lexeme.charCodeAt(de)===40?Z++:q.lexeme.charCodeAt(de)===41&&Z--}if(Z<0)break;ee.push(L.$Ui.getLexeme(H)),this.z(),H=this.D()}const ie=ee.join(""),ce=ie.lastIndexOf("/"),oe=ce===ie.length-1?void 0:this.w(ie.substring(ce+1));let fe;try{fe=new RegExp(ie.substring(1,ce),oe)}catch{throw this.B("REGEX",q)}return s.regex(A,fe)}case 18:{const ee=q.lexeme;this.z();let H=null;if(!(0,N.$Fe)(ee)){const Z=ee.indexOf("/"),ie=ee.lastIndexOf("/");if(Z!==ie&&Z>=0){const ce=ee.slice(Z+1,ie),oe=ee[ie+1]==="i"?"i":"";try{H=new RegExp(ce,oe)}catch{throw this.B("REGEX",q)}}}if(H===null)throw this.B("REGEX",q);return J.create(A,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const q=this.u();return s.notIn(A,q)}switch(this.D().type){case 3:{this.z();const q=this.u();if(this.x().type===18)return s.equals(A,q);switch(q){case"true":return s.has(A);case"false":return s.not(A);default:return s.equals(A,q)}}case 4:{this.z();const q=this.u();if(this.x().type===18)return s.notEquals(A,q);switch(q){case"true":return s.not(A);case"false":return s.has(A);default:return s.notEquals(A,q)}}case 5:return this.z(),U.create(A,this.u());case 6:return this.z(),Y.create(A,this.u());case 7:return this.z(),T.create(A,this.u());case 8:return this.z(),M.create(A,this.u());case 13:return this.z(),s.in(A,this.u());default:return s.has(A)}}case 20:throw this.h.push({message:h,offset:P.offset,lexeme:"",additionalInfo:d}),E.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,A){if(this.C(P))return this.z();throw this.B(A,this.D())}B(P,A,G){const q=(0,O.localize)(8,null,P,L.$Ui.getLexeme(A)),ee=A.offset,H=L.$Ui.getLexeme(A);return this.h.push({message:q,offset:ee,lexeme:H,additionalInfo:G}),E.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Wi=E;class s{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(P){return a.create(P)}static equals(P,A){return v.create(P,A)}static notEquals(P,A){return y.create(P,A)}static regex(P,A){return J.create(P,A)}static in(P,A){return m.create(P,A)}static notIn(P,A){return f.create(P,A)}static not(P){return I.create(P)}static and(...P){return X.create(P,null,!0)}static or(...P){return V.create(P,null,!0)}static greater(P,A){return T.create(P,A)}static greaterEquals(P,A){return M.create(P,A)}static smaller(P,A){return U.create(P,A)}static smallerEquals(P,A){return Y.create(P,A)}static{this.c=new E({regexParsingWithErrorRecovery:!1})}static deserialize(P){return P==null?void 0:this.c.parse(P)}}e.$Xi=s;function o(z){const P=new E({regexParsingWithErrorRecovery:!1});return z.map(A=>(P.parse(A),P.lexingErrors.length>0?P.lexingErrors.map(G=>({errorMessage:G.additionalInfo?(0,O.localize)(9,null,G.additionalInfo):(0,O.localize)(10,null),offset:G.offset,length:G.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(G=>({errorMessage:G.additionalInfo?`${G.message}. ${G.additionalInfo}`:G.message,offset:G.offset,length:G.lexeme.length})):[]))}e.$Yi=o;function n(z,P){const A=z?z.substituteConstants():void 0,G=P?P.substituteConstants():void 0;return!A&&!G?!0:!A||!G?!1:A.equals(G)}e.$Zi=n;function i(z,P){return z.cmp(P)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return r.INSTANCE}}e.$1i=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return t.INSTANCE}}e.$2i=r;class a{static create(P,A=null){const G=S.get(P);return typeof G=="boolean"?G?r.INSTANCE:t.INSTANCE:new a(P,A)}constructor(P,A){this.key=P,this.c=A,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:te(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=S.get(this.key);return typeof P=="boolean"?P?r.INSTANCE:t.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$3i=a;class v{static create(P,A,G=null){if(typeof A=="boolean")return A?a.create(P,G):I.create(P,G);const q=S.get(P);return typeof q=="boolean"?A===(q?"true":"false")?r.INSTANCE:t.INSTANCE:new v(P,A,G)}constructor(P,A,G){this.c=P,this.d=A,this.f=G,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=S.get(this.c);if(typeof P=="boolean"){const A=P?"true":"false";return this.d===A?r.INSTANCE:t.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$4i=v;class m{static create(P,A){return new m(P,A)}constructor(P,A){this.d=P,this.f=A,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:se(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const A=P.getValue(this.f),G=P.getValue(this.d);return Array.isArray(A)?A.includes(G):typeof G=="string"&&typeof A=="object"&&A!==null?R.call(A,G):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$5i=m;class f{static create(P,A){return new f(P,A)}constructor(P,A){this.d=P,this.f=A,this.type=11,this.c=m.create(P,A)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$6i=f;class y{static create(P,A,G=null){if(typeof A=="boolean")return A?I.create(P,G):a.create(P,G);const q=S.get(P);return typeof q=="boolean"?A===(q?"true":"false")?t.INSTANCE:r.INSTANCE:new y(P,A,G)}constructor(P,A,G){this.c=P,this.d=A,this.f=G,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=S.get(this.c);if(typeof P=="boolean"){const A=P?"true":"false";return this.d===A?t.INSTANCE:r.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$7i=y;class I{static create(P,A=null){const G=S.get(P);return typeof G=="boolean"?G?t.INSTANCE:r.INSTANCE:new I(P,A)}constructor(P,A){this.c=P,this.d=A,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:te(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=S.get(this.c);return typeof P=="boolean"?P?t.INSTANCE:r.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$8i=I;function F(z,P){if(typeof z=="string"){const A=parseFloat(z);isNaN(A)||(z=A)}return typeof z=="string"||typeof z=="number"?P(z):t.INSTANCE}class T{static create(P,A,G=null){return F(A,q=>new T(P,q,G))}constructor(P,A,G){this.c=P,this.d=A,this.f=G,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$9i=T;class M{static create(P,A,G=null){return F(A,q=>new M(P,q,G))}constructor(P,A,G){this.c=P,this.d=A,this.f=G,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$0i=M;class U{static create(P,A,G=null){return F(A,q=>new U(P,q,G))}constructor(P,A,G){this.c=P,this.d=A,this.f=G,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$$i=U;class Y{static create(P,A,G=null){return F(A,q=>new Y(P,q,G))}constructor(P,A,G){this.c=P,this.d=A,this.f=G,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$_i=Y;class J{static create(P,A){return new J(P,A)}constructor(P,A){this.d=P,this.f=A,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const A=this.f?this.f.source:"",G=P.f?P.f.source:"";return A<G?-1:A>G?1:0}equals(P){if(P.type===this.type){const A=this.f?this.f.source:"",G=P.f?P.f.source:"";return this.d===P.d&&A===G}return!1}substituteConstants(){return this}evaluate(P){const A=P.getValue(this.d);return this.f?this.f.test(A):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$aj=J;class x{static create(P){return new x(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(P){return new x(this.c.map(P))}negate(){return this.c}}e.$bj=x;function W(z){let P=null;for(let A=0,G=z.length;A<G;A++){const q=z[A].substituteConstants();if(z[A]!==q&&P===null){P=[];for(let ee=0;ee<A;ee++)P[ee]=z[ee]}P!==null&&(P[A]=q)}return P===null?z:P}class X{static create(P,A,G){return X.d(P,A,G)}constructor(P,A){this.expr=P,this.c=A,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let A=0,G=this.expr.length;A<G;A++){const q=i(this.expr[A],P.expr[A]);if(q!==0)return q}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let A=0,G=this.expr.length;A<G;A++)if(!this.expr[A].equals(P.expr[A]))return!1;return!0}return!1}substituteConstants(){const P=W(this.expr);return P===this.expr?this:X.create(P,this.c,!1)}evaluate(P){for(let A=0,G=this.expr.length;A<G;A++)if(!this.expr[A].evaluate(P))return!1;return!0}static d(P,A,G){const q=[];let ee=!1;for(const H of P)if(H){if(H.type===1){ee=!0;continue}if(H.type===0)return t.INSTANCE;if(H.type===6){q.push(...H.expr);continue}q.push(H)}if(q.length===0&&ee)return r.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(i);for(let H=1;H<q.length;H++)q[H-1].equals(q[H])&&(q.splice(H,1),H--);if(q.length===1)return q[0];for(;q.length>1;){const H=q[q.length-1];if(H.type!==9)break;q.pop();const Z=q.pop(),ie=q.length===0,ce=V.create(H.expr.map(oe=>X.create([oe,Z],null,G)),null,ie);ce&&(q.push(ce),q.sort(i))}if(q.length===1)return q[0];if(G){for(let H=0;H<q.length;H++)for(let Z=H+1;Z<q.length;Z++)if(q[H].negate().equals(q[Z]))return t.INSTANCE;if(q.length===1)return q[0]}return new X(q,A)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const A of this.expr)P.push(...A.keys());return P}map(P){return new X(this.expr.map(A=>A.map(P)),null)}negate(){if(!this.c){const P=[];for(const A of this.expr)P.push(A.negate());this.c=V.create(P,this,!0)}return this.c}}e.$cj=X;class V{static create(P,A,G){return V.d(P,A,G)}constructor(P,A){this.expr=P,this.c=A,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let A=0,G=this.expr.length;A<G;A++){const q=i(this.expr[A],P.expr[A]);if(q!==0)return q}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let A=0,G=this.expr.length;A<G;A++)if(!this.expr[A].equals(P.expr[A]))return!1;return!0}return!1}substituteConstants(){const P=W(this.expr);return P===this.expr?this:V.create(P,this.c,!1)}evaluate(P){for(let A=0,G=this.expr.length;A<G;A++)if(this.expr[A].evaluate(P))return!0;return!1}static d(P,A,G){let q=[],ee=!1;if(P){for(let H=0,Z=P.length;H<Z;H++){const ie=P[H];if(ie){if(ie.type===0){ee=!0;continue}if(ie.type===1)return r.INSTANCE;if(ie.type===9){q=q.concat(ie.expr);continue}q.push(ie)}}if(q.length===0&&ee)return t.INSTANCE;q.sort(i)}if(q.length!==0){if(q.length===1)return q[0];for(let H=1;H<q.length;H++)q[H-1].equals(q[H])&&(q.splice(H,1),H--);if(q.length===1)return q[0];if(G){for(let H=0;H<q.length;H++)for(let Z=H+1;Z<q.length;Z++)if(q[H].negate().equals(q[Z]))return r.INSTANCE;if(q.length===1)return q[0]}return new V(q,A)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const A of this.expr)P.push(...A.keys());return P}map(P){return new V(this.expr.map(A=>A.map(P)),null)}negate(){if(!this.c){const P=[];for(const A of this.expr)P.push(A.negate());for(;P.length>1;){const A=P.shift(),G=P.shift(),q=[];for(const ee of K(A))for(const H of K(G))q.push(X.create([ee,H],null,!1));P.unshift(V.create(q,null,!1))}this.c=V.create(P,this,!0)}return this.c}}e.$dj=V;class B extends a{static{this.d=[]}static all(){return B.d.values()}constructor(P,A,G){super(P,null),this.f=A,typeof G=="object"?B.d.push({...G,key:P}):G!==!0&&B.d.push({key:P,description:G,type:A!=null?typeof A:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return v.create(this.key,P)}notEqualsTo(P){return y.create(this.key,P)}}e.$ej=B,e.$fj=(0,j.$Zh)("contextKeyService");function te(z,P){return z<P?-1:z>P?1:0}function se(z,P,A,G){return z<A?-1:z>A?1:P<G?-1:P>G?1:0}function _(z,P){if(z.type===0||P.type===1)return!0;if(z.type===9)return P.type===9?re(z.expr,P.expr):!1;if(P.type===9){for(const A of P.expr)if(_(z,A))return!0;return!1}if(z.type===6){if(P.type===6)return re(P.expr,z.expr);for(const A of z.expr)if(_(A,P))return!0;return!1}return z.equals(P)}e.$gj=_;function re(z,P){let A=0,G=0;for(;A<z.length&&G<P.length;){const q=z[A].cmp(P[G]);if(q<0)return!1;q===0&&A++,G++}return A===z.length}function K(z){return z.type===9?z.expr:[z]}}),define(le[95],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=e.ID=void 0,e.ID="diagnosticsService",e.$Am=(0,D.$Zh)(e.ID);function N(j){return!!j.hostName&&!!j.errorMessage}e.$Bm=N;class L{async getPerformanceInfo(O,C){return{}}async getSystemInfo(O,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,C){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$Cm=L}),define(le[96],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0,e.$Yn=(0,D.$Zh)("downloadService")}),define(le[14],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=void 0,e.$7h=(0,D.$Zh)("environmentService"),e.$8h=(0,D.$1h)(e.$7h)}),define(le[29],he([0,1,152,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ho=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=void 0,e.$8n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9n=new RegExp(e.$8n),e.$0n="__web_extension",e.$$n="skipWalkthrough",e.$_n="extensionsSync",e.$ao="dependecyOrPackExtensionInstall";function L(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$bo=L;function j(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$co=j;function O(l,u){switch(l){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$do=O;function C(l,u){return u==="web"&&!l.includes("web")}e.$eo=C;function S(l,u,h){return C(u,h)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===h}e.$fo=S;function b(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.$go=b;var R;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var k;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var $;(function(l){l.Install="install",l.Uninstall="uninstall"})($||(e.StatisticType=$={}));var c;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(c||(e.InstallOperation=c={})),e.$ho=(0,N.$Zh)("extensionGalleryService");var g;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));var p;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class w extends Error{constructor(u,h){super(u),this.code=h,this.name=h}}e.$io=w,e.$jo=(0,N.$Zh)("extensionManagementService"),e.$ko="extensionsIdentifiers/disabled",e.$lo="extensionsIdentifiers/enabled",e.$mo=(0,N.$Zh)("IGlobalExtensionEnablementService"),e.$no=(0,N.$Zh)("IExtensionTipsService"),e.$oo=(0,D.localize)(0,null),e.$po={value:e.$oo,original:"Extensions"},e.$qo={value:(0,D.localize)(1,null),original:"Preferences"}}),define(le[188],he([0,1,3,2,30,10,92,29]),function(ne,e,D,N,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=void 0;function S(w,l){return w?j.URI.revive(l?l.transformIncoming(w):w):void 0}function b(w,l){return l?l.transformOutgoingURI(w):w}function R(w,l){l=l||O.$Wm;const u=w.manifest;return{...(0,O.$Zm)({...w,manifest:void 0},l),manifest:u}}function k(w,l){return w?.profileLocation?(0,O.$Zm)(w,l??O.$Wm):w}function $(w,l){return l?(0,L.$gn)(w,u=>u instanceof j.URI?l.transformOutgoingURI(u):void 0):w}class c{constructor(l,u){this.a=l,this.b=u,this.onInstallExtension=D.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,u){const h=this.b(l);switch(u){case"onInstallExtension":return D.Event.map(this.onInstallExtension,d=>({...d,profileLocation:d.profileLocation?b(d.profileLocation,h):d.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,d=>d.map(E=>({...E,local:E.local?$(E.local,h):E.local,profileLocation:E.profileLocation?b(E.profileLocation,h):E.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,d=>({...d,profileLocation:d.profileLocation?b(d.profileLocation,h):d.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,d=>({...d,profileLocation:d.profileLocation?b(d.profileLocation,h):d.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,d=>$(d,h))}throw new Error("Invalid listen")}async call(l,u,h){const d=this.b(l);switch(u){case"zip":{const E=R(h[0],d),s=await this.a.zip(E);return b(s,d)}case"unzip":return this.a.unzip(S(h[0],d));case"install":return this.a.install(S(h[0],d),k(h[1],d));case"installFromLocation":return this.a.installFromLocation(S(h[0],d),S(h[1],d));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(h[0],S(h[1],d),S(h[2],d));case"getManifest":return this.a.getManifest(S(h[0],d));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(h[0]);case"installFromGallery":return this.a.installFromGallery(h[0],k(h[1],d));case"installGalleryExtensions":{const E=h[0];return this.a.installGalleryExtensions(E.map(({extension:s,options:o})=>({extension:s,options:k(o,d)??{}})))}case"uninstall":return this.a.uninstall(R(h[0],d),k(h[1],d));case"reinstallFromGallery":return this.a.reinstallFromGallery(R(h[0],d));case"getInstalled":return(await this.a.getInstalled(h[0],S(h[1],d))).map(s=>$(s,d));case"toggleAppliationScope":{const E=await this.a.toggleAppliationScope(R(h[0],d),S(h[1],d));return $(E,d)}case"copyExtensions":return this.a.copyExtensions(S(h[0],d),S(h[1],d));case"updateMetadata":{const E=await this.a.updateMetadata(R(h[0],d),h[1],S(h[2],d));return $(E,d)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(h[0],h[1],h[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$rp=c;class g extends N.$Rc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.m=l,this.c=this.B(new D.$Rd),this.f=this.B(new D.$Rd),this.g=this.B(new D.$Rd),this.h=this.B(new D.$Rd),this.j=this.B(new D.$Rd),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?j.URI.revive(u.source):u.source,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(h=>({...h,local:h.local?R(h.local,null):h.local,source:this.r(h.source)?j.URI.revive(h.source):h.source,profileLocation:j.URI.revive(h.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(R(u,null))))}n(l,u){l.fire(u)}r(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(l){const u=await this.getTargetPlatform();return l.allTargetPlatforms.some(h=>(0,C.$fo)(h,l.allTargetPlatforms,u))}zip(l){return Promise.resolve(this.m.call("zip",[l]).then(u=>j.URI.revive(u)))}unzip(l){return Promise.resolve(this.m.call("unzip",[l]))}install(l,u){return Promise.resolve(this.m.call("install",[l,u])).then(h=>R(h,null))}installFromLocation(l,u){return Promise.resolve(this.m.call("installFromLocation",[l,u])).then(h=>R(h,null))}async installExtensionsFromProfile(l,u,h){return(await this.m.call("installExtensionsFromProfile",[l,u,h])).map(E=>R(E,null))}getManifest(l){return Promise.resolve(this.m.call("getManifest",[l]))}installFromGallery(l,u){return Promise.resolve(this.m.call("installFromGallery",[l,u])).then(h=>R(h,null))}async installGalleryExtensions(l){return(await this.m.call("installGalleryExtensions",[l])).map(h=>({...h,local:h.local?R(h.local,null):h.local,source:this.r(h.source)?j.URI.revive(h.source):h.source,profileLocation:j.URI.revive(h.profileLocation)}))}uninstall(l,u){return Promise.resolve(this.m.call("uninstall",[l,u]))}reinstallFromGallery(l){return Promise.resolve(this.m.call("reinstallFromGallery",[l])).then(u=>R(u,null))}getInstalled(l=null,u){return Promise.resolve(this.m.call("getInstalled",[l,u])).then(h=>h.map(d=>R(d,null)))}updateMetadata(l,u,h){return Promise.resolve(this.m.call("updateMetadata",[l,u,h])).then(d=>R(d,null))}toggleAppliationScope(l,u){return this.m.call("toggleAppliationScope",[l,u]).then(h=>R(h,null))}copyExtensions(l,u){return this.m.call("copyExtensions",[l,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(l,u,h){const d=await this.m.call("download",[l,u,h]);return j.URI.revive(d)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$sp=g;class p{constructor(l){this.a=l}listen(l,u){throw new Error("Invalid listen")}call(l,u,h){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(h[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$tp=p}),define(le[97],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=void 0,e.$op=(0,D.$Zh)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((j,O)=>ne(["node-vsce-sign"],async C=>j(C),O))),this.a}async verify(j,O,C){let S;try{S=await this.b()}catch{return!1}return S.verify(j,O,C)}}e.$pp=N}),define(le[98],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MXb=e.RecommendationsNotificationResult=e.$LXb=e.RecommendationSource=void 0;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$LXb=L;var j;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$MXb=(0,D.$Zh)("IExtensionRecommendationNotificationService")}),define(le[11],he([0,1,47,16,27,12,10,159,4,5,23,52]),function(ne,e,D,N,L,j,O,C,S,b,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileKind=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.FileOperationResult=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileChangeType=e.$Ak=e.FileOperation=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileSystemProviderErrorCode=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderCapabilities=e.$kk=e.FilePermission=e.FileType=e.$jk=e.$ik=void 0,e.$ik=(0,S.$Zh)("fileService");function $(_){return _.create===!0}e.$jk=$;var c;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var g;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(g||(e.FilePermission=g={}));function p(_){const re=_;return!!re&&typeof re.onDidChange=="function"}e.$kk=p;var w;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function l(_){return!!(_.capabilities&2)}e.$lk=l;function u(_){return!!(_.capabilities&8)}e.$mk=u;function h(_){return!!(_.capabilities&131072)}e.$nk=h;function d(_){return!!(_.capabilities&4)}e.$ok=d;function E(_){return!!(_.capabilities&16)}e.$pk=E;function s(_){return l(_)?!!(_.capabilities&16384):!1}e.$qk=s;function o(_){return l(_)?!!(_.capabilities&32768):!1}e.$rk=o;function n(_){return!!(_.capabilities&65536)}e.$sk=n;function i(_){return!!(_.capabilities&2048)}e.$tk=i;var t;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(re,K){const z=new r(re.toString(),K);return m(z,K),z}constructor(re,K){super(re),this.code=K}}e.$uk=r;function a(_,re){return r.create(_,re)}e.$vk=a;function v(_){return _||a((0,C.localize)(0,null),t.Unknown)}e.$wk=v;function m(_,re){return _.name=re?`${re} (FileSystemError)`:"FileSystemError",_}e.$xk=m;function f(_){if(!_)return t.Unknown;if(_ instanceof r)return _.code;const re=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!re)return t.Unknown;switch(re[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$yk=f;function y(_){if(_ instanceof Y)return _.fileOperationResult;switch(f(_)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$zk=y;var I;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class F{constructor(re,K,z){this.resource=re,this.operation=K,this.target=z}isOperation(re){return this.operation===re}}e.$Ak=F;var T;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class M{static{this.a=null}constructor(re,K){this.c=K,this.b=void 0,this.d=new k.$U(()=>{const z=D.$6h.forUris(()=>this.c);return z.fill(this.rawAdded.map(P=>[P,!0])),z}),this.f=new k.$U(()=>{const z=D.$6h.forUris(()=>this.c);return z.fill(this.rawUpdated.map(P=>[P,!0])),z}),this.g=new k.$U(()=>{const z=D.$6h.forUris(()=>this.c);return z.fill(this.rawDeleted.map(P=>[P,!0])),z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const z of re){switch(z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}this.b!==M.a&&(typeof z.cId=="number"?this.b===void 0?this.b=z.cId:this.b!==z.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(re,...K){return this.h(re,{includeChildren:!1},...K)}affects(re,...K){return this.h(re,{includeChildren:!0},...K)}h(re,K,...z){if(!re)return!1;const P=z.length>0;return!!((!P||z.includes(1))&&(this.d.value.get(re)||K.includeChildren&&this.d.value.findSuperstr(re))||(!P||z.includes(0))&&(this.f.value.get(re)||K.includeChildren&&this.f.value.findSuperstr(re))||(!P||z.includes(2))&&(this.g.value.findSubstr(re)||K.includeChildren&&this.g.value.findSuperstr(re)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(re){return this.b===re}hasCorrelation(){return typeof this.b=="number"}}e.$Bk=M;function U(_,re,K){return!_||!re||_===re||re.length>_.length?!1:(re.charAt(re.length-1)!==N.sep&&(re+=N.sep),K?(0,L.$7e)(_,re):_.indexOf(re)===0)}e.$Ck=U;class Y extends Error{constructor(re,K,z){super(re),this.fileOperationResult=K,this.options=z}}e.$Dk=Y;class J extends Y{constructor(re,K,z,P){super(re,K,P),this.fileOperationResult=K,this.size=z}}e.$Ek=J;class x extends Y{constructor(re,K,z){super(re,2,z),this.stat=K}}e.$Fk=x;var W;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$Gk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Hk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ik="files.associations",e.$Jk="files.exclude",e.$Kk="files.readonlyInclude",e.$Lk="files.readonlyExclude",e.$Mk="files.readonlyFromPermissions";var X;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$Nk="";function V(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Ok=V;async function B(_,re){if(!re.hasProvider(O.URI.from({scheme:_.scheme})))return new Promise(K=>{const z=re.onDidChangeFileSystemProviderRegistrations(P=>{P.scheme===_.scheme&&P.added&&(z.dispose(),K())})})}e.$Pk=B;class te{static{this.KB=1024}static{this.MB=te.KB*te.KB}static{this.GB=te.MB*te.KB}static{this.TB=te.GB*te.KB}static formatSize(re){return(0,j.$Gf)(re)||(re=0),re<te.KB?(0,C.localize)(1,null,re.toFixed(0)):re<te.MB?(0,C.localize)(2,null,(re/te.KB).toFixed(2)):re<te.GB?(0,C.localize)(3,null,(re/te.MB).toFixed(2)):re<te.TB?(0,C.localize)(4,null,(re/te.GB).toFixed(2)):(0,C.localize)(5,null,(re/te.TB).toFixed(2))}}e.$Qk=te;function se(_){const re=typeof _=="string"||_?.scheme===R.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===R.Schemas.file?1024*te.MB:re?10*te.MB:b.$o?50*te.MB:1024*te.MB}e.$Rk=se});var Q=this&&this.__param||function(ne,e){return function(D,N){e(D,N,ne)}};define(le[189],he([0,1,72,46,11]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$20b=void 0;let j=class{constructor(C){this.a=C}async checksum(C){const S=(await this.a.readFileStream(C)).value;return new Promise((b,R)=>{const k=(0,D.createHash)("md5");(0,N.$0d)(S,{onData:$=>k.update($.buffer),onError:$=>R($),onEnd:()=>b(k.digest("base64").replace(/=+$/,""))})})}};e.$20b=j,e.$20b=j=ye([Q(0,L.$ik)],j)}),define(le[99],he([0,1,15,7,160,11]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;async function O(R,k,$,c,g,p){let w;try{await C(R,k,$,c,g,p)}catch(l){w=l}finally{w&&g.errorTransformer&&(w=g.errorTransformer(w)),typeof w<"u"&&$.error(w),$.end()}}e.$Wp=O;async function C(R,k,$,c,g,p){S(p);const w=await R.open(k,{create:!1});try{S(p);let l=0,u=0,h=g&&typeof g.length=="number"?g.length:void 0,d=D.$fe.alloc(Math.min(g.bufferSize,typeof h=="number"?h:g.bufferSize)),E=g&&typeof g.position=="number"?g.position:0,s=0;do u=await R.read(w,E,d.buffer,s,d.byteLength-s),E+=u,s+=u,l+=u,typeof h=="number"&&(h-=u),s===d.byteLength&&(await $.write(c(d)),d=D.$fe.alloc(Math.min(g.bufferSize,typeof h=="number"?h:g.bufferSize)),s=0);while(u>0&&(typeof h!="number"||h>0)&&S(p)&&b(l,g));if(s>0){let o=s;typeof h=="number"&&(o=Math.min(s,h)),$.write(c(d.slice(0,o)))}}catch(l){throw(0,j.$wk)(l)}finally{await R.close(w)}}function S(R){if(R.isCancellationRequested)throw(0,N.$5)();return!0}function b(R,k){if(typeof k?.limits?.size=="number"&&R>k.limits.size)throw(0,j.$vk)((0,L.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[49],he([0,1,91,2,16,5,10,11]),function(ne,e,D,N,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.$Yp=void 0;function S(l){return l.recursive===!0}e.$Yp=S;class b extends N.$Rc{static{this.a=5}constructor(u,h,d,E){super(),this.h=u,this.j=h,this.m=d,this.n=E,this.c=this.B(new N.$Sc),this.f=void 0,this.g=0}s(){const u=new N.$Qc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(h=>this.h(h))),u.add(this.b.onDidLogMessage(h=>this.j(h))),u.add(this.b.onDidError(h=>this.t(h)))}t(u){this.n.restartOnError?this.g<b.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Zp=b;class R extends b{constructor(u,h,d){super(u,h,d,{type:"node.js",restartOnError:!1})}}e.$1p=R;class k extends b{constructor(u,h,d){super(u,h,d,{type:"universal",restartOnError:!0})}}e.$2p=k;function $(l){return l.map(u=>({type:u.type,resource:O.URI.revive(u.resource),cId:u.cId}))}e.$3p=$;function c(l){const u=new w;for(const h of l)u.processEvent(h);return u.coalesce()}e.$4p=c;function g(l,u){return typeof u=="string"&&!u.startsWith(D.$Cj)&&!(0,L.$hc)(u)?{base:l,pattern:u}:u}e.$5p=g;function p(l,u){const h=[];for(const d of u)h.push((0,D.$Gj)(g(l,d)));return h}e.$6p=p;class w{constructor(){this.a=new Set,this.b=new Map}c(u){return j.$k?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const h=this.b.get(this.c(u));let d=!1;if(h){const E=h.type,s=u.type;h.resource.fsPath!==u.resource.fsPath&&(u.type===2||u.type===1)?d=!0:E===1&&s===2?(this.b.delete(this.c(u)),this.a.delete(h)):E===2&&s===1?h.type=0:E===1&&s===0||(h.type=s)}else d=!0;d&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],h=[];return Array.from(this.a).filter(d=>d.type!==2?(u.push(d),!1):!0).sort((d,E)=>d.resource.fsPath.length-E.resource.fsPath.length).filter(d=>h.some(E=>(0,C.$Ck)(d.resource.fsPath,E,!j.$k))?!1:(h.push(d.resource.fsPath),!0)).concat(u)}}}),define(le[190],he([0,1,15,38,7,3,2,46,32,11,49]),function(ne,e,D,N,L,j,O,C,S,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=e.$JN=void 0,e.$JN="localFilesystem";class k extends O.$Rc{constructor(c,g){super(),this.a=c,this.b=g,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$Rd),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$Rd),this.onDidWatchError=this.g.event,this.h=(0,S.$kg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(c){return this.a.call("stat",[c])}readdir(c){return this.a.call("readdir",[c])}async readFile(c,g){const{buffer:p}=await this.a.call("readFile",[c,g]);return p}readFileStream(c,g,p){const w=(0,C.$6d)(u=>D.$fe.concat(u.map(h=>D.$fe.wrap(h))).buffer),l=new O.$Qc;return l.add(this.a.listen("readFileStream",[c,g])(u=>{if(u instanceof D.$fe)w.write(u.buffer);else{if(u==="end")w.end();else{let h;if(u instanceof Error)h=u;else{const d=u;h=(0,b.$vk)(d.message??(0,N.$Ki)(d),d.code??b.FileSystemProviderErrorCode.Unknown)}w.error(h),w.end()}l.dispose()}})),l.add(p.onCancellationRequested(()=>{w.error((0,L.$5)()),w.end(),l.dispose()})),w}writeFile(c,g,p){return this.a.call("writeFile",[c,D.$fe.wrap(g),p])}open(c,g){return this.a.call("open",[c,g])}close(c){return this.a.call("close",[c])}async read(c,g,p,w,l){const[u,h]=await this.a.call("read",[c,g,l]);return p.set(u.buffer.slice(0,h),w),h}write(c,g,p,w,l){return this.a.call("write",[c,g,D.$fe.wrap(p),w,l])}mkdir(c){return this.a.call("mkdir",[c])}delete(c,g){return this.a.call("delete",[c,g])}rename(c,g,p){return this.a.call("rename",[c,g,p])}copy(c,g,p){return this.a.call("copy",[c,g,p])}cloneFile(c,g){return this.a.call("cloneFile",[c,g])}j(){this.B(this.a.listen("fileChange",[this.h])(c=>{if(Array.isArray(c)){const g=c;this.f.fire((0,R.$3p)(g))}else{const g=c;this.g.fire(g)}}))}watch(c,g){const p=(0,S.$kg)();return this.a.call("watch",[this.h,p,c,g]),(0,O.$Pc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$KN=k}),define(le[191],he([0,1,54,6,26,48,2,88,16,5,19,10,143,31,49]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;class p extends O.$Rc{static{this.a=100}static{this.b=75}constructor(u,h,d,E){super(),this.m=u,this.n=h,this.r=d,this.s=E,this.c=this.B(new N.$ch({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.n(s))),this.f=this.B(new N.$bh(s=>this.z(s),p.b)),this.g=(0,g.$6p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,g.$6p)(this.m.path,this.m.includes):void 0,this.j=new L.$2d,this.ready=this.t()}async t(){try{const u=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await c.Promises.stat(u);this.B(await this.w(u,h.isDirectory()))}catch(u){u.code!=="ENOENT"?this.D(u):this.G(u)}}async u(u){let h=u.path;try{h=await c.Promises.realpath(u.path),u.path===h&&(h=await(0,$.$dq)(u.path)??u.path),u.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${h})`)}catch{}return h}async w(u,h){if(b.$j&&(0,j.$2f)(u,"/Volumes/",!0))return this.D(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$Rc.None;const d=new L.$2d(this.j.token),E=new O.$Qc;try{const s=k.URI.file(this.m.path),o=(0,S.$mc)(u),n=(0,D.watch)(u);E.add((0,O.$Pc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${u}'`);const i=new Set;if(h)try{for(const r of await c.Promises.readdir(u))i.add(r)}catch(r){this.D(r)}const t=new Map;E.add((0,O.$Pc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.D(`Failed to watch ${u} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(d.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${a}`);let v="";if(a&&(v=a.toString(),b.$j&&(v=(0,C.$yl)(v))),!(!v||r!=="change"&&r!=="rename"))if(h)if(r==="rename"){t.get(v)?.dispose();const m=setTimeout(async()=>{if(t.delete(v),v===o&&!await c.Promises.exists(u)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.C((0,S.$ic)(u,v));if(d.token.isCancellationRequested)return;let y;f?i.has(v)?y=0:(y=1,i.add(v)):(i.delete(v),y=2),this.y({resource:(0,R.$Bg)(s,v),type:y,cId:this.m.correlationId})},p.a);t.set(v,(0,O.$Pc)(()=>clearTimeout(m)))}else{let m;i.has(v)?m=0:(m=1,i.add(v)),this.y({resource:(0,R.$Bg)(s,v),type:m,cId:this.m.correlationId})}else if(r==="rename"||v!==o){const m=setTimeout(async()=>{const f=await c.Promises.exists(u);d.token.isCancellationRequested||(f?(this.y({resource:s,type:0,cId:this.m.correlationId},!0),E.add(await this.w(u,!1))):(this.y({resource:s,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);E.clear(),E.add((0,O.$Pc)(()=>clearTimeout(m)))}else this.y({resource:s,type:0,cId:this.m.correlationId},!0)})}catch(s){await c.Promises.exists(u)&&!d.token.isCancellationRequested&&this.D(`Failed to watch ${u} for changes using fs.watch() (${s.toString()})`)}return(0,O.$Pc)(()=>{d.dispose(!0),E.dispose()})}y(u,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!h&&this.g.some(d=>d(u.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${u.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(d=>d(u.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}z(u){const h=(0,g.$4p)(u);if(h.length>0){if(this.s)for(const E of h)this.G(` >> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(u){if(b.$k)return c.Promises.exists(u);try{const h=(0,S.$mc)(u);return(await c.Promises.readdir((0,S.$lc)(u))).some(E=>E===h)}catch(h){return this.G(h),!1}}setVerboseLogging(u){this.s=u}D(u){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}F(u){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}G(u){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$gq=p;async function w(l,u,h,d,E=512){const s=await c.Promises.open(l,"r"),o=Buffer.allocUnsafe(E),n=new L.$2d(d);let i,t=!1;const r={path:l,excludes:[],recursive:!1},a=new p(r,v=>{(async()=>{for(const{type:m}of v)if(m===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:f}=await c.Promises.read(s,o,0,E,null);if(!f||n.token.isCancellationRequested)break;u(o.slice(0,f))}}catch(f){i=new Error(f),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,h(),new Promise((v,m)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await c.Promises.close(s)}catch(f){i=new Error(f)}i?m(i):v()})})}e.$hq=w}),define(le[192],he([0,1,3,91,2,5,191]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=void 0;class C extends L.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Rd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Rd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(b){const R=this.j(b),k=R.filter(c=>{const g=this.c.get(c.path);return g?!(0,N.$Kj)(g.request.excludes,c.excludes)||!(0,N.$Kj)(g.request.includes,c.includes):!0}),$=Array.from(this.c.values()).filter(({request:c})=>!R.find(g=>g.path===c.path&&(0,N.$Kj)(g.excludes,c.excludes)&&(0,N.$Kj)(g.includes,c.includes))).map(({request:c})=>c.path);k.length&&this.m(`Request to start watching: ${k.map(c=>`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`).join(",")}`),$.length&&this.m(`Request to stop watching: ${$.join(",")}`);for(const c of $)this.h(c);for(const c of k)this.g(c)}g(b){const R=new O.$gq(b,$=>this.a.fire($),$=>this.b.fire($),this.f),k={request:b,instance:R};this.c.set(b.path,k)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const R=this.c.get(b);R&&(this.c.delete(b),R.instance.dispose())}j(b){const R=new Map;for(const k of b){const $=j.$k?k.path:k.path.toLowerCase();let c=R.get(k.correlationId);c||(c=new Map,R.set(k.correlationId,c)),c.set($,k)}return Array.from(R.values()).map(k=>Array.from(k.values())).flat()}async setVerboseLogging(b){this.f=b;for(const[,R]of this.c)R.instance.setVerboseLogging(b)}m(b){this.f&&this.b.fire({type:"trace",message:this.n(b)})}n(b,R){return R?`[File Watcher (node.js)] ${b} (path: ${R.request.path})`:`[File Watcher (node.js)] ${b}`}}e.$iq=C}),define(le[193],he([0,1,49,192]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=void 0;class L extends D.$1p{constructor(O,C,S){super(O,C,S),this.s()}r(O){return O.add(new N.$iq)}}e.$jq=L}),define(le[194],he([0,1,23,40,93,49]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;class O extends j.$2p{constructor(S,b,R){super(S,b,R),this.s()}r(S){const b=S.add(new L.$aq(D.$ig.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(b.onDidProcessExit(({code:R,signal:k})=>this.t(`terminated by itself with code ${R}, signal: ${k}`))),N.ProxyChannel.toService((0,N.$Gh)(b.getChannel("watcher")))}}e.$bq=O}),define(le[73],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=void 0;class D{constructor(...L){this.a=new Map;for(const[j,O]of L)this.set(j,O)}set(L,j){const O=this.a.get(L);return this.a.set(L,j),O}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$Xh=D}),define(le[195],he([0,1,6,7,2,71,186,4,73,87]),function(ne,e,D,N,L,j,O,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$nq=void 0;const R=!1;class k extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class ${constructor(w=new S.$Xh,l=!1,u,h=R){this.f=w,this.g=l,this.h=u,this.i=h,this.o=new Set,this.f.set(C.$Yh,this),this._globalGraph=h?u?._globalGraph??new O.$mq(d=>d):void 0}createChild(w){return new $(w,this.g,this,this.i)}invokeFunction(w,...l){const u=g.traceInvocation(this.i,w);let h=!1;try{return w({get:E=>{if(h)throw(0,N.$7)("service accessor is only valid during the invocation of its target method");const s=this.m(E,u);if(!s)throw new Error(`[invokeFunction] unknown service '${E}'`);return s}},...l)}finally{h=!0,u.stop()}}createInstance(w,...l){let u,h;return w instanceof j.$Wh?(u=g.traceCreation(this.i,w.ctor),h=this.j(w.ctor,w.staticArguments.concat(l),u)):(u=g.traceCreation(this.i,w),h=this.j(w,l,u)),u.stop(),h}j(w,l=[],u){const h=C._util.getServiceDependencies(w).sort((s,o)=>s.index-o.index),d=[];for(const s of h){const o=this.m(s.id,u);o||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${s.id}.`,!1),d.push(o)}const E=h.length>0?h[0].index:l.length;if(l.length!==E){console.trace(`[createInstance] First service dependency of ${w.name} at position ${E+1} conflicts with ${l.length} static arguments`);const s=E-l.length;s>0?l=l.concat(new Array(s)):l=l.slice(0,E)}return Reflect.construct(w,l.concat(d))}k(w,l){if(this.f.get(w)instanceof j.$Wh)this.f.set(w,l);else if(this.h)this.h.k(w,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const l=this.f.get(w);return!l&&this.h?this.h.l(w):l}m(w,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const u=this.l(w);return u instanceof j.$Wh?this.q(w,u,l.branch(w,!0)):(l.branch(w,!1),u)}q(w,l,u){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,l,u)}finally{this.o.delete(w)}}r(w,l,u){const h=new O.$mq(s=>s.id.toString());let d=0;const E=[{id:w,desc:l,_trace:u}];for(;E.length;){const s=E.pop();if(h.lookupOrInsertNode(s),d++>1e3)throw new k(h);for(const o of C._util.getServiceDependencies(s.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),n instanceof j.$Wh){const i={id:o.id,desc:n,_trace:s._trace.branch(o.id,!0)};h.insertEdge(s,i),E.push(i)}}}for(;;){const s=h.roots();if(s.length===0){if(!h.isEmpty())throw new k(h);break}for(const{data:o}of s){if(this.l(o.id)instanceof j.$Wh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}h.removeNode(o)}}return this.l(w)}s(w,l,u=[],h,d){if(this.f.get(w)instanceof j.$Wh)return this.t(w,l,u,h,d);if(this.h)return this.h.s(w,l,u,h,d);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(w,l,u=[],h,d){if(h){const E=new $(void 0,this.g,this,this.i);E.c=String(w);const s=new Map,o=new D.$gh(()=>{const n=E.j(l,u,d);for(const[i,t]of s){const r=n[i];if(typeof r=="function")for(const a of t)r.apply(n,a)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let a=s.get(i);return a||(a=new b.$2c,s.set(i,a)),(m,f,y)=>{const I=a.push([m,f,y]);return(0,L.$Pc)(I)}}if(i in n)return n[i];const t=o.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),n[i]=r),r},set(n,i,t){return o.value[i]=t,!0},getPrototypeOf(n){return l.prototype}})}else return this.j(l,u,d)}u(w,l){if(l&&console.warn(w),this.g)throw new Error(w)}}e.$nq=$;var c;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(c||(c={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,l){return w?new g(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(w,l){return w?new g(1,l.name):g.c}static{this.f=0}constructor(w,l){this.type=w,this.name=l,this.g=Date.now(),this.h=[]}branch(w,l){const u=new g(3,w.toString());return this.h.push([w,l,u]),u}stop(){const w=Date.now()-this.g;g.f+=w;let l=!1;function u(d,E){const s=[],o=new Array(d+1).join("	");for(const[n,i,t]of E.h)if(i&&t){l=!0,s.push(`${o}CREATES -> ${n}`);const r=u(d+1,t);r&&s.push(r)}else s.push(`${o}uses -> ${n}`);return s.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(w>2||l)&&g.all.add(h.join(`
`))}}e.$oq=g}),define(le[56],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z0b=e.$y0b=void 0,e.$y0b=(0,D.$Zh)("mainProcessService");class N{constructor(j,O){this.a=j,this.b=O}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,O){this.a.registerChannel(j,O)}}e.$z0b=N}),define(le[74],he([0,1,26,2,5,162,29,4]),function(ne,e,D,N,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=e.$2q=void 0;function S(R){return R.tags.find(k=>k.startsWith("lp-"))?.split("lp-")[1]}e.$2q=S,e.$3q=(0,C.$Zh)("languagePackService");let b=class extends N.$Rc{constructor(k){super(),this.c=k}async getAvailableLanguages(){const k=new D.$2d;setTimeout(()=>k.cancel(),1e3);let $;try{$=await this.c.query({text:'category:"language packs"',pageSize:20},k.token)}catch{return[]}const g=$.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(w=>w.startsWith("lp-"))).map(p=>{const w=p.properties.localizedLanguages?.[0],l=S(p);return{...this.f(l,w,p),extensionId:p.identifier.id,galleryExtension:p}});return g.push(this.f("en","English")),g}f(k,$,c){const g=$??k;let p;if(g!==k&&(p=`(${k})`),k.toLowerCase()===L.$w.toLowerCase()&&(p??="",p+=(0,j.localize)(0,null)),c?.installCount){p??="";const w=c.installCount;let l;w>1e6?l=`${Math.floor(w/1e5)/10}M`:w>1e3?l=`${Math.floor(w/1e3)}K`:l=String(w),p+=` $(cloud-download) ${l}`}return{id:k,label:g,description:p}}};e.$4q=b,e.$4q=b=ye([Q(0,O.$ho)],b)}),define(le[196],he([0,1,2,74]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0b=void 0;let L=class extends D.$Rc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$X0b=L,e.$X0b=L=ye([Q(0,N.$3q)],L)}),define(le[8],he([0,1,38,3,53,2,34,5,19,12,10,94,4]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.log=e.$kj=e.LogLevel=e.$jj=e.$ij=e.$hj=void 0,e.$hj=(0,$.$Zh)("logService"),e.$ij=(0,$.$Zh)("loggerService");function c(){return new Date().toISOString()}function g(m){return(0,b.$Gf)(m)}e.$jj=g;var p;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$kj=p.Info;function w(m,f,y){switch(f){case p.Trace:m.trace(y);break;case p.Debug:m.debug(y);break;case p.Info:m.info(y);break;case p.Warning:m.warn(y);break;case p.Error:m.error(y);break;case p.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=w;function l(m,f=!1){let y="";for(let I=0;I<m.length;I++){let F=m[I];if(F instanceof Error&&(F=(0,D.$Ki)(F,f)),typeof F=="object")try{F=JSON.stringify(F)}catch{}y+=(I>0?" ":"")+F}return y}class u extends j.$Rc{constructor(){super(...arguments),this.b=e.$kj,this.c=this.B(new N.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==p.Off&&this.b<=f}}e.$mj=u;class h extends u{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...y){this.f(p.Trace)&&this.g(p.Trace,l([f,...y],!0))}debug(f,...y){this.f(p.Debug)&&this.g(p.Debug,l([f,...y]))}info(f,...y){this.f(p.Info)&&this.g(p.Info,l([f,...y]))}warn(f,...y){this.f(p.Warning)&&this.g(p.Warning,l([f,...y]))}error(f,...y){if(this.f(p.Error))if(f instanceof Error){const I=Array.prototype.slice.call(arguments);I[0]=f.stack,this.g(p.Error,l(I))}else this.g(p.Error,l([f,...y]))}flush(){}}e.$nj=h;class d extends u{constructor(f=e.$kj){super(),this.setLevel(f),this.g=!C.$i}trace(f,...y){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...y):console.log(`[main ${c()}]`,f,...y))}debug(f,...y){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...y):console.log(`[main ${c()}]`,f,...y))}info(f,...y){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,f,...y):console.log(`[main ${c()}]`,f,...y))}warn(f,...y){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,f,...y):console.warn(`[main ${c()}]`,f,...y))}error(f,...y){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,f,...y):console.error(`[main ${c()}]`,f,...y))}dispose(){}flush(){}}e.$oj=d;class E extends u{constructor(f=e.$kj,y=!0){super(),this.g=y,this.setLevel(f)}trace(f,...y){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...y):console.log(f,...y))}debug(f,...y){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...y):console.log(f,...y))}info(f,...y){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...y):console.log(f,...y))}warn(f,...y){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...y):console.log(f,...y))}error(f,...y){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...y):console.error(f,...y))}dispose(){}flush(){}}e.$pj=E;class s extends u{constructor(f,y=e.$kj){super(),this.g=f,this.setLevel(y)}trace(f,...y){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(f),...y])}debug(f,...y){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(f),...y])}info(f,...y){this.f(p.Info)&&this.g.log(p.Info,[this.h(f),...y])}warn(f,...y){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(f),...y])}error(f,...y){this.f(p.Error)&&this.g.log(p.Error,[this.h(f),...y])}h(f){return typeof f=="string"?f:(0,D.$Ki)(f,this.f(p.Trace))}dispose(){}flush(){}}e.$qj=s;class o extends u{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const y of this.g)y.setLevel(f);super.setLevel(f)}trace(f,...y){for(const I of this.g)I.trace(f,...y)}debug(f,...y){for(const I of this.g)I.debug(f,...y)}info(f,...y){for(const I of this.g)I.info(f,...y)}warn(f,...y){for(const I of this.g)I.warn(f,...y)}error(f,...y){for(const I of this.g)I.error(f,...y)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$rj=o;class n extends j.$Rc{constructor(f,y,I){if(super(),this.h=f,this.j=y,this.b=new O.$zc,this.c=this.B(new N.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Rd),this.onDidChangeVisibility=this.g.event,I)for(const F of I)this.b.set(F.resource,{logger:void 0,info:F})}m(f){return(0,b.$Cf)(f)?[...this.b.values()].find(y=>y.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,y){const I=this.n(f),F=(0,b.$Cf)(f)?f:y?.id??(0,L.$Ni)(I.toString()).toString(16);let T=this.b.get(I)?.logger;const M=y?.logLevel==="always"?p.Trace:y?.logLevel;T||(T=this.s(I,M??this.getLogLevel(I)??this.h,{...y,id:F}));const U={logger:T,info:{resource:I,id:F,logLevel:M,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(U.info),this.b.set(I,U),T}n(f){return(0,b.$Cf)(f)?(0,S.$Bg)(this.j,`${f}.log`):f}setLogLevel(f,y){if(R.URI.isUri(f)){const I=f,F=y,T=this.b.get(I);T&&F!==T.info.logLevel&&(T.info.logLevel=F===this.h?void 0:F,T.logger?.setLevel(F),this.b.set(T.info.resource,T),this.f.fire([I,F]))}else{this.h=f;for(const[I,F]of this.b.entries())this.b.get(I)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,y){const I=this.m(f);I&&y!==!I.info.hidden&&(I.info.hidden=!y,this.b.set(I.info.resource,I),this.g.fire([I.info.resource,y]))}getLogLevel(f){let y;return f&&(y=this.b.get(f)?.info.logLevel),y??this.h}registerLogger(f){const y=this.b.get(f.resource);y?y.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const y=this.b.get(f);y&&(y.logger&&y.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$sj=n;class i{constructor(){this.onDidChangeLogLevel=new N.$Rd().event}setLevel(f){}getLevel(){return p.Info}trace(f,...y){}debug(f,...y){}info(f,...y){}warn(f,...y){}error(f,...y){}critical(f,...y){}dispose(){}flush(){}}e.$tj=i;class t extends i{}e.$uj=t;function r(m){if(m.verbose)return p.Trace;if(typeof m.logLevel=="string"){const f=v(m.logLevel.toLowerCase());if(f!==void 0)return f}return e.$kj}e.$vj=r;function a(m){switch(m){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$wj=a;function v(m){switch(m){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$xj=v,e.$yj=new k.$ej("logLevel",a(p.Info))}),define(le[197],he([0,1,6,7,2,23,16,19,31,14,8]),function(ne,e,D,N,L,j,O,C,S,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y0b=void 0;let k=class extends L.$Rc{constructor(c,g){super(),this.a=c,this.b=g,this.B(new D.$_g(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const c=(0,C.$yg)(this.a.logsHome),g=(0,C.$Ag)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,l=(await S.Promises.readdir(g)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==c),u=l.slice(0,Math.max(0,l.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(h=>S.Promises.rm((0,O.$ic)(g,h)))))}catch(c){(0,N.$Z)(c)}}};e.$Y0b=k,e.$Y0b=k=ye([Q(0,b.$7h),Q(1,R.$hj)],k)}),define(le[198],he([0,1,18,6,7,3,2,16,49,8]),function(ne,e,D,N,L,j,O,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;class R extends O.$Rc{constructor($,c){super(),this.a=$,this.b=c,this.c=this.B(new j.$Rd),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$Rd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Xg(0)),this.w=[],this.y=this.B(new N.$Xg(0))}watch($,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n($,c):this.z($,c)}n($,c){const g={path:this.H($),excludes:c.excludes,includes:c.includes,recursive:c.recursive,correlationId:c.correlationId},p=(0,D.$Tb)(this.j,g);return this.r(),(0,O.$Pc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,L.$Z)($))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,S.$3p)(c)),c=>this.G(c),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const c of this.j)(0,S.$Yp)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const c of this.j)(0,S.$Yp)(c)&&$.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,c){const g={path:this.H($),excludes:c.excludes,includes:c.includes,recursive:!1,correlationId:c.correlationId},p=(0,D.$Tb)(this.w,g);return this.C(),(0,O.$Pc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,L.$Z)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,S.$3p)($)),$=>this.G($),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}H($){return(0,C.$gc)($.fsPath)}}e.$7p=R}),define(le[199],he([0,1,18,6,15,26,3,53,61,2,47,23,100,19,46,158,11,99,8,7]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u,h){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;let E=class extends b.$Rc{static{d=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new O.$Rd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$Rd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$Rd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$Rd),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$Rd),this.Y=this.B(new O.$Rd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$Rd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$9g)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${o}`);const i=new b.$Qc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),i.add(n.onDidChangeFile(t=>{const r=new w.$Bk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&i.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),i.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,b.$Pc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,b.$Mc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(i){n.push(i)}}),!this.h.has(o)&&await N.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&n)}listCapabilities(){return S.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,c.$Fg)(o))throw new w.$Dk((0,p.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const i=new h.$ab;throw i.message=(0,p.localize)(1,null,o.toString()),i}return n}async m(o){const n=await this.j(o);if((0,w.$ok)(n)||(0,w.$lk)(n)||(0,w.$pk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,w.$ok)(n)||(0,w.$lk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(i){throw(0,w.$yk)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.$Dk((0,p.localize)(2,null,this.sb(o)),1):(0,w.$wk)(i)}}async s(o,n){const i=await this.j(o),t=this.S(i),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,m=await i.stat(o);let f;return this.t(i,o,m,void 0,!!v,(y,I)=>(f||(f=R.$6h.forUris(()=>!t),f.set(o,!0),r&&f.fill(!0,r)),f.get(y.resource)||f.findSuperstr(y.resource.with({query:null,fragment:null}))?!0:y.isDirectory&&a?I===1:!1))}async t(o,n,i,t,r,a){const{providerExtUri:v}=this.R(o),m={resource:n,name:v.basename(n),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Ok)({mtime:i.mtime,size:i.size}),children:void 0};if(m.isDirectory&&a(m,t)){try{const f=await o.readdir(n),y=await N.Promises.settled(f.map(async([I,F])=>{try{const T=v.joinPath(n,I),M=r?await o.stat(T):{type:F};return await this.t(o,T,M,f.length,r,a)}catch(T){return this.b.trace(T),null}}));m.children=(0,D.$Gb)(y)}catch(f){this.b.trace(f),m.children=[]}return m}return m}async resolveAll(o){return N.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),i=await n.stat(o);return this.t(n,o,i,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(i){return i}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new w.$Dk((0,p.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=L.$fe.fromString(""),i){await this.u(o,i);const t=await this.writeFile(o,n);return this.r.fire(new w.$Ak(o,0,t)),t}async writeFile(o,n,i){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=i;if((0,w.$rk)(t)&&!a?.atomic){const v=t.enforceAtomicWriteFile?.(o);v&&(a={...i,atomic:v})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let m;if((0,w.$lk)(t)&&!(n instanceof L.$fe))if((0,g.$4d)(n)){const f=await(0,g.$$d)(n,3);f.ended?m=L.$fe.concat(f.buffer):m=f}else m=(0,g.$8d)(n,f=>L.$fe.concat(f),3);else m=n;!(0,w.$ok)(t)||(0,w.$lk)(t)&&m instanceof L.$fe||(0,w.$lk)(t)&&(0,w.$rk)(t)&&a?.atomic?await this.hb(t,o,a,m):await this.db(t,o,a,m instanceof L.$fe?(0,L.$qe)(m):m),this.r.fire(new w.$Ak(o,4))}catch(v){throw new w.$Dk((0,p.localize)(4,null,this.sb(o),(0,w.$wk)(v).toString()),(0,w.$zk)(v),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,i){const t=!!i?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(n)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(n)));if(t)throw new Error((0,p.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&w.FileType.Directory)throw new w.$Dk((0,p.localize)(9,null,this.sb(n)),0,i);if(this.rb(n,a),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.$Nk&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==(0,w.$Ok)({mtime:i.mtime,size:a.size}))throw new w.$Dk((0,p.localize)(10,null),3,i);return a}async readFile(o,n,i){const t=await this.m(o);return n?.atomic?this.z(t,o,n,i):this.C(t,o,n,i)}async z(o,n,i,t){return new Promise((r,a)=>{this.cb.queueFor(n,this.R(o).providerExtUri).queue(async()=>{try{const v=await this.C(o,n,i,t);r(v)}catch(v){a(v)}})})}async C(o,n,i,t){const r=await this.D(o,n,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,L.$re)(r.value)}}async readFileStream(o,n,i){const t=await this.m(o);return this.D(t,o,n,i)}async D(o,n,i,t){const r=new j.$2d(t);let a=i;(0,w.$qk)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...i,atomic:!0});const v=this.J(n,a).then(f=>f,f=>{throw r.dispose(!0),f});let m;try{return typeof a?.etag=="string"&&a.etag!==w.$Nk&&await v,a?.atomic&&(0,w.$qk)(o)||!((0,w.$ok)(o)||(0,w.$pk)(o))||(0,w.$lk)(o)&&a?.preferUnbuffered?m=this.I(o,n,a):(0,w.$pk)(o)?m=this.G(o,n,r.token,a):m=this.H(o,n,r.token,a),m.on("end",()=>r.dispose()),m.on("error",()=>r.dispose()),{...await v,value:m}}catch(f){throw m&&await(0,g.$9d)(m),this.F(f,n,a)}}F(o,n,i){const t=(0,p.localize)(11,null,this.sb(n),(0,w.$wk)(o).toString());return o instanceof w.$Fk?new w.$Fk(t,o.stat,i):o instanceof w.$Ek?new w.$Ek(t,o.fileOperationResult,o.size,o.options):new w.$Dk(t,(0,w.$zk)(o),i)}G(o,n,i,t=Object.create(null)){const r=o.readFileStream(n,t,i);return(0,g.$ce)(r,{data:a=>a instanceof L.$fe?a:L.$fe.wrap(a),error:a=>this.F(a,n,t)},a=>L.$fe.concat(a))}H(o,n,i,t=Object.create(null)){const r=(0,L.$ve)();return(0,l.$Wp)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},i),r}I(o,n,i){const t=(0,g.$6d)(r=>L.$fe.concat(r));return(async()=>{try{let r;i?.atomic&&(0,w.$qk)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(n,r.byteLength,i),t.end(L.$fe.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new w.$Dk((0,p.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.$Nk&&n.etag===i.etag)throw new w.$Fk((0,p.localize)(13,null),i,n);return this.L(o,i.size,n),i}L(o,n,i){if(typeof i?.limits?.size=="number"&&n>i.limits.size)throw new w.$Ek((0,p.localize)(14,null,this.sb(o)),7,n,i)}async canMove(o,n,i){return this.M(o,n,"move",i)}async canCopy(o,n,i){return this.M(o,n,"copy",i)}async M(o,n,i,t){if(o.toString()!==n.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,i,t)}catch(r){return r}return!0}async move(o,n,i){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$Ak(o,a==="move"?2:3,v)),v}async copy(o,n,i){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$Ak(o,a==="copy"?3:2,v)),v}async N(o,n,i,t,r,a){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:m}=await this.Q(o,n,i,t,r,a);if(v&&!m&&a&&await this.del(t,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(t)),r==="copy"){if(o===i&&(0,w.$mk)(o))await o.copy(n,t,{overwrite:a});else{const f=await this.resolve(n);f.isDirectory?await this.P(o,f,i,t):await this.O(o,n,i,t)}return r}else return o===i?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,i,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,i,t){if((0,w.$ok)(o)&&(0,w.$ok)(i))return this.jb(o,n,i,t);if((0,w.$ok)(o)&&(0,w.$lk)(i))return this.pb(o,n,i,t);if((0,w.$lk)(o)&&(0,w.$ok)(i))return this.nb(o,n,i,t);if((0,w.$lk)(o)&&(0,w.$lk)(i))return this.lb(o,n,i,t)}async P(o,n,i,t){await i.mkdir(t),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async r=>{const a=this.R(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,a):this.O(o,r.resource,i,a)}))}async Q(o,n,i,t,r,a){let v=!1;if(o===i){const{providerExtUri:f,isPathCaseSensitive:y}=this.R(o);if(y||(v=f.isEqual(n,t)),v&&r==="copy")throw new Error((0,p.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&f.isEqualOrParent(t,n))throw new Error((0,p.localize)(16,null,this.sb(n),this.sb(t)))}const m=await this.exists(t);if(m&&!v){if(!a)throw new w.$Dk((0,p.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===i){const{providerExtUri:f}=this.R(o);if(f.isEqualOrParent(n,t))throw new Error((0,p.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:m,isSameResourceWithDifferentPathCase:v}}R(o){const n=this.S(o);return{providerExtUri:n?c.$rg:c.$tg,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new w.$Ak(o,0,i)),i}async U(o,n){const i=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&w.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(n)));break}catch(r){if((0,w.$yk)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(n)),n=t.dirname(n)}for(let r=i.length-1;r>=0;r--){n=t.joinPath(n,i[r]);try{await o.mkdir(n)}catch(a){if((0,w.$yk)(a)!==w.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(i){return i}return!0}async W(o,n){const i=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,p.localize)(22,null,this.sb(o)));let a;try{a=await i.stat(o)}catch{}if(a)this.rb(o,a);else throw new w.$Dk((0,p.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const m=await this.resolve(o);if(m.isDirectory&&Array.isArray(m.children)&&m.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(o)))}return i}async del(o,n){const i=await this.W(o,n);let t=n;if((0,w.$sk)(i)&&!t?.atomic){const m=i.enforceAtomicDelete?.(o);m&&(t={...n,atomic:m})}const r=!!t?.useTrash,a=!!t?.recursive,v=t?.atomic??!1;await i.delete(o,{recursive:a,useTrash:r,atomic:v}),this.r.fire(new w.$Ak(o,1))}async cloneFile(o,n){const i=await this.j(o),t=this.qb(await this.n(n),n);if(i===t&&this.R(i).providerExtUri.isEqual(o,n))return;if(i===t&&(0,w.$nk)(i))return i.cloneFile(o,n);await this.U(t,this.R(t).providerExtUri.dirname(n));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===t&&(0,w.$mk)(i)?r.queue(()=>i.copy(o,n,{overwrite:!0})):r.queue(()=>this.O(i,o,t,n))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:d.ab++})}watch(o,n={recursive:!1,excludes:[]}){const i=new b.$Qc;let t=!1,r=()=>{t=!0};i.add((0,b.$Pc)(()=>r())),(async()=>{try{const v=await this.bb(o,n);t?(0,b.$Mc)(v):r=()=>(0,b.$Mc)(v)}catch(v){this.b.error(v)}})();const a=n.correlationId;if(typeof a=="number"){const v=i.add(new O.$Rd);return i.add(this.X.event(f=>{f.correlates(a)&&v.fire(f)})),{onDidChange:v.event,dispose:()=>i.dispose()}}return i}async bb(o,n){const i=await this.j(o),t=(0,C.$Ni)([this.R(i).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:i.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,b.$Pc)(()=>{r&&(r.count--,r.count===0&&((0,b.$Mc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,b.$Mc)(o.disposable);this.$.clear()}async db(o,n,i,t){return this.cb.queueFor(n,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(n,{create:!0,unlock:i?.unlock??!1});try{(0,g.$4d)(t)||(0,g.$5d)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,w.$wk)(a)}finally{await o.close(r)}})}async eb(o,n,i){let t=0,r;if((0,g.$5d)(i)){if(i.buffer.length>0){const a=L.$fe.concat(i.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((a,v)=>{(0,g.$0d)(r,{onData:async m=>{r.pause();try{await this.gb(o,n,m,m.byteLength,t,0)}catch(f){return v(f)}t+=m.byteLength,setTimeout(()=>r.resume())},onError:m=>v(m),onEnd:()=>a()})})}async fb(o,n,i){let t=0,r;for(;(r=i.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,i,t,r,a){let v=0;for(;v<t;){const m=await o.write(n,r+v,i.buffer,a+v,t-v);v+=m}}async hb(o,n,i,t){return this.cb.queueFor(n,this.R(o).providerExtUri).queue(()=>this.ib(o,n,i,t))}async ib(o,n,i,t){let r;t instanceof L.$fe?r=t:(0,g.$4d)(t)?r=await(0,L.$re)(t):(0,g.$5d)(t)?r=await(0,L.$se)(t):r=(0,L.$pe)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.kb(o,n,i,t))}async kb(o,n,i,t){let r,a;try{r=await o.open(n,{create:!1}),a=await i.open(t,{create:!0,unlock:!1});const v=L.$fe.alloc(this.a);let m=0,f=0,y=0;do y=await o.read(r,m,v.buffer,f,v.byteLength-f),await this.gb(i,a,v,y,m,f),m+=y,f+=y,f===v.byteLength&&(f=0);while(y>0)}catch(v){throw(0,w.$wk)(v)}finally{await N.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async lb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.mb(o,n,i,t))}async mb(o,n,i,t){return i.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.ob(o,n,i,t))}async ob(o,n,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(i,r,L.$fe.wrap(a),a.byteLength,0,0)}catch(a){throw(0,w.$wk)(a)}finally{await i.close(r)}}async pb(o,n,i,t){const r=await(0,L.$re)(this.H(o,n,j.CancellationToken.None));await this.hb(i,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new w.$Dk((0,p.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.$Dk((0,p.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===k.Schemas.file?o.fsPath:o.toString(!0)}};e.$Xp=E,e.$Xp=E=d=ye([Q(0,u.$hj)],E)}),define(le[200],he([0,1,54,270,6,34,15,3,48,2,16,5,19,46,31,161,11,99,198,38,194,193]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u,h,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0,(()=>{try{(0,N.gracefulify)(D)}catch(o){console.error(`Error enabling graceful-fs: ${(0,h.$Ki)(o)}`)}})();class s extends u.$7p{static{this.I=!1}constructor(n,i){super(n,i),this.onDidChangeCapabilities=C.Event.None,this.N=new j.$zc(t=>$.$sg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,k.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:i,symbolicLink:t}=await g.SymlinkSupport.stat(this.H(n));return{type:this.M(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await g.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,$.$Bg)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(i){throw this.fb(i)}}M(n,i){let t;return i?.dangling?t=w.FileType.Unknown:n.isFile()?t=w.FileType.File:n.isDirectory()?t=w.FileType.Directory:t=w.FileType.Unknown,i&&(t|=w.FileType.SymbolicLink),t}async O(n){const i=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new L.$Yg;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,b.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(n,i){let t;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await g.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){s.I&&this.a.trace(n)}readFileStream(n,i,t){const r=(0,c.$6d)(a=>O.$fe.concat(a.map(v=>O.$fe.wrap(v))).buffer);return(0,l.$Wp)(this,n,r,a=>a.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(n,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,$.$Bg)((0,$.$Ag)(n),`${(0,$.$yg)(n)}${t.atomic.postfix}`),i,t):this.S(n,i,t)}async Q(n){try{const i=this.H(n),{symbolicLink:t}=await g.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async R(n,i,t,r){const a=new b.$Qc;try{a.add(await this.O(n)),a.add(await this.O(i)),await this.S(i,t,r,!0);try{await this.rename(i,n,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{a.dispose()}}async S(n,i,t,r){let a;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await g.Promises.exists(v)){if(!t.overwrite)throw(0,w.$vk)((0,p.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,w.$vk)((0,p.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,i,0,i.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(n){s.Y=n}async open(n,i,t){const r=this.H(n);let a;(0,w.$jk)(i)&&!t&&(a=await this.O(n));let v;try{if((0,w.$jk)(i)&&i.unlock)try{const{stat:f}=await g.SymlinkSupport.stat(r);f.mode&128||await g.Promises.chmod(r,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let m;if((0,w.$jk)(i)){if(k.$i)try{await g.Promises.truncate(r,0),m="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}m||(m="w")}else m="r";v=await g.Promises.open(r,m)}catch(m){throw a?.dispose(),(0,w.$jk)(i)?await this.gb(n,m):this.fb(m)}if(this.U.set(v,0),(0,w.$jk)(i)&&this.X.set(v,n),a){const m=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,a),m&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),m.dispose())}return v}async close(n){const i=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&s.Y)try{await g.Promises.fdatasync(n)}catch(t){s.configureFlushOnWrite(!1),this.a.error(t)}return await g.Promises.close(n)}catch(t){throw this.fb(t)}finally{i&&(this.W.get(n)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,t,r,a){const v=this.Z(n,i);let m=null;try{m=(await g.Promises.read(n,t,r,a,v)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(n,v,m)}return m}Z(n,i){return i===this.U.get(n)?null:i}$(n,i,t){const r=this.U.get(n);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,i,t,r,a){return(0,L.$hh)(()=>this.ab(n,i,t,r,a),100,3)}async ab(n,i,t,r,a){const v=this.Z(n,i);let m=null;try{m=(await g.Promises.write(n,t,r,a,v)).bytesWritten}catch(f){throw await this.gb(this.X.get(n),f)}finally{this.$(n,v,m)}return m}async mkdir(n){try{await g.Promises.mkdir(this.H(n))}catch(i){throw this.fb(i)}}async delete(n,i){try{const t=this.H(n);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,R.$ic)((0,R.$lc)(t),`${(0,R.$mc)(t)}${i.atomic.postfix}`)),await g.Promises.rm(t,g.RimRafMode.MOVE,r)}else try{await g.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:v,symbolicLink:m}=await g.SymlinkSupport.stat(t);a=v.isDirectory()&&!m}catch{}if(a)await g.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,i,t){const r=this.H(n),a=this.H(i);if(r!==a)try{await this.bb(n,i,"move",t.overwrite),await g.Promises.rename(r,a)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(2,null,(0,R.$mc)(r),(0,R.$mc)((0,R.$lc)(a)),v.toString()))),this.fb(v)}}async copy(n,i,t){const r=this.H(n),a=this.H(i);if(r!==a)try{await this.bb(n,i,"copy",t.overwrite),await g.Promises.copy(r,a,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(3,null,(0,R.$mc)(r),(0,R.$mc)((0,R.$lc)(a)),v.toString()))),this.fb(v)}}async bb(n,i,t,r){const a=this.H(n),v=this.H(i);let m=!1;if(!!(this.capabilities&1024)||(m=(0,S.$1f)(a,v,!0)),m){if(t==="copy")throw(0,w.$vk)((0,p.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const y=await this.L(n);if(!y)throw(0,w.$vk)((0,p.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const I=await this.L(i);if(I){if(!r)throw(0,w.$vk)((0,p.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);y.type&w.FileType.File&&I.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.cb(n,i,!1)}async cb(n,i,t){const r=this.H(n),a=this.H(i),v=!!(this.capabilities&1024);if((0,S.$1f)(r,a,!v))return;const m=new b.$Qc;try{m.add(await this.O(n)),m.add(await this.O(i)),t&&await g.Promises.mkdir((0,R.$lc)(a),{recursive:!0}),await g.Promises.copyFile(r,a)}catch(f){if(f.code==="ENOENT"&&!t)return this.cb(n,i,!0);throw this.fb(f)}finally{m.dispose()}}t(n,i,t){return new d.$bq(r=>n(r),r=>i(r),t)}F(n,i,t){return new E.$jq(r=>n(r),r=>i(r),t)}fb(n){if(n instanceof w.$uk)return n;let i=n,t;switch(n.code){case"ENOENT":t=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=w.FileSystemProviderErrorCode.Unknown;break;default:t=w.FileSystemProviderErrorCode.Unknown}return(0,w.$vk)(i,t)}async gb(n,i){let t=this.fb(i);if(n&&t.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await g.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,w.$vk)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$kq=s}),define(le[101],he([0,1,3,2,4,8]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p$b=e.$o$b=void 0,e.$o$b=(0,L.$Zh)("sharedProcessLifecycleService");let O=class extends N.$Rc{constructor(S){super(),this.b=S,this.a=this.B(new D.$Rd),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$p$b=O,e.$p$b=O=ye([Q(0,j.$hj)],O)}),define(le[201],he([0,1,10,3,8,2]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.$ir=void 0;class O extends L.$sj{constructor(k,$,c,g,p){super($,c,g),this.r=k,this.t=p,this.B(p.listen("onDidChangeLogLevel",k)(w=>{(0,L.$jj)(w)?super.setLogLevel(w):super.setLogLevel(D.URI.revive(w[0]),w[1])})),this.B(p.listen("onDidChangeVisibility",k)(([w,l])=>super.setVisibility(D.URI.revive(w),l))),this.B(p.listen("onDidChangeLoggers",k)(({added:w,removed:l})=>{for(const u of w)super.registerLogger({...u,resource:D.URI.revive(u.resource)});for(const u of l)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new L.$qj({log:(k,$)=>{this.t.call("consoleLog",[k,$])}})}registerLogger(k){super.registerLogger(k),this.t.call("registerLogger",[k,this.r])}deregisterLogger(k){super.deregisterLogger(k),this.t.call("deregisterLogger",[k,this.r])}setLogLevel(k,$){super.setLogLevel(k,$),this.t.call("setLogLevel",[k,$])}setVisibility(k,$){super.setVisibility(k,$),this.t.call("setVisibility",[this.n(k),$])}s(k,$,c){return new C(this.t,k,$,c,this.r)}static setLogLevel(k,$,c){return k.call("setLogLevel",[$,c])}}e.$ir=O;class C extends L.$nj{constructor(k,$,c,g,p){super(g?.logLevel==="always"),this.r=k,this.s=$,this.m=!1,this.n=[],this.setLevel(c),this.r.call("createLogger",[$,g,p]).then(()=>{this.u(this.n),this.m=!0})}g(k,$){const c=[[k,$]];this.m?this.u(c):this.n.push(...c)}u(k){this.r.call("log",[this.s,k])}}class S{constructor(k,$){this.a=k,this.b=$}listen(k,$){const c=this.b(k);switch($){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(p=>this.c(p,c)),removed:[...g.removed].map(p=>this.c(p,c))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,g=>[c.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,g=>(0,L.$jj)(g)?g:[c.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${$}`)}async call(k,$,c){const g=this.b(k);switch($){case"setLogLevel":return(0,L.$jj)(c[0])?this.a.setLogLevel(c[0]):this.a.setLogLevel(D.URI.revive(g.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,g)))}throw new Error(`Call not found: ${$}`)}c(k,$){return{...k,resource:$.transformOutgoingURI(k.resource)}}}e.$jr=S;class b extends j.$Rc{constructor(k,$){super(),$.call("setLogLevel",[k.getLogLevel()]),this.B(k.onDidChangeLogLevel(c=>$.call("setLogLevel",[c]))),$.call("getRegisteredLoggers").then(c=>{for(const g of c)k.registerLogger({...g,resource:D.URI.revive(g.resource)})}),this.B($.listen("onDidChangeVisibility")(([c,g])=>k.setVisibility(D.URI.revive(c),g))),this.B($.listen("onDidChangeLoggers")(({added:c,removed:g})=>{for(const p of c)k.registerLogger({...p,resource:D.URI.revive(p.resource)});for(const p of g)k.deregisterLogger(p.resource)}))}}e.$kr=b}),define(le[202],he([0,1,2,8]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2N=void 0;class L extends D.$Rc{constructor(O,C=[]){super(),this.a=new N.$rj([O,...C]),this.B(O.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...C){this.a.trace(O,...C)}debug(O,...C){this.a.debug(O,...C)}info(O,...C){this.a.info(O,...C)}warn(O,...C){this.a.warn(O,...C)}error(O,...C){this.a.error(O,...C)}flush(){this.a.flush()}}e.$2N=L}),define(le[57],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k9b=void 0,e.$k9b=(0,D.$Zh)("nativeHostService")}),define(le[203],he([0,1,40,56]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E0b=void 0;let L=class{constructor(O,C){return this.windowId=O,D.ProxyChannel.toService(C.getChannel("nativeHost"),{context:O,properties:(()=>{const S=new Map;return S.set("windowId",O),S})()})}};e.$E0b=L,e.$E0b=L=ye([Q(1,N.$y0b)],L)}),define(le[58],he([0,1,3,61,2,4]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=void 0,e.$sn=(0,j.$Zh)("policy");class O extends L.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$Rd),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const R=Object.keys(this.f).length;return this.f={...b,...this.f},R!==Object.keys(this.f).length&&await this.j(b),N.Iterable.reduce(this.g.entries(),(k,[$,c])=>({...k,[$]:c}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(b,[R,k])=>({...b,[R]:{definition:k,value:this.g.get(R)}}),{})}}e.$tn=O;class C{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$un=C}),define(le[204],he([0,1,3,2,58]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$89b=e.$79b=void 0;class j{constructor(S){this.b=S,this.a=new N.$Qc}listen(S,b){switch(b){case"onDidChange":return D.Event.map(this.b.onDidChange,R=>R.reduce((k,$)=>({...k,[$]:this.b.getPolicyValue($)??null}),{}),this.a)}throw new Error(`Event not found: ${b}`)}call(S,b,R){switch(b){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(R)}throw new Error(`Call not found: ${b}`)}dispose(){this.a.dispose()}}e.$79b=j;class O extends L.$tn{constructor(S,b){super(),this.a=b;for(const R in S){const{definition:k,value:$}=S[R];this.f[R]=k,$!==void 0&&this.g.set(R,$)}this.a.listen("onDidChange")(R=>{for(const k in R){const $=R[k];$===null?this.g.delete(k):this.g.set(k,$)}this.h.fire(Object.keys(R))})}async j(S){const b=await this.a.call("updatePolicyDefinitions",S);for(const R in b)this.g.set(R,b[R])}}e.$89b=O}),define(le[102],he([0,1,37]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const j=L.context.configuration();if(j)N=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:j.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(le[25],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=void 0,e.$zj=(0,D.$Zh)("productService"),e.$Aj="vscode://schemas/vscode-product"}),define(le[205],he([0,1,6,7,2,16,31,8,25]),function(ne,e,D,N,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V0b=void 0;let b=class extends L.$Rc{constructor(k,$,c){super(),this.b=$,this.c=c,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,k&&this.B(new D.$_g(()=>{this.f(k)},3e4)).schedule()}async f(k){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const $=Date.now(),c=(0,j.$lc)(k),g=(0,j.$mc)(k),p=await O.Promises.readdir(c);await Promise.all(p.map(async w=>{if(w===g)return;const l=(0,j.$ic)(c,w),u=await O.Promises.stat(l);if(u.isDirectory()&&$-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),O.Promises.rm(l)}))}catch($){(0,N.$Z)($)}}};e.$V0b=b,e.$V0b=b=ye([Q(1,S.$zj),Q(2,C.$hj)],b)}),define(le[206],he([0,1,6,7,2,16,31,14,8,25]),function(ne,e,D,N,L,j,O,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W0b=void 0;let R=class extends L.$Rc{constructor($,c,g){super(),this.b=$,this.c=c,this.f=g,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.$_g(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const $=Object.create(null),c=JSON.parse(await O.Promises.readFile((0,j.$ic)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(c)){const h=c[u];$[`${h.hash}.${u}`]=!0}const g=(0,j.$ic)(this.b.userDataPath,"clp");if(!await O.Promises.exists(g))return;const w=await O.Promises.readdir(g);for(const u of w){if($[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await O.Promises.rm((0,j.$ic)(g,u))}const l=Date.now();for(const u of Object.keys($)){const h=(0,j.$ic)(g,u),d=await O.Promises.readdir(h);for(const E of d){if(E==="tcf.json")continue;const s=(0,j.$ic)(h,E),o=await O.Promises.stat(s);o.isDirectory()&&l-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$ic)(u,E)}`),await O.Promises.rm(s))}}}catch($){(0,N.$Z)($)}}};e.$W0b=R,e.$W0b=R=ye([Q(0,C.$8h),Q(1,S.$hj),Q(2,b.$zj)],R)}),define(le[207],he([0,1,16,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$CF=void 0,e.$CF=(0,N.$Zh)("IV8InspectProfilingService");var L;(function(j){function O(S){return!!(S.samples&&S.timeDeltas)}j.isValidProfile=O;function C(S,b="noAbsolutePaths"){for(const R of S.nodes)R.callFrame&&R.callFrame.url&&((0,D.$hc)(R.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(R.callFrame.url))&&(R.callFrame.url=(0,D.$ic)(b,(0,D.$mc)(R.callFrame.url)));return S}j.rewriteAbsolutePaths=C})(L||(e.Utils=L={}))}),define(le[208],he([0,1,32]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$b=void 0;class N{constructor(){this.a=new Map}async startProfiling(j){const C=await(await new Promise((b,R)=>{ne(["v8-inspect-profiler"],b,R)})).startProfiling({port:j.port,checkForPaused:!0}),S=(0,D.$kg)();return this.a.set(S,C),S}async stopProfiling(j){const O=this.a.get(j);if(!O)throw new Error(`UNKNOWN session '${j}'`);const C=await O.stop();return this.a.delete(j),C.profile}}e.$e$b=N}),define(le[41],he([0,1,126,12]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0;class L{constructor(){this.a=new Map}add(O,C){D.ok(N.$Cf(O)),D.ok(N.$Ef(C)),D.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,C)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$qn=new L}),define(le[103],he([0,1,3,41]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=void 0,e.$rn={JSONContribution:"base.contributions.json"};function L(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class j{constructor(){this.b=new D.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,b){this.a[L(S)]=b,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const O=new j;N.$qn.add(e.$rn.JSONContribution,O)}),define(le[50],he([0,1,18,3,12,148,20,103,41]),function(ne,e,D,N,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.ConfigurationScope=e.$vn=e.EditPresentationTypes=void 0;var b;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$vn={Configuration:"base.contributions.configuration"};var R;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn={properties:{},patternProperties:{}},e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn="vscode://schemas/settings/resourceLanguage",e.$Dn="vscode://schemas/settings/configurationDefaults";const k=S.$qn.as(C.$rn.JSONContribution);class ${constructor(){this.h=new Set,this.i=new N.$Rd,this.onDidSchemaChange=this.i.event,this.j=new N.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Cn,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const n=new Set;this.n(s,o,n),k.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const o=new Set;this.o(s,o),k.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const n=new Set;this.o(o,n),this.n(s,!1,n),k.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const n=[];for(const{overrides:i,source:t}of s)for(const r in i)if(o.add(r),e.$Fn.test(r)){const a=this.a.get(r),v=a?.valuesSources??new Map;if(t)for(const I of Object.keys(i[r]))v.set(I,t);const m={...a?.value||{},...i[r]};this.a.set(r,{source:t,value:m,valuesSources:v});const f=(0,O.$Di)(r),y={type:"object",default:m,description:j.localize(1,null,f),$ref:e.$Cn,defaultDefaultValue:m,source:L.$Cf(t)?void 0:t,defaultValueSource:t};n.push(...p(r)),this.d[r]=y,this.b.properties[r]=y}else{this.a.set(r,{value:i[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:n,source:i}of s)for(const t in n){const r=this.a.get(t),a=L.$Cf(i)?i:i?.id,v=L.$Cf(r?.source)?r?.source:r?.source?.id;if(a===v)if(o.add(t),this.a.delete(t),e.$Fn.test(t))delete this.d[t],delete this.b.properties[t];else{const m=this.d[t];m&&(this.w(t,m),this.r(t,m))}}this.u()}deltaConfiguration(s){let o=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,n){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(s,o){const n=i=>{if(i.properties)for(const t in i.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,i.properties[t])}i.allOf?.forEach(t=>n(t))};for(const i of s){n(i);const t=this.c.indexOf(i);t!==-1&&this.c.splice(t,1)}}p(s,o=!0,n,i,t=3,r){t=L.$Lf(s.scope)?t:s.scope;const a=s.properties;if(a)for(const m in a){const f=a[m];if(o&&h(m,f)){delete a[m];continue}if(f.source=n,f.defaultDefaultValue=a[m].default,this.w(m,f),e.$Fn.test(m)?f.scope=void 0:(f.scope=L.$Lf(f.scope)?t:f.scope,f.restricted=L.$Lf(f.restricted)?!!i?.includes(m):f.restricted),a[m].hasOwnProperty("included")&&!a[m].included){this.f[m]=a[m],delete a[m];continue}else this.d[m]=a[m],a[m].policy?.name&&this.e.set(a[m].policy.name,m);!a[m].deprecationMessage&&a[m].markdownDeprecationMessage&&(a[m].deprecationMessage=a[m].markdownDeprecationMessage),r.add(m)}const v=s.allOf;if(v)for(const m of v)this.p(m,o,n,i,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=n=>{const i=n.properties;if(i)for(const r in i)this.r(r,i[r]);n.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$wn.properties[s]=o,o.scope){case 1:e.$xn.properties[s]=o;break;case 2:e.$yn.properties[s]=o;break;case 6:e.$zn.properties[s]=o;break;case 3:e.$An.properties[s]=o;break;case 4:e.$Bn.properties[s]=o;break;case 5:e.$Bn.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$wn.properties[s],o.scope){case 1:delete e.$xn.properties[s];break;case 2:delete e.$yn.properties[s];break;case 6:delete e.$zn.properties[s];break;case 3:delete e.$An.properties[s];break;case 4:case 5:delete e.$Bn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,n={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$Cn};this.w(o,n),e.$wn.properties[o]=n,e.$xn.properties[o]=n,e.$yn.properties[o]=n,e.$zn.properties[o]=n,e.$An.properties[o]=n,e.$Bn.properties[o]=n}}v(){const s={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$Cn};e.$wn.patternProperties[e.$En]=s,e.$xn.patternProperties[e.$En]=s,e.$yn.patternProperties[e.$En]=s,e.$zn.patternProperties[e.$En]=s,e.$An.patternProperties[e.$En]=s,e.$Bn.patternProperties[e.$En]=s,this.i.fire()}w(s,o){const n=this.a.get(s);let i=n?.value,t=n?.source;L.$Jf(i)&&(i=o.defaultDefaultValue,t=void 0),L.$Jf(i)&&(i=l(o.type)),o.default=i,o.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",g=new RegExp(c,"g");e.$En=`^(${c})+$`,e.$Fn=new RegExp(e.$En);function p(E){const s=[];if(e.$Fn.test(E)){let o=g.exec(E);for(;o?.length;){const n=o[1].trim();n&&s.push(n),o=g.exec(E)}}return(0,D.$Lb)(s)}e.$Gn=p;function w(E){return E.reduce((s,o)=>`${s}[${o}]`,"")}e.$Hn=w;function l(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$In=l;const u=new $;S.$qn.add(e.$vn.Configuration,u);function h(E,s){return E.trim()?e.$Fn.test(E)?j.localize(7,null,E):u.getConfigurationProperties()[E]!==void 0?j.localize(8,null,E):s.policy?.name&&u.getPolicyConfigurations().get(s.policy?.name)!==void 0?j.localize(9,null,E,s.policy?.name,u.getPolicyConfigurations().get(s.policy?.name)):null:j.localize(6,null)}e.$Jn=h;function d(){const E=[],s=u.getConfigurationProperties();for(const o of Object.keys(s))E.push([o,s[o].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.$Kn=d}),define(le[75],he([0,1,18,3,35,2,34,30,12,10,20,50,41]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0;function c(o){return Object.isFrozen(o)?o:C.$fn(o)}class g{constructor(n={},i=[],t=[],r){this.b=n,this.c=i,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof g)return i;const t=new p("");return t.parseRaw(i),t.configurationModel});this.f=n.reduce((i,t)=>t===i?t:i.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,R.$Bi)(this.contents,n):this.contents}inspect(n,i){const t=this.rawConfiguration.getValue(n),r=i?this.rawConfiguration.getOverrideValue(n,i):void 0,a=i?this.rawConfiguration.override(i).getValue(n):t;return{value:t,override:r,merged:a}}getOverrideValue(n,i){const t=this.i(i);return t?n?(0,R.$Bi)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const t of this.overrides)t.identifiers.includes(n)&&i.push(...t.keys);return D.$Lb(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return D.$Lb(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=C.$en(this.contents),t=C.$en(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const v of n)if(a.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(i,v.contents);for(const m of v.overrides){const[f]=t.filter(y=>D.$tb(y.identifiers,m.identifiers));f?(this.h(f.contents,m.contents),f.keys.push(...m.keys),f.keys=D.$Lb(f.keys)):t.push(C.$en(m))}for(const m of v.keys)r.indexOf(m)===-1&&r.push(m)}return new g(i,r,t,a.every(v=>v instanceof g)?void 0:a)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of D.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r];const v=i[r];v&&(typeof a=="object"&&typeof v=="object"?(a=C.$en(a),this.h(a,v)):a=v),t[r]=a}return new g(t,this.keys,this.overrides)}h(n,i){for(const t of Object.keys(i)){if(t in n&&S.$Ef(n[t])&&S.$Ef(i[t])){this.h(n[t],i[t]);continue}n[t]=C.$en(i[t])}}i(n){let i=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=C.$en(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?i=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,R.$Ai)(this.contents,n),k.$Fn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>D.$tb(t.identifiers,(0,k.$Gn)(n))),1))}j(n,i,t){(0,R.$zi)(this.contents,n,i,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),k.$Fn.test(n)&&this.overrides.push({identifiers:(0,k.$Gn)(n),keys:Object.keys(this.contents[n]),contents:(0,R.$yi)(this.contents[n],r=>console.error(r))})}}e.$Ln=g;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!S.$Lf(n)){const t=this.g(n);this.parseRaw(t,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:t,keys:r,overrides:a,restricted:v,hasExcludedProperties:m}=this.h(n,i);this.b=new g(t,r,a,m?[n]:void 0),this.c=v||[]}g(n){let i={},t=null,r=[];const a=[],v=[];function m(y){Array.isArray(r)?r.push(y):t!==null&&(r[t]=y)}const f={onObjectBegin:()=>{const y={};m(y),a.push(r),r=y,t=null},onObjectProperty:y=>{t=y},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const y=[];m(y),a.push(r),r=y,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:m,onError:(y,I,F)=>{v.push({error:y,offset:I,length:F})}};if(n)try{L.$bn(n,f),i=r[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return i}h(n,i){const t=$.$qn.as(k.$vn.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,i);n=r.raw;const a=(0,R.$yi)(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),v=Object.keys(n),m=this.j(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:a,keys:v,overrides:m,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,i,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const v={},m=[];for(const f in n)if(k.$Fn.test(f)&&t){const y=this.i(n[f],i,!1,r);v[f]=y.raw,a=a||y.hasExcludedProperties,m.push(...y.restricted)}else{const y=i[f],I=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&m.push(f),!r.exclude?.includes(f)&&(r.include?.includes(f)||(I===void 0||r.scopes===void 0||r.scopes.includes(I))&&!(r.skipRestricted&&y?.restricted))?v[f]=n[f]:a=!0}return{raw:v,restricted:m,hasExcludedProperties:a}}j(n,i){const t=[];for(const r of Object.keys(n))if(k.$Fn.test(r)){const a={};for(const v in n[r])a[v]=n[r][v];t.push({identifiers:(0,k.$Gn)(r),keys:Object.keys(a),contents:(0,R.$yi)(a,i)})}return t}}e.$Mn=p;class w extends j.$Rc{constructor(n,i,t,r){super(),this.c=n,this.f=i,this.g=r,this.b=this.B(new N.$Rd),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Nn=w;class l{constructor(n,i,t,r,a,v,m,f,y,I,F,T,M){this.a=n,this.b=i,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=v,this.g=m,this.h=f,this.i=y,this.j=I,this.k=F,this.l=T,this.m=M}get value(){return c(this.c)}n(n,i,t){const r=n.inspect(i,t);return{get value(){return c(r.value)},get override(){return c(r.override)},get merged(){return c(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(n,i,t,r,a=new g,v=new g,m=new O.$zc,f=new g,y=new O.$zc){this.c=n,this.d=i,this.f=t,this.g=r,this.h=a,this.i=v,this.j=m,this.l=f,this.m=y,this.a=null,this.b=new O.$zc,this.n=null}getValue(n,i,t){return this.p(n,i,t).getValue(n)}updateValue(n,i,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new g,this.m.set(t.resource,r))):r=this.l,i===void 0?r.removeValue(n):r.setValue(n,i),t.resource||(this.a=null)}inspect(n,i,t){const r=this.p(n,i,t),a=this.t(i.resource,t),v=i.resource?this.m.get(i.resource)||this.l:this.l,m=new Set;for(const f of r.overrides)for(const y of f.identifiers)r.getOverrideValue(n,y)!==void 0&&m.add(y);return new l(n,i,r.getValue(n),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,v)}keys(n){const i=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const t=[];if(!i){const{added:r,updated:a,removed:v}=E(this.c,n);i=[...r,...a,...v]}for(const r of i)for(const a of(0,k.$Gn)(r)){const v=this.c.getKeysForOverrideIdentifier(a),m=n.getKeysForOverrideIdentifier(a),f=[...m.filter(y=>v.indexOf(y)===-1),...v.filter(y=>m.indexOf(y)===-1),...v.filter(y=>!C.$in(this.c.override(a).getValue(y),n.override(a).getValue(y)))];t.push([a,f])}return this.updateDefaultConfiguration(n),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:t,removed:r}=E(this.d,n),a=[...i,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.applicationConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.localUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.remoteUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.workspaceConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(n,i){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:v,overrides:m}=E(t,i),f=[...r,...a,...v];return(f.length||!t)&&this.updateFolderConfiguration(n,i),{keys:f,overrides:m}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:v}=E(i,void 0);return{keys:[...t,...r,...a],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,i,t){let r=this.q(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}q({resource:n},i){let t=this.r();if(i&&n){const r=i.getFolder(n);r&&(t=this.s(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let i=this.b.get(n);if(!i){const t=this.r(),r=this.j.get(n);r?(i=t.merge(r),this.b.set(n,i)):i=t}return i}t(n,i){if(i&&n){const t=i.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:t,overrides:r,keys:a}=this.j.get(i);return n.push([i,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(t=>n.add(t))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}v(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r))),[...i.values()]}static parse(n){const i=this.w(n.defaults),t=this.w(n.policy),r=this.w(n.application),a=this.w(n.user),v=this.w(n.workspace),m=n.folders.reduce((f,y)=>(f.set(b.URI.revive(y[0]),this.w(y[1])),f),new O.$zc);return new u(i,t,r,a,new g,v,m,new g,new O.$zc)}static w(n){return new g(n.contents,n.keys,n.overrides)}}e.$On=u;function h(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,i=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,v])=>{const m=(0,O.$wc)(i,a,new Set);v.forEach(f=>m.add(f))});const t=[];return i.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$Pn=h;class d{constructor(n,i,t,r){this.change=n,this.f=i,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const v of a)this.affectedKeys.add(v);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(n,i){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const v=this.d.charCodeAt(a);if(v!==this.b&&v!==this.c)return!1;if(i){const m=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,f=this.g.getValue(n,i,this.h);return!C.$in(m,f)}return!0}}e.$Qn=d;function E(o,n){const{added:i,removed:t,updated:r}=s(n?.rawConfiguration,o?.rawConfiguration),a=[],v=o?.getAllOverrideIdentifiers()||[],m=n?.getAllOverrideIdentifiers()||[];if(n){const f=m.filter(y=>!v.includes(y));for(const y of f)a.push([y,n.getKeysForOverrideIdentifier(y)])}if(o){const f=v.filter(y=>!m.includes(y));for(const y of f)a.push([y,o.getKeysForOverrideIdentifier(y)])}if(n&&o){for(const f of v)if(m.includes(f)){const y=s({contents:o.getOverrideValue(void 0,f)||{},keys:o.getKeysForOverrideIdentifier(f)},{contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)});a.push([f,[...y.added,...y.removed,...y.updated]])}}return{added:i,removed:t,updated:r,overrides:a}}function s(o,n){const i=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const v=(0,R.$Bi)(n.contents,a),m=(0,R.$Bi)(o.contents,a);C.$in(v,m)||r.push(a)}}return{added:i,removed:t,updated:r}}}),define(le[209],he([0,1,18,3,2,30,12,75,50,8,58,41]),function(ne,e,D,N,L,j,O,C,S,b,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=e.$Rn=void 0;class $ extends L.$Rc{constructor(){super(...arguments),this.a=this.B(new N.$Rd),this.onDidChangeConfiguration=this.a.event,this.b=new C.$Ln}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(k.$qn.as(S.$vn.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:l})=>this.c(Array.from(w),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,l){this.h(w,k.$qn.as(S.$vn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new C.$Ln;const w=k.$qn.as(S.$vn.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,l){const u=this.f();for(const h of w){const d=u[h],E=l[h];d!==void 0?this.b.addValue(h,d):E?this.b.addValue(h,E.default):this.b.removeValue(h)}}}e.$Rn=$;class c{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new C.$Ln}async initialize(){return this.configurationModel}}e.$Sn=c;let g=class extends L.$Rc{get configurationModel(){return this.b}constructor(w,l,u){super(),this.c=w,this.f=l,this.g=u,this.a=this.B(new N.$Rd),this.onDidChangeConfiguration=this.a.event,this.b=new C.$Ln}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const l={},u=[],h=k.$qn.as(S.$vn.Configuration).getConfigurationProperties();for(const d of w){const E=h[d];if(!E){u.push(d);continue}if(E.policy){if(E.type!=="string"&&E.type!=="number"){this.g.warn(`Policy ${E.policy.name} has unsupported type ${E.type}`);continue}u.push(d),l[E.policy.name]={type:E.type}}}return(0,O.$Pf)(l)||await this.f.updatePolicyDefinitions(l),u}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const l=k.$qn.as(S.$vn.Configuration).getPolicyConfigurations(),u=(0,D.$Gb)(w.map(h=>l.get(h)));this.m(u,!0)}m(w,l){this.g.trace("PolicyConfiguration#update",w);const u=k.$qn.as(S.$vn.Configuration).getConfigurationProperties(),h=[],d=this.b.isEmpty();for(const E of w){const s=u[E]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(d?o!==void 0:!(0,j.$in)(this.b.getValue(E),o))&&h.push([E,o])}else this.b.getValue(E)!==void 0&&h.push([E,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const E=this.b;this.b=new C.$Ln;for(const s of E.keys)this.b.setValue(s,E.getValue(s));for(const[s,o]of h)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);l&&this.a.fire(this.b)}}};e.$Tn=g,e.$Tn=g=ye([Q(1,R.$sn),Q(2,b.$hj)],g)}),define(le[210],he([0,1,6,3,2,19,20,75,209,58]),function(ne,e,D,N,L,j,O,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=void 0;class R extends L.$Rc{constructor($,c,g,p){super(),this.j=$,this.h=this.B(new N.$Rd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$Rn),this.c=g instanceof b.$un?new S.$Sn:this.B(new S.$Tn(this.b,g,p)),this.f=this.B(new C.$Nn(this.j,{},j.$sg,c)),this.a=new C.$On(this.b.configurationModel,this.c.configurationModel,new C.$Ln,new C.$Ln),this.g=this.B(new D.$_g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:l})=>this.n(w,l))),this.B(this.c.onDidChangeConfiguration(w=>this.r(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,c,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new C.$On($,c,new C.$Ln,g)}getConfigurationData(){return this.a.toData()}getValue($,c){const g=typeof $=="string"?$:void 0,p=(0,O.$ui)($)?$:(0,O.$ui)(c)?c:{};return this.a.getValue(g,p,void 0)}updateValue($,c,g,p){return Promise.reject(new Error("not supported"))}inspect($){return this.a.inspect($,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.m($)}m($){const c=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration($);this.s(g,c,2)}n($,c){const g=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration($,c);this.s(p,g,7)}r($){const c=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration($);this.s(g,c,7)}s($,c,g){const p=new C.$Qn($,{data:c},this.a);p.source=g,p.sourceConfig=this.t(g),this.h.fire(p)}t($){switch($){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Un=R}),define(le[211],he([0,1,15,3,2,67]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kqb=e.$Jqb=e.$Iqb=e.$Hqb=void 0;const O=(b,R,k)=>{const $=new Uint8Array(16);for(let p=0;p<16;p++)$[p]=Math.round(Math.random()*256);const c=(0,D.$ze)(D.$fe.wrap($));return[`GET ws://localhost${b}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${c}`].join(`\r
`)+`\r
\r
`};e.$Hqb=O,e.$Iqb=D.$fe.fromString(`\r
\r
`);async function C(b,R,k,$,c){b.write(D.$fe.fromString((0,e.$Hqb)(R,k,$)));const g=new L.$Qc;try{return await new Promise((p,w)=>{let l;g.add(b.onData(u=>{l?l=D.$fe.concat([l,u],l.byteLength+u.byteLength):l=u;const h=l.indexOf(e.$Iqb);if(h===-1)return;p(b),b.pauseData();const d=l.slice(h+e.$Iqb.byteLength);d.byteLength&&c.onData.fire(d)})),g.add(b.onClose(u=>w(u??new Error("socket closed")))),g.add(b.onEnd(()=>w(new Error("socket ended"))))})}catch(p){throw b.dispose(),p}finally{g.dispose()}}e.$Jqb=C;class S extends L.$Rc{constructor(R,k){super(),this.g=R,this.a=this.B(new N.$Ud),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new N.$Rd),this.onDidDispose=this.b.event,this.f=!1,this.B(k.onData),this.B(k.onData.event($=>this.a.fire($))),this.onClose=this.B(k.onClose).event,this.onEnd=this.B(k.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,k){j.SocketDiagnostics.traceSocketEvent(this,this.g,R,k)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Kqb=S}),define(le[212],he([0,1,7,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=e.RemoteAuthorityResolverErrorCode=e.$2k=e.$1k=e.RemoteConnectionType=e.$Zk=void 0,e.$Zk=(0,N.$Zh)("remoteAuthorityResolverService");var L;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class j{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$1k=j;class O{constructor(k,$){this.host=k,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$2k=O;var C;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(C||(e.RemoteAuthorityResolverErrorCode=C={}));class S extends D.$ab{static isNotAvailable(k){return k instanceof S&&k._code===C.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof S&&k._code===C.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof S&&k._code===C.NoResolverFound}static isInvalidAuthority(k){return k instanceof S&&k._code===C.InvalidAuthority}static isHandled(k){return k instanceof S&&k.isHandled}constructor(k,$=C.Unknown,c){super(k),this._message=k,this._code=$,this._detail=c,this.isHandled=$===C.NotAvailable&&c===!0,Object.setPrototypeOf(this,S.prototype)}}e.$3k=S;function b(R){const k=R.indexOf("+");return k===-1?R:R.substring(0,k)}e.$4k=b}),define(le[76],he([0,1,23]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=void 0;function N(b){return b.scheme===D.Schemas.vscodeRemote?b.authority:void 0}e.$5k=N;function L(b){if(!b)return;const R=b.indexOf("+");return R<0?b:b.substr(0,R)}e.$6k=L;function j(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$7k=j;function O(b){const{host:R,port:k}=S(b);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:k}}e.$8k=O;function C(b,R){let{host:k,port:$}=S(b);return typeof $>"u"&&($=R),{host:k,port:$}}e.$9k=C;function S(b){const R=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=b.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const $=b.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:b,port:void 0}}}),define(le[44],he([0,1,27,4,76]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.TargetPlatform=e.ExtensionType=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l="extensions.user.cache",e.$$l="extensions.builtin.cache",e.$_l="undefined_publisher",e.$am=["ui","workspace","web"];function j(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$bm=j,e.$cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(O||(e.ExtensionType=O={}));var C;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(C||(e.TargetPlatform=C={}));class S{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,l){if(typeof w>"u"||w===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof w=="string"||typeof l=="string"){const u=typeof w=="string"?w:w.value,h=typeof l=="string"?l:l.value;return D.$6e(u,h)}return w._lower===l._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$dm=S;class b{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const l of w)this.add(l)}add(w){this.c.add(S.toKey(w))}delete(w){return this.c.delete(S.toKey(w))}has(w){return this.c.has(S.toKey(w))}}e.$em=b;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(S.toKey(w))}get(w){return this.c.get(S.toKey(w))}has(w){return this.c.has(S.toKey(w))}set(w,l){this.c.set(S.toKey(w),l)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$fm=R;function k(p){return $(p)}e.$gm=k;function $(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$hm=$;function c(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$im=c;function g(p,w){if(w){const l=`onResolveRemoteAuthority:${(0,L.$6k)(w)}`;return!!p.activationEvents?.includes(l)}return!1}e.$jm=g,e.$km=(0,N.$Zh)("IBuiltinExtensionsScannerService")}),define(le[213],he([0,1,2,44,11]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;class j extends D.$Rc{constructor(C,S,b,R,k){super(),this.a=C,this.b=S,this.c=b,this.f=k,this.B(R.onDidInstallExtensions($=>this.g($))),this.B(R.onDidUninstallExtension($=>this.h($)))}g(C){for(const S of C)S.local&&this.invalidate(S.profileLocation)}h(C){C.error||this.invalidate(C.profileLocation)}async invalidate(C){if(C)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,C)&&await this.j(S);else await this.j(this.a.defaultProfile)}async j(C){try{await this.b.del(this.c.extUri.joinPath(C.cacheHome,N.$0l))}catch(S){(0,L.$zk)(S)!==1&&this.f.error(S)}}}e.$Qp=j}),define(le[214],he([0,1,6,15,26,7,3,2,100,62,32,67,212,76]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.PersistentConnectionEventType=e.$dl=e.$cl=e.$bl=e.ConnectionType=void 0;const g=30*1e3;var p;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function w(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(z){const P=new L.$2d;return setTimeout(()=>P.cancel(),z),P.token}function u(z,P){if(z.isCancellationRequested||P.isCancellationRequested)return L.CancellationToken.Cancelled;const A=new L.$2d;return z.onCancellationRequested(()=>A.cancel()),P.onCancellationRequested(()=>A.cancel()),A.token}class h{get didTimeout(){return this.c==="timedout"}constructor(P){this.c="pending",this.d=new C.$Qc,this.promise=new Promise((A,G)=>{this.f=A,this.g=G}),P.isCancellationRequested?this.h():this.d.add(P.onCancellationRequested(()=>this.h()))}registerDisposable(P){this.c==="pending"?this.d.add(P):P.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const P=new Error("Time limit reached");return P.code="ETIMEDOUT",P.syscall="connect",P}resolve(P){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(P))}reject(P){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(P))}}function d(z,P){const A=new h(P);return A.registerDisposable(z.onControlMessage(G=>{const q=JSON.parse(G.toString()),ee=B(q);ee?A.reject(ee):A.resolve(q)})),A.promise}function E(z,P,A,G,q,ee,H,Z){const ie=new h(Z),ce=b.$Nd.create(!1);return z.info(`Creating a socket (${H})...`),S.mark(`code/willCreateSocket/${ee}`),P.connect(A,G,q,H).then(oe=>{ie.didTimeout?(S.mark(`code/didCreateSocketError/${ee}`),z.info(`Creating a socket (${H}) finished after ${ce.elapsed()} ms, but this is too late and has timed out already.`),oe?.dispose()):(S.mark(`code/didCreateSocketOK/${ee}`),z.info(`Creating a socket (${H}) was successful after ${ce.elapsed()} ms.`),ie.resolve(oe))},oe=>{S.mark(`code/didCreateSocketError/${ee}`),z.info(`Creating a socket (${H}) returned an error after ${ce.elapsed()} ms.`),z.error(oe),ie.reject(oe)}),ie.promise}function s(z,P){const A=new h(P);return z.then(G=>{A.didTimeout||A.resolve(G)},G=>{A.didTimeout||A.reject(G)}),A.promise}async function o(z,P,A,G){const q=re(z,P);z.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let ee;try{ee=await E(z.logService,z.remoteSocketFactoryService,z.connectTo,(0,c.$7k)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,w(P),`renderer-${w(P)}-${z.reconnectionToken}`,G)}catch(oe){throw z.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),z.logService.error(oe),oe}z.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let H,Z;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(ee,null),H=z.reconnectionProtocol,Z=!1):(H=new k.$Nh({socket:ee}),Z=!0),z.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const ie=await s(z.signService.createNewMessage((0,R.$kg)()),G),ce={type:"auth",auth:z.connectionToken||"00000000000000000000",data:ie.data};H.sendControl(N.$fe.fromString(JSON.stringify(ce)));try{const oe=await d(H,u(G,l(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(z.logService.trace(`${q} 4/6. received SignRequest control message.`),!await s(z.signService.validate(ie,oe.signedData),G)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const de=await s(z.signService.sign(oe.data),G),we={type:"connectionType",commit:z.commit,signedData:de,desiredConnectionType:P};return A&&(we.args=A),z.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(N.$fe.fromString(JSON.stringify(we))),{protocol:H,ownsProtocol:Z}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(z.logService.error(`${q} the handshake timed out. Error:`),z.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${q} received error control message when negotiating connection. Error:`),z.logService.error(oe)),Z&&V(H),oe}}async function n(z,P,A,G){const q=Date.now(),ee=re(z,P),{protocol:H,ownsProtocol:Z}=await o(z,P,A,G),ie=new h(G);return ie.registerDisposable(H.onControlMessage(ce=>{const oe=JSON.parse(ce.toString()),fe=B(oe);fe?(z.logService.error(`${ee} received error control message when negotiating connection. Error:`),z.logService.error(fe),Z&&V(H),ie.reject(fe)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${K(q)}!`),ie.resolve({protocol:H,firstMessage:oe}))})),ie.promise}async function i(z,P){const{protocol:A}=await n(z,1,void 0,P);return{protocol:A}}async function t(z,P,A){const{protocol:G,firstMessage:q}=await n(z,2,P,A),ee=q&&q.debugPort;return{protocol:G,debugPort:ee}}async function r(z,P,A){const G=Date.now(),q=re(z,3),{protocol:ee}=await o(z,3,P,A);return z.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${K(G)}!`),ee}async function a(z,P,A){const{connectTo:G,connectionToken:q}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,connectTo:G,connectionToken:q,reconnectionToken:P,reconnectionProtocol:A,remoteSocketFactoryService:z.remoteSocketFactoryService,signService:z.signService,logService:z.logService}}async function v(z,P,A){return f(z,async G=>{const{protocol:q}=await i(G,L.CancellationToken.None);return new W(z,P,A,G.reconnectionToken,q)})}e.$bl=v;async function m(z,P){return f(z,async A=>{const{protocol:G,debugPort:q}=await t(A,P,L.CancellationToken.None);return new X(z,P,A.reconnectionToken,G,q)})}e.$cl=m;async function f(z,P){for(let G=1;;G++)try{const q=(0,R.$kg)(),ee=await a(z,q,null);return await P(ee)}catch(q){if(G<5)z.logService.error(`[remote-connection][attempt ${G}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(q);else throw z.logService.error(`[remote-connection][attempt ${G}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(q),x.triggerPermanentFailure(0,0,$.$3k.isHandled(q)),q}}async function y(z,P,A){const G=await a(z,(0,R.$kg)(),null);return await r(G,{host:P,port:A},L.CancellationToken.None)}e.$dl=y;function I(z){return(0,D.$Ng)(P=>new Promise((A,G)=>{const q=setTimeout(A,z*1e3);P.onCancellationRequested(()=>{clearTimeout(q),A()})}))}var F;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class T{constructor(P,A){this.reconnectionToken=P,this.millisSinceLastIncomingData=A,this.type=0}}e.$el=T;class M{constructor(P,A,G,q){this.reconnectionToken=P,this.millisSinceLastIncomingData=A,this.durationSeconds=G,this.c=q,this.type=1}skipWait(){this.c.cancel()}}e.$fl=M;class U{constructor(P,A,G){this.reconnectionToken=P,this.millisSinceLastIncomingData=A,this.attempt=G,this.type=2}}e.$gl=U;class Y{constructor(P,A,G){this.reconnectionToken=P,this.millisSinceLastIncomingData=A,this.attempt=G,this.type=4}}e.$hl=Y;class J{constructor(P,A,G,q){this.reconnectionToken=P,this.millisSinceLastIncomingData=A,this.attempt=G,this.handled=q,this.type=3}}e.$il=J;class x extends C.$Rc{static triggerPermanentFailure(P,A,G){this._permanentFailure=!0,this.f=P,this.g=A,this.h=G,this.j.forEach(q=>q.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(P=>P.y())}static debugPauseSocketWriting(){this.j.forEach(P=>P.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(P,A,G,q,ee){super(),this.t=P,this.u=A,this.reconnectionToken=G,this.protocol=q,this.w=ee,this.m=this.B(new O.$Rd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(q.onSocketClose(H=>{const Z=_(this.t,this.reconnectionToken,!0);H?H.type===0?(this.u.logService.info(`${Z} received socket close event (hadError: ${H.hadError}).`),H.error&&this.u.logService.error(H.error)):(this.u.logService.info(`${Z} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this.u.logService.error(H.event)):this.u.logService.info(`${Z} received socket close event.`),this.y()})),this.B(q.onSocketTimeout(H=>{const Z=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Z} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,C.$Pc)(()=>{const H=x.j.indexOf(this);H>=0&&x.j.splice(H,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const P=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${P} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const A=[0,5,5,10,10,10,10,10,30];let G=-1;do{G++;const q=G<A.length?A[G]:A[A.length-1];try{if(q>0){const H=I(q);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,H)),this.u.logService.info(`${P} waiting for ${q} seconds before reconnecting...`);try{await H}catch{}}if(this.n){this.u.logService.error(`${P} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this.u.logService.info(`${P} resolving connection...`);const ee=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${P} connecting to ${ee.connectTo}...`),await this.G(ee,l(g)),this.u.logService.info(`${P} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${P} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(G>360){this.u.logService.error(`${P} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if($.$3k.isTemporarilyNotAvailable(ee)){this.u.logService.info(`${P} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this.u.logService.info(`${P} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if((0,j.$3)(ee)){this.u.logService.info(`${P} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if(ee instanceof $.$3k){this.u.logService.error(`${P} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),G+1,$.$3k.isHandled(ee));break}this.u.logService.error(`${P} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!this.n&&!this.s)}C(P,A,G){this.w?x.triggerPermanentFailure(P,A,G):this.D(P,A,G)}D(P,A,G){this.m.fire(new J(this.reconnectionToken,P,A,G)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$jl=x;class W extends x{constructor(P,A,G,q,ee){super(1,P,q,ee,!0),this.client=this.B(new k.$Lh(ee,{remoteAuthority:A,clientId:G},P.ipcLogger))}async G(P,A){await i(P,A)}}e.$kl=W;class X extends x{constructor(P,A,G,q,ee){super(2,P,G,q,!1),this.H=A,this.debugPort=ee}async G(P,A){await t(P,this.H,A)}}e.$ll=X;function V(z){try{z.acceptDisconnect();const P=z.getSocket();z.dispose(),P.dispose()}catch(P){(0,j.$Z)(P)}}function B(z){if(z&&z.type==="error"){const P=new Error(`Connection error: ${z.reason}`);return P.code="VSCODE_CONNECTION_ERROR",P}return null}function te(z,P){for(;z.length<P;)z+=" ";return z}function se(z,P){return`[remote-connection][${te(w(z),13)}][${P.substr(0,5)}\u2026]`}function _(z,P,A){return`${se(z,P)}[${A?"reconnect":"initial"}]`}function re(z,P){return`${_(P,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.connectTo}]`}function K(z){return`${Date.now()-z} ms`}}),define(le[104],he([0,1,2,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=void 0,e.$0k=(0,N.$Zh)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(O,C){return this.a[O]??=[],this.a[O].push(C),(0,D.$Pc)(()=>{const S=this.a[O]?.indexOf(C);typeof S=="number"&&S>=0&&this.a[O]?.splice(S,1)})}b(O){return(this.a[O.type]||[]).find(S=>S.supports(O))}connect(O,C,S,b){const R=this.b(O);if(!R)throw new Error(`No socket factory found for ${O}`);return R.connect(O,C,S,b)}}e.$$k=L}),define(le[215],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c$b=e.$b$b=void 0,e.$b$b=(0,D.$Zh)("sharedProcessTunnelService"),e.$c$b="sharedProcessTunnel"}),define(le[105],he([0,1,4,163]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m$b=e.$l$b=e.$k$b=e.$j$b=e.$i$b=e.TunnelStates=e.$h$b=e.$g$b=void 0,e.$g$b=(0,D.$Zh)("IRemoteTunnelService"),e.$h$b={active:!1};var L;(function(j){j.disconnected=O=>({type:"disconnected",onTokenFailed:O}),j.connected=(O,C)=>({type:"connected",info:O,serviceInstallFailed:C}),j.connecting=O=>({type:"connecting",progress:O}),j.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$i$b="remote.tunnels.access",e.$j$b=e.$i$b+".hostNameOverride",e.$k$b=e.$i$b+".preventSleep",e.$l$b="remoteTunnelService",e.$m$b=(0,N.localize)(0,null)}),define(le[59],he([0,1,15,7,2,165,50,4,8,41]),function(ne,e,D,N,L,j,O,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0,e.$3o=(0,C.$Zh)("requestService");class R{constructor(E){this.b=E}toJSON(){if(!this.a){const E=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?E[s]="*****":E[s]=this.b[s];this.a=E}return this.a}}class k extends L.$Rc{constructor(E){super(),this.b=0,this.a=E.createLogger("network",{name:(0,j.localize)(0,null),when:S.$yj.isEqualTo((0,S.$wj)(S.LogLevel.Trace)).serialize()})}async c(E,s,o){const n=`${E} #${++this.b}: ${s.url}`;this.a.trace(`${n} - begin`,s.type,new R(s.headers??{}));try{const i=await o();return this.a.trace(`${n} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,s.type,(0,N.$9)(i)),i}}}e.$4o=k;function $(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.$5o=$;function c(d){return d.res.statusCode===204}e.$6o=c;async function g(d){return c(d)?null:(await(0,D.$re)(d.stream)).toString()}e.$7o=g;async function p(d){if(!$(d))throw new Error("Server returned "+d.res.statusCode);return g(d)}e.$8o=p;async function w(d){if(!$(d))throw new Error("Server returned "+d.res.statusCode);if(c(d))return null;const s=(await(0,D.$re)(d.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$9o=w;function l(d){h(d)}e.$0o=l;let u;function h(d){const E=b.$qn.as(O.$vn.Configuration),s=u;u={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},E.updateConfigurations({add:[u],remove:s?[s]:[]})}h(1)}),define(le[216],he([0,1,26,23,11,59]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eO=void 0;let O=class{constructor(S,b){this.a=S,this.b=b}async download(S,b,R=D.CancellationToken.None){if(S.scheme===N.Schemas.file||S.scheme===N.Schemas.vscodeRemote){await this.b.copy(S,b);return}const k={type:"GET",url:S.toString(!0)},$=await this.a.request(k,R);if($.res.statusCode===200)await this.b.writeFile(b,$.stream);else{const c=await(0,j.$8o)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${c}`)}}};e.$eO=O,e.$eO=O=ye([Q(0,j.$3o),Q(1,L.$ik)],O)}),define(le[217],he([0,1,15,26]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=void 0;class L{constructor(C){this.a=C}listen(C,S){throw new Error("Invalid listen")}call(C,S,b,R=N.CancellationToken.None){switch(S){case"request":return this.a.request(b[0],R).then(async({res:k,stream:$})=>{const c=await(0,D.$re)($);return[{statusCode:k.statusCode,headers:k.headers},c]});case"resolveProxy":return this.a.resolveProxy(b[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$6q=L;class j{constructor(C){this.a=C}async request(C,S){const[b,R]=await this.a.call("request",[C],S);return{res:b,stream:(0,D.$te)(R)}}async resolveProxy(C){return this.a.call("resolveProxy",[C])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$7q=j}),define(le[218],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G9b=e.$F9b=e.$E9b=void 0,e.$E9b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$F9b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$G9b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[219],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x5b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const j=await this.c();if(j){const O=String(D.a++);return this.b.set(O,j),{id:O,data:j.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,j){if(!L.id)return!0;const O=this.b.get(L.id);if(!O)return!1;this.b.delete(L.id);try{return O.validate(j)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$x5b=D}),define(le[106],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=void 0,e.$_k="signService",e.$al=(0,D.$Zh)(e.$_k)}),define(le[220],he([0,1,219]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u0b=void 0;class N extends D.$x5b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(O=>new O.signer().sign(j))}h(){return new Promise((j,O)=>ne(["vsda"],j,O))}}e.$u0b=N}),define(le[77],he([0,1,3,2]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GEb=e.$FEb=e.$EEb=e.$DEb=void 0;class L extends N.$Rc{constructor(k,$,c){super(),this.a=k,this.b=$,this.c=c}async getItems(){const k={profile:this.b,workspace:this.c},$=await this.a.call("getItems",k);return new Map($)}updateItems(k){const $={profile:this.b,workspace:this.c};return k.insert&&($.insert=Array.from(k.insert.entries())),k.delete&&($.delete=Array.from(k.delete.values())),this.a.call("updateItems",$)}optimize(){const k={profile:this.b,workspace:this.c};return this.a.call("optimize",k)}}class j extends L{constructor(k,$){super(k,$,void 0),this.f=this.B(new D.$Rd),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(k=>this.h(k)))}h(k){(Array.isArray(k.changed)||Array.isArray(k.deleted))&&this.f.fire({changed:k.changed?new Map(k.changed):void 0,deleted:k.deleted?new Set(k.deleted):void 0})}}class O extends j{constructor(k){super(k,void 0)}async close(){this.dispose()}}e.$DEb=O;class C extends j{constructor(k,$){super(k,$)}async close(){this.dispose()}}e.$EEb=C;class S extends L{constructor(k,$){super(k,void 0,$),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.$FEb=S;class b{constructor(k){this.a=k}isUsed(k){const $={payload:k,profile:void 0,workspace:void 0};return this.a.call("isUsed",$)}}e.$GEb=b}),define(le[107],he([0,1,5,37,32]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=void 0;function j(S){if(D.$u===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function O(S,b,R,k,$,c,g,p,w){const l=Object.create(null);l["common.machineId"]=c,l["common.sqmId"]=g,l.sessionID=(0,L.$kg)()+Date.now(),l.commitHash=k,l.version=$,l["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,D.$h)(D.$u),l["common.nodePlatform"]=N.$cc,l["common.nodeArch"]=R,l["common.product"]=w||"desktop",p&&(l["common.msftInternal"]=p);let u=0;const h=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),D.$l&&(l["common.snap"]="true");const d=j(b);return d&&(l["common.platformDetail"]=d),l}e.$ro=O;function C(S){const b=N.env.USERDNSDOMAIN;if(!b)return!1;const R=b.toLowerCase();return S.some(k=>R===k)}e.$so=C}),define(le[22],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=void 0,e.$ml=(0,D.$Zh)("telemetryService"),e.$nl=(0,D.$Zh)("customEndpointTelemetryService"),e.$ol="telemetry.currentSessionDate",e.$pl="telemetry.firstSessionDate",e.$ql="telemetry.lastSessionDate",e.$rl="telemetry.machineId",e.$sl="telemetry.sqmId",e.$tl="telemetry",e.$ul="telemetry.telemetryLevel",e.$vl="telemetry.enableCrashReporter",e.$wl="telemetry.enableTelemetry";var N;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(le[221],he([0,1,36,6,35,23,16,5,10,142,31,145,95,11,25,22]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=e.$Pr=e.$Or=e.$Nr=void 0;const w=new Map;async function l(s,o){const n=`${s}::${o.join(":")}`,i=w.get(n);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,v=2e4;function m(y,I,F,T){const M=I.substring(y.length+1);return N.Promises.withAsyncBody(async U=>{let Y;try{Y=await R.Promises.readdir(I,{withFileTypes:!0})}catch{U();return}if(T.count>=v){T.count+=Y.length,T.maxReached=!0,U();return}let J=Y.length;if(J===0){U();return}let x=Y;T.count+Y.length>v&&(T.maxReached=!0,J=v-T.count,x=Y.slice(0,J)),T.count+=Y.length;for(const W of x)if(W.isDirectory()){if(F.includes(W.name)||await m(y,(0,O.$ic)(I,W.name),F,T),--J===0){U();return}}else{const X=W.name.lastIndexOf(".");if(X>=0){const V=W.name.substring(X+1);V&&r.set(V,(r.get(V)??0)+1)}for(const V of t)V.relativePathPattern?.test(M)!==!1&&V.filePattern.test(W.name)&&a.set(V.tag,(a.get(V.tag)??0)+1);if(--J===0){U();return}}})}const f=N.Promises.withAsyncBody(async y=>{const I={count:0,maxReached:!1};await m(s,s,o,I);const F=await d(s);y({configFiles:u(a),fileTypes:u(r),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:F})});return w.set(n,f),f}e.$Nr=l;function u(s){return Array.from(s.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function h(){const s={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/c.$Qk.GB).toFixed(2)}GB (${(D.freemem()/c.$Qk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.$2m.value()*100)}%`},o=D.cpus();return o&&o.length>0&&(s.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),s}e.$Or=h;async function d(s){try{const o=new Map,n=(0,O.$ic)(s,".vscode","launch.json"),i=await R.Promises.readFile(n),t=[],r=(0,L.$7m)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,L.$dn)(r)==="object"&&r.configurations)for(const a of r.configurations){const v=a.type;v&&(o.has(v)?o.set(v,o.get(v)+1):o.set(v,1))}return u(o)}catch{return[]}}e.$Pr=d;let E=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const i=D.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/c.$Qk.GB).toFixed(2)}GB (${(D.freemem()/c.$Qk.GB).toFixed(2)}GB free)`),C.$i||n.push(`Load (avg):       ${D.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(b.$2m.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,k.$Mr)(o.mainPID),this.k(o)]).then(async i=>{let[t,r]=i,a=this.m(o,t);return n.forEach(v=>{if((0,$.$Bm)(v))a+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(a+=`

Remote: ${v.hostName}`,v.processes&&(a+=`
${this.m(o,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const m of Object.keys(v.workspaceMetadata)){const f=v.workspaceMetadata[m];let y=`${f.fileCount} files`;f.maxFilesReached&&(y=`more than ${y}`),r+=`|    Folder (${m}): ${y}`,r+=this.h(f)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:i,vmHint:t,os:r,cpus:a}=h(),v={os:r,memory:i,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return C.$i||(v.load=`${D.loadavg().map(m=>Math.round(m)).join(", ")}`),C.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(o,n){const i=[];return(0,k.$Mr)(o.mainPID).then(async t=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),n.forEach(r=>{if((0,$.$Bm)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.f(r.machineInfo)),r.processes&&i.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[a];let m=`${v.fileCount} files`;v.maxFilesReached&&(m=`more than ${m}`),i.push(`Folder (${a}): ${m}`),i.push(this.h(v))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const n=[];let t=0;const r=(f,y)=>{const I=` ${f}(${y})`;t+I.length>60?(n.push(a),a="|                 ",t=a.length):t+=I.length,a+=I};let a="|      File types:";const v=10,m=o.fileTypes.length>v?v:o.fileTypes.length;for(let f=0;f<m;f++){const y=o.fileTypes[f];r(y.name,y.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(f=>{r(f.name,f.count)}),n.push(a)),o.launchConfigFiles.length>0){let f="|      Launch Configs:";o.launchConfigFiles.forEach(y=>{const I=y.count>1?` ${y.name}(${y.count})`:` ${y.name}`;f+=I}),n.push(f)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const n=[],i=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=S.URI.revive(r);if(a.scheme===j.Schemas.file){const v=a.fsPath;i.push(l(v,["node_modules",".git"]).then(m=>{let f=`${m.fileCount} files`;m.maxFilesReached&&(f=`more than ${f}`),n.push(`|    Folder (${(0,O.$mc)(v)}): ${f}`),n.push(this.h(m))}).catch(m=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${m.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const i=new Map;o.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>i.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,i,t,n,0),t.join(`
`)}n(o,n,i,t,r){const a=r===0;let v;a?v=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const m=process.platform==="win32"?t.mem:D.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${(m/c.$Qk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(f=>this.n(o,n,i,f,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:i}of o.folders){const t=S.URI.revive(i);if(t.scheme!==j.Schemas.file)continue;const r=t.fsPath;try{(await l(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const i=S.URI.revive(n);if(i.scheme!==j.Schemas.file)continue;const t=i.fsPath;try{const r=await l(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$Qr=E,e.$Qr=E=ye([Q(0,p.$ml),Q(1,g.$zj)],E)}),define(le[108],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K9b=e.$J9b=void 0;class D{constructor(j){this.b=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,{eventName:C,data:S}){return this.b.forEach(b=>b.log(C,S)),Promise.resolve(null)}}e.$J9b=D;class N{constructor(j){this.b=j}log(j,O){return this.b.call("log",{eventName:j,data:O}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$K9b=N}),define(le[45],he([0,1,30,12,3,20,76,107,22]),function(ne,e,D,N,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=void 0;class b{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$to=b;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$uo=R,e.$vo=new R;class k{async publicLog(t,r,a){}async publicLogError(t,r,a){}}e.$wo=k,e.$xo="telemetry",e.$yo="extensionTelemetryLog",e.$zo={log:()=>null,flush:()=>Promise.resolve(null)};function $(i,t){return L.Event.debounce(t.onDidChangeConfiguration,(a,v)=>{const m=a?new Set([...a.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:m}},1e3,!0)(a=>{a.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,j.$wi)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.$Ao=$;function c(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.$Bo=c;function g(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Co=g;function p(i){const t=i.getValue(S.$ul),r=i.getValue(S.$vl);if(i.getValue(S.$wl)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Do=p;function w(i){const t={},r={},a={};h(i,a);for(let v in a){v=v.length>150?v.substr(v.length-149):v;const m=a[v];typeof m=="number"?r[v]=m:typeof m=="boolean"?r[v]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${m.length}`),t[v]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(t[v]=m)}return{properties:t,measurements:r}}e.$Eo=w;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const t=(0,O.$6k)(i);return l.has(t)?t:"other"}e.$Fo=u;function h(i,t,r=0,a){if(i)for(const v of Object.getOwnPropertyNames(i)){const m=i[v],f=a?a+v:v;Array.isArray(m)?t[f]=(0,D.$jn)(m):m instanceof Date?t[f]=m.toISOString():(0,N.$Ef)(m)?r<2?h(m,t,r+1,f+"."):t[f]=(0,D.$jn)(m):t[f]=m}}function d(i,t){const r=i.msftInternalDomains||[],a=t.getValue("telemetry.internalTesting");return(0,C.$so)(r)||a}e.$Go=d;function E(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Ho=E;function s(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const a=[];for(const y of t)for(;;){const I=y.exec(i);if(!I)break;a.push([I.index,y.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(r="";;){const y=m.exec(i);if(!y)break;const I=a.some(([F,T])=>y.index<T&&F<m.lastIndex);!v.test(y[0])&&!I&&(r+=i.substring(f,y.index)+"<REDACTED: user-file-path>",f=m.lastIndex)}return f<i.length&&(r+=i.substr(f)),r}function o(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function n(i,t){return(0,D.$gn)(i,r=>{if(r instanceof b||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=s(a,t);for(const v of t)a=a.replace(v,"");return a=o(a),a}})}e.$Io=n}),define(le[33],he([0,1,27,29,44,5,10,7,37,45]),function(ne,e,D,N,L,j,O,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0;function R(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,D.$1e)(n.id,i.id)===0}e.$Jo=R;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new $(i.identifier,t,r)}static parse(i){const t=k.exec(i);return t&&t[1]&&t[2]?new $({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof $?R(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Ko=$;const c=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(n){const i=c.exec(n);return i&&i[1]?[w(i[1]),i[2]]:[w(n),void 0]}e.$Lo=g;function p(n,i){return`${n}.${i}`}e.$Mo=p;function w(n){return n.toLowerCase()}e.$No=w;function l(n,i){return w(p(n??L.$_l,i))}e.$Oo=l;function u(n,i){const t=[],r=a=>{for(const v of t)if(v.some(m=>R(i(m),i(a))))return v;return null};for(const a of n){const v=r(a);v?v.push(a):t.push([a])}return t}e.$Po=u;function h(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$Qo=h;function d(n){return{id:new b.$to(n.identifier.id),name:new b.$to(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Ro=d,e.$So=new L.$dm("pprice.better-merge");function E(n,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(v=>!R(v.identifier,{id:a}))){const v=n.filter(m=>R(m.identifier,{id:a}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$To=E;async function s(n,i){if(!j.$k)return!1;let t;try{t=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,C.$9)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,i){const t=await s(n,i),r=(0,N.$do)(t?"alpine":j.$u,S.$dc);return i.debug("ComputeTargetPlatform:",r),r}e.$Uo=o}),define(le[222],he([0,1,18,2,19,10,11,25,6,3,16,5,37,33]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=e.$E7b=void 0;let g=class extends N.$Rc{constructor(h,d){super(),this.b=h,this.c=d,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,E])=>this.a.set(E.configPath,E))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const d=[];for(const[E,s]of this.a)if(!(s.configScheme&&s.configScheme!==h.scheme))try{const o=(await this.b.readFile((0,L.$Bg)(h,E))).value.toString();for(const[n,i]of Object.entries(s.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(o))&&d.push({extensionId:n,extensionName:i.name,configName:s.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return d}};e.$E7b=g,e.$E7b=g=ye([Q(0,O.$ik),Q(1,C.$zj)],g);const p="extensionTips/promptedExecutableTips",w="extensionTips/lastPromptedMediumImpExeTime";class l extends g{constructor(h,d,E,s,o,n,i,t){super(i,t),this.r=h,this.s=d,this.t=E,this.u=s,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const v=[],m=[],f=[];Object.entries(a.recommendations).forEach(([y,I])=>{I.important?a.important?v.push({extensionId:y,extensionName:I.name,isExtensionPack:!!I.isExtensionPack}):m.push({extensionId:y,extensionName:I.name,isExtensionPack:!!I.isExtensionPack}):f.push({extensionId:y,extensionName:I.name,isExtensionPack:!!I.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),m.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:m}),f.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:f})}),(0,S.$2g)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),d=await this.O(this.h);return[...h,...d]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),d=await this.O(this.h),E=await this.u.getInstalled();this.m=this.D(h,E),this.n=this.D(d,E)}D(h,d){const E=new Map;h.forEach(t=>E.set(t.extensionId.toLowerCase(),t));const{installed:s,uninstalled:o}=this.N([...E.keys()],d);for(const t of s){const r=E.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=E.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),i=new Map;for(const t of o){const r=E.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=i.get(r.exeName);a||(a=[],i.set(r.exeName,a)),a.push(r)}}return i}F(){if(this.m.size===0)return;const[h,d]=[...this.m.entries()][0];this.H(d).then(E=>{switch(E){case"reacted":this.M(d[0].exeName,d);break;case"ignored":this.m.delete(h);break;case"incompatibleWindow":{const s=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.F()));break}case"toomany":{const s=this.B(new N.$Sc);s.value=(0,S.$2g)(()=>{s.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),d=Date.now()-h,E=7*24*60*60*1e3;if(d<E){const n=this.B(new N.$Sc);n.value=(0,S.$2g)(()=>{n.dispose(),this.G()},E-d);return}const[s,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(s),this.M(o[0].exeName,o);const i=this.B(new N.$Sc);i.value=(0,S.$2g)(()=>{i.dispose(),this.G()},E);break}case"ignored":this.n.delete(s),this.G();break;case"incompatibleWindow":{const i=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.G()));break}case"toomany":{const i=this.B(new N.$Sc);i.value=(0,S.$2g)(()=>{i.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const d=await this.u.getInstalled(1),E=h.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(o=>d.every(n=>!(0,c.$Jo)(n.identifier,{id:o})))).map(({extensionId:s})=>s.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:E,source:3,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber(w,-1);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store(w,h,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(h,d){const E=this.L();E[h]=d.map(({extensionId:s})=>s.toLowerCase()),this.w.store(p,JSON.stringify(E),-1,0)}N(h,d){const E=[],s=[],o=d.reduce((n,i)=>(n.add(i.identifier.id.toLowerCase()),n),new Set);return h.forEach(n=>{o.has(n.toLowerCase())?E.push(n):s.push(n)}),{installed:E,uninstalled:s}}async O(h){const d=[],E=new Map;for(const s of h.keys()){const o=h.get(s);if(!o||!(0,D.$Kb)(o.recommendations))continue;const n=[];k.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>$.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>$.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>$.env.ProgramFiles).replace("%APPDATA%",()=>$.env.APPDATA).replace("%WINDIR%",()=>$.env.WINDIR)):(n.push((0,R.$ic)("/usr/local/bin",s)),n.push((0,R.$ic)("/usr/bin",s)),n.push((0,R.$ic)(this.r.fsPath,s)));for(const i of n){let t=E.get(i);if(t===void 0&&(t=await this.b.exists(j.URI.file(i)),E.set(i,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:v,whenNotInstalled:m}of o.recommendations)d.push({extensionId:r,extensionName:a,isExtensionPack:v,exeName:s,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:m})}}return d}}e.$F7b=l}),define(le[223],he([0,1,26,33]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3Xb=void 0;async function L(j,O,C,S,b){try{const R=await j.getExtensionsControlManifest();if(!R.deprecated)return;const k=await j.getInstalled(1);for(const[$,c]of Object.entries(R.deprecated)){if(!c?.extension)continue;const{id:g,autoMigrate:p,preRelease:w}=c.extension;if(!p)continue;const l=k.find(h=>(0,N.$Jo)(h.identifier,{id:$}));if(!l)continue;const u=(await O.getExtensions([{id:g,preRelease:w}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!u){b.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{b.info(`Migrating '${l.identifier.id}' extension to '${g}' extension...`);const h=!S.getDisabledExtensions().some(E=>(0,N.$Jo)(E,l.identifier));await j.uninstall(l),b.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let d=k.find(E=>(0,N.$Jo)(E.identifier,{id:g}));(!d||!d.isPreReleaseVersion&&h)&&(d=await j.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),b.info(`Installed the pre-release extension '${d.identifier.id}'`),h||(await S.disableExtension(d.identifier),b.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),p.storage&&(C.addToMigrationList((0,N.$Mo)(l.manifest.publisher,l.manifest.name),(0,N.$Mo)(d.manifest.publisher,d.manifest.name)),b.info("Added pre-release extension to the storage migration list"))),b.info(`Migrated '${l.identifier.id}' extension to '${g}' extension.`)}catch(h){b.error(h)}}}catch(R){b.error(R)}}e.$3Xb=L}),define(le[224],he([0,1,6,7,2,23,19,55,12,32,31,69,20,14,29,33,97,11,8]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;let d=class extends L.$Rc{static{h=this}static{this.c=".sigzip"}constructor(s,o,n,i,t,r){super(),this.h=o,this.j=n,this.m=i,this.n=t,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,n){await this.g;const i=(0,O.$Bg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new g.$io(r.message,g.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(s)){const r=await this.u(s);try{t=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===u.LogLevel.Trace)}catch(a){const v=a;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${v.output}`),t===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new g.$io(k.$up,g.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${s.identifier.id}`),{location:i,verificationStatus:t}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,S.$If)(o)?o:!0}async u(s){await this.g;const o=(0,O.$Bg)(this.extensionsDownloadDir,`${this.z(s)}${h.c}`);return await this.w(s,o,n=>this.j.downloadSignatureArchive(s,n)),o}async w(s,o,n){if(await this.h.exists(o))return;if(o.scheme!==j.Schemas.file){await n(o);return}const i=(0,O.$Bg)(this.extensionsDownloadDir,`.${(0,b.$kg)()}`);await this.h.exists(i)||await n(i);try{await R.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(i)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,N.$9)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],n=[],i=[];for(const a of s.children)if(a.name.endsWith(h.c))i.push(a.resource);else{const v=p.$Ko.parse(a.name);v&&n.push([v,a])}const t=(0,p.$Po)(n,([a])=>a),r=[];for(const a of t)a.sort((v,m)=>C.rcompare(v[0].version,m[0].version)),o.push(...a.slice(1).map(v=>v[1].resource)),r.push(a[0][1]);r.sort((a,v)=>a.mtime-v.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...i),await D.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(s){this.r.error(s)}}z(s){return this.f?p.$Ko.create(s).toString().toLowerCase():(0,b.$kg)()}};e.$Np=d,e.$Np=d=h=ye([Q(0,c.$8h),Q(1,l.$ik),Q(2,g.$ho),Q(3,$.$ti),Q(4,w.$op),Q(5,u.$hj)],d)}),define(le[225],he([0,1,3,2,34,33,44]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;class C extends N.$Rc{constructor(b,R,k,$,c,g,p){super(),this.f=b,this.g=R,this.h=k,this.j=$,this.m=c,this.n=g,this.r=p,this.a=this.B(new D.$Rd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$1c),this.s().then(null,w=>p.error(w))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(b=>this.u(b.added))),this.B(this.j.onAddExtensions(b=>this.w(b))),this.B(this.j.onDidAddExtensions(b=>this.y(b))),this.B(this.j.onRemoveExtensions(b=>this.z(b))),this.B(this.j.onDidRemoveExtensions(b=>this.C(b))),this.B(this.n.onDidFilesChange(b=>this.D(b)))}async u(b){try{b.length&&await Promise.all(b.map(R=>(this.c.set(R.id,(0,N.$Oc)(this.n.watch(this.m.extUri.dirname(R.extensionsResource)),this.n.watch(R.extensionsResource))),this.G(R.extensionsResource))))}catch(R){throw this.r.error(R),R}}async w(b){for(const R of b.extensions)this.I(this.L(R.identifier,R.version),b.profileLocation)}async y(b){for(const R of b.extensions){const k=this.L(R.identifier,R.version);b.error?this.J(k,b.profileLocation):this.I(k,b.profileLocation)}}async z(b){for(const R of b.extensions)this.J(this.L(R.identifier,R.version),b.profileLocation)}async C(b){const R=[],k=[];for(const $ of b.extensions){const c=this.L($.identifier,$.version);b.error?this.I(c,b.profileLocation):(this.J(c,b.profileLocation),this.b.has(c)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),k.push(this.f.scanInstalledExtensionAtLocation($.location).then(g=>{g?R.push(g):this.r.info("Extension not found at the location",$.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(k),R.length&&await this.H(R)}catch($){this.r.error($)}}D(b){for(const R of this.h.profiles)b.contains(R.extensionsResource,0,1)&&this.F(R.extensionsResource)}async F(b){const R=[],k=[],$=await this.j.scanProfileExtensions(b),c=new Set,g=new Set;for(const[p,w]of this.b)w.has(b)&&g.add(p);for(const p of $){const w=this.L(p.identifier,p.version);c.add(w),g.has(w)||(R.push(p.identifier),this.I(w,b))}for(const p of g)if(!c.has(p)){const w=this.M(p);w&&(k.push(w.identifier),this.J(p,b))}(R.length||k.length)&&this.a.fire({added:R.length?{extensions:R,profileLocation:b}:void 0,removed:k.length?{extensions:k,profileLocation:b}:void 0})}async G(b){const R=await this.j.scanProfileExtensions(b);for(const k of R)this.I(this.L(k.identifier,k.version),b)}async H(b){b||(b=(await this.f.scanAllUserInstalledExtensions()).filter(k=>!this.b.has(this.L(k.identifier,k.manifest.version)))),b.length&&await this.f.markAsUninstalled(...b)}I(b,R){let k=this.b.get(b);k||this.b.set(b,k=new L.$Ac($=>this.m.extUri.getComparisonKey($))),k.add(R)}J(b,R){const k=this.b.get(b);k&&k.delete(R),k?.size||this.b.delete(b)}L(b,R){return`${O.$dm.toKey(b.id)}@${R}`}M(b){const[R,k]=(0,j.$Lo)(b);return k?{identifier:{id:R},version:k}:void 0}}e.$Rp=C}),define(le[226],he([0,1,43,45]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;async function L(j,O,C,S,b,R,k){const $={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${O.nameShort})`};if((0,N.$Bo)(O,C)&&(0,N.$Do)(S)===3){const c=await(0,D.$jp)(C,b,R);$["X-Market-User-Id"]=c,$["VSCode-SessionId"]=k.machineId||c}return $}e.$kp=L}),define(le[227],he([0,1,72,18,6,2,23,16,31,14,29,33,8,74,10]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;let p=class extends c.$4q{constructor(h,d,E,s){super(E),this.h=h,this.j=s,this.g=this.B(new w(d,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(h,d){const s=(await this.g.getLanguagePacks())[d];if(!s){this.j.warn(`No language pack found for ${d}`);return}const o=s.translations[h];return o?g.URI.file(o):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),d=Object.keys(h).map(E=>{const s=h[E];return{...this.f(E,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return d.push(this.f("en","English")),d.sort((E,s)=>E.label.localeCompare(s.label)),d}async m(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",h.identifier.id),await this.update())}async n(h){const d=await this.g.getLanguagePacks();Object.keys(d).some(E=>d[E]&&d[E].extensions.some(s=>(0,k.$Jo)(s.extensionIdentifier,h.identifier)))&&(this.j.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,d]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),E=await this.g.update(d);return!(0,N.$tb)(Object.keys(h),Object.keys(E))}};e.$5q=p,e.$5q=p=ye([Q(0,R.$jo),Q(1,b.$8h),Q(2,R.$ho),Q(3,$.$hj)],p);let w=class extends j.$Rc{constructor(h,d){super(),this.j=d,this.c={},this.f=(0,C.$ic)(h.userDataPath,"languagepacks.json"),this.g=new L.$7g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.s(d=>{Object.keys(d).forEach(E=>delete d[E]),this.m(d,...h)}).then(()=>this.c)}m(h,...d){for(const E of d)E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&this.n(h,E);Object.keys(h).forEach(E=>this.r(h[E]))}n(h,d){const E=d.identifier,s=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const o of s)if(d.location.scheme===O.Schemas.file&&l(o)){let n=h[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},h[o.languageId]=n);const i=n.extensions.filter(t=>(0,k.$Jo)(t.extensionIdentifier,E))[0];i?i.version=d.manifest.version:n.extensions.push({extensionIdentifier:E,version:d.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,C.$ic)(d.location.fsPath,t.path)}}r(h){if(h){const d=(0,D.createHash)("md5");for(const E of h.extensions)d.update(E.extensionIdentifier.uuid||E.extensionIdentifier.id).update(E.version);h.hash=d.digest("hex")}}s(h=()=>null){return this.g.queue(()=>{let d=null;return S.Promises.readFile(this.f,"utf8").then(void 0,E=>E.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(E)).then(E=>{try{return JSON.parse(E)}catch{return{}}}).then(E=>(d=h(E),E)).then(E=>{for(const o of Object.keys(E))E[o]||delete E[o];this.c=E,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),S.Promises.writeFile(this.f,s)}).then(()=>d,E=>this.j.error(E))})}};w=ye([Q(0,b.$8h),Q(1,$.$hj)],w);function l(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const h of u.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(le[228],he([0,1,141,7,30,45]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ON=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",C="https://mobile.events.data.microsoft.com/ping";async function S(R,k,$){const c=await(0,D.$SC)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,D.$SC)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new c.AppInsightsCore,w=new g.PostChannel,l={instrumentationKey:R,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if($){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:$};l.extensionConfig[w.identifier]=u}return p.initialize(l,[]),p.addTelemetryInitializer(u=>{k&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),p}class b{constructor(k,$,c,g,p){this.e=k,this.f=$,this.g=c,this.h=p,this.c=O,this.d=C,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(k){if(this.a){if(typeof this.a!="string"){k(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then($=>{k($)},$=>{(0,N.$Z)($),console.error($)})}}log(k,$){if(!this.a)return;$=(0,L.$hn)($,this.g),$=(0,j.$Eo)($);const c=this.f+"/"+k;try{this.i(g=>{g.pluginVersionString=$?.properties.version??"Unknown",g.track({name:c,baseData:{name:c,properties:$?.properties,measurements:$?.measurements}})})}catch{}}flush(){return this.a?new Promise(k=>{this.i($=>{$.unload(!0,()=>{this.a=void 0,k(void 0)})})}):Promise.resolve(void 0)}}e.$ON=b}),define(le[109],he([0,1,2,166,14,8,25,45]),function(ne,e,D,N,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=void 0;let S=class extends D.$Rc{constructor(R,k,$,c,g=""){super(),this.b=g;const p=k.getLogger(C.$xo);if(p)this.a=this.B(p);else{const l=(0,C.$Co)(c,$)?" (Not Sent)":"",u=()=>(0,C.$Bo)(c,$)&&R.getLevel()===j.LogLevel.Trace;this.a=this.B(k.createLogger(C.$xo,{name:(0,N.localize)(0,null,l),hidden:!u()})),this.B(R.onDidChangeLogLevel(()=>k.setVisibility(C.$xo,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(R,k){this.a.trace(`${this.b}telemetry/${R}`,(0,C.$Eo)(k))}};e.$56b=S,e.$56b=S=ye([Q(0,j.$hj),Q(1,j.$ij),Q(2,L.$7h),Q(3,O.$zj)],S)}),define(le[110],he([0,1,2,30,5,27,167,20,50,102,25,41,22,45]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,u,h){this.k=u,this.l=h,this.d={},this.i=new D.$Qc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,j.$Je)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Je)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration($.$ul)||d.affectsConfiguration($.$wl)||d.affectsConfiguration($.$vl))&&this.m()}))}setExperimentProperty(l,u){this.d[l]=u}m(){let l=(0,c.$Do)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const h=u.usage?3:u.error?2:0;l=Math.min(l,h)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,u,h){this.g<u||(h=(0,N.$hn)(h,this.d),h=(0,c.$Io)(h,this.j),h=(0,N.$hn)(h,this.c),this.b.forEach(d=>d.log(l,h)))}publicLog(l,u){this.n(l,3,u)}publicLog2(l,u){this.publicLog(l,u)}publicLogError(l,u){this.h&&this.n(l,2,u)}publicLogError2(l,u){this.publicLogError(l,u)}};e.$$q=g,e.$$q=g=ye([Q(1,C.$ti),Q(2,R.$zj)],g);function p(){const w=(0,O.localize)(0,null,b.default.nameLong),l=b.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=L.$o?"":(0,O.localize)(3,null),h=(0,O.localize)(4,null),d=(0,O.localize)(5,null),E=(0,O.localize)(6,null),s=(0,O.localize)(7,null),o=`
|       | ${h} | ${d} | ${E} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${w} ${l} ${u}

&nbsp;

${s}
${o}

&nbsp;

${n}
`}k.$qn.as(S.$vn.Configuration).registerConfiguration({id:$.$tl,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[$.$ul]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.$qn.as(S.$vn.Configuration).registerConfiguration({id:$.$tl,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[$.$wl]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,O.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,O.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${$.$ul}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[229],he([0,1,15,26,271,228]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=void 0;async function O(R,k){const $=await k.request(R,N.CancellationToken.None),c=(await(0,D.$re)($.stream)).toString(),g=$.res.statusCode??200;return{headers:$.res.headers,statusCode:g,responseData:c}}async function C(R){const k={method:R.type,headers:R.headers};return new Promise((c,g)=>{const p=L.request(R.url??"",k,w=>{w.on("data",function(l){c({headers:w.headers,statusCode:w.statusCode??200,responseData:l.toString()})}),w.on("error",function(l){g(l)})});p.write(R.data,w=>{w&&g(w)}),p.end()})}async function S(R,k,$){const c=typeof k.data=="string"?k.data:new TextDecoder().decode(k.data),g={type:"POST",headers:{...k.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(k.data).toString()},url:k.urlString,data:c};try{const p=R?await O(g,R):await C(g);$(p.statusCode,p.headers,p.responseData)}catch{$(0,{})}}class b extends j.$ON{constructor(k,$,c,g,p){const w={sendPOST:(l,u)=>{S(k,l,u)}};super($,c,g,p,w)}}e.$PN=b}),define(le[230],he([0,1,23,93,20,14,8,25,22,108,109,110]),function(ne,e,D,N,L,j,O,C,S,b,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$30b=void 0;let $=class{constructor(g,p,w,l,u,h){this.b=g,this.c=p,this.d=w,this.e=l,this.f=u,this.g=h,this.a=new Map}h(g){if(!this.a.has(g.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const w=[g.id,JSON.stringify(p),g.aiKey],u=new N.$aq(D.$ig.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),h=[new b.$K9b(u),new R.$56b(this.d,this.e,this.f,this.g,`[${g.id}] `)];this.a.set(g.id,new k.$$q({appenders:h,sendErrorTelemetry:g.sendErrorTelemetry},this.b,this.g))}return this.a.get(g.id)}publicLog(g,p,w){this.h(g).publicLog(p,w)}publicLogError(g,p,w){this.h(g).publicLogError(p,w)}};e.$30b=$,e.$30b=$=ye([Q(0,L.$ti),Q(1,S.$ml),Q(2,O.$hj),Q(3,O.$ij),Q(4,j.$7h),Q(5,C.$zj)],$)}),define(le[78],he([0,1,3,20,4,8]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.ProvidedOnAutoForward=e.$jv=e.TunnelPrivacyId=e.TunnelProtocol=e.$iv=e.$hv=void 0,e.$hv=(0,L.$Zh)("tunnelService"),e.$iv=(0,L.$Zh)("sharedTunnelsService");var O;(function(w){w.Http="http",w.Https="https"})(O||(e.TunnelProtocol=O={}));var C;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(C||(e.TunnelPrivacyId=C={}));function S(w){return!!w.forwardPort}e.$jv=S;var b;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function R(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(l)return{address:l[1],port:+l[2]}}e.$kv=R,e.$lv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(w){return e.$lv.indexOf(w)>=0}e.$mv=k,e.$nv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(w){return e.$nv.indexOf(w)>=0}e.$ov=$;function c(w,l,u,h){if(u===1)return!1;if(u===2&&$(l)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(d?.length===4&&parseInt(d[1])>=18)return!1}return w<1024}e.$pv=c;class g{constructor(l,u,h){this.remoteAddress=l,this.localAddress=u,this.b=h,this.a=new D.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$qv=g;let p=class{constructor(l,u){this.j=l,this.k=u,this.a=new D.$Rd,this.onTunnelOpened=this.a.event,this.b=new D.$Rd,this.onTunnelClosed=this.b.event,this.c=new D.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const l=this.k.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.h=l.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const l=[],u=Array.from(this.e.values());for(const h of u){const d=Array.from(h.values());for(const E of d){const s=await E.value;s&&typeof s!="string"&&l.push(s)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:u}of l.values())await u.then(h=>typeof h!="string"?h?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,u,h,d,E){this.p(l,u,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:u,localAddress:h,privacy:d,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,u){($(l)||k(l))&&(l=e.$lv[0]);const h=this.r(l,u);if(h)return++h.refcount,h.value}openTunnel(l,u,h,d,E,s=!1,o,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${h} on local port ${E}.`);const i=this.f??l;if(!i)return;if(u||(u="localhost"),d||(d=this.l),this.f&&this.i.has(h)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(i,u,h,d,E,s,o,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(u,h),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(u,h);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.n(r);return(r.tunnelRemoteHost!==u||r.tunnelRemotePort!==h)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const u=this.e.get(l.tunnelRemoteHost);if(u){const h=u.get(l.tunnelRemotePort);h&&(h.refcount--,await this.o(l.tunnelRemoteHost,l.tunnelRemotePort,h))}}}}async o(l,u,h){if(h.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${u}.`);const d=h.value.then(async E=>{E&&typeof E!="string"&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(u),d}}async closeTunnel(l,u){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${u} `);const h=this.e.get(l);if(h&&h.has(u)){const d=h.get(u);d.refcount=0,await this.o(l,u,d)}}p(l,u,h){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(u,{refcount:1,value:h})}async q(l,u){const h=this.e.get(l);if(h){const d=h.get(u),E=d?await d.value:void 0;(!E||typeof E=="string")&&h.delete(u),h.size===0&&this.e.delete(l)}}r(l,u){const h=[l];k(l)?(h.push(...e.$lv),h.push(...e.$nv)):$(l)&&h.push(...e.$nv);const d=h.map(E=>this.e.get(E));for(const E of d){const s=E?.get(u);if(s)return s}}canTunnel(l){return!!R(l)}t(l,u,h,d,E,s,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${h} on local port ${d}.`);const n=h;this.i.add(n);const i=d===void 0?h:d,t={elevationRequired:E?this.isPortPrivileged(i):!1},r={remoteAddress:{host:u,port:h},localAddressPort:d,privacy:s,public:s?s!==C.Private:void 0,protocol:o},a=l.forwardPort(r,t);return a?(this.p(u,h,a),a.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),a}};e.$rv=p,e.$rv=p=ye([Q(0,j.$hj),Q(1,N.$ti)],p)}),define(le[231],he([0,1,8,78,2,7,6]),function(ne,e,D,N,L,j,O){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$d$b=void 0;class S extends L.$Rc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$kh),this.b.p)}setAddress(k){this.a=k,this.b&&(this.b.complete(k),this.b=null)}setTunnel(k){this.B(k)}}let b=class extends L.$Rc{static{C=this}static{this.a=0}constructor(k,$){super(),this.f=k,this.g=$,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(k=>k.dispose())}async createTunnel(){return{id:String(++C.a)}}async startTunnel(k,$,c,g,p,w,l){const u=new S,h=await Promise.resolve(this.f.openTunnel(k,u,c,g,p,w,l));if(!h||typeof h=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${c}:${g} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has($))throw this.c.delete($),u.dispose(),await h.dispose(),(0,j.$5)();return u.setTunnel(h),this.b.set($,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${$}: ${h.localAddress} (local) to ${c}:${g} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(k,$){const c=this.b.get(k);c&&c.setAddress($)}async destroyTunnel(k){const $=this.b.get(k);if($){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${k}.`),this.b.delete(k),await $.dispose();return}this.c.add(k)}};e.$d$b=b,e.$d$b=b=C=ye([Q(0,N.$iv),Q(1,D.$hj)],b)}),define(le[28],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=void 0,e.$Sk=(0,D.$Zh)("IUriIdentityService")}),define(le[232],he([0,1,28,185,11,19,127,3,2]),function(ne,e,D,N,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=void 0;class b{static{this._clock=0}constructor($){this.uri=$,this.time=b._clock++}touch(){return this.time=b._clock++,this}}let R=class{constructor($){this.g=$,this.c=new S.$Qc,this.f=2**16;const c=new Map,g=p=>{let w=c.get(p.scheme);return w===void 0&&(w=$.hasProvider(p)&&!this.g.hasCapability(p,1024),c.set(p.scheme,w)),w};this.c.add(C.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(p=>{c.delete(p.scheme)})),this.extUri=new j.$qg(g),this.d=new O.$Ir((p,w)=>this.extUri.compare(p,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,j.$Cg)($));const c=this.d.get($);return c?c.touch().uri.with({fragment:$.fragment}):(this.d.set($,new b($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((g,p)=>g[1].time<p[1].time?1:g[1].time>p[1].time?-1:0);b._clock=0,this.d.clear();const c=this.f*.5;for(let g=0;g<c;g++)this.d.set($[g][0],$[g][1].touch())}};e.$Jr=R,e.$Jr=R=ye([Q(0,L.$ik)],R),(0,N.$Gr)(D.$Sk,R,1)}),define(le[233],he([0,1,3,2,11,47,34]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x0b=void 0;class C extends N.$Rc{constructor(b,R,k,$,c,g){super(),this.f=b,this.g=R,this.h=k,this.j=$,this.m=c,this.n=g,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$Rd),this.onDidChangeFile=this.a.event,this.b=j.$6h.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Ac(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B($.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const b of this.j.profiles)this.c.add(b.settingsResource),this.c.add(b.keybindingsResource),this.c.add(b.tasksResource),this.c.add(b.extensionsResource)}open(b,R){return this.g.open(this.t(b),R)}close(b){return this.g.close(b)}read(b,R,k,$,c){return this.g.read(b,R,k,$,c)}write(b,R,k,$,c){return this.g.write(b,R,k,$,c)}watch(b,R){this.b.set(b,b);const k=this.g.watch(this.t(b),R);return(0,N.$Pc)(()=>{this.b.delete(b),k.dispose()})}stat(b){return this.g.stat(this.t(b))}mkdir(b){return this.g.mkdir(this.t(b))}rename(b,R,k){return this.g.rename(this.t(b),this.t(R),k)}readFile(b,R){return this.g.readFile(this.t(b),R)}readFileStream(b,R,k){return this.g.readFileStream(this.t(b),R,k)}readdir(b){return this.g.readdir(this.t(b))}enforceAtomicReadFile(b){return this.c.has(b)}writeFile(b,R,k){return this.g.writeFile(this.t(b),R,k)}enforceAtomicWriteFile(b){return this.c.has(b)?{postfix:".vsctmp"}:!1}delete(b,R){return this.g.delete(this.t(b),R)}copy(b,R,k){if((0,L.$mk)(this.g))return this.g.copy(this.t(b),this.t(R),k);throw new Error("copy not supported")}cloneFile(b,R){if((0,L.$nk)(this.g))return this.g.cloneFile(this.t(b),this.t(R));throw new Error("clone not supported")}s(b){const R=[];for(const k of b){if(k.resource.scheme!==this.f)continue;const $=this.u(k.resource);this.b.findSubstr($)&&R.push({resource:$,type:k.type,cId:k.cId})}R.length&&(this.n.debug("User data changed"),this.a.fire(R))}t(b){return b.with({scheme:this.f})}u(b){return b.with({scheme:this.h})}}e.$x0b=C}),define(le[79],he([0,1,86]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kEb=e.$jEb=e.edit=void 0;function N(O,C,S,b){const R=(0,D.$IT)(O,C,S,b)[0];return R&&(O=O.substring(0,R.offset)+R.content+O.substring(R.offset+R.length)),O}e.edit=N;function L(O,C,S){let b=S;for(;b>=0;){if(O.charAt(b)===C.charAt(C.length-1)&&C.length===1)return b+1;if(b--,C.length===2&&b>=0&&O.charAt(b)===C.charAt(0))return b+2}return 0}e.$jEb=L;function j(O,C,S){let b=S;for(;b>=0;)if(O.charAt(b)===C.charAt(C.length-1)&&C.length===1||(b++,C.length===2&&b>=0&&O.charAt(b)===C.charAt(1)))return b;return O.length-1}e.$kEb=j}),define(le[234],he([0,1,30,55,12]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K5b=void 0;function j(c,g,p,w,l,u){const h=[],d=[],E=[];if(!g){const U=c.filter(({identifier:Y})=>l.every(J=>J.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:h,removed:d,updated:E},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}c=c.map(k),g=g.map(k),p=p?p.map(k):null;const s=new Map,o=U=>{U.uuid&&s.set(U.id.toLowerCase(),U.uuid)};c.forEach(({identifier:U})=>o(U)),g.forEach(({identifier:U})=>o(U)),p?.forEach(({identifier:U})=>o(U)),w?.forEach(({identifier:U})=>o(U)),u?.forEach(U=>o(U));const n=U=>{const Y=U.identifier.uuid||s.get(U.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${U.identifier.id.toLowerCase()}`},i=(U,Y)=>(U.set(n(Y),Y),U),t=c.reduce(i,new Map),r=g.reduce(i,new Map),a=g.reduce((U,Y)=>i(U,(0,D.$en)(Y)),new Map),v=p?p.reduce(i,new Map):null,m=w.reduce(i,new Map),f=l.reduce((U,Y)=>{const J=s.get(Y.toLowerCase());return U.add(J?`uuid:${J}`:`id:${Y.toLowerCase()}`)},new Set),y=u?u.reduce((U,{id:Y,uuid:J})=>(J=J??s.get(Y.toLowerCase()),U.add(J?`uuid:${J}`:`id:${Y.toLowerCase()}`)),new Set):null,I=O(t,r,f,!1);if(I.added.size>0||I.removed.size>0||I.updated.size>0){const U=O(v,t,f,!1),Y=O(v,r,f,!0),J=(x,W,X,V)=>{let B,te,se;return W.installed?(B=V.pinned,se=V.preRelease,B&&(te=V.version)):(B=X.pinned,se=X.preRelease,B&&(te=X.version)),B===void 0&&(B=W.pinned,B&&(te=W.version)),se===void 0&&(se=W.preRelease),{...V,installed:W.installed||X.installed,pinned:B,preRelease:se,version:te??(X.version&&(!W.installed||N.gt(X.version,W.version))?X.version:W.version),state:S(W,X,v?.get(x))}};for(const x of Y.removed.values()){const W=t.get(x);if(!W)continue;const X=(0,L.$Nf)(v?.get(x)),V=y&&!y.has(x)&&X.installed;W.installed&&V?d.push(W.identifier):a.set(x,W)}for(const x of Y.added.values()){const W=(0,L.$Nf)(r.get(x)),X=t.get(x);if(X){if(I.updated.has(x)){const V=J(x,X,W,W);C(X,W,!1,!1)||E.push($(V,x)),a.set(x,V)}}else W.installed&&h.push($(W,x))}for(const x of Y.updated.values()){const W=(0,L.$Nf)(r.get(x)),X=(0,L.$Nf)(v?.get(x)),V=t.get(x);if(V)if(y&&!y.has(x)&&X.installed&&V.installed&&!W.installed)d.push(V.identifier);else{const te=J(x,V,W,W);E.push($(te,x)),a.set(x,te)}else W.installed&&h.push($(W,x))}for(const x of U.added.values())Y.added.has(x)||a.set(x,(0,L.$Nf)(t.get(x)));for(const x of U.updated.values()){if(Y.removed.has(x)||Y.updated.has(x))continue;const W=(0,L.$Nf)(t.get(x)),X=(0,L.$Nf)(r.get(x));a.set(x,J(x,W,X,W))}for(const x of U.removed.values())Y.updated.has(x)||Y.removed.has(x)||m.has(x)||(0,L.$Nf)(r.get(x)).installed&&y&&(y.has(x)||!(0,L.$Nf)(v?.get(x)).installed||a.delete(x))}const F=[],T=O(r,a,new Set,!0),M=T.added.size>0||T.updated.size>0||T.removed.size>0;return M&&a.forEach((U,Y)=>F.push($(U,Y))),{local:{added:h,removed:d,updated:E},remote:M?{added:[...T.added].map(U=>a.get(U)),updated:[...T.updated].map(U=>a.get(U)),removed:[...T.removed].map(U=>r.get(U)),all:F}:null}}e.$K5b=j;function O(c,g,p,w){const l=c?[...c.keys()].filter(s=>!p.has(s)):[],u=[...g.keys()].filter(s=>!p.has(s)),h=u.filter(s=>!l.includes(s)).reduce((s,o)=>(s.add(o),s),new Set),d=l.filter(s=>!u.includes(s)).reduce((s,o)=>(s.add(o),s),new Set),E=new Set;for(const s of l){if(d.has(s))continue;const o=c.get(s),n=g.get(s);(!n||!C(o,n,w,!0))&&E.add(s)}return{added:h,removed:d,updated:E}}function C(c,g,p,w){return!(c.disabled!==g.disabled||!!c.isApplicationScoped!=!!g.isApplicationScoped||w&&c.installed!==g.installed||c.installed&&g.installed&&(c.preRelease!==g.preRelease||c.pinned!==g.pinned||g.pinned&&c.version!==g.version)||!R(c.state,g.state)||p&&c.version!==g.version)}function S(c,g,p){const w=c.state,l=g.state,u=p?.state;if(!g.version||w&&N.gt(c.version,g.version))return w;if(l&&N.gt(g.version,c.version)||!w)return l;if(!l)return w;const h=(0,D.$en)(w),d=u?b(u,l):{added:Object.keys(l).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set},E=u?b(u,w):{added:Object.keys(w).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set};for(const s of[...d.added.values(),...d.updated.values()])h[s]=l[s];for(const s of d.removed.values())E.updated.has(s)||delete h[s];return h}function b(c,g){const p=Object.keys(c),w=Object.keys(g),l=w.filter(d=>!p.includes(d)).reduce((d,E)=>(d.add(E),d),new Set),u=p.filter(d=>!w.includes(d)).reduce((d,E)=>(d.add(E),d),new Set),h=new Set;for(const d of p){if(u.has(d))continue;const E=c[d],s=g[d];(0,D.$in)(E,s)||h.add(d)}return{added:l,removed:u,updated:h}}function R(c={},g={}){const{added:p,removed:w,updated:l}=b(c,g);return p.size===0&&w.size===0&&l.size===0}function k(c){return{...c,disabled:!!c.disabled,installed:!!c.installed}}function $(c,g){const p={...c,identifier:{id:c.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},preRelease:!!c.preRelease,pinned:!!c.pinned};return c.disabled||delete p.disabled,c.installed||delete p.installed,c.state||delete p.state,c.isApplicationScoped||delete p.isApplicationScoped,p}}),define(le[111],he([0,1,18,20,4]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hGb=e.$gGb=void 0,e.$gGb=(0,L.$Zh)("IIgnoredExtensionsManagementService");let j=class{constructor(C){this.a=C}hasToNeverSyncExtension(C){return this.b().includes(C.toLowerCase())}hasToAlwaysSyncExtension(C){return this.b().includes(`-${C.toLowerCase()}`)}updateIgnoredExtensions(C,S){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return b=b.filter(R=>R!==C&&R!==`-${C}`),S&&b.push(C.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}updateSynchronizedExtensions(C,S){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return b=b.filter(R=>R!==C&&R!==`-${C}`),S&&b.push(`-${C.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}getIgnoredExtensions(C){const S=C.filter($=>$.isMachineScoped).map($=>$.identifier.id.toLowerCase()),b=this.b().map($=>$.toLowerCase()),R=[],k=[];if(Array.isArray(b))for(const $ of b)$.startsWith("-")?k.push($.substring(1)):R.push($);return(0,D.$Lb)([...S,...R].filter($=>!k.includes($)))}b(){let C=this.a.inspect("settingsSync.ignoredExtensions").userValue;return C!==void 0||(C=this.a.inspect("sync.ignoredExtensions").userValue,C!==void 0)?C:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$hGb=j,e.$hGb=j=ye([Q(0,N.$ti)],j)}),define(le[235],he([0,1,18,35,30,94,79]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q5b=void 0;function C(d){return(0,N.$7m)(d)||[]}async function S(d,E,s,o,n){const i=C(d),t=C(E),r=s?C(s):null,a=[...i,...t,...r||[]].map(J=>J.key),v=await n.resolveUserBindings(a),m=R(i,t,r,v);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:E,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const f=$(i),y=$(t),I=r?$(r):null,F=g(f,y,v),T=I?g(I,f,v):{added:[...f.keys()].reduce((J,x)=>(J.add(x),J),new Set),removed:new Set,updated:new Set},M=I?g(I,y,v):{added:[...y.keys()].reduce((J,x)=>(J.add(x),J),new Set),removed:new Set,updated:new Set},U=b(F,T,M);let Y=d;for(const J of U.removed.values())U.conflicts.has(J)||(Y=u(Y,J,o));for(const J of U.added.values()){if(U.conflicts.has(J))continue;const x=y.get(J);if(x.some(W=>W.command!==`-${J}`&&m.conflicts.has(v[W.key]))){U.conflicts.add(J);continue}Y=l(Y,x,o)}for(const J of U.updated.values()){if(U.conflicts.has(J))continue;const x=y.get(J);if(x.some(W=>W.command!==`-${J}`&&m.conflicts.has(v[W.key]))){U.conflicts.add(J);continue}Y=h(Y,J,x,o)}return{mergeContent:Y,hasChanges:!0,hasConflicts:U.conflicts.size>0}}e.$Q5b=S;function b(d,E,s){const o=new Set,n=new Set,i=new Set,t=new Set;for(const r of E.removed.values())s.updated.has(r)&&t.add(r);for(const r of s.removed.values())t.has(r)||(E.updated.has(r)?t.add(r):n.add(r));for(const r of E.added.values())t.has(r)||s.added.has(r)&&d.updated.has(r)&&t.add(r);for(const r of s.added.values())t.has(r)||(E.added.has(r)?d.updated.has(r)&&t.add(r):o.add(r));for(const r of E.updated.values())t.has(r)||s.updated.has(r)&&d.updated.has(r)&&t.add(r);for(const r of s.updated.values())t.has(r)||(E.updated.has(r)?d.updated.has(r)&&t.add(r):i.add(r));return{added:o,removed:n,updated:i,conflicts:t}}function R(d,E,s,o){const n=new Set,i=k(d,o),t=k(E,o),r=s?k(s,o):null,a=c(i,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?c(r,i):{added:[...i.keys()].reduce((T,M)=>(T.add(M),T),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const m=r?c(r,t):{added:[...t.keys()].reduce((T,M)=>(T.add(M),T),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:f,removed:y,updated:I,conflicts:F}=b(a,v,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:y,updated:I,conflicts:F}}function k(d,E){const s=new Map;for(const o of d){const n=E[o.key];let i=s.get(n);i||(i=[],s.set(n,i)),i.push(o)}return s}function $(d){const E=new Map;for(const s of d){const o=s.command[0]==="-"?s.command.substring(1):s.command;let n=E.get(o);n||(n=[],E.set(o,n)),n.push(s)}return E}function c(d,E){const s=[...d.keys()],o=[...E.keys()],n=o.filter(r=>!s.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=s.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of s){if(i.has(r))continue;const a=d.get(r).map(m=>({...m,key:r})),v=E.get(r).map(m=>({...m,key:r}));(0,D.$tb)(a,v,(m,f)=>w(m,f))||t.add(r)}return{added:n,removed:i,updated:t}}function g(d,E,s){const o=[...d.keys()],n=[...E.keys()],i=n.filter(a=>!o.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const v=d.get(a).map(f=>({...f,key:s[f.key]})),m=E.get(a).map(f=>({...f,key:s[f.key]}));p(v,m)||r.add(a)}return{added:i,removed:t,updated:r}}function p(d,E){return!(!(0,D.$tb)(d.filter(({command:s})=>s[0]!=="-"),E.filter(({command:s})=>s[0]!=="-"),(s,o)=>w(s,o))||!(0,D.$tb)(d.filter(({command:s})=>s[0]==="-"),E.filter(({command:s})=>s[0]==="-"),(s,o)=>w(s,o)))}function w(d,E){if(d.command!==E.command||d.key!==E.key)return!1;const s=j.$Xi.deserialize(d.when),o=j.$Xi.deserialize(E.when);return!(s&&!o||!s&&o||s&&o&&!s.equals(o)||!L.$in(d.args,E.args))}function l(d,E,s){for(const o of E)d=O.edit(d,[-1],o,s);return d}function u(d,E,s){const o=C(d);for(let n=o.length-1;n>=0;n--)(o[n].command===E||o[n].command===`-${E}`)&&(d=O.edit(d,[n],void 0,s));return d}function h(d,E,s,o){const n=C(d),i=n.findIndex(t=>t.command===E||t.command===`-${E}`);for(let t=n.length-1;t>=0;t--)(n[t].command===E||n[t].command===`-${E}`)&&(d=O.edit(d,[t],void 0,o));for(let t=s.length-1;t>=0;t--)d=O.edit(d,[i],s[t],o);return d}}),define(le[236],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y5b=e.$X5b=void 0;function D(j,O,C){const S={},b={},R=new Set;if(!O)return{local:{added:S,updated:b,removed:[...R.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const k=N(j,O);if(k.added.size===0&&k.removed.size===0&&k.updated.size===0)return{local:{added:S,updated:b,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const $=N(C,j),c=N(C,O),g={},p={},w=new Set,l=new Set;for(const u of $.removed.values())c.updated.has(u)?S[u]=O[u]:w.add(u);for(const u of c.removed.values())l.has(u)||($.updated.has(u)?l.add(u):R.add(u));for(const u of $.updated.values())l.has(u)||(c.updated.has(u)?k.updated.has(u)&&l.add(u):p[u]=j[u]);for(const u of c.updated.values())l.has(u)||($.updated.has(u)?k.updated.has(u)&&l.add(u):j[u]!==void 0&&(b[u]=O[u]));for(const u of $.added.values())l.has(u)||(c.added.has(u)?k.updated.has(u)&&l.add(u):g[u]=j[u]);for(const u of c.added.values())l.has(u)||($.added.has(u)?k.updated.has(u)&&l.add(u):S[u]=O[u]);return{local:{added:S,removed:[...R.values()],updated:b},remote:{added:g,removed:[...w.values()],updated:p},conflicts:[...l.values()]}}e.$X5b=D;function N(j,O){const C=j?Object.keys(j):[],S=O?Object.keys(O):[],b=S.filter($=>!C.includes($)).reduce(($,c)=>($.add(c),$),new Set),R=C.filter($=>!S.includes($)).reduce(($,c)=>($.add(c),$),new Set),k=new Set;for(const $ of C){if(R.has($))continue;const c=j[$],g=O[$];c!==g&&k.add($)}return{added:b,removed:R,updated:k}}function L(j,O){const{added:C,removed:S,updated:b}=N(j,O);return C.size===0&&S.size===0&&b.size===0}e.$Y5b=L}),define(le[237],he([0,1,30]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I7b=void 0;function N(j,O,C,S){const b={added:[],removed:[],updated:[]};let R={added:[],removed:[],updated:[]};if(!O){const $=j.filter(({id:c})=>!S.includes(c));return $.length?R.added=$:R=null,{local:b,remote:R}}const k=L(j,O,S);if(k.added.length>0||k.removed.length>0||k.updated.length>0){const $=L(C,j,S),c=L(C,O,S);for(const g of c.removed){const p=j.find(w=>w.id===g);p&&b.removed.push(p)}for(const g of c.added){const p=O.find(w=>w.id===g);$.added.includes(g)?k.updated.includes(g)&&b.updated.push(p):b.added.push(p)}for(const g of c.updated)b.updated.push(O.find(p=>p.id===g));for(const g of $.added)c.added.includes(g)||R.added.push(j.find(p=>p.id===g));for(const g of $.updated)c.removed.includes(g)||c.updated.includes(g)||R.updated.push(j.find(p=>p.id===g));for(const g of $.removed){const p=O.find(w=>w.id===g);p&&R.removed.push(p)}}return R.added.length===0&&R.removed.length===0&&R.updated.length===0&&(R=null),{local:b,remote:R}}e.$I7b=N;function L(j,O,C){j=j?j.filter(({id:c})=>!C.includes(c)):[],O=O.filter(({id:c})=>!C.includes(c));const S=j.map(({id:c})=>c),b=O.map(({id:c})=>c),R=b.filter(c=>!S.includes(c)),k=S.filter(c=>!b.includes(c)),$=[];for(const{id:c,name:g,shortName:p,icon:w,useDefaultFlags:l}of j){if(k.includes(c))continue;const u=O.find(h=>h.id===c);(!u||u.name!==g||u.shortName!==p||u.icon!==w||!(0,D.$in)(u.useDefaultFlags,l))&&$.push(c)}return{added:R,removed:k,updated:$}}}),define(le[24],he([0,1,18,12,173,50,29,4,103,41]),function(ne,e,D,N,L,j,O,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhb=e.$Phb=e.$Ohb=e.$Nhb=e.$Mhb=e.$Lhb=e.$Khb=e.$Jhb=e.$Ihb=e.$Hhb=e.$Ghb=e.MergeState=e.Change=e.SyncStatus=e.$Fhb=e.$Ehb=e.$Dhb=e.UserDataSyncErrorCode=e.$Chb=e.$Bhb=e.$Ahb=e.$zhb=e.$yhb=e.$xhb=e.$whb=e.$vhb=e.$uhb=e.SyncResource=e.$thb=e.$shb=e.$rhb=e.$qhb=e.$phb=e.$ohb=void 0;function R(){const t=b.$qn.as(j.$vn.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$ohb=R;function k(){const t=b.$qn.as(j.$vn.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(m=>!!t[m].ignoreSync),a=Object.keys(t).filter(m=>t[m].scope===2||t[m].scope===6),v=R();return(0,D.$Lb)([...r,...a,...v])}e.$phb=k,e.$qhb="settingsSync",e.$rhb="settingsSync.keybindingsPerPlatform";function $(){const t="vscode://schemas/ignoredSettings",r=b.$qn.as(j.$vn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.$rhb]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:O.$8n,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=b.$qn.as(S.$rn.JSONContribution),v=()=>{const m=R(),f=k(),y=Object.keys(j.$wn.properties).filter(T=>!f.includes(T)),I=f.filter(T=>!m.includes(T)),F={items:{type:"string",enum:[...y,...I.map(T=>`-${T}`)]}};a.registerSchema(t,F)};return r.onDidUpdateConfiguration(()=>v())}e.$shb=$;function c(t){return t&&(0,N.$Ef)(t)&&(0,N.$Cf)(t.id)&&Array.isArray(t.scopes)}e.$thb=c;var g;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(g||(e.SyncResource=g={})),e.$uhb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(t,...r){return t?[t,...r]:r}e.$vhb=p;function w(t,r,a,v){return v.joinPath(a.userDataSyncHome,...p(t,r,`lastSync${r}.json`))}e.$whb=w,e.$xhb=(0,C.$Zh)("IUserDataSyncStoreManagementService"),e.$yhb=(0,C.$Zh)("IUserDataSyncStoreService"),e.$zhb=(0,C.$Zh)("IUserDataSyncLocalStoreService"),e.$Ahb="x-operation-id",e.$Bhb="X-Execution-Id";function l(t){const r={};return r[e.$Bhb]=t,r}e.$Chb=l;var u;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class h extends Error{constructor(r,a,v,m){super(r),this.code=a,this.resource=v,this.operationId=m,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Dhb=h;class d extends h{constructor(r,a,v,m,f){super(r,v,void 0,f),this.url=a,this.serverCode=m}}e.$Ehb=d;class E extends h{constructor(r,a){super(r,a)}}e.$Fhb=E,function(t){function r(a){if(a instanceof t)return a;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(v&&v[1]){const m=v[2]==="unknown"?void 0:v[2],f=v[3]==="unknown"?void 0:v[3];return new t(a.message,v[1],m,f)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(h||(e.$Dhb=h={}));var s;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$Ghb="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.$Hhb=i,e.$Ihb=(0,C.$Zh)("IUserDataSyncEnablementService"),e.$Jhb=(0,C.$Zh)("IUserDataSyncService"),e.$Khb=(0,C.$Zh)("IUserDataSyncResourceProviderService"),e.$Lhb=(0,C.$Zh)("IUserDataAutoSyncService"),e.$Mhb=(0,C.$Zh)("IUserDataSyncUtilService"),e.$Nhb=(0,C.$Zh)("IUserDataSyncLogService"),e.$Ohb="userDataSync",e.$Phb="vscode-userdata-sync",e.$Qhb="preview"}),define(le[238],he([0,1,30,24]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CFb=void 0;function L(O,C,S,b,R){if(!C)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const k=j(O,C);if(k.added.size===0&&k.removed.size===0&&k.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const $=S?j(S,C):{added:Object.keys(C).reduce((u,h)=>(u.add(h),u),new Set),removed:new Set,updated:new Set},c=S?j(S,O):{added:Object.keys(O).reduce((u,h)=>(u.add(h),u),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},p=D.$en(C),w=!S;for(const u of c.added.values())u!==N.$Ghb&&w&&$.added.has(u)||(p[u]=O[u]);for(const u of c.updated.values())p[u]=O[u];for(const u of c.removed.values())b.unregistered.includes(u)||delete p[u];for(const u of $.added.values()){const h=C[u];if(b.machine.includes(u)){R.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(S&&c.added.has(u))continue;const d=O[u];d&&d.value===h.value||u===N.$Ghb&&w&&c.added.has(u)||(d?g.updated[u]=h:g.added[u]=h)}for(const u of $.updated.values()){const h=C[u];if(b.machine.includes(u)){R.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(u)||c.removed.has(u))continue;const d=O[u];d&&d.value===h.value||(g.updated[u]=h)}for(const u of $.removed.values()){if(b.machine.includes(u)){R.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}c.updated.has(u)||c.removed.has(u)||g.removed.push(u)}const l=j(C,p);return{local:g,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:p}}}e.$CFb=L;function j(O,C){const S=Object.keys(O),b=Object.keys(C),R=b.filter(c=>!S.includes(c)).reduce((c,g)=>(c.add(g),c),new Set),k=S.filter(c=>!b.includes(c)).reduce((c,g)=>(c.add(g),c),new Set),$=new Set;for(const c of S){if(k.has(c))continue;const g=O[c],p=C[c];D.$in(g,p)||$.add(c)}return{added:R,removed:k,updated:$}}}),define(le[239],he([0,1,18,35,86,42,30,79,24]),function(ne,e,D,N,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qEb=e.$pEb=e.$oEb=e.$nEb=e.$mEb=e.$lEb=void 0;function b(a,v,m){let f=[];m?f=k(m):f=R(v);const y=[],I=[...(0,S.$ohb)()];if(Array.isArray(f))for(const F of f)F.startsWith("-")?I.push(F.substring(1)):y.push(F);return(0,D.$Lb)([...a,...y].filter(F=>!I.includes(F)))}e.$lEb=b;function R(a){let v=a.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=a.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:a.getValue("settingsSync.ignoredSettings")||[]}function k(a){const v=(0,N.$7m)(a);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function $(a,v){const m=(0,N.$7m)(a)||{};let f="{}";for(const y of Object.keys(m)){const I=(0,L.$IT)(f,[y],m[y],v);f=(0,L.$LT)(f,I)}return f}e.$mEb=$;function c(a,v,m,f){if(m.length){const y=r(v),I=(0,N.$7m)(v)||{},F=(0,N.$7m)(a);if(!F)return a;const T=[];for(const M of m){const U=I[M],Y=F[M];U===void 0?a=C.edit(a,[M],void 0,f):Y!==void 0?a=C.edit(a,[M],U,f):T.push(s(M,y))}T.sort((M,U)=>M.startOffset-U.startOffset),T.forEach(M=>a=u(M.setting.key,v,a,f))}return a}e.$nEb=c;function g(a,v,m,f,y,I){const F=c(a,v,f,I),T=m!==F,M=m!==v;if(!T&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(T&&!M)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(M&&!T)return{conflictsSettings:[],localContent:c(v,a,f,I),remoteContent:null,hasConflicts:!1};if(m===null&&w(a)){const A=p(a,v,f)?null:c(v,a,f,I);return{conflictsSettings:[],localContent:A,remoteContent:null,hasConflicts:!1}}let U=a,Y=v;const J=(0,N.$7m)(a),x=(0,N.$7m)(v),W=m?(0,N.$7m)(m):null,X=f.reduce((A,G)=>(A.add(G),A),new Set),V=l(J,x,X),B=l(W,J,X),te=l(W,x,X),se=new Map,_=new Set,re=A=>{_.add(A);const G=y.filter(({key:q})=>q===A)[0];G?(U=C.edit(U,[A],G.value,I),Y=C.edit(Y,[A],G.value,I)):se.set(A,{key:A,localValue:J[A],remoteValue:x[A]})};for(const A of B.removed.values())te.updated.has(A)?re(A):Y=C.edit(Y,[A],void 0,I);for(const A of te.removed.values())_.has(A)||(B.updated.has(A)?re(A):U=C.edit(U,[A],void 0,I));for(const A of B.updated.values())_.has(A)||(te.updated.has(A)?V.updated.has(A)&&re(A):Y=C.edit(Y,[A],J[A],I));for(const A of te.updated.values())_.has(A)||(B.updated.has(A)?V.updated.has(A)&&re(A):U=C.edit(U,[A],x[A],I));for(const A of B.added.values())_.has(A)||(te.added.has(A)?V.updated.has(A)&&re(A):Y=u(A,U,Y,I));for(const A of te.added.values())_.has(A)||(B.added.has(A)?V.updated.has(A)&&re(A):U=u(A,Y,U,I));const K=se.size>0||!p(U,Y,f),z=K||!p(U,a,[]),P=K||!p(Y,v,[]);return{localContent:z?U:null,remoteContent:P?Y:null,conflictsSettings:[...se.values()],hasConflicts:K}}e.$oEb=g;function p(a,v,m){if(a===v)return!0;const f=(0,N.$7m)(a),y=(0,N.$7m)(v),I=m.reduce((M,U)=>(M.add(U),M),new Set),F=r(a).filter(M=>!(M.setting&&I.has(M.setting.key))),T=r(v).filter(M=>!(M.setting&&I.has(M.setting.key)));if(F.length!==T.length)return!1;for(let M=0;M<F.length;M++){const U=F[M],Y=T[M];if(U.setting&&Y.setting){if(U.setting.key!==Y.setting.key||!O.$in(f[U.setting.key],y[U.setting.key]))return!1}else if(!U.setting&&!Y.setting){if(U.value!==Y.value)return!1}else return!1}return!0}function w(a){return a?r(a).length===0:!0}e.$pEb=w;function l(a,v,m){const f=a?Object.keys(a).filter(M=>!m.has(M)):[],y=Object.keys(v).filter(M=>!m.has(M)),I=y.filter(M=>!f.includes(M)).reduce((M,U)=>(M.add(U),M),new Set),F=f.filter(M=>!y.includes(M)).reduce((M,U)=>(M.add(U),M),new Set),T=new Set;if(a)for(const M of f){if(F.has(M))continue;const U=a[M],Y=v[M];O.$in(U,Y)||T.add(M)}return{added:I,removed:F,updated:T}}function u(a,v,m,f){const y=(0,N.$7m)(v),I=r(v),F=r(m),T=h(a,I,F);return d(m,a,y[a],T,F,f)}e.$qEb=u;function h(a,v,m){const f=v.findIndex(I=>I.setting?.key===a),y=v[f-1];if(y){if(y.setting){const F=s(y.setting.key,m);if(F)return{index:m.indexOf(F),insertAfter:!0}}else{const F=o(f,v);if(F){const T=s(F.setting.key,m);if(T){const M=n(m.indexOf(T),m),U=i(v,F,v[f]);if(M){const Y=i(m,T,M),J=t(U,Y);return J?{index:m.indexOf(J),insertAfter:!0}:{index:m.indexOf(M),insertAfter:!1}}else{const Y=i(m,T,m[m.length-1]),J=t(U,Y);return J?{index:m.indexOf(J),insertAfter:!0}:{index:m.length-1,insertAfter:!0}}}}}const I=v[f+1];if(I)if(I.setting){const F=s(I.setting.key,m);if(F)return{index:m.indexOf(F),insertAfter:!1}}else{const F=n(f,v);if(F){const T=s(F.setting.key,m);if(T){const M=o(m.indexOf(T),m),U=i(v,v[f],F);if(M){const Y=i(m,M,T),J=t(U.reverse(),Y.reverse());return J?{index:m.indexOf(J),insertAfter:!1}:{index:m.indexOf(M),insertAfter:!0}}else{const Y=i(m,m[0],T),J=t(U.reverse(),Y.reverse());return J?{index:m.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:m.length-1,insertAfter:!0}}function d(a,v,m,f,y,I){let F;return f.index===-1?F=(0,L.$IT)(a,[v],m,I):F=E(a,v,m,f,y,I).map(T=>(0,L.$JT)(a,T,I)[0]),(0,L.$LT)(a,F)}function E(a,v,m,f,y,I){const F=`${JSON.stringify(v)}: ${JSON.stringify(m)}`,T=(0,j.$FT)(I,a),M=y[f.index];if(f.insertAfter){const U=[];if(M.setting)U.push({offset:M.endOffset,length:0,content:","+F});else{const Y=n(f.index,y),J=o(f.index,y),x=J?.setting?.commaOffset;J&&x===void 0&&U.push({offset:J.endOffset,length:0,content:","});const W=x!==void 0&&x>M.endOffset;U.push({offset:W?x+1:M.endOffset,length:0,content:Y?T+F+",":T+F})}return U}else{if(M.setting)return[{offset:M.startOffset,length:0,content:F+","}];const U=(y[f.index-1]&&!y[f.index-1].setting?T:"")+F+(n(f.index,y)?",":"")+T;return[{offset:M.startOffset,length:0,content:U}]}}function s(a,v){return v.filter(m=>m.setting?.key===a)[0]}function o(a,v){for(let m=a-1;m>=0;m--)if(v[m].setting)return v[m]}function n(a,v){for(let m=a+1;m<v.length;m++)if(v[m].setting)return v[m]}function i(a,v,m){const f=a.indexOf(v),y=a.indexOf(m);return a.filter((I,F)=>f<F&&F<y)}function t(a,v){if(a.length&&v.length){let m=0;for(;m<v.length&&m<a.length;m++)if(a[m].value!==v[m].value)return v[m-1];return v[m-1]}}function r(a){const v=[];let m=-1,f,y;const I={onObjectBegin:F=>{m++},onObjectProperty:(F,T,M)=>{m===0&&(f=T,y=F)},onObjectEnd:(F,T)=>{m--,m===0&&v.push({startOffset:f,endOffset:F+T,value:a.substring(f,F+T),setting:{key:y,commaOffset:void 0}})},onArrayBegin:(F,T)=>{m++},onArrayEnd:(F,T)=>{m--,m===0&&v.push({startOffset:f,endOffset:F+T,value:a.substring(f,F+T),setting:{key:y,commaOffset:void 0}})},onLiteralValue:(F,T,M)=>{m===0&&v.push({startOffset:f,endOffset:T+M,value:a.substring(f,T+M),setting:{key:y,commaOffset:void 0}})},onSeparator:(F,T,M)=>{if(m===0&&F===","){let U=v.length-1;for(;U>=0&&!v[U].setting;U--);const Y=v[U];Y&&v.splice(U,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:T}})}},onComment:(F,T)=>{m===0&&v.push({startOffset:F,endOffset:F+T,value:a.substring(F,F+T)})}};return(0,N.$bn)(a,I),v}}),define(le[80],he([0,1,3,2,4,24]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Db=e.$8Db=void 0,e.$8Db=(0,L.$Zh)("IUserDataSyncAccountService");let O=class extends N.$Rc{get account(){return this.a}constructor(S,b){super(),this.g=S,this.h=b,this.b=this.B(new D.$Rd),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.$Rd),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(R=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,R),this.updateAccount(void 0),R==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$9Db=O,e.$9Db=O=ye([Q(0,j.$yhb),Q(1,j.$Nhb)],O)}),define(le[240],he([0,1,2,10]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$00b=e.$90b=e.$80b=e.$70b=e.$60b=e.$50b=e.$40b=void 0;class L{constructor($){this.a=$}listen($,c){switch(c){case"onError":return this.a.onError}throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"triggerSync":return this.a.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(g[0])}throw new Error("Invalid call")}}e.$40b=L;class j{constructor($){this.a=$}listen($,c){throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive(g[0]))}throw new Error("Invalid call")}}e.$50b=j;class O{constructor($){this.a=$}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings($){return this.a.call("resolveUserKeybindings",[$])}async resolveFormattingOptions($){return this.a.call("resolveFormattingOptions",[$])}}e.$60b=O;class C{constructor($){this.a=$}listen($,c){switch(c){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${c}`)}async call($,c,g){switch(c){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(g[0],g[1]);case"setEnablements":return this.a.setEnablements(g)}throw new Error("Invalid call")}}e.$70b=C;class S{constructor($){this.a=$}listen($,c){switch(c){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(g)}throw new Error("Invalid call")}}e.$80b=S;class b{constructor($){this.a=$}listen($,c){switch(c){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${c}`)}call($,c,g){switch(c){case"switch":return this.a.switch(g[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$90b=b;class R extends D.$Rc{constructor($){super(),this.a=$,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch($){return this.a.call("switch",[$])}async getPreviousUserDataSyncStore(){const $=await this.a.call("getPreviousUserDataSyncStore");return this.b($)}b($){return{url:N.URI.revive($.url),type:$.type,defaultUrl:N.URI.revive($.defaultUrl),insidersUrl:N.URI.revive($.insidersUrl),stableUrl:N.URI.revive($.stableUrl),canSwitch:$.canSwitch,authenticationProviders:$.authenticationProviders}}}e.$00b=R}),define(le[241],he([0,1,19,174,14,8,24]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iGb=void 0;let C=class extends j.$mj{constructor(b,R){super(),this.g=this.B(b.createLogger((0,D.$Bg)(R.logsHome,`${O.$Ohb}.log`),{id:O.$Ohb,name:(0,N.localize)(0,null)}))}trace(b,...R){this.g.trace(b,...R)}debug(b,...R){this.g.debug(b,...R)}info(b,...R){this.g.info(b,...R)}warn(b,...R){this.g.warn(b,...R)}error(b,...R){this.g.error(b,...R)}flush(){this.g.flush()}};e.$iGb=C,e.$iGb=C=ye([Q(0,j.$ij),Q(1,L.$7h)],C)}),define(le[242],he([0,1,6,3,2]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$59b=void 0;class j extends L.$Rc{constructor({onDidOpenMainWindow:C,onDidFocusMainWindow:S,getActiveWindowId:b}){super(),this.a=this.B(new L.$Qc),N.Event.latch(N.Event.any(C,S))(this.f,this,this.a),this.b=(0,D.$Ng)(()=>b()),(async()=>{try{const k=await this.b;this.c=typeof this.c=="number"?this.c:k}catch{}finally{this.b=void 0}})()}f(C){this.b&&(this.b.cancel(),this.b=void 0),this.c=C}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$59b=j}),define(le[112],he([0,1,177,16,47,19,10,4,23]),function(ne,e,D,N,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.WorkbenchState=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=void 0,e.$9h=(0,C.$Zh)("contextService");function b(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}e.$0h=b;function R(i){return typeof i?.id=="string"&&!b(i)&&!$(i)}e.$$h=R,e.$_h={id:"ext-dev"},e.$ai={id:"empty-window"};function k(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,N.$mc)(i)}:t?e.$_h:e.$ai;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$bi=k;function $(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}e.$ci=$;function c(i){const t=i;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$di=c;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function p(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$ei=p;function w(i){const t=i;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$fi=w;class l{constructor(t,r,a,v,m){this.h=t,this.j=a,this.k=v,this.l=m,this.c=L.$6h.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=L.$6h.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$gi=l;class u{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,j.$Bg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$hi=u;function h(i){return new u({uri:i,index:0,name:(0,j.$xg)(i)},{uri:i.toString()})}e.$ii=h,e.$ji="code-workspace",e.$ki=`.${e.$ji}`,e.$li=[{name:(0,D.localize)(0,null),extensions:[e.$ji]}],e.$mi="workspace.json";function d(i,t){return j.$sg.isEqualOrParent(i,t.untitledWorkspacesHome)}e.$ni=d;function E(i){let t;return O.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===S.Schemas.tmp}e.$oi=E,e.$pi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$pi}e.$qi=s;function o(i,t){return!d(i,t)&&!E(i)}e.$ri=o;function n(i){return(typeof i=="string"?(0,N.$nc)(i):(0,j.$zg)(i))===e.$ki}e.$si=n}),define(le[17],he([0,1,53,3,2,19,10,168,14,11,4,8,112,34,28,6,32,27,12]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.ProfileResourceType=void 0;var h;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function d(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.$Tk=d,e.$Uk=(0,R.$Zh)("IUserDataProfilesService");function E(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:O.URI.revive(i.location).with({scheme:t}),globalStorageHome:O.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:O.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Vk=E;function s(i,t,r,a,v,m){return{id:i,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:m&&v?.useDefaultFlags?.globalState?m.globalStorageHome:(0,j.$Bg)(r,"globalStorage"),settingsResource:m&&v?.useDefaultFlags?.settings?m.settingsResource:(0,j.$Bg)(r,"settings.json"),keybindingsResource:m&&v?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,j.$Bg)(r,"keybindings.json"),tasksResource:m&&v?.useDefaultFlags?.tasks?m.tasksResource:(0,j.$Bg)(r,"tasks.json"),snippetsHome:m&&v?.useDefaultFlags?.snippets?m.snippetsHome:(0,j.$Bg)(r,"snippets"),extensionsResource:m&&v?.useDefaultFlags?.extensions?m.extensionsResource:(0,j.$Bg)(r,"extensions.json"),cacheHome:(0,j.$Bg)(a,i),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Wk=s;let o=class extends L.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,v){super(),this.t=t,this.u=r,this.w=a,this.y=v,this.f=!0,this.h=this.B(new N.$Rd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Rd),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Rd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Rd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new c.$zc,emptyWindows:new Map},this.profilesHome=(0,j.$Bg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$Bg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const m of this.O()){if(!m.name||!(0,u.$Cf)(m.name)||!m.location){this.y.warn("Skipping the invalid stored profile",m.location||m.name);continue}r.push(s((0,j.$yg)(m.location),m.name,m.location,this.g,{shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags},t))}}catch(m){this.y.error(m)}const a=new c.$zc,v=new Map;if(r.length)try{const m=this.Q();if(m.workspaces)for(const[f,y]of Object.entries(m.workspaces)){const I=O.URI.parse(f),F=r.find(T=>T.id===y);F&&a.set(I,F)}if(m.emptyWindows)for(const[f,y]of Object.entries(m.emptyWindows)){const I=r.find(F=>F.id===y);I&&v.set(f,I)}}catch(m){this.y.error(m)}this.z={profiles:r,workspaces:a,emptyWindows:v}}return this.z}D(){const t=s("__default__profile__",(0,C.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,l.$Je)(r)}\\s(\\d+)`);let v=0;for(const f of this.profiles){const y=a.exec(f.name),I=y?parseInt(y[1]):0;v=I>v?I:v}const m=`${r} ${v+1}`;return this.createProfile((0,D.$Ni)((0,w.$kg)()).toString(16),m,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,D.$Ni)((0,w.$kg)()).toString(16),t,r,a)}async createProfile(t,r,a,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.F(t,r,a);return v&&await this.setProfileForWorkspace(v,m),m}async F(t,r,a){if(!(0,u.$Cf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const m=this.profiles.find(I=>I.name===r||I.id===t);if(m)return m;const f=s(t,r,(0,j.$Bg)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(f.location);const y=[];return this.j.fire({profile:f,join(I){y.push(I)}}),await p.Promises.settled(y),this.I([f],[],[]),f}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(v=>v.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=s(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(v){a.push(v)}});try{await Promise.allSettled(a)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,b.$zk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(v=>v.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,$.$0h)(t)?t.uri:(0,$.$ci)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const v=[...this.profiles,...t],m=[];this.s.profiles=[];for(let f of v)f.isDefault||r.some(y=>f.id===y.id)||(f=a.find(y=>f.id===y.id)??f,f.isTransient?this.s.profiles.push(f):m.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P(m),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const v=this.G(t),m=a?this.s:this.C;O.URI.isUri(v)?(m.workspaces.delete(v),r&&m.workspaces.set(v,r)):(m.emptyWindows.delete(v),r&&m.emptyWindows.set(v,r)),a||this.M()}M(){const t={};for(const[a,v]of this.C.workspaces.entries())t[a.toString()]=v.id;const r={};for(const[a,v]of this.C.emptyWindows.entries())r[a.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[m,f]of Object.entries(t.workspaces)){const y=O.URI.parse(f);r[m]=this.w.extUri.isEqual(y,a.location)?a.id:this.w.extUri.basename(y)}const v={};if(t.emptyWindows)for(const[m,f]of Object.entries(t.emptyWindows)){const y=O.URI.parse(f);v[m]=this.w.extUri.isEqual(y,a.location)?a.id:this.w.extUri.basename(y)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Xk=o,e.$Xk=o=ye([Q(0,S.$7h),Q(1,b.$ik),Q(2,g.$Sk),Q(3,k.$hj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Yk=n}),define(le[243],he([0,1,6,2,17]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f$b=void 0;let j=class extends N.$Rc{constructor(C){super(),this.B(new D.$_g(()=>{C.cleanUp()},10*1e3)).schedule()}};e.$f$b=j,e.$f$b=j=ye([Q(0,L.$Uk)],j)}),define(le[244],he([0,1,18,6,26,7,3,2,5,12,10,151,29,33,44,8,25,22,28,17]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=void 0;let d=class extends C.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,v,m,f){super(),this.z=t,this.C=r,this.D=a,this.F=v,this.G=m,this.H=f,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$Rd),this.s=this.B(new O.$Rd),this.t=this.B(new O.$Rd),this.u=this.B(new O.$Rd),this.w=this.B(new O.$Rd),this.y=[],this.B((0,C.$Pc)(()=>{this.j.forEach(({task:y})=>y.cancel()),this.m.forEach(y=>y.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,$.$fo)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:m})=>(0,c.$Jo)(m,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:s(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(a){throw s(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new $.$io(k.localize(0,null),$.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(t.map(async({extension:v,options:m})=>{try{const f=await this.O(v,!!m?.installGivenVersion,!!m?.installPreReleaseVersion);a.push({...f,options:m})}catch(f){r.push({identifier:v.identifier,operation:2,source:v,error:f})}})),a.length&&r.push(...await this.I(a));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!R.URI.isUri(v.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,c.$Ro)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,g.$gm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const m=(await this.getInstalled(1,v.extensionsResource)).find(f=>(0,c.$Jo)(f.identifier,t.identifier));m?this.w.fire(m):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async a=>{try{const v=await this.J(a,(m,f)=>t.some(y=>(0,c.$No)(f.identifier.id)===(0,c.$Oo)(y.manifest.publisher,y.manifest.name))?!1:this.L(m,f));r.push(...v)}catch(v){r.push({identifier:{id:(0,c.$Oo)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:a},v){const m=a.isApplicationScoped||a.isBuiltin||(0,g.$gm)(t),f={...a,installOnlyNewlyAddedFromExtensionPack:R.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:m,profileLocation:m?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},y=Y=>`${c.$Ko.create(Y).toString()}${f.profileLocation?`-${f.profileLocation.toString()}`:""}`;if(!R.URI.isUri(r)){const Y=this.j.get(y(r));if(Y)return this.F.info("Extensions is already requested to install",r.identifier.id),await Y.task.waitUntilTaskIsFinished(),[]}const I=[],F=[],T=[],M=this.Z(t,r,f);R.URI.isUri(r)||this.j.set(y(r),{task:M,waitingTasks:[]}),this.n.fire({identifier:M.identifier,source:r,profileLocation:f.profileLocation}),this.F.info("Installing extension:",M.identifier.id),I.push({task:M,manifest:t});let U=!1;try{if(f.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const J=await this.N(M.identifier,t,!!f.installOnlyNewlyAddedFromExtensionPack,!!f.installPreReleaseVersion,f.profileLocation),x=await this.getInstalled(void 0,f.profileLocation),W={...f,donotIncludePackAndDependencies:!0,context:{...f.context,[$.$ao]:!0}};for(const{gallery:X,manifest:V}of(0,D.$Lb)(J,({gallery:B})=>B.identifier.id)){U=U||!!V.extensionDependencies?.some(se=>(0,c.$Jo)({id:se},M.identifier));const B=y(X),te=this.j.get(B);if(te){if(v(M,te.task)){const se=te.task.identifier;this.F.info("Waiting for already requested installing extension",se.id,M.identifier.id),te.waitingTasks.push(M),F.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,_=>_.some(re=>(0,c.$Jo)(re.identifier,se)))).then(_=>{if(this.F.info("Finished waiting for already requested installing extension",se.id,M.identifier.id),!_.find(K=>(0,c.$Jo)(K.identifier,se))?.local)throw new Error(`Extension ${se.id} is not installed`)}))}}else if(!x.some(({identifier:se})=>(0,c.$Jo)(se,X.identifier))){const se=this.Z(V,X,W);this.j.set(B,{task:se,waitingTasks:[M]}),this.n.fire({identifier:se.identifier,source:X,profileLocation:f.profileLocation}),this.F.info("Installing extension:",se.identifier.id,M.identifier.id),I.push({task:se,manifest:V})}}}catch(J){if(R.URI.isUri(M.source))(0,D.$Kb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",M.identifier.id,J.message),(0,D.$Kb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",M.identifier.id,J.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),J}const Y=I.reduce((J,{task:x,manifest:W})=>(J.set(x.identifier.id.toLowerCase(),{task:x,manifest:W}),J),new Map);for(;Y.size;){let J;const x=[...Y.values()].filter(({manifest:W})=>!W.extensionDependencies?.some(X=>Y.has(X.toLowerCase())));x.length?J=Y.size===1?x:x.filter(({task:W})=>!(W===M&&!U)):(this.F.info("Found extensions with circular dependencies",x.map(({task:W})=>W.identifier.id)),J=[...Y.values()]),await this.M(J.map(async({task:W})=>{const X=new Date().getTime();try{const V=await W.run();if(await this.M(this.y.map(B=>B.postInstall(V,W.source,f,L.CancellationToken.None))),!R.URI.isUri(W.source)){const B=W.operation===3,te=B?void 0:(new Date().getTime()-W.source.lastUpdated)/1e3;if(o(this.C,B?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Ro)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-X,durationSinceUpdate:te}),S.$o&&W.operation!==3)try{await this.z.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch{}}T.push({local:V,identifier:W.identifier,operation:W.operation,source:W.source,context:W.options.context,profileLocation:W.profileLocation,applicationScoped:V.isApplicationScoped})}catch(V){throw R.URI.isUri(W.source)||o(this.C,W.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Ro)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-X,error:V}),this.F.error("Error while installing the extension:",W.identifier.id),V}finally{Y.delete(W.identifier.id.toLowerCase())}}))}return F.length&&await this.M(F),T.forEach(({identifier:J})=>this.F.info("Extension installed successfully:",J.id)),T}catch(Y){if(I.forEach(({task:J})=>J.cancel()),T.length)try{const J=await Promise.allSettled(T.map(({local:x})=>this.$(x,{versionOnly:!0,profileLocation:f.profileLocation}).run()));for(let x=0;x<J.length;x++){const W=J[x],{identifier:X}=T[x];W.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",X.id):this.F.warn("Rollback: Error while uninstalling extension",X.id,(0,j.$9)(W.reason))}}catch(J){this.F.warn("Error while rolling back extensions",(0,j.$9)(J),T.map(({identifier:x})=>x.id))}return I.map(({task:J})=>({identifier:J.identifier,operation:2,source:J.source,context:f.context,profileLocation:f.profileLocation,error:Y}))}finally{for(const{task:Y}of I)Y.source&&!R.URI.isUri(Y.source)&&this.j.delete(y(Y.source))}}L(t,r){for(const[,{task:a,waitingTasks:v}]of this.j.entries())if(a===t&&(v.includes(r)||v.some(m=>this.L(m,r)))||a===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],a=[],v=await Promise.allSettled(t);for(const m of v)m.status==="fulfilled"?r.push(m.value):a.push(m.reason);if(a.length)throw E(a);return r}async N(t,r,a,v,m){if(!this.z.isEnabled())return[];const f=await this.getInstalled(void 0,m),y=[],I=[],F=async(T,M)=>{y.push(T);const U=M.extensionDependencies||[],Y=[...U];if(M.extensionPack){const J=a?f.find(x=>(0,c.$Jo)(x.identifier,T)):void 0;for(const x of M.extensionPack)J&&J.manifest.extensionPack&&J.manifest.extensionPack.some(W=>(0,c.$Jo)({id:W},{id:x}))||Y.every(W=>!(0,c.$Jo)({id:W},{id:x}))&&Y.push(x)}if(Y.length){const J=Y.filter(x=>y.every(W=>!(0,c.$Jo)(W,{id:x})));if(J.length){const x=await this.z.getExtensions(J.map(W=>({id:W,preRelease:v})),L.CancellationToken.None);for(const W of x){if(y.find(B=>(0,c.$Jo)(B,W.identifier)))continue;const X=U.some(B=>(0,c.$Jo)({id:B},W.identifier));let V;try{V=await this.O(W,!1,v)}catch(B){if(X)throw B;this.F.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,j.$9)(B));continue}I.push({gallery:V.extension,manifest:V.manifest}),await F(V.extension.identifier,V.manifest)}}}};return await F(t,r),I}async O(t,r,a){let v;const m=await this.getExtensionsControlManifest();if(m.malicious.some(I=>(0,c.$Jo)(t.identifier,I)))throw new $.$io(k.localize(1,null,t.identifier.id),$.ExtensionManagementErrorCode.Malicious);const f=m.deprecated[t.identifier.id.toLowerCase()];if(f?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${f.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:f.extension.id,preRelease:f.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0],!v)throw new $.$io(k.localize(2,null,t.identifier.id,f.extension.id),$.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const I=await this.getTargetPlatform();throw new $.$io(k.localize(3,null,t.identifier.id,this.G.nameLong,(0,$.$bo)(I)),$.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,a),!v)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],L.CancellationToken.None))[0]?new $.$io(k.localize(4,null,t.identifier.id),$.ExtensionManagementErrorCode.ReleaseVersionNotFound):new $.$io(k.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),$.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const y=await this.z.getManifest(v,L.CancellationToken.None);if(y===null)throw new $.$io(`Missing manifest for extension ${v.identifier.id}`,$.ExtensionManagementErrorCode.Invalid);if(y.version!==v.version)throw new $.$io(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,$.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:y}}async P(t,r,a){const v=await this.getTargetPlatform();let m=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(m=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:v,compatible:!0},L.CancellationToken.None))[0]||null),!m&&await this.z.isExtensionCompatible(t,a,v)&&(m=t),m||(r?m=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},L.CancellationToken.None))[0]||null:m=await this.z.getCompatibleExtension(t,a,v)),m}async Q(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=T=>`${T.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,m=this.m.get(v(t.identifier));if(m)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),m.waitUntilTaskIsFinished();const f=T=>{const M=this.$(T,a);return this.m.set(v(M.extension.identifier),M),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:a.profileLocation,applicationScoped:T.isApplicationScoped}),M},y=(T,M)=>{M?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString(),M.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,M.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,c.$Qo)(T),error:M}),this.u.fire({identifier:T.identifier,error:M?.code,profileLocation:a.profileLocation,applicationScoped:T.isApplicationScoped})},I=[],F=[];try{I.push(f(t));const T=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const M=this.U(t,T);for(const U of M)this.m.has(v(U.identifier))?this.F.info("Extensions is already requested to uninstall",U.identifier.id):I.push(f(U))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(I.map(M=>M.extension),T,t),await this.M(I.map(async M=>{try{if(await M.run(),await this.M(this.y.map(U=>U.postUninstall(M.extension,a,L.CancellationToken.None))),M.extension.identifier.uuid)try{await this.z.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}y(M.extension)}catch(U){const Y=U instanceof $.$io?U:new $.$io((0,j.$9)(U),$.ExtensionManagementErrorCode.Internal);throw y(M.extension,Y),Y}finally{F.push(M)}}))}catch(T){const M=T instanceof $.$io?T:new $.$io((0,j.$9)(T),$.ExtensionManagementErrorCode.Internal);for(const U of I){try{U.cancel()}catch{}F.includes(U)||y(U.extension,M)}throw M}finally{for(const T of I)this.m.delete(v(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}R(t,r,a){for(const v of t){const m=this.W(v,r);if(m.length){const f=m.filter(y=>!t.some(I=>(0,c.$Jo)(I.identifier,y.identifier)));if(f.length)throw new Error(this.S(v,f,a))}}}S(t,r,a){return a===t?r.length===1?k.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?k.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):k.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?k.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?k.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):k.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const m=r.filter(y=>!y.isBuiltin&&v.some(I=>(0,c.$Jo)({id:I},y.identifier))),f=[];for(const y of m)f.push(...this.U(y,r,a));return[...m,...f]}return[]}W(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>(0,c.$Jo)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$zp=d,e.$zp=d=ye([Q(0,$.$ho),Q(1,l.$ml),Q(2,u.$Sk),Q(3,p.$hj),Q(4,w.$zj),Q(5,h.$Uk)],d);function E(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$Ap=E;function s(i){if(i instanceof $.$io)return i;const t=new $.$io(i.message,$.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.$Bp=s;function o(i,t,{extensionData:r,verificationStatus:a,duration:v,error:m,durationSinceUpdate:f}){let y,I;(0,b.$Kf)(a)&&(a===!0?a="Verified":(a===!1||(y=$.ExtensionManagementErrorCode.Signature,I=a),a="Unverified")),m&&(m instanceof $.$io?(y=m.code,m.code===$.ExtensionManagementErrorCode.Signature&&(I=m.message)):y=$.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:a,success:!m,duration:v,errorcode:y,errorcodeDetail:I,durationSinceUpdate:f})}class n{constructor(){this.d=new N.$Yg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$Ng)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$Ng)(t=>new Promise((r,a)=>{const v=t.onCancellationRequested(()=>{v.dispose(),a(new j.$4)})})),this.d.open()),this.g.cancel()}}e.$Cp=n}),define(le[51],he([0,1,6,15,2,3,34,10,29,33,11,4,8,17,28,12,7,22]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=e.$Dp=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class h extends Error{constructor(n,i){super(n),this.code=i}}e.$Dp=h,e.$Ep=(0,k.$Zh)("IExtensionsProfileScannerService");let d=class extends L.$Rc{constructor(n,i,t,r,a,v){super(),this.j=n,this.m=i,this.n=t,this.r=r,this.s=a,this.t=v,this.b=this.B(new j.$Rd),this.onAddExtensions=this.b.event,this.c=this.B(new j.$Rd),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$Rd),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$Rd),this.onDidRemoveExtensions=this.g.event,this.h=new O.$zc}scanProfileExtensions(n,i){return this.u(n,void 0,i)}async addExtensionsToProfile(n,i){const t=[],r=[];try{return await this.u(i,a=>{const v=[];for(const m of a)n.some(([f])=>(0,b.$Jo)(f.identifier,m.identifier)&&f.manifest.version!==m.version)?t.push(m):v.push(m);for(const[m,f]of n){const y=v.findIndex(F=>(0,b.$Jo)(F.identifier,m.identifier)&&F.version===m.manifest.version),I={identifier:m.identifier,version:m.manifest.version,location:m.location,metadata:f};y===-1?(r.push(I),v.push(I)):v.splice(y,1,I)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),t.length&&this.f.fire({extensions:t,profileLocation:i}),v}),r.length&&this.c.fire({extensions:r,profileLocation:i}),t.length&&this.g.fire({extensions:t,profileLocation:i}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:i}),t.length&&this.g.fire({extensions:t,error:a,profileLocation:i}),a}}async updateMetadata(n,i){const t=[];return await this.u(i,r=>{const a=[];for(const v of r){const m=n.find(([f])=>(0,b.$Jo)(f.identifier,v.identifier)&&f.manifest.version===v.version);m&&(v.metadata={...v.metadata,...m[1]},t.push(v)),a.push(v)}return a}),t}async removeExtensionFromProfile(n,i){const t=[];try{await this.u(i,r=>{const a=[];for(const v of r)(0,b.$Jo)(v.identifier,n.identifier)?t.push(v):a.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:i}),a}),t.length&&this.g.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:i}),r}}async u(n,i,t){return this.F(n).queue(async()=>{let r=[],a;try{const v=await this.m.readFile(n);a=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,R.$zk)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new h((0,w.$9)(v),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let v=!1;for(const m of a){E(m)||this.w(n);let f;if((0,p.$Cf)(m.relativeLocation)&&m.relativeLocation)f=this.z(m.relativeLocation);else if((0,p.$Cf)(m.location))f=this.z(m.location),v=!0,m.relativeLocation=m.location,m.location=f.toJSON();else{f=C.URI.revive(m.location);const y=this.y(f);y&&(v=!0,m.relativeLocation=y)}r.push({identifier:m.identifier,location:f,version:m.version,metadata:m.metadata})}v&&await this.m.writeFile(n,N.$fe.fromString(JSON.stringify(a)))}if(i){r=i(r);const v=r.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),relativeLocation:this.y(m.location),metadata:m.metadata}));await this.m.writeFile(n,N.$fe.fromString(JSON.stringify(v)))}return r})}w(n){const i=new h(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,R.$zk)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(v=>E(v))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$fe.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,R.$zk)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,R.$zk)(a)!==1&&this.t.error(a)}try{await this.m.del(i)}catch(a){(0,R.$zk)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let i=this.h.get(n);return i||(i=new D.$7g,this.h.set(n,i)),i}};e.$Fp=d,e.$Fp=d=ye([Q(1,R.$ik),Q(2,c.$Uk),Q(3,g.$Sk),Q(4,l.$ml),Q(5,$.$hj)],d);function E(o){return(0,p.$Ef)(o)&&(0,S.$go)(o.identifier)&&(s(o.location)||(0,p.$Cf)(o.location)&&o.location)&&((0,p.$Jf)(o.relativeLocation)||(0,p.$Cf)(o.relativeLocation))&&o.version&&(0,p.$Cf)(o.version)}function s(o){return o?(0,p.$Cf)(o.path)&&(0,p.$Cf)(o.scheme):!1}}),define(le[81],he([0,1,18,6,30,15,7,35,137,2,23,16,5,19,55,89,12,10,154,14,33,44,70,11,4,8,25,3,65,51,17,28,182]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u,h,d,E,s,o,n,i,t,r,a,v,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.Translations=void 0;var I;(function(x){function W(X,V){if(X===V)return!0;const B=Object.keys(X),te=new Set;for(const se of Object.keys(V))te.add(se);if(B.length!==te.size)return!1;for(const se of B){if(X[se]!==V[se])return!1;te.delete(se)}return te.size===0}x.equals=W})(I||(e.Translations=I={})),e.$Ip=(0,n.$Zh)("IExtensionsScannerService");let F=class extends b.$Rc{constructor(W,X,V,B,te,se,_,re,K,z,P,A){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=X,this.r=V,this.s=B,this.t=te,this.u=se,this.w=_,this.y=re,this.z=K,this.C=z,this.D=P,this.F=A,this.g=this.B(new r.$Rd),this.onDidChangeCache=this.g.event,this.h=(0,c.$Bg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(U,this.s,this.h)),this.m=this.B(this.F.createInstance(U,this.s,this.h)),this.n=this.B(this.F.createInstance(M,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,d.$Uo)(this.w,this.y)),this.G}async scanAllExtensions(W,X,V){const[B,te]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(X)]),se=V?await this.scanExtensionsUnderDevelopment(W,[...B,...te]):[];return this.L(B,te,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const X=[];X.push(this.M(!!W.useCache,W.language)),X.push(this.N(W.language,!!W.checkControlFile));const[V,B]=await Promise.all(X);return this.J([...V,...B],0,W,!1)}async scanUserExtensions(W){const X=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const V=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(X,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,V),te=W.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let se;try{se=await te.scanExtensions(B)}catch(_){if(_ instanceof v.$Dp&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),se=await te.scanExtensions(B);else throw _}return se=await this.J(se,1,W,!0),this.y.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(W,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===R.Schemas.file).map(async B=>{const te=await this.P(B,!1,1,!0,W.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(te)).map(_=>(_.type=X.find(re=>(0,d.$Jo)(re.identifier,_.identifier))?.type??_.type,this.n.validate(_,te)))}))).flat();return this.J(V,"development",W,!0)}return[]}async scanExistingExtension(W,X,V){const B=await this.P(W,!1,X,!0,V.language,!0,void 0),te=await this.n.scanExtension(B);return!te||!V.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(W,X,V){const B=await this.P(W,!1,X,!0,V.language,!0,void 0),te=await this.n.scanOneOrMultipleExtensions(B);return this.J(te,X,V,!0)}async scanMetadata(W){const X=(0,c.$Bg)(W,"package.json"),V=(await this.w.readFile(X)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(W,X){const V=(0,c.$Bg)(W,"package.json"),B=(await this.w.readFile(V)).value.toString(),te=JSON.parse(B);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,te.__metadata={...te.__metadata,...X},await this.w.writeFile((0,c.$Bg)(W,"package.json"),j.$fe.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof v.$Dp&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$fe.fromString(JSON.stringify([])))}catch(X){(0,o.$zk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$9)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,X,V,B){return V.includeAllVersions||(W=this.L(X===0?W:void 0,X===1?W:void 0,X==="development"?W:void 0,await this.getTargetPlatform(),B)),V.includeInvalid||(W=W.filter(te=>te.isValid)),W.sort((te,se)=>{const _=k.$mc(te.location.fsPath),re=k.$mc(se.location.fsPath);return _<re?-1:_>re?1:0})}L(W,X,V,B,te){const se=(re,K,z)=>{if(re.isValid&&!K.isValid)return!1;if(re.isValid===K.isValid){if(te&&g.gt(re.manifest.version,K.manifest.version))return this.y.debug(`Skipping extension ${K.location.path} with lower version ${K.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if(g.eq(re.manifest.version,K.manifest.version)){if(re.type===0)return this.y.debug(`Skipping extension ${K.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===B)return this.y.debug(`Skipping extension ${K.location.path} from different target platform ${K.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${re.location.path} with ${K.location.path}.`):this.y.debug(`Overwriting user extension ${re.location.path} with ${K.location.path}.`),!0},_=new E.$fm;return W?.forEach(re=>{const K=_.get(re.identifier.id);(!K||se(K,re,!1))&&_.set(re.identifier.id,re)}),X?.forEach(re=>{const K=_.get(re.identifier.id);if(!K&&W&&re.type===0){this.y.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!K||se(K,re,!1))&&_.set(re.identifier.id,re)}),V?.forEach(re=>{const K=_.get(re.identifier.id);(!K||se(K,re,!0))&&_.set(re.identifier.id,re),_.set(re.identifier.id,re)}),[..._.values()]}async M(W,X){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),te=await(W&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",te.length),te}async N(W,X){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const B=X?await this.O():{},te=[],se=l.URI.file(k.$gc(k.$ic(R.$ig.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const re of V){const K=B[re.name]||"marketplace";switch(K){case"disabled":break;case"marketplace":te.push((0,c.$Bg)(se,re.name));break;default:te.push(l.URI.file(K));break}}const _=await Promise.all(te.map(async re=>this.n.scanExtension(await this.P(re,!1,0,!0,W,!0,void 0))));return this.y.trace("Scanned dev system extensions:",_.length),(0,D.$Gb)(_)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,X,V,B,te,se,_){const re=await this.f(te??$.$w),K=await this.Q(W),z=X&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,P=z?await this.Q(z):void 0;return new T(W,K,z,P,X,_,V,B,se,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,te,re)}async Q(W){try{const X=await this.w.stat(W);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$Jp=F,e.$Jp=F=ye([Q(4,m.$Uk),Q(5,v.$Ep),Q(6,o.$ik),Q(7,i.$hj),Q(8,h.$7h),Q(9,t.$zj),Q(10,f.$Sk),Q(11,n.$Yh)],F);class T{constructor(W,X,V,B,te,se,_,re,K,z,P,A,G,q,ee){this.location=W,this.mtime=X,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=B,this.profile=te,this.profileScanOptions=se,this.type=_,this.excludeObsolete=re,this.validate=K,this.productVersion=z,this.productDate=P,this.productCommit=A,this.devMode=G,this.language=q,this.translations=ee}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,X){return(0,c.$ug)(W.location,X.location)&&W.mtime===X.mtime&&(0,c.$ug)(W.applicationExtensionslocation,X.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&W.profile===X.profile&&L.$in(W.profileScanOptions,X.profileScanOptions)&&W.type===X.type&&W.excludeObsolete===X.excludeObsolete&&W.validate===X.validate&&W.productVersion===X.productVersion&&W.productDate===X.productDate&&W.productCommit===X.productCommit&&W.devMode===X.devMode&&W.language===X.language&&I.equals(W.translations,X.translations)}}e.$Kp=T;let M=class extends b.$Rc{constructor(W,X,V,B,te){super(),this.f=W,this.g=X,this.h=V,this.j=B,this.m=te}async scanExtensions(W){const X=W.profile?await this.r(W):await this.n(W);let V={};if(W.excludeObsolete&&W.type===1)try{const B=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(B)}catch{}return(0,w.$Pf)(V)?X:X.filter(B=>!V[d.$Ko.create(B).toString()])}async n(W){const X=await this.j.resolve(W.location);if(!X.children?.length)return[];const V=await Promise.all(X.children.map(async B=>{if(!B.isDirectory||W.type===1&&(0,c.$yg)(B.resource).indexOf(".")===0)return null;const te=new T(B.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(te)}));return(0,D.$Gb)(V).sort((B,te)=>B.location.path<te.location.path?-1:1)}async r(W){let X=await this.s(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){X=X.filter(B=>!B.metadata?.isApplicationScoped);const V=await this.s(W.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,W);X.push(...V)}return X}async s(W,X,V){const B=await this.g.scanProfileExtensions(W,V.profileScanOptions);if(!B.length)return[];const te=await Promise.all(B.map(async se=>{if(X(se)){const _=new T(se.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(_,se.metadata)}return null}));return(0,D.$Gb)(te)}async scanOneOrMultipleExtensions(W){try{if(await this.j.exists((0,c.$Bg)(W.location,"package.json"))){const X=await this.scanExtension(W);return X?[X]:[]}else return await this.scanExtensions(W)}catch(X){return this.m.error(`Error scanning extensions at ${W.location.path}:`,(0,O.$9)(X)),[]}}async scanExtension(W,X){try{let V=await this.scanExtensionManifest(W.location);if(V){V.publisher||(V.publisher=E.$_l),X=X??V.__metadata,delete V.__metadata;const B=(0,d.$Oo)(V.publisher,V.name),te=X?.id?{id:B,uuid:X.id}:{id:B},se=X?.isSystem?0:W.type,_=se===0||!!X?.isBuiltin;V=await this.t(W.location,V,T.createNlsConfiguration(W));const re={type:se,identifier:te,manifest:V,location:W.location,isBuiltin:_,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return W.validate?this.validate(re,W):re}}catch(V){W.type!==0&&this.m.error(V)}return null}validate(W,X){let V=!0;const B=(0,s.$Zo)(X.productVersion,X.productDate,X.location,W.manifest,W.isBuiltin);for(const[te,se]of B)te===p.default.Error&&(V=!1,this.m.error(this.z(X.location,se)));return W.isValid=V,W.validations=B,W}async scanExtensionManifest(W){const X=(0,c.$Bg)(W,"package.json");let V;try{V=(await this.j.readFile(X)).value.toString()}catch(te){return(0,o.$zk)(te)!==1&&this.m.error(this.z(W,(0,u.localize)(0,null,X.path,te.message))),null}let B;try{B=JSON.parse(V)}catch{const se=[];(0,C.$7m)(V,se);for(const _ of se)this.m.error(this.z(W,(0,u.localize)(1,null,X.path,_.offset,_.length,(0,S.$Gp)(_.error))));return null}return(0,C.$dn)(B)!=="object"?(this.m.error(this.z(W,(0,u.localize)(2,null,X.path))),null):B}async t(W,X,V){const B=await this.u(W,X,V);if(B)try{const te=[],se=await this.w(B.default,te);if(te.length>0)return te.forEach(re=>{this.m.error(this.z(W,(0,u.localize)(3,null,B.default?.path,(0,S.$Gp)(re.error))))}),X;if((0,C.$dn)(B)!=="object")return this.m.error(this.z(W,(0,u.localize)(4,null,B.default?.path))),X;const _=B.values||Object.create(null);return(0,y.$Hp)(this.m,X,_,se)}catch{}return X}async u(W,X,V){const B=(0,c.$Bg)(W,"package.nls.json"),te=(K,z)=>{z.forEach(P=>{this.m.error(this.z(W,(0,u.localize)(5,null,K?.path,(0,S.$Gp)(P.error))))})},se=K=>{this.m.error(this.z(W,(0,u.localize)(6,null,K?.path)))},_=`${X.publisher}.${X.name}`,re=V.translations[_];if(re)try{const K=l.URI.file(re),z=(await this.j.readFile(K)).value.toString(),P=[],A=(0,C.$7m)(z,P);return P.length>0?(te(K,P),{values:void 0,default:B}):(0,C.$dn)(A)!=="object"?(se(K),{values:void 0,default:B}):{values:A.contents?A.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.j.exists(B))return;let z;try{z=await this.y(W,V)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const P=(await this.j.readFile(z.localized)).value.toString(),A=[],G=(0,C.$7m)(P,A);return A.length>0?(te(z.localized,A),{values:void 0,default:z.original}):(0,C.$dn)(G)!=="object"?(se(z.localized),{values:void 0,default:z.original}):{values:G,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(W,X){if(W)try{const V=(await this.j.readFile(W)).value.toString();return(0,C.$7m)(V,X)}catch{}}y(W,X){return new Promise((V,B)=>{const te=se=>{const _=(0,c.$Bg)(W,`package.nls.${se}.json`);this.j.exists(_).then(re=>{re&&V({localized:_,original:(0,c.$Bg)(W,"package.nls.json")});const K=se.lastIndexOf("-");K===-1?V({localized:(0,c.$Bg)(W,"package.nls.json"),original:null}):(se=se.substring(0,K),te(se))})};if(X.devMode||X.pseudo||!X.language)return V({localized:(0,c.$Bg)(W,"package.nls.json"),original:null});te(X.language)})}z(W,X){return`[${W.path}]: ${X}`}};M=ye([Q(1,v.$Ep),Q(2,f.$Sk),Q(3,o.$ik),Q(4,i.$hj)],M);let U=class extends M{constructor(W,X,V,B,te,se,_){super(X,B,te,se,_),this.G=W,this.H=V,this.D=this.B(new N.$Xg(3e3)),this.F=this.B(new r.$Rd),this.onDidChangeCache=this.F.event}async scanExtensions(W){const X=this.M(W),V=await this.I(X);if(this.C=W,V&&V.input&&T.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",W.location.toString()),this.D.trigger(()=>this.L()),V.result.map(te=>(te.location=l.URI.revive(te.location),te));const B=await super.scanExtensions(W);return await this.J(X,{input:W,result:B}),B}async I(W){try{const X=await this.j.readFile(W),V=JSON.parse(X.value.toString());return{result:V.result,input:(0,a.$wh)(V.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",W.path,(0,O.$9)(X))}return null}async J(W,X){try{await this.j.writeFile(W,j.$fe.fromString(JSON.stringify(X)))}catch(V){this.m.debug("Error while writing the extension cache file:",W.path,(0,O.$9)(V))}}async L(){if(!this.C)return;const W=this.M(this.C),X=await this.I(W);if(!X)return;const V=X.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!L.$in(B,V))try{this.m.info("Invalidating Cache",V,B),await this.j.del(W),this.F.fire()}catch(te){this.m.error(te)}}M(W){const X=this.N(W);return this.h.extUri.joinPath(X.cacheHome,W.type===0?E.$$l:E.$0l)}N(W){return W.type===0?this.H.defaultProfile:W.profile?this.h.extUri.isEqual(W.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(W.location,X.extensionsResource))??this.G:this.H.defaultProfile}};U=ye([Q(2,m.$Uk),Q(3,v.$Ep),Q(4,f.$Sk),Q(5,o.$ik),Q(6,i.$hj)],U);function Y(x,W){const X=(0,d.$Mo)(x.manifest.publisher,x.manifest.name);return{id:X,identifier:new E.$dm(X),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:W,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$Lp=Y;class J extends F{constructor(W,X,V,B,te,se,_,re,K,z,P,A){super(W,X,(0,c.$Bg)(V,".vscode-oss-dev","extensions","control.json"),B,te,se,_,re,K,z,P,A),this.R=(async()=>{if($.$z)try{const G=await this.w.readFile(l.URI.file($.$z));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(W){return this.R}}e.$Mp=J}),define(le[245],he([0,1,66,6,38,3,2,23,16,31,8,17]),function(ne,e,D,N,L,j,O,C,S,b,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;let $=class extends O.$Rc{constructor(g,p){super(),this.b=g,this.f=p,this.a=new N.$6g(5)}async postUninstall(g){const p=this.g(g,"uninstall");p&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(w){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(w)}}));try{await b.Promises.rm(this.m(g))}catch(w){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(w)}}g(g,p){const w=`vscode:${p}`;if(g.location.scheme===C.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[w]=="string"){const l=g.manifest.scripts[w].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${w} should be a node script`),null):{script:(0,S.$ic)(g.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(g,p,w,l,u){return new Promise((h,d)=>{const E=this.j(g,p,w,u);let s;const o=n=>{s&&(clearTimeout(s),s=null),n?d(n):h(void 0)};E.on("error",n=>{o((0,L.$Ki)(n)||"Unknown")}),E.on("exit",(n,i)=>{o(n?`post-${p} process exited with code ${n}`:void 0)}),l&&(s=setTimeout(()=>{s=null,E.kill(),d("timed out")},5e3))})}j(g,p,w,l){const u={silent:!0,execArgv:void 0},h=(0,D.fork)(g,[`--type=extension-post-${p}`,...w],u);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const d=j.Event.fromNodeEventEmitter(h.stdout,"data"),E=j.Event.fromNodeEventEmitter(h.stderr,"data");d(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${p}`,n)),E(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${p}`,n));const s=j.Event.any(j.Event.map(d,n=>({data:`%c${n}`,format:[""]})),j.Event.map(E,n=>({data:`%c${n}`,format:["color: red"]})));return j.Event.debounce(s,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}m(g){return(0,S.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.$Op=$,e.$Op=$=ye([Q(0,k.$Uk),Q(1,R.$hj)],$)}),define(le[113],he([0,1,6,15,26,38,7,3,53,2,34,23,16,19,55,12,10,32,31,69,155,96,14,244,29,33,51,81,224,245,183,213,225,70,11,4,8,25,22,28,17]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u,h,d,E,s,o,n,i,t,r,a,v,m,f,y,I,F,T,M,U,Y,J,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0,e.$Sp=(0,T.$1h)(n.$jo);const W=".vsctmp";let X=class extends o.$zp{constructor(K,z,P,A,G,q,ee,H,Z,ie,ce,oe){super(K,z,ce,P,ie,oe),this.fb=G,this.gb=q,this.hb=ee,this.ib=Z,this.eb=new Map,this.rb=new R.$Ac;const fe=this.B(H.createInstance(v.$Op));this.bb=this.B(H.createInstance(V,we=>fe.postUninstall(we))),this.cb=this.B(new f.$Qp(oe,Z,ce,this,this.F)),this.db=this.B(H.createInstance(a.$Np));const de=this.B(new y.$Rp(this,this.fb,oe,q,ce,Z,P));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Uo)(this.ib,this.F)),this.jb}async zip(K){this.F.trace("ExtensionManagementService#zip",K.identifier.id);const z=await this.pb(K),P=await(0,h.zip)((0,c.$Bg)(this.db.extensionsDownloadDir,(0,l.$kg)()).fsPath,z);return w.URI.file(P)}async unzip(K){return this.F.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:z,cleanup:P}=await this.lb(K),A=$.$jc(z.fsPath);try{return await(0,m.$Pp)(A)}finally{await P()}}getInstalled(K,z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(K??null,z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.bb.scanUserExtensionAtLocation(K)}async install(K,z={}){this.F.trace("ExtensionManagementService#install",K.toString());const{location:P,cleanup:A}=await this.lb(K);try{const G=await(0,m.$Pp)($.$jc(P.fsPath)),q=(0,i.$Oo)(G.publisher,G.name);if(G.engines&&G.engines.vscode&&!(0,I.$2o)(G.engines.vscode,this.G.version,this.G.date))throw new Error(d.localize(0,null,q,this.G.version));const H=(await this.I([{manifest:G,extension:P,options:z}])).find(({identifier:Z})=>(0,i.$Jo)(Z,{id:q}));if(H?.local)return H.local;throw H?.error?H.error:(0,o.$Bp)(new Error(`Unknown error while installing extension ${q}`))}finally{await A()}}async installFromLocation(K,z){this.F.trace("ExtensionManagementService#installFromLocation",K.toString());const P=await this.bb.scanUserExtensionAtLocation(K);if(!P)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.ub([[P,void 0]],z),this.F.info("Successfully installed extension",P.identifier.id,z.toString()),P}async installExtensionsFromProfile(K,z,P){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",K,z.toString(),P.toString());const A=(await this.bb.scanExtensions(1,z)).filter(G=>K.some(q=>(0,i.$Jo)(q,G.identifier)));if(A.length){const G=await Promise.all(A.map(q=>this.bb.scanMetadata(q,z)));await this.ub(A.map((q,ee)=>[q,G[ee]]),P),this.F.info("Successfully installed extensions",A.map(q=>q.identifier.id),P.toString())}return A}async updateMetadata(K,z,P=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",K.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),K=await this.bb.updateMetadata(K,z,P),this.cb.invalidate(P),this.w.fire(K),K}async reinstallFromGallery(K){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.z.isEnabled())throw new Error(d.localize(1,null));const z=await this.getTargetPlatform(),[P]=await this.z.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:z,compatible:!0},L.CancellationToken.None);if(!P)throw new Error(d.localize(2,null));await this.bb.setUninstalled(K);try{await this.bb.removeUninstalledExtension(K)}catch(A){throw new Error(d.localize(3,null,(0,j.$Ki)(A)))}return this.installFromGallery(P)}ab(K,z,P,A){return this.bb.copyExtension(K,z,P,A)}copyExtensions(K,z){return this.bb.copyExtensions(K,z)}markAsUninstalled(...K){return this.bb.setUninstalled(...K)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(K){this.F.error(K)}}async download(K,z,P){const{location:A}=await this.db.download(K,z,!P);return A}async lb(K){if(K.scheme===k.Schemas.file)return{location:K,async cleanup(){}};this.F.trace("Downloading extension from",K.toString());const z=(0,c.$Bg)(this.db.extensionsDownloadDir,(0,l.$kg)());return await this.hb.download(K,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(A){this.F.error(A)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(K,z,P){if(w.URI.isUri(z))return new se(K,z,P,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const A=i.$Ko.create(z).toString();let G=this.eb.get(A);return G||(this.eb.set(A,G=new te(K,z,P,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),G.waitUntilTaskIsFinished().finally(()=>this.eb.delete(A))),G}$(K,z){return new _(K,z.profileLocation,this.gb)}async pb(K){const z=async A=>{let G=await u.Promises.readdir(A);G=G.map(H=>$.$ic(A,H));const q=await Promise.all(G.map(H=>u.Promises.stat(H)));let ee=Promise.resolve([]);return q.forEach((H,Z)=>{const ie=G[Z];H.isFile()&&(ee=ee.then(ce=>[...ce,ie])),H.isDirectory()&&(ee=ee.then(ce=>z(ie).then(oe=>[...ce,...oe])))}),ee};return(await z(K.location.fsPath)).map(A=>({path:`extension/${$.$kc(K.location.fsPath,A)}`,localPath:A}))}async qb({added:K,removed:z}){if(z){const P=K&&this.D.extUri.isEqual(z.profileLocation,K.profileLocation)?z.extensions.filter(A=>K.extensions.every(G=>!(0,i.$Jo)(G,A))):z.extensions;for(const A of P)this.F.info("Extensions removed from another source",A.id,z.profileLocation.toString()),this.u.fire({identifier:A,profileLocation:z.profileLocation})}if(K){const A=(await this.bb.scanExtensions(1,K.profileLocation)).filter(G=>K.extensions.some(q=>(0,i.$Jo)(q,G.identifier)));this.s.fire(A.map(G=>(this.F.info("Extensions added from another source",G.identifier.id,K.profileLocation.toString()),{identifier:G.identifier,local:G,profileLocation:K.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(z=>this.rb.add(z)));const K=await this.ib.resolve(this.fb.userExtensionsLocation);for(const z of K.children??[])z.isDirectory&&this.rb.add(z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.tb(z)))}async tb(K){if(!K.affects(this.fb.userExtensionsLocation,1))return;const z=[];for(const P of K.rawAdded){if(this.rb.has(P)||!this.D.extUri.isEqual(this.D.extUri.dirname(P),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(P,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(P).startsWith(".")||!(await this.ib.stat(P)).isDirectory)continue;const A=await this.bb.scanUserExtensionAtLocation(P);A&&A.installedTimestamp===void 0&&(this.rb.add(P),z.push(A))}z.length&&(await this.ub(z.map(P=>[P,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(P=>P.identifier.id)))}async ub(K,z){const P=K.map(A=>A[0]);await this.vb(P),await this.gb.addExtensionsToProfile(K,z),this.s.fire(P.map(A=>({local:A,identifier:A.identifier,operation:1,profileLocation:z})))}async vb(K){const z=await this.bb.getUninstalledExtensions();for(const P of K){const A=i.$Ko.create(P);z[A.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",A.id),await this.bb.setInstalled(A),this.F.info("Removed the extension from uninstalled list:",A.id))}}};e.$Tp=X,e.$Tp=X=ye([Q(0,n.$ho),Q(1,Y.$ml),Q(2,M.$hj),Q(3,s.$8h),Q(4,r.$Ip),Q(5,t.$Ep),Q(6,E.$Yn),Q(7,T.$Yh),Q(8,F.$ik),Q(9,U.$zj),Q(10,J.$Sk),Q(11,x.$Uk)],X);let V=class extends b.$Rc{constructor(K,z,P,A,G,q){super(),this.j=K,this.m=z,this.n=P,this.s=A,this.t=G,this.u=q,this.h=this.B(new C.$Rd),this.onExtract=this.h.event,this.c=(0,c.$Bg)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$7g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(K,z){const P={includeInvalid:!0,profileLocation:z};let A=[];return K===null||K===0?A.push(...await this.n.scanAllExtensions({includeInvalid:!0},P,!1)):K===1&&A.push(...await this.n.scanUserExtensions(P)),A=K!==null?A.filter(G=>G.type===K):A,Promise.all(A.map(G=>this.F(G)))}async scanAllUserExtensions(K){const z=await this.n.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(z.map(P=>this.F(P)))}async scanUserExtensionAtLocation(K){try{const z=await this.n.scanExistingExtension(K,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(K,z,P,A,G){const q=K.toString(),ee=w.URI.file($.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,l.$kg)()}`)),H=w.URI.file($.$ic(this.n.userExtensionsLocation.fsPath,q));let Z=await this.m.exists(H);if(Z&&A){try{await this.y(K.id,H,"removeExisting")}catch{throw new n.$io(d.localize(4,null,H.fsPath,K.id),n.ExtensionManagementErrorCode.Delete)}Z=!1}if(!Z)try{try{this.u.trace(`Started extracting the extension from ${z} to ${H.fsPath}`),await(0,h.$xp)(z,ee.fsPath,{sourcePath:"extension",overwrite:!0},G),this.u.info(`Extracted extension to ${H}:`,K.id)}catch(ie){let ce=n.ExtensionManagementErrorCode.Extract;throw ie instanceof h.$vp&&(ie.type==="CorruptZip"?ce=n.ExtensionManagementErrorCode.CorruptZip:ie.type==="Incomplete"&&(ce=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$io(ie.message,ce)}await this.n.updateMetadata(ee,P);try{this.u.trace(`Started renaming the extension from ${ee.fsPath} to ${H.fsPath}`),await this.C(ee.fsPath,H.fsPath),this.u.info("Renamed to",H.fsPath)}catch(ie){if(ie.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.u.info(`Rename failed because of ${(0,O.$9)(ie)}. Deleted from extracted location`,ee),ie}this.h.fire(H)}catch(ie){try{await this.m.del(ee,{recursive:!0})}catch{}throw ie}return this.D(H,1)}async scanMetadata(K,z){return z?(await this.w(K,z))?.metadata:this.n.scanMetadata(K.location)}async w(K,z){return(await this.s.scanProfileExtensions(z)).find(A=>(0,i.$Jo)(A.identifier,K.identifier))}async updateMetadata(K,z,P){return P?await this.s.updateMetadata([[K,z]],P):await this.n.updateMetadata(K.location,z),this.D(K.location,K.type,P)}getUninstalledExtensions(){return this.z()}async setUninstalled(...K){const z=K.map(P=>i.$Ko.create(P));await this.z(P=>z.forEach(A=>{P[A.toString()]=!0,this.u.info("Marked extension as uninstalled",A.toString())}))}async setInstalled(K){await this.z(z=>delete z[K.toString()])}async removeExtension(K,z){if(this.t.extUri.isEqualOrParent(K.location,this.n.userExtensionsLocation))return this.y(K.identifier.id,K.location,z)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.z(z=>delete z[i.$Ko.create(K).toString()])}async copyExtension(K,z,P,A){const G=await this.w(K,z),q=await this.w(K,P);return A={...G?.metadata,...A},q?await this.s.updateMetadata([[K,{...q.metadata,...A}]],P):await this.s.addExtensionsToProfile([[K,A]],P),this.D(K.location,K.type,P)}async copyExtensions(K,z){const P=await this.scanExtensions(1,K),A=await Promise.all(P.filter(G=>!G.isApplicationScoped).map(async G=>[G,await this.scanMetadata(G,K)]));await this.s.addExtensionsToProfile(A,z)}async y(K,z,P){this.u.trace(`Deleting ${P} extension from disk`,K,z.fsPath);const A=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,S.$Ni)((0,l.$kg)()).toString(16)}${W}`);await this.C(z.fsPath,A.fsPath),await this.m.del(A,{recursive:!0}),this.u.info(`Deleted ${P} extension from disk`,K,z.fsPath)}async z(K){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(A){if((0,F.$zk)(A)!==1)throw A}let P={};if(z)try{P=JSON.parse(z)}catch{}return K&&(K(P),Object.keys(P).length?await this.m.writeFile(this.c,N.$fe.fromString(JSON.stringify(P))):await this.m.del(this.c)),P})}async C(K,z){try{await u.Promises.rename(K,z,2*60*1e3)}catch(P){throw new n.$io(P.message||d.localize(5,null,K,z),P.code||n.ExtensionManagementErrorCode.Rename)}}async D(K,z,P){if(P){const G=(await this.n.scanUserExtensions({profileLocation:P})).find(q=>this.t.extUri.isEqual(q.location,K));if(G)return this.F(G)}else{const A=await this.n.scanExistingExtension(K,z,{includeInvalid:!0});if(A)return this.F(A)}throw new Error(d.localize(6,null,K.path))}async F(K){const z=await this.m.resolve(K.location);let P,A;return z.children&&(P=z.children.find(({name:G})=>/^readme(\.txt|\.md|)$/i.test(G))?.resource,A=z.children.find(({name:G})=>/^changelog(\.txt|\.md|)$/i.test(G))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:P,changelogUrl:A,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned}}async G(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(K));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),P=new Set;for(const G of z)K[i.$Ko.create(G).toString()]||P.add(G.identifier.id.toLowerCase());try{const G=(0,i.$Po)(z,q=>q.identifier);await D.Promises.settled(G.map(async q=>{const ee=q.sort((H,Z)=>g.rcompare(H.manifest.version,Z.manifest.version))[0];P.has(ee.identifier.id.toLowerCase())||await this.j(await this.F(ee))}))}catch(G){this.u.error(G)}const A=z.filter(G=>G.metadata&&K[i.$Ko.create(G).toString()]);await Promise.allSettled(A.map(G=>this.removeUninstalledExtension(G)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let K;try{K=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,F.$zk)(z)!==1&&this.u.error(z);return}if(K?.children)try{await Promise.allSettled(K.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(W))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(P){(0,F.$zk)(P)!==1&&this.u.error(P)}}}))}catch{}}};e.$Up=V,e.$Up=V=ye([Q(1,F.$ik),Q(2,r.$Ip),Q(3,t.$Ep),Q(4,J.$Sk),Q(5,M.$hj)],V);class B extends o.$Cp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$Jf)(this.options.operation)?this.l:this.options.operation}constructor(K,z,P,A,G,q,ee,H,Z){super(),this.identifier=K,this.source=z,this.options=P,this.m=A,this.n=G,this.o=q,this.p=ee,this.q=H,this.s=Z,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(K){const[z,P]=await this.x(K);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,P]],this.j),z}async u({zipPath:K,key:z,metadata:P},A,G){let q=await this.v(z);return q||(this.s.trace("Extracting extension...",z.id),q=await this.m.extractUserExtension(z,K,P,A,G),this.s.info("Extracting extension completed.",z.id)),q}async v(K){return await this.w(K)?(this.s.trace("Removing the extension from uninstalled list:",K.id),await this.m.setInstalled(K),this.s.info("Removed the extension from uninstalled list:",K.id),(await this.m.scanAllUserExtensions(!0)).find(A=>i.$Ko.create(A).equals(K))):void 0}async w(K){return!!(await this.m.getUninstalledExtensions())[K.toString()]}}class te extends B{constructor(K,z,P,A,G,q,ee,H,Z,ie){super(z.identifier,z,P,G,q,ee,H,Z,ie),this.y=z,this.z=A}async x(K){const P=(await this.m.scanExtensions(null,this.options.profileLocation)).find(ee=>(0,i.$Jo)(ee.identifier,this.y.identifier));P&&(this.l=3);const A={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,isSystem:P?.type===0?!0:void 0,updated:!!P,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:P?.pinned,preRelease:this.y.properties.isPreReleaseVersion||((0,p.$If)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:P?.preRelease)};if(P?.manifest.version===this.y.version)return[await this.m.updateMetadata(P,A),A];const{location:G,verificationStatus:q}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=q,this.B(G.fsPath),[await this.u({zipPath:G.fsPath,key:i.$Ko.create(this.y),metadata:A},!1,K),A]}catch(ee){try{await this.z.delete(G)}catch(H){this.s.warn("Error while deleting the downloaded file",G.toString(),(0,O.$9)(H))}throw ee}}async B(K){try{await(0,m.$Pp)(K)}catch(z){throw new n.$io((0,o.$Ap)(z).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Vp=te;class se extends B{constructor(K,z,P,A,G,q,ee,H,Z,ie){super({id:(0,i.$Oo)(K.publisher,K.name)},z,P,G,q,ee,H,Z,ie),this.y=K,this.z=z,this.A=A}async h(K){const z=await super.h(K);return this.D(z,K),z}async x(K){const z=new i.$Ko(this.identifier,this.y.version),A=(await this.m.scanExtensions(1,this.options.profileLocation)).find(ee=>(0,i.$Jo)(this.identifier,ee.identifier)),G={isApplicationScoped:this.options.isApplicationScoped||A?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||A?.isMachineScoped,isBuiltin:this.options.isBuiltin||A?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(A)if(this.l=3,z.equals(new i.$Ko(A.identifier,A.manifest.version)))try{await this.m.removeExtension(A,"existing")}catch{throw new Error(d.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&g.gt(A.manifest.version,this.y.version)&&await this.m.setUninstalled(A);else{const ee=await this.v(z);if(ee)try{await this.m.removeExtension(ee,"existing")}catch{throw new Error(d.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:$.$jc(this.z.fsPath),key:z,metadata:G},!0,K),G]}async D(K,z){try{let[P]=await this.A.getExtensions([{id:K.identifier.id,version:K.manifest.version}],z);if(P||([P]=await this.A.getExtensions([{id:K.identifier.id}],z)),P){const A={id:P.identifier.uuid,publisherDisplayName:P.publisherDisplayName,publisherId:P.publisherId,isPreReleaseVersion:P.properties.isPreReleaseVersion,preRelease:P.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(K,A,this.options.profileLocation)}}catch{}}}class _ extends o.$Cp{constructor(K,z,P){super(),this.extension=K,this.j=z,this.k=P}async h(K){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[246],he([0,1,8,17,28,22,51,11,14,10]),function(ne,e,D,N,L,j,O,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=void 0;let R=class extends O.$Fp{constructor($,c,g,p,w,l){super(b.URI.file($.extensionsPath),c,g,p,w,l)}};e.$1N=R,e.$1N=R=ye([Q(0,S.$8h),Q(1,C.$ik),Q(2,N.$Uk),Q(3,L.$Sk),Q(4,j.$ml),Q(5,D.$hj)],R)}),define(le[247],he([0,1,10,14,51,81,11,4,8,25,28,17]),function(ne,e,D,N,L,j,O,C,S,b,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$99b=void 0;let $=class extends j.$Mp{constructor(g,p,w,l,u,h,d,E){super(D.URI.file(u.builtinExtensionsPath),D.URI.file(u.extensionsPath),u.userHome,g.defaultProfile,g,p,w,l,u,h,d,E)}};e.$99b=$,e.$99b=$=ye([Q(0,k.$Uk),Q(1,L.$Ep),Q(2,O.$ik),Q(3,S.$hj),Q(4,N.$8h),Q(5,b.$zj),Q(6,R.$Sk),Q(7,C.$Yh)],$)}),define(le[21],he([0,1,6,3,2,100,12,68,4,17]),function(ne,e,D,N,L,j,O,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$dp=e.$cp=e.$bp=void 0,e.$bp="__$__isNewStorageMarker",e.$cp="__$__targetStorageMarker",e.$dp=(0,S.$Zh)("storageService");var R;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var k;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var $;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function c(u){const h=u.get(e.$cp);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.$ep=c;class g extends L.$Rc{static{this.a=60*1e3}constructor(h={flushInterval:g.a}){super(),this.m=h,this.b=this.B(new N.$Ud),this.c=this.B(new N.$Ud),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Rd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$_g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,d,E){return N.Event.filter(this.b.event,s=>s.scope===h&&(d===void 0||s.key===d),E)}n(){this.j.value=(0,D.$dh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,d){const{key:E,external:s}=d;if(E===e.$cp){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:E,target:this.J(h)[E],external:s})}w(h){this.f.fire({reason:h})}get(h,d,E){return this.P(d)?.get(h,E)}getBoolean(h,d,E){return this.P(d)?.getBoolean(h,E)}getNumber(h,d,E){return this.P(d)?.getNumber(h,E)}getObject(h,d,E){return this.P(d)?.getObject(h,E)}storeAll(h,d){this.y(()=>{for(const E of h)this.store(E.key,E.value,E.scope,E.target,d)})}store(h,d,E,s,o=!1){if((0,O.$Lf)(d)){this.remove(h,E,o);return}this.y(()=>{this.z(h,E,s),this.P(E)?.set(h,d,o)})}remove(h,d,E=!1){this.y(()=>{this.z(h,d,void 0),this.P(d)?.delete(h,E)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,d){const E=[],s=this.J(h);for(const o of Object.keys(s))s[o]===d&&E.push(o);return E}z(h,d,E,s=!1){const o=this.J(d);typeof E=="number"?o[h]!==E&&(o[h]=E,this.P(d)?.set(e.$cp,JSON.stringify(o),s)):typeof o[h]=="number"&&(delete o[h],this.P(d)?.set(e.$cp,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const d=this.P(h);return d?c(d):Object.create(null)}isNew(h){return this.getBoolean(e.$bp,h)===!0}async flush(h=R.NONE){this.f.fire({reason:h});const d=this.P(-1),E=this.P(0),s=this.P(1);switch(h){case R.NONE:await D.Promises.settled([d?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await D.Promises.settled([d?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,E=this.P(1)?.items??new Map;return l(h,d,E,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,d){return this.w(R.NONE),(0,b.$Tk)(h)?this.R(h,d):this.S(h,d)}M(h,d){return!(h.id===d.id||p(d)&&p(h))}N(h,d,E){this.y(()=>{const s=new Set;for(const[o,n]of h)s.add(o),d.get(o)!==n&&this.u(E,{key:o,external:!0});for(const[o]of d.items)s.has(o)||this.u(E,{key:o,external:!0})})}}e.$fp=g;function p(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$gp=p;class w extends g{constructor(){super(),this.U=this.B(new C.$_o(new C.$ap,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new C.$_o(new C.$ap,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new C.$_o(new C.$ap,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$hp=w;async function l(u,h,d,E,s,o){const n=I=>{try{return JSON.parse(I)}catch{return I}},i=new Map,t=new Map;u.forEach((I,F)=>{i.set(F,I),t.set(F,n(I))});const r=new Map,a=new Map;h.forEach((I,F)=>{r.set(F,I),a.set(F,n(I))});const v=new Map,m=new Map;d.forEach((I,F)=>{v.set(F,I),m.set(F,n(I))}),console.group(E!==s?`Storage: Application (path: ${E})`:`Storage: Application & Profile (path: ${E}, default profile)`);const f=[];if(i.forEach((I,F)=>{f.push({key:F,value:I})}),console.table(f),console.groupEnd(),console.log(t),E!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const I=[];r.forEach((F,T)=>{I.push({key:T,value:F})}),console.table(I),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const y=[];v.forEach((I,F)=>{y.push({key:F,value:I})}),console.table(y),console.groupEnd(),console.log(m)}e.$ip=l}),define(le[114],he([0,1,3,2,12,29,33,21]),function(ne,e,D,N,L,j,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Db=e.$6Db=void 0;let S=class extends N.$Rc{constructor(k,$){super(),this.a=new D.$Rd,this.onDidChangeEnablement=this.a.event,this.b=this.B(new b(k)),this.B(this.b.onDidChange(c=>this.a.fire({extensions:c,source:"storage"}))),this.B($.onDidInstallExtensions(c=>c.forEach(({local:g,operation:p})=>{g&&p===4&&this.f(g.identifier)})))}async enableExtension(k,$){return this.f(k)?(this.a.fire({extensions:[k],source:$}),!0):!1}async disableExtension(k,$){return this.c(k)?(this.a.fire({extensions:[k],source:$}),!0):!1}getDisabledExtensions(){return this.h(j.$ko)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(k){const $=this.getDisabledExtensions();return $.every(c=>!(0,O.$Jo)(c,k))?($.push(k),this.g($),!0):!1}f(k){const $=this.getDisabledExtensions();for(let c=0;c<$.length;c++){const g=$[c];if((0,O.$Jo)(g,k))return $.splice(c,1),this.g($),!0}return!1}g(k){this.j(j.$ko,k)}h(k){return this.b.get(k,0)}j(k,$){this.b.set(k,$,0)}};e.$6Db=S,e.$6Db=S=ye([Q(0,C.$dp),Q(1,j.$jo)],S);class b extends N.$Rc{constructor(k){super(),this.c=k,this.a=Object.create(null),this.b=this.B(new D.$Rd),this.onDidChange=this.b.event,this.B(k.onDidChangeValue(0,void 0,this.B(new N.$Qc))($=>this.f($)))}get(k,$){let c;return $===0?((0,L.$Lf)(this.a[k])&&(this.a[k]=this.g(k,$)),c=this.a[k]):c=this.g(k,$),JSON.parse(c)}set(k,$,c){const g=JSON.stringify($.map(({id:w,uuid:l})=>({id:w,uuid:l})));this.g(k,c)!==g&&(c===0&&($.length?this.a[k]=g:delete this.a[k]),this.h(k,$.length?g:void 0,c))}f(k){if(!(0,L.$Lf)(this.a[k.key])&&this.g(k.key,k.scope)!==this.a[k.key]){const c=this.get(k.key,k.scope);delete this.a[k.key];const g=this.get(k.key,k.scope),p=c.filter(l=>!g.some(u=>(0,O.$Jo)(l,u))),w=g.filter(l=>!c.some(u=>(0,O.$Jo)(u,l)));(p.length||w.length)&&this.b.fire([...p,...w])}}g(k,$){return this.c.get(k,$,"[]")}h(k,$,c){$?this.c.store(k,$,c,1):this.c.remove(k,c)}}e.$7Db=b}),define(le[248],he([0,1,18,26,7,5,37,12,10,20,14,29,33,70,11,8,25,59,226,21,22,62]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u,h,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=void 0;const s=j.$o?"web":(0,k.$do)(j.$u,O.$dc),o="X-Market-Search-Activity-Id";var n;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function i(...P){return String(P.reduce((A,G)=>A|G,0))}var t;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},m={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class f{constructor(A=m){this.d=A}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(A,G=this.d.pageSize){return new f({...this.d,pageNumber:A,pageSize:G})}withFilter(A,...G){const q=[...this.d.criteria,...G.length?G.map(ee=>({filterType:A,value:ee})):[{filterType:A}]];return new f({...this.d,criteria:q})}withSortBy(A){return new f({...this.d,sortBy:A})}withSortOrder(A){return new f({...this.d,sortOrder:A})}withFlags(...A){return new f({...this.d,flags:A.reduce((G,q)=>G|q,0)})}withAssetTypes(...A){return new f({...this.d,assetTypes:A})}withSource(A){return new f({...this.d,source:A})}get raw(){const{criteria:A,pageNumber:G,pageSize:q,sortBy:ee,sortOrder:H,flags:Z,assetTypes:ie}=this.d;return{filters:[{criteria:A,pageNumber:G,pageSize:q,sortBy:ee,sortOrder:H}],assetTypes:ie,flags:Z}}get searchText(){const A=this.d.criteria.filter(G=>G.filterType===t.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(A=>String(A.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function y(P,A){const G=(P||[]).filter(q=>q.statisticName===A)[0];return G?G.value:0}function I(P){const A="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(q=>q.assetType.indexOf(A)===0).reduce((q,ee)=>{const H=M(P,ee.assetType);return H&&q.push([ee.assetType.substring(A.length),H]),q},[])}function F(P){if(P.properties){const A=P.properties.filter(ee=>ee.key===r.Repository),G=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),q=A.filter(ee=>G.test(ee.value))[0];return q?{uri:q.value,fallbackUri:q.value}:null}return M(P,r.Repository)}function T(P){return{uri:`${P.fallbackAssetUri}/${r.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${r.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function M(P,A){return P.files.filter(q=>q.assetType===A)[0]?{uri:`${P.assetUri}/${A}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${A}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function U(P,A){const G=P.properties?P.properties.filter(ee=>ee.key===A):[],q=G.length>0&&G[0].value;return q?q.split(",").map(ee=>(0,$.$No)(ee)):[]}function Y(P){const A=P.properties?P.properties.filter(G=>G.key===a.Engine):[];return A.length>0&&A[0].value||""}function J(P){const A=P.properties?P.properties.filter(G=>G.key===a.PreRelease):[];return A.length>0&&A[0].value==="true"}function x(P){const A=P.properties?P.properties.filter(q=>q.key===a.LocalizedLanguages):[],G=A.length>0&&A[0].value||"";return G?G.split(","):[]}function W(P){return P.properties?.find(A=>A.key===a.SponsorLink)?.value}function X(P){return P.indexOf("preview")!==-1}function V(P){return P.targetPlatform?(0,k.$co)(P.targetPlatform):"undefined"}function B(P){const A=(0,D.$Lb)(P.versions.map(V)),G=!!P.tags?.includes(k.$0n),q=A.indexOf("web");return G?q===-1&&A.push("web"):q!==-1&&A.splice(q,1),A}function te(P,A){for(let G=0;G<P.length;G++){const q=P[G];if(q.version===P[G-1]?.version){let ee=G;if(V(q)===A)for(;ee>0&&P[ee-1].version===q.version;)ee--;ee!==G&&(P.splice(G,1),P.splice(ee,0,q))}}return P}e.$lp=te;function se(P,A,G){P.telemetryData={index:A,querySource:G,queryActivityId:P.queryContext?.[o]}}function _(P,A,G,q){const ee=P.versions[0],H={manifest:M(A,r.Manifest),readme:M(A,r.Details),changelog:M(A,r.Changelog),license:M(A,r.License),repository:F(A),download:T(A),icon:M(A,r.Icon),signature:M(A,r.Signature),coreTranslations:I(A)};return{identifier:{id:(0,$.$Oo)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:A.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(ee),description:P.shortDescription||"",installCount:y(P.statistics,"install"),rating:y(P.statistics,"averagerating"),ratingCount:y(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:G,assets:H,properties:{dependencies:U(A,a.Dependency),extensionPack:U(A,a.ExtensionPack),engine:Y(A),localizedLanguages:x(A),targetPlatform:V(A),isPreReleaseVersion:J(A)},hasPreReleaseVersion:J(ee),hasReleaseVersion:!0,preview:X(P.flags),isSigned:!!H.signature,queryContext:q}}let re=class{constructor(A,G,q,ee,H,Z,ie,ce){this.k=G,this.l=q,this.n=ee,this.o=H,this.q=Z,this.u=ie,this.w=ce;const oe=ie.extensionsGallery,fe=oe?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=fe?oe.servicePPEUrl:oe?.serviceUrl,this.g=fe?void 0:oe?.searchUrl,this.h=oe?.controlUrl,this.j=(0,u.$kp)(ie.version,ie,this.n,this.w,this.q,A,this.o)}x(A=""){return`${this.d}${A}`}isEnabled(){return!!this.d}async getExtensions(A,G,q){const ee=N.CancellationToken.isCancellationToken(G)?{}:G,H=N.CancellationToken.isCancellationToken(G)?G:q,Z=[],ie=[],ce=[],oe=[];let fe=!0;for(const ve of A){ve.uuid?ie.push(ve.uuid):Z.push(ve.id);const Ie=!!(ve.version||ve.preRelease);ce.push({id:ve.id,uuid:ve.uuid,includePreRelease:Ie}),ve.version&&oe.push({id:ve.id,uuid:ve.uuid,version:ve.version}),fe=fe&&!!ve.hasPreRelease&&!Ie}if(!ie.length&&!Z.length)return[];let de=new f().withPage(1,A.length);ie.length&&(de=de.withFilter(t.ExtensionId,...ie)),Z.length&&(de=de.withFilter(t.ExtensionName,...Z)),(ee.queryAllVersions||fe)&&(de=de.withFlags(de.flags,n.IncludeVersions)),ee.source&&(de=de.withSource(ee.source));const{extensions:we}=await this.z(de,{targetPlatform:ee.targetPlatform??s,includePreRelease:ce,versions:oe,compatible:!!ee.compatible},H);return ee.source&&we.forEach((ve,Ie)=>se(ve,Ie,ee.source)),we}async getCompatibleExtension(A,G,q){if((0,k.$eo)(A.allTargetPlatforms,q))return null;if(await this.isExtensionCompatible(A,G,q))return A;const ee=new f().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,A.identifier.uuid),{extensions:H}=await this.z(ee,{targetPlatform:q,compatible:!0,includePreRelease:G},N.CancellationToken.None);return H[0]||null}async isExtensionCompatible(A,G,q){if(!(0,k.$fo)(A.properties.targetPlatform,A.allTargetPlatforms,q)||!G&&A.properties.isPreReleaseVersion)return!1;let ee=A.properties.engine;if(!ee){const H=await this.getManifest(A,N.CancellationToken.None);if(!H)throw new Error("Manifest was not found");ee=H.engines.vscode}return(0,c.$2o)(ee,this.u.version,this.u.date)}async y(A,G,q,ee,H){if(!(0,k.$fo)(V(A),ee,H)||G!=="any"&&J(A)!==(G==="prerelease"))return!1;if(q)try{const Z=await this.E(A);if(!(0,c.$2o)(Z,this.u.version,this.u.date))return!1}catch(Z){return this.l.error(`Error while getting the engine for the version ${A.version}.`,(0,L.$9)(Z)),!1}return!0}async query(A,G){let q=A.text||"";const ee=A.pageSize??50;let H=new f().withPage(1,ee);q?(q=q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,de,we)=>(H=H.withFilter(t.Category,we||de),"")),q=q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,de,we)=>(H=H.withFilter(t.Tag,we||de),"")),q=q.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(t.Featured),"")),q=q.trim(),q&&(q=q.length<200?q:q.substring(0,200),H=H.withFilter(t.SearchText,q)),H=H.withSortBy(0)):A.ids?H=H.withFilter(t.ExtensionId,...A.ids):A.names?H=H.withFilter(t.ExtensionName,...A.names):H=H.withSortBy(4),typeof A.sortBy=="number"&&(H=H.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(H=H.withSortOrder(A.sortOrder)),A.source&&(H=H.withSource(A.source));const Z=async(fe,de)=>{const{extensions:we,total:ve}=await this.z(fe,{targetPlatform:s,compatible:!1,includePreRelease:!!A.includePreRelease},de);return we.forEach((Ie,Ne)=>se(Ie,(fe.pageNumber-1)*fe.pageSize+Ne,A.source)),{extensions:we,total:ve}},{extensions:ie,total:ce}=await Z(H,G),oe=async(fe,de)=>{if(de.isCancellationRequested)throw new L.$4;const{extensions:we}=await Z(H.withPage(fe+1),de);return we};return{firstPage:ie,total:ce,pageSize:H.pageSize,getPage:oe}}async z(A,G,q){const ee=A.flags;A.flags&n.IncludeLatestVersionOnly&&A.flags&n.IncludeVersions&&(A=A.withFlags(A.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(A.flags&n.IncludeLatestVersionOnly)&&!(A.flags&n.IncludeVersions)&&(A=A.withFlags(A.flags,n.IncludeLatestVersionOnly)),G.versions?.length&&(A=A.withFlags(A.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),A=A.withFlags(A.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:H,total:Z,context:ie}=await this.B(A,q);if(!(A.flags&n.IncludeLatestVersionOnly)){const de=[];for(const we of H){const ve=await this.A(we,G,ie);ve&&de.push(ve)}return{extensions:de,total:Z}}const oe=[],fe=new Map;for(let de=0;de<H.length;de++){const we=H[de],ve={id:(0,$.$Oo)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Ie=(0,C.$If)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(Me=>(0,$.$Jo)(Me,ve))?.includePreRelease;if(G.compatible&&(0,k.$eo)(B(we),G.targetPlatform))continue;const Ne=await this.A(we,G,ie);!Ne||Ne.properties.isPreReleaseVersion&&(!Ie||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==G.targetPlatform&&Ne.hasPreReleaseVersion?fe.set(we.extensionId,de):oe.push([de,Ne])}if(fe.size){const de=new E.$Nd,we=new f().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,fe.size).withFilter(t.ExtensionId,...fe.keys()),{extensions:ve}=await this.z(we,G,q);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:fe.size});for(const Ie of ve){const Ne=fe.get(Ie.identifier.uuid);oe.push([Ne,Ie])}}return{extensions:oe.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:Z}}async A(A,G,q){const ee={id:(0,$.$Oo)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},H=G.versions?.find(oe=>(0,$.$Jo)(oe,ee))?.version,Z=(0,C.$If)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(oe=>(0,$.$Jo)(oe,ee))?.includePreRelease,ie=B(A),ce=te(A.versions,G.targetPlatform);if(G.compatible&&(0,k.$eo)(ie,G.targetPlatform))return null;for(let oe=0;oe<ce.length;oe++){const fe=ce[oe];if(!(H&&fe.version!==H)){if(await this.y(fe,Z?"any":"release",G.compatible,ie,G.targetPlatform))return _(A,fe,ie,q);if(H&&fe.version===H)return null}}return H||G.compatible?null:_(A,A.versions[0],ie)}async B(A,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(n.Unpublished));const q=await this.j,ee=JSON.stringify(A.raw),H={...q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Z=new E.$Nd;let ie,ce,oe=0;try{if(ie=await this.k.request({type:"POST",url:this.g&&A.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:H},G),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:oe};const fe=await(0,l.$9o)(ie);if(fe){const de=fe.results[0],we=de.extensions,ve=de.resultMetadata&&de.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return oe=ve&&ve.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:oe,context:{[o]:ie.res.headers.activityid}}}return{galleryExtensions:[],total:oe}}catch(fe){throw ce=fe,fe}finally{this.o.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(ee.length),duration:Z.elapsed(),success:!!ie&&(0,l.$5o)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:ce?(0,L.$3)(ce)?"canceled":(0,L.$9)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(oe)})}}async reportStatistic(A,G,q,ee){if(!this.isEnabled())return;const H=j.$o?this.x(`/itemName/${A}.${G}/version/${q}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${A}/extensions/${G}/${q}/stats?statType=${ee}`),Z=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:Z};try{await this.k.request({type:"POST",url:H,headers:ce},N.CancellationToken.None)}catch{}}async download(A,G,q){this.l.trace("ExtensionGalleryService#download",A.identifier.id);const ee=(0,$.$Ro)(A),H=new Date().getTime(),Z=de=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:de}),ie=q===2?"install":q===3?"update":"",ce=ie?{uri:`${A.assets.download.uri}${S.URI.parse(A.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${A.assets.download.fallbackUri}${S.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:A.assets.download,oe=A.queryContext?.[o]?{[o]:A.queryContext[o]}:void 0,fe=await this.D(ce,oe?{headers:oe}:void 0);await this.q.writeFile(G,fe.stream),Z(new Date().getTime()-H)}async downloadSignatureArchive(A,G){if(!A.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",A.identifier.id);const q=await this.D(A.assets.signature);await this.q.writeFile(G,q.stream)}async getReadme(A,G){if(A.assets.readme){const q=await this.D(A.assets.readme,{},G);return await(0,l.$8o)(q)||""}return""}async getManifest(A,G){if(A.assets.manifest){const q=await this.D(A.assets.manifest,{},G),ee=await(0,l.$8o)(q);return ee?JSON.parse(ee):null}return null}async C(A,G){const q=M(A,r.Manifest);if(!q)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},H=await this.D(q,{headers:ee});return await(0,l.$9o)(H)}async getCoreTranslation(A,G){const q=A.assets.coreTranslations.filter(ee=>ee[0]===G.toUpperCase())[0];if(q){const ee=await this.D(q[1]),H=await(0,l.$8o)(ee);return H?JSON.parse(H):null}return null}async getChangelog(A,G){if(A.assets.changelog){const q=await this.D(A.assets.changelog,{},G);return await(0,l.$8o)(q)||""}return""}async getAllCompatibleVersions(A,G,q){let ee=new f().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);A.identifier.uuid?ee=ee.withFilter(t.ExtensionId,A.identifier.uuid):ee=ee.withFilter(t.ExtensionName,A.identifier.id);const{galleryExtensions:H}=await this.B(ee,N.CancellationToken.None);if(!H.length)return[];const Z=B(H[0]);if((0,k.$eo)(Z,q))return[];const ie=[];await Promise.all(H[0].versions.map(async fe=>{try{await this.y(fe,G?"any":"release",!0,Z,q)&&ie.push(fe)}catch{}}));const ce=[],oe=new Set;for(const fe of te(ie,q))oe.has(fe.version)||(oe.add(fe.version),ce.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:J(fe)}));return ce}async D(A,G={},q=N.CancellationToken.None){const ee=await this.j,H={type:"GET"},Z={...ee,...G.headers||{}};G={...G,...H,headers:Z};const ie=A.uri,ce=A.fallbackUri,oe={...G,url:ie};try{const fe=await this.k.request(oe,q);if(fe.res.statusCode===200)return fe;const de=await(0,l.$8o)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${de}`)}catch(fe){if((0,L.$3)(fe))throw fe;const de=(0,L.$9)(fe);this.o.publicLog2("galleryService:cdnFallback",{url:ie,message:de});const we={...G,url:ce};return this.k.request(we,q)}}async E(A){let G=Y(A);if(!G){const q=await this.C(A,N.CancellationToken.None);if(!q)throw new Error("Manifest was not found");G=q.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const A=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const G=await(0,l.$9o)(A),q=[],ee={},H=[];if(G){for(const Z of G.malicious)q.push({id:Z});if(G.migrateToPreRelease)for(const[Z,ie]of Object.entries(G.migrateToPreRelease))(!ie.engine||(0,c.$2o)(ie.engine,this.u.version,this.u.date))&&(ee[Z.toLowerCase()]={disallowInstall:!0,extension:{id:ie.id,displayName:ie.displayName,autoMigrate:{storage:!!ie.migrateStorage},preRelease:!0}});if(G.deprecated)for(const[Z,ie]of Object.entries(G.deprecated))ie&&(ee[Z.toLowerCase()]=(0,C.$If)(ie)?{}:ie);if(G.search)for(const Z of G.search)H.push(Z)}return{malicious:q,deprecated:ee,search:H}}};re=ye([Q(1,l.$3o),Q(2,p.$hj),Q(3,R.$7h),Q(4,d.$ml),Q(5,g.$ik),Q(6,w.$zj),Q(7,b.$ti)],re);let K=class extends re{constructor(A,G,q,ee,H,Z,ie,ce){super(A,G,q,ee,H,Z,ie,ce)}};e.$mp=K,e.$mp=K=ye([Q(0,h.$dp),Q(1,l.$3o),Q(2,p.$hj),Q(3,R.$7h),Q(4,d.$ml),Q(5,g.$ik),Q(6,w.$zj),Q(7,b.$ti)],K);let z=class extends re{constructor(A,G,q,ee,H,Z,ie){super(void 0,A,G,q,ee,H,Z,ie)}};e.$np=z,e.$np=z=ye([Q(0,l.$3o),Q(1,p.$hj),Q(2,R.$7h),Q(3,d.$ml),Q(4,g.$ik),Q(5,w.$zj),Q(6,b.$ti)],z)}),define(le[82],he([0,1,4,3,2,21,33,25,18,8,12]),function(ne,e,D,N,L,j,O,C,S,b,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$8u=e.$7u=void 0,e.$7u=(0,D.$Zh)("IExtensionStorageService");const $=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let c=class extends L.$Rc{static{k=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,O.$No)(p.id)}@${p.version}`}static c(p){const w=$.exec(p);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(p,w){const l=await p.getInstalled(),u=[];for(const[h,d]of k.f(w)){const E=l.find(s=>(0,O.$Jo)(s.identifier,{id:h}))?.manifest.version;for(const s of d)E!==s&&u.push(k.b({id:h,version:s}))}for(const h of u)w.remove(h,0)}static f(p){const w=new Map,l=p.keys(0,1);for(const u of l){const h=k.c(u);if(h){let d=w.get(h.id.toLowerCase());d||w.set(h.id.toLowerCase(),d=[]),d.push(h.version)}}return w}constructor(p,w,l){super(),this.j=p,this.m=w,this.n=l,this.g=this.B(new N.$Rd),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=k.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new L.$Qc))(u=>this.r(u)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const w=k.c(p.key);if(w){if(this.j.get(p.key,0)===void 0)this.h.delete(w.id.toLowerCase());else{let l=this.h.get(w.id.toLowerCase());l||this.h.set(w.id.toLowerCase(),l=[]),l.push(w.version),this.g.fire()}return}}s(p){if((0,R.$Cf)(p))return p;const w=p.manifest?p.manifest.publisher:p.publisher,l=p.manifest?p.manifest.name:p.name;return(0,O.$Mo)(w,l)}getExtensionState(p,w){const l=this.s(p),u=this.getExtensionStateRaw(p,w);if(u)try{return JSON.parse(u)}catch(h){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${w}): ${h}`)}}getExtensionStateRaw(p,w){const l=this.s(p),u=this.j.get(l,w?0:1);return u&&u?.length>k.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${w}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(p,w,l){const u=this.s(p);w===void 0?this.j.remove(u,l?0:1):this.j.store(u,JSON.stringify(w),l?0:1,1)}setKeysForSync(p,w){this.j.store(k.b(p),JSON.stringify(w),0,1)}getKeysForSync(p){const w=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],l=this.j.get(k.b(p),0),u=l?JSON.parse(l):void 0;return u&&w?(0,S.$Lb)([...u,...w]):u||w}addToMigrationList(p,w){if(p!==w){const l=this.t.filter(u=>!u.includes(p)&&!u.includes(w));l.push([p,w]),this.t=l}}getSourceExtensionToMigrate(p){const w=this.t.find(([,l])=>p===l);return w?w[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(p);if(Array.isArray(w))return w}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$8u=c,e.$8u=c=k=ye([Q(0,j.$dp),Q(1,C.$zj),Q(2,b.$hj)],c)}),define(le[249],he([0,1,2,29,82,223,113,8,21]),function(ne,e,D,N,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n$b=void 0;let b=class extends D.$Rc{constructor(k,$,c,g,p,w){super(),k.cleanUp(),(0,j.$3Xb)(k,$,c,g,w),L.$8u.removeOutdatedExtensionVersions(k,p)}};e.$n$b=b,e.$n$b=b=ye([Q(0,O.$Sp),Q(1,N.$ho),Q(2,L.$7u),Q(3,N.$mo),Q(4,S.$dp),Q(5,C.$hj)],b)}),define(le[250],he([0,1,29,11,25,14,98,57,21,22,222]),function(ne,e,D,N,L,j,O,C,S,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u$b=void 0;let k=class extends R.$F7b{constructor(c,g,p,w,l,u,h,d){super(c.userHome,l,g,p,w,u,h,d)}};e.$u$b=k,e.$u$b=k=ye([Q(0,j.$8h),Q(1,b.$ml),Q(2,D.$jo),Q(3,S.$dp),Q(4,C.$k9b),Q(5,O.$MXb),Q(6,N.$ik),Q(7,L.$zj)],k)}),define(le[251],he([0,1,105,3,22,14,2,8,16,66,25,5,6,101,20,164,36,21,12,131,19]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q$b=void 0;const E=[D.$j$b,D.$k$b],s="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends O.$Rc{constructor(a,v,m,f,y,I,F){super(),this.y=a,this.z=v,this.C=m,this.D=I,this.F=F,this.f=new N.$Rd,this.onDidTokenFailed=this.f.event,this.g=new N.$Rd,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$Rd,this.onDidChangeMode=this.h.event,this.n=D.$h$b,this.w=!1,this.I=(T,M)=>{M?this.j.error(T):this.j.info(T)},this.j=this.B(f.createLogger((0,d.$Bg)(m.logsHome,`${D.$l$b}.log`),{id:D.$l$b,name:D.$m$b})),this.t=new $.$Wg(100),this.B(this.j.onDidChangeLogLevel(T=>this.j.info("Log level changed to "+(0,C.$wj)(T)))),this.B(y.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(I.onDidChangeConfiguration(T=>{E.some(M=>T.affectsConfiguration(M))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=D.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let a;k.$j?a=this.C.appRoot:a=(0,S.$lc)((0,S.$lc)(this.C.appRoot)),this.u=(0,S.$ic)(a,"bin",`${this.z.tunnelApplicationName}${k.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const a=this.n.asService;this.H(D.$h$b);try{a&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(D.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",v=!1;const m=(M,U)=>{U?this.j.error(M):a+=M,!this.C.isBuilt&&M.startsWith("   Compiling")&&this.G(D.TunnelStates.connecting((0,p.localize)(0,null)))},f=this.O("status",["status"],m);this.r=f;try{if(await f,this.r!==f)return;let M;try{M=JSON.parse(a.trim().split(`
`).find(U=>U.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(D.TunnelStates.disconnected());return}if(v=M.service_installed,this.j.info(M.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!M.tunnel&&!this.n.active){this.G(D.TunnelStates.disconnected());return}}catch(M){this.j.error(M),this.G(D.TunnelStates.disconnected());return}finally{this.r===f&&(this.r=void 0)}const y=this.n.active?this.n.session:void 0;if(y&&y.token){const M=y.token;this.G(D.TunnelStates.connecting((0,p.localize)(1,null,y.accountLabel,y.providerId)));const U=(J,x)=>{J=J.replaceAll(M,"*".repeat(4)),m(J,x)},Y=this.O("login",["user","login","--provider",y.providerId,"--access-token",M,"--log",(0,C.$wj)(this.j.getLevel())],U);this.r=Y;try{if(await Y,this.r!==Y)return}catch(J){this.j.error(J),this.r=void 0,this.f.fire(y),this.G(D.TunnelStates.disconnected(y));return}}const I=this.Q();I?this.G(D.TunnelStates.connecting((0,p.localize)(2,null,I))):this.G(D.TunnelStates.connecting((0,p.localize)(3,null)));const F=["--accept-server-license-terms","--log",(0,C.$wj)(this.j.getLevel())];I?F.push("--name",I):F.push("--random-name");let T=!1;return this.n.active&&this.n.asService&&!v&&(T=await this.M(F)===!1),this.N(y,F,T)}async M(a){let v;try{v=await this.O("serviceInstall",["service","install",...a])}catch(m){this.j.error(m),v=1}if(v!==0){const m=(0,p.localize)(4,null);return this.j.warn(m),this.G(D.TunnelStates.connecting(m)),!1}return!0}async N(a,v,m){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let f=!1;const y=this.O("tunnel",v,(I,F)=>{F?this.j.error(I):this.j.info(I),I.includes("Connected to an existing tunnel process")&&(f=!0);const T=I.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(T){const M={link:T[1],domain:T[2],tunnelName:T[4],isAttached:f};this.G(D.TunnelStates.connected(M,m))}else I.match(/error refreshing token/)&&(y.cancel(),this.f.fire(a),this.G(D.TunnelStates.disconnected(a)))});this.r=y,y.finally(()=>{y===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=D.$h$b,this.G(D.TunnelStates.disconnected()))})}O(a,v,m=this.I){return(0,$.$Ng)(f=>new Promise((y,I)=>{f.isCancellationRequested&&y(-1);let F;const T=["ignore","pipe","pipe"];if(f.onCancellationRequested(()=>{F&&(this.j.info(`${a} terminating(${F.pid})`),F.kill())}),!this.C.isBuilt)m(`Building tunnel CLI from sources and run
`,!1),m(`${a} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),F=(0,b.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,S.$ic)(this.C.appRoot,"cli"),stdio:T});else{m(`Running tunnel CLI
`,!1);const M=this.J();m(`${a} Spawning: ${M} tunnel ${v.join(" ")}
`,!1),F=(0,b.spawn)(M,["tunnel",...v],{cwd:(0,w.homedir)(),stdio:T})}F.stdout.pipe(new h.$2T(`
`)).on("data",M=>{if(F){const U=M.toString();m(U,!1)}}),F.stderr.pipe(new h.$2T(`
`)).on("data",M=>{if(F){const U=M.toString();m(U,!0)}}),F.on("exit",M=>{F&&(m(`${a} exit(${F.pid}): + ${M} `,!1),F=void 0,y(M||0))}),F.on("error",M=>{F&&(m(`${a} error(${F.pid}): + ${M} `,!0),F=void 0,I())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(D.$k$b)}Q(){let a=this.D.getValue(D.$j$b)||(0,w.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(s,-1),v=this.F.getBoolean(o,-1,!1);if(a){const m=JSON.parse(a);if(m&&(0,u.$Cf)(m.accountLabel)&&(0,u.$Cf)(m.sessionId)&&(0,u.$Cf)(m.providerId))return{active:!0,session:m,asService:v};this.j.error("Problems restoring session from storage, invalid format",m)}}catch(a){this.j.error("Problems restoring session from storage",a)}return D.$h$b}S(a){if(a.active){const v={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(s,JSON.stringify(v),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(s,-1),this.F.remove(o,-1)}};e.$q$b=n,e.$q$b=n=ye([Q(0,L.$ml),Q(1,R.$zj),Q(2,j.$8h),Q(3,C.$ij),Q(4,c.$o$b),Q(5,g.$ti),Q(6,l.$dp)],n);function i(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&i(r.session,a.session):!0}),define(le[252],he([0,1,6,2,23,19,68,21,77,17]),function(ne,e,D,N,L,j,O,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v$b=void 0;class R extends C.$fp{constructor($,c,g,p){super(),this.bb=$,this.cb=c,this.db=g,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Qc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Qc),this.ab=this.hb(this.bb)}fb(){const $=this.B(new S.$DEb(this.db.getChannel("storage"))),c=this.B(new O.$_o($));return this.B(c.onDidChangeStorage(g=>this.u(-1,g))),c}gb($){this.X.clear(),this.W=$;let c;if((0,C.$gp)($))c=this.U;else{const g=this.X.add(new S.$EEb(this.db.getChannel("storage"),$));c=this.X.add(new O.$_o(g))}return this.X.add(c.onDidChangeStorage(g=>this.u(0,g))),c}hb($){this.$.clear(),this.Z=$?.id;let c;if($){const g=this.$.add(new S.$FEb(this.db.getChannel("storage"),$));c=this.$.add(new O.$_o(g)),this.$.add(c.onDidChangeStorage(p=>this.u(1,p)))}return c}async O(){await D.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P($){switch($){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q($){switch($){case-1:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,j.$Bg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(C.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R($){if(!this.M(this.W,$))return;const c=this.Y,g=c.items;c!==this.U&&await c.close(),this.Y=this.gb($),await this.Y.init(),this.N(g,this.Y,0)}async S($,c){const g=this.ab,p=g?.items??new Map;await g?.close(),this.ab=this.hb($),await this.ab.init(),this.N(p,this.ab,1)}hasScope($){return(0,b.$Tk)($)?this.W.id===$.id:this.Z===$.id}}e.$v$b=R}),define(le[253],he([0,1,3,2,17,92]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9N=e.$8N=void 0;class O{constructor(b,R){this.a=b,this.b=R}listen(b,R){const k=this.b(b);switch(R){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,$=>({all:$.all.map(c=>(0,j.$Xm)({...c},k)),added:$.added.map(c=>(0,j.$Xm)({...c},k)),removed:$.removed.map(c=>(0,j.$Xm)({...c},k)),updated:$.updated.map(c=>(0,j.$Xm)({...c},k))}))}throw new Error(`Invalid listen ${R}`)}async call(b,R,k){const $=this.b(b);switch(R){case"createProfile":{const c=await this.a.createProfile(k[0],k[1],k[2]);return(0,j.$Xm)({...c},$)}case"updateProfile":{let c=(0,L.$Vk)((0,j.$Ym)(k[0],$),this.a.profilesHome.scheme);return c=await this.a.updateProfile(c,k[1]),(0,j.$Xm)({...c},$)}case"removeProfile":{const c=(0,L.$Vk)((0,j.$Ym)(k[0],$),this.a.profilesHome.scheme);return this.a.removeProfile(c)}}throw new Error(`Invalid call ${R}`)}}e.$8N=O;class C extends N.$Rc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(b,R,k){super(),this.profilesHome=R,this.f=k,this.a=[],this.b=this.B(new D.$Rd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=b.map($=>(0,L.$Vk)($,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")($=>{const c=$.added.map(w=>(0,L.$Vk)(w,this.profilesHome.scheme)),g=$.removed.map(w=>(0,L.$Vk)(w,this.profilesHome.scheme)),p=$.updated.map(w=>(0,L.$Vk)(w,this.profilesHome.scheme));this.a=$.all.map(w=>(0,L.$Vk)(w,this.profilesHome.scheme)),this.b.fire({added:c,removed:g,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(b){this.c=b}isEnabled(){return this.c}async createNamedProfile(b,R,k){const $=await this.f.call("createNamedProfile",[b,R,k]);return(0,L.$Vk)($,this.profilesHome.scheme)}async createProfile(b,R,k,$){const c=await this.f.call("createProfile",[b,R,k,$]);return(0,L.$Vk)(c,this.profilesHome.scheme)}async createTransientProfile(b){const R=await this.f.call("createTransientProfile",[b]);return(0,L.$Vk)(R,this.profilesHome.scheme)}async setProfileForWorkspace(b,R){await this.f.call("setProfileForWorkspace",[b,R])}removeProfile(b){return this.f.call("removeProfile",[b])}async updateProfile(b,R){const k=await this.f.call("updateProfile",[b,R]);return(0,L.$Vk)(k,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$9N=C}),define(le[60],he([0,1,2,68,4,21,3,77,17]),function(ne,e,D,N,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JEb=e.$IEb=e.$HEb=void 0,e.$HEb=(0,L.$Zh)("IUserDataProfileStorageService");let b=class extends D.$Rc{constructor(c){super(),this.a=c}async readStorageData(c){return this.withProfileScopedStorageService(c,async g=>this.b(g))}async updateStorageData(c,g,p){return this.withProfileScopedStorageService(c,async w=>this.c(w,g,p))}async withProfileScopedStorageService(c,g){if(this.a.hasScope(c))return g(this.a);const p=await this.g(c),w=new k(p);try{await w.initialize();const l=await g(w);return await w.flush(),l}finally{w.dispose(),await this.f(p)}}b(c){const g=new Map,p=w=>{for(const l of c.keys(0,w))g.set(l,{value:c.get(l,0),target:w})};return p(0),p(1),g}c(c,g,p){c.storeAll(Array.from(g.entries()).map(([w,l])=>({key:w,value:l,scope:0,target:p})),!0)}async f(c){try{await c.close()}finally{(0,D.$Lc)(c)&&c.dispose()}}};e.$IEb=b,e.$IEb=b=ye([Q(0,j.$dp)],b);class R extends b{constructor(c,g,p,w){super(p),this.j=c;const l=c.getChannel("profileStorageListener"),u=this.B(new D.$Sc);this.h=this.B(new O.$Rd({onWillAddFirstListener:()=>{u.value=l.listen("onDidChange")(h=>{w.trace("profile storage changes",h),this.h.fire({targetChanges:h.targetChanges.map(d=>(0,S.$Vk)(d,g.profilesHome.scheme)),valueChanges:h.valueChanges.map(d=>({...d,profile:(0,S.$Vk)(d.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(c){const g=this.j.getChannel("storage");return(0,j.$gp)(c)?new C.$DEb(g):new C.$EEb(g,c)}}e.$JEb=R;class k extends j.$fp{constructor(c){super({flushInterval:100}),this.s=this.B(new N.$_o(c))}O(){return this.s.init()}P(c){return c===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[254],he([0,1,21,8,17,56,60]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a$b=void 0;let C=class extends O.$JEb{constructor(b,R,k,$){super(b,R,k,$)}};e.$a$b=C,e.$a$b=C=ye([Q(0,j.$y0b),Q(1,L.$Uk),Q(2,D.$dp),Q(3,N.$hj)],C)}),define(le[39],he([0,1,18,6,15,26,3,35,2,27,12,169,20,14,11,8,43,21,22,28,24,17]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u,h,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BFb=e.$AFb=e.$zFb=e.$yFb=e.$xFb=e.$wFb=e.$vFb=void 0;function s(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||o(v.syncData)))}e.$vFb=s;function o(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$wFb=o;function n(v,m){return`${(0,b.$uf)(v)}${m.isDefault?"":` (${m.name})`}`}e.$xFb=n;let i=class extends S.$Rc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(m,f,y,I,F,T,M,U,Y,J,x,W){super(),this.syncResource=m,this.collection=f,this.G=y,this.H=I,this.I=F,this.J=T,this.L=M,this.M=U,this.N=Y,this.O=J,this.P=x,this.c=null,this.m="idle",this.n=this.B(new O.$Rd),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$Rd),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$Xg(50)),this.w=this.B(new O.$Rd),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(m.syncResource,m.profile),this.h=W.extUri,this.f=this.h.joinPath(I.userDataSyncHome,...(0,d.$vhb)(m.profile.isDefault?void 0:m.profile.id,m.syncResource)),this.g=this.h.joinPath(this.f,d.$Qhb),this.y=(0,d.$whb)(m.profile.isDefault?void 0:m.profile.id,m.syncResource,I,this.h),this.j=(0,w.$jp)(I,y,F)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const m=await this.c;this.c=null;const f=await this.Y(m.remoteUserData,m.lastSyncUserData,!0,this.ob());this.S(f)}else{this.O.trace(`${this.D}: Checking for local changes...`);const m=await this.getLastSyncUserData();(m?await this.ub(m):!0)&&this.w.fire()}}S(m){this.m!==m&&(this.m=m,this.n.fire(m))}async sync(m,f={}){await this.U(m,!0,this.ob(),f)}async preview(m,f,y={}){return this.U(m,!1,f,y)}async apply(m,f={}){try{this.F={...f};const y=await this.ab(m);return this.S(y),this.c}finally{this.F={}}}async U(m,f,y,I){try{if(this.F={...I},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let F="idle";try{const T=await this.getLastSyncUserData(),M=await this.X(m,T);return F=await this.Y(M,T,f,y),F==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(F)}}finally{this.F={}}}async replace(m){const f=this.kb(m);if(!f)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const y=await this.getLastSyncUserData(),I=await this.X(null,y),F=await this.W(I),T=await this.qb({ref:I.ref,syncData:f},y,F,this.ob(),j.CancellationToken.None),M=[];for(const U of T){const Y=await this.sb(U,U.remoteResource,void 0,j.CancellationToken.None),{remoteChange:J}=await this.sb(U,U.previewResource,U.remoteContent,j.CancellationToken.None);M.push([U,{...Y,remoteChange:J!==0?J:2}])}await this.tb(I,y,M,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(m){const f=await this.j;return!!m.syncData?.machineId&&m.syncData.machineId===f}async X(m,f){if(f){const y=m?m[this.resource]:void 0;if(f.ref===y||y===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async Y(m,f,y,I){if(m.syncData&&m.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new d.$Dhb((0,k.localize)(0,null,this.resource,this.pb,m.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(m,f,y,I)}catch(F){if(F instanceof d.$Dhb)switch(F.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(m,f,y,I);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),m=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.Y(m,f,y,I)}throw F}}async Z(m,f,y,I){try{const F=await this.W(m),T=!F&&f===null&&this.gb()!==void 0,M=y&&!T;this.c||(this.c=(0,N.$Ng)(Y=>this.eb(m,f,F,M,I,Y)));let U=await this.c;if(y&&T){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of U.resourcePreviews)U=await this.accept(Y.remoteResource)||U}return this.cb(U.resourcePreviews),U.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":y?await this.ab(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(m){return await this.$(m,async f=>{const y=await this.rb(f,j.CancellationToken.None);await this.G.writeFile(f.previewResource,L.$fe.fromString(y?.content||""));const I=y&&!y.hasConflicts?await this.sb(f,f.previewResource,void 0,j.CancellationToken.None):void 0;return f.acceptResult=I,f.mergeState=y.hasConflicts?"conflict":I?"accepted":"preview",f.localChange=I?I.localChange:y.localChange,f.remoteChange=I?I.remoteChange:y.remoteChange,f}),this.c}async accept(m,f){return await this.$(m,async y=>{const I=await this.sb(y,m,f,j.CancellationToken.None);return y.acceptResult=I,y.mergeState="accepted",y.localChange=I.localChange,y.remoteChange=I.remoteChange,y}),this.c}async discard(m){return await this.$(m,async f=>{const y=await this.rb(f,j.CancellationToken.None);return await this.G.writeFile(f.previewResource,L.$fe.fromString(y.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=y.localChange,f.remoteChange=y.remoteChange,f}),this.c}async $(m,f){if(!this.c)return;let y=await this.c;const I=y.resourcePreviews.findIndex(({localResource:F,remoteResource:T,previewResource:M})=>this.h.isEqual(F,m)||this.h.isEqual(T,m)||this.h.isEqual(M,m));I!==-1&&(this.c=(0,N.$Ng)(async F=>{const T=[...y.resourcePreviews];return T[I]=await f(T[I]),{...y,resourcePreviews:T}}),y=await this.c,this.cb(y.resourcePreviews),y.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(m){if(!this.c)return"idle";const f=await this.c;return f.resourcePreviews.some(({mergeState:y})=>y==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:y})=>y!=="accepted")?"syncing":(await this.tb(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(y=>[y,y.acceptResult]),m),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(m){const f=m.filter(({mergeState:y})=>y==="conflict");(0,D.$tb)(this.s,f,(y,I)=>this.h.isEqual(y.previewResource,I.previewResource))||(this.s=f,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const m=await this.getLastSyncUserData();return!!m&&m.syncData!==null}async db(m){const f=this.c?await this.c:null;if(f)for(const y of f.resourcePreviews){if(this.h.isEqual(y.acceptedResource,m))return y.acceptResult?y.acceptResult.content:null;if(this.h.isEqual(y.remoteResource,m))return y.remoteContent;if(this.h.isEqual(y.localResource,m))return y.localContent;if(this.h.isEqual(y.baseResource,m))return y.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(m){(0,g.$zk)(m)!==1&&this.O.error(m)}}async eb(m,f,y,I,F,T){const M=await this.qb(m,f,y,F,T),U=[];for(const Y of M){const J=Y.previewResource.with({scheme:d.$Phb,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)U.push({...Y,acceptedResource:J,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=I?await this.rb(Y,T):void 0;if(T.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,L.$fe.fromString(x?.content||""));const W=x&&!x.hasConflicts?await this.sb(Y,Y.previewResource,void 0,T):void 0;U.push({...Y,acceptResult:W,mergeState:x?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:x?x.localChange:Y.localChange,remoteChange:W?W.remoteChange:x?x.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:m,lastSyncUserData:f,resourcePreviews:U,isLastSyncFromCurrentMachine:y}}async getLastSyncUserData(){let m=this.gb();if(m||(m=await this.jb()),!m)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const f=JSON.parse(m),y=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!f.version&&!!y&&f.version!==y,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${y}.`),await this.resetLocal(),null;let I,F=1;for(;I===void 0&&F++<6;)try{const T=await this.hb();T&&(T.ref===f.ref?I=T.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(T){if(T instanceof g.$Dk&&T.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(T instanceof d.$Dhb)throw T;this.O.error(T,F)}}if(I===void 0)try{const T=await this.J.resolveResourceContent(this.resource,f.ref,this.collection,this.F);I=T===null?null:this.kb(T),await this.ib({ref:f.ref,syncData:I})}catch(T){if(T instanceof d.$Dhb&&T.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw T}return I===void 0?null:{...f,syncData:I}}async fb(m,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const y=this.M.getResourceSyncStateVersion(this.resource),I={ref:m.ref,version:y,...f};this.I.store(this.z,JSON.stringify(I),-1,1),await this.ib(m)}gb(){return this.I.get(this.z,-1)}async hb(){const m=(await this.G.readFile(this.y)).value.toString();try{const f=m?JSON.parse(m):void 0;if(s(f))return f}catch(f){this.O.error(f)}}async ib(m){await this.G.writeFile(this.y,L.$fe.fromString(JSON.stringify(m)))}async jb(){try{const m=await this.G.readFile(this.y),f=JSON.parse(m.value.toString());await this.G.del(this.y),f.ref&&f.content!==void 0?(this.I.store(this.z,JSON.stringify({...f,content:void 0}),-1,1),await this.ib({ref:f.ref,syncData:f.content===null?null:JSON.parse(f.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,f)}catch(m){m instanceof g.$Dk&&m.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(m)}return this.I.get(this.z,-1)}async getRemoteUserData(m){const{ref:f,content:y}=await this.lb(m);let I=null;return y!==null&&(I=this.kb(y)),{ref:f,syncData:I}}kb(m){try{const f=JSON.parse(m);if(o(f))return f}catch(f){this.O.error(f)}throw new d.$Dhb((0,k.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(m){const f=m?{ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null}:null;return this.J.readResource(this.resource,f,this.collection,this.F)}async mb(m,f){const y=await this.j,I={version:this.pb,machineId:y,content:m};try{return f=await this.J.writeResource(this.resource,JSON.stringify(I),f,this.collection,this.F),{ref:f,syncData:I}}catch(F){throw F instanceof d.$Dhb&&F.code==="TooLarge"&&(F=new d.$Dhb(F.message,F.code,this.resource)),F}}async nb(m){const f={version:this.pb,content:m};return this.L.writeResource(this.resource,JSON.stringify(f),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(d.$qhb)}};e.$yFb=i,e.$yFb=i=ye([Q(2,g.$ik),Q(3,c.$7h),Q(4,l.$dp),Q(5,d.$yhb),Q(6,d.$zhb),Q(7,d.$Ihb),Q(8,u.$ml),Q(9,d.$Nhb),Q(10,$.$ti),Q(11,h.$Sk)],i);let t=class extends i{constructor(m,f,y,I,F,T,M,U,Y,J,x,W,X){super(f,y,I,F,T,M,U,Y,J,x,W,X),this.r=m,this.B(this.G.watch(this.h.dirname(m))),this.B(this.G.onDidFilesChange(V=>this.yb(V)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(m,f,y){try{f?await this.G.writeFile(this.r,L.$fe.fromString(m),y?void 0:f):await this.G.createFile(this.r,L.$fe.fromString(m),{overwrite:y})}catch(I){throw I instanceof g.$Dk&&I.fileOperationResult===1||I instanceof g.$Dk&&I.fileOperationResult===3?new d.$Dhb(I.message,"LocalPreconditionFailed"):I}}async xb(){try{await this.G.del(this.r)}catch(m){if(!(m instanceof g.$Dk&&m.fileOperationResult===1))throw m}}yb(m){m.contains(this.r)&&this.Q()}};e.$zFb=t,e.$zFb=t=ye([Q(3,g.$ik),Q(4,c.$7h),Q(5,l.$dp),Q(6,d.$yhb),Q(7,d.$zhb),Q(8,d.$Ihb),Q(9,u.$ml),Q(10,d.$Nhb),Q(11,$.$ti),Q(12,h.$Sk)],t);let r=class extends t{constructor(m,f,y,I,F,T,M,U,Y,J,x,W,X,V){super(m,f,y,I,F,T,M,U,Y,J,x,X,V),this.zb=W,this.Bb=void 0}Ab(m,f){const y=[],I=(0,C.$7m)(m,y,{allowEmptyContent:!0,allowTrailingComma:!0});return y.length>0||!(0,R.$Jf)(I)&&f!==Array.isArray(I)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$AFb=r,e.$AFb=r=ye([Q(3,g.$ik),Q(4,c.$7h),Q(5,l.$dp),Q(6,d.$yhb),Q(7,d.$zhb),Q(8,d.$Ihb),Q(9,u.$ml),Q(10,d.$Nhb),Q(11,d.$Mhb),Q(12,$.$ti),Q(13,h.$Sk)],r);let a=class{constructor(m,f,y,I,F,T,M){this.resource=m,this.g=f,this.h=y,this.j=I,this.k=F,this.l=T,this.d=M.extUri,this.f=(0,d.$whb)(void 0,this.resource,y,this.d)}async initialize({ref:m,content:f}){if(!f){this.j.info("Remote content does not exist.",this.resource);return}const y=this.m(f);if(y)try{await this.o({ref:m,syncData:y})}catch(I){this.j.error(I)}}m(m){try{const f=JSON.parse(m);if(o(f))return f}catch(f){this.j.error(f)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(m,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const y={ref:m.ref,version:void 0,...f};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(y),-1,1),await this.k.writeFile(this.f,L.$fe.fromString(JSON.stringify(m)))}};e.$BFb=a,e.$BFb=a=ye([Q(1,E.$Uk),Q(2,c.$7h),Q(3,p.$hj),Q(4,g.$ik),Q(5,l.$dp),Q(6,h.$Sk)],a)}),define(le[115],he([0,1,6,26,7,3,42,2,27,20,14,114,29,33,82,44,11,4,73,8,21,22,28,17,39,234,111,24,60]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u,h,d,E,s,o,n,i,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P5b=e.$O5b=e.$N5b=e.$M5b=e.$L5b=void 0;async function v(T,M){const U=JSON.parse(T.content);if(T.version===1||T.version===2){const Y=(await M.getInstalled(0)).filter(J=>J.isBuiltin);for(const J of U)T.version===1&&(J.enabled===!1&&(J.disabled=!0),delete J.enabled),T.version===2&&Y.every(x=>!(0,c.$Jo)(x.identifier,J.identifier))&&(J.installed=!0)}return U}function m(T){return JSON.parse(T.content)}e.$L5b=m;function f(T,M){return T.sort((U,Y)=>!U.identifier.uuid&&Y.identifier.uuid?-1:U.identifier.uuid&&!Y.identifier.uuid?1:(0,S.$Ye)(U.identifier.id,Y.identifier.id)),M?(0,O.$ET)(T,{}):JSON.stringify(T)}e.$M5b=f;let y=class extends n.$yFb{constructor(M,U,Y,J,x,W,X,V,B,te,se,_,re,K,z,P,A){super({syncResource:"extensions",profile:M},U,J,Y,x,W,X,_,re,te,se,z),this.Cb=V,this.Db=B,this.Eb=A,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Phb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Phb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Phb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Phb,authority:"accepted"}),this.Bb=this.Eb.createInstance(I),this.B(j.Event.any(j.Event.filter(this.Cb.onDidInstallExtensions,G=>G.some(({local:q})=>!!q)),j.Event.filter(this.Cb.onDidUninstallExtension,G=>!G.error),j.Event.filter(P.onDidChange,G=>G.valueChanges.some(({profile:q,changes:ee})=>this.syncResource.profile.id===q.id&&ee.some(H=>H.key===$.$ko))),K.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(M,U){const Y=M.syncData?await v(M.syncData,this.Cb):null,J=U?.skippedExtensions??[],x=U?.builtinExtensions??null,W=U?.syncData?await v(U.syncData,this.Cb):null,{localExtensions:X,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:te}=(0,i.$K5b)(X,Y,W,J,V,x),se={local:B,remote:te,content:this.Hb(X,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:te!==null?2:0},_=this.Ob(X,!1);return[{skippedExtensions:J,builtinExtensions:x,baseResource:this.xb,baseContent:W?this.Ob(W,!1):_,localResource:this.yb,localContent:_,localExtensions:X,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:se,localChange:se.localChange,remoteChange:se.remoteChange,acceptedResource:this.Ab}]}async ub(M){const U=M.syncData?await v(M.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$K5b)(Y,U,U,M.skippedExtensions||[],J,M.builtinExtensions||[]);return x!==null}Hb(M,U,Y,J){const x=[...U,...Y],W=new Set,X=V=>{W.add(V.id.toLowerCase()),V.uuid&&W.add(V.uuid)};x.forEach(({identifier:V})=>X(V)),J.forEach(X);for(const V of M)W.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&W.has(V.identifier.uuid)||x.push(V);return this.Ob(x,!1)}async rb(M,U){return{...M.previewResult,hasConflicts:!1}}async sb(M,U,Y,J){if(this.h.isEqual(U,this.yb))return this.Kb(M);if(this.h.isEqual(U,this.zb))return this.Lb(M);if(this.h.isEqual(U,this.wb))return M.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async Kb(M){const U=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(U),J=(0,i.$K5b)(M.localExtensions,null,null,M.skippedExtensions,Y,M.builtinExtensions),{local:x,remote:W}=J;return{content:M.localContent,local:x,remote:W,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Lb(M){const U=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(U),J=M.remoteContent?JSON.parse(M.remoteContent):null;if(J!==null){const x=(0,i.$K5b)(M.localExtensions,J,M.localExtensions,[],Y,M.builtinExtensions),{local:W,remote:X}=x;return{content:M.remoteContent,local:W,remote:X,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:X!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(M,U,Y,J){let{skippedExtensions:x,builtinExtensions:W,localExtensions:X}=Y[0][0];const{local:V,remote:B,localChange:te,remoteChange:se}=Y[0][1];if(te===0&&se===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),te!==0&&(await this.nb(JSON.stringify(X)),x=await this.Bb.updateLocalExtensions(V.added,V.removed,V.updated,x,this.syncResource.profile)),B){this.O.trace(`${this.D}: Updating remote extensions...`);const _=JSON.stringify(B.all);M=await this.mb(_,J?null:M.ref),this.O.info(`${this.D}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(re=>re.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(re=>re.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(re=>re.identifier.id))}.`:""}`)}U?.ref!==M.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),W=this.Nb(X,W),await this.fb(M,{skippedExtensions:x,builtinExtensions:W}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`))}Nb(M,U){const Y=new Set,J=[];for(const x of M)Y.add(x.identifier.id.toLowerCase()),x.installed||J.push(x.identifier);if(U)for(const x of U)Y.has(x.id.toLowerCase())||J.push(x);return J}async resolveContent(M){if(this.h.isEqual(this.zb,M)||this.h.isEqual(this.xb,M)||this.h.isEqual(this.yb,M)||this.h.isEqual(this.Ab,M)){const U=await this.db(M);return U&&this.Ob(JSON.parse(U),!0)}return null}Ob(M,U){return f(M,U)}async hasLocalData(){try{const{localExtensions:M}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(M.some(U=>U.installed||U.disabled))return!0}catch{}return!1}};e.$N5b=y,e.$N5b=y=ye([Q(2,R.$7h),Q(3,w.$ik),Q(4,d.$dp),Q(5,r.$yhb),Q(6,r.$zhb),Q(7,$.$jo),Q(8,t.$gGb),Q(9,r.$Nhb),Q(10,b.$ti),Q(11,r.$Ihb),Q(12,E.$ml),Q(13,g.$7u),Q(14,s.$Sk),Q(15,a.$HEb),Q(16,l.$Yh)],y);let I=class{constructor(M,U,Y,J,x,W){this.a=M,this.b=U,this.c=Y,this.d=J,this.f=x,this.g=W}async getLocalExtensions(M){const U=await this.a.getInstalled(void 0,M.extensionsResource),Y=this.d.getIgnoredExtensions(U);return{localExtensions:await this.j(M,async(x,W)=>{const X=x.getDisabledExtensions();return U.map(V=>{const{identifier:B,isBuiltin:te,manifest:se,preRelease:_,pinned:re,isApplicationScoped:K}=V,z={identifier:B,preRelease:_,version:se.version,pinned:!!re};K&&!(0,p.$gm)(se)&&(z.isApplicationScoped=K),X.some(P=>(0,c.$Jo)(P,B))&&(z.disabled=!0),te||(z.installed=!0);try{const P=W.getKeysForSync({id:B.id,version:se.version});if(P){const A=W.getExtensionState(V,!0)||{};z.state=Object.keys(A).reduce((G,q)=>(P.includes(q)&&(G[q]=A[q]),G),{})}}catch(P){this.g.info(`${(0,n.$xFb)("extensions",M)}: Error while parsing extension state`,(0,L.$9)(P))}return z})}),ignoredExtensions:Y}}async updateLocalExtensions(M,U,Y,J,x){const W=(0,n.$xFb)("extensions",x),X=[],V=new Map,B=[],te=[],se=await this.a.getInstalled(void 0,x.extensionsResource);if((M.length||Y.length)&&await this.j(x,async(K,z)=>{await D.Promises.settled([...M,...Y].map(async P=>{const A=se.find(ee=>(0,c.$Jo)(ee.identifier,P.identifier));if(A&&A.isBuiltin){P.state&&A.manifest.version===P.version&&this.h(P.state,A,A.manifest.version,z),K.getDisabledExtensions().some(H=>(0,c.$Jo)(H,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${W}: Disabling extension...`,P.identifier.id),await K.disableExtension(P.identifier),this.g.info(`${W}: Disabled extension`,P.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,P.identifier.id),await K.enableExtension(P.identifier),this.g.info(`${W}: Enabled extension`,P.identifier.id))),B.push(P.identifier);return}const G=P.pinned?P.version:void 0,q=(await this.c.getExtensions([{...P.identifier,version:G,preRelease:G?void 0:P.preRelease}],N.CancellationToken.None))[0];if(P.state&&(A?A.manifest.version===P.version:q)&&this.h(P.state,A||q,A?.manifest.version,z),q)try{K.getDisabledExtensions().some(H=>(0,c.$Jo)(H,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${W}: Disabling extension...`,P.identifier.id,q.version),await K.disableExtension(q.identifier),this.g.info(`${W}: Disabled extension`,P.identifier.id,q.version)):(this.g.trace(`${W}: Enabling extension...`,P.identifier.id,q.version),await K.enableExtension(q.identifier),this.g.info(`${W}: Enabled extension`,P.identifier.id,q.version))),(!A||A.preRelease!==P.preRelease||A.pinned!==P.pinned||G&&A.manifest.version!==G)&&(await this.a.canInstall(q)?(X.push({extension:q,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:P.pinned&&!!P.version,installPreReleaseVersion:P.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:P.isApplicationScoped,context:{[$.$$n]:!0,[$.$_n]:!0}}}),V.set(q.identifier.id.toLowerCase(),P)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,q.displayName||q.identifier.id),te.push(P)))}catch(ee){te.push(P),this.g.error(ee),this.g.info(`${W}: Skipped synchronizing extension`,q.displayName||q.identifier.id)}else te.push(P),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,P.identifier.id)}))}),U.length){const K=se.filter(({identifier:z,isBuiltin:P})=>!P&&U.some(A=>(0,c.$Jo)(z,A)));await D.Promises.settled(K.map(async z=>{this.g.trace(`${W}: Uninstalling local extension...`,z.identifier.id),await this.a.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,z.identifier.id),B.push(z.identifier)}))}const _=await this.a.installGalleryExtensions(X);for(const{identifier:K,local:z,error:P,source:A}of _){const G=A;if(z)this.g.info(`${W}: Installed extension.`,K.id,G.version),B.push(K);else{const q=V.get(K.id.toLowerCase());q&&(te.push(q),this.g.info(`${W}: Skipped synchronizing extension`,G.displayName||G.identifier.id)),P instanceof $.$io&&[$.ExtensionManagementErrorCode.Incompatible,$.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(P.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,G.displayName||G.identifier.id):P&&this.g.error(P)}}const re=[];for(const K of J)B.some(z=>(0,c.$Jo)(z,K.identifier))||re.push(K);for(const K of te)re.some(z=>(0,c.$Jo)(z.identifier,K.identifier))||re.push(K);return re}h(M,U,Y,J){const x=J.getExtensionState(U,!0)||{},W=Y?J.getKeysForSync({id:U.identifier.id,version:Y}):void 0;W?W.forEach(X=>{x[X]=M[X]}):Object.keys(M).forEach(X=>x[X]=M[X]),J.setExtensionState(U,x,!0)}async j(M,U){return this.b.withProfileScopedStorageService(M,async Y=>{const J=new C.$Qc,x=this.f.createChild(new u.$Xh([d.$dp,Y])),W=J.add(x.createInstance(k.$6Db)),X=J.add(x.createInstance(g.$8u));try{return await U(W,X)}finally{J.dispose()}})}};e.$O5b=I,e.$O5b=I=ye([Q(0,$.$jo),Q(1,a.$HEb),Q(2,$.$ho),Q(3,t.$gGb),Q(4,l.$Yh),Q(5,r.$Nhb)],I);let F=class extends n.$BFb{constructor(M,U,Y,J,x,W,X,V){super("extensions",J,x,W,Y,X,V),this.p=M,this.q=U}async t(M){return M.syncData?await v(M.syncData,this.p):null}u(M,U){const Y=[],J=[],x=[];for(const W of M){if(this.q.hasToNeverSyncExtension(W.identifier.id))continue;const X=U.find(V=>(0,c.$Jo)(V.identifier,W.identifier));X?(Y.push(X),W.disabled&&x.push(W.identifier)):W.installed&&(J.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&x.push(W.identifier))}return{installedExtensions:Y,newExtensions:J,disabledExtensions:x,remoteExtensions:M}}};e.$P5b=F,e.$P5b=F=ye([Q(0,$.$jo),Q(1,t.$gGb),Q(2,w.$ik),Q(3,o.$Uk),Q(4,R.$7h),Q(5,h.$hj),Q(6,d.$dp),Q(7,s.$Sk)],F)}),define(le[116],he([0,1,15,7,3,35,42,5,32,20,14,11,8,43,21,22,28,39,79,238,24,17,60,4]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u,h,d,E,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HFb=e.$GFb=e.$FFb=e.$EFb=e.$DFb=void 0;const n="globalState.argv.",i=["locale"];function t(y,I){const F=y.storage?Object.keys(y.storage).sort():[],T={};return F.forEach(M=>T[M]=y.storage[M]),y.storage=T,I?(0,O.$ET)(y,{}):JSON.stringify(y)}e.$DFb=t;const r=1;let a=class extends l.$yFb{constructor(I,F,T,M,U,Y,J,x,W,X,V,B,te,se){super({syncResource:"globalState",profile:I},F,M,x,B,U,Y,W,X,J,V,te),this.Bb=T,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:d.$Phb,authority:"base"}),this.xb=this.vb.with({scheme:d.$Phb,authority:"local"}),this.yb=this.vb.with({scheme:d.$Phb,authority:"remote"}),this.zb=this.vb.with({scheme:d.$Phb,authority:"accepted"}),this.Ab=se.createInstance(v),this.B(M.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(M.onDidFilesChange,_=>_.contains(this.H.argvResource)),L.Event.filter(T.onDidChange,_=>!!(_.targetChanges.some(re=>this.syncResource.profile.id===re.id)||_.valueChanges.some(({profile:re,changes:K})=>this.syncResource.profile.id===re.id&&K.some(z=>z.target===0)))))(()=>this.Q()))}async qb(I,F,T){const M=I.syncData?JSON.parse(I.syncData.content):null;F=F===null&&T?I:F;const U=F&&F.syncData?JSON.parse(F.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);M?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const J=await this.Jb(U),{local:x,remote:W}=(0,h.$CFb)(Y.storage,M?M.storage:null,U?U.storage:null,J,this.O),X={content:null,local:x,remote:W,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:W.all!==null?2:0},V=t(Y,!1);return[{baseResource:this.wb,baseContent:U?t(U,!1):V,localResource:this.xb,localContent:V,localUserData:Y,remoteResource:this.yb,remoteContent:M?t(M,!1):null,previewResource:this.vb,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.zb,storageKeys:J}]}async ub(I){const F=I.syncData?JSON.parse(I.syncData.content):null;if(F===null)return!0;const T=await this.Ab.getLocalGlobalState(this.syncResource.profile),M=await this.Jb(F),{remote:U}=(0,h.$CFb)(T.storage,F.storage,F.storage,M,this.O);return U.all!==null}async rb(I,F){return{...I.previewResult,hasConflicts:!1}}async sb(I,F,T,M){if(this.h.isEqual(F,this.xb))return this.Gb(I);if(this.h.isEqual(F,this.yb))return this.Hb(I);if(this.h.isEqual(F,this.vb))return I.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Gb(I){return{content:I.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(I.localUserData.storage),removed:[],updated:[],all:I.localUserData.storage},localChange:0,remoteChange:2}}async Hb(I){if(I.remoteContent!==null){const F=JSON.parse(I.remoteContent),{local:T,remote:M}=(0,h.$CFb)(I.localUserData.storage,F.storage,null,I.storageKeys,this.O);return{content:I.remoteContent,local:T,remote:M,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:I.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(I,F,T,M){const{localUserData:U}=T[0][0],{local:Y,remote:J,localChange:x,remoteChange:W}=T[0][1];if(x===0&&W===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(U)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),W!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const X=JSON.stringify({storage:J.all});I=await this.mb(X,M?null:I.ref),this.O.info(`${this.D}: Updated remote ui state.${J.added.length?` Added: ${J.added}.`:""}${J.updated.length?` Updated: ${J.updated}.`:""}${J.removed.length?` Removed: ${J.removed}.`:""}`)}F?.ref!==I.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(I),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(I){if(this.h.isEqual(this.yb,I)||this.h.isEqual(this.wb,I)||this.h.isEqual(this.xb,I)||this.h.isEqual(this.zb,I)){const F=await this.db(I);return F&&t(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:I}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(I).length>1||I[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(I){const F=await this.Bb.readStorageData(this.syncResource.profile),T=[],M=[];for(const[J,x]of F)x.target===0?T.push(J):x.target===1&&M.push(J);const U=[...T,...M],Y=I?.storage?Object.keys(I.storage).filter(J=>!J.startsWith(n)&&!U.includes(J)&&F.get(J)!==void 0):[];if(!C.$o){const J=[...d.$uhb.map(x=>(0,d.$Hhb)(x)),d.$Ghb];Y.push(...J),M.push(...J)}return{user:T,machine:M,unregistered:Y}}};e.$EFb=a,e.$EFb=a=ye([Q(2,s.$HEb),Q(3,k.$ik),Q(4,d.$yhb),Q(5,d.$zhb),Q(6,d.$Nhb),Q(7,R.$7h),Q(8,d.$Ihb),Q(9,p.$ml),Q(10,b.$ti),Q(11,g.$dp),Q(12,w.$Sk),Q(13,o.$Yh)],a);let v=class{constructor(I,F,T,M){this.a=I,this.b=F,this.c=T,this.d=M}async getLocalGlobalState(I){const F={};if(I.isDefault){const M=await this.f(),U=(0,j.$7m)(M);for(const Y of i)U[Y]!==void 0&&(F[`${n}${Y}`]={version:1,value:U[Y]})}const T=await this.c.readStorageData(I);for(const[M,U]of T)U.value&&U.target===0&&(F[M]={version:1,value:U.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const I=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),I.value.toString()}catch(I){this.d.debug((0,N.$9)(I))}return"{}"}async writeLocalGlobalState({added:I,removed:F,updated:T},M){const U=(0,l.$xFb)("globalState",M),Y={},J=new Map,x=await this.c.readStorageData(M),W=(X,V)=>{for(const B of X){if(B.startsWith(n)){Y[B.substring(n.length)]=V?V[B].value:void 0;continue}if(V){const te=V[B];te.value!==x.get(B)?.value&&J.set(B,te.value)}else x.get(B)!==void 0&&J.set(B,void 0)}};if(W(Object.keys(I),I),W(Object.keys(T),T),W(F),Object.keys(Y).length){this.d.trace(`${U}: Updating locale...`);const X=await this.f();let V=X;for(const B of Object.keys(Y))V=(0,u.edit)(V,[B],Y[B],{});X!==V&&(this.d.trace(`${U}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.$fe.fromString(V)),this.d.info(`${U}: Updated locale.`)),this.d.info(`${U}: Updated locale`)}J.size&&(this.d.trace(`${U}: Updating global state...`),await this.c.updateStorageData(M,J,0),this.d.info(`${U}: Updated global state`,[...J.keys()]))}};e.$FFb=v,e.$FFb=v=ye([Q(0,k.$ik),Q(1,R.$7h),Q(2,s.$HEb),Q(3,d.$Nhb)],v);let m=class extends l.$BFb{constructor(I,F,T,M,U,Y){super("globalState",T,M,U,F,I,Y)}async o(I){const F=I.syncData?JSON.parse(I.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const T={},M={};for(const U of Object.keys(F.storage))U.startsWith(n)?T[U.substring(n.length)]=F.storage[U].value:this.l.get(U,0)===void 0&&(M[U]=F.storage[U].value);if(Object.keys(T).length){let U="{}";try{U=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(T))U=(0,u.edit)(U,[Y],T[Y],{});await this.k.writeFile(this.h.argvResource,D.$fe.fromString(U))}if(Object.keys(M).length){const U=[];for(const Y of Object.keys(M))U.push({key:Y,value:M[Y],scope:0,target:0});this.l.storeAll(U,!0)}}};e.$GFb=m,e.$GFb=m=ye([Q(0,g.$dp),Q(1,k.$ik),Q(2,E.$Uk),Q(3,R.$7h),Q(4,d.$Nhb),Q(5,w.$Sk)],m);let f=class{constructor(I,F,T,M,U){this.a=I,this.b=F,this.c=T,this.d=M,this.f=U}getSyncStoreType(I){return this.h(I)?.storage[d.$Ghb]?.value}async sync(I){const F=(0,d.$Chb)((0,S.$kg)());try{return await this.g(I,F)}catch(T){if(T instanceof d.$Dhb)switch(T.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(I,F)}throw T}}async g(I,F){const T=await this.a.readResource("globalState",null,void 0,F),M=this.h(T)||{storage:{}};M.storage[d.$Ghb]={value:I,version:r};const U=await(0,c.$jp)(this.c,this.d,this.b),Y={version:r,machineId:U,content:t(M,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),T.ref,void 0,F)}h({content:I}){if(!I)return null;const F=JSON.parse(I);if((0,l.$wFb)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};e.$HFb=f,e.$HFb=f=ye([Q(1,g.$dp),Q(2,R.$7h),Q(3,k.$ik),Q(4,$.$hj)],f)}),define(le[117],he([0,1,18,15,3,35,5,12,170,20,14,11,21,22,28,17,39,235,24]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T5b=e.$S5b=e.$R5b=void 0;function h(s,o,n){try{const i=JSON.parse(s);if(!o)return(0,C.$Jf)(i.all)?null:i.all;switch(O.OS){case 2:return(0,C.$Jf)(i.mac)?null:i.mac;case 3:return(0,C.$Jf)(i.linux)?null:i.linux;case 1:return(0,C.$Jf)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.$R5b=h;let d=class extends w.$AFb{constructor(o,n,i,t,r,a,v,m,f,y,I,F,T){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,m,f,y,i,t,v,F,r,I,a,T),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:u.$Phb,authority:"base"}),this.Gb=this.Eb.with({scheme:u.$Phb,authority:"local"}),this.Hb=this.Eb.with({scheme:u.$Phb,authority:"remote"}),this.Ib=this.Eb.with({scheme:u.$Phb,authority:"accepted"}),this.B(L.Event.filter(a.onDidChangeConfiguration,M=>M.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,i,t){const r=o.syncData?h(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&i?o:n;const a=n?this.Ob(n):null,v=await this.vb(),m=await this.Cb();let f=null,y=!1,I=!1,F=!1;if(r){let U=v?v.value.toString():"[]";if(U=U||"[]",this.Ab(U,!0))throw new u.$Dhb((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==U||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,l.$Q5b)(U,r,a,m,this.zb);Y.hasChanges&&(f=Y.mergeContent,F=Y.hasConflicts,y=F||Y.mergeContent!==U,I=F||Y.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=v.value.toString(),I=!0);const T={content:F?a:f,localChange:y?v?2:1:0,remoteChange:I?2:0,hasConflicts:F},M=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:M,localChange:T.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:T.remoteChange,previewResource:this.Eb,previewResult:T,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const i=await this.vb(),t=i?i.value.toString():"",r=await this.Cb(),a=await(0,l.$Q5b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,i,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return i===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,i,t){const{fileContent:r}=i[0][0];let{content:a,localChange:v,remoteChange:m}=i[0][1];if(v===0&&m===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new u.$Dhb((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),m!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const f=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(f,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,j.$7m)(o.value.toString());if((0,D.$Kb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:h(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let i={};try{i=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete i.all:i.all=o,O.OS){case 2:i.mac=o;break;case 3:i.linux=o;break;case 1:i.windows=o;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(u.$rhb)}};e.$S5b=d,e.$S5b=d=ye([Q(2,u.$yhb),Q(3,u.$zhb),Q(4,u.$Nhb),Q(5,b.$ti),Q(6,u.$Ihb),Q(7,k.$ik),Q(8,R.$7h),Q(9,$.$dp),Q(10,u.$Mhb),Q(11,c.$ml),Q(12,g.$Sk)],d);let E=class extends w.$BFb{constructor(o,n,i,t,r,a){super("keybindings",n,i,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$fe.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,j.$7m)(o.value.toString());return!(0,D.$Kb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return h(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$T5b=E,e.$T5b=E=ye([Q(0,k.$ik),Q(1,p.$Uk),Q(2,R.$7h),Q(3,u.$Nhb),Q(4,$.$dp),Q(5,g.$Sk)],E)}),define(le[118],he([0,1,15,3,171,20,75,14,29,11,21,22,28,17,39,239,24]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W5b=e.$V5b=e.$U5b=void 0;function l(E){return E&&E.settings&&typeof E.settings=="string"&&Object.keys(E).length===1}function u(E){const s=JSON.parse(E);return l(s)?s:{settings:E}}e.$U5b=u;let h=class extends g.$AFb{constructor(s,o,n,i,t,r,a,v,m,f,y,I,F,T){super(s.settingsResource,{syncResource:"settings",profile:s},o,n,i,t,r,a,y,I,v,m,f,T),this.Eb=F,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$Phb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$Phb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$Phb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$Phb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(s){const o=await this.getLastSyncUserData(),n=await this.X(s,o),i=this.Lb(n),t=new O.$Mn(w.$qhb);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(w.$qhb)||{}}async qb(s,o,n){const i=await this.vb(),t=await this.Cb(),r=this.Lb(s);o=o===null&&n?s:o;const a=o?this.Lb(o):null,v=await this.Pb();let m=null,f=!1,y=!1,I=!1;if(r){let U=i?i.value.toString().trim():"{}";U=U||"{}",this.Qb(U),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,p.$oEb)(U,r.settings,a?a.settings:null,v,[],t);m=Y.localContent||Y.remoteContent,f=Y.localContent!==null,y=Y.remoteContent!==null,I=Y.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),m=i.value.toString().trim()||"{}",this.Qb(m),y=!0);const F=i?i.value.toString():null,T=a?.settings??null,M={content:I?T:m,localChange:f?2:0,remoteChange:y?2:0,hasConflicts:I};return[{fileContent:i,baseResource:this.baseResource,baseContent:T,localResource:this.localResource,localContent:F,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async ub(s){const o=this.Lb(s);if(o===null)return!0;const n=await this.vb(),i=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,p.$oEb)(i||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(s,o){const n=await this.Cb(),i=await this.Pb();return{...s.previewResult,content:s.previewResult.content?(0,p.$nEb)(s.previewResult.content,"{}",i,n):null}}async sb(s,o,n,i){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:s.fileContent?(0,p.$nEb)(s.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:s.remoteContent!==null?(0,p.$nEb)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,p.$nEb)(n,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(s,o,n,i){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:v}=n[0][1];if(a===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,i),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const m=await this.Cb(),f=this.Lb(s),y=await this.Pb(r);r=(0,p.$nEb)(r,f?f.settings:"{}",y,m),this.O.trace(`${this.D}: Updating remote settings...`),s=await this.mb(JSON.stringify(this.Nb(r)),i?null:s.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(s),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.vb();if(s)return!(0,p.$pEb)(s.value.toString())}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.db(s):null}async db(s){let o=await super.db(s);if(o){const n=await this.Cb(),i=await this.Pb();o=(0,p.$nEb)(o,"{}",i,n)}return o}Lb(s){return s.syncData?this.Mb(s.syncData.content):null}Mb(s){try{return u(s)}catch(o){this.O.error(o)}return null}Nb(s){return{settings:s}}async Pb(s){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),N.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,p.$lEb)(o,this.P,s)}Qb(s){if(this.Ab(s,!1))throw new w.$Dhb((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$V5b=h,e.$V5b=h=ye([Q(2,b.$ik),Q(3,C.$7h),Q(4,R.$dp),Q(5,w.$yhb),Q(6,w.$zhb),Q(7,w.$Nhb),Q(8,w.$Mhb),Q(9,j.$ti),Q(10,w.$Ihb),Q(11,k.$ml),Q(12,S.$jo),Q(13,$.$Sk)],h);let d=class extends g.$BFb{constructor(s,o,n,i,t,r){super("settings",o,n,i,s,t,r)}async o(s){const o=s.syncData?this.p(s.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.$fe.fromString(o.settings)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$pEb)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}p(s){try{return u(s)}catch(o){this.j.error(o)}return null}};e.$W5b=d,e.$W5b=d=ye([Q(0,b.$ik),Q(1,c.$Uk),Q(2,C.$7h),Q(3,w.$Nhb),Q(4,R.$dp),Q(5,$.$Sk)],d)}),define(le[119],he([0,1,15,3,30,20,14,11,21,22,28,17,39,236,24]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$25b=e.$15b=e.$Z5b=void 0;function p(u){return JSON.parse(u.content)}e.$Z5b=p;let w=class extends $.$yFb{constructor(h,d,E,s,o,n,i,t,r,a,v,m){super({syncResource:"snippets",profile:h},d,s,E,o,n,i,a,v,t,r,m),this.pb=1,this.vb=h.snippetsHome,this.B(this.G.watch(E.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,f=>f.affects(this.vb))(()=>this.Q()))}async qb(h,d,E){const s=await this.Hb(),o=this.Gb(s),n=h.syncData?this.Fb(h.syncData):null;d=d===null&&E?h:d;const i=d&&d.syncData?this.Fb(d.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,c.$X5b)(o,n,i);return this.Bb(t,s,n||{},i||{})}async ub(h){const d=h.syncData?this.Fb(h.syncData):null;if(d===null)return!0;const E=await this.Hb(),s=this.Gb(E),o=(0,c.$X5b)(s,d,d);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(h,d){return h.previewResult}async sb(h,d,E,s){if(this.h.isEqualOrParent(d,this.g.with({scheme:g.$Phb,authority:"local"})))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:h.fileContent?h.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(d,this.g.with({scheme:g.$Phb,authority:"remote"})))return{content:h.remoteContent,localChange:h.remoteContent!==null?h.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(d,this.g))return E===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:E,localChange:E===null?h.fileContent!==null?3:0:2,remoteChange:E===null?h.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(h,d,E,s){const o=E.map(([n,i])=>({...n,acceptResult:i}));o.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,s)),o.some(({remoteChange:n})=>n!==0)&&(h=await this.Eb(o,h,s)),d?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(h,d,E,s){const o=new Map;for(const n of Object.keys(h.local.added)){const i={content:h.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"accepted"})})}for(const n of Object.keys(h.local.updated)){const i={content:h.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"accepted"})})}for(const n of h.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"accepted"})})}for(const n of Object.keys(h.remote.added)){const i={content:h.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"accepted"})})}for(const n of Object.keys(h.remote.updated)){const i={content:h.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"accepted"})})}for(const n of h.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"accepted"})})}for(const n of h.conflicts){const i={content:s[n]??null,hasConflicts:!0,localChange:d[n]?2:1,remoteChange:E[n]?2:1},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"local"}),fileContent:d[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"remote"}),remoteContent:E[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"accepted"})})}for(const n of Object.keys(d))if(!o.has(n)){const i={content:d[n]?d[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"local"}),fileContent:d[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"remote"}),remoteContent:E[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Phb,authority:"accepted"})})}return[...o.values()]}async resolveContent(h){return this.h.isEqualOrParent(h,this.g.with({scheme:g.$Phb,authority:"remote"}))||this.h.isEqualOrParent(h,this.g.with({scheme:g.$Phb,authority:"local"}))||this.h.isEqualOrParent(h,this.g.with({scheme:g.$Phb,authority:"base"}))||this.h.isEqualOrParent(h,this.g.with({scheme:g.$Phb,authority:"accepted"}))?this.db(h):null}async hasLocalData(){try{const h=await this.Hb();if(Object.keys(h).length)return!0}catch{}return!1}async Cb(h){const d={};for(const E of h)E.fileContent&&(d[this.h.basename(E.localResource)]=E.fileContent);await this.nb(JSON.stringify(this.Gb(d)))}async Db(h,d){for(const{fileContent:E,acceptResult:s,localResource:o,remoteResource:n,localChange:i}of h)if(i!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);i===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):i===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,D.$fe.fromString(s.content),{overwrite:d}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,D.$fe.fromString(s.content),d?void 0:E),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(h,d,E){const s=d.syncData?this.Fb(d.syncData):{},o=(0,L.$en)(s);for(const{acceptResult:n,localResource:i,remoteResource:t,remoteChange:r}of h)if(r!==0){const a=i?this.h.basename(i):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,c.$Y5b)(s,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),d=await this.mb(JSON.stringify(o),E?null:d.ref),this.O.info(`${this.D}: Updated remote snippets`)),d}Fb(h){return p(h)}Gb(h){const d={};for(const E of Object.keys(h))d[E]=h[E].value.toString();return d}async Hb(){const h={};let d;try{d=await this.G.resolve(this.vb)}catch(E){if(E instanceof C.$Dk&&E.fileOperationResult===1)return h;throw E}for(const E of d.children||[]){const s=E.resource,o=this.h.extname(s);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,s),i=await this.G.readFile(s);h[n]=i}}return h}};e.$15b=w,e.$15b=w=ye([Q(2,O.$7h),Q(3,C.$ik),Q(4,S.$dp),Q(5,g.$yhb),Q(6,g.$zhb),Q(7,g.$Nhb),Q(8,j.$ti),Q(9,g.$Ihb),Q(10,b.$ml),Q(11,R.$Sk)],w);let l=class extends $.$BFb{constructor(h,d,E,s,o,n){super("snippets",d,E,s,h,o,n)}async o(h){const d=h.syncData?JSON.parse(h.syncData.content):null;if(!d){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(d)){const o=d[s];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,s);await this.k.createFile(n,D.$fe.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(h)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(h){return h.fileOperationResult===1}}};e.$25b=l,e.$25b=l=ye([Q(0,C.$ik),Q(1,k.$Uk),Q(2,O.$7h),Q(3,g.$Nhb),Q(4,S.$dp),Q(5,R.$Sk)],l)}),define(le[120],he([0,1,15,20,14,11,21,22,28,17,39,24]),function(ne,e,D,N,L,j,O,C,S,b,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$55b=e.$45b=e.$35b=void 0;function $(w,l){try{return JSON.parse(w).tasks??null}catch(u){return l.error(u),null}}e.$35b=$;let c=class extends R.$zFb{constructor(l,u,h,d,E,s,o,n,i,t,r,a){super(l.tasksResource,{syncResource:"tasks",profile:l},u,n,i,t,h,d,o,r,E,s,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:k.$Phb,authority:"base"}),this.Cb=this.Ab.with({scheme:k.$Phb,authority:"local"}),this.Db=this.Ab.with({scheme:k.$Phb,authority:"remote"}),this.Eb=this.Ab.with({scheme:k.$Phb,authority:"accepted"})}async qb(l,u,h,d){const E=l.syncData?$(l.syncData.content,this.O):null;u=u===null&&h?l:u;const s=u?.syncData?$(u.syncData.content,this.O):null,o=await this.vb();let n=null,i=!1,t=!1,r=!1;if(l.syncData){const m=o?o.value.toString():null;if(!s||s!==m||s!==E){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const f=p(m,E,s);n=f.content,r=f.hasConflicts,i=f.hasLocalChanged,t=f.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?s:n,localChange:i?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:s,localResource:this.Cb,localContent:v,localChange:a.localChange,remoteResource:this.Db,remoteContent:E,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(l){const u=l?.syncData?$(l.syncData.content,this.O):null;if(u===null)return!0;const h=await this.vb(),d=h?h.value.toString():null,E=p(d,u,u);return E.hasLocalChanged||E.hasRemoteChanged}async rb(l,u){return l.previewResult}async sb(l,u,h,d){if(this.h.isEqual(u,this.Cb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.Db))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.Ab))return h===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:h,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(l,u,h,d){const{fileContent:E}=h[0][0],{content:s,localChange:o,remoteChange:n}=h[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),E&&await this.nb(JSON.stringify(this.Kb(E.value.toString()))),s?await this.wb(s,E,d):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(s));l=await this.mb(i,d?null:l.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(l){return this.h.isEqual(this.Db,l)||this.h.isEqual(this.Bb,l)||this.h.isEqual(this.Cb,l)||this.h.isEqual(this.Eb,l)?this.db(l):null}Kb(l){return l?{tasks:l}:{}}};e.$45b=c,e.$45b=c=ye([Q(2,k.$yhb),Q(3,k.$zhb),Q(4,k.$Nhb),Q(5,N.$ti),Q(6,k.$Ihb),Q(7,j.$ik),Q(8,L.$7h),Q(9,O.$dp),Q(10,C.$ml),Q(11,S.$Sk)],c);let g=class extends R.$BFb{constructor(l,u,h,d,E,s){super("tasks",u,h,d,l,E,s),this.c=this.g.defaultProfile.tasksResource}async o(l){const u=l.syncData?$(l.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.$fe.fromString(u)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$55b=g,e.$55b=g=ye([Q(0,j.$ik),Q(1,b.$Uk),Q(2,L.$7h),Q(3,k.$Nhb),Q(4,O.$dp),Q(5,S.$Sk)],g);function p(w,l,u){if(w===null&&l===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const h=u!==w,d=u!==l;return!h&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:h&&!d?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!h?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],he([0,1,42,20,14,11,21,22,28,17,39,237,24]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=e.$K7b=e.$J7b=void 0;let c=class extends R.$yFb{constructor(l,u,h,d,E,s,o,n,i,t,r,a,v){super({syncResource:"profiles",profile:l},u,d,E,s,o,n,r,a,i,t,v),this.vb=h,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:$.$Phb,authority:"base"}),this.localResource=this.previewResource.with({scheme:$.$Phb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:$.$Phb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:$.$Phb,authority:"accepted"}),this.B(h.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?p(l.syncData):null}async getRemoteSyncedProfiles(l){const u=await this.getLastSyncUserData(),h=await this.X(l,u);return h?.syncData?p(h.syncData):null}async qb(l,u,h){if(!this.vb.isEnabled())throw new $.$Dhb("Cannot sync profiles because they are disabled","LocalError");const d=l.syncData?p(l.syncData):null,E=u?.syncData?p(u.syncData):null,s=this.Db(),{local:o,remote:n}=(0,k.$I7b)(s,d,E,[]),i={local:o,remote:n,content:E?this.Eb(E):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=g(s,!1);return[{baseResource:this.baseResource,baseContent:E?this.Eb(E):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:d?this.Eb(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(l){const u=l?.syncData?p(l.syncData):null,h=this.Db(),{remote:d}=(0,k.$I7b)(h,u,u,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async rb(l,u){return{...l.previewResult,hasConflicts:!1}}async sb(l,u,h,d){if(this.h.isEqual(u,this.localResource))return this.Ab(l);if(this.h.isEqual(u,this.remoteResource))return this.Bb(l);if(this.h.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async Ab(l){const u=this.Db(),h=(0,k.$I7b)(u,null,null,[]),{local:d,remote:E}=h;return{content:l.localContent,local:d,remote:E,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:E!==null?2:0}}async Bb(l){const u=l.remoteContent?JSON.parse(l.remoteContent):null,h=[],d=[];for(const E of this.Db()){const s=u?.find(o=>o.id===E.id);s&&(h.push({id:E.id,name:E.name,collection:s.collection}),d.push(E))}if(u!==null){const E=(0,k.$I7b)(d,u,h,[]),{local:s,remote:o}=E;return{content:l.remoteContent,local:s,remote:o,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(l,u,h,d){const{local:E,remote:s,localChange:o,remoteChange:n}=h[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=h[0][0].remoteProfiles||[];if(i.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new $.$Dhb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb(g(this.Db(),!1));const t=[];for(const r of E.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of E.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of E.updated){const a=this.vb.profiles.find(v=>v.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=i.length+(s?.added.length??0)<=20;if(r)for(const a of s?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),i.push({id:a.id,name:a.name,collection:v,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of s?.removed||[])i.splice(i.findIndex(({id:v})=>a.id===v),1);for(const a of s?.updated||[]){const v=i.find(({id:m})=>a.id===m);v&&i.splice(i.indexOf(v),1,{...v,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(i,d?null:l.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&s?.added.length?` Added: ${JSON.stringify(s.added.map(a=>a.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(a=>a.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw a}for(const a of s?.removed||[])await this.J.deleteCollection(a.collection,this.F)}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,u){return this.mb(this.Eb(l),u)}async hasLocalData(){return this.Db().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const u=await this.db(l);return u&&(0,D.$ET)(JSON.parse(u),{})}return null}Db(){return this.vb.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Eb(l){return JSON.stringify([...l].sort((u,h)=>u.name.localeCompare(h.name)))}};e.$J7b=c,e.$J7b=c=ye([Q(2,b.$Uk),Q(3,j.$ik),Q(4,L.$7h),Q(5,O.$dp),Q(6,$.$yhb),Q(7,$.$zhb),Q(8,$.$Nhb),Q(9,N.$ti),Q(10,$.$Ihb),Q(11,C.$ml),Q(12,S.$Sk)],c);function g(w,l){const u=[...w].sort((h,d)=>h.name.localeCompare(d.name)).map(h=>({id:h.id,name:h.name}));return l?(0,D.$ET)(u,{}):JSON.stringify(u)}e.$K7b=g;function p(w){return JSON.parse(w.content)}e.$L7b=p}),define(le[255],he([0,1,3,2,5,14,21,22,24]),function(ne,e,D,N,L,j,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=void 0;const b="sync.enable";let R=class extends N.$Rc{constructor($,c,g,p){super(),this.c=$,this.f=c,this.g=g,this.h=p,this.a=new D.$Rd,this.onDidChangeEnablement=this.a.event,this.b=new D.$Rd,this.onDidChangeResourceEnablement=this.b.event,this.B($.onDidChangeValue(-1,void 0,this.B(new N.$Qc))(w=>this.m(w)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(b,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement($){$&&!this.canToggleEnablement()||(this.f.publicLog2(b,{enabled:$}),this.c.store(b,$,-1,1))}isResourceEnabled($){return this.c.getBoolean((0,S.$Hhb)($),-1,!0)}setResourceEnablement($,c){if(this.isResourceEnabled($)!==c){const g=(0,S.$Hhb)($);this.j(g,c)}}getResourceSyncStateVersion($){}j($,c){this.c.store($,c,-1,L.$o?0:1)}m($){if(b===$.key){this.a.fire(this.isEnabled());return}const c=S.$uhb.filter(g=>(0,S.$Hhb)(g)===$.key)[0];if(c){this.b.fire([c,this.isResourceEnabled(c)]);return}}};e.$w7b=R,e.$w7b=R=ye([Q(0,O.$dp),Q(1,C.$ml),Q(2,j.$7h),Q(3,S.$xhb)],R)}),define(le[256],he([0,1,6,15,64,2,19,20,14,11,17,24]),function(ne,e,D,N,L,j,O,C,S,b,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H7b=void 0;let $=class extends j.$Rc{constructor(g,p,w,l,u){super(),this.a=g,this.b=p,this.c=w,this.f=l,this.g=u,this.h()}async h(){for(const p of this.g.profiles)for(const w of k.$uhb)try{await this.m(this.j(w,p.isDefault?void 0:p.id))}catch(l){this.f.error(l)}let g;try{g=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,b.$zk)(p)!==1&&this.f.error(p);return}if(g.children){for(const p of g.children)if(p.isDirectory&&!this.g.profiles.some(w=>w.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(w){this.f.error(w)}}}async getAllResourceRefs(g,p,w){const l=this.j(g,p,w);try{const u=await this.b.resolve(l);if(u.children)return u.children.filter(d=>d.isFile&&!d.name.startsWith("lastSync")).sort().reverse().map(d=>({ref:d.name,created:this.n(d)}))}catch(u){if((0,b.$zk)(u)!==1)throw u}return[]}async resolveResourceContent(g,p,w,l){const u=this.j(g,w,l),h=(0,O.$Bg)(u,p);try{return(await this.b.readFile(h)).value.toString()}catch(d){return this.f.error(d),null}}async writeResource(g,p,w,l,u){const h=this.j(g,l,u),d=(0,O.$Bg)(h,`${(0,L.$om)(w).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,N.$fe.fromString(p))}catch(E){this.f.error(E)}}j(g,p,w=this.a.userDataSyncHome){return(0,O.$Bg)(w,...p?[p,g]:[g])}async m(g){try{try{if(!await this.b.exists(g))return}catch{return}const p=await this.b.resolve(g);if(p.children){const w=p.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=w.filter(d=>Date.now()-this.n(d)>l);const h=w.length-u.length;h<10&&(u=u.slice(10-h)),await D.Promises.settled(u.map(async d=>{this.f.info("Deleting from backup",d.resource.path),await this.b.del(d.resource)}))}}catch(p){this.f.error(p)}}n(g){return new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};e.$H7b=$,e.$H7b=$=ye([Q(0,S.$7h),Q(1,b.$ik),Q(2,C.$ti),Q(3,k.$Nhb),Q(4,R.$Uk)],$)}),define(le[83],he([0,1,3,2,5,27,175,14,11,4,25,43,21,24]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$nhb=e.$mhb=e.$lhb=void 0,e.$lhb=(0,b.$Zh)("IUserDataSyncMachinesService");const p="sync.currentMachineName",w="Safari",l="Chrome",u="Edge",h="Firefox",d="Android";function E(n){switch(n){case w:case l:case u:case h:case d:case(0,L.$h)(0):return!0}return!1}e.$mhb=E;function s(){return L.$G?w:L.$E?l:L.$H?u:L.$F?h:L.$I?d:(0,L.$h)(L.$o?0:L.$u)}let o=class extends N.$Rc{static{g=this}static{this.a=1}static{this.b="machines"}constructor(i,t,r,a,v,m){super(),this.h=r,this.j=a,this.m=v,this.n=m,this.c=this.B(new D.$Rd),this.onDidChange=this.c.event,this.g=null,this.f=(0,k.$jp)(i,t,r)}async getMachines(i){const t=await this.f;return(await this.s(i)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(i){const t=await this.f,r=await this.s(i);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:s()}),await this.t(r))}async removeCurrentMachine(i){const t=await this.f,r=await this.s(i),a=r.machines.filter(({id:v})=>v!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(i,t,r){const a=await this.s(r),v=a.machines.find(({id:m})=>m===i);if(v){v.name=t,await this.t(a);const m=await this.f;i===m&&this.h.store(p,t,-1,1)}}async setEnablements(i){const t=await this.s();for(const[r,a]of i){const v=t.machines.find(m=>m.id===r);v&&(v.disabled=a?void 0:!0)}await this.t(t)}r(i){const t=this.h.get(p,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${s()} (${this.n.nameShort})`,a=new RegExp(`${(0,j.$Je)(r)}\\s#(\\d+)`);let v=0;for(const m of i){const f=a.exec(m.name),y=f?parseInt(f[1]):0;v=y>v?y:v}return`${r} #${v+1}`}async s(i){this.g=await this.u(i);const t=this.w(this.g);if(t.version!==g.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return t}async t(i){const t=JSON.stringify(i),r=await this.j.writeResource(g.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(i){if(this.g){const t=i&&i.latest?i.latest[g.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(g.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.m.error(t)}return{version:g.a,machines:[]}}};e.$nhb=o,e.$nhb=o=g=ye([Q(0,C.$7h),Q(1,S.$ik),Q(2,$.$dp),Q(3,c.$yhb),Q(4,c.$Nhb),Q(5,R.$zj)],o)}),define(le[257],he([0,1,6,64,38,7,3,2,5,19,10,172,25,21,22,24,80,83]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N7b=void 0;const u="sync.disableMachineEventually",h="sync.sessionId",d="sync.storeUrl",E="sync.productQuality";let s=class extends C.$Rc{get n(){const i=this.H.get(d,-1);return i?R.URI.parse(i):void 0}set n(i){i?this.H.store(d,i.toString(),-1,1):this.H.remove(d,-1)}get s(){return this.H.get(E,-1)}set s(i){i?this.H.store(E,i,-1,1):this.H.remove(E,-1)}constructor(i,t,r,a,v,m,f,y,I,F){super(),this.u=t,this.w=r,this.y=a,this.z=v,this.C=m,this.D=f,this.F=y,this.G=I,this.H=F,this.a=this.B(new C.$Sc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$Rd),this.onError=this.h.event,this.S=[],this.f=this.B(new D.$Xg(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,b.$ug)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(f.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(T=>this.triggerSync([T],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,T])=>T)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:t}=this.L();i?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$om)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(h,-1),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const t=p.$Dhb.toUserDataSyncError(i);t instanceof p.$Fhb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?S.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(u,!0,-1,1),await(0,D.$1g)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(u,-1,!1)}R(){this.H.remove(u,-1)}async triggerSync(i,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$N7b=s,e.$N7b=s=ye([Q(0,$.$zj),Q(1,p.$xhb),Q(2,p.$yhb),Q(3,p.$Ihb),Q(4,p.$Jhb),Q(5,p.$Nhb),Q(6,w.$8Db),Q(7,g.$ml),Q(8,l.$lhb),Q(9,c.$dp)],s);class o extends C.$Rc{static{this.a="Interval"}constructor(i,t,r,a,v,m,f,y,I){super(),this.m=i,this.n=t,this.r=r,this.s=a,this.u=v,this.w=m,this.y=f,this.z=y,this.C=I,this.b=this.B(new C.$Sc),this.c=this.B(new O.$Rd),this.onDidStartSync=this.c.event,this.f=this.B(new O.$Rd),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,C.$Pc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,D.$2g)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(i,t){const r=(0,D.$Ng)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,j.$3)(v))return}return this.H(i,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,b.$ug)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!i&&(!(0,b.$ug)(t.defaultUrl,i.defaultUrl)||!(0,b.$ug)(t.insidersUrl,i.insidersUrl)||!(0,b.$ug)(t.stableUrl,i.stableUrl))}async H(i,t,r){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let a;try{await this.I(t,r)}catch(v){if(this.y.error(v),a=v,p.$Dhb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(m){this.y.error(m),a=m}}this.f.fire(a)}async I(i,t){if(this.h=await this.u.createSyncTask(this.g,i),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$Fhb((0,k.localize)(0,null),"DefaultServiceChanged"):new p.$Fhb((0,k.localize)(1,null),"ServiceChanged"):new p.$Fhb((0,k.localize)(2,null),"TurnedOff");const r=this.C.get(h,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new p.$Fhb((0,k.localize)(3,null),"DefaultServiceChanged"):new p.$Fhb((0,k.localize)(4,null),"ServiceChanged"):new p.$Fhb((0,k.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=a.find(f=>f.isCurrent);if(v?.disabled)throw new p.$Fhb((0,k.localize)(6,null),"TurnedOff");const m=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-m}),this.g===null)try{this.g=await this.s.manifest(null)}catch(f){throw new p.$Fhb((0,L.$Ki)(f),f instanceof p.$Dhb?f.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(h,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(le[258],he([0,1,10,176,14,11,43,21,28,24,17,39,119,118,117,20,120,115,116,4,121,42,27]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u,h,d,E,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$l8b=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,v,m,f,y,I,F,T){this.e=t,this.f=r,this.g=a,this.h=m,this.i=f,this.j=y,this.k=I,this.l=F,this.n=T,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,d.$L7b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const v=this.L(a,"profiles");return(0,d.$L7b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(m=>({...m,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:m})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:m,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:m,ref:f})=>({created:m,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:f,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,O.$jp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,v,m){if(t){const{content:f}=await this.M(r,v,a);return f}return this.f.resolveResourceContent(r,v,a,m)}q(t,r,a){const v=this.L(r,t);switch(t){case"settings":return this.t(v,a);case"keybindings":return this.v(v,a);case"tasks":return this.x(v,a);case"snippets":return this.z(v,a);case"globalState":return this.E(v,a);case"extensions":return this.B(v,a);case"profiles":return this.H(v,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(v=>v.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,c.$U5b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,g.$R5b)(t.content,!!this.l.getValue(b.$rhb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,w.$35b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const v=this.L(a,"snippets");if(v){const m=(0,$.$Z5b)(v),f=[];for(const y of Object.keys(m)){const I=this.d.joinPath(t,y),F=r?this.d.joinPath(r.snippetsHome,y):this.d.joinPath(t,o.a);f.push({resource:I,comparableResource:F})}return f}}return[]}z(t,r){return(0,$.$Z5b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,l.$M5b)((0,l.$L5b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(l.$O5b).getLocalExtensions(t);return(0,l.$M5b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,u.$DFb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(u.$FFb).getLocalGlobalState(t);return(0,u.$DFb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,E.$ET)(JSON.parse(t.content),{})}return null}async I(t){return(0,d.$K7b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,s.$Me)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(D.URI.from({scheme:b.$Phb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==b.$Phb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let v,m;const f=[];let y,I,F,T,M;for(;r.length;){const U=r.shift();U.startsWith("scheme:")?v=U.substring(7):U.startsWith("authority:")?m=U.substring(10):U.startsWith("syncResource:")?y=U.substring(13):U.startsWith("profile:")?I=U.substring(8):U.startsWith("collection:")?F=U.substring(11):U.startsWith("ref:")?T=U.substring(4):y?M=U:f.push(U)}return{remote:a,syncResource:y,profile:I,collection:F,ref:T,node:M,location:v&&m!==void 0?this.d.joinPath(D.URI.from({scheme:v,authority:m,query:t.query,fragment:t.fragment,path:"/"}),...f):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,k.$wFb)(a))return a}catch(a){this.g.error(a)}throw new b.$Dhb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const v=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:v}}};e.$l8b=n,e.$l8b=n=o=ye([Q(0,b.$yhb),Q(1,b.$zhb),Q(2,b.$Nhb),Q(3,S.$Sk),Q(4,L.$7h),Q(5,C.$dp),Q(6,j.$ik),Q(7,R.$Uk),Q(8,p.$ti),Q(9,h.$Yh)],n)}),define(le[259],he([0,1,18,6,26,38,3,2,19,12,32,20,29,11,4,21,22,17,115,116,117,118,119,120,121,24]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u,h,d,E,s,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M7b=void 0;const t="sync.lastSyncTime";let r=class extends C.$Rc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(y,I,F,T,M,U,Y,J,x,W,X){super(),this.C=y,this.D=I,this.F=F,this.G=T,this.H=M,this.I=U,this.J=Y,this.L=J,this.M=x,this.N=W,this.O=X,this.f="uninitialized",this.g=this.B(new O.$Rd),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$Rd),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$Rd),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$Rd),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$Rd),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$Rd),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$Rd),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=F.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,C.$Pc)(()=>this.bb()))}async createSyncTask(y,I){this.cb(),this.H.info("Sync started.");const F=new Date().getTime(),T=(0,R.$kg)();try{const J=(0,i.$Chb)(T);I&&(J["Cache-Control"]="no-cache"),y=await this.D.manifest(y,J)}catch(J){const x=i.$Dhb.toUserDataSyncError(J);throw m(x,T,this.F,this.I),x}const M=!1,U=this;let Y;return{manifest:y,async run(){if(M)throw new Error("Can run a task only once");Y=(0,N.$Ng)(J=>U.P(y,!1,T,J)),await Y.finally(()=>Y=void 0),U.H.info(`Sync done. Took ${new Date().getTime()-F}ms`),U.$()},stop(){return Y?.cancel(),U.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new i.$Dhb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const y=new Date().getTime(),I=(0,R.$kg)(),F=(0,i.$Chb)(I);let T;try{T=await this.D.manifest(null,F)}catch(Y){const J=i.$Dhb.toUserDataSyncError(Y);throw m(J,I,this.F,this.I),J}await this.resetLocal();const M=this,U=new L.$2d;return{id:I,async merge(){return M.P(T,!0,I,U.token)},async apply(){try{try{await M.R(T,I,U.token)}catch(Y){if(i.$Dhb.toUserDataSyncError(Y).code==="MethodNotFound")M.H.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.H.info("Applying manual sync again..."),await M.R(T,I,U.token);else throw Y}}catch(Y){throw M.H.error(Y),Y}M.H.info(`Sync done. Took ${new Date().getTime()-y}ms`),M.$()},async stop(){U.cancel(),await M.U(),await M.resetLocal()}}}async P(y,I,F,T){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(M,y,I,F,T));const U=M.enabled.find(Y=>Y.resource==="profiles");if(U){const Y=await U.getLastSyncedProfiles()||[];if(T.isCancellationRequested)return;await this.Q(Y,y,I,F,T)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(y,I,F,T,M){for(const U of y){if(M.isCancellationRequested)return;const Y=this.M.profiles.find(x=>x.id===U.id);if(!Y){this.H.error(`Profile with id:${U.id} and name: ${U.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",U.name);const J=this.getOrCreateActiveProfileSynchronizer(Y,U);this.n.push(...await this.S(J,I,F,T,M))}for(const[U,Y]of this.z.entries())this.M.profiles.some(J=>J.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(U))}async R(y,I,F){const T=this.ab();for(const x of T){if(F.isCancellationRequested)return;await x.apply(I,F)}const M=T.find(x=>x.profile.isDefault);if(!M)return;const U=M.enabled.find(x=>x.resource==="profiles");if(!U)return;const J=(await U.getRemoteSyncedProfiles(y?.latest??null)||[]).filter(x=>T.every(W=>W.profile.id!==x.id));J.length&&await this.Q(J,y,!1,I,F)}async S(y,I,F,T,M){return(await y.sync(I,F,T,M)).map(([Y,J])=>({profile:y.profile,syncResource:Y,error:J}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(y=>y.stop()))}async resolveContent(y){const I=await this.N.resolveContent(y);if(I)return I;for(const F of this.ab())for(const T of F.enabled){const M=await T.resolveContent(y);if(M)return M}return null}async replace(y){this.cb();const I=this.N.resolveUserDataSyncResource(y);if(!I)return;const F=await this.resolveContent(y.uri);F&&await this.W(I.profile,async T=>{if(I.syncResource===T.resource)return await T.replace(F),!0})}async accept(y,I,F,T){this.cb(),await this.W(y.profile,async M=>{if(y.syncResource===M.resource)return await M.accept(I,F),T&&await M.apply((0,b.$If)(T)?!1:T.force,(0,i.$Chb)((0,R.$kg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async I=>{if(I.resource!=="globalState"&&await I.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async I=>{if(await I.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(y){this.H.error(y)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[y]of this.z.values())try{await y.resetLocal()}catch(I){this.H.error(I)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const y=await this.N.getRemoteSyncedProfiles(),I=y.map(U=>U.collection),F=await this.D.getAllCollections(),T=F.filter(U=>!I.includes(U));T.length&&(this.H.info(`Deleting ${T.length} redundant collections on server`),await Promise.allSettled(T.map(U=>this.D.deleteCollection(U))),this.H.info("Deleted redundant collections on server"));const M=y.filter(U=>F.includes(U.collection));if(M.length!==y.length){const U=this.G.createInstance(n.$J7b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await U.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await U.updateRemoteProfiles(M,null),this.H.info("Updated remote profiles on server")}finally{U.dispose()}}}async saveRemoteActivityData(y){this.cb();const I=await this.D.getActivityData();await this.C.writeFile(y,I)}async extractActivityData(y,I){const F=(await this.C.readFile(y)).value.toString(),T=JSON.parse(F);if(T.resources)for(const M in T.resources)for(const U of T.resources[M])await this.O.writeResource(M,U.content,new Date(U.created*1e3),void 0,I);if(T.collections)for(const M in T.collections)for(const U in T.collections[M].resources)for(const Y of T.collections[M].resources?.[U]??[])await this.O.writeResource(U,Y.content,new Date(Y.created*1e3),M,I)}async W(y,I){const F=new C.$Qc;try{const T=this.z.get(y.id);if(T){const x=await this.X(T[0],I,F);return(0,b.$Jf)(x)?null:x}if(y.isDefault){const x=F.add(this.G.createInstance(a,y,void 0)),W=await this.X(x,I,F);return(0,b.$Jf)(W)?null:W}if(this.M.isEnabled())return null;const M=F.add(this.G.createInstance(n.$J7b,y,void 0)),U=await this.D.manifest(null),J=(await M.getRemoteSyncedProfiles(U?.latest??null)||[]).find(x=>x.id===y.id);if(J){const x=F.add(this.G.createInstance(a,y,J.collection)),W=await this.X(x,I,F);return(0,b.$Jf)(W)?null:W}return null}finally{F.dispose()}}async X(y,I,F){const T=[...y.enabled,...y.disabled.reduce((M,U)=>(U!=="workspaceState"&&M.push(F.add(y.createSynchronizer(U))),M),[])];for(const M of T){const U=await I(M);if(!(0,b.$Jf)(U))return U}}Y(y){const I=this.f;this.f!==y&&(this.f=y,this.g.fire(y),I==="hasConflicts"&&this.$())}Z(){const y=this.ab().map(I=>I.conflicts).flat();(0,D.$tb)(this.j,y,(I,F)=>I.profile.id===F.profile.id&&I.syncResource===F.syncResource&&(0,D.$tb)(I.conflicts,F.conflicts,(T,M)=>(0,S.$ug)(T.previewResource,M.previewResource)))||(this.j=y,this.m.fire(y))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(y,I){let F=this.z.get(y.id);if(F&&F[0].collection!==I?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),F[1].dispose(),F=void 0,this.z.delete(y.id)),!F){const T=new C.$Qc,M=T.add(this.G.createInstance(a,y,I?.collection));T.add(M.onDidChangeStatus(U=>this.Y(U))),T.add(M.onDidChangeConflicts(U=>this.Z())),T.add(M.onDidChangeLocal(U=>this.h.fire(U))),this.z.set(y.id,F=[M,T])}return F[0]}ab(){const y=[];for(const[I]of this.z.values())y.push(I);return y}bb(){this.z.forEach(([,y])=>y.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$M7b=r,e.$M7b=r=ye([Q(0,c.$ik),Q(1,i.$yhb),Q(2,i.$xhb),Q(3,g.$Yh),Q(4,i.$Nhb),Q(5,w.$ml),Q(6,p.$dp),Q(7,i.$Ihb),Q(8,l.$Uk),Q(9,i.$Khb),Q(10,i.$zhb)],r);let a=class extends C.$Rc{get enabled(){return this.f.sort((y,I)=>y[1]-I[1]).map(([y])=>y)}get disabled(){return i.$uhb.filter(y=>!this.r.isResourceEnabled(y))}get status(){return this.g}get conflicts(){return this.m}constructor(y,I,F,T,M,U,Y,J,x,W){super(),this.profile=y,this.collection=I,this.r=F,this.t=T,this.u=M,this.w=U,this.y=Y,this.z=J,this.C=x,this.D=W,this.f=[],this.g="idle",this.h=this.B(new O.$Rd),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$Rd),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$Rd),this.onDidChangeConflicts=this.n.event,this.B(F.onDidChangeResourceEnablement(([X,V])=>this.F(X,V))),this.B((0,C.$Pc)(()=>this.f.splice(0,this.f.length).forEach(([,,X])=>X.dispose())));for(const X of i.$uhb)F.isResourceEnabled(X)&&this.G(X)}F(y,I){I?this.G(y):this.H(y)}G(y){if(this.f.some(([M])=>M.resource===y))return;if(y==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(y==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||y==="workspaceState")return;if(y!=="profiles"&&this.profile.useDefaultFlags?.[y]){this.z.debug(`Skipping syncing ${y} in ${this.profile.name} because it is already synced by default profile`);return}const I=new C.$Qc,F=I.add(this.createSynchronizer(y));I.add(F.onDidChangeStatus(()=>this.L())),I.add(F.onDidChangeConflicts(()=>this.M())),I.add(F.onDidChangeLocal(()=>this.j.fire(y)));const T=this.N(y);this.f.push([F,T,I])}H(y){const I=this.f.findIndex(([F])=>F.resource===y);if(I!==-1){const[[F,,T]]=this.f.splice(I,1);T.dispose(),this.L(),Promise.allSettled([F.stop(),F.resetLocal()]).then(null,M=>this.z.error(M))}}createSynchronizer(y){switch(y){case"settings":return this.t.createInstance(E.$V5b,this.profile,this.collection);case"keybindings":return this.t.createInstance(d.$S5b,this.profile,this.collection);case"snippets":return this.t.createInstance(s.$15b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$45b,this.profile,this.collection);case"globalState":return this.t.createInstance(h.$EFb,this.profile,this.collection);case"extensions":return this.t.createInstance(u.$N5b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$J7b,this.profile,this.collection)}}async sync(y,I,F,T){if(T.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const U=[],Y=(0,i.$Chb)(F),J=(this.collection?y?.collections?.[this.collection]?.latest:y?.latest)??null,x=I?await this.I(J):{};for(const W of M){if(T.isCancellationRequested)return[];if(!this.r.isResourceEnabled(W.resource))return[];try{if(I){const X=await W.preview(J,x,Y);if(X)for(const V of X.resourcePreviews)(V.localChange!==0||V.remoteChange!==0)&&V.mergeState==="preview"&&await W.merge(V.previewResource)}else await W.sync(J,Y)}catch(X){const V=i.$Dhb.toUserDataSyncError(X);if(m(V,F,this.w,this.y),v(X))throw V;this.z.error(X),this.z.error(`${W.resource}: ${(0,j.$Ki)(X)}`),U.push([W.resource,V])}}return U}finally{this.L()}}async apply(y,I){const F=(0,i.$Chb)(y);for(const T of this.enabled){if(I.isCancellationRequested)return;try{await T.apply(!1,F)}catch(M){const U=i.$Dhb.toUserDataSyncError(M);if(m(U,y,this.w,this.y),v(M))throw U;this.z.error(M),this.z.error(`${T.resource}: ${(0,j.$Ki)(M)}`)}}}async stop(){for(const y of this.enabled)try{y.status!=="idle"&&await y.stop()}catch(I){this.z.error(I)}}async resetLocal(){for(const y of this.enabled)try{await y.resetLocal()}catch(I){this.z.error(`${y.resource}: ${(0,j.$Ki)(I)}`),this.z.error(I)}}async I(y){if(!this.profile.isDefault)return{};const I=this.D.getValue(i.$qhb),F=this.enabled.find(T=>T instanceof E.$V5b);if(F){const T=await F.getRemoteUserDataSyncConfiguration(y);return{...I,...T}}return I}J(y){this.g!==y&&(this.g=y,this.h.fire(y))}L(){return this.M(),this.enabled.some(y=>y.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(y=>y.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const y=this.enabled.filter(I=>I.status==="hasConflicts").filter(I=>I.conflicts.conflicts.length>0).map(I=>I.conflicts);(0,D.$tb)(this.m,y,(I,F)=>I.syncResource===F.syncResource&&(0,D.$tb)(I.conflicts,F.conflicts,(T,M)=>(0,S.$ug)(T.previewResource,M.previewResource)))||(this.m=y,this.n.fire(y))}N(y){switch(y){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([Q(2,i.$Ihb),Q(3,g.$Yh),Q(4,$.$ho),Q(5,i.$xhb),Q(6,w.$ml),Q(7,i.$Nhb),Q(8,l.$Uk),Q(9,k.$ti)],a);function v(f){if(f instanceof i.$Dhb)switch(f.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function m(f,y,I,F){F.publicLog2("sync/error",{code:f.code,serverCode:f instanceof i.$Ehb?String(f.serverCode):void 0,url:f instanceof i.$Ehb?f.url:void 0,resource:f.resource,executionId:y,service:I.userDataSyncStore.url.toString()})}}),define(le[260],he([0,1,3,2,10,17,24]),function(ne,e,D,N,L,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_0b=e.$$0b=void 0;function C($,c){return{...$,profile:(0,j.$Vk)($.profile,c.profilesHome.scheme)}}function S($){return{created:$.created,uri:L.URI.revive($.uri)}}class b{constructor(c,g,p){this.c=c,this.d=g,this.f=p,this.a=new Map,this.b=new D.$Rd}listen(c,g){switch(g){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${g}`)}async call(c,g,p){try{return await this.g(c,g,p)}catch(w){throw this.f.error(w),w}}async g(c,g,p){switch(g){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(p[0]));case"accept":return this.c.accept(C(p[0],this.d),L.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(S(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(p[0]),L.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if(g.startsWith("manualSync/")){const w=g.substring(11),l=p[0],u=this.h(l);switch(p=p.slice(1),w){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(c){const g=this.a.get(this.j(c));if(!g)throw new Error(`Manual sync taks not found: ${c}`);return g}async i(){const c=await this.c.createManualSyncTask();return this.a.set(this.j(c.id),c),c.id}j(c){return`manualSyncTask-${c}`}}e.$$0b=b;let R=class extends N.$Rc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(c,g){super(),this.n=g,this.b="uninitialized",this.c=this.B(new D.$Rd),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.$Rd),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new D.$Rd),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new D.$Rd),this.onSyncErrors=this.m.event,this.a={call(p,w,l){return c.call(p,w,l).then(null,u=>{throw O.$Dhb.toUserDataSyncError(u)})},listen(p,w){return c.listen(p,w)}},this.a.call("_getInitialData").then(([p,w,l])=>{this.s(p),this.t(w),l&&this.u(l),this.B(this.a.listen("onDidChangeStatus")(u=>this.s(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.u(u)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(w=>({...w,error:O.$Dhb.toUserDataSyncError(w.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const c=await this.a.call("createManualSyncTask"),g=this;return new k(c,{async call(w,l,u){return g.a.call(`manualSync/${w}`,[c,...Array.isArray(l)?l:[l]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(c,g,p,w){return this.a.call("accept",[c,g,p,w])}resolveContent(c){return this.a.call("resolveContent",[c])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(c){return this.a.call("replace",[c])}saveRemoteActivityData(c){return this.a.call("getRemoteActivityData",[c])}extractActivityData(c,g){return this.a.call("extractActivityData",[c,g])}async s(c){this.b=c,this.c.fire(c)}async t(c){this.f=c.map(g=>({syncResource:g.syncResource,profile:(0,j.$Vk)(g.profile,this.n.profilesHome.scheme),conflicts:g.conflicts.map(p=>({...p,baseResource:L.URI.revive(p.baseResource),localResource:L.URI.revive(p.localResource),remoteResource:L.URI.revive(p.remoteResource),previewResource:L.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(c){this.h!==c&&(this.h=c,this.j.fire(c))}};e.$_0b=R,e.$_0b=R=ye([Q(1,j.$Uk)],R);class k extends N.$Rc{constructor(c,g){super(),this.id=c,this.a=g}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(le[261],he([0,1,6,26,7,3,2,139,5,19,12,10,32,20,14,11,25,59,43,21,24]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uFb=e.$tFb=e.$sFb=e.$rFb=e.$qFb=void 0;const E="configurationSync.store",s="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends O.$Rc{get userDataSyncStore(){return this.b}get c(){return this.h.get(d.$Ghb,-1)}set c(F){this.h.store(d.$Ghb,F,-1,S.$o?0:1)}constructor(F,T,M){super(),this.f=F,this.g=T,this.h=M,this.a=this.B(new j.$Rd),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const U=this.B(new O.$Qc);this.B(j.Event.filter(M.onDidChangeValue(-1,d.$Ghb,U),()=>this.c!==this.userDataSyncStore?.type,U)(()=>this.j()))}j(){this.b=this.m(this.f[E]),this.a.fire()}m(F){if(F&&(F=S.$o&&F.web?{...F,...F.web}:F,(0,R.$Cf)(F.url)&&(0,R.$Ef)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(T=>Array.isArray(F.authenticationProviders[T].scopes)))){const T=F,M=!!T.canSwitch,U=T.url===T.insidersUrl?"insiders":"stable",Y=(M?this.c:void 0)||U,J=Y==="insiders"?T.insidersUrl:Y==="stable"?T.stableUrl:T.url;return{url:k.URI.parse(J),type:Y,defaultType:U,defaultUrl:k.URI.parse(T.url),stableUrl:k.URI.parse(T.stableUrl),insidersUrl:k.URI.parse(T.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(T.authenticationProviders).reduce((x,W)=>(x.push({id:W,scopes:T.authenticationProviders[W].scopes}),x),[])}}}};e.$qFb=a,e.$qFb=a=ye([Q(0,w.$zj),Q(1,c.$ti),Q(2,h.$dp)],a);let v=class extends a{constructor(F,T,M){super(F,T,M);const U=this.h.get(s,-1);U&&(this.n=JSON.parse(U));const Y=this.f[E];Y?this.h.store(s,JSON.stringify(Y),-1,1):this.h.remove(s,-1)}async switch(F){F!==this.c&&(this.c=F,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$rFb=v,e.$rFb=v=ye([Q(0,w.$zj),Q(1,c.$ti),Q(2,h.$dp)],v);let m=class extends O.$Rc{get donotMakeRequestsUntil(){return this.j}constructor(F,T,M,U,Y,J,x){super(),this.n=M,this.r=U,this.s=x,this.g=this.B(new j.$Rd),this.onTokenFailed=this.g.event,this.h=this.B(new j.$Rd),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new j.$Rd),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(F),this.c=(0,u.$jp)(Y,J,x).then(W=>{const X={"X-Client-Name":`${T.applicationName}${S.$o?"-web":""}`,"X-Client-Version":T.version};return T.commit&&(X["X-Client-Commit"]=T.commit),X}),this.f=new y(t,r,this.n,this.r),this.u(),this.B((0,O.$Pc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(F,T){this.b={token:F,type:T}}t(F){this.a=F?(0,b.$Bg)(F,"v1"):void 0}u(){const F=this.s.getNumber(o,-1);F&&Date.now()<F&&this.y(new Date(F))}y(F){this.j?.getTime()!==F?.getTime()&&(this.j=F,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,D.$Ng)(T=>(0,D.$1g)(this.j.getTime()-Date.now(),T).then(()=>this.y(void 0))),this.w.then(null,T=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,b.$Bg)(this.a,"collection").toString();F={...F},F["Content-Type"]="application/json";const M=await this.D(T,{type:"GET",headers:F},[],N.CancellationToken.None);return(await(0,l.$9o)(M))?.map(({id:U})=>U)||[]}async createCollection(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,b.$Bg)(this.a,"collection").toString();F={...F},F["Content-Type"]=C.$Zr.text;const M=await this.D(T,{type:"POST",headers:F},[],N.CancellationToken.None),U=await(0,l.$8o)(M);if(!U)throw new d.$Ehb("Server did not return the collection id",T,"NoCollection",M.res.statusCode,M.res.headers[d.$Ahb]);return U}async deleteCollection(F,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=F?(0,b.$Bg)(this.a,"collection",F).toString():(0,b.$Bg)(this.a,"collection").toString();T={...T},await this.D(M,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async getAllResourceRefs(F,T){if(!this.a)throw new Error("No settings sync store url configured.");const M=this.z(this.a,T,F),U={},Y=await this.D(M.toString(),{type:"GET",headers:U},[],N.CancellationToken.None);return(await(0,l.$9o)(Y)||[]).map(({url:x,created:W})=>({ref:(0,b.$Dg)(M,M.with({path:x})),created:W*1e3}))}async resolveResourceContent(F,T,M,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,b.$Bg)(this.z(this.a,M,F),T).toString();U={...U},U["Cache-Control"]="no-cache";const J=await this.D(Y,{type:"GET",headers:U},[],N.CancellationToken.None);return await(0,l.$8o)(J)}async deleteResource(F,T,M){if(!this.a)throw new Error("No settings sync store url configured.");const U=T!==null?(0,b.$Bg)(this.z(this.a,M,F),T).toString():this.z(this.a,M,F).toString(),Y={};await this.D(U,{type:"DELETE",headers:Y},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.$Bg)(this.a,"resource").toString(),T={"Content-Type":C.$Zr.text};await this.D(F,{type:"DELETE",headers:T},[],N.CancellationToken.None)}async readResource(F,T,M,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,b.$Bg)(this.z(this.a,M,F),"latest").toString();U={...U},U["Cache-Control"]="no-cache",T&&(U["If-None-Match"]=T.ref);const J=await this.D(Y,{type:"GET",headers:U},[304],N.CancellationToken.None);let x=null;if(J.res.statusCode===304&&(x=T),x===null){const W=J.res.headers.etag;if(!W)throw new d.$Ehb("Server did not return the ref",Y,"NoRef",J.res.statusCode,J.res.headers[d.$Ahb]);const X=await(0,l.$8o)(J);if(!X&&J.res.statusCode===304)throw new d.$Ehb("Empty response",Y,"EmptyResponse",J.res.statusCode,J.res.headers[d.$Ahb]);x={ref:W,content:X}}return x}async writeResource(F,T,M,U,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=this.z(this.a,U,F).toString();Y={...Y},Y["Content-Type"]=C.$Zr.text,M&&(Y["If-Match"]=M);const x=await this.D(J,{type:"POST",data:T,headers:Y},[],N.CancellationToken.None),W=x.res.headers.etag;if(!W)throw new d.$Ehb("Server did not return the ref",J,"NoRef",x.res.statusCode,x.res.headers[d.$Ahb]);return W}async manifest(F,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,b.$Bg)(this.a,"manifest").toString();T={...T},T["Content-Type"]="application/json",F&&(T["If-None-Match"]=F.ref);const U=await this.D(M,{type:"GET",headers:T},[304],N.CancellationToken.None);let Y=null;if(U.res.statusCode===304&&(Y=F),!Y){const x=U.res.headers.etag;if(!x)throw new d.$Ehb("Server did not return the ref",M,"NoRef",U.res.statusCode,U.res.headers[d.$Ahb]);const W=await(0,l.$8o)(U);if(!W&&U.res.statusCode===304)throw new d.$Ehb("Empty response",M,"EmptyResponse",U.res.statusCode,U.res.headers[d.$Ahb]);W&&(Y={...JSON.parse(W),ref:x})}const J=this.s.get(n,-1);return J&&Y&&J!==Y.session&&this.C(),Y===null&&J&&this.C(),Y&&this.s.store(n,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.$Bg)(this.a,"download").toString(),T={},M=await this.D(F,{type:"GET",headers:T},[],N.CancellationToken.None);if(!(0,l.$5o)(M))throw new d.$Ehb("Server returned "+M.res.statusCode,F,"EmptyResponse",M.res.statusCode,M.res.headers[d.$Ahb]);if((0,l.$6o)(M))throw new d.$Ehb("Empty response",F,"EmptyResponse",M.res.statusCode,M.res.headers[d.$Ahb]);return M.stream}z(F,T,M){return T?(0,b.$Bg)(F,"collection",T,"resource",M):(0,b.$Bg)(F,"resource",M)}C(){this.s.remove(n,-1),this.s.remove(i,-1)}async D(F,T,M,U){if(!this.b)throw new d.$Ehb("No Auth Token Available",F,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new d.$Ehb(`${T.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;T.headers={...T.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(T.headers),this.r.trace("Sending request to server",{url:F,type:T.type,headers:{...T.headers,authorization:void 0}});let J;try{J=await this.f.request(F,T,U)}catch(B){if(!(B instanceof d.$Ehb)){let te="RequestFailed";const se=(0,L.$9)(B).toLowerCase();se.includes("xhr timeout")?te="RequestTimeout":se.includes("protocol")&&se.includes("not supported")?te="RequestProtocolNotSupported":se.includes("request path contains unescaped characters")?te="RequestPathNotEscaped":se.includes("headers must be an object")?te="RequestHeadersNotObject":(0,L.$3)(B)&&(te="RequestCanceled"),B=new d.$Ehb(`Connection refused for the request '${F}'.`,F,te,void 0,void 0)}throw this.r.info("Request failed",F),B}const x=J.res.headers[d.$Ahb],W={url:F,status:J.res.statusCode,"execution-id":T.headers[d.$Bhb],"operation-id":x},X=(0,l.$5o)(J)||J.res.statusCode&&M.includes(J.res.statusCode);let V="";if(X?this.r.trace("Request succeeded",W):(V=await(0,l.$7o)(J)||"",this.r.info("Request failed",W,V)),J.res.statusCode===401||J.res.statusCode===403){if(this.b=void 0,J.res.statusCode===401)throw this.g.fire("Unauthorized"),new d.$Ehb(`${T.type} request '${F}' failed because of Unauthorized (401).`,F,"Unauthorized",J.res.statusCode,x);if(J.res.statusCode===403)throw this.g.fire("Forbidden"),new d.$Ehb(`${T.type} request '${F}' failed because the access is forbidden (403).`,F,"Forbidden",J.res.statusCode,x)}if(this.h.fire(),J.res.statusCode===404)throw new d.$Ehb(`${T.type} request '${F}' failed because the requested resource is not found (404).`,F,"NotFound",J.res.statusCode,x);if(J.res.statusCode===405)throw new d.$Ehb(`${T.type} request '${F}' failed because the requested endpoint is not found (405). ${V}`,F,"MethodNotFound",J.res.statusCode,x);if(J.res.statusCode===409)throw new d.$Ehb(`${T.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,"Conflict",J.res.statusCode,x);if(J.res.statusCode===410)throw new d.$Ehb(`${T.type} request '${F}' failed because the requested resource is not longer available (410).`,F,"Gone",J.res.statusCode,x);if(J.res.statusCode===412)throw new d.$Ehb(`${T.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,"PreconditionFailed",J.res.statusCode,x);if(J.res.statusCode===413)throw new d.$Ehb(`${T.type} request '${F}' failed because of too large payload (413).`,F,"TooLarge",J.res.statusCode,x);if(J.res.statusCode===426)throw new d.$Ehb(`${T.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,"UpgradeRequired",J.res.statusCode,x);if(J.res.statusCode===429){const B=J.res.headers["retry-after"];throw B?(this.y(new Date(Date.now()+parseInt(B)*1e3)),new d.$Ehb(`${T.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",J.res.statusCode,x)):new d.$Ehb(`${T.type} request '${F}' failed because of too many requests (429).`,F,"RemoteTooManyRequests",J.res.statusCode,x)}if(!X)throw new d.$Ehb("Server returned "+J.res.statusCode,F,"Unknown",J.res.statusCode,x);return J}F(F){let T=this.s.get(i,-1);T===void 0&&(T=(0,$.$kg)(),this.s.store(i,T,-1,1)),F["X-Machine-Session-Id"]=T;const M=this.s.get(n,-1);M!==void 0&&(F["X-User-Session-Id"]=M)}};e.$sFb=m,e.$sFb=m=ye([Q(1,w.$zj),Q(2,l.$3o),Q(3,d.$Nhb),Q(4,g.$7h),Q(5,p.$ik),Q(6,h.$dp)],m);let f=class extends m{constructor(F,T,M,U,Y,J,x){super(F.userDataSyncStore?.url,T,M,U,Y,J,x),this.B(F.onDidChangeUserDataSyncStore(()=>this.t(F.userDataSyncStore?.url)))}};e.$tFb=f,e.$tFb=f=ye([Q(0,d.$xhb),Q(1,w.$zj),Q(2,l.$3o),Q(3,d.$Nhb),Q(4,g.$7h),Q(5,p.$ik),Q(6,h.$dp)],f);class y{constructor(F,T,M,U){this.c=F,this.d=T,this.f=M,this.g=U,this.a=[],this.b=void 0}request(F,T,M){if(this.h()&&this.i(),T.url=F,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new d.$Ehb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,F,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(F),this.f.request(T,M)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$uFb=y}),define(le[262],he([0,1,3,57,25,21,22,257,24,80,83]),function(ne,e,D,N,L,j,O,C,S,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t$b=void 0;let k=class extends C.$N7b{constructor(c,g,p,w,l,u,h,d,E,s,o){super(c,g,p,w,l,h,d,E,s,o),this.B(D.Event.debounce(D.Event.any(D.Event.map(u.onDidFocusMainWindow,()=>"windowFocus"),D.Event.map(u.onDidOpenMainWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$t$b=k,e.$t$b=k=ye([Q(0,L.$zj),Q(1,S.$xhb),Q(2,S.$yhb),Q(3,S.$Ihb),Q(4,S.$Jhb),Q(5,N.$k9b),Q(6,S.$Nhb),Q(7,b.$8Db),Q(8,O.$ml),Q(9,R.$lhb),Q(10,j.$dp)],k)}),define(le[263],he([0,1,72,23,5,19]),function(ne,e,D,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R8b=e.$Q8b=e.$P8b=e.$O8b=void 0,e.$O8b=128/4;function O(b){function R(){let k=b.scheme===N.Schemas.file?(0,j.$pg)(b):b.toString();return L.$k||(k=k.toLowerCase()),(0,D.createHash)("md5").update(k).digest("hex")}return{id:R(),configPath:b}}e.$P8b=O;function C(b,R){function k(){if(b.scheme!==N.Schemas.file)return(0,D.createHash)("md5").update(b.toString()).digest("hex");if(!R)return;let c;return L.$k?c=R.ino:L.$j?c=R.birthtime.getTime():L.$i&&(typeof R.birthtimeMs=="number"?c=Math.floor(R.birthtimeMs):c=R.birthtime.getTime()),(0,D.createHash)("md5").update(b.fsPath).update(c?String(c):"").digest("hex")}const $=k();if(typeof $=="string")return{id:$,uri:b}}e.$Q8b=C;function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$R8b=S}),define(le[264],he([0,1,6,7,2,16,31,14,8,77,112,263,57,56,23]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z0b=void 0;let p=class extends L.$Rc{constructor(l,u,h,d){super(),this.a=l,this.b=u,this.c=h,this.f=d,this.B(new D.$_g(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.a.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,u=await O.Promises.readdir(l),h=new b.$GEb(this.f.getChannel("storage"));await Promise.all(u.map(async d=>{const E=(0,j.$ic)(l,d);d.length===k.$O8b||d===R.$_h.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===d)||await h.isUsed(E)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await O.Promises.rm(E))}))}catch(l){(0,N.$Z)(l)}}};e.$Z0b=p,e.$Z0b=p=ye([Q(0,C.$8h),Q(1,S.$hj),Q(2,$.$k9b),Q(3,c.$y0b)],p)}),define(le[122],he([0,1,72,63,36,272,15,7,3,2,16,5,32,40,67]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=void 0;class p{traceSocketEvent(f,y){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,y)}constructor(f,y=""){this.f=!0,this.debugLabel=y,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=I=>{if(this.traceSocketEvent("error",{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,C.$Z)(I)}},this.socket.on("error",this.a),this.b=I=>{this.traceSocketEvent("close",{hadError:I}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const y=I=>{this.traceSocketEvent("read",I),f(O.$fe.wrap(I))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(f){const y=I=>{f({type:0,hadError:I,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(f){const y=()=>{f()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,C.$Z)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,C.$Z)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.$Oh=p;var w;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var l;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(l||(l={}));class u extends b.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,y){this.socket.traceSocketEvent(f,y)}constructor(f,y,I,F){super(),this.f=this.B(new S.$Rd),this.g=this.B(new S.$Rd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:I?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new h(this,y,I,F,this.f,(T,M)=>this.m(T,M))),this.B(this.a.onError(T=>{console.error(T),(0,C.$Z)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new g.$Jh,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let y=0;for(;y<f.byteLength;)this.a.writeMessage(f.slice(y,Math.min(y+262144,f.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(f,{compressed:y,opcode:I}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let F=2;f.byteLength<126?F+=0:f.byteLength<2**16?F+=2:F+=8;const T=O.$fe.alloc(F),M=y?64:0,U=I&15;if(T.writeUInt8(128|M|U,0),f.byteLength<126)T.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){T.writeUInt8(126,1);let Y=1;T.writeUInt8(f.byteLength>>>8&255,++Y),T.writeUInt8(f.byteLength>>>0&255,++Y)}else{T.writeUInt8(127,1);let Y=1;T.writeUInt8(0,++Y),T.writeUInt8(0,++Y),T.writeUInt8(0,++Y),T.writeUInt8(0,++Y),T.writeUInt8(f.byteLength>>>24&255,++Y),T.writeUInt8(f.byteLength>>>16&255,++Y),T.writeUInt8(f.byteLength>>>8&255,++Y),T.writeUInt8(f.byteLength>>>0&255,++Y)}this.socket.write(O.$fe.concat([T,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),I=y.readUInt8(0),F=(I&128)>>>7,T=(I&64)>>>6,M=I&15,U=y.readUInt8(1),Y=(U&128)>>>7,J=U&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(J===126?2:0)+(J===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),I=y.readUInt8(1),F=(I&128)>>>7;let T=I&127,M=1;T===126?T=y.readUInt8(++M)*2**8+y.readUInt8(++M):T===127&&(T=y.readUInt8(++M)*0+y.readUInt8(++M)*0+y.readUInt8(++M)*0+y.readUInt8(++M)*0+y.readUInt8(++M)*2**24+y.readUInt8(++M)*2**16+y.readUInt8(++M)*2**8+y.readUInt8(++M));let U=0;F&&(U=y.readUInt8(++M)*2**24+y.readUInt8(++M)*2**16+y.readUInt8(++M)*2**8+y.readUInt8(++M)),this.j.state=3,this.j.readLen=T,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),s(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Ph=u;class h extends b.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$fe.alloc(0)}constructor(f,y,I,F,T,M){super(),this.n=f,this.r=T,this.s=M,this.a=this.B(new S.$Rd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$Rd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new S.$Rd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new d(this.n,F,I,{windowBits:15})),this.f=this.B(new E(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(f,y){this.g.push({data:f,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:y}=this.g.shift();if(this.f&&y.compressed){const I=await this.w(this.f,f);this.s(I,y)}else this.s(f,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,y){return new Promise((I,F)=>{f.write(y),f.flush(T=>I(T))})}acceptFrame(f,y,I){this.h.push({data:f,isCompressed:y,isLastFrameOfMessage:I}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const y=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,y,I){return new Promise((F,T)=>{f.write(y),I&&f.write(O.$fe.fromByteArray([0,0,255,255])),f.flush(M=>F(M))})}}class d extends b.$Rc{get recordedInflateBytes(){return this.j?O.$fe.concat(this.f):O.$fe.alloc(0)}constructor(f,y,I,F){super(),this.h=f,this.j=y,this.a=this.B(new S.$Rd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(F),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(O.$fe.wrap(T))}),I&&(this.h.traceSocketEvent("zlibInflateInitialWrite",I.buffer),this.b.write(I.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=O.$fe.concat(this.g);this.g.length=0,f(y)})}}class E extends b.$Rc{constructor(f,y){super(),this.g=f,this.a=this.B(new S.$Rd),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",I=>{this.g.traceSocketEvent("zlibDeflateError",{message:I?.message,code:I?.code}),this.a.fire(I)}),this.b.on("data",I=>{this.g.traceSocketEvent("zlibDeflateData",I),this.f.push(O.$fe.wrap(I))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=O.$fe.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),f(y)})}}function s(m,f){if(f===0)return;const y=m.byteLength>>>2;for(let Y=0;Y<y;Y++){const J=m.readUInt32BE(Y*4);m.writeUInt32BE(J^f,Y*4)}const I=y*4,F=m.byteLength-I,T=f>>>24&255,M=f>>>16&255,U=f>>>8&255;F>=1&&m.writeUInt8(m.readUInt8(I)^T,I),F>=2&&m.writeUInt8(m.readUInt8(I+1)^M,I+1),F>=3&&m.writeUInt8(m.readUInt8(I+2)^U,I+2)}e.$Qh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const m=(0,$.$kg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const f=process.platform!=="darwin"&&e.$Qh?e.$Qh:(0,L.tmpdir)(),y=(0,R.$ic)(f,`vscode-ipc-${m}.sock`);return t(y),y}e.$Rh=n;function i(m,f,y){const I=(0,D.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${y}-${f}-sock`;const F=y.substr(0,4),T=f.substr(0,6),M=I.substr(0,8);let U;return process.platform!=="darwin"&&e.$Qh&&!process.env.VSCODE_PORTABLE?U=(0,R.$ic)(e.$Qh,`vscode-${M}-${F}-${T}.sock`):U=(0,R.$ic)(m,`${F}-${T}.sock`),t(U),U}e.$Sh=i;function t(m){const f=o[k.$u];typeof f=="number"&&m.length>=f&&console.warn(`WARNING: IPC handle "${m}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends c.$Dh{static b(f){const y=S.Event.fromNodeEventEmitter(f,"connection");return S.Event.map(y,I=>({protocol:new g.$Kh(new p(I,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(I,"close"))}))}constructor(f){super(r.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Th=r;function a(m){return new Promise((f,y)=>{const I=(0,N.createServer)();I.on("error",y),I.listen(m,()=>{I.removeListener("error",y),f(new r(I))})})}e.$Uh=a;function v(m,f){return new Promise((y,I)=>{const F=(0,N.createConnection)(m,()=>{F.removeListener("error",I),y(g.$Lh.fromSocket(new p(F,`ipc-client${f}`),f))});F.once("error",I)})}e.$Vh=v}),define(le[265],he([0,1,63,122,211]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w$b=void 0,e.$w$b=new class{supports(j){return!0}connect({host:j,port:O},C,S,b){return new Promise((R,k)=>{const $=D.createConnection({host:j,port:O},()=>{$.removeListener("error",k),$.write((0,L.$Hqb)(C,S,b));const c=g=>{g.toString().indexOf(`\r
\r
`)>=0&&($.off("data",c),R(new N.$Oh($,b)))};$.on("data",c)});$.setNoDelay(!0),$.once("error",k)})}}}),define(le[266],he([0,1,63,36,132,122,6,2,5,20,8,25,214,104,106,78,15]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s0b=e.$r0b=e.$q0b=e.$p0b=void 0;async function l(s,o,n,i,t){let r;for(let a=3;a&&(r?.dispose(),r=await new u(s,o,n,i,t).waitForReady(),!(t&&L.$ng[t]||!L.$ng[r.tunnelLocalPort]));a--);return r}class u extends C.$Rc{constructor(o,n,i,t,r){super(),this.m=n,this.n=r,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=D.createServer(),this.c=new O.$Yg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,p.$ov)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,L.$og)(o,2,1e3,n),t=null;return this.b.listen(i,this.m),await this.c.wait(),t=this.b.address(),t||(i=0,this.b.listen(i,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,p.$mv)(this.tunnelRemoteHost)||(0,p.$ov)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,$.$dl)(this.a,n,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof j.$Oh?t.socket.destroy():t.end()}),t instanceof j.$Oh?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(i=>o.write(i.buffer)),o.on("data",i=>n.write(w.$fe.wrap(i))),o.resume()}t(o,n){const i=n.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$p0b=u;let h=class extends p.$rv{constructor(o,n,i,t,r){super(n,r),this.u=o,this.v=i,this.w=t}isPortPrivileged(o){return(0,p.$pv)(o,this.l,S.OS,N.release())}s(o,n,i,t,r,a,v,m){const f=this.r(n,i);if(f)return++f.refcount,f.value;if((0,p.$jv)(o))return this.t(o,n,i,r,a,v,m);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${i} on local port ${r}.`);const y={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},I=l(y,t,n,i,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,i,I),I}}};e.$q0b=h,e.$q0b=h=ye([Q(0,c.$0k),Q(1,R.$hj),Q(2,g.$al),Q(3,k.$zj),Q(4,b.$ti)],h);let d=class extends h{constructor(o,n,i,t,r){super(o,n,i,t,r)}};e.$r0b=d,e.$r0b=d=ye([Q(0,c.$0k),Q(1,R.$hj),Q(2,g.$al),Q(3,k.$zj),Q(4,b.$ti)],d);let E=class extends C.$Rc{constructor(o,n,i,t,r){super(),this.b=o,this.c=n,this.f=i,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,i,t,r,a,v,m,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${a}.`),!this.a.has(o)){const y=new d(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(o,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,i,t,r,a,v,m,f)}};e.$s0b=E,e.$s0b=E=ye([Q(0,c.$0k),Q(1,R.$hj),Q(2,k.$zj),Q(3,g.$al),Q(4,b.$ti)],E)}),define(le[273],he([0,1,36,38,7,2,23,10,18,3,40,146,205,206,196,197,264,187,189,20,210,95,221,96,216,14,114,248,29,97,188,113,98,11,199,200,71,4,195,73,74,227,8,201,102,25,59,21,107,22,108,109,110,45,230,82,111,24,80,256,240,241,83,255,259,260,261,60,254,242,106,220,78,266,215,231,28,232,5,233,190,208,207,81,247,17,51,204,58,253,229,243,105,258,249,9,202,101,251,246,217,184,57,203,262,250,56,252,104,265,181,218]),function(ne,e,D,N,L,j,O,C,S,b,R,k,$,c,g,p,w,l,u,h,d,E,s,o,n,i,t,r,a,v,m,f,y,I,F,T,M,U,Y,J,x,W,X,V,B,te,se,_,re,K,z,P,A,G,q,ee,H,Z,ie,ce,oe,fe,de,we,ve,Ie,Ne,Me,ue,ge,be,Se,Re,ze,je,Ue,Te,ae,$e,me,pe,ke,Ce,Pe,Oe,De,Ae,Fe,Be,qe,Ve,_e,ut,pt,vt,Et,kt,ft,St,Pt,Rt,Ct,It,Ot,Dt,jt,dt,Lt,$t,At,Nt,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ft extends j.$Rc{constructor(Ee){super(),this.f=Ee,this.a=this.B(new k.$gU(this)),this.b=void 0,this.c=this.B(new b.$Rd),this.g()}g(){let Ee=!1;const Le=()=>{Ee||(Ee=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Le),(0,k.$hU)(process.parentPort,it.$E9b.exit,Le)}async init(){const Ee=await this.h();(0,Z.$shb)(),Ee.invokeFunction(Le=>{const Ke=Le.get(X.$hj),We=Le.get(K.$ml),Ze=Le.get(De.$Uk);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Le),this.m(Ke),this.n(We,Ze),this.B(Ze.onDidChangeProfiles(()=>this.n(We,Ze)))}),this.B((0,j.$Oc)(Ee.createInstance($.$V0b,this.f.codeCachePath),Ee.createInstance(c.$W0b),Ee.createInstance(w.$Z0b),Ee.createInstance(p.$Y0b),Ee.createInstance(g.$X0b),Ee.createInstance(vt.$n$b),Ee.createInstance(_e.$f$b)))}async h(){const Ee=new J.$Xh,Le={_serviceBrand:void 0,...B.default};Ee.set(te.$zj,Le);const Ke=new R.$Hh(He=>He==="main"),We=new dt.$z0b(this.a,Ke);Ee.set(dt.$y0b,We);const Ze=this.f.policiesData?new Fe.$89b(this.f.policiesData,We.getChannel("policy")):new Be.$un;Ee.set(Be.$sn,Ze);const Ge=new Nt.$tm(this.f.args,Le);Ee.set(i.$8h,Ge);const xe=new V.$ir(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(He=>({...He,resource:C.URI.revive(He.resource)})),We.getChannel("logger"));Ee.set(X.$ij,xe);const st=this.B(xe.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ct=this.B(new X.$pj(st.getLevel())),Je=this.B(new kt.$2N(st,[ct]));Ee.set(X.$hj,Je),this.b=this.B(new ft.$p$b(Je)),Ee.set(ft.$o$b,this.b);const Xe=this.B(new F.$Xp(Je));Ee.set(I.$ik,Xe);const lt=this.B(new T.$kq(Je));Xe.registerProvider(O.Schemas.file,lt);const rt=new ae.$Jr(Xe);Ee.set(Te.$Sk,rt);const Qe=this.B(new qe.$9N(this.f.profiles.all,C.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),We.getChannel("userDataProfiles")));Ee.set(De.$Uk,Qe);const ht=this.B(new me.$x0b(O.Schemas.file,this.B(new pe.$KN(We.getChannel(pe.$JN),{pathCaseSensitive:$e.$k})),O.Schemas.vscodeUserData,Qe,rt,Je));Xe.registerProvider(O.Schemas.vscodeUserData,ht);const Ye=this.B(new d.$Un(Qe.defaultProfile.settingsResource,Xe,Ze,Je));Ee.set(h.$ti,Ye);const et=new Lt.$v$b(void 0,{defaultProfile:Qe.defaultProfile,currentProfile:Qe.defaultProfile},We,Ge);Ee.set(_.$dp,et),this.B((0,j.$Pc)(()=>et.flush())),await Promise.all([Ye.initialize(),et.initialize()]);const mt=new Rt.$7q(We.getChannel("request"));Ee.set(se.$3o,mt),Ee.set(l.$10b,new M.$Wh(u.$20b,void 0,!1)),Ee.set(Ce.$CF,new M.$Wh(ke.$e$b,void 0,!1));const bt=new Ot.$E0b(-1,We);Ee.set(It.$k9b,bt),Ee.set(o.$Yn,new M.$Wh(n.$eO,void 0,!0));const Tt=this.B(new ge.$59b(bt)),Mt=new R.$Hh(He=>Tt.getActiveClientId().then(at=>He===at));Ee.set(y.$MXb,new Ct.$r$b(this.a.getChannel("extensionRecommendationNotification",Mt)));let ot;const tt=[],wt=(0,G.$Go)(Le,Ye);if((0,G.$Bo)(Le,Ge)){const He=new P.$56b(Je,xe,Ge,Le);if(tt.push(He),!(0,G.$Co)(Le,Ge)&&Le.aiConfig?.ariaKey){const at=new Ve.$PN(mt,wt,"monacoworkbench",null,Le.aiConfig.ariaKey);this.B((0,j.$Pc)(()=>at.flush())),tt.push(at)}ot=new A.$$q({appenders:tt,commonProperties:(0,re.$ro)((0,D.release)(),(0,D.hostname)(),process.arch,Le.commit,Le.version,this.f.machineId,this.f.sqmId,wt),sendErrorTelemetry:!0,piiPaths:(0,G.$Ho)(Ge)},Ye,Le)}else{ot=G.$vo;const He=G.$zo;tt.push(He)}this.a.registerChannel("telemetryAppender",new z.$J9b(tt)),Ee.set(K.$ml,ot);const zt=new q.$30b(Ye,ot,Je,xe,Ge,Le);Ee.set(K.$nl,zt),Ee.set(Ae.$Ep,new M.$Wh(Pt.$1N,void 0,!0)),Ee.set(Pe.$Ip,new M.$Wh(Oe.$99b,void 0,!0)),Ee.set(v.$op,new M.$Wh(v.$pp,void 0,!0)),Ee.set(f.$Sp,new M.$Wh(f.$Tp,void 0,!0)),Ee.set(a.$ho,new M.$Wh(r.$mp,void 0,!0)),Ee.set(a.$no,new M.$Wh(jt.$u$b,void 0,!1)),Ee.set(x.$3q,new M.$Wh(W.$5q,void 0,!1)),Ee.set(E.$Am,new M.$Wh(s.$Qr,void 0,!1)),Ee.set(ie.$8Db,new M.$Wh(ie.$9Db,void 0,!0)),Ee.set(Z.$Nhb,new M.$Wh(fe.$iGb,void 0,!0)),Ee.set(Z.$Mhb,new oe.$60b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),Ee.set(a.$mo,new M.$Wh(t.$6Db,void 0,!1)),Ee.set(H.$gGb,new M.$Wh(H.$hGb,void 0,!0)),Ee.set(ee.$7u,new M.$Wh(ee.$8u)),Ee.set(Z.$xhb,new M.$Wh(Ne.$rFb,void 0,!0)),Ee.set(Z.$yhb,new M.$Wh(Ne.$tFb,void 0,!0)),Ee.set(de.$lhb,new M.$Wh(de.$nhb,void 0,!0)),Ee.set(Z.$zhb,new M.$Wh(ce.$H7b,void 0,!1)),Ee.set(Z.$Ihb,new M.$Wh(we.$w7b,void 0,!0)),Ee.set(Z.$Jhb,new M.$Wh(ve.$M7b,void 0,!1)),Ee.set(Me.$HEb,new M.$Wh(ue.$a$b,void 0,!0)),Ee.set(Z.$Khb,new M.$Wh(pt.$l8b,void 0,!0)),Ee.set(be.$al,new M.$Wh(Se.$u0b,void 0,!1));const yt=new $t.$$k;return Ee.set($t.$0k,yt),yt.register(0,At.$w$b),Ee.set(Re.$iv,new M.$Wh(ze.$s0b)),Ee.set(je.$b$b,new M.$Wh(Ue.$d$b)),Ee.set(ut.$g$b,new M.$Wh(St.$q$b)),new Y.$nq(Ee)}j(Ee){const Le=this.B(new j.$Qc),Ke=new m.$rp(Ee.get(a.$jo),()=>null);this.a.registerChannel("extensions",Ke);const We=R.ProxyChannel.fromService(Ee.get(x.$3q),Le);this.a.registerChannel("languagePacks",We);const Ze=R.ProxyChannel.fromService(Ee.get(E.$Am),Le);this.a.registerChannel("diagnostics",Ze);const Ge=new m.$tp(Ee.get(a.$no));this.a.registerChannel("extensionTipsService",Ge);const xe=R.ProxyChannel.fromService(Ee.get(l.$10b),Le);this.a.registerChannel("checksum",xe);const st=R.ProxyChannel.fromService(Ee.get(Ce.$CF),Le);this.a.registerChannel("v8InspectProfiling",st);const ct=new oe.$70b(Ee.get(de.$lhb));this.a.registerChannel("userDataSyncMachines",ct);const Je=R.ProxyChannel.fromService(Ee.get(K.$nl),Le);this.a.registerChannel("customEndpointTelemetry",Je);const Xe=new oe.$80b(Ee.get(ie.$8Db));this.a.registerChannel("userDataSyncAccount",Xe);const lt=new oe.$90b(Ee.get(Z.$xhb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Ie.$$0b(Ee.get(Z.$Jhb),Ee.get(De.$Uk),Ee.get(X.$hj));this.a.registerChannel("userDataSync",rt);const Qe=this.B(Ee.get(U.$Yh).createInstance(Dt.$t$b)),ht=new oe.$40b(Qe);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",R.ProxyChannel.fromService(Ee.get(Z.$Khb),Le));const Ye=R.ProxyChannel.fromService(Ee.get(je.$b$b),Le);this.a.registerChannel(je.$c$b,Ye);const et=R.ProxyChannel.fromService(Ee.get(ut.$g$b),Le);this.a.registerChannel("remoteTunnel",et)}m(Ee){process.on("uncaughtException",Le=>(0,L.$Z)(Le)),process.on("unhandledRejection",Le=>(0,L.$Z)(Le)),(0,L.setUnexpectedErrorHandler)(Le=>{const Ke=(0,N.$Ki)(Le,!0);Ke&&Ee.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Ee,Le){Ee.publicLog2("profilesInfo",{count:Le.profiles.length})}handledClientConnection(Ee){if(Ee.data!==it.$G9b.response)return!1;const Le=(0,S.$Nb)(Ee.ports);return Le?(this.c.fire(Le),!0):!1}}async function gt(nt){const Ee=new Ft(nt);process.parentPort.postMessage(it.$E9b.ipcReady),await Ee.init(),process.parentPort.postMessage(it.$E9b.initDone)}e.main=gt,process.parentPort.once("message",nt=>{gt(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f3da7cb46a8ffbea21998420dc673777715e55cf/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
