/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","child_process","vs/base/common/iterator","vs/base/common/hash","vs/editor/common/core/position","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(be){for(var e=[],D=0,T=be.length;D<T;D++)e[D]=ke[be[D]];return e};define(ke[158],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class D{static get(){const m=new Map,A=new Map,R=new Map,w=new Map;function b(v,S){v.has(S.detail)||v.set(S.detail,-S.timestamp)}function y(v,S){const g=v.get(S.detail);g&&(g>=0||v.set(S.detail,g+S.timestamp))}let L=[];typeof be=="function"&&typeof be.getStats=="function"&&(L=be.getStats().slice(0).sort((v,S)=>v.timestamp-S.timestamp));for(const v of L)switch(v.type){case 10:b(m,v);break;case 11:case 12:y(m,v);break;case 21:b(A,v);break;case 22:y(A,v);break;case 33:b(R,v);break;case 34:y(R,v);break;case 31:b(w,v);break;case 32:y(w,v);break}let P=0;R.forEach(v=>P+=v);function $(v){const S=[];return v.forEach((g,d)=>S.push([d,g])),S}return{amdLoad:$(m),amdInvoke:$(A),nodeRequire:$(R),nodeEval:$(w),nodeRequireTotal:P}}static toMarkdownTable(m,A){let R="";const w=[];return m.forEach((b,y)=>{w[y]=b.length}),A.forEach(b=>{b.forEach((y,L)=>{typeof y>"u"&&(y=b[L]="-");const P=y.toString().length;w[L]=Math.max(P,w[L])})}),m.forEach((b,y)=>{R+=`| ${b+" ".repeat(w[y]-b.toString().length)} `}),R+=`|
`,m.forEach((b,y)=>{R+=`| ${"-".repeat(w[y])} `}),R+=`|
`,A.forEach(b=>{b.forEach((y,L)=>{typeof y<"u"&&(R+=`| ${y+" ".repeat(w[L]-y.toString().length)} `)}),R+=`|
`}),R}}e.$T=D}),define(ke[121],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function D(g,d,o){const i=T(g,d);if(i!==-1)return g[i]}e.$eb=D;function T(g,d,o=g.length-1){for(let i=o;i>=0;i--){const n=g[i];if(d(n))return i}return-1}e.$fb=T;function m(g,d){const o=A(g,d);return o===-1?void 0:g[o]}e.$gb=m;function A(g,d,o=0,i=g.length){let n=o,s=i;for(;n<s;){const a=Math.floor((n+s)/2);d(g[a])?n=a+1:s=a}return n-1}e.$hb=A;function R(g,d){const o=w(g,d);return o===g.length?void 0:g[o]}e.$ib=R;function w(g,d,o=0,i=g.length){let n=o,s=i;for(;n<s;){const a=Math.floor((n+s)/2);d(g[a])?s=a:n=a+1}return n}e.$jb=w;function b(g,d,o=0,i=g.length){const n=w(g,d,o,i);return n===g.length?-1:n}e.$kb=b;class y{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(y.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!d(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const o=A(this.e,d,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$lb=y;function L(g,d){if(g.length===0)return;let o=g[0];for(let i=1;i<g.length;i++){const n=g[i];d(n,o)>0&&(o=n)}return o}e.$mb=L;function P(g,d){if(g.length===0)return;let o=g[0];for(let i=1;i<g.length;i++){const n=g[i];d(n,o)>=0&&(o=n)}return o}e.$nb=P;function $(g,d){return L(g,(o,i)=>-d(o,i))}e.$ob=$;function v(g,d){if(g.length===0)return-1;let o=0;for(let i=1;i<g.length;i++){const n=g[i];d(n,g[o])>0&&(o=i)}return o}e.$pb=v;function S(g,d){for(const o of g){const i=d(o);if(i!==void 0)return i}}e.$qb=S}),define(ke[73],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function D(R,w){const b=Object.create(null);for(const y of R){const L=w(y);let P=b[L];P||(P=b[L]=[]),P.push(y)}return b}e.$J=D;function T(R,w){const b=[],y=[];for(const L of R)w.has(L)||b.push(L);for(const L of w)R.has(L)||y.push(L);return{removed:b,added:y}}e.$K=T;function m(R,w){const b=[],y=[];for(const[L,P]of R)w.has(L)||b.push(P);for(const[L,P]of w)R.has(L)||y.push(P);return{removed:b,added:y}}e.$L=m;function A(R,w){const b=new Set;for(const y of w)R.has(y)&&b.add(y);return b}e.$M=A}),define(ke[59],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=e.$rh=void 0;function D(R){return(w,b,y)=>{let L=null,P=null;if(typeof y.value=="function"?(L="value",P=y.value):typeof y.get=="function"&&(L="get",P=y.get),!P)throw new Error("not supported");y[L]=R(P,b)}}function T(R,w,b){let y=null,L=null;if(typeof b.value=="function"?(y="value",L=b.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(y="get",L=b.get),!L)throw new Error("not supported");const P=`$memoize$${w}`;b[y]=function(...$){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,$)}),this[P]}}e.$rh=T;function m(R,w,b){return D((y,L)=>{const P=`$debounce$${L}`,$=`$debounce$result$${L}`;return function(...v){this[$]||(this[$]=b?b():void 0),clearTimeout(this[P]),w&&(this[$]=w(this[$],...v),v=[this[$]]),this[P]=setTimeout(()=>{y.apply(this,v),this[$]=b?b():void 0},R)}})}e.$sh=m;function A(R,w,b){return D((y,L)=>{const P=`$throttle$timer$${L}`,$=`$throttle$result$${L}`,v=`$throttle$lastRun$${L}`,S=`$throttle$pending$${L}`;return function(...g){if(this[$]||(this[$]=b?b():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),w&&(this[$]=w(this[$],...g)),this[S])return;const d=this[v]+R;d<=Date.now()?(this[v]=Date.now(),y.apply(this,[this[$]]),this[$]=b?b():void 0):(this[S]=!0,this[P]=setTimeout(()=>{this[S]=!1,this[v]=Date.now(),y.apply(this,[this[$]]),this[$]=b?b():void 0},d-Date.now()))}})}e.$th=A}),define(ke[8],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=D,e.$W=new D;function T(a){e.$W.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=T;function m(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=m;function A(a){y(a)||e.$W.onUnexpectedError(a)}e.$Z=A;function R(a){y(a)||e.$W.onUnexpectedExternalError(a)}e.$1=R;function w(a){if(a instanceof Error){const{name:t,message:r}=a,h=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:h,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$2=w;const b="Canceled";function y(a){return a instanceof L?!0:a instanceof Error&&a.name===b&&a.message===b}e.$3=y;class L extends Error{constructor(){super(b),this.name=this.message}}e.$4=L;function P(){const a=new Error(b);return a.name=a.message,a}e.$5=P;function $(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$6=$;function v(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$7=v;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=S;function g(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$9=g;class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=d;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const r=new n;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=n;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.$bb=s}),define(ke[19],Se([1,0,8,121]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function m(fe,me=0){return fe[fe.length-(1+me)]}e.$rb=m;function A(fe){if(fe.length===0)throw new Error("Invalid tail call");return[fe.slice(0,fe.length-1),fe[fe.length-1]]}e.$sb=A;function R(fe,me,ee=(te,K)=>te===K){if(fe===me)return!0;if(!fe||!me||fe.length!==me.length)return!1;for(let te=0,K=fe.length;te<K;te++)if(!ee(fe[te],me[te]))return!1;return!0}e.$tb=R;function w(fe,me){const ee=fe.length-1;me<ee&&(fe[me]=fe[ee]),fe.pop()}e.$ub=w;function b(fe,me,ee){return y(fe.length,te=>ee(fe[te],me))}e.$vb=b;function y(fe,me){let ee=0,te=fe-1;for(;ee<=te;){const K=(ee+te)/2|0,ie=me(K);if(ie<0)ee=K+1;else if(ie>0)te=K-1;else return K}return-(ee+1)}e.$wb=y;function L(fe,me,ee){if(fe=fe|0,fe>=me.length)throw new TypeError("invalid index");const te=me[Math.floor(me.length*Math.random())],K=[],ie=[],G=[];for(const ae of me){const $e=ee(ae,te);$e<0?K.push(ae):$e>0?ie.push(ae):G.push(ae)}return fe<K.length?L(fe,K,ee):fe<K.length+G.length?G[0]:L(fe-(K.length+G.length),ie,ee)}e.$xb=L;function P(fe,me){const ee=[];let te;for(const K of fe.slice(0).sort(me))!te||me(te[0],K)!==0?(te=[K],ee.push(te)):te.push(K);return ee}e.$yb=P;function*$(fe,me){let ee,te;for(const K of fe)te!==void 0&&me(te,K)?ee.push(K):(ee&&(yield ee),ee=[K]),te=K;ee&&(yield ee)}e.$zb=$;function v(fe,me){for(let ee=0;ee<=fe.length;ee++)me(ee===0?void 0:fe[ee-1],ee===fe.length?void 0:fe[ee])}e.$Ab=v;function S(fe,me){for(let ee=0;ee<fe.length;ee++)me(ee===0?void 0:fe[ee-1],fe[ee],ee+1===fe.length?void 0:fe[ee+1])}e.$Bb=S;function g(fe,me,ee){const te=[];function K(ae,$e,Ce){if($e===0&&Ce.length===0)return;const B=te[te.length-1];B&&B.start+B.deleteCount===ae?(B.deleteCount+=$e,B.toInsert.push(...Ce)):te.push({start:ae,deleteCount:$e,toInsert:Ce})}let ie=0,G=0;for(;;){if(ie===fe.length){K(ie,0,me.slice(G));break}if(G===me.length){K(ie,fe.length-ie,[]);break}const ae=fe[ie],$e=me[G],Ce=ee(ae,$e);Ce===0?(ie+=1,G+=1):Ce<0?(K(ie,1,[]),ie+=1):Ce>0&&(K(ie,0,[$e]),G+=1)}return te}e.$Cb=g;function d(fe,me,ee){const te=g(fe,me,ee),K=[],ie=[];for(const G of te)K.push(...fe.slice(G.start,G.start+G.deleteCount)),ie.push(...G.toInsert);return{removed:K,added:ie}}e.$Db=d;function o(fe,me,ee){if(ee===0)return[];const te=fe.slice(0,ee).sort(me);return n(fe,me,te,ee,fe.length),te}e.top=o;function i(fe,me,ee,te,K){return ee===0?Promise.resolve([]):new Promise((ie,G)=>{(async()=>{const ae=fe.length,$e=fe.slice(0,ee).sort(me);for(let Ce=ee,B=Math.min(ee+te,ae);Ce<ae;Ce=B,B=Math.min(B+te,ae)){if(Ce>ee&&await new Promise(Y=>setTimeout(Y)),K&&K.isCancellationRequested)throw new D.$4;n(fe,me,$e,Ce,B)}return $e})().then(ie,G)})}e.$Fb=i;function n(fe,me,ee,te,K){for(const ie=ee.length;te<K;te++){const G=fe[te];if(me(G,ee[ie-1])<0){ee.pop();const ae=(0,T.$jb)(ee,$e=>me(G,$e)<0);ee.splice(ae,0,G)}}}function s(fe){return fe.filter(me=>!!me)}e.$Gb=s;function a(fe){let me=0;for(let ee=0;ee<fe.length;ee++)fe[ee]&&(fe[me]=fe[ee],me+=1);fe.length=me}e.$Hb=a;function t(fe,me,ee){fe.splice(ee,0,fe.splice(me,1)[0])}e.$Ib=t;function r(fe){return!Array.isArray(fe)||fe.length===0}e.$Jb=r;function h(fe){return Array.isArray(fe)&&fe.length>0}e.$Kb=h;function u(fe,me=ee=>ee){const ee=new Set;return fe.filter(te=>{const K=me(te);return ee.has(K)?!1:(ee.add(K),!0)})}e.$Lb=u;function c(fe){const me=new Set;return ee=>{const te=fe(ee);return me.has(te)?!1:(me.add(te),!0)}}e.$Mb=c;function l(fe,me){return fe.length>0?fe[0]:me}e.$Nb=l;function E(fe,me){return fe.length>0?fe[fe.length-1]:me}e.$Ob=E;function C(fe,me,ee=(te,K)=>te===K){let te=0;for(let K=0,ie=Math.min(fe.length,me.length);K<ie&&ee(fe[K],me[K]);K++)te++;return te}e.$Pb=C;function f(fe){return[].concat(...fe)}e.$Qb=f;function p(fe,me){let ee=typeof me=="number"?fe:0;typeof me=="number"?ee=fe:(ee=0,me=fe);const te=[];if(ee<=me)for(let K=ee;K<me;K++)te.push(K);else for(let K=ee;K>me;K--)te.push(K);return te}e.$Rb=p;function k(fe,me,ee){return fe.reduce((te,K)=>(te[me(K)]=ee?ee(K):K,te),Object.create(null))}e.$Sb=k;function I(fe,me){return fe.push(me),()=>j(fe,me)}e.$Tb=I;function j(fe,me){const ee=fe.indexOf(me);if(ee>-1)return fe.splice(ee,1),me}e.$Ub=j;function z(fe,me,ee){const te=fe.slice(0,me),K=fe.slice(me);return te.concat(ee,K)}e.$Vb=z;function M(fe,me){let ee;if(typeof me=="number"){let te=me;ee=()=>{const K=Math.sin(te++)*179426549;return K-Math.floor(K)}}else ee=Math.random;for(let te=fe.length-1;te>0;te-=1){const K=Math.floor(ee()*(te+1)),ie=fe[te];fe[te]=fe[K],fe[K]=ie}}e.$Wb=M;function F(fe,me){const ee=fe.indexOf(me);ee>-1&&(fe.splice(ee,1),fe.unshift(me))}e.$Xb=F;function N(fe,me){const ee=fe.indexOf(me);ee>-1&&(fe.splice(ee,1),fe.push(me))}e.$Yb=N;function O(fe,me){for(const ee of me)fe.push(ee)}e.$Zb=O;function W(fe,me){return Array.isArray(fe)?fe.map(me):me(fe)}e.$1b=W;function x(fe){return Array.isArray(fe)?fe:[fe]}e.$2b=x;function ue(fe){return fe[Math.floor(Math.random()*fe.length)]}e.$3b=ue;function X(fe,me,ee){const te=Q(fe,me),K=fe.length,ie=ee.length;fe.length=K+ie;for(let G=K-1;G>=te;G--)fe[G+ie]=fe[G];for(let G=0;G<ie;G++)fe[G+te]=ee[G]}e.$4b=X;function J(fe,me,ee,te){const K=Q(fe,me);let ie=fe.splice(K,ee);return ie===void 0&&(ie=[]),X(fe,K,te),ie}e.$5b=J;function Q(fe,me){return me<0?Math.max(me+fe.length,0):Math.min(me,fe.length)}var he;(function(fe){function me(ie){return ie<0}fe.isLessThan=me;function ee(ie){return ie<=0}fe.isLessThanOrEqual=ee;function te(ie){return ie>0}fe.isGreaterThan=te;function K(ie){return ie===0}fe.isNeitherLessOrGreaterThan=K,fe.greaterThan=1,fe.lessThan=-1,fe.neitherLessOrGreaterThan=0})(he||(e.CompareResult=he={}));function Z(fe,me){return(ee,te)=>me(fe(ee),fe(te))}e.$6b=Z;function ye(...fe){return(me,ee)=>{for(const te of fe){const K=te(me,ee);if(!he.isNeitherLessOrGreaterThan(K))return K}return he.neitherLessOrGreaterThan}}e.$7b=ye;const de=(fe,me)=>fe-me;e.$8b=de;const H=(fe,me)=>(0,e.$8b)(fe?1:0,me?1:0);e.$9b=H;function U(fe){return(me,ee)=>-fe(me,ee)}e.$0b=U;class ne{constructor(me){this.g=me,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(me){let ee=this.c;for(;ee<this.g.length&&me(this.g[ee]);)ee++;const te=ee===this.c?null:this.g.slice(this.c,ee);return this.c=ee,te}takeFromEndWhile(me){let ee=this.d;for(;ee>=0&&me(this.g[ee]);)ee--;const te=ee===this.d?null:this.g.slice(ee+1,this.d+1);return this.d=ee,te}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const me=this.g[this.c];return this.c++,me}removeLast(){const me=this.g[this.d];return this.d--,me}takeCount(me){const ee=this.g.slice(this.c,this.c+me);return this.c+=me,ee}}e.$$b=ne;class Ee{static{this.empty=new Ee(me=>{})}constructor(me){this.iterate=me}forEach(me){this.iterate(ee=>(me(ee),!0))}toArray(){const me=[];return this.iterate(ee=>(me.push(ee),!0)),me}filter(me){return new Ee(ee=>this.iterate(te=>me(te)?ee(te):!0))}map(me){return new Ee(ee=>this.iterate(te=>ee(me(te))))}some(me){let ee=!1;return this.iterate(te=>(ee=me(te),!ee)),ee}findFirst(me){let ee;return this.iterate(te=>me(te)?(ee=te,!1):!0),ee}findLast(me){let ee;return this.iterate(te=>(me(te)&&(ee=te),!0)),ee}findLastMaxBy(me){let ee,te=!0;return this.iterate(K=>((te||he.isGreaterThan(me(K,ee)))&&(te=!1,ee=K),!0)),ee}}e.$_b=Ee}),define(ke[60],Se([1,0,8]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function T(b,y){if(!b)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=T;function m(b,y="Unreachable"){throw new Error(y)}e.$4c=m;function A(b){if(!b)throw new D.$bb("Assertion Failed")}e.$5c=A;function R(b){if(!b()){debugger;b(),(0,D.$Z)(new D.$bb("Assertion Failed"))}}e.$6c=R;function w(b,y){let L=0;for(;L<b.length-1;){const P=b[L],$=b[L+1];if(!y(P,$))return!1;L++}return!0}e.$7c=w}),define(ke[74],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function D(T,m){const A=this;let R=!1,w;return function(){if(R)return w;if(R=!0,m)try{w=T.apply(A,arguments)}finally{m()}else w=T.apply(A,arguments);return w}}e.$cb=D}),define(ke[122],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=void 0;class D{constructor(m){this.a=m,this.b=0}nextId(){return this.a+ ++this.b}}e.$JM=D,e.$KM=new D("id#")}),define(ke[51],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(T){function m(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}T.is=m;const A=Object.freeze([]);function R(){return A}T.empty=R;function*w(a){yield a}T.single=w;function b(a){return m(a)?a:w(a)}T.wrap=b;function y(a){return a||A}T.from=y;function*L(a){for(let t=a.length-1;t>=0;t--)yield a[t]}T.reverse=L;function P(a){return!a||a[Symbol.iterator]().next().done===!0}T.isEmpty=P;function $(a){return a[Symbol.iterator]().next().value}T.first=$;function v(a,t){for(const r of a)if(t(r))return!0;return!1}T.some=v;function S(a,t){for(const r of a)if(t(r))return r}T.find=S;function*g(a,t){for(const r of a)t(r)&&(yield r)}T.filter=g;function*d(a,t){let r=0;for(const h of a)yield t(h,r++)}T.map=d;function*o(...a){for(const t of a)for(const r of t)yield r}T.concat=o;function i(a,t,r){let h=r;for(const u of a)h=t(h,u);return h}T.reduce=i;function*n(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}T.slice=n;function s(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const h=a[Symbol.iterator]();for(let u=0;u<t;u++){const c=h.next();if(c.done)return[r,T.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return h}}]}T.consume=s})(D||(e.Iterable=D={}))}),define(ke[159],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var m;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(m||(e.ParseErrorCode=m={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function R(t,r=!1){let h=0;const u=t.length;let c="",l=0,E=16,C=0;function f(F){let N=0,O=0;for(;N<F;){const W=t.charCodeAt(h);if(W>=48&&W<=57)O=O*16+W-48;else if(W>=65&&W<=70)O=O*16+W-65+10;else if(W>=97&&W<=102)O=O*16+W-97+10;else break;h++,N++}return N<F&&(O=-1),O}function p(F){h=F,c="",l=0,E=16,C=0}function k(){const F=h;if(t.charCodeAt(h)===48)h++;else for(h++;h<t.length&&y(t.charCodeAt(h));)h++;if(h<t.length&&t.charCodeAt(h)===46)if(h++,h<t.length&&y(t.charCodeAt(h)))for(h++;h<t.length&&y(t.charCodeAt(h));)h++;else return C=3,t.substring(F,h);let N=h;if(h<t.length&&(t.charCodeAt(h)===69||t.charCodeAt(h)===101))if(h++,(h<t.length&&t.charCodeAt(h)===43||t.charCodeAt(h)===45)&&h++,h<t.length&&y(t.charCodeAt(h))){for(h++;h<t.length&&y(t.charCodeAt(h));)h++;N=h}else C=3;return t.substring(F,N)}function I(){let F="",N=h;for(;;){if(h>=u){F+=t.substring(N,h),C=2;break}const O=t.charCodeAt(h);if(O===34){F+=t.substring(N,h),h++;break}if(O===92){if(F+=t.substring(N,h),h++,h>=u){C=2;break}switch(t.charCodeAt(h++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const x=f(4);x>=0?F+=String.fromCharCode(x):C=4;break}default:C=5}N=h;continue}if(O>=0&&O<=31)if(b(O)){F+=t.substring(N,h),C=2;break}else C=6;h++}return F}function j(){if(c="",C=0,l=h,h>=u)return l=u,E=17;let F=t.charCodeAt(h);if(w(F)){do h++,c+=String.fromCharCode(F),F=t.charCodeAt(h);while(w(F));return E=15}if(b(F))return h++,c+=String.fromCharCode(F),F===13&&t.charCodeAt(h)===10&&(h++,c+=`
`),E=14;switch(F){case 123:return h++,E=1;case 125:return h++,E=2;case 91:return h++,E=3;case 93:return h++,E=4;case 58:return h++,E=6;case 44:return h++,E=5;case 34:return h++,c=I(),E=10;case 47:{const N=h-1;if(t.charCodeAt(h+1)===47){for(h+=2;h<u&&!b(t.charCodeAt(h));)h++;return c=t.substring(N,h),E=12}if(t.charCodeAt(h+1)===42){h+=2;const O=u-1;let W=!1;for(;h<O;){if(t.charCodeAt(h)===42&&t.charCodeAt(h+1)===47){h+=2,W=!0;break}h++}return W||(h++,C=1),c=t.substring(N,h),E=13}return c+=String.fromCharCode(F),h++,E=16}case 45:if(c+=String.fromCharCode(F),h++,h===u||!y(t.charCodeAt(h)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=k(),E=11;default:for(;h<u&&z(F);)h++,F=t.charCodeAt(h);if(l!==h){switch(c=t.substring(l,h),c){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return c+=String.fromCharCode(F),h++,E=16}}function z(F){if(w(F)||b(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let F;do F=j();while(F>=12&&F<=15);return F}return{setPosition:p,getPosition:()=>h,scan:r?M:j,getToken:()=>E,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>h-l,getTokenError:()=>C}}e.$5m=R;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function P(t,r){const h=[],u=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function C(f,p,k,I){l.value=f,l.offset=p,l.length=k,l.type=I,l.colonOffset=void 0,c=l}try{n(t,{onObjectBegin:(f,p)=>{if(r<=f)throw u;c=void 0,E=r>f,h.push("")},onObjectProperty:(f,p,k)=>{if(r<p||(C(f,p,k,"property"),h[h.length-1]=f,r<=p+k))throw u},onObjectEnd:(f,p)=>{if(r<=f)throw u;c=void 0,h.pop()},onArrayBegin:(f,p)=>{if(r<=f)throw u;c=void 0,h.push(0)},onArrayEnd:(f,p)=>{if(r<=f)throw u;c=void 0,h.pop()},onLiteralValue:(f,p,k)=>{if(r<p||(C(f,p,k,a(f)),r<=p+k))throw u},onSeparator:(f,p,k)=>{if(r<=p)throw u;if(f===":"&&c&&c.type==="property")c.colonOffset=p,E=!1,c=void 0;else if(f===","){const I=h[h.length-1];typeof I=="number"?h[h.length-1]=I+1:(E=!0,h[h.length-1]=""),c=void 0}}})}catch(f){if(f!==u)throw f}return{path:h,previousNode:c,isAtPropertyKey:E,matches:f=>{let p=0;for(let k=0;p<f.length&&k<h.length;k++)if(f[p]===h[k]||f[p]==="*")p++;else if(f[p]!=="**")return!1;return p===f.length}}}e.$6m=P;function $(t,r=[],h=A.DEFAULT){let u=null,c=[];const l=[];function E(f){Array.isArray(c)?c.push(f):u!==null&&(c[u]=f)}return n(t,{onObjectBegin:()=>{const f={};E(f),l.push(c),c=f,u=null},onObjectProperty:f=>{u=f},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const f=[];E(f),l.push(c),c=f,u=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:E,onError:(f,p,k)=>{r.push({error:f,offset:p,length:k})}},h),c[0]}e.$7m=$;function v(t,r=[],h=A.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(f){u.type==="property"&&(u.length=f-u.offset,u=u.parent)}function l(f){return u.children.push(f),f}n(t,{onObjectBegin:f=>{u=l({type:"object",offset:f,length:-1,parent:u,children:[]})},onObjectProperty:(f,p,k)=>{u=l({type:"property",offset:p,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:f,offset:p,length:k,parent:u})},onObjectEnd:(f,p)=>{u.length=f+p-u.offset,u=u.parent,c(f+p)},onArrayBegin:(f,p)=>{u=l({type:"array",offset:f,length:-1,parent:u,children:[]})},onArrayEnd:(f,p)=>{u.length=f+p-u.offset,u=u.parent,c(f+p)},onLiteralValue:(f,p,k)=>{l({type:a(f),offset:p,length:k,parent:u,value:f}),c(p+k)},onSeparator:(f,p,k)=>{u.type==="property"&&(f===":"?u.colonOffset=p:f===","&&c(p))},onError:(f,p,k)=>{r.push({error:f,offset:p,length:k})}},h);const C=u.children[0];return C&&delete C.parent,C}e.$8m=v;function S(t,r){if(!t)return;let h=t;for(const u of r)if(typeof u=="string"){if(h.type!=="object"||!Array.isArray(h.children))return;let c=!1;for(const l of h.children)if(Array.isArray(l.children)&&l.children[0].value===u){h=l.children[1],c=!0;break}if(!c)return}else{const c=u;if(h.type!=="array"||c<0||!Array.isArray(h.children)||c>=h.children.length)return;h=h.children[c]}return h}e.$9m=S;function g(t){if(!t.parent||!t.parent.children)return[];const r=g(t.parent);if(t.parent.type==="property"){const h=t.parent.children[0].value;r.push(h)}else if(t.parent.type==="array"){const h=t.parent.children.indexOf(t);h!==-1&&r.push(h)}return r}e.$0m=g;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const r=Object.create(null);for(const h of t.children){const u=h.children[1];u&&(r[h.children[0].value]=d(u))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$$m=d;function o(t,r,h=!1){return r>=t.offset&&r<t.offset+t.length||h&&r===t.offset+t.length}e.$_m=o;function i(t,r,h=!1){if(o(t,r,h)){const u=t.children;if(Array.isArray(u))for(let c=0;c<u.length&&u[c].offset<=r;c++){const l=i(u[c],r,h);if(l)return l}return t}}e.$an=i;function n(t,r,h=A.DEFAULT){const u=R(t,!1);function c(Z){return Z?()=>Z(u.getTokenOffset(),u.getTokenLength()):()=>!0}function l(Z){return Z?ye=>Z(ye,u.getTokenOffset(),u.getTokenLength()):()=>!0}const E=c(r.onObjectBegin),C=l(r.onObjectProperty),f=c(r.onObjectEnd),p=c(r.onArrayBegin),k=c(r.onArrayEnd),I=l(r.onLiteralValue),j=l(r.onSeparator),z=c(r.onComment),M=l(r.onError),F=h&&h.disallowComments,N=h&&h.allowTrailingComma;function O(){for(;;){const Z=u.scan();switch(u.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:F||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(Z){case 12:case 13:F?W(10):z();break;case 16:W(1);break;case 15:case 14:break;default:return Z}}}function W(Z,ye=[],de=[]){if(M(Z),ye.length+de.length>0){let H=u.getToken();for(;H!==17;){if(ye.indexOf(H)!==-1){O();break}else if(de.indexOf(H)!==-1)break;H=O()}}}function x(Z){const ye=u.getTokenValue();return Z?I(ye):C(ye),O(),!0}function ue(){switch(u.getToken()){case 11:{let Z=0;try{Z=JSON.parse(u.getTokenValue()),typeof Z!="number"&&(W(2),Z=0)}catch{W(2)}I(Z);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return O(),!0}function X(){return u.getToken()!==10?(W(3,[],[2,5]),!1):(x(!1),u.getToken()===6?(j(":"),O(),he()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function J(){E(),O();let Z=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(Z||W(4,[],[]),j(","),O(),u.getToken()===2&&N)break}else Z&&W(6,[],[]);X()||W(4,[],[2,5]),Z=!0}return f(),u.getToken()!==2?W(7,[2],[]):O(),!0}function Q(){p(),O();let Z=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(Z||W(4,[],[]),j(","),O(),u.getToken()===4&&N)break}else Z&&W(6,[],[]);he()||W(4,[],[4,5]),Z=!0}return k(),u.getToken()!==4?W(8,[4],[]):O(),!0}function he(){switch(u.getToken()){case 3:return Q();case 1:return J();case 10:return x(!0);default:return ue()}}return O(),u.getToken()===17?h.allowEmptyContent?!0:(W(4,[],[]),!1):he()?(u.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$bn=n;function s(t,r){const h=R(t),u=[];let c,l=0,E;do switch(E=h.getPosition(),c=h.scan(),c){case 12:case 13:case 17:l!==E&&u.push(t.substring(l,E)),r!==void 0&&u.push(h.getTokenValue().replace(/[^\r\n]/g,r)),l=h.getPosition();break}while(c!==17);return u.join("")}e.$cn=s;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$dn=a}),define(ke[43],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class D{constructor(m){this.d=m,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(m){this.c=m}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=D}),define(ke[75],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}class T{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let A=this.a;for(;A!==D.Undefined;){const R=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=R}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,R){const w=new D(A);if(this.a===D.Undefined)this.a=w,this.b=w;else if(R){const y=this.b;this.b=w,w.prev=y,y.next=w}else{const y=this.a;this.a=w,w.next=y,y.prev=w}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(w))}}shift(){if(this.a!==D.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==D.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const R=A.prev;R.next=A.next,A.next.prev=R}else A.prev===D.Undefined&&A.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):A.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):A.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.$2c=T}),define(ke[28],Se([1,0]),function(be,e){"use strict";var D,T,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function A(i,n,s){let a=i.get(n);return a===void 0&&(a=s,i.set(n,a)),a}e.$wc=A;function R(i){const n=[];return i.forEach((s,a)=>{n.push(`${a} => ${s}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.$xc=R;function w(i){const n=[];return i.forEach(s=>{n.push(s)}),`Set(${i.size}) {${n.join(", ")}}`}e.$yc=w;class b{constructor(n,s){this.uri=n,this.value=s}}function y(i){return Array.isArray(i)}class L{static{this.a=n=>n.toString()}constructor(n,s){if(this[D]="ResourceMap",n instanceof L)this.b=new Map(n.b),this.c=s??L.a;else if(y(n)){this.b=new Map,this.c=s??L.a;for(const[a,t]of n)this.set(a,t)}else this.b=new Map,this.c=n??L.a}set(n,s){return this.b.set(this.c(n),new b(n,s)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[a,t]of this.b)n(t.value,t.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$zc=L;class P{constructor(n,s){this[T]="ResourceSet",!n||typeof n=="function"?this.a=new L(n):(this.a=new L(s),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,s){this.a.forEach((a,t)=>n.call(s,t,t,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=P;var $;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})($||(e.Touch=$={}));class v{constructor(){this[m]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,s=0){const a=this.a.get(n);if(a)return s!==0&&this.j(a,s),a.value}set(n,s,a=0){let t=this.a.get(n);if(t)t.value=s,a!==0&&this.j(t,a);else{switch(t={key:n,value:s,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(n,t),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this.a.get(n);if(s)return this.a.delete(n),this.i(s),this.d--,s.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,s){const a=this.e;let t=this.b;for(;t;){if(s?n.bind(s)(t.value,t.key,this):n(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,s=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.key,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}values(){const n=this,s=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.value,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}entries(){const n=this,s=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:[a.key,a.value],done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}[(m=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this.b,a=this.size;for(;s&&a>n;)this.a.delete(s.key),s=s.next,a--;this.b=s,this.d=a,s&&(s.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const s=n.next,a=n.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}n.next=void 0,n.previous=void 0,this.e++}j(n,s){if(!this.b||!this.c)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this.b)return;const a=n.next,t=n.previous;n===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(s===2){if(n===this.c)return;const a=n.next,t=n.previous;n===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((s,a)=>{n.push([a,s])}),n}fromJSON(n){this.clear();for(const[s,a]of n)this.set(s,a)}}e.$Bc=v;class S extends v{constructor(n,s=1){super(),this.k=n,this.l=Math.min(Math.max(0,s),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=S;class g{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let s=this.a.get(n)||0;return s===0?!1:(s--,s===0?this.a.delete(n):this.a.set(n,s),!0)}has(n){return this.a.has(n)}}e.$Dc=g;class d{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[s,a]of n)this.set(s,a)}clear(){this.a.clear(),this.b.clear()}set(n,s){this.a.set(n,s),this.b.set(s,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const s=this.a.get(n);return s===void 0?!1:(this.a.delete(n),this.b.delete(s),!0)}forEach(n,s){this.a.forEach((a,t)=>{n.call(s,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=d;class o{constructor(){this.a=new Map}add(n,s){let a=this.a.get(n);a||(a=new Set,this.a.set(n,a)),a.add(s)}delete(n,s){const a=this.a.get(n);a&&(a.delete(s),a.size===0&&this.a.delete(n))}forEach(n,s){const a=this.a.get(n);a&&a.forEach(s)}get(n){const s=this.a.get(n);return s||new Set}}e.$Fc=o}),define(ke[3],Se([1,0,19,73,28,74,51]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const w=!1;let b=null;class y{constructor(){this.b=new Map}static{this.a=0}c(I){let j=this.b.get(I);return j||(j={parent:null,source:null,isSingleton:!1,value:I,idx:y.a++},this.b.set(I,j)),j}trackDisposable(I){const j=this.c(I);j.source||(j.source=new Error().stack)}setParent(I,j){const z=this.c(I);z.parent=j}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,j){const z=j.get(I);if(z)return z;const M=I.parent?this.f(this.c(I.parent),j):I;return j.set(I,M),M}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,I).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(I=10,j){let z;if(j)z=j;else{const W=new Map,x=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,W).isSingleton);if(x.length===0)return;const ue=new Set(x.map(X=>X.value));if(z=x.filter(X=>!(X.parent&&ue.has(X.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function M(W){function x(X,J){for(;X.length>0&&J.some(Q=>typeof Q=="string"?Q===X[0]:X[0].match(Q));)X.shift()}const ue=W.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return x(ue,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ue.reverse()}const F=new m.$Fc;for(const W of z){const x=M(W);for(let ue=0;ue<=x.length;ue++)F.add(x.slice(0,ue).join(`
`),W)}z.sort((0,D.$6b)(W=>W.idx,D.$8b));let N="",O=0;for(const W of z.slice(0,I)){O++;const x=M(W),ue=[];for(let X=0;X<x.length;X++){let J=x[X];J=`(shared with ${F.get(x.slice(0,X+1).join(`
`)).size}/${z.length} leaks) at ${J}`;const he=F.get(x.slice(0,X).join(`
`)),Z=(0,T.$J)([...he].map(ye=>M(ye)[X]),ye=>ye);delete Z[x[X]];for(const[ye,de]of Object.entries(Z))ue.unshift(`    - stacktraces of ${de.length} other leaks continue with ${ye}`);ue.unshift(J)}N+=`


==================== Leaking disposable ${O}/${z.length}: ${W.value.constructor.name} ====================
${ue.join(`
`)}
============================================================

`}return z.length>I&&(N+=`


... and ${z.length-I} more leaking disposables

`),{leaks:z,details:N}}}e.$Gc=y;function L(k){b=k}if(e.$Hc=L,w){const k="__is_disposable_tracked__";L(new class{trackDisposable(I){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[k]||console.log(j)},3e3)}setParent(I,j){if(I&&I!==t.None)try{I[k]=!0}catch{}}markAsDisposed(I){if(I&&I!==t.None)try{I[k]=!0}catch{}}markAsSingleton(I){}})}function P(k){return b?.trackDisposable(k),k}e.$Ic=P;function $(k){b?.markAsDisposed(k)}e.$Jc=$;function v(k,I){b?.setParent(k,I)}function S(k,I){if(b)for(const j of k)b.setParent(j,I)}function g(k){return b?.markAsSingleton(k),k}e.$Kc=g;function d(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Lc=d;function o(k){if(R.Iterable.is(k)){const I=[];for(const j of k)if(j)try{j.dispose()}catch(z){I.push(z)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Mc=o;function i(k){for(const I of k)d(I)&&I.dispose();return[]}e.$Nc=i;function n(...k){const I=s(()=>o(k));return S(k,I),I}e.$Oc=n;function s(k){const I=P({dispose:(0,A.$cb)(()=>{$(I),k()})});return I}e.$Pc=s;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return v(I,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),v(I,null))}}e.$Qc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,P(this),v(this.q,this)}dispose(){$(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Rc=t;class r{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&v(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&v(I,null),I}}e.$Sc=r;class h{constructor(I){this.a=new r,this.b=!1,this.a.value=I}get value(){return this.a.value}set value(I){this.b||I===this.a.value||(this.a.value=I)}dispose(){this.b=!0,this.a.dispose()}}e.$Tc=h;class u{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=u;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(I){let j=I;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,$(this))},this}}e.$Vc=c;class l{constructor(){this.a=new Map}acquire(I,...j){let z=this.a.get(I);z||(z={counter:0,object:this.b(I,...j)},this.a.set(I,z));const{object:M}=z,F=(0,A.$cb)(()=>{--z.counter===0&&(this.c(I,z.object),this.a.delete(I))});return z.counter++,{object:M,dispose:F}}}e.$Wc=l;class E{constructor(I){this.a=I}async acquire(I,...j){const z=this.a.acquire(I,...j);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(M){throw z.dispose(),M}}}e.$Xc=E;class C{constructor(I){this.object=I}dispose(){}}e.$Yc=C;function f(k){const I=new a;try{k(I)}finally{I.dispose()}}e.$Zc=f;class p{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,j,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(I)?.dispose(),this.a.set(I,j)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=p}),function(be,e){typeof define=="function"&&define.amd?define(ke[160],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(me,ee){for(var te=0;te<ee.length;te++){var K=ee[te];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(me,K.key,K)}}function D(me,ee,te){return ee&&e(me.prototype,ee),te&&e(me,te),Object.defineProperty(me,"prototype",{writable:!1}),me}function T(me,ee){if(me){if(typeof me=="string")return m(me,ee);var te=Object.prototype.toString.call(me).slice(8,-1);if(te==="Object"&&me.constructor&&(te=me.constructor.name),te==="Map"||te==="Set")return Array.from(me);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return m(me,ee)}}function m(me,ee){(ee==null||ee>me.length)&&(ee=me.length);for(var te=0,K=new Array(ee);te<ee;te++)K[te]=me[te];return K}function A(me,ee){var te=typeof Symbol<"u"&&me[Symbol.iterator]||me["@@iterator"];if(te)return(te=te.call(me)).next.bind(te);if(Array.isArray(me)||(te=T(me))||ee&&me&&typeof me.length=="number"){te&&(me=te);var K=0;return function(){return K>=me.length?{done:!0}:{done:!1,value:me[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=R();function w(me){be.defaults=me}var b=/[&<>"']/,y=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(ee){return $[ee]};function S(me,ee){if(ee){if(b.test(me))return me.replace(y,v)}else if(L.test(me))return me.replace(P,v);return me}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(me){return me.replace(g,function(ee,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(me,ee){me=typeof me=="string"?me:me.source,ee=ee||"";var te={replace:function(ie,G){return G=G.source||G,G=G.replace(o,"$1"),me=me.replace(ie,G),te},getRegex:function(){return new RegExp(me,ee)}};return te}var n=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(me,ee,te){if(me){var K;try{K=decodeURIComponent(d(te)).replace(n,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}ee&&!s.test(te)&&(te=c(ee,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var t={},r=/^[^:]+:\/*[^/]*$/,h=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(me,ee){t[" "+me]||(r.test(me)?t[" "+me]=me+"/":t[" "+me]=f(me,"/",!0)),me=t[" "+me];var te=me.indexOf(":")===-1;return ee.substring(0,2)==="//"?te?ee:me.replace(h,"$1")+ee:ee.charAt(0)==="/"?te?ee:me.replace(u,"$1")+ee:me+ee}var l={exec:function(){}};function E(me){for(var ee=1,te,K;ee<arguments.length;ee++){te=arguments[ee];for(K in te)Object.prototype.hasOwnProperty.call(te,K)&&(me[K]=te[K])}return me}function C(me,ee){var te=me.replace(/\|/g,function(G,ae,$e){for(var Ce=!1,B=ae;--B>=0&&$e[B]==="\\";)Ce=!Ce;return Ce?"|":" |"}),K=te.split(/ \|/),ie=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>ee)K.splice(ee);else for(;K.length<ee;)K.push("");for(;ie<K.length;ie++)K[ie]=K[ie].trim().replace(/\\\|/g,"|");return K}function f(me,ee,te){var K=me.length;if(K===0)return"";for(var ie=0;ie<K;){var G=me.charAt(K-ie-1);if(G===ee&&!te)ie++;else if(G!==ee&&te)ie++;else break}return me.slice(0,K-ie)}function p(me,ee){if(me.indexOf(ee[1])===-1)return-1;for(var te=me.length,K=0,ie=0;ie<te;ie++)if(me[ie]==="\\")ie++;else if(me[ie]===ee[0])K++;else if(me[ie]===ee[1]&&(K--,K<0))return ie;return-1}function k(me){me&&me.sanitize&&!me.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(me,ee){if(ee<1)return"";for(var te="";ee>1;)ee&1&&(te+=me),ee>>=1,me+=me;return te+me}function j(me,ee,te,K){var ie=ee.href,G=ee.title?S(ee.title):null,ae=me[1].replace(/\\([\[\]])/g,"$1");if(me[0].charAt(0)!=="!"){K.state.inLink=!0;var $e={type:"link",raw:te,href:ie,title:G,text:ae,tokens:K.inlineTokens(ae)};return K.state.inLink=!1,$e}return{type:"image",raw:te,href:ie,title:G,text:S(ae)}}function z(me,ee){var te=me.match(/^(\s+)(?:```)/);if(te===null)return ee;var K=te[1];return ee.split(`
`).map(function(ie){var G=ie.match(/^\s+/);if(G===null)return ie;var ae=G[0];return ae.length>=K.length?ie.slice(K.length):ie}).join(`
`)}var M=function(){function me(te){this.options=te||be.defaults}var ee=me.prototype;return ee.space=function(K){var ie=this.rules.block.newline.exec(K);if(ie&&ie[0].length>0)return{type:"space",raw:ie[0]}},ee.code=function(K){var ie=this.rules.block.code.exec(K);if(ie){var G=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?G:f(G,`
`)}}},ee.fences=function(K){var ie=this.rules.block.fences.exec(K);if(ie){var G=ie[0],ae=z(G,ie[3]||"");return{type:"code",raw:G,lang:ie[2]?ie[2].trim():ie[2],text:ae}}},ee.heading=function(K){var ie=this.rules.block.heading.exec(K);if(ie){var G=ie[2].trim();if(/#$/.test(G)){var ae=f(G,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(G=ae.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:G,tokens:this.lexer.inline(G)}}},ee.hr=function(K){var ie=this.rules.block.hr.exec(K);if(ie)return{type:"hr",raw:ie[0]}},ee.blockquote=function(K){var ie=this.rules.block.blockquote.exec(K);if(ie){var G=ie[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ie[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},ee.list=function(K){var ie=this.rules.block.list.exec(K);if(ie){var G,ae,$e,Ce,B,Y,se,oe,_,ge,ve,ze,We=ie[1].trim(),tt=We.length>1,Ye={type:"list",raw:"",ordered:tt,start:tt?+We.slice(0,-1):"",loose:!1,items:[]};We=tt?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=tt?We:"[*+-]");for(var rt=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(ze=!1,!(!(ie=rt.exec(K))||this.rules.block.hr.test(K)));){if(G=ie[0],K=K.substring(G.length),oe=ie[2].split(`
`,1)[0],_=K.split(`
`,1)[0],this.options.pedantic?(Ce=2,ve=oe.trimLeft()):(Ce=ie[2].search(/[^ ]/),Ce=Ce>4?1:Ce,ve=oe.slice(Ce),Ce+=ie[1].length),Y=!1,!oe&&/^ *$/.test(_)&&(G+=_+`
`,K=K.substring(_.length+1),ze=!0),!ze)for(var nt=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}#");K&&(ge=K.split(`
`,1)[0],oe=ge,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(oe)||qe.test(oe)||nt.test(oe)||Ae.test(K)));){if(oe.search(/[^ ]/)>=Ce||!oe.trim())ve+=`
`+oe.slice(Ce);else if(!Y)ve+=`
`+oe;else break;!Y&&!oe.trim()&&(Y=!0),G+=ge+`
`,K=K.substring(ge.length+1)}Ye.loose||(se?Ye.loose=!0:/\n *\n *$/.test(G)&&(se=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(ve),ae&&($e=ae[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:G,task:!!ae,checked:$e,loose:!1,text:ve}),Ye.raw+=G}Ye.items[Ye.items.length-1].raw=G.trimRight(),Ye.items[Ye.items.length-1].text=ve.trimRight(),Ye.raw=Ye.raw.trimRight();var Me=Ye.items.length;for(B=0;B<Me;B++){this.lexer.state.top=!1,Ye.items[B].tokens=this.lexer.blockTokens(Ye.items[B].text,[]);var Xe=Ye.items[B].tokens.filter(function(ce){return ce.type==="space"}),le=Xe.every(function(ce){for(var Pe=ce.raw.split(""),He=0,Ge=A(Pe),xe;!(xe=Ge()).done;){var ot=xe.value;if(ot===`
`&&(He+=1),He>1)return!0}return!1});!Ye.loose&&Xe.length&&le&&(Ye.loose=!0,Ye.items[B].loose=!0)}return Ye}},ee.html=function(K){var ie=this.rules.block.html.exec(K);if(ie){var G={type:"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:ie[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(ie[0]):S(ie[0]);G.type="paragraph",G.text=ae,G.tokens=this.lexer.inline(ae)}return G}},ee.def=function(K){var ie=this.rules.block.def.exec(K);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var G=ie[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:ie[0],href:ie[2],title:ie[3]}}},ee.table=function(K){var ie=this.rules.block.table.exec(K);if(ie){var G={type:"table",header:C(ie[1]).map(function(se){return{text:se}}),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ie[3]&&ie[3].trim()?ie[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=ie[0];var ae=G.align.length,$e,Ce,B,Y;for($e=0;$e<ae;$e++)/^ *-+: *$/.test(G.align[$e])?G.align[$e]="right":/^ *:-+: *$/.test(G.align[$e])?G.align[$e]="center":/^ *:-+ *$/.test(G.align[$e])?G.align[$e]="left":G.align[$e]=null;for(ae=G.rows.length,$e=0;$e<ae;$e++)G.rows[$e]=C(G.rows[$e],G.header.length).map(function(se){return{text:se}});for(ae=G.header.length,Ce=0;Ce<ae;Ce++)G.header[Ce].tokens=this.lexer.inline(G.header[Ce].text);for(ae=G.rows.length,Ce=0;Ce<ae;Ce++)for(Y=G.rows[Ce],B=0;B<Y.length;B++)Y[B].tokens=this.lexer.inline(Y[B].text);return G}}},ee.lheading=function(K){var ie=this.rules.block.lheading.exec(K);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1],tokens:this.lexer.inline(ie[1])}},ee.paragraph=function(K){var ie=this.rules.block.paragraph.exec(K);if(ie){var G=ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1];return{type:"paragraph",raw:ie[0],text:G,tokens:this.lexer.inline(G)}}},ee.text=function(K){var ie=this.rules.block.text.exec(K);if(ie)return{type:"text",raw:ie[0],text:ie[0],tokens:this.lexer.inline(ie[0])}},ee.escape=function(K){var ie=this.rules.inline.escape.exec(K);if(ie)return{type:"escape",raw:ie[0],text:S(ie[1])}},ee.tag=function(K){var ie=this.rules.inline.tag.exec(K);if(ie)return!this.lexer.state.inLink&&/^<a /i.test(ie[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ie[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ie[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ie[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ie[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):S(ie[0]):ie[0]}},ee.link=function(K){var ie=this.rules.inline.link.exec(K);if(ie){var G=ie[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var ae=f(G.slice(0,-1),"\\");if((G.length-ae.length)%2===0)return}else{var $e=p(ie[2],"()");if($e>-1){var Ce=ie[0].indexOf("!")===0?5:4,B=Ce+ie[1].length+$e;ie[2]=ie[2].substring(0,$e),ie[0]=ie[0].substring(0,B).trim(),ie[3]=""}}var Y=ie[2],se="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Y);oe&&(Y=oe[1],se=oe[3])}else se=ie[3]?ie[3].slice(1,-1):"";return Y=Y.trim(),/^</.test(Y)&&(this.options.pedantic&&!/>$/.test(G)?Y=Y.slice(1):Y=Y.slice(1,-1)),j(ie,{href:Y&&Y.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},ie[0],this.lexer)}},ee.reflink=function(K,ie){var G;if((G=this.rules.inline.reflink.exec(K))||(G=this.rules.inline.nolink.exec(K))){var ae=(G[2]||G[1]).replace(/\s+/g," ");if(ae=ie[ae.toLowerCase()],!ae||!ae.href){var $e=G[0].charAt(0);return{type:"text",raw:$e,text:$e}}return j(G,ae,G[0],this.lexer)}},ee.emStrong=function(K,ie,G){G===void 0&&(G="");var ae=this.rules.inline.emStrong.lDelim.exec(K);if(ae&&!(ae[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $e=ae[1]||ae[2]||"";if(!$e||$e&&(G===""||this.rules.inline.punctuation.exec(G))){var Ce=ae[0].length-1,B,Y,se=Ce,oe=0,_=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(_.lastIndex=0,ie=ie.slice(-1*K.length+Ce);(ae=_.exec(ie))!=null;)if(B=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!B){if(Y=B.length,ae[3]||ae[4]){se+=Y;continue}else if((ae[5]||ae[6])&&Ce%3&&!((Ce+Y)%3)){oe+=Y;continue}if(se-=Y,!(se>0)){if(Y=Math.min(Y,Y+se+oe),Math.min(Ce,Y)%2){var ge=K.slice(1,Ce+ae.index+Y);return{type:"em",raw:K.slice(0,Ce+ae.index+Y+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}var ve=K.slice(2,Ce+ae.index+Y-1);return{type:"strong",raw:K.slice(0,Ce+ae.index+Y+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},ee.codespan=function(K){var ie=this.rules.inline.code.exec(K);if(ie){var G=ie[2].replace(/\n/g," "),ae=/[^ ]/.test(G),$e=/^ /.test(G)&&/ $/.test(G);return ae&&$e&&(G=G.substring(1,G.length-1)),G=S(G,!0),{type:"codespan",raw:ie[0],text:G}}},ee.br=function(K){var ie=this.rules.inline.br.exec(K);if(ie)return{type:"br",raw:ie[0]}},ee.del=function(K){var ie=this.rules.inline.del.exec(K);if(ie)return{type:"del",raw:ie[0],text:ie[2],tokens:this.lexer.inlineTokens(ie[2])}},ee.autolink=function(K,ie){var G=this.rules.inline.autolink.exec(K);if(G){var ae,$e;return G[2]==="@"?(ae=S(this.options.mangle?ie(G[1]):G[1]),$e="mailto:"+ae):(ae=S(G[1]),$e=ae),{type:"link",raw:G[0],text:ae,href:$e,tokens:[{type:"text",raw:ae,text:ae}]}}},ee.url=function(K,ie){var G;if(G=this.rules.inline.url.exec(K)){var ae,$e;if(G[2]==="@")ae=S(this.options.mangle?ie(G[0]):G[0]),$e="mailto:"+ae;else{var Ce;do Ce=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(Ce!==G[0]);ae=S(G[0]),G[1]==="www."?$e="http://"+ae:$e=ae}return{type:"link",raw:G[0],text:ae,href:$e,tokens:[{type:"text",raw:ae,text:ae}]}}},ee.inlineText=function(K,ie){var G=this.rules.inline.text.exec(K);if(G){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):S(G[0]):G[0]:ae=S(this.options.smartypants?ie(G[0]):G[0]),{type:"text",raw:G[0],text:ae}}},me}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=i(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=i(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=i(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=i(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=i(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=i(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=E({},F),F.gfm=E({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=i(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=i(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=E({},F.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:i(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=i(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=i(F._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=i(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=i(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=i(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=i(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=i(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=i(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=i(N.reflink).replace("label",N._label).replace("ref",F._label).getRegex(),N.nolink=i(N.nolink).replace("ref",F._label).getRegex(),N.reflinkSearch=i(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=E({},N),N.pedantic=E({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=E({},N.normal,{escape:i(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=i(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=E({},N.gfm,{br:i(N.br).replace("{2,}","*").getRegex(),text:i(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(me){return me.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(me){var ee="",te,K,ie=me.length;for(te=0;te<ie;te++)K=me.charCodeAt(te),Math.random()>.5&&(K="x"+K.toString(16)),ee+="&#"+K+";";return ee}var x=function(){function me(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||be.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:F.normal,inline:N.normal};this.options.pedantic?(K.block=F.pedantic,K.inline=N.pedantic):this.options.gfm&&(K.block=F.gfm,this.options.breaks?K.inline=N.breaks:K.inline=N.gfm),this.tokenizer.rules=K}me.lex=function(K,ie){var G=new me(ie);return G.lex(K)},me.lexInline=function(K,ie){var G=new me(ie);return G.inlineTokens(K)};var ee=me.prototype;return ee.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var ie;ie=this.inlineQueue.shift();)this.inlineTokens(ie.src,ie.tokens);return this.tokens},ee.blockTokens=function(K,ie){var G=this;ie===void 0&&(ie=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(se,oe,_){return oe+"    ".repeat(_.length)});for(var ae,$e,Ce,B;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(ae=se.call({lexer:G},K,ie))?(K=K.substring(ae.raw.length),ie.push(ae),!0):!1}))){if(ae=this.tokenizer.space(K)){K=K.substring(ae.raw.length),ae.raw.length===1&&ie.length>0?ie[ie.length-1].raw+=`
`:ie.push(ae);continue}if(ae=this.tokenizer.code(K)){K=K.substring(ae.raw.length),$e=ie[ie.length-1],$e&&($e.type==="paragraph"||$e.type==="text")?($e.raw+=`
`+ae.raw,$e.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=$e.text):ie.push(ae);continue}if(ae=this.tokenizer.fences(K)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(ae=this.tokenizer.heading(K)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(ae=this.tokenizer.hr(K)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(ae=this.tokenizer.blockquote(K)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(ae=this.tokenizer.list(K)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(ae=this.tokenizer.html(K)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(ae=this.tokenizer.def(K)){K=K.substring(ae.raw.length),$e=ie[ie.length-1],$e&&($e.type==="paragraph"||$e.type==="text")?($e.raw+=`
`+ae.raw,$e.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=$e.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(K)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(ae=this.tokenizer.lheading(K)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(Ce=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,oe=K.slice(1),_=void 0;G.options.extensions.startBlock.forEach(function(ge){_=ge.call({lexer:this},oe),typeof _=="number"&&_>=0&&(se=Math.min(se,_))}),se<1/0&&se>=0&&(Ce=K.substring(0,se+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(Ce))){$e=ie[ie.length-1],B&&$e.type==="paragraph"?($e.raw+=`
`+ae.raw,$e.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$e.text):ie.push(ae),B=Ce.length!==K.length,K=K.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(K)){K=K.substring(ae.raw.length),$e=ie[ie.length-1],$e&&$e.type==="text"?($e.raw+=`
`+ae.raw,$e.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$e.text):ie.push(ae);continue}if(K){var Y="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return this.state.top=!0,ie},ee.inline=function(K,ie){return ie===void 0&&(ie=[]),this.inlineQueue.push({src:K,tokens:ie}),ie},ee.inlineTokens=function(K,ie){var G=this;ie===void 0&&(ie=[]);var ae,$e,Ce,B=K,Y,se,oe;if(this.tokens.links){var _=Object.keys(this.tokens.links);if(_.length>0)for(;(Y=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)_.includes(Y[0].slice(Y[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,Y.index)+"["+I("a",Y[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Y=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,Y.index)+"["+I("a",Y[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Y=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,Y.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(se||(oe=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(ae=ve.call({lexer:G},K,ie))?(K=K.substring(ae.raw.length),ie.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(K)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(ae=this.tokenizer.tag(K)){K=K.substring(ae.raw.length),$e=ie[ie.length-1],$e&&ae.type==="text"&&$e.type==="text"?($e.raw+=ae.raw,$e.text+=ae.text):ie.push(ae);continue}if(ae=this.tokenizer.link(K)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(ae=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(ae.raw.length),$e=ie[ie.length-1],$e&&ae.type==="text"&&$e.type==="text"?($e.raw+=ae.raw,$e.text+=ae.text):ie.push(ae);continue}if(ae=this.tokenizer.emStrong(K,B,oe)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(ae=this.tokenizer.codespan(K)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(ae=this.tokenizer.br(K)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(ae=this.tokenizer.del(K)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(ae=this.tokenizer.autolink(K,W)){K=K.substring(ae.raw.length),ie.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(K,W))){K=K.substring(ae.raw.length),ie.push(ae);continue}if(Ce=K,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,ze=K.slice(1),We=void 0;G.options.extensions.startInline.forEach(function(tt){We=tt.call({lexer:this},ze),typeof We=="number"&&We>=0&&(ve=Math.min(ve,We))}),ve<1/0&&ve>=0&&(Ce=K.substring(0,ve+1))}(),ae=this.tokenizer.inlineText(Ce,O)){K=K.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(oe=ae.raw.slice(-1)),se=!0,$e=ie[ie.length-1],$e&&$e.type==="text"?($e.raw+=ae.raw,$e.text+=ae.text):ie.push(ae);continue}if(K){var ge="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return ie},D(me,null,[{key:"rules",get:function(){return{block:F,inline:N}}}]),me}(),ue=function(){function me(te){this.options=te||be.defaults}var ee=me.prototype;return ee.code=function(K,ie,G){var ae=(ie||"").match(/\S*/)[0];if(this.options.highlight){var $e=this.options.highlight(K,ae);$e!=null&&$e!==K&&(G=!0,K=$e)}return K=K.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+S(ae,!0)+'">'+(G?K:S(K,!0))+`</code></pre>
`:"<pre><code>"+(G?K:S(K,!0))+`</code></pre>
`},ee.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},ee.html=function(K){return K},ee.heading=function(K,ie,G,ae){if(this.options.headerIds){var $e=this.options.headerPrefix+ae.slug(G);return"<h"+ie+' id="'+$e+'">'+K+"</h"+ie+`>
`}return"<h"+ie+">"+K+"</h"+ie+`>
`},ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ee.list=function(K,ie,G){var ae=ie?"ol":"ul",$e=ie&&G!==1?' start="'+G+'"':"";return"<"+ae+$e+`>
`+K+"</"+ae+`>
`},ee.listitem=function(K){return"<li>"+K+`</li>
`},ee.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ee.paragraph=function(K){return"<p>"+K+`</p>
`},ee.table=function(K,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+ie+`</table>
`},ee.tablerow=function(K){return`<tr>
`+K+`</tr>
`},ee.tablecell=function(K,ie){var G=ie.header?"th":"td",ae=ie.align?"<"+G+' align="'+ie.align+'">':"<"+G+">";return ae+K+("</"+G+`>
`)},ee.strong=function(K){return"<strong>"+K+"</strong>"},ee.em=function(K){return"<em>"+K+"</em>"},ee.codespan=function(K){return"<code>"+K+"</code>"},ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},ee.del=function(K){return"<del>"+K+"</del>"},ee.link=function(K,ie,G){if(K=a(this.options.sanitize,this.options.baseUrl,K),K===null)return G;var ae='<a href="'+S(K)+'"';return ie&&(ae+=' title="'+ie+'"'),ae+=">"+G+"</a>",ae},ee.image=function(K,ie,G){if(K=a(this.options.sanitize,this.options.baseUrl,K),K===null)return G;var ae='<img src="'+K+'" alt="'+G+'"';return ie&&(ae+=' title="'+ie+'"'),ae+=this.options.xhtml?"/>":">",ae},ee.text=function(K){return K},me}(),X=function(){function me(){}var ee=me.prototype;return ee.strong=function(K){return K},ee.em=function(K){return K},ee.codespan=function(K){return K},ee.del=function(K){return K},ee.html=function(K){return K},ee.text=function(K){return K},ee.link=function(K,ie,G){return""+G},ee.image=function(K,ie,G){return""+G},ee.br=function(){return""},me}(),J=function(){function me(){this.seen={}}var ee=me.prototype;return ee.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ee.getNextSafeSlug=function(K,ie){var G=K,ae=0;if(this.seen.hasOwnProperty(G)){ae=this.seen[K];do ae++,G=K+"-"+ae;while(this.seen.hasOwnProperty(G))}return ie||(this.seen[K]=ae,this.seen[G]=0),G},ee.slug=function(K,ie){ie===void 0&&(ie={});var G=this.serialize(K);return this.getNextSafeSlug(G,ie.dryrun)},me}(),Q=function(){function me(te){this.options=te||be.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new J}me.parse=function(K,ie){var G=new me(ie);return G.parse(K)},me.parseInline=function(K,ie){var G=new me(ie);return G.parseInline(K)};var ee=me.prototype;return ee.parse=function(K,ie){ie===void 0&&(ie=!0);var G="",ae,$e,Ce,B,Y,se,oe,_,ge,ve,ze,We,tt,Ye,rt,nt,Ae,Oe,qe,Me=K.length;for(ae=0;ae<Me;ae++){if(ve=K[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(qe=this.options.extensions.renderers[ve.type].call({parser:this},ve),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){G+=qe||"";continue}switch(ve.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,d(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(_="",oe="",B=ve.header.length,$e=0;$e<B;$e++)oe+=this.renderer.tablecell(this.parseInline(ve.header[$e].tokens),{header:!0,align:ve.align[$e]});for(_+=this.renderer.tablerow(oe),ge="",B=ve.rows.length,$e=0;$e<B;$e++){for(se=ve.rows[$e],oe="",Y=se.length,Ce=0;Ce<Y;Ce++)oe+=this.renderer.tablecell(this.parseInline(se[Ce].tokens),{header:!1,align:ve.align[Ce]});ge+=this.renderer.tablerow(oe)}G+=this.renderer.table(_,ge);continue}case"blockquote":{ge=this.parse(ve.tokens),G+=this.renderer.blockquote(ge);continue}case"list":{for(ze=ve.ordered,We=ve.start,tt=ve.loose,B=ve.items.length,ge="",$e=0;$e<B;$e++)rt=ve.items[$e],nt=rt.checked,Ae=rt.task,Ye="",rt.task&&(Oe=this.renderer.checkbox(nt),tt?rt.tokens.length>0&&rt.tokens[0].type==="paragraph"?(rt.tokens[0].text=Oe+" "+rt.tokens[0].text,rt.tokens[0].tokens&&rt.tokens[0].tokens.length>0&&rt.tokens[0].tokens[0].type==="text"&&(rt.tokens[0].tokens[0].text=Oe+" "+rt.tokens[0].tokens[0].text)):rt.tokens.unshift({type:"text",text:Oe}):Ye+=Oe),Ye+=this.parse(rt.tokens,tt),ge+=this.renderer.listitem(Ye,Ae,nt);G+=this.renderer.list(ge,ze,We);continue}case"html":{G+=this.renderer.html(ve.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(ge=ve.tokens?this.parseInline(ve.tokens):ve.text;ae+1<Me&&K[ae+1].type==="text";)ve=K[++ae],ge+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);G+=ie?this.renderer.paragraph(ge):ge;continue}default:{var Xe='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return G},ee.parseInline=function(K,ie){ie=ie||this.renderer;var G="",ae,$e,Ce,B=K.length;for(ae=0;ae<B;ae++){if($e=K[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$e.type]&&(Ce=this.options.extensions.renderers[$e.type].call({parser:this},$e),Ce!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($e.type))){G+=Ce||"";continue}switch($e.type){case"escape":{G+=ie.text($e.text);break}case"html":{G+=ie.html($e.text);break}case"link":{G+=ie.link($e.href,$e.title,this.parseInline($e.tokens,ie));break}case"image":{G+=ie.image($e.href,$e.title,$e.text);break}case"strong":{G+=ie.strong(this.parseInline($e.tokens,ie));break}case"em":{G+=ie.em(this.parseInline($e.tokens,ie));break}case"codespan":{G+=ie.codespan($e.text);break}case"br":{G+=ie.br();break}case"del":{G+=ie.del(this.parseInline($e.tokens,ie));break}case"text":{G+=ie.text($e.text);break}default:{var Y='Token with "'+$e.type+'" type was not found.';if(this.options.silent){console.error(Y);return}else throw new Error(Y)}}}return G},me}();function he(me,ee,te){if(typeof me>"u"||me===null)throw new Error("marked(): input parameter is undefined or null");if(typeof me!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(me)+", string expected");if(typeof ee=="function"&&(te=ee,ee=null),ee=E({},he.defaults,ee||{}),k(ee),te){var K=ee.highlight,ie;try{ie=x.lex(me,ee)}catch(B){return te(B)}var G=function(Y){var se;if(!Y)try{ee.walkTokens&&he.walkTokens(ie,ee.walkTokens),se=Q.parse(ie,ee)}catch(oe){Y=oe}return ee.highlight=K,Y?te(Y):te(null,se)};if(!K||K.length<3||(delete ee.highlight,!ie.length))return G();var ae=0;he.walkTokens(ie,function(B){B.type==="code"&&(ae++,setTimeout(function(){K(B.text,B.lang,function(Y,se){if(Y)return G(Y);se!=null&&se!==B.text&&(B.text=se,B.escaped=!0),ae--,ae===0&&G()})},0))}),ae===0&&G();return}function $e(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,ee.silent)return"<p>An error occurred:</p><pre>"+S(B.message+"",!0)+"</pre>";throw B}try{var Ce=x.lex(me,ee);if(ee.walkTokens){if(ee.async)return Promise.all(he.walkTokens(Ce,ee.walkTokens)).then(function(){return Q.parse(Ce,ee)}).catch($e);he.walkTokens(Ce,ee.walkTokens)}return Q.parse(Ce,ee)}catch(B){$e(B)}}he.options=he.setOptions=function(me){return E(he.defaults,me),w(he.defaults),he},he.getDefaults=R,he.defaults=be.defaults,he.use=function(){for(var me=arguments.length,ee=new Array(me),te=0;te<me;te++)ee[te]=arguments[te];var K=E.apply(void 0,[{}].concat(ee)),ie=he.defaults.extensions||{renderers:{},childTokens:{}},G;ee.forEach(function(ae){if(ae.extensions&&(G=!0,ae.extensions.forEach(function(Ce){if(!Ce.name)throw new Error("extension name required");if(Ce.renderer){var B=ie.renderers?ie.renderers[Ce.name]:null;B?ie.renderers[Ce.name]=function(){for(var Y=arguments.length,se=new Array(Y),oe=0;oe<Y;oe++)se[oe]=arguments[oe];var _=Ce.renderer.apply(this,se);return _===!1&&(_=B.apply(this,se)),_}:ie.renderers[Ce.name]=Ce.renderer}if(Ce.tokenizer){if(!Ce.level||Ce.level!=="block"&&Ce.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ie[Ce.level]?ie[Ce.level].unshift(Ce.tokenizer):ie[Ce.level]=[Ce.tokenizer],Ce.start&&(Ce.level==="block"?ie.startBlock?ie.startBlock.push(Ce.start):ie.startBlock=[Ce.start]:Ce.level==="inline"&&(ie.startInline?ie.startInline.push(Ce.start):ie.startInline=[Ce.start]))}Ce.childTokens&&(ie.childTokens[Ce.name]=Ce.childTokens)})),ae.renderer&&function(){var Ce=he.defaults.renderer||new ue,B=function(oe){var _=Ce[oe];Ce[oe]=function(){for(var ge=arguments.length,ve=new Array(ge),ze=0;ze<ge;ze++)ve[ze]=arguments[ze];var We=ae.renderer[oe].apply(Ce,ve);return We===!1&&(We=_.apply(Ce,ve)),We}};for(var Y in ae.renderer)B(Y);K.renderer=Ce}(),ae.tokenizer&&function(){var Ce=he.defaults.tokenizer||new M,B=function(oe){var _=Ce[oe];Ce[oe]=function(){for(var ge=arguments.length,ve=new Array(ge),ze=0;ze<ge;ze++)ve[ze]=arguments[ze];var We=ae.tokenizer[oe].apply(Ce,ve);return We===!1&&(We=_.apply(Ce,ve)),We}};for(var Y in ae.tokenizer)B(Y);K.tokenizer=Ce}(),ae.walkTokens){var $e=he.defaults.walkTokens;K.walkTokens=function(Ce){var B=[];return B.push(ae.walkTokens.call(this,Ce)),$e&&(B=B.concat($e.call(this,Ce))),B}}G&&(K.extensions=ie),he.setOptions(K)})},he.walkTokens=function(me,ee){for(var te=[],K=function(){var $e=G.value;switch(te=te.concat(ee.call(he,$e)),$e.type){case"table":{for(var Ce=A($e.header),B;!(B=Ce()).done;){var Y=B.value;te=te.concat(he.walkTokens(Y.tokens,ee))}for(var se=A($e.rows),oe;!(oe=se()).done;)for(var _=oe.value,ge=A(_),ve;!(ve=ge()).done;){var ze=ve.value;te=te.concat(he.walkTokens(ze.tokens,ee))}break}case"list":{te=te.concat(he.walkTokens($e.items,ee));break}default:he.defaults.extensions&&he.defaults.extensions.childTokens&&he.defaults.extensions.childTokens[$e.type]?he.defaults.extensions.childTokens[$e.type].forEach(function(We){te=te.concat(he.walkTokens($e[We],ee))}):$e.tokens&&(te=te.concat(he.walkTokens($e.tokens,ee)))}},ie=A(me),G;!(G=ie()).done;)K();return te},he.parseInline=function(me,ee){if(typeof me>"u"||me===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof me!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(me)+", string expected");ee=E({},he.defaults,ee||{}),k(ee);try{var te=x.lexInline(me,ee);return ee.walkTokens&&he.walkTokens(te,ee.walkTokens),Q.parseInline(te,ee)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,ee.silent)return"<p>An error occurred:</p><pre>"+S(K.message+"",!0)+"</pre>";throw K}},he.Parser=Q,he.parser=Q.parse,he.Renderer=ue,he.TextRenderer=X,he.Lexer=x,he.lexer=x.lex,he.Tokenizer=M,he.Slugger=J,he.parse=he;var Z=he.options,ye=he.setOptions,de=he.use,H=he.walkTokens,U=he.parseInline,ne=he,Ee=Q.parse,fe=x.lex;be.Lexer=x,be.Parser=Q,be.Renderer=ue,be.Slugger=J,be.TextRenderer=X,be.Tokenizer=M,be.getDefaults=R,be.lexer=fe,be.marked=he,be.options=Z,be.parse=ne,be.parseInline=U,be.parser=Ee,be.setOptions=ye,be.use=de,be.walkTokens=H,Object.defineProperty(be,"__esModule",{value:!0})}),define(ke[76],Se([1,0,28]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.$yl=void 0;const T=new D.$Cc(1e4);function m(y){return b(y,"NFC",T)}e.$yl=m;const A=new D.$Cc(1e4);function R(y){return b(y,"NFD",A)}e.$zl=R;const w=/[^\u0000-\u0080]/;function b(y,L,P){if(!y)return y;const $=P.get(y);if($)return $;let v;return w.test(y)?v=y.normalize(L):v=y,P.set(y,v),v}e.$Al=function(){const y=/[\u0300-\u036f]/g;return function(L){return R(L).replace(y,"")}}()}),define(ke[123],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.rot=e.$Yl=void 0;function D(w,b,y){return Math.min(Math.max(w,b),y)}e.$Yl=D;function T(w,b){return(b+w%b)%b}e.rot=T;class m{constructor(){this.a=0}getNext(){return this.a++}}e.$1l=m;class A{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$2l=A;class R{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const y=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$3l=R}),function(){function be(m){const A=[];typeof m=="number"&&A.push("code/timeOrigin",m);function R(b){A.push(b,Date.now())}function w(){const b=[];for(let y=0;y<A.length;y+=2)b.push({name:A[y],startTime:A[y+1]});return b}return{mark:R,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(m){performance.mark(m)},getMarks(){let m=performance.timeOrigin;typeof m!="number"&&(m=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(m)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(m+R.startTime)});return A}};if(typeof process=="object"){const m=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(m)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function D(m){return m.MonacoPerformanceMarks||(m.MonacoPerformanceMarks=e()),m.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=D(T))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var T in D)(typeof exports=="object"?exports:be)[T]=D[T]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function D(T){if(e[T])return e[T].exports;var m=e[T]={i:T,l:!1,exports:{}};return be[T].call(m.exports,m,m.exports,D),m.l=!0,m.exports}return D.m=be,D.c=e,D.d=function(T,m,A){D.o(T,m)||Object.defineProperty(T,m,{enumerable:!0,get:A})},D.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},D.t=function(T,m){if(1&m&&(T=D(T)),8&m||4&m&&typeof T=="object"&&T&&T.__esModule)return T;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:T}),2&m&&typeof T!="string")for(var R in T)D.d(A,R,function(w){return T[w]}.bind(null,R));return A},D.n=function(T){var m=T&&T.__esModule?function(){return T.default}:function(){return T};return D.d(m,"a",m),m},D.o=function(T,m){return Object.prototype.hasOwnProperty.call(T,m)},D.p="",D(D.s=0)}([function(be,e,D){(function(T){var m;e=be.exports=de,m=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],b=e.src=[],y=0,L=y++;b[L]="0|[1-9]\\d*";var P=y++;b[P]="[0-9]+";var $=y++;b[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=y++;b[v]="("+b[L]+")\\.("+b[L]+")\\.("+b[L]+")";var S=y++;b[S]="("+b[P]+")\\.("+b[P]+")\\.("+b[P]+")";var g=y++;b[g]="(?:"+b[L]+"|"+b[$]+")";var d=y++;b[d]="(?:"+b[P]+"|"+b[$]+")";var o=y++;b[o]="(?:-("+b[g]+"(?:\\."+b[g]+")*))";var i=y++;b[i]="(?:-?("+b[d]+"(?:\\."+b[d]+")*))";var n=y++;b[n]="[0-9A-Za-z-]+";var s=y++;b[s]="(?:\\+("+b[n]+"(?:\\."+b[n]+")*))";var a=y++,t="v?"+b[v]+b[o]+"?"+b[s]+"?";b[a]="^"+t+"$";var r="[v=\\s]*"+b[S]+b[i]+"?"+b[s]+"?",h=y++;b[h]="^"+r+"$";var u=y++;b[u]="((?:<|>)?=?)";var c=y++;b[c]=b[P]+"|x|X|\\*";var l=y++;b[l]=b[L]+"|x|X|\\*";var E=y++;b[E]="[v=\\s]*("+b[l]+")(?:\\.("+b[l]+")(?:\\.("+b[l]+")(?:"+b[o]+")?"+b[s]+"?)?)?";var C=y++;b[C]="[v=\\s]*("+b[c]+")(?:\\.("+b[c]+")(?:\\.("+b[c]+")(?:"+b[i]+")?"+b[s]+"?)?)?";var f=y++;b[f]="^"+b[u]+"\\s*"+b[E]+"$";var p=y++;b[p]="^"+b[u]+"\\s*"+b[C]+"$";var k=y++;b[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=y++;b[I]="(?:~>?)";var j=y++;b[j]="(\\s*)"+b[I]+"\\s+",w[j]=new RegExp(b[j],"g");var z=y++;b[z]="^"+b[I]+b[E]+"$";var M=y++;b[M]="^"+b[I]+b[C]+"$";var F=y++;b[F]="(?:\\^)";var N=y++;b[N]="(\\s*)"+b[F]+"\\s+",w[N]=new RegExp(b[N],"g");var O=y++;b[O]="^"+b[F]+b[E]+"$";var W=y++;b[W]="^"+b[F]+b[C]+"$";var x=y++;b[x]="^"+b[u]+"\\s*("+r+")$|^$";var ue=y++;b[ue]="^"+b[u]+"\\s*("+t+")$|^$";var X=y++;b[X]="(\\s*)"+b[u]+"\\s*("+r+"|"+b[E]+")",w[X]=new RegExp(b[X],"g");var J=y++;b[J]="^\\s*("+b[E]+")\\s+-\\s+("+b[E]+")\\s*$";var Q=y++;b[Q]="^\\s*("+b[C]+")\\s+-\\s+("+b[C]+")\\s*$";var he=y++;b[he]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)m(Z,b[Z]),w[Z]||(w[Z]=new RegExp(b[Z]));function ye(_,ge){if(_ instanceof de)return _;if(typeof _!="string"||_.length>A||!(ge?w[h]:w[a]).test(_))return null;try{return new de(_,ge)}catch{return null}}function de(_,ge){if(_ instanceof de){if(_.loose===ge)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof de))return new de(_,ge);m("SemVer",_,ge),this.loose=ge;var ve=_.trim().match(ge?w[h]:w[a]);if(!ve)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var We=+ze;if(We>=0&&We<R)return We}return ze}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=ye,e.valid=function(_,ge){var ve=ye(_,ge);return ve?ve.version:null},e.clean=function(_,ge){var ve=ye(_.trim().replace(/^[=v]+/,""),ge);return ve?ve.version:null},e.SemVer=de,de.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},de.prototype.toString=function(){return this.version},de.prototype.compare=function(_){return m("SemVer.compare",this.version,this.loose,_),_ instanceof de||(_=new de(_,this.loose)),this.compareMain(_)||this.comparePre(_)},de.prototype.compareMain=function(_){return _ instanceof de||(_=new de(_,this.loose)),U(this.major,_.major)||U(this.minor,_.minor)||U(this.patch,_.patch)},de.prototype.comparePre=function(_){if(_ instanceof de||(_=new de(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var ge=0;do{var ve=this.prerelease[ge],ze=_.prerelease[ge];if(m("prerelease compare",ge,ve,ze),ve===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(ve===void 0)return-1;if(ve!==ze)return U(ve,ze)}while(++ge)},de.prototype.inc=function(_,ge){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,ge,ve,ze){typeof ve=="string"&&(ze=ve,ve=void 0);try{return new de(_,ve).inc(ge,ze).version}catch{return null}},e.diff=function(_,ge){if(me(_,ge))return null;var ve=ye(_),ze=ye(ge);if(ve.prerelease.length||ze.prerelease.length){for(var We in ve)if((We==="major"||We==="minor"||We==="patch")&&ve[We]!==ze[We])return"pre"+We;return"prerelease"}for(var We in ve)if((We==="major"||We==="minor"||We==="patch")&&ve[We]!==ze[We])return We},e.compareIdentifiers=U;var H=/^[0-9]+$/;function U(_,ge){var ve=H.test(_),ze=H.test(ge);return ve&&ze&&(_=+_,ge=+ge),ve&&!ze?-1:ze&&!ve?1:_<ge?-1:_>ge?1:0}function ne(_,ge,ve){return new de(_,ve).compare(new de(ge,ve))}function Ee(_,ge,ve){return ne(_,ge,ve)>0}function fe(_,ge,ve){return ne(_,ge,ve)<0}function me(_,ge,ve){return ne(_,ge,ve)===0}function ee(_,ge,ve){return ne(_,ge,ve)!==0}function te(_,ge,ve){return ne(_,ge,ve)>=0}function K(_,ge,ve){return ne(_,ge,ve)<=0}function ie(_,ge,ve,ze){var We;switch(ge){case"===":typeof _=="object"&&(_=_.version),typeof ve=="object"&&(ve=ve.version),We=_===ve;break;case"!==":typeof _=="object"&&(_=_.version),typeof ve=="object"&&(ve=ve.version),We=_!==ve;break;case"":case"=":case"==":We=me(_,ve,ze);break;case"!=":We=ee(_,ve,ze);break;case">":We=Ee(_,ve,ze);break;case">=":We=te(_,ve,ze);break;case"<":We=fe(_,ve,ze);break;case"<=":We=K(_,ve,ze);break;default:throw new TypeError("Invalid operator: "+ge)}return We}function G(_,ge){if(_ instanceof G){if(_.loose===ge)return _;_=_.value}if(!(this instanceof G))return new G(_,ge);m("comparator",_,ge),this.loose=ge,this.parse(_),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,m("comp",this)}e.rcompareIdentifiers=function(_,ge){return U(ge,_)},e.major=function(_,ge){return new de(_,ge).major},e.minor=function(_,ge){return new de(_,ge).minor},e.patch=function(_,ge){return new de(_,ge).patch},e.compare=ne,e.compareLoose=function(_,ge){return ne(_,ge,!0)},e.rcompare=function(_,ge,ve){return ne(ge,_,ve)},e.sort=function(_,ge){return _.sort(function(ve,ze){return e.compare(ve,ze,ge)})},e.rsort=function(_,ge){return _.sort(function(ve,ze){return e.rcompare(ve,ze,ge)})},e.gt=Ee,e.lt=fe,e.eq=me,e.neq=ee,e.gte=te,e.lte=K,e.cmp=ie,e.Comparator=G;var ae={};function $e(_,ge){if(_ instanceof $e)return _.loose===ge?_:new $e(_.raw,ge);if(_ instanceof G)return new $e(_.value,ge);if(!(this instanceof $e))return new $e(_,ge);if(this.loose=ge,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Ce(_){return!_||_.toLowerCase()==="x"||_==="*"}function B(_,ge,ve,ze,We,tt,Ye,rt,nt,Ae,Oe,qe,Me){return((ge=Ce(ve)?"":Ce(ze)?">="+ve+".0.0":Ce(We)?">="+ve+"."+ze+".0":">="+ge)+" "+(rt=Ce(nt)?"":Ce(Ae)?"<"+(+nt+1)+".0.0":Ce(Oe)?"<"+nt+"."+(+Ae+1)+".0":qe?"<="+nt+"."+Ae+"."+Oe+"-"+qe:"<="+rt)).trim()}function Y(_,ge){for(var ve=0;ve<_.length;ve++)if(!_[ve].test(ge))return!1;if(ge.prerelease.length){for(ve=0;ve<_.length;ve++)if(m(_[ve].semver),_[ve].semver!==ae&&_[ve].semver.prerelease.length>0){var ze=_[ve].semver;if(ze.major===ge.major&&ze.minor===ge.minor&&ze.patch===ge.patch)return!0}return!1}return!0}function se(_,ge,ve){try{ge=new $e(ge,ve)}catch{return!1}return ge.test(_)}function oe(_,ge,ve,ze){var We,tt,Ye,rt,nt;switch(_=new de(_,ze),ge=new $e(ge,ze),ve){case">":We=Ee,tt=K,Ye=fe,rt=">",nt=">=";break;case"<":We=fe,tt=te,Ye=Ee,rt="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(_,ge,ze))return!1;for(var Ae=0;Ae<ge.set.length;++Ae){var Oe=ge.set[Ae],qe=null,Me=null;if(Oe.forEach(function(Xe){Xe.semver===ae&&(Xe=new G(">=0.0.0")),qe=qe||Xe,Me=Me||Xe,We(Xe.semver,qe.semver,ze)?qe=Xe:Ye(Xe.semver,Me.semver,ze)&&(Me=Xe)}),qe.operator===rt||qe.operator===nt||(!Me.operator||Me.operator===rt)&&tt(_,Me.semver)||Me.operator===nt&&Ye(_,Me.semver))return!1}return!0}G.prototype.parse=function(_){var ge=this.loose?w[x]:w[ue],ve=_.match(ge);if(!ve)throw new TypeError("Invalid comparator: "+_);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new de(ve[2],this.loose):this.semver=ae},G.prototype.toString=function(){return this.value},G.prototype.test=function(_){return m("Comparator.test",_,this.loose),this.semver===ae||(typeof _=="string"&&(_=new de(_,this.loose)),ie(_,this.operator,this.semver,this.loose))},G.prototype.intersects=function(_,ge){if(!(_ instanceof G))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new $e(_.value,ge),se(this.value,ve,ge);if(_.operator==="")return ve=new $e(this.value,ge),se(_.semver,ve,ge);var ze=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),tt=this.semver.version===_.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),rt=ie(this.semver,"<",_.semver,ge)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),nt=ie(this.semver,">",_.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return ze||We||tt&&Ye||rt||nt},e.Range=$e,$e.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},$e.prototype.toString=function(){return this.range},$e.prototype.parseRange=function(_){var ge=this.loose;_=_.trim(),m("range",_,ge);var ve=ge?w[Q]:w[J];_=_.replace(ve,B),m("hyphen replace",_),_=_.replace(w[X],"$1$2$3"),m("comparator trim",_,w[X]),_=(_=(_=_.replace(w[j],"$1~")).replace(w[N],"$1^")).split(/\s+/).join(" ");var ze=ge?w[x]:w[ue],We=_.split(" ").map(function(tt){return function(Ye,rt){return m("comp",Ye),Ye=function(nt,Ae){return nt.trim().split(/\s+/).map(function(Oe){return function(qe,Me){m("caret",qe,Me);var Xe=Me?w[W]:w[O];return qe.replace(Xe,function(le,ce,Pe,He,Ge){var xe;return m("caret",qe,le,ce,Pe,He,Ge),Ce(ce)?xe="":Ce(Pe)?xe=">="+ce+".0.0 <"+(+ce+1)+".0.0":Ce(He)?xe=ce==="0"?">="+ce+"."+Pe+".0 <"+ce+"."+(+Pe+1)+".0":">="+ce+"."+Pe+".0 <"+(+ce+1)+".0.0":Ge?(m("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),xe=ce==="0"?Pe==="0"?">="+ce+"."+Pe+"."+He+Ge+" <"+ce+"."+Pe+"."+(+He+1):">="+ce+"."+Pe+"."+He+Ge+" <"+ce+"."+(+Pe+1)+".0":">="+ce+"."+Pe+"."+He+Ge+" <"+(+ce+1)+".0.0"):(m("no pr"),xe=ce==="0"?Pe==="0"?">="+ce+"."+Pe+"."+He+" <"+ce+"."+Pe+"."+(+He+1):">="+ce+"."+Pe+"."+He+" <"+ce+"."+(+Pe+1)+".0":">="+ce+"."+Pe+"."+He+" <"+(+ce+1)+".0.0"),m("caret return",xe),xe})}(Oe,Ae)}).join(" ")}(Ye,rt),m("caret",Ye),Ye=function(nt,Ae){return nt.trim().split(/\s+/).map(function(Oe){return function(qe,Me){var Xe=Me?w[M]:w[z];return qe.replace(Xe,function(le,ce,Pe,He,Ge){var xe;return m("tilde",qe,le,ce,Pe,He,Ge),Ce(ce)?xe="":Ce(Pe)?xe=">="+ce+".0.0 <"+(+ce+1)+".0.0":Ce(He)?xe=">="+ce+"."+Pe+".0 <"+ce+"."+(+Pe+1)+".0":Ge?(m("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),xe=">="+ce+"."+Pe+"."+He+Ge+" <"+ce+"."+(+Pe+1)+".0"):xe=">="+ce+"."+Pe+"."+He+" <"+ce+"."+(+Pe+1)+".0",m("tilde return",xe),xe})}(Oe,Ae)}).join(" ")}(Ye,rt),m("tildes",Ye),Ye=function(nt,Ae){return m("replaceXRanges",nt,Ae),nt.split(/\s+/).map(function(Oe){return function(qe,Me){qe=qe.trim();var Xe=Me?w[p]:w[f];return qe.replace(Xe,function(le,ce,Pe,He,Ge,xe){m("xRange",qe,le,ce,Pe,He,Ge,xe);var ot=Ce(Pe),lt=ot||Ce(He),Ne=lt||Ce(Ge);return ce==="="&&Ne&&(ce=""),ot?le=ce===">"||ce==="<"?"<0.0.0":"*":ce&&Ne?(lt&&(He=0),Ne&&(Ge=0),ce===">"?(ce=">=",lt?(Pe=+Pe+1,He=0,Ge=0):Ne&&(He=+He+1,Ge=0)):ce==="<="&&(ce="<",lt?Pe=+Pe+1:He=+He+1),le=ce+Pe+"."+He+"."+Ge):lt?le=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ne&&(le=">="+Pe+"."+He+".0 <"+Pe+"."+(+He+1)+".0"),m("xRange return",le),le})}(Oe,Ae)}).join(" ")}(Ye,rt),m("xrange",Ye),Ye=function(nt,Ae){return m("replaceStars",nt,Ae),nt.trim().replace(w[he],"")}(Ye,rt),m("stars",Ye),Ye}(tt,ge)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(tt){return!!tt.match(ze)})),We=We.map(function(tt){return new G(tt,ge)})},$e.prototype.intersects=function(_,ge){if(!(_ instanceof $e))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(ze){return _.set.some(function(We){return We.every(function(tt){return ze.intersects(tt,ge)})})})})},e.toComparators=function(_,ge){return new $e(_,ge).set.map(function(ve){return ve.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},$e.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new de(_,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Y(this.set[ge],_))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(_,ge,ve){var ze=null,We=null;try{var tt=new $e(ge,ve)}catch{return null}return _.forEach(function(Ye){tt.test(Ye)&&(ze&&We.compare(Ye)!==-1||(We=new de(ze=Ye,ve)))}),ze},e.minSatisfying=function(_,ge,ve){var ze=null,We=null;try{var tt=new $e(ge,ve)}catch{return null}return _.forEach(function(Ye){tt.test(Ye)&&(ze&&We.compare(Ye)!==1||(We=new de(ze=Ye,ve)))}),ze},e.validRange=function(_,ge){try{return new $e(_,ge).range||"*"}catch{return null}},e.ltr=function(_,ge,ve){return oe(_,ge,"<",ve)},e.gtr=function(_,ge,ve){return oe(_,ge,">",ve)},e.outside=oe,e.prerelease=function(_,ge){var ve=ye(_,ge);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(_,ge,ve){return _=new $e(_,ve),ge=new $e(ge,ve),_.intersects(ge)},e.coerce=function(_){if(_ instanceof de)return _;if(typeof _!="string")return null;var ge=_.match(w[k]);return ge==null?null:ye((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,D(1))},function(be,e){var D,T,m=be.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function w(d){if(D===setTimeout)return setTimeout(d,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(d,0);try{return D(d,0)}catch{try{return D.call(null,d,0)}catch{return D.call(this,d,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{T=typeof clearTimeout=="function"?clearTimeout:R}catch{T=R}})();var b,y=[],L=!1,P=-1;function $(){L&&b&&(L=!1,b.length?y=b.concat(y):P=-1,y.length&&v())}function v(){if(!L){var d=w($);L=!0;for(var o=y.length;o;){for(b=y,y=[];++P<o;)b&&b[P].run();P=-1,o=y.length}b=null,L=!1,function(i){if(T===clearTimeout)return clearTimeout(i);if((T===R||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(i);try{T(i)}catch{try{return T.call(null,i)}catch{return T.call(this,i)}}}(d)}}function S(d,o){this.fun=d,this.array=o}function g(){}m.nextTick=function(d){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];y.push(new S(d,o)),y.length!==1||L||w(v)},S.prototype.run=function(){this.fun.apply(null,this.array)},m.title="browser",m.browser=!0,m.env={},m.argv=[],m.version="",m.versions={},m.on=g,m.addListener=g,m.once=g,m.off=g,m.removeListener=g,m.removeAllListeners=g,m.emit=g,m.prependListener=g,m.prependOnceListener=g,m.listeners=function(d){return[]},m.binding=function(d){throw new Error("process.binding is not supported")},m.cwd=function(){return"/"},m.chdir=function(d){throw new Error("process.chdir is not supported")},m.umask=function(){return 0}}])}),define(ke[38],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(A){return new T(A)}constructor(A){this.c=D&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Nd=T}),define(ke[4],Se([1,0,8,74,3,75,38]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.Event=void 0;const w=!1,b=!1;var y;(function(f){f.None=()=>m.$Rc.None;function p(ie){if(b){const{onDidAddListener:G}=ie,ae=S.create();let $e=0;ie.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ae.print()),G?.()}}}function k(ie,G){return ue(ie,()=>{},0,void 0,!0,void 0,G)}f.defer=k;function I(ie){return(G,ae=null,$e)=>{let Ce=!1,B;return B=ie(Y=>{if(!Ce)return B?B.dispose():Ce=!0,G.call(ae,Y)},null,$e),Ce&&B.dispose(),B}}f.once=I;function j(ie,G,ae){return W(($e,Ce=null,B)=>ie(Y=>$e.call(Ce,G(Y)),null,B),ae)}f.map=j;function z(ie,G,ae){return W(($e,Ce=null,B)=>ie(Y=>{G(Y),$e.call(Ce,Y)},null,B),ae)}f.forEach=z;function M(ie,G,ae){return W(($e,Ce=null,B)=>ie(Y=>G(Y)&&$e.call(Ce,Y),null,B),ae)}f.filter=M;function F(ie){return ie}f.signal=F;function N(...ie){return(G,ae=null,$e)=>{const Ce=(0,m.$Oc)(...ie.map(B=>B(Y=>G.call(ae,Y))));return x(Ce,$e)}}f.any=N;function O(ie,G,ae,$e){let Ce=ae;return j(ie,B=>(Ce=G(Ce,B),Ce),$e)}f.reduce=O;function W(ie,G){let ae;const $e={onWillAddFirstListener(){ae=ie(Ce.fire,Ce)},onDidRemoveLastListener(){ae?.dispose()}};G||p($e);const Ce=new n($e);return G?.add(Ce),Ce.event}function x(ie,G){return G instanceof Array?G.push(ie):G&&G.add(ie),ie}function ue(ie,G,ae=100,$e=!1,Ce=!1,B,Y){let se,oe,_,ge=0,ve;const ze={leakWarningThreshold:B,onWillAddFirstListener(){se=ie(tt=>{ge++,oe=G(oe,tt),$e&&!_&&(We.fire(oe),oe=void 0),ve=()=>{const Ye=oe;oe=void 0,_=void 0,(!$e||ge>1)&&We.fire(Ye),ge=0},typeof ae=="number"?(clearTimeout(_),_=setTimeout(ve,ae)):_===void 0&&(_=0,queueMicrotask(ve))})},onWillRemoveListener(){Ce&&ge>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,se.dispose()}};Y||p(ze);const We=new n(ze);return Y?.add(We),We.event}f.debounce=ue;function X(ie,G=0,ae){return f.debounce(ie,($e,Ce)=>$e?($e.push(Ce),$e):[Ce],G,void 0,!0,void 0,ae)}f.accumulate=X;function J(ie,G=($e,Ce)=>$e===Ce,ae){let $e=!0,Ce;return M(ie,B=>{const Y=$e||!G(B,Ce);return $e=!1,Ce=B,Y},ae)}f.latch=J;function Q(ie,G,ae){return[f.filter(ie,G,ae),f.filter(ie,$e=>!G($e),ae)]}f.split=Q;function he(ie,G=!1,ae=[],$e){let Ce=ae.slice(),B=ie(oe=>{Ce?Ce.push(oe):se.fire(oe)});$e&&$e.add(B);const Y=()=>{Ce?.forEach(oe=>se.fire(oe)),Ce=null},se=new n({onWillAddFirstListener(){B||(B=ie(oe=>se.fire(oe)),$e&&$e.add(B))},onDidAddFirstListener(){Ce&&(G?setTimeout(Y):Y())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return $e&&$e.add(se),se.event}f.buffer=he;function Z(ie,G){return($e,Ce,B)=>{const Y=G(new de);return ie(function(se){const oe=Y.evaluate(se);oe!==ye&&$e.call(Ce,oe)},void 0,B)}}f.chain=Z;const ye=Symbol("HaltChainable");class de{constructor(){this.f=[]}map(G){return this.f.push(G),this}forEach(G){return this.f.push(ae=>(G(ae),ae)),this}filter(G){return this.f.push(ae=>G(ae)?ae:ye),this}reduce(G,ae){let $e=ae;return this.f.push(Ce=>($e=G($e,Ce),$e)),this}latch(G=(ae,$e)=>ae===$e){let ae=!0,$e;return this.f.push(Ce=>{const B=ae||!G(Ce,$e);return ae=!1,$e=Ce,B?Ce:ye}),this}evaluate(G){for(const ae of this.f)if(G=ae(G),G===ye)break;return G}}function H(ie,G,ae=$e=>$e){const $e=(...se)=>Y.fire(ae(...se)),Ce=()=>ie.on(G,$e),B=()=>ie.removeListener(G,$e),Y=new n({onWillAddFirstListener:Ce,onDidRemoveLastListener:B});return Y.event}f.fromNodeEventEmitter=H;function U(ie,G,ae=$e=>$e){const $e=(...se)=>Y.fire(ae(...se)),Ce=()=>ie.addEventListener(G,$e),B=()=>ie.removeEventListener(G,$e),Y=new n({onWillAddFirstListener:Ce,onDidRemoveLastListener:B});return Y.event}f.fromDOMEventEmitter=U;function ne(ie){return new Promise(G=>I(ie)(G))}f.toPromise=ne;function Ee(ie){const G=new n;return ie.then(ae=>{G.fire(ae)},()=>{G.fire(void 0)}).finally(()=>{G.dispose()}),G.event}f.fromPromise=Ee;function fe(ie,G,ae){return G(ae),ie($e=>G($e))}f.runAndSubscribe=fe;function me(ie,G){let ae=null;function $e(B){ae?.dispose(),ae=new m.$Qc,G(B,ae)}$e(void 0);const Ce=ie(B=>$e(B));return(0,m.$Pc)(()=>{Ce.dispose(),ae?.dispose()})}f.runAndSubscribeWithStore=me;class ee{constructor(G,ae){this._observable=G,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};ae||p($e),this.emitter=new n($e),ae&&ae.add(this.emitter)}beginUpdate(G){this.f++}handlePossibleChange(G){}handleChange(G,ae){this.g=!0}endUpdate(G){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function te(ie,G){return new ee(ie,G).emitter.event}f.fromObservable=te;function K(ie){return G=>{let ae=0,$e=!1;const Ce={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(ie.reportChanges(),$e&&($e=!1,G()))},handlePossibleChange(){},handleChange(){$e=!0}};return ie.addObserver(Ce),ie.reportChanges(),{dispose(){ie.removeObserver(Ce)}}}}f.fromObservableLight=K})(y||(e.Event=y={}));class L{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${L.f++}`,L.all.add(this)}start(p){this.g=new R.$Nd,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$Pd=L;let P=-1;function $(f){const p=P;return P=f,{dispose(){P=p}}}e.$Qd=$;class v{constructor(p,k=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=k,this.g=0}dispose(){this.f?.clear()}check(p,k){const I=this.threshold;if(I<=0||k<I)return;this.f||(this.f=new Map);const j=this.f.get(p.value)||0;if(this.f.set(p.value,j+1),this.g-=1,this.g<=0){this.g=I*.5;let z,M=0;for(const[F,N]of this.f)(!z||M<N)&&(z=F,M=N);console.warn(`[${this.name}] potential listener LEAK detected, having ${k} listeners already. MOST frequent listener (${M}):`),console.warn(z)}return()=>{const z=this.f.get(p.value)||0;this.f.set(p.value,z-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let g=0;class d{constructor(p){this.value=p,this.id=g++}}const o=2,i=(f,p)=>{if(f instanceof d)p(f);else for(let k=0;k<f.length;k++){const I=f[k];I&&p(I)}};class n{constructor(p){this.w=0,this.f=p,this.g=P>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new L(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(w){const p=this.t;queueMicrotask(()=>{i(p,k=>k.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,k,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),m.$Rc.None;if(this.m)return m.$Rc.None;k&&(p=p.bind(k));const j=new d(p);let z,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(j.stack=S.create(),z=this.g.check(j.stack,this.w+1)),w&&(j.stack=M??S.create()),this.t?this.t instanceof d?(this.u??=new a,this.t=[this.t,j]):this.t.push(j):(this.f?.onWillAddFirstListener?.(this),this.t=j,this.f?.onDidAddFirstListener?.(this)),this.w++;const F=(0,m.$Pc)(()=>{z?.(),this.x(j)});return I instanceof m.$Qc?I.add(F):Array.isArray(I)&&I.push(F),F},this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const k=this.t,I=k.indexOf(p);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,k[I]=void 0;const j=this.u.current===this;if(this.w*o<=k.length){let z=0;for(let M=0;M<k.length;M++)k[M]?k[z++]=k[M]:j&&(this.u.end--,z<this.u.i&&this.u.i--);k.length=z}}y(p,k){if(!p)return;const I=this.f?.onListenerError||D.$Z;if(!I){p.value(k);return}try{p.value(k)}catch(j){I(j)}}z(p){const k=p.current.t;for(;p.i<p.end;)this.y(k[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof d)this.y(this.t,p);else{const k=this.u;k.enqueue(this,p,this.t.length),this.z(k)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Rd=n;const s=()=>new a;e.$Sd=s;class a{constructor(){this.i=-1,this.end=0}enqueue(p,k,I){this.i=0,this.end=I,this.current=p,this.value=k}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(p,k,I){if(this.t)for(this.h||(this.h=new A.$2c),i(this.t,j=>this.h.push([j.value,p]));this.h.size>0&&!k.isCancellationRequested;){const[j,z]=this.h.shift(),M=[],F={...z,token:k,waitUntil:N=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");I&&(N=I(N,j)),M.push(N)}};try{j(F)}catch(N){(0,D.$Z)(N);continue}Object.freeze(M),await Promise.allSettled(M).then(N=>{for(const O of N)O.status==="rejected"&&(0,D.$Z)(O.reason)})}}}e.$Td=t;class r extends n{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new A.$2c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$Ud=r;class h extends r{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$Vd=h;class u extends n{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(k=>super.fire(k)),this.h=[]}))}}e.$Wd=u;class c{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const k={event:p,listener:null};this.h.push(k),this.g&&this.m(k);const I=()=>{this.g&&this.o(k);const j=this.h.indexOf(k);this.h.splice(j,1)};return(0,m.$Pc)((0,T.$cb)(I))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(k=>this.f.fire(k))}o(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.f.dispose()}}e.$Xd=c;class l{constructor(p,k,I,j){this.f=new m.$Qc;const z=this.f.add(new c),M=this.f.add(new m.$1c);function F(N){M.set(N,z.add(j(N)))}for(const N of p)F(N);this.f.add(k(N=>{F(N)})),this.f.add(I(N=>{M.deleteAndDispose(N)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Yd=l;class E{constructor(){this.f=[]}wrapEvent(p){return(k,I,j)=>p(z=>{const M=this.f[this.f.length-1];M?M.push(()=>k.call(I,z)):k.call(I,z)},void 0,j)}bufferEvents(p){const k=[];this.f.push(k);const I=p();return this.f.pop(),k.forEach(j=>j()),I}}e.$Zd=E;class C{constructor(){this.f=!1,this.g=y.None,this.h=m.$Rc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$1d=C}),define(ke[21],Se([1,0,4]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.CancellationToken=void 0;const T=Object.freeze(function(w,b){const y=setTimeout(w.bind(b),0);return{dispose(){clearTimeout(y)}}});var m;(function(w){function b(y){return y===w.None||y===w.Cancelled||y instanceof A?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}w.isCancellationToken=b,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(m||(e.CancellationToken=m={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new D.$Rd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=m.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=m.None}}e.$2d=R}),define(ke[161],Se([1,0,21]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=void 0;class T{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new D.$2d,b=this.b(w.token);return this.a={promise:b,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}e.$Ae=T;class m{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const b=JSON.stringify(w);return this.b!==b&&(this.b=b,this.a=this.c(w)),this.a}}e.$Be=m;class A{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const b=this.b(w);return this.a.set(w,b),b}}e.$Ce=A}),define(ke[98],Se([1,0,8,3]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function m(s){const a=s;return a?typeof a.read=="function":!1}e.$3d=m;function A(s){const a=s;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$4d=A;function R(s){const a=s;return a?A(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$5d=R;function w(s,a){return new b(s,a)}e.$6d=w;class b{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,D.$Z)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const h=r.indexOf(t);h>=0&&r.splice(h,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(s,a){const t=[];let r;for(;(r=s.read())!==null;)t.push(r);return a(t)}e.$7d=y;function L(s,a,t){const r=[];let h;for(;(h=s.read())!==null&&r.length<t;)r.push(h);return h===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof h<"u"){const u=h;return h=void 0,u}return s.read()}}}e.$8d=L;function P(s,a){return new Promise((t,r)=>{const h=[];$(s,{onData:u=>{a&&h.push(u)},onError:u=>{a?r(u):t(void 0)},onEnd:()=>{t(a?a(h):void 0)}})})}e.$9d=P;function $(s,a,t){s.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),s.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),s.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}e.$0d=$;function v(s,a){return new Promise((t,r)=>{const h=new T.$Qc,u=[],c=C=>{if(u.push(C),u.length>a)return h.dispose(),s.pause(),t({stream:s,buffer:u,ended:!1})},l=C=>(h.dispose(),r(C)),E=()=>(h.dispose(),t({stream:s,buffer:u,ended:!0}));h.add((0,T.$Pc)(()=>s.removeListener("error",l))),s.on("error",l),h.add((0,T.$Pc)(()=>s.removeListener("end",E))),s.on("end",E),h.add((0,T.$Pc)(()=>s.removeListener("data",c))),s.on("data",c)})}e.$$d=v;function S(s,a){const t=w(a);return t.end(s),t}e.$_d=S;function g(){const s=w(()=>{throw new Error("not supported")});return s.end(),s}e.$ae=g;function d(s){let a=!1;return{read:()=>a?null:(a=!0,s)}}e.$be=d;function o(s,a,t){const r=w(t);return $(s,{onData:h=>r.write(a.data(h)),onError:h=>r.error(a.error?a.error(h):h),onEnd:()=>r.end()}),r}e.$ce=o;function i(s,a,t){let r=!1;return{read:()=>{const h=a.read();return r?h:(r=!0,h!==null?t([s,h]):s)}}}e.$de=i;function n(s,a,t){let r=!1;const h=w(t);return $(a,{onData:u=>r?h.write(u):(r=!0,h.write(t([s,u]))),onError:u=>h.error(u),onEnd:()=>{r||(r=!0,h.write(s)),h.end()}}),h}e.$ee=n}),define(ke[22],Se([1,0,43,98]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const m=typeof Buffer<"u",A=new D.$U(()=>new Uint8Array(256));let R,w;class b{static alloc(k){return m?new b(Buffer.allocUnsafe(k)):new b(new Uint8Array(k))}static wrap(k){return m&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new b(k)}static fromString(k,I){return!(I?.dontUseNodeBuffer||!1)&&m?new b(Buffer.from(k)):(R||(R=new TextEncoder),new b(R.encode(k)))}static fromByteArray(k){const I=b.alloc(k.length);for(let j=0,z=k.length;j<z;j++)I.buffer[j]=k[j];return I}static concat(k,I){if(typeof I>"u"){I=0;for(let M=0,F=k.length;M<F;M++)I+=k[M].byteLength}const j=b.alloc(I);let z=0;for(let M=0,F=k.length;M<F;M++){const N=k[M];j.set(N,z),z+=N.byteLength}return j}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=b.alloc(this.byteLength);return k.set(this),k}toString(){return m?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(k,I){return new b(this.buffer.subarray(k,I))}set(k,I){if(k instanceof b)this.buffer.set(k.buffer,I);else if(k instanceof Uint8Array)this.buffer.set(k,I);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),I);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return $(this.buffer,k)}writeUInt32BE(k,I){v(this.buffer,k,I)}readUInt32LE(k){return S(this.buffer,k)}writeUInt32LE(k,I){g(this.buffer,k,I)}readUInt8(k){return d(this.buffer,k)}writeUInt8(k,I){o(this.buffer,k,I)}indexOf(k,I=0){return y(this.buffer,k instanceof b?k.buffer:k,I)}}e.$fe=b;function y(p,k,I=0){const j=k.byteLength,z=p.byteLength;if(j===0)return 0;if(j===1)return p.indexOf(k[0]);if(j>z-I)return-1;const M=A.value;M.fill(k.length);for(let W=0;W<k.length;W++)M[k[W]]=k.length-W-1;let F=I+k.length-1,N=F,O=-1;for(;F<z;)if(p[F]===k[N]){if(N===0){O=F;break}F--,N--}else F+=Math.max(k.length-N,M[p[F]]),N=k.length-1;return O}e.$ge=y;function L(p,k){return p[k+0]<<0>>>0|p[k+1]<<8>>>0}e.$he=L;function P(p,k,I){p[I+0]=k&255,k=k>>>8,p[I+1]=k&255}e.$ie=P;function $(p,k){return p[k]*2**24+p[k+1]*2**16+p[k+2]*2**8+p[k+3]}e.$je=$;function v(p,k,I){p[I+3]=k,k=k>>>8,p[I+2]=k,k=k>>>8,p[I+1]=k,k=k>>>8,p[I]=k}e.$ke=v;function S(p,k){return p[k+0]<<0>>>0|p[k+1]<<8>>>0|p[k+2]<<16>>>0|p[k+3]<<24>>>0}e.$le=S;function g(p,k,I){p[I+0]=k&255,k=k>>>8,p[I+1]=k&255,k=k>>>8,p[I+2]=k&255,k=k>>>8,p[I+3]=k&255}e.$me=g;function d(p,k){return p[k]}e.$ne=d;function o(p,k,I){p[I]=k}e.$oe=o;function i(p){return T.$7d(p,k=>b.concat(k))}e.$pe=i;function n(p){return T.$be(p)}e.$qe=n;function s(p){return T.$9d(p,k=>b.concat(k))}e.$re=s;async function a(p){return p.ended?b.concat(p.buffer):b.concat([...p.buffer,await s(p.stream)])}e.$se=a;function t(p){return T.$_d(p,k=>b.concat(k))}e.$te=t;function r(p){return T.$ce(p,{data:k=>typeof k=="string"?b.fromString(k):b.wrap(k)},k=>b.concat(k))}e.$ue=r;function h(p){return T.$6d(k=>b.concat(k),p)}e.$ve=h;function u(p,k){return T.$de(p,k,I=>b.concat(I))}e.$we=u;function c(p,k){return T.$ee(p,k,I=>b.concat(I))}e.$xe=c;function l(p){let k=0,I=0,j=0;const z=new Uint8Array(Math.floor(p.length/4*3)),M=N=>{switch(I){case 3:z[j++]=k|N,I=0;break;case 2:z[j++]=k|N>>>2,k=N<<6,I=3;break;case 1:z[j++]=k|N>>>4,k=N<<4,I=2;break;default:k=N<<2,I=1}};for(let N=0;N<p.length;N++){const O=p.charCodeAt(N);if(O>=65&&O<=90)M(O-65);else if(O>=97&&O<=122)M(O-97+26);else if(O>=48&&O<=57)M(O-48+52);else if(O===43||O===45)M(62);else if(O===47||O===95)M(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${p[N]}`)}}const F=j;for(;I>0;)M(0);return b.wrap(z).slice(0,F)}e.$ye=l;const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:p},k=!0,I=!1){const j=I?C:E;let z="";const M=p.byteLength%3;let F=0;for(;F<p.byteLength-M;F+=3){const N=p[F+0],O=p[F+1],W=p[F+2];z+=j[N>>>2],z+=j[(N<<4|O>>>4)&63],z+=j[(O<<2|W>>>6)&63],z+=j[W&63]}if(M===1){const N=p[F+0];z+=j[N>>>2],z+=j[N<<4&63],k&&(z+="==")}else if(M===2){const N=p[F+0],O=p[F+1];z+=j[N>>>2],z+=j[(N<<4|O>>>4)&63],z+=j[O<<2&63],k&&(z+="=")}return z}e.$ze=f}),define(ke[13],Se([1,0,161,43]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bf=e.$Af=e.$zf=e.$yf=e.GraphemeBreakType=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=void 0;function m(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Fe=m;const A=/{(\d+)}/g;function R(Ae,...Oe){return Oe.length===0?Ae:Ae.replace(A,function(qe,Me){const Xe=parseInt(Me,10);return isNaN(Xe)||Xe<0||Xe>=Oe.length?qe:Oe[Xe]})}e.$Ge=R;const w=/{([^}]+)}/g;function b(Ae,Oe){return Object.keys(Oe).length===0?Ae:Ae.replace(w,(qe,Me)=>Oe[Me]??qe)}e.$He=b;function y(Ae){return Ae.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}e.$Ie=y;function L(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Je=L;function P(Ae,Oe){let qe=0;const Me=Oe.charCodeAt(0);for(let Xe=Ae.length-1;Xe>=0;Xe--)Ae.charCodeAt(Xe)===Me&&qe++;return qe}e.$Ke=P;function $(Ae,Oe,qe="\u2026"){return Ae.length<=Oe?Ae:`${Ae.substr(0,Oe)}${qe}`}e.$Le=$;function v(Ae,Oe=" "){const qe=S(Ae,Oe);return g(qe,Oe)}e.$Me=v;function S(Ae,Oe){if(!Ae||!Oe)return Ae;const qe=Oe.length;if(qe===0||Ae.length===0)return Ae;let Me=0;for(;Ae.indexOf(Oe,Me)===Me;)Me=Me+qe;return Ae.substring(Me)}e.$Ne=S;function g(Ae,Oe){if(!Ae||!Oe)return Ae;const qe=Oe.length,Me=Ae.length;if(qe===0||Me===0)return Ae;let Xe=Me,le=-1;for(;le=Ae.lastIndexOf(Oe,Xe-1),!(le===-1||le+qe!==Xe);){if(le===0)return"";Xe=le}return Ae.substring(0,Xe)}e.$Oe=g;function d(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Pe=d;function o(Ae){return Ae.replace(/\*/g,"")}e.$Qe=o;function i(Ae,Oe,qe={}){if(!Ae)throw new Error("Cannot create regex from empty string");Oe||(Ae=L(Ae)),qe.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Me="";return qe.global&&(Me+="g"),qe.matchCase||(Me+="i"),qe.multiline&&(Me+="m"),qe.unicode&&(Me+="u"),new RegExp(Ae,Me)}e.$Re=i;function n(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Se=n;function s(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Te=s;function a(Ae){for(let Oe=0,qe=Ae.length;Oe<qe;Oe++){const Me=Ae.charCodeAt(Oe);if(Me!==32&&Me!==9)return Oe}return-1}e.$Ue=a;function t(Ae,Oe=0,qe=Ae.length){for(let Me=Oe;Me<qe;Me++){const Xe=Ae.charCodeAt(Me);if(Xe!==32&&Xe!==9)return Ae.substring(Oe,Me)}return Ae.substring(Oe,qe)}e.$Ve=t;function r(Ae,Oe=Ae.length-1){for(let qe=Oe;qe>=0;qe--){const Me=Ae.charCodeAt(qe);if(Me!==32&&Me!==9)return qe}return-1}e.$We=r;function h(Ae,Oe,qe){const Me=[];let Xe=0;for(const le of Ae.matchAll(Oe)){if(Me.push(Ae.slice(Xe,le.index)),le.index===void 0)throw new Error("match.index should be defined");Xe=le.index+le[0].length,Me.push(qe(le[0],...le.slice(1),le.index,Ae,le.groups))}return Me.push(Ae.slice(Xe)),Promise.all(Me).then(le=>le.join(""))}e.$Xe=h;function u(Ae,Oe){return Ae<Oe?-1:Ae>Oe?1:0}e.$Ye=u;function c(Ae,Oe,qe=0,Me=Ae.length,Xe=0,le=Oe.length){for(;qe<Me&&Xe<le;qe++,Xe++){const He=Ae.charCodeAt(qe),Ge=Oe.charCodeAt(Xe);if(He<Ge)return-1;if(He>Ge)return 1}const ce=Me-qe,Pe=le-Xe;return ce<Pe?-1:ce>Pe?1:0}e.$Ze=c;function l(Ae,Oe){return E(Ae,Oe,0,Ae.length,0,Oe.length)}e.$1e=l;function E(Ae,Oe,qe=0,Me=Ae.length,Xe=0,le=Oe.length){for(;qe<Me&&Xe<le;qe++,Xe++){let He=Ae.charCodeAt(qe),Ge=Oe.charCodeAt(Xe);if(He===Ge)continue;if(He>=128||Ge>=128)return c(Ae.toLowerCase(),Oe.toLowerCase(),qe,Me,Xe,le);f(He)&&(He-=32),f(Ge)&&(Ge-=32);const xe=He-Ge;if(xe!==0)return xe}const ce=Me-qe,Pe=le-Xe;return ce<Pe?-1:ce>Pe?1:0}e.$2e=E;function C(Ae){return Ae>=48&&Ae<=57}e.$3e=C;function f(Ae){return Ae>=97&&Ae<=122}e.$4e=f;function p(Ae){return Ae>=65&&Ae<=90}e.$5e=p;function k(Ae,Oe){return Ae.length===Oe.length&&E(Ae,Oe)===0}e.$6e=k;function I(Ae,Oe){const qe=Oe.length;return Oe.length>Ae.length?!1:E(Ae,Oe,0,qe)===0}e.$7e=I;function j(Ae,Oe){const qe=Math.min(Ae.length,Oe.length);let Me;for(Me=0;Me<qe;Me++)if(Ae.charCodeAt(Me)!==Oe.charCodeAt(Me))return Me;return qe}e.$8e=j;function z(Ae,Oe){const qe=Math.min(Ae.length,Oe.length);let Me;const Xe=Ae.length-1,le=Oe.length-1;for(Me=0;Me<qe;Me++)if(Ae.charCodeAt(Xe-Me)!==Oe.charCodeAt(le-Me))return Me;return qe}e.$9e=z;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$0e=M;function F(Ae){return 56320<=Ae&&Ae<=57343}e.$$e=F;function N(Ae,Oe){return(Ae-55296<<10)+(Oe-56320)+65536}e.$_e=N;function O(Ae,Oe,qe){const Me=Ae.charCodeAt(qe);if(M(Me)&&qe+1<Oe){const Xe=Ae.charCodeAt(qe+1);if(F(Xe))return N(Me,Xe)}return Me}e.$af=O;function W(Ae,Oe){const qe=Ae.charCodeAt(Oe-1);if(F(qe)&&Oe>1){const Me=Ae.charCodeAt(Oe-2);if(M(Me))return N(Me,qe)}return qe}class x{get offset(){return this.e}constructor(Oe,qe=0){this.c=Oe,this.d=Oe.length,this.e=qe}setOffset(Oe){this.e=Oe}prevCodePoint(){const Oe=W(this.c,this.e);return this.e-=Oe>=65536?2:1,Oe}nextCodePoint(){const Oe=O(this.c,this.d,this.e);return this.e+=Oe>=65536?2:1,Oe}eol(){return this.e>=this.d}}e.$bf=x;class ue{get offset(){return this.c.offset}constructor(Oe,qe=0){this.c=new x(Oe,qe)}nextGraphemeLength(){const Oe=ge.getInstance(),qe=this.c,Me=qe.offset;let Xe=Oe.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const le=qe.offset,ce=Oe.getGraphemeBreakType(qe.nextCodePoint());if(oe(Xe,ce)){qe.setOffset(le);break}Xe=ce}return qe.offset-Me}prevGraphemeLength(){const Oe=ge.getInstance(),qe=this.c,Me=qe.offset;let Xe=Oe.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const le=qe.offset,ce=Oe.getGraphemeBreakType(qe.prevCodePoint());if(oe(ce,Xe)){qe.setOffset(le);break}Xe=ce}return Me-qe.offset}eol(){return this.c.eol()}}e.$cf=ue;function X(Ae,Oe){return new ue(Ae,Oe).nextGraphemeLength()}e.$df=X;function J(Ae,Oe){return new ue(Ae,Oe).prevGraphemeLength()}e.$ef=J;function Q(Ae,Oe){Oe>0&&F(Ae.charCodeAt(Oe))&&Oe--;const qe=Oe+X(Ae,Oe);return[qe-J(Ae,qe),qe]}e.$ff=Q;function he(Ae){const Oe=new ue(Ae);let qe=0;for(;!Oe.eol();)qe++,Oe.nextGraphemeLength();return qe}e.$gf=he;let Z;function ye(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function de(Ae){return Z||(Z=ye()),Z.test(Ae)}e.$hf=de;const H=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return H.test(Ae)}e.$if=U,e.$jf=/[\u2028\u2029]/;function ne(Ae){return e.$jf.test(Ae)}e.$kf=ne;function Ee(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$lf=Ee;function fe(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$mf=fe;function me(Ae,Oe){if(Ae.length<Oe)return Ae;const qe=/\b/g;let Me=0;for(;qe.test(Ae)&&!(Ae.length-qe.lastIndex<Oe);)Me=qe.lastIndex,qe.lastIndex+=1;return Ae.substring(Me).replace(/^\s/,"")}e.$nf=me;const ee=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,te=/\x1b\].*?\x07/g;function K(Ae){return Ae&&(Ae=Ae.replace(ee,"").replace(te,"")),Ae}e.$of=K,e.$pf=String.fromCharCode(65279);function ie(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$qf=ie;function G(Ae){return ie(Ae)?Ae.substr(1):Ae}e.$rf=G;function ae(Ae,Oe){if(!Ae||!Oe||Ae.length<Oe.length)return!1;const qe=Oe.length,Me=Ae.toLowerCase();let Xe=0,le=-1;for(;Xe<qe;){const ce=Me.indexOf(Oe[Xe],le+1);if(ce<0)return!1;le=ce,Xe++}return!0}e.$sf=ae;function $e(Ae,Oe=!1){return Ae?(Oe&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$tf=$e;function Ce(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$uf=Ce;function B(Ae,Oe=1){if(Oe===0)return"";let qe=-1;do qe=Ae.indexOf(`
`,qe+1),Oe--;while(Oe>0&&qe>=0);return qe===-1?Ae:(Ae[qe-1]==="\r"&&qe--,Ae.substr(0,qe))}e.$vf=B;function Y(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$wf=Y;function se(Ae){return ge.getInstance().getGraphemeBreakType(Ae)}e.$xf=se;function oe(Ae,Oe){return Ae===0?Oe!==5&&Oe!==7:Ae===2&&Oe===3?!1:Ae===4||Ae===2||Ae===3||Oe===4||Oe===2||Oe===3?!0:!(Ae===8&&(Oe===8||Oe===9||Oe===11||Oe===12)||(Ae===11||Ae===9)&&(Oe===9||Oe===10)||(Ae===12||Ae===10)&&Oe===10||Oe===5||Oe===13||Oe===7||Ae===1||Ae===13&&Oe===14||Ae===6&&Oe===6)}var _;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(_||(e.GraphemeBreakType=_={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=ve()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===10?3:Oe===13?2:4;if(Oe<127)return 0;const qe=this.d,Me=qe.length/3;let Xe=1;for(;Xe<=Me;)if(Oe<qe[3*Xe])Xe=2*Xe;else if(Oe>qe[3*Xe+1])Xe=2*Xe+1;else return qe[3*Xe+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(Ae,Oe){if(Ae===0)return 0;const qe=We(Ae,Oe);if(qe!==void 0)return qe;const Me=new x(Oe,Ae);return Me.prevCodePoint(),Me.offset}e.$yf=ze;function We(Ae,Oe){const qe=new x(Oe,Ae);let Me=qe.prevCodePoint();for(;tt(Me)||Me===65039||Me===8419;){if(qe.offset===0)return;Me=qe.prevCodePoint()}if(!fe(Me))return;let Xe=qe.offset;return Xe>0&&qe.prevCodePoint()===8205&&(Xe=qe.offset),Xe}function tt(Ae){return 127995<=Ae&&Ae<=127999}var Ye;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$zf="\xA0";class rt{static{this.c=new T.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Be(Oe=>{function qe(xe){const ot=new Map;for(let lt=0;lt<xe.length;lt+=2)ot.set(xe[lt],xe[lt+1]);return ot}function Me(xe,ot){const lt=new Map(xe);for(const[Ne,St]of ot)lt.set(Ne,St);return lt}function Xe(xe,ot){if(!xe)return ot;const lt=new Map;for(const[Ne,St]of xe)ot.has(Ne)&&lt.set(Ne,St);return lt}const le=this.c.value;let ce=Oe.filter(xe=>!xe.startsWith("_")&&xe in le);ce.length===0&&(ce=["_default"]);let Pe;for(const xe of ce){const ot=qe(le[xe]);Pe=Xe(Pe,ot)}const He=qe(le._common),Ge=Me(He,Pe);return new rt(Ge)})}static getInstance(Oe){return rt.d.get(Array.from(Oe))}static{this.e=new T.$U(()=>Object.keys(rt.c.value).filter(Oe=>!Oe.startsWith("_")))}static getLocales(){return rt.e.value}constructor(Oe){this.f=Oe}isAmbiguous(Oe){return this.f.has(Oe)}getPrimaryConfusable(Oe){return this.f.get(Oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Af=rt;class nt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(nt.c())),this.d}static isInvisibleCharacter(Oe){return nt.e().has(Oe)}static get codePoints(){return nt.e()}}e.$Bf=nt}),define(ke[124],Se([1,0,28,13]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.FuzzyScore=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.or=void 0;function m(...G){return function(ae,$e){for(let Ce=0,B=G.length;Ce<B;Ce++){const Y=G[Ce](ae,$e);if(Y)return Y}return null}}e.or=m,e.$Mj=A.bind(void 0,!1),e.$Nj=A.bind(void 0,!0);function A(G,ae,$e){if(!$e||$e.length<ae.length)return null;let Ce;return G?Ce=T.$7e($e,ae):Ce=$e.indexOf(ae)===0,Ce?ae.length>0?[{start:0,end:ae.length}]:[]:null}function R(G,ae){const $e=ae.toLowerCase().indexOf(G.toLowerCase());return $e===-1?null:[{start:$e,end:$e+G.length}]}e.$Oj=R;function w(G,ae){return b(G.toLowerCase(),ae.toLowerCase(),0,0)}e.$Pj=w;function b(G,ae,$e,Ce){if($e===G.length)return[];if(Ce===ae.length)return null;if(G[$e]===ae[Ce]){let B=null;return(B=b(G,ae,$e+1,Ce+1))?o({start:Ce,end:Ce+1},B):null}return b(G,ae,$e,Ce+1)}function y(G){return 97<=G&&G<=122}function L(G){return 65<=G&&G<=90}e.$Qj=L;function P(G){return 48<=G&&G<=57}function $(G){return G===32||G===9||G===10||G===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>v.add(G.charCodeAt(0)));function S(G){return $(G)||v.has(G)}function g(G,ae){return G===ae||S(G)&&S(ae)}function d(G){return y(G)||L(G)||P(G)}function o(G,ae){return ae.length===0?ae=[G]:G.end===ae[0].start?ae[0].start=G.start:ae.unshift(G),ae}function i(G,ae){for(let $e=ae;$e<G.length;$e++){const Ce=G.charCodeAt($e);if(L(Ce)||P(Ce)||$e>0&&!d(G.charCodeAt($e-1)))return $e}return G.length}function n(G,ae,$e,Ce){if($e===G.length)return[];if(Ce===ae.length)return null;if(G[$e]!==ae[Ce].toLowerCase())return null;{let B=null,Y=Ce+1;for(B=n(G,ae,$e+1,Ce+1);!B&&(Y=i(ae,Y))<ae.length;)B=n(G,ae,$e+1,Y),Y++;return B===null?null:o({start:Ce,end:Ce+1},B)}}function s(G){let ae=0,$e=0,Ce=0,B=0,Y=0;for(let ve=0;ve<G.length;ve++)Y=G.charCodeAt(ve),L(Y)&&ae++,y(Y)&&$e++,d(Y)&&Ce++,P(Y)&&B++;const se=ae/G.length,oe=$e/G.length,_=Ce/G.length,ge=B/G.length;return{upperPercent:se,lowerPercent:oe,alphaPercent:_,numericPercent:ge}}function a(G){const{upperPercent:ae,lowerPercent:$e}=G;return $e===0&&ae>.6}function t(G){const{upperPercent:ae,lowerPercent:$e,alphaPercent:Ce,numericPercent:B}=G;return $e>.2&&ae<.8&&Ce>.6&&B<.2}function r(G){let ae=0,$e=0,Ce=0,B=0;for(let Y=0;Y<G.length;Y++)Ce=G.charCodeAt(Y),L(Ce)&&ae++,y(Ce)&&$e++,$(Ce)&&B++;return(ae===0||$e===0)&&B===0?G.length<=30:ae<=5}function h(G,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!r(G)||ae.length>60)return null;const $e=s(ae);if(!t($e)){if(!a($e))return null;ae=ae.toLowerCase()}let Ce=null,B=0;for(G=G.toLowerCase();B<ae.length&&(Ce=n(G,ae,0,B))===null;)B=i(ae,B+1);return Ce}e.$Rj=h;function u(G,ae,$e=!1){if(!ae||ae.length===0)return null;let Ce=null,B=0;for(G=G.toLowerCase(),ae=ae.toLowerCase();B<ae.length&&(Ce=c(G,ae,0,B,$e))===null;)B=l(ae,B+1);return Ce}e.$Sj=u;function c(G,ae,$e,Ce,B){if($e===G.length)return[];if(Ce===ae.length)return null;if(g(G.charCodeAt($e),ae.charCodeAt(Ce))){let Y=null,se=Ce+1;if(Y=c(G,ae,$e+1,Ce+1,B),!B)for(;!Y&&(se=l(ae,se))<ae.length;)Y=c(G,ae,$e+1,se,B),se++;return Y?G.charCodeAt($e)!==ae.charCodeAt(Ce)?Y:o({start:Ce,end:Ce+1},Y):null}else return null}function l(G,ae){for(let $e=ae;$e<G.length;$e++)if(S(G.charCodeAt($e))||$e>0&&S(G.charCodeAt($e-1)))return $e;return G.length}const E=m(e.$Nj,h,R),C=m(e.$Nj,h,w),f=new D.$Cc(1e4);function p(G,ae,$e=!1){if(typeof G!="string"||typeof ae!="string")return null;let Ce=f.get(G);Ce||(Ce=new RegExp(T.$Pe(G),"i"),f.set(G,Ce));const B=Ce.exec(ae);return B?[{start:B.index,end:B.index+B[0].length}]:$e?C(G,ae):E(G,ae)}e.$Tj=p;function k(G,ae){const $e=Ee(G,G.toLowerCase(),0,ae,ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $e?j($e):null}e.$Uj=k;function I(G,ae,$e,Ce,B,Y){const se=Math.min(13,G.length);for(;$e<se;$e++){const oe=Ee(G,ae,$e,Ce,B,Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,Y]}e.$Vj=I;function j(G){if(typeof G>"u")return[];const ae=[],$e=G[1];for(let Ce=G.length-1;Ce>1;Ce--){const B=G[Ce]+$e,Y=ae[ae.length-1];Y&&Y.end===B?Y.end=B+1:ae.push({start:B,end:B+1})}return ae}e.$Wj=j;const z=128;function M(){const G=[],ae=[];for(let $e=0;$e<=z;$e++)ae[$e]=0;for(let $e=0;$e<=z;$e++)G.push(ae.slice(0));return G}function F(G){const ae=[];for(let $e=0;$e<=G;$e++)ae[$e]=0;return ae}const N=F(2*z),O=F(2*z),W=M(),x=M(),ue=M(),X=!1;function J(G,ae,$e,Ce,B){function Y(oe,_,ge=" "){for(;oe.length<_;)oe=ge+oe;return oe}let se=` |   |${Ce.split("").map(oe=>Y(oe,3)).join("|")}
`;for(let oe=0;oe<=$e;oe++)oe===0?se+=" |":se+=`${ae[oe-1]}|`,se+=G[oe].slice(0,B+1).map(_=>Y(_.toString(),3)).join("|")+`
`;return se}function Q(G,ae,$e,Ce){G=G.substr(ae),$e=$e.substr(Ce),console.log(J(x,G,G.length,$e,$e.length)),console.log(J(ue,G,G.length,$e,$e.length)),console.log(J(W,G,G.length,$e,$e.length))}function he(G,ae){if(ae<0||ae>=G.length)return!1;const $e=G.codePointAt(ae);switch($e){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$mf($e)}}function Z(G,ae){if(ae<0||ae>=G.length)return!1;switch(G.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function ye(G,ae,$e){return ae[G]!==$e[G]}function de(G,ae,$e,Ce,B,Y,se=!1){for(;ae<$e&&B<Y;)G[ae]===Ce[B]&&(se&&(N[ae]=B),ae+=1),B+=1;return ae===$e}e.$Xj=de;var H;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(H||(H={}));var U;(function(G){G.Default=[-100,0];function ae($e){return!$e||$e.length===2&&$e[0]===-100&&$e[1]===0}G.isDefault=ae})(U||(e.FuzzyScore=U={}));class ne{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ae,$e){this.firstMatchCanBeWeak=ae,this.boostFullMatch=$e}}e.$Yj=ne;function Ee(G,ae,$e,Ce,B,Y,se=ne.default){const oe=G.length>z?z:G.length,_=Ce.length>z?z:Ce.length;if($e>=oe||Y>=_||oe-$e>_-Y||!de(ae,$e,oe,B,Y,_,!0))return;fe(oe,_,$e,Y,ae,B);let ge=1,ve=1,ze=$e,We=Y;const tt=[!1];for(ge=1,ze=$e;ze<oe;ge++,ze++){const Oe=N[ze],qe=O[ze],Me=ze+1<oe?O[ze+1]:_;for(ve=Oe-Y+1,We=Oe;We<Me;ve++,We++){let Xe=Number.MIN_SAFE_INTEGER,le=!1;We<=qe&&(Xe=me(G,ae,ze,$e,Ce,B,We,_,Y,W[ge-1][ve-1]===0,tt));let ce=0;Xe!==Number.MAX_SAFE_INTEGER&&(le=!0,ce=Xe+x[ge-1][ve-1]);const Pe=We>Oe,He=Pe?x[ge][ve-1]+(W[ge][ve-1]>0?-5:0):0,Ge=We>Oe+1&&W[ge][ve-1]>0,xe=Ge?x[ge][ve-2]+(W[ge][ve-2]>0?-5:0):0;if(Ge&&(!Pe||xe>=He)&&(!le||xe>=ce))x[ge][ve]=xe,ue[ge][ve]=3,W[ge][ve]=0;else if(Pe&&(!le||He>=ce))x[ge][ve]=He,ue[ge][ve]=2,W[ge][ve]=0;else if(le)x[ge][ve]=ce,ue[ge][ve]=1,W[ge][ve]=W[ge-1][ve-1]+1;else throw new Error("not possible")}}if(X&&Q(G,$e,Ce,Y),!tt[0]&&!se.firstMatchCanBeWeak)return;ge--,ve--;const Ye=[x[ge][ve],Y];let rt=0,nt=0;for(;ge>=1;){let Oe=ve;do{const qe=ue[ge][Oe];if(qe===3)Oe=Oe-2;else if(qe===2)Oe=Oe-1;else break}while(Oe>=1);rt>1&&ae[$e+ge-1]===B[Y+ve-1]&&!ye(Oe+Y-1,Ce,B)&&rt+1>W[ge][Oe]&&(Oe=ve),Oe===ve?rt++:rt=1,nt||(nt=Oe),ge--,ve=Oe-1,Ye.push(ve)}_===oe&&se.boostFullMatch&&(Ye[0]+=2);const Ae=nt-oe;return Ye[0]-=Ae,Ye}e.$Zj=Ee;function fe(G,ae,$e,Ce,B,Y){let se=G-1,oe=ae-1;for(;se>=$e&&oe>=Ce;)B[se]===Y[oe]&&(O[se]=oe,se--),oe--}function me(G,ae,$e,Ce,B,Y,se,oe,_,ge,ve){if(ae[$e]!==Y[se])return Number.MIN_SAFE_INTEGER;let ze=1,We=!1;return se===$e-Ce?ze=G[$e]===B[se]?7:5:ye(se,B,Y)&&(se===0||!ye(se-1,B,Y))?(ze=G[$e]===B[se]?7:5,We=!0):he(Y,se)&&(se===0||!he(Y,se-1))?ze=5:(he(Y,se-1)||Z(Y,se-1))&&(ze=5,We=!0),ze>1&&$e===Ce&&(ve[0]=!0),We||(We=ye(se,B,Y)||he(Y,se-1)||Z(Y,se-1)),$e===Ce?se>_&&(ze-=We?3:5):ge?ze+=We?2:0:ze+=We?0:1,se+1===oe&&(ze-=We?3:5),ze}function ee(G,ae,$e,Ce,B,Y,se){return K(G,ae,$e,Ce,B,Y,!0,se)}e.$1j=ee;function te(G,ae,$e,Ce,B,Y,se){return K(G,ae,$e,Ce,B,Y,!1,se)}e.$2j=te;function K(G,ae,$e,Ce,B,Y,se,oe){let _=Ee(G,ae,$e,Ce,B,Y,oe);if(_&&!se)return _;if(G.length>=3){const ge=Math.min(7,G.length-1);for(let ve=$e+1;ve<ge;ve++){const ze=ie(G,ve);if(ze){const We=Ee(ze,ze.toLowerCase(),$e,Ce,B,Y,oe);We&&(We[0]-=3,(!_||We[0]>_[0])&&(_=We))}}}return _}function ie(G,ae){if(ae+1>=G.length)return;const $e=G[ae],Ce=G[ae+1];if($e!==Ce)return G.slice(0,ae)+Ce+$e+G.slice(ae+2)}}),define(ke[52],Se([1,0,13]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=void 0;function T(o){return m(o,0)}e.$Ni=T;function m(o,i){switch(typeof o){case"object":return o===null?A(349,i):Array.isArray(o)?b(o,i):y(o,i);case"string":return w(o,i);case"boolean":return R(o,i);case"number":return A(o,i);case"undefined":return A(937,i);default:return A(617,i)}}e.$Oi=m;function A(o,i){return(i<<5)-i+o|0}e.$Pi=A;function R(o,i){return A(o?433:863,i)}function w(o,i){i=A(149417,i);for(let n=0,s=o.length;n<s;n++)i=A(o.charCodeAt(n),i);return i}e.$Qi=w;function b(o,i){return i=A(104579,i),o.reduce((n,s)=>m(s,n),i)}function y(o,i){return i=A(181387,i),Object.keys(o).sort().reduce((n,s)=>(n=w(s,n),m(o[s],n)),i)}class L{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=m(i,this.g),this.g}}e.$Ri=L;var P;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function $(o,i,n=32){const s=n-i,a=~((1<<s)-1);return(o<<i|(a&o)>>>s)>>>0}function v(o,i=0,n=o.byteLength,s=0){for(let a=0;a<n;a++)o[i+a]=s}function S(o,i,n="0"){for(;o.length<i;)o=n+o;return o}function g(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(n=>n.toString(16).padStart(2,"0")).join(""):S((o>>>0).toString(16),i/4)}e.$Si=g;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const s=this.p;let a=this.r,t=this.u,r,h;for(t!==0?(r=t,h=-1,t=0):(r=i.charCodeAt(0),h=0);;){let u=r;if(D.$0e(r))if(h+1<n){const c=i.charCodeAt(h+1);D.$$e(c)?(h++,u=D.$_e(r,c)):u=65533}else{t=r;break}else D.$$e(r)&&(u=65533);if(a=this.w(s,a,u),h++,h<n)r=i.charCodeAt(h);else break}this.r=a,this.u=t}w(i,n,s){return s<128?i[n++]=s:s<2048?(i[n++]=192|(s&1984)>>>6,i[n++]=128|(s&63)>>>0):s<65536?(i[n++]=224|(s&61440)>>>12,i[n++]=128|(s&4032)>>>6,i[n++]=128|(s&63)>>>0):(i[n++]=240|(s&1835008)>>>18,i[n++]=128|(s&258048)>>>12,i[n++]=128|(s&4032)>>>6,i[n++]=128|(s&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=d.g,n=this.q;for(let E=0;E<64;E+=4)i.setUint32(E,n.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)i.setUint32(E,$(i.getUint32(E-12,!1)^i.getUint32(E-32,!1)^i.getUint32(E-56,!1)^i.getUint32(E-64,!1),1),!1);let s=this.h,a=this.l,t=this.m,r=this.n,h=this.o,u,c,l;for(let E=0;E<80;E++)E<20?(u=a&t|~a&r,c=1518500249):E<40?(u=a^t^r,c=1859775393):E<60?(u=a&t|a&r|t&r,c=2400959708):(u=a^t^r,c=3395469782),l=$(s,5)+u+h+c+i.getUint32(E*4,!1)&4294967295,h=r,r=t,t=$(a,30),a=s,s=l;this.h=this.h+s&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+h&4294967295}}e.$Ti=d}),define(ke[39],Se([1,0,13]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(m){m[m.Ignore=0]="Ignore",m[m.Info=1]="Info",m[m.Warning=2]="Warning",m[m.Error=3]="Error"})(T||(T={})),function(m){const A="error",R="warning",w="warn",b="info",y="ignore";function L($){return $?D.$6e(A,$)?m.Error:D.$6e(R,$)||D.$6e(w,$)?m.Warning:D.$6e(b,$)?m.Info:m.Ignore:m.Ignore}m.fromValue=L;function P($){switch($){case m.Error:return A;case m.Warning:return R;case m.Info:return b;default:return y}}m.toString=P}(T||(T={})),e.default=T}),define(ke[162],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(ke[77],Se([1,0,19,13]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=void 0;class m{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const S=v.charCodeAt(0),g=this.b.charCodeAt(this.c);return S-g}value(){return this.b[this.c]}}e.$2h=m;class A{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,T.$Ze)(v,this.b,0,v.length,this.c,this.d):(0,T.$2e)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$3h=A;class R{constructor(v=!0,S=!0){this.f=v,this.g=S}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let S=v.length-1;S>=0;S--,this.c--){const g=this.b.charCodeAt(S);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,T.$Ze)(v,this.b,0,v.length,this.d,this.e):(0,T.$2e)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$4h=R;var w;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(w||(w={}));class b{constructor(v,S){this.f=v,this.g=S,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,T.$1e)(v,this.c.scheme);if(this.d[this.e]===2)return(0,T.$1e)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,T.$Ye)(v,this.c.query);if(this.d[this.e]===5)return(0,T.$Ye)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$5h=b;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(L||(L={}));class P{static forUris(v=()=>!1,S=()=>!1){return new P(new b(v,S))}static forPaths(v=!1){return new P(new R(void 0,!v))}static forStrings(){return new P(new m)}static forConfigKeys(){return new P(new A)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,S){if(S){const g=S.slice(0);(0,D.$Wb)(g);for(const d of g)this.set(d,v)}else{const g=v.slice(0);(0,D.$Wb)(g);for(const d of g)this.set(d[0],d[1])}}set(v,S){const g=this.b.reset(v);let d;this.c||(this.c=new y,this.c.segment=g.value());const o=[];for(d=this.c;;){const n=g.cmp(d.segment);if(n>0)d.left||(d.left=new y,d.left.segment=g.value()),o.push([-1,d]),d=d.left;else if(n<0)d.right||(d.right=new y,d.right.segment=g.value()),o.push([1,d]),d=d.right;else if(g.hasNext())g.next(),d.mid||(d.mid=new y,d.mid.segment=g.value()),o.push([0,d]),d=d.mid;else break}const i=d.value;d.value=S,d.key=v;for(let n=o.length-1;n>=0;n--){const s=o[n][1];s.updateHeight();const a=s.balanceFactor();if(a<-1||a>1){const t=o[n][0],r=o[n+1][0];if(t===1&&r===1)o[n][1]=s.rotateLeft();else if(t===-1&&r===-1)o[n][1]=s.rotateRight();else if(t===1&&r===-1)s.right=o[n+1][1]=o[n+1][1].rotateRight(),o[n][1]=s.rotateLeft();else if(t===-1&&r===1)s.left=o[n+1][1]=o[n+1][1].rotateLeft(),o[n][1]=s.rotateRight();else throw new Error;if(n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}return i}get(v){return this.d(v)?.value}d(v){const S=this.b.reset(v);let g=this.c;for(;g;){const d=S.cmp(g.segment);if(d>0)g=g.left;else if(d<0)g=g.right;else if(S.hasNext())S.next(),g=g.mid;else break}return g}has(v){const S=this.d(v);return!(S?.value===void 0&&S?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,S){const g=this.b.reset(v),d=[];let o=this.c;for(;o;){const i=g.cmp(o.segment);if(i>0)d.push([-1,o]),o=o.left;else if(i<0)d.push([1,o]),o=o.right;else if(g.hasNext())g.next(),d.push([0,o]),o=o.mid;else break}if(o){if(S?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:n,value:s,segment:a}=i;this.e(i.key,!1),o.key=n,o.value=s,o.segment=a}}else{const i=o.left??o.right;if(d.length>0){const[n,s]=d[d.length-1];switch(n){case-1:s.left=i;break;case 0:s.mid=i;break;case 1:s.right=i;break}}else this.c=i}for(let i=d.length-1;i>=0;i--){const n=d[i][1];n.updateHeight();const s=n.balanceFactor();if(s>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),d[i][1]=n.rotateLeft()):s<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),d[i][1]=n.rotateRight()),i>0)switch(d[i-1][0]){case-1:d[i-1][1].left=d[i][1];break;case 1:d[i-1][1].right=d[i][1];break;case 0:d[i-1][1].mid=d[i][1];break}else this.c=d[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const S=this.b.reset(v);let g=this.c,d;for(;g;){const o=S.cmp(g.segment);if(o>0)g=g.left;else if(o<0)g=g.right;else if(S.hasNext())S.next(),d=g.value||d,g=g.mid;else break}return g&&g.value||d}findSuperstr(v){return this.g(v,!1)}g(v,S){const g=this.b.reset(v);let d=this.c;for(;d;){const o=g.cmp(d.segment);if(o>0)d=d.left;else if(o<0)d=d.right;else if(g.hasNext())g.next(),d=d.mid;else return d.mid?this.h(d.mid):S?d.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[S,g]of this)v(g,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const S=[];return this.j(v,S),S[Symbol.iterator]()}j(v,S){v&&(v.left&&this.j(v.left,S),v.value&&S.push([v.key,v.value]),v.mid&&this.j(v.mid,S),v.right&&this.j(v.right,S))}_isBalanced(){const v=S=>{if(!S)return!0;const g=S.balanceFactor();return g<-1||g>1?!1:v(S.left)&&v(S.right)};return v(this.c)}}e.$6h=P}),define(ke[18],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=void 0;function D(a){return typeof a=="string"}e.$Cf=D;function T(a){return Array.isArray(a)&&a.every(t=>D(t))}e.$Df=T;function m(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Ef=m;function A(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Ff=A;function R(a){return typeof a=="number"&&!isNaN(a)}e.$Gf=R;function w(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Hf=w;function b(a){return a===!0||a===!1}e.$If=b;function y(a){return typeof a>"u"}e.$Jf=y;function L(a){return!P(a)}e.$Kf=L;function P(a){return y(a)||a===null}e.$Lf=P;function $(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Mf=$;function v(a){if(P(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Nf=v;function S(...a){const t=[];for(let r=0;r<a.length;r++){const h=a[r];if(P(h))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(h)}return t}e.$Of=S;const g=Object.prototype.hasOwnProperty;function d(a){if(!m(a))return!1;for(const t in a)if(g.call(a,t))return!1;return!0}e.$Pf=d;function o(a){return typeof a=="function"}e.$Qf=o;function i(...a){return a.length>0&&a.every(o)}e.$Rf=i;function n(a,t){const r=Math.min(a.length,t.length);for(let h=0;h<r;h++)s(a[h],t[h])}e.$Sf=n;function s(a,t){if(D(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(a instanceof t)return}catch{}if(!P(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Tf=s}),define(ke[78],Se([1,0,18]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=void 0;const T=Object.create(null);function m(w,b){if((0,D.$Cf)(b)){const y=T[b];if(y===void 0)throw new Error(`${w} references an unknown codicon: ${b}`);b=y}return T[w]=b,{id:w}}function A(){return T}e.$3j=A;function R(){return Object.values(e.$5j)}e.$4j=R,e.$5j={add:m("add",6e4),plus:m("plus",6e4),gistNew:m("gist-new",6e4),repoCreate:m("repo-create",6e4),lightbulb:m("lightbulb",60001),lightBulb:m("light-bulb",60001),repo:m("repo",60002),repoDelete:m("repo-delete",60002),gistFork:m("gist-fork",60003),repoForked:m("repo-forked",60003),gitPullRequest:m("git-pull-request",60004),gitPullRequestAbandoned:m("git-pull-request-abandoned",60004),recordKeys:m("record-keys",60005),keyboard:m("keyboard",60005),tag:m("tag",60006),tagAdd:m("tag-add",60006),tagRemove:m("tag-remove",60006),gitPullRequestLabel:m("git-pull-request-label",60006),person:m("person",60007),personFollow:m("person-follow",60007),personOutline:m("person-outline",60007),personFilled:m("person-filled",60007),gitBranch:m("git-branch",60008),gitBranchCreate:m("git-branch-create",60008),gitBranchDelete:m("git-branch-delete",60008),sourceControl:m("source-control",60008),mirror:m("mirror",60009),mirrorPublic:m("mirror-public",60009),star:m("star",60010),starAdd:m("star-add",60010),starDelete:m("star-delete",60010),starEmpty:m("star-empty",60010),comment:m("comment",60011),commentAdd:m("comment-add",60011),alert:m("alert",60012),warning:m("warning",60012),search:m("search",60013),searchSave:m("search-save",60013),logOut:m("log-out",60014),signOut:m("sign-out",60014),logIn:m("log-in",60015),signIn:m("sign-in",60015),eye:m("eye",60016),eyeUnwatch:m("eye-unwatch",60016),eyeWatch:m("eye-watch",60016),circleFilled:m("circle-filled",60017),primitiveDot:m("primitive-dot",60017),closeDirty:m("close-dirty",60017),debugBreakpoint:m("debug-breakpoint",60017),debugBreakpointDisabled:m("debug-breakpoint-disabled",60017),debugHint:m("debug-hint",60017),primitiveSquare:m("primitive-square",60018),edit:m("edit",60019),pencil:m("pencil",60019),info:m("info",60020),issueOpened:m("issue-opened",60020),gistPrivate:m("gist-private",60021),gitForkPrivate:m("git-fork-private",60021),lock:m("lock",60021),mirrorPrivate:m("mirror-private",60021),close:m("close",60022),removeClose:m("remove-close",60022),x:m("x",60022),repoSync:m("repo-sync",60023),sync:m("sync",60023),clone:m("clone",60024),desktopDownload:m("desktop-download",60024),beaker:m("beaker",60025),microscope:m("microscope",60025),vm:m("vm",60026),deviceDesktop:m("device-desktop",60026),file:m("file",60027),fileText:m("file-text",60027),more:m("more",60028),ellipsis:m("ellipsis",60028),kebabHorizontal:m("kebab-horizontal",60028),mailReply:m("mail-reply",60029),reply:m("reply",60029),organization:m("organization",60030),organizationFilled:m("organization-filled",60030),organizationOutline:m("organization-outline",60030),newFile:m("new-file",60031),fileAdd:m("file-add",60031),newFolder:m("new-folder",60032),fileDirectoryCreate:m("file-directory-create",60032),trash:m("trash",60033),trashcan:m("trashcan",60033),history:m("history",60034),clock:m("clock",60034),folder:m("folder",60035),fileDirectory:m("file-directory",60035),symbolFolder:m("symbol-folder",60035),logoGithub:m("logo-github",60036),markGithub:m("mark-github",60036),github:m("github",60036),terminal:m("terminal",60037),console:m("console",60037),repl:m("repl",60037),zap:m("zap",60038),symbolEvent:m("symbol-event",60038),error:m("error",60039),stop:m("stop",60039),variable:m("variable",60040),symbolVariable:m("symbol-variable",60040),array:m("array",60042),symbolArray:m("symbol-array",60042),symbolModule:m("symbol-module",60043),symbolPackage:m("symbol-package",60043),symbolNamespace:m("symbol-namespace",60043),symbolObject:m("symbol-object",60043),symbolMethod:m("symbol-method",60044),symbolFunction:m("symbol-function",60044),symbolConstructor:m("symbol-constructor",60044),symbolBoolean:m("symbol-boolean",60047),symbolNull:m("symbol-null",60047),symbolNumeric:m("symbol-numeric",60048),symbolNumber:m("symbol-number",60048),symbolStructure:m("symbol-structure",60049),symbolStruct:m("symbol-struct",60049),symbolParameter:m("symbol-parameter",60050),symbolTypeParameter:m("symbol-type-parameter",60050),symbolKey:m("symbol-key",60051),symbolText:m("symbol-text",60051),symbolReference:m("symbol-reference",60052),goToFile:m("go-to-file",60052),symbolEnum:m("symbol-enum",60053),symbolValue:m("symbol-value",60053),symbolRuler:m("symbol-ruler",60054),symbolUnit:m("symbol-unit",60054),activateBreakpoints:m("activate-breakpoints",60055),archive:m("archive",60056),arrowBoth:m("arrow-both",60057),arrowDown:m("arrow-down",60058),arrowLeft:m("arrow-left",60059),arrowRight:m("arrow-right",60060),arrowSmallDown:m("arrow-small-down",60061),arrowSmallLeft:m("arrow-small-left",60062),arrowSmallRight:m("arrow-small-right",60063),arrowSmallUp:m("arrow-small-up",60064),arrowUp:m("arrow-up",60065),bell:m("bell",60066),bold:m("bold",60067),book:m("book",60068),bookmark:m("bookmark",60069),debugBreakpointConditionalUnverified:m("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:m("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:m("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:m("debug-breakpoint-data-unverified",60072),debugBreakpointData:m("debug-breakpoint-data",60073),debugBreakpointDataDisabled:m("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:m("debug-breakpoint-log-unverified",60074),debugBreakpointLog:m("debug-breakpoint-log",60075),debugBreakpointLogDisabled:m("debug-breakpoint-log-disabled",60075),briefcase:m("briefcase",60076),broadcast:m("broadcast",60077),browser:m("browser",60078),bug:m("bug",60079),calendar:m("calendar",60080),caseSensitive:m("case-sensitive",60081),check:m("check",60082),checklist:m("checklist",60083),chevronDown:m("chevron-down",60084),dropDownButton:m("drop-down-button",60084),chevronLeft:m("chevron-left",60085),chevronRight:m("chevron-right",60086),chevronUp:m("chevron-up",60087),chromeClose:m("chrome-close",60088),chromeMaximize:m("chrome-maximize",60089),chromeMinimize:m("chrome-minimize",60090),chromeRestore:m("chrome-restore",60091),circle:m("circle",60092),circleOutline:m("circle-outline",60092),debugBreakpointUnverified:m("debug-breakpoint-unverified",60092),circleSlash:m("circle-slash",60093),circuitBoard:m("circuit-board",60094),clearAll:m("clear-all",60095),clippy:m("clippy",60096),closeAll:m("close-all",60097),cloudDownload:m("cloud-download",60098),cloudUpload:m("cloud-upload",60099),code:m("code",60100),collapseAll:m("collapse-all",60101),colorMode:m("color-mode",60102),commentDiscussion:m("comment-discussion",60103),compareChanges:m("compare-changes",60157),creditCard:m("credit-card",60105),dash:m("dash",60108),dashboard:m("dashboard",60109),database:m("database",60110),debugContinue:m("debug-continue",60111),debugDisconnect:m("debug-disconnect",60112),debugPause:m("debug-pause",60113),debugRestart:m("debug-restart",60114),debugStart:m("debug-start",60115),debugStepInto:m("debug-step-into",60116),debugStepOut:m("debug-step-out",60117),debugStepOver:m("debug-step-over",60118),debugStop:m("debug-stop",60119),debug:m("debug",60120),deviceCameraVideo:m("device-camera-video",60121),deviceCamera:m("device-camera",60122),deviceMobile:m("device-mobile",60123),diffAdded:m("diff-added",60124),diffIgnored:m("diff-ignored",60125),diffModified:m("diff-modified",60126),diffRemoved:m("diff-removed",60127),diffRenamed:m("diff-renamed",60128),diff:m("diff",60129),discard:m("discard",60130),editorLayout:m("editor-layout",60131),emptyWindow:m("empty-window",60132),exclude:m("exclude",60133),extensions:m("extensions",60134),eyeClosed:m("eye-closed",60135),fileBinary:m("file-binary",60136),fileCode:m("file-code",60137),fileMedia:m("file-media",60138),filePdf:m("file-pdf",60139),fileSubmodule:m("file-submodule",60140),fileSymlinkDirectory:m("file-symlink-directory",60141),fileSymlinkFile:m("file-symlink-file",60142),fileZip:m("file-zip",60143),files:m("files",60144),filter:m("filter",60145),flame:m("flame",60146),foldDown:m("fold-down",60147),foldUp:m("fold-up",60148),fold:m("fold",60149),folderActive:m("folder-active",60150),folderOpened:m("folder-opened",60151),gear:m("gear",60152),gift:m("gift",60153),gistSecret:m("gist-secret",60154),gist:m("gist",60155),gitCommit:m("git-commit",60156),gitCompare:m("git-compare",60157),gitMerge:m("git-merge",60158),githubAction:m("github-action",60159),githubAlt:m("github-alt",60160),globe:m("globe",60161),grabber:m("grabber",60162),graph:m("graph",60163),gripper:m("gripper",60164),heart:m("heart",60165),home:m("home",60166),horizontalRule:m("horizontal-rule",60167),hubot:m("hubot",60168),inbox:m("inbox",60169),issueClosed:m("issue-closed",60324),issueReopened:m("issue-reopened",60171),issues:m("issues",60172),italic:m("italic",60173),jersey:m("jersey",60174),json:m("json",60175),bracket:m("bracket",60175),kebabVertical:m("kebab-vertical",60176),key:m("key",60177),law:m("law",60178),lightbulbAutofix:m("lightbulb-autofix",60179),linkExternal:m("link-external",60180),link:m("link",60181),listOrdered:m("list-ordered",60182),listUnordered:m("list-unordered",60183),liveShare:m("live-share",60184),loading:m("loading",60185),location:m("location",60186),mailRead:m("mail-read",60187),mail:m("mail",60188),markdown:m("markdown",60189),megaphone:m("megaphone",60190),mention:m("mention",60191),milestone:m("milestone",60192),gitPullRequestMilestone:m("git-pull-request-milestone",60192),mortarBoard:m("mortar-board",60193),move:m("move",60194),multipleWindows:m("multiple-windows",60195),mute:m("mute",60196),noNewline:m("no-newline",60197),note:m("note",60198),octoface:m("octoface",60199),openPreview:m("open-preview",60200),package:m("package",60201),paintcan:m("paintcan",60202),pin:m("pin",60203),play:m("play",60204),run:m("run",60204),plug:m("plug",60205),preserveCase:m("preserve-case",60206),preview:m("preview",60207),project:m("project",60208),pulse:m("pulse",60209),question:m("question",60210),quote:m("quote",60211),radioTower:m("radio-tower",60212),reactions:m("reactions",60213),references:m("references",60214),refresh:m("refresh",60215),regex:m("regex",60216),remoteExplorer:m("remote-explorer",60217),remote:m("remote",60218),remove:m("remove",60219),replaceAll:m("replace-all",60220),replace:m("replace",60221),repoClone:m("repo-clone",60222),repoForcePush:m("repo-force-push",60223),repoPull:m("repo-pull",60224),repoPush:m("repo-push",60225),report:m("report",60226),requestChanges:m("request-changes",60227),rocket:m("rocket",60228),rootFolderOpened:m("root-folder-opened",60229),rootFolder:m("root-folder",60230),rss:m("rss",60231),ruby:m("ruby",60232),saveAll:m("save-all",60233),saveAs:m("save-as",60234),save:m("save",60235),screenFull:m("screen-full",60236),screenNormal:m("screen-normal",60237),searchStop:m("search-stop",60238),server:m("server",60240),settingsGear:m("settings-gear",60241),settings:m("settings",60242),shield:m("shield",60243),smiley:m("smiley",60244),sortPrecedence:m("sort-precedence",60245),splitHorizontal:m("split-horizontal",60246),splitVertical:m("split-vertical",60247),squirrel:m("squirrel",60248),starFull:m("star-full",60249),starHalf:m("star-half",60250),symbolClass:m("symbol-class",60251),symbolColor:m("symbol-color",60252),symbolCustomColor:m("symbol-customcolor",60252),symbolConstant:m("symbol-constant",60253),symbolEnumMember:m("symbol-enum-member",60254),symbolField:m("symbol-field",60255),symbolFile:m("symbol-file",60256),symbolInterface:m("symbol-interface",60257),symbolKeyword:m("symbol-keyword",60258),symbolMisc:m("symbol-misc",60259),symbolOperator:m("symbol-operator",60260),symbolProperty:m("symbol-property",60261),wrench:m("wrench",60261),wrenchSubaction:m("wrench-subaction",60261),symbolSnippet:m("symbol-snippet",60262),tasklist:m("tasklist",60263),telescope:m("telescope",60264),textSize:m("text-size",60265),threeBars:m("three-bars",60266),thumbsdown:m("thumbsdown",60267),thumbsup:m("thumbsup",60268),tools:m("tools",60269),triangleDown:m("triangle-down",60270),triangleLeft:m("triangle-left",60271),triangleRight:m("triangle-right",60272),triangleUp:m("triangle-up",60273),twitter:m("twitter",60274),unfold:m("unfold",60275),unlock:m("unlock",60276),unmute:m("unmute",60277),unverified:m("unverified",60278),verified:m("verified",60279),versions:m("versions",60280),vmActive:m("vm-active",60281),vmOutline:m("vm-outline",60282),vmRunning:m("vm-running",60283),watch:m("watch",60284),whitespace:m("whitespace",60285),wholeWord:m("whole-word",60286),window:m("window",60287),wordWrap:m("word-wrap",60288),zoomIn:m("zoom-in",60289),zoomOut:m("zoom-out",60290),listFilter:m("list-filter",60291),listFlat:m("list-flat",60292),listSelection:m("list-selection",60293),selection:m("selection",60293),listTree:m("list-tree",60294),debugBreakpointFunctionUnverified:m("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:m("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:m("debug-breakpoint-function-disabled",60296),debugStackframeActive:m("debug-stackframe-active",60297),circleSmallFilled:m("circle-small-filled",60298),debugStackframeDot:m("debug-stackframe-dot",60298),debugStackframe:m("debug-stackframe",60299),debugStackframeFocused:m("debug-stackframe-focused",60299),debugBreakpointUnsupported:m("debug-breakpoint-unsupported",60300),symbolString:m("symbol-string",60301),debugReverseContinue:m("debug-reverse-continue",60302),debugStepBack:m("debug-step-back",60303),debugRestartFrame:m("debug-restart-frame",60304),callIncoming:m("call-incoming",60306),callOutgoing:m("call-outgoing",60307),menu:m("menu",60308),expandAll:m("expand-all",60309),feedback:m("feedback",60310),gitPullRequestReviewer:m("git-pull-request-reviewer",60310),groupByRefType:m("group-by-ref-type",60311),ungroupByRefType:m("ungroup-by-ref-type",60312),account:m("account",60313),gitPullRequestAssignee:m("git-pull-request-assignee",60313),bellDot:m("bell-dot",60314),debugConsole:m("debug-console",60315),library:m("library",60316),output:m("output",60317),runAll:m("run-all",60318),syncIgnored:m("sync-ignored",60319),pinned:m("pinned",60320),githubInverted:m("github-inverted",60321),debugAlt:m("debug-alt",60305),serverProcess:m("server-process",60322),serverEnvironment:m("server-environment",60323),pass:m("pass",60324),stopCircle:m("stop-circle",60325),playCircle:m("play-circle",60326),record:m("record",60327),debugAltSmall:m("debug-alt-small",60328),vmConnect:m("vm-connect",60329),cloud:m("cloud",60330),merge:m("merge",60331),exportIcon:m("export",60332),graphLeft:m("graph-left",60333),magnet:m("magnet",60334),notebook:m("notebook",60335),redo:m("redo",60336),checkAll:m("check-all",60337),pinnedDirty:m("pinned-dirty",60338),passFilled:m("pass-filled",60339),circleLargeFilled:m("circle-large-filled",60340),circleLarge:m("circle-large",60341),circleLargeOutline:m("circle-large-outline",60341),combine:m("combine",60342),gather:m("gather",60342),table:m("table",60343),variableGroup:m("variable-group",60344),typeHierarchy:m("type-hierarchy",60345),typeHierarchySub:m("type-hierarchy-sub",60346),typeHierarchySuper:m("type-hierarchy-super",60347),gitPullRequestCreate:m("git-pull-request-create",60348),runAbove:m("run-above",60349),runBelow:m("run-below",60350),notebookTemplate:m("notebook-template",60351),debugRerun:m("debug-rerun",60352),workspaceTrusted:m("workspace-trusted",60353),workspaceUntrusted:m("workspace-untrusted",60354),workspaceUnspecified:m("workspace-unspecified",60355),terminalCmd:m("terminal-cmd",60356),terminalDebian:m("terminal-debian",60357),terminalLinux:m("terminal-linux",60358),terminalPowershell:m("terminal-powershell",60359),terminalTmux:m("terminal-tmux",60360),terminalUbuntu:m("terminal-ubuntu",60361),terminalBash:m("terminal-bash",60362),arrowSwap:m("arrow-swap",60363),copy:m("copy",60364),personAdd:m("person-add",60365),filterFilled:m("filter-filled",60366),wand:m("wand",60367),debugLineByLine:m("debug-line-by-line",60368),inspect:m("inspect",60369),layers:m("layers",60370),layersDot:m("layers-dot",60371),layersActive:m("layers-active",60372),compass:m("compass",60373),compassDot:m("compass-dot",60374),compassActive:m("compass-active",60375),azure:m("azure",60376),issueDraft:m("issue-draft",60377),gitPullRequestClosed:m("git-pull-request-closed",60378),gitPullRequestDraft:m("git-pull-request-draft",60379),debugAll:m("debug-all",60380),debugCoverage:m("debug-coverage",60381),runErrors:m("run-errors",60382),folderLibrary:m("folder-library",60383),debugContinueSmall:m("debug-continue-small",60384),beakerStop:m("beaker-stop",60385),graphLine:m("graph-line",60386),graphScatter:m("graph-scatter",60387),pieChart:m("pie-chart",60388),bracketDot:m("bracket-dot",60389),bracketError:m("bracket-error",60390),lockSmall:m("lock-small",60391),azureDevops:m("azure-devops",60392),verifiedFilled:m("verified-filled",60393),newLine:m("newline",60394),layout:m("layout",60395),layoutActivitybarLeft:m("layout-activitybar-left",60396),layoutActivitybarRight:m("layout-activitybar-right",60397),layoutPanelLeft:m("layout-panel-left",60398),layoutPanelCenter:m("layout-panel-center",60399),layoutPanelJustify:m("layout-panel-justify",60400),layoutPanelRight:m("layout-panel-right",60401),layoutPanel:m("layout-panel",60402),layoutSidebarLeft:m("layout-sidebar-left",60403),layoutSidebarRight:m("layout-sidebar-right",60404),layoutStatusbar:m("layout-statusbar",60405),layoutMenubar:m("layout-menubar",60406),layoutCentered:m("layout-centered",60407),layoutSidebarRightOff:m("layout-sidebar-right-off",60416),layoutPanelOff:m("layout-panel-off",60417),layoutSidebarLeftOff:m("layout-sidebar-left-off",60418),target:m("target",60408),indent:m("indent",60409),recordSmall:m("record-small",60410),errorSmall:m("error-small",60411),arrowCircleDown:m("arrow-circle-down",60412),arrowCircleLeft:m("arrow-circle-left",60413),arrowCircleRight:m("arrow-circle-right",60414),arrowCircleUp:m("arrow-circle-up",60415),heartFilled:m("heart-filled",60420),map:m("map",60421),mapFilled:m("map-filled",60422),circleSmall:m("circle-small",60423),bellSlash:m("bell-slash",60424),bellSlashDot:m("bell-slash-dot",60425),commentUnresolved:m("comment-unresolved",60426),gitPullRequestGoToChanges:m("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:m("git-pull-request-new-changes",60428),searchFuzzy:m("search-fuzzy",60429),commentDraft:m("comment-draft",60430),send:m("send",60431),sparkle:m("sparkle",60432),insert:m("insert",60433),mic:m("mic",60434),thumbsDownFilled:m("thumbsdown-filled",60435),thumbsUpFilled:m("thumbsup-filled",60436),coffee:m("coffee",60437),snake:m("snake",60438),game:m("game",60439),vr:m("vr",60440),chip:m("chip",60441),piano:m("piano",60442),music:m("music",60443),micFilled:m("mic-filled",60444),gitFetch:m("git-fetch",60445),copilot:m("copilot",60446),lightbulbSparkle:m("lightbulb-sparkle",60447),lightbulbSparkleAutofix:m("lightbulb-sparkle-autofix",60447),dialogError:m("dialog-error","error"),dialogWarning:m("dialog-warning","warning"),dialogInfo:m("dialog-info","info"),dialogClose:m("dialog-close","close"),treeItemExpanded:m("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:m("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:m("tree-filter-on-type-off","list-selection"),treeFilterClear:m("tree-filter-clear","close"),treeItemLoading:m("tree-item-loading","loading"),menuSelection:m("menu-selection","check"),menuSubmenu:m("menu-submenu","chevron-right"),menuBarMore:m("menubar-more","more"),scrollbarButtonLeft:m("scrollbar-button-left","triangle-left"),scrollbarButtonRight:m("scrollbar-button-right","triangle-right"),scrollbarButtonUp:m("scrollbar-button-up","triangle-up"),scrollbarButtonDown:m("scrollbar-button-down","triangle-down"),toolBarMore:m("toolbar-more","more"),quickInputBack:m("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=void 0;function T(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([n,s])=>{i[n]=s&&typeof s=="object"?T(s):s}),i}e.$en=T;function m(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const s in n)if(A.call(n,s)){const a=n[s];typeof a=="object"&&!Object.isFrozen(a)&&!(0,D.$Ff)(a)&&i.push(a)}}return o}e.$fn=m;const A=Object.prototype.hasOwnProperty;function R(o,i){return w(o,i,new Set)}e.$gn=R;function w(o,i,n){if((0,D.$Lf)(o))return o;const s=i(o);if(typeof s<"u")return s;if(Array.isArray(o)){const a=[];for(const t of o)a.push(w(t,i,n));return a}if((0,D.$Ef)(o)){if(n.has(o))throw new Error("Cannot clone recursive data-structure");n.add(o);const a={};for(const t in o)A.call(o,t)&&(a[t]=w(o[t],i,n));return n.delete(o),a}return o}function b(o,i,n=!0){return(0,D.$Ef)(o)?((0,D.$Ef)(i)&&Object.keys(i).forEach(s=>{s in o?n&&((0,D.$Ef)(o[s])&&(0,D.$Ef)(i[s])?b(o[s],i[s],n):o[s]=i[s]):o[s]=i[s]}),o):i}e.$hn=b;function y(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let n,s;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(n=0;n<o.length;n++)if(!y(o[n],i[n]))return!1}else{const a=[];for(s in o)a.push(s);a.sort();const t=[];for(s in i)t.push(s);if(t.sort(),!y(a,t))return!1;for(n=0;n<a.length;n++)if(!y(o[a[n]],i[a[n]]))return!1}return!0}e.$in=y;function L(o){const i=new Set;return JSON.stringify(o,(n,s)=>{if((0,D.$Ef)(s)||Array.isArray(s)){if(i.has(s))return"[Circular]";i.add(s)}return s})}e.$jn=L;function P(o,i){const n=Object.create(null);return!o||!i||Object.keys(i).forEach(a=>{const t=o[a],r=i[a];y(t,r)||(n[a]=r)}),n}e.$kn=P;function $(o,i){const n=i.toLowerCase(),s=Object.keys(o).find(a=>a.toLowerCase()===n);return s?o[s]:o[i]}e.$ln=$;function v(o,i){const n=Object.create(null);for(const[s,a]of Object.entries(o))i(s,a)&&(n[s]=a);return n}e.$mn=v;function S(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$nn=S;function g(o){const i=[];for(const n of S(o))typeof o[n]=="function"&&i.push(n);return i}e.$on=g;function d(o,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},s={};for(const a of o)s[a]=n(a);return s}e.$pn=d}),define(ke[61],Se([1,0,78]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$6j=e.ThemeColor=void 0;var T;(function(R){function w(b){return b&&typeof b=="object"&&typeof b.id=="string"}R.isThemeColor=w})(T||(e.ThemeColor=T={}));function m(R){return{id:R}}e.$6j=m;var A;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function b(i){const n=w.exec(i.id);if(!n)return b(D.$5j.error);const[,s,a]=n,t=["codicon","codicon-"+s];return a&&t.push("codicon-modifier-"+a.substring(1)),t}R.asClassNameArray=b;function y(i){return b(i).join(" ")}R.asClassName=y;function L(i){return"."+b(i).join(".")}R.asCSSSelector=L;function P(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||T.isThemeColor(i.color))}R.isThemeIcon=P;const $=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function v(i){const n=$.exec(i);if(!n)return;const[,s]=n;return{id:s}}R.fromString=v;function S(i){return{id:i}}R.fromId=S;function g(i,n){let s=i.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),n&&(s=`${s}~${n}`),{id:s}}R.modify=g;function d(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=d;function o(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=o})(A||(e.ThemeIcon=A={}))}),define(ke[163],Se([1,0,124,13,61]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=void 0;const A="$(",R=new RegExp(`\\$\\(${m.ThemeIcon.iconNameExpression}(?:${m.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${R.source}`,"g");function b(o){return o.replace(w,(i,n)=>n?i:`\\${i}`)}e.$7j=b;const y=new RegExp(`\\\\${R.source}`,"g");function L(o){return o.replace(y,i=>`\\${i}`)}e.$8j=L;const P=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function $(o){return o.indexOf(A)===-1?o:o.replace(P,(i,n,s,a)=>s?i:n||a||"")}e.$9j=$;function v(o){return o?o.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$0j=v;const S=new RegExp(`\\$\\(${m.ThemeIcon.iconNameCharacter}+\\)`,"g");function g(o){S.lastIndex=0;let i="";const n=[];let s=0;for(;;){const a=S.lastIndex,t=S.exec(o),r=o.substring(a,t?.index);if(r.length>0){i+=r;for(let h=0;h<r.length;h++)n.push(s)}if(!t)break;s+=t[0].length}return{text:i,iconOffsets:n}}e.$$j=g;function d(o,i,n=!1){const{text:s,iconOffsets:a}=i;if(!a||a.length===0)return(0,D.$Tj)(o,s,n);const t=(0,T.$Ne)(s," "),r=s.length-t.length,h=(0,D.$Tj)(o,t,n);if(h)for(const u of h){const c=a[u.start+r]+r;u.start+=c,u.end+=c}return h}e.$_j=d}),define(ke[125],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.Constants=void 0;var D;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function T(A){return A<0?0:A>255?255:A|0}e.$De=T;function m(A){return A<0?0:A>4294967295?4294967295:A|0}e.$Ee=m}),define(ke[30],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kg=e.$jg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(m){return D.test(m)}e.$jg=T,e.$kg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let m;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?m=crypto.getRandomValues.bind(crypto):m=function(w){for(let b=0;b<w.length;b++)w[b]=Math.floor(Math.random()*256);return w};const A=new Uint8Array(16),R=[];for(let w=0;w<256;w++)R.push(w.toString(16).padStart(2,"0"));return function(){m(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let b=0,y="";return y+=R[A[b++]],y+=R[A[b++]],y+=R[A[b++]],y+=R[A[b++]],y+="-",y+=R[A[b++]],y+=R[A[b++]],y+="-",y+=R[A[b++]],y+=R[A[b++]],y+="-",y+=R[A[b++]],y+=R[A[b++]],y+="-",y+=R[A[b++]],y+=R[A[b++]],y+=R[A[b++]],y+=R[A[b++]],y+=R[A[b++]],y+=R[A[b++]],y}}()}),define(ke[164],Se([1,0,19,51,30]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.$_s=e.$$s=e.$0s=e.$9s=void 0;function A(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.$9s=A;function R(P,$,v){const S={id:(0,m.$kg)(),name:P,uri:$,data:v};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$0s=R;class w{constructor(){this.a=new Map}get size(){let $=0;for(const v of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const v=[...this.a.keys()];return T.Iterable.some(this,([S,g])=>g.asFile())&&v.push("files"),L(b($),v)}get($){return this.a.get(this.b($))?.[0]}append($,v){const S=this.a.get($);S?S.push(v):this.a.set(this.b($),[v])}replace($,v){this.a.set(this.b($),[v])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,v]of this.a)for(const S of v)yield[$,S]}b($){return b($)}}e.$$s=w;function b(P){return P.toLowerCase()}function y(P,$){return L(b(P),$.map(b))}e.$_s=y;function L(P,$){if(P==="*/*")return $.length>0;if($.includes(P))return!0;const v=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[S,g,d]=v;return d==="*"?$.some(o=>o.startsWith(g+"/")):!1}e.$at=Object.freeze({create:P=>(0,D.$Lb)(P.map($=>$.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$at.split(P).filter($=>!$.startsWith("#"))})}),define(ke[165],Se([1,0,62]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=e.$mg=void 0;function T(w,b,y,L=1){let P=!1;return new Promise($=>{const v=setTimeout(()=>{if(!P)return P=!0,$(0)},y);m(w,b,L,S=>{if(!P)return P=!0,clearTimeout(v),$(S)})})}e.$mg=T;function m(w,b,y,L){if(b===0)return L(0);const P=new D.Socket;P.once("connect",()=>(R(P),m(w+y,b-1,y,L))),P.once("data",()=>{}),P.once("error",$=>(R(P),$.code!=="ECONNREFUSED"?m(w+y,b-1,y,L):L(w))),P.connect(w,"127.0.0.1")}e.$ng={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(w,b,y,L="127.0.0.1"){let P=!1,$,v=1;const S=D.createServer({pauseOnConnect:!0});function g(d,o){P||(P=!0,S.removeAllListeners(),S.close(),$&&clearTimeout($),o(d))}return new Promise(d=>{$=setTimeout(()=>{g(0,d)},y),S.on("listening",()=>{g(w,d)}),S.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&v<b?(w++,v++,S.listen(w,L)):g(0,d)}),S.on("close",()=>{g(0,d)}),S.listen(w,L)})}e.$og=A;function R(w){try{w.removeAllListeners("connect"),w.removeAllListeners("error"),w.end(),w.destroy(),w.unref()}catch(b){console.error(b)}}}),define(ke[126],Se([1,0,125]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=void 0;class T{constructor(w){const b=(0,D.$De)(w);this.c=b,this.a=T.d(b),this.b=new Map}static d(w){const b=new Uint8Array(256);return b.fill(w),b}set(w,b){const y=(0,D.$De)(b);w>=0&&w<256?this.a[w]=y:this.b.set(w,y)}get(w){return w>=0&&w<256?this.a[w]:this.b.get(w)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$1s=T;var m;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(m||(m={}));class A{constructor(){this.a=new T(0)}add(w){this.a.set(w,1)}has(w){return this.a.get(w)===1}clear(){return this.a.clear()}}e.$2s=A}),define(ke[166],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.StringEOL=void 0;var D;(function(m){m[m.Unknown=0]="Unknown",m[m.Invalid=3]="Invalid",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function T(m){let A=0,R=0,w=0,b=0;for(let y=0,L=m.length;y<L;y++){const P=m.charCodeAt(y);P===13?(A===0&&(R=y),A++,y+1<L&&m.charCodeAt(y+1)===10?(b|=2,y++):b|=3,w=y+1):P===10&&(b|=1,A===0&&(R=y),A++,w=y+1)}return A===0&&(R=m.length),[A,R,m.length-w,b]}e.$dt=T}),define(ke[53],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=void 0;class D{constructor(m,A){this.lineNumber=m,this.column=A}with(m=this.lineNumber,A=this.column){return m===this.lineNumber&&A===this.column?this:new D(m,A)}delta(m=0,A=0){return this.with(this.lineNumber+m,this.column+A)}equals(m){return D.equals(this,m)}static equals(m,A){return!m&&!A?!0:!!m&&!!A&&m.lineNumber===A.lineNumber&&m.column===A.column}isBefore(m){return D.isBefore(this,m)}static isBefore(m,A){return m.lineNumber<A.lineNumber?!0:A.lineNumber<m.lineNumber?!1:m.column<A.column}isBeforeOrEqual(m){return D.isBeforeOrEqual(this,m)}static isBeforeOrEqual(m,A){return m.lineNumber<A.lineNumber?!0:A.lineNumber<m.lineNumber?!1:m.column<=A.column}static compare(m,A){const R=m.lineNumber|0,w=A.lineNumber|0;if(R===w){const b=m.column|0,y=A.column|0;return b-y}return R-w}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(m){return new D(m.lineNumber,m.column)}static isIPosition(m){return m&&typeof m.lineNumber=="number"&&typeof m.column=="number"}}e.$Cs=D}),define(ke[29],Se([1,0,53]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=void 0;class T{constructor(A,R,w,b){A>w||A===w&&R>b?(this.startLineNumber=w,this.startColumn=b,this.endLineNumber=A,this.endColumn=R):(this.startLineNumber=A,this.startColumn=R,this.endLineNumber=w,this.endColumn=b)}isEmpty(){return T.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return T.containsPosition(this,A)}static containsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<A.startColumn||R.lineNumber===A.endLineNumber&&R.column>A.endColumn)}static strictContainsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<=A.startColumn||R.lineNumber===A.endLineNumber&&R.column>=A.endColumn)}containsRange(A){return T.containsRange(this,A)}static containsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>A.endColumn)}strictContainsRange(A){return T.strictContainsRange(this,A)}static strictContainsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<=A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>=A.endColumn)}plusRange(A){return T.plusRange(this,A)}static plusRange(A,R){let w,b,y,L;return R.startLineNumber<A.startLineNumber?(w=R.startLineNumber,b=R.startColumn):R.startLineNumber===A.startLineNumber?(w=R.startLineNumber,b=Math.min(R.startColumn,A.startColumn)):(w=A.startLineNumber,b=A.startColumn),R.endLineNumber>A.endLineNumber?(y=R.endLineNumber,L=R.endColumn):R.endLineNumber===A.endLineNumber?(y=R.endLineNumber,L=Math.max(R.endColumn,A.endColumn)):(y=A.endLineNumber,L=A.endColumn),new T(w,b,y,L)}intersectRanges(A){return T.intersectRanges(this,A)}static intersectRanges(A,R){let w=A.startLineNumber,b=A.startColumn,y=A.endLineNumber,L=A.endColumn;const P=R.startLineNumber,$=R.startColumn,v=R.endLineNumber,S=R.endColumn;return w<P?(w=P,b=$):w===P&&(b=Math.max(b,$)),y>v?(y=v,L=S):y===v&&(L=Math.min(L,S)),w>y||w===y&&b>L?null:new T(w,b,y,L)}equalsRange(A){return T.equalsRange(this,A)}static equalsRange(A,R){return!A&&!R?!0:!!A&&!!R&&A.startLineNumber===R.startLineNumber&&A.startColumn===R.startColumn&&A.endLineNumber===R.endLineNumber&&A.endColumn===R.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(A){return new D.$Cs(A.endLineNumber,A.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(A){return new D.$Cs(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,R){return new T(this.startLineNumber,this.startColumn,A,R)}setStartPosition(A,R){return new T(A,R,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(A){return new T(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(A){return new T(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new T(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,R=A){return new T(A.lineNumber,A.column,R.lineNumber,R.column)}static lift(A){return A?new T(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn)}static areIntersecting(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,R){if(A&&R){const y=A.startLineNumber|0,L=R.startLineNumber|0;if(y===L){const P=A.startColumn|0,$=R.startColumn|0;if(P===$){const v=A.endLineNumber|0,S=R.endLineNumber|0;if(v===S){const g=A.endColumn|0,d=R.endColumn|0;return g-d}return v-S}return P-$}return y-L}return(A?1:0)-(R?1:0)}static compareRangesUsingEnds(A,R){return A.endLineNumber===R.endLineNumber?A.endColumn===R.endColumn?A.startLineNumber===R.startLineNumber?A.startColumn-R.startColumn:A.startLineNumber-R.startLineNumber:A.endColumn-R.endColumn:A.endLineNumber-R.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.$Ds=T}),define(ke[167],Se([1,0,29]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;class T{static insert(A,R){return{range:new D.$Ds(A.lineNumber,A.column,A.lineNumber,A.column),text:R,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,R){return{range:A,text:R}}static replaceMove(A,R){return{range:A,text:R,forceMoveMarkers:!0}}}e.$Es=T}),define(ke[168],Se([1,0,53,29]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=e.SelectionDirection=void 0;var m;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(m||(e.SelectionDirection=m={}));class A extends T.$Ds{constructor(w,b,y,L){super(w,b,y,L),this.selectionStartLineNumber=w,this.selectionStartColumn=b,this.positionLineNumber=y,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(w){return A.selectionsEqual(this,w)}static selectionsEqual(w,b){return w.selectionStartLineNumber===b.selectionStartLineNumber&&w.selectionStartColumn===b.selectionStartColumn&&w.positionLineNumber===b.positionLineNumber&&w.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(w,b){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,w,b):new A(w,b,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Cs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Cs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(w,b){return this.getDirection()===0?new A(w,b,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,w,b)}static fromPositions(w,b=w){return new A(w.lineNumber,w.column,b.lineNumber,b.column)}static fromRange(w,b){return b===0?new A(w.startLineNumber,w.startColumn,w.endLineNumber,w.endColumn):new A(w.endLineNumber,w.endColumn,w.startLineNumber,w.startColumn)}static liftSelection(w){return new A(w.selectionStartLineNumber,w.selectionStartColumn,w.positionLineNumber,w.positionColumn)}static selectionsArrEqual(w,b){if(w&&!b||!w&&b)return!1;if(!w&&!b)return!0;if(w.length!==b.length)return!1;for(let y=0,L=w.length;y<L;y++)if(!this.selectionsEqual(w[y],b[y]))return!1;return!0}static isISelection(w){return w&&typeof w.selectionStartLineNumber=="number"&&typeof w.selectionStartColumn=="number"&&typeof w.positionLineNumber=="number"&&typeof w.positionColumn=="number"}static createWithDirection(w,b,y,L,P){return P===0?new A(w,b,y,L):new A(y,L,w,b)}}e.$Fs=A}),define(ke[169],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0,e.$as={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[170],Se([1,0,126]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=e.WordCharacterClass=void 0;var T;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class m extends D.$1s{constructor(w){super(0);for(let b=0,y=w.length;b<y;b++)this.set(w.charCodeAt(b),2);this.set(32,1),this.set(9,1)}}e.$3s=m;function A(R){const w={};return b=>(w.hasOwnProperty(b)||(w[b]=R(b)),w[b])}e.$4s=A(R=>new m(R))}),define(ke[127],Se([1,0,51,3,75]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=e.$es=e.$ds=e.$cs=e.$bs=void 0,e.$bs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(P=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const v of e.$bs)P.indexOf(v)>=0||($+="\\"+v);return $+="\\s]+)",new RegExp($,"g")}e.$cs=A();function R(P){let $=e.$cs;if(P&&P instanceof RegExp)if(P.global)$=P;else{let v="g";P.ignoreCase&&(v+="i"),P.multiline&&(v+="m"),P.unicode&&(v+="u"),$=new RegExp(P.source,v)}return $.lastIndex=0,$}e.$ds=R;const w=new m.$2c;w.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function b(P){const $=w.unshift(P);return(0,T.$Pc)($)}e.$es=b;function y(P,$,v,S,g){if(g||(g=D.Iterable.first(w)),v.length>g.maxLen){let s=P-g.maxLen/2;return s<0?s=0:S+=s,v=v.substring(s,P+g.maxLen/2),y(P,$,v,S,g)}const d=Date.now(),o=P-1-S;let i=-1,n=null;for(let s=1;!(Date.now()-d>=g.timeBudget);s++){const a=o-g.windowSize*s;$.lastIndex=Math.max(0,a);const t=L($,v,o,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const s={word:n[0],startColumn:S+1+n.index,endColumn:S+1+n.index+n[0].length};return $.lastIndex=0,s}return null}e.$fs=y;function L(P,$,v,S){let g;for(;g=P.exec($);){const d=g.index||0;if(d<=v&&P.lastIndex>=v)return g;if(S>0&&d>S)return null}return null}}),define(ke[171],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.$zt=e.IndentAction=void 0;var D;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class T{constructor(w){if(this.e=null,this.f=!1,this.open=w.open,this.close=w.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(w.notIn))for(let b=0,y=w.notIn.length;b<y;b++)switch(w.notIn[b]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(w){switch(w){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(w,b){if(w.getTokenCount()===0)return!0;const y=w.findTokenIndexAtOffset(b-2),L=w.getStandardTokenType(y);return this.isOK(L)}g(w,b){for(let y=w;y<=b;y++){const L=String.fromCharCode(y);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$zt=T;class m{constructor(w){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of w)A(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),A(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),A(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),A(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&A(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.$At=m;function A(R,w,b){R.has(w)?R.get(w).push(b):R.set(w,[b])}}),define(ke[172],Se([1,0,126]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aZ=e.$_Y=e.$$Y=e.State=void 0;var T;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class m{constructor(S,g,d){const o=new Uint8Array(S*g);for(let i=0,n=S*g;i<n;i++)o[i]=d;this.a=o,this.rows=S,this.cols=g}get(S,g){return this.a[S*this.cols+g]}set(S,g,d){this.a[S*this.cols+g]=d}}class A{constructor(S){let g=0,d=0;for(let i=0,n=S.length;i<n;i++){const[s,a,t]=S[i];a>g&&(g=a),s>d&&(d=s),t>d&&(d=t)}g++,d++;const o=new m(d,g,0);for(let i=0,n=S.length;i<n;i++){const[s,a,t]=S[i];o.set(s,a,t)}this.a=o,this.b=g}nextState(S,g){return g<0||g>=this.b?0:this.a.get(S,g)}}e.$$Y=A;let R=null;function w(){return R===null&&(R=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var b;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})(b||(b={}));let y=null;function L(){if(y===null){y=new D.$1s(0);const v=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<v.length;g++)y.set(v.charCodeAt(g),1);const S=".,;:";for(let g=0;g<S.length;g++)y.set(S.charCodeAt(g),2)}return y}class P{static a(S,g,d,o,i){let n=i-1;do{const s=g.charCodeAt(n);if(S.get(s)!==2)break;n--}while(n>o);if(o>0){const s=g.charCodeAt(o-1),a=g.charCodeAt(n);(s===40&&a===41||s===91&&a===93||s===123&&a===125)&&n--}return{range:{startLineNumber:d,startColumn:o+1,endLineNumber:d,endColumn:n+2},url:g.substring(o,n+1)}}static computeLinks(S,g=w()){const d=L(),o=[];for(let i=1,n=S.getLineCount();i<=n;i++){const s=S.getLineContent(i),a=s.length;let t=0,r=0,h=0,u=1,c=!1,l=!1,E=!1,C=!1;for(;t<a;){let f=!1;const p=s.charCodeAt(t);if(u===13){let k;switch(p){case 40:c=!0,k=0;break;case 41:k=c?0:1;break;case 91:E=!0,l=!0,k=0;break;case 93:E=!1,k=l?0:1;break;case 123:C=!0,k=0;break;case 125:k=C?0:1;break;case 39:case 34:case 96:h===p?k=1:h===39||h===34||h===96?k=0:k=1;break;case 42:k=h===42?1:0;break;case 124:k=h===124?1:0;break;case 32:k=E?0:1;break;default:k=d.get(p)}k===1&&(o.push(P.a(d,s,i,r,t)),f=!0)}else if(u===12){let k;p===91?(l=!0,k=0):k=d.get(p),k===1?f=!0:u=13}else u=g.nextState(u,p),u===0&&(f=!0);f&&(u=1,c=!1,l=!1,C=!1,r=t+1,h=p),t++}u===13&&o.push(P.a(d,s,i,r,a))}return o}}e.$_Y=P;function $(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:P.computeLinks(v)}e.$aZ=$}),define(ke[79],Se([1,0,24]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zu=e.$Yu=e.$Xu=e.$Wu=e.ModelConstants=e.PositionAffinity=e.$Vu=e.TrackedRangeStickiness=e.$Uu=e.$Tu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var m;(function(s){s[s.Left=1]="Left",s[s.Right=2]="Right"})(m||(e.GlyphMarginLane=m={}));var A;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var R;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var w;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(w||(e.EndOfLinePreference=w={}));var b;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(b||(e.DefaultEndOfLine=b={}));var y;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(y||(e.EndOfLineSequence=y={}));class L{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,D.$in)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Tu=L;class P{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Uu=P;var $;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($||(e.TrackedRangeStickiness=$={}));function v(s){return s&&typeof s.read=="function"}e.$Vu=v;var S;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var g;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(g||(e.ModelConstants=g={}));class d{constructor(a,t,r,h,u,c){this.identifier=a,this.range=t,this.text=r,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=u,this._isTracked=c}}e.$Wu=d;class o{constructor(a,t,r){this.regex=a,this.wordSeparators=t,this.simpleSearch=r}}e.$Xu=o;class i{constructor(a,t,r){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.$Yu=i;function n(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}e.$Zu=n}),define(ke[173],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EB=e.$DB=e.$CB=e.$BB=e.$AB=e.$zB=e.$yB=e.$xB=e.$wB=e.NodeColor=e.$vB=void 0;class D{constructor(d,o){this.piece=d,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$wB)return m(this.right);let d=this;for(;d.parent!==e.$wB&&d.parent.left!==d;)d=d.parent;return d.parent===e.$wB?e.$wB:d.parent}prev(){if(this.left!==e.$wB)return A(this.left);let d=this;for(;d.parent!==e.$wB&&d.parent.right!==d;)d=d.parent;return d.parent===e.$wB?e.$wB:d.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$vB=D;var T;(function(g){g[g.Black=0]="Black",g[g.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$wB=new D(null,0),e.$wB.parent=e.$wB,e.$wB.left=e.$wB,e.$wB.right=e.$wB,e.$wB.color=0;function m(g){for(;g.left!==e.$wB;)g=g.left;return g}e.$xB=m;function A(g){for(;g.right!==e.$wB;)g=g.right;return g}e.$yB=A;function R(g){return g===e.$wB?0:g.size_left+g.piece.length+R(g.right)}function w(g){return g===e.$wB?0:g.lf_left+g.piece.lineFeedCnt+w(g.right)}function b(){e.$wB.parent=e.$wB}function y(g,d){const o=d.right;o.size_left+=d.size_left+(d.piece?d.piece.length:0),o.lf_left+=d.lf_left+(d.piece?d.piece.lineFeedCnt:0),d.right=o.left,o.left!==e.$wB&&(o.left.parent=d),o.parent=d.parent,d.parent===e.$wB?g.root=o:d.parent.left===d?d.parent.left=o:d.parent.right=o,o.left=d,d.parent=o}e.$zB=y;function L(g,d){const o=d.left;d.left=o.right,o.right!==e.$wB&&(o.right.parent=d),o.parent=d.parent,d.size_left-=o.size_left+(o.piece?o.piece.length:0),d.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),d.parent===e.$wB?g.root=o:d===d.parent.right?d.parent.right=o:d.parent.left=o,o.right=d,d.parent=o}e.$AB=L;function P(g,d){let o,i;if(d.left===e.$wB?(i=d,o=i.right):d.right===e.$wB?(i=d,o=i.left):(i=m(d.right),o=i.right),i===g.root){g.root=o,o.color=0,d.detach(),b(),g.root.parent=e.$wB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===d?(o.parent=i.parent,S(g,o)):(i.parent===d?o.parent=i:o.parent=i.parent,S(g,o),i.left=d.left,i.right=d.right,i.parent=d.parent,i.color=d.color,d===g.root?g.root=i:d===d.parent.left?d.parent.left=i:d.parent.right=i,i.left!==e.$wB&&(i.left.parent=i),i.right!==e.$wB&&(i.right.parent=i),i.size_left=d.size_left,i.lf_left=d.lf_left,S(g,i)),d.detach(),o.parent.left===o){const a=R(o),t=w(o);if(a!==o.parent.size_left||t!==o.parent.lf_left){const r=a-o.parent.size_left,h=t-o.parent.lf_left;o.parent.size_left=a,o.parent.lf_left=t,v(g,o.parent,r,h)}}if(S(g,o.parent),n){b();return}let s;for(;o!==g.root&&o.color===0;)o===o.parent.left?(s=o.parent.right,s.color===1&&(s.color=0,o.parent.color=1,y(g,o.parent),s=o.parent.right),s.left.color===0&&s.right.color===0?(s.color=1,o=o.parent):(s.right.color===0&&(s.left.color=0,s.color=1,L(g,s),s=o.parent.right),s.color=o.parent.color,o.parent.color=0,s.right.color=0,y(g,o.parent),o=g.root)):(s=o.parent.left,s.color===1&&(s.color=0,o.parent.color=1,L(g,o.parent),s=o.parent.left),s.left.color===0&&s.right.color===0?(s.color=1,o=o.parent):(s.left.color===0&&(s.right.color=0,s.color=1,y(g,s),s=o.parent.left),s.color=o.parent.color,o.parent.color=0,s.left.color=0,L(g,o.parent),o=g.root));o.color=0,b()}e.$BB=P;function $(g,d){for(S(g,d);d!==g.root&&d.parent.color===1;)if(d.parent===d.parent.parent.left){const o=d.parent.parent.right;o.color===1?(d.parent.color=0,o.color=0,d.parent.parent.color=1,d=d.parent.parent):(d===d.parent.right&&(d=d.parent,y(g,d)),d.parent.color=0,d.parent.parent.color=1,L(g,d.parent.parent))}else{const o=d.parent.parent.left;o.color===1?(d.parent.color=0,o.color=0,d.parent.parent.color=1,d=d.parent.parent):(d===d.parent.left&&(d=d.parent,L(g,d)),d.parent.color=0,d.parent.parent.color=1,y(g,d.parent.parent))}g.root.color=0}e.$CB=$;function v(g,d,o,i){for(;d!==g.root&&d!==e.$wB;)d.parent.left===d&&(d.parent.size_left+=o,d.parent.lf_left+=i),d=d.parent}e.$DB=v;function S(g,d){let o=0,i=0;if(d!==g.root){for(;d!==g.root&&d===d.parent.right;)d=d.parent;if(d!==g.root)for(d=d.parent,o=R(d.left)-d.size_left,i=w(d.left)-d.lf_left,d.size_left+=o,d.lf_left+=i;d!==g.root&&(o!==0||i!==0);)d.parent.left===d&&(d.parent.size_left+=o,d.parent.lf_left+=i),d=d.parent}}e.$EB=S}),define(ke[174],Se([1,0,19,125]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5u=e.$4u=e.$3u=void 0;class m{constructor(b){this.a=b,this.b=new Uint32Array(b.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(b,y){b=(0,T.$Ee)(b);const L=this.a,P=this.b,$=y.length;return $===0?!1:(this.a=new Uint32Array(L.length+$),this.a.set(L.subarray(0,b),0),this.a.set(L.subarray(b),b+$),this.a.set(y,b),b-1<this.c[0]&&(this.c[0]=b-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(b,y){return b=(0,T.$Ee)(b),y=(0,T.$Ee)(y),this.a[b]===y?!1:(this.a[b]=y,b-1<this.c[0]&&(this.c[0]=b-1),!0)}removeValues(b,y){b=(0,T.$Ee)(b),y=(0,T.$Ee)(y);const L=this.a,P=this.b;if(b>=L.length)return!1;const $=L.length-b;return y>=$&&(y=$),y===0?!1:(this.a=new Uint32Array(L.length-y),this.a.set(L.subarray(0,b),0),this.a.set(L.subarray(b+y),b),this.b=new Uint32Array(this.a.length),b-1<this.c[0]&&(this.c[0]=b-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(b){return b<0?0:(b=(0,T.$Ee)(b),this.d(b))}d(b){if(b<=this.c[0])return this.b[b];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),b>=this.a.length&&(b=this.a.length-1);for(let L=y;L<=b;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],b),this.b[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let y=0,L=this.a.length-1,P=0,$=0,v=0;for(;y<=L;)if(P=y+(L-y)/2|0,$=this.b[P],v=$-this.a[P],b<v)L=P-1;else if(b>=$)y=P+1;else break;return new R(P,b-v)}}e.$3u=m;class A{constructor(b){this.a=b,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(b){return this.g(),b===0?0:this.d[b-1]}getIndexOf(b){this.g();const y=this.e[b],L=y>0?this.d[y-1]:0;return new R(y,b-L)}removeValues(b,y){this.a.splice(b,y),this.f(b)}insertValues(b,y){this.a=(0,D.$Vb)(this.a,b,y),this.f(b)}f(b){this.b=!1,this.c=Math.min(this.c,b-1)}g(){if(!this.b){for(let b=this.c+1,y=this.a.length;b<y;b++){const L=this.a[b],P=b>0?this.d[b-1]:0;this.d[b]=P+L;for(let $=0;$<L;$++)this.e[P+$]=b}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(b,y){this.a[b]!==y&&(this.a[b]=y,this.f(b))}}e.$4u=A;class R{constructor(b,y){this.index=b,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=y}}e.$5u=R}),define(ke[175],Se([1,0,13,53,174]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6u=void 0;class A{constructor(w,b,y,L){this.d=w,this.f=b,this.g=y,this.h=L,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(w){w.eol&&w.eol!==this.g&&(this.g=w.eol,this.j=null);const b=w.changes;for(const y of b)this.o(y.range),this.p(new T.$Cs(y.range.startLineNumber,y.range.startColumn),y.text);this.h=w.versionId,this.k=null}l(){if(!this.j){const w=this.g.length,b=this.f.length,y=new Uint32Array(b);for(let L=0;L<b;L++)y[L]=this.f[L].length+w;this.j=new m.$3u(y)}}n(w,b){this.f[w]=b,this.j&&this.j.setValue(w,this.f[w].length+this.g.length)}o(w){if(w.startLineNumber===w.endLineNumber){if(w.startColumn===w.endColumn)return;this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.startLineNumber-1].substring(w.endColumn-1));return}this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.endLineNumber-1].substring(w.endColumn-1)),this.f.splice(w.startLineNumber,w.endLineNumber-w.startLineNumber),this.j&&this.j.removeValues(w.startLineNumber,w.endLineNumber-w.startLineNumber)}p(w,b){if(b.length===0)return;const y=(0,D.$Te)(b);if(y.length===1){this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+y[0]+this.f[w.lineNumber-1].substring(w.column-1));return}y[y.length-1]+=this.f[w.lineNumber-1].substring(w.column-1),this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+y[0]);const L=new Uint32Array(y.length-1);for(let P=1;P<y.length;P++)this.f.splice(w.lineNumber+P-1,0,y[P]),L[P-1]=y[P].length+this.g.length;this.j&&this.j.insertValues(w.lineNumber,L)}}e.$6u=A}),define(ke[99],Se([1,0,13,170,53,29,79]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=e.$FB=void 0;const w=999;class b{constructor(i,n,s,a){this.searchString=i,this.isRegex=n,this.matchCase=s,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=y(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=D.$Re(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let s=!this.isRegex&&!i;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new R.$Xu(n,this.wordSeparators?(0,T.$4s)(this.wordSeparators):null,s?this.searchString:null)}}e.$FB=b;function y(o){if(!o||o.length===0)return!1;for(let i=0,n=o.length;i<n;i++){const s=o.charCodeAt(i);if(s===10)return!0;if(s===92){if(i++,i>=n)break;const a=o.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$GB=y;function L(o,i,n){if(!n)return new R.$Uu(o,null);const s=[];for(let a=0,t=i.length;a<t;a++)s[a]=i[a];return new R.$Uu(o,s)}e.$HB=L;class P{constructor(i){const n=[];let s=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[s++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let s=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;s<a;){const t=s+((a-s)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(s=t,a=t):s=t+1}return s+1}}class ${static findMatches(i,n,s,a,t){const r=n.parseSearchRequest();return r?r.regex.multiline?this.b(i,s,new d(r.wordSeparators,r.regex),a,t):this.c(i,s,r,a,t):[]}static a(i,n,s,a,t,r){let h,u=0;a?(u=a.findLineFeedCountBeforeOffset(t),h=n+t+u):h=n+t;let c;if(a){const f=a.findLineFeedCountBeforeOffset(t+r.length)-u;c=h+r.length+f}else c=h+r.length;const l=i.getPositionAt(h),E=i.getPositionAt(c);return new A.$Ds(l.lineNumber,l.column,E.lineNumber,E.column)}static b(i,n,s,a,t){const r=i.getOffsetAt(n.getStartPosition()),h=i.getValueInRange(n,1),u=i.getEOL()===`\r
`?new P(h):null,c=[];let l=0,E;for(s.reset(0);E=s.next(h);)if(c[l++]=L(this.a(i,r,h,u,E.index,E[0]),E,a),l>=t)return c;return c}static c(i,n,s,a,t){const r=[];let h=0;if(n.startLineNumber===n.endLineNumber){const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return h=this.d(s,c,n.startLineNumber,n.startColumn-1,h,r,a,t),r}const u=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);h=this.d(s,u,n.startLineNumber,n.startColumn-1,h,r,a,t);for(let c=n.startLineNumber+1;c<n.endLineNumber&&h<t;c++)h=this.d(s,i.getLineContent(c),c,0,h,r,a,t);if(h<t){const c=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);h=this.d(s,c,n.endLineNumber,0,h,r,a,t)}return r}static d(i,n,s,a,t,r,h,u){const c=i.wordSeparators;if(!h&&i.simpleSearch){const C=i.simpleSearch,f=C.length,p=n.length;let k=-f;for(;(k=n.indexOf(C,k+f))!==-1;)if((!c||g(c,n,p,k,f))&&(r[t++]=new R.$Uu(new A.$Ds(s,k+1+a,s,k+1+f+a),null),t>=u))return t;return t}const l=new d(i.wordSeparators,i.regex);let E;l.reset(0);do if(E=l.next(n),E&&(r[t++]=L(new A.$Ds(s,E.index+1+a,s,E.index+1+E[0].length+a),E,h),t>=u))return t;while(E);return t}static findNextMatch(i,n,s,a){const t=n.parseSearchRequest();if(!t)return null;const r=new d(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,s,r,a):this.f(i,s,r,a)}static e(i,n,s,a){const t=new m.$Cs(n.lineNumber,1),r=i.getOffsetAt(t),h=i.getLineCount(),u=i.getValueInRange(new A.$Ds(t.lineNumber,t.column,h,i.getLineMaxColumn(h)),1),c=i.getEOL()===`\r
`?new P(u):null;s.reset(n.column-1);const l=s.next(u);return l?L(this.a(i,r,u,c,l.index,l[0]),l,a):n.lineNumber!==1||n.column!==1?this.e(i,new m.$Cs(1,1),s,a):null}static f(i,n,s,a){const t=i.getLineCount(),r=n.lineNumber,h=i.getLineContent(r),u=this.g(s,h,r,n.column,a);if(u)return u;for(let c=1;c<=t;c++){const l=(r+c-1)%t,E=i.getLineContent(l+1),C=this.g(s,E,l+1,1,a);if(C)return C}return null}static g(i,n,s,a,t){i.reset(a-1);const r=i.next(n);return r?L(new A.$Ds(s,r.index+1,s,r.index+1+r[0].length),r,t):null}static findPreviousMatch(i,n,s,a){const t=n.parseSearchRequest();if(!t)return null;const r=new d(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,s,r,a):this.j(i,s,r,a)}static h(i,n,s,a){const t=this.b(i,new A.$Ds(1,1,n.lineNumber,n.column),s,a,10*w);if(t.length>0)return t[t.length-1];const r=i.getLineCount();return n.lineNumber!==r||n.column!==i.getLineMaxColumn(r)?this.h(i,new m.$Cs(r,i.getLineMaxColumn(r)),s,a):null}static j(i,n,s,a){const t=i.getLineCount(),r=n.lineNumber,h=i.getLineContent(r).substring(0,n.column-1),u=this.k(s,h,r,a);if(u)return u;for(let c=1;c<=t;c++){const l=(t+r-c-1)%t,E=i.getLineContent(l+1),C=this.k(s,E,l+1,a);if(C)return C}return null}static k(i,n,s,a){let t=null,r;for(i.reset(0);r=i.next(n);)t=L(new A.$Ds(s,r.index+1,s,r.index+1+r[0].length),r,a);return t}}e.$IB=$;function v(o,i,n,s,a){if(s===0)return!0;const t=i.charCodeAt(s-1);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(s);if(o.get(r)!==0)return!0}return!1}function S(o,i,n,s,a){if(s+a===n)return!0;const t=i.charCodeAt(s+a);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(s+a-1);if(o.get(r)!==0)return!0}return!1}function g(o,i,n,s,a){return v(o,i,n,s,a)&&S(o,i,n,s,a)}e.$JB=g;class d{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let s;do{if(this.b+this.c===n||(s=this.a.exec(i),!s))return null;const a=s.index,t=s[0].length;if(a===this.b&&t===this.c){if(t===0){D.$af(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||g(this._wordSeparators,i,n,a,t))return s}while(s);return null}}e.$KB=d}),define(ke[128],Se([1,0,53,29,79,173,99]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PB=e.$OB=e.$NB=e.$MB=e.$LB=void 0;const w=65535;function b(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class y{constructor(i,n,s,a,t){this.lineStarts=i,this.cr=n,this.lf=s,this.crlf=a,this.isBasicASCII=t}}function L(o,i=!0){const n=[0];let s=1;for(let a=0,t=o.length;a<t;a++){const r=o.charCodeAt(a);r===13?a+1<t&&o.charCodeAt(a+1)===10?(n[s++]=a+2,a++):n[s++]=a+1:r===10&&(n[s++]=a+1)}return i?b(n):n}e.$LB=L;function P(o,i){o.length=0,o[0]=0;let n=1,s=0,a=0,t=0,r=!0;for(let u=0,c=i.length;u<c;u++){const l=i.charCodeAt(u);l===13?u+1<c&&i.charCodeAt(u+1)===10?(t++,o[n++]=u+2,u++):(s++,o[n++]=u+1):l===10?(a++,o[n++]=u+1):r&&l!==9&&(l<32||l>126)&&(r=!1)}const h=new y(b(o),s,a,t,r);return o.length=0,h}e.$MB=P;class ${constructor(i,n,s,a,t){this.bufferIndex=i,this.start=n,this.end=s,this.lineFeedCnt=a,this.length=t}}e.$NB=$;class v{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$OB=v;class S{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==A.$wB&&i.iterate(i.root,s=>(s!==A.$wB&&this.a.push(s.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class g{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const s=this.b[n];if(s.nodeStartOffset<=i&&s.nodeStartOffset+s.node.piece.length>=i)return s}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const s=this.b[n];if(s.nodeStartLineNumber&&s.nodeStartLineNumber<i&&s.nodeStartLineNumber+s.node.piece.lineFeedCnt>=i)return s}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const s=this.b;for(let a=0;a<s.length;a++){const t=s[a];if(t.node.parent===null||t.nodeStartOffset>=i){s[a]=null,n=!0;continue}}if(n){const a=[];for(const t of s)t!==null&&a.push(t);this.b=a}}}class d{constructor(i,n,s){this.create(i,n,s)}create(i,n,s){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=A.$wB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=s;let a=null;for(let t=0,r=i.length;t<r;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=L(i[t].buffer));const h=new $(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,h)}this.h=new g(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=w,s=n-Math.floor(n/3),a=s*2;let t="",r=0;const h=[];if(this.iterate(this.root,u=>{const c=this.R(u),l=c.length;if(r<=s||r+l<a)return t+=c,r+=l,!0;const E=t.replace(/\r\n|\r|\n/g,i);return h.push(new v(E,L(E))),t=c,r=l,!0}),r>0){const u=t.replace(/\r\n|\r|\n/g,i);h.push(new v(u,L(u)))}this.create(h,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===A.$wB)return!0;const t=this.R(a),r=t.length,h=i.G(n),u=i.G(n+r),c=i.getValueInRange2(h,u);return n+=r,t===c})}getOffsetAt(i,n){let s=0,a=this.root;for(;a!==A.$wB;)if(a.left!==A.$wB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){s+=a.size_left;const t=this.B(a,i-a.lf_left-2);return s+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,s+=a.size_left+a.piece.length,a=a.right;return s}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,s=0;const a=i;for(;n!==A.$wB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(s+=n.lf_left+t.index,t.index===0){const r=this.getOffsetAt(s+1,1),h=a-r;return new D.$Cs(s+1,h+1)}return new D.$Cs(s+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,s+=n.lf_left+n.piece.lineFeedCnt,n.right===A.$wB){const t=this.getOffsetAt(s+1,1),r=a-i-t;return new D.$Cs(s+1,r+1)}else n=n.right;return new D.$Cs(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const s=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(s,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const h=i.node,u=this.a[h.piece.bufferIndex].buffer,c=this.u(h.piece.bufferIndex,h.piece.start);return u.substring(c+i.remainder,c+n.remainder)}let s=i.node;const a=this.a[s.piece.bufferIndex].buffer,t=this.u(s.piece.bufferIndex,s.piece.start);let r=a.substring(t+i.remainder,t+s.piece.length);for(s=s.next();s!==A.$wB;){const h=this.a[s.piece.bufferIndex].buffer,u=this.u(s.piece.bufferIndex,s.piece.start);if(s===n.node){r+=h.substring(u,u+n.remainder);break}else r+=h.substr(u,s.piece.length);s=s.next()}return r}getLinesContent(){const i=[];let n=0,s="",a=!1;return this.iterate(this.root,t=>{if(t===A.$wB)return!0;const r=t.piece;let h=r.length;if(h===0)return!0;const u=this.a[r.bufferIndex].buffer,c=this.a[r.bufferIndex].lineStarts,l=r.start.line,E=r.end.line;let C=c[l]+r.start.column;if(a&&(u.charCodeAt(C)===10&&(C++,h--),i[n++]=s,s="",a=!1,h===0))return!0;if(l===E)return!this.f&&u.charCodeAt(C+h-1)===13?(a=!0,s+=u.substr(C,h-1)):s+=u.substr(C,h),!0;s+=this.f?u.substring(C,Math.max(C,c[l+1]-this.e)):u.substring(C,c[l+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=s;for(let f=l+1;f<E;f++)s=this.f?u.substring(c[f],c[f+1]-this.e):u.substring(c[f],c[f+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=s;return!this.f&&u.charCodeAt(c[E]+r.end.column-1)===13?(a=!0,r.end.column===0?n--:s=u.substr(c[E],r.end.column-1)):s=u.substr(c[E],r.end.column),!0}),a&&(i[n++]=s,s=""),i[n++]=s,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const s=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return s.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const s=this.H(i,n+1);return this.l(s)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,s,a,t,r,h,u,c,l,E){const C=this.a[i.piece.bufferIndex],f=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,t),k=this.u(i.piece.bufferIndex,r);let I;const j={line:0,column:0};let z,M;n._wordSeparators?(z=C.buffer.substring(p,k),M=F=>F+p,n.reset(0)):(z=C.buffer,M=F=>F,n.reset(p));do if(I=n.next(z),I){if(M(I.index)>=k)return l;this.s(i,M(I.index)-f,j);const F=this.t(i.piece.bufferIndex,t,j),N=j.line===t.line?j.column-t.column+a:j.column+1,O=N+I[0].length;if(E[l++]=(0,R.$HB)(new T.$Ds(s+F,N,s+F,O),I,u),M(I.index)+I[0].length>=k||l>=c)return l}while(I);return l}findMatchesLineByLine(i,n,s,a){const t=[];let r=0;const h=new R.$KB(n.wordSeparators,n.regex);let u=this.H(i.startLineNumber,i.startColumn);if(u===null)return[];const c=this.H(i.endLineNumber,i.endColumn);if(c===null)return[];let l=this.s(u.node,u.remainder);const E=this.s(c.node,c.remainder);if(u.node===c.node)return this.findMatchesInNode(u.node,h,i.startLineNumber,i.startColumn,l,E,n,s,a,r,t),t;let C=i.startLineNumber,f=u.node;for(;f!==c.node;){const k=this.t(f.piece.bufferIndex,l,f.piece.end);if(k>=1){const j=this.a[f.piece.bufferIndex].lineStarts,z=this.u(f.piece.bufferIndex,f.piece.start),M=j[l.line+k],F=C===i.startLineNumber?i.startColumn:1;if(r=this.findMatchesInNode(f,h,C,F,l,this.s(f,M-z),n,s,a,r,t),r>=a)return t;C+=k}const I=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const j=this.getLineContent(C).substring(I,i.endColumn-1);return r=this.n(n,h,j,i.endLineNumber,I,r,t,s,a),t}if(r=this.n(n,h,this.getLineContent(C).substr(I),C,I,r,t,s,a),r>=a)return t;C++,u=this.H(C,1),f=u.node,l=this.s(u.node,u.remainder)}if(C===i.endLineNumber){const k=C===i.startLineNumber?i.startColumn-1:0,I=this.getLineContent(C).substring(k,i.endColumn-1);return r=this.n(n,h,I,i.endLineNumber,k,r,t,s,a),t}const p=C===i.startLineNumber?i.startColumn:1;return r=this.findMatchesInNode(c.node,h,C,p,l,E,n,s,a,r,t),t}n(i,n,s,a,t,r,h,u,c){const l=i.wordSeparators;if(!u&&i.simpleSearch){const C=i.simpleSearch,f=C.length,p=s.length;let k=-f;for(;(k=s.indexOf(C,k+f))!==-1;)if((!l||(0,R.$JB)(l,s,p,k,f))&&(h[r++]=new m.$Uu(new T.$Ds(a,k+1+t,a,k+1+f+t),null),r>=c))return r;return r}let E;n.reset(0);do if(E=n.next(s),E&&(h[r++]=(0,R.$HB)(new T.$Ds(a,E.index+1+t,a,E.index+1+E[0].length+t),E,u),r>=c))return r;while(E);return r}insert(i,n,s=!1){if(this.f=this.f&&s,this.j.lineNumber=0,this.j.value="",this.root!==A.$wB){const{node:a,remainder:t,nodeStartOffset:r}=this.G(i),h=a.piece,u=h.bufferIndex,c=this.s(a,t);if(a.piece.bufferIndex===0&&h.end.line===this.g.line&&h.end.column===this.g.column&&r+h.length===i&&n.length<w){this.F(a,n),this.y();return}if(r===i)this.o(n,a),this.h.validate(i);else if(r+a.piece.length>i){const l=[];let E=new $(h.bufferIndex,c,h.end,this.t(h.bufferIndex,c,h.end),this.u(u,h.end)-this.u(u,c));if(this.K()&&this.M(n)&&this.I(a,t)===10){const k={line:E.start.line+1,column:0};E=new $(E.bufferIndex,k,E.end,this.t(E.bufferIndex,k,E.end),E.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const k=this.s(a,t-1);this.C(a,k),n="\r"+n,a.piece.length===0&&l.push(a)}else this.C(a,c);else this.C(a,c);const C=this.w(n);E.length>0&&this.S(a,E);let f=a;for(let p=0;p<C.length;p++)f=this.S(f,C[p]);this.v(l)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let r=1;r<a.length;r++)t=this.S(t,a[r])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===A.$wB)return;const s=this.G(i),a=this.G(i+n),t=s.node,r=a.node;if(t===r){const C=this.s(t,s.remainder),f=this.s(t,a.remainder);if(s.nodeStartOffset===i){if(n===t.piece.length){const p=t.next();(0,A.$BB)(this,t),this.N(p),this.y();return}this.D(t,f),this.h.validate(i),this.N(t),this.y();return}if(s.nodeStartOffset+t.piece.length===i+n){this.C(t,C),this.O(t),this.y();return}this.E(t,C,f),this.y();return}const h=[],u=this.s(t,s.remainder);this.C(t,u),this.h.validate(i),t.piece.length===0&&h.push(t);const c=this.s(r,a.remainder);this.D(r,c),r.piece.length===0&&h.push(r);const l=t.next();for(let C=l;C!==A.$wB&&C!==r;C=C.next())h.push(C);const E=t.piece.length===0?t.prev():t;this.v(h),this.O(E),this.y()}o(i,n){const s=[];if(this.K()&&this.M(i)&&this.L(n)){const r=n.piece,h={line:r.start.line+1,column:0},u=new $(r.bufferIndex,h,r.end,this.t(r.bufferIndex,h,r.end),r.length-1);n.piece=u,i+=`
`,(0,A.$DB)(this,n,-1,-1),n.piece.length===0&&s.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let r=a.length-2;r>=0;r--)t=this.T(t,a[r]);this.N(t),this.v(s)}q(i,n){this.Q(i,n)&&(i+=`
`);const s=this.w(i),a=this.S(n,s[0]);let t=a;for(let r=1;r<s.length;r++)t=this.S(t,s[r]);this.N(a)}s(i,n,s){const a=i.piece,t=i.piece.bufferIndex,r=this.a[t].lineStarts,u=r[a.start.line]+a.start.column+n;let c=a.start.line,l=a.end.line,E=0,C=0,f=0;for(;c<=l&&(E=c+(l-c)/2|0,f=r[E],E!==l);)if(C=r[E+1],u<f)l=E-1;else if(u>=C)c=E+1;else break;return s?(s.line=E,s.column=u-f,null):{line:E,column:u-f}}t(i,n,s){if(s.column===0)return s.line-n.line;const a=this.a[i].lineStarts;if(s.line===a.length-1)return s.line-n.line;const t=a[s.line+1],r=a[s.line]+s.column;if(t>r+1)return s.line-n.line;const h=r-1;return this.a[i].buffer.charCodeAt(h)===13?s.line-n.line+1:s.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,A.$BB)(this,i[n])}w(i){if(i.length>w){const l=[];for(;i.length>w;){const C=i.charCodeAt(w-1);let f;C===13||C>=55296&&C<=56319?(f=i.substring(0,w-1),i=i.substring(w-1)):(f=i.substring(0,w),i=i.substring(w));const p=L(f);l.push(new $(this.a.length,{line:0,column:0},{line:p.length-1,column:f.length-p[p.length-1]},p.length-1,f.length)),this.a.push(new v(f,p))}const E=L(i);return l.push(new $(this.a.length,{line:0,column:0},{line:E.length-1,column:i.length-E[E.length-1]},E.length-1,i.length)),this.a.push(new v(i,E)),l}let n=this.a[0].buffer.length;const s=L(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let l=0;l<s.length;l++)s[l]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let l=0;l<s.length;l++)s[l]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,h=t-this.a[0].lineStarts[r],u={line:r,column:h},c=new $(0,a,u,this.t(0,a,u),t-n);return this.g=u,[c]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let s=this.root,a="";const t=this.h.get2(i);if(t){s=t.node;const r=this.B(s,i-t.nodeStartLineNumber-1),h=this.a[s.piece.bufferIndex].buffer,u=this.u(s.piece.bufferIndex,s.piece.start);if(t.nodeStartLineNumber+s.piece.lineFeedCnt===i)a=h.substring(u+r,u+s.piece.length);else{const c=this.B(s,i-t.nodeStartLineNumber);return h.substring(u+r,u+c-n)}}else{let r=0;const h=i;for(;s!==A.$wB;)if(s.left!==A.$wB&&s.lf_left>=i-1)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt>i-1){const u=this.B(s,i-s.lf_left-2),c=this.B(s,i-s.lf_left-1),l=this.a[s.piece.bufferIndex].buffer,E=this.u(s.piece.bufferIndex,s.piece.start);return r+=s.size_left,this.h.set({node:s,nodeStartOffset:r,nodeStartLineNumber:h-(i-1-s.lf_left)}),l.substring(E+u,E+c-n)}else if(s.lf_left+s.piece.lineFeedCnt===i-1){const u=this.B(s,i-s.lf_left-2),c=this.a[s.piece.bufferIndex].buffer,l=this.u(s.piece.bufferIndex,s.piece.start);a=c.substring(l+u,l+s.piece.length);break}else i-=s.lf_left+s.piece.lineFeedCnt,r+=s.size_left+s.piece.length,s=s.right}for(s=s.next();s!==A.$wB;){const r=this.a[s.piece.bufferIndex].buffer;if(s.piece.lineFeedCnt>0){const h=this.B(s,0),u=this.u(s.piece.bufferIndex,s.piece.start);return a+=r.substring(u,u+h-n),a}else{const h=this.u(s.piece.bufferIndex,s.piece.start);a+=r.substr(h,s.piece.length)}s=s.next()}return a}y(){let i=this.root,n=1,s=0;for(;i!==A.$wB;)n+=i.lf_left+i.piece.lineFeedCnt,s+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=s,this.h.validate(this.c)}A(i,n){const s=i.piece,a=this.s(i,n),t=a.line-s.start.line;if(this.u(s.bufferIndex,s.end)-this.u(s.bufferIndex,s.start)===n){const r=this.t(i.piece.bufferIndex,s.start,a);if(r!==t)return{index:r,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const s=i.piece,a=this.a[s.bufferIndex].lineStarts,t=s.start.line+n+1;return t>s.end.line?a[s.end.line]+s.end.column-a[s.start.line]-s.start.column:a[t]-a[s.start.line]-s.start.column}C(i,n){const s=i.piece,a=s.lineFeedCnt,t=this.u(s.bufferIndex,s.end),r=n,h=this.u(s.bufferIndex,r),u=this.t(s.bufferIndex,s.start,r),c=u-a,l=h-t,E=s.length+l;i.piece=new $(s.bufferIndex,s.start,r,u,E),(0,A.$DB)(this,i,l,c)}D(i,n){const s=i.piece,a=s.lineFeedCnt,t=this.u(s.bufferIndex,s.start),r=n,h=this.t(s.bufferIndex,r,s.end),u=this.u(s.bufferIndex,r),c=h-a,l=t-u,E=s.length+l;i.piece=new $(s.bufferIndex,r,s.end,h,E),(0,A.$DB)(this,i,l,c)}E(i,n,s){const a=i.piece,t=a.start,r=a.end,h=a.length,u=a.lineFeedCnt,c=n,l=this.t(a.bufferIndex,a.start,c),E=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new $(a.bufferIndex,a.start,c,l,E),(0,A.$DB)(this,i,E-h,l-u);const C=new $(a.bufferIndex,s,r,this.t(a.bufferIndex,s,r),this.u(a.bufferIndex,r)-this.u(a.bufferIndex,s)),f=this.S(i,C);this.N(f)}F(i,n){this.Q(n,i)&&(n+=`
`);const s=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=L(n,!1);for(let f=0;f<t.length;f++)t[f]+=a;if(s){const f=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-f}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const r=this.a[0].lineStarts.length-1,h=this.a[0].buffer.length-this.a[0].lineStarts[r],u={line:r,column:h},c=i.piece.length+n.length,l=i.piece.lineFeedCnt,E=this.t(0,i.piece.start,u),C=E-l;i.piece=new $(i.piece.bufferIndex,i.piece.start,u,E,c),this.g=u,(0,A.$DB)(this,i,n.length,C)}G(i){let n=this.root;const s=this.h.get(i);if(s)return{node:s.node,nodeStartOffset:s.nodeStartOffset,remainder:i-s.nodeStartOffset};let a=0;for(;n!==A.$wB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let s=this.root,a=0;for(;s!==A.$wB;)if(s.left!==A.$wB&&s.lf_left>=i-1)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt>i-1){const t=this.B(s,i-s.lf_left-2),r=this.B(s,i-s.lf_left-1);return a+=s.size_left,{node:s,remainder:Math.min(t+n-1,r),nodeStartOffset:a}}else if(s.lf_left+s.piece.lineFeedCnt===i-1){const t=this.B(s,i-s.lf_left-2);if(t+n-1<=s.piece.length)return{node:s,remainder:t+n-1,nodeStartOffset:a};n-=s.piece.length-t;break}else i-=s.lf_left+s.piece.lineFeedCnt,a+=s.size_left+s.piece.length,s=s.right;for(s=s.next();s!==A.$wB;){if(s.piece.lineFeedCnt>0){const t=this.B(s,0),r=this.J(s);return{node:s,remainder:Math.min(n-1,t),nodeStartOffset:r}}else if(s.piece.length>=n-1){const t=this.J(s);return{node:s,remainder:n-1,nodeStartOffset:t}}else n-=s.piece.length;s=s.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const s=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return s.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$wB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,s=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=s[a]+n.start.column;return a===s.length-1||s[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$wB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const s=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const r=i.piece.length-1,h=i.piece.lineFeedCnt-1;i.piece=new $(i.piece.bufferIndex,i.piece.start,t,h,r),(0,A.$DB)(this,i,-1,-1),i.piece.length===0&&s.push(i);const u={line:n.piece.start.line+1,column:0},c=n.piece.length-1,l=this.t(n.piece.bufferIndex,u,n.piece.end);n.piece=new $(n.piece.bufferIndex,u,n.piece.end,l,c),(0,A.$DB)(this,n,-1,-1),n.piece.length===0&&s.push(n);const E=this.w(`\r
`);this.S(i,E[0]);for(let C=0;C<s.length;C++)(0,A.$BB)(this,s[C])}Q(i,n){if(this.K()&&this.M(i)){const s=n.next();if(this.L(s)){if(i+=`
`,s.piece.length===1)(0,A.$BB)(this,s);else{const a=s.piece,t={line:a.start.line+1,column:0},r=a.length-1,h=this.t(a.bufferIndex,t,a.end);s.piece=new $(a.bufferIndex,t,a.end,h,r),(0,A.$DB)(this,s,-1,-1)}return!0}}return!1}iterate(i,n){if(i===A.$wB)return n(A.$wB);const s=this.iterate(i.left,n);return s&&n(i)&&this.iterate(i.right,n)}R(i){if(i===A.$wB)return"";const n=this.a[i.piece.bufferIndex],s=i.piece,a=this.u(s.bufferIndex,s.start),t=this.u(s.bufferIndex,s.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],s=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(s,a)}S(i,n){const s=new A.$vB(n,1);if(s.left=A.$wB,s.right=A.$wB,s.parent=A.$wB,s.size_left=0,s.lf_left=0,this.root===A.$wB)this.root=s,s.color=0;else if(i.right===A.$wB)i.right=s,s.parent=i;else{const t=(0,A.$xB)(i.right);t.left=s,s.parent=t}return(0,A.$CB)(this,s),s}T(i,n){const s=new A.$vB(n,1);if(s.left=A.$wB,s.right=A.$wB,s.parent=A.$wB,s.size_left=0,s.lf_left=0,this.root===A.$wB)this.root=s,s.color=0;else if(i.left===A.$wB)i.left=s,s.parent=i;else{const a=(0,A.$yB)(i.left);a.right=s,s.parent=a}return(0,A.$CB)(this,s),s}U(i){let n="";return this.iterate(i,s=>(n+=this.R(s),!0)),n}}e.$PB=d}),define(ke[176],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z7=e.$Y7=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const R=this.a.get(A);return this.a.delete(A),R}}addDragOperationTransfer(A,R){this.a.set(A,R)}}e.$Y7=D;class T{constructor(A){this.identifier=A}}e.$Z7=T}),define(ke[177],Se([1,0,4,3]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class m{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Rd,this.onDidChange=this.c.event,this.d=null}handleChange(w){this.c.fire({changedLanguages:w,changedColorMap:!1})}register(w,b){return this.a.set(w,b),this.handleChange([w]),(0,T.$Pc)(()=>{this.a.get(w)===b&&(this.a.delete(w),this.handleChange([w]))})}get(w){return this.a.get(w)||null}registerFactory(w,b){this.b.get(w)?.dispose();const y=new A(this,w,b);return this.b.set(w,y),(0,T.$Pc)(()=>{const L=this.b.get(w);!L||L!==y||(this.b.delete(w),L.dispose())})}async getOrCreate(w){const b=this.get(w);if(b)return b;const y=this.b.get(w);return!y||y.isResolved?null:(await y.resolve(),this.get(w))}isResolved(w){if(this.get(w))return!0;const y=this.b.get(w);return!!(!y||y.isResolved)}setColorMap(w){this.d=w,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$ct=m;class A extends T.$Rc{get isResolved(){return this.c}constructor(w,b,y){super(),this.f=w,this.g=b,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const w=await this.h.tokenizationSupport;this.c=!0,w&&!this.a&&this.B(this.f.register(this.g,w))}}}),define(ke[178],Se([9,10]),function(be,e){return be.create("vs/base/common/actions",e)}),define(ke[179],Se([1,0,4,3,178]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class A extends T.$Rc{constructor($,v="",S="",g=!0,d){super(),this.h=this.B(new D.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=v,this.u=S,this.w=g,this.C=d}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,v){this.C&&await this.C($)}}e.$Ei=A;class R extends T.$Rc{constructor(){super(...arguments),this.f=this.B(new D.$Rd),this.onWillRun=this.f.event,this.m=this.B(new D.$Rd),this.onDidRun=this.m.event}async run($,v){if(!$.enabled)return;this.f.fire({action:$});let S;try{await this.u($,v)}catch(g){S=g}this.m.fire({action:$,error:S})}async u($,v){await $.run(v)}}e.$Fi=R;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let v=[];for(const S of $)S.length&&(v.length?v=[...v,new w,...S]:v=S);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Gi=w;class b{get actions(){return this.a}constructor($,v,S,g){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=v,this.class=g,this.a=S}async run(){}}e.$Hi=b;class y extends A{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,m.localize(0,null),void 0,!1)}}e.$Ii=y;function L(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async(...$)=>P.run(...$),tooltip:P.label}}e.$Ji=L}),define(ke[180],Se([9,10]),function(be,e){return be.create("vs/base/common/date",e)}),define(ke[181],Se([1,0,180]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=void 0;const T=60,m=T*60,A=m*24,R=A*7,w=A*30,b=A*365;function y(P,$,v,S){typeof P!="number"&&(P=P.getTime());const g=Math.round((new Date().getTime()-P)/1e3);if(g<-30)return(0,D.localize)(0,null,y(new Date().getTime()+g*1e3,!1));if(!S&&g<30)return(0,D.localize)(1,null);let d;return g<T?(d=g,$?d===1?v?(0,D.localize)(2,null,d):(0,D.localize)(3,null,d):v?(0,D.localize)(4,null,d):(0,D.localize)(5,null,d):d===1?v?(0,D.localize)(6,null,d):(0,D.localize)(7,null,d):v?(0,D.localize)(8,null,d):(0,D.localize)(9,null,d)):g<m?(d=Math.floor(g/T),$?d===1?v?(0,D.localize)(10,null,d):(0,D.localize)(11,null,d):v?(0,D.localize)(12,null,d):(0,D.localize)(13,null,d):d===1?v?(0,D.localize)(14,null,d):(0,D.localize)(15,null,d):v?(0,D.localize)(16,null,d):(0,D.localize)(17,null,d)):g<A?(d=Math.floor(g/m),$?d===1?v?(0,D.localize)(18,null,d):(0,D.localize)(19,null,d):v?(0,D.localize)(20,null,d):(0,D.localize)(21,null,d):d===1?v?(0,D.localize)(22,null,d):(0,D.localize)(23,null,d):v?(0,D.localize)(24,null,d):(0,D.localize)(25,null,d)):g<R?(d=Math.floor(g/A),$?d===1?(0,D.localize)(26,null,d):(0,D.localize)(27,null,d):d===1?(0,D.localize)(28,null,d):(0,D.localize)(29,null,d)):g<w?(d=Math.floor(g/R),$?d===1?v?(0,D.localize)(30,null,d):(0,D.localize)(31,null,d):v?(0,D.localize)(32,null,d):(0,D.localize)(33,null,d):d===1?v?(0,D.localize)(34,null,d):(0,D.localize)(35,null,d):v?(0,D.localize)(36,null,d):(0,D.localize)(37,null,d)):g<b?(d=Math.floor(g/w),$?d===1?v?(0,D.localize)(38,null,d):(0,D.localize)(39,null,d):v?(0,D.localize)(40,null,d):(0,D.localize)(41,null,d):d===1?v?(0,D.localize)(42,null,d):(0,D.localize)(43,null,d):v?(0,D.localize)(44,null,d):(0,D.localize)(45,null,d)):(d=Math.floor(g/b),$?d===1?v?(0,D.localize)(46,null,d):(0,D.localize)(47,null,d):v?(0,D.localize)(48,null,d):(0,D.localize)(49,null,d):d===1?v?(0,D.localize)(50,null,d):(0,D.localize)(51,null,d):v?(0,D.localize)(52,null,d):(0,D.localize)(53,null,d))}e.$nm=y;function L(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$om=L}),define(ke[182],Se([9,10]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(ke[44],Se([1,0,19,18,182]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=void 0;function A(P,$){return $&&(P.stack||P.stacktrace)?m.localize(0,null,w(P),R(P.stack)||R(P.stacktrace)):w(P)}function R(P){return Array.isArray(P)?P.join(`
`):P}function w(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?m.localize(1,null,P.message):P.message||m.localize(2,null)}function b(P=null,$=!1){if(!P)return m.localize(3,null);if(Array.isArray(P)){const v=D.$Gb(P),S=b(v[0],$);return v.length>1?m.localize(4,null,S,v.length):S}if(T.$Cf(P))return P;if(P.detail){const v=P.detail;if(v.error)return A(v.error,$);if(v.exception)return A(v.exception,$)}return P.stack?A(P,$):P.message?P.message:m.localize(5,null)}e.$Ki=b;function y(P){const $=P;return $ instanceof Error&&Array.isArray($.actions)}e.$Li=y;function L(P,$){let v;return typeof P=="string"?v=new Error(P):v=P,v.actions=$,v}e.$Mi=L}),define(ke[183],Se([9,10]),function(be,e){return be.create("vs/base/common/platform",e)}),define(ke[11],Se([1,0,183]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let T=!1,m=!1,A=!1,R=!1,w=!1,b=!1,y=!1,L=!1,P=!1,$=!1,v,S=e.$g,g=e.$g,d,o;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const s=typeof n?.versions?.electron=="string",a=s&&n?.type==="renderer";if(typeof navigator=="object"&&!a)o=navigator.userAgent,T=o.indexOf("Windows")>=0,m=o.indexOf("Macintosh")>=0,L=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=o.indexOf("Linux")>=0,$=o?.indexOf("Mobi")>=0,b=!0,v=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,S=v,g=navigator.language;else if(typeof n=="object"){T=n.platform==="win32",m=n.platform==="darwin",A=n.platform==="linux",R=A&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,y=s,P=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$g,S=e.$g;const f=n.env.VSCODE_NLS_CONFIG;if(f)try{const p=JSON.parse(f),k=p.availableLanguages["*"];v=p.locale,g=p.osLocale,S=k||e.$g,d=p._translationsConfigFile}catch{}w=!0}else console.error("Unable to resolve platform.");var t;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=r;let h=0;m?h=1:T?h=3:A&&(h=2),e.$i=T,e.$j=m,e.$k=A,e.$l=R,e.$m=w,e.$n=y,e.$o=b,e.$p=b&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=L,e.$s=$,e.$t=P,e.$u=h,e.$v=o,e.$w=S;var u;(function(f){function p(){return e.$w}f.value=p;function k(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}f.isDefaultVariant=k;function I(){return e.$w==="en"}f.isDefault=I})(u||(e.Language=u={})),e.$x=v,e.$y=g,e.$z=d,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const f=[];i.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let I=0,j=f.length;I<j;I++){const z=f[I];if(z.id===k.data.vscodeScheduleAsyncWork){f.splice(I,1),z.callback();return}}});let p=0;return k=>{const I=++p;f.push({id:I,callback:k}),i.postMessage({vscodeScheduleAsyncWork:I},"*")}}return f=>setTimeout(f)})();var c;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=m||L?2:T?1:3;let l=!0,E=!1;function C(){if(!E){E=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,l=new Uint16Array(f.buffer)[0]===(2<<8)+1}return l}e.$D=C,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ke[49],Se([1,0,11]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let T;const m=globalThis.vscode;if(typeof m<"u"&&typeof m.process<"u"){const A=m.process;T={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$cc=T.platform,e.$dc=T.arch}),define(ke[16],Se([1,0,49]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const T=65,m=97,A=90,R=122,w=46,b=47,y=92,L=58,P=63;class $ extends Error{constructor(r,h,u){let c;typeof h=="string"&&h.indexOf("not ")===0?(c="must not be",h=h.replace(/^not /,"")):c="must be";const l=r.indexOf(".")!==-1?"property":"argument";let E=`The "${r}" ${l} ${c} of type ${h}`;E+=`. Received type ${typeof u}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function v(t,r){if(t===null||typeof t!="object")throw new $(r,"Object",t)}function S(t,r){if(typeof t!="string")throw new $(r,"string",t)}const g=D.$cc==="win32";function d(t){return t===b||t===y}function o(t){return t===b}function i(t){return t>=T&&t<=A||t>=m&&t<=R}function n(t,r,h,u){let c="",l=0,E=-1,C=0,f=0;for(let p=0;p<=t.length;++p){if(p<t.length)f=t.charCodeAt(p);else{if(u(f))break;f=b}if(u(f)){if(!(E===p-1||C===1))if(C===2){if(c.length<2||l!==2||c.charCodeAt(c.length-1)!==w||c.charCodeAt(c.length-2)!==w){if(c.length>2){const k=c.lastIndexOf(h);k===-1?(c="",l=0):(c=c.slice(0,k),l=c.length-1-c.lastIndexOf(h)),E=p,C=0;continue}else if(c.length!==0){c="",l=0,E=p,C=0;continue}}r&&(c+=c.length>0?`${h}..`:"..",l=2)}else c.length>0?c+=`${h}${t.slice(E+1,p)}`:c=t.slice(E+1,p),l=p-E-1;E=p,C=0}else f===w&&C!==-1?++C:C=-1}return c}function s(t,r){v(r,"pathObject");const h=r.dir||r.root,u=r.base||`${r.name||""}${r.ext||""}`;return h?h===r.root?`${h}${u}`:`${h}${t}${u}`:u}e.$ec={resolve(...t){let r="",h="",u=!1;for(let c=t.length-1;c>=-1;c--){let l;if(c>=0){if(l=t[c],S(l,"path"),l.length===0)continue}else r.length===0?l=D.cwd():(l=D.env[`=${r}`]||D.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==r.toLowerCase()&&l.charCodeAt(2)===y)&&(l=`${r}\\`));const E=l.length;let C=0,f="",p=!1;const k=l.charCodeAt(0);if(E===1)d(k)&&(C=1,p=!0);else if(d(k))if(p=!0,d(l.charCodeAt(1))){let I=2,j=I;for(;I<E&&!d(l.charCodeAt(I));)I++;if(I<E&&I!==j){const z=l.slice(j,I);for(j=I;I<E&&d(l.charCodeAt(I));)I++;if(I<E&&I!==j){for(j=I;I<E&&!d(l.charCodeAt(I));)I++;(I===E||I!==j)&&(f=`\\\\${z}\\${l.slice(j,I)}`,C=I)}}}else C=1;else i(k)&&l.charCodeAt(1)===L&&(f=l.slice(0,2),C=2,E>2&&d(l.charCodeAt(2))&&(p=!0,C=3));if(f.length>0)if(r.length>0){if(f.toLowerCase()!==r.toLowerCase())continue}else r=f;if(u){if(r.length>0)break}else if(h=`${l.slice(C)}\\${h}`,u=p,p&&r.length>0)break}return h=n(h,!u,"\\",d),u?`${r}\\${h}`:`${r}${h}`||"."},normalize(t){S(t,"path");const r=t.length;if(r===0)return".";let h=0,u,c=!1;const l=t.charCodeAt(0);if(r===1)return o(l)?"\\":t;if(d(l))if(c=!0,d(t.charCodeAt(1))){let C=2,f=C;for(;C<r&&!d(t.charCodeAt(C));)C++;if(C<r&&C!==f){const p=t.slice(f,C);for(f=C;C<r&&d(t.charCodeAt(C));)C++;if(C<r&&C!==f){for(f=C;C<r&&!d(t.charCodeAt(C));)C++;if(C===r)return`\\\\${p}\\${t.slice(f)}\\`;C!==f&&(u=`\\\\${p}\\${t.slice(f,C)}`,h=C)}}}else h=1;else i(l)&&t.charCodeAt(1)===L&&(u=t.slice(0,2),h=2,r>2&&d(t.charCodeAt(2))&&(c=!0,h=3));let E=h<r?n(t.slice(h),!c,"\\",d):"";return E.length===0&&!c&&(E="."),E.length>0&&d(t.charCodeAt(r-1))&&(E+="\\"),u===void 0?c?`\\${E}`:E:c?`${u}\\${E}`:`${u}${E}`},isAbsolute(t){S(t,"path");const r=t.length;if(r===0)return!1;const h=t.charCodeAt(0);return d(h)||r>2&&i(h)&&t.charCodeAt(1)===L&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,h;for(let l=0;l<t.length;++l){const E=t[l];S(E,"path"),E.length>0&&(r===void 0?r=h=E:r+=`\\${E}`)}if(r===void 0)return".";let u=!0,c=0;if(typeof h=="string"&&d(h.charCodeAt(0))){++c;const l=h.length;l>1&&d(h.charCodeAt(1))&&(++c,l>2&&(d(h.charCodeAt(2))?++c:u=!1))}if(u){for(;c<r.length&&d(r.charCodeAt(c));)c++;c>=2&&(r=`\\${r.slice(c)}`)}return e.$ec.normalize(r)},relative(t,r){if(S(t,"from"),S(r,"to"),t===r)return"";const h=e.$ec.resolve(t),u=e.$ec.resolve(r);if(h===u||(t=h.toLowerCase(),r=u.toLowerCase(),t===r))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===y;)c++;let l=t.length;for(;l-1>c&&t.charCodeAt(l-1)===y;)l--;const E=l-c;let C=0;for(;C<r.length&&r.charCodeAt(C)===y;)C++;let f=r.length;for(;f-1>C&&r.charCodeAt(f-1)===y;)f--;const p=f-C,k=E<p?E:p;let I=-1,j=0;for(;j<k;j++){const M=t.charCodeAt(c+j);if(M!==r.charCodeAt(C+j))break;M===y&&(I=j)}if(j!==k){if(I===-1)return u}else{if(p>k){if(r.charCodeAt(C+j)===y)return u.slice(C+j+1);if(j===2)return u.slice(C+j)}E>k&&(t.charCodeAt(c+j)===y?I=j:j===2&&(I=3)),I===-1&&(I=0)}let z="";for(j=c+I+1;j<=l;++j)(j===l||t.charCodeAt(j)===y)&&(z+=z.length===0?"..":"\\..");return C+=I,z.length>0?`${z}${u.slice(C,f)}`:(u.charCodeAt(C)===y&&++C,u.slice(C,f))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$ec.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===y){if(r.charCodeAt(1)===y){const h=r.charCodeAt(2);if(h!==P&&h!==w)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(i(r.charCodeAt(0))&&r.charCodeAt(1)===L&&r.charCodeAt(2)===y)return`\\\\?\\${r}`;return t},dirname(t){S(t,"path");const r=t.length;if(r===0)return".";let h=-1,u=0;const c=t.charCodeAt(0);if(r===1)return d(c)?t:".";if(d(c)){if(h=u=1,d(t.charCodeAt(1))){let C=2,f=C;for(;C<r&&!d(t.charCodeAt(C));)C++;if(C<r&&C!==f){for(f=C;C<r&&d(t.charCodeAt(C));)C++;if(C<r&&C!==f){for(f=C;C<r&&!d(t.charCodeAt(C));)C++;if(C===r)return t;C!==f&&(h=u=C+1)}}}}else i(c)&&t.charCodeAt(1)===L&&(h=r>2&&d(t.charCodeAt(2))?3:2,u=h);let l=-1,E=!0;for(let C=r-1;C>=u;--C)if(d(t.charCodeAt(C))){if(!E){l=C;break}}else E=!1;if(l===-1){if(h===-1)return".";l=h}return t.slice(0,l)},basename(t,r){r!==void 0&&S(r,"ext"),S(t,"path");let h=0,u=-1,c=!0,l;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(h=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let E=r.length-1,C=-1;for(l=t.length-1;l>=h;--l){const f=t.charCodeAt(l);if(d(f)){if(!c){h=l+1;break}}else C===-1&&(c=!1,C=l+1),E>=0&&(f===r.charCodeAt(E)?--E===-1&&(u=l):(E=-1,u=C))}return h===u?u=C:u===-1&&(u=t.length),t.slice(h,u)}for(l=t.length-1;l>=h;--l)if(d(t.charCodeAt(l))){if(!c){h=l+1;break}}else u===-1&&(c=!1,u=l+1);return u===-1?"":t.slice(h,u)},extname(t){S(t,"path");let r=0,h=-1,u=0,c=-1,l=!0,E=0;t.length>=2&&t.charCodeAt(1)===L&&i(t.charCodeAt(0))&&(r=u=2);for(let C=t.length-1;C>=r;--C){const f=t.charCodeAt(C);if(d(f)){if(!l){u=C+1;break}continue}c===-1&&(l=!1,c=C+1),f===w?h===-1?h=C:E!==1&&(E=1):h!==-1&&(E=-1)}return h===-1||c===-1||E===0||E===1&&h===c-1&&h===u+1?"":t.slice(h,c)},format:s.bind(null,"\\"),parse(t){S(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const h=t.length;let u=0,c=t.charCodeAt(0);if(h===1)return d(c)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(d(c)){if(u=1,d(t.charCodeAt(1))){let I=2,j=I;for(;I<h&&!d(t.charCodeAt(I));)I++;if(I<h&&I!==j){for(j=I;I<h&&d(t.charCodeAt(I));)I++;if(I<h&&I!==j){for(j=I;I<h&&!d(t.charCodeAt(I));)I++;I===h?u=I:I!==j&&(u=I+1)}}}}else if(i(c)&&t.charCodeAt(1)===L){if(h<=2)return r.root=r.dir=t,r;if(u=2,d(t.charCodeAt(2))){if(h===3)return r.root=r.dir=t,r;u=3}}u>0&&(r.root=t.slice(0,u));let l=-1,E=u,C=-1,f=!0,p=t.length-1,k=0;for(;p>=u;--p){if(c=t.charCodeAt(p),d(c)){if(!f){E=p+1;break}continue}C===-1&&(f=!1,C=p+1),c===w?l===-1?l=p:k!==1&&(k=1):l!==-1&&(k=-1)}return C!==-1&&(l===-1||k===0||k===1&&l===C-1&&l===E+1?r.base=r.name=t.slice(E,C):(r.name=t.slice(E,l),r.base=t.slice(E,C),r.ext=t.slice(l,C))),E>0&&E!==u?r.dir=t.slice(0,E-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(g){const t=/\\/g;return()=>{const r=D.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>D.cwd()})();e.$fc={resolve(...t){let r="",h=!1;for(let u=t.length-1;u>=-1&&!h;u--){const c=u>=0?t[u]:a();S(c,"path"),c.length!==0&&(r=`${c}/${r}`,h=c.charCodeAt(0)===b)}return r=n(r,!h,"/",o),h?`/${r}`:r.length>0?r:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===b,h=t.charCodeAt(t.length-1)===b;return t=n(t,!r,"/",o),t.length===0?r?"/":h?"./":".":(h&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let r;for(let h=0;h<t.length;++h){const u=t[h];S(u,"path"),u.length>0&&(r===void 0?r=u:r+=`/${u}`)}return r===void 0?".":e.$fc.normalize(r)},relative(t,r){if(S(t,"from"),S(r,"to"),t===r||(t=e.$fc.resolve(t),r=e.$fc.resolve(r),t===r))return"";const h=1,u=t.length,c=u-h,l=1,E=r.length-l,C=c<E?c:E;let f=-1,p=0;for(;p<C;p++){const I=t.charCodeAt(h+p);if(I!==r.charCodeAt(l+p))break;I===b&&(f=p)}if(p===C)if(E>C){if(r.charCodeAt(l+p)===b)return r.slice(l+p+1);if(p===0)return r.slice(l+p)}else c>C&&(t.charCodeAt(h+p)===b?f=p:p===0&&(f=0));let k="";for(p=h+f+1;p<=u;++p)(p===u||t.charCodeAt(p)===b)&&(k+=k.length===0?"..":"/..");return`${k}${r.slice(l+f)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===b;let h=-1,u=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===b){if(!u){h=c;break}}else u=!1;return h===-1?r?"/":".":r&&h===1?"//":t.slice(0,h)},basename(t,r){r!==void 0&&S(r,"ext"),S(t,"path");let h=0,u=-1,c=!0,l;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let E=r.length-1,C=-1;for(l=t.length-1;l>=0;--l){const f=t.charCodeAt(l);if(f===b){if(!c){h=l+1;break}}else C===-1&&(c=!1,C=l+1),E>=0&&(f===r.charCodeAt(E)?--E===-1&&(u=l):(E=-1,u=C))}return h===u?u=C:u===-1&&(u=t.length),t.slice(h,u)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===b){if(!c){h=l+1;break}}else u===-1&&(c=!1,u=l+1);return u===-1?"":t.slice(h,u)},extname(t){S(t,"path");let r=-1,h=0,u=-1,c=!0,l=0;for(let E=t.length-1;E>=0;--E){const C=t.charCodeAt(E);if(C===b){if(!c){h=E+1;break}continue}u===-1&&(c=!1,u=E+1),C===w?r===-1?r=E:l!==1&&(l=1):r!==-1&&(l=-1)}return r===-1||u===-1||l===0||l===1&&r===u-1&&r===h+1?"":t.slice(r,u)},format:s.bind(null,"/"),parse(t){S(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const h=t.charCodeAt(0)===b;let u;h?(r.root="/",u=1):u=0;let c=-1,l=0,E=-1,C=!0,f=t.length-1,p=0;for(;f>=u;--f){const k=t.charCodeAt(f);if(k===b){if(!C){l=f+1;break}continue}E===-1&&(C=!1,E=f+1),k===w?c===-1?c=f:p!==1&&(p=1):c!==-1&&(p=-1)}if(E!==-1){const k=l===0&&h?1:l;c===-1||p===0||p===1&&c===E-1&&c===l+1?r.base=r.name=t.slice(k,E):(r.name=t.slice(k,c),r.base=t.slice(k,E),r.ext=t.slice(c,E))}return l>0?r.dir=t.slice(0,l-1):h&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=g?e.$ec.normalize:e.$fc.normalize,e.$hc=g?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=g?e.$ec.join:e.$fc.join,e.$jc=g?e.$ec.resolve:e.$fc.resolve,e.$kc=g?e.$ec.relative:e.$fc.relative,e.$lc=g?e.$ec.dirname:e.$fc.dirname,e.$mc=g?e.$ec.basename:e.$fc.basename,e.$nc=g?e.$ec.extname:e.$fc.extname,e.$oc=g?e.$ec.format:e.$fc.format,e.$pc=g?e.$ec.parse:e.$fc.parse,e.$qc=g?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=g?e.$ec.sep:e.$fc.sep,e.$sc=g?e.$ec.delimiter:e.$fc.delimiter}),define(ke[129],Se([1,0,43,16]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=void 0;const m=new D.$U(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),A=new D.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new D.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function w(C,f,p=!1){const k=C||"",I=f||"",j=m.value.collator.compare(k,I);return m.value.collatorIsNumeric&&j===0&&k!==I?k<I?-1:1:j}e.$rq=w;function b(C,f){const p=A.value.collator;return C=C||"",f=f||"",s(p,C,f)}e.$sq=b;function y(C,f){const p=A.value.collator;return C=C||"",f=f||"",h(C,f)||s(p,C,f)}e.$tq=y;function L(C,f){const p=A.value.collator;return C=C||"",f=f||"",r(C,f)||s(p,C,f)}e.$uq=L;function P(C,f){return C=C||"",f=f||"",C===f?0:C<f?-1:1}e.$vq=P;function $(C,f){const[p,k]=i(C),[I,j]=i(f);let z=m.value.collator.compare(k,j);if(z===0){if(m.value.collatorIsNumeric&&k!==j)return k<j?-1:1;if(z=m.value.collator.compare(p,I),m.value.collatorIsNumeric&&z===0&&p!==I)return p<I?-1:1}return z}e.$wq=$;function v(C,f){C=C||"",f=f||"";const p=n(C),k=n(f),I=A.value.collator,j=R.value.collator;return s(j,p,k)||s(I,C,f)}e.$xq=v;function S(C,f){C=C||"",f=f||"";const p=n(C),k=n(f),I=A.value.collator,j=R.value.collator;return s(j,p,k)||h(C,f)||s(I,C,f)}e.$yq=S;function g(C,f){C=C||"",f=f||"";const p=n(C),k=n(f),I=A.value.collator,j=R.value.collator;return s(j,p,k)||r(C,f)||s(I,C,f)}e.$zq=g;function d(C,f){C=C||"",f=f||"";const p=n(C).toLowerCase(),k=n(f).toLowerCase();return p!==k?p<k?-1:1:C!==f?C<f?-1:1:0}e.$Aq=d;const o=/^(.*?)(\.([^.]*))?$/;function i(C,f=!1){const p=C?o.exec(C):[];let k=[p&&p[1]||"",p&&p[3]||""];return f&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function n(C){const f=C?o.exec(C):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function s(C,f,p){const k=C.compare(f,p);return k!==0?k:f.length!==p.length?f.length<p.length?-1:1:0}function a(C){const f=C.charAt(0);return f.toLocaleUpperCase()!==f}function t(C){const f=C.charAt(0);return f.toLocaleLowerCase()!==f}function r(C,f){return a(C)&&t(f)?-1:t(C)&&a(f)?1:0}function h(C,f){return t(C)&&a(f)?-1:a(C)&&t(f)?1:0}function u(C,f,p=!1){return p||(C=C&&C.toLowerCase(),f=f&&f.toLowerCase()),C===f?0:C<f?-1:1}function c(C,f,p=!1){const k=C.split(T.sep),I=f.split(T.sep),j=k.length-1,z=I.length-1;let M,F;for(let N=0;;N++){if(M=j===N,F=z===N,M&&F)return w(k[N],I[N],p);if(M)return-1;if(F)return 1;const O=u(k[N],I[N],p);if(O!==0)return O}}e.$Bq=c;function l(C,f,p){const k=C.toLowerCase(),I=f.toLowerCase(),j=E(C,f,p);if(j)return j;const z=k.endsWith(p),M=I.endsWith(p);if(z!==M)return z?-1:1;const F=w(k,I);return F!==0?F:k.localeCompare(I)}e.$Cq=l;function E(C,f,p){const k=C.toLowerCase(),I=f.toLowerCase(),j=k.startsWith(p),z=I.startsWith(p);if(j!==z)return j?-1:1;if(j&&z){if(k.length<I.length)return-1;if(k.length>I.length)return 1}return 0}e.$Dq=E}),define(ke[33],Se([1,0,16,11,13,18]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function R(l){return l===47||l===92}e.$Uf=R;function w(l){return l.replace(/[\\/]/g,D.$fc.sep)}e.$Vf=w;function b(l){return l.indexOf("/")===-1&&(l=w(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$Wf=b;function y(l,E=D.$fc.sep){if(!l)return"";const C=l.length,f=l.charCodeAt(0);if(R(f)){if(R(l.charCodeAt(1))&&!R(l.charCodeAt(2))){let k=3;const I=k;for(;k<C&&!R(l.charCodeAt(k));k++);if(I!==k&&!R(l.charCodeAt(k+1))){for(k+=1;k<C;k++)if(R(l.charCodeAt(k)))return l.slice(0,k+1).replace(/[\\/]/g,E)}}return E}else if(o(f)&&l.charCodeAt(1)===58)return R(l.charCodeAt(2))?l.slice(0,2)+E:l.slice(0,2);let p=l.indexOf("://");if(p!==-1){for(p+=3;p<C;p++)if(R(l.charCodeAt(p)))return l.slice(0,p+1)}return""}e.$Xf=y;function L(l){if(!T.$i||!l||l.length<5)return!1;let E=l.charCodeAt(0);if(E!==92||(E=l.charCodeAt(1),E!==92))return!1;let C=2;const f=C;for(;C<l.length&&(E=l.charCodeAt(C),E!==92);C++);return!(f===C||(E=l.charCodeAt(C+1),isNaN(E)||E===92))}e.$Yf=L;const P=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(l,E=T.$i){const C=E?P:$;return!(!l||l.length===0||/^\s+$/.test(l)||(C.lastIndex=0,C.test(l))||E&&v.test(l)||l==="."||l===".."||E&&l[l.length-1]==="."||E&&l.length!==l.trim().length||l.length>255)}e.$Zf=S;function g(l,E,C){const f=l===E;return!C||f?f:!l||!E?!1:(0,m.$6e)(l,E)}e.$1f=g;function d(l,E,C,f=D.sep){if(l===E)return!0;if(!l||!E||E.length>l.length)return!1;if(C){if(!(0,m.$7e)(l,E))return!1;if(E.length===l.length)return!0;let k=E.length;return E.charAt(E.length-1)===f&&k--,l.charAt(k)===f}return E.charAt(E.length-1)!==f&&(E+=f),l.indexOf(E)===0}e.$2f=d;function o(l){return l>=65&&l<=90||l>=97&&l<=122}e.$3f=o;function i(l,E){return T.$i&&l.endsWith(":")&&(l+=D.sep),(0,D.$hc)(l)||(l=(0,D.$ic)(E,l)),l=(0,D.$gc)(l),T.$i?(l=(0,m.$Oe)(l,D.sep),l.endsWith(":")&&(l+=D.sep)):(l=(0,m.$Oe)(l,D.sep),l||(l=D.sep)),l}e.$4f=i;function n(l){const E=(0,D.$gc)(l);return T.$i?l.length>3?!1:s(E)&&(l.length===2||E.charCodeAt(2)===92):E===D.$fc.sep}e.$5f=n;function s(l,E=T.$i){return E?o(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$6f=s;function a(l,E=T.$i){return s(l,E)?l[0]:void 0}e.$7f=a;function t(l,E,C){return E.length>l.length?-1:l===E?0:(C&&(l=l.toLowerCase(),E=E.toLowerCase()),l.indexOf(E))}e.$8f=t;function r(l){const E=l.split(":");let C,f,p;for(const k of E){const I=Number(k);(0,A.$Gf)(I)?f===void 0?f=I:p===void 0&&(p=I):C=C?[C,k].join(":"):k}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:f!==void 0?f:void 0,column:p!==void 0?p:f!==void 0?1:void 0}}e.$9f=r;const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(l,E,C=8){let f="";for(let k=0;k<C;k++){let I;k===0&&T.$i&&!E&&(C===3||C===4)?I=u:I=h,f+=I.charAt(Math.floor(Math.random()*I.length))}let p;return E?p=`${E}-${f}`:p=f,l?(0,D.$ic)(l,p):p}e.$0f=c}),define(ke[130],Se([1,0,129,124,52,16,11,13]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=e.$Hq=e.$Gq=e.$Fq=e.$Eq=void 0;const b=0,y=[b,[]];function L(W,x,ue,X){if(!W||!x)return y;const J=W.length,Q=x.length;if(J<Q)return y;const he=W.toLowerCase();return P(x,ue,Q,W,he,J,X)}e.$Eq=L;function P(W,x,ue,X,J,Q,he){const Z=[],ye=[];for(let ne=0;ne<ue;ne++){const Ee=ne*Q,fe=Ee-Q,me=ne>0,ee=W[ne],te=x[ne];for(let K=0;K<Q;K++){const ie=K>0,G=Ee+K,ae=G-1,$e=fe+K-1,Ce=ie?Z[ae]:0,B=me&&ie?Z[$e]:0,Y=me&&ie?ye[$e]:0;let se;!B&&me?se=0:se=$(ee,te,X,J,K,Y),se&&B+se>=Ce&&(he||me||J.startsWith(x,K))?(ye[G]=Y+1,Z[G]=B+se):(ye[G]=b,Z[G]=Ce)}}const de=[];let H=ue-1,U=Q-1;for(;H>=0&&U>=0;){const ne=H*Q+U;ye[ne]===b||(de.push(U),H--),U--}return[Z[ue*Q-1],de.reverse()]}function $(W,x,ue,X,J,Q){let he=0;if(!v(x,X[J]))return he;if(he+=1,Q>0&&(he+=Q*5),W===ue[J]&&(he+=1),J===0)he+=8;else{const Z=S(ue.charCodeAt(J-1));Z?he+=Z:(0,T.$Qj)(ue.charCodeAt(J))&&Q===0&&(he+=2)}return he}function v(W,x){return W===x?!0:W==="/"||W==="\\"?x==="/"||x==="\\":!1}function S(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const g=[void 0,[]];function d(W,x,ue=0,X=0){const J=x;return J.values&&J.values.length>1?o(W,J.values,ue,X):i(W,x,ue,X)}e.$Fq=d;function o(W,x,ue,X){let J=0;const Q=[];for(const he of x){const[Z,ye]=i(W,he,ue,X);if(typeof Z!="number")return g;J+=Z,Q.push(...ye)}return[J,C(Q)]}function i(W,x,ue,X){const J=(0,T.$Zj)(x.original,x.originalLowercase,ue,W,W.toLowerCase(),X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,T.$Wj)(J)]:g}const n=Object.freeze({score:0}),s=1<<18,a=1<<17,t=1<<16;function r(W,x,ue,X){const J=X.values?X.values:[X];return(0,m.$Ni)({[X.normalized]:{values:J.map(he=>({value:he.normalized,expectContiguousMatch:he.expectContiguousMatch})),label:W,description:x,allowNonContiguousMatches:ue}})}function h(W,x,ue,X,J){if(!W||!x.normalized)return n;const Q=X.getItemLabel(W);if(!Q)return n;const he=X.getItemDescription(W),Z=r(Q,he,ue,x),ye=J[Z];if(ye)return ye;const de=u(Q,he,X.getItemPath(W),x,ue);return J[Z]=de,de}e.$Gq=h;function u(W,x,ue,X,J){const Q=!ue||!X.containsPathSeparator;return ue&&(R.$k?X.pathNormalized===ue:(0,w.$6e)(X.pathNormalized,ue))?{score:s,labelMatch:[{start:0,end:W.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:X.values&&X.values.length>1?c(W,x,ue,X.values,Q,J):l(W,x,ue,X,Q,J)}function c(W,x,ue,X,J,Q){let he=0;const Z=[],ye=[];for(const de of X){const{score:H,labelMatch:U,descriptionMatch:ne}=l(W,x,ue,de,J,Q);if(H===b)return n;he+=H,U&&Z.push(...U),ne&&ye.push(...ne)}return{score:he,labelMatch:C(Z),descriptionMatch:C(ye)}}function l(W,x,ue,X,J,Q){if(J||!x){const[he,Z]=L(W,X.normalized,X.normalizedLowercase,Q&&!X.expectContiguousMatch);if(he){const ye=(0,T.$Nj)(X.normalized,W);let de;if(ye){de=a;const H=Math.round(X.normalized.length/W.length*100);de+=H}else de=t;return{score:de+he,labelMatch:ye||E(Z)}}}if(x){let he=x;ue&&(he=`${x}${A.sep}`);const Z=he.length,ye=`${he}${W}`,[de,H]=L(ye,X.normalized,X.normalizedLowercase,Q&&!X.expectContiguousMatch);if(de){const U=E(H),ne=[],Ee=[];return U.forEach(fe=>{fe.start<Z&&fe.end>Z?(ne.push({start:0,end:fe.end-Z}),Ee.push({start:fe.start,end:Z})):fe.start>=Z?ne.push({start:fe.start-Z,end:fe.end-Z}):Ee.push(fe)}),{score:de,labelMatch:ne,descriptionMatch:Ee}}}return n}function E(W){const x=[];if(!W)return x;let ue;for(const X of W)ue&&ue.end===X?ue.end+=1:(ue={start:X,end:X+1},x.push(ue));return x}function C(W){const x=W.sort((J,Q)=>J.start-Q.start),ue=[];let X;for(const J of x)!X||!f(X,J)?(X=J,ue.push(J)):(X.start=Math.min(X.start,J.start),X.end=Math.max(X.end,J.end));return ue}function f(W,x){return!(W.end<x.start||x.end<W.start)}function p(W,x,ue,X,J,Q){const he=h(W,ue,X,J,Q),Z=h(x,ue,X,J,Q),ye=he.score,de=Z.score;if((ye===s||de===s)&&ye!==de)return ye===s?-1:1;if(ye>t||de>t){if(ye!==de)return ye>de?-1:1;if(ye<a&&de<a){const ee=I(he.labelMatch,Z.labelMatch);if(ee!==0)return ee}const fe=J.getItemLabel(W)||"",me=J.getItemLabel(x)||"";if(fe.length!==me.length)return fe.length-me.length}if(ye!==de)return ye>de?-1:1;const H=Array.isArray(he.labelMatch)&&he.labelMatch.length>0,U=Array.isArray(Z.labelMatch)&&Z.labelMatch.length>0;if(H&&!U)return-1;if(U&&!H)return 1;const ne=k(W,he,J),Ee=k(x,Z,J);return ne&&Ee&&ne!==Ee?Ee>ne?-1:1:j(W,x,ue,J)}e.$Hq=p;function k(W,x,ue){let X=-1,J=-1;if(x.descriptionMatch&&x.descriptionMatch.length?X=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(X=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(J=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const Q=ue.getItemDescription(W);Q&&(J+=Q.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(J=x.descriptionMatch[x.descriptionMatch.length-1].end);return J-X}function I(W,x){if(!W&&!x||(!W||!W.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!W||!W.length)return 1;const ue=W[0].start,J=W[W.length-1].end-ue,Q=x[0].start,Z=x[x.length-1].end-Q;return J===Z?0:Z<J?1:-1}function j(W,x,ue,X){const J=X.getItemLabel(W)||"",Q=X.getItemLabel(x)||"",he=X.getItemDescription(W),Z=X.getItemDescription(x),ye=J.length+(he?he.length:0),de=Q.length+(Z?Z.length:0);if(ye!==de)return ye-de;const H=X.getItemPath(W),U=X.getItemPath(x);return H&&U&&H.length!==U.length?H.length-U.length:J!==Q?(0,D.$Cq)(J,Q,ue.normalized):he&&Z&&he!==Z?(0,D.$Cq)(he,Z,ue.normalized):H&&U&&H!==U?(0,D.$Cq)(H,U,ue.normalized):0}function z(W){return W.startsWith('"')&&W.endsWith('"')}const M=" ";function F(W){typeof W!="string"&&(W="");const x=W.toLowerCase(),{pathNormalized:ue,normalized:X,normalizedLowercase:J}=N(W),Q=ue.indexOf(A.sep)>=0,he=z(W);let Z;const ye=W.split(M);if(ye.length>1)for(const de of ye){const H=z(de),{pathNormalized:U,normalized:ne,normalizedLowercase:Ee}=N(de);ne&&(Z||(Z=[]),Z.push({original:de,originalLowercase:de.toLowerCase(),pathNormalized:U,normalized:ne,normalizedLowercase:Ee,expectContiguousMatch:H}))}return{original:W,originalLowercase:x,pathNormalized:ue,normalized:X,normalizedLowercase:J,values:Z,containsPathSeparator:Q,expectContiguousMatch:he}}e.$Iq=F;function N(W){let x;R.$i?x=W.replace(/\//g,A.sep):x=W.replace(/\\/g,A.sep);const ue=(0,w.$Qe)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:ue,normalizedLowercase:ue.toLowerCase()}}function O(W){return Array.isArray(W)?F(W.map(x=>x.original).join(M)):F(W.original)}e.$Jq=O}),define(ke[100],Se([1,0,16]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=e.$2r=e.$1r=e.$Zr=void 0,e.$Zr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},m={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(L){const P=(0,D.$nc)(L),$=T[P.toLowerCase()];return $!==void 0?$:R(L)}e.$1r=A;function R(L){const P=(0,D.$nc)(L);return m[P.toLowerCase()]}e.$2r=R;function w(L){for(const P in m)if(m[P]===L)return P}e.$3r=w;const b=/^(.+)\/(.+?)(;.+)?$/;function y(L,P){const $=b.exec(L);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:P?void 0:L}e.$4r=y}),define(ke[101],Se([1,0,11]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.TerminateResponseCode=e.Source=void 0;var T;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(T||(e.Source=T={}));var m;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(m||(e.TerminateResponseCode=m={}));function A(w,...b){const y=b.reduce(($,v)=>($[v]=!0,$),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter($=>!y[$]).forEach($=>{for(let v=0;v<L.length;v++)if($.search(L[v])!==-1){delete w[$];break}})}e.$Jl=A;function R(w){w&&(delete w.DEBUG,D.$j&&delete w.DYLD_LIBRARY_PATH,D.$k&&delete w.LD_PRELOAD)}e.$Kl=R}),define(ke[2],Se([1,0,16,11]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const m=/^\w[\w\d+.-]*$/,A=/^\//,R=/^\/\//;function w(u,c){if(!u.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!m.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!A.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(u,c){return!u&&!c?"file":u}function y(u,c){switch(u){case"https":case"http":case"file":c?c[0]!==P&&(c=P+c):c=P;break}return c}const L="",P="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(c){return c instanceof v?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,l,E,C,f,p=!1){typeof c=="object"?(this.scheme=c.scheme||L,this.authority=c.authority||L,this.path=c.path||L,this.query=c.query||L,this.fragment=c.fragment||L):(this.scheme=b(c,p),this.authority=l||L,this.path=y(this.scheme,E||L),this.query=C||L,this.fragment=f||L,w(this,p))}get fsPath(){return s(this,!1)}with(c){if(!c)return this;let{scheme:l,authority:E,path:C,query:f,fragment:p}=c;return l===void 0?l=this.scheme:l===null&&(l=L),E===void 0?E=this.authority:E===null&&(E=L),C===void 0?C=this.path:C===null&&(C=L),f===void 0?f=this.query:f===null&&(f=L),p===void 0?p=this.fragment:p===null&&(p=L),l===this.scheme&&E===this.authority&&C===this.path&&f===this.query&&p===this.fragment?this:new d(l,E,C,f,p)}static parse(c,l=!1){const E=$.exec(c);return E?new d(E[2]||L,h(E[4]||L),h(E[5]||L),h(E[7]||L),h(E[9]||L),l):new d(L,L,L,L,L)}static file(c){let l=L;if(T.$i&&(c=c.replace(/\\/g,P)),c[0]===P&&c[1]===P){const E=c.indexOf(P,2);E===-1?(l=c.substring(2),c=P):(l=c.substring(2,E),c=c.substring(E)||P)}return new d("file",l,c,L,L)}static from(c,l){return new d(c.scheme,c.authority,c.path,c.query,c.fragment,l)}static joinPath(c,...l){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return T.$i&&c.scheme==="file"?E=v.file(D.$ec.join(s(c,!0),...l)).path:E=D.$fc.join(c.path,...l),c.with({path:E})}toString(c=!1){return a(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof v)return c;{const l=new d(c);return l._formatted=c.external??null,l._fsPath=c._sep===g?c.fsPath??null:null,l}}else return c}}e.URI=v;function S(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}e.$uc=S;const g=T.$i?1:void 0;class d extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(c=!1){return c?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=g),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(u,c,l){let E,C=-1;for(let f=0;f<u.length;f++){const p=u.charCodeAt(f);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||c&&p===47||l&&p===91||l&&p===93||l&&p===58)C!==-1&&(E+=encodeURIComponent(u.substring(C,f)),C=-1),E!==void 0&&(E+=u.charAt(f));else{E===void 0&&(E=u.substr(0,f));const k=o[p];k!==void 0?(C!==-1&&(E+=encodeURIComponent(u.substring(C,f)),C=-1),E+=k):C===-1&&(C=f)}}return C!==-1&&(E+=encodeURIComponent(u.substring(C))),E!==void 0?E:u}function n(u){let c;for(let l=0;l<u.length;l++){const E=u.charCodeAt(l);E===35||E===63?(c===void 0&&(c=u.substr(0,l)),c+=o[E]):c!==void 0&&(c+=u[l])}return c!==void 0?c:u}function s(u,c){let l;return u.authority&&u.path.length>1&&u.scheme==="file"?l=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?c?l=u.path.substr(1):l=u.path[1].toLowerCase()+u.path.substr(2):l=u.path,T.$i&&(l=l.replace(/\//g,"\\")),l}e.$vc=s;function a(u,c){const l=c?n:i;let E="",{scheme:C,authority:f,path:p,query:k,fragment:I}=u;if(C&&(E+=C,E+=":"),(f||C==="file")&&(E+=P,E+=P),f){let j=f.indexOf("@");if(j!==-1){const z=f.substr(0,j);f=f.substr(j+1),j=z.lastIndexOf(":"),j===-1?E+=l(z,!1,!1):(E+=l(z.substr(0,j),!1,!1),E+=":",E+=l(z.substr(j+1),!1,!0)),E+="@"}f=f.toLowerCase(),j=f.lastIndexOf(":"),j===-1?E+=l(f,!1,!0):(E+=l(f.substr(0,j),!1,!0),E+=f.substr(j))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const j=p.charCodeAt(1);j>=65&&j<=90&&(p=`/${String.fromCharCode(j+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const j=p.charCodeAt(0);j>=65&&j<=90&&(p=`${String.fromCharCode(j+32)}:${p.substr(2)}`)}E+=l(p,!0,!1)}return k&&(E+="?",E+=l(k,!1,!1)),I&&(E+="#",E+=c?I:i(I,!1,!1)),E}function t(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+t(u.substr(3)):u}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(u){return u.match(r)?u.replace(r,c=>t(c)):u}}),define(ke[184],Se([1,0,2]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$0p=e.$9p=e.$8p=void 0;function T(y){const L=y;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.$8p=T;function m(y){const L=[];let P;try{const $=JSON.parse(y.arguments),v=$[$.length-1];v&&v.__$stack&&($.pop(),P=v.__$stack),L.push(...$)}catch{L.push("Unable to log remote console arguments",y.arguments)}return{args:L,stack:P}}e.$9p=m;function A(y){if(typeof y!="string")return A(m(y).stack);const L=y;if(L){const P=R(L),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if($&&$.length===4)return{uri:D.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$0p=A;function R(y){if(!y)return y;const L=y.indexOf(`
`);return L===-1?y:y.substring(0,L)}function w(y,L){const{args:P,stack:$}=m(y),v=typeof P[0]=="string"&&P.length===1;let S=R($);S&&(S=`(${S.trim()})`);let g=[];if(typeof P[0]=="string"?S&&v?g=[`%c[${L}] %c${P[0]} %c${S}`,b("blue"),b(""),b("grey")]:g=[`%c[${L}] %c${P[0]}`,b("blue"),b(""),...P.slice(1)]:g=[`%c[${L}]%`,b("blue"),...P],S&&!v&&g.push(S),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,g)}e.log=w;function b(y){return`color: ${y}`}}),define(ke[54],Se([1,0,22,2]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=void 0;function m(b){return JSON.stringify(b,R)}e.$uh=m;function A(b){let y=JSON.parse(b);return y=w(y),y}e.$vh=A;function R(b,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function w(b,y=0){if(!b||y>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return T.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof D.$fe||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let L=0;L<b.length;++L)b[L]=w(b[L],y+1);else for(const L in b)Object.hasOwnProperty.call(b,L)&&(b[L]=w(b[L],y+1))}return b}e.$wh=w}),define(ke[17],Se([1,0,8,11,13,2]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var R;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function w($,v){return A.URI.isUri($)?(0,m.$6e)($.scheme,v):(0,m.$7e)($,v+":")}e.$$f=w;function b($,...v){return v.some(S=>w($,S))}e.$_f=b,e.$ag="vscode-tkn",e.$bg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v){this.f=`${v}/${R.vscodeRemoteResource}`}set(v,S,g){this.a[v]=S,this.b[v]=g}setConnectionToken(v,S){this.c[v]=S}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(n){return D.$Z(n),v}const S=v.authority;let g=this.a[S];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const d=this.b[S],o=this.c[S];let i=`path=${encodeURIComponent(v.path)}`;return typeof o=="string"&&(i+=`&${e.$bg}=${encodeURIComponent(o)}`),A.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${g}:${d}`,path:this.f,query:i})}}e.$cg=new y,e.$dg="vs/../../extensions",e.$eg="vs/../../node_modules",e.$fg="vs/../../node_modules.asar",e.$gg="vs/../../node_modules.asar.unpacked",e.$hg="vscode-app";class L{static{this.a=e.$hg}asBrowserUri(v){const S=this.b(v,be);return this.uriToBrowserUri(S)}uriToBrowserUri(v){return v.scheme===R.vscodeRemote?e.$cg.rewrite(v):v.scheme===R.file&&(T.$m||T.$q===`${R.vscodeFileResource}://${L.a}`)?v.with({scheme:R.vscodeFileResource,authority:v.authority||L.a,query:null,fragment:null}):v}asFileUri(v){const S=this.b(v,be);return this.uriToFileUri(S)}uriToFileUri(v){return v.scheme===R.vscodeFileResource?v.with({scheme:R.file,authority:v.authority!==L.a?v.authority:null,query:null,fragment:null}):v}b(v,S){return A.URI.isUri(v)?v:A.URI.parse(S.toUrl(v))}}e.$ig=new L;var P;(function($){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(v.get("3"));const S="vscode-coi";function g(o){let i;typeof o=="string"?i=new URL(o).searchParams:o instanceof URL?i=o.searchParams:A.URI.isUri(o)&&(i=new URL(o.toString(!0)).searchParams);const n=i?.get(S);if(n)return v.get(n)}$.getHeadersFromQuery=g;function d(o,i,n){if(!globalThis.crossOriginIsolated)return;const s=i&&n?"3":n?"2":"1";o instanceof URLSearchParams?o.set(S,s):o[S]=s}$.addSearchParam=d})(P||(e.COI=P={}))}),define(ke[185],Se([1,0,158,17,11,2]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SC=void 0;class R{constructor($,v,S){this.id=$,this.dependencies=v,this.callback=S}}class w{static{this.INSTANCE=new w}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,v,S)=>{typeof $!="string"&&(S=v,v=$,$=null),(typeof v!="object"||!Array.isArray(v))&&(S=v,v=null),this.c.push(new R($,v,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const v=await(this.a?this.i($):this.b?this.h($):this.j($));if(!v)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(v.dependencies)&&v.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${v.dependencies.join(", ")}`);return typeof v.callback=="function"?v.callback([]):v.callback}h($){return new Promise((v,S)=>{const g=document.createElement("script");g.setAttribute("async","async"),g.setAttribute("type","text/javascript");const d=()=>{g.removeEventListener("load",o),g.removeEventListener("error",i)},o=n=>{d(),v(this.c.pop())},i=n=>{d(),S(n)};g.addEventListener("load",o),g.addEventListener("error",i),this.f&&($=this.f.createScriptURL($)),g.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(g)})}i($){return new Promise((v,S)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),v(this.c.pop())}catch(g){S(g)}})}async j($){try{const v=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,g=globalThis._VSCODE_NODE_MODULES.module,d=A.URI.parse($).fsPath,o=v.readFileSync(d).toString(),i=g.wrap(o.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(v){throw v}}}const b=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function L(P,$,v){if(D.$S){v===void 0&&(v=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[P]&&(P=y[P]);const S=`${P}/${$}`;if(b.has(S))return b.get(S);let g;if(/^\w[\w\d+.-]*:\/\//.test(S))g=S;else{const n=`${v&&!m.$o?T.$fg:T.$eg}/${S}`;g=T.$ig.asBrowserUri(n).toString(!0)}const d=w.INSTANCE.load(g);return b.set(S,d),d}else return await new Promise((S,g)=>{be([P],S,g)})}e.$SC=L}),define(ke[23],Se([1,0,33,17,16,11,13,2]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lg=e.DataUri=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=void 0;function b(v){return(0,w.$vc)(v,!0)}e.$pg=b;class y{constructor(S){this.a=S}compare(S,g,d=!1){return S===g?0:(0,R.$Ye)(this.getComparisonKey(S,d),this.getComparisonKey(g,d))}isEqual(S,g,d=!1){return S===g?!0:!S||!g?!1:this.getComparisonKey(S,d)===this.getComparisonKey(g,d)}getComparisonKey(S,g=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,g,d=!1){if(S.scheme===g.scheme){if(S.scheme===T.Schemas.file)return D.$2f(b(S),b(g),this.a(S))&&S.query===g.query&&(d||S.fragment===g.fragment);if((0,e.$Gg)(S.authority,g.authority))return D.$2f(S.path,g.path,this.a(S),"/")&&S.query===g.query&&(d||S.fragment===g.fragment)}return!1}joinPath(S,...g){return w.URI.joinPath(S,...g)}basenameOrAuthority(S){return(0,e.$yg)(S)||S.authority}basename(S){return m.$fc.basename(S.path)}extname(S){return m.$fc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let g;return S.scheme===T.Schemas.file?g=w.URI.file(m.$lc(b(S))).path:(g=m.$fc.dirname(S.path),S.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),g="/")),S.with({path:g})}normalizePath(S){if(!S.path.length)return S;let g;return S.scheme===T.Schemas.file?g=w.URI.file(m.$gc(b(S))).path:g=m.$fc.normalize(S.path),S.with({path:g})}relativePath(S,g){if(S.scheme!==g.scheme||!(0,e.$Gg)(S.authority,g.authority))return;if(S.scheme===T.Schemas.file){const i=m.$kc(b(S),b(g));return A.$i?D.$Vf(i):i}let d=S.path||"/";const o=g.path||"/";if(this.a(S)){let i=0;for(const n=Math.min(d.length,o.length);i<n&&!(d.charCodeAt(i)!==o.charCodeAt(i)&&d.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);d=o.substr(0,i)+d.substr(i)}return m.$fc.relative(d,o)}resolvePath(S,g){if(S.scheme===T.Schemas.file){const d=w.URI.file(m.$jc(b(S),g));return S.with({authority:d.authority,path:d.path})}return g=D.$Wf(g),S.with({path:m.$fc.resolve(S.path,g)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,g){return S===g||S!==void 0&&g!==void 0&&(0,R.$6e)(S,g)}hasTrailingPathSeparator(S,g=m.sep){if(S.scheme===T.Schemas.file){const d=b(S);return d.length>D.$Xf(d).length&&d[d.length-1]===g}else{const d=S.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,g=m.sep){return(0,e.$Hg)(S,g)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,g=m.sep){let d=!1;if(S.scheme===T.Schemas.file){const o=b(S);d=o!==void 0&&o.length===D.$Xf(o).length&&o[o.length-1]===g}else{g="/";const o=S.path;d=o.length===1&&o.charCodeAt(o.length-1)===47}return!d&&!(0,e.$Hg)(S,g)?S.with({path:S.path+"/"}):S}}e.$qg=y,e.$rg=new y(()=>!1),e.$sg=new y(v=>v.scheme===T.Schemas.file?!A.$k:!0),e.$tg=new y(v=>!0),e.$ug=e.$rg.isEqual.bind(e.$rg),e.$vg=e.$rg.isEqualOrParent.bind(e.$rg),e.$wg=e.$rg.getComparisonKey.bind(e.$rg),e.$xg=e.$rg.basenameOrAuthority.bind(e.$rg),e.$yg=e.$rg.basename.bind(e.$rg),e.$zg=e.$rg.extname.bind(e.$rg),e.$Ag=e.$rg.dirname.bind(e.$rg),e.$Bg=e.$rg.joinPath.bind(e.$rg),e.$Cg=e.$rg.normalizePath.bind(e.$rg),e.$Dg=e.$rg.relativePath.bind(e.$rg),e.$Eg=e.$rg.resolvePath.bind(e.$rg),e.$Fg=e.$rg.isAbsolutePath.bind(e.$rg),e.$Gg=e.$rg.isEqualAuthority.bind(e.$rg),e.$Hg=e.$rg.hasTrailingPathSeparator.bind(e.$rg),e.$Ig=e.$rg.removeTrailingPathSeparator.bind(e.$rg),e.$Jg=e.$rg.addTrailingPathSeparator.bind(e.$rg);function L(v,S){const g=[];for(let d=0;d<v.length;d++){const o=S(v[d]);v.some((i,n)=>n===d?!1:(0,e.$vg)(o,S(i)))||g.push(v[d])}return g}e.$Kg=L;var P;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function S(g){const d=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(n=>{const[s,a]=n.split(":");s&&a&&d.set(s,a)});const i=g.path.substring(0,g.path.indexOf(";"));return i&&d.set(v.META_DATA_MIME,i),d}v.parseMetaData=S})(P||(e.DataUri=P={}));function $(v,S,g){if(S){let d=v.path;return d&&d[0]!==m.$fc.sep&&(d=m.$fc.sep+d),v.with({scheme:g,authority:S,path:d})}return v.with({scheme:g})}e.$Lg=$}),define(ke[12],Se([1,0,21,8,4,3,23,11,162,43]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.Promises=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=void 0;function L(ee){return!!ee&&typeof ee.then=="function"}e.$Mg=L;function P(ee){const te=new D.$2d,K=ee(te.token),ie=new Promise((G,ae)=>{const $e=te.token.onCancellationRequested(()=>{$e.dispose(),te.dispose(),ae(new T.$4)});Promise.resolve(K).then(Ce=>{$e.dispose(),te.dispose(),G(Ce)},Ce=>{$e.dispose(),te.dispose(),ae(Ce)})});return new class{cancel(){te.cancel()}then(G,ae){return ie.then(G,ae)}catch(G){return this.then(void 0,G)}finally(G){return ie.finally(G)}}}e.$Ng=P;function $(ee,te,K){return new Promise((ie,G)=>{const ae=te.onCancellationRequested(()=>{ae.dispose(),ie(K)});ee.then(ie,G).finally(()=>ae.dispose())})}e.$Og=$;function v(ee,te){return new Promise((K,ie)=>{const G=te.onCancellationRequested(()=>{G.dispose(),ie(new T.$4)});ee.then(K,ie).finally(()=>G.dispose())})}e.$Pg=v;async function S(ee){let te=-1;const K=ee.map((ie,G)=>ie.then(ae=>(te=G,ae)));try{return await Promise.race(K)}finally{ee.forEach((ie,G)=>{G!==te&&ie.cancel()})}}e.$Qg=S;function g(ee,te,K){let ie;const G=setTimeout(()=>{ie?.(void 0),K?.()},te);return Promise.race([ee.finally(()=>clearTimeout(G)),new Promise(ae=>ie=ae)])}e.$Rg=g;function d(ee){return new Promise((te,K)=>{const ie=ee();L(ie)?ie.then(te,K):te(ie)})}e.$Sg=d;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(te){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=te,!this.b){const K=()=>{if(this.b=null,this.f)return;const ie=this.queue(this.d);return this.d=null,ie};this.b=new Promise(ie=>{this.a.then(K,K).then(ie)})}return new Promise((K,ie)=>{this.b.then(K,ie)})}return this.a=te(),new Promise((K,ie)=>{this.a.then(G=>{this.a=null,K(G)},G=>{this.a=null,ie(G)})})}dispose(){this.f=!0}}e.$Tg=o;class i{constructor(){this.a=Promise.resolve(null)}queue(te){return this.a=this.a.then(()=>te(),()=>te())}}e.$Ug=i;class n{constructor(){this.a=new Map}queue(te,K){const G=(this.a.get(te)??Promise.resolve()).catch(()=>{}).then(K).finally(()=>{this.a.get(te)===G&&this.a.delete(te)});return this.a.set(te,G),G}}e.$Vg=n;const s=(ee,te)=>{let K=!0;const ie=setTimeout(()=>{K=!1,te()},ee);return{isTriggered:()=>K,dispose:()=>{clearTimeout(ie),K=!1}}},a=ee=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,ee())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class t{constructor(te){this.defaultDelay=te,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(te,K=this.defaultDelay){this.g=te,this.h(),this.b||(this.b=new Promise((G,ae)=>{this.d=G,this.f=ae}).then(()=>{if(this.b=null,this.d=null,this.g){const G=this.g;return this.g=null,G()}}));const ie=()=>{this.a=null,this.d?.(null)};return this.a=K===b.$Od?a(ie):s(K,ie),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Wg=t;class r{constructor(te){this.a=new t(te),this.b=new o}trigger(te,K){return this.a.trigger(()=>this.b.queue(te),K)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Xg=r;class h{constructor(){this.a=!1,this.b=new Promise((te,K)=>{this.d=te})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Yg=h;class u extends h{constructor(te){super(),this.f=setTimeout(()=>this.open(),te)}open(){clearTimeout(this.f),super.open()}}e.$Zg=u;function c(ee,te){return te?new Promise((K,ie)=>{const G=setTimeout(()=>{ae.dispose(),K()},ee),ae=te.onCancellationRequested(()=>{clearTimeout(G),ae.dispose(),ie(new T.$4)})}):P(K=>c(ee,K))}e.$1g=c;function l(ee,te=0,K){const ie=setTimeout(()=>{ee(),K&&G.dispose()},te),G=(0,A.$Pc)(()=>{clearTimeout(ie),K?.deleteAndLeak(G)});return K?.add(G),G}e.$2g=l;function E(ee){const te=[];let K=0;const ie=ee.length;function G(){return K<ie?ee[K++]():null}function ae($e){$e!=null&&te.push($e);const Ce=G();return Ce?Ce.then(ae):Promise.resolve(te)}return Promise.resolve(null).then(ae)}e.$3g=E;function C(ee,te=ie=>!!ie,K=null){let ie=0;const G=ee.length,ae=()=>{if(ie>=G)return Promise.resolve(K);const $e=ee[ie++];return Promise.resolve($e()).then(B=>te(B)?Promise.resolve(B):ae())};return ae()}e.$4g=C;function f(ee,te=ie=>!!ie,K=null){if(ee.length===0)return Promise.resolve(K);let ie=ee.length;const G=()=>{ie=-1;for(const ae of ee)ae.cancel?.()};return new Promise((ae,$e)=>{for(const Ce of ee)Ce.then(B=>{--ie>=0&&te(B)?(G(),ae(B)):ie===0&&ae(K)}).catch(B=>{--ie>=0&&(G(),$e(B))})})}e.$5g=f;class p{constructor(te){this.a=0,this.d=te,this.f=[],this.b=0,this.g=new m.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(te){return this.a++,new Promise((K,ie)=>{this.f.push({factory:te,c:K,e:ie}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const te=this.f.shift();this.b++;const K=te.factory();K.then(te.c,te.e),K.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$6g=p;class k extends p{constructor(){super(1)}}e.$7g=k;class I{constructor(){this.a=new J,this.b=0}queue(te){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,te())):this.a.run(this.b++,te())}}e.$8g=I;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const te=new Z;return this.b.add(te),te.p}g(){for(const[,te]of this.a)if(te.size>0)return!1;return!0}queueFor(te,K=R.$rg){const ie=K.getComparisonKey(te);let G=this.a.get(ie);if(!G){G=new k;const ae=this.f++,$e=m.Event.once(G.onDrained)(()=>{G?.dispose(),this.a.delete(ie),this.h(),this.d?.deleteAndDispose(ae),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$1c),this.d.set(ae,$e),this.a.set(ie,G)}return G}h(){this.g()&&this.j()}j(){for(const te of this.b)te.complete();this.b.clear()}dispose(){for(const[,te]of this.a)te.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$9g=j;class z{constructor(te,K){this.a=-1,typeof te=="function"&&typeof K=="number"&&this.setIfNotSet(te,K)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(te,K){this.cancel(),this.a=setTimeout(()=>{this.a=-1,te()},K)}setIfNotSet(te,K){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,te()},K))}}e.$0g=z;class M{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(te,K,ie=globalThis){this.cancel();const G=ie.setInterval(()=>{te()},K);this.d=(0,A.$Pc)(()=>{ie.clearInterval(G),this.d=void 0})}dispose(){this.cancel()}}e.$$g=M;class F{constructor(te,K){this.b=-1,this.a=te,this.d=K,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(te=this.d){this.cancel(),this.b=setTimeout(this.f,te)}get delay(){return this.d}set delay(te){this.d=te}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$_g=F;class N{constructor(te,K){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.a=te,this.b=K,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(te=this.b){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(te/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ah=N;class O extends F{constructor(te,K){super(te,K),this.j=[]}work(te){this.j.push(te),this.isScheduled()||this.schedule()}h(){const te=this.j;this.j=[],this.a?.(te)}dispose(){this.j=[],super.dispose()}}e.$bh=O;class W extends A.$Rc{constructor(te,K){super(),this.g=te,this.h=K,this.a=[],this.b=this.B(new A.$Sc),this.f=!1}get pending(){return this.a.length}work(te){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+te.length>this.g.maxBufferedWork)return!1}else if(this.pending+te.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const K of te)this.a.push(K);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ch=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$eh=(ee,te)=>{(0,w.$B)(()=>{if(K)return;const ie=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let K=!1;return{dispose(){K||(K=!0)}}}:e.$eh=(ee,te,K)=>{const ie=ee.requestIdleCallback(te,typeof K=="number"?{timeout:K}:void 0);let G=!1;return{dispose(){G||(G=!0,ee.cancelIdleCallback(ie))}}},e.$dh=ee=>(0,e.$eh)(globalThis,ee)}();class x{constructor(te,K){this.g=!1,this.d=()=>{try{this.j=K()}catch(ie){this.l=ie}finally{this.g=!0}},this.f=(0,e.$eh)(te,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$fh=x;class ue extends x{constructor(te){super(globalThis,te)}}e.$gh=ue;async function X(ee,te,K){let ie;for(let G=0;G<K;G++)try{return await ee()}catch(ae){ie=ae,await c(te)}throw ie}e.$hh=X;class J{isRunning(te){return typeof te=="number"?this.a?.taskId===te:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(te,K,ie){return this.a={taskId:te,cancel:()=>ie?.(),promise:K},K.then(()=>this.d(te),()=>this.d(te)),K}d(te){this.a&&te===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const te=this.b;this.b=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this.b)this.b.run=te;else{let K,ie;const G=new Promise((ae,$e)=>{K=ae,ie=$e});this.b={run:te,promise:G,promiseResolve:K,promiseReject:ie}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ih=J;class Q{constructor(te,K=()=>Date.now()){this.d=te,this.f=K,this.a=0,this.b=0}increment(){const te=this.f();return te-this.a>this.d&&(this.a=te,this.b=0),this.b++,this.b}}e.$jh=Q;var he;(function(ee){ee[ee.Resolved=0]="Resolved",ee[ee.Rejected=1]="Rejected"})(he||(he={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((te,K)=>{this.a=te,this.b=K})}complete(te){return new Promise(K=>{this.a(te),this.d={outcome:0,value:te},K()})}error(te){return new Promise(K=>{this.b(te),this.d={outcome:1,value:te},K()})}cancel(){return this.error(new T.$4)}}e.$kh=Z;var ye;(function(ee){async function te(ie){let G;const ae=await Promise.all(ie.map($e=>$e.then(Ce=>Ce,Ce=>{G||(G=Ce)})));if(typeof G<"u")throw G;return ae}ee.settled=te;function K(ie){return new Promise(async(G,ae)=>{try{await ie(G,ae)}catch($e){ae($e)}})}ee.withAsyncBody=K})(ye||(e.Promises=ye={}));class de{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(te){this.a=void 0,this.b=void 0,this.d=!1,this.promise=te.then(K=>(this.a=K,this.d=!0,K),K=>{throw this.b=K,this.d=!0,K})}requireValue(){if(!this.d)throw new T.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$lh=de;class H{constructor(te){this.b=te,this.a=new y.$U(()=>new de(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$mh=H;var U;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(U||(U={}));class ne{static fromArray(te){return new ne(K=>{K.emitMany(te)})}static fromPromise(te){return new ne(async K=>{K.emitMany(await te)})}static fromPromises(te){return new ne(async K=>{await Promise.all(te.map(async ie=>K.emitOne(await ie)))})}static merge(te){return new ne(async K=>{await Promise.all(te.map(async ie=>{for await(const G of ie)K.emitOne(G)}))})}static{this.EMPTY=ne.fromArray([])}constructor(te){this.a=0,this.b=[],this.d=null,this.f=new m.$Rd,queueMicrotask(async()=>{const K={emitOne:ie=>this.g(ie),emitMany:ie=>this.h(ie),reject:ie=>this.k(ie)};try{await Promise.resolve(te(K)),this.j()}catch(ie){this.k(ie)}finally{K.emitOne=void 0,K.emitMany=void 0,K.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(te<this.b.length)return{done:!1,value:this.b[te++]};if(this.a===1)return{done:!0,value:void 0};await m.Event.toPromise(this.f.event)}while(!0)}}}static map(te,K){return new ne(async ie=>{for await(const G of te)ie.emitOne(K(G))})}map(te){return ne.map(this,te)}static filter(te,K){return new ne(async ie=>{for await(const G of te)K(G)&&ie.emitOne(G)})}filter(te){return ne.filter(this,te)}static coalesce(te){return ne.filter(te,K=>!!K)}coalesce(){return ne.coalesce(this)}static async toPromise(te){const K=[];for await(const ie of te)K.push(ie);return K}toPromise(){return ne.toPromise(this)}g(te){this.a===0&&(this.b.push(te),this.f.fire())}h(te){this.a===0&&(this.b=this.b.concat(te),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(te){this.a===0&&(this.a=2,this.d=te,this.f.fire())}}e.$nh=ne;class Ee extends ne{constructor(te,K){super(K),this.l=te}cancel(){this.l.cancel()}}e.$oh=Ee;function fe(ee){const te=new D.$2d,K=ee(te.token);return new Ee(te,async ie=>{const G=te.token.onCancellationRequested(()=>{G.dispose(),te.dispose(),ie.reject(new T.$4)});try{for await(const ae of K){if(te.token.isCancellationRequested)return;ie.emitOne(ae)}G.dispose(),te.dispose()}catch(ae){G.dispose(),te.dispose(),ie.reject(ae)}})}e.$ph=fe;class me{constructor(){this.a=new Z,this.b=new ne(ie=>{if(te){ie.reject(te);return}return K&&ie.emitMany(K),this.d=G=>ie.reject(G),this.f=G=>ie.emitOne(G),this.a.p});let te,K;this.f=ie=>{K||(K=[]),K.push(ie)},this.d=ie=>{te||(te=ie)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(te){this.d(te),this.a.complete()}emitOne(te){this.f(te)}}e.$qh=me}),define(ke[34],Se([1,0,19,12,33,28,16,11,13]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=void 0;function y(){return Object.create(null)}e.$Bj=y,e.$Cj="**",e.$Dj="/";const L="[/\\\\]",P="[^/\\\\]",$=/\//g;function v(ue,X){switch(ue){case 0:return"";case 1:return`${P}*?`;default:return`(?:${L}|${P}+${L}${X?`|${L}${P}+`:""})*?`}}function S(ue,X){if(!ue)return[];const J=[];let Q=!1,he=!1,Z="";for(const ye of ue){switch(ye){case X:if(!Q&&!he){J.push(Z),Z="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":he=!0;break;case"]":he=!1;break}Z+=ye}return Z&&J.push(Z),J}e.$Ej=S;function g(ue){if(!ue)return"";let X="";const J=S(ue,e.$Dj);if(J.every(Q=>Q===e.$Cj))X=".*";else{let Q=!1;J.forEach((he,Z)=>{if(he===e.$Cj){if(Q)return;X+=v(2,Z===J.length-1)}else{let ye=!1,de="",H=!1,U="";for(const ne of he){if(ne!=="}"&&ye){de+=ne;continue}if(H&&(ne!=="]"||!U)){let Ee;ne==="-"?Ee=ne:(ne==="^"||ne==="!")&&!U?Ee="^":ne===e.$Dj?Ee="":Ee=(0,b.$Je)(ne),U+=Ee;continue}switch(ne){case"{":ye=!0;continue;case"[":H=!0;continue;case"}":{const fe=`(?:${S(de,",").map(me=>g(me)).join("|")})`;X+=fe,ye=!1,de="";break}case"]":{X+="["+U+"]",H=!1,U="";break}case"?":X+=P;continue;case"*":X+=v(1);continue;default:X+=(0,b.$Je)(ne)}}Z<J.length-1&&(J[Z+1]!==e.$Cj||Z+2<J.length)&&(X+=L)}Q=he===e.$Cj})}return X}const d=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Cc(1e4),r=function(){return!1},h=function(){return null};function u(ue,X){if(!ue)return h;let J;typeof ue!="string"?J=ue.pattern:J=ue,J=J.trim();const Q=`${J}_${!!X.trimForExclusions}`;let he=t.get(Q);if(he)return c(he,ue);let Z;return d.test(J)?he=E(J.substr(4),J):(Z=o.exec(l(J,X)))?he=C(Z[1],J):(X.trimForExclusions?n:i).test(J)?he=f(J,X):(Z=s.exec(l(J,X)))?he=p(Z[1].substr(1),J,!0):(Z=a.exec(l(J,X)))?he=p(Z[1],J,!1):he=k(J),t.set(Q,he),c(he,ue)}function c(ue,X){if(typeof X=="string")return ue;const J=function(Q,he){return(0,m.$2f)(Q,X.base,!w.$k)?ue((0,b.$Ne)(Q.substr(X.base.length),R.sep),he):null};return J.allBasenames=ue.allBasenames,J.allPaths=ue.allPaths,J.basenames=ue.basenames,J.patterns=ue.patterns,J}function l(ue,X){return X.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function E(ue,X){return function(J,Q){return typeof J=="string"&&J.endsWith(ue)?X:null}}function C(ue,X){const J=`/${ue}`,Q=`\\${ue}`,he=function(ye,de){return typeof ye!="string"?null:de?de===ue?X:null:ye===ue||ye.endsWith(J)||ye.endsWith(Q)?X:null},Z=[ue];return he.basenames=Z,he.patterns=[X],he.allBasenames=Z,he}function f(ue,X){const J=W(ue.slice(1,-1).split(",").map(de=>u(de,X)).filter(de=>de!==h),ue),Q=J.length;if(!Q)return h;if(Q===1)return J[0];const he=function(de,H){for(let U=0,ne=J.length;U<ne;U++)if(J[U](de,H))return ue;return null},Z=J.find(de=>!!de.allBasenames);Z&&(he.allBasenames=Z.allBasenames);const ye=J.reduce((de,H)=>H.allPaths?de.concat(H.allPaths):de,[]);return ye.length&&(he.allPaths=ye),he}function p(ue,X,J){const Q=R.sep===R.$fc.sep,he=Q?ue:ue.replace($,R.sep),Z=R.sep+he,ye=R.$fc.sep+ue;let de;return J?de=function(H,U){return typeof H=="string"&&(H===he||H.endsWith(Z)||!Q&&(H===ue||H.endsWith(ye)))?X:null}:de=function(H,U){return typeof H=="string"&&(H===he||!Q&&H===ue)?X:null},de.allPaths=[(J?"*/":"./")+ue],de}function k(ue){try{const X=new RegExp(`^${g(ue)}$`);return function(J){return X.lastIndex=0,typeof J=="string"&&X.test(J)?ue:null}}catch{return h}}function I(ue,X,J){return!ue||typeof X!="string"?!1:j(ue)(X,void 0,J)}e.$Fj=I;function j(ue,X={}){if(!ue)return r;if(typeof ue=="string"||z(ue)){const J=u(ue,X);if(J===h)return r;const Q=function(he,Z){return!!J(he,Z)};return J.allBasenames&&(Q.allBasenames=J.allBasenames),J.allPaths&&(Q.allPaths=J.allPaths),Q}return N(ue,X)}e.$Gj=j;function z(ue){const X=ue;return X?typeof X.base=="string"&&typeof X.pattern=="string":!1}e.$Hj=z;function M(ue){return ue.allBasenames||[]}e.$Ij=M;function F(ue){return ue.allPaths||[]}e.$Jj=F;function N(ue,X){const J=W(Object.getOwnPropertyNames(ue).map(de=>O(de,ue[de],X)).filter(de=>de!==h)),Q=J.length;if(!Q)return h;if(!J.some(de=>!!de.requiresSiblings)){if(Q===1)return J[0];const de=function(ne,Ee){let fe;for(let me=0,ee=J.length;me<ee;me++){const te=J[me](ne,Ee);if(typeof te=="string")return te;(0,T.$Mg)(te)&&(fe||(fe=[]),fe.push(te))}return fe?(async()=>{for(const me of fe){const ee=await me;if(typeof ee=="string")return ee}return null})():null},H=J.find(ne=>!!ne.allBasenames);H&&(de.allBasenames=H.allBasenames);const U=J.reduce((ne,Ee)=>Ee.allPaths?ne.concat(Ee.allPaths):ne,[]);return U.length&&(de.allPaths=U),de}const he=function(de,H,U){let ne,Ee;for(let fe=0,me=J.length;fe<me;fe++){const ee=J[fe];ee.requiresSiblings&&U&&(H||(H=(0,R.$mc)(de)),ne||(ne=H.substr(0,H.length-(0,R.$nc)(de).length)));const te=ee(de,H,ne,U);if(typeof te=="string")return te;(0,T.$Mg)(te)&&(Ee||(Ee=[]),Ee.push(te))}return Ee?(async()=>{for(const fe of Ee){const me=await fe;if(typeof me=="string")return me}return null})():null},Z=J.find(de=>!!de.allBasenames);Z&&(he.allBasenames=Z.allBasenames);const ye=J.reduce((de,H)=>H.allPaths?de.concat(H.allPaths):de,[]);return ye.length&&(he.allPaths=ye),he}function O(ue,X,J){if(X===!1)return h;const Q=u(ue,J);if(Q===h)return h;if(typeof X=="boolean")return Q;if(X){const he=X.when;if(typeof he=="string"){const Z=(ye,de,H,U)=>{if(!U||!Q(ye,de))return null;const ne=he.replace("$(basename)",()=>H),Ee=U(ne);return(0,T.$Mg)(Ee)?Ee.then(fe=>fe?ue:null):Ee?ue:null};return Z.requiresSiblings=!0,Z}}return Q}function W(ue,X){const J=ue.filter(de=>!!de.basenames);if(J.length<2)return ue;const Q=J.reduce((de,H)=>{const U=H.basenames;return U?de.concat(U):de},[]);let he;if(X){he=[];for(let de=0,H=Q.length;de<H;de++)he.push(X)}else he=J.reduce((de,H)=>{const U=H.patterns;return U?de.concat(U):de},[]);const Z=function(de,H){if(typeof de!="string")return null;if(!H){let ne;for(ne=de.length;ne>0;ne--){const Ee=de.charCodeAt(ne-1);if(Ee===47||Ee===92)break}H=de.substr(ne)}const U=Q.indexOf(H);return U!==-1?he[U]:null};Z.basenames=Q,Z.patterns=he,Z.allBasenames=Q;const ye=ue.filter(de=>!de.basenames);return ye.push(Z),ye}function x(ue,X){return(0,D.$tb)(ue,X,(J,Q)=>typeof J=="string"&&typeof Q=="string"?J===Q:typeof J!="string"&&typeof Q!="string"?J.base===Q.base&&J.pattern===Q.pattern:!1)}e.$Kj=x}),define(ke[80],Se([1,0,8,163,23,13,2]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(w||(e.MarkdownStringTextNewlineStyle=w={}));class b{constructor(o="",i=!1){if(this.value=o,typeof this.value!="string")throw(0,D.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(o,i=0){return this.value+=$(this.supportThemeIcons?(0,T.$7j)(o):o).replace(/([ \t]+)/g,(n,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,i){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(o,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(o),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(o,i){const n=new RegExp((0,A.$Je)(i),"g");return o.replace(n,(s,a)=>o.charAt(a-1)!=="\\"?`\\${s}`:s)}}e.$ak=b;function y(d){return L(d)?!d.value:Array.isArray(d)?d.every(y):!0}e.$bk=y;function L(d){return d instanceof b?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.$ck=L;function P(d,o){return d===o?!0:!d||!o?!1:d.value===o.value&&d.isTrusted===o.isTrusted&&d.supportThemeIcons===o.supportThemeIcons&&d.supportHtml===o.supportHtml&&(d.baseUri===o.baseUri||!!d.baseUri&&!!o.baseUri&&(0,m.$ug)(R.URI.from(d.baseUri),R.URI.from(o.baseUri)))}e.$dk=P;function $(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ek=$;function v(d){return d.replace(/"/g,"&quot;")}e.$fk=v;function S(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$gk=S;function g(d){const o=[],i=d.split("|").map(s=>s.trim());d=i[0];const n=i[1];if(n){const s=/height=(\d+)/.exec(n),a=/width=(\d+)/.exec(n),t=s?s[1]:"",r=a?a[1]:"",h=isFinite(parseInt(r)),u=isFinite(parseInt(t));h&&o.push(`width="${r}"`),u&&o.push(`height="${t}"`)}return{href:d,dimensions:o}}e.$hk=g}),define(ke[102],Se([1,0,19,33,16,11,23,13]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=void 0;function b(u,c){const{os:l,tildify:E,relative:C}=c;if(C){const k=y(u,C,l);if(typeof k=="string")return k}let f=u.fsPath;if(l===1&&!A.$i?f=f.replace(/\//g,"\\"):l!==1&&A.$i&&(f=f.replace(/\\/g,"/")),l!==1&&E?.userHome){const k=E.userHome.fsPath;let I;u.scheme!==E.userHome.scheme&&u.path[0]===m.$fc.sep&&u.path[1]!==m.$fc.sep?I=E.userHome.with({path:u.path}).fsPath:I=f,f=$(I,k,l)}return(l===1?m.$ec:m.$fc).normalize(L(f,l===1))}e.$Cv=b;function y(u,c,l){const E=l===1?m.$ec:m.$fc,C=l===3?R.$rg:R.$tg,f=c.getWorkspace(),p=(0,D.$Nb)(f.folders);if(!p)return;u.scheme!==p.uri.scheme&&u.path[0]===m.$fc.sep&&u.path[1]!==m.$fc.sep&&(u=p.uri.with({path:u.path}));const k=c.getWorkspaceFolder(u);if(!k)return;let I;if(C.isEqual(k.uri,u)?I="":I=C.relativePath(k.uri,u)??"",I&&(I=E.normalize(I)),f.folders.length>1&&!c.noPrefix){const j=k.name?k.name:C.basenameOrAuthority(k.uri);I=I?`${j} \u2022 ${I}`:j}return I}function L(u,c=A.$i){return(0,T.$6f)(u,c)?u.charAt(0).toUpperCase()+u.slice(1):u}e.$Dv=L;let P=Object.create(null);function $(u,c,l=A.OS){if(l===1||!u||!c)return u;let E=P.original===c?P.normalized:void 0;E||(E=c,A.$i&&(E=(0,T.$Vf)(E)),E=`${(0,w.$Oe)(E,m.$fc.sep)}${m.$fc.sep}`,P={original:c,normalized:E});let C=u;return A.$i&&(C=(0,T.$Vf)(C)),(l===3?C.startsWith(E):(0,w.$7e)(C,E))?`~/${C.substr(E.length)}`:u}e.$Ev=$;function v(u,c){return u.replace(/^~($|\/|\\)/,`${c}$1`)}e.$Fv=v;const S="\u2026",g="\\\\",d="~";function o(u,c=m.sep){const l=new Array(u.length);let E=!1;for(let C=0;C<u.length;C++){const f=u[C];if(f===""){l[C]=`.${c}`;continue}if(!f){l[C]=f;continue}E=!0;let p="",k=f;k.indexOf(g)===0?(p=k.substr(0,k.indexOf(g)+g.length),k=k.substr(k.indexOf(g)+g.length)):k.indexOf(c)===0?(p=k.substr(0,k.indexOf(c)+c.length),k=k.substr(k.indexOf(c)+c.length)):k.indexOf(d)===0&&(p=k.substr(0,k.indexOf(d)+d.length),k=k.substr(k.indexOf(d)+d.length));const I=k.split(c);for(let j=1;E&&j<=I.length;j++)for(let z=I.length-j;E&&z>=0;z--){E=!1;let M=I.slice(z,z+j).join(c);for(let F=0;!E&&F<u.length;F++)if(F!==C&&u[F]&&u[F].indexOf(M)>-1){const N=z+j===I.length,O=z>0&&u[F].indexOf(c)>-1?c+M:M,W=u[F].endsWith(O);E=!N||W}if(!E){let F="";(I[0].endsWith(":")||p!=="")&&(z===1&&(z=0,j++,M=I[0]+c+M),z>0&&(F=I[0]+c),F=p+F),z>0&&(F=F+S+c),F=F+M,z+j<I.length&&(F=F+c+S),l[C]=F}}E&&(l[C]=f)}return l}e.$Gv=o;var i;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(u,c=Object.create(null)){const l=[];let E=!1,C="";for(const f of u)if(f==="$"||E&&f==="{")C&&l.push({value:C,type:i.TEXT}),C="",E=!0;else if(f==="}"&&E){const p=c[C];if(typeof p=="string")p.length&&l.push({value:p,type:i.VARIABLE});else if(p){const k=l[l.length-1];(!k||k.type!==i.SEPARATOR)&&l.push({value:p.label,type:i.SEPARATOR})}C="",E=!1}else C+=f;return C&&!E&&l.push({value:C,type:i.TEXT}),l.filter((f,p)=>{if(f.type===i.SEPARATOR){const k=l[p-1],I=l[p+1];return[k,I].every(j=>j&&(j.type===i.VARIABLE||j.type===i.TEXT)&&j.value.length>0)}return!0}).map(f=>f.value).join("")}e.$Hv=n;function s(u,c){return A.$j||c?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):u.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$Iv=s;function a(u,c){return A.$j||c?u.replace(/\(&&\w\)|&&/g,""):A.$i?u.replace(/&&|&/g,l=>l==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.$Jv=a;function t(u){return u.replace(/&/g,"&&")}e.$Kv=t;function r(u){if(u.endsWith("]")){const c=u.lastIndexOf(" [",u.length-2);if(c!==-1){const l=h(u.substring(0,c));return{name:l.name,parentPath:l.parentPath+u.substring(c)}}}return h(u)}e.$Lv=r;function h(u){const c=u.indexOf("/")!==-1?m.$fc:m.$ec,l=c.basename(u),E=c.dirname(u);return l.length?{name:l,parentPath:E}:{name:E,parentPath:""}}}),define(ke[131],Se([1,0,22,2]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=void 0;function m(P){return P.toJSON()}class A{constructor($){this.a=$}transformIncoming($){const v=this.a.transformIncoming($);return v===$?$:m(T.URI.from(v))}transformOutgoing($){const v=this.a.transformOutgoing($);return v===$?$:m(T.URI.from(v))}transformOutgoingURI($){const v=this.a.transformOutgoing($);return v===$?$:T.URI.from(v)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Vm=A,e.$Wm=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function R(P,$,v){if(!P||v>200)return null;if(typeof P=="object"){if(P instanceof T.URI)return $.transformOutgoing(P);for(const S in P)if(Object.hasOwnProperty.call(P,S)){const g=R(P[S],$,v+1);g!==null&&(P[S]=g)}}return null}function w(P,$){const v=R(P,$,0);return v===null?P:v}e.$Xm=w;function b(P,$,v,S){if(!P||S>200)return null;if(typeof P=="object"){if(P.$mid===1)return v?T.URI.revive($.transformIncoming(P)):$.transformIncoming(P);if(P instanceof D.$fe)return null;for(const g in P)if(Object.hasOwnProperty.call(P,g)){const d=b(P[g],$,v,S+1);d!==null&&(P[g]=d)}}return null}function y(P,$){const v=b(P,$,!1,0);return v===null?P:v}e.$Ym=y;function L(P,$){const v=b(P,$,!0,0);return v===null?P:v}e.$Zm=L}),define(ke[31],Se([1,0,55,63,384,12,33,76,16,11,23,2]),function(be,e,D,T,m,A,R,w,b,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function v(O,W=$.UNLINK,x){if((0,R.$5f)(O))throw new Error("rimraf - will refuse to recursively delete root");return W===$.UNLINK?g(O):S(O,x)}async function S(O,W=(0,R.$0f)((0,T.tmpdir)())){try{try{await D.promises.rename(O,W)}catch(x){return x.code==="ENOENT"?void 0:g(O)}g(W).catch(x=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function g(O){return(0,m.promisify)(D.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function d(O){if((0,R.$5f)(O))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function o(O,W){return s(await(W?i(O):(0,m.promisify)(D.readdir)(O)))}async function i(O){try{return await(0,m.promisify)(D.readdir)(O,{withFileTypes:!0})}catch(ue){console.warn("[node.js fs] readdir with filetypes failed with error: ",ue)}const W=[],x=await o(O);for(const ue of x){let X=!1,J=!1,Q=!1;try{const he=await e.Promises.lstat((0,b.$ic)(O,ue));X=he.isFile(),J=he.isDirectory(),Q=he.isSymbolicLink()}catch(he){console.warn("[node.js fs] unexpected error from lstat after readdir: ",he)}W.push({name:ue,isFile:()=>X,isDirectory:()=>J,isSymbolicLink:()=>Q})}return W}function n(O){return s(D.readdirSync(O))}e.readdirSync=n;function s(O){return O.map(W=>typeof W=="string"?y.$j?(0,w.$yl)(W):W:(W.name=y.$j?(0,w.$yl)(W.name):W.name,W))}async function a(O){const W=await o(O),x=[];for(const ue of W)await r.existsDirectory((0,b.$ic)(O,ue))&&x.push(ue);return x}function t(O,W=1e3){return new Promise(x=>{let ue=!1;const X=setInterval(()=>{ue||(ue=!0,D.access(O,J=>{ue=!1,J&&(clearInterval(X),x(void 0))}))},W)})}e.whenDeleted=t;var r;(function(O){async function W(X){let J;try{if(J=await e.Promises.lstat(X),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(y.$i&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(he){if(he.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw he}throw Q}}O.stat=W;async function x(X){try{const{stat:J,symbolicLink:Q}=await O.stat(X);return J.isFile()&&Q?.dangling!==!0}catch{}return!1}O.existsFile=x;async function ue(X){try{const{stat:J,symbolicLink:Q}=await O.stat(X);return J.isDirectory()&&Q?.dangling!==!0}catch{}return!1}O.existsDirectory=ue})(r||(e.SymlinkSupport=r={}));const h=new A.$9g;function u(O,W,x){return h.queueFor(P.URI.file(O),L.$sg).queue(()=>{const ue=f(x);return new Promise((X,J)=>E(O,W,ue,Q=>Q?J(Q):X()))})}let c=!0;function l(O){c=O}e.configureFlushOnWrite=l;function E(O,W,x,ue){if(!c)return D.writeFile(O,W,{mode:x.mode,flag:x.flag},ue);D.open(O,x.flag,x.mode,(X,J)=>{if(X)return ue(X);D.writeFile(J,W,Q=>{if(Q)return D.close(J,()=>ue(Q));D.fdatasync(J,he=>(he&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",he),l(!1)),D.close(J,Z=>ue(Z))))})})}function C(O,W,x){const ue=f(x);if(!c)return D.writeFileSync(O,W,{mode:ue.mode,flag:ue.flag});const X=D.openSync(O,ue.flag,ue.mode);try{D.writeFileSync(X,W);try{D.fdatasyncSync(X)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),l(!1)}}finally{D.closeSync(X)}}e.writeFileSync=C;function f(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function p(O,W,x=6e4){if(O!==W)try{y.$i&&typeof x=="number"?await k(O,W,Date.now(),x):await(0,m.promisify)(D.rename)(O,W)}catch(ue){if(O.toLowerCase()!==W.toLowerCase()&&ue.code==="EXDEV"||O.endsWith("."))await I(O,W,{preserveSymlinks:!1}),await v(O,$.MOVE);else throw ue}}async function k(O,W,x,ue,X=0){try{return await(0,m.promisify)(D.rename)(O,W)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-x>=ue)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${J}`),J;if(X===0){let Q=!1;try{const{stat:he}=await r.stat(W);he.isFile()||(Q=!0)}catch{}if(Q)throw J}return await(0,A.$1g)(Math.min(100,X*10)),k(O,W,x,ue,X+1)}}async function I(O,W,x){return z(O,W,{root:{source:O,target:W},options:x,handledSourcePaths:new Set})}const j=511;async function z(O,W,x){if(x.handledSourcePaths.has(O))return;x.handledSourcePaths.add(O);const{stat:ue,symbolicLink:X}=await r.stat(O);if(X){if(x.options.preserveSymlinks)try{return await N(O,W,x)}catch{}if(X.dangling)return}return ue.isDirectory()?M(O,W,ue.mode&j,x):F(O,W,ue.mode&j)}async function M(O,W,x,ue){await e.Promises.mkdir(W,{recursive:!0,mode:x});const X=await o(O);for(const J of X)await z((0,b.$ic)(O,J),(0,b.$ic)(W,J),ue)}async function F(O,W,x){await e.Promises.copyFile(O,W),await e.Promises.chmod(W,x)}async function N(O,W,x){let ue=await e.Promises.readlink(O);(0,R.$2f)(ue,x.root.source,!y.$k)&&(ue=(0,b.$ic)(x.root.target,ue.substr(x.root.source.length+1))),await e.Promises.symlink(ue,W)}e.Promises=new class{get access(){return(0,m.promisify)(D.access)}get stat(){return(0,m.promisify)(D.stat)}get lstat(){return(0,m.promisify)(D.lstat)}get utimes(){return(0,m.promisify)(D.utimes)}get read(){return(O,W,x,ue,X)=>new Promise((J,Q)=>{D.read(O,W,x,ue,X,(he,Z,ye)=>he?Q(he):J({bytesRead:Z,buffer:ye}))})}get readFile(){return(0,m.promisify)(D.readFile)}get write(){return(O,W,x,ue,X)=>new Promise((J,Q)=>{D.write(O,W,x,ue,X,(he,Z,ye)=>he?Q(he):J({bytesWritten:Z,buffer:ye}))})}get appendFile(){return(0,m.promisify)(D.appendFile)}get fdatasync(){return(0,m.promisify)(D.fdatasync)}get truncate(){return(0,m.promisify)(D.truncate)}get copyFile(){return(0,m.promisify)(D.copyFile)}get open(){return(0,m.promisify)(D.open)}get close(){return(0,m.promisify)(D.close)}get symlink(){return(0,m.promisify)(D.symlink)}get readlink(){return(0,m.promisify)(D.readlink)}get chmod(){return(0,m.promisify)(D.chmod)}get mkdir(){return(0,m.promisify)(D.mkdir)}get unlink(){return(0,m.promisify)(D.unlink)}get rmdir(){return(0,m.promisify)(D.rmdir)}get realpath(){return(0,m.promisify)(D.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return a}get writeFile(){return u}get rm(){return v}get rename(){return p}get copy(){return I}}}),define(ke[103],Se([1,0,55,16,11,13,31]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.$dq=e.$cq=void 0;function w($){if(m.$k)return $;const v=(0,T.$lc)($);if($===v)return $;const S=((0,T.$mc)($)||$).toLowerCase();try{const d=(0,R.readdirSync)(v).filter(o=>o.toLowerCase()===S);if(d.length===1){const o=w(v);if(o)return(0,T.$ic)(o,d[0])}else if(d.length>1){const o=d.indexOf(S);if(o>=0){const i=w(v);if(i)return(0,T.$ic)(i,d[o])}}}catch{}return null}e.$cq=w;async function b($){if(m.$k)return $;const v=(0,T.$lc)($);if($===v)return $;const S=((0,T.$mc)($)||$).toLowerCase();try{const d=(await R.Promises.readdir(v)).filter(o=>o.toLowerCase()===S);if(d.length===1){const o=await b(v);if(o)return(0,T.$ic)(o,d[0])}else if(d.length>1){const o=d.indexOf(S);if(o>=0){const i=await b(v);if(i)return(0,T.$ic)(i,d[o])}}}catch{}return null}e.$dq=b;async function y($){try{return await R.Promises.realpath($)}catch{const S=P($);return await R.Promises.access(S,D.constants.R_OK),S}}e.$eq=y;function L($){try{return D.realpathSync($)}catch{const S=P($);return D.accessSync(S,D.constants.R_OK),S}}e.$fq=L;function P($){return(0,A.$Oe)((0,T.$gc)($),T.sep)}}),define(ke[104],Se([1,0,16,11,49,101,18,31]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ml=e.$Ll=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function b(P=m.env){return P.comspec||"cmd.exe"}e.$Ll=b;function y(P){let $=[],v=!1;const S=function(g){if(v){$.push(g);return}(!P.send(g,o=>{if(o&&console.error(o),v=!1,$.length>0){const i=$.slice(0);$=[],i.forEach(n=>S(n))}})||T.$i)&&(v=!0)};return{send:S}}e.$Ml=y;var L;(function(P){async function $(v,S,g){if(D.$hc(v))return v;if(S===void 0&&(S=m.cwd()),D.$lc(v)!=="."||(g===void 0&&R.$Cf(m.env.PATH)&&(g=m.env.PATH.split(D.$sc)),g===void 0||g.length===0))return D.$ic(S,v);async function o(i){if(await w.Promises.exists(i)){let n;try{n=await w.Promises.stat(i)}catch(s){s.message.startsWith("EACCES")&&(n=await w.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of g){let n;if(D.$hc(i)?n=D.$ic(i,v):n=D.$ic(S,i,v),await o(n))return n;let s=n+".com";if(await o(s)||(s=n+".exe",await o(s)))return s}return D.$ic(S,v)}P.findExecutable=$})(L||(e.win32=L={}))});var Ke=this&&this.__decorate||function(be,e,D,T){var m=arguments.length,A=m<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,D):T,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(be,e,D,T);else for(var w=be.length-1;w>=0;w--)(R=be[w])&&(A=(m<3?R(A):m>3?R(e,D,A):R(e,D))||A);return m>3&&A&&Object.defineProperty(e,D,A),A};define(ke[81],Se([1,0,19,12,22,21,59,8,4,3,54,13,18]),function(be,e,D,T,m,A,R,w,b,y,L,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.ProxyChannel=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.RequestInitiator=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=void 0;var v;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(v||(v={}));function S(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(g||(g={}));function d(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(o||(o={}));function i(X){let J=0;for(let Q=0;;Q+=7){const he=X.read(1);if(J|=(he.buffer[0]&127)<<Q,!(he.buffer[0]&128))return J}}const n=h(0);function s(X,J){if(J===0){X.write(n);return}let Q=0;for(let Z=J;Z!==0;Z=Z>>>7)Q++;const he=m.$fe.alloc(Q);for(let Z=0;J!==0;Z++)he.buffer[Z]=J&127,J=J>>>7,J>0&&(he.buffer[Z]|=128);X.write(he)}class a{constructor(J){this.b=J,this.a=0}read(J){const Q=this.b.slice(this.a,this.a+J);return this.a+=Q.byteLength,Q}}e.$xh=a;class t{constructor(){this.a=[]}get buffer(){return m.$fe.concat(this.a)}write(J){this.a.push(J)}}e.$yh=t;var r;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(r||(r={}));function h(X){const J=m.$fe.alloc(1);return J.writeUInt8(X,0),J}const u={Undefined:h(r.Undefined),String:h(r.String),Buffer:h(r.Buffer),VSBuffer:h(r.VSBuffer),Array:h(r.Array),Object:h(r.Object),Uint:h(r.Int)},c=typeof Buffer<"u";function l(X,J){if(typeof J>"u")X.write(u.Undefined);else if(typeof J=="string"){const Q=m.$fe.fromString(J);X.write(u.String),s(X,Q.byteLength),X.write(Q)}else if(c&&Buffer.isBuffer(J)){const Q=m.$fe.wrap(J);X.write(u.Buffer),s(X,Q.byteLength),X.write(Q)}else if(J instanceof m.$fe)X.write(u.VSBuffer),s(X,J.byteLength),X.write(J);else if(Array.isArray(J)){X.write(u.Array),s(X,J.length);for(const Q of J)l(X,Q)}else if(typeof J=="number"&&(J|0)===J)X.write(u.Uint),s(X,J);else{const Q=m.$fe.fromString(JSON.stringify(J));X.write(u.Object),s(X,Q.byteLength),X.write(Q)}}e.$zh=l;function E(X){switch(X.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return X.read(i(X)).toString();case r.Buffer:return X.read(i(X)).buffer;case r.VSBuffer:return X.read(i(X));case r.Array:{const Q=i(X),he=[];for(let Z=0;Z<Q;Z++)he.push(E(X));return he}case r.Object:return JSON.parse(X.read(i(X)).toString());case r.Int:return i(X)}}e.$Ah=E;class C{constructor(J,Q,he=null,Z=1e3){this.h=J,this.j=Q,this.k=he,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ye=>this.q(ye)),this.m({type:200})}registerChannel(J,Q){this.b.set(J,Q),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const Q=this.o([J.type]);this.k?.logOutgoing(Q,0,1,d(J.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([J.type,J.id],J.data);this.k?.logOutgoing(Q,J.id,1,d(J.type),J.data);return}}}o(J,Q=void 0){const he=new t;return l(he,J),l(he,Q),this.p(he.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const Q=new a(J),he=E(Q),Z=E(Q),ye=he[0];switch(ye){case 100:return this.k?.logIncoming(J.byteLength,he[1],1,`${S(ye)}: ${he[2]}.${he[3]}`,Z),this.s({type:ye,id:he[1],channelName:he[2],name:he[3],arg:Z});case 102:return this.k?.logIncoming(J.byteLength,he[1],1,`${S(ye)}: ${he[2]}.${he[3]}`,Z),this.t({type:ye,id:he[1],channelName:he[2],name:he[3],arg:Z});case 101:return this.k?.logIncoming(J.byteLength,he[1],1,`${S(ye)}`),this.u({type:ye,id:he[1]});case 103:return this.k?.logIncoming(J.byteLength,he[1],1,`${S(ye)}`),this.u({type:ye,id:he[1]})}}s(J){const Q=this.b.get(J.channelName);if(!Q){this.v(J);return}const he=new A.$2d;let Z;try{Z=Q.call(this.j,J.name,J.arg,he.token)}catch(H){Z=Promise.reject(H)}const ye=J.id;Z.then(H=>{this.m({id:ye,data:H,type:201})},H=>{H instanceof Error?this.m({id:ye,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.m({id:ye,data:H,type:203})}).finally(()=>{de.dispose(),this.d.delete(J.id)});const de=(0,y.$Pc)(()=>he.cancel());this.d.set(J.id,de)}t(J){const Q=this.b.get(J.channelName);if(!Q){this.v(J);return}const he=J.id,ye=Q.listen(this.j,J.name,J.arg)(de=>this.m({id:he,data:de,type:204}));this.d.set(J.id,ye)}u(J){const Q=this.d.get(J.id);Q&&(Q.dispose(),this.d.delete(J.id))}v(J){let Q=this.g.get(J.channelName);Q||(Q=[],this.g.set(J.channelName,Q));const he=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:J,timeoutTimer:he})}w(J){const Q=this.g.get(J);if(Q){for(const he of Q)switch(clearTimeout(he.timeoutTimer),he.request.type){case 100:this.s(he.request);break;case 102:this.t(he.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Mc)(this.d.values()),this.d.clear()}}e.$Bh=C;var f;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(f||(e.RequestInitiator=f={}));class p{constructor(J,Q=null){this.l=J,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$Rd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(he=>this.s(he)),this.j=Q}getChannel(J){const Q=this;return{call(he,Z,ye){return Q.a?Promise.reject(new w.$4):Q.m(J,he,Z,ye)},listen(he,Z){return Q.a?b.Event.None:Q.o(J,he,Z)}}}m(J,Q,he,Z=A.CancellationToken.None){const ye=this.g++,H={id:ye,type:100,channelName:J,name:Q,arg:he};if(Z.isCancellationRequested)return Promise.reject(new w.$4);let U;return new Promise((Ee,fe)=>{if(Z.isCancellationRequested)return fe(new w.$4);const me=()=>{const ie=G=>{switch(G.type){case 201:this.f.delete(ye),Ee(G.data);break;case 202:{this.f.delete(ye);const ae=new Error(G.data.message);ae.stack=Array.isArray(G.data.stack)?G.data.stack.join(`
`):G.data.stack,ae.name=G.data.name,fe(ae);break}case 203:this.f.delete(ye),fe(G.data);break}};this.f.set(ye,ie),this.p(H)};let ee=null;this.b===o.Idle?me():(ee=(0,T.$Ng)(ie=>this.u()),ee.then(()=>{ee=null,me()}));const te=()=>{ee?(ee.cancel(),ee=null):this.p({id:ye,type:101}),fe(new w.$4)},K=Z.onCancellationRequested(te);U=(0,y.$Oc)((0,y.$Pc)(te),K),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(J,Q,he){const Z=this.g++,de={id:Z,type:102,channelName:J,name:Q,arg:he};let H=null;const U=new b.$Rd({onWillAddFirstListener:()=>{H=(0,T.$Ng)(Ee=>this.u()),H.then(()=>{H=null,this.d.add(U),this.p(de)})},onDidRemoveLastListener:()=>{H?(H.cancel(),H=null):(this.d.delete(U),this.p({id:Z,type:103}))}}),ne=Ee=>U.fire(Ee.data);return this.f.set(Z,ne),U.event}p(J){switch(J.type){case 100:case 102:{const Q=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(Q,J.id,0,`${S(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const Q=this.q([J.type,J.id]);this.j?.logOutgoing(Q,J.id,0,S(J.type));return}}}q(J,Q=void 0){const he=new t;return l(he,J),l(he,Q),this.r(he.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const Q=new a(J),he=E(Q),Z=E(Q),ye=he[0];switch(ye){case 200:return this.j?.logIncoming(J.byteLength,0,0,d(ye)),this.t({type:he[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,he[1],0,d(ye),Z),this.t({type:he[0],id:he[1],data:Z})}}t(J){if(J.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Mc)(this.d.values()),this.d.clear()}}e.$Ch=p,Ke([R.$rh],p.prototype,"onDidInitializePromise",null);class k{get connections(){const J=[];return this.f.forEach(Q=>J.push(Q)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new b.$Rd,this.onDidAddConnection=this.g.event,this.h=new b.$Rd,this.onDidRemoveConnection=this.h.event,this.j=new y.$Qc,this.j.add(J(({protocol:Q,onDidClientDisconnect:he})=>{const Z=b.Event.once(Q.onMessage);this.j.add(Z(ye=>{const de=new a(ye),H=E(de),U=new C(Q,H),ne=new p(Q);this.a.forEach((fe,me)=>U.registerChannel(me,fe));const Ee={channelServer:U,channelClient:ne,ctx:H};this.f.add(Ee),this.g.fire(Ee),this.j.add(he(()=>{U.dispose(),ne.dispose(),this.f.delete(Ee),this.h.fire(Ee)}))}))}))}getChannel(J,Q){const he=this;return{call(Z,ye,de){let H;if((0,$.$Qf)(Q)){const ne=(0,D.$3b)(he.connections.filter(Q));H=ne?Promise.resolve(ne):b.Event.toPromise(b.Event.filter(he.onDidAddConnection,Q))}else H=Q.routeCall(he,Z,ye);const U=H.then(ne=>ne.channelClient.getChannel(J));return j(U).call(Z,ye,de)},listen(Z,ye){if((0,$.$Qf)(Q))return he.k(J,Q,Z,ye);const de=Q.routeEvent(he,Z,ye).then(H=>H.channelClient.getChannel(J));return j(de).listen(Z,ye)}}}k(J,Q,he,Z){const ye=this;let de;const H=new b.$Rd({onWillAddFirstListener:()=>{de=new y.$Qc;const U=new b.$Xd,ne=new Map,Ee=me=>{const te=me.channelClient.getChannel(J).listen(he,Z),K=U.add(te);ne.set(me,K)},fe=me=>{const ee=ne.get(me);ee&&(ee.dispose(),ne.delete(me))};ye.connections.filter(Q).forEach(Ee),b.Event.filter(ye.onDidAddConnection,Q)(Ee,void 0,de),ye.onDidRemoveConnection(fe,void 0,de),U.event(H.fire,H,de),de.add(U)},onDidRemoveLastListener:()=>{de?.dispose(),de=void 0}});return H.event}registerChannel(J,Q){this.a.set(J,Q);for(const he of this.f)he.channelServer.registerChannel(J,Q)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Dh=k;class I{constructor(J,Q,he=null){const Z=new t;l(Z,Q),J.send(Z.buffer),this.a=new p(J,he),this.d=new C(J,Q,he)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,Q){this.d.registerChannel(J,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Eh=I;function j(X){return{call(J,Q,he){return X.then(Z=>Z.call(J,Q,he))},listen(J,Q){const he=new b.$1d;return X.then(Z=>he.input=Z.listen(J,Q)),he.event}}}e.$Fh=j;function z(X){let J=!1;return{call(Q,he,Z){return J?X.call(Q,he,Z):(0,T.$1g)(0).then(()=>J=!0).then(()=>X.call(Q,he,Z))},listen(Q,he){if(J)return X.listen(Q,he);const Z=new b.$1d;return(0,T.$1g)(0).then(()=>J=!0).then(()=>Z.input=X.listen(Q,he)),Z.event}}}e.$Gh=z;class M{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const Q of J.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await b.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$Hh=M;var F;(function(X){function J(ye,de,H){const U=ye,ne=H&&H.disableMarshalling,Ee=new Map;for(const fe in U)he(fe)&&Ee.set(fe,b.Event.buffer(U[fe],!0,void 0,de));return new class{listen(fe,me,ee){const te=Ee.get(me);if(te)return te;if(Z(me)){const K=U[me];if(typeof K=="function")return K.call(U,ee)}throw new w.$ab(`Event not found: ${me}`)}call(fe,me,ee){const te=U[me];if(typeof te=="function"){if(!ne&&Array.isArray(ee))for(let ie=0;ie<ee.length;ie++)ee[ie]=(0,L.$wh)(ee[ie]);let K=te.apply(U,ee);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new w.$ab(`Method not found: ${me}`)}}}X.fromService=J;function Q(ye,de){const H=de&&de.disableMarshalling;return new Proxy({},{get(U,ne){if(typeof ne=="string")return de?.properties?.has(ne)?de.properties.get(ne):Z(ne)?function(Ee){return ye.listen(ne,Ee)}:he(ne)?ye.listen(ne):async function(...Ee){let fe;de&&!(0,$.$Lf)(de.context)?fe=[de.context,...Ee]:fe=Ee;const me=await ye.call(ne,fe);return H?me:(0,L.$wh)(me)};throw new w.$ab(`Property not found: ${String(ne)}`)}})}X.toService=Q;function he(ye){return ye[0]==="o"&&ye[1]==="n"&&P.$5e(ye.charCodeAt(2))}function Z(ye){return/^onDynamic/.test(ye)&&P.$5e(ye.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const J=X.toString();if(J!=="[object Object]")return J}return X}function W(X){return Array.isArray(X)?X.map(O):O(X)}function x(X,J,Q,he,Z,ye,de){de=W(de);const H=N[Z],U=H[he%H.length];let ne=[`%c[${X}]%c[${String(J).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(he).padStart(5," ")} - ${ye}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ye)?(ne=ne.concat(de),ne.push(")")):ne.push(de),console.log.apply(console,ne)}class ue{constructor(J,Q){this.d=J,this.f=Q,this.a=0,this.b=0}logOutgoing(J,Q,he,Z,ye){this.b+=J,x(this.d,this.b,J,Q,he,Z,ye)}logIncoming(J,Q,he,Z,ye){this.a+=J,x(this.f,this.a,J,Q,he,Z,ye)}}e.$Ih=ue}),define(ke[82],Se([1,0,22,4,3,81]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.ProtocolConstants=e.$Jh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var w;(function(u){u.enableDiagnostics=!1,u.records=[];const c=new WeakMap;let l=0;function E(f,p){if(!c.has(f)){const k=String(++l);c.set(f,k)}return c.get(f)}function C(f,p,k,I){if(!u.enableDiagnostics)return;const j=E(f,p);if(I instanceof D.$fe||I instanceof Uint8Array||I instanceof ArrayBuffer||ArrayBuffer.isView(I)){const z=D.$fe.alloc(I.byteLength);z.set(I),u.records.push({timestamp:Date.now(),id:j,label:p,type:k,buff:z})}else u.records.push({timestamp:Date.now(),id:j,label:p,type:k,data:I})}u.traceSocketEvent=C})(w||(e.SocketDiagnostics=w={}));var b;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let y=null;function L(){return y||(y=D.$fe.alloc(0)),y}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,l){if(c===0)return L();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const p=this.a[0];return l&&(this.a.shift(),this.b-=c),p}if(this.a[0].byteLength>c){const p=this.a[0].slice(0,c);return l&&(this.a[0]=this.a[0].slice(c),this.b-=c),p}const E=D.$fe.alloc(c);let C=0,f=0;for(;c>0;){const p=this.a[f];if(p.byteLength>c){const k=p.slice(0,c);E.set(k,C),C+=c,l&&(this.a[f]=p.slice(c),this.b-=c),c-=c}else E.set(p,C),C+=p.byteLength,l?(this.a.shift(),this.b-=p.byteLength):f++,c-=p.byteLength}return E}}e.$Jh=P;var $;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})($||($={}));function v(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class g{constructor(c,l,E,C){this.type=c,this.id=l,this.ack=E,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends m.$Rc{constructor(c){super(),this.f=this.B(new T.$Rd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new P,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:v(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const E=this.g.messageType,C=this.g.id,f=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new g(E,C,f,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=D.$fe.alloc(13);l.writeUInt8(c.type,0),l.writeUInt32BE(c.id,1),l.writeUInt32BE(c.ack,5),l.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:v(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(l,c.data)}g(c,l){const E=this.f===0;return this.d.push(c,l),this.f+=c.byteLength+l.byteLength,E}h(){const c=D.$fe.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,l){this.g(c,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class i extends m.$Rc{constructor(c){super(),this.f=new T.$Rd,this.onMessage=this.f.event,this.g=new T.$Rd,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new o(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new g(1,0,0,c))}}e.$Kh=i;class n extends A.$Eh{static fromSocket(c,l){return new n(new i(c),l)}get onDidDispose(){return this.b.onDidDispose}constructor(c,l,E=null){super(c,l,E),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$Lh=n;class s{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$Rd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$Mh=s;class a{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,l=this.a;for(;l;)l=l.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let l=0,E=this.a;for(;E;)c[l++]=E.data,E=E.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const l=new a(c);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const c=Date.now();for(let l=0;l<r.a;l++)this.c[l]=c-1e3*l;setInterval(()=>{for(let l=r.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),l=(1+r.a)*1e3;let E=0;for(let C=0;C<r.a;C++)c-this.c[C]<=l&&E++;return 1-E/r.a}hasHighLoad(){return this.d()>=.5}}class h{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new s,this.onControlMessage=this.u.event,this.v=new s,this.onMessage=this.v.event,this.w=new s,this.onDidDispose=this.w.event,this.x=new s,this.onSocketClose=this.x.event,this.y=new s,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??r.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new m.$Qc,this.o=c.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new g(5,0,0,L());this.p.write(c),this.p.flush()}sendPause(){const c=new g(7,0,0,L());this.p.write(c)}sendResume(){const c=new g(8,0,0,L());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,l){this.a=!0,this.r.dispose(),this.r=new m.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(E=>this.z(E))),this.r.add(this.o.onClose(E=>this.x.fire(E))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new g(3,0,this.h,L());this.p.write(c);const l=this.b.toArray();for(let E=0,C=l.length;E<C;E++)this.p.write(l[E]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const l=this.b.peek();if(l&&l.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new g(6,0,0,L())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let E=0,C=l.length;E<C;E++)this.p.write(l[E]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const l=++this.c;this.h=this.g;const E=new g(1,l,this.h,c);this.b.push(E),this.a||(this.p.write(E),this.B())}sendControl(c){const l=new g(2,0,0,c);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),l=Date.now()-c.writtenTime,E=Date.now()-this.q.lastReadTime,C=Date.now()-this.n;if(l>=2e4&&E>=2e4&&C>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:E});return}const f=Math.max(2e4-l,2e4-E,2e4-C,500);this.f=setTimeout(()=>{this.f=null,this.B()},f)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new g(3,0,this.h,L());this.p.write(c)}D(){this.h=this.g;const c=new g(9,0,this.h,L());this.p.write(c)}}e.$Nh=h}),define(ke[186],Se([1,0,50,12,22,21,184,8,4,3,24,104,101,81]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;class S extends v.$Bh{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",i=>m.$fe.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$_p=S;class g{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new b.$Rd,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new T.$Wg(n),this.d=null,this.f=null}getChannel(o){const i=this;return{call(n,s,a){return i.k(o,n,s,a)},listen(n,s){return i.l(o,n,s)}}}k(o,i,n,s=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(w.$5());this.b.cancel();const a=this.n(o),t=(0,T.$Ng)(u=>a.call(i,n,u)),r=s.onCancellationRequested(()=>t.cancel()),h=(0,y.$Pc)(()=>t.cancel());return this.c.add(h),t.finally(()=>{r.dispose(),this.c.delete(h),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,n){if(!this.b)return b.Event.None;this.b.cancel();let s;const a=new b.$Rd({onWillAddFirstListener:()=>{s=this.n(o).listen(i,n)(a.fire,a),this.c.add(s)},onDidRemoveLastListener:()=>{this.c.delete(s),s.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,L.$en)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,$.$Kl)(i.env),this.d=(0,D.fork)(this.i,o,i);const n=new b.$Rd;b.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,R.$8p)(c)){(0,R.log)(c,`IPC Library: ${this.j.serverName}`);return}n.fire(m.$fe.wrap(Buffer.from(c,"base64")))});const a=this.j.useQueue?(0,P.$Ml)(this.d):this.d,t=c=>this.d&&this.d.connected&&a.send(c.buffer.toString("base64")),r=n.event,h={send:t,onMessage:r};this.f=new v.$Ch(h);const u=()=>this.o();process.once("exit",u),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,l)=>{process.removeListener("exit",u),this.c.forEach(E=>(0,y.$Mc)(E)),this.c.clear(),c!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:l})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$aq=g}),define(ke[187],Se([1,0,12,4,3,54,18]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.StorageState=e.$$o=e.StorageHint=void 0;var w;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function b($){const v=$;return v?.changed instanceof Map||v?.deleted instanceof Set}e.$$o=b;var y;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(y||(e.StorageState=y={}));class L extends m.$Rc{static{this.a=100}constructor(v,S=Object.create(null)){super(),this.r=v,this.s=S,this.b=this.B(new T.$Ud),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new D.$Xg(L.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(v=>this.u(v)))}u(v){this.b.pause();try{v.changed?.forEach((S,g)=>this.w(g,S)),v.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(v,S){if(this.c===y.Closed)return;let g=!1;(0,R.$Lf)(S)?g=this.f.delete(v):this.f.get(v)!==S&&(this.f.set(v,S),g=!0),g&&this.b.fire({key:v,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(v,S){const g=this.f.get(v);return(0,R.$Lf)(g)?S:g}getBoolean(v,S){const g=this.get(v);return(0,R.$Lf)(g)?S:g==="true"}getNumber(v,S){const g=this.get(v);return(0,R.$Lf)(g)?S:parseInt(g,10)}getObject(v,S){const g=this.get(v);return(0,R.$Lf)(g)?S:(0,A.$vh)(g)}async set(v,S,g=!1){if(this.c===y.Closed)return;if((0,R.$Lf)(S))return this.delete(v,g);const d=(0,R.$Ef)(S)||Array.isArray(S)?(0,A.$uh)(S):String(S);if(this.f.get(v)!==d)return this.f.set(v,d),this.j.set(v,d),this.h.delete(v),this.b.fire({key:v,external:g}),this.D()}async delete(v,S=!1){if(!(this.c===y.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire({key:v,external:S}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(v).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(v){if(this.z)return this.D(v)}async D(v){return this.s.hint===w.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),v)}async whenFlushed(){if(this.z)return new Promise(v=>this.n.push(v))}isInMemory(){return this.s.hint===w.STORAGE_IN_MEMORY}}e.$_o=L;class P{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((S,g)=>this.a.set(g,S)),v.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$ap=P}),define(ke[188],Se([1,0,13,11,22]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=e.$Vs=void 0;let A;function R(){return A||(A=new TextDecoder("UTF-16LE")),A}let w;function b(){return w||(w=new TextDecoder("UTF-16BE")),w}let y;function L(){return y||(y=T.$D()?R():b()),y}e.$Vs=L;function P(S,g,d){const o=new Uint16Array(S.buffer,g,d);return d>0&&(o[0]===65279||o[0]===65534)?$(S,g,d):R().decode(o)}e.$Ws=P;function $(S,g,d){const o=[];let i=0;for(let n=0;n<d;n++){const s=m.$he(S,g);g+=2,o[i++]=String.fromCharCode(s)}return o.join("")}class v{constructor(g){this.a=g|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const g=new Uint16Array(this.b.buffer,0,this.d);return L().decode(g)}f(){const g=this.e();this.d=0,this.c===null?this.c=[g]:this.c[this.c.length]=g}appendCharCode(g){const d=this.a-this.d;d<=1&&(d===0||D.$0e(g))&&this.f(),this.b[this.d++]=g}appendASCIICharCode(g){this.d===this.a&&this.f(),this.b[this.d++]=g}appendString(g){const d=g.length;if(this.d+d>=this.a){this.f(),this.c[this.c.length]=g;return}for(let o=0;o<d;o++)this.b[this.d++]=g.charCodeAt(o)}}e.$Xs=v}),define(ke[189],Se([1,0,22,188]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.$Ys=void 0;function m(b){return b.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,L,P,$){this.oldPosition=y,this.oldText=L,this.newPosition=P,this.newText=$}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${m(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${m(this.oldText)}")`:`(replace@${this.oldPosition} "${m(this.oldText)}" with "${m(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,L,P){const $=L.length;D.$ke(y,$,P),P+=4;for(let v=0;v<$;v++)D.$ie(y,L.charCodeAt(v),P),P+=2;return P}static d(y,L){const P=D.$je(y,L);return L+=4,(0,T.$Ws)(y,L,P)}writeSize(){return 4+4+A.a(this.oldText)+A.a(this.newText)}write(y,L){return D.$ke(y,this.oldPosition,L),L+=4,D.$ke(y,this.newPosition,L),L+=4,L=A.c(y,this.oldText,L),L=A.c(y,this.newText,L),L}static read(y,L,P){const $=D.$je(y,L);L+=4;const v=D.$je(y,L);L+=4;const S=A.d(y,L);L+=A.a(S);const g=A.d(y,L);return L+=A.a(g),P.push(new A($,S,v,g)),L}}e.$Ys=A;function R(b,y){return b===null||b.length===0?y:new w(b,y).compress()}e.$Zs=R;class w{constructor(y,L){this.a=y,this.c=L,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,L=0,P=this.n(y),$=this.l(L);for(;y<this.f||L<this.h;){if(P===null){this.k($),$=this.l(++L);continue}if($===null){this.m(P),P=this.n(++y);continue}if($.oldEnd<=P.newPosition){this.k($),$=this.l(++L);continue}if(P.newEnd<=$.oldPosition){this.m(P),P=this.n(++y);continue}if($.oldPosition<P.newPosition){const[o,i]=w.r($,P.newPosition-$.oldPosition);this.k(o),$=i;continue}if(P.newPosition<$.oldPosition){const[o,i]=w.q(P,$.oldPosition-P.newPosition);this.m(o),P=i;continue}let g,d;if($.oldEnd===P.newEnd)g=P,d=$,P=this.n(++y),$=this.l(++L);else if($.oldEnd<P.newEnd){const[o,i]=w.q(P,$.oldLength);g=o,d=$,P=i,$=this.l(++L)}else{const[o,i]=w.r($,P.newLength);g=P,d=o,P=this.n(++y),$=i}this.d[this.e++]=new A(g.oldPosition,g.oldText,d.newPosition,d.newText),this.g+=g.newLength-g.oldLength,this.j+=d.newLength-d.oldLength}const v=w.s(this.d);return w.t(v)}k(y){this.d[this.e++]=w.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=w.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,L){return new A(L.oldPosition-y,L.oldText,L.newPosition,L.newText)}static p(y,L){return new A(L.oldPosition,L.oldText,L.newPosition+y,L.newText)}static q(y,L){const P=y.newText.substr(0,L),$=y.newText.substr(L);return[new A(y.oldPosition,y.oldText,y.newPosition,P),new A(y.oldEnd,"",y.newPosition+L,$)]}static r(y,L){const P=y.oldText.substr(0,L),$=y.oldText.substr(L);return[new A(y.oldPosition,P,y.newPosition,y.newText),new A(y.oldPosition+L,$,y.newEnd,"")]}static s(y){if(y.length===0)return y;const L=[];let P=0,$=y[0];for(let v=1;v<y.length;v++){const S=y[v];$.oldEnd===S.oldPosition?$=new A($.oldPosition,$.oldText+S.oldText,$.newPosition,$.newText+S.newText):(L[P++]=$,$=S)}return L[P++]=$,L}static t(y){if(y.length===0)return y;const L=[];let P=0;for(let $=0;$<y.length;$++){const v=y[$];v.oldText!==v.newText&&(L[P++]=v)}return L}}}),define(ke[190],Se([1,0,34,16]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PE=void 0;function m(A,R,w,b,y,L){if(Array.isArray(A)){let P=0;for(const $ of A){const v=m($,R,w,b,y,L);if(v===10)return v;v>P&&(P=v)}return P}else{if(typeof A=="string")return b?A==="*"?5:A===w?10:0:0;if(A){const{language:P,pattern:$,scheme:v,hasAccessToAllModels:S,notebookType:g}=A;if(!b&&!S)return 0;g&&y&&(R=y);let d=0;if(v)if(v===R.scheme)d=10;else if(v==="*")d=5;else return 0;if(P)if(P===w)d=10;else if(P==="*")d=Math.max(d,5);else return 0;if(g)if(g===L)d=10;else if(g==="*"&&L!==void 0)d=Math.max(d,5);else return 0;if($){let o;if(typeof $=="string"?o=$:o={...$,base:(0,T.$gc)($.base)},o===R.fsPath||(0,D.$Fj)(o,R.fsPath))d=10;else return 0}return d}else return 0}}e.$PE=m}),define(ke[191],Se([1,0,4,13,29,79,128,166,189,3]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QB=void 0;class L extends y.$Rc{constructor($,v,S,g,d,o,i){super(),this.m=this.B(new D.$Rd),this.onDidChangeContent=this.m.event,this.f=v,this.j=!o,this.g=g,this.h=d,this.c=new R.$PB($,S,i)}equals($){return!($ instanceof L)||this.f!==$.f||this.getEOL()!==$.getEOL()?!1:this.c.equal($.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot($){return this.c.createSnapshot($?this.f:"")}getOffsetAt($,v){return this.c.getOffsetAt($,v)}getPositionAt($){return this.c.getPositionAt($)}getRangeAt($,v){const S=$+v,g=this.getPositionAt($),d=this.getPositionAt(S);return new m.$Ds(g.lineNumber,g.column,d.lineNumber,d.column)}getValueInRange($,v=0){if($.isEmpty())return"";const S=this.n(v);return this.c.getValueInRange($,S)}getValueLengthInRange($,v=0){if($.isEmpty())return 0;if($.startLineNumber===$.endLineNumber)return $.endColumn-$.startColumn;const S=this.getOffsetAt($.startLineNumber,$.startColumn),g=this.getOffsetAt($.endLineNumber,$.endColumn);let d=0;const o=this.n(v),i=this.getEOL();if(o.length!==i.length){const n=o.length-i.length,s=$.endLineNumber-$.startLineNumber;d=n*s}return g-S+d}getCharacterCountInRange($,v=0){if(this.j){let S=0;const g=$.startLineNumber,d=$.endLineNumber;for(let o=g;o<=d;o++){const i=this.getLineContent(o),n=o===g?$.startColumn-1:0,s=o===d?$.endColumn-1:i.length;for(let a=n;a<s;a++)T.$0e(i.charCodeAt(a))?(S=S+1,a=a+1):S=S+1}return S+=this.n(v).length*(d-g),S}return this.getValueLengthInRange($,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent($){return this.c.getLineContent($)}getLineCharCode($,v){return this.c.getLineCharCode($,v)}getCharCode($){return this.c.getCharCode($)}getLineLength($){return this.c.getLineLength($)}getLineMinColumn($){return 1}getLineMaxColumn($){return this.getLineLength($)+1}getLineFirstNonWhitespaceColumn($){const v=T.$Ue(this.getLineContent($));return v===-1?0:v+1}getLineLastNonWhitespaceColumn($){const v=T.$We(this.getLineContent($));return v===-1?0:v+2}n($){switch($){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL($){this.c.setEOL($)}applyEdits($,v,S){let g=this.g,d=this.h,o=this.j,i=!0,n=[];for(let c=0;c<$.length;c++){const l=$[c];i&&l._isTracked&&(i=!1);const E=l.range;if(l.text){let I=!0;o||(I=!T.$if(l.text),o=I),!g&&I&&(g=T.$hf(l.text)),!d&&I&&(d=T.$kf(l.text))}let C="",f=0,p=0,k=0;if(l.text){let I;[f,p,k,I]=(0,w.$dt)(l.text);const j=this.getEOL();I===0||I===(j===`\r
`?2:1)?C=l.text:C=l.text.replace(/\r\n|\r|\n/g,j)}n[c]={sortIndex:c,identifier:l.identifier||null,range:E,rangeOffset:this.getOffsetAt(E.startLineNumber,E.startColumn),rangeLength:this.getValueLengthInRange(E),text:C,eolCount:f,firstLineLength:p,lastLineLength:k,forceMoveMarkers:!!l.forceMoveMarkers,isAutoWhitespaceEdit:l.isAutoWhitespaceEdit||!1}}n.sort(L.u);let s=!1;for(let c=0,l=n.length-1;c<l;c++){const E=n[c].range.getEndPosition(),C=n[c+1].range.getStartPosition();if(C.isBeforeOrEqual(E)){if(C.isBefore(E))throw new Error("Overlapping ranges are not allowed!");s=!0}}i&&(n=this.s(n));const a=S||v?L._getInverseEditRanges(n):[],t=[];if(v)for(let c=0;c<n.length;c++){const l=n[c],E=a[c];if(l.isAutoWhitespaceEdit&&l.range.isEmpty())for(let C=E.startLineNumber;C<=E.endLineNumber;C++){let f="";C===E.startLineNumber&&(f=this.getLineContent(l.range.startLineNumber),T.$Ue(f)!==-1)||t.push({lineNumber:C,oldContent:f})}}let r=null;if(S){let c=0;r=[];for(let l=0;l<n.length;l++){const E=n[l],C=a[l],f=this.getValueInRange(E.range),p=E.rangeOffset+c;c+=E.text.length-f.length,r[l]={sortIndex:E.sortIndex,identifier:E.identifier,range:C,text:f,textChange:new b.$Ys(E.rangeOffset,f,p,E.text)}}s||r.sort((l,E)=>l.sortIndex-E.sortIndex)}this.g=g,this.h=d,this.j=o;const h=this.t(n);let u=null;if(v&&t.length>0){t.sort((c,l)=>l.lineNumber-c.lineNumber),u=[];for(let c=0,l=t.length;c<l;c++){const E=t[c].lineNumber;if(c>0&&t[c-1].lineNumber===E)continue;const C=t[c].oldContent,f=this.getLineContent(E);f.length===0||f===C||T.$Ue(f)!==-1||u.push(E)}}return this.m.fire(),new A.$Yu(r,h,u)}s($){return $.length<1e3?$:[this._toSingleEditOperation($)]}_toSingleEditOperation($){let v=!1;const S=$[0].range,g=$[$.length-1].range,d=new m.$Ds(S.startLineNumber,S.startColumn,g.endLineNumber,g.endColumn);let o=S.startLineNumber,i=S.startColumn;const n=[];for(let h=0,u=$.length;h<u;h++){const c=$[h],l=c.range;v=v||c.forceMoveMarkers,n.push(this.getValueInRange(new m.$Ds(o,i,l.startLineNumber,l.startColumn))),c.text.length>0&&n.push(c.text),o=l.endLineNumber,i=l.endColumn}const s=n.join(""),[a,t,r]=(0,w.$dt)(s);return{sortIndex:0,identifier:$[0].identifier,range:d,rangeOffset:this.getOffsetAt(d.startLineNumber,d.startColumn),rangeLength:this.getValueLengthInRange(d,0),text:s,eolCount:a,firstLineLength:t,lastLineLength:r,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t($){$.sort(L.w);const v=[];for(let S=0;S<$.length;S++){const g=$[S],d=g.range.startLineNumber,o=g.range.startColumn,i=g.range.endLineNumber,n=g.range.endColumn;if(d===i&&o===n&&g.text.length===0)continue;g.text?(this.c.delete(g.rangeOffset,g.rangeLength),this.c.insert(g.rangeOffset,g.text,!0)):this.c.delete(g.rangeOffset,g.rangeLength);const s=new m.$Ds(d,o,i,n);v.push({range:s,rangeLength:g.rangeLength,text:g.text,rangeOffset:g.rangeOffset,forceMoveMarkers:g.forceMoveMarkers})}return v}findMatchesLineByLine($,v,S,g){return this.c.findMatchesLineByLine($,v,S,g)}getPieceTree(){return this.c}static _getInverseEditRange($,v){const S=$.startLineNumber,g=$.startColumn,[d,o,i]=(0,w.$dt)(v);let n;if(v.length>0){const s=d+1;s===1?n=new m.$Ds(S,g,S,g+o):n=new m.$Ds(S,g,S+s-1,i+1)}else n=new m.$Ds(S,g,S,g);return n}static _getInverseEditRanges($){const v=[];let S=0,g=0,d=null;for(let o=0,i=$.length;o<i;o++){const n=$[o];let s,a;d?d.range.endLineNumber===n.range.startLineNumber?(s=S,a=g+(n.range.startColumn-d.range.endColumn)):(s=S+(n.range.startLineNumber-d.range.endLineNumber),a=n.range.startColumn):(s=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const r=n.eolCount+1;r===1?t=new m.$Ds(s,a,s,a+n.firstLineLength):t=new m.$Ds(s,a,s+r-1,n.lastLineLength+1)}else t=new m.$Ds(s,a,s,a);S=t.endLineNumber,g=t.endColumn,v.push(t),d=n}return v}static u($,v){const S=m.$Ds.compareRangesUsingEnds($.range,v.range);return S===0?$.sortIndex-v.sortIndex:S}static w($,v){const S=m.$Ds.compareRangesUsingEnds($.range,v.range);return S===0?v.sortIndex-$.sortIndex:-S}}e.$QB=L}),define(ke[192],Se([1,0,13,128,191]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RB=void 0;class A{constructor(b,y,L,P,$,v,S,g,d){this.a=b,this.b=y,this.c=L,this.d=P,this.e=$,this.f=v,this.g=S,this.h=g,this.j=d}k(b){const y=this.c+this.d+this.e,L=this.c+this.e;return y===0?b===1?`
`:`\r
`:L>y/2?`\r
`:`
`}create(b){const y=this.k(b),L=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let $=0,v=L.length;$<v;$++){const S=L[$].buffer.replace(/\r\n|\r|\n/g,y),g=(0,T.$LB)(S);L[$]=new T.$OB(S,g)}const P=new m.$QB(L,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(b){return this.a[0].buffer.substr(0,b).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(b){if(b.length===0)return;this.a.length===0&&D.$qf(b)&&(this.b=D.$pf,b=b.substr(1));const y=b.charCodeAt(b.length-1);y===13||y>=55296&&y<=56319?(this.m(b.substr(0,b.length-1),!1),this.c=!0,this.d=y):(this.m(b,!1),this.c=!1,this.d=y)}m(b,y){!y&&b.length===0||(this.c?this.n(String.fromCharCode(this.d)+b):this.n(b))}n(b){const y=(0,T.$MB)(this.e,b);this.a.push(new T.$OB(b,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=D.$hf(b)),this.k||(this.k=D.$kf(b)))}finish(b=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,b)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const b=this.a[this.a.length-1];b.buffer+=String.fromCharCode(this.d);const y=(0,T.$LB)(b.buffer);b.lineStarts=y,this.d===13&&this.f++}}}e.$RB=R}),define(ke[132],Se([1,0,22,11]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$90=e.$80=void 0;var m;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(m||(m={}));function A(P){for(let $=0,v=P.length;$<v;$+=4){const S=P[$+0],g=P[$+1],d=P[$+2],o=P[$+3];P[$+0]=o,P[$+1]=d,P[$+2]=g,P[$+3]=S}}function R(P){const $=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return T.$D()||A($),D.$fe.wrap($)}function w(P){const $=P.buffer;if(T.$D()||A($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const v=new Uint8Array($.byteLength);return v.set($),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function b(P){const $=new Uint32Array(y(P));let v=0;if($[v++]=P.id,P.type==="full")$[v++]=1,$[v++]=P.data.length,$.set(P.data,v),v+=P.data.length;else{$[v++]=2,$[v++]=P.deltas.length;for(const S of P.deltas)$[v++]=S.start,$[v++]=S.deleteCount,S.data?($[v++]=S.data.length,$.set(S.data,v),v+=S.data.length):$[v++]=0}return R($)}e.$80=b;function y(P){let $=0;if($+=1+1,P.type==="full")$+=1+P.data.length;else{$+=1,$+=(1+1+1)*P.deltas.length;for(const v of P.deltas)v.data&&($+=v.data.length)}return $}function L(P){const $=w(P);let v=0;const S=$[v++];if($[v++]===1){const i=$[v++],n=$.subarray(v,v+i);return v+=i,{id:S,type:"full",data:n}}const d=$[v++],o=[];for(let i=0;i<d;i++){const n=$[v++],s=$[v++],a=$[v++];let t;a>0&&(t=$.subarray(v,v+a),v+=a),o[i]={start:n,deleteCount:s,data:t}}return{id:S,type:"delta",deltas:o}}e.$90=L}),define(ke[193],Se([9,10]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(ke[133],Se([1,0,19,24,11,169,127,193]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var b;(function(le){le[le.None=0]="None",le[le.Keep=1]="Keep",le[le.Brackets=2]="Brackets",le[le.Advanced=3]="Advanced",le[le.Full=4]="Full"})(b||(e.EditorAutoIndentStrategy=b={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ce){this.c=ce}hasChanged(ce){return this.c[ce]}}e.ConfigurationChangedEvent=y;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class P{constructor(ce,Pe,He,Ge){this.id=ce,this.name=Pe,this.defaultValue=He,this.schema=Ge}applyUpdate(ce,Pe){return v(ce,Pe)}compute(ce,Pe,He){return He}}class ${constructor(ce,Pe){this.newValue=ce,this.didChange=Pe}}e.ApplyUpdateResult=$;function v(le,ce){if(typeof le!="object"||typeof ce!="object"||!le||!ce)return new $(ce,le!==ce);if(Array.isArray(le)||Array.isArray(ce)){const He=Array.isArray(le)&&Array.isArray(ce)&&D.$tb(le,ce);return new $(ce,!He)}let Pe=!1;for(const He in ce)if(ce.hasOwnProperty(He)){const Ge=v(le[He],ce[He]);Ge.didChange&&(le[He]=Ge.newValue,Pe=!0)}return new $(le,Pe)}class S{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,Pe){return v(ce,Pe)}validate(ce){return this.defaultValue}}class g{constructor(ce,Pe,He,Ge){this.id=ce,this.name=Pe,this.defaultValue=He,this.schema=Ge}applyUpdate(ce,Pe){return v(ce,Pe)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,Pe,He){return He}}function d(le,ce){return typeof le>"u"?ce:le==="false"?!1:!!le}e.boolean=d;class o extends g{constructor(ce,Pe,He,Ge=void 0){typeof Ge<"u"&&(Ge.type="boolean",Ge.default=He),super(ce,Pe,He,Ge)}validate(ce){return d(ce,this.defaultValue)}}function i(le,ce,Pe,He){if(typeof le>"u")return ce;let Ge=parseInt(le,10);return isNaN(Ge)?ce:(Ge=Math.max(Pe,Ge),Ge=Math.min(He,Ge),Ge|0)}e.clampedInt=i;class n extends g{static clampedInt(ce,Pe,He,Ge){return i(ce,Pe,He,Ge)}constructor(ce,Pe,He,Ge,xe,ot=void 0){typeof ot<"u"&&(ot.type="integer",ot.default=He,ot.minimum=Ge,ot.maximum=xe),super(ce,Pe,He,ot),this.minimum=Ge,this.maximum=xe}validate(ce){return n.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function s(le,ce,Pe,He){if(typeof le>"u")return ce;const Ge=a.float(le,ce);return a.clamp(Ge,Pe,He)}e.clampedFloat=s;class a extends g{static clamp(ce,Pe,He){return ce<Pe?Pe:ce>He?He:ce}static float(ce,Pe){if(typeof ce=="number")return ce;if(typeof ce>"u")return Pe;const He=parseFloat(ce);return isNaN(He)?Pe:He}constructor(ce,Pe,He,Ge,xe){typeof xe<"u"&&(xe.type="number",xe.default=He),super(ce,Pe,He,xe),this.validationFn=Ge}validate(ce){return this.validationFn(a.float(ce,this.defaultValue))}}class t extends g{static string(ce,Pe){return typeof ce!="string"?Pe:ce}constructor(ce,Pe,He,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.default=He),super(ce,Pe,He,Ge)}validate(ce){return t.string(ce,this.defaultValue)}}function r(le,ce,Pe,He){return typeof le!="string"?ce:He&&le in He?He[le]:Pe.indexOf(le)===-1?ce:le}e.stringSet=r;class h extends g{constructor(ce,Pe,He,Ge,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.enum=Ge,xe.default=He),super(ce,Pe,He,xe),this.c=Ge}validate(ce){return r(ce,this.defaultValue,this.c)}}class u extends P{constructor(ce,Pe,He,Ge,xe,ot,lt=void 0){typeof lt<"u"&&(lt.type="string",lt.enum=xe,lt.default=Ge),super(ce,Pe,He,lt),this.c=xe,this.d=ot}validate(ce){return typeof ce!="string"?this.defaultValue:this.c.indexOf(ce)===-1?this.defaultValue:this.d(ce)}}function c(le){switch(le){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",tags:["accessibility"],description:w.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,Pe,He){return He===0?ce.accessibilitySupport:He}}class E extends P{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:w.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{insertSpace:d(Pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(Pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(le){le[le.Hidden=0]="Hidden",le[le.Blink=1]="Blink",le[le.Smooth=2]="Smooth",le[le.Phase=3]="Phase",le[le.Expand=4]="Expand",le[le.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function f(le){switch(le){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(le){le[le.Line=1]="Line",le[le.Block=2]="Block",le[le.Underline=3]="Underline",le[le.LineThin=4]="LineThin",le[le.BlockOutline=5]="BlockOutline",le[le.UnderlineThin=6]="UnderlineThin"})(p||(e.TextEditorCursorStyle=p={}));function k(le){switch(le){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function I(le){switch(le){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class j extends S{constructor(){super(140)}compute(ce,Pe,He){const Ge=["monaco-editor"];return Pe.get(39)&&Ge.push(Pe.get(39)),ce.extraEditorClassName&&Ge.push(ce.extraEditorClassName),Pe.get(73)==="default"?Ge.push("mouse-default"):Pe.get(73)==="copy"&&Ge.push("mouse-copy"),Pe.get(110)&&Ge.push("showUnused"),Pe.get(138)&&Ge.push("showDeprecated"),Ge.join(" ")}}class z extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(ce,Pe,He){return He&&ce.emptySelectionClipboard}}class M extends P{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[w.localize(8,null),w.localize(9,null),w.localize(10,null)],description:w.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[w.localize(12,null),w.localize(13,null),w.localize(14,null)],description:w.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:w.localize(16,null),included:m.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:w.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:w.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{cursorMoveOnType:d(Pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":r(Pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":r(Pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(Pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(Pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(Pe.loop,this.defaultValue.loop)}}}class F extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:w.localize(19,null)},{type:"string",description:w.localize(20,null)}],description:w.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?F.OFF:ce==="true"?F.ON:ce:ce?F.ON:F.OFF}}e.EditorFontLigatures=F;class N extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:w.localize(22,null)},{type:"string",description:w.localize(23,null)}],description:w.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?N.OFF:ce==="true"?N.TRANSLATE:ce:ce?N.TRANSLATE:N.OFF}compute(ce,Pe,He){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class O extends S{constructor(){super(50)}compute(ce,Pe,He){return ce.fontInfo}}class W extends g{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(25,null)})}validate(ce){const Pe=a.float(ce,this.defaultValue);return Pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Pe,6,100)}compute(ce,Pe,He){return ce.fontInfo.fontSize}}class x extends P{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.d,maximum:x.e,errorMessage:w.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(n.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,x.d,x.e))}}class ue extends P{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[w.localize(28,null),w.localize(29,null),w.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:w.localize(32,null),...Pe},"editor.gotoLocation.multipleTypeDefinitions":{description:w.localize(33,null),...Pe},"editor.gotoLocation.multipleDeclarations":{description:w.localize(34,null),...Pe},"editor.gotoLocation.multipleImplementations":{description:w.localize(35,null),...Pe},"editor.gotoLocation.multipleReferences":{description:w.localize(36,null),...Pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:He,description:w.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:He,description:w.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:He,description:w.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:He,description:w.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:He,description:w.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{multiple:r(Pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Pe.multipleDefinitions??r(Pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Pe.multipleTypeDefinitions??r(Pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Pe.multipleDeclarations??r(Pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Pe.multipleImplementations??r(Pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Pe.multipleReferences??r(Pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class X extends P{constructor(){const ce={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:w.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:w.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:w.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ce.hidingDelay,description:w.localize(45,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:w.localize(46,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{enabled:d(Pe.enabled,this.defaultValue.enabled),delay:n.clampedInt(Pe.delay,this.defaultValue.delay,0,1e4),sticky:d(Pe.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:d(Pe.above,this.defaultValue.above)}}}var J;(function(le){le[le.None=0]="None",le[le.Text=1]="Text",le[le.Blocks=2]="Blocks"})(J||(e.RenderMinimap=J={}));class Q extends S{constructor(){super(143)}compute(ce,Pe,He){return Q.computeLayout(Pe,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const Pe=ce.height/ce.lineHeight,He=Math.floor(ce.paddingTop/ce.lineHeight);let Ge=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(Ge=Math.max(Ge,Pe-1));const xe=(He+ce.viewLineCount+Ge)/(ce.pixelRatio*ce.height),ot=Math.floor(ce.viewLineCount/xe);return{typicalViewportLineCount:Pe,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Ge,desiredRatio:xe,minimapLineCount:ot}}static c(ce,Pe){const He=ce.outerWidth,Ge=ce.outerHeight,xe=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*Ge),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ge};const ot=Pe.stableMinimapLayoutInput,lt=ot&&ce.outerHeight===ot.outerHeight&&ce.lineHeight===ot.lineHeight&&ce.typicalHalfwidthCharacterWidth===ot.typicalHalfwidthCharacterWidth&&ce.pixelRatio===ot.pixelRatio&&ce.scrollBeyondLastLine===ot.scrollBeyondLastLine&&ce.paddingTop===ot.paddingTop&&ce.paddingBottom===ot.paddingBottom&&ce.minimap.enabled===ot.minimap.enabled&&ce.minimap.side===ot.minimap.side&&ce.minimap.size===ot.minimap.size&&ce.minimap.showSlider===ot.minimap.showSlider&&ce.minimap.renderCharacters===ot.minimap.renderCharacters&&ce.minimap.maxColumn===ot.minimap.maxColumn&&ce.minimap.scale===ot.minimap.scale&&ce.verticalScrollbarWidth===ot.verticalScrollbarWidth&&ce.isViewportWrapping===ot.isViewportWrapping,Ne=ce.lineHeight,St=ce.typicalHalfwidthCharacterWidth,Ht=ce.scrollBeyondLastLine,Kt=ce.minimap.renderCharacters;let vt=xe>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const Ut=ce.minimap.maxColumn,Ot=ce.minimap.size,Gt=ce.minimap.side,Bt=ce.verticalScrollbarWidth,Dt=ce.viewLineCount,Tt=ce.remainingWidth,et=ce.isViewportWrapping,Jt=Kt?2:3;let Wt=Math.floor(xe*Ge);const ut=Wt/xe;let gt=!1,qt=!1,Rt=Jt*vt,kt=vt/xe,mt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:Re,extraLinesBeyondLastLine:Fe,desiredRatio:Ie,minimapLineCount:re}=Q.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Ht,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:Ge,lineHeight:Ne,pixelRatio:xe});if(Dt/re>1)gt=!0,qt=!0,vt=1,Rt=1,kt=vt/xe;else{let Ve=!1,_e=vt+1;if(Ot==="fit"){const Qe=Math.ceil((Re+Dt+Fe)*Rt);et&&lt&&Tt<=Pe.stableFitRemainingWidth?(Ve=!0,_e=Pe.stableFitMaxMinimapScale):Ve=Qe>Wt}if(Ot==="fill"||Ve){gt=!0;const Qe=vt;Rt=Math.min(Ne*xe,Math.max(1,Math.floor(1/Ie))),et&&lt&&Tt<=Pe.stableFitRemainingWidth&&(_e=Pe.stableFitMaxMinimapScale),vt=Math.min(_e,Math.max(1,Math.floor(Rt/Jt))),vt>Qe&&(mt=Math.min(2,vt/Qe)),kt=vt/xe/mt,Wt=Math.ceil(Math.max(Qt,Re+Dt+Fe)*Rt),et?(Pe.stableMinimapLayoutInput=ce,Pe.stableFitRemainingWidth=Tt,Pe.stableFitMaxMinimapScale=vt):(Pe.stableMinimapLayoutInput=null,Pe.stableFitRemainingWidth=0)}}}const Lt=Math.floor(Ut*kt),At=Math.min(Lt,Math.max(0,Math.floor((Tt-Bt-2)*kt/(St+kt)))+e.MINIMAP_GUTTER_WIDTH);let Ct=Math.floor(xe*At);const Je=Ct/xe;Ct=Math.floor(Ct*mt);const Nt=Kt?1:2,jt=Gt==="left"?0:He-At-Bt;return{renderMinimap:Nt,minimapLeft:jt,minimapWidth:At,minimapHeightIsEditorHeight:gt,minimapIsSampling:qt,minimapScale:vt,minimapLineHeight:Rt,minimapCanvasInnerWidth:Ct,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Je,minimapCanvasOuterHeight:ut}}static computeLayout(ce,Pe){const He=Pe.outerWidth|0,Ge=Pe.outerHeight|0,xe=Pe.lineHeight|0,ot=Pe.lineNumbersDigitCount|0,lt=Pe.typicalHalfwidthCharacterWidth,Ne=Pe.maxDigitWidth,St=Pe.pixelRatio,Ht=Pe.viewLineCount,Kt=ce.get(135),vt=Kt==="inherit"?ce.get(134):Kt,Ut=vt==="inherit"?ce.get(130):vt,Ot=ce.get(133),Gt=Pe.isDominatedByLongLines,Bt=ce.get(57),Dt=ce.get(67).renderType!==0,Tt=ce.get(68),et=ce.get(104),Jt=ce.get(83),Wt=ce.get(72),ut=ce.get(102),gt=ut.verticalScrollbarSize,qt=ut.verticalHasArrows,Rt=ut.arrowSize,kt=ut.horizontalScrollbarSize,mt=ce.get(43),Lt=ce.get(109)!=="never";let At=ce.get(65);mt&&Lt&&(At+=16);let Ct=0;if(Dt){const ht=Math.max(ot,Tt);Ct=Math.round(ht*Ne)}let Je=0;Bt&&(Je=xe*Pe.glyphMarginDecorationLaneCount);let Nt=0,jt=Nt+Je,Qt=jt+Ct,Re=Qt+At;const Fe=He-Je-Ct-At;let Ie=!1,re=!1,Te=-1;vt==="inherit"&&Gt?(Ie=!0,re=!0):Ut==="on"||Ut==="bounded"?re=!0:Ut==="wordWrapColumn"&&(Te=Ot);const Ve=Q.c({outerWidth:He,outerHeight:Ge,lineHeight:xe,typicalHalfwidthCharacterWidth:lt,pixelRatio:St,scrollBeyondLastLine:et,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Wt,verticalScrollbarWidth:gt,viewLineCount:Ht,remainingWidth:Fe,isViewportWrapping:re},Pe.memory||new L);Ve.renderMinimap!==0&&Ve.minimapLeft===0&&(Nt+=Ve.minimapWidth,jt+=Ve.minimapWidth,Qt+=Ve.minimapWidth,Re+=Ve.minimapWidth);const _e=Fe-Ve.minimapWidth,Qe=Math.max(1,Math.floor((_e-gt-2)/lt)),st=qt?Rt:0;return re&&(Te=Math.max(1,Qe),Ut==="bounded"&&(Te=Math.min(Te,Ot))),{width:He,height:Ge,glyphMarginLeft:Nt,glyphMarginWidth:Je,glyphMarginDecorationLaneCount:Pe.glyphMarginDecorationLaneCount,lineNumbersLeft:jt,lineNumbersWidth:Ct,decorationsLeft:Qt,decorationsWidth:At,contentLeft:Re,contentWidth:_e,minimap:Ve,viewportColumn:Qe,isWordWrapMinified:Ie,isViewportWrapping:re,wrappingColumn:Te,verticalScrollbarWidth:gt,horizontalScrollbarHeight:kt,overviewRuler:{top:st,width:gt,height:Ge-2*st,right:0}}}}e.EditorLayoutInfoComputer=Q;class he extends P{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[w.localize(47,null),w.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:w.localize(49,null)}})}validate(ce){return r(ce,"simple",["simple","advanced"])}compute(ce,Pe,He){return Pe.get(2)===2?"advanced":He}}class Z extends P{constructor(){const ce={enabled:!0};super(64,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"boolean",default:ce.enabled,description:w.localize(50,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:d(ce.enabled,this.defaultValue.enabled)}}}class ye extends P{constructor(){const ce={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:w.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:10,description:w.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:w.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:w.localize(54,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{enabled:d(Pe.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:d(Pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class de extends P{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:w.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[w.localize(56,null),w.localize(57,null,m.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(58,null,m.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:w.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:w.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:w.localize(62,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return typeof Pe.enabled=="boolean"&&(Pe.enabled=Pe.enabled?"on":"off"),{enabled:r(Pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily),padding:d(Pe.padding,this.defaultValue.padding)}}}class H extends P{constructor(){super(65,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):n.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,Pe,He){return He<0?n.clampedInt(-He*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class U extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>a.clamp(ce,0,150),{markdownDescription:w.localize(63,null)})}compute(ce,Pe,He){return ce.fontInfo.lineHeight}}class ne extends P{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:w.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:w.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)],default:ce.size,description:w.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:w.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:w.localize(71,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:w.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:w.localize(74,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{enabled:d(Pe.enabled,this.defaultValue.enabled),autohide:d(Pe.autohide,this.defaultValue.autohide),size:r(Pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Pe.side,this.defaultValue.side,["right","left"]),showSlider:r(Pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(Pe.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Pe.scale,1,1,3),maxColumn:n.clampedInt(Pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ee(le){return le==="ctrlCmd"?m.$j?"metaKey":"ctrlKey":"altKey"}class fe extends P{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(76,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{top:n.clampedInt(Pe.top,0,0,1e3),bottom:n.clampedInt(Pe.bottom,0,0,1e3)}}}class me extends P{constructor(){const ce={enabled:!0,cycle:!0};super(85,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:w.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:w.localize(78,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{enabled:d(Pe.enabled,this.defaultValue.enabled),cycle:d(Pe.cycle,this.defaultValue.cycle)}}}class ee extends S{constructor(){super(141)}compute(ce,Pe,He){return ce.pixelRatio}}class te extends P{constructor(){const ce={other:"on",comments:"off",strings:"off"},Pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[w.localize(79,null),w.localize(80,null),w.localize(81,null)]}];super(88,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Pe,default:ce.strings,description:w.localize(82,null)},comments:{anyOf:Pe,default:ce.comments,description:w.localize(83,null)},other:{anyOf:Pe,default:ce.other,description:w.localize(84,null)}},default:ce,markdownDescription:w.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const St=ce?"on":"off";return{comments:St,strings:St,other:St}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:Pe,comments:He,strings:Ge}=ce,xe=["on","inline","off"];let ot,lt,Ne;return typeof Pe=="boolean"?ot=Pe?"on":"off":ot=r(Pe,this.defaultValue.other,xe),typeof He=="boolean"?lt=He?"on":"off":lt=r(He,this.defaultValue.comments,xe),typeof Ge=="boolean"?Ne=Ge?"on":"off":Ne=r(Ge,this.defaultValue.strings,xe),{other:ot,comments:lt,strings:Ne}}}var K;(function(le){le[le.Off=0]="Off",le[le.On=1]="On",le[le.Relative=2]="Relative",le[le.Interval=3]="Interval",le[le.Custom=4]="Custom"})(K||(e.RenderLineNumbersType=K={}));class ie extends P{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(86,null),w.localize(87,null),w.localize(88,null),w.localize(89,null)],default:"on",description:w.localize(90,null)})}validate(ce){let Pe=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(Pe=4,He=ce):ce==="interval"?Pe=3:ce==="relative"?Pe=2:ce==="on"?Pe=1:Pe=0),{renderType:Pe,renderFn:He}}}function G(le){const ce=le.get(97);return ce==="editable"?le.get(90):ce!=="on"}e.filterValidationDecorations=G;class ae extends P{constructor(){const ce=[],Pe={type:"number",description:w.localize(91,null)};super(101,"rulers",ce,{type:"array",items:{anyOf:[Pe,{type:["object"],properties:{column:Pe,color:{type:"string",description:w.localize(92,null),format:"color-hex"}}}]},default:ce,description:w.localize(93,null)})}validate(ce){if(Array.isArray(ce)){const Pe=[];for(const He of ce)if(typeof He=="number")Pe.push({column:n.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Ge=He;Pe.push({column:n.clampedInt(Ge.column,0,0,1e4),color:Ge.color})}return Pe.sort((He,Ge)=>He.column-Ge.column),Pe}return this.defaultValue}}class $e extends P{constructor(){super(91,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function Ce(le,ce){if(typeof le!="string")return ce;switch(le){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends P{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(94,null),w.localize(95,null),w.localize(96,null)],default:"auto",description:w.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(98,null),w.localize(99,null),w.localize(100,null)],default:"auto",description:w.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:w.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:w.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:w.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ce.ignoreHorizontalScrollbarInContentHeight,description:w.localize(105,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce,He=n.clampedInt(Pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ge=n.clampedInt(Pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(Pe.vertical,this.defaultValue.vertical),horizontal:Ce(Pe.horizontal,this.defaultValue.horizontal),useShadows:d(Pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(Pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(Pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(Pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(Pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:n.clampedInt(Pe.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Ge,verticalSliderSize:n.clampedInt(Pe.verticalSliderSize,Ge,0,1e3),scrollByPage:d(Pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:d(Pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Y extends P{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:w.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:w.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:w.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:w.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:w.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:w.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:w.localize(112,null)}})}applyUpdate(ce,Pe){let He=!1;Pe.allowedCharacters&&ce&&(T.$in(ce.allowedCharacters,Pe.allowedCharacters)||(ce={...ce,allowedCharacters:Pe.allowedCharacters},He=!0)),Pe.allowedLocales&&ce&&(T.$in(ce.allowedLocales,Pe.allowedLocales)||(ce={...ce,allowedLocales:Pe.allowedLocales},He=!0));const Ge=super.applyUpdate(ce,Pe);return He?new $(Ge.newValue,!0):Ge}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{nonBasicASCII:ge(Pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(Pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(Pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(Pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(Pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ce.allowedLocales,this.defaultValue.allowedLocales)}}c(ce,Pe){if(typeof ce!="object"||!ce)return Pe;const He={};for(const[Ge,xe]of Object.entries(ce))xe===!0&&(He[Ge]=!0);return He}}class se extends P{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:w.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(114,null),w.localize(115,null),w.localize(116,null)],description:w.localize(117,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:w.localize(118,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{enabled:d(Pe.enabled,this.defaultValue.enabled),mode:r(Pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:d(Pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:d(Pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends P{constructor(){const ce={enabled:A.$as.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$as.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:w.localize(119,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:w.localize(120,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{enabled:d(Pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(Pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class _ extends P{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(121,null),w.localize(122,null),w.localize(123,null)],default:ce.bracketPairs,description:w.localize(124,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(125,null),w.localize(126,null),w.localize(127,null)],default:ce.bracketPairsHorizontal,description:w.localize(128,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:w.localize(129,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:w.localize(130,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[w.localize(131,null),w.localize(132,null),w.localize(133,null)],default:ce.highlightActiveIndentation,description:w.localize(134,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{bracketPairs:ge(Pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(Pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(Pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(Pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(Pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(le,ce,Pe){const He=Pe.indexOf(le);return He===-1?ce:Pe[He]}class ve extends P{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(135,null),w.localize(136,null)],default:ce.insertMode,description:w.localize(137,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:w.localize(138,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:w.localize(139,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:w.localize(140,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[w.localize(141,null),w.localize(142,null),w.localize(143,null),w.localize(144,null)],default:ce.selectionMode,markdownDescription:w.localize(145,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:w.localize(146,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:w.localize(147,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:w.localize(148,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:w.localize(149,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:w.localize(150,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(151,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(152,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(153,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(154,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(155,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:w.localize(156,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:w.localize(157,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(158,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(159,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(160,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(161,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(162,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(163,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(164,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(165,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(166,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(167,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(168,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(169,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(170,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(171,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(172,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(173,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(174,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(175,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(176,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(177,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(178,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(179,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(180,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(181,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(182,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{insertMode:r(Pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(Pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(Pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(Pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(Pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(Pe.showIcons,this.defaultValue.showIcons),showStatusBar:d(Pe.showStatusBar,this.defaultValue.showStatusBar),preview:d(Pe.preview,this.defaultValue.preview),previewMode:r(Pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(Pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(Pe.showMethods,this.defaultValue.showMethods),showFunctions:d(Pe.showFunctions,this.defaultValue.showFunctions),showConstructors:d(Pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(Pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(Pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(Pe.showFields,this.defaultValue.showFields),showVariables:d(Pe.showVariables,this.defaultValue.showVariables),showClasses:d(Pe.showClasses,this.defaultValue.showClasses),showStructs:d(Pe.showStructs,this.defaultValue.showStructs),showInterfaces:d(Pe.showInterfaces,this.defaultValue.showInterfaces),showModules:d(Pe.showModules,this.defaultValue.showModules),showProperties:d(Pe.showProperties,this.defaultValue.showProperties),showEvents:d(Pe.showEvents,this.defaultValue.showEvents),showOperators:d(Pe.showOperators,this.defaultValue.showOperators),showUnits:d(Pe.showUnits,this.defaultValue.showUnits),showValues:d(Pe.showValues,this.defaultValue.showValues),showConstants:d(Pe.showConstants,this.defaultValue.showConstants),showEnums:d(Pe.showEnums,this.defaultValue.showEnums),showEnumMembers:d(Pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(Pe.showKeywords,this.defaultValue.showKeywords),showWords:d(Pe.showWords,this.defaultValue.showWords),showColors:d(Pe.showColors,this.defaultValue.showColors),showFiles:d(Pe.showFiles,this.defaultValue.showFiles),showReferences:d(Pe.showReferences,this.defaultValue.showReferences),showFolders:d(Pe.showFolders,this.defaultValue.showFolders),showTypeParameters:d(Pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(Pe.showSnippets,this.defaultValue.showSnippets),showUsers:d(Pe.showUsers,this.defaultValue.showUsers),showIssues:d(Pe.showIssues,this.defaultValue.showIssues)}}}class ze extends P{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(183,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:w.localize(184,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:d(ce.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(le){le[le.None=0]="None",le[le.Same=1]="Same",le[le.Indent=2]="Indent",le[le.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class tt extends P{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[w.localize(185,null),w.localize(186,null),w.localize(187,null),w.localize(188,null)],description:w.localize(189,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,Pe,He){return Pe.get(2)===2?0:He}}class Ye extends S{constructor(){super(144)}compute(ce,Pe,He){const Ge=Pe.get(143);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:Ge.isWordWrapMinified,isViewportWrapping:Ge.isViewportWrapping,wrappingColumn:Ge.wrappingColumn}}}class rt extends P{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:w.localize(190,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:w.localize(191,null),enum:["afterDrop","never"],enumDescriptions:[w.localize(192,null),w.localize(193,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{enabled:d(Pe.enabled,this.defaultValue.enabled),showDropSelector:r(Pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class nt extends P{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:w.localize(194,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:w.localize(195,null),enum:["afterPaste","never"],enumDescriptions:[w.localize(196,null),w.localize(197,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Pe=ce;return{enabled:d(Pe.enabled,this.defaultValue.enabled),showPasteSelector:r(Pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Oe="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:m.$j?Oe:m.$k?qe:Ae,fontWeight:"normal",fontSize:m.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(le){return e.editorOptionsRegistry[le.id]=le,le}var Xe;(function(le){le[le.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",le[le.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",le[le.accessibilitySupport=2]="accessibilitySupport",le[le.accessibilityPageSize=3]="accessibilityPageSize",le[le.ariaLabel=4]="ariaLabel",le[le.ariaRequired=5]="ariaRequired",le[le.autoClosingBrackets=6]="autoClosingBrackets",le[le.autoClosingComments=7]="autoClosingComments",le[le.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",le[le.autoClosingDelete=9]="autoClosingDelete",le[le.autoClosingOvertype=10]="autoClosingOvertype",le[le.autoClosingQuotes=11]="autoClosingQuotes",le[le.autoIndent=12]="autoIndent",le[le.automaticLayout=13]="automaticLayout",le[le.autoSurround=14]="autoSurround",le[le.bracketPairColorization=15]="bracketPairColorization",le[le.guides=16]="guides",le[le.codeLens=17]="codeLens",le[le.codeLensFontFamily=18]="codeLensFontFamily",le[le.codeLensFontSize=19]="codeLensFontSize",le[le.colorDecorators=20]="colorDecorators",le[le.colorDecoratorsLimit=21]="colorDecoratorsLimit",le[le.columnSelection=22]="columnSelection",le[le.comments=23]="comments",le[le.contextmenu=24]="contextmenu",le[le.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",le[le.cursorBlinking=26]="cursorBlinking",le[le.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",le[le.cursorStyle=28]="cursorStyle",le[le.cursorSurroundingLines=29]="cursorSurroundingLines",le[le.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",le[le.cursorWidth=31]="cursorWidth",le[le.disableLayerHinting=32]="disableLayerHinting",le[le.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",le[le.domReadOnly=34]="domReadOnly",le[le.dragAndDrop=35]="dragAndDrop",le[le.dropIntoEditor=36]="dropIntoEditor",le[le.emptySelectionClipboard=37]="emptySelectionClipboard",le[le.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",le[le.extraEditorClassName=39]="extraEditorClassName",le[le.fastScrollSensitivity=40]="fastScrollSensitivity",le[le.find=41]="find",le[le.fixedOverflowWidgets=42]="fixedOverflowWidgets",le[le.folding=43]="folding",le[le.foldingStrategy=44]="foldingStrategy",le[le.foldingHighlight=45]="foldingHighlight",le[le.foldingImportsByDefault=46]="foldingImportsByDefault",le[le.foldingMaximumRegions=47]="foldingMaximumRegions",le[le.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",le[le.fontFamily=49]="fontFamily",le[le.fontInfo=50]="fontInfo",le[le.fontLigatures=51]="fontLigatures",le[le.fontSize=52]="fontSize",le[le.fontWeight=53]="fontWeight",le[le.fontVariations=54]="fontVariations",le[le.formatOnPaste=55]="formatOnPaste",le[le.formatOnType=56]="formatOnType",le[le.glyphMargin=57]="glyphMargin",le[le.gotoLocation=58]="gotoLocation",le[le.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",le[le.hover=60]="hover",le[le.inDiffEditor=61]="inDiffEditor",le[le.inlineSuggest=62]="inlineSuggest",le[le.letterSpacing=63]="letterSpacing",le[le.lightbulb=64]="lightbulb",le[le.lineDecorationsWidth=65]="lineDecorationsWidth",le[le.lineHeight=66]="lineHeight",le[le.lineNumbers=67]="lineNumbers",le[le.lineNumbersMinChars=68]="lineNumbersMinChars",le[le.linkedEditing=69]="linkedEditing",le[le.links=70]="links",le[le.matchBrackets=71]="matchBrackets",le[le.minimap=72]="minimap",le[le.mouseStyle=73]="mouseStyle",le[le.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",le[le.mouseWheelZoom=75]="mouseWheelZoom",le[le.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",le[le.multiCursorModifier=77]="multiCursorModifier",le[le.multiCursorPaste=78]="multiCursorPaste",le[le.multiCursorLimit=79]="multiCursorLimit",le[le.occurrencesHighlight=80]="occurrencesHighlight",le[le.overviewRulerBorder=81]="overviewRulerBorder",le[le.overviewRulerLanes=82]="overviewRulerLanes",le[le.padding=83]="padding",le[le.pasteAs=84]="pasteAs",le[le.parameterHints=85]="parameterHints",le[le.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",le[le.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",le[le.quickSuggestions=88]="quickSuggestions",le[le.quickSuggestionsDelay=89]="quickSuggestionsDelay",le[le.readOnly=90]="readOnly",le[le.readOnlyMessage=91]="readOnlyMessage",le[le.renameOnType=92]="renameOnType",le[le.renderControlCharacters=93]="renderControlCharacters",le[le.renderFinalNewline=94]="renderFinalNewline",le[le.renderLineHighlight=95]="renderLineHighlight",le[le.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",le[le.renderValidationDecorations=97]="renderValidationDecorations",le[le.renderWhitespace=98]="renderWhitespace",le[le.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",le[le.roundedSelection=100]="roundedSelection",le[le.rulers=101]="rulers",le[le.scrollbar=102]="scrollbar",le[le.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",le[le.scrollBeyondLastLine=104]="scrollBeyondLastLine",le[le.scrollPredominantAxis=105]="scrollPredominantAxis",le[le.selectionClipboard=106]="selectionClipboard",le[le.selectionHighlight=107]="selectionHighlight",le[le.selectOnLineNumbers=108]="selectOnLineNumbers",le[le.showFoldingControls=109]="showFoldingControls",le[le.showUnused=110]="showUnused",le[le.snippetSuggestions=111]="snippetSuggestions",le[le.smartSelect=112]="smartSelect",le[le.smoothScrolling=113]="smoothScrolling",le[le.stickyScroll=114]="stickyScroll",le[le.stickyTabStops=115]="stickyTabStops",le[le.stopRenderingLineAfter=116]="stopRenderingLineAfter",le[le.suggest=117]="suggest",le[le.suggestFontSize=118]="suggestFontSize",le[le.suggestLineHeight=119]="suggestLineHeight",le[le.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",le[le.suggestSelection=121]="suggestSelection",le[le.tabCompletion=122]="tabCompletion",le[le.tabIndex=123]="tabIndex",le[le.unicodeHighlighting=124]="unicodeHighlighting",le[le.unusualLineTerminators=125]="unusualLineTerminators",le[le.useShadowDOM=126]="useShadowDOM",le[le.useTabStops=127]="useTabStops",le[le.wordBreak=128]="wordBreak",le[le.wordSeparators=129]="wordSeparators",le[le.wordWrap=130]="wordWrap",le[le.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",le[le.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",le[le.wordWrapColumn=133]="wordWrapColumn",le[le.wordWrapOverride1=134]="wordWrapOverride1",le[le.wordWrapOverride2=135]="wordWrapOverride2",le[le.wrappingIndent=136]="wrappingIndent",le[le.wrappingStrategy=137]="wrappingStrategy",le[le.showDeprecated=138]="showDeprecated",le[le.inlayHints=139]="inlayHints",le[le.editorClassName=140]="editorClassName",le[le.pixelRatio=141]="pixelRatio",le[le.tabFocusMode=142]="tabFocusMode",le[le.layoutInfo=143]="layoutInfo",le[le.wrappingInfo=144]="wrappingInfo",le[le.defaultColorDecorators=145]="defaultColorDecorators",le[le.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",le[le.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(198,null)})),acceptSuggestionOnEnter:Me(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(199,null),""],markdownDescription:w.localize(200,null)})),accessibilitySupport:Me(new l),accessibilityPageSize:Me(new n(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(201,null),tags:["accessibility"]})),ariaLabel:Me(new t(4,"ariaLabel",w.localize(202,null))),ariaRequired:Me(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Me(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:w.localize(203,null),tags:["accessibility"]})),autoClosingBrackets:Me(new h(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(204,null),w.localize(205,null),""],description:w.localize(206,null)})),autoClosingComments:Me(new h(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(207,null),w.localize(208,null),""],description:w.localize(209,null)})),autoClosingDelete:Me(new h(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(210,null),""],description:w.localize(211,null)})),autoClosingOvertype:Me(new h(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(212,null),""],description:w.localize(213,null)})),autoClosingQuotes:Me(new h(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(214,null),w.localize(215,null),""],description:w.localize(216,null)})),autoIndent:Me(new u(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[w.localize(217,null),w.localize(218,null),w.localize(219,null),w.localize(220,null),w.localize(221,null)],description:w.localize(222,null)})),automaticLayout:Me(new o(13,"automaticLayout",!1)),autoSurround:Me(new h(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(223,null),w.localize(224,null),w.localize(225,null),""],description:w.localize(226,null)})),bracketPairColorization:Me(new oe),bracketPairGuides:Me(new _),stickyTabStops:Me(new o(115,"stickyTabStops",!1,{description:w.localize(227,null)})),codeLens:Me(new o(17,"codeLens",!0,{description:w.localize(228,null)})),codeLensFontFamily:Me(new t(18,"codeLensFontFamily","",{description:w.localize(229,null)})),codeLensFontSize:Me(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:w.localize(230,null)})),colorDecorators:Me(new o(20,"colorDecorators",!0,{description:w.localize(231,null)})),colorDecoratorActivatedOn:Me(new h(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[w.localize(232,null),w.localize(233,null),w.localize(234,null)],description:w.localize(235,null)})),colorDecoratorsLimit:Me(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:w.localize(236,null)})),columnSelection:Me(new o(22,"columnSelection",!1,{description:w.localize(237,null)})),comments:Me(new E),contextmenu:Me(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new o(25,"copyWithSyntaxHighlighting",!0,{description:w.localize(238,null)})),cursorBlinking:Me(new u(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:w.localize(239,null)})),cursorSmoothCaretAnimation:Me(new h(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[w.localize(240,null),w.localize(241,null),w.localize(242,null)],description:w.localize(243,null)})),cursorStyle:Me(new u(28,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],I,{description:w.localize(244,null)})),cursorSurroundingLines:Me(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(245,null)})),cursorSurroundingLinesStyle:Me(new h(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(246,null),w.localize(247,null)],markdownDescription:w.localize(248,null)})),cursorWidth:Me(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(249,null)})),disableLayerHinting:Me(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new o(34,"domReadOnly",!1)),dragAndDrop:Me(new o(35,"dragAndDrop",!0,{description:w.localize(250,null)})),emptySelectionClipboard:Me(new z),dropIntoEditor:Me(new rt),stickyScroll:Me(new ye),experimentalWhitespaceRendering:Me(new h(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[w.localize(251,null),w.localize(252,null),w.localize(253,null)],description:w.localize(254,null)})),extraEditorClassName:Me(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Me(new a(40,"fastScrollSensitivity",5,le=>le<=0?5:le,{markdownDescription:w.localize(255,null)})),find:Me(new M),fixedOverflowWidgets:Me(new o(42,"fixedOverflowWidgets",!1)),folding:Me(new o(43,"folding",!0,{description:w.localize(256,null)})),foldingStrategy:Me(new h(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(257,null),w.localize(258,null)],description:w.localize(259,null)})),foldingHighlight:Me(new o(45,"foldingHighlight",!0,{description:w.localize(260,null)})),foldingImportsByDefault:Me(new o(46,"foldingImportsByDefault",!1,{description:w.localize(261,null)})),foldingMaximumRegions:Me(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:w.localize(262,null)})),unfoldOnClickAfterEndOfLine:Me(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(263,null)})),fontFamily:Me(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(264,null)})),fontInfo:Me(new O),fontLigatures2:Me(new F),fontSize:Me(new W),fontWeight:Me(new x),fontVariations:Me(new N),formatOnPaste:Me(new o(55,"formatOnPaste",!1,{description:w.localize(265,null)})),formatOnType:Me(new o(56,"formatOnType",!1,{description:w.localize(266,null)})),glyphMargin:Me(new o(57,"glyphMargin",!0,{description:w.localize(267,null)})),gotoLocation:Me(new ue),hideCursorInOverviewRuler:Me(new o(59,"hideCursorInOverviewRuler",!1,{description:w.localize(268,null)})),hover:Me(new X),inDiffEditor:Me(new o(61,"inDiffEditor",!1)),letterSpacing:Me(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,le=>a.clamp(le,-5,20),{description:w.localize(269,null)})),lightbulb:Me(new Z),lineDecorationsWidth:Me(new H),lineHeight:Me(new U),lineNumbers:Me(new ie),lineNumbersMinChars:Me(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new o(69,"linkedEditing",!1,{description:w.localize(270,null)})),links:Me(new o(70,"links",!0,{description:w.localize(271,null)})),matchBrackets:Me(new h(71,"matchBrackets","always",["always","near","never"],{description:w.localize(272,null)})),minimap:Me(new ne),mouseStyle:Me(new h(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new a(74,"mouseWheelScrollSensitivity",1,le=>le===0?1:le,{markdownDescription:w.localize(273,null)})),mouseWheelZoom:Me(new o(75,"mouseWheelZoom",!1,{markdownDescription:w.localize(274,null)})),multiCursorMergeOverlapping:Me(new o(76,"multiCursorMergeOverlapping",!0,{description:w.localize(275,null)})),multiCursorModifier:Me(new u(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ee,{markdownEnumDescriptions:[w.localize(276,null),w.localize(277,null)],markdownDescription:w.localize(278,null)})),multiCursorPaste:Me(new h(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(279,null),w.localize(280,null)],markdownDescription:w.localize(281,null)})),multiCursorLimit:Me(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:w.localize(282,null)})),occurrencesHighlight:Me(new h(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[w.localize(283,null),w.localize(284,null),w.localize(285,null)],markdownDescription:w.localize(286,null)})),overviewRulerBorder:Me(new o(81,"overviewRulerBorder",!0,{description:w.localize(287,null)})),overviewRulerLanes:Me(new n(82,"overviewRulerLanes",3,0,3)),padding:Me(new fe),pasteAs:Me(new nt),parameterHints:Me(new me),peekWidgetDefaultFocus:Me(new h(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(288,null),w.localize(289,null)],description:w.localize(290,null)})),definitionLinkOpensInPeek:Me(new o(87,"definitionLinkOpensInPeek",!1,{description:w.localize(291,null)})),quickSuggestions:Me(new te),quickSuggestionsDelay:Me(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(292,null)})),readOnly:Me(new o(90,"readOnly",!1)),readOnlyMessage:Me(new $e),renameOnType:Me(new o(92,"renameOnType",!1,{description:w.localize(293,null),markdownDeprecationMessage:w.localize(294,null)})),renderControlCharacters:Me(new o(93,"renderControlCharacters",!0,{description:w.localize(295,null),restricted:!0})),renderFinalNewline:Me(new h(94,"renderFinalNewline",m.$k?"dimmed":"on",["off","on","dimmed"],{description:w.localize(296,null)})),renderLineHighlight:Me(new h(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(297,null)],description:w.localize(298,null)})),renderLineHighlightOnlyWhenFocus:Me(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(299,null)})),renderValidationDecorations:Me(new h(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new h(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(300,null),w.localize(301,null),w.localize(302,null),""],description:w.localize(303,null)})),revealHorizontalRightPadding:Me(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new o(100,"roundedSelection",!0,{description:w.localize(304,null)})),rulers:Me(new ae),scrollbar:Me(new B),scrollBeyondLastColumn:Me(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:w.localize(305,null)})),scrollBeyondLastLine:Me(new o(104,"scrollBeyondLastLine",!0,{description:w.localize(306,null)})),scrollPredominantAxis:Me(new o(105,"scrollPredominantAxis",!0,{description:w.localize(307,null)})),selectionClipboard:Me(new o(106,"selectionClipboard",!0,{description:w.localize(308,null),included:m.$k})),selectionHighlight:Me(new o(107,"selectionHighlight",!0,{description:w.localize(309,null)})),selectOnLineNumbers:Me(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Me(new h(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[w.localize(310,null),w.localize(311,null),w.localize(312,null)],description:w.localize(313,null)})),showUnused:Me(new o(110,"showUnused",!0,{description:w.localize(314,null)})),showDeprecated:Me(new o(138,"showDeprecated",!0,{description:w.localize(315,null)})),inlayHints:Me(new de),snippetSuggestions:Me(new h(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(316,null),w.localize(317,null),w.localize(318,null),w.localize(319,null)],description:w.localize(320,null)})),smartSelect:Me(new ze),smoothScrolling:Me(new o(113,"smoothScrolling",!1,{description:w.localize(321,null)})),stopRenderingLineAfter:Me(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new ve),inlineSuggest:Me(new se),inlineCompletionsAccessibilityVerbose:Me(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:w.localize(322,null)})),suggestFontSize:Me(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(323,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(324,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new o(120,"suggestOnTriggerCharacters",!0,{description:w.localize(325,null)})),suggestSelection:Me(new h(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(326,null),w.localize(327,null),w.localize(328,null)],description:w.localize(329,null)})),tabCompletion:Me(new h(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(330,null),w.localize(331,null),w.localize(332,null)],description:w.localize(333,null)})),tabIndex:Me(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new Y),unusualLineTerminators:Me(new h(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(334,null),w.localize(335,null),w.localize(336,null)],description:w.localize(337,null)})),useShadowDOM:Me(new o(126,"useShadowDOM",!0)),useTabStops:Me(new o(127,"useTabStops",!0,{description:w.localize(338,null)})),wordBreak:Me(new h(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[w.localize(339,null),w.localize(340,null)],description:w.localize(341,null)})),wordSeparators:Me(new t(129,"wordSeparators",R.$bs,{description:w.localize(342,null)})),wordWrap:Me(new h(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(343,null),w.localize(344,null),w.localize(345,null),w.localize(346,null)],description:w.localize(347,null)})),wordWrapBreakAfterCharacters:Me(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(348,null)})),wordWrapOverride1:Me(new h(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new h(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new j),defaultColorDecorators:Me(new o(145,"defaultColorDecorators",!1,{markdownDescription:w.localize(349,null)})),pixelRatio:Me(new ee),tabFocusMode:Me(new o(142,"tabFocusMode",!1,{markdownDescription:w.localize(350,null)})),layoutInfo:Me(new Q),wrappingInfo:Me(new Ye),wrappingIndent:Me(new tt),wrappingStrategy:Me(new he)}}),define(ke[194],Se([9,10]),function(be,e){return be.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,78,2,167,29,177,194]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$ut=e.$tt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$st=e.$rt=e.SymbolKinds=e.SymbolTag=e.$qt=e.$pt=e.SymbolKind=e.$ot=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$nt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$mt=e.$lt=e.$kt=void 0;class b{constructor(F,N,O){this.offset=F,this.type=N,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$kt=b;class y{constructor(F,N){this.tokens=F,this.endState=N,this._tokenizationResultBrand=void 0}}e.$lt=y;class L{constructor(F,N){this.tokens=F,this.endState=N,this._encodedTokenizationResultBrand=void 0}}e.$mt=L;var P;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var $;(function(M){const F=new Map;F.set(0,D.$5j.symbolMethod),F.set(1,D.$5j.symbolFunction),F.set(2,D.$5j.symbolConstructor),F.set(3,D.$5j.symbolField),F.set(4,D.$5j.symbolVariable),F.set(5,D.$5j.symbolClass),F.set(6,D.$5j.symbolStruct),F.set(7,D.$5j.symbolInterface),F.set(8,D.$5j.symbolModule),F.set(9,D.$5j.symbolProperty),F.set(10,D.$5j.symbolEvent),F.set(11,D.$5j.symbolOperator),F.set(12,D.$5j.symbolUnit),F.set(13,D.$5j.symbolValue),F.set(15,D.$5j.symbolEnum),F.set(14,D.$5j.symbolConstant),F.set(15,D.$5j.symbolEnum),F.set(16,D.$5j.symbolEnumMember),F.set(17,D.$5j.symbolKeyword),F.set(27,D.$5j.symbolSnippet),F.set(18,D.$5j.symbolText),F.set(19,D.$5j.symbolColor),F.set(20,D.$5j.symbolFile),F.set(21,D.$5j.symbolReference),F.set(22,D.$5j.symbolCustomColor),F.set(23,D.$5j.symbolFolder),F.set(24,D.$5j.symbolTypeParameter),F.set(25,D.$5j.account),F.set(26,D.$5j.issues);function N(x){let ue=F.get(x);return ue||(console.info("No codicon found for CompletionItemKind "+x),ue=D.$5j.symbolProperty),ue}M.toIcon=N;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function W(x,ue){let X=O.get(x);return typeof X>"u"&&!ue&&(X=9),X}M.fromString=W})($||(e.CompletionItemKinds=$={}));var v;(function(M){M[M.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var S;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var g;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(e.CompletionTriggerKind=g={}));var d;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(d||(e.InlineCompletionTriggerKind=d={}));class o{constructor(F,N,O,W){this.range=F,this.text=N,this.completionKind=O,this.isSnippetText=W}equals(F){return A.$Ds.lift(this.range).equalsRange(F.range)&&this.text===F.text&&this.completionKind===F.completionKind&&this.isSnippetText===F.isSnippetText}}e.$nt=o;var i;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var s;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(s||(e.DocumentHighlightKind=s={}));function a(M){return M&&T.URI.isUri(M.uri)&&A.$Ds.isIRange(M.range)&&(A.$Ds.isIRange(M.originSelectionRange)||A.$Ds.isIRange(M.targetSelectionRange))}e.$ot=a;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$pt={[17]:(0,w.localize)(0,null),[16]:(0,w.localize)(1,null),[4]:(0,w.localize)(2,null),[13]:(0,w.localize)(3,null),[8]:(0,w.localize)(4,null),[9]:(0,w.localize)(5,null),[21]:(0,w.localize)(6,null),[23]:(0,w.localize)(7,null),[7]:(0,w.localize)(8,null),[0]:(0,w.localize)(9,null),[11]:(0,w.localize)(10,null),[10]:(0,w.localize)(11,null),[19]:(0,w.localize)(12,null),[5]:(0,w.localize)(13,null),[1]:(0,w.localize)(14,null),[2]:(0,w.localize)(15,null),[20]:(0,w.localize)(16,null),[15]:(0,w.localize)(17,null),[18]:(0,w.localize)(18,null),[24]:(0,w.localize)(19,null),[3]:(0,w.localize)(20,null),[6]:(0,w.localize)(21,null),[14]:(0,w.localize)(22,null),[22]:(0,w.localize)(23,null),[25]:(0,w.localize)(24,null),[12]:(0,w.localize)(25,null)};function r(M,F){return(0,w.localize)(26,null,M,e.$pt[F])}e.$qt=r;var h;(function(M){M[M.Deprecated=1]="Deprecated"})(h||(e.SymbolTag=h={}));var u;(function(M){const F=new Map;F.set(0,D.$5j.symbolFile),F.set(1,D.$5j.symbolModule),F.set(2,D.$5j.symbolNamespace),F.set(3,D.$5j.symbolPackage),F.set(4,D.$5j.symbolClass),F.set(5,D.$5j.symbolMethod),F.set(6,D.$5j.symbolProperty),F.set(7,D.$5j.symbolField),F.set(8,D.$5j.symbolConstructor),F.set(9,D.$5j.symbolEnum),F.set(10,D.$5j.symbolInterface),F.set(11,D.$5j.symbolFunction),F.set(12,D.$5j.symbolVariable),F.set(13,D.$5j.symbolConstant),F.set(14,D.$5j.symbolString),F.set(15,D.$5j.symbolNumber),F.set(16,D.$5j.symbolBoolean),F.set(17,D.$5j.symbolArray),F.set(18,D.$5j.symbolObject),F.set(19,D.$5j.symbolKey),F.set(20,D.$5j.symbolNull),F.set(21,D.$5j.symbolEnumMember),F.set(22,D.$5j.symbolStruct),F.set(23,D.$5j.symbolEvent),F.set(24,D.$5j.symbolOperator),F.set(25,D.$5j.symbolTypeParameter);function N(O){let W=F.get(O);return W||(console.info("No codicon found for SymbolKind "+O),W=D.$5j.symbolProperty),W}M.toIcon=N})(u||(e.SymbolKinds=u={}));class c{static asEditOperation(F){return m.$Es.replace(A.$Ds.lift(F.range),F.text)}}e.$rt=c;class l{static{this.Comment=new l("comment")}static{this.Imports=new l("imports")}static{this.Region=new l("region")}static fromValue(F){switch(F){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(F)}constructor(F){this.value=F}}e.$st=l;var E;(function(M){function F(N){return!N||typeof N!="object"?!1:typeof N.id=="string"&&typeof N.title=="string"}M.is=F})(E||(e.Command=E={}));var C;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(C||(e.CommentThreadCollapsibleState=C={}));var f;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(f||(e.CommentThreadState=f={}));var p;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(p||(e.CommentMode=p={}));var k;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(k||(e.CommentState=k={}));var I;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(I||(e.InlayHintKind=I={}));class j{constructor(F){this.b=F,this.a=null}dispose(){this.a&&this.a.then(F=>{F&&F.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$tt=j,e.$ut=new R.$ct;var z;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}))}),define(ke[195],Se([9,10]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[196],Se([9,10]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[197],Se([9,10]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(ke[198],Se([9,10]),function(be,e){return be.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[199],Se([9,10]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[200],Se([9,10]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[201],Se([9,10]),function(be,e){return be.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[202],Se([9,10]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(ke[203],Se([9,10]),function(be,e){return be.create("vs/platform/files/common/io",e)}),define(ke[204],Se([9,10]),function(be,e){return be.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[205],Se([9,10]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(ke[206],Se([9,10]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[207],Se([9,10]),function(be,e){return be.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[208],Se([9,10]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(ke[209],Se([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[210],Se([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[211],Se([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[212],Se([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[213],Se([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[214],Se([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[215],Se([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(ke[216],Se([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[217],Se([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[218],Se([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[219],Se([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[220],Se([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[221],Se([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[222],Se([9,10]),function(be,e){return be.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[223],Se([9,10]),function(be,e){return be.create("vs/workbench/common/configuration",e)}),define(ke[224],Se([9,10]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(ke[225],Se([9,10]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(ke[226],Se([9,10]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[227],Se([9,10]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[228],Se([9,10]),function(be,e){return be.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[229],Se([9,10]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[230],Se([9,10]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[231],Se([9,10]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[232],Se([9,10]),function(be,e){return be.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[233],Se([9,10]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[234],Se([9,10]),function(be,e){return be.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[235],Se([9,10]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[236],Se([1,0,8,197]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.TokenType=void 0;var m;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(m||(e.TokenType=m={}));function A(...y){switch(y.length){case 1:return(0,T.localize)(0,null,y[0]);case 2:return(0,T.localize)(1,null,y[0],y[1]);case 3:return(0,T.localize)(2,null,y[0],y[1],y[2]);default:return}}const R=(0,T.localize)(3,null),w=(0,T.localize)(4,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,D.$7)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(L=>L.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const P=this.d,$=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:$};this.g.push({offset:P,lexeme:$,additionalInfo:L}),this.f.push(v)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const P=this.c.substring(this.d,this.e),$=b.b.get(P);$?this.k($):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,P=!1,$=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(w);return}const S=this.c.charCodeAt(L);if(P)P=!1;else if(S===47&&!$){L++;break}else S===91?$=!0:S===92?P=!0:S===93&&($=!1);L++}for(;L<this.c.length&&b.a.has(this.c.charCodeAt(L));)L++;this.e=L;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ui=b}),define(ke[237],Se([1,0,23,39,200,385]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function b(o){return o=o.trim(),o==="*"||R.test(o)}e.$Vo=b;function y(o){if(!b(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$Wo=y;function L(o){if(!o)return null;const i=o.majorBase,n=o.majorMustEqual,s=o.minorBase;let a=o.minorMustEqual;const t=o.patchBase;let r=o.patchMustEqual;o.hasCaret&&(i===0||(a=!1),r=!1);let h=0;if(o.preRelease){const u=w.exec(o.preRelease);if(u){const[,c,l,E]=u;h=Date.UTC(Number(c),Number(l)-1,Number(E))}}return{majorBase:i,majorMustEqual:n,minorBase:s,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:o.hasGreaterEquals,notBefore:h}}e.$Xo=L;function P(o,i,n){let s;typeof o=="string"?s=L(y(o)):s=o;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=L(y(n)):t=n,!s||!t)return!1;const r=s.majorBase,h=s.minorBase,u=s.patchBase;let c=t.majorBase,l=t.minorBase,E=t.patchBase;const C=t.notBefore;let f=t.majorMustEqual,p=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?r>c?!0:r<c?!1:h>l?!0:h<l||a&&a<C?!1:u>=E:(r===1&&c===0&&(!f||!p||!k)&&(c=1,l=0,E=0,f=!0,p=!1,k=!1),r<c?!1:r>c?!f:h<l?!1:h>l?!p:u<E?!1:u>E?!k:!(a&&a<C))}e.$Yo=P;function $(o,i,n,s,a){const t=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return t.push([T.default.Error,m.localize(0,null)]),t;if(typeof s.name!="string")return t.push([T.default.Error,m.localize(1,null,"name")]),t;if(typeof s.version!="string")return t.push([T.default.Error,m.localize(2,null,"version")]),t;if(!s.engines)return t.push([T.default.Error,m.localize(3,null,"engines")]),t;if(typeof s.engines.vscode!="string")return t.push([T.default.Error,m.localize(4,null,"engines.vscode")]),t;if(typeof s.extensionDependencies<"u"&&!d(s.extensionDependencies))return t.push([T.default.Error,m.localize(5,null,"extensionDependencies")]),t;if(typeof s.activationEvents<"u"){if(!d(s.activationEvents))return t.push([T.default.Error,m.localize(6,null,"activationEvents")]),t;if(typeof s.main>"u"&&typeof s.browser>"u")return t.push([T.default.Error,m.localize(7,null,"activationEvents","main","browser")]),t}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&t.push([T.default.Warning,m.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return t.push([T.default.Error,m.localize(9,null,"main")]),t;{const u=(0,D.$Bg)(n,s.main);(0,D.$vg)(u,n)||t.push([T.default.Warning,m.localize(10,null,u.path,n.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return t.push([T.default.Error,m.localize(11,null,"browser")]),t;{const u=(0,D.$Bg)(n,s.browser);(0,D.$vg)(u,n)||t.push([T.default.Warning,m.localize(12,null,u.path,n.path)])}}if(!A.valid(s.version))return t.push([T.default.Error,m.localize(13,null)]),t;const r=[];if(!v(o,i,s,a,r))for(const u of r)t.push([T.default.Error,u]);return t}e.$Zo=$;function v(o,i,n,s,a){return s||typeof n.main>"u"&&typeof n.browser>"u"?!0:g(o,i,n.engines.vscode,a)}e.$1o=v;function S(o,i,n){return o==="*"||g(i,n,o)}e.$2o=S;function g(o,i,n,s=[]){const a=L(y(n));if(!a)return s.push(m.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return s.push(m.localize(15,null,n)),!1}else if(!a.majorMustEqual)return s.push(m.localize(16,null,n)),!1;return P(o,i,a)?!0:(s.push(m.localize(17,null,o,n)),!1)}function d(o){if(!Array.isArray(o))return!1;for(let i=0,n=o.length;i<n;i++)if(typeof o[i]!="string")return!1;return!0}}),define(ke[105],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=void 0;class D{constructor(m,A=[],R=!1){this.ctor=m,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.$Wh=D}),define(ke[106],Se([1,0,105]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=e.InstantiationType=void 0;const T=[];var m;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(m||(e.InstantiationType=m={}));function A(w,b,y){b instanceof D.$Wh||(b=new D.$Wh(b,[],!!y)),T.push([w,b])}e.$Gr=A;function R(){return T}e.$Hr=R}),define(ke[238],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=void 0;class D{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$lq=D;class T{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const R of this.a.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const w=this.lookupOrInsertNode(A),b=this.lookupOrInsertNode(R);w.outgoing.set(b.key,b),b.incoming.set(w.key,w)}removeNode(A){const R=this.b(A);this.a.delete(R);for(const w of this.a.values())w.outgoing.delete(R),w.incoming.delete(R)}lookupOrInsertNode(A){const R=this.b(A);let w=this.a.get(R);return w||(w=new D(R,A),this.a.set(R,w)),w}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[R,w]of this.a)A.push(`${R}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this.a){const w=new Set([A]),b=this.c(R,w);if(b)return b}}c(A,R){for(const[w,b]of A.outgoing){if(R.has(w))return[...R,w].join(" -> ");R.add(w);const y=this.c(b,R);if(y)return y;R.delete(w)}}}e.$mq=T}),define(ke[5],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.$Zh=e.$Yh=e._util=void 0;var D;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function w(b){return b[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=w})(D||(e._util=D={})),e.$Yh=m("instantiationService");function T(R,w,b){w[D.DI_TARGET]===w?w[D.DI_DEPENDENCIES].push({id:R,index:b}):(w[D.DI_DEPENDENCIES]=[{id:R,index:b}],w[D.DI_TARGET]=w)}function m(R){if(D.serviceIds.has(R))return D.serviceIds.get(R);const w=function(b,y,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(w,b,L)};return w.toString=()=>R,D.serviceIds.set(R,w),w}e.$Zh=m;function A(R){return R}e.$1h=A}),define(ke[45],Se([1,0,18,2,5]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.ConfigurationTarget=e.$vi=e.$ui=e.$ti=void 0,e.$ti=(0,m.$Zh)("configurationService");function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof T.URI)}e.$ui=A;function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof T.URI)}e.$vi=R;var w;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function b(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$wi=b;function y(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$xi=y;function L(o,i){const n=Object.create(null);for(const s in o)P(n,s,o[s],i);return n}e.$yi=L;function P(o,i,n,s){const a=i.split("."),t=a.pop();let r=o;for(let h=0;h<a.length;h++){const u=a[h];let c=r[u];switch(typeof c){case"undefined":c=r[u]=Object.create(null);break;case"object":break;default:s(`Ignoring ${i} as ${a.slice(0,h+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[t]=n}catch{s(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}else s(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}e.$zi=P;function $(o,i){const n=i.split(".");v(o,n)}e.$Ai=$;function v(o,i){const n=i.shift();if(i.length===0){delete o[n];return}if(Object.keys(o).indexOf(n)!==-1){const s=o[n];typeof s=="object"&&!Array.isArray(s)&&(v(s,i),Object.keys(s).length===0&&delete o[n])}}function S(o,i,n){function s(r,h){let u=r;for(const c of h){if(typeof u!="object"||u===null)return;u=u[c]}return u}const a=i.split("."),t=s(o,a);return typeof t>"u"?n:t}e.$Bi=S;function g(o,i,n){Object.keys(i).forEach(s=>{s!=="__proto__"&&(s in o?D.$Ef(o[s])&&D.$Ef(i[s])?g(o[s],i[s],n):n&&(o[s]=i[s]):o[s]=i[s])})}e.$Ci=g;function d(o){return o.replace(/[\[\]]/g,"")}e.$Di=d}),define(ke[46],Se([1,0,11,13,236,5,196,8]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.ContextKeyExprType=e.$Vi=void 0;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",D.$j),b.set("isLinux",D.$k),b.set("isWindows",D.$i),b.set("isWeb",D.$o),b.set("isMacNative",D.$j&&!D.$o),b.set("isEdge",D.$H),b.set("isFirefox",D.$F),b.set("isChrome",D.$E),b.set("isSafari",D.$G);function y(H,U){if(b.get(H)!==void 0)throw(0,w.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(H,U)}e.$Vi=y;const L=Object.prototype.hasOwnProperty;var P;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const $={regexParsingWithErrorRecovery:!0},v=(0,R.localize)(0,null),S=(0,R.localize)(1,null),g=(0,R.localize)(2,null),d=(0,R.localize)(3,null),o=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),s=(0,R.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=$){this.k=U,this.d=new m.$Ui,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Ee=this.D(),fe=Ee.type===17?i:void 0;throw this.h.push({message:o,offset:Ee.offset,lexeme:m.$Ui.getLexeme(Ee),additionalInfo:fe}),a.c}return ne}catch(ne){if(ne!==a.c)throw ne;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ne=this.o();U.push(ne)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ne=this.s();U.push(ne)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,d),ne?.negate()}case 17:return this.z(),I.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,d),ne}case 17:{const ne=U.lexeme;if(this.z(),this.y(9)){const fe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),fe.type!==10)throw this.B("REGEX",fe);const me=fe.lexeme,ee=me.lastIndexOf("/"),te=ee===me.length-1?void 0:this.w(me.substring(ee+1));let K;try{K=new RegExp(me.substring(1,ee),te)}catch{throw this.B("REGEX",fe)}return O.create(ne,K)}switch(fe.type){case 10:case 19:{const me=[fe.lexeme];this.z();let ee=this.D(),te=0;for(let $e=0;$e<fe.lexeme.length;$e++)fe.lexeme.charCodeAt($e)===40?te++:fe.lexeme.charCodeAt($e)===41&&te--;for(;!this.E()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let $e=0;$e<ee.lexeme.length;$e++)ee.lexeme.charCodeAt($e)===40?te++:fe.lexeme.charCodeAt($e)===41&&te--}if(te<0)break;me.push(m.$Ui.getLexeme(ee)),this.z(),ee=this.D()}const K=me.join(""),ie=K.lastIndexOf("/"),G=ie===K.length-1?void 0:this.w(K.substring(ie+1));let ae;try{ae=new RegExp(K.substring(1,ie),G)}catch{throw this.B("REGEX",fe)}return t.regex(ne,ae)}case 18:{const me=fe.lexeme;this.z();let ee=null;if(!(0,T.$Fe)(me)){const te=me.indexOf("/"),K=me.lastIndexOf("/");if(te!==K&&te>=0){const ie=me.slice(te+1,K),G=me[K+1]==="i"?"i":"";try{ee=new RegExp(ie,G)}catch{throw this.B("REGEX",fe)}}}if(ee===null)throw this.B("REGEX",fe);return O.create(ne,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,g);const fe=this.u();return t.notIn(ne,fe)}switch(this.D().type){case 3:{this.z();const fe=this.u();if(this.x().type===18)return t.equals(ne,fe);switch(fe){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,fe)}}case 4:{this.z();const fe=this.u();if(this.x().type===18)return t.notEquals(ne,fe);switch(fe){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,fe)}}case 5:return this.z(),F.create(ne,this.u());case 6:return this.z(),N.create(ne,this.u());case 7:return this.z(),z.create(ne,this.u());case 8:return this.z(),M.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:s}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ne){if(this.C(U))return this.z();throw this.B(ne,this.D())}B(U,ne,Ee){const fe=(0,R.localize)(8,null,U,m.$Ui.getLexeme(ne)),me=ne.offset,ee=m.$Ui.getLexeme(ne);return this.h.push({message:fe,offset:me,lexeme:ee,additionalInfo:Ee}),a.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Wi=a;class t{static false(){return c.INSTANCE}static true(){return l.INSTANCE}static has(U){return E.create(U)}static equals(U,ne){return C.create(U,ne)}static notEquals(U,ne){return k.create(U,ne)}static regex(U,ne){return O.create(U,ne)}static in(U,ne){return f.create(U,ne)}static notIn(U,ne){return p.create(U,ne)}static not(U){return I.create(U)}static and(...U){return ue.create(U,null,!0)}static or(...U){return X.create(U,null,!0)}static greater(U,ne){return z.create(U,ne)}static greaterEquals(U,ne){return M.create(U,ne)}static smaller(U,ne){return F.create(U,ne)}static smallerEquals(U,ne){return N.create(U,ne)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Xi=t;function r(H){const U=new a({regexParsingWithErrorRecovery:!1});return H.map(ne=>(U.parse(ne),U.lexingErrors.length>0?U.lexingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?(0,R.localize)(9,null,Ee.additionalInfo):(0,R.localize)(10,null),offset:Ee.offset,length:Ee.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?`${Ee.message}. ${Ee.additionalInfo}`:Ee.message,offset:Ee.offset,length:Ee.lexeme.length})):[]))}e.$Yi=r;function h(H,U){const ne=H?H.substituteConstants():void 0,Ee=U?U.substituteConstants():void 0;return!ne&&!Ee?!0:!ne||!Ee?!1:ne.equals(Ee)}e.$Zi=h;function u(H,U){return H.cmp(U)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return l.INSTANCE}}e.$1i=c;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return c.INSTANCE}}e.$2i=l;class E{static create(U,ne=null){const Ee=b.get(U);return typeof Ee=="boolean"?Ee?l.INSTANCE:c.INSTANCE:new E(U,ne)}constructor(U,ne){this.key=U,this.c=ne,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:Q(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=b.get(this.key);return typeof U=="boolean"?U?l.INSTANCE:c.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$3i=E;class C{static create(U,ne,Ee=null){if(typeof ne=="boolean")return ne?E.create(U,Ee):I.create(U,Ee);const fe=b.get(U);return typeof fe=="boolean"?ne===(fe?"true":"false")?l.INSTANCE:c.INSTANCE:new C(U,ne,Ee)}constructor(U,ne,Ee){this.c=U,this.d=ne,this.f=Ee,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=b.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?l.INSTANCE:c.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$4i=C;class f{static create(U,ne){return new f(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:he(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.f),Ee=U.getValue(this.d);return Array.isArray(ne)?ne.includes(Ee):typeof Ee=="string"&&typeof ne=="object"&&ne!==null?L.call(ne,Ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$5i=f;class p{static create(U,ne){return new p(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=11,this.c=f.create(U,ne)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$6i=p;class k{static create(U,ne,Ee=null){if(typeof ne=="boolean")return ne?I.create(U,Ee):E.create(U,Ee);const fe=b.get(U);return typeof fe=="boolean"?ne===(fe?"true":"false")?c.INSTANCE:l.INSTANCE:new k(U,ne,Ee)}constructor(U,ne,Ee){this.c=U,this.d=ne,this.f=Ee,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=b.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?c.INSTANCE:l.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$7i=k;class I{static create(U,ne=null){const Ee=b.get(U);return typeof Ee=="boolean"?Ee?c.INSTANCE:l.INSTANCE:new I(U,ne)}constructor(U,ne){this.c=U,this.d=ne,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:Q(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=b.get(this.c);return typeof U=="boolean"?U?c.INSTANCE:l.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}e.$8i=I;function j(H,U){if(typeof H=="string"){const ne=parseFloat(H);isNaN(ne)||(H=ne)}return typeof H=="string"||typeof H=="number"?U(H):c.INSTANCE}class z{static create(U,ne,Ee=null){return j(ne,fe=>new z(U,fe,Ee))}constructor(U,ne,Ee){this.c=U,this.d=ne,this.f=Ee,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$9i=z;class M{static create(U,ne,Ee=null){return j(ne,fe=>new M(U,fe,Ee))}constructor(U,ne,Ee){this.c=U,this.d=ne,this.f=Ee,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$0i=M;class F{static create(U,ne,Ee=null){return j(ne,fe=>new F(U,fe,Ee))}constructor(U,ne,Ee){this.c=U,this.d=ne,this.f=Ee,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$$i=F;class N{static create(U,ne,Ee=null){return j(ne,fe=>new N(U,fe,Ee))}constructor(U,ne,Ee){this.c=U,this.d=ne,this.f=Ee,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:he(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$_i=N;class O{static create(U,ne){return new O(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ne=this.f?this.f.source:"",Ee=U.f?U.f.source:"";return ne<Ee?-1:ne>Ee?1:0}equals(U){if(U.type===this.type){const ne=this.f?this.f.source:"",Ee=U.f?U.f.source:"";return this.d===U.d&&ne===Ee}return!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$aj=O;class W{static create(U){return new W(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new W(this.c.map(U))}negate(){return this.c}}e.$bj=W;function x(H){let U=null;for(let ne=0,Ee=H.length;ne<Ee;ne++){const fe=H[ne].substituteConstants();if(H[ne]!==fe&&U===null){U=[];for(let me=0;me<ne;me++)U[me]=H[me]}U!==null&&(U[ne]=fe)}return U===null?H:U}class ue{static create(U,ne,Ee){return ue.d(U,ne,Ee)}constructor(U,ne){this.expr=U,this.c=ne,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,Ee=this.expr.length;ne<Ee;ne++){const fe=u(this.expr[ne],U.expr[ne]);if(fe!==0)return fe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,Ee=this.expr.length;ne<Ee;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=x(this.expr);return U===this.expr?this:ue.create(U,this.c,!1)}evaluate(U){for(let ne=0,Ee=this.expr.length;ne<Ee;ne++)if(!this.expr[ne].evaluate(U))return!1;return!0}static d(U,ne,Ee){const fe=[];let me=!1;for(const ee of U)if(ee){if(ee.type===1){me=!0;continue}if(ee.type===0)return c.INSTANCE;if(ee.type===6){fe.push(...ee.expr);continue}fe.push(ee)}if(fe.length===0&&me)return l.INSTANCE;if(fe.length!==0){if(fe.length===1)return fe[0];fe.sort(u);for(let ee=1;ee<fe.length;ee++)fe[ee-1].equals(fe[ee])&&(fe.splice(ee,1),ee--);if(fe.length===1)return fe[0];for(;fe.length>1;){const ee=fe[fe.length-1];if(ee.type!==9)break;fe.pop();const te=fe.pop(),K=fe.length===0,ie=X.create(ee.expr.map(G=>ue.create([G,te],null,Ee)),null,K);ie&&(fe.push(ie),fe.sort(u))}if(fe.length===1)return fe[0];if(Ee){for(let ee=0;ee<fe.length;ee++)for(let te=ee+1;te<fe.length;te++)if(fe[ee].negate().equals(fe[te]))return c.INSTANCE;if(fe.length===1)return fe[0]}return new ue(fe,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new ue(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());this.c=X.create(U,this,!0)}return this.c}}e.$cj=ue;class X{static create(U,ne,Ee){return X.d(U,ne,Ee)}constructor(U,ne){this.expr=U,this.c=ne,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,Ee=this.expr.length;ne<Ee;ne++){const fe=u(this.expr[ne],U.expr[ne]);if(fe!==0)return fe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,Ee=this.expr.length;ne<Ee;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=x(this.expr);return U===this.expr?this:X.create(U,this.c,!1)}evaluate(U){for(let ne=0,Ee=this.expr.length;ne<Ee;ne++)if(this.expr[ne].evaluate(U))return!0;return!1}static d(U,ne,Ee){let fe=[],me=!1;if(U){for(let ee=0,te=U.length;ee<te;ee++){const K=U[ee];if(K){if(K.type===0){me=!0;continue}if(K.type===1)return l.INSTANCE;if(K.type===9){fe=fe.concat(K.expr);continue}fe.push(K)}}if(fe.length===0&&me)return c.INSTANCE;fe.sort(u)}if(fe.length!==0){if(fe.length===1)return fe[0];for(let ee=1;ee<fe.length;ee++)fe[ee-1].equals(fe[ee])&&(fe.splice(ee,1),ee--);if(fe.length===1)return fe[0];if(Ee){for(let ee=0;ee<fe.length;ee++)for(let te=ee+1;te<fe.length;te++)if(fe[ee].negate().equals(fe[te]))return l.INSTANCE;if(fe.length===1)return fe[0]}return new X(fe,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new X(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());for(;U.length>1;){const ne=U.shift(),Ee=U.shift(),fe=[];for(const me of de(ne))for(const ee of de(Ee))fe.push(ue.create([me,ee],null,!1));U.unshift(X.create(fe,null,!1))}this.c=X.create(U,this,!0)}return this.c}}e.$dj=X;class J extends E{static{this.d=[]}static all(){return J.d.values()}constructor(U,ne,Ee){super(U,null),this.f=ne,typeof Ee=="object"?J.d.push({...Ee,key:U}):Ee!==!0&&J.d.push({key:U,description:Ee,type:ne!=null?typeof ne:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return C.create(this.key,U)}notEqualsTo(U){return k.create(this.key,U)}}e.$ej=J,e.$fj=(0,A.$Zh)("contextKeyService");function Q(H,U){return H<U?-1:H>U?1:0}function he(H,U,ne,Ee){return H<ne?-1:H>ne?1:U<Ee?-1:U>Ee?1:0}function Z(H,U){if(H.type===0||U.type===1)return!0;if(H.type===9)return U.type===9?ye(H.expr,U.expr):!1;if(U.type===9){for(const ne of U.expr)if(Z(H,ne))return!0;return!1}if(H.type===6){if(U.type===6)return ye(U.expr,H.expr);for(const ne of H.expr)if(Z(ne,U))return!0;return!1}return H.equals(U)}e.$gj=Z;function ye(H,U){let ne=0,Ee=0;for(;ne<H.length&&Ee<U.length;){const fe=H[ne].cmp(U[Ee]);if(fe<0)return!1;fe===0&&ne++,Ee++}return ne===H.length}function de(H){return H.type===9?H.expr:[H]}}),define(ke[239],Se([1,0,23,39,198,5,102,11,24]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qv=e.$Pv=e.ConfirmResult=e.$Ov=e.$Nv=e.$Mv=void 0,e.$Mv=(0,A.$Zh)("dialogService");var y;(function(g){g[g.Confirmation=1]="Confirmation",g[g.Prompt=2]="Prompt",g[g.Input=3]="Input"})(y||(y={}));class L{a(d){return this.d(d,y.Confirmation)}b(d){return this.d(d,y.Prompt)}c(d){return this.d(d,y.Input)}d(d,o){const i=[];switch(o){case y.Confirmation:{const n=d;n.primaryButton?i.push(n.primaryButton):i.push((0,m.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,m.localize)(1,null));break}case y.Prompt:{const n=d;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(s=>s.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,m.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,m.localize)(3,null))),i.length===0&&i.push((0,m.localize)(4,null));break}case y.Input:{const n=d;n.primaryButton?i.push(n.primaryButton):i.push((0,m.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,m.localize)(6,null));break}}return i}e(d){if(typeof d=="string")return d;if(typeof d=="number")return d===T.default.Info?"info":d===T.default.Error?"error":d===T.default.Warning?"warning":"none"}f(d,o,i){const n=[...d.buttons??[]];d.cancelButton&&typeof d.cancelButton!="string"&&typeof d.cancelButton!="boolean"&&n.push(d.cancelButton);let s=n[o]?.run({checkboxChecked:i});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:i}}}e.$Nv=L,e.$Ov=(0,A.$Zh)("fileDialogService");var P;(function(g){g[g.SAVE=0]="SAVE",g[g.DONT_SAVE=1]="DONT_SAVE",g[g.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const $=10;function v(g){const d=[];return d.push(...g.slice(0,$).map(o=>typeof o=="string"?o:(0,D.$yg)(o))),g.length>$&&(g.length-$===1?d.push((0,m.localize)(7,null)):d.push((0,m.localize)(8,null,g.length-$))),d.push(""),d.join(`
`)}e.$Pv=v;function S(g,d){const o=(0,b.$en)(g);let i=(o.buttons??[]).map(t=>(0,R.$Jv)(t)),n=(g.buttons||[]).map((t,r)=>r),s=0,a=o.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(w.$k||w.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const r=n[a];n.splice(a,1),n.splice(1,0,r),a=1}w.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),s=i.length-1,typeof t=="string"&&(a=s-1))}else if(w.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const r=n[a];n.splice(a,1),n.push(r),a=i.length-1}}return o.buttons=i,o.defaultId=s,o.cancelId=a,o.noLink=!0,o.title=o.title||d.nameLong,{options:o,buttonIndeces:n}}e.$Qv=S}),define(ke[134],Se([1,0,5]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=void 0,e.$7h=(0,D.$Zh)("environmentService"),e.$8h=(0,D.$1h)(e.$7h)}),define(ke[135],Se([1,0,199,5]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ho=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=void 0,e.$8n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9n=new RegExp(e.$8n),e.$0n="__web_extension",e.$$n="skipWalkthrough",e.$_n="extensionsSync",e.$ao="dependecyOrPackExtensionInstall";function m(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$bo=m;function A(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$co=A;function R(o,i){switch(o){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$do=R;function w(o,i){return i==="web"&&!o.includes("web")}e.$eo=w;function b(o,i,n){return w(i,n)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===n}e.$fo=b;function y(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$go=y;var L;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(L||(e.SortBy=L={}));var P;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var $;(function(o){o.Install="install",o.Uninstall="uninstall"})($||(e.StatisticType=$={}));var v;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$ho=(0,T.$Zh)("extensionGalleryService");var S;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var g;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(g||(e.ExtensionSignaturetErrorCode=g={}));class d extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.$io=d,e.$jo=(0,T.$Zh)("extensionManagementService"),e.$ko="extensionsIdentifiers/disabled",e.$lo="extensionsIdentifiers/enabled",e.$mo=(0,T.$Zh)("IGlobalExtensionEnablementService"),e.$no=(0,T.$Zh)("IExtensionTipsService"),e.$oo=(0,D.localize)(0,null),e.$po={value:e.$oo,original:"Extensions"},e.$qo={value:(0,D.localize)(1,null),original:"Preferences"}}),define(ke[240],Se([1,0,5]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j1b=e.$i1b=void 0,e.$i1b=(0,D.$Zh)("externalTerminal"),e.$j1b="Terminal.app"}),define(ke[241],Se([1,0,50,17,16,11,101,31,104,201,240]),function(be,e,D,T,m,A,R,w,b,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i9b=e.$h9b=e.$g9b=void 0;const P=y.localize(0,null);class ${async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends ${static{this.b="cmd.exe"}openTerminal(s,a){return this.spawnTerminal(D,s,b.$Ll(),a)}spawnTerminal(s,a,t,r){const h=a.windowsExec||v.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const u=m.$mc(h,".exe").toLowerCase();if(u==="cmder")return s.spawn(h,r?[r]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return h.indexOf(" ")>=0&&c.push('""'),c.push(h),u==="wt"&&c.push("-d ."),new Promise((l,E)=>{const C=d(process),f=s.spawn(t,c,{cwd:r,env:C});f.on("error",E),f.on("exit",()=>l())})}runInTerminal(s,a,t,r,h){const u="windowsExec"in h&&h.windowsExec?h.windowsExec:v.getDefaultTerminalWindows();return new Promise((c,l)=>{const E=`"${a} - ${P}"`,C=`""${t.join('" "')}" & pause"`,f=Object.assign({},d(process),r);Object.keys(f).filter(z=>f[z]===null).forEach(z=>delete f[z]);const p={cwd:a,env:f,windowsVerbatimArguments:!0};let k,I;m.$mc(u,".exe")==="wt"?(k=u,I=["-d",".",v.b,"/c",C]):(k=v.b,I=["/c","start",E,"/wait",u,"/c",C]),D.spawn(k,I,p).on("error",z=>{l(o(z))}),c(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return v.d}}e.$g9b=v;class S extends ${static{this.b="/usr/bin/osascript"}openTerminal(s,a){return this.spawnTerminal(D,s,a)}runInTerminal(s,a,t,r,h){const u=h.osxExec||L.$j1b;return new Promise((c,l)=>{if(u===L.$j1b||u==="iTerm.app"){const E=u===L.$j1b?"TerminalHelper":"iTermHelper",f=[T.$ig.asFileUri(`vs/workbench/contrib/externalTerminal/node/${E}.scpt`).fsPath,"-t",s||P,"-w",a];for(const I of t)f.push("-a"),f.push(I);if(r){const I=Object.assign({},d(process),r);for(const j in I){const z=I[j];z===null?(f.push("-u"),f.push(j)):(f.push("-e"),f.push(`${j}=${z}`))}}let p="";const k=D.spawn(S.b,f);k.on("error",I=>{l(o(I))}),k.stderr.on("data",I=>{p+=I.toString()}),k.on("exit",I=>{if(I===0)c(void 0);else if(p){const j=p.split(`
`,1);l(new Error(j[0]))}else l(new Error(y.localize(1,null,E,I)))})}else l(new Error(y.localize(2,null,u)))})}spawnTerminal(s,a,t){const r=a.osxExec||L.$j1b;return new Promise((h,u)=>{const c=["-a",r];t&&c.push(t);const l=d(process),E=s.spawn("/usr/bin/open",c,{cwd:t,env:l});E.on("error",u),E.on("exit",()=>h())})}}e.$h9b=S;class g extends ${static{this.b=y.localize(3,null)}openTerminal(s,a){return this.spawnTerminal(D,s,a)}runInTerminal(s,a,t,r,h){const u=h.linuxExec?Promise.resolve(h.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((c,l)=>{const E=[];u.then(C=>{C.indexOf("gnome-terminal")>=0?E.push("-x"):E.push("-e"),E.push("bash"),E.push("-c");const f=`${i(t)}; echo; read -p "${g.b}" -n1;`;E.push(`''${f}''`);const p=Object.assign({},d(process),r);Object.keys(p).filter(z=>p[z]===null).forEach(z=>delete p[z]);const k={cwd:a,env:p};let I="";const j=D.spawn(C,E,k);j.on("error",z=>{l(o(z))}),j.stderr.on("data",z=>{I+=z.toString()}),j.on("exit",z=>{if(z===0)c(void 0);else if(I){const M=I.split(`
`,1);l(new Error(M[0]))}else l(new Error(y.localize(4,null,C,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!A.$k)g.d=Promise.resolve("xterm");else{const s=await w.Promises.exists("/etc/debian_version");g.d=new Promise(a=>{s?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return g.d}spawnTerminal(s,a,t){const r=a.linuxExec?Promise.resolve(a.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((h,u)=>{r.then(c=>{const l=d(process),E=s.spawn(c,[],{cwd:t,env:l});E.on("error",u),E.on("exit",()=>h())})})}}e.$i9b=g;function d(n){const s={...n.env};return(0,R.$Jl)(s),s}function o(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(y.localize(5,null,n.path)):n}function i(n){let s="";for(const a of n)a.indexOf(" ")>=0?s+='"'+a+'"':s+=a,s+=" ";return s}}),define(ke[32],Se([1,0,77,16,13,18,2,202,5,11,17,43]),function(be,e,D,T,m,A,R,w,b,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileKind=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.FileOperationResult=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileChangeType=e.$Ak=e.FileOperation=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileSystemProviderErrorCode=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderCapabilities=e.$kk=e.FilePermission=e.FileType=e.$jk=e.$ik=void 0,e.$ik=(0,b.$Zh)("fileService");function $(Z){return Z.create===!0}e.$jk=$;var v;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var S;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function g(Z){const ye=Z;return!!ye&&typeof ye.onDidChange=="function"}e.$kk=g;var d;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function o(Z){return!!(Z.capabilities&2)}e.$lk=o;function i(Z){return!!(Z.capabilities&8)}e.$mk=i;function n(Z){return!!(Z.capabilities&131072)}e.$nk=n;function s(Z){return!!(Z.capabilities&4)}e.$ok=s;function a(Z){return!!(Z.capabilities&16)}e.$pk=a;function t(Z){return o(Z)?!!(Z.capabilities&16384):!1}e.$qk=t;function r(Z){return o(Z)?!!(Z.capabilities&32768):!1}e.$rk=r;function h(Z){return!!(Z.capabilities&65536)}e.$sk=h;function u(Z){return!!(Z.capabilities&2048)}e.$tk=u;var c;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class l extends Error{static create(ye,de){const H=new l(ye.toString(),de);return f(H,de),H}constructor(ye,de){super(ye),this.code=de}}e.$uk=l;function E(Z,ye){return l.create(Z,ye)}e.$vk=E;function C(Z){return Z||E((0,w.localize)(0,null),c.Unknown)}e.$wk=C;function f(Z,ye){return Z.name=ye?`${ye} (FileSystemError)`:"FileSystemError",Z}e.$xk=f;function p(Z){if(!Z)return c.Unknown;if(Z instanceof l)return Z.code;const ye=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!ye)return c.Unknown;switch(ye[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.$yk=p;function k(Z){if(Z instanceof N)return Z.fileOperationResult;switch(p(Z)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}e.$zk=k;var I;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class j{constructor(ye,de,H){this.resource=ye,this.operation=de,this.target=H}isOperation(ye){return this.operation===ye}}e.$Ak=j;var z;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class M{static{this.a=null}constructor(ye,de){this.c=de,this.b=void 0,this.d=new P.$U(()=>{const H=D.$6h.forUris(()=>this.c);return H.fill(this.rawAdded.map(U=>[U,!0])),H}),this.f=new P.$U(()=>{const H=D.$6h.forUris(()=>this.c);return H.fill(this.rawUpdated.map(U=>[U,!0])),H}),this.g=new P.$U(()=>{const H=D.$6h.forUris(()=>this.c);return H.fill(this.rawDeleted.map(U=>[U,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of ye){switch(H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}this.b!==M.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(ye,...de){return this.h(ye,{includeChildren:!1},...de)}affects(ye,...de){return this.h(ye,{includeChildren:!0},...de)}h(ye,de,...H){if(!ye)return!1;const U=H.length>0;return!!((!U||H.includes(1))&&(this.d.value.get(ye)||de.includeChildren&&this.d.value.findSuperstr(ye))||(!U||H.includes(0))&&(this.f.value.get(ye)||de.includeChildren&&this.f.value.findSuperstr(ye))||(!U||H.includes(2))&&(this.g.value.findSubstr(ye)||de.includeChildren&&this.g.value.findSuperstr(ye)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ye){return this.b===ye}hasCorrelation(){return typeof this.b=="number"}}e.$Bk=M;function F(Z,ye,de){return!Z||!ye||Z===ye||ye.length>Z.length?!1:(ye.charAt(ye.length-1)!==T.sep&&(ye+=T.sep),de?(0,m.$7e)(Z,ye):Z.indexOf(ye)===0)}e.$Ck=F;class N extends Error{constructor(ye,de,H){super(ye),this.fileOperationResult=de,this.options=H}}e.$Dk=N;class O extends N{constructor(ye,de,H,U){super(ye,de,U),this.fileOperationResult=de,this.size=H}}e.$Ek=O;class W extends N{constructor(ye,de,H){super(ye,2,H),this.stat=de}}e.$Fk=W;var x;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(x||(e.FileOperationResult=x={})),e.$Gk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Hk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ik="files.associations",e.$Jk="files.exclude",e.$Kk="files.readonlyInclude",e.$Lk="files.readonlyExclude",e.$Mk="files.readonlyFromPermissions";var ue;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$Nk="";function X(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}e.$Ok=X;async function J(Z,ye){if(!ye.hasProvider(R.URI.from({scheme:Z.scheme})))return new Promise(de=>{const H=ye.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===Z.scheme&&U.added&&(H.dispose(),de())})})}e.$Pk=J;class Q{static{this.KB=1024}static{this.MB=Q.KB*Q.KB}static{this.GB=Q.MB*Q.KB}static{this.TB=Q.GB*Q.KB}static formatSize(ye){return(0,A.$Gf)(ye)||(ye=0),ye<Q.KB?(0,w.localize)(1,null,ye.toFixed(0)):ye<Q.MB?(0,w.localize)(2,null,(ye/Q.KB).toFixed(2)):ye<Q.GB?(0,w.localize)(3,null,(ye/Q.MB).toFixed(2)):ye<Q.TB?(0,w.localize)(4,null,(ye/Q.GB).toFixed(2)):(0,w.localize)(5,null,(ye/Q.TB).toFixed(2))}}e.$Qk=Q;function he(Z){const ye=typeof Z=="string"||Z?.scheme===L.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===L.Schemas.file?1024*Q.MB:ye?10*Q.MB:y.$o?50*Q.MB:1024*Q.MB}e.$Rk=he}),define(ke[242],Se([1,0,22,8,203,32]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;async function R(L,P,$,v,S,g){let d;try{await w(L,P,$,v,S,g)}catch(o){d=o}finally{d&&S.errorTransformer&&(d=S.errorTransformer(d)),typeof d<"u"&&$.error(d),$.end()}}e.$Wp=R;async function w(L,P,$,v,S,g){b(g);const d=await L.open(P,{create:!1});try{b(g);let o=0,i=0,n=S&&typeof S.length=="number"?S.length:void 0,s=D.$fe.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),a=S&&typeof S.position=="number"?S.position:0,t=0;do i=await L.read(d,a,s.buffer,t,s.byteLength-t),a+=i,t+=i,o+=i,typeof n=="number"&&(n-=i),t===s.byteLength&&(await $.write(v(s)),s=D.$fe.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&b(g)&&y(o,S));if(t>0){let r=t;typeof n=="number"&&(r=Math.min(t,n)),$.write(v(s.slice(0,r)))}}catch(o){throw(0,A.$wk)(o)}finally{await L.close(d)}}function b(L){if(L.isCancellationRequested)throw(0,T.$5)();return!0}function y(L,P){if(typeof P?.limits?.size=="number"&&L>P.limits.size)throw(0,A.$vk)((0,m.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[84],Se([1,0,34,3,16,11,2,32]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.$Yp=void 0;function b(o){return o.recursive===!0}e.$Yp=b;class y extends T.$Rc{static{this.a=5}constructor(i,n,s,a){super(),this.h=i,this.j=n,this.m=s,this.n=a,this.c=this.B(new T.$Sc),this.f=void 0,this.g=0}s(){const i=new T.$Qc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<y.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Zp=y;class L extends y{constructor(i,n,s){super(i,n,s,{type:"node.js",restartOnError:!1})}}e.$1p=L;class P extends y{constructor(i,n,s){super(i,n,s,{type:"universal",restartOnError:!0})}}e.$2p=P;function $(o){return o.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.$3p=$;function v(o){const i=new d;for(const n of o)i.processEvent(n);return i.coalesce()}e.$4p=v;function S(o,i){return typeof i=="string"&&!i.startsWith(D.$Cj)&&!(0,m.$hc)(i)?{base:o,pattern:i}:i}e.$5p=S;function g(o,i){const n=[];for(const s of i)n.push((0,D.$Gj)(S(o,s)));return n}e.$6p=g;class d{constructor(){this.a=new Set,this.b=new Map}c(i){return A.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let s=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?s=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else s=!0;s&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(s=>s.type!==2?(i.push(s),!1):!0).sort((s,a)=>s.resource.fsPath.length-a.resource.fsPath.length).filter(s=>n.some(a=>(0,w.$Ck)(s.resource.fsPath,a,!A.$k))?!1:(n.push(s.resource.fsPath),!0)).concat(i)}}}),define(ke[243],Se([1,0,55,12,21,33,3,76,16,11,23,2,103,31,84]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;class g extends R.$Rc{static{this.a=100}static{this.b=75}constructor(i,n,s,a){super(),this.m=i,this.n=n,this.r=s,this.s=a,this.c=this.B(new T.$ch({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new T.$bh(t=>this.z(t),g.b)),this.g=(0,S.$6p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$6p)(this.m.path,this.m.includes):void 0,this.j=new m.$2d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await v.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await v.Promises.realpath(i.path),i.path===n&&(n=await(0,$.$dq)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(y.$j&&(0,A.$2f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Rc.None;const s=new m.$2d(this.j.token),a=new R.$Qc;try{const t=P.URI.file(this.m.path),r=(0,b.$mc)(i),h=(0,D.watch)(i);a.add((0,R.$Pc)(()=>{h.removeAllListeners(),h.close()})),this.G(`Started watching: '${i}'`);const u=new Set;if(n)try{for(const l of await v.Promises.readdir(i))u.add(l)}catch(l){this.D(l)}const c=new Map;a.add((0,R.$Pc)(()=>{for(const[,l]of c)l.dispose();c.clear()})),h.on("error",(l,E)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${l}, ${E})`),this.dispose()}),h.on("change",(l,E)=>{if(s.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${E}`);let C="";if(E&&(C=E.toString(),y.$j&&(C=(0,w.$yl)(C))),!(!C||l!=="change"&&l!=="rename"))if(n)if(l==="rename"){c.get(C)?.dispose();const f=setTimeout(async()=>{if(c.delete(C),C===r&&!await v.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.C((0,b.$ic)(i,C));if(s.token.isCancellationRequested)return;let k;p?u.has(C)?k=0:(k=1,u.add(C)):(u.delete(C),k=2),this.y({resource:(0,L.$Bg)(t,C),type:k,cId:this.m.correlationId})},g.a);c.set(C,(0,R.$Pc)(()=>clearTimeout(f)))}else{let f;u.has(C)?f=0:(f=1,u.add(C)),this.y({resource:(0,L.$Bg)(t,C),type:f,cId:this.m.correlationId})}else if(l==="rename"||C!==r){const f=setTimeout(async()=>{const p=await v.Promises.exists(i);s.token.isCancellationRequested||(p?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},g.a);a.clear(),a.add((0,R.$Pc)(()=>clearTimeout(f)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await v.Promises.exists(i)&&!s.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.$Pc)(()=>{s.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(s=>s(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(s=>s(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,S.$4p)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(y.$k)return v.Promises.exists(i);try{const n=(0,b.$mc)(i);return(await v.Promises.readdir((0,b.$lc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$gq=g;async function d(o,i,n,s,a=512){const t=await v.Promises.open(o,"r"),r=Buffer.allocUnsafe(a),h=new m.$2d(s);let u,c=!1;const l={path:o,excludes:[],recursive:!1},E=new g(l,C=>{(async()=>{for(const{type:f}of C)if(f===0){if(c)return;c=!0;try{for(;!h.token.isCancellationRequested;){const{bytesRead:p}=await v.Promises.read(t,r,0,a,null);if(!p||h.token.isCancellationRequested)break;i(r.slice(0,p))}}catch(p){u=new Error(p),h.dispose(!0)}finally{c=!1}}})()});return await E.ready,n(),new Promise((C,f)=>{h.token.onCancellationRequested(async()=>{E.dispose();try{await v.Promises.close(t)}catch(p){u=new Error(p)}u?f(u):C()})})}e.$hq=d}),define(ke[244],Se([1,0,4,34,3,11,243]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=void 0;class w extends m.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Rd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Rd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(y){const L=this.j(y),P=L.filter(v=>{const S=this.c.get(v.path);return S?!(0,T.$Kj)(S.request.excludes,v.excludes)||!(0,T.$Kj)(S.request.includes,v.includes):!0}),$=Array.from(this.c.values()).filter(({request:v})=>!L.find(S=>S.path===v.path&&(0,T.$Kj)(S.excludes,v.excludes)&&(0,T.$Kj)(S.includes,v.includes))).map(({request:v})=>v.path);P.length&&this.m(`Request to start watching: ${P.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"}, correlationId: ${typeof v.correlationId=="number"?v.correlationId:"<none>"})`).join(",")}`),$.length&&this.m(`Request to stop watching: ${$.join(",")}`);for(const v of $)this.h(v);for(const v of P)this.g(v)}g(y){const L=new R.$gq(y,$=>this.a.fire($),$=>this.b.fire($),this.f),P={request:y,instance:L};this.c.set(y.path,P)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const L=this.c.get(y);L&&(this.c.delete(y),L.instance.dispose())}j(y){const L=new Map;for(const P of y){const $=A.$k?P.path:P.path.toLowerCase();let v=L.get(P.correlationId);v||(v=new Map,L.set(P.correlationId,v)),v.set($,P)}return Array.from(L.values()).map(P=>Array.from(P.values())).flat()}async setVerboseLogging(y){this.f=y;for(const[,L]of this.c)L.instance.setVerboseLogging(y)}m(y){this.f&&this.b.fire({type:"trace",message:this.n(y)})}n(y,L){return L?`[File Watcher (node.js)] ${y} (path: ${L.request.path})`:`[File Watcher (node.js)] ${y}`}}e.$iq=w}),define(ke[245],Se([1,0,84,244]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=void 0;class m extends D.$1p{constructor(R,w,b){super(R,w,b),this.s()}r(R){return R.add(new T.$iq)}}e.$jq=m}),define(ke[246],Se([1,0,17,81,186,84]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;class R extends A.$2p{constructor(b,y,L){super(b,y,L),this.s()}r(b){const y=b.add(new m.$aq(D.$ig.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(y.onDidProcessExit(({code:L,signal:P})=>this.t(`terminated by itself with code ${L}, signal: ${P}`))),T.ProxyChannel.toService((0,T.$Gh)(y.getChannel("watcher")))}}e.$bq=R}),define(ke[107],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=void 0;class D{constructor(...m){this.a=new Map;for(const[A,R]of m)this.set(A,R)}set(m,A){const R=this.a.get(m);return this.a.set(m,A),R}has(m){return this.a.has(m)}get(m){return this.a.get(m)}}e.$Xh=D}),define(ke[247],Se([1,0,12,8,3,105,238,5,107,75]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$nq=void 0;const L=!1;class P extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class ${constructor(d=new b.$Xh,o=!1,i,n=L){this.f=d,this.g=o,this.h=i,this.i=n,this.o=new Set,this.f.set(w.$Yh,this),this._globalGraph=n?i?._globalGraph??new R.$mq(s=>s):void 0}createChild(d){return new $(d,this.g,this,this.i)}invokeFunction(d,...o){const i=S.traceInvocation(this.i,d);let n=!1;try{return d({get:a=>{if(n)throw(0,T.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...o)}finally{n=!0,i.stop()}}createInstance(d,...o){let i,n;return d instanceof A.$Wh?(i=S.traceCreation(this.i,d.ctor),n=this.j(d.ctor,d.staticArguments.concat(o),i)):(i=S.traceCreation(this.i,d),n=this.j(d,o,i)),i.stop(),n}j(d,o=[],i){const n=w._util.getServiceDependencies(d).sort((t,r)=>t.index-r.index),s=[];for(const t of n){const r=this.m(t.id,i);r||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),s.push(r)}const a=n.length>0?n[0].index:o.length;if(o.length!==a){console.trace(`[createInstance] First service dependency of ${d.name} at position ${a+1} conflicts with ${o.length} static arguments`);const t=a-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,a)}return Reflect.construct(d,o.concat(s))}k(d,o){if(this.f.get(d)instanceof A.$Wh)this.f.set(d,o);else if(this.h)this.h.k(d,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const o=this.f.get(d);return!o&&this.h?this.h.l(d):o}m(d,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const i=this.l(d);return i instanceof A.$Wh?this.q(d,i,o.branch(d,!0)):(o.branch(d,!1),i)}q(d,o,i){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,o,i)}finally{this.o.delete(d)}}r(d,o,i){const n=new R.$mq(t=>t.id.toString());let s=0;const a=[{id:d,desc:o,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),s++>1e3)throw new P(n);for(const r of w._util.getServiceDependencies(t.desc.ctor)){const h=this.l(r.id);if(h||this.u(`[createInstance] ${d} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),h instanceof A.$Wh){const u={id:r.id,desc:h,_trace:t._trace.branch(r.id,!0)};n.insertEdge(t,u),a.push(u)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new P(n);break}for(const{data:r}of t){if(this.l(r.id)instanceof A.$Wh){const u=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,u)}n.removeNode(r)}}return this.l(d)}s(d,o,i=[],n,s){if(this.f.get(d)instanceof A.$Wh)return this.t(d,o,i,n,s);if(this.h)return this.h.s(d,o,i,n,s);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(d,o,i=[],n,s){if(n){const a=new $(void 0,this.g,this,this.i);a.c=String(d);const t=new Map,r=new D.$gh(()=>{const h=a.j(o,i,s);for(const[u,c]of t){const l=h[u];if(typeof l=="function")for(const E of c)l.apply(h,E)}return t.clear(),h});return new Proxy(Object.create(null),{get(h,u){if(!r.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let E=t.get(u);return E||(E=new y.$2c,t.set(u,E)),(f,p,k)=>{const I=E.push([f,p,k]);return(0,m.$Pc)(I)}}if(u in h)return h[u];const c=r.value;let l=c[u];return typeof l!="function"||(l=l.bind(c),h[u]=l),l},set(h,u,c){return r.value[u]=c,!0},getPrototypeOf(h){return o.prototype}})}else return this.j(o,i,s)}u(d,o){if(o&&console.warn(d),this.g)throw new Error(d)}}e.$nq=$;var v;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(v||(v={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,o){return d?new S(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(d,o){return d?new S(1,o.name):S.c}static{this.f=0}constructor(d,o){this.type=d,this.name=o,this.g=Date.now(),this.h=[]}branch(d,o){const i=new S(3,d.toString());return this.h.push([d,o,i]),i}stop(){const d=Date.now()-this.g;S.f+=d;let o=!1;function i(s,a){const t=[],r=new Array(s+1).join("	");for(const[h,u,c]of a.h)if(u&&c){o=!0,t.push(`${r}CREATES -> ${h}`);const l=i(s+1,c);l&&t.push(l)}else t.push(`${r}uses -> ${h}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(d>2||o)&&S.all.add(n.join(`
`))}}e.$oq=S}),define(ke[14],Se([1,0,44,4,52,3,28,11,23,18,2,46,5]),function(be,e,D,T,m,A,R,w,b,y,L,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.log=e.$kj=e.LogLevel=e.$jj=e.$ij=e.$hj=void 0,e.$hj=(0,$.$Zh)("logService"),e.$ij=(0,$.$Zh)("loggerService");function v(){return new Date().toISOString()}function S(f){return(0,y.$Gf)(f)}e.$jj=S;var g;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$kj=g.Info;function d(f,p,k){switch(p){case g.Trace:f.trace(k);break;case g.Debug:f.debug(k);break;case g.Info:f.info(k);break;case g.Warning:f.warn(k);break;case g.Error:f.error(k);break;case g.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=d;function o(f,p=!1){let k="";for(let I=0;I<f.length;I++){let j=f[I];if(j instanceof Error&&(j=(0,D.$Ki)(j,p)),typeof j=="object")try{j=JSON.stringify(j)}catch{}k+=(I>0?" ":"")+j}return k}class i extends A.$Rc{constructor(){super(...arguments),this.b=e.$kj,this.c=this.B(new T.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==g.Off&&this.b<=p}}e.$mj=i;class n extends i{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...k){this.f(g.Trace)&&this.g(g.Trace,o([p,...k],!0))}debug(p,...k){this.f(g.Debug)&&this.g(g.Debug,o([p,...k]))}info(p,...k){this.f(g.Info)&&this.g(g.Info,o([p,...k]))}warn(p,...k){this.f(g.Warning)&&this.g(g.Warning,o([p,...k]))}error(p,...k){if(this.f(g.Error))if(p instanceof Error){const I=Array.prototype.slice.call(arguments);I[0]=p.stack,this.g(g.Error,o(I))}else this.g(g.Error,o([p,...k]))}flush(){}}e.$nj=n;class s extends i{constructor(p=e.$kj){super(),this.setLevel(p),this.g=!w.$i}trace(p,...k){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...k):console.log(`[main ${v()}]`,p,...k))}debug(p,...k){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...k):console.log(`[main ${v()}]`,p,...k))}info(p,...k){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...k):console.log(`[main ${v()}]`,p,...k))}warn(p,...k){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,p,...k):console.warn(`[main ${v()}]`,p,...k))}error(p,...k){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,p,...k):console.error(`[main ${v()}]`,p,...k))}dispose(){}flush(){}}e.$oj=s;class a extends i{constructor(p=e.$kj,k=!0){super(),this.g=k,this.setLevel(p)}trace(p,...k){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...k):console.log(p,...k))}debug(p,...k){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...k):console.log(p,...k))}info(p,...k){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...k):console.log(p,...k))}warn(p,...k){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...k):console.log(p,...k))}error(p,...k){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...k):console.error(p,...k))}dispose(){}flush(){}}e.$pj=a;class t extends i{constructor(p,k=e.$kj){super(),this.g=p,this.setLevel(k)}trace(p,...k){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(p),...k])}debug(p,...k){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(p),...k])}info(p,...k){this.f(g.Info)&&this.g.log(g.Info,[this.h(p),...k])}warn(p,...k){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(p),...k])}error(p,...k){this.f(g.Error)&&this.g.log(g.Error,[this.h(p),...k])}h(p){return typeof p=="string"?p:(0,D.$Ki)(p,this.f(g.Trace))}dispose(){}flush(){}}e.$qj=t;class r extends i{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const k of this.g)k.setLevel(p);super.setLevel(p)}trace(p,...k){for(const I of this.g)I.trace(p,...k)}debug(p,...k){for(const I of this.g)I.debug(p,...k)}info(p,...k){for(const I of this.g)I.info(p,...k)}warn(p,...k){for(const I of this.g)I.warn(p,...k)}error(p,...k){for(const I of this.g)I.error(p,...k)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose()}}e.$rj=r;class h extends A.$Rc{constructor(p,k,I){if(super(),this.h=p,this.j=k,this.b=new R.$zc,this.c=this.B(new T.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Rd),this.onDidChangeVisibility=this.g.event,I)for(const j of I)this.b.set(j.resource,{logger:void 0,info:j})}m(p){return(0,y.$Cf)(p)?[...this.b.values()].find(k=>k.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,k){const I=this.n(p),j=(0,y.$Cf)(p)?p:k?.id??(0,m.$Ni)(I.toString()).toString(16);let z=this.b.get(I)?.logger;const M=k?.logLevel==="always"?g.Trace:k?.logLevel;z||(z=this.s(I,M??this.getLogLevel(I)??this.h,{...k,id:j}));const F={logger:z,info:{resource:I,id:j,logLevel:M,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(F.info),this.b.set(I,F),z}n(p){return(0,y.$Cf)(p)?(0,b.$Bg)(this.j,`${p}.log`):p}setLogLevel(p,k){if(L.URI.isUri(p)){const I=p,j=k,z=this.b.get(I);z&&j!==z.info.logLevel&&(z.info.logLevel=j===this.h?void 0:j,z.logger?.setLevel(j),this.b.set(z.info.resource,z),this.f.fire([I,j]))}else{this.h=p;for(const[I,j]of this.b.entries())this.b.get(I)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,k){const I=this.m(p);I&&k!==!I.info.hidden&&(I.info.hidden=!k,this.b.set(I.info.resource,I),this.g.fire([I.info.resource,k]))}getLogLevel(p){let k;return p&&(k=this.b.get(p)?.info.logLevel),k??this.h}registerLogger(p){const k=this.b.get(p.resource);k?k.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const k=this.b.get(p);k&&(k.logger&&k.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$sj=h;class u{constructor(){this.onDidChangeLogLevel=new T.$Rd().event}setLevel(p){}getLevel(){return g.Info}trace(p,...k){}debug(p,...k){}info(p,...k){}warn(p,...k){}error(p,...k){}critical(p,...k){}dispose(){}flush(){}}e.$tj=u;class c extends u{}e.$uj=c;function l(f){if(f.verbose)return g.Trace;if(typeof f.logLevel=="string"){const p=C(f.logLevel.toLowerCase());if(p!==void 0)return p}return e.$kj}e.$vj=l;function E(f){switch(f){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}e.$wj=E;function C(f){switch(f){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$xj=C,e.$yj=new P.$ej("logLevel",E(g.Info))}),define(ke[248],Se([1,0,19,12,8,4,3,16,84,14]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;class L extends R.$Rc{constructor($,v){super(),this.a=$,this.b=v,this.c=this.B(new A.$Rd),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Rd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new T.$Xg(0)),this.w=[],this.y=this.B(new T.$Xg(0))}watch($,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n($,v):this.z($,v)}n($,v){const S={path:this.H($),excludes:v.excludes,includes:v.includes,recursive:v.recursive,correlationId:v.correlationId},g=(0,D.$Tb)(this.j,S);return this.r(),(0,R.$Pc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,m.$Z)($))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,b.$3p)(v)),v=>this.G(v),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const v of this.j)(0,b.$Yp)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const v of this.j)(0,b.$Yp)(v)&&$.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,v){const S={path:this.H($),excludes:v.excludes,includes:v.includes,recursive:!1,correlationId:v.correlationId},g=(0,D.$Tb)(this.w,S);return this.C(),(0,R.$Pc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,m.$Z)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,b.$3p)($)),$=>this.G($),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}H($){return(0,w.$gc)($.fsPath)}}e.$7p=L}),define(ke[249],Se([1,0,55,386,12,28,22,4,33,3,16,11,23,98,31,204,32,242,248,44,246,245]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0,(()=>{try{(0,T.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,n.$Ki)(r)}`)}})();class t extends i.$7p{static{this.I=!1}constructor(h,u){super(h,u),this.onDidChangeCapabilities=w.Event.None,this.N=new A.$zc(c=>$.$sg.getComparisonKey(c)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,P.$k&&(this.J|=1024)),this.J}async stat(h){try{const{stat:u,symbolicLink:c}=await S.SymlinkSupport.stat(this.H(h));return{type:this.M(u,c),ctime:u.birthtime.getTime(),mtime:u.mtime.getTime(),size:u.size,permissions:u.mode&128?void 0:d.FilePermission.Locked}}catch(u){throw this.fb(u)}}async L(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const u=await S.Promises.readdir(this.H(h),{withFileTypes:!0}),c=[];return await Promise.all(u.map(async l=>{try{let E;l.isSymbolicLink()?E=(await this.stat((0,$.$Bg)(h,l.name))).type:E=this.M(l),c.push([l.name,E])}catch(E){this.a.trace(E)}})),c}catch(u){throw this.fb(u)}}M(h,u){let c;return u?.dangling?c=d.FileType.Unknown:h.isFile()?c=d.FileType.File:h.isDirectory()?c=d.FileType.Directory:c=d.FileType.Unknown,u&&(c|=d.FileType.SymbolicLink),c}async O(h){const u=this.H(h);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${u})`);let c;for(;c=this.N.get(h);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${u})`),await c.wait();const l=new m.$Yg;return this.N.set(h,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${u})`),(0,y.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${u})`),this.N.get(h)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${u})`),this.N.delete(h)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${u})`),l.open()})}async readFile(h,u){let c;try{u?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(h)})`),c=await this.O(h));const l=this.H(h);return await S.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{c?.dispose()}}P(h){t.I&&this.a.trace(h)}readFileStream(h,u,c){const l=(0,v.$6d)(E=>R.$fe.concat(E.map(C=>R.$fe.wrap(C))).buffer);return(0,o.$Wp)(this,h,l,E=>E.buffer,{...u,bufferSize:256*1024},c),l}async writeFile(h,u,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.Q(h)?this.R(h,(0,$.$Bg)((0,$.$Ag)(h),`${(0,$.$yg)(h)}${c.atomic.postfix}`),u,c):this.S(h,u,c)}async Q(h){try{const u=this.H(h),{symbolicLink:c}=await S.SymlinkSupport.stat(u);if(c)return!1}catch{}return!0}async R(h,u,c,l){const E=new y.$Qc;try{E.add(await this.O(h)),E.add(await this.O(u)),await this.S(u,c,l,!0);try{await this.rename(u,h,{overwrite:!0})}catch(C){try{await this.delete(u,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{E.dispose()}}async S(h,u,c,l){let E;try{const C=this.H(h);if(!c.create||!c.overwrite){if(await S.Promises.exists(C)){if(!c.overwrite)throw(0,d.$vk)((0,g.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,d.$vk)((0,g.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}E=await this.open(h,{create:!0,unlock:c.unlock},l),await this.write(E,0,u,0,u.byteLength)}catch(C){throw await this.gb(h,C)}finally{typeof E=="number"&&await this.close(E)}}static{this.Y=!0}static configureFlushOnWrite(h){t.Y=h}async open(h,u,c){const l=this.H(h);let E;(0,d.$jk)(u)&&!c&&(E=await this.O(h));let C;try{if((0,d.$jk)(u)&&u.unlock)try{const{stat:p}=await S.SymlinkSupport.stat(l);p.mode&128||await S.Promises.chmod(l,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let f;if((0,d.$jk)(u)){if(P.$i)try{await S.Promises.truncate(l,0),f="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}f||(f="w")}else f="r";C=await S.Promises.open(l,f)}catch(f){throw E?.dispose(),(0,d.$jk)(u)?await this.gb(h,f):this.fb(f)}if(this.U.set(C,0),(0,d.$jk)(u)&&this.X.set(C,h),E){const f=this.W.get(C);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${l})`),this.W.set(C,E),f&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${l})`),f.dispose())}return C}async close(h){const u=this.W.get(h);try{if(this.U.delete(h),this.X.delete(h)&&t.Y)try{await S.Promises.fdatasync(h)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await S.Promises.close(h)}catch(c){throw this.fb(c)}finally{u&&(this.W.get(h)===u&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.W.delete(h)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),u.dispose())}}async read(h,u,c,l,E){const C=this.Z(h,u);let f=null;try{f=(await S.Promises.read(h,c,l,E,C)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(h,C,f)}return f}Z(h,u){return u===this.U.get(h)?null:u}$(h,u,c){const l=this.U.get(h);typeof l=="number"&&(typeof u=="number"||(typeof c=="number"?this.U.set(h,l+c):this.U.delete(h)))}async write(h,u,c,l,E){return(0,m.$hh)(()=>this.ab(h,u,c,l,E),100,3)}async ab(h,u,c,l,E){const C=this.Z(h,u);let f=null;try{f=(await S.Promises.write(h,c,l,E,C)).bytesWritten}catch(p){throw await this.gb(this.X.get(h),p)}finally{this.$(h,C,f)}return f}async mkdir(h){try{await S.Promises.mkdir(this.H(h))}catch(u){throw this.fb(u)}}async delete(h,u){try{const c=this.H(h);if(u.recursive){let l;u?.atomic!==!1&&u.atomic.postfix&&(l=(0,L.$ic)((0,L.$lc)(c),`${(0,L.$mc)(c)}${u.atomic.postfix}`)),await S.Promises.rm(c,S.RimRafMode.MOVE,l)}else try{await S.Promises.unlink(c)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let E=!1;try{const{stat:C,symbolicLink:f}=await S.SymlinkSupport.stat(c);E=C.isDirectory()&&!f}catch{}if(E)await S.Promises.rmdir(c);else throw l}else throw l}}catch(c){throw this.fb(c)}}async rename(h,u,c){const l=this.H(h),E=this.H(u);if(l!==E)try{await this.bb(h,u,"move",c.overwrite),await S.Promises.rename(l,E)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,g.localize)(2,null,(0,L.$mc)(l),(0,L.$mc)((0,L.$lc)(E)),C.toString()))),this.fb(C)}}async copy(h,u,c){const l=this.H(h),E=this.H(u);if(l!==E)try{await this.bb(h,u,"copy",c.overwrite),await S.Promises.copy(l,E,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,g.localize)(3,null,(0,L.$mc)(l),(0,L.$mc)((0,L.$lc)(E)),C.toString()))),this.fb(C)}}async bb(h,u,c,l){const E=this.H(h),C=this.H(u);let f=!1;if(!!(this.capabilities&1024)||(f=(0,b.$1f)(E,C,!0)),f){if(c==="copy")throw(0,d.$vk)((0,g.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const k=await this.L(h);if(!k)throw(0,d.$vk)((0,g.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const I=await this.L(u);if(I){if(!l)throw(0,d.$vk)((0,g.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);k.type&d.FileType.File&&I.type&d.FileType.File||await this.delete(u,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,u){return this.cb(h,u,!1)}async cb(h,u,c){const l=this.H(h),E=this.H(u),C=!!(this.capabilities&1024);if((0,b.$1f)(l,E,!C))return;const f=new y.$Qc;try{f.add(await this.O(h)),f.add(await this.O(u)),c&&await S.Promises.mkdir((0,L.$lc)(E),{recursive:!0}),await S.Promises.copyFile(l,E)}catch(p){if(p.code==="ENOENT"&&!c)return this.cb(h,u,!0);throw this.fb(p)}finally{f.dispose()}}t(h,u,c){return new s.$bq(l=>h(l),l=>u(l),c)}F(h,u,c){return new a.$jq(l=>h(l),l=>u(l),c)}fb(h){if(h instanceof d.$uk)return h;let u=h,c;switch(h.code){case"ENOENT":c=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":u=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=d.FileSystemProviderErrorCode.Unknown;break;default:c=d.FileSystemProviderErrorCode.Unknown}return(0,d.$vk)(u,c)}async gb(h,u){let c=this.fb(u);if(h&&c.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await S.SymlinkSupport.stat(this.H(h));l.mode&128||(c=(0,d.$vk)(u,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return c}}e.$kq=t}),define(ke[250],Se([1,0,3,14]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2N=void 0;class m extends D.$Rc{constructor(R,w=[]){super(),this.a=new T.$rj([R,...w]),this.B(R.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...w){this.a.trace(R,...w)}debug(R,...w){this.a.debug(R,...w)}info(R,...w){this.a.info(R,...w)}warn(R,...w){this.a.warn(R,...w)}error(R,...w){this.a.error(R,...w)}flush(){this.a.flush()}}e.$2N=m}),define(ke[251],Se([1,0,32,14]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QN=void 0;var m;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(m||(m={}));async function A(y,L,P,$,v){try{const S=await new Promise((d,o)=>{be(["@vscode/spdlog"],d,o)});S.setFlushOn(m.Trace);const g=await S.createAsyncRotatingLogger(y,L,P,$);return v?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(S){console.error(S)}return null}function R(y,L,P){switch(L){case T.LogLevel.Trace:y.trace(P);break;case T.LogLevel.Debug:y.debug(P);break;case T.LogLevel.Info:y.info(P);break;case T.LogLevel.Warning:y.warn(P);break;case T.LogLevel.Error:y.error(P);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function w(y,L){switch(L){case T.LogLevel.Trace:y.setLevel(m.Trace);break;case T.LogLevel.Debug:y.setLevel(m.Debug);break;case T.LogLevel.Info:y.setLevel(m.Info);break;case T.LogLevel.Warning:y.setLevel(m.Warning);break;case T.LogLevel.Error:y.setLevel(m.Error);break;case T.LogLevel.Off:y.setLevel(m.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class b extends T.$nj{constructor(L,P,$,v,S){super(),this.m=[],this.setLevel(S),this.n=this.s(L,P,$,v),this.B(this.onDidChangeLogLevel(g=>{this.r&&w(this.r,g)}))}async s(L,P,$,v){const S=$?6:1,g=30/S*D.$Qk.MB,d=await A(L,P,g,S,v);if(d){this.r=d,w(this.r,this.getLevel());for(const{level:o,message:i}of this.m)R(this.r,o,i);this.m=[]}}g(L,P){this.r?R(this.r,L,P):this.getLevel()<=L&&this.m.push({level:L,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$QN=b}),define(ke[136],Se([1,0,39,205,5]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var R;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(b){function y(S,g){return g-S}b.compare=y;const L=Object.create(null);L[b.Error]=(0,T.localize)(0,null),L[b.Warning]=(0,T.localize)(1,null),L[b.Info]=(0,T.localize)(2,null);function P(S){return L[S]||""}b.toString=P;function $(S){switch(S){case D.default.Error:return b.Error;case D.default.Warning:return b.Warning;case D.default.Info:return b.Info;case D.default.Ignore:return b.Hint}}b.fromSeverity=$;function v(S){switch(S){case b.Error:return D.default.Error;case b.Warning:return D.default.Warning;case b.Info:return D.default.Info;case b.Hint:return D.default.Ignore}}b.toSeverity=v}(R||(e.MarkerSeverity=R={}));var w;(function(b){const y="";function L($){return P($,!0)}b.makeKey=L;function P($,v){const S=[y];return $.source?S.push($.source.replace("\xA6","\\\xA6")):S.push(y),$.code?typeof $.code=="string"?S.push($.code.replace("\xA6","\\\xA6")):S.push($.code.value.replace("\xA6","\\\xA6")):S.push(y),$.severity!==void 0&&$.severity!==null?S.push(R.toString($.severity)):S.push(y),$.message&&v?S.push($.message.replace("\xA6","\\\xA6")):S.push(y),$.startLineNumber!==void 0&&$.startLineNumber!==null?S.push($.startLineNumber.toString()):S.push(y),$.startColumn!==void 0&&$.startColumn!==null?S.push($.startColumn.toString()):S.push(y),$.endLineNumber!==void 0&&$.endLineNumber!==null?S.push($.endLineNumber.toString()):S.push(y),$.endColumn!==void 0&&$.endColumn!==null?S.push($.endColumn.toString()):S.push(y),S.push(y),S.join("\xA6")}b.makeKeyOptionalMessage=P})(w||(e.IMarkerData=w={})),e.$jt=(0,m.$Zh)("markerService")}),define(ke[252],Se([1,0,4,39,5]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_u=e.$$u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$0u=e.Severity=void 0,e.Severity=T.default,e.$0u=(0,m.$Zh)("notificationService");var A;(function(L){L[L.DEFAULT=0]="DEFAULT",L[L.SILENT=1]="SILENT",L[L.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var R;(function(L){L[L.WORKSPACE=0]="WORKSPACE",L[L.PROFILE=1]="PROFILE",L[L.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var w;(function(L){L[L.OFF=0]="OFF",L[L.SILENT=1]="SILENT",L[L.ERROR=2]="ERROR"})(w||(e.NotificationsFilter=w={}));class b{constructor(){this.progress=new y,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.$$u=b;class y{infinite(){}done(){}total(P){}worked(P){}}e.$_u=y}),define(ke[253],Se([1,0,49]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;const m=globalThis.vscode;if(typeof m<"u"&&typeof m.context<"u"){const A=m.context.configuration();if(A)T=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(T=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:A.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ke[137],Se([1,0,5]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=void 0,e.$zj=(0,D.$Zh)("productService"),e.$Aj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function(be,e){return function(D,T){e(D,T,be)}};define(ke[85],Se([1,0,12,21,3,5]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.ProgressLocation=e.$av=void 0,e.$av=(0,A.$Zh)("progressService");var R;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$bv=Object.freeze({total(){},worked(){},done(){}});class w{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor($){this.b=$}report($){this.a=$,this.b(this.a)}}e.$cv=w;class b{get value(){return this.a}constructor($){this.e=$}report($){this.b?this.b.push($):this.b=[$],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const $=this.b.shift();this.a=$,await this.e(this.a)}}finally{this.c=!1;const $=this.d;this.d=void 0,$?.()}}drain(){return this.c?new Promise($=>{const v=this.d;this.d=()=>{v?.(),$()}}):Promise.resolve()}}e.$dv=b;let y=class extends m.$Rc{constructor($,v){super(),this.a=new D.$kh,v.withProgress($,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,m.$Pc)(()=>this.a.complete()))}report($){this.b?this.b.report($):this.c=$}};e.$ev=y,e.$ev=y=Ke([Be(1,e.$av)],y);class L extends m.$Rc{constructor($){super(),this.g=$,this.a=0,this.b=this.B(new m.$Qc)}start($){this.stop();const v=++this.a,S=new T.$2d;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},$),this.b.add((0,m.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,m.$Pc)(()=>S.cancel())),this.b.add((0,m.$Pc)(()=>this.c?this.c.done():void 0)),{id:v,token:S.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h($){this.a===$&&this.b.clear()}}e.$fv=L,e.$gv=(0,A.$Zh)("editorProgressService")}),define(ke[37],Se([1,0,60,18]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0;class m{constructor(){this.a=new Map}add(R,w){D.ok(T.$Cf(R)),D.ok(T.$Ef(w)),D.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,w)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$qn=new m}),define(ke[108],Se([1,0,4,37]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=void 0,e.$rn={JSONContribution:"base.contributions.json"};function m(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class A{constructor(){this.b=new D.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,y){this.a[m(b)]=y,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const R=new A;T.$qn.add(e.$rn.JSONContribution,R)}),define(ke[86],Se([1,0,19,4,18,195,45,108,37]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.ConfigurationScope=e.$vn=e.EditPresentationTypes=void 0;var y;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$vn={Configuration:"base.contributions.configuration"};var L;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn={properties:{},patternProperties:{}},e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn="vscode://schemas/settings/resourceLanguage",e.$Dn="vscode://schemas/settings/configurationDefaults";const P=b.$qn.as(w.$rn.JSONContribution);class ${constructor(){this.h=new Set,this.i=new T.$Rd,this.onDidSchemaChange=this.i.event,this.j=new T.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$Cn,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const h=new Set;this.n(t,r,h),P.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:h})}deregisterConfigurations(t){const r=new Set;this.o(t,r),P.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const h=new Set;this.o(r,h),this.n(t,!1,h),P.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:h})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const h=[];for(const{overrides:u,source:c}of t)for(const l in u)if(r.add(l),e.$Fn.test(l)){const E=this.a.get(l),C=E?.valuesSources??new Map;if(c)for(const I of Object.keys(u[l]))C.set(I,c);const f={...E?.value||{},...u[l]};this.a.set(l,{source:c,value:f,valuesSources:C});const p=(0,R.$Di)(l),k={type:"object",default:f,description:A.localize(1,null,p),$ref:e.$Cn,defaultDefaultValue:f,source:m.$Cf(c)?void 0:c,defaultValueSource:c};h.push(...g(l)),this.d[l]=k,this.b.properties[l]=k}else{this.a.set(l,{value:u[l],source:c});const E=this.d[l];E&&(this.w(l,E),this.r(l,E))}this.m(h)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:h,source:u}of t)for(const c in h){const l=this.a.get(c),E=m.$Cf(u)?u:u?.id,C=m.$Cf(l?.source)?l?.source:l?.source?.id;if(E===C)if(r.add(c),this.a.delete(c),e.$Fn.test(c))delete this.d[c],delete this.b.properties[c];else{const f=this.d[c];f&&(this.w(c,f),this.r(c,f))}}this.u()}deltaConfiguration(t){let r=!1;const h=new Set;t.removedDefaults&&(this.l(t.removedDefaults,h),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,h),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,h),t.addedConfigurations&&this.n(t.addedConfigurations,!1,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,h){t.forEach(u=>{this.p(u,r,u.extensionInfo,u.restrictedProperties,void 0,h),this.c.push(u),this.q(u)})}o(t,r){const h=u=>{if(u.properties)for(const c in u.properties){r.add(c);const l=this.d[c];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[c],this.s(c,u.properties[c])}u.allOf?.forEach(c=>h(c))};for(const u of t){h(u);const c=this.c.indexOf(u);c!==-1&&this.c.splice(c,1)}}p(t,r=!0,h,u,c=3,l){c=m.$Lf(t.scope)?c:t.scope;const E=t.properties;if(E)for(const f in E){const p=E[f];if(r&&n(f,p)){delete E[f];continue}if(p.source=h,p.defaultDefaultValue=E[f].default,this.w(f,p),e.$Fn.test(f)?p.scope=void 0:(p.scope=m.$Lf(p.scope)?c:p.scope,p.restricted=m.$Lf(p.restricted)?!!u?.includes(f):p.restricted),E[f].hasOwnProperty("included")&&!E[f].included){this.f[f]=E[f],delete E[f];continue}else this.d[f]=E[f],E[f].policy?.name&&this.e.set(E[f].policy.name,f);!E[f].deprecationMessage&&E[f].markdownDeprecationMessage&&(E[f].deprecationMessage=E[f].markdownDeprecationMessage),l.add(f)}const C=t.allOf;if(C)for(const f of C)this.p(f,r,h,u,c,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=h=>{const u=h.properties;if(u)for(const l in u)this.r(l,u[l]);h.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$wn.properties[t]=r,r.scope){case 1:e.$xn.properties[t]=r;break;case 2:e.$yn.properties[t]=r;break;case 6:e.$zn.properties[t]=r;break;case 3:e.$An.properties[t]=r;break;case 4:e.$Bn.properties[t]=r;break;case 5:e.$Bn.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$wn.properties[t],r.scope){case 1:delete e.$xn.properties[t];break;case 2:delete e.$yn.properties[t];break;case 6:delete e.$zn.properties[t];break;case 3:delete e.$An.properties[t];break;case 4:case 5:delete e.$Bn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,h={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$Cn};this.w(r,h),e.$wn.properties[r]=h,e.$xn.properties[r]=h,e.$yn.properties[r]=h,e.$zn.properties[r]=h,e.$An.properties[r]=h,e.$Bn.properties[r]=h}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$Cn};e.$wn.patternProperties[e.$En]=t,e.$xn.patternProperties[e.$En]=t,e.$yn.patternProperties[e.$En]=t,e.$zn.patternProperties[e.$En]=t,e.$An.patternProperties[e.$En]=t,e.$Bn.patternProperties[e.$En]=t,this.i.fire()}w(t,r){const h=this.a.get(t);let u=h?.value,c=h?.source;m.$Jf(u)&&(u=r.defaultDefaultValue,c=void 0),m.$Jf(u)&&(u=o(r.type)),r.default=u,r.defaultValueSource=c}}const v="\\[([^\\]]+)\\]",S=new RegExp(v,"g");e.$En=`^(${v})+$`,e.$Fn=new RegExp(e.$En);function g(a){const t=[];if(e.$Fn.test(a)){let r=S.exec(a);for(;r?.length;){const h=r[1].trim();h&&t.push(h),r=S.exec(a)}}return(0,D.$Lb)(t)}e.$Gn=g;function d(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}e.$Hn=d;function o(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$In=o;const i=new $;b.$qn.add(e.$vn.Configuration,i);function n(a,t){return a.trim()?e.$Fn.test(a)?A.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?A.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$Jn=n;function s(){const a=[],t=i.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$Kn=s}),define(ke[254],Se([1,0,19,4,159,3,28,24,18,2,45,86,37]),function(be,e,D,T,m,A,R,w,b,y,L,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0;function v(r){return Object.isFrozen(r)?r:w.$fn(r)}class S{constructor(h={},u=[],c=[],l){this.b=h,this.c=u,this.d=c,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const h=this.raw.map(u=>{if(u instanceof S)return u;const c=new g("");return c.parseRaw(u),c.configurationModel});this.f=h.reduce((u,c)=>c===u?c:u.merge(c),h[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(h){return h?(0,L.$Bi)(this.contents,h):this.contents}inspect(h,u){const c=this.rawConfiguration.getValue(h),l=u?this.rawConfiguration.getOverrideValue(h,u):void 0,E=u?this.rawConfiguration.override(u).getValue(h):c;return{value:c,override:l,merged:E}}getOverrideValue(h,u){const c=this.i(u);return c?h?(0,L.$Bi)(c,h):c:void 0}getKeysForOverrideIdentifier(h){const u=[];for(const c of this.overrides)c.identifiers.includes(h)&&u.push(...c.keys);return D.$Lb(u)}getAllOverrideIdentifiers(){const h=[];for(const u of this.overrides)h.push(...u.identifiers);return D.$Lb(h)}override(h){let u=this.a.get(h);return u||(u=this.g(h),this.a.set(h,u)),u}merge(...h){const u=w.$en(this.contents),c=w.$en(this.overrides),l=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const C of h)if(E.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(u,C.contents);for(const f of C.overrides){const[p]=c.filter(k=>D.$tb(k.identifiers,f.identifiers));p?(this.h(p.contents,f.contents),p.keys.push(...f.keys),p.keys=D.$Lb(p.keys)):c.push(w.$en(f))}for(const f of C.keys)l.indexOf(f)===-1&&l.push(f)}return new S(u,l,c,E.every(C=>C instanceof S)?void 0:E)}g(h){const u=this.i(h);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const c={};for(const l of D.$Lb([...Object.keys(this.contents),...Object.keys(u)])){let E=this.contents[l];const C=u[l];C&&(typeof E=="object"&&typeof C=="object"?(E=w.$en(E),this.h(E,C)):E=C),c[l]=E}return new S(c,this.keys,this.overrides)}h(h,u){for(const c of Object.keys(u)){if(c in h&&b.$Ef(h[c])&&b.$Ef(u[c])){this.h(h[c],u[c]);continue}h[c]=w.$en(u[c])}}i(h){let u=null,c=null;const l=E=>{E&&(c?this.h(c,E):c=w.$en(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===h?u=E.contents:E.identifiers.includes(h)&&l(E.contents);return l(u),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(h,u){this.j(h,u,!0)}setValue(h,u){this.j(h,u,!1)}removeValue(h){const u=this.keys.indexOf(h);u!==-1&&(this.keys.splice(u,1),(0,L.$Ai)(this.contents,h),P.$Fn.test(h)&&this.overrides.splice(this.overrides.findIndex(c=>D.$tb(c.identifiers,(0,P.$Gn)(h))),1))}j(h,u,c){(0,L.$zi)(this.contents,h,u,l=>console.error(l)),c=c||this.keys.indexOf(h)===-1,c&&this.keys.push(h),P.$Fn.test(h)&&this.overrides.push({identifiers:(0,P.$Gn)(h),keys:Object.keys(this.contents[h]),contents:(0,L.$yi)(this.contents[h],l=>console.error(l))})}}e.$Ln=S;class g{constructor(h){this.f=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(h,u){if(!b.$Lf(h)){const c=this.g(h);this.parseRaw(c,u)}}reparse(h){this.a&&this.parseRaw(this.a,h)}parseRaw(h,u){this.a=h;const{contents:c,keys:l,overrides:E,restricted:C,hasExcludedProperties:f}=this.h(h,u);this.b=new S(c,l,E,f?[h]:void 0),this.c=C||[]}g(h){let u={},c=null,l=[];const E=[],C=[];function f(k){Array.isArray(l)?l.push(k):c!==null&&(l[c]=k)}const p={onObjectBegin:()=>{const k={};f(k),E.push(l),l=k,c=null},onObjectProperty:k=>{c=k},onObjectEnd:()=>{l=E.pop()},onArrayBegin:()=>{const k=[];f(k),E.push(l),l=k,c=null},onArrayEnd:()=>{l=E.pop()},onLiteralValue:f,onError:(k,I,j)=>{C.push({error:k,offset:I,length:j})}};if(h)try{m.$bn(h,p),u=l[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return u}h(h,u){const c=$.$qn.as(P.$vn.Configuration).getConfigurationProperties(),l=this.i(h,c,!0,u);h=l.raw;const E=(0,L.$yi)(h,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),C=Object.keys(h),f=this.j(h,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:E,keys:C,overrides:f,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(h,u,c,l){let E=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:h,restricted:[],hasExcludedProperties:E};const C={},f=[];for(const p in h)if(P.$Fn.test(p)&&c){const k=this.i(h[p],u,!1,l);C[p]=k.raw,E=E||k.hasExcludedProperties,f.push(...k.restricted)}else{const k=u[p],I=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&f.push(p),!l.exclude?.includes(p)&&(l.include?.includes(p)||(I===void 0||l.scopes===void 0||l.scopes.includes(I))&&!(l.skipRestricted&&k?.restricted))?C[p]=h[p]:E=!0}return{raw:C,restricted:f,hasExcludedProperties:E}}j(h,u){const c=[];for(const l of Object.keys(h))if(P.$Fn.test(l)){const E={};for(const C in h[l])E[C]=h[l][C];c.push({identifiers:(0,P.$Gn)(l),keys:Object.keys(E),contents:(0,L.$yi)(E,u)})}return c}}e.$Mn=g;class d extends A.$Rc{constructor(h,u,c,l){super(),this.c=h,this.f=u,this.g=l,this.b=this.B(new T.$Rd),this.onDidChange=this.b.event,this.a=new g(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,E=>E.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,E=>(E.isOperation(0)||E.isOperation(3)||E.isOperation(1)||E.isOperation(4))&&c.isEqual(E.resource,h)))(()=>this.b.fire()))}async loadConfiguration(){try{const h=await this.g.readFile(this.c);return this.a.parse(h.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(h){return h&&(this.f=h),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Nn=d;class o{constructor(h,u,c,l,E,C,f,p,k,I,j,z,M){this.a=h,this.b=u,this.c=c,this.overrideIdentifiers=l,this.d=E,this.f=C,this.g=f,this.h=p,this.i=k,this.j=I,this.k=j,this.l=z,this.m=M}get value(){return v(this.c)}n(h,u,c){const l=h.inspect(u,c);return{get value(){return v(l.value)},get override(){return v(l.override)},get merged(){return v(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(h,u,c,l,E=new S,C=new S,f=new R.$zc,p=new S,k=new R.$zc){this.c=h,this.d=u,this.f=c,this.g=l,this.h=E,this.i=C,this.j=f,this.l=p,this.m=k,this.a=null,this.b=new R.$zc,this.n=null}getValue(h,u,c){return this.p(h,u,c).getValue(h)}updateValue(h,u,c={}){let l;c.resource?(l=this.m.get(c.resource),l||(l=new S,this.m.set(c.resource,l))):l=this.l,u===void 0?l.removeValue(h):l.setValue(h,u),c.resource||(this.a=null)}inspect(h,u,c){const l=this.p(h,u,c),E=this.t(u.resource,c),C=u.resource?this.m.get(u.resource)||this.l:this.l,f=new Set;for(const p of l.overrides)for(const k of p.identifiers)l.getOverrideValue(h,k)!==void 0&&f.add(k);return new o(h,u,l.getValue(h),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,E||void 0,C)}keys(h){const u=this.t(void 0,h);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(h){this.c=h,this.a=null,this.b.clear()}updatePolicyConfiguration(h){this.d=h}updateApplicationConfiguration(h){this.f=h,this.a=null,this.b.clear()}updateLocalUserConfiguration(h){this.g=h,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(h){this.h=h,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(h){this.i=h,this.a=null,this.b.clear()}updateFolderConfiguration(h,u){this.j.set(h,u),this.b.delete(h)}deleteFolderConfiguration(h){this.folderConfigurations.delete(h),this.b.delete(h)}compareAndUpdateDefaultConfiguration(h,u){const c=[];if(!u){const{added:l,updated:E,removed:C}=a(this.c,h);u=[...l,...E,...C]}for(const l of u)for(const E of(0,P.$Gn)(l)){const C=this.c.getKeysForOverrideIdentifier(E),f=h.getKeysForOverrideIdentifier(E),p=[...f.filter(k=>C.indexOf(k)===-1),...C.filter(k=>f.indexOf(k)===-1),...C.filter(k=>!w.$in(this.c.override(E).getValue(k),h.override(E).getValue(k)))];c.push([E,p])}return this.updateDefaultConfiguration(h),{keys:u,overrides:c}}compareAndUpdatePolicyConfiguration(h){const{added:u,updated:c,removed:l}=a(this.d,h),E=[...u,...c,...l];return E.length&&this.updatePolicyConfiguration(h),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(h){const{added:u,updated:c,removed:l,overrides:E}=a(this.applicationConfiguration,h),C=[...u,...c,...l];return C.length&&this.updateApplicationConfiguration(h),{keys:C,overrides:E}}compareAndUpdateLocalUserConfiguration(h){const{added:u,updated:c,removed:l,overrides:E}=a(this.localUserConfiguration,h),C=[...u,...c,...l];return C.length&&this.updateLocalUserConfiguration(h),{keys:C,overrides:E}}compareAndUpdateRemoteUserConfiguration(h){const{added:u,updated:c,removed:l,overrides:E}=a(this.remoteUserConfiguration,h),C=[...u,...c,...l];return C.length&&this.updateRemoteUserConfiguration(h),{keys:C,overrides:E}}compareAndUpdateWorkspaceConfiguration(h){const{added:u,updated:c,removed:l,overrides:E}=a(this.workspaceConfiguration,h),C=[...u,...c,...l];return C.length&&this.updateWorkspaceConfiguration(h),{keys:C,overrides:E}}compareAndUpdateFolderConfiguration(h,u){const c=this.folderConfigurations.get(h),{added:l,updated:E,removed:C,overrides:f}=a(c,u),p=[...l,...E,...C];return(p.length||!c)&&this.updateFolderConfiguration(h,u),{keys:p,overrides:f}}compareAndDeleteFolderConfiguration(h){const u=this.folderConfigurations.get(h);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(h);const{added:c,updated:l,removed:E,overrides:C}=a(u,void 0);return{keys:[...c,...l,...E],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(h,u,c){let l=this.q(u,c);return u.overrideIdentifier&&(l=l.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(h)!==void 0&&(l=l.merge(this.d)),l}q({resource:h},u){let c=this.r();if(u&&h){const l=u.getFolder(h);l&&(c=this.s(l.uri)||c);const E=this.m.get(h);E&&(c=c.merge(E))}return c}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(h){let u=this.b.get(h);if(!u){const c=this.r(),l=this.j.get(h);l?(u=c.merge(l),this.b.set(h,u)):u=c}return u}t(h,u){if(u&&h){const c=u.getFolder(h);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((h,u)=>{const{contents:c,overrides:l,keys:E}=this.j.get(u);return h.push([u,{contents:c,overrides:l,keys:E}]),h},[])}}allKeys(){const h=new Set;return this.c.keys.forEach(u=>h.add(u)),this.userConfiguration.keys.forEach(u=>h.add(u)),this.i.keys.forEach(u=>h.add(u)),this.j.forEach(u=>u.keys.forEach(c=>h.add(c))),[...h.values()]}u(){const h=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>h.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>h.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>h.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(c=>h.add(c))),[...h.values()]}v(h){const u=new Set;return this.c.getKeysForOverrideIdentifier(h).forEach(c=>u.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(h).forEach(c=>u.add(c)),this.i.getKeysForOverrideIdentifier(h).forEach(c=>u.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(h).forEach(l=>u.add(l))),[...u.values()]}static parse(h){const u=this.w(h.defaults),c=this.w(h.policy),l=this.w(h.application),E=this.w(h.user),C=this.w(h.workspace),f=h.folders.reduce((p,k)=>(p.set(y.URI.revive(k[0]),this.w(k[1])),p),new R.$zc);return new i(u,c,l,E,new S,C,f,new S,new R.$zc)}static w(h){return new S(h.contents,h.keys,h.overrides)}}e.$On=i;function n(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const h=new Set,u=new Map;for(const l of r)l.keys.forEach(E=>h.add(E)),l.overrides.forEach(([E,C])=>{const f=(0,R.$wc)(u,E,new Set);C.forEach(p=>f.add(p))});const c=[];return u.forEach((l,E)=>c.push([E,[...l.values()]])),{keys:[...h.values()],overrides:c}}e.$Pn=n;class s{constructor(h,u,c,l){this.change=h,this.f=u,this.g=c,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const E of h.keys)this.affectedKeys.add(E);for(const[,E]of h.overrides)for(const C of E)this.affectedKeys.add(C);this.d=this.a;for(const E of this.affectedKeys)this.d+=E+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(h,u){const c=this.a+h,l=this.d.indexOf(c);if(l<0)return!1;const E=l+c.length;if(E>=this.d.length)return!1;const C=this.d.charCodeAt(E);if(C!==this.b&&C!==this.c)return!1;if(u){const f=this.previousConfiguration?this.previousConfiguration.getValue(h,u,this.f?.workspace):void 0,p=this.g.getValue(h,u,this.h);return!w.$in(f,p)}return!0}}e.$Qn=s;function a(r,h){const{added:u,removed:c,updated:l}=t(h?.rawConfiguration,r?.rawConfiguration),E=[],C=r?.getAllOverrideIdentifiers()||[],f=h?.getAllOverrideIdentifiers()||[];if(h){const p=f.filter(k=>!C.includes(k));for(const k of p)E.push([k,h.getKeysForOverrideIdentifier(k)])}if(r){const p=C.filter(k=>!f.includes(k));for(const k of p)E.push([k,r.getKeysForOverrideIdentifier(k)])}if(h&&r){for(const p of C)if(f.includes(p)){const k=t({contents:r.getOverrideValue(void 0,p)||{},keys:r.getKeysForOverrideIdentifier(p)},{contents:h.getOverrideValue(void 0,p)||{},keys:h.getKeysForOverrideIdentifier(p)});E.push([p,[...k.added,...k.removed,...k.updated]])}}return{added:u,removed:c,updated:l,overrides:E}}function t(r,h){const u=r?h?r.keys.filter(E=>h.keys.indexOf(E)===-1):[...r.keys]:[],c=h?r?h.keys.filter(E=>r.keys.indexOf(E)===-1):[...h.keys]:[],l=[];if(r&&h){for(const E of h.keys)if(r.keys.indexOf(E)!==-1){const C=(0,L.$Bi)(h.contents,E),f=(0,L.$Bi)(r.contents,E);w.$in(C,f)||l.push(E)}}return{added:u,removed:c,updated:l}}}),define(ke[255],Se([1,0,22,4,3,82]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kqb=e.$Jqb=e.$Iqb=e.$Hqb=void 0;const R=(y,L,P)=>{const $=new Uint8Array(16);for(let g=0;g<16;g++)$[g]=Math.round(Math.random()*256);const v=(0,D.$ze)(D.$fe.wrap($));return[`GET ws://localhost${y}?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`].join(`\r
`)+`\r
\r
`};e.$Hqb=R,e.$Iqb=D.$fe.fromString(`\r
\r
`);async function w(y,L,P,$,v){y.write(D.$fe.fromString((0,e.$Hqb)(L,P,$)));const S=new m.$Qc;try{return await new Promise((g,d)=>{let o;S.add(y.onData(i=>{o?o=D.$fe.concat([o,i],o.byteLength+i.byteLength):o=i;const n=o.indexOf(e.$Iqb);if(n===-1)return;g(y),y.pauseData();const s=o.slice(n+e.$Iqb.byteLength);s.byteLength&&v.onData.fire(s)})),S.add(y.onClose(i=>d(i??new Error("socket closed")))),S.add(y.onEnd(()=>d(new Error("socket ended"))))})}catch(g){throw y.dispose(),g}finally{S.dispose()}}e.$Jqb=w;class b extends m.$Rc{constructor(L,P){super(),this.g=L,this.a=this.B(new T.$Ud),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new T.$Rd),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event($=>this.a.fire($))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(L,P){A.SocketDiagnostics.traceSocketEvent(this,this.g,L,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Kqb=b}),define(ke[64],Se([1,0,8,5]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=e.RemoteAuthorityResolverErrorCode=e.$2k=e.$1k=e.RemoteConnectionType=e.$Zk=void 0,e.$Zk=(0,T.$Zh)("remoteAuthorityResolverService");var m;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})(m||(e.RemoteConnectionType=m={}));class A{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$1k=A;class R{constructor(P,$){this.host=P,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$2k=R;var w;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound",L.InvalidAuthority="InvalidAuthority"})(w||(e.RemoteAuthorityResolverErrorCode=w={}));class b extends D.$ab{static isNotAvailable(P){return P instanceof b&&P._code===w.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof b&&P._code===w.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof b&&P._code===w.NoResolverFound}static isInvalidAuthority(P){return P instanceof b&&P._code===w.InvalidAuthority}static isHandled(P){return P instanceof b&&P.isHandled}constructor(P,$=w.Unknown,v){super(P),this._message=P,this._code=$,this._detail=v,this.isHandled=$===w.NotAvailable&&v===!0,Object.setPrototypeOf(this,b.prototype)}}e.$3k=b;function y(L){const P=L.indexOf("+");return P===-1?L:L.substring(0,P)}e.$4k=y}),define(ke[65],Se([1,0,17]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=void 0;function T(y){return y.scheme===D.Schemas.vscodeRemote?y.authority:void 0}e.$5k=T;function m(y){if(!y)return;const L=y.indexOf("+");return L<0?y:y.substr(0,L)}e.$6k=m;function A(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$7k=A;function R(y){const{host:L,port:P}=b(y);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:P}}e.$8k=R;function w(y,L){let{host:P,port:$}=b(y);return typeof $>"u"&&($=L),{host:P,port:$}}e.$9k=w;function b(y){const L=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const P=y.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const $=y.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:y,port:void 0}}}),define(ke[26],Se([1,0,13,5,65]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.TargetPlatform=e.ExtensionType=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l="extensions.user.cache",e.$$l="extensions.builtin.cache",e.$_l="undefined_publisher",e.$am=["ui","workspace","web"];function A(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$bm=A,e.$cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(R||(e.ExtensionType=R={}));var w;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class b{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,o){if(typeof d>"u"||d===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof d=="string"||typeof o=="string"){const i=typeof d=="string"?d:d.value,n=typeof o=="string"?o:o.value;return D.$6e(i,n)}return d._lower===o._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$dm=b;class y{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const o of d)this.add(o)}add(d){this.c.add(b.toKey(d))}delete(d){return this.c.delete(b.toKey(d))}has(d){return this.c.has(b.toKey(d))}}e.$em=y;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(b.toKey(d))}get(d){return this.c.get(b.toKey(d))}has(d){return this.c.has(b.toKey(d))}set(d,o){this.c.set(b.toKey(d),o)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$fm=L;function P(g){return $(g)}e.$gm=P;function $(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.$hm=$;function v(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.$im=v;function S(g,d){if(d){const o=`onResolveRemoteAuthority:${(0,m.$6k)(d)}`;return!!g.activationEvents?.includes(o)}return!1}e.$jm=S,e.$km=(0,T.$Zh)("IBuiltinExtensionsScannerService")}),define(ke[138],Se([1,0,8,26]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BF=e.$AF=void 0;class m{constructor(){this.a=new Map,this.b=new WeakMap}register(R,w){this.a.set(R,w)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const w=Object.create(null);for(const b of R){const y=this.readActivationEvents(b);y.length>0&&(w[T.$dm.toKey(b.identifier)]=y)}return w}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const w=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let b=0;b<w.length;b++)w[b]==="onUri"&&(w[b]=`onUri:${T.$dm.toKey(R.identifier)}`);if(!R.contributes)return w;for(const b in R.contributes){const y=this.a.get(b);if(!y)continue;const L=R.contributes[b],P=Array.isArray(L)?L:[L];try{y(P,w)}catch($){(0,D.$Z)($)}}return w}}e.$AF=m,e.$BF=new m}),define(ke[256],Se([1,0,12,22,21,8,4,3,56,38,30,82,64,65]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.PersistentConnectionEventType=e.$dl=e.$cl=e.$bl=e.ConnectionType=void 0;const S=30*1e3;var g;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(g||(e.ConnectionType=g={}));function d(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(H){const U=new m.$2d;return setTimeout(()=>U.cancel(),H),U.token}function i(H,U){if(H.isCancellationRequested||U.isCancellationRequested)return m.CancellationToken.Cancelled;const ne=new m.$2d;return H.onCancellationRequested(()=>ne.cancel()),U.onCancellationRequested(()=>ne.cancel()),ne.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new w.$Qc,this.promise=new Promise((ne,Ee)=>{this.f=ne,this.g=Ee}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function s(H,U){const ne=new n(U);return ne.registerDisposable(H.onControlMessage(Ee=>{const fe=JSON.parse(Ee.toString()),me=J(fe);me?ne.reject(me):ne.resolve(fe)})),ne.promise}function a(H,U,ne,Ee,fe,me,ee,te){const K=new n(te),ie=y.$Nd.create(!1);return H.info(`Creating a socket (${ee})...`),b.mark(`code/willCreateSocket/${me}`),U.connect(ne,Ee,fe,ee).then(G=>{K.didTimeout?(b.mark(`code/didCreateSocketError/${me}`),H.info(`Creating a socket (${ee}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),G?.dispose()):(b.mark(`code/didCreateSocketOK/${me}`),H.info(`Creating a socket (${ee}) was successful after ${ie.elapsed()} ms.`),K.resolve(G))},G=>{b.mark(`code/didCreateSocketError/${me}`),H.info(`Creating a socket (${ee}) returned an error after ${ie.elapsed()} ms.`),H.error(G),K.reject(G)}),K.promise}function t(H,U){const ne=new n(U);return H.then(Ee=>{ne.didTimeout||ne.resolve(Ee)},Ee=>{ne.didTimeout||ne.reject(Ee)}),ne.promise}async function r(H,U,ne,Ee){const fe=ye(H,U);H.logService.trace(`${fe} 1/6. invoking socketFactory.connect().`);let me;try{me=await a(H.logService,H.remoteSocketFactoryService,H.connectTo,(0,v.$7k)(H),`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,d(U),`renderer-${d(U)}-${H.reconnectionToken}`,Ee)}catch(G){throw H.logService.error(`${fe} socketFactory.connect() failed or timed out. Error:`),H.logService.error(G),G}H.logService.trace(`${fe} 2/6. socketFactory.connect() was successful.`);let ee,te;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(me,null),ee=H.reconnectionProtocol,te=!1):(ee=new P.$Nh({socket:me}),te=!0),H.logService.trace(`${fe} 3/6. sending AuthRequest control message.`);const K=await t(H.signService.createNewMessage((0,L.$kg)()),Ee),ie={type:"auth",auth:H.connectionToken||"00000000000000000000",data:K.data};ee.sendControl(T.$fe.fromString(JSON.stringify(ie)));try{const G=await s(ee,i(Ee,o(1e4)));if(G.type!=="sign"||typeof G.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(H.logService.trace(`${fe} 4/6. received SignRequest control message.`),!await t(H.signService.validate(K,G.signedData),Ee)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const $e=await t(H.signService.sign(G.data),Ee),Ce={type:"connectionType",commit:H.commit,signedData:$e,desiredConnectionType:U};return ne&&(Ce.args=ne),H.logService.trace(`${fe} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(T.$fe.fromString(JSON.stringify(Ce))),{protocol:ee,ownsProtocol:te}}catch(G){throw G&&G.code==="ETIMEDOUT"&&(H.logService.error(`${fe} the handshake timed out. Error:`),H.logService.error(G)),G&&G.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${fe} received error control message when negotiating connection. Error:`),H.logService.error(G)),te&&X(ee),G}}async function h(H,U,ne,Ee){const fe=Date.now(),me=ye(H,U),{protocol:ee,ownsProtocol:te}=await r(H,U,ne,Ee),K=new n(Ee);return K.registerDisposable(ee.onControlMessage(ie=>{const G=JSON.parse(ie.toString()),ae=J(G);ae?(H.logService.error(`${me} received error control message when negotiating connection. Error:`),H.logService.error(ae),te&&X(ee),K.reject(ae)):(H.reconnectionProtocol?.endAcceptReconnection(),H.logService.trace(`${me} 6/6. handshake finished, connection is up and running after ${de(fe)}!`),K.resolve({protocol:ee,firstMessage:G}))})),K.promise}async function u(H,U){const{protocol:ne}=await h(H,1,void 0,U);return{protocol:ne}}async function c(H,U,ne){const{protocol:Ee,firstMessage:fe}=await h(H,2,U,ne),me=fe&&fe.debugPort;return{protocol:Ee,debugPort:me}}async function l(H,U,ne){const Ee=Date.now(),fe=ye(H,3),{protocol:me}=await r(H,3,U,ne);return H.logService.trace(`${fe} 6/6. handshake finished, connection is up and running after ${de(Ee)}!`),me}async function E(H,U,ne){const{connectTo:Ee,connectionToken:fe}=await H.addressProvider.getAddress();return{commit:H.commit,quality:H.quality,connectTo:Ee,connectionToken:fe,reconnectionToken:U,reconnectionProtocol:ne,remoteSocketFactoryService:H.remoteSocketFactoryService,signService:H.signService,logService:H.logService}}async function C(H,U,ne){return p(H,async Ee=>{const{protocol:fe}=await u(Ee,m.CancellationToken.None);return new x(H,U,ne,Ee.reconnectionToken,fe)})}e.$bl=C;async function f(H,U){return p(H,async ne=>{const{protocol:Ee,debugPort:fe}=await c(ne,U,m.CancellationToken.None);return new ue(H,U,ne.reconnectionToken,Ee,fe)})}e.$cl=f;async function p(H,U){for(let Ee=1;;Ee++)try{const fe=(0,L.$kg)(),me=await E(H,fe,null);return await U(me)}catch(fe){if(Ee<5)H.logService.error(`[remote-connection][attempt ${Ee}] An error occurred in initial connection! Will retry... Error:`),H.logService.error(fe);else throw H.logService.error(`[remote-connection][attempt ${Ee}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),H.logService.error(fe),W.triggerPermanentFailure(0,0,$.$3k.isHandled(fe)),fe}}async function k(H,U,ne){const Ee=await E(H,(0,L.$kg)(),null);return await l(Ee,{host:U,port:ne},m.CancellationToken.None)}e.$dl=k;function I(H){return(0,D.$Ng)(U=>new Promise((ne,Ee)=>{const fe=setTimeout(ne,H*1e3);U.onCancellationRequested(()=>{clearTimeout(fe),ne()})}))}var j;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(j||(e.PersistentConnectionEventType=j={}));class z{constructor(U,ne){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.type=0}}e.$el=z;class M{constructor(U,ne,Ee,fe){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.durationSeconds=Ee,this.c=fe,this.type=1}skipWait(){this.c.cancel()}}e.$fl=M;class F{constructor(U,ne,Ee){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=Ee,this.type=2}}e.$gl=F;class N{constructor(U,ne,Ee){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=Ee,this.type=4}}e.$hl=N;class O{constructor(U,ne,Ee,fe){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=Ee,this.handled=fe,this.type=3}}e.$il=O;class W extends w.$Rc{static triggerPermanentFailure(U,ne,Ee){this._permanentFailure=!0,this.f=U,this.g=ne,this.h=Ee,this.j.forEach(fe=>fe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||W._permanentFailure}constructor(U,ne,Ee,fe,me){super(),this.t=U,this.u=ne,this.reconnectionToken=Ee,this.protocol=fe,this.w=me,this.m=this.B(new R.$Rd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(fe.onSocketClose(ee=>{const te=Z(this.t,this.reconnectionToken,!0);ee?ee.type===0?(this.u.logService.info(`${te} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.u.logService.error(ee.error)):(this.u.logService.info(`${te} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.u.logService.error(ee.event)):this.u.logService.info(`${te} received socket close event.`),this.y()})),this.B(fe.onSocketTimeout(ee=>{const te=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${te} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.y()})),W.j.push(this),this.B((0,w.$Pc)(()=>{const ee=W.j.indexOf(this);ee>=0&&W.j.splice(ee,1)})),this.n&&this.D(W.f,W.g,W.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let Ee=-1;do{Ee++;const fe=Ee<ne.length?ne[Ee]:ne[ne.length-1];try{if(fe>0){const ee=I(fe);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),fe,ee)),this.u.logService.info(`${U} waiting for ${fe} seconds before reconnecting...`);try{await ee}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ee+1)),this.u.logService.info(`${U} resolving connection...`);const me=await E(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${me.connectTo}...`),await this.G(me,o(S)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ee+1));break}catch(me){if(me.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(me),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,!1);break}if(Ee>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(me),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,!1);break}if($.$3k.isTemporarilyNotAvailable(me)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(me);continue}if((me.code==="ETIMEDOUT"||me.code==="ENETUNREACH"||me.code==="ECONNREFUSED"||me.code==="ECONNRESET")&&me.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(me);continue}if((0,A.$3)(me)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(me);continue}if(me instanceof $.$3k){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(me),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,$.$3k.isHandled(me));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(me),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,!1);break}}while(!this.n&&!this.s)}C(U,ne,Ee){this.w?W.triggerPermanentFailure(U,ne,Ee):this.D(U,ne,Ee)}D(U,ne,Ee){this.m.fire(new O(this.reconnectionToken,U,ne,Ee)),X(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$jl=W;class x extends W{constructor(U,ne,Ee,fe,me){super(1,U,fe,me,!0),this.client=this.B(new P.$Lh(me,{remoteAuthority:ne,clientId:Ee},U.ipcLogger))}async G(U,ne){await u(U,ne)}}e.$kl=x;class ue extends W{constructor(U,ne,Ee,fe,me){super(2,U,Ee,fe,!1),this.H=ne,this.debugPort=me}async G(U,ne){await c(U,this.H,ne)}}e.$ll=ue;function X(H){try{H.acceptDisconnect();const U=H.getSocket();H.dispose(),U.dispose()}catch(U){(0,A.$Z)(U)}}function J(H){if(H&&H.type==="error"){const U=new Error(`Connection error: ${H.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function Q(H,U){for(;H.length<U;)H+=" ";return H}function he(H,U){return`[remote-connection][${Q(d(H),13)}][${U.substr(0,5)}\u2026]`}function Z(H,U,ne){return`${he(H,U)}[${ne?"reconnect":"initial"}]`}function ye(H,U){return`${Z(U,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.connectTo}]`}function de(H){return`${Date.now()-H} ms`}}),define(ke[257],Se([1,0,3,5]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=void 0,e.$0k=(0,T.$Zh)("remoteSocketFactoryService");class m{constructor(){this.a={}}register(R,w){return this.a[R]??=[],this.a[R].push(w),(0,D.$Pc)(()=>{const b=this.a[R]?.indexOf(w);typeof b=="number"&&b>=0&&this.a[R]?.splice(b,1)})}b(R){return(this.a[R.type]||[]).find(b=>b.supports(R))}connect(R,w,b,y){const L=this.b(R);if(!L)throw new Error(`No socket factory found for ${R}`);return L.connect(R,w,b,y)}}e.$$k=m}),define(ke[258],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x5b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(m){try{const A=await this.c();if(A){const R=String(D.a++);return this.b.set(R,A),{id:R,data:A.createNewMessage(m)}}}catch{}return{id:"",data:m}}async validate(m,A){if(!m.id)return!0;const R=this.b.get(m.id);if(!R)return!1;this.b.delete(m.id);try{return R.validate(A)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(m){try{return await this.d(m)}catch{}return m}}e.$x5b=D}),define(ke[109],Se([1,0,5]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=void 0,e.$_k="signService",e.$al=(0,D.$Zh)(e.$_k)}),define(ke[139],Se([1,0,258]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u0b=void 0;class T extends D.$x5b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(R=>new R.signer().sign(A))}h(){return new Promise((A,R)=>be(["vsda"],A,R))}}e.$u0b=T}),define(ke[259],Se([1,0,11,49,30]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=void 0;function A(b){if(D.$u===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}function R(b,y,L,P,$,v,S,g,d){const o=Object.create(null);o["common.machineId"]=v,o["common.sqmId"]=S,o.sessionID=(0,m.$kg)()+Date.now(),o.commitHash=P,o.version=$,o["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,D.$h)(D.$u),o["common.nodePlatform"]=T.$cc,o["common.nodeArch"]=L,o["common.product"]=d||"desktop",g&&(o["common.msftInternal"]=g);let i=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(o["common.snap"]="true");const s=A(y);return s&&(o["common.platformDetail"]=s),o}e.$ro=R;function w(b){const y=T.env.USERDNSDOMAIN;if(!y)return!1;const L=y.toLowerCase();return b.some(P=>L===P)}e.$so=w}),define(ke[260],Se([1,0,5]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=void 0,e.$ml=(0,D.$Zh)("telemetryService"),e.$nl=(0,D.$Zh)("customEndpointTelemetryService"),e.$ol="telemetry.currentSessionDate",e.$pl="telemetry.firstSessionDate",e.$ql="telemetry.lastSessionDate",e.$rl="telemetry.machineId",e.$sl="telemetry.sqmId",e.$tl="telemetry",e.$ul="telemetry.telemetryLevel",e.$vl="telemetry.enableCrashReporter",e.$wl="telemetry.enableTelemetry";var T;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var m;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(m||(e.TelemetryConfiguration=m={}))}),define(ke[87],Se([1,0,24,18,4,45,65,259,260]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=void 0;class y{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$to=y;class L{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$uo=L,e.$vo=new L;class P{async publicLog(c,l,E){}async publicLogError(c,l,E){}}e.$wo=P,e.$xo="telemetry",e.$yo="extensionTelemetryLog",e.$zo={log:()=>null,flush:()=>Promise.resolve(null)};function $(u,c){return m.Event.debounce(c.onDidChangeConfiguration,(E,C)=>{const f=E?new Set([...E.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:f}},1e3,!0)(E=>{E.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,A.$wi)(E.source),configurationKeys:Array.from(E.affectedKeys)})})}e.$Ao=$;function v(u,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!u.enableTelemetry)}e.$Bo=v;function S(u,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.$Co=S;function g(u){const c=u.getValue(b.$ul),l=u.getValue(b.$vl);if(u.getValue(b.$wl)===!1||l===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Do=g;function d(u){const c={},l={},E={};n(u,E);for(let C in E){C=C.length>150?C.substr(C.length-149):C;const f=E[C];typeof f=="number"?l[C]=f:typeof f=="boolean"?l[C]=f?1:0:typeof f=="string"?(f.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${f.length}`),c[C]=f.substring(0,8191)):typeof f<"u"&&f!==null&&(c[C]=f)}return{properties:c,measurements:l}}e.$Eo=d;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(u){if(!u)return"none";const c=(0,R.$6k)(u);return o.has(c)?c:"other"}e.$Fo=i;function n(u,c,l=0,E){if(u)for(const C of Object.getOwnPropertyNames(u)){const f=u[C],p=E?E+C:C;Array.isArray(f)?c[p]=(0,D.$jn)(f):f instanceof Date?c[p]=f.toISOString():(0,T.$Ef)(f)?l<2?n(f,c,l+1,p+"."):c[p]=(0,D.$jn)(f):c[p]=f}}function s(u,c){const l=u.msftInternalDomains||[],E=c.getValue("telemetry.internalTesting");return(0,w.$so)(l)||E}e.$Go=s;function a(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.$Ho=a;function t(u,c){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let l=u;const E=[];for(const k of c)for(;;){const I=k.exec(u);if(!I)break;E.push([I.index,k.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(l="";;){const k=f.exec(u);if(!k)break;const I=E.some(([j,z])=>k.index<z&&j<f.lastIndex);!C.test(k[0])&&!I&&(l+=u.substring(p,k.index)+"<REDACTED: user-file-path>",p=f.lastIndex)}return p<u.length&&(l+=u.substr(p)),l}function r(u){if(!u)return u;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of c)if(l.regex.test(u))return`<REDACTED: ${l.label}>`;return u}function h(u,c){return(0,D.$gn)(u,l=>{if(l instanceof y||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let E=l.replaceAll("%20"," ");E=t(E,c);for(const C of c)E=E.replace(C,"");return E=r(E),E}})}e.$Io=h}),define(ke[261],Se([1,0,13,135,26,11,2,8,49,87]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0;function L(h,u){return h.uuid&&u.uuid?h.uuid===u.uuid:h.id===u.id?!0:(0,D.$1e)(h.id,u.id)===0}e.$Jo=L;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(u){const c=u.manifest?u.manifest.version:u.version,l=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new $(u.identifier,c,l)}static parse(u){const c=P.exec(u);return c&&c[1]&&c[2]?new $({id:c[1]},c[2],c[4]||void 0):null}constructor(u,c,l="undefined"){this.version=c,this.targetPlatform=l,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof $?L(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$Ko=$;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(h){const u=v.exec(h);return u&&u[1]?[d(u[1]),u[2]]:[d(h),void 0]}e.$Lo=S;function g(h,u){return`${h}.${u}`}e.$Mo=g;function d(h){return h.toLowerCase()}e.$No=d;function o(h,u){return d(g(h??m.$_l,u))}e.$Oo=o;function i(h,u){const c=[],l=E=>{for(const C of c)if(C.some(f=>L(u(f),u(E))))return C;return null};for(const E of h){const C=l(E);C?C.push(E):c.push([E])}return c}e.$Po=i;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.$Qo=n;function s(h){return{id:new y.$to(h.identifier.id),name:new y.$to(h.name),galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),isSigned:h.isSigned,...h.telemetryData}}e.$Ro=s,e.$So=new m.$dm("pprice.better-merge");function a(h,u){const c=[],l=u.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const E=l.shift();if(E&&c.every(C=>!L(C.identifier,{id:E}))){const C=h.filter(f=>L(f.identifier,{id:E}));C.length===1&&(c.push(C[0]),l.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.$To=a;async function t(h,u){if(!A.$k)return!1;let c;try{c=(await h.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await h.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(E){u.debug("Error while getting the os-release file.",(0,w.$9)(E))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(h,u){const c=await t(h,u),l=(0,T.$do)(c?"alpine":A.$u,b.$dc);return u.debug("ComputeTargetPlatform:",l),l}e.$Uo=r}),define(ke[262],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=e.$yr=e.$xr=e.$wr=e.$vr=e.$ur=void 0;function D(b){return[...b.entries()]}e.$ur=D;function T(b){return b?[...b.entries()]:[]}e.$vr=T;function m(b){return new Map(b)}e.$wr=m;function A(b){return new Map(b??[])}e.$xr=A;function R(b){return Array.from(b.entries()).map(y=>[y[0],D(y[1].map),T(y[1].descriptionMap)])}e.$yr=R;function w(b){return new Map(b.map(y=>[y[0],{map:m(y[1]),descriptionMap:A(y[2])}]))}e.$zr=w}),define(ke[263],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qb=void 0;class D{constructor(m){this.b=m,this.a=new Map}dispose(){for(const m of this.a.values())m.dispose()}startBuffering(m,A,R=5){const w=A(b=>{const y=typeof b=="string"?b:b.data;let L=this.a.get(m);if(L){L.data.push(y);return}const P=setTimeout(()=>this.flushBuffer(m),R);L={data:[y],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(m),w.dispose()}},this.a.set(m,L)});return w}stopBuffering(m){this.a.get(m)?.dispose()}flushBuffer(m){const A=this.a.get(m);A&&(this.a.delete(m),this.b(m,A.data.join("")))}}e.$2qb=D}),define(ke[264],Se([1,0,12,78,61,4,18,2,206,108,37]),function(be,e,D,T,m,A,R,w,b,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lw=e.$kw=e.$jw=e.$iw=e.$hw=e.$gw=e.$fw=e.$ew=e.IconFontDefinition=e.IconContribution=e.$dw=void 0,e.$dw={IconContribution:"base.contributions.icons"};var P;(function(s){function a(t,r){let h=t.defaults;for(;m.ThemeIcon.isThemeIcon(h);){const u=S.getIcon(h.id);if(!u)return;h=u.defaults}return h}s.getDefinition=a})(P||(e.IconContribution=P={}));var $;(function(s){function a(r){return{weight:r.weight,style:r.style,src:r.src.map(h=>({format:h.format,location:h.location.toString()}))}}s.toJSONObject=a;function t(r){const h=u=>(0,R.$Cf)(u)?u:void 0;if(r&&Array.isArray(r.src)&&r.src.every(u=>(0,R.$Cf)(u.format)&&(0,R.$Cf)(u.location)))return{weight:h(r.weight),style:h(r.style),src:r.src.map(u=>({format:u.format,location:w.URI.parse(u.location)}))}}s.fromJSONObject=t})($||(e.IconFontDefinition=$={}));class v{constructor(){this.a=new A.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${m.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,r,h){const u=this.b[a];if(u){if(r&&!u.description){u.description=r,this.d.properties[a].markdownDescription=`${r} $(${a})`;const E=this.e.enum.indexOf(a);E!==-1&&(this.e.enumDescriptions[E]=r),this.a.fire()}return u}const c={id:a,description:r,defaults:t,deprecationMessage:h};this.b[a]=c;const l={$ref:"#/definitions/icons"};return h&&(l.deprecationMessage=h),r&&(l.markdownDescription=`${r}: $(${a})`),this.d.properties[a]=l,this.e.enum.push(a),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const r=this.f[a];return r||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(u,c)=>u.id.localeCompare(c.id),t=u=>{for(;m.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.b).map(u=>this.b[u]);for(const u of h.filter(c=>!!c.description).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|${m.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const u of h.filter(c=>!m.ThemeIcon.isThemeIcon(c.defaults)).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|`);return r.join(`
`)}}const S=new v;L.$qn.add(e.$dw.IconContribution,S);function g(s,a,t,r){return S.registerIcon(s,a,t,r)}e.$ew=g;function d(){return S}e.$fw=d;function o(){const s=(0,T.$3j)();for(const a in s){const t="\\"+s[a].toString(16);S.registerIcon(a,{fontCharacter:t})}}o(),e.$gw="vscode://schemas/icons";const i=L.$qn.as(y.$rn.JSONContribution);i.registerSchema(e.$gw,S.getIconSchema());const n=new D.$_g(()=>i.notifySchemaChanged(e.$gw),200);S.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$hw=g("widget-close",T.$5j.close,(0,b.localize)(2,null)),e.$iw=g("goto-previous-location",T.$5j.arrowUp,(0,b.localize)(3,null)),e.$jw=g("goto-next-location",T.$5j.arrowDown,(0,b.localize)(4,null)),e.$kw=m.ThemeIcon.modify(T.$5j.sync,"spin"),e.$lw=m.ThemeIcon.modify(T.$5j.loading,"spin")}),define(ke[88],Se([1,0,4,45,5,14]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.ProvidedOnAutoForward=e.$jv=e.TunnelPrivacyId=e.TunnelProtocol=e.$iv=e.$hv=void 0,e.$hv=(0,m.$Zh)("tunnelService"),e.$iv=(0,m.$Zh)("sharedTunnelsService");var R;(function(d){d.Http="http",d.Https="https"})(R||(e.TunnelProtocol=R={}));var w;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(w||(e.TunnelPrivacyId=w={}));function b(d){return!!d.forwardPort}e.$jv=b;var y;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function L(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(o)return{address:o[1],port:+o[2]}}e.$kv=L,e.$lv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(d){return e.$lv.indexOf(d)>=0}e.$mv=P,e.$nv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(d){return e.$nv.indexOf(d)>=0}e.$ov=$;function v(d,o,i,n){if(i===1)return!1;if(i===2&&$(o)){const s=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(s?.length===4&&parseInt(s[1])>=18)return!1}return d<1024}e.$pv=v;class S{constructor(o,i,n){this.remoteAddress=o,this.localAddress=i,this.b=n,this.a=new D.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$qv=S;let g=class{constructor(o,i){this.j=o,this.k=i,this.a=new D.$Rd,this.onTunnelOpened=this.a.event,this.b=new D.$Rd,this.onTunnelClosed=this.b.event,this.c=new D.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const o=this.k.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.h=o.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const o=[],i=Array.from(this.e.values());for(const n of i){const s=Array.from(n.values());for(const a of s){const t=await a.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:i}of o.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,i,n,s,a){this.p(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:n,privacy:s,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){($(o)||P(o))&&(o=e.$lv[0]);const n=this.r(o,i);if(n)return++n.refcount,n.value}openTunnel(o,i,n,s,a,t=!1,r,h){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const u=this.f??o;if(!u)return;if(i||(i="localhost"),s||(s=this.l),this.f&&this.i.has(n)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.s(u,i,n,s,a,t,r,h);return c?c.then(l=>{if(l){if(typeof l=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,n),l}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,n);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.n(l);return(l.tunnelRemoteHost!==i||l.tunnelRemotePort!==n)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&l.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}n(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this.e.get(o.tunnelRemoteHost);if(i){const n=i.get(o.tunnelRemotePort);n&&(n.refcount--,await this.o(o.tunnelRemoteHost,o.tunnelRemotePort,n))}}}}async o(o,i,n){if(n.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const s=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(i),s}}async closeTunnel(o,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const n=this.e.get(o);if(n&&n.has(i)){const s=n.get(i);s.refcount=0,await this.o(o,i,s)}}p(o,i,n){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(i,{refcount:1,value:n})}async q(o,i){const n=this.e.get(o);if(n){const s=n.get(i),a=s?await s.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this.e.delete(o)}}r(o,i){const n=[o];P(o)?(n.push(...e.$lv),n.push(...e.$nv)):$(o)&&n.push(...e.$nv);const s=n.map(a=>this.e.get(a));for(const a of s){const t=a?.get(i);if(t)return t}}canTunnel(o){return!!L(o)}t(o,i,n,s,a,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${s}.`);const h=n;this.i.add(h);const u=s===void 0?n:s,c={elevationRequired:a?this.isPortPrivileged(u):!1},l={remoteAddress:{host:i,port:n},localAddressPort:s,privacy:t,public:t?t!==w.Private:void 0,protocol:r},E=o.forwardPort(l,c);return E?(this.p(i,n,E),E.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(h)})):this.i.delete(h),E}};e.$rv=g,e.$rv=g=Ke([Be(0,A.$hj),Be(1,T.$ti)],g)}),define(ke[265],Se([1,0,5]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=void 0,e.$Sk=(0,D.$Zh)("IUriIdentityService")}),define(ke[266],Se([1,0,5]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$sv=void 0,e.$sv=(0,D.$Zh)("editSessionIdentityService");var T;(function(m){m[m.Complete=100]="Complete",m[m.Partial=50]="Partial",m[m.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(ke[267],Se([1,0,17]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=void 0;function T(b){return b.scheme!==D.Schemas.file&&b.scheme!==D.Schemas.vscodeRemote}e.$_J=T;function m(b){if(b.folders.length)return b.folders.every(y=>T(y.uri))?b.folders[0].uri:void 0;if(b.configuration&&T(b.configuration))return b.configuration}e.$aK=m;function A(b){return m(b)?.scheme}e.$bK=A;function R(b){return m(b)?.authority}e.$cK=R;function w(b){return m(b)!==void 0}e.$dK=w}),define(ke[40],Se([1,0,208,16,77,23,2,5,17]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.WorkbenchState=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=void 0,e.$9h=(0,w.$Zh)("contextService");function y(u){const c=u;return typeof c?.id=="string"&&R.URI.isUri(c.uri)}e.$0h=y;function L(u){return typeof u?.id=="string"&&!y(u)&&!$(u)}e.$$h=L,e.$_h={id:"ext-dev"},e.$ai={id:"empty-window"};function P(u,c){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,T.$mc)(u)}:c?e.$_h:e.$ai;const l=u;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$bi=P;function $(u){const c=u;return typeof c?.id=="string"&&R.URI.isUri(c.configPath)}e.$ci=$;function v(u){const c=u;if(c?.uri)return{id:c.id,uri:R.URI.revive(c.uri)};const l=u;if(l?.configPath)return{id:l.id,configPath:R.URI.revive(l.configPath)};if(u?.id)return{id:u.id}}e.$di=v;var S;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function g(u){const c=u;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.$ei=g;function d(u){const c=u;return!!(c&&typeof c=="object"&&R.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.$fi=d;class o{constructor(c,l,E,C,f){this.h=c,this.j=E,this.k=C,this.l=f,this.c=m.$6h.forUris(this.l,()=>!0),this.folders=l}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=m.$6h.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$gi=o;class i{constructor(c,l){this.raw=l,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,A.$Bg)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$hi=i;function n(u){return new i({uri:u,index:0,name:(0,A.$xg)(u)},{uri:u.toString()})}e.$ii=n,e.$ji="code-workspace",e.$ki=`.${e.$ji}`,e.$li=[{name:(0,D.localize)(0,null),extensions:[e.$ji]}],e.$mi="workspace.json";function s(u,c){return A.$sg.isEqualOrParent(u,c.untitledWorkspacesHome)}e.$ni=s;function a(u){let c;return R.URI.isUri(u)?c=u:c=u.configuration,c?.scheme===b.Schemas.tmp}e.$oi=a,e.$pi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(u){return u.id===e.$pi}e.$qi=t;function r(u,c){return!s(u,c)&&!a(u)}e.$ri=r;function h(u){return(typeof u=="string"?(0,T.$nc)(u):(0,A.$zg)(u))===e.$ki}e.$si=h}),define(ke[268],Se([1,0,52,4,3,23,2,207,134,32,5,14,40,28,265,12,30,13,18]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.ProfileResourceType=void 0;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function s(u){const c=u;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&R.URI.isUri(c.location)&&R.URI.isUri(c.globalStorageHome)&&R.URI.isUri(c.settingsResource)&&R.URI.isUri(c.keybindingsResource)&&R.URI.isUri(c.tasksResource)&&R.URI.isUri(c.snippetsHome)&&R.URI.isUri(c.extensionsResource))}e.$Tk=s,e.$Uk=(0,L.$Zh)("IUserDataProfilesService");function a(u,c){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:R.URI.revive(u.location).with({scheme:c}),globalStorageHome:R.URI.revive(u.globalStorageHome).with({scheme:c}),settingsResource:R.URI.revive(u.settingsResource).with({scheme:c}),keybindingsResource:R.URI.revive(u.keybindingsResource).with({scheme:c}),tasksResource:R.URI.revive(u.tasksResource).with({scheme:c}),snippetsHome:R.URI.revive(u.snippetsHome).with({scheme:c}),extensionsResource:R.URI.revive(u.extensionsResource).with({scheme:c}),cacheHome:R.URI.revive(u.cacheHome).with({scheme:c}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}e.$Vk=a;function t(u,c,l,E,C,f){return{id:u,name:c,location:l,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:f&&C?.useDefaultFlags?.globalState?f.globalStorageHome:(0,A.$Bg)(l,"globalStorage"),settingsResource:f&&C?.useDefaultFlags?.settings?f.settingsResource:(0,A.$Bg)(l,"settings.json"),keybindingsResource:f&&C?.useDefaultFlags?.keybindings?f.keybindingsResource:(0,A.$Bg)(l,"keybindings.json"),tasksResource:f&&C?.useDefaultFlags?.tasks?f.tasksResource:(0,A.$Bg)(l,"tasks.json"),snippetsHome:f&&C?.useDefaultFlags?.snippets?f.snippetsHome:(0,A.$Bg)(l,"snippets"),extensionsResource:f&&C?.useDefaultFlags?.extensions?f.extensionsResource:(0,A.$Bg)(l,"extensions.json"),cacheHome:(0,A.$Bg)(E,u),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.$Wk=t;let r=class extends m.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,l,E,C){super(),this.t=c,this.u=l,this.w=E,this.y=C,this.f=!0,this.h=this.B(new T.$Rd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new T.$Rd),this.onWillCreateProfile=this.j.event,this.m=this.B(new T.$Rd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new T.$Rd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new v.$zc,emptyWindows:new Map},this.profilesHome=(0,A.$Bg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$Bg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),l=[c];if(this.f)try{for(const f of this.O()){if(!f.name||!(0,i.$Cf)(f.name)||!f.location){this.y.warn("Skipping the invalid stored profile",f.location||f.name);continue}l.push(t((0,A.$yg)(f.location),f.name,f.location,this.g,{shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags},c))}}catch(f){this.y.error(f)}const E=new v.$zc,C=new Map;if(l.length)try{const f=this.Q();if(f.workspaces)for(const[p,k]of Object.entries(f.workspaces)){const I=R.URI.parse(p),j=l.find(z=>z.id===k);j&&E.set(I,j)}if(f.emptyWindows)for(const[p,k]of Object.entries(f.emptyWindows)){const I=l.find(j=>j.id===k);I&&C.set(p,I)}}catch(f){this.y.error(f)}this.z={profiles:l,workspaces:E,emptyWindows:C}}return this.z}D(){const c=t("__default__profile__",(0,w.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const l="Temp",E=new RegExp(`${(0,o.$Je)(l)}\\s(\\d+)`);let C=0;for(const p of this.profiles){const k=E.exec(p.name),I=k?parseInt(k[1]):0;C=I>C?I:C}const f=`${l} ${C+1}`;return this.createProfile((0,D.$Ni)((0,d.$kg)()).toString(16),f,{transient:!0},c)}async createNamedProfile(c,l,E){return this.createProfile((0,D.$Ni)((0,d.$kg)()).toString(16),c,l,E)}async createProfile(c,l,E,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=await this.F(c,l,E);return C&&await this.setProfileForWorkspace(C,f),f}async F(c,l,E){if(!(0,i.$Cf)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.r.get(l);return C||(C=(async()=>{try{const f=this.profiles.find(I=>I.name===l||I.id===c);if(f)return f;const p=t(c,l,(0,A.$Bg)(this.profilesHome,c),this.g,E,this.defaultProfile);await this.u.createFolder(p.location);const k=[];return this.j.fire({profile:p,join(I){k.push(I)}}),await g.Promises.settled(k),this.I([p],[],[]),p}finally{this.r.delete(l)}})(),this.r.set(l,C)),C}async updateProfile(c,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let E=this.profiles.find(C=>C.id===c.id);if(!E)throw new Error(`Profile '${c.name}' does not exist`);return E=t(E.id,l.name??E.name,E.location,this.g,{shortName:l.shortName??E.shortName,icon:l.icon===null?void 0:l.icon??E.icon,transient:l.transient??E.isTransient,useDefaultFlags:l.useDefaultFlags??E.useDefaultFlags},this.defaultProfile),this.I([],[],[E]),E}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(C=>C.id===c.id);if(!l)throw new Error(`Profile '${c.name}' does not exist`);const E=[];this.m.fire({profile:l,join(C){E.push(C)}});try{await Promise.allSettled(E)}catch(C){this.y.error(C)}for(const C of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(C)?.id&&this.C.emptyWindows.delete(C);for(const C of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(C)?.id&&this.C.workspaces.delete(C);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(C){(0,y.$zk)(C)!==1&&this.y.error(C)}}async setProfileForWorkspace(c,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=this.profiles.find(C=>C.id===l.id);if(!E)throw new Error(`Profile '${l.name}' does not exist`);this.L(c,E)}unsetWorkspace(c,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(l=>l.isDirectory&&this.profiles.every(E=>!this.w.extUri.isEqual(E.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(c.map(l=>this.removeProfile(l)))}getProfileForWorkspace(c){const l=this.G(c);return R.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(c){return(0,$.$0h)(c)?c.uri:(0,$.$ci)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,c.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,c.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,c.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,c.location)))}I(c,l,E){const C=[...this.profiles,...c],f=[];this.s.profiles=[];for(let p of C)p.isDefault||l.some(k=>p.id===k.id)||(p=E.find(k=>p.id===k.id)??p,p.isTransient?this.s.profiles.push(p):f.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(f),this.z=void 0,this.J(c,l,E)}J(c,l,E){this.h.fire({added:c,removed:l,updated:E,all:this.profiles})}L(c,l,E){E=l?.isTransient?!0:E,E||this.L(c,void 0,!0);const C=this.G(c),f=E?this.s:this.C;R.URI.isUri(C)?(f.workspaces.delete(C),l&&f.workspaces.set(C,l)):(f.emptyWindows.delete(C),l&&f.emptyWindows.set(C,l)),E||this.M()}M(){const c={};for(const[E,C]of this.C.workspaces.entries())c[E.toString()]=C.id;const l={};for(const[E,C]of this.C.emptyWindows.entries())l[E.toString()]=C.id;this.R({workspaces:c,emptyWindows:l}),this.z=void 0}N(c){const l={},E=this.D();if(c.workspaces)for(const[f,p]of Object.entries(c.workspaces)){const k=R.URI.parse(p);l[f]=this.w.extUri.isEqual(k,E.location)?E.id:this.w.extUri.basename(k)}const C={};if(c.emptyWindows)for(const[f,p]of Object.entries(c.emptyWindows)){const k=R.URI.parse(p);C[f]=this.w.extUri.isEqual(k,E.location)?E.id:this.w.extUri.basename(k)}return{workspaces:l,emptyWindows:C}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Xk=r,e.$Xk=r=Ke([Be(0,b.$7h),Be(1,y.$ik),Be(2,S.$Sk),Be(3,P.$hj)],r);class h extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Yk=h}),define(ke[269],Se([1,0,12,4,3,56,18,187,5,268]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$dp=e.$cp=e.$bp=void 0,e.$bp="__$__isNewStorageMarker",e.$cp="__$__targetStorageMarker",e.$dp=(0,b.$Zh)("storageService");var L;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(L||(e.WillSaveStateReason=L={}));var P;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var $;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function v(i){const n=i.get(e.$cp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$ep=v;class S extends m.$Rc{static{this.a=60*1e3}constructor(n={flushInterval:S.a}){super(),this.m=n,this.b=this.B(new T.$Ud),this.c=this.B(new T.$Ud),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$Rd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$_g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new m.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,s,a){return T.Event.filter(this.b.event,t=>t.scope===n&&(s===void 0||t.key===s),a)}n(){this.j.value=(0,D.$dh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,m.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,s){const{key:a,external:t}=s;if(a===e.$cp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,s,a){return this.P(s)?.get(n,a)}getBoolean(n,s,a){return this.P(s)?.getBoolean(n,a)}getNumber(n,s,a){return this.P(s)?.getNumber(n,a)}getObject(n,s,a){return this.P(s)?.getObject(n,a)}storeAll(n,s){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,s)})}store(n,s,a,t,r=!1){if((0,R.$Lf)(s)){this.remove(n,a,r);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,s,r)})}remove(n,s,a=!1){this.y(()=>{this.z(n,s,void 0),this.P(s)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,s){const a=[],t=this.J(n);for(const r of Object.keys(t))t[r]===s&&a.push(r);return a}z(n,s,a,t=!1){const r=this.J(s);typeof a=="number"?r[n]!==a&&(r[n]=a,this.P(s)?.set(e.$cp,JSON.stringify(r),t)):typeof r[n]=="number"&&(delete r[n],this.P(s)?.set(e.$cp,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const s=this.P(n);return s?v(s):Object.create(null)}isNew(n){return this.getBoolean(e.$bp,n)===!0}async flush(n=L.NONE){this.f.fire({reason:n});const s=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case L.NONE:await D.Promises.settled([s?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case L.SHUTDOWN:await D.Promises.settled([s?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,s=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return o(n,s,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,s){return this.w(L.NONE),(0,y.$Tk)(n)?this.R(n,s):this.S(n,s)}M(n,s){return!(n.id===s.id||g(s)&&g(n))}N(n,s,a){this.y(()=>{const t=new Set;for(const[r,h]of n)t.add(r),s.get(r)!==h&&this.u(a,{key:r,external:!0});for(const[r]of s.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$fp=S;function g(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$gp=g;class d extends S{constructor(){super(),this.U=this.B(new w.$_o(new w.$ap,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new w.$_o(new w.$ap,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new w.$_o(new w.$ap,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$hp=d;async function o(i,n,s,a,t,r){const h=I=>{try{return JSON.parse(I)}catch{return I}},u=new Map,c=new Map;i.forEach((I,j)=>{u.set(j,I),c.set(j,h(I))});const l=new Map,E=new Map;n.forEach((I,j)=>{l.set(j,I),E.set(j,h(I))});const C=new Map,f=new Map;s.forEach((I,j)=>{C.set(j,I),f.set(j,h(I))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const p=[];if(u.forEach((I,j)=>{p.push({key:j,value:I})}),console.table(p),console.groupEnd(),console.log(c),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const I=[];l.forEach((j,z)=>{I.push({key:z,value:j})}),console.table(I),console.groupEnd(),console.log(E)}console.group(`Storage: Workspace (path: ${r})`);const k=[];C.forEach((I,j)=>{k.push({key:j,value:I})}),console.table(k),console.groupEnd(),console.log(f)}e.$ip=o}),define(ke[110],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class D{static{this.a=!1}constructor(m){this.d=m,this.b=new Map,this.c=1}add(m){const A=this.c++;return this.b.set(A,m),this.e(),A}get(m,A){return this.b.has(m)?this.b.get(m)[A]:void 0}delete(m){this.b.delete(m),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$jec=D}),define(ke[57],Se([1,0,17,23,5]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=e.$mec=void 0;class A{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new T.$qg(w=>{const b=this.b.get(w.scheme);return!(b===void 0||b&1024)})}$acceptProviderInfos(w,b){b===null?this.b.delete(w.scheme):this.b.set(w.scheme,b)}isFreeScheme(w){return!this.b.has(w)&&!this.a.has(w)}getCapabilities(w){return this.b.get(w)}}e.$mec=A,e.$nec=(0,m.$Zh)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=void 0,e.$UM=(0,D.$Zh)("IExtHostInitDataService")}),define(ke[270],Se([1,0,213,14,250,27]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;let R=class extends m.$2N{constructor(b,y,L){const P=L.remote.isRemote?"remoteexthost":b?"workerexthost":"exthost",$=L.remote.isRemote?(0,D.localize)(0,null):b?(0,D.localize)(1,null):(0,D.localize)(2,null);super(y.createLogger(P,{name:$}))}};e.$tgc=R,e.$tgc=R=Ke([Be(1,T.$ij),Be(2,A.$UM)],R)}),define(ke[271],Se([1,0,12]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=e.$8ec=void 0;class T{constructor(R,w,b){this.h=new Map,this.a=R,this.b=w,this.c=b,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new D.$_g(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of y.values())L.complete()}catch(L){for(const P of y.values())P.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,w){let b=this.f[R];return typeof b>"u"&&(b=w),b}update(R,w){this.f[R]=w;const b=this.h.get(R);if(b!==void 0)return b.p;const y=new D.$kh;return this.h.set(R,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$8ec=T;class m extends T{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,w){super(R.identifier.value,!0,w),this.j=R}}e.$9ec=m}),define(ke[272],Se([1,0,4,2]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=void 0;class m{constructor(R){this.c=R,this.a=new D.$Rd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Rd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,w,b,y){const P=this.c.getNotebookDocument(T.URI.revive(R)).acceptModelChanged(w.value,b,y);this.b.fire(P)}$acceptDirtyStateChanged(R,w){this.c.getNotebookDocument(T.URI.revive(R)).acceptDirty(w)}$acceptModelSaved(R){const w=this.c.getNotebookDocument(T.URI.revive(R));this.a.fire(w.apiNotebook)}}e.$Vfc=m}),define(ke[20],Se([1,0,5]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0,e.$EM=(0,D.$Zh)("IExtHostRpcService");class T{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$FM=T}),define(ke[273],Se([1,0,26,4]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class m{#e;constructor(R,w){this.b=new T.$Rd,this.onDidChange=this.b.event,this.a=D.$dm.toKey(R.identifier),this.#e=w,this.#e.onDidChangePassword(b=>{b.extensionId===this.a&&this.b.fire({key:b.key})})}get(R){return this.#e.get(this.a,R)}store(R,w){return this.#e.store(this.a,R,w)}delete(R){return this.#e.delete(this.a,R)}}e.$dfc=m}),define(ke[66],Se([1,0,5]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=e.$Fec=void 0,e.$Fec=(0,D.$Zh)("IURITransformerService");class T{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Gec=T}),define(ke[274],Se([1,0,22]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfb=e.$gfb=void 0;class T{constructor(){this.buffers=[]}add(b){let y=this.buffers.indexOf(b);return y<0&&(y=this.buffers.length,this.buffers.push(b)),y}}function m(w,b){if(b.serializeBuffersForPostMessage){const y=new T,P=JSON.stringify(w,(v,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S)};if(ArrayBuffer.isView(S)){const g=A(S);if(g)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S.buffer),view:{type:g,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),$=y.buffers.map(v=>{const S=new Uint8Array(v);return D.$fe.wrap(S)});return{message:P,buffers:$}}else return{message:JSON.stringify(w),buffers:[]}}e.$gfb=m;function A(w){switch(w.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(w,b){const y=b.map($=>{const v=new ArrayBuffer($.byteLength);return new Uint8Array(v).set($.buffer),v}),L=b.length?($,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const S=v,{index:g}=S,d=y[g];if(S.view)switch(S.view.type){case 1:return new Int8Array(d,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return v}:void 0;return{message:JSON.parse(w,L),arrayBuffers:y}}e.$hfb=R}),define(ke[275],Se([1,0,276,387,388,62,2,14,389]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=void 0;const y=!1;function L(n,s,a,t,r,h){const u=h.environment.useHostProxy,c=typeof u=="boolean"?u:!h.remote.isRemote,l={resolveProxy:f=>n.resolveProxy(f),lookupProxyAuthorization:d.bind(void 0,t,r,s,{},h.remote.isRemote),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>$(s),addCertificatesV2:()=>v(s),log:t,getLogLevel:()=>{const f=t.getLevel();switch(f){case w.LogLevel.Trace:return b.LogLevel.Trace;case w.LogLevel.Debug:return b.LogLevel.Debug;case w.LogLevel.Info:return b.LogLevel.Info;case w.LogLevel.Warning:return b.LogLevel.Warning;case w.LogLevel.Error:return b.LogLevel.Error;case w.LogLevel.Off:return b.LogLevel.Off;default:return p(f)}function p(k){return t.error("Unknown log level",k),b.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,loadAdditionalCertificates:async()=>{const f=[];if(h.remote.isRemote&&f.push((0,b.loadSystemCertificates)({log:t})),c){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const p=n.loadCertificates();p.then(k=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",k.length)),f.push(p)}return(await Promise.all(f)).flat()},env:process.env},E=(0,b.createProxyResolver)(l),C=P(l,E);return g(a,C)}e.$2gc=L;function P(n,s){return{http:Object.assign(D,(0,b.createHttpPatch)(n,D,s)),https:Object.assign(T,(0,b.createHttpPatch)(n,T,s)),net:Object.assign(A,(0,b.createNetPatch)(n,A)),tls:Object.assign(m,(0,b.createTlsPatch)(n,m))}}function $(n){const s=n.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",y)&&!!s.get("systemCertificates")}function v(n){const s=n.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",y)&&!!s.get("systemCertificates")}const S=new Map;function g(n,s){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(u,c,l){if(u==="net")return s.net;if(u==="tls")return s.tls;if(u!=="http"&&u!=="https")return r.apply(this,arguments);const E=a.findSubstr(R.URI.file(c.filename));let C=S.get(E);if(C||S.set(E,C={}),!C[u]){const f=s[u];C[u]={...f}}return C[u]}})}async function d(n,s,a,t,r,h,u,c){const l=t[h];u&&(t[h]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${h}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${l}`);const E=u||l,C=Array.isArray(E)?E:typeof E=="string"?[E]:[];if(i(s,C,r),C.some(f=>/^(Negotiate|Kerberos)( |$)/i.test(f))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const f=await new Promise((z,M)=>{be(["kerberos"],z,M)}),p=new URL(h),k=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${p.hostname}`:`HTTP@${p.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${h}`,`spn:${k}`),"Negotiate "+await(await f.initializeClient(k)).step("")}catch(f){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",f)}}let o=!1;function i(n,s,a){o||!s.length||(o=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(ke[277],Se([1,0,131]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=void 0;function T(A){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:A,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function m(A){return new D.$Vm(T(A))}e.$Kr=m}),define(ke[140],Se([1,0,224,18,2,3,5,37,32,17,44,179,39]),function(be,e,D,T,m,A,R,w,b,y,L,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FE=e.$EE=e.$DE=e.EditorsOrder=e.$CE=e.CloseDirection=e.$BE=e.$AE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.$uE=e.$tE=e.$sE=e.EditorInputCapabilities=e.$rE=e.SaveReason=e.Verbosity=e.$qE=e.$pE=e.$oE=e.$nE=e.$mE=e.$lE=e.$kE=e.$jE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$iE=e.$hE=e.$gE=e.$fE=e.$eE=void 0,e.$eE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$fE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$gE="workbench.editor.sidebysideEditor",e.$hE="workbench.editors.textDiffEditor",e.$iE="workbench.editors.binaryResourceDiffEditor";var v;(function(de){de[de.PROGRAMMATIC=1]="PROGRAMMATIC",de[de.USER=2]="USER",de[de.EDIT=3]="EDIT",de[de.NAVIGATION=4]="NAVIGATION",de[de.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var S;(function(de){de[de.IDENTICAL=1]="IDENTICAL",de[de.SIMILAR=2]="SIMILAR",de[de.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function g(de){const H=de;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}e.$jE=g;function d(de,H,U){for(const ne of U.visibleEditorPanes)if(ne.group.id===H&&de.matches(ne.input))return ne.getViewState()}e.$kE=d;function o(de){if(E(de))return!1;const H=de;return m.URI.isUri(H?.resource)}e.$lE=o;function i(de){if(E(de))return!1;const H=de;return H?.original!==void 0&&H.modified!==void 0}e.$mE=i;function n(de){if(E(de))return!1;const H=de;return Array.isArray(H?.resources)}e.$nE=n;function s(de){if(E(de)||i(de))return!1;const H=de;return H?.primary!==void 0&&H.secondary!==void 0}e.$oE=s;function a(de){if(E(de))return!1;const H=de;return H?H.resource===void 0||H.resource.scheme===y.Schemas.untitled||H.forceUntitled===!0:!1}e.$pE=a;function t(de){if(E(de))return!1;const H=de;return m.URI.isUri(H?.base?.resource)&&m.URI.isUri(H?.input1?.resource)&&m.URI.isUri(H?.input2?.resource)&&m.URI.isUri(H?.result?.resource)}e.$qE=t;var r;(function(de){de[de.SHORT=0]="SHORT",de[de.MEDIUM=1]="MEDIUM",de[de.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var h;(function(de){de[de.EXPLICIT=1]="EXPLICIT",de[de.AUTO=2]="AUTO",de[de.FOCUS_CHANGE=3]="FOCUS_CHANGE",de[de.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(h||(e.SaveReason=h={}));class u{constructor(){this.a=new Map}registerSource(H,U){let ne=this.a.get(H);return ne||(ne={source:H,label:U},this.a.set(H,ne)),ne.source}getSourceLabel(H){return this.a.get(H)?.label??H}}e.$rE=new u;var c;(function(de){de[de.None=0]="None",de[de.Readonly=2]="Readonly",de[de.Untitled=4]="Untitled",de[de.Singleton=8]="Singleton",de[de.RequiresTrust=16]="RequiresTrust",de[de.CanSplitInGroup=32]="CanSplitInGroup",de[de.ForceDescription=64]="ForceDescription",de[de.CanDropIntoEditor=128]="CanDropIntoEditor",de[de.MultipleEditors=256]="MultipleEditors",de[de.Scratchpad=512]="Scratchpad",de[de.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(c||(e.EditorInputCapabilities=c={}));class l extends A.$Rc{}e.$sE=l;function E(de){return de instanceof l}e.$tE=E;function C(de){const H=de;return m.URI.isUri(H?.preferredResource)}function f(de){const H=de;return E(H?.primary)&&E(H?.secondary)}e.$uE=f;function p(de){const H=de;return E(H?.modified)&&E(H?.original)}e.$vE=p;function k(de,H,U,ne,Ee){return ye(ne,[(0,P.$Ji)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const fe={...U,limits:{size:Number.MAX_VALUE}};de.openEditor(H,fe)}}),(0,P.$Ji)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>Ee.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}e.$wE=k;function I(de){return E(de?.editor)}e.$xE=I;function j(de){const H=de;return I(de)&&H?.group!==void 0}e.$yE=j;function z(de){const H=de;return typeof H?.groupId=="number"&&E(H.editor)}e.$zE=z;var M;(function(de){de[de.UNKNOWN=0]="UNKNOWN",de[de.REPLACE=1]="REPLACE",de[de.MOVE=2]="MOVE",de[de.UNPIN=3]="UNPIN"})(M||(e.EditorCloseContext=M={}));var F;(function(de){de[de.GROUP_ACTIVE=0]="GROUP_ACTIVE",de[de.GROUP_INDEX=1]="GROUP_INDEX",de[de.GROUP_LABEL=2]="GROUP_LABEL",de[de.GROUP_LOCKED=3]="GROUP_LOCKED",de[de.EDITOR_OPEN=4]="EDITOR_OPEN",de[de.EDITOR_CLOSE=5]="EDITOR_CLOSE",de[de.EDITOR_MOVE=6]="EDITOR_MOVE",de[de.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",de[de.EDITOR_LABEL=8]="EDITOR_LABEL",de[de.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",de[de.EDITOR_PIN=10]="EDITOR_PIN",de[de.EDITOR_STICKY=11]="EDITOR_STICKY",de[de.EDITOR_DIRTY=12]="EDITOR_DIRTY",de[de.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var N;(function(de){de[de.PRIMARY=1]="PRIMARY",de[de.SECONDARY=2]="SECONDARY",de[de.BOTH=3]="BOTH",de[de.ANY=4]="ANY"})(N||(e.SideBySideEditor=N={}));class O{getOriginalUri(H,U){if(!H)return;if(t(H))return e.$BE.getOriginalUri(H.result,U);if(U?.supportSideBySide){const{primary:Ee,secondary:fe}=this.a(H);if(Ee&&fe){if(U?.supportSideBySide===N.BOTH)return{primary:this.getOriginalUri(Ee,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(fe,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===N.ANY)return this.getOriginalUri(Ee,{filterByScheme:U.filterByScheme})??this.getOriginalUri(fe,{filterByScheme:U.filterByScheme});H=U.supportSideBySide===N.PRIMARY?Ee:fe}}if(i(H)||n(H)||s(H)||t(H))return;const ne=C(H)?H.preferredResource:H.resource;return!ne||!U||!U.filterByScheme?ne:this.b(ne,U.filterByScheme)}a(H){return f(H)||s(H)?{primary:H.primary,secondary:H.secondary}:p(H)||i(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,U){if(!H)return;if(t(H))return e.$BE.getCanonicalUri(H.result,U);if(U?.supportSideBySide){const{primary:Ee,secondary:fe}=this.a(H);if(Ee&&fe){if(U?.supportSideBySide===N.BOTH)return{primary:this.getCanonicalUri(Ee,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(fe,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===N.ANY)return this.getCanonicalUri(Ee,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(fe,{filterByScheme:U.filterByScheme});H=U.supportSideBySide===N.PRIMARY?Ee:fe}}if(i(H)||n(H)||s(H)||t(H))return;const ne=H.resource;return!ne||!U||!U.filterByScheme?ne:this.b(ne,U.filterByScheme)}b(H,U){if(Array.isArray(U)){if(U.some(ne=>H.scheme===ne))return H}else if(U===H.scheme)return H}}var W;(function(de){de[de.UNKNOWN=0]="UNKNOWN",de[de.KEYBOARD=1]="KEYBOARD",de[de.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function x(de,H,U,ne){if(!de.isSticky(H))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return U===W.MOUSE||U===W.KEYBOARD;case"mouse":return U===W.MOUSE;case"keyboard":return U===W.KEYBOARD}return!1}e.$AE=x,e.$BE=new O;var ue;(function(de){de[de.LEFT=0]="LEFT",de[de.RIGHT=1]="RIGHT"})(ue||(e.CloseDirection=ue={}));class X{constructor(){this.c=new Map,this.d=new Map}start(H){const U=this.a=H.get(R.$Yh);for(const[ne,Ee]of this.c)this.e(ne,Ee,U);this.c.clear()}e(H,U,ne){const Ee=ne.createInstance(U);this.d.set(H,Ee)}registerFileEditorFactory(H){if(this.b)throw new Error("Can only register one file editor factory.");this.b=H}getFileEditorFactory(){return(0,T.$Nf)(this.b)}registerEditorSerializer(H,U){if(this.c.has(H)||this.d.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.a?this.e(H,U,this.a):this.c.set(H,U),(0,A.$Pc)(()=>{this.c.delete(H),this.d.delete(H)})}getEditorSerializer(H){return this.d.get(typeof H=="string"?H:H.typeId)}}w.$qn.add(e.$eE.EditorFactory,new X);async function J(de,H,U){return!de||!de.length?[]:await Promise.all(de.map(async ne=>{const Ee=m.URI.revive(ne.fileUri);if(!Ee){U.info("Cannot resolve the path because it is not valid.",ne);return}if(!await H.canHandleResource(Ee)){U.info("Cannot resolve the path because it cannot be handled",ne);return}let me=ne.exists,ee=ne.type;if(typeof me!="boolean"||typeof ee!="number")try{ee=(await H.stat(Ee)).isDirectory?b.FileType.Directory:b.FileType.Unknown,me=!0}catch(K){U.error(K),me=!1}if(!me&&ne.openOnlyIfExists){U.info("Cannot resolve the path because it does not exist",ne);return}if(ee===b.FileType.Directory){U.info("Cannot resolve the path because it is a directory",ne);return}const te={...ne.options,pinned:!0};return me?{resource:Ee,options:te}:{resource:Ee,options:te,forceUntitled:!0}}))}e.$CE=J;var Q;(function(de){de[de.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",de[de.SEQUENTIAL=1]="SEQUENTIAL"})(Q||(e.EditorsOrder=Q={}));function he(de){const H=de;if(!H)return!1;const U=H;if(U.modified)return he(U.modified);const ne=H;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$DE=he;function Z(de){return(0,L.$Li)(de)}e.$EE=Z;function ye(de,H,U){const ne=(0,L.$Mi)(de,H);return ne.forceMessage=U?.forceMessage,ne.forceSeverity=U?.forceSeverity,ne.allowDialog=U?.allowDialog,ne}e.$FE=ye}),define(ke[278],Se([1,0,4,225,5,3,28,37,19,24,78,264]),function(be,e,D,T,m,A,R,w,b,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OE=e.$NE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$ME=e.$LE=e.ViewContentGroups=e.$KE=e.$JE=e.ViewContainerLocation=e.Extensions=e.$IE=e.$HE=e.$GE=void 0,e.$GE="views",e.$HE=(0,T.localize)(0,null),e.$IE=(0,P.$ew)("default-view-icon",L.$5j.window,(0,T.localize)(1,null));var $;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})($||(e.Extensions=$={}));var v;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$JE=[0,1,2];function S(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$KE=S;class g extends A.$Rc{constructor(){super(...arguments),this.c=this.B(new D.$Rd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Rd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,b.$Qb)([...this.g.values()])}registerViewContainer(h,u,c){const l=this.get(h.id);if(l)return l;const E=h;return E.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,R.$wc)(this.g,u,[]).push(E),c?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:u}),E}deregisterViewContainer(h){for(const u of this.g.keys()){const c=this.g.get(u),l=c?.indexOf(h);if(l!==-1){c?.splice(l,1),c.length===0&&this.g.delete(u),this.f.fire({viewContainer:h,viewContainerLocation:u});return}}}get(h){return this.all.filter(u=>u.id===h)[0]}getViewContainers(h){return[...this.g.get(h)||[]]}getViewContainerLocation(h){return[...this.g.keys()].filter(u=>this.getViewContainers(u).filter(c=>c?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.h.find(u=>this.getViewContainerLocation(u)===h)}}w.$qn.add($.ViewContainersRegistry,new g);var d;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(d||(e.ViewContentGroups=d={}));function o(r,h){const u=r.group??d.More,c=h.group??d.More;return u!==c?u.localeCompare(c):(r.order??5)-(h.order??5)}class i extends A.$Rc{constructor(){super(...arguments),this.c=this.B(new D.$Rd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Rd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Rd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Rd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Fc}registerViews(h,u){this.registerViews2([{views:h,viewContainer:u}])}registerViews2(h){h.forEach(({views:u,viewContainer:c})=>this.r(u,c)),this.c.fire(h)}deregisterViews(h,u){const c=this.s(h,u);c.length&&this.f.fire({views:c,viewContainer:u})}moveViews(h,u){for(const c of this.m.keys())if(c!==u){const l=this.s(h,c);l.length&&(this.r(l,u),this.g.fire({views:l,from:c,to:u}))}}getViews(h){return this.m.get(h)||[]}getView(h){for(const u of this.j){const c=(this.m.get(u)||[]).filter(l=>l.id===h)[0];if(c)return c}return null}getViewContainer(h){for(const u of this.j)if((this.m.get(u)||[]).filter(l=>l.id===h)[0])return u;return null}registerViewWelcomeContent(h,u){return this.n.add(h,u),this.h.fire(h),(0,A.$Pc)(()=>{this.n.delete(h,u),this.h.fire(h)})}registerViewWelcomeContent2(h,u){const c=new Map;for(const[l,E]of u)this.n.add(h,E),c.set(l,(0,A.$Pc)(()=>{this.n.delete(h,E),this.h.fire(h)}));return this.h.fire(h),c}getViewWelcomeContent(h){const u=[];return this.n.forEach(h,c=>u.push(c)),u.sort(o)}r(h,u){let c=this.m.get(u);c||(c=[],this.m.set(u,c),this.j.push(u));for(const l of h){if(this.getView(l.id)!==null)throw new Error((0,T.localize)(2,null,l.id));c.push(l)}}s(h,u){const c=this.m.get(u);if(!c)return[];const l=[],E=[];for(const C of c)h.includes(C)?l.push(C):E.push(C);return l.length&&(E.length?this.m.set(u,E):(this.m.delete(u),this.j.splice(this.j.indexOf(u),1))),l}}w.$qn.add($.ViewsRegistry,new i),e.$LE=(0,m.$Zh)("viewsService"),e.$ME=(0,m.$Zh)("viewDescriptorService");var n;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var s;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(s||(e.TreeItemCollapsibleState=s={}));class a{constructor(h,u){this.c=!1,this.d=!1,(0,y.$hn)(this,h),this.d=!!u,this.resolve=async c=>{if(u&&!this.c){const l=await u(c);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$NE=a;class t extends Error{constructor(h){super((0,T.localize)(3,null,h)),this.name="NoTreeViewError"}static is(h){return h.name==="NoTreeViewError"}}e.$OE=t}),define(ke[279],Se([1,0,2,29,5]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$cF=e.$bF=void 0;function A(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof D.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(T.$Ds.isIRange)}e.$bF=A;function R(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(A)}e.$cF=R;var w;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(w||(e.InteractiveSessionVoteDirection=w={}));var b;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})(b||(e.InteractiveSessionCopyKind=b={})),e.$dF=(0,m.$Zh)("IChatService")}),define(ke[141],Se([1,0,4,12,226]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfb=void 0;class A{constructor(){this.f=new Map,this.k=[],this.m=new D.$Rd,this.n=new D.$Rd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(w){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=w}onEvent(w){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=w}onRequest(w){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=w}sendResponse(w){w.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${w.command}`)):this.s("response",w)}sendRequest(w,b,y,L){const P={command:w};if(b&&Object.keys(b).length>0&&(P.arguments=b),this.s("request",P),typeof L=="number"){const $=setTimeout(()=>{clearTimeout($);const v=this.f.get(P.seq);if(v){this.f.delete(P.seq);const S={type:"response",seq:0,request_seq:P.seq,success:!1,command:w,message:(0,m.localize)(0,null,L,w)};v(S)}},L)}return y&&this.f.set(P.seq,y),P.seq}acceptMessage(w){this.j?this.j(w):(this.k.push(w),this.k.length===1&&this.q())}o(w,b){return w.type!=="event"||b.type!=="event"}async q(){let w;for(;this.k.length;){if((!w||this.o(this.k[0],w))&&await(0,T.$1g)(0),w=this.k.shift(),!w)return;switch(w.type){case"event":this.i?.(w);break;case"request":this.g?.(w);break;case"response":{const b=w,y=this.f.get(b.request_seq);y&&(this.f.delete(b.request_seq),y(b));break}}}}s(w,b){b.type=w,b.seq=this.d++,this.sendMessage(b)}async u(){if(this.f.size===0)return Promise.resolve();const w=new Map;this.f.forEach((b,y)=>w.set(y,b)),await(0,T.$1g)(500),w.forEach((b,y)=>{b({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Mfb=A}),define(ke[280],Se([1,0,227,46,5]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$oH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$nH=e.MemoryRangeType=e.$mH=e.State=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=void 0,e.$jG="workbench.view.debug",e.$kG="workbench.debug.variablesView",e.$lG="workbench.debug.watchExpressionsView",e.$mG="workbench.debug.callStackView",e.$nG="workbench.debug.loadedScriptsView",e.$oG="workbench.debug.breakPointsView",e.$pG="workbench.debug.disassemblyView",e.$qG="workbench.panel.repl",e.$rG="workbench.panel.repl.view",e.$sG=new T.$ej("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$tG=new T.$ej("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$uG=new T.$ej("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$vG="debugUx",e.$wG=new T.$ej(e.$vG,"default",{type:"string",description:D.localize(3,null)}),e.$xG=new T.$ej("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$yG=new T.$ej("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$zG=new T.$ej("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$AG=new T.$ej("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$BG=new T.$ej("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$CG=new T.$ej("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$DG=new T.$ej("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$EG=new T.$ej("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$FG=new T.$ej("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$GG=new T.$ej("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$HG=new T.$ej("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$IG=new T.$ej("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$JG=new T.$ej("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$KG=new T.$ej("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$LG=new T.$ej("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$MG=new T.$ej("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$NG=new T.$ej("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$OG=new T.$ej("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$PG=new T.$ej("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$QG=new T.$ej("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$RG=new T.$ej("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$SG=new T.$ej("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$TG=new T.$ej("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(26,null)}),e.$UG=new T.$ej("stepBackSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$VG=new T.$ej("restartFrameSupported",!1,{type:"boolean",description:D.localize(28,null)}),e.$WG=new T.$ej("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(29,null)}),e.$XG=new T.$ej("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$YG=new T.$ej("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(31,null)}),e.$ZG=new T.$ej("breakpointsExist",!1,{type:"boolean",description:D.localize(32,null)}),e.$1G=new T.$ej("debuggersAvailable",!1,{type:"boolean",description:D.localize(33,null)}),e.$2G=new T.$ej("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(34,null)}),e.$3G=new T.$ej("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(35,null)}),e.$4G=new T.$ej("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$5G=new T.$ej("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$6G=new T.$ej("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$7G=new T.$ej("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$8G=new T.$ej("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$9G=new T.$ej("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$0G=new T.$ej("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(42,null)}),e.$$G=new T.$ej("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(43,null)}),e.$_G=new T.$ej("variableIsReadonly",!1,{type:"boolean",description:D.localize(44,null)}),e.$aH=new T.$ej("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(45,null)}),e.$bH=new T.$ej("multiSessionRepl",!1,{type:"boolean",description:D.localize(46,null)}),e.$cH=new T.$ej("multiSessionDebug",!1,{type:"boolean",description:D.localize(47,null)}),e.$dH=new T.$ej("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(48,null)}),e.$eH=new T.$ej("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(49,null)}),e.$fH=new T.$ej("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(50,null)}),e.$gH=new T.$ej("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(51,null)});const A=$=>D.localize(52,null,$);e.$hH=A,e.$iH="editor.contrib.debug",e.$jH="editor.contrib.breakpoint",e.$kH="debug",e.$lH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(53,null)};var R;(function($){$[$.Inactive=0]="Inactive",$[$.Initializing=1]="Initializing",$[$.Stopped=2]="Stopped",$[$.Running=3]="Running"})(R||(e.State=R={}));function w($){switch($){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$mH=w;var b;(function($){$[$.Valid=0]="Valid",$[$.Unreadable=1]="Unreadable",$[$.Error=2]="Error"})(b||(e.MemoryRangeType=b={})),e.$nH="vscode-debug-memory";var y;(function($){$[$.Initial=1]="Initial",$[$.Dynamic=2]="Dynamic"})(y||(e.DebugConfigurationProviderTriggerKind=y={}));var L;(function($){$.UnverifiedBreakpoints="unverifiedBreakpoints"})(L||(e.DebuggerString=L={})),e.$oH=(0,m.$Zh)("debugService");var P;(function($){$[$.CONDITION=0]="CONDITION",$[$.HIT_COUNT=1]="HIT_COUNT",$[$.LOG_MESSAGE=2]="LOG_MESSAGE"})(P||(e.BreakpointWidgetContext=P={}))}),define(ke[281],Se([1,0,13,2,16,24,17,29,21,19]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=void 0;const L=/{([^}]+)}/g;function P(C,f,p){return C.replace(L,function(k,I){return f&&I.length>0&&I[0]!=="_"?k:p&&p.hasOwnProperty(I)?p[I]:k})}e.$iF=P;function $(C){const f={};for(const p of Object.keys(C))p.startsWith("!")||(f[p]=C[p]);return f}e.$jF=$;function v(C){return C.configuration.request==="attach"&&!S(C)&&(!C.parentSession||v(C.parentSession))}e.$kF=v;function S(C){let f=C.configuration.type;if(f)return f==="vslsShare"&&(f=C.configuration.adapterProxy.configuration.type),(0,D.$6e)(f,"extensionhost")||(0,D.$6e)(f,"pwa-extensionhost")?C:C.parentSession?S(C.parentSession):void 0}e.$lF=S;function g(C){return C.type&&(C.label||C.program||C.runtime)}e.$mF=g;function d(C,f,p){let k,I=0;const j=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=j.exec(C);){const M=z.index+1,F=M+z[0].length;if(M<=f&&F>=p){k=z[0],I=M;break}}if(k){const M=/\w+/g;let F=null;for(;(F=M.exec(k))&&!(F.index+1+I+F[0].length>=p););F&&(k=k.substring(0,M.lastIndex))}return k?{start:I,end:I+k.length-1}:{start:0,end:0}}e.$nF=d;async function o(C,f,p,k){if(C.evaluatableExpressionProvider.has(f)){const I=C.evaluatableExpressionProvider.ordered(f),j=(0,y.$Gb)(await Promise.all(I.map(async z=>{try{return await z.provideEvaluatableExpression(f,p,k??b.CancellationToken.None)}catch{return}})));if(j.length>0){let z=j[0].expression;const M=j[0].range;return z||(z=f.getLineContent(p.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:z}}}else{const I=f.getLineContent(p.lineNumber),{start:j,end:z}=d(I,p.column,p.column),M=I.substring(j-1,z);return{matchingExpression:M,range:new w.$Ds(p.lineNumber,j,p.lineNumber,j+M.length)}}return null}e.$oF=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(C){return!!(C&&C.match(i))}e.$pF=n;function s(C){if(typeof C.path=="string"&&!(typeof C.sourceReference=="number"&&C.sourceReference>0)){if(n(C.path))return T.URI.parse(C.path);if((0,m.$hc)(C.path))return T.URI.file(C.path)}return C.path}function a(C){if(typeof C.path=="object"){const f=T.URI.revive(C.path);if(f)return f.scheme===R.Schemas.file?f.fsPath:f.toString()}return C.path}function t(C,f){const p=f?s:a,k=(0,A.$en)(C);return h(k,(I,j)=>{I&&j&&(j.path=p(j))}),k}e.$qF=t;function r(C,f){const p=f?s:a,k=(0,A.$en)(C);return h(k,(I,j)=>{!I&&j&&(j.path=p(j))}),k}e.$rF=r;function h(C,f){switch(C.type){case"event":{const p=C;switch(p.event){case"output":f(!1,p.body.source);break;case"loadedSource":f(!1,p.body.source);break;case"breakpoint":f(!1,p.body.breakpoint.source);break;default:break}break}case"request":{const p=C;switch(p.command){case"setBreakpoints":f(!0,p.arguments.source);break;case"breakpointLocations":f(!0,p.arguments.source);break;case"source":f(!0,p.arguments.source);break;case"gotoTargets":f(!0,p.arguments.source);break;case"launchVSCode":p.arguments.args.forEach(k=>f(!1,k));break;default:break}break}case"response":{const p=C;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(k=>f(!1,k.source));break;case"loadedSources":p.body.sources.forEach(k=>f(!1,k));break;case"scopes":p.body.scopes.forEach(k=>f(!1,k.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(k=>f(!1,k.source));break;case"setBreakpoints":p.body.breakpoints.forEach(k=>f(!1,k.source));break;case"disassemble":p.body?.instructions.forEach(I=>f(!1,I.location));break;default:break}break}}}function u(C){return C.filter(f=>!f.presentation?.hidden).sort((f,p)=>f.presentation?p.presentation?f.presentation.group?p.presentation.group?f.presentation.group!==p.presentation.group?f.presentation.group.localeCompare(p.presentation.group):c(f.presentation.order,p.presentation.order):-1:p.presentation.group?1:c(f.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.$sF=u;function c(C,f){return typeof C!="number"?typeof f!="number"?0:1:typeof f!="number"?-1:C-f}async function l(C,f){const p=C.getValue("debug.saveBeforeStart",{overrideIdentifier:f.activeTextEditorLanguageId});if(p!=="none"&&(await f.saveAll(),p==="allEditorsInActiveGroup")){const k=f.activeEditorPane;k&&k.input.resource?.scheme===R.Schemas.untitled&&await f.save({editor:k.input,groupId:k.group.id})}await C.reloadConfiguration()}e.$tF=l;const E=(C,f)=>!C||!f?C===f:C.name===f.name&&C.path===f.path&&C.sourceReference===f.sourceReference;e.$uF=E}),define(ke[282],Se([1,0,50,62,24,16,11,13,31,228,141]),function(be,e,D,T,m,A,R,w,b,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=e.$Cgc=e.$Bgc=e.$Agc=e.$zgc=void 0;class P extends L.$Mfb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",n=>this.w(n))}sendMessage(o){if(this.p){const i=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${P.a}${i}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(P.a);if(i!==-1){const s=this.r.toString("utf8",0,i).split(P.b);for(const a of s){const t=a.split(P.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+P.a.length);continue}}break}}}e.$zgc=P;class $ extends P{startSession(){return new Promise((o,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",s=>{n?this.m.fire(s):i(s)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Agc=$;class v extends ${constructor(o){super(),this.z=o}y(o){return T.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$Bgc=v;class S extends ${constructor(o){super(),this.z=o}y(o){return T.createConnection(this.z.path,o)}}e.$Cgc=S;class g extends P{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,n=this.y.options||{};try{if(o)if(A.$hc(o)){if(!await b.Promises.exists(o))throw new Error(y.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let s=process.env;if(n.env&&Object.keys(n.env).length>0&&(s=m.$hn(m.$en(process.env),n.env)),o==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:s,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const r=D.fork(i[0],i.slice(1),t);if(!r.pid)throw new Error(y.localize(2,null,i[0]));this.x=r}else throw new Error(y.localize(3,null));else{const a={env:s};n.cwd&&(a.cwd=n.cwd),this.x=D.spawn(o,i,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(s){this.m.fire(s)}}async stopSession(){return this.x?(await this.u(),R.$i?new Promise((o,i)=>{const n=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(s,a,t){if(s)return i(s)});n.on("exit",o),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const n=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?n.runtime=A.$ic(i,o.runtime):n.runtime=o.runtime),o.runtimeArgs&&(n.runtimeArgs=o.runtimeArgs),o.program&&(A.$hc(o.program)?n.program=o.program:n.program=A.$ic(i,o.program)),o.args&&(n.args=o.args);const s=o;return s.win&&(n.win=g.A(s.win,i)),s.winx86&&(n.winx86=g.A(s.winx86,i)),s.windows&&(n.windows=g.A(s.windows,i)),s.osx&&(n.osx=g.A(s.osx,i)),s.linux&&(n.linux=g.A(s.linux,i)),n}static platformAdapterExecutable(o,i){let n=Object.create(null);i=i.toLowerCase();for(const u of o)if(u.contributes){const c=u.contributes.debuggers;c&&c.length>0&&c.filter(l=>typeof l.type=="string"&&w.$6e(l.type,i)).forEach(l=>{const E=g.A(l,u.extensionLocation.fsPath);n=m.$hn(n,E,u.isBuiltin)})}let s;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=n.winx86||n.win||n.windows:R.$i?s=n.win||n.windows:R.$j?s=n.osx:R.$k&&(s=n.linux),s=s||n;const a=s.program||n.program,t=s.args||n.args,r=s.runtime||n.runtime,h=s.runtimeArgs||n.runtimeArgs;if(r)return{type:"executable",command:r,args:(h||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$Dgc=g}),define(ke[283],Se([1,0,50,33,11]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=e.$Egc=void 0;function A(y,L){return new Promise((P,$)=>{let v="";const S=D.spawn(y,L);S.pid&&S.stdout.on("data",g=>{v+=g.toString()}),S.on("error",g=>{$(g)}),S.on("close",g=>{P(v)})})}async function R(y){if(y)if(m.$i){const L=await new Promise((P,$)=>{be(["@vscode/windows-process-tree"],P,$)});return new Promise(P=>{L.getProcessTree(y,$=>{P(!!$&&$.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(y)]).then(L=>{const P=L.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.$Egc=R;var w;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(w||(w={}));function b(y,L,P,$,v){y=y.trim().toLowerCase();let S;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?S=1:y.indexOf("cmd.exe")>=0?S=0:y.indexOf("bash")>=0?S=2:m.$i?S=0:S=2;let g,d=" ";switch(S){case 1:if(g=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),$){const o=(0,T.$7f)($);o&&(d+=`${o}:; `),d+=`cd ${g($)}; `}if(v)for(const o in v){const i=v[o];i===null?d+=`Remove-Item env:${o}; `:d+=`\${env:${o}}='${i}'; `}if(L.length>0){const o=L.shift(),i=P?o:g(o);d+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of L)d+=n==="<"||n===">"||P?n:g(n),d+=" "}break;case 0:if(g=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),$){const o=(0,T.$7f)($);o&&(d+=`${o}: && `),d+=`cd ${g($)} && `}if(v){d+='cmd /C "';for(const o in v){let i=v[o];i===null?d+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),d+=`set "${o}=${i}" && `)}}for(const o of L)d+=o==="<"||o===">"||P?o:g(o),d+=" ";v&&(d+='"');break;case 2:{g=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if($&&(d+=`cd ${g($)} ; `),v){d+="/usr/bin/env";for(const i in v){const n=v[i];n===null?d+=` -u ${o(i)}`:d+=` ${o(`${i}=${n}`)}`}d+=" "}for(const i of L)d+=i==="<"||i===">"||P?i:g(i),d+=" ";break}}return d}e.$Fgc=b}),define(ke[111],Se([1,0,22,34,51,100,17,16,11,46]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JI=e.$II=e.$HI=e.$GI=e.CellStatusbarAlignment=e.$FI=e.$EI=e.$DI=e.NotebookEditorPriority=e.$CI=e.$BI=e.$AI=e.$zI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$yI=e.$xI=e.$wI=e.$vI=e.CellKind=e.$uI=e.$tI=e.$sI=void 0,e.$sI="workbench.editor.notebook",e.$tI="workbench.editor.notebookTextDiffEditor",e.$uI="workbench.editor.interactive";var L;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(L||(e.CellKind=L={})),e.$vI=["application/json","application/javascript","text/html","image/svg+xml",A.$Zr.latex,A.$Zr.markdown,"image/png","image/jpeg",A.$Zr.text],e.$wI=[A.$Zr.latex,A.$Zr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$Zr.text],e.$xI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$yI="_notAvailable";var P;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(P||(e.NotebookRunState=P={}));var $;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var v;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var S;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var g;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var d;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var o;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var i;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(O){O.scheme=R.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],x=new RegExp(`^[${W.join("")}]+`),ue=7;function X(de,H){const U=H.toString(ue),Ee=`${U.length<W.length?W[U.length-1]:"z"}${U}s${(0,D.$ze)(D.$fe.fromString(de.scheme),!0,!0)}`;return de.with({scheme:O.scheme,fragment:Ee})}O.generate=X;function J(de){if(de.scheme!==O.scheme)return;const H=de.fragment.indexOf("s");if(H<0)return;const U=parseInt(de.fragment.substring(0,H).replace(x,""),ue),ne=(0,D.$ye)(de.fragment.substring(H+1)).toString();if(!isNaN(U))return{handle:U,notebook:de.with({scheme:ne,fragment:null})}}O.parse=J;function Q(de,H){return de.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${de.scheme!==R.Schemas.file?de.scheme:""}`})}O.generateCellOutputUri=Q;function he(de){if(de.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(de.fragment);if(!H)return;const U=H[1]&&H[1]!==""?H[1]:void 0,ne=H[2];return{outputId:U,notebook:de.with({scheme:ne||R.Schemas.file,fragment:null})}}O.parseCellOutputUri=he;function Z(de,H,U){return O.generate(de,H).with({scheme:U})}O.generateCellPropertyUri=Z;function ye(de,H){if(de.scheme===H)return O.parse(de.with({scheme:O.scheme}))}O.parseCellPropertyUri=ye})(n||(e.CellUri=n={}));const s=O=>b.$i?O.replace(/\//g,"\\"):O;class a{constructor(W=[],x=e.$vI){this.e=x,this.d=[...new Set(W)].map(ue=>({pattern:ue,matches:T.$Gj(s(ue))}))}sort(W){const x=new Map(m.Iterable.map(W,X=>[X,s(X)]));let ue=[];for(const{matches:X}of this.d)for(const[J,Q]of x)if(X(Q)){ue.push(J),x.delete(J);break}return x.size&&(ue=ue.concat([...x.keys()].sort((X,J)=>this.e.indexOf(X)-this.e.indexOf(J)))),ue}prioritize(W,x){const ue=this.f(W);if(ue===-1){this.d.unshift({pattern:W,matches:T.$Gj(s(W))});return}const X=new Set(x.map(Q=>this.f(Q,ue)));X.delete(-1);const J=Array.from(X).sort();this.d.splice(ue+1,0,...J.map(Q=>this.d[Q]));for(let Q=J.length-1;Q>=0;Q--)this.d.splice(J[Q],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,x=this.d.length){const ue=s(W);for(let X=0;X<x;X++)if(this.d[X].matches(ue))return X;return-1}}e.$zI=a;function t(O,W,x,ue=(X,J)=>X===J){const X=[];function J(Z,ye,de){if(ye===0&&de.length===0)return;const H=X[X.length-1];H&&H.start+H.deleteCount===Z?(H.deleteCount+=ye,H.toInsert.push(...de)):X.push({start:Z,deleteCount:ye,toInsert:de})}let Q=0,he=0;for(;;){if(Q===O.length){J(Q,0,W.slice(he));break}if(he===W.length){J(Q,O.length-Q,[]);break}const Z=O[Q],ye=W[he];if(ue(Z,ye)){Q+=1,he+=1;continue}x(ye)?(J(Q,1,[]),Q+=1):(J(Q,0,[ye]),he+=1)}return X}e.$AI=t,e.$BI=new y.$ej("notebookEditorCursorAtBoundary","none"),e.$CI=new y.$ej("notebookEditorCursorAtLineBoundary","none");var r;(function(O){O.default="default",O.option="option"})(r||(e.NotebookEditorPriority=r={}));function h(O){const W=O;return!!((typeof W.include=="string"||T.$Hj(W.include))&&(typeof W.exclude=="string"||T.$Hj(W.exclude)))}e.$DI=h;function u(O,W,x){if(Array.isArray(O.viewType)&&O.viewType.indexOf(W)>=0||O.viewType===W)return!0;if(O.filenamePattern){const ue=h(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,X=h(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(T.$Fj(ue,(0,w.$mc)(x.fsPath).toLowerCase()))return!(X&&T.$Fj(X,(0,w.$mc)(x.fsPath).toLowerCase()))}return!1}e.$EI=u,e.$FI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var c;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class l{static{this.d="notebook/"}static create(W){return`${l.d}${W}`}static parse(W){if(W.startsWith(l.d))return W.substring(l.d.length)}}e.$GI=l;function E(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$HI=E;const C=new TextDecoder;function f(O){const W=[];let x=!1;for(const Q of O)(W.length===0||x)&&(W.push(Q),x=!0);let ue=I(W);const X=D.$fe.concat(W.map(Q=>D.$fe.wrap(Q))),J=N(X);return ue=ue||J.byteLength!==X.byteLength,{data:J,didCompression:ue}}e.$II=f,e.$JI=`${String.fromCharCode(27)}[A`;const p=e.$JI.split("").map(O=>O.charCodeAt(0)),k=10;function I(O){let W=!1;return O.forEach((x,ue)=>{if(ue===0||x.length<e.$JI.length)return;const X=O[ue-1],J=x.subarray(0,e.$JI.length);if(J[0]===p[0]&&J[1]===p[1]&&J[2]===p[2]){const Q=X.lastIndexOf(k);if(Q===-1)return;W=!0,O[ue-1]=X.subarray(0,Q),O[ue]=x.subarray(e.$JI.length)}}),W}function j(O){let W=O;do O=W,W=O.replace(/[^\n]\x08/gm,"");while(W.length<O.length);return O}function z(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const W=O.match(/^(.*)\r+/m)[1];let x=O.match(/\r+(.*)$/m)[1];x=x+W.slice(x.length,W.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,x)}return O}const M="\b".charCodeAt(0),F="\r".charCodeAt(0);function N(O){return!O.buffer.includes(M)&&!O.buffer.includes(F)?O:D.$fe.fromString(z(j(C.decode(O.buffer))))}}),define(ke[7],Se([1,0,19,8,80,28,100,13,18,2,30,26,32,64,111]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S){"use strict";var g,d,o,i,n,s,a,t,r,h,u,c,l,E,C,f,p,k;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$tM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.TestRunProfileKind=e.TestResultState=e.$_L=e.$$L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$0L=e.NotebookVariablesRequestKind=e.$9L=e.$8L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$7L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.ColorThemeKind=e.$1L=e.$ZL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$YL=e.DebugConsoleMode=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$SL=e.$RL=e.FileChangeType=e.$QL=e.$PL=e.$OL=e.$NL=e.InlineCompletionTriggerKind=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.ConfigurationTarget=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$qL=e.ViewBadge=e.ProgressLocation=e.$pL=e.$oL=e.TaskScope=e.ShellQuoting=e.$nL=e.$mL=e.$lL=e.TaskPanelKind=e.TaskRevealKind=e.$kL=e.TerminalLocation=e.$jL=e.$iL=e.$hL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$gL=e.$fL=e.$eL=e.$dL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$cL=e.StatusBarAlignment=e.ViewColumn=e.$bL=e.$aL=e.$_K=e.$$K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$0K=e.$9K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.LanguageStatusSeverity=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.CodeActionTriggerKind=e.$WK=e.$VK=e.SymbolTag=e.SymbolKind=e.$UK=e.DocumentHighlightKind=e.$TK=e.$SK=e.$RK=e.$QK=e.DiagnosticSeverity=e.DiagnosticTag=e.$PK=e.$OK=e.FileEditType=e.$NK=e.$MK=e.$LK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function I(V){return Object.assign(V,{apply:function(...pe){if(pe.length===0)return Reflect.construct(V,[]);{const Le=pe.length===1?[]:pe[1];return Reflect.construct(V,Le,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(V,[]);{const[Le,...Ze]=pe;return Reflect.construct(V,Ze,Le.constructor)}}})}var j;(function(V){V[V.Top=0]="Top",V[V.Bottom=1]="Bottom"})(j||(e.TerminalOutputAnchor=j={}));var z;(function(V){V[V.TerminalCommand=0]="TerminalCommand",V[V.Opener=1]="Opener",V[V.Command=3]="Command"})(z||(e.TerminalQuickFixType=z={}));let M=g=class{static from(...q){let pe=q;return new g(function(){if(pe){for(const Le of pe)Le&&typeof Le.dispose=="function"&&Le.dispose();pe=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$EK=M,e.$EK=M=g=Ke([I],M);let F=d=class{static Min(...q){if(q.length===0)throw new TypeError;let pe=q[0];for(let Le=1;Le<q.length;Le++){const Ze=q[Le];Ze.isBefore(pe)&&(pe=Ze)}return pe}static Max(...q){if(q.length===0)throw new TypeError;let pe=q[0];for(let Le=1;Le<q.length;Le++){const Ze=q[Le];Ze.isAfter(pe)&&(pe=Ze)}return pe}static isPosition(q){if(!q)return!1;if(q instanceof d)return!0;const{line:pe,character:Le}=q;return typeof pe=="number"&&typeof Le=="number"}static of(q){if(q instanceof d)return q;if(this.isPosition(q))return new d(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,pe){if(q<0)throw(0,T.$6)("line must be non-negative");if(pe<0)throw(0,T.$6)("character must be non-negative");this.c=q,this.e=pe}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,pe=0){if(q===null||pe===null)throw(0,T.$6)();let Le;return typeof q>"u"?Le=0:typeof q=="number"?Le=q:(Le=typeof q.lineDelta=="number"?q.lineDelta:0,pe=typeof q.characterDelta=="number"?q.characterDelta:0),Le===0&&pe===0?this:new d(this.line+Le,this.character+pe)}with(q,pe=this.character){if(q===null||pe===null)throw(0,T.$6)();let Le;return typeof q>"u"?Le=this.line:typeof q=="number"?Le=q:(Le=typeof q.line=="number"?q.line:this.line,pe=typeof q.character=="number"?q.character:this.character),Le===this.line&&pe===this.character?this:new d(Le,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$FK=F,e.$FK=F=d=Ke([I],F);let N=o=class{static isRange(q){return q instanceof o?!0:q?F.isPosition(q.start)&&F.isPosition(q.end):!1}static of(q){if(q instanceof o)return q;if(this.isRange(q))return new o(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,pe,Le,Ze){let it,ct;if(typeof q=="number"&&typeof pe=="number"&&typeof Le=="number"&&typeof Ze=="number"?(it=new F(q,pe),ct=new F(Le,Ze)):F.isPosition(q)&&F.isPosition(pe)&&(it=F.of(q),ct=F.of(pe)),!it||!ct)throw new Error("Invalid arguments");it.isBefore(ct)?(this.c=it,this.e=ct):(this.c=ct,this.e=it)}contains(q){return o.isRange(q)?this.contains(q.start)&&this.contains(q.end):F.isPosition(q)?!(F.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const pe=F.Max(q.start,this.c),Le=F.Min(q.end,this.e);if(!pe.isAfter(Le))return new o(pe,Le)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const pe=F.Min(q.start,this.c),Le=F.Max(q.end,this.end);return new o(pe,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,pe=this.end){if(q===null||pe===null)throw(0,T.$6)();let Le;return q?F.isPosition(q)?Le=q:(Le=q.start||this.start,pe=q.end||this.end):Le=this.start,Le.isEqual(this.c)&&pe.isEqual(this.end)?this:new o(Le,pe)}toJSON(){return[this.start,this.end]}};e.$GK=N,e.$GK=N=o=Ke([I],N);let O=i=class extends N{static isSelection(q){return q instanceof i?!0:q?N.isRange(q)&&F.isPosition(q.anchor)&&F.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,pe,Le,Ze){let it,ct;if(typeof q=="number"&&typeof pe=="number"&&typeof Le=="number"&&typeof Ze=="number"?(it=new F(q,pe),ct=new F(Le,Ze)):F.isPosition(q)&&F.isPosition(pe)&&(it=F.of(q),ct=F.of(pe)),!it||!ct)throw new Error("Invalid arguments");super(it,ct),this.f=it,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$HK=O,e.$HK=O=i=Ke([I],O);const W=V=>{if(typeof V!="string"||V.length===0||!/^[0-9A-Za-z_\-]+$/.test(V))throw(0,T.$6)("connectionToken")};class x{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,pe,Le){if(typeof q!="string"||q.length===0)throw(0,T.$6)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,T.$6)("port");typeof Le<"u"&&W(Le),this.host=q,this.port=Math.round(pe),this.connectionToken=Le}}e.$IK=x;class ue{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,pe){this.makeConnection=q,this.connectionToken=pe,typeof pe<"u"&&W(pe)}}e.$JK=ue;class X extends Error{static NotAvailable(q,pe){return new X(q,v.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(q){return new X(q,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,pe=v.RemoteAuthorityResolverErrorCode.Unknown,Le){super(q),this._message=q,this._code=pe,this._detail=Le,Object.setPrototypeOf(this,X.prototype)}}e.$KK=X;var J;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(J||(e.EndOfLine=J={}));var Q;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let he=n=class{static isTextEdit(q){return q instanceof n?!0:q?N.isRange(q)&&typeof q.newText=="string":!1}static replace(q,pe){return new n(q,pe)}static insert(q,pe){return n.replace(new N(q,q),pe)}static delete(q){return n.replace(q,"")}static setEndOfLine(q){const pe=new n(new N(new F(0,0),new F(0,0)),"");return pe.newEol=q,pe}get range(){return this.c}set range(q){if(q&&!N.isRange(q))throw(0,T.$6)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,T.$6)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,T.$6)("newEol");this.f=q}constructor(q,pe){this.c=q,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$LK=he,e.$LK=he=n=Ke([I],he);let Z=s=class{static isNotebookCellEdit(q){return q instanceof s?!0:q?xt.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,pe){return new s(q,pe)}static insertCells(q,pe){return new s(new xt(q,q),pe)}static deleteCells(q){return new s(q,[])}static updateCellMetadata(q,pe){const Le=new s(new xt(q,q),[]);return Le.newCellMetadata=pe,Le}static updateNotebookMetadata(q){const pe=new s(new xt(0,0),[]);return pe.newNotebookMetadata=q,pe}constructor(q,pe){this.range=q,this.newCells=pe}};e.$MK=Z,e.$MK=Z=s=Ke([I],Z);class ye{static isSnippetTextEdit(q){return q instanceof ye?!0:q?N.isRange(q.range)&&U.isSnippetString(q.snippet):!1}static replace(q,pe){return new ye(q,pe)}static insert(q,pe){return ye.replace(new N(q,q),pe)}constructor(q,pe){this.range=q,this.snippet=pe}}e.$NK=ye;var de;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace",V[V.Snippet=6]="Snippet"})(de||(e.FileEditType=de={}));let H=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,pe,Le,Ze){this.c.push({_type:1,from:q,to:pe,options:Le,metadata:Ze})}createFile(q,pe,Le){this.c.push({_type:1,from:void 0,to:q,options:pe,metadata:Le})}deleteFile(q,pe,Le){this.c.push({_type:1,from:q,to:void 0,options:pe,metadata:Le})}e(q,pe,Le){this.c.push({_type:3,metadata:Le,uri:q,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(q,pe,Le,Ze){const it=pe.start,ct=pe.end;(it!==ct||Le.length>0)&&this.c.push({_type:5,uri:q,index:it,count:ct-it,cells:Le,metadata:Ze})}g(q,pe,Le,Ze){this.c.push({_type:3,metadata:Ze,uri:q,edit:{editType:3,index:pe,metadata:Le}})}replace(q,pe,Le,Ze){this.c.push({_type:2,uri:q,edit:new he(pe,Le),metadata:Ze})}insert(q,pe,Le,Ze){this.replace(q,new N(pe,pe),Le,Ze)}delete(q,pe,Le){this.replace(q,pe,"",Le)}has(q){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===q.toString())}set(q,pe){if(pe)for(const Le of pe){if(!Le)continue;let Ze,it;Array.isArray(Le)?(Ze=Le[0],it=Le[1]):Ze=Le,Z.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(q,Ze.range.start,Ze.newCellMetadata,it):Ze.newNotebookMetadata?this.e(q,Ze.newNotebookMetadata,it):this.f(q,Ze.range,Ze.newCells,it):ye.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:q,range:Ze.range,edit:Ze.snippet,metadata:it}):this.c.push({_type:2,uri:q,edit:Ze,metadata:it})}else{for(let Le=0;Le<this.c.length;Le++){const Ze=this.c[Le];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===q.toString()&&(this.c[Le]=void 0);break}}(0,D.$Hb)(this.c)}}get(q){const pe=[];for(const Le of this.c)Le._type===2&&Le.uri.toString()===q.toString()&&pe.push(Le.edit);return pe}entries(){const q=new A.$zc;for(const pe of this.c)if(pe._type===2){let Le=q.get(pe.uri);Le||(Le=[pe.uri,[]],q.set(pe.uri,Le)),Le[1].push(pe.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$OK=H,e.$OK=H=Ke([I],H);let U=a=class{static isSnippetString(q){return q instanceof a?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=a.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,pe=this.e++){if(typeof q=="function"){const Le=new a;Le.e=this.e,q(Le),this.e=Le.e,q=Le.value}else q=a.c(q);return this.value+="${",this.value+=pe,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,pe=this.e++){const Le=q.map(Ze=>Ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(q,pe){if(typeof pe=="function"){const Le=new a;Le.e=this.e,pe(Le),this.e=Le.e,pe=Le.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$PK=U,e.$PK=U=a=Ke([I],U);var ne;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var Ee;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(Ee||(e.DiagnosticSeverity=Ee={}));let fe=t=class{static isLocation(q){return q instanceof t?!0:q?N.isRange(q.range)&&y.URI.isUri(q.uri):!1}constructor(q,pe){if(this.uri=q,pe)if(N.isRange(pe))this.range=N.of(pe);else if(F.isPosition(pe))this.range=new N(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$QK=fe,e.$QK=fe=t=Ke([I],fe);let me=class{static is(q){return q?typeof q.message=="string"&&q.location&&N.isRange(q.location.range)&&y.URI.isUri(q.location.uri):!1}constructor(q,pe){this.location=q,this.message=pe}static isEqual(q,pe){return q===pe?!0:!q||!pe?!1:q.message===pe.message&&q.location.range.isEqual(pe.location.range)&&q.location.uri.toString()===pe.location.uri.toString()}};e.$RK=me,e.$RK=me=Ke([I],me);let ee=class{constructor(q,pe,Le=Ee.Error){if(!N.isRange(q))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=q,this.message=pe,this.severity=Le}toJSON(){return{severity:Ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,pe){return q===pe?!0:!q||!pe?!1:q.message===pe.message&&q.severity===pe.severity&&q.code===pe.code&&q.severity===pe.severity&&q.source===pe.source&&q.range.isEqual(pe.range)&&(0,D.$tb)(q.tags,pe.tags)&&(0,D.$tb)(q.relatedInformation,pe.relatedInformation,me.isEqual)}};e.$SK=ee,e.$SK=ee=Ke([I],ee);let te=class{constructor(q,pe){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=pe}};e.$TK=te,e.$TK=te=Ke([I],te);var K;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(K||(e.DocumentHighlightKind=K={}));let ie=class{constructor(q,pe=K.Text){this.range=q,this.kind=pe}toJSON(){return{range:this.range,kind:K[this.kind]}}};e.$UK=ie,e.$UK=ie=Ke([I],ie);var G;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(G||(e.SymbolKind=G={}));var ae;(function(V){V[V.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let $e=r=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,pe,Le,Ze,it){this.name=q,this.kind=pe,this.containerName=it,typeof Le=="string"&&(this.containerName=Le),Ze instanceof fe?this.location=Ze:Le instanceof N&&(this.location=new fe(Ze,Le)),r.validate(this)}toJSON(){return{name:this.name,kind:G[this.kind],location:this.location,containerName:this.containerName}}};e.$VK=$e,e.$VK=$e=r=Ke([I],$e);let Ce=h=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(h.validate)}constructor(q,pe,Le,Ze,it){this.name=q,this.detail=pe,this.kind=Le,this.range=Ze,this.selectionRange=it,this.children=[],h.validate(this)}};e.$WK=Ce,e.$WK=Ce=h=Ke([I],Ce);var B;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let Y=class{constructor(q,pe){this.title=q,this.kind=pe}};e.$XK=Y,e.$XK=Y=Ke([I],Y);let se=class{static{u=this}static{this.c="."}constructor(q){this.value=q}append(q){return new u(this.value?this.value+u.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+u.c)}};e.$YK=se,e.$YK=se=u=Ke([I],se),se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorMove=se.Refactor.append("move"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll"),se.Notebook=se.Empty.append("notebook");let oe=class{constructor(q,pe){if(this.range=q,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$ZK=oe,e.$ZK=oe=Ke([I],oe);class _{constructor(q,pe,Le,Ze,it,ct){this.kind=q,this.name=pe,this.detail=Le,this.uri=Ze,this.range=it,this.selectionRange=ct}}e.$1K=_;class ge{constructor(q,pe){this.fromRanges=pe,this.from=q}}e.$2K=ge;class ve{constructor(q,pe){this.fromRanges=pe,this.to=q}}e.$3K=ve;var ze;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(ze||(e.LanguageStatusSeverity=ze={}));let We=class{constructor(q,pe){this.range=q,this.command=pe}get isResolved(){return!!this.command}};e.$4K=We,e.$4K=We=Ke([I],We);let tt=c=class{#e;static isMarkdownString(q){return q instanceof c?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,pe=!1){this.#e=new m.$ak(q,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,pe){return this.#e.appendCodeblock(pe??"",q),this}};e.$5K=tt,e.$5K=tt=c=Ke([I],tt);let Ye=class{constructor(q,pe){this.label=q,this.documentation=pe}};e.$6K=Ye,e.$6K=Ye=Ke([I],Ye);let rt=class{constructor(q,pe){this.label=q,this.documentation=pe,this.parameters=[]}};e.$7K=rt,e.$7K=rt=Ke([I],rt);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$8K=nt,e.$8K=nt=Ke([I],nt);var Ae;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Oe;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(Oe||(e.InlayHintKind=Oe={}));let qe=class{constructor(q){this.value=q}};e.$9K=qe,e.$9K=qe=Ke([I],qe);let Me=class{constructor(q,pe,Le){this.position=q,this.label=pe,this.kind=Le}};e.$0K=Me,e.$0K=Me=Ke([I],Me);var Xe;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe||(e.CompletionTriggerKind=Xe={}));var le;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(le||(e.CompletionItemKind=le={}));var ce;(function(V){V[V.Deprecated=1]="Deprecated"})(ce||(e.CompletionItemTag=ce={}));let Pe=class{constructor(q,pe){this.label=q,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$$K=Pe,e.$$K=Pe=Ke([I],Pe);let He=class{constructor(q=[],pe=!1){this.items=q,this.isIncomplete=pe}};e.$_K=He,e.$_K=He=Ke([I],He);let Ge=class{constructor(q,pe,Le){this.insertText=q,this.range=pe,this.command=Le}};e.$aL=Ge,e.$aL=Ge=Ke([I],Ge);let xe=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$bL=xe,e.$bL=xe=Ke([I],xe);var ot;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(ot||(e.ViewColumn=ot={}));var lt;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(lt||(e.StatusBarAlignment=lt={}));function Ne(V,q){return`${P.$dm.toKey(V)}.${q}`}e.$cL=Ne;var St;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(St||(e.TextEditorLineNumbersStyle=St={}));var Ht;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Ht||(e.TextDocumentSaveReason=Ht={}));var Kt;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var vt;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var Ut;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Ot;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(V){function q(pe){switch(pe){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=q}(vt||(e.TextEditorSelectionChangeKind=vt={}));var Gt;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(V){function q(pe){switch(pe){case V.Other:return"other";case V.Comment:return"comment";case V.String:return"string";case V.RegEx:return"regex"}return"other"}V.toString=q}(Gt||(e.SyntaxTokenType=Gt={}));let Bt=class{constructor(q,pe){if(pe&&!y.URI.isUri(pe))throw(0,T.$6)("target");if(!N.isRange(q)||q.isEmpty)throw(0,T.$6)("range");this.range=q,this.target=pe}};e.$dL=Bt,e.$dL=Bt=Ke([I],Bt);let Dt=class{constructor(q,pe,Le,Ze){this.red=q,this.green=pe,this.blue=Le,this.alpha=Ze}};e.$eL=Dt,e.$eL=Dt=Ke([I],Dt);let Tt=class{constructor(q,pe){if(pe&&!(pe instanceof Dt))throw(0,T.$6)("color");if(!N.isRange(q)||q.isEmpty)throw(0,T.$6)("range");this.range=q,this.color=pe}};e.$fL=Tt,e.$fL=Tt=Ke([I],Tt);let et=class{constructor(q){if(!q||typeof q!="string")throw(0,T.$6)("label");this.label=q}};e.$gL=et,e.$gL=et=Ke([I],et);var Jt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Wt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var ut;(function(V){V[V.Unknown=0]="Unknown",V[V.Shutdown=1]="Shutdown",V[V.Process=2]="Process",V[V.User=3]="User",V[V.Extension=4]="Extension"})(ut||(e.TerminalExitReason=ut={}));class gt{constructor(q,pe,Le){if(this.startIndex=q,this.length=pe,this.tooltip=Le,typeof q!="number"||q<0)throw(0,T.$6)("startIndex");if(typeof pe!="number"||pe<1)throw(0,T.$6)("length");if(Le!==void 0&&typeof Le!="string")throw(0,T.$6)("tooltip")}}e.$hL=gt;class qt{constructor(q){this.uri=q}}e.$iL=qt;class Rt{constructor(q){this.terminalCommand=q}}e.$jL=Rt;var kt;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class mt{constructor(q){if(this.options=q,typeof q!="object")throw(0,T.$6)("options")}}e.$kL=mt;var Lt;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(Lt||(e.TaskRevealKind=Lt={}));var At;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(At||(e.TaskPanelKind=At={}));let Ct=class{static{l=this}static{this.Clean=new l("clean","Clean")}static{this.Build=new l("build","Build")}static{this.Rebuild=new l("rebuild","Rebuild")}static{this.Test=new l("test","Test")}static from(q){switch(q){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}constructor(q,pe){if(this.label=pe,typeof q!="string"||typeof pe!="string")throw(0,T.$6)("name");this.c=q}get id(){return this.c}};e.$lL=Ct,e.$lL=Ct=l=Ke([I],Ct);function Je(V){let q="";for(let pe=0;pe<V.length;pe++)q+=V[pe].replace(/,/g,",,")+",";return q}let Nt=class{constructor(q,pe,Le){if(typeof q!="string")throw(0,T.$6)("process");this.e=[],this.c=q,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Le):this.f=pe)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,T.$6)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)q.push(pe);return Je(q)}};e.$mL=Nt,e.$mL=Nt=Ke([I],Nt);let jt=class{constructor(q,pe,Le){if(this.f=[],Array.isArray(pe)){if(!q)throw(0,T.$6)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,T.$6)("command");this.e=q,this.f=pe,this.g=Le}else{if(typeof q!="string")throw(0,T.$6)("commandLine");this.c=q,this.g=pe}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,T.$6)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,T.$6)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)q.push(typeof pe=="string"?pe:pe.value);return Je(q)}};e.$nL=jt,e.$nL=jt=Ke([I],jt);var Qt;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var Re;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(Re||(e.TaskScope=Re={}));class Fe{constructor(q){this.c=q}computeId(){return"customExecution"+(0,L.$kg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$oL=Fe;let Ie=class{static{E=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,pe,Le,Ze,it,ct){this.j=!1,this.k=this.definition=q;let ft;typeof pe=="string"?(this.m=this.name=pe,this.t=this.source=Le,this.execution=Ze,ft=it,this.j=!0):pe===Re.Global||pe===Re.Workspace?(this.target=pe,this.m=this.name=Le,this.t=this.source=Ze,this.execution=it,ft=ct):(this.target=pe,this.m=this.name=Le,this.t=this.source=Ze,this.execution=it,ft=ct),typeof ft=="string"?(this.o=[ft],this.q=!0):Array.isArray(ft)?(this.o=ft,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(q){this.h=q}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Nt?this.k={type:E.e,id:this.n.computeId()}:this.n instanceof jt?this.k={type:E.f,id:this.n.computeId()}:this.n instanceof Fe?this.k={type:E.c,id:this.n.computeId()}:this.k={type:E.g,id:(0,L.$kg)()}}get definition(){return this.k}set definition(q){if(q==null)throw(0,T.$6)("Kind can't be undefined or null");this.z(),this.k=q}get scope(){return this.l}set target(q){this.z(),this.l=q}get name(){return this.m}set name(q){if(typeof q!="string")throw(0,T.$6)("name");this.z(),this.m=q}get execution(){return this.n}set execution(q){q===null&&(q=void 0),this.z(),this.n=q;const pe=this.k.type;(E.g===pe||E.e===pe||E.f===pe||E.c===pe)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(q){if(Array.isArray(q))this.z(),this.o=q,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.z(),this.r=q}get source(){return this.t}set source(q){if(typeof q!="string"||q.length===0)throw(0,T.$6)("source must be a string of length > 0");this.z(),this.t=q}get group(){return this.u}set group(q){q===null&&(q=void 0),this.z(),this.u=q}get detail(){return this.y}set detail(q){q===null&&(q=void 0),this.y=q}get presentationOptions(){return this.w}set presentationOptions(q){q==null&&(q=Object.create(null)),this.z(),this.w=q}get runOptions(){return this.x}set runOptions(q){q==null&&(q=Object.create(null)),this.z(),this.x=q}};e.$pL=Ie,e.$pL=Ie=E=Ke([I],Ie);var re;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(re||(e.ProgressLocation=re={}));var Te;(function(V){function q(pe){const Le=pe;return(0,b.$Gf)(Le.value)?Le.tooltip&&!(0,b.$Cf)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}V.isViewBadge=q})(Te||(e.ViewBadge=Te={}));let Ve=C=class{static isTreeItem(q,pe){const Le=q;if(Le.checkboxState!==void 0){const Ze=(0,b.$Gf)(Le.checkboxState)?Le.checkboxState:(0,b.$Ef)(Le.checkboxState)&&(0,b.$Gf)(Le.checkboxState.state)?Le.checkboxState.state:void 0,it=!(0,b.$Gf)(Le.checkboxState)&&(0,b.$Ef)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==Qe.Checked&&Ze!==Qe.Unchecked||it!==void 0&&!(0,b.$Cf)(it))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(q instanceof C)return!0;if(Le.label!==void 0&&!(0,b.$Cf)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,b.$Cf)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,b.$Cf)(Le.iconPath)&&!y.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,b.$Cf)(Le.iconPath.id))){const Ze=Le.iconPath;if(!Ze||!(0,b.$Cf)(Ze.light)&&!y.URI.isUri(Ze.light)&&!(0,b.$Cf)(Ze.dark)&&!y.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,b.$Cf)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!y.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,b.$Cf)(Le.tooltip)&&!(Le.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<_e.None&&Le.collapsibleState>_e.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,b.$Cf)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(q,pe=_e.None){this.collapsibleState=pe,y.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$qL=Ve,e.$qL=Ve=C=Ke([I],Ve);var _e;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(_e||(e.TreeItemCollapsibleState=_e={}));var Qe;(function(V){V[V.Unchecked=0]="Unchecked",V[V.Checked=1]="Checked"})(Qe||(e.TreeItemCheckboxState=Qe={}));let st=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$rL=st,e.$rL=st=Ke([I],st);class ht extends st{}e.$sL=ht;class wt extends ht{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$tL=wt;class bt{constructor(q,pe,Le,Ze){this.name=q,this.uri=pe,this._itemId=Le,this.c=Ze}data(){return this.c()}}e.$uL=bt;let Et=class{#e=new Map;constructor(q){for(const[pe,Le]of q??[]){const Ze=this.#e.get(this.#t(pe));Ze?Ze.push(Le):this.#e.set(this.#t(pe),[Le])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,pe){this.#e.set(this.#t(q),[pe])}forEach(q,pe){for(const[Le,Ze]of this.#e)for(const it of Ze)q.call(pe,it,Le,this)}*[Symbol.iterator](){for(const[q,pe]of this.#e)for(const Le of pe)yield[q,Le]}#t(q){return q.toLowerCase()}};e.$vL=Et,e.$vL=Et=Ke([I],Et);let yt=class{constructor(q){this.insertText=q}};e.$wL=yt,e.$wL=yt=Ke([I],yt);let ki=class{constructor(q,pe){this.label=pe,this.insertText=q}};e.$xL=ki,e.$xL=ki=Ke([I],ki);let Vt=class{constructor(q,pe){this.id=q,this.color=pe}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$yL=Vt,e.$yL=Vt=Ke([I],Vt),Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let mi=class{constructor(q){this.id=q}};e.$zL=mi,e.$zL=mi=Ke([I],mi);var Pt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(Pt||(e.ConfigurationTarget=Pt={}));let Si=class{get base(){return this.c}set base(q){this.c=q,this.e=y.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,pe){if(typeof q!="string"&&(!q||!y.URI.isUri(q)&&!y.URI.isUri(q.uri)))throw(0,T.$6)("base");if(typeof pe!="string")throw(0,T.$6)("pattern");typeof q=="string"?this.baseUri=y.URI.file(q):y.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$AL=Si,e.$AL=Si=Ke([I],Si);const Hi=new WeakMap;function It(V,q){Hi.set(V,q)}e.$BL=It;let ii=class{constructor(q,pe,Le,Ze){this.enabled=typeof q=="boolean"?q:!0,typeof pe=="string"&&(this.condition=pe),typeof Le=="string"&&(this.hitCondition=Le),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this.c||(this.c=Hi.get(this)??(0,L.$kg)()),this.c}};e.$CL=ii,e.$CL=ii=Ke([I],ii);let $i=class extends ii{constructor(q,pe,Le,Ze,it){if(super(pe,Le,Ze,it),q===null)throw(0,T.$6)("location");this.location=q}};e.$DL=$i,e.$DL=$i=Ke([I],$i);let oi=class extends ii{constructor(q,pe,Le,Ze,it){super(pe,Le,Ze,it),this.functionName=q}};e.$EL=oi,e.$EL=oi=Ke([I],oi);let Di=class extends ii{constructor(q,pe,Le,Ze,it,ct,ft){if(super(Ze,it,ct,ft),!pe)throw(0,T.$6)("dataId");this.label=q,this.dataId=pe,this.canPersist=Le}};e.$FL=Di,e.$FL=Di=Ke([I],Di);let Ci=class{constructor(q,pe,Le){this.command=q,this.args=pe||[],this.options=Le}};e.$GL=Ci,e.$GL=Ci=Ke([I],Ci);let Mt=class{constructor(q,pe){this.port=q,this.host=pe}};e.$HL=Mt,e.$HL=Mt=Ke([I],Mt);let bi=class{constructor(q){this.path=q}};e.$IL=bi,e.$IL=bi=Ke([I],bi);let Ii=class{constructor(q){this.implementation=q}};e.$JL=Ii,e.$JL=Ii=Ke([I],Ii);let ai=class{constructor(q,pe,Le){this.session=q,this.threadId=pe,this.frameId=Le}};e.$KL=ai,e.$KL=ai=Ke([I],ai);let ci=class{constructor(q,pe){this.session=q,this.threadId=pe}};e.$LL=ci,e.$LL=ci=Ke([I],ci);let dt=class{constructor(q,pe){this.range=q,this.expression=pe}};e.$ML=dt,e.$ML=dt=Ke([I],dt);var Ki;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(Ki||(e.InlineCompletionTriggerKind=Ki={}));let Xt=class{constructor(q,pe){this.range=q,this.text=pe}};e.$NL=Xt,e.$NL=Xt=Ke([I],Xt);let ni=class{constructor(q,pe,Le=!0){this.range=q,this.variableName=pe,this.caseSensitiveLookup=Le}};e.$OL=ni,e.$OL=ni=Ke([I],ni);let di=class{constructor(q,pe){this.range=q,this.expression=pe}};e.$PL=di,e.$PL=di=Ke([I],di);let Pi=class{constructor(q,pe){this.frameId=q,this.stoppedLocation=pe}};e.$QL=Pi,e.$QL=Pi=Ke([I],Pi);var Gi;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Gi||(e.FileChangeType=Gi={}));let Ai=f=class extends Error{static FileExists(q){return new f(q,$.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(q){return new f(q,$.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(q){return new f(q,$.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(q){return new f(q,$.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(q){return new f(q,$.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(q){return new f(q,$.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}constructor(q,pe=$.FileSystemProviderErrorCode.Unknown,Le){super(y.URI.isUri(q)?q.toString(!0):q),this.code=Le?.name??"Unknown",(0,$.$xk)(this,pe),Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$RL=Ai,e.$RL=Ai=f=Ke([I],Ai);let wi=class{constructor(q,pe,Le){this.start=q,this.end=pe,this.kind=Le}};e.$SL=wi,e.$SL=wi=Ke([I],wi);var Ji;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Ji||(e.FoldingRangeKind=Ji={}));var Ri;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(Ri||(e.CommentThreadCollapsibleState=Ri={}));var ui;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(ui||(e.CommentMode=ui={}));var Qi;(function(V){V[V.Published=0]="Published",V[V.Draft=1]="Draft"})(Qi||(e.CommentState=Qi={}));var pi;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(pi||(e.CommentThreadState=pi={}));class Li{constructor(q,pe=[]){this.tokenTypes=q,this.tokenModifiers=pe}}e.$TL=Li;function ln(V){return typeof V>"u"||(0,b.$Df)(V)}class Mi{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,q){this.l=!0;for(let pe=0,Le=q.tokenTypes.length;pe<Le;pe++)this.j.set(q.tokenTypes[pe],pe);for(let pe=0,Le=q.tokenModifiers.length;pe<Le;pe++)this.k.set(q.tokenModifiers[pe],pe)}}push(q,pe,Le,Ze,it){if(typeof q=="number"&&typeof pe=="number"&&typeof Le=="number"&&typeof Ze=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.n(q,pe,Le,Ze,it);if(N.isRange(q)&&typeof pe=="string"&&ln(Le))return this.m(q,pe,Le);throw(0,T.$6)()}m(q,pe,Le){if(!this.l)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(pe))throw new Error("`tokenType` is not in the provided legend");const Ze=q.start.line,it=q.start.character,ct=q.end.character-q.start.character,ft=this.j.get(pe);let zt=0;if(Le)for(const Yt of Le){if(!this.k.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Yt);zt|=1<<ei>>>0}this.n(Ze,it,ct,ft,zt)}n(q,pe,Le,Ze,it){if(this.f&&(q<this.c||q===this.c&&pe<this.e)){this.f=!1;const zt=this.g.length/5|0;let Yt=0,ei=0;for(let ti=0;ti<zt;ti++){let si=this.g[5*ti],qi=this.g[5*ti+1];si===0?(si=Yt,qi+=ei):si+=Yt,this.g[5*ti]=si,this.g[5*ti+1]=qi,Yt=si,ei=qi}}let ct=q,ft=pe;this.f&&this.h>0&&(ct-=this.c,ct===0&&(ft-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=ft,this.g[this.h++]=Le,this.g[this.h++]=Ze,this.g[this.h++]=it,this.c=q,this.e=pe}static o(q){const pe=[],Le=q.length/5|0;for(let ft=0;ft<Le;ft++)pe[ft]=ft;pe.sort((ft,zt)=>{const Yt=q[5*ft],ei=q[5*zt];if(Yt===ei){const ti=q[5*ft+1],si=q[5*zt+1];return ti-si}return Yt-ei});const Ze=new Uint32Array(q.length);let it=0,ct=0;for(let ft=0;ft<Le;ft++){const zt=5*pe[ft],Yt=q[zt+0],ei=q[zt+1],ti=q[zt+2],si=q[zt+3],qi=q[zt+4],Sn=Yt-it,On=Sn===0?ei-ct:ei,Vi=5*ft;Ze[Vi+0]=Sn,Ze[Vi+1]=On,Ze[Vi+2]=ti,Ze[Vi+3]=si,Ze[Vi+4]=qi,it=Yt,ct=ei}return Ze}build(q){return this.f?new ri(new Uint32Array(this.g),q):new ri(Mi.o(this.g),q)}}e.$UL=Mi;class ri{constructor(q,pe){this.resultId=pe,this.data=q}}e.$VL=ri;class hn{constructor(q,pe,Le){this.start=q,this.deleteCount=pe,this.data=Le}}e.$WL=hn;class dn{constructor(q,pe){this.resultId=pe,this.edits=q}}e.$XL=dn;var Zi;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let fi=class{static{this.Back={iconPath:new Vt("arrow-left")}}constructor(){}};e.$YL=fi,e.$YL=fi=Ke([I],fi);var Yi;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var Xi;(function(V){V[V.Info=1]="Info",V[V.Warning=2]="Warning",V[V.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var gi;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class xi{static validate(q){if(typeof q.badge=="string"){let pe=(0,w.$df)(q.badge,0);if(pe<q.badge.length&&(pe+=(0,w.$df)(q.badge,pe)),q.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!Vt.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,pe,Le){this.badge=q,this.tooltip=pe,this.color=Le}}e.$ZL=xi;let Fi=class{constructor(q){this.kind=q}};e.$1L=Fi,e.$1L=Fi=Ke([I],Fi);var Ti;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast",V[V.HighContrastLight=4]="HighContrastLight"})(Ti||(e.ColorThemeKind=Ti={}));class xt{static isNotebookRange(q){return q instanceof xt?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,pe){if(q<0)throw(0,T.$6)("start must be positive");if(pe<0)throw(0,T.$6)("end must be positive");q<=pe?(this.c=q,this.e=pe):(this.c=pe,this.e=q)}with(q){let pe=this.c,Le=this.e;return q.start!==void 0&&(pe=q.start),q.end!==void 0&&(Le=q.end),pe===this.c&&Le===this.e?this:new xt(pe,Le)}}e.$2L=xt;class vi{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(pe=>vi.isNotebookCellData(pe))}static isNotebookCellData(q){return!0}constructor(q,pe,Le,Ze,it,ct,ft){this.kind=q,this.value=pe,this.languageId=Le,this.mime=Ze,this.outputs=it??[],this.metadata=ct,this.executionSummary=ft,vi.validate(this)}}e.$3L=vi;class fn{constructor(q){this.cells=q}}e.$4L=fn;class Zt{static isNotebookCellOutputItem(q){return q instanceof Zt?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const pe={name:q.name,message:q.message,stack:q.stack};return Zt.json(pe,"application/vnd.code.notebook.error")}static stdout(q){return Zt.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return Zt.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,pe="application/octet-stream"){return new Zt(q,pe)}static#e=new TextEncoder;static text(q,pe=R.$Zr.text){const Le=Zt.#e.encode(String(q));return new Zt(Le,pe)}static json(q,pe="text/x-json"){const Le=JSON.stringify(q,void 0,"	");return Zt.text(Le,pe)}constructor(q,pe){this.data=q,this.mime=pe;const Le=(0,R.$4r)(pe,!0);if(!Le)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$5L=Zt;class yi{static isNotebookCellOutput(q){return q instanceof yi?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,pe=!1){const Le=new Set,Ze=new Set;for(let it=0;it<q.length;it++){const ct=q[it],ft=(0,R.$4r)(ct.mime);if(!Le.has(ft)||(0,S.$HI)(ft)){Le.add(ft);continue}Ze.add(it),pe&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ze.size===0?q:q.filter((it,ct)=>!Ze.has(ct))}constructor(q,pe,Le){this.items=yi.ensureUniqueMimeTypes(q,!0),typeof pe=="string"?(this.id=pe,this.metadata=Le):(this.id=(0,L.$kg)(),this.metadata=pe??Le)}}e.$6L=yi;var Ei;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(Ei||(e.NotebookCellKind=Ei={}));var Oi;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Ue;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(Ue||(e.NotebookCellStatusBarAlignment=Ue={}));var _t;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(_t||(e.NotebookEditorRevealType=_t={}));class _i{constructor(q,pe){this.text=q,this.alignment=pe}}e.$7L=_i;var $t;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})($t||(e.NotebookControllerAffinity=$t={}));var en;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred",V[V.Hidden=-1]="Hidden"})(en||(e.NotebookControllerAffinity2=en={}));class gn{constructor(q,pe=[]){this.uri=q,this.provides=(0,D.$2b)(pe)}}e.$8L=gn;class tn{constructor(q){this.label=q}}e.$9L=tn;var nn;(function(V){V[V.Named=1]="Named",V[V.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let li=class{constructor(q,pe){this.label=q,this.timestamp=pe}};e.$0L=li,e.$0L=li=Ke([I],li);var rn;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class an{constructor(q,pe){this.ranges=q,this.wordPattern=pe}}e.$$L=an;class mn{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$_L=mn;var cn;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Ni=class{constructor(q=void 0,pe=void 0,Le=void 0,Ze=!1){this.include=q,this.exclude=pe,this.profile=Le,this.continuous=Ze}};e.$aM=Ni,e.$aM=Ni=Ke([I],Ni);let ji=p=class{static diff(q,pe,Le){const Ze=new p(q);return Ze.expectedOutput=pe,Ze.actualOutput=Le,Ze}constructor(q){this.message=q}};e.$bM=ji,e.$bM=ji=p=Ke([I],ji);let zi=class{constructor(q){this.id=q}};e.$cM=zi,e.$cM=zi=Ke([I],zi);let hi=class{constructor(q,pe){this.covered=q,this.total=pe}};e.$dM=hi,e.$dM=hi=Ke([I],hi);let Ui=k=class{static fromDetails(q,pe){const Le=new hi(0,0),Ze=new hi(0,0),it=new hi(0,0);for(const ft of pe)if("branches"in ft){Le.total+=1,Le.covered+=ft.executionCount>0?1:0;for(const zt of ft.branches)Ze.total+=1,Ze.covered+=zt.executionCount>0?1:0}else it.total+=1,it.covered+=ft.executionCount>0?1:0;const ct=new k(q,Le,Ze.total>0?Ze:void 0,it.total>0?it:void 0);return ct.detailedCoverage=pe,ct}constructor(q,pe,Le,Ze){this.uri=q,this.statementCoverage=pe,this.branchCoverage=Le,this.functionCoverage=Ze}};e.$eM=Ui,e.$eM=Ui=k=Ke([I],Ui);let Bi=class{constructor(q,pe,Le=[]){this.executionCount=q,this.location=pe,this.branches=Le}};e.$fM=Bi,e.$fM=Bi=Ke([I],Bi);let Wi=class{constructor(q,pe){this.executionCount=q,this.location=pe}};e.$gM=Wi,e.$gM=Wi=Ke([I],Wi);let we=class{constructor(q,pe){this.executionCount=q,this.location=pe}};e.$hM=we,e.$hM=we=Ke([I],we);var De;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(De||(e.ExternalUriOpenerPriority=De={}));var je;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(je||(e.WorkspaceTrustState=je={}));var at;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(at||(e.PortAutoForwardAction=at={}));class pt{constructor(q,pe,Le,Ze,it,ct){this.kind=q,this.name=pe,this.detail=Le,this.uri=Ze,this.range=it,this.selectionRange=ct}}e.$iM=pt;class Ft{constructor(q){this.uri=q}}e.$jM=Ft;class Dn{constructor(q,pe){this.original=q,this.modified=pe}}e.$kM=Dn;class Cn{constructor(q,pe,Le,Ze){this.base=q,this.input1=pe,this.input2=Le,this.result=Ze}}e.$lM=Cn;class In{constructor(q,pe){this.uri=q,this.viewType=pe}}e.$mM=In;class Pn{constructor(q){this.viewType=q}}e.$nM=Pn;class An{constructor(q,pe){this.uri=q,this.notebookType=pe}}e.$oM=An;class Rn{constructor(q,pe,Le){this.original=q,this.modified=pe,this.notebookType=Le}}e.$pM=Rn;class Ln{constructor(){}}e.$qM=Ln;class Mn{constructor(q,pe){this.uri=q,this.inputBoxUri=pe}}e.$rM=Mn;class Fn{constructor(q){this.providerId=q}}e.$sM=Fn;var $n;(function(V){V[V.Down=0]="Down",V[V.Up=1]="Up"})($n||(e.InteractiveSessionVoteDirection=$n={}));var bn;(function(V){V[V.Action=1]="Action",V[V.Toolbar=2]="Toolbar"})(bn||(e.InteractiveSessionCopyKind=bn={}));var wn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful",V[V.Undone=2]="Undone",V[V.Accepted=3]="Accepted",V[V.Bug=4]="Bug"})(wn||(e.InteractiveEditorResponseFeedbackKind=wn={}));var pn;(function(V){V[V.System=0]="System",V[V.User=1]="User",V[V.Assistant=2]="Assistant",V[V.Function=3]="Function"})(pn||(e.ChatMessageRole=pn={}));var vn;(function(V){V[V.Short=1]="Short",V[V.Medium=2]="Medium",V[V.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Tn{constructor(q,pe){this.role=q,this.content=pe}}e.$tM=Tn;var yn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful"})(yn||(e.ChatAgentResultFeedbackKind=yn={}));var En;(function(V){V[V.SymbolInformation=1]="SymbolInformation",V[V.CommandInformation=2]="CommandInformation",V[V.SearchInformation=3]="SearchInformation",V[V.SettingInformation=4]="SettingInformation"})(En||(e.RelatedInformationType=En={}));var kn;(function(V){V[V.Started=1]="Started",V[V.Recognizing=2]="Recognizing",V[V.Recognized=3]="Recognized",V[V.Stopped=4]="Stopped"})(kn||(e.SpeechToTextStatus=kn={}))}),define(ke[142],Se([1,0,60,17,13,175,127,7,19]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.$HM=e.$GM=void 0;const y=new Map;function L(S,g){g?y.set(S,g):y.delete(S)}e.$GM=L;function P(S){return y.get(S)}class $ extends A.$6u{constructor(g,d,o,i,n,s,a,t){super(d,o,i,n),this.c=g,this.m=s,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(g){return(0,b.$tb)(this.f,g)}get document(){if(!this.a){const g=this;this.a={get uri(){return g.d},get fileName(){return g.d.fsPath},get isUntitled(){return g.d.scheme===T.Schemas.untitled},get languageId(){return g.m},get version(){return g.h},get isClosed(){return g.b},get isDirty(){return g.q},save(){return g.r()},getText(d){return d?g.s(d):g.getText()},get eol(){return g.g===`
`?w.EndOfLine.LF:w.EndOfLine.CRLF},get lineCount(){return g.f.length},lineAt(d){return g.t(d)},offsetAt(d){return g.u(d)},positionAt(d){return g.v(d)},validateRange(d){return g.w(d)},validatePosition(d){return g.x(d)},getWordRangeAtPosition(d,o){return g.y(d,o)}}}return Object.freeze(this.a)}_acceptLanguageId(g){(0,D.ok)(!this.b),this.m=g}_acceptIsDirty(g){(0,D.ok)(!this.b),this.q=g}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(g){const d=this.w(g);if(d.isEmpty)return"";if(d.isSingleLine)return this.f[d.start.line].substring(d.start.character,d.end.character);const o=this.g,i=d.start.line,n=d.end.line,s=[];s.push(this.f[i].substring(d.start.character));for(let a=i+1;a<n;a++)s.push(this.f[a]);return s.push(this.f[n].substring(0,d.end.character)),s.join(o)}t(g){let d;if(g instanceof w.$FK?d=g.line:typeof g=="number"&&(d=g),typeof d!="number"||d<0||d>=this.f.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new v(d,this.f[d],d===this.f.length-1)}u(g){return g=this.x(g),this.l(),this.j.getPrefixSum(g.line-1)+g.character}v(g){g=Math.floor(g),g=Math.max(0,g),this.l();const d=this.j.getIndexOf(g),o=this.f[d.index].length;return new w.$FK(d.index,Math.min(d.remainder,o))}w(g){if(!(g instanceof w.$GK))throw new Error("Invalid argument");const d=this.x(g.start),o=this.x(g.end);return d===g.start&&o===g.end?g:new w.$GK(d.line,d.character,o.line,o.character)}x(g){if(!(g instanceof w.$FK))throw new Error("Invalid argument");if(this.f.length===0)return g.with(0,0);let{line:d,character:o}=g,i=!1;if(d<0)d=0,o=0,i=!0;else if(d>=this.f.length)d=this.f.length-1,o=this.f[d].length,i=!0;else{const n=this.f[d].length;o<0?(o=0,i=!0):o>n&&(o=n,i=!0)}return i?new w.$FK(d,o):g}y(g,d){const o=this.x(g);if(!d)d=P(this.m);else if((0,m.$Se)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const i=(0,R.$fs)(o.character+1,(0,R.$ds)(d),this.f[o.line],0);if(i)return new w.$GK(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$HM=$;class v{constructor(g,d,o){this.a=g,this.b=d,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new w.$GK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new w.$GK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$IM=v}),define(ke[284],Se([1,0,7,20,4]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;let A=class{constructor(w){this.a=new D.$1L(D.ColorThemeKind.Dark),this.b=new m.$Rd}get activeColorTheme(){return this.a}$onColorThemeChange(w){let b;switch(w){case"light":b=D.ColorThemeKind.Light;break;case"hcDark":b=D.ColorThemeKind.HighContrast;break;case"hcLight":b=D.ColorThemeKind.HighContrastLight;break;default:b=D.ColorThemeKind.Dark}this.a=new D.$1L(b),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$hgc=A,e.$hgc=A=Ke([Be(0,T.$EM)],A)}),define(ke[285],Se([1,0,5]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LI=e.CellExecutionUpdateType=void 0;var T;(function(m){m[m.Output=1]="Output",m[m.OutputItems=2]="OutputItems",m[m.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$LI=(0,D.$Zh)("INotebookExecutionService")}),define(ke[286],Se([1,0,3,29,192,99]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oPb=void 0;class R extends D.$Rc{constructor(b,y,L){super(),this._source=b,this.b=y,this.c=L,this.a=void 0}f(b){const y=b.getLineCount();return new T.$Ds(1,1,y,this.g(b,y))}g(b,y){if(y<1||y>b.getLineCount())throw new Error("Illegal value for lineNumber");return b.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const b=new m.$RB;b.acceptChunk(this._source);const y=b.finish(!0),{textBuffer:L,disposable:P}=y.create(1);this.b=L,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(b=>{const y=new m.$RB;y.acceptChunk(b);const L=y.finish(!0),{textBuffer:P,disposable:$}=L.create(1);return this.B($),P})),this.a}findInInputs(b){const L=new A.$FB(b,!1,!1,null).parseSearchRequest();if(!L)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,L,!0,5e3)}findInOutputs(b){const L=new A.$FB(b,!1,!1,null).parseSearchRequest();return L?this.outputTextBuffers.map(P=>{const $=P.findMatchesLineByLine(this.f(P),L,!0,5e3);if($.length!==0)return{textBuffer:P,matches:$}}).filter(P=>!!P):[]}}e.$oPb=R}),define(ke[67],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vJ=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(A){A.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var T;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class m{static fromExtHostTestItem(R,w,b=R.parent){if(R._isRoot)return new m([w]);const y=[R.id];for(let L=b;L&&L.id!==w;L=L.parent)y.push(L.id);return y.push(w),new m(y.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const w=R.indexOf("\0");return w===-1?R:R.slice(0,w)}static fromString(R){return new m(R.split("\0"))}static join(R,w){return new m([...R.path,w])}static joinToString(R,w){return R.toString()+"\0"+w}static parentId(R){const w=R.lastIndexOf("\0");return w===-1?void 0:R.slice(0,w)}static localId(R){const w=R.lastIndexOf("\0");return w===-1?R:R.slice(w+1)}static isChild(R,w){return w.startsWith(R)&&w[R.length]==="\0"}static compare(R,w){return R===w?0:m.isChild(R,w)?2:m.isChild(w,R)?3:1}constructor(R,w=R.length){if(this.path=R,this.d=w,R.length===0||w<1)throw new Error("cannot create test with empty path")}get rootId(){return new m(this.path,1)}get parentId(){return this.d>1?new m(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new m(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new m(this.path,R)}compare(R){if(typeof R=="string")return m.compare(this.toString(),R);for(let w=0;w<R.d&&w<this.d;w++)if(R.path[w]!==this.path[w])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$vJ=m}),define(ke[89],Se([1,0,2,29,67]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$BJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$AJ=e.$zJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$yJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$xJ=e.$wJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var R;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var w;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(w||(e.TestRunProfileBitset=w={})),e.$wJ=[2,4,8,16,32,64];const b=C=>"runId"in C;e.$xJ=b;var y;(function(C){C.serialize=f=>({range:f.range.toJSON(),uri:f.uri.toJSON()}),C.deserialize=f=>({range:T.$Ds.lift(f.range),uri:D.URI.revive(f.uri)})})(y||(e.IRichLocation=y={}));var L;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(L||(e.TestMessageType=L={}));var P;(function(C){C.serialize=f=>({message:f.message,type:0,expected:f.expected,actual:f.actual,contextValue:f.contextValue,location:f.location&&y.serialize(f.location)}),C.deserialize=f=>({message:f.message,type:0,expected:f.expected,actual:f.actual,contextValue:f.contextValue,location:f.location&&y.deserialize(f.location)})})(P||(e.ITestErrorMessage=P={}));const $=(C,f)=>`${f?"s":"e"}${C}`;e.$yJ=$;var v;(function(C){C.serialize=f=>({message:f.message,type:1,offset:f.offset,length:f.length,location:f.location&&y.serialize(f.location)}),C.deserialize=f=>({message:f.message,type:1,offset:f.offset,length:f.length,location:f.location&&y.deserialize(f.location)})})(v||(e.ITestOutputMessage=v={}));var S;(function(C){C.serialize=f=>f.type===0?P.serialize(f):v.serialize(f),C.deserialize=f=>f.type===0?P.deserialize(f):v.deserialize(f)})(S||(e.ITestMessage=S={}));var g;(function(C){C.serializeWithoutMessages=f=>({state:f.state,duration:f.duration,messages:[]}),C.serialize=f=>({state:f.state,duration:f.duration,messages:f.messages.map(S.serialize)}),C.deserialize=f=>({state:f.state,duration:f.duration,messages:f.messages.map(S.deserialize)})})(g||(e.ITestTaskState=g={}));const d="\0",o=(C,f)=>C+d+f;e.$zJ=o;const i=C=>{const f=C.indexOf(d);return{ctrlId:C.slice(0,f),tagId:C.slice(f+1)}};e.$AJ=i;var n;(function(C){C.serialize=f=>({extId:f.extId,label:f.label,tags:f.tags,busy:f.busy,children:void 0,uri:f.uri?.toJSON(),range:f.range?.toJSON()||null,description:f.description,error:f.error,sortText:f.sortText}),C.deserialize=f=>({extId:f.extId,label:f.label,tags:f.tags,busy:f.busy,children:void 0,uri:f.uri?D.URI.revive(f.uri):void 0,range:f.range?T.$Ds.lift(f.range):null,description:f.description,error:f.error,sortText:f.sortText})})(n||(e.ITestItem=n={}));var s;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var a;(function(C){C.serialize=f=>({expand:f.expand,item:n.serialize(f.item)}),C.deserialize=f=>({controllerId:m.$vJ.root(f.item.extId),expand:f.expand,item:n.deserialize(f.item)})})(a||(e.InternalTestItem=a={}));var t;(function(C){C.serialize=f=>{let p;return f.item&&(p={},f.item.label!==void 0&&(p.label=f.item.label),f.item.tags!==void 0&&(p.tags=f.item.tags),f.item.busy!==void 0&&(p.busy=f.item.busy),f.item.uri!==void 0&&(p.uri=f.item.uri?.toJSON()),f.item.range!==void 0&&(p.range=f.item.range?.toJSON()),f.item.description!==void 0&&(p.description=f.item.description),f.item.error!==void 0&&(p.error=f.item.error),f.item.sortText!==void 0&&(p.sortText=f.item.sortText)),{extId:f.extId,expand:f.expand,item:p}},C.deserialize=f=>{let p;return f.item&&(p={},f.item.label!==void 0&&(p.label=f.item.label),f.item.tags!==void 0&&(p.tags=f.item.tags),f.item.busy!==void 0&&(p.busy=f.item.busy),f.item.range!==void 0&&(p.range=f.item.range?T.$Ds.lift(f.item.range):null),f.item.description!==void 0&&(p.description=f.item.description),f.item.error!==void 0&&(p.error=f.item.error),f.item.sortText!==void 0&&(p.sortText=f.item.sortText)),{extId:f.extId,expand:f.expand,item:p}}})(t||(e.ITestItemUpdate=t={}));const r=(C,f)=>{f.expand!==void 0&&(C.expand=f.expand),f.item!==void 0&&(C.item=C.item?Object.assign(C.item,f.item):f.item)};e.$BJ=r;var h;(function(C){C.serializeWithoutMessages=f=>({...a.serialize(f),ownComputedState:f.ownComputedState,computedState:f.computedState,tasks:f.tasks.map(g.serializeWithoutMessages)}),C.serialize=f=>({...a.serialize(f),ownComputedState:f.ownComputedState,computedState:f.computedState,tasks:f.tasks.map(g.serialize)}),C.deserialize=f=>({...a.deserialize(f),ownComputedState:f.ownComputedState,computedState:f.computedState,tasks:f.tasks.map(g.deserialize),retired:!0})})(h||(e.TestResultItem=h={}));var u;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(u||(e.DetailType=u={}));var c;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(c||(e.TestDiffOpType=c={}));var l;(function(C){C.deserialize=f=>f.op===0?{op:f.op,item:a.deserialize(f.item)}:f.op===1?{op:f.op,item:t.deserialize(f.item)}:f.op===2?{op:f.op,uri:D.URI.revive(f.uri),docv:f.docv}:f,C.serialize=f=>f.op===0?{op:f.op,item:a.serialize(f.item)}:f.op===1?{op:f.op,item:t.serialize(f.item)}:f})(l||(e.TestsDiffOp=l={}));class E{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(f){const p=this.o();for(const k of f)switch(k.op){case 0:this.j(a.deserialize(k.item),p);break;case 1:this.k(t.deserialize(k.item),p);break;case 3:this.l(k.itemId,p);break;case 5:this.m(k.itemId);break;case 4:this.updatePendingRoots(k.amount);break;case 6:this.c.set(k.tag.id,k.tag);break;case 7:this.c.delete(k.id);break}p.complete?.()}j(f,p){const k=m.$vJ.parentId(f.item.extId)?.toString();let I;if(!k)I=this.p(f),this.f.add(I),this.d.set(f.item.extId,I);else if(this.d.has(k)){const j=this.d.get(k);j.children.add(f.item.extId),I=this.p(f,j),this.d.set(f.item.extId,I)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(f)}`);return}return p.add?.(I),f.expand===2&&this.g++,I}k(f,p){const k=this.d.get(f.extId);if(k)return f.expand!==void 0&&(k.expand===2&&this.g--,f.expand===2&&this.g++),(0,e.$BJ)(k,f),p.update?.(k),k}l(f,p){const k=this.d.get(f);if(!k)return;const I=m.$vJ.parentId(k.item.extId)?.toString();I?this.d.get(I).children.delete(k.item.extId):this.f.delete(k);const j=[[f]];for(;j.length;)for(const z of j.pop()){const M=this.d.get(z);M&&(j.push(M.children),this.d.delete(z),p.remove?.(M,M!==k),M.expand===2&&this.g--)}}m(f){}updatePendingRoots(f){this.h+=f}o(){return{}}}e.$CJ=E}),define(ke[112],Se([1,0,12,4,3,60,89,67]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.TestItemEventOp=void 0;var b;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const y=(i,n)=>i===n,P=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,n)=>!(i.length!==n.length||i.some(s=>!n.includes(s)))}),$=(i,n)=>{let s;for(const[a,t]of P)t(i[a],n[a])||(s?s[a]=n[a]:s={[a]:n[a]});return s};class v extends m.$Rc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new D.$_g(()=>this.flushDiff(),200)),this.g=this.B(new T.$Rd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(n){this.h=n;for(const s of this.tree.values())this.I(s)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const s of this.m)if(s.op===2&&s.uri===n.uri){s.docv=n.docv;return}break}case 1:{const s=this.m[this.m.length-1];if(s){if(s.op===1&&s.item.extId===n.item.extId){(0,R.$BJ)(s.item,n.item);return}if(s.op===0&&s.item.item.extId===n.item.extId){(0,R.$BJ)(s.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,s){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||s>a.expandLevels)&&(a.expandLevels=s),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,s-1):t.wait().then(()=>this.J(a,s-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,s-1)):this.J(a,s-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(n,s){switch(s.op){case 3:this.N(w.$vJ.joinToString(n.fullId,s.id));break;case 0:this.y(s.item,n);break;case 5:for(const a of s.ops)this.u(n,a);break;case 1:this.z(s.new,s.old,n.fullId.toString());break;case 2:this.I(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:s.update}});break;case 6:this.w(n.actual.uri);break;default:(0,A.$4c)(s)}}w(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}y(n,s){const a=w.$vJ.fromExtHostTestItem(n,this.root.id,s?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==s?.actual&&this.s.getChildren(t.parent).delete(n.id);let r=this.tree.get(a.toString());if(!r){r={fullId:a,actual:n,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:0},n.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(n,s),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(n)}}),this.H(n,r,s);return}if(r.actual===n){this.G(n,r,s);return}if(r.actual.uri?.toString()!==n.uri?.toString())return this.N(a.toString()),this.y(n,s);const h=this.s.getChildren(r.actual),u=r.actual,c=$(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,r.actual=n,r.expand=0,c&&(c.hasOwnProperty("tags")&&(this.z(n.tags,u.tags,a.toString()),delete c.tags),this.u(r,{op:4,update:c})),this.H(n,r,s);for(const[l,E]of h)this.s.getChildren(n).get(E.id)||this.N(w.$vJ.joinToString(a,E.id));this.w(r.actual.uri)}z(n,s,a){const t=new Set(s.map(r=>r.id));for(const r of n)t.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(r=>(0,R.$zJ)(this.s.controllerId,r.id))}}}),t.forEach(this.D,this)}C(n){const s=this.j.get(n.id);s?s.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$zJ)(this.s.controllerId,n.id)}}))}D(n){const s=this.j.get(n);s&&!--s.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$zJ)(this.s.controllerId,n)}))}F(n,s){this.s.getApiFor(n).parent=s&&s.actual!==this.root?s.actual:void 0}G(n,s,a){this.F(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=r=>this.u(s,r),this.I(s)}H(n,s,a){this.G(n,s,a);for(const[t,r]of this.s.getChildren(n))this.y(r,s)}I(n){let s;this.h?n.resolveBarrier?s=n.resolveBarrier.isOpen()?3:2:s=n.actual.canResolveChildren?1:0:s=0,s!==n.expand&&(n.expand=s,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:s}}),s===1&&n.expandLevels!==void 0&&this.L(n))}J(n,s){if(s<0)return;const a=[];for(const[t,r]of this.s.getChildren(n.actual)){const h=this.expand(w.$vJ.joinToString(n.fullId,r.id),s);(0,D.$Mg)(h)&&a.push(h)}if(a.length)return Promise.all(a).then(()=>{})}L(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const r=new D.$Yg;return r.open(),r}n.expand=2,this.M(n);const s=n.resolveBarrier=new D.$Yg,a=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(r){a(r)}return(0,D.$Mg)(t)?t.catch(a).then(()=>{s.open(),this.I(n)}):(s.open(),this.I(n)),n.resolveBarrier}M(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}N(n){const s=this.tree.get(n);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[s];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.D(r.id);this.tree.delete(t.fullId.toString());for(const[r,h]of this.s.getChildren(t.actual))a.push(this.tree.get(w.$vJ.joinToString(t.fullId,h.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$uM=v;class S extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$vM=S;class g extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$wM=g;class d extends Error{constructor(n,s,a){super(`TestItem with ID "${n}" is from controller "${s}" and cannot be added as a child of an item from controller "${a}".`)}}e.$xM=d;const o=(i,n,s)=>{let a=new Map;return{get size(){return a.size},forEach(t,r){for(const h of a.values())t.call(r,h,this)},[Symbol.iterator](){return a.entries()},replace(t){const r=new Map,h=new Set(a.keys()),u={op:5,ops:[]};for(const c of t){if(!(c instanceof s))throw new g(c.id);const l=n(c).controllerId;if(l!==i.controllerId)throw new d(c.id,l,i.controllerId);if(r.has(c.id))throw new S(c.id);r.set(c.id,c),h.delete(c.id),u.ops.push({op:0,item:c})}for(const c of h.keys())u.ops.push({op:3,id:c});i.listener?.(u),a=r},add(t){if(!(t instanceof s))throw new g(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$yM=o}),define(ke[143],Se([1,0,112]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=void 0;const T=new WeakMap,m=(R,w)=>{const b={controllerId:w};return T.set(R,b),b};e.$zM=m;const A=R=>{const w=T.get(R);if(!w)throw new D.$wM(R?.id||"<unknown>");return w};e.$AM=A}),define(ke[113],Se([1,0,17,2]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oub=e.$Nub=e.$Mub=e.$Lub=e.$Kub=void 0,e.$Kub="vscode-cdn.net",e.$Lub=`vscode-resource.${e.$Kub}`,e.$Mub=`'self' https://*.${e.$Kub}`;function m(w,b){return w.scheme===D.Schemas.http||w.scheme===D.Schemas.https?w:(b&&b.authority&&b.isRemote&&w.scheme===D.Schemas.file&&(w=T.URI.from({scheme:D.Schemas.vscodeRemote,authority:b.authority,path:w.path})),T.URI.from({scheme:D.Schemas.https,authority:`${w.scheme}+${A(w.authority)}.${e.$Lub}`,path:w.path,fragment:w.fragment,query:w.query}))}e.$Nub=m;function A(w){return w.replace(/./g,b=>{const y=b.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?b:"-"+y.toString(16).padStart(4,"0")})}function R(w){return w.replace(/-([0-9a-f]{4})/g,(b,y)=>String.fromCharCode(parseInt(y,16)))}e.$Oub=R}),define(ke[287],Se([1,0,4,3,113]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0;class A{constructor(w,b,y){this.d=w,this.e=b,this.f=y,this.a=0,this.b=new T.$Qc,this.c=new Map,this.b.add(b.onDidChangeVisibleTextEditors(()=>{const L=b.getVisibleTextEditors();for(const P of this.c.values())L.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(w=>w.inset.dispose()),this.b.dispose()}createWebviewEditorInset(w,b,y,L,P){let $;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===w){$=n;break}if(!$)throw new Error("not a visible editor");const v=this,S=this.a++,g=new D.$Rd,d=new D.$Rd,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,m.$Nub)(n,v.f)}get cspSource(){return m.$Mub}set options(n){this.b=n,v.d.$setOptions(S,n)}get options(){return this.b}set html(n){this.a=n,v.d.$setHtml(S,n)}get html(){return this.a}get onDidReceiveMessage(){return g.event}postMessage(n){return v.d.$postMessage(S,n)}},i=new class{constructor(){this.editor=w,this.line=b,this.height=y,this.webview=o,this.onDidDispose=d.event}dispose(){v.c.has(S)&&(v.c.delete(S),v.d.$disposeEditorInset(S),d.fire(),d.dispose(),g.dispose())}};return this.d.$createEditorInset(S,$.id,$.value.document.uri,b+1,y,L||{},P.identifier,P.extensionLocation),this.c.set(S,{editor:w,inset:i,onDidReceiveMessage:g}),i}$onDidDispose(w){const b=this.c.get(w);b&&b.inset.dispose()}$onDidReceiveMessage(w,b){this.c.get(w)?.onDidReceiveMessage.fire(b)}}e.$Dec=A}),define(ke[288],Se([1,0,5]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.VariableKind=e.$qN=void 0,e.$qN=(0,D.$Zh)("configurationResolverService");var T;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class m extends Error{constructor(R,w){super(w),this.variable=R}}e.$rN=m}),define(ke[289],Se([1,0,16,49,18,24,11,102,231,288,13]),function(be,e,D,T,m,A,R,w,b,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,S,g,d){this.h=new Map,this.a=v,this.b=S,this.g=g,d&&(this.c=d.then(o=>this.i(o)))}i(v){if(R.$i){const S=Object.create(null);return Object.keys(v).forEach(g=>{S[g.toLowerCase()]=v[g]}),S}return v}resolveWithEnvironment(v,S,g){return this.l({env:this.i(v),userHome:void 0},S?S.uri:void 0,g)}async resolveAsync(v,S){const g={env:await this.c,userHome:await this.g};return this.l(g,v?v.uri:void 0,S)}async j(v,S,g,d){const o=A.$en(S);R.$i&&o.windows?Object.keys(o.windows).forEach(n=>o[n]=o.windows[n]):R.$j&&o.osx?Object.keys(o.osx).forEach(n=>o[n]=o.osx[n]):R.$k&&o.linux&&Object.keys(o.linux).forEach(n=>o[n]=o.linux[n]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,v?v.uri:void 0,o,g,d)}async resolveAnyAsync(v,S,g){return this.j(v,S,g)}async resolveAnyMap(v,S,g){const d=new Map;return{newConfig:await this.j(v,S,g,d),resolvedVariables:d}}resolveWithInteractionReplace(v,S,g,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,S,g,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,S){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,S)}async l(v,S,g,d,o){if(m.$Cf(g))return this.m(v,S,g,d,o);if(Array.isArray(g))return Promise.all(g.map(i=>this.l(v,S,i,d,o)));if(m.$Ef(g)){const i=Object.create(null),n=await Promise.all(Object.keys(g).map(async s=>[await this.m(v,S,s,d,o),await this.l(v,S,g[s],d,o)]));for(const[s,a]of n)i[s]=a;return i}return g}m(v,S,g,d,o){return(0,L.$Xe)(g,P.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(P.VARIABLE_LHS))return i;let s=await this.o(v,i,n,S,d);return o?.set(n,s),s!==i&&m.$Cf(s)&&s.match(P.VARIABLE_REGEXP)&&(s=await this.m(v,S,s,d,o)),s})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,S,g,d,o){let i;const n=g.split(":");n.length>1&&(g=n[0],i=n[1]);const s=r=>{const h=this.a.getFilePath();if(h)return(0,w.$Dv)(h);throw new y.$rN(r,(0,b.localize)(0,null,S))},a=r=>{const h=s(r);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,w.$Dv)(u)}throw new y.$rN(r,(0,b.localize)(1,null,S,D.$mc(h)))},t=r=>{if(i){const h=this.a.getFolderUri(i);if(h)return h;throw new y.$rN(r,(0,b.localize)(2,null,S,i))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new y.$rN(r,(0,b.localize)(3,null,S)):new y.$rN(r,(0,b.localize)(4,null,S))};switch(g){case"env":if(i){if(v.env){const r=v.env[R.$i?i.toLowerCase():i];if(m.$Cf(r))return r}return""}throw new y.$rN(y.VariableKind.Env,(0,b.localize)(5,null,S));case"config":if(i){const r=this.a.getConfigurationValue(d,i);if(m.$Lf(r))throw new y.$rN(y.VariableKind.Config,(0,b.localize)(6,null,S,i));if(m.$Ef(r))throw new y.$rN(y.VariableKind.Config,(0,b.localize)(7,null,S,i));return r}throw new y.$rN(y.VariableKind.Config,(0,b.localize)(8,null,S));case"command":return this.p(y.VariableKind.Command,S,i,o,"command");case"input":return this.p(y.VariableKind.Input,S,i,o,"input");case"extensionInstallFolder":if(i){const r=await this.a.getExtension(i);if(!r)throw new y.$rN(y.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,S,i));return this.n(r.extensionLocation)}throw new y.$rN(y.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,S));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,w.$Dv)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return d||i?(0,w.$Dv)(this.n(t(y.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,w.$Dv)(D.$mc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new y.$rN(y.VariableKind.UserHome,(0,b.localize)(11,null,S))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new y.$rN(y.VariableKind.LineNumber,(0,b.localize)(12,null,S))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new y.$rN(y.VariableKind.SelectedText,(0,b.localize)(13,null,S))}case"file":return s(y.VariableKind.File);case"fileWorkspaceFolder":return a(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$mc(a(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return d||i?D.$kc(this.n(t(y.VariableKind.RelativeFile)),s(y.VariableKind.RelativeFile)):s(y.VariableKind.RelativeFile);case"relativeFileDirname":{const r=D.$lc(s(y.VariableKind.RelativeFileDirname));if(d||i){const h=D.$kc(this.n(t(y.VariableKind.RelativeFileDirname)),r);return h.length===0?".":h}return r}case"fileDirname":return D.$lc(s(y.VariableKind.FileDirname));case"fileExtname":return D.$nc(s(y.VariableKind.FileExtname));case"fileBasename":return D.$mc(s(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=D.$mc(s(y.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-D.$nc(r).length)}case"fileDirnameBasename":return D.$mc(D.$lc(s(y.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||S}case"execInstallFolder":{const r=this.a.getAppRoot();return r||S}case"pathSeparator":return D.sep;default:try{const r=i?`${g}:${i}`:g;return this.p(y.VariableKind.Unknown,S,r,o,void 0)}catch{return S}}}}p(v,S,g,d,o){if(g&&d){const i=o===void 0?d[g]:d[o+":"+g];if(typeof i=="string")return i;throw new y.$rN(v,(0,b.localize)(14,null,S))}return S}}e.$FN=P}),define(ke[144],Se([1,0,5,140]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=e.$MC=e.OpenEditorContext=e.GroupsOrder=e.$LC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$KC=void 0,e.$KC=(0,D.$Zh)("editorGroupsService");var m;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(m||(e.GroupDirection=m={}));var A;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var R;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var w;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(w||(e.GroupsArrangement=w={}));var b;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function y(S){const g=S;return(0,T.$tE)(g?.editor)&&(0,T.$tE)(g?.replacement)}e.$LC=y;var L;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var P;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function $(S){const g=S;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.$MC=$;function v(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$NC=v}),define(ke[290],Se([1,0,5,144]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RC=e.$QC=e.$PC=e.$OC=void 0,e.$OC=(0,D.$Zh)("editorService"),e.$PC=-1,e.$QC=-2;function m(A){const R=A;return typeof A=="number"||(0,T.$MC)(R)}e.$RC=m}),define(ke[145],Se([1,0,5,134]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZJ=void 0,e.$ZJ=(0,D.$1h)(T.$7h)}),define(ke[146],Se([1,0,26,4,16,3]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=e.$z6b=e.$y6b=e.$x6b=e.$w6b=void 0;class R{constructor(o,i){this.versionId=o,this.removedDueToLooping=i}}e.$w6b=R;class w{static isHostExtension(o,i,n){if(i.getExtensionDescription(o))return!1;const s=n.getExtensionDescription(o);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(o,i){this.j=o,this.c=new T.$Rd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new D.$fm,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const i=this.j.readActivationEvents(o);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,i){this.e=g(this.e,i),this.e=this.e.concat(o);const n=w.l(this.e);return this.e=g(this.e,n.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,n)}static l(o){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,h){this.addNode(r),this.addNode(h),this.c.has(r)?this.c.get(r).push(h):this.c.set(r,[h])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,h){const u=i.getArcs(r);for(let c=0;c<u.length;c++)if(!h.has(u[c]))return!1;return!0}getNodes(){return this.e}},n=new D.$fm;for(const r of o)if(n.set(r.identifier,r),r.extensionDependencies)for(const h of r.extensionDependencies)i.addArc(D.$dm.toKey(r.identifier),D.$dm.toKey(h));const s=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>s.add(r));const a=i.getNodes().filter(r=>!s.has(r));let t;do{t=!1;for(let r=0;r<a.length;r++){const h=a[r];i.hasOnlyGoodArcs(h,s)&&(a.splice(r,1),r--,s.add(h),t=!0)}}while(t);return a.map(r=>n.get(r))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const i=this.h.get(o);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new b(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const i=this.f.get(o);return i||void 0}getExtensionDescriptionByUUID(o){for(const i of this.g)if(i.uuid===o)return i}getExtensionDescriptionByIdOrUUID(o,i){return this.getExtensionDescription(o)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$x6b=w;class b{constructor(o,i){this.versionId=o,this.extensions=i}}e.$y6b=b;class y{constructor(o){this.d=new $,this.c=new w(o,[])}async acquireLock(o){const i=await this.d.acquire(o);return new L(this,i)}deltaExtensions(o,i,n){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,i){return this.c.getExtensionDescriptionByIdOrUUID(o,i)}}e.$z6b=y;class L extends A.$Rc{constructor(o,i){super(),this.f=o,this.c=!1,this.B(i)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$A6b=L;class P{constructor(o){this.name=o,this.promise=new Promise((i,n)=>{this.c=i})}resolve(o){this.c(o)}}class ${constructor(){this.c=[],this.d=!1}async acquire(o){const i=new P(o);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};o.resolve((0,A.$Pc)(s))}}var v;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(v||(v={}));function S(d,o){const i=d.isBuiltin?0:d.isUnderDevelopment?2:1,n=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(i!==n)return i-n;const s=m.$fc.basename(d.extensionLocation.path),a=m.$fc.basename(o.extensionLocation.path);return s<a?-1:s>a?1:0}function g(d,o){const i=new D.$em(o);return d.filter(n=>!i.has(n.identifier))}}),define(ke[291],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.ExtHostConnectionType=void 0;var D;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class T{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[T.ENV_KEY]=this.pipeName}}e.$Hm=T;class m{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[m.ENV_KEY]="1"}}e.$Im=m;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[A.ENV_KEY]="1"}}e.$Jm=A;function R(L){delete L[T.ENV_KEY],delete L[m.ENV_KEY],delete L[A.ENV_KEY]}function w(L,P){R(P),L.serialize(P)}e.$Km=w;function b(L){if(L[T.ENV_KEY])return y(L,new T(L[T.ENV_KEY]));if(L[m.ENV_KEY])return y(L,new m);if(L[A.ENV_KEY])return y(L,new A);throw new Error("No connection information defined in environment!")}e.$Lm=b;function y(L,P){return R(L),P}}),define(ke[114],Se([1,0,22]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$mm=e.$lm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(T||(e.UIKind=T={}));var m;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(m||(e.ExtensionHostExitCode=m={}));var A;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function R(y){const L=D.$fe.alloc(1);switch(y){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.$lm=R;function w(y,L){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.$mm=w;var b;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(ke[90],Se([1,0,5,4,14,27,114,65,87,24,2,3,217]),function(be,e,D,T,m,A,R,w,b,y,L,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=e.$XM=e.$WM=e.$VM=void 0;let v=class extends P.$Rc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new T.$Rd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Rd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=L.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:b.$yo,name:(0,$.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(i.onDidChangeLogLevel(n=>{(0,m.$jj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===m.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,n){const s=this.getTelemetryDetails(),a=new S(i,n,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(o,i,n){this.f=o,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=g(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,w.$6k)((0,b.$Fo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((n,s)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(s):this.r.set(s,a)}),this.r.forEach(n=>{for(const s of n)s.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const s=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!s)return this.r.delete(o.value),!1;let a=!1;for(const t of s)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$VM=v,e.$VM=v=Ke([Be(0,A.$UM),Be(1,m.$ij)],v);class S{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,n,s,a,t,r){this.g=n,this.h=s,this.i=a,this.j=t,this.a=new T.$Rd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,b.$Io)(i,[]),this.c&&(i=(0,y.$hn)(i,this.c)),this.b||(i=(0,y.$hn)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const n={name:o.name,message:o.message,stack:o.stack,cause:o.cause},s=(0,b.$Io)(n,[]),a=new Error(s.message,{cause:s.cause});a.stack=s.stack,a.name=s.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$WM=S;function g(d){const o=Date.now()-new Date(d).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$XM=g,e.$YM=(0,D.$Zh)("IExtHostTelemetry")}),define(ke[25],Se([1,0,4,2,261,138,26,5]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VF=e.$UF=e.$TF=e.ActivationKind=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.ExtensionHostStartup=e.$NF=e.$MF=e.$LF=e.$KF=void 0,e.$KF=Object.freeze({identifier:new R.$dm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$LF="extensions.webWorker",e.$MF=(0,w.$Zh)("extensionService");class b{constructor(a){this.dependency=a}}e.$NF=b;var y;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class L{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,r){this.c=a,this.d=t.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$BF.createActivationEventsMap(this.d)}}set(a,t,r){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const h=[],u=[],c=[],l=[],E=P(this.d),C=P(t),f=(z,M)=>z.extensionLocation.toString()===M.extensionLocation.toString()||z.isBuiltin===M.isBuiltin||z.isUserBuiltin===M.isUserBuiltin||z.isUnderDevelopment===M.isUnderDevelopment;for(const z of this.d){const M=C.get(z.identifier);if(!M){h.push(z.identifier),E.delete(z.identifier);continue}if(!f(z,M)){h.push(z.identifier),E.delete(z.identifier);continue}}for(const z of t){const M=E.get(z.identifier);if(!M){u.push(z);continue}if(!f(M,z)){h.push(M.identifier),E.delete(M.identifier);continue}}const p=new R.$em(this.e),k=new R.$em(r);for(const z of this.e)k.has(z)||c.push(z);for(const z of r)p.has(z)||l.push(z);const I=A.$BF.createActivationEventsMap(u),j={versionId:a,toRemove:h,toAdd:u,addActivationEvents:I,myToRemove:c,myToAdd:l};return this.delta(j),j}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:h,myToAdd:u}=a,c=new R.$em(t),l=new R.$em(h);for(let E=0;E<this.d.length;E++)c.has(this.d[E].identifier)&&(this.d.splice(E,1),E--);for(let E=0;E<this.e.length;E++)l.has(this.e[E])&&(this.e.splice(E,1),E--);for(const E of r)this.d.push(E);for(const E of u)this.e.push(E);return this.f=null,a}containsExtension(a){for(const t of this.e)if(R.$dm.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const r=A.$BF.readActivationEvents(t);for(const h of r)a.add(h)}return a}}e.$OF=L;function P(s){const a=new R.$fm;for(const t of s)a.set(t.identifier,t);return a}function $(s,a){return s.enabledApiProposals?s.enabledApiProposals.includes(a):!1}e.$PF=$;function v(s,a){if(!$(s,a))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.$QF=v;class S{constructor(a,t,r,h){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=h}}e.$RF=S;class g{constructor(a,t){this.description=a,this.value=t}}e.$SF=g;var d;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(d||(e.ActivationKind=d={}));function o(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,m.$Oo)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.$TF=o;function i(s,a){return{identifier:new R.$dm((0,m.$Mo)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!a,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform}}e.$UF=i;class n{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$VF=n}),define(ke[292],Se([1,0,8,146,26,25,14,12]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=e.$4ec=e.$3ec=e.$2ec=e.$1ec=e.$Zec=void 0;class b{static{this.NONE=new b(!1,-1,-1,-1)}constructor(o,i,n,s){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=s}}e.$Zec=b;class y{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new b(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$1ec=y;class L{constructor(o,i,n,s,a,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=n,this.module=s,this.exports=a,this.subscriptions=t}}e.$2ec=L;class P extends L{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$3ec=P;class $ extends L{constructor(){super(!1,null,b.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$4ec=$;class v extends L{constructor(o){super(!0,o,b.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(o,i,n,s){this.g=s,this.a=o,this.b=i,this.c=n,this.d=new m.$fm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,n]of this.d)o.push(n.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const n=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(n.map(s=>({id:s.identifier,reason:{startup:i,extensionId:s.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const n=this.a.getExtensionDescription(o);if(!n)throw new Error(`Extension '${o}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(o){const i=o.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new v(a));return this.c.onExtensionActivationError(o.id,a,new A.$NF(o.id.value)),t}const n=[],s=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of s){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:o.reason}));continue}const r=this.a.getExtensionDescription(a);if(r){if(!r.main&&!r.browser)continue;n.push(this.j({id:r.identifier,reason:o.reason}));continue}const h=i.displayName||i.identifier.value,u=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${a}'`),c=this.k(o,i.displayName,[],new v(u));return this.c.onExtensionActivationError(i.identifier,u,new A.$NF(a)),c}return this.k(o,i.displayName,n,null)}k(o,i,n,s){const a=new g(o.id,i,o.reason,n,s,this.c,this.g);return this.d.set(o.id,a),a}l(o){return T.$x6b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$5ec=S,e.$5ec=S=Ke([Be(3,R.$hj)],S);let g=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,n,s,a,t,r){this.c=o,this.d=i,this.f=n,this.g=s,this.h=a,this.j=t,this.k=r,this.a=new w.$Yg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new v(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new v(i),this.b&&D.$3(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};g=Ke([Be(6,R.$hj)],g)}),define(ke[15],Se([1,0,19,22,164,74,80,28,160,54,100,24,18,2,29,83,136,143,140,111,67,89,290,7,25]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s,a,t,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$DM=e.$CM=e.MarkdownString=e.$BM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(Re){function Fe(re){const{selectionStartLineNumber:Te,selectionStartColumn:Ve,positionLineNumber:_e,positionColumn:Qe}=re,st=new r.$FK(Te-1,Ve-1),ht=new r.$FK(_e-1,Qe-1);return new r.$HK(st,ht)}Re.to=Fe;function Ie(re){const{anchor:Te,active:Ve}=re;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Re.from=Ie})(u||(e.Selection=u={}));var c;(function(Re){function Fe(re){if(!re)return;const{start:Te,end:Ve}=re;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Re.from=Fe;function Ie(re){if(!re)return;const{startLineNumber:Te,startColumn:Ve,endLineNumber:_e,endColumn:Qe}=re;return new r.$GK(Te-1,Ve-1,_e-1,Qe-1)}Re.to=Ie})(c||(e.Range=c={}));var l;(function(Re){function Fe(Ie){switch(Ie){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Re.to=Fe})(l||(e.TokenType=l={}));var E;(function(Re){function Fe(re){return new r.$FK(re.lineNumber-1,re.column-1)}Re.to=Fe;function Ie(re){return{lineNumber:re.line+1,column:re.character+1}}Re.from=Ie})(E||(e.Position=E={}));var C;(function(Re){function Fe(Te,Ve,_e){return(0,D.$Gb)((0,D.$2b)(Te).map(Qe=>Ie(Qe,Ve,_e)))}Re.from=Fe;function Ie(Te,Ve,_e){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:_e?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:re(Te.scheme,Ve),pattern:le.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:_e?.isBuiltin}}function re(Te,Ve){return Ve&&typeof Te=="string"?Ve.transformOutgoingScheme(Te):Te}})(C||(e.DocumentSelector=C={}));var f;(function(Re){function Fe(re){switch(re){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Re.from=Fe;function Ie(re){switch(re){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Re.to=Ie})(f||(e.DiagnosticTag=f={}));var p;(function(Re){function Fe(re){let Te;return re.code&&((0,$.$Cf)(re.code)||(0,$.$Gf)(re.code)?Te=String(re.code):Te={value:String(re.code.value),target:re.code.target}),{...c.from(re.range),message:re.message,source:re.source,code:Te,severity:I.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(k.from),tags:Array.isArray(re.tags)?(0,D.$Gb)(re.tags.map(f.from)):void 0}}Re.from=Fe;function Ie(re){const Te=new r.$SK(c.to(re),re.message,I.to(re.severity));return Te.source=re.source,Te.code=(0,$.$Cf)(re.code)?re.code:re.code?.value,Te.relatedInformation=re.relatedInformation&&re.relatedInformation.map(k.to),Te.tags=re.tags&&(0,D.$Gb)(re.tags.map(f.to)),Te}Re.to=Ie})(p||(e.Diagnostic=p={}));var k;(function(Re){function Fe(re){return{...c.from(re.location.range),message:re.message,resource:re.location.uri}}Re.from=Fe;function Ie(re){return new r.$RK(new r.$QK(re.resource,c.to(re)),re.message)}Re.to=Ie})(k||(e.DiagnosticRelatedInformation=k={}));var I;(function(Re){function Fe(re){switch(re){case r.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Re.from=Fe;function Ie(re){switch(re){case d.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Re.to=Ie})(I||(e.DiagnosticSeverity=I={}));var j;(function(Re){function Fe(re){return typeof re=="number"&&re>=r.ViewColumn.One?re-1:re===r.ViewColumn.Beside?t.$QC:t.$PC}Re.from=Fe;function Ie(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Ie})(j||(e.ViewColumn=j={}));function z(Re){return typeof Re.range<"u"}function M(Re){return Re.length===0?!0:!!z(Re[0])}e.$BM=M;var F;(function(Re){function Fe(Qe){return Qe.map(Re.from)}Re.fromMany=Fe;function Ie(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function re(Qe){let st;if(Ie(Qe)){const{language:Et,value:yt}=Qe;st={value:"```"+Et+`
`+yt+"\n```\n"}}else r.$5K.isMarkdownString(Qe)?st={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?st={value:Qe}:st={value:""};const ht=Object.create(null);st.uris=ht;const wt=Et=>{try{let yt=v.URI.parse(Et,!0);yt=yt.with({query:Te(yt.query,ht)}),ht[Et]=yt}catch{}return""},bt=new b.marked.Renderer;return bt.link=wt,bt.image=Et=>typeof Et=="string"?wt(R.$hk(Et).href):"",(0,b.marked)(st.value,{renderer:bt}),st}Re.from=re;function Te(Qe,st){if(!Qe)return Qe;let ht;try{ht=(0,y.$vh)(Qe)}catch{}if(!ht)return Qe;let wt=!1;return ht=(0,P.$gn)(ht,bt=>{if(v.URI.isUri(bt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[Et]=bt,wt=!0,Et}else return}),wt?JSON.stringify(ht):Qe}function Ve(Qe){const st=new r.$5K(Qe.value,Qe.supportThemeIcons);return st.isTrusted=Qe.isTrusted,st.supportHtml=Qe.supportHtml,st.baseUri=Qe.baseUri?v.URI.from(Qe.baseUri):void 0,st}Re.to=Ve;function _e(Qe){if(Qe)return typeof Qe=="string"?Qe:Re.from(Qe)}Re.fromStrict=_e})(F||(e.MarkdownString=F={}));function N(Re){return M(Re)?Re.map(Fe=>({range:c.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?F.fromMany(Fe.hoverMessage):Fe.hoverMessage?F.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Re.map(Fe=>({range:c.from(Fe)}))}e.$CM=N;function O(Re){return typeof Re>"u"?Re:typeof Re=="string"?v.URI.file(Re):Re}e.$DM=O;var W;(function(Re){function Fe(Ie){return typeof Ie>"u"?Ie:{contentText:Ie.contentText,contentIconPath:Ie.contentIconPath?O(Ie.contentIconPath):void 0,border:Ie.border,borderColor:Ie.borderColor,fontStyle:Ie.fontStyle,fontWeight:Ie.fontWeight,textDecoration:Ie.textDecoration,color:Ie.color,backgroundColor:Ie.backgroundColor,margin:Ie.margin,width:Ie.width,height:Ie.height}}Re.from=Fe})(W||(e.ThemableDecorationAttachmentRenderOptions=W={}));var x;(function(Re){function Fe(Ie){return typeof Ie>"u"?Ie:{backgroundColor:Ie.backgroundColor,outline:Ie.outline,outlineColor:Ie.outlineColor,outlineStyle:Ie.outlineStyle,outlineWidth:Ie.outlineWidth,border:Ie.border,borderColor:Ie.borderColor,borderRadius:Ie.borderRadius,borderSpacing:Ie.borderSpacing,borderStyle:Ie.borderStyle,borderWidth:Ie.borderWidth,fontStyle:Ie.fontStyle,fontWeight:Ie.fontWeight,textDecoration:Ie.textDecoration,cursor:Ie.cursor,color:Ie.color,opacity:Ie.opacity,letterSpacing:Ie.letterSpacing,gutterIconPath:Ie.gutterIconPath?O(Ie.gutterIconPath):void 0,gutterIconSize:Ie.gutterIconSize,overviewRulerColor:Ie.overviewRulerColor,before:Ie.before?W.from(Ie.before):void 0,after:Ie.after?W.from(Ie.after):void 0}}Re.from=Fe})(x||(e.ThemableDecorationRenderOptions=x={}));var ue;(function(Re){function Fe(Ie){if(typeof Ie>"u")return Ie;switch(Ie){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Fe})(ue||(e.DecorationRangeBehavior=ue={}));var X;(function(Re){function Fe(Ie){return{isWholeLine:Ie.isWholeLine,rangeBehavior:Ie.rangeBehavior?ue.from(Ie.rangeBehavior):void 0,overviewRulerLane:Ie.overviewRulerLane,light:Ie.light?x.from(Ie.light):void 0,dark:Ie.dark?x.from(Ie.dark):void 0,backgroundColor:Ie.backgroundColor,outline:Ie.outline,outlineColor:Ie.outlineColor,outlineStyle:Ie.outlineStyle,outlineWidth:Ie.outlineWidth,border:Ie.border,borderColor:Ie.borderColor,borderRadius:Ie.borderRadius,borderSpacing:Ie.borderSpacing,borderStyle:Ie.borderStyle,borderWidth:Ie.borderWidth,fontStyle:Ie.fontStyle,fontWeight:Ie.fontWeight,textDecoration:Ie.textDecoration,cursor:Ie.cursor,color:Ie.color,opacity:Ie.opacity,letterSpacing:Ie.letterSpacing,gutterIconPath:Ie.gutterIconPath?O(Ie.gutterIconPath):void 0,gutterIconSize:Ie.gutterIconSize,overviewRulerColor:Ie.overviewRulerColor,before:Ie.before?W.from(Ie.before):void 0,after:Ie.after?W.from(Ie.after):void 0}}Re.from=Fe})(X||(e.DecorationRenderOptions=X={}));var J;(function(Re){function Fe(re){return{text:re.newText,eol:re.newEol&&Ae.from(re.newEol),range:c.from(re.range)}}Re.from=Fe;function Ie(re){const Te=new r.$LK(c.to(re.range),re.text);return Te.newEol=typeof re.eol>"u"?void 0:Ae.to(re.eol),Te}Re.to=Ie})(J||(e.TextEdit=J={}));var Q;(function(Re){function Fe(re,Te){const Ve={edits:[]};if(re instanceof r.$OK){const _e=new w.$Ac;for(const Qe of re._allEntries())Qe._type===1&&v.URI.isUri(Qe.to)&&Qe.from===void 0&&_e.add(Qe.to);for(const Qe of re._allEntries())if(Qe._type===1){let st;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?st={type:"base64",value:(0,T.$ze)(T.$fe.wrap(Qe.options.contents))}:st={type:"dataTransferItem",id:Qe.options.contents._itemId}),Ve.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:st},metadata:Qe.metadata})}else Qe._type===2?Ve.edits.push({resource:Qe.uri,textEdit:J.from(Qe.edit),versionId:_e.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?Ve.edits.push({resource:Qe.uri,textEdit:{range:c.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:_e.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?Ve.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&Ve.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(Ne.from)}})}return Ve}Re.from=Fe;function Ie(re){const Te=new r.$OK,Ve=new w.$zc;for(const _e of re.edits)if(_e.textEdit){const Qe=_e,st=v.URI.revive(Qe.resource),ht=c.to(Qe.textEdit.range),wt=Qe.textEdit.text,bt=Qe.textEdit.insertAsSnippet;let Et;bt?Et=r.$NK.replace(ht,new r.$PK(wt)):Et=r.$LK.replace(ht,wt);const yt=Ve.get(st);yt?yt.push(Et):Ve.set(st,[Et])}else Te.renameFile(v.URI.revive(_e.oldResource),v.URI.revive(_e.newResource),_e.options);for(const[_e,Qe]of Ve)Te.set(_e,Qe);return Te}Re.to=Ie})(Q||(e.WorkspaceEdit=Q={}));var he;(function(Re){const Fe=Object.create(null);Fe[r.SymbolKind.File]=0,Fe[r.SymbolKind.Module]=1,Fe[r.SymbolKind.Namespace]=2,Fe[r.SymbolKind.Package]=3,Fe[r.SymbolKind.Class]=4,Fe[r.SymbolKind.Method]=5,Fe[r.SymbolKind.Property]=6,Fe[r.SymbolKind.Field]=7,Fe[r.SymbolKind.Constructor]=8,Fe[r.SymbolKind.Enum]=9,Fe[r.SymbolKind.Interface]=10,Fe[r.SymbolKind.Function]=11,Fe[r.SymbolKind.Variable]=12,Fe[r.SymbolKind.Constant]=13,Fe[r.SymbolKind.String]=14,Fe[r.SymbolKind.Number]=15,Fe[r.SymbolKind.Boolean]=16,Fe[r.SymbolKind.Array]=17,Fe[r.SymbolKind.Object]=18,Fe[r.SymbolKind.Key]=19,Fe[r.SymbolKind.Null]=20,Fe[r.SymbolKind.EnumMember]=21,Fe[r.SymbolKind.Struct]=22,Fe[r.SymbolKind.Event]=23,Fe[r.SymbolKind.Operator]=24,Fe[r.SymbolKind.TypeParameter]=25;function Ie(Te){return typeof Fe[Te]=="number"?Fe[Te]:6}Re.from=Ie;function re(Te){for(const Ve in Fe)if(Fe[Ve]===Te)return Number(Ve);return r.SymbolKind.Property}Re.to=re})(he||(e.SymbolKind=he={}));var Z;(function(Re){function Fe(re){switch(re){case r.SymbolTag.Deprecated:return 1}}Re.from=Fe;function Ie(re){switch(re){case 1:return r.SymbolTag.Deprecated}}Re.to=Ie})(Z||(e.SymbolTag=Z={}));var ye;(function(Re){function Fe(re){return{name:re.name,kind:he.from(re.kind),tags:re.tags&&re.tags.map(Z.from),containerName:re.containerName,location:Ee.from(re.location)}}Re.from=Fe;function Ie(re){const Te=new r.$VK(re.name,he.to(re.kind),re.containerName,Ee.to(re.location));return Te.tags=re.tags&&re.tags.map(Z.to),Te}Re.to=Ie})(ye||(e.WorkspaceSymbol=ye={}));var de;(function(Re){function Fe(re){const Te={name:re.name||"!!MISSING: name!!",detail:re.detail,range:c.from(re.range),selectionRange:c.from(re.selectionRange),kind:he.from(re.kind),tags:re.tags?.map(Z.from)??[]};return re.children&&(Te.children=re.children.map(Fe)),Te}Re.from=Fe;function Ie(re){const Te=new r.$WK(re.name,re.detail,he.to(re.kind),c.to(re.range),c.to(re.selectionRange));return(0,D.$Kb)(re.tags)&&(Te.tags=re.tags.map(Z.to)),re.children&&(Te.children=re.children.map(Ie)),Te}Re.to=Ie})(de||(e.DocumentSymbol=de={}));var H;(function(Re){function Fe(re){const Te=new r.$1K(he.to(re.kind),re.name,re.detail||"",v.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Te._sessionId=re._sessionId,Te._itemId=re._itemId,Te}Re.to=Fe;function Ie(re,Te,Ve){if(Te=Te??re._sessionId,Ve=Ve??re._itemId,Te===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Ve,name:re.name,detail:re.detail,kind:he.from(re.kind),uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(Z.from)}}Re.from=Ie})(H||(e.CallHierarchyItem=H={}));var U;(function(Re){function Fe(Ie){return new r.$2K(H.to(Ie.from),Ie.fromRanges.map(re=>c.to(re)))}Re.to=Fe})(U||(e.CallHierarchyIncomingCall=U={}));var ne;(function(Re){function Fe(Ie){return new r.$3K(H.to(Ie.to),Ie.fromRanges.map(re=>c.to(re)))}Re.to=Fe})(ne||(e.CallHierarchyOutgoingCall=ne={}));var Ee;(function(Re){function Fe(re){return{range:re.range&&c.from(re.range),uri:re.uri}}Re.from=Fe;function Ie(re){return new r.$QK(v.URI.revive(re.uri),c.to(re.range))}Re.to=Ie})(Ee||(e.location=Ee={}));var fe;(function(Re){function Fe(re){const Te=re,Ve=re;return{originSelectionRange:Te.originSelectionRange?c.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Ve.uri,range:c.from(Te.targetRange?Te.targetRange:Ve.range),targetSelectionRange:Te.targetSelectionRange?c.from(Te.targetSelectionRange):void 0}}Re.from=Fe;function Ie(re){return{targetUri:v.URI.revive(re.uri),targetRange:c.to(re.range),targetSelectionRange:re.targetSelectionRange?c.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?c.to(re.originSelectionRange):void 0}}Re.to=Ie})(fe||(e.DefinitionLink=fe={}));var me;(function(Re){function Fe(re){return{range:c.from(re.range),contents:F.fromMany(re.contents)}}Re.from=Fe;function Ie(re){return new r.$TK(re.contents.map(F.to),c.to(re.range))}Re.to=Ie})(me||(e.Hover=me={}));var ee;(function(Re){function Fe(re){return{range:c.from(re.range),expression:re.expression}}Re.from=Fe;function Ie(re){return new r.$ML(c.to(re.range),re.expression)}Re.to=Ie})(ee||(e.EvaluatableExpression=ee={}));var te;(function(Re){function Fe(re){if(re instanceof r.$NL)return{type:"text",range:c.from(re.range),text:re.text};if(re instanceof r.$OL)return{type:"variable",range:c.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof r.$PL)return{type:"expression",range:c.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Fe;function Ie(re){switch(re.type){case"text":return{range:c.to(re.range),text:re.text};case"variable":return{range:c.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:c.to(re.range),expression:re.expression}}}Re.to=Ie})(te||(e.InlineValue=te={}));var K;(function(Re){function Fe(re){return{frameId:re.frameId,stoppedLocation:c.from(re.stoppedLocation)}}Re.from=Fe;function Ie(re){return new r.$QL(re.frameId,c.to(re.stoppedLocation))}Re.to=Ie})(K||(e.InlineValueContext=K={}));var ie;(function(Re){function Fe(re){return{range:c.from(re.range),kind:re.kind}}Re.from=Fe;function Ie(re){return new r.$UK(c.to(re.range),re.kind)}Re.to=Ie})(ie||(e.DocumentHighlight=ie={}));var G;(function(Re){function Fe(Ie){switch(Ie){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Re.to=Fe})(G||(e.CompletionTriggerKind=G={}));var ae;(function(Re){function Fe(Ie){return{triggerKind:G.to(Ie.triggerKind),triggerCharacter:Ie.triggerCharacter}}Re.to=Fe})(ae||(e.CompletionContext=ae={}));var $e;(function(Re){function Fe(re){switch(re){case r.CompletionItemTag.Deprecated:return 1}}Re.from=Fe;function Ie(re){switch(re){case 1:return r.CompletionItemTag.Deprecated}}Re.to=Ie})($e||(e.CompletionItemTag=$e={}));var Ce;(function(Re){const Fe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ie(Ve){return Fe.get(Ve)??9}Re.from=Ie;const re=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Te(Ve){return re.get(Ve)??r.CompletionItemKind.Property}Re.to=Te})(Ce||(e.CompletionItemKind=Ce={}));var B;(function(Re){function Fe(Ie,re){const Te=new r.$$K(Ie.label);return Te.insertText=Ie.insertText,Te.kind=Ce.to(Ie.kind),Te.tags=Ie.tags?.map($e.to),Te.detail=Ie.detail,Te.documentation=R.$ck(Ie.documentation)?F.to(Ie.documentation):Ie.documentation,Te.sortText=Ie.sortText,Te.filterText=Ie.filterText,Te.preselect=Ie.preselect,Te.commitCharacters=Ie.commitCharacters,S.$Ds.isIRange(Ie.range)?Te.range=c.to(Ie.range):typeof Ie.range=="object"&&(Te.range={inserting:c.to(Ie.range.insert),replacing:c.to(Ie.range.replace)}),Te.keepWhitespace=typeof Ie.insertTextRules>"u"?!1:!!(Ie.insertTextRules&1),typeof Ie.insertTextRules<"u"&&Ie.insertTextRules&4?Te.insertText=new r.$PK(Ie.insertText):(Te.insertText=Ie.insertText,Te.textEdit=Te.range instanceof r.$GK?new r.$LK(Te.range,Te.insertText):void 0),Ie.additionalTextEdits&&Ie.additionalTextEdits.length>0&&(Te.additionalTextEdits=Ie.additionalTextEdits.map(Ve=>J.to(Ve))),Te.command=re&&Ie.command?re.fromInternal(Ie.command):void 0,Te}Re.to=Fe})(B||(e.CompletionItem=B={}));var Y;(function(Re){function Fe(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:F.fromStrict(re.documentation)}}Re.from=Fe;function Ie(re){return{label:re.label,documentation:R.$ck(re.documentation)?F.to(re.documentation):re.documentation}}Re.to=Ie})(Y||(e.ParameterInformation=Y={}));var se;(function(Re){function Fe(re){return{label:re.label,documentation:F.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(Y.from):[],activeParameter:re.activeParameter}}Re.from=Fe;function Ie(re){return{label:re.label,documentation:R.$ck(re.documentation)?F.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(Y.to):[],activeParameter:re.activeParameter}}Re.to=Ie})(se||(e.SignatureInformation=se={}));var oe;(function(Re){function Fe(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(se.from):[]}}Re.from=Fe;function Ie(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(se.to):[]}}Re.to=Ie})(oe||(e.SignatureHelp=oe={}));var _;(function(Re){function Fe(Ie,re){const Te=new r.$0K(E.to(re.position),typeof re.label=="string"?re.label:re.label.map(ge.to.bind(void 0,Ie)),re.kind&&ve.to(re.kind));return Te.textEdits=re.textEdits&&re.textEdits.map(J.to),Te.tooltip=R.$ck(re.tooltip)?F.to(re.tooltip):re.tooltip,Te.paddingLeft=re.paddingLeft,Te.paddingRight=re.paddingRight,Te}Re.to=Fe})(_||(e.InlayHint=_={}));var ge;(function(Re){function Fe(Ie,re){const Te=new r.$9K(re.label);return Te.tooltip=R.$ck(re.tooltip)?F.to(re.tooltip):re.tooltip,g.Command.is(re.command)&&(Te.command=Ie.fromInternal(re.command)),re.location&&(Te.location=Ee.to(re.location)),Te}Re.to=Fe})(ge||(e.InlayHintLabelPart=ge={}));var ve;(function(Re){function Fe(re){return re}Re.from=Fe;function Ie(re){return re}Re.to=Ie})(ve||(e.InlayHintKind=ve={}));var ze;(function(Re){function Fe(re){return{range:c.from(re.range),url:re.target,tooltip:re.tooltip}}Re.from=Fe;function Ie(re){let Te;if(re.url)try{Te=typeof re.url=="string"?v.URI.parse(re.url,!0):v.URI.revive(re.url)}catch{}return new r.$dL(c.to(re.range),Te)}Re.to=Ie})(ze||(e.DocumentLink=ze={}));var We;(function(Re){function Fe(re){const Te=new r.$gL(re.label);return re.textEdit&&(Te.textEdit=J.to(re.textEdit)),re.additionalTextEdits&&(Te.additionalTextEdits=re.additionalTextEdits.map(Ve=>J.to(Ve))),Te}Re.to=Fe;function Ie(re){return{label:re.label,textEdit:re.textEdit?J.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Te=>J.from(Te)):void 0}}Re.from=Ie})(We||(e.ColorPresentation=We={}));var tt;(function(Re){function Fe(re){return new r.$eL(re[0],re[1],re[2],re[3])}Re.to=Fe;function Ie(re){return[re.red,re.green,re.blue,re.alpha]}Re.from=Ie})(tt||(e.Color=tt={}));var Ye;(function(Re){function Fe(re){return{range:c.from(re.range)}}Re.from=Fe;function Ie(re){return new r.$ZK(c.to(re.range))}Re.to=Ie})(Ye||(e.SelectionRange=Ye={}));var rt;(function(Re){function Fe(Ie){switch(Ie){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Re.to=Fe})(rt||(e.TextDocumentSaveReason=rt={}));var nt;(function(Re){function Fe(re){switch(re){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Fe;function Ie(re){switch(re){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Re.to=Ie})(nt||(e.TextEditorLineNumbersStyle=nt={}));var Ae;(function(Re){function Fe(re){if(re===r.EndOfLine.CRLF)return 1;if(re===r.EndOfLine.LF)return 0}Re.from=Fe;function Ie(re){if(re===1)return r.EndOfLine.CRLF;if(re===0)return r.EndOfLine.LF}Re.to=Ie})(Ae||(e.EndOfLine=Ae={}));var Oe;(function(Re){function Fe(Ie){if(typeof Ie=="object")return Ie.viewId;switch(Ie){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Fe})(Oe||(e.ProgressLocation=Oe={}));var qe;(function(Re){function Fe(re){const Te={start:re.start+1,end:re.end+1};return re.kind&&(Te.kind=Me.from(re.kind)),Te}Re.from=Fe;function Ie(re){const Te={start:re.start-1,end:re.end-1};return re.kind&&(Te.kind=Me.to(re.kind)),Te}Re.to=Ie})(qe||(e.FoldingRange=qe={}));var Me;(function(Re){function Fe(re){if(re)switch(re){case r.FoldingRangeKind.Comment:return g.$st.Comment;case r.FoldingRangeKind.Imports:return g.$st.Imports;case r.FoldingRangeKind.Region:return g.$st.Region}}Re.from=Fe;function Ie(re){if(re)switch(re.value){case g.$st.Comment.value:return r.FoldingRangeKind.Comment;case g.$st.Imports.value:return r.FoldingRangeKind.Imports;case g.$st.Region.value:return r.FoldingRangeKind.Region}}Re.to=Ie})(Me||(e.FoldingRangeKind=Me={}));var Xe;(function(Re){function Fe(Ie){if(Ie)return{pinned:typeof Ie.preview=="boolean"?!Ie.preview:void 0,inactive:Ie.background,preserveFocus:Ie.preserveFocus,selection:typeof Ie.selection=="object"?c.from(Ie.selection):void 0,override:typeof Ie.override=="boolean"?i.$fE.id:void 0}}Re.from=Fe})(Xe||(e.TextEditorOpenOptions=Xe={}));var le;(function(Re){function Fe(Ve){return Ve instanceof r.$AL?Ve.toJSON():typeof Ve=="string"?Ve:Ie(Ve)||re(Ve)?new r.$AL(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Re.from=Fe;function Ie(Ve){const _e=Ve;return _e?v.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function re(Ve){const _e=Ve;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Te(Ve){return typeof Ve=="string"?Ve:new r.$AL(v.URI.revive(Ve.baseUri),Ve.pattern)}Re.to=Te})(le||(e.GlobPattern=le={}));var ce;(function(Re){function Fe(Ie){if(Ie){if(Array.isArray(Ie))return Ie.map(Fe);if(typeof Ie=="string")return Ie;{const re=Ie;return{language:re.language,scheme:re.scheme,pattern:le.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Re.from=Fe})(ce||(e.LanguageSelector=ce={}));var Pe;(function(Re){function Fe(re){return!!re&&typeof re=="object"&&"documents"in re&&Array.isArray(re.documents)&&re.documents.every(Te=>Array.isArray(Te)&&Te.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&v.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(_e=>_e instanceof r.$GK)))}Re.is=Fe;function Ie(re){return{documents:re.documents.map(Te=>Te.map(Ve=>({uri:v.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(_e=>c.from(_e))})))}}Re.from=Ie})(Pe||(e.MappedEditsContext=Pe={}));var He;(function(Re){function Fe(re){return{start:re.start,end:re.end}}Re.from=Fe;function Ie(re){return new r.$2L(re.start,re.end)}Re.to=Ie})(He||(e.NotebookRange=He={}));var Ge;(function(Re){function Fe(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Re.to=Fe;function Ie(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Re.from=Ie})(Ge||(e.NotebookCellExecutionSummary=Ge={}));var xe;(function(Re){function Fe(Ie){if(Ie===n.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ie===n.NotebookCellExecutionState.Pending)return;if(Ie===n.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ie}`)}Re.to=Fe})(xe||(e.NotebookCellExecutionState=xe={}));var ot;(function(Re){function Fe(re){switch(re){case r.NotebookCellKind.Markup:return n.CellKind.Markup;case r.NotebookCellKind.Code:default:return n.CellKind.Code}}Re.from=Fe;function Ie(re){switch(re){case n.CellKind.Markup:return r.NotebookCellKind.Markup;case n.CellKind.Code:default:return r.NotebookCellKind.Code}}Re.to=Ie})(ot||(e.NotebookCellKind=ot={}));var lt;(function(Re){function Fe(re){const Te={metadata:re.metadata??Object.create(null),cells:[]};for(const Ve of re.cells)r.$3L.validate(Ve),Te.cells.push(Ne.from(Ve));return Te}Re.from=Fe;function Ie(re){const Te=new r.$4L(re.cells.map(Ne.to));return(0,$.$Pf)(re.metadata)||(Te.metadata=re.metadata),Te}Re.to=Ie})(lt||(e.NotebookData=lt={}));var Ne;(function(Re){function Fe(re){return{cellKind:ot.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Ge.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(Ht.from):[]}}Re.from=Fe;function Ie(re){return new r.$3L(ot.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(Ht.to):void 0,re.metadata,re.internalMetadata?Ge.to(re.internalMetadata):void 0)}Re.to=Ie})(Ne||(e.NotebookCellData=Ne={}));var St;(function(Re){function Fe(re){return{mime:re.mime,valueBytes:T.$fe.wrap(re.data)}}Re.from=Fe;function Ie(re){return new r.$5L(re.valueBytes.buffer,re.mime)}Re.to=Ie})(St||(e.NotebookCellOutputItem=St={}));var Ht;(function(Re){function Fe(re){return{outputId:re.id,items:re.items.map(St.from),metadata:re.metadata}}Re.from=Fe;function Ie(re){const Te=re.items.map(St.to);return new r.$6L(Te,re.outputId,re.metadata)}Re.to=Ie})(Ht||(e.NotebookCellOutput=Ht={}));var Kt;(function(Re){function Fe(Te){return re(Te)?{include:le.from(Te.include)??void 0,exclude:le.from(Te.exclude)??void 0}:le.from(Te)??void 0}Re.from=Fe;function Ie(Te){return re(Te)?{include:le.to(Te.include),exclude:le.to(Te.exclude)}:le.to(Te)}Re.to=Ie;function re(Te){const Ve=Te;return Ve?!(0,$.$Lf)(Ve.include)&&!(0,$.$Lf)(Ve.exclude):!1}})(Kt||(e.NotebookExclusiveDocumentPattern=Kt={}));var vt;(function(Re){function Fe(Ie,re,Te){const Ve=typeof Ie.command=="string"?{title:"",command:Ie.command}:Ie.command;return{alignment:Ie.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal(Ve,Te),text:Ie.text,tooltip:Ie.tooltip,accessibilityInformation:Ie.accessibilityInformation,priority:Ie.priority}}Re.from=Fe})(vt||(e.NotebookStatusBarItem=vt={}));var Ut;(function(Re){function Fe(Ie,re,Te){const Ve=typeof Ie.command=="string"?{title:"",command:Ie.command}:Ie.command;return{command:re.toInternal(Ve,Te),label:Ie.label,description:Ie.description,detail:Ie.detail,documentation:Ie.documentation}}Re.from=Fe})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Ot;(function(Re){function Fe(Ie){return{transientOutputs:Ie?.transientOutputs??!1,transientCellMetadata:Ie?.transientCellMetadata??{},transientDocumentMetadata:Ie?.transientDocumentMetadata??{},cellContentMetadata:Ie?.cellContentMetadata??{}}}Re.from=Fe})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Gt;(function(Re){function Fe(re){return{uri:re.uri,provides:re.provides}}Re.from=Fe;function Ie(re){return new r.$8L(v.URI.revive(re.uri),re.provides)}Re.to=Ie})(Gt||(e.NotebookRendererScript=Gt={}));var Bt;(function(Re){function Fe(re){return{message:F.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,contextValue:re.contextValue,location:re.location&&{range:c.from(re.location.range),uri:re.location.uri}}}Re.from=Fe;function Ie(re){const Te=new r.$bM(typeof re.message=="string"?re.message:F.to(re.message));return Te.actualOutput=re.actual,Te.expectedOutput=re.expected,Te.contextValue=re.contextValue,Te.location=re.location?Ee.to(re.location):void 0,Te}Re.to=Ie})(Bt||(e.TestMessage=Bt={}));var Dt;(function(Re){Re.namespace=a.$zJ,Re.denamespace=a.$AJ})(Dt||(e.TestTag=Dt={}));var Tt;(function(Re){function Fe(re){const Te=(0,o.$AM)(re).controllerId;return{extId:s.$vJ.fromExtHostTestItem(re,Te).toString(),label:re.label,uri:v.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(Ve=>Dt.namespace(Te,Ve.id)),range:S.$Ds.lift(c.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&F.fromStrict(re.error)||null}}Re.from=Fe;function Ie(re){return{parent:void 0,error:void 0,id:s.$vJ.fromString(re.extId).localId,label:re.label,uri:v.URI.revive(re.uri),tags:(re.tags||[]).map(Te=>{const{tagId:Ve}=Dt.denamespace(Te);return new r.$cM(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Re.toPlain=Ie})(Tt||(e.TestItem=Tt={})),function(Re){function Fe(re){return{id:re.id}}Re.from=Fe;function Ie(re){return new r.$cM(re.id)}Re.to=Ie}(Dt||(e.TestTag=Dt={}));var et;(function(Re){const Fe=(re,Te)=>{const Ve=[];for(const[Qe,st]of Te)s.$vJ.compare(st.item.extId,Qe)===2&&(Te.delete(Qe),Ve.push(st));const _e={...Tt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(st=>st.type===0).map(Bt.to)})),children:Ve.map(Qe=>Fe(Qe,Te))};for(const Qe of _e.children)Qe.parent=_e;return _e};function Ie(re){const Te=[],Ve=new Map;for(const _e of re.items){Ve.set(_e.item.extId,_e);const Qe=s.$vJ.root(_e.item.extId);re.request.targets.some(st=>st.controllerId===Qe&&st.testIds.includes(_e.item.extId))&&Te.push(_e)}return{completedAt:re.completedAt,results:Te.map(_e=>Fe(_e,Ve))}}Re.to=Ie})(et||(e.TestResults=et={}));var Jt;(function(Re){function Fe(Ve){return{covered:Ve.covered,total:Ve.covered}}function Ie(Ve){return"line"in Ve?E.from(Ve):c.from(Ve)}function re(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Ie(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Ie(_e.location)})):void 0}:{type:0,count:Ve.executionCount,location:Ie(Ve.location)}}Re.fromDetailed=re;function Te(Ve){return{uri:Ve.uri,statement:Fe(Ve.statementCoverage),branch:Ve.branchCoverage&&Fe(Ve.branchCoverage),function:Ve.functionCoverage&&Fe(Ve.functionCoverage),details:Ve.detailedCoverage?.map(re)}}Re.fromFile=Te})(Jt||(e.TestCoverage=Jt={}));var Wt;(function(Re){function Fe(Ie){switch(Ie){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Re.to=Fe})(Wt||(e.CodeActionTriggerKind=Wt={}));var ut;(function(Re){function Fe(re){const Te=new r.$iM(he.to(re.kind),re.name,re.detail||"",v.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Te._sessionId=re._sessionId,Te._itemId=re._itemId,Te}Re.to=Fe;function Ie(re,Te,Ve){if(Te=Te??re._sessionId,Ve=Ve??re._itemId,Te===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Ve,kind:he.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(Z.from)}}Re.from=Ie})(ut||(e.TypeHierarchyItem=ut={}));var gt;(function(Re){function Fe(Ie){if(Ie)return{value:Ie.value,tooltip:Ie.tooltip}}Re.from=Fe})(gt||(e.ViewBadge=gt={}));var qt;(function(Re){function Fe(Ve,_e,Qe){const st=_e.fileData;return st?new r.$tL(new r.$uL(st.name,v.URI.revive(st.uri),st.id,(0,A.$cb)(()=>Qe(st.id)))):Ve===L.$Zr.uriList&&_e.uriListData?new r.$sL(Te(_e.uriListData)):new r.$sL(_e.asString)}Re.to=Fe;async function Ie(Ve,_e){const Qe=await _e.asString();if(Ve===L.$Zr.uriList)return{asString:Qe,fileData:void 0,uriListData:re(Qe)};const st=_e.asFile();return{asString:Qe,fileData:st?{name:st.name,uri:st.uri,id:st._itemId??st.id}:void 0}}Re.from=Ie;function re(Ve){return m.$at.split(Ve).map(_e=>{if(_e.startsWith("#"))return _e;try{return v.URI.parse(_e)}catch{}return _e})}function Te(Ve){return m.$at.create(Ve.map(_e=>typeof _e=="string"?_e:v.URI.revive(_e)))}})(qt||(e.DataTransferItem=qt={}));var Rt;(function(Re){function Fe(re,Te){const Ve=re.items.map(([_e,Qe])=>[_e,qt.to(_e,Qe,Te)]);return new r.$vL(Ve)}Re.toDataTransfer=Fe;async function Ie(re){const Te={items:[]},Ve=[];for(const[_e,Qe]of re)Ve.push((async()=>{Te.items.push([_e,await qt.from(_e,Qe)])})());return await Promise.all(Ve),Te}Re.from=Ie})(Rt||(e.DataTransfer=Rt={}));var kt;(function(Re){function Fe(Ie){return{kind:"reply",message:Ie.message,title:Ie.title,tooltip:Ie.tooltip}}Re.from=Fe})(kt||(e.ChatReplyFollowup=kt={}));var mt;(function(Re){function Fe(Ie){return typeof Ie=="string"?{title:Ie,message:Ie,kind:"reply"}:"commandId"in Ie?{kind:"command",title:Ie.title??"",commandId:Ie.commandId??"",when:Ie.when??"",args:Ie.args}:kt.from(Ie)}Re.from=Fe})(mt||(e.ChatFollowup=mt={}));var Lt;(function(Re){function Fe(re){const Te=new r.$tM(At.to(re.role),re.content);return Te.name=re.name,Te}Re.to=Fe;function Ie(re){return{role:At.from(re.role),content:re.content,name:re.name}}Re.from=Ie})(Lt||(e.ChatMessage=Lt={}));var At;(function(Re){function Fe(re){switch(re){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Re.to=Fe;function Ie(re){switch(re){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Re.from=Ie})(At||(e.ChatMessageRole=At={}));var Ct;(function(Re){function Fe(Te){const Ve={};for(const _e of Object.keys(Te))Ve[_e]=Te[_e].map(Re.to);return Ve}Re.objectTo=Fe;function Ie(Te){return{level:Je.to(Te.level),value:Te.value,description:Te.description}}Re.to=Ie;function re(Te){return{level:Je.from(Te.level),value:Te.value,description:Te.description}}Re.from=re})(Ct||(e.ChatVariable=Ct={}));var Je;(function(Re){function Fe(re){switch(re){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Re.to=Fe;function Ie(re){switch(re){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Re.from=Ie})(Je||(e.ChatVariableLevel=Je={}));var Nt;(function(Re){function Fe(Ie){switch(Ie){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Re.to=Fe})(Nt||(e.InteractiveEditorResponseFeedbackKind=Nt={}));var jt;(function(Re){function Fe(Ie,re){return"placeholder"in re&&"resolvedContent"in re?{content:re.placeholder,kind:"asyncContent"}:"markdownContent"in re?((0,h.$QF)(Ie,"chatAgents2Additions"),{content:F.from(re.markdownContent),kind:"markdownContent"}):"content"in re?"vulnerabilities"in re&&re.vulnerabilities?((0,h.$QF)(Ie,"chatAgents2Additions"),{content:re.content,vulnerabilities:re.vulnerabilities,kind:"vulnerability"}):typeof re.content=="string"?{content:re.content,kind:"content"}:((0,h.$QF)(Ie,"chatAgents2Additions"),{content:F.from(re.content),kind:"markdownContent"}):"documents"in re?{documents:re.documents.map(Te=>({uri:Te.uri,version:Te.version,ranges:Te.ranges.map(Ve=>c.from(Ve))})),kind:"usedContext"}:"reference"in re?{reference:"uri"in re.reference?{uri:re.reference.uri,range:c.from(re.reference.range)}:re.reference,kind:"reference"}:"inlineReference"in re?{inlineReference:"uri"in re.inlineReference?{uri:re.inlineReference.uri,range:c.from(re.inlineReference.range)}:re.inlineReference,name:re.title,kind:"inlineReference"}:"agentName"in re?((0,h.$QF)(Ie,"chatAgents2Additions"),{agentName:re.agentName,command:re.command,kind:"agentDetection"}):"treeData"in re?{treeData:re.treeData,kind:"treeData"}:"message"in re?{content:re.message,kind:"progressMessage"}:void 0}Re.from=Fe})(jt||(e.ChatResponseProgress=jt={}));var Qt;(function(Re){function Fe(Ie,re,Te){return"terminalCommand"in Ie?{terminalCommand:Ie.terminalCommand,shouldExecute:Ie.shouldExecute}:"uri"in Ie?{uri:Ie.uri}:re.toInternal(Ie,Te)}Re.from=Fe})(Qt||(e.TerminalQuickFix=Qt={}))}),define(ke[293],Se([1,0,2,8,7,15,75]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;class w{constructor(y,L,P,$={timeout:1500,errors:3}){this.c=y,this.d=L,this.f=P,this.g=$,this.a=new R.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(L,P,$)=>{const S={dispose:this.a.push([L,P,y])};return Array.isArray($)&&$.push(S),S}}async $participateInSave(y,L){const P=D.URI.revive(y);let $=!1;const v=setTimeout(()=>$=!0,this.g.timeout),S=[];try{for(const g of[...this.a]){if($)break;const d=this.d.getDocument(P),o=await this.h(g,{document:d,reason:A.TextDocumentSaveReason.to(L)});S.push(o)}}finally{clearTimeout(v)}return S}h([y,L,P],$){const v=this.b.get(y);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(P,y,L,$).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const g=this.b.get(y);this.b.set(y,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,L,P,$){const v=[],S=Date.now(),{document:g,reason:d}=$,{version:o}=g,i=Object.freeze({document:g,reason:d,waitUntil(n){if(Object.isFrozen(v))throw(0,T.$7)("waitUntil can not be called async");v.push(Promise.resolve(n))}});try{L.apply(P,[i])}catch(n){return Promise.reject(n)}return Object.freeze(v),new Promise((n,s)=>{const a=setTimeout(()=>s(new Error("timeout")),this.g.timeout);return Promise.all(v).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),s(t)})}).then(n=>{const s={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof m.$LK))for(const{newText:t,newEol:r,range:h}of a)s.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:h&&A.Range.from(h),text:t,eol:r&&A.EndOfLine.from(r)}});if(s.edits.length!==0)return o===g.version?this.f.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.$yfc=w}),define(ke[294],Se([1,0,17,2,15,7,111]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=void 0;class w{constructor(P,$,v,S){this.start=P,this.deletedCount=$,this.deletedItems=v,this.items=S}asApiEvent(){return{range:new A.$2L(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class b{static asModelAddData(P,$){return{EOL:$.eol,lines:$.source,languageId:$.language,uri:$.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,$,v){this.notebook=P,this.h=$,this.j=v,this.handle=v.handle,this.uri=T.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(m.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(m.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:m.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return P.g},set mime(S){P.g=S},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(v)}return this.f}setOutputs(P){this.a=P.map(m.NotebookCellOutput.to)}setOutputItems(P,$,v){const S=v.map(m.NotebookCellOutputItem.to),g=this.a.find(d=>d.id===P);if(g&&($||(g.items.length=0),g.items.push(...S),g.items.length>1&&g.items.every(d=>R.$HI(d.mime)))){const d=new Map,o=[];g.items.forEach(i=>{let n;d.has(i.mime)?n=d.get(i.mime):(n=[],d.set(i.mime,n),o.push(i.mime)),n.push(i.data)}),g.items.length=0,o.forEach(i=>{const n=R.$II(d.get(i));g.items.push({mime:i,data:n.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(m.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$Dfc=b;class y{static{this.a=0}constructor(P,$,v,S,g){this.k=P,this.l=$,this.m=v,this.uri=S,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=g.viewType,this.f=Object.freeze(g.metadata??Object.create(null)),this.r([[0,0,g.cells]],!0,void 0),this.g=g.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,$={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===D.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(v){return v=P.n(v),P.b[v].apiCell},getCells(v){return(v?P.p(v):P.b).map(g=>g.apiCell)},save(){return P.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,$,v){this.g=P.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:v});const S={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},g=[];for(const o of P.rawEvents)o.kind===R.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,S.contentChanges):o.kind===R.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,S.contentChanges):o.kind===R.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),g.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),g.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),g.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===R.NotebookCellsChangeType.ChangeCellContent?g.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),g.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),g.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const d=new Map;for(let o=0;o<g.length;o++){const i=g[o],n=d.get(i.cell);if(n===void 0){const s=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});d.set(i.cell,s-1)}else S.cellChanges[n]={...S.cellChanges[n],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let $=P.start|0,v=P.end|0;return $<0&&($=0),v>this.b.length&&(v=this.b.length),P.with({start:$,end:v})}p(P){P=this.o(P);const $=[];for(let v=P.start;v<P.end;v++)$.push(this.b[v]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,$,v){if(this.j)return;const S=[],g=[],d=[];if(P.reverse().forEach(o=>{const n=o[2].map(t=>{const r=new b(this,this.l,t);return $||g.push(b.asModelAddData(this.apiNotebook,t)),r}),s=new w(o[0],o[1],[],n),a=this.b.splice(o[0],o[1],...n);for(const t of a)d.push(t.uri),s.deletedItems.push(t.apiCell);S.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:d}),v)for(const o of S)v.push(o.asApiEvent())}s(P,$,v,S){const g=this.b.splice(P,$);this.b.splice(v,0,...g);const d=[new w(P,$,g.map(o=>o.apiCell),[]),new w(v,0,[],g)];for(const o of d)S.push(o.asApiEvent())}t(P,$){this.b[P].setOutputs($)}u(P,$,v,S){this.b[P].setOutputItems($,v,S)}v(P,$){const v=this.b[P];v.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(v.uri,$)}w(P,$){const v=this.b[P];v.apiCell.mime=$}x(P,$){this.b[P].setMetadata($)}y(P,$){this.b[P].setInternalMetadata($)}getCellFromApiCell(P){return this.b.find($=>$.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find($=>$.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$Efc=y}),define(ke[295],Se([1,0,4,2,15,7]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=void 0;class R{constructor(b,y,L,P={timeout:1500,errors:3}){this.b=b,this.c=y,this.d=L,this.f=P,this.a=new D.$Td}dispose(){}getOnWillSaveNotebookDocumentEvent(b){return(y,L,P)=>{const $=function(S){y.call(L,S)};return $.extension=b,this.a.event($,void 0,P)}}async $participateInSave(b,y,L){const P=T.URI.revive(b),$=this.c.getNotebookDocument(P);if(!$)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:$.apiNotebook,reason:m.TextDocumentSaveReason.to(y)},L,async(g,d)=>{const o=Date.now(),i=await await Promise.resolve(g);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier),!L.isCancellationRequested&&i&&(i instanceof A.$OK?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if(v.length===0)return!0;const S={edits:[]};for(const g of v){const{edits:d}=m.WorkspaceEdit.from(g);S.edits=S.edits.concat(d)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$Ufc=R}),define(ke[147],Se([1,0,8,15,7]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(w,b,y,L,P,$){this.id=w,this.f=b,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=L,this.c=$}get apiEditor(){if(!this.e){const w=this;this.e={get notebook(){return w.notebookData.apiNotebook},get selection(){return w.a[0]},set selection(b){this.selections=[b]},get selections(){return w.a},set selections(b){if(!Array.isArray(b)||!b.every(m.$2L.isNotebookRange))throw(0,D.$6)("selections");w.a=b,w.g(b)},get visibleRanges(){return w.b},revealRange(b,y){w.f.$tryRevealRange(w.id,T.NotebookRange.from(b),y??m.NotebookEditorRevealType.Default)},get viewColumn(){return w.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(w){this.d=w}_acceptVisibleRanges(w){this.b=w}_acceptSelections(w){this.a=w}g(w){this.f.$trySetSelections(this.id,w.map(T.NotebookRange.from))}_acceptViewColumn(w){this.c=w}}e.$Ffc=A}),define(ke[296],Se([1,0,8,4,14,15]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=void 0;let R=class{constructor(b,y){this.c=b,this.d=y,this.a=new T.$Rd({onListenerError:D.$1}),this.b=new T.$Rd({onListenerError:D.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,y);const L=this.d.getEditorById(b);y.visibleRanges&&L._acceptVisibleRanges(y.visibleRanges.ranges.map(A.NotebookRange.to)),y.selections&&L._acceptSelections(y.selections.selections.map(A.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:L.apiEditor,visibleRanges:L.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:L.apiEditor,selections:L.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const y in b)this.d.getEditorById(y)._acceptViewColumn(A.ViewColumn.to(b[y]))}};e.$Wfc=R,e.$Wfc=R=Ke([Be(0,m.$hj)],R)}),define(ke[297],Se([1,0,15,85,215,21,59,8]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;class b{constructor($){this.b=0,this.c=new Map,this.a=$}async withProgress($,v,S){const g=this.b++,{title:d,location:o,cancellable:i}=v,n={label:(0,m.localize)(0,null,$.displayName||$.name),id:$.identifier.value};return this.a.$startProgress(g,{location:D.ProgressLocation.from(o),title:d,source:n,cancellable:i},$.isUnderDevelopment?void 0:$.identifier.value).catch(w.$1),this.d(g,S,!!i)}d($,v,S){let g;S&&(g=new A.$2d,this.c.set($,g));const d=i=>{this.a.$progressEnd(i),this.c.delete(i),g?.dispose()};let o;try{o=v(new L(this.a,$),S&&g?g.token:A.CancellationToken.None)}catch(i){throw d($),i}return o.then(i=>d($),i=>d($)),o}$acceptProgressCanceled($){const v=this.c.get($);v&&(v.cancel(),this.c.delete($))}}e.$4fc=b;function y(P,$){return P.message=$.message,typeof $.increment=="number"&&(typeof P.increment=="number"?P.increment+=$.increment:P.increment=$.increment),P}class L extends T.$cv{constructor($,v){super(S=>this.throttledReport(S)),this.c=$,this.d=v}throttledReport($){this.c.$progressReport(this.d,$)}}Ke([(0,R.$th)(100,(P,$)=>y(P,$),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ke[148],Se([1,0,29,143,67,112,89,15,2]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=e.$SM=e.$RM=e.$QM=void 0;const y=(n,s,a,t)=>{let r=s;return{enumerable:!0,configurable:!1,get(){return r},set(h){if(!a(r,h)){const u=r;r=h,n.listener?.(t(h,u))}}}},L=(n,s)=>n===s,P={range:(n,s)=>n===s?!0:!n||!s?!1:n.isEqual(s),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(n,s)=>!(n.length!==s.length||n.some(a=>!s.find(t=>a.id===t.id)))},$=n=>s=>({op:4,update:n(s)}),v=(n,s)=>({range:(()=>{let a;const t=$(r=>({range:D.$Ds.lift(w.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return a},set(r){n.listener?.({op:6}),P.range(a,r)||(a=r,n.listener?.(t(r)))}}})(),label:y(n,s,P.label,$(a=>({label:a}))),description:y(n,void 0,P.description,$(a=>({description:a}))),sortText:y(n,void 0,P.sortText,$(a=>({sortText:a}))),canResolveChildren:y(n,!1,P.canResolveChildren,a=>({op:2,state:a})),busy:y(n,!1,P.busy,$(a=>({busy:a}))),error:y(n,void 0,P.error,$(a=>({error:w.MarkdownString.fromStrict(a)||null}))),tags:y(n,[],P.tags,(a,t)=>({op:1,new:a.map(w.TestTag.from),old:t.map(w.TestTag.from)}))}),S=n=>{const s=m.$vJ.fromString(n.extId),a=new d(s.controllerId,s.localId,n.label,b.URI.revive(n.uri)||void 0);return a.range=w.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>w.TestTag.to({id:(0,R.$AJ)(t).tagId})),a},g=n=>{let s;for(const a of n.tests){const t=S(a.item);(0,T.$AM)(t).parent=s,s=t}return s};e.$QM=g;class d{constructor(s,a,t,r){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const h=(0,T.$zM)(this,s);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof o?void 0:h.parent}},children:{value:(0,A.$yM)(h,T.$AM,d),enumerable:!0,writable:!1},...v(h,t)})}}e.$RM=d;class o extends d{constructor(s,a){super(s,s,a,void 0),this._isRoot=!0}}e.$SM=o;class i extends A.$uM{constructor(s,a,t){super({controllerId:s,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:T.$AM,getChildren:r=>r.children,root:new o(s,a),toITestItem:w.TestItem.from})}}e.$TM=i}),define(ke[149],Se([1,0,60,8,122,15,7]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=e.$LM=void 0;class w{static{this.c=new m.$JM("TextEditorDecorationType")}constructor($,v,S){const g=w.c.nextId();$.$registerTextEditorDecorationType(v.identifier,g,A.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:g,dispose(){$.$removeTextEditorDecorationType(g)}})}}e.$LM=w;class b{constructor($,v){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,v){this.k();let S=null;if($ instanceof R.$FK)S=new R.$GK($,$);else if($ instanceof R.$GK)S=$;else throw new Error("Unrecognized location");this.l(S,v,!1)}insert($,v){this.k(),this.l(new R.$GK($,$),v,!0)}delete($){this.k();let v=null;if($ instanceof R.$GK)v=$;else throw new Error("Unrecognized location");this.l(v,null,!0)}l($,v,S){const g=this.c.validateRange($);this.g.push({range:g,text:v,forceMoveMarkers:S})}setEndOfLine($){if(this.k(),$!==R.EndOfLine.LF&&$!==R.EndOfLine.CRLF)throw(0,T.$6)("endOfLine");this.h=$}}class y{constructor($,v,S,g){this.c=$,this.d=v,this._accept(S),this.e=g;const d=this;this.value={get tabSize(){return d.f},set tabSize(o){d.m(o)},get indentSize(){return d.g},set indentSize(o){d.o(o)},get insertSpaces(){return d.h},set insertSpaces(o){d.q(o)},get cursorStyle(){return d.j},set cursorStyle(o){d.s(o)},get lineNumbers(){return d.k},set lineNumbers(o){d.t(o)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.insertSpaces,this.j=$.cursorStyle,this.k=A.TextEditorLineNumbersStyle.to($.lineNumbers)}l($){if($==="auto")return"auto";if(typeof $=="number"){const v=Math.floor($);return v>0?v:null}if(typeof $=="string"){const v=parseInt($,10);return isNaN(v)?null:v>0?v:null}return null}m($){const v=this.l($);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const v=Math.floor($);return v>0?v:null}if(typeof $=="string"){const v=parseInt($,10);return isNaN(v)?null:v>0?v:null}return null}o($){const v=this.n($);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p($){return $==="auto"?"auto":$==="false"?!1:!!$}q($){const v=this.p($);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s($){this.j!==$&&(this.j=$,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}t($){this.k!==$&&(this.k=$,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from($)})))}assign($){const v={};let S=!1;if(typeof $.tabSize<"u"){const g=this.l($.tabSize);g==="auto"?(S=!0,v.tabSize=g):typeof g=="number"&&this.f!==g&&(this.f=g,S=!0,v.tabSize=g)}if(typeof $.indentSize<"u"){const g=this.n($.indentSize);g==="tabSize"?(S=!0,v.indentSize=g):typeof g=="number"&&this.g!==g&&(this.g=g,S=!0,v.indentSize=g)}if(typeof $.insertSpaces<"u"){const g=this.p($.insertSpaces);g==="auto"?(S=!0,v.insertSpaces=g):this.h!==g&&(this.h=g,S=!0,v.insertSpaces=g)}typeof $.cursorStyle<"u"&&this.j!==$.cursorStyle&&(this.j=$.cursorStyle,S=!0,v.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.k!==$.lineNumbers&&(this.k=$.lineNumbers,S=!0,v.lineNumbers=A.TextEditorLineNumbersStyle.from($.lineNumbers)),S&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u($,v){v.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(S)})}}e.$MM=y;class L{constructor($,v,S,g,d,o,i,n){this.id=$,this.j=v,this.k=S,this.g=!1,this.h=new Set,this.c=d,this.d=new y(this.j,this.id,o,S),this.e=i,this.f=n;const s=this;this.value=Object.freeze({get document(){return g.value},set document(a){throw new T.$8("document")},get selection(){return s.c&&s.c[0]},set selection(a){if(!(a instanceof R.$HK))throw(0,T.$6)("selection");s.c=[a],s.l()},get selections(){return s.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof R.$HK)))throw(0,T.$6)("selections");s.c=a,s.l()},get visibleRanges(){return s.e},set visibleRanges(a){throw new T.$8("visibleRanges")},get options(){return s.d.value},set options(a){s.g||s.d.assign(a)},get viewColumn(){return s.f},set viewColumn(a){throw new T.$8("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new b(g.value,t);return a(r),s.m(r)},insertSnippet(a,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let h;if(!t||Array.isArray(t)&&t.length===0)h=s.c.map(u=>A.Range.from(u));else if(t instanceof R.$FK){const{lineNumber:u,column:c}=A.Position.from(t);h=[{startLineNumber:u,startColumn:c,endLineNumber:u,endColumn:c}]}else if(t instanceof R.$GK)h=[A.Range.from(t)];else{h=[];for(const u of t)if(u instanceof R.$GK)h.push(A.Range.from(u));else{const{lineNumber:c,column:l}=A.Position.from(u);h.push({startLineNumber:c,startColumn:l,endLineNumber:c,endColumn:l})}}return v.$tryInsertSnippet($,g.value.version,a.value,h,r)},setDecorations(a,t){const r=t.length===0;r&&!s.h.has(a.key)||(r?s.h.delete(a.key):s.h.add(a.key),s.n(()=>{if(A.$BM(t))return v.$trySetDecorations($,a.key,A.$CM(t));{const h=new Array(4*t.length);for(let u=0,c=t.length;u<c;u++){const l=t[u];h[4*u]=l.start.line+1,h[4*u+1]=l.start.character+1,h[4*u+2]=l.end.line+1,h[4*u+3]=l.end.character+1}return v.$trySetDecorationsFast($,a.key,h)}}))},revealRange(a,t){s.n(()=>v.$tryRevealRange($,A.Range.from(a),t||R.TextEditorRevealType.Default))},show(a){v.$tryShowEditor($,A.ViewColumn.from(a))},hide(){v.$tryHideEditor($)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions($){(0,D.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,D.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,D.ok)(!this.g),this.f=$}_acceptSelections($){(0,D.ok)(!this.g),this.c=$}async l(){const $=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const v=$.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const S=v.edits.map(d=>d.range);S.sort((d,o)=>d.end.line===o.end.line?d.end.character===o.end.character?d.start.line===o.start.line?d.start.character-o.start.character:d.start.line-o.start.line:d.end.character-o.end.character:d.end.line-o.end.line);for(let d=0,o=S.length-1;d<o;d++){const i=S[d].end;if(S[d+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=v.edits.map(d=>({range:A.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,g,{setEndOfLine:typeof v.setEndOfLine=="number"?A.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$NM=L}),define(ke[298],Se([1,0,219,23,2,4,3,278,12,7,18,19,15,80,21,176,25]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;function o(s,a){if((0,L.$Cf)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let t;return Array.isArray(s.highlights)&&(t=s.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:s.label,highlights:t}}}class i extends R.$Rc{constructor(a,t,r){super(),this.f=a,this.g=t,this.h=r,this.a=new Map,this.b=new g.$Y7;function h(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>h(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(c=>h(c)?this.r(c):c):u})}registerTreeDataProvider(a,t,r){const h=this.createTreeView(a,{treeDataProvider:t},r);return{dispose:()=>h.dispose()}}createTreeView(a,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,l=!!t.dragAndDropController?.handleDrop,E=this.m(a,t,r),C={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:h,dragMimeTypes:u,hasHandleDrag:c,hasHandleDrop:l,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},f=this.f.$registerTreeViewDataProvider(a,C),p={get onDidCollapseElement(){return E.onDidCollapseElement},get onDidExpandElement(){return E.onDidExpandElement},get selection(){return E.selectedElements},get onDidChangeSelection(){return E.onDidChangeSelection},get activeItem(){return(0,d.$QF)(r,"treeViewActiveItem"),E.focusedElement},get onDidChangeActiveItem(){return(0,d.$QF)(r,"treeViewActiveItem"),E.onDidChangeActiveItem},get visible(){return E.visible},get onDidChangeVisibility(){return E.onDidChangeVisibility},get onDidChangeCheckboxState(){return E.onDidChangeCheckboxState},get message(){return E.message},set message(k){(0,v.$ck)(k)&&(0,d.$QF)(r,"treeViewMarkdownMessage"),E.message=k},get title(){return E.title},set title(k){E.title=k},get description(){return E.description},set description(k){E.description=k},get badge(){return E.badge},set badge(k){k!==void 0&&y.ViewBadge.isViewBadge(k)?E.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(E.badge=void 0)},reveal:(k,I)=>E.reveal(k,I),dispose:async()=>{await f,this.a.delete(a),E.dispose()}};return this.B(p),p}$getChildren(a,t){const r=this.a.get(a);return r?r.getChildren(t):Promise.reject(new w.$OE(a))}async $handleDrop(a,t,r,h,u,c,l,E){const C=this.a.get(a);if(!C)return Promise.reject(new w.$OE(a));const f=$.DataTransfer.toDataTransfer(r,async p=>(await this.f.$resolveDropFileData(a,t,p)).buffer);return l===a&&E&&await this.j(f,C,E,u,c),C.onDrop(f,h,u)}async j(a,t,r,h,u){const c=this.b.removeDragOperationTransfer(u);if(c)(await c)?.forEach((l,E)=>{l&&a.set(E,l)});else if(u&&t.handleDrag){const l=t.handleDrag(r,a,h);this.b.addDragOperationTransfer(u,l),await l}return a}async $handleDrag(a,t,r,h){const u=this.a.get(a);if(!u)return Promise.reject(new w.$OE(a));const c=await this.j(new y.$vL,u,t,h,r);if(!(!c||h.isCancellationRequested))return $.DataTransfer.from(c)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new w.$OE(a);return t.hasResolve}$resolve(a,t,r){const h=this.a.get(a);if(!h)throw new w.$OE(a);return h.resolveTreeItem(t,r)}$setExpanded(a,t,r){const h=this.a.get(a);if(!h)throw new w.$OE(a);h.setExpanded(t,r)}$setSelectionAndFocus(a,t,r){const h=this.a.get(a);if(!h)throw new w.$OE(a);h.setSelectionAndFocus(t,r)}$setVisible(a,t){const r=this.a.get(a);if(!r){if(!t)return;throw new w.$OE(a)}r.setVisible(t)}$changeCheckboxState(a,t){const r=this.a.get(a);if(!r)throw new w.$OE(a);r.setCheckboxState(t)}m(a,t,r){const h=this.B(new n(a,t,this.f,this.g.converter,this.h,r));return this.a.set(a,h),h}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$kgc=i;class n extends R.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,L.$Lf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,r,h,u,c){if(super(),this.I=a,this.J=r,this.L=h,this.M=u,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$Rd),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$Rd),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$Rd),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$Rd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$Rd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$Rd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$Rd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$2d,c.contributes&&c.contributes.views)for(const f in c.contributes.views)for(const p of c.contributes.views[f])p.id===a&&(this.P=p.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(f=>this.F.fire({message:!1,element:f})));let l,E;const C=A.Event.debounce(this.F.event,(f,p)=>(f||(f={message:!1,elements:[]}),p.element!==!1&&(l||(l=new Promise(k=>E=k),this.G=this.G.then(()=>l)),Array.isArray(p.element)?f.elements.push(...p.element):f.elements.push(p.element)),p.message&&(f.message=!0),f),200,!0);this.B(C(({message:f,elements:p})=>{p.length&&(this.H=this.H.then(()=>{const k=E;return l=null,this.$(p).then(()=>k())})),f&&this.J.$setMessage(this.I,$.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let r=this.X(a);return r||(r=await this.Y(t)),r?r.map(h=>h.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const r=(0,L.$Lf)(t.select)?!0:t.select,h=(0,L.$Lf)(t.focus)?!1:t.focus,u=(0,L.$Lf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(c=>this.W(a,c[c.length-1]).then(l=>this.J.$reveal(this.I,{item:l.item,parentChain:c.map(E=>E.item)},{select:r,focus:h,expand:u})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:r,focus:h,expand:u})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=$.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const r=this.getExtensionElement(a);r&&(t?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(a,t){const r=!(0,P.$tb)(this.s,a);this.s=a;const h=this.t!==t;this.t=t,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),h&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async r=>{const h=this.getExtensionElement(r.treeItemHandle);return h?{extensionItem:h,treeItem:await this.f.getTreeItem(h),newState:r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(a,t,r){const h=[];for(const u of a){const c=this.getExtensionElement(u);c&&h.push(c)}if(!(!this.g?.handleDrag||h.length===0))return await this.g.handleDrag(h,t,r),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,r){const h=t?this.getExtensionElement(t):void 0;if(!(!h&&t||!this.g?.handleDrop))return(0,b.$Sg)(()=>this.g?.handleDrop?this.g.handleDrop(h,a,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const r=this.j.get(a);if(r){const h=this.m.get(r);if(h){const u=await this.f.resolveTreeItem(h.extensionItem,r,t)??h.extensionItem;return this.hb(u),h.item.tooltip=this.eb(u.tooltip),h.item.command=this.fb(h.disposableStore,u.command),h.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(r=>this.W(t,r[r.length-1]).then(h=>(r.push(h),r))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,b.$Sg)(()=>this.f.getParent(a))}W(a,t){const r=this.m.get(a);return r?Promise.resolve(r):(0,b.$Sg)(()=>this.f.getTreeItem(a)).then(h=>this.kb(a,h,t,!0)).then(h=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(h);if(u){const c=this.m.get(u);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${h} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const r=this.getExtensionElement(a);t=r?this.m.get(r):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new S.$2d(this.Z.token);try{const r=a?this.m.get(a):void 0,h=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const u=await Promise.all((0,P.$Gb)(h||[]).map(async c=>{const l=await this.f.getTreeItem(c);return l&&!t.token.isCancellationRequested?this.db(c,l,r):null}));return t.token.isCancellationRequested?void 0:(0,P.$Gb)(u)}finally{t.dispose()}}$(a){if(a.some(r=>!r))return this.Z.dispose(!0),this.Z=new S.$2d,this.tb(),this.J.$refresh(this.I);{const r=this.ab(a);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(a){const t=new Set,r=a.map(u=>this.m.get(u));for(const u of r)if(u&&!t.has(u.item.handle)){let c=u;for(;c&&c.parent&&r.findIndex(l=>c&&c.parent&&l&&l.item.handle===c.parent.item.handle)===-1;){const l=this.j.get(c.parent.item.handle);c=l?this.m.get(l):void 0}c&&!c.parent&&t.add(u.item.handle)}const h=[];return t.forEach(u=>{const c=this.j.get(u);if(c){const l=this.m.get(c);l&&(!l.parent||!t.has(l.parent.item.handle))&&h.push(u)}}),h}bb(a){const t={};return Promise.all(a.map(r=>this.cb(r).then(h=>{h&&(t[r]=h.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const r=this.m.get(t);if(r)return this.rb(t),(0,b.$Sg)(()=>this.f.getTreeItem(t)).then(h=>{if(h){const u=this.ib(t,h,r.parent);return this.pb(t,u,r,r.parent),r.dispose(),u}return null})}return Promise.resolve(null)}db(a,t,r){const h=this.ib(a,t,r);if(t.id&&this.j.has(h.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(a,h),this.qb(h,r),h}eb(a){return y.$5K.isMarkdownString(a)?$.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,r,h;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,r=a.checkboxState.tooltip,h=a.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:h}}hb(a){if(!y.$qL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,r){this.hb(t);const h=this.B(new R.$Qc),u=this.kb(a,t,r),c=this.lb(t);return{item:{handle:u,parentHandle:r?r.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(h,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,L.$Lf)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:r,children:void 0,disposableStore:h,dispose(){h.dispose()}}}jb(a){return a.iconPath instanceof y.$yL?a.iconPath:void 0}kb(a,{id:t,label:r,resourceUri:h},u,c){if(t)return`${n.b}/${t}`;const l=o(r,this.N),E=u?u.item.handle:n.a;let C=l?l.label:h?(0,T.$yg)(h):"";C=C.indexOf("/")!==-1?C.replace("/","//"):C;const f=this.m.has(a)?this.m.get(a).item.handle:void 0,p=this.X(u)||[];let k,I=0;do{if(k=`${E}/${I}:${C}`,c||!this.j.has(k)||f===k)break;I++}while(I<=p.length);return k}lb(a){if(a.iconPath&&!(a.iconPath instanceof y.$yL))return typeof a.iconPath=="string"||m.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof y.$yL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return m.URI.isUri(a)?a:m.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,r,h){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(a,t);const u=this.X(h)||[],c=u.filter(l=>l.item.handle===r.item.handle)[0];c&&u.splice(u.indexOf(c),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const h=this.j.get(r.item.handle);h&&this.sb(h)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const h=this.j.get(r.item.handle);h&&this.sb(h)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[299],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[300],Se([1,0,233,8,39,135,108,37,26,299,137,138]),function(be,e,D,T,m,A,R,w,b,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=void 0;const $=w.$qn.as(R.$rn.JSONContribution);class v{constructor(a,t,r){this.a=a,this.b=t,this.c=r}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(m.default.Error,a)}warn(a){this.d(m.default.Warning,a)}info(a){this.d(m.default.Info,a)}}e.$WF=v;class S{static a(a){const t=new b.$em;for(let r=0,h=a.length;r<h;r++)t.add(a[r].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new S(t,[]);if(!t||!t.length)return new S([],a);const r=this.a(a),h=this.a(t),u=t.filter(l=>!r.has(l.description.identifier)),c=a.filter(l=>!h.has(l.description.identifier));return new S(u,c)}constructor(a,t){this.added=a,this.removed=t}}e.$XF=S;class g{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=S.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,T.$Z)(a)}}}e.$YF=g;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$ZF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.$cm},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$8n}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$8n}},extensionKind:{description:D.localize(52,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new g(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&P.$BF.register(a.extensionPoint,a.activationEventsGenerator),e.$ZF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,$.registerSchema(o,e.$ZF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$1F=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};w.$qn.add(n.ExtensionsRegistry,new i),e.$2F=w.$qn.as(n.ExtensionsRegistry),$.registerSchema(o,e.$ZF),$.registerSchema(L.$Aj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(ke[301],Se([1,0,229,18,24,300,46,4]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$F=void 0;const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var y;(function($){function v(S,g,d){if(!S)return;const o=T.$Cf(S.type)?S.type:void 0;if(!o||o.length===0){d.error(D.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const n of S.required)T.$Cf(n)&&i.push(n);return{extensionId:g.value,taskType:o,required:i,properties:S.properties?m.$en(S.properties):{},when:S.when?R.$Xi.deserialize(S.when):void 0}}$.from=v})(y||(y={}));const L=A.$2F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,v)=>{for(const S of $)S.type&&v.push(`onTaskType:${S.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:b}});class P{constructor(){this.d=new w.$Rd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,S)=>{L.setHandler((g,d)=>{this.c=void 0;try{for(const o of d.removed){const i=o.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const o of d.added){const i=o.value;for(const n of i){const s=y.from(n,o.description.identifier,o.collector);s&&(this.a[s.taskType]=s)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const S of this.all()){const g={type:"object",additionalProperties:!1};S.required.length>0&&(g.required=S.required.slice(0)),S.properties!==void 0?g.properties=m.$en(S.properties):g.properties=Object.create(null),g.properties.type={type:"string",enum:[S.taskType]},v.push(g)}this.c={oneOf:v}}return this.c}}e.$$F=new P}),define(ke[302],Se([1,0,230,18,23,24,46,301]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$iG=e.JsonSchemaVersion=e.ExecutionEngine=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$cG=e.ShellQuoting=e.$bG=e.$aG=e.$_F=void 0,e.$_F="settings",e.$aG=new R.$ej("taskRunning",!1,D.localize(0,null)),e.$bG={value:D.localize(1,null),original:"Tasks"};var b;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(b||(e.ShellQuoting=b={})),e.$cG="$customized",function(N){function O(W){if(!W)return N.Strong;switch(W.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=O}(b||(e.ShellQuoting=b={}));var y;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var L;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(L||(e.RevealKind=L={})),function(N){function O(W){switch(W.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=O}(L||(e.RevealKind=L={}));var P;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(N){function O(W){switch(W.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=O}(P||(e.RevealProblemKind=P={}));var $;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})($||(e.PanelKind=$={})),function(N){function O(W){switch(W.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=O}($||(e.PanelKind=$={}));var v;(function(N){N.defaults={echo:!0,reveal:L.Always,revealProblems:P.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var S;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(N){function O(x){switch(x.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=O;function W(x){switch(x){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=W}(S||(e.RuntimeType=S={}));var g;(function(N){function O(W){return T.$Cf(W)?W:W.value}N.value=O})(g||(e.CommandString=g={}));var d;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function O(x){return x===N.Clean._id||x===N.Build._id||x===N.Rebuild._id||x===N.Test._id}N.is=O;function W(x){if(x!==void 0)return T.$Cf(x)?O(x)?{_id:x,isDefault:!1}:void 0:x}N.from=W})(d||(e.TaskGroup=d={}));var o;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function O(W){switch(W){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var n;(function(N){N.parallel="parallel",N.sequence="sequence"})(n||(e.DependsOrder=n={}));var s;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(s||(e.RunOnOptions=s={}));var a;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:s.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(O,W,x,ue,X,J){this._label="",this._id=O,W&&(this._label=W),x&&(this.type=x),this.runOptions=ue,this.configurationProperties=X,this._source=J}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,W=!1){if(O===void 0)return!1;if(T.$Cf(O))return O===this._label||O===this.configurationProperties.identifier||W&&O===this._id;const x=this.getDefinition(!0);return x!==void 0&&x._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$dG=t;class r extends t{constructor(O,W,x,ue,X,J,Q,he){super(O,x,void 0,Q,he,W),this.command={},this._source=W,this.hasDefinedMatchers=J,X&&(this.command=X)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case S.Shell:W="shell";break;case S.Process:W="process";break;case S.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(O){return O instanceof r}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$_F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const x={type:e.$cG,folder:O,id:W};return JSON.stringify(x)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?m.$yg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new r(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$eG=r;class h extends t{constructor(O,W,x,ue,X,J,Q){super(O,x,ue,J,Q,W),this._source=W,this.configures=X}static is(O){return O instanceof h}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?m.$yg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$_F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const x={type:e.$cG,folder:O,id:W};return JSON.stringify(x)}}e.$fG=h;class u extends t{constructor(O,W,x,ue,X,J,Q,he,Z){super(O,x,ue,he,Z,W),this.defines=X,this.hasDefinedMatchers=Q,this.command=J,this.icon=Z.icon,this.hide=Z.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof u}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new u(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$gG=u;class c extends t{constructor(O,W,x,ue,X,J){super(O,x,ue,X,J,W),this._source=W}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new c(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$hG=c;var l;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(N){N._default=N.Terminal}(l||(e.ExecutionEngine=l={}));var E;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(E||(e.JsonSchemaVersion=E={}));class C{constructor(O){this.c=new Map;for(let W=0;W<O.length;W++)this.c.set(O[W].uri.toString(),W)}compare(O,W){const x=O.getWorkspaceFolder(),ue=W.getWorkspaceFolder();if(x&&ue){let X=this.c.get(x.uri.toString());X=X===void 0?0:X+1;let J=this.c.get(ue.uri.toString());return J=J===void 0?0:J+1,X===J?O._label.localeCompare(W._label):X-J}else return!x&&ue?-1:x&&!ue?1:0}}e.$iG=C;var f;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(f||(e.TaskEventKind=f={}));var p;(function(N){N.SingleRun="singleRun",N.Background="background"})(p||(e.TaskRunType=p={}));var k;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var I;(function(N){function O(he){return{taskId:he._id,taskName:he.configurationProperties.name,runType:he.configurationProperties.isBackground?"background":"singleRun",group:he.configurationProperties.group,__task:he}}function W(he,Z,ye){return{...O(he),kind:"start",terminalId:Z,resolvedVariables:ye}}N.start=W;function x(he,Z,ye){return{...O(he),kind:"processStarted",terminalId:Z,processId:ye}}N.processStarted=x;function ue(he,Z,ye){return{...O(he),kind:"processEnded",terminalId:Z,exitCode:ye}}N.processEnded=ue;function X(he,Z,ye){return{...O(he),kind:"terminated",exitReason:ye,terminalId:Z}}N.terminated=X;function J(he,Z,ye){return{...O(Z),kind:he,terminalId:ye}}N.general=J;function Q(){return{kind:"changed"}}N.changed=Q})(I||(e.TaskEvent=I={}));var j;(function(N){function O(x){const ue=Object.keys(x).sort();let X="";for(const J of ue){let Q=x[J];Q instanceof Object?Q=O(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),X+=J+","+Q+","}return X}function W(x){const X={_key:O(x),type:x.taskType};return Object.assign(X,x),X}N.create=W})(j||(e.KeyedTaskIdentifier=j={}));var z;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var M;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var F;(function(N){function O(W,x){const ue=w.$$F.get(W.type);if(ue===void 0){const he=A.$en(W);return delete he._key,j.create(he)}const X=Object.create(null);X.type=ue.taskType;const J=new Set;ue.required.forEach(he=>J.add(he));const Q=ue.properties;for(const he of Object.keys(Q)){const Z=W[he];if(Z!=null)X[he]=Z;else if(J.has(he)){const ye=Q[he];if(ye.default!==void 0)X[he]=A.$en(ye.default);else switch(ye.type){case"boolean":X[he]=!1;break;case"number":case"integer":X[he]=0;break;case"string":X[he]="";break;default:x.error(D.localize(2,null,JSON.stringify(W,void 0,0),he));return}}}return j.create(X)}N.createTaskIdentifier=O})(F||(e.TaskDefinition=F={}))}),define(ke[303],Se([1,0,8]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C6b=e.$B6b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,w)=>{this.b=R,this.d=w,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,D.$Z)(R))}then(R,w){return this.j().then(R,w)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$B6b=T;class m extends T{constructor(){super(),this.h=!0,this.i=new D.$4}}e.$C6b=m}),define(ke[68],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.$xv=void 0;class D{static{this.count=0}constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++D.count}}e.$xv=D;const T=[];function m(w){const b=new D(w);return T[b.nid]=b,b}e.$yv=m;function A(w){return T[w].sid}e.$zv=A;class R{constructor(b){this.value=b}}e.$Av=R}),define(ke[6],Se([1,0,68]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DK=e.$CK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$BK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var m;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput",g[g.ChatEditorInput=10]="ChatEditorInput"})(m||(e.TabInputKind=m={}));var A;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var R;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var w;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})(w||(e.WebviewMessageArrayBufferViewType=w={}));var b;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var y;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var L;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class P{static{this.a=0}static mixin(d){return d._id=P.a++,d}}e.$BK=P;var $;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.kindModifier="m",g.commandIdent="n",g.commandId="o",g.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var v;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var S;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$CK={MainThreadAuthentication:(0,D.$yv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$yv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$yv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$yv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$yv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$yv)("MainThreadClipboard"),MainThreadCommands:(0,D.$yv)("MainThreadCommands"),MainThreadComments:(0,D.$yv)("MainThreadComments"),MainThreadConfiguration:(0,D.$yv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$yv)("MainThreadConsole"),MainThreadDebugService:(0,D.$yv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$yv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$yv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$yv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$yv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$yv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$yv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$yv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$yv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$yv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$yv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$yv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$yv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$yv)("MainThreadLanguages"),MainThreadLogger:(0,D.$yv)("MainThreadLogger"),MainThreadMessageService:(0,D.$yv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$yv)("MainThreadOutputService"),MainThreadProgress:(0,D.$yv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$yv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$yv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$yv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$yv)("MainThreadSecretState"),MainThreadStorage:(0,D.$yv)("MainThreadStorage"),MainThreadSpeech:(0,D.$yv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$yv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$yv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$yv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$yv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$yv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$yv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$yv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$yv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$yv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$yv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$yv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$yv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$yv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$yv)("MainThreadSCM"),MainThreadSearch:(0,D.$yv)("MainThreadSearch"),MainThreadShare:(0,D.$yv)("MainThreadShare"),MainThreadTask:(0,D.$yv)("MainThreadTask"),MainThreadWindow:(0,D.$yv)("MainThreadWindow"),MainThreadLabelService:(0,D.$yv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$yv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$yv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$yv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$yv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$yv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$yv)("MainThreadInteractive"),MainThreadChat:(0,D.$yv)("MainThreadChat"),MainThreadInlineChat:(0,D.$yv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$yv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$yv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$yv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$yv)("MainThreadTimeline"),MainThreadTesting:(0,D.$yv)("MainThreadTesting"),MainThreadLocalization:(0,D.$yv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$yv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$yv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$yv)("MainThreadIssueReporter")},e.$DK={ExtHostCommands:(0,D.$yv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$yv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$yv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$yv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$yv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$yv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$yv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$yv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$yv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$yv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$yv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$yv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$yv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$yv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$yv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$yv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$yv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$yv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$yv)("ExtHostStatusBar"),ExtHostShare:(0,D.$yv)("ExtHostShare"),ExtHostExtensionService:(0,D.$yv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$yv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$yv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$yv)("ExtHostSCM"),ExtHostSearch:(0,D.$yv)("ExtHostSearch"),ExtHostTask:(0,D.$yv)("ExtHostTask"),ExtHostWorkspace:(0,D.$yv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$yv)("ExtHostWindow"),ExtHostWebviews:(0,D.$yv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$yv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$yv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$yv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$yv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$yv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$yv)("ExtHostProgress"),ExtHostComments:(0,D.$yv)("ExtHostComments"),ExtHostSecretState:(0,D.$yv)("ExtHostSecretState"),ExtHostStorage:(0,D.$yv)("ExtHostStorage"),ExtHostUrls:(0,D.$yv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$yv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$yv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$yv)("ExtHostOutputService"),ExtHosLabelService:(0,D.$yv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$yv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$yv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$yv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$yv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$yv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$yv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$yv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$yv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$yv)("ExtHostChat"),ExtHostChatAgents2:(0,D.$yv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$yv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$yv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$yv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$yv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$yv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$yv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$yv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$yv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$yv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$yv)("ExtHostTimeline"),ExtHostTesting:(0,D.$yv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$yv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$yv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$yv)("ExtHostIssueReporter")}}),define(ke[304],Se([1,0,6,7]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;class m{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$CK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,w,b){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(R);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(w,b)??[]}getRelatedInformation(R,w,b){return this.c.$getAiRelatedInformation(w,b)}registerRelatedInformationProvider(R,w,b){const y=this.b;return this.b++,this.a.set(y,b),this.c.$registerAiRelatedInformationProvider(y,w),new T.$EK(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$kec=m}),define(ke[91],Se([1,0,5,14,6,20]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=e.$rec=e.$qec=void 0,e.$qec=(0,D.$Zh)("IExtHostApiDeprecationService");let R=class{constructor(b,y){this.c=y,this.a=new Set,this.b=b.getProxy(m.$CK.MainThreadTelemetry)}report(b,y,L){const P=this.d(b,y);this.a.has(P)||(this.a.add(P),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${b}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:b}))}d(b,y){return`${b}-${y.identifier.value}`}};e.$rec=R,e.$rec=R=Ke([Be(0,A.$EM),Be(1,T.$hj)],R),e.$sec=Object.freeze(new class{report(w,b,y){}})}),define(ke[305],Se([1,0,4,6,7,26]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=void 0;class R{constructor(y){this.b=new Map,this.c=[],this.d=new D.$Rd,this.onDidChangeSessions=this.d.event,this.f=new w,this.g=new w,this.a=y.getProxy(T.$CK.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,L,P,$={}){const v=A.$dm.toKey(y.identifier),S=[...P].sort().join(" ");return await this.f.getOrCreate(`${v} ${L} ${S}`,async()=>{await this.a.$ensureProvider(L);const g=y.displayName||y.name;return this.a.$getSession(L,P,v,g,$)})}async getSessions(y,L,P){const $=A.$dm.toKey(y.identifier),v=[...P].sort().join(" ");return await this.g.getOrCreate(`${$} ${v}`,async()=>{await this.a.$ensureProvider(L);const S=y.displayName||y.name;return this.a.$getSessions(L,P,$,S)})}async removeSession(y,L){const P=this.b.get(y);return P?P.provider.removeSession(L):this.a.$removeSession(y,L)}registerAuthenticationProvider(y,L,P,$){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:L,provider:P,options:$??{supportsMultipleAccounts:!1}}),this.c.find(S=>S.id===y)||this.c.push({id:y,label:L});const v=P.onDidChangeSessions(S=>{this.a.$sendDidChangeSessions(y,{added:S.added??[],changed:S.changed??[],removed:S.removed??[]})});return this.a.$registerAuthenticationProvider(y,L,$?.supportsMultipleAccounts??!1),new m.$EK(()=>{v.dispose(),this.b.delete(y);const S=this.c.findIndex(g=>g.id===y);S>-1&&this.c.splice(S),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,L,P){const $=this.b.get(y);if($)return Promise.resolve($.provider.createSession(L,P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,L){const P=this.b.get(y);if(P)return Promise.resolve(P.provider.removeSession(L));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,L){const P=this.b.get(y);if(P)return Promise.resolve(P.provider.getSessions(L));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,L){return this.d.fire({provider:{id:y,label:L}}),Promise.resolve()}}e.$vec=R;class w{constructor(){this.a=new Map}getOrCreate(y,L){const P=this.a.get(y);if(P)return P;const $=L().finally(()=>this.a.delete(y));return this.a.set(y,$),$}}}),define(ke[306],Se([1,0,6,20,15]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0;let A=class{constructor(w,b){this.a=w.getProxy(D.$CK.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>b.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(w,b,y){const L=m.WorkspaceEdit.from(w,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,y?.isRefactoring??!1)}};e.$wec=A,e.$wec=A=Ke([Be(0,T.$EM)],A)}),define(ke[307],Se([1,0,4,51,3,6,15]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class w{static{this.a=0}constructor(L,P){this.extension=L,this.provider=P,this.handle=w.a++}}class b{static{this.a=0}constructor(L){this.b=new Map,this.c=new Map,this.d=new D.$Rd,this.onDidPerformUserAction=this.d.event,this.e=L.getProxy(A.$CK.MainThreadChat)}registerChatProvider(L,P,$){const v=new w(L,$);return this.b.set(v.handle,v),this.e.$registerChatProvider(v.handle,P),(0,m.$Pc)(()=>{this.e.$unregisterChatProvider(v.handle),this.b.delete(v.handle)})}transferChatSession(L,P){const $=T.Iterable.find(this.c.keys(),v=>this.c.get(v)===L)??0;typeof $=="number"&&this.e.$transferChatSession($,P)}sendInteractiveRequestToProvider(L,P){this.e.$sendRequestToProvider(L,P)}async $prepareChat(L,P){const $=this.b.get(L);if(!$)return;const v=await $.provider.prepareSession(P);if(!v)return;const S=b.a++;return this.c.set(S,v),{id:S,requesterUsername:v.requester?.name,requesterAvatarIconUri:v.requester?.icon,responderUsername:v.responder?.name,responderAvatarIconUri:v.responder?.icon,inputPlaceholder:v.inputPlaceholder}}async $provideWelcomeMessage(L,P){const $=this.b.get(L);if(!$||!$.provider.provideWelcomeMessage)return;const v=await $.provider.provideWelcomeMessage(P);if(v)return v.map(S=>typeof S=="string"?S:Array.isArray(S)?S.map(g=>R.ChatReplyFollowup.from(g)):R.MarkdownString.from(S))}async $provideSampleQuestions(L,P){const $=this.b.get(L);if(!$||!$.provider.provideSampleQuestions)return;const v=await $.provider.provideSampleQuestions(P);if(v)return v?.map(S=>R.ChatReplyFollowup.from(S))}$releaseSession(L){this.c.delete(L)}async $onDidPerformUserAction(L){this.d.fire(L)}}e.$xec=b}),define(ke[308],Se([1,0,12,21,44,4,38,18,2,209,85,6,15,7,279,25]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;class d{static{this.a=0}constructor(n,s,a){this.i=s,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=n.getProxy(P.$CK.MainThreadChatAgents2)}createChatAgent(n,s,a){const t=d.a++,r=new o(n,s,this.d,t,a);return this.b.set(t,r),this.d.$registerAgent(t,s,{}),r.apiAgent}async $invokeAgent(n,s,a,t,r,h){this.g.delete(s);const u=this.b.get(n);if(!u)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let c=!1;function l(){if(c)throw new Error("Only valid while executing the command")}const E=new D.$kh;h.onCancellationRequested(()=>E.complete()),setTimeout(()=>E.complete(),10*1e3),this.i.allowListExtensionWhile(u.extension.identifier,E.p);const C=t.command?await u.validateSlashCommand(t.command):void 0,f=R.$Nd.create(!1);let p;try{const k=u.invoke({prompt:t.message,variables:$.ChatVariable.objectTo(t.variables),slashCommand:C},{history:r.history.map($.ChatMessage.to)},new L.$cv(I=>{l(),typeof p>"u"&&"content"in I&&(p=f.elapsed());const j=$.ChatResponseProgress.from(u.extension,I);if(!j){this.j.error("Unknown progress type: "+JSON.stringify(I));return}if("placeholder"in I&&"resolvedContent"in I){const z=Promise.all([this.d.$handleProgressChunk(a,j),I.resolvedContent]);(0,D.$Og)(z,h).then(M=>{if(!M)return;const[F,N]=M,O=$.ChatResponseProgress.from(u.extension,N);if(!O){this.j.error("Unknown progress type: "+JSON.stringify(N));return}this.d.$handleProgressChunk(a,O,F??void 0)})}else this.d.$handleProgressChunk(a,j)}),h);return await(0,D.$Og)(Promise.resolve(k).then(I=>{if(I){this.g.set(s,I);let j=this.h.get(s);j||(j=new Map,this.h.set(s,j)),j.set(a,I);const z={firstProgress:p,totalElapsed:f.elapsed()};return{errorDetails:I.errorDetails,timings:z}}else this.g.delete(s)}),h)}catch(k){return this.j.error(k,u.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,m.$Ki)(k)),responseIsIncomplete:!0}}}finally{c=!0,E.complete()}}$releaseSession(n){this.g.delete(n),this.h.delete(n)}async $provideSlashCommands(n,s){const a=this.b.get(n);return a?a.provideSlashCommand(s):[]}$provideFollowups(n,s,a){const t=this.b.get(n);if(!t)return Promise.resolve([]);const r=this.g.get(s);return r?t.provideFollowups(r,a):Promise.resolve([])}$acceptFeedback(n,s,a,t,r){const h=this.b.get(n);if(!h)return;const u=this.h.get(s)?.get(a);if(!u)return;let c;switch(t){case S.InteractiveSessionVoteDirection.Down:c=v.ChatAgentResultFeedbackKind.Unhelpful;break;case S.InteractiveSessionVoteDirection.Up:c=v.ChatAgentResultFeedbackKind.Helpful;break}h.acceptFeedback(Object.freeze(r?{result:u,kind:c,reportIssue:r}:{result:u,kind:c}))}$acceptAction(n,s,a,t){const r=this.b.get(n);if(!r)return;const h=this.h.get(s)?.get(a);h&&t.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:t.action,result:h}))}}e.$zec=d;class o{constructor(n,s,a,t,r){this.extension=n,this.s=s,this.t=a,this.u=t,this.w=r,this.o=new A.$Rd,this.q=new A.$Rd}acceptFeedback(n){this.o.fire(n)}acceptAction(n){this.q.fire(n)}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,w.$Mf)(this.b));const s=this.b.find(a=>a.name===n);if(!s)throw new Error(`Unknown slashCommand: ${n}`);return s}async provideSlashCommand(n){if(!this.a)return[];const s=await this.a.provideSlashCommands(n);return s?(this.b=s,s.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate,sampleRequest:a.sampleRequest}))):[]}async provideFollowups(n,s){if(!this.d)return[];const a=await this.d.provideFollowups(n,s);return a?a.map(t=>$.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,s=!1;const a=()=>{n||s||(s=!0,queueMicrotask(()=>{this.t.$updateAgent(this.u,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof b.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$yL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:$.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:$.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),s=!1}))},t=this;return{get name(){return t.s},get description(){return t.g??""},set description(r){t.g=r,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(r){t.h=r,a()},get iconPath(){return t.i},set iconPath(r){t.i=r,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(r){t.a=r,a()},get followupProvider(){return t.d},set followupProvider(r){t.d=r,a()},get isDefault(){return(0,g.$QF)(t.extension,"defaultChatAgent"),t.j},set isDefault(r){(0,g.$QF)(t.extension,"defaultChatAgent"),t.j=r,a()},get helpTextPrefix(){return(0,g.$QF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(r){if((0,g.$QF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=r,a()},get helpTextPostfix(){return(0,g.$QF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(r){if((0,g.$QF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=r,a()},get isSecondary(){return(0,g.$QF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(r){(0,g.$QF)(t.extension,"defaultChatAgent"),t.n=r,a()},get sampleRequest(){return t.m},set sampleRequest(r){t.m=r,a()},get supportIssueReporting(){return(0,g.$QF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(r){(0,g.$QF)(t.extension,"chatAgents2Additions"),t.r=r,a()},get onDidReceiveFeedback(){return t.o.event},onDidPerformAction:(0,g.$PF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){n=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.t.$unregisterAgent(t.u)}}}invoke(n,s,a,t){return this.w(n,s,a,t)}}}),define(ke[309],Se([1,0,21,3,6,15,85,26,12,4]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;class L{constructor(S,g){this.stream=new b.$qh,this.stream=g??new b.$qh;const d=this;this.apiObj={option:S,response:d.stream.asyncIterable}}}class P{constructor(S,g){this.a=new y.$Rd,this.b=new Map,this.c=new b.$qh,this.d=!1;const d=this;this.apiObject={result:S,response:d.c.asyncIterable,onDidStartResponseStream:d.a.event,cancel(){g.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,o]of this.b)o.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let g=this.b.get(S.index);g||(this.b.size===0?g=new L(S.index,this.c):g=new L(S.index),this.b.set(S.index,g),this.a.fire(g.apiObj)),g.stream.emitOne(S.part)}}class ${static{this.a=1}constructor(S,g){this.d=g,this.c=new Map,this.e=new Map,this.f=new w.$fm,this.b=S.getProxy(m.$CK.MainThreadChatProvider)}registerProvider(S,g,d,o){const i=$.a++;return this.c.set(i,{extension:S,provider:d}),this.b.$registerProvider(i,g,{extension:S,displayName:o.name??S.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,g,d,o,i){const n=this.c.get(S);if(!n)return;const s=new R.$cv(async a=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(g,{index:a.index,part:a.part})});return n.provider.provideChatResponse(d.map(A.ChatMessage.to),o,s,i)}allowListExtensionWhile(S,g){this.f.set(S,g),g.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,g){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const d=this;return{get isRevoked(){return!d.f.has(S)},makeRequest(o,i,n){if(!d.f.has(S))throw new Error("Access to chat has been revoked");const s=new D.$2d(n),a=Math.random()*1e6|0,t=d.b.$fetchResponse(S,g,a,o.map(A.ChatMessage.from),i??{},s.token),r=new P(t,s);return d.e.set(a,{res:r}),t.finally(()=>{d.e.delete(a)}),r.apiObject}}}async $handleResponseFragment(S,g){const d=this.e.get(S);d&&d.res.handleFragment(g)}}e.$yec=$}),define(ke[310],Se([1,0,3,6,8,15]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;class R{static{this.a=0}constructor(b){this.b=new Map,this.c=b.getProxy(T.$CK.MainThreadChatVariables)}async $resolveVariable(b,y,L){const P=this.b.get(b);if(P)try{const $=await P.resolver.resolve(P.data.name,{message:y},L);if($)return $.map(A.ChatVariable.from)}catch($){(0,m.$1)($)}}registerVariableResolver(b,y,L,P){const $=R.a++;return this.b.set($,{extension:b.identifier,data:{name:y,description:L},resolver:P}),this.c.$registerVariable($,{name:y,description:L}),(0,D.$Pc)(()=>{this.b.delete($),this.c.$unregisterVariable($)})}}e.$Aec=R}),define(ke[311],Se([1,0,6]),function(be,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=void 0;class T{constructor(A){const R=A.getProxy(D.$CK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(w){return R.$writeText(w)}})}}e.$Bec=T}),define(ke[35],Se([1,0,18,7,15,24,6,19,14,54,29,53,2,3,5,20,148,22,68,44,38,87,90,30]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=void 0;let h=class{#e;#t;#i;constructor(f,p,k){this.b=new Map,this.c=new Map,this.#e=f.getProxy(R.$CK.MainThreadCommands),this.d=p,this.#i=k,this.#t=f.getProxy(R.$CK.MainThreadTelemetry),this.converter=new u(this,I=>{const j=this.c.get(I);return j?.result===l.Void?j:void 0},p),this.f=[{processArgument(I){return(0,y.$wh)(I)}},{processArgument(I){return(0,A.$gn)(I,function(j){if(L.$Ds.isIRange(j))return m.Range.to(j);if(P.$Cs.isIPosition(j))return m.Position.to(j);if(L.$Ds.isIRange(j.range)&&$.URI.isUri(j.uri))return m.location.to(j);if(j instanceof o.$fe)return j.buffer.buffer;if(!Array.isArray(j))return j})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const p=this.registerCommand(!1,f.id,async(...k)=>{const I=f.args.map((z,M)=>{if(!z.validate(k[M]))throw new Error(`Invalid argument '${z.name}' when running '${f.id}', received: ${typeof k[M]=="object"?JSON.stringify(k[M],null,"	"):k[M]} `);return z.convert(k[M])}),j=await this.executeCommand(f.internalId,...I);return f.result.convert(j,k,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new T.$EK(()=>{p.dispose(),this.c.delete(f.id)})}registerCommand(f,p,k,I,j,z){if(this.d.trace("ExtHostCommands#registerCommand",p),!p.trim().length)throw new Error("invalid id");if(this.b.has(p))throw new Error(`command '${p}' already exists`);return this.b.set(p,{callback:k,thisArg:I,metadata:j,extension:z}),f&&this.#e.$registerCommand(p),new T.$EK(()=>{this.b.delete(p)&&f&&this.#e.$unregisterCommand(p)})}executeCommand(f,...p){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,p,!0)}async g(f,p,k){if(this.b.has(f))return this.#e.$fireCommandActivationEvent(f),this.h(f,p,!1);{let I=!1;const j=(0,A.$gn)(p,function(z){if(z instanceof T.$FK)return m.Position.from(z);if(z instanceof T.$GK)return m.Range.from(z);if(z instanceof T.$QK)return m.location.from(z);if(T.$2L.isNotebookRange(z))return m.NotebookRange.from(z);if(z instanceof ArrayBuffer)return I=!0,o.$fe.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return I=!0,o.$fe.wrap(z);if(z instanceof o.$fe)return I=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(f,I?new i.$Av(j):j,k);return(0,y.$wh)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(f,p,!1);throw z}}}async h(f,p,k){const I=this.b.get(f);if(!I)throw new Error("Unknown command");const{callback:j,thisArg:z,metadata:M}=I;if(M?.args)for(let N=0;N<M.args.length;N++)try{(0,D.$Tf)(p[N],M.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${M.args[N].name}' - ${M.args[N].description}`)}const F=s.$Nd.create();try{return await j.apply(z,p)}catch(N){if(f===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...p);O&&(f=O.command)}if(this.d.error(N,f,I.extension?.identifier),!k)throw N;if(I.extension?.identifier){const O=this.#i.onExtensionError(I.extension.identifier,N);this.d.trace("forwarded error to extension?",O,I.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Ki)(N)),this.id=f,this.source=I.extension?.displayName??I.extension?.name}}}finally{this.j(I,f,F.elapsed())}}j(f,p,k){f.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new a.$to(p),duration:k})}$executeContributedCommand(f,...p){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const k=this.b.get(f);return k?(p=p.map(I=>this.f.reduce((j,z)=>z.processArgument(j,k.extension?.identifier),I)),this.h(f,p,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),this.#e.$getCommands().then(p=>(f&&(p=p.filter(k=>k[0]!=="_")),p))}$getContributedCommandMetadata(){const f=Object.create(null);for(const[p,k]of this.b){const{metadata:I}=k;I&&(f[p]=I)}return Promise.resolve(f)}};e.$ZM=h,e.$ZM=h=Ke([Be(0,g.$EM),Be(1,b.$hj),Be(2,t.$YM)],h),e.$1M=(0,S.$Zh)("IExtHostCommands");class u{constructor(f,p,k){this.d=f,this.f=p,this.g=k,this.delegatingCommandId=`__vsc${(0,r.$kg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,p){if(!f)return;const k={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return k;const I=this.f(f.command);if(I)k.id=I.internalId,k.arguments=I.args.map((j,z)=>j.convert(f.arguments&&f.arguments[z]));else if((0,w.$Kb)(f.arguments)){const j=`${f.command} /${++this.c}`;this.b.set(j,f),p.add((0,v.$Pc)(()=>{this.b.delete(j),this.g.trace("CommandsConverter#DISPOSE",j)})),k.$ident=j,k.id=this.delegatingCommandId,k.arguments=[j],this.g.trace("CommandsConverter#CREATE",f.command,j)}return k}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const p=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],p?p.command:"MISSING"),p?this.d.executeCommand(p.command,...p.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.$2M=u;class c{static{this.Uri=new c("uri","Uri of a text document",f=>$.URI.isUri(f),f=>f)}static{this.Position=new c("position","A position in a text document",f=>T.$FK.isPosition(f),m.Position.from)}static{this.Range=new c("range","A range in a text document",f=>T.$GK.isRange(f),m.Range.from)}static{this.Selection=new c("selection","A selection in a text document",f=>T.$HK.isSelection(f),m.Selection.from)}static{this.Number=new c("number","",f=>typeof f=="number",f=>f)}static{this.String=new c("string","",f=>typeof f=="string",f=>f)}static{this.StringArray=c.Arr(c.String)}static Arr(f){return new c(`${f.name}_array`,`Array of ${f.name}, ${f.description}`,p=>Array.isArray(p)&&p.every(k=>f.validate(k)),p=>p.map(k=>f.convert(k)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",f=>f instanceof T.$1K,m.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",f=>f instanceof T.$iM,m.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",f=>f instanceof d.$RM,m.TestItem.from)}constructor(f,p,k,I){this.name=f,this.description=p,this.validate=k,this.convert=I}optional(){return new c(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,p){return new c(f??this.name,p??this.description,this.validate,this.convert)}}e.$3M=c;class l{static{this.Void=new l("no result",f=>f)}constructor(f,p){this.description=f,this.convert=p}}e.$4M=l;class E{constructor(f,p,k,I,j){this.id=f,this.internalId=p,this.description=k,this.args=I,this.result=j}}e.$5M=E}),define(ke[312],Se([1,0,19,17,2,83,132,46,35,15,7]),function(be,e,D,T,m,A,R,w,b,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;const P=[new b.$5M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$3M.Uri,b.$3M.Position],new b.$4M("A promise that resolves to an array of DocumentHighlight-instances.",v(y.DocumentHighlight.to))),new b.$5M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$3M.Uri],new b.$4M("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(g,d)=>{if((0,D.$Jb)(g))return;class o extends L.$VK{static to(n){const s=new o(n.name,y.SymbolKind.to(n.kind),n.containerName||"",new L.$QK(d[0],y.Range.to(n.range)));return s.detail=n.detail,s.range=s.location.range,s.selectionRange=y.Range.to(n.selectionRange),s.children=n.children?n.children.map(o.to):[],s}}return g.map(o.to)})),new b.$5M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$3M.Uri,new b.$3M("options","Formatting options",g=>!0,g=>g)],new b.$4M("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new b.$5M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$3M.Uri,b.$3M.Range,new b.$3M("options","Formatting options",g=>!0,g=>g)],new b.$4M("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new b.$5M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$3M.Uri,b.$3M.Position,new b.$3M("ch","Trigger character",g=>typeof g=="string",g=>g),new b.$3M("options","Formatting options",g=>!0,g=>g)],new b.$4M("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new b.$5M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$3M.Uri,b.$3M.Position],new b.$4M("A promise that resolves to an array of Location or LocationLink instances.",S)),new b.$5M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$3M.Uri,b.$3M.Position],new b.$4M("A promise that resolves to an array of Location or LocationLink instances.",S)),new b.$5M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$3M.Uri,b.$3M.Position],new b.$4M("A promise that resolves to an array of Location or LocationLink instances.",S)),new b.$5M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$3M.Uri,b.$3M.Position],new b.$4M("A promise that resolves to an array of Location or LocationLink instances.",S)),new b.$5M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$3M.Uri,b.$3M.Position],new b.$4M("A promise that resolves to an array of Location-instances.",v(y.location.to))),new b.$5M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$3M.Uri,b.$3M.Position],new b.$4M("A promise that resolves to an array of Hover-instances.",v(y.Hover.to))),new b.$5M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$3M.Uri,new b.$3M("position","A position in a text document",g=>Array.isArray(g)&&g.every(d=>L.$FK.isPosition(d)),g=>g.map(y.Position.from))],new b.$4M("A promise that resolves to an array of ranges.",g=>g.map(d=>{let o;for(const i of d.reverse())o=new L.$ZK(y.Range.to(i),o);return o}))),new b.$5M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$3M.String.with("query","Search string")],new b.$4M("A promise that resolves to an array of SymbolInformation-instances.",g=>g.map(y.WorkspaceSymbol.to))),new b.$5M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$3M.Uri,b.$3M.Position],new b.$4M("A promise that resolves to an array of CallHierarchyItem-instances",g=>g.map(y.CallHierarchyItem.to))),new b.$5M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$3M.CallHierarchyItem],new b.$4M("A promise that resolves to an array of CallHierarchyIncomingCall-instances",g=>g.map(y.CallHierarchyIncomingCall.to))),new b.$5M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$3M.CallHierarchyItem],new b.$4M("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",g=>g.map(y.CallHierarchyOutgoingCall.to))),new b.$5M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$3M.Uri,b.$3M.Position],new b.$4M("A promise that resolves to a range and placeholder text.",g=>{if(g)return{range:y.Range.to(g.range),placeholder:g.text}})),new b.$5M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$3M.Uri,b.$3M.Position,b.$3M.String.with("newName","The new symbol name")],new b.$4M("A promise that resolves to a WorkspaceEdit.",g=>{if(g){if(g.rejectReason)throw new Error(g.rejectReason);return y.WorkspaceEdit.to(g)}})),new b.$5M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$3M.Uri,b.$3M.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$4M("A promise that resolves to an array of DocumentLink-instances.",g=>g.map(y.DocumentLink.to))),new b.$5M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$3M.Uri],new b.$4M("A promise that resolves to SemanticTokensLegend.",g=>{if(g)return new L.$TL(g.tokenTypes,g.tokenModifiers)})),new b.$5M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$3M.Uri],new b.$4M("A promise that resolves to SemanticTokens.",g=>{if(!g)return;const d=(0,R.$90)(g);if(d.type==="full")return new L.$VL(d.data,void 0)})),new b.$5M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$3M.Uri,b.$3M.Range.optional()],new b.$4M("A promise that resolves to SemanticTokensLegend.",g=>{if(g)return new L.$TL(g.tokenTypes,g.tokenModifiers)})),new b.$5M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$3M.Uri,b.$3M.Range],new b.$4M("A promise that resolves to SemanticTokens.",g=>{if(!g)return;const d=(0,R.$90)(g);if(d.type==="full")return new L.$VL(d.data,void 0)})),new b.$5M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$3M.Uri,b.$3M.Position,b.$3M.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$3M.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$4M("A promise that resolves to a CompletionList-instance.",(g,d,o)=>{if(!g)return new L.$_K([]);const i=g.suggestions.map(n=>y.CompletionItem.to(n,o));return new L.$_K(i,g.incomplete)})),new b.$5M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$3M.Uri,b.$3M.Position,b.$3M.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$4M("A promise that resolves to SignatureHelp.",g=>{if(g)return y.SignatureHelp.to(g)})),new b.$5M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$3M.Uri,b.$3M.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$4M("A promise that resolves to an array of CodeLens-instances.",(g,d,o)=>v(i=>new L.$4K(y.Range.to(i.range),i.command&&o.fromInternal(i.command)))(g))),new b.$5M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$3M.Uri,new b.$3M("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",g=>L.$GK.isRange(g),g=>L.$HK.isSelection(g)?y.Selection.from(g):y.Range.from(g)),b.$3M.String.with("kind","Code action kind to return code actions for").optional(),b.$3M.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$4M("A promise that resolves to an array of Command-instances.",(g,d,o)=>v(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const n=new L.$XK(i.title,i.kind?new L.$YK(i.kind):void 0);return i.edit&&(n.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(n.command=o.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(g))),new b.$5M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$3M.Uri],new b.$4M("A promise that resolves to an array of ColorInformation objects.",g=>g?g.map(d=>new L.$fL(y.Range.to(d.range),y.Color.to(d.color))):[])),new b.$5M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$3M("color","The color to show and insert",g=>g instanceof L.$eL,y.Color.from),new b.$3M("context","Context object with uri and range",g=>!0,g=>({uri:g.uri,range:y.Range.from(g.range)}))],new b.$4M("A promise that resolves to an array of ColorPresentation objects.",g=>g?g.map(y.ColorPresentation.to):[])),new b.$5M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$3M.Uri,b.$3M.Range],new b.$4M("A promise that resolves to an array of Inlay objects",(g,d,o)=>g.map(y.InlayHint.to.bind(void 0,o)))),new b.$5M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$3M.Uri],new b.$4M("A promise that resolves to an array of FoldingRange objects",(g,d)=>{if(g)return g.map(y.FoldingRange.to)})),new b.$5M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$4M("A promise that resolves to an array of NotebookContentProvider static info objects.",v(g=>({viewType:g.viewType,displayName:g.displayName,options:{transientOutputs:g.options.transientOutputs,transientCellMetadata:g.options.transientCellMetadata,transientDocumentMetadata:g.options.transientDocumentMetadata},filenamePattern:g.filenamePattern.map(d=>y.NotebookExclusiveDocumentPattern.to(d))})))),new b.$5M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$3M.Uri,b.$3M.Range,new b.$3M("context","An InlineValueContext",g=>g&&typeof g.frameId=="number"&&g.stoppedLocation instanceof L.$GK,g=>y.InlineValueContext.from(g))],new b.$4M("A promise that resolves to an array of InlineValue objects",g=>g.map(y.InlineValue.to))),new b.$5M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$3M("uriOrString","Uri-instance or string (only http/https)",g=>m.URI.isUri(g)||typeof g=="string"&&(0,T.$_f)(g,T.Schemas.http,T.Schemas.https),g=>g),new b.$3M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="number"||typeof g=="object",g=>g&&(typeof g=="number"?[y.ViewColumn.from(g),void 0]:[y.ViewColumn.from(g.viewColumn),y.TextEditorOpenOptions.from(g)])).optional(),b.$3M.String.with("label","").optional()],b.$4M.Void),new b.$5M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$3M.Uri.with("resource","Resource to open"),b.$3M.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new b.$3M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="number"||typeof g=="object",g=>g&&(typeof g=="number"?[y.ViewColumn.from(g),void 0]:[y.ViewColumn.from(g.viewColumn),y.TextEditorOpenOptions.from(g)])).optional()],b.$4M.Void),new b.$5M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$3M.Uri.with("left","Left-hand side resource of the diff editor"),b.$3M.Uri.with("right","Right-hand side resource of the diff editor"),b.$3M.String.with("title","Human readable title for the diff editor").optional(),new b.$3M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="object",g=>g&&[y.ViewColumn.from(g.viewColumn),y.TextEditorOpenOptions.from(g)]).optional()],b.$4M.Void),new b.$5M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[b.$3M.String.with("title","Human readable title for the changes editor"),new b.$3M("resourceList","List of resources to compare",g=>{for(const d of g){if(d.length!==3)return!1;const[o,i,n]=d;if(!m.URI.isUri(o)||!m.URI.isUri(i)&&i!==void 0&&i!==null||!m.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},g=>g)],b.$4M.Void),new b.$5M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$3M.Uri,b.$3M.Position],new b.$4M("A promise that resolves to an array of TypeHierarchyItem-instances",g=>g.map(y.TypeHierarchyItem.to))),new b.$5M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$3M.TypeHierarchyItem],new b.$4M("A promise that resolves to an array of TypeHierarchyItem-instances",g=>g.map(y.TypeHierarchyItem.to))),new b.$5M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$3M.TypeHierarchyItem],new b.$4M("A promise that resolves to an array of TypeHierarchyItem-instances",g=>g.map(y.TypeHierarchyItem.to))),new b.$5M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$3M.TestItem],b.$4M.Void),new b.$5M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$3M.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$4M.Void),new b.$5M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$3M.String.with("name","The context key name"),new b.$3M("value","The context key value",()=>!0,g=>g)],b.$4M.Void),new b.$5M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.$3M.Uri,b.$3M.StringArray,new b.$3M("MappedEditsContext","Mapped Edits Context",g=>y.MappedEditsContext.is(g),g=>y.MappedEditsContext.from(g))],new b.$4M("A promise that resolves to a workspace edit or null",g=>g?y.WorkspaceEdit.to(g):null))];class ${static register(d){P.forEach(d.registerApiCommand,d),this.a(d)}static a(d){d.registerCommand(!1,"_validateWhenClauses",w.$Yi)}}e.$uec=$;function v(g){return d=>{if(Array.isArray(d))return d.map(g)}}function S(g){if(!Array.isArray(g))return;const d=[];for(const o of g)A.$ot(o)?d.push(y.DefinitionLink.to(o)):d.push(y.location.to(o));return d}}),define(ke[313],Se([1,0,12,59,4,3,2,83,26,15,7,6,25]),function(be,e,D,T,m,A,R,w,b,y,L,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;function v(S,g,d){const o=S.getProxy(P.$CK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new b.$fm,g.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const E=this.b.get(l.handle);return E?E.value:l}else if(l&&l.$mid===7){const E=this.b.get(l.commentControlHandle);if(!E)return l;const C=E.getCommentThread(l.commentThreadHandle);return C?C.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const E=this.b.get(l.thread.commentControlHandle);if(!E)return l;const C=E.getCommentThread(l.thread.commentThreadHandle);return C?l.$mid===8?C.value:{thread:C.value,text:l.text}:l}else if(l&&l.$mid===10){const E=this.b.get(l.thread.commentControlHandle);if(!E)return l;const C=E.getCommentThread(l.thread.commentThreadHandle);if(!C)return l;const f=l.commentUniqueId,p=C.getCommentByUniqueId(f);return p||l}else if(l&&l.$mid===11){const E=this.b.get(l.thread.commentControlHandle);if(!E)return l;const C=E.getCommentThread(l.thread.commentThreadHandle);if(!C)return l;const f=l.text,p=l.commentUniqueId,k=C.getCommentByUniqueId(p);return k?(typeof k.body=="string"?k.body=f:k.body=new L.$5K(f),k):l}return l}})}createCommentController(l,E,C){const f=i.a++,p=new s(l,f,E,C);this.b.set(p.handle,p);const k=this.c.get(l.identifier)||[];return k.push(p),this.c.set(l.identifier,k),p.value}async $createCommentThreadTemplate(l,E,C){const f=this.b.get(l);f&&f.$createCommentThreadTemplate(E,C)}async $updateCommentThreadTemplate(l,E,C){const f=this.b.get(l);f&&f.$updateCommentThreadTemplate(E,C)}$deleteCommentThread(l,E){this.b.get(l)?.$deleteCommentThread(E)}$provideCommentingRanges(l,E,C){const f=this.b.get(l);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const p=d.getDocument(R.URI.revive(E));return(0,D.$Sg)(async()=>{const k=await f.commentingRangeProvider.provideCommentingRanges(p,C);let I;return Array.isArray(k)?I={ranges:k,fileComments:!1}:k?I={ranges:k.ranges||[],fileComments:k.fileComments||!1}:I=k??void 0,I}).then(k=>{let I;return k&&(I={ranges:k.ranges.map(j=>y.Range.from(j)),fileComments:k.fileComments}),I})}$toggleReaction(l,E,C,f,p){const k=this.b.get(l);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,D.$Sg)(()=>{const I=k.getCommentThread(E);if(I){const j=I.getCommentByUniqueId(f.uniqueIdInThread);if(k!==void 0&&j&&k.reactionHandler)return k.reactionHandler(j,r(p))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,E,C,f,p,k,I,j){this.m=E,this.n=C,this.o=f,this.p=p,this.q=k,this.extensionDescription=I,this.r=j,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new m.$Rd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Sc,this.l.value=new A.$Qc,this.n===void 0&&(this.n=`${l}.${this.handle}`),o.$createCommentThread(E,this.handle,this.n,this.o,y.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{o.$deleteCommentThread(E,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(M){z.range=M},get comments(){return z.comments},set comments(M){z.comments=M},get collapsibleState(){return z.collapsibleState},set collapsibleState(M){z.collapsibleState=M},get canReply(){return z.canReply},set canReply(M){z.canReply=M},get contextValue(){return z.contextValue},set contextValue(M){z.contextValue=M},get label(){return z.label},set label(M){z.label=M},get state(){return z.state},set state(M){z.state=M},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Qc);const l=C=>Object.prototype.hasOwnProperty.call(this.b,C),E={};l("range")&&(E.range=y.Range.from(this.p)),l("label")&&(E.label=this.label),l("contextValue")&&(E.contextValue=this.contextValue??null),l("comments")&&(E.comments=this.q.map(C=>a(this,C,this.k,this.extensionDescription))),l("collapsibleState")&&(E.collapseState=h(this.g)),l("canReply")&&(E.canReply=this.canReply),l("state")&&(E.state=u(this.h)),l("isTemplate")&&(E.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(l){for(const E of this.k){const C=E[0],f=E[1];if(l===f)return C}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Ke([(0,T.$sh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class s{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,E,C,f){this.f=l,this.g=E,this.h=C,this.i=f,this.a=new Map,o.$registerCommentController(this.handle,C,f,this.f.identifier.value);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(k){p.options=k},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(k){p.commentingRangeProvider=k},get reactionHandler(){return p.reactionHandler},set reactionHandler(k){p.reactionHandler=k},createCommentThread(k,I,j){return p.createCommentThread(k,I,j).value},dispose:()=>{p.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(l,E,C){E===void 0&&(0,$.$QF)(this.f,"fileComments");const f=new n(this.id,this.handle,void 0,l,E,C,this.f,!1);return this.a.set(f.handle,f),f}$createCommentThreadTemplate(l,E){const C=new n(this.id,this.handle,void 0,R.URI.revive(l),y.Range.to(E),[],this.f,!0);return C.collapsibleState=w.CommentThreadCollapsibleState.Expanded,this.a.set(C.handle,C),C}$updateCommentThreadTemplate(l,E){const C=this.a.get(l);C&&(C.range=y.Range.to(E))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function a(c,l,E,C){let f=E.get(l);return f||(f=++c.commentHandle,E.set(l,f)),l.state!==void 0&&(0,$.$QF)(C,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:f,body:typeof l.body=="string"?l.body:y.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(p=>t(p)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?y.$DM(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?R.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function h(c){if(c!==void 0)switch(c){case L.CommentThreadCollapsibleState.Expanded:return w.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return w.CommentThreadCollapsibleState.Collapsed}return w.CommentThreadCollapsibleState.Collapsed}function u(c){if(c!==void 0)switch(c){case L.CommentThreadState.Unresolved:return w.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return w.CommentThreadState.Resolved}return w.CommentThreadState.Unresolved}return new i}e.$Eec=v}),define(ke[314],Se([1,0,24,6,27,20]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;let R=class{constructor(L,P){this.a=L.getProxy(T.$CK.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,P){const $=this,v=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){$.e(L,P,v,arguments)}})}e(L,P,$,v){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:b(v,this.b)}),this.c&&this.f(L,$,v)}};e.$sgc=R,e.$sgc=R=Ke([Be(0,A.$EM),Be(1,m.$UM)],R);const w=1e5;function b(y,L){const P=[];if(y.length)for(let $=0;$<y.length;$++){let v=y[$];if(typeof v>"u")v="undefined";else if(v instanceof Error){const S=v;S.stack?v=S.stack:v=S.toString()}P.push(v)}if(L){const $=new Error().stack;$&&P.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,D.$jn)(P);return $.length>w?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(ke[150],Se([1,0,2,6,7,5,20,14,19,13,16,25]),function(be,e,D,T,m,A,R,w,b,y,L,P){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=e.$ufc=void 0;let v=class{static{$=this}static{this.c=0}static{this.d=250}constructor(g,d){this.h=d,this.f=new Map,this.g=g.getProxy(T.$CK.MainThreadDecorations)}registerFileDecorationProvider(g,d){const o=$.c++;this.f.set(o,{provider:g,extensionDescription:d}),this.g.$registerDecorationProvider(o,d.identifier.value);const i=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(o,null);return}const s=(0,b.$2b)(n);if(s.length<=$.d){this.g.$onDidChange(o,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,s.length);const a=s.map(h=>({uri:h,rank:(0,y.$Ke)(h.path,"/")})),t=(0,b.$yb)(a,(h,u)=>h.rank-u.rank||(0,y.$Ye)(h.uri.path,u.uri.path)),r=[];e:for(const h of t){let u;for(const c of h){const l=(0,L.$lc)(c.uri.path);if(u!==l&&(u=l,r.push(c.uri)>=$.d))break e}}this.g.$onDidChange(o,r)});return new m.$EK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(g,d,o){if(!this.f.has(g))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:s}=this.f.get(g);return await Promise.all(d.map(async a=>{try{const{uri:t,id:r}=a,h=await Promise.resolve(n.provideFileDecoration(D.URI.revive(t),o));if(!h)return;try{m.$ZL.validate(h),h.badge&&typeof h.badge!="string"&&(0,P.$QF)(s,"codiconDecoration"),i[r]=[h.propagate,h.tooltip,h.badge,h.color]}catch(u){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${u}`)}}catch(t){this.h.error(t)}})),i}};e.$ufc=v,e.$ufc=v=$=Ke([Be(0,R.$EM),Be(1,w.$hj)],v),e.$vfc=(0,A.$Zh)("IExtHostDecorations")}),define(ke[315],Se([1,0,210,136,2,6,7,15,4,14,28,57]),function(be,e,D,T,m,A,R,w,b,y,L,P){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=e.$oec=void 0;class v{#e;#t;#i;constructor(d,o,i,n,s,a,t,r){this.d=d,this.e=o,this.f=i,this.g=n,this.h=s,this.c=!1,this.f=Math.max(n,i),this.#i=new L.$zc(h=>a.getComparisonKey(h)),this.#e=t,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(d,o){if(!d){this.clear();return}this.j();let i=[];if(m.URI.isUri(d)){if(!o){this.delete(d);return}this.#i.set(d,o.slice()),i=[d]}else if(Array.isArray(d)){i=[];let a;d=[...d].sort(v.k);for(const t of d){const[r,h]=t;if((!a||r.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=r,i.push(r),this.#i.set(r,[])),h)this.#i.get(r)?.push(...h);else{const u=this.#i.get(r);u&&(u.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let s=0;for(const a of i){let t=[];const r=this.#i.get(a);if(r)if(r.length>this.g){t=[];const h=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const c of r)if(c.severity===h[u]&&t.push({...w.Diagnostic.from(c),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,D.localize)(0,null,r.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(h=>({...w.Diagnostic.from(h),modelVersionId:this.h(a)}));if(n.push([a,t]),s+=t.length,s>this.f)break}this.#e.$changeMany(this.e,n)}delete(d){this.j(),this.#t.fire([d]),this.#i.delete(d),this.#e?.$changeMany(this.e,[[d,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(d,o){this.j();for(const[i,n]of this)d.call(o,i,n,this)}*[Symbol.iterator](){this.j();for(const d of this.#i.keys())yield[d,this.get(d)]}get(d){this.j();const o=this.#i.get(d);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(d){return this.j(),Array.isArray(this.#i.get(d))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(d,o){return d[0].toString()<o[0].toString()?-1:d[0].toString()>o[0].toString()?1:0}}e.$oec=v;let S=class{static{$=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*$.d}static _mapper(d){const o=new L.$zc;for(const i of d)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(d,o,i,n){this.j=o,this.k=i,this.l=n,this.g=new Map,this.h=new b.$Vd({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this.h.event,$._mapper),this.f=d.getProxy(A.$CK.MainThreadDiagnostics)}createDiagnosticCollection(d,o){const{g:i,f:n,h:s,j:a,k:t,l:r}=this,h=new class{$changeMany(l,E){n.$changeMany(l,E),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,l,E.length===0?"CLEARING":E)}$clear(l){n.$clear(l),a.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,l)}dispose(){n.dispose()}};let u;if(!o)o="_generated_diagnostic_collection_name_#"+$.c++,u=o;else if(!i.has(o))u=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do u=o+$.c++;while(i.has(u))}return new class extends v{constructor(){super(o,u,$.e,$.d,l=>r.getDocument(l)?.version,t.extUri,h,s),i.set(u,this)}dispose(){super.dispose(),i.delete(u)}}}getDiagnostics(d){if(d)return this.m(d);{const o=new Map,i=[];for(const n of this.g.values())n.forEach((s,a)=>{let t=o.get(s.toString());typeof t>"u"&&(t=i.length,o.set(s.toString(),t),i.push([s,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(d){let o=[];for(const i of this.g.values())i.has(d)&&(o=o.concat(i.get(d)));return o}$acceptMarkersChange(d){if(!this.n){const o="_generated_mirror",i=new v(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of d)this.n.set(m.URI.revive(o),i.map(w.Diagnostic.to))}};e.$pec=S,e.$pec=S=$=Ke([Be(1,y.$hj),Be(2,P.$nec)],S)}),define(ke[316],Se([1,0,2,6,25]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;class A{constructor(w){this.a=w.getProxy(T.$CK.MainThreadDialogs)}showOpenDialog(w,b){return b?.allowUIResources&&(0,m.$QF)(w,"showLocal"),this.a.$showOpenDialog(b).then(y=>y?y.map(L=>D.URI.revive(L)):void 0)}showSaveDialog(w){return this.a.$showSaveDialog(w).then(b=>b?D.URI.revive(b):void 0)}}e.$wfc=A}),define(ke[317],Se([1,0,8,2,7,6,17,21,13]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;class y{static{this.a=0}constructor(P,$,v){this.d=$,this.e=v,this.b=new Map,this.c=P.getProxy(A.$CK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,$){if(Object.keys(R.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const v=y.a++;this.b.set(v,$),this.c.$registerTextContentProvider(v,P);let S;return typeof $.onDidChange=="function"&&(S=$.onDidChange(g=>{if(g.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this.d.getDocument(g)&&this.$provideTextDocumentContent(v,g).then(d=>{if(!d&&typeof d!="string")return;const o=this.d.getDocument(g);if(!o)return;const i=(0,b.$Te)(d);if(!o.equalLines(i))return this.c.$onVirtualDocumentChange(g,d)},D.$Z)})),new m.$EK(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(P,$){const v=this.b.get(P);return v?Promise.resolve(v.provideTextDocumentContent(T.URI.revive($),w.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$xfc=y}),define(ke[318],Se([1,0,4,3,2,6,142,15,18,24,7,8]),function(be,e,D,T,m,A,R,w,b,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;class ${constructor(S,g){this.a=new D.$Rd({onListenerError:P.$1}),this.b=new D.$Rd({onListenerError:P.$1}),this.c=new D.$Rd({onListenerError:P.$1}),this.d=new D.$Rd({onListenerError:P.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Qc,this.h=new Map,this.f=S.getProxy(A.$CK.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(d=>{for(const o of d)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const o of d)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const g=this.g.getDocument(S);if(g)return g}getDocument(S){const g=this.getDocumentData(S);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return g.document}ensureDocumentData(S){const g=this.g.getDocument(S);if(g)return Promise.resolve(g);let d=this.h.get(S.toString());return d||(d=this.f.$tryOpenDocument(S).then(o=>{this.h.delete(S.toString());const i=m.URI.revive(o);return(0,b.$Nf)(this.g.getDocument(i))},o=>(this.h.delete(S.toString()),Promise.reject(o))),this.h.set(S.toString(),d)),d}createDocumentData(S){return this.f.$tryCreateDocument(S).then(g=>m.URI.revive(g))}$acceptModelLanguageChanged(S,g){const d=m.URI.revive(S),o=this.g.getDocument(d);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(g),this.a.fire(o.document)}$acceptModelSaved(S){const g=m.URI.revive(S),d=this.g.getDocument(g);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(S,g){const d=m.URI.revive(S),o=this.g.getDocument(d);if(!o)throw new Error("unknown document");o._acceptIsDirty(g),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,g,d){const o=m.URI.revive(S),i=this.g.getDocument(o);if(!i)throw new Error("unknown document");i._acceptIsDirty(d),i.onEvents(g);let n;g.isUndoing?n=L.TextDocumentChangeReason.Undo:g.isRedoing&&(n=L.TextDocumentChangeReason.Redo),this.c.fire((0,y.$fn)({document:i.document,contentChanges:g.changes.map(s=>({range:w.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:n}))}setWordDefinitionFor(S,g){(0,R.$GM)(S,g)}}e.$lec=$}),define(ke[69],Se([1,0,60,4,3,2,5,6,142,20,149,15,14,28,17,51,43]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=e.$OM=void 0;class o{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(s,a){this.h=s,this.i=a,this.a=null,this.b=new Map,this.c=new v.$zc,this.d=new T.$Rd,this.e=new T.$Rd,this.f=new T.$Rd,this.g=new T.$Rd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const a=[],t=[],r=[];if(s.removedDocuments)for(const h of s.removedDocuments){const u=A.URI.revive(h),c=this.c.get(u);c?.unref()&&(this.c.delete(u),a.push(c.value))}if(s.addedDocuments)for(const h of s.addedDocuments){const u=A.URI.revive(h.uri);let c=this.c.get(u);if(c&&u.scheme!==S.Schemas.vscodeNotebookCell&&u.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);c||(c=new o(new b.$HM(this.h.getProxy(w.$CK.MainThreadDocuments),u,h.lines,h.EOL,h.versionId,h.languageId,h.isDirty,h.notebook)),this.c.set(u,c),t.push(c.value)),c.ref()}if(s.removedEditors)for(const h of s.removedEditors){const u=this.b.get(h);this.b.delete(h),u&&r.push(u)}if(s.addedEditors)for(const h of s.addedEditors){const u=A.URI.revive(h.documentUri);D.ok(this.c.has(u),`document '${u}' does not exist`),D.ok(!this.b.has(h.id),`editor '${h.id}' already exists!`);const c=this.c.get(u).value,l=new L.$NM(h.id,this.h.getProxy(w.$CK.MainThreadTextEditors),this.i,new d.$U(()=>c.document),h.selections.map(P.Selection.to),h.options,h.visibleRanges.map(E=>P.Range.to(E)),typeof h.editorPosition=="number"?P.ViewColumn.to(h.editorPosition):void 0);this.b.set(h.id,l)}s.newActiveEditor!==void 0&&(D.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,m.$Mc)(a),(0,m.$Mc)(r),s.removedDocuments&&this.e.fire(a),s.addedDocuments&&this.d.fire(t),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(h=>h.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return g.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const a=this.b.get(this.a);return s?a:a?.value}allEditors(){return[...this.b.values()]}};e.$OM=i,e.$OM=i=Ke([Be(0,y.$EM),Be(1,$.$hj)],i),e.$PM=(0,R.$Zh)("IExtHostDocumentsAndEditors")}),define(ke[70],Se([1,0,73,4,18,2,5,6,20,15,7]),function(be,e,D,T,m,A,R,w,b,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=e.$Xec=void 0,e.$Xec=(0,R.$Zh)("IExtHostEditorTabs");class P{constructor(d,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,o={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new L.$jM(A.URI.revive(this.b.input.uri));case 2:return new L.$kM(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case 3:return new L.$lM(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case 6:return new L.$mM(A.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new L.$nM(this.b.input.viewType);case 4:return new L.$oM(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new L.$pM(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new L.$qM;case 9:return new L.$rM(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case 10:return new L.$sM(this.b.input.providerId);default:return}}}class ${constructor(d,o){this.c=[],this.d="",this.b=d,this.e=o;for(const i of d.tabs)i.isActive&&(this.d=i.id),this.c.push(new P(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,o={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return y.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find(i=>i.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===0){const i=new P(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,i),d.tabDto.isActive&&(this.d=i.tabId),i}else if(d.kind===1){const i=this.c.splice(d.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(d.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,i),i}const o=this.c.find(i=>i.tabId===d.tabDto.id);if(!o)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(d.tabDto),o}activeTabId(){return this.d}}let v=class{constructor(d){this.b=new T.$Rd,this.c=new T.$Rd,this.e=[],this.a=d.getProxy(w.$CK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,o={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map(i=>i.apiObject))},get activeTabGroup(){const i=d.d;return(0,m.$Nf)(d.e.find(s=>s.groupId===i)?.apiObject)},close:async(i,n)=>{const s=Array.isArray(i)?i:[i];return s.length?S(s[0])?this.j(s,n):this.i(s,n):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(d){const o=new Set(this.e.map(h=>h.groupId)),i=new Set(d.map(h=>h.groupId)),n=(0,D.$K)(o,i),s=this.e.filter(h=>n.removed.includes(h.groupId)).map(h=>h.apiObject),a=[],t=[];this.e=d.map(h=>{const u=new $(h,()=>this.d);return n.added.includes(u.groupId)?a.push(u.apiObject):t.push(u.apiObject),u});const r=(0,m.$Nf)(d.find(h=>h.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:a,closed:s,changed:t}))}$acceptTabGroupUpdate(d){const o=this.e.find(i=>i.groupId===d.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const o=this.e.find(n=>n.groupId===d.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(d);switch(d.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(d){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===d)return i}h(d){return this.e.find(o=>o.apiObject===d)}async i(d,o){const i=[];for(const n of d){const s=this.g(n);if(!s)throw new Error("Tab close: Invalid tab not found!");i.push(s.tabId)}return this.a.$closeTab(i,o)}async j(d,o){const i=[];for(const n of d){const s=this.h(n);if(!s)throw new Error("Group close: Invalid group not found!");i.push(s.groupId)}return this.a.$closeGroup(i,o)}};e.$Yec=v,e.$Yec=v=Ke([Be(0,b.$EM)],v);function S(g){return g.tabs!==void 0}}),define(ke[319],Se([1,0,6,7]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=void 0;class m{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$CK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,w,b){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(R);if(!y)throw new Error("Embedding vector provider not found");const L=await y.provideEmbeddingVector(w,b);if(!L)throw new Error("Embedding vector provider returned undefined");return L}registerEmbeddingVectorProvider(R,w,b){const y=this.b;return this.b++,this.a.set(y,b),this.c.$registerAiEmbeddingVectorProvider(w,y),new T.$EK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$zfc=m}),define(ke[320],Se([1,0,2,6,3,7,15,172,13,22,25,80]),function(be,e,D,T,m,A,R,w,b,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=void 0;class ${constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const d=this.a.indexOf(g);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),d=[];let o,i,n=14,s=14;for(const a of g){let t=o?(0,b.$8e)(o,a):0;for(t===0?i=1:i=s;t<a.length;t++)t+1===a.length?(n=s,s=9):s+=1,d.push([i,a.toUpperCase().charCodeAt(t),s]),d.push([i,a.toLowerCase().charCodeAt(t),s]),i=s;o=a,s=n}d.push([9,58,10]),d.push([10,47,12]),this.b=new w.$$Y(d)}}provideDocumentLinks(g){this.c();const d=[],o=w.$_Y.computeLinks({getLineContent(i){return g.lineAt(i-1).text},getLineCount(){return g.lineCount}},this.b);for(const i of o){const n=R.DocumentLink.to(i);n.target&&d.push(n)}return d}}class v{constructor(g,d){this.i=d,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(T.$CK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,d,o,i={}){if(v.j(o),this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const n=this.h++;this.b.add(d),this.d.add(d),this.c.set(n,o);let s=2;i.isCaseSensitive&&(s+=1024),i.isReadonly&&(s+=2048),typeof o.copy=="function"&&(s+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,L.$QF)(g,"fsChunks"),s+=4);let a;i.isReadonly&&(0,P.$ck)(i.isReadonly)&&((0,L.$QF)(g,"readonlyMessage"),a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,d,s,a).catch(r=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${d}`),console.error(r)});const t=o.onDidChangeFile(r=>{const h=[];for(const u of r){const{uri:c,type:l}=u;if(c.scheme!==d)continue;let E;switch(l){case A.FileChangeType.Changed:E=0;break;case A.FileChangeType.Created:E=1;break;case A.FileChangeType.Deleted:E=2;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:c,type:E})}this.a.$onFileSystemChange(n,h)});return(0,m.$Pc)(()=>{t.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:d,ctime:o,mtime:i,size:n,permissions:s}=g;return{type:d,ctime:o,mtime:i,size:n,permissions:s}}$stat(g,d){return Promise.resolve(this.l(g).stat(D.URI.revive(d))).then(o=>v.k(o))}$readdir(g,d){return Promise.resolve(this.l(g).readDirectory(D.URI.revive(d)))}$readFile(g,d){return Promise.resolve(this.l(g).readFile(D.URI.revive(d))).then(o=>y.$fe.wrap(o))}$writeFile(g,d,o,i){return Promise.resolve(this.l(g).writeFile(D.URI.revive(d),o.buffer,i))}$delete(g,d,o){return Promise.resolve(this.l(g).delete(D.URI.revive(d),o))}$rename(g,d,o,i){return Promise.resolve(this.l(g).rename(D.URI.revive(d),D.URI.revive(o),i))}$copy(g,d,o,i){const n=this.l(g);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(D.URI.revive(d),D.URI.revive(o),i))}$mkdir(g,d){return Promise.resolve(this.l(g).createDirectory(D.URI.revive(d)))}$watch(g,d,o,i){const n=this.l(g).watch(D.URI.revive(o),i);this.f.set(d,n)}$unwatch(g,d){const o=this.f.get(d);o&&(o.dispose(),this.f.delete(d))}$open(g,d,o){const i=this.l(g);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(d),o))}$close(g,d){const o=this.l(g);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(d))}$read(g,d,o,i){const n=this.l(g);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const s=y.$fe.alloc(i);return Promise.resolve(n.read(d,o,s.buffer,0,i)).then(a=>s.slice(0,a))}$write(g,d,o,i){const n=this.l(g);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(d,o,i.buffer,0,i.byteLength))}l(g){const d=this.c.get(g);if(!d){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return d}}e.$Afc=v}),define(ke[71],Se([1,0,6,32,7,22,5,20,57,3,12,23,17]),function(be,e,D,T,m,A,R,w,b,y,L,P,$){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=e.$Mec=void 0;let S=v=class{constructor(d,o){this.b=new Map,this.c=new L.$9g,this.a=d.getProxy(D.$CK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let s;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),s=await a.impl.stat(n)):s=await i.a.$stat(n),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===T.FilePermission.Readonly?1:void 0}}catch(s){v.e(s)}},async readDirectory(n){try{const s=i.b.get(n.scheme);return s?(await i.a.$ensureActivation(n.scheme),(await s.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(s){return v.e(s)}},async createDirectory(n){try{const s=i.b.get(n.scheme);return s&&!s.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(s.impl,s.extUri,n)):await i.a.$mkdir(n)}catch(s){return v.e(s)}},async readFile(n){try{const s=i.b.get(n.scheme);return s?(await i.a.$ensureActivation(n.scheme),(await s.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(s){return v.e(s)}},async writeFile(n,s){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n).queue(()=>Promise.resolve(a.impl.writeFile(n,s,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,A.$fe.wrap(s))}catch(a){return v.e(a)}},async delete(n,s){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...s})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(a){return v.e(a)}},async rename(n,s,a){try{return await i.a.$rename(n,s,{overwrite:!1,...a})}catch(t){return v.e(t)}},async copy(n,s,a){try{return await i.a.$copy(n,s,{overwrite:!1,...a})}catch(t){return v.e(t)}},isWritableFileSystem(n){const s=o.getCapabilities(n);if(typeof s=="number")return!(s&2048)}})}async d(d,o,i){const n=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await d.stat(i)).type&T.FileType.Directory))throw m.$RL.FileExists(`Unable to create folder '${i.scheme===$.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(T.$yk(s)!==T.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(o.basename(i)),i=o.dirname(i)}for(let s=n.length-1;s>=0;s--){i=o.joinPath(i,n[s]);try{await d.createDirectory(i)}catch(a){if(T.$yk(a)!==T.FileSystemProviderErrorCode.FileExists)throw a}}}static e(d){if(d instanceof m.$RL)throw d;if(d instanceof T.$uk)switch(d.code){case T.FileSystemProviderErrorCode.FileExists:throw m.$RL.FileExists(d.message);case T.FileSystemProviderErrorCode.FileNotFound:throw m.$RL.FileNotFound(d.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw m.$RL.FileNotADirectory(d.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw m.$RL.FileIsADirectory(d.message);case T.FileSystemProviderErrorCode.NoPermissions:throw m.$RL.NoPermissions(d.message);case T.FileSystemProviderErrorCode.Unavailable:throw m.$RL.Unavailable(d.message);default:throw new m.$RL(d.message,d.name)}if(!(d instanceof Error))throw new m.$RL(String(d));if(d.name==="ENOPRO"||d.message.includes("ENOPRO"))throw m.$RL.Unavailable(d.message);switch(d.name){case T.FileSystemProviderErrorCode.FileExists:throw m.$RL.FileExists(d.message);case T.FileSystemProviderErrorCode.FileNotFound:throw m.$RL.FileNotFound(d.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw m.$RL.FileNotADirectory(d.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw m.$RL.FileIsADirectory(d.message);case T.FileSystemProviderErrorCode.NoPermissions:throw m.$RL.NoPermissions(d.message);case T.FileSystemProviderErrorCode.Unavailable:throw m.$RL.Unavailable(d.message);default:throw new m.$RL(d.message,d.name)}}addFileSystemProvider(d,o,i){return this.b.set(d,{impl:o,extUri:i?.isCaseSensitive?P.$rg:P.$tg,isReadonly:!!i?.isReadonly}),(0,y.$Pc)(()=>this.b.delete(d))}getFileSystemProviderExtUri(d){return this.b.get(d)?.extUri??P.$rg}};e.$Mec=S,e.$Mec=S=v=Ke([Be(0,w.$EM),Be(1,b.$nec)],S),e.$Nec=(0,R.$Zh)("IExtHostConsumerFileSystem")}),define(ke[321],Se([1,0,4,34,2,6,15,7,43]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,S,g,d,o,i){this.a=Math.random(),this.b=new D.$Rd,this.c=new D.$Rd,this.d=new D.$Rd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,T.$Gj)(o),s=typeof o=="string",a=i?.correlate,t=d(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(a&&typeof r.session>"u")){if(!i?.ignoreCreateEvents)for(const h of r.created){const u=m.URI.revive(h);n(u.fsPath)&&(!s||S.getWorkspaceFolder(u))&&this.b.fire(u)}if(!i?.ignoreChangeEvents)for(const h of r.changed){const u=m.URI.revive(h);n(u.fsPath)&&(!s||S.getWorkspaceFolder(u))&&this.c.fire(u)}if(!i?.ignoreDeleteEvents)for(const h of r.deleted){const u=m.URI.revive(h);n(u.fsPath)&&(!s||S.getWorkspaceFolder(u))&&this.d.fire(u)}}});this.g=w.$EK.from(this.i(v,g,o,i,i?.correlate),this.b,this.c,this.d,t)}i(v,S,g,d,o){const i=w.$EK.from();if(typeof g=="string")return i;const n=v.getProxy(A.$CK.MainThreadFileSystemEventService);let s=!1;return(g.pattern.includes(T.$Cj)||g.pattern.includes(T.$Dj))&&(s=!0),n.$watch(S.identifier.value,this.a,g.baseUri,{recursive:s,excludes:d?.excludes??[]},!!o),w.$EK.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class L{constructor(v){this.a=v,this.session=this.a.session,this.b=new b.$U(()=>this.a.created.map(m.URI.revive)),this.c=new b.$U(()=>this.a.changed.map(m.URI.revive)),this.d=new b.$U(()=>this.a.deleted.map(m.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(v,S,g){this.j=v,this.k=S,this.l=g,this.a=new D.$Rd,this.b=new D.$Rd,this.c=new D.$Rd,this.d=new D.$Rd,this.g=new D.$Td,this.h=new D.$Td,this.i=new D.$Td,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,S,g,d){return new y(this.j,v,S,this.a.event,R.GlobPattern.from(g),d)}$onFileEvent(v){this.a.fire(new L(v))}$onDidRunFileOperation(v,S){switch(v){case 2:this.b.fire(Object.freeze({files:S.map(g=>({oldUri:m.URI.revive(g.source),newUri:m.URI.revive(g.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(g=>m.URI.revive(g.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(g=>m.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,S){return(g,d,o)=>{const i=function(s){g.call(d,s)};return i.extension=v,S.event(i,void 0,o)}}async $onWillRunFileOperation(v,S,g,d){switch(v){case 2:return await this.n(this.g,{files:S.map(o=>({oldUri:m.URI.revive(o.source),newUri:m.URI.revive(o.target)}))},g,d);case 1:return await this.n(this.i,{files:S.map(o=>m.URI.revive(o.target))},g,d);case 0:case 3:return await this.n(this.h,{files:S.map(o=>m.URI.revive(o.target))},g,d)}}async n(v,S,g,d){const o=new Set,i=[];if(await v.fireAsync(S,d,async(s,a)=>{const t=Date.now(),r=await Promise.resolve(s);r instanceof w.$OK&&(i.push([a.extension,r]),o.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>g&&this.k.warn("SLOW file-participant",a.extension.identifier)}),d.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,s]of i){const{edits:a}=R.WorkspaceEdit.from(s,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(o)}}}e.$Bfc=P}),define(ke[322],Se([1,0,3,2,6,15,7,35,12]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=void 0;class y{static{this.a=0}constructor(v,S){this.extension=v,this.provider=S,this.handle=y.a++}}class L{constructor(v){this.session=v,this.responses=[]}}class P{static{this.a=0}constructor(v,S,g,d){this.f=g,this.g=d,this.b=new Map,this.d=new Map,this.e=v.getProxy(m.$CK.MainThreadInlineChat),S.registerApiCommand(new w.$5M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new w.$3M("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?A.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?A.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?A.Position.from(o.position):void 0}})],w.$4M.Void))}registerProvider(v,S,g){const d=new y(v,S);return this.b.set(d.handle,d),this.e.$registerInteractiveEditorProvider(d.handle,g?.label??v.displayName??v.name,v.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",g?.supportReportIssue??!1),(0,D.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(d.handle),this.b.delete(d.handle)})}async $prepareSession(v,S,g,d){const o=this.b.get(v);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(T.URI.revive(S)),n=A.Selection.to(g),s=await o.provider.prepareInteractiveEditorSession({document:i,selection:n},d);if(!s)return;if(s.wholeRange&&!s.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=P.a++;return this.d.set(a,new L(s)),{id:a,placeholder:s.placeholder,input:s.input,slashCommands:s.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:A.Range.from(s.wholeRange),message:s.message}}async $provideResponse(v,S,g,d){const o=this.b.get(v);if(!o)return;const i=this.d.get(S.id);if(!i)return;const n={prompt:g.prompt,selection:A.Selection.to(g.selection),wholeRange:A.Range.to(g.wholeRange),attempt:g.attempt,live:g.live};let s=!1;const a={report:async c=>{if(!g.live&&c.edits?.length)throw new Error("Progress reporting is only supported for live sessions");s||d.isCancellationRequested||await this.e.$handleProgressChunk(g.requestId,{message:c.message,edits:c.edits?.map(A.TextEdit.from),editsShouldBeInstant:c.editsShouldBeInstant,slashCommand:c.slashCommand?.command,markdownFragment:R.$5K.isMarkdownString(c.content)?c.content.value:c.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,n,a,d));let r;try{r=await(0,b.$Og)(t,d)}finally{s=!0}if(!r)return;const h=i.responses.push(r)-1,u={wholeRange:A.Range.from(r.wholeRange),placeholder:r.placeholder};if(P.h(r)){const{edits:c,contents:l}=r,E=l!==void 0?A.MarkdownString.from(l):void 0;return c instanceof R.$OK?{...u,id:h,type:"bulkEdit",edits:A.WorkspaceEdit.from(c),message:E}:{...u,id:h,type:"editorEdit",edits:c.map(A.TextEdit.from),message:E}}return{...u,id:h,type:"message",message:A.MarkdownString.from(r.contents)}}async $provideFollowups(v,S,g,d){const o=this.b.get(v),i=this.d.get(S),n=i?.responses[g];if(o&&n&&o.provider.provideFollowups){const s=Promise.resolve(o.provider.provideFollowups(i.session,n,d));return(await(0,b.$Og)(s,d))?.map(A.ChatReplyFollowup.from)}}$handleFeedback(v,S,g,d){const o=this.b.get(v),i=this.d.get(S),n=i?.responses[g];if(o&&n){const s=A.InteractiveEditorResponseFeedbackKind.to(d);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,s)}}$releaseSession(v,S){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$Cfc=P}),define(ke[323],Se([1,0,2,35]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=void 0;class m{constructor(R,w,b,y,L){this.a=w,this.b=b,this.c=y;const P=new T.$5M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$3M("showOptions","Show Options",$=>!0,$=>$),new T.$3M("resource","Interactive resource Uri",$=>!0,$=>$),new T.$3M("controllerId","Notebook controller Id",$=>!0,$=>$),new T.$3M("title","Interactive editor title",$=>!0,$=>$)],new T.$4M("Notebook and input URI",$=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const v=this.a.getEditorById($.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:D.URI.revive($.notebookUri),inputUri:D.URI.revive($.inputUri),notebookEditor:v.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:D.URI.revive($.notebookUri),inputUri:D.URI.revive($.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(R,w,b,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:w,lines:[""],languageId:b,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,w){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Pfc=m}),define(ke[324],Se([1,0,6,7]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=void 0;class m{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(D.$CK.MainThreadIssueReporter)}async $getIssueReporterUri(R,w){if(this.a.size===0)throw new Error("No issue request handlers registered");const b=this.a.get(R);if(!b)throw new Error("Issue request handler not found");const y=await b.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(R,w){if(this.b.size===0)throw new Error("No issue request handlers registered");const b=this.b.get(R);if(!b)throw new Error("Issue data provider not found");const y=await b.provideIssueData(w);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(R,w){if(this.b.size===0)throw new Error("No issue request handlers registered");const b=this.b.get(R);if(!b)throw new Error("Issue data provider not found");const y=await b.provideIssueTemplate(w);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(R,w){const b=R.identifier.value;return this.a.set(b,w),this.c.$registerIssueUriRequestHandler(b),new T.$EK(()=>{this.c.$unregisterIssueUriRequestHandler(b),this.a.delete(b)})}registerIssueDataProvider(R,w){const b=R.identifier.value;return this.b.set(b,w),this.c.$registerIssueDataProvider(b),new T.$EK(()=>{this.c.$unregisterIssueDataProvider(b),this.b.delete(b)})}}e.$Qfc=m}),define(ke[325],Se([1,0,3,6]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0;class m{constructor(R){this.b=0,this.a=R.getProxy(T.$CK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const w=this.b++;return this.a.$registerResourceLabelFormatter(w,R),(0,D.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(w)})}}e.$Rfc=m}),define(ke[326],Se([1,0,2,24,15,7,83,6,13,29,19,18,168,21,26,3,132,122,110,38,8,12,25,212]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=void 0;class h{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentSymbols(B,Y){const se=this.d.getDocument(B),oe=await this.e.provideDocumentSymbols(se,Y);if(!(0,L.$Jb)(oe))return oe[0]instanceof A.$WK?oe.map(m.DocumentSymbol.from):h.f(oe)}static f(B){B=B.slice(0).sort((oe,_)=>{let ge=oe.location.range.start.compareTo(_.location.range.start);return ge===0&&(ge=_.location.range.end.compareTo(oe.location.range.end)),ge});const Y=[],se=[];for(const oe of B){const _={name:oe.name||"!!MISSING: name!!",kind:m.SymbolKind.from(oe.kind),tags:oe.tags?.map(m.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:m.Range.from(oe.location.range),selectionRange:m.Range.from(oe.location.range),children:[]};for(;;){if(se.length===0){se.push(_),Y.push(_);break}const ge=se[se.length-1];if(y.$Ds.containsRange(ge.range,_.range)&&!y.$Ds.equalsRange(ge.range,_.range)){ge.children?.push(_),se.push(_);break}se.pop()}}return Y}}class u{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,Y,se){this.g=B,this.h=Y,this.j=se,this.e=new i.$jec("CodeLens"),this.f=new Map}async provideCodeLenses(B,Y){const se=this.g.getDocument(B),oe=await this.j.provideCodeLenses(se,Y);if(!oe||Y.isCancellationRequested)return;const _=this.e.add(oe),ge=new g.$Qc;this.f.set(_,ge);const ve={cacheId:_,lenses:[]};for(let ze=0;ze<oe.length;ze++)ve.lenses.push({cacheId:[_,ze],range:m.Range.from(oe[ze].range),command:this.h.toInternal(oe[ze].command,ge)});return ve}async resolveCodeLens(B,Y){const se=B.cacheId&&this.e.get(...B.cacheId);if(!se)return;let oe;if(typeof this.j.resolveCodeLens!="function"||se.isResolved?oe=se:oe=await this.j.resolveCodeLens(se,Y),oe||(oe=se),Y.isCancellationRequested)return;const _=B.cacheId&&this.f.get(B.cacheId[0]);if(_)return B.command=this.h.toInternal(oe.command??u.d,_),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function c(Ce){return Array.isArray(Ce)?Ce.map(m.DefinitionLink.from):Ce?[m.DefinitionLink.from(Ce)]:[]}class l{constructor(B,Y){this.d=B,this.e=Y}async provideDefinition(B,Y,se){const oe=this.d.getDocument(B),_=m.Position.to(Y),ge=await this.e.provideDefinition(oe,_,se);return c(ge)}}class E{constructor(B,Y){this.d=B,this.e=Y}async provideDeclaration(B,Y,se){const oe=this.d.getDocument(B),_=m.Position.to(Y),ge=await this.e.provideDeclaration(oe,_,se);return c(ge)}}class C{constructor(B,Y){this.d=B,this.e=Y}async provideImplementation(B,Y,se){const oe=this.d.getDocument(B),_=m.Position.to(Y),ge=await this.e.provideImplementation(oe,_,se);return c(ge)}}class f{constructor(B,Y){this.d=B,this.e=Y}async provideTypeDefinition(B,Y,se){const oe=this.d.getDocument(B),_=m.Position.to(Y),ge=await this.e.provideTypeDefinition(oe,_,se);return c(ge)}}class p{constructor(B,Y){this.d=B,this.e=Y}async provideHover(B,Y,se){const oe=this.d.getDocument(B),_=m.Position.to(Y),ge=await this.e.provideHover(oe,_,se);if(!(!ge||(0,L.$Jb)(ge.contents)))return ge.range||(ge.range=oe.getWordRangeAtPosition(_)),ge.range||(ge.range=new A.$GK(_,_)),m.Hover.from(ge)}}class k{constructor(B,Y){this.d=B,this.e=Y}async provideEvaluatableExpression(B,Y,se){const oe=this.d.getDocument(B),_=m.Position.to(Y),ge=await this.e.provideEvaluatableExpression(oe,_,se);if(ge)return m.EvaluatableExpression.from(ge)}}class I{constructor(B,Y){this.d=B,this.e=Y}async provideInlineValues(B,Y,se,oe){const _=this.d.getDocument(B),ge=await this.e.provideInlineValues(_,m.Range.to(Y),m.InlineValueContext.to(se),oe);if(Array.isArray(ge))return ge.map(ve=>m.InlineValue.from(ve))}}class j{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentHighlights(B,Y,se){const oe=this.d.getDocument(B),_=m.Position.to(Y),ge=await this.e.provideDocumentHighlights(oe,_,se);if(Array.isArray(ge))return ge.map(m.DocumentHighlight.from)}}class z{constructor(B,Y){this.d=B,this.e=Y}async provideLinkedEditingRanges(B,Y,se){const oe=this.d.getDocument(B),_=m.Position.to(Y),ge=await this.e.provideLinkedEditingRanges(oe,_,se);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,L.$Gb)(ge.ranges.map(m.Range.from)),wordPattern:ge.wordPattern}}}class M{constructor(B,Y){this.d=B,this.e=Y}async provideReferences(B,Y,se,oe){const _=this.d.getDocument(B),ge=m.Position.to(Y),ve=await this.e.provideReferences(_,ge,se,oe);if(Array.isArray(ve))return ve.map(m.location.from)}}class F{static{this.d=1e3}constructor(B,Y,se,oe,_,ge,ve){this.g=B,this.h=Y,this.j=se,this.k=oe,this.l=_,this.m=ge,this.n=ve,this.e=new i.$jec("CodeAction"),this.f=new Map}async provideCodeActions(B,Y,se,oe){const _=this.g.getDocument(B),ge=$.$Fs.isISelection(Y)?m.Selection.to(Y):m.Range.to(Y),ve=[];for(const nt of this.j.getDiagnostics(B))if(ge.intersection(nt.range)&&ve.push(nt)>F.d)break;const ze={diagnostics:ve,only:se.only?new A.$YK(se.only):void 0,triggerKind:m.CodeActionTriggerKind.to(se.trigger)},We=await this.k.provideCodeActions(_,ge,ze,oe);if(!(0,L.$Kb)(We)||oe.isCancellationRequested)return;const tt=this.e.add(We),Ye=new g.$Qc;this.f.set(tt,Ye);const rt=[];for(let nt=0;nt<We.length;nt++){const Ae=We[nt];Ae&&(F.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ye)})):(ze.only&&(Ae.kind?ze.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[tt,nt],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ye),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(m.Diagnostic.from),edit:Ae.edit&&m.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$PF)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:tt,actions:rt}}async resolveCodeAction(B,Y){const[se,oe]=B,_=this.e.get(se,oe);if(!_||F.o(_))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(_,Y)??_;let ve;ge.edit&&(ve=m.WorkspaceEdit.from(ge.edit,void 0));let ze;if(ge.command){const We=this.f.get(se);We&&(ze=this.h.toInternal(ge.command,We))}return{edit:ve,command:ze}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class N{static toInternalProviderId(B,Y){return B+"."+Y}constructor(B,Y,se,oe,_){this.d=B,this.e=Y,this.f=se,this.g=oe,this.h=_}async prepareDocumentPaste(B,Y,se,oe){if(!this.f.prepareDocumentPaste)return;const _=this.e.getDocument(B),ge=Y.map(We=>m.Range.to(We)),ve=m.DataTransfer.toDataTransfer(se,()=>{throw new s.$0});if(await this.f.prepareDocumentPaste(_,ge,ve,oe),oe.isCancellationRequested)return;const ze=Array.from(ve).filter(([,We])=>!(We instanceof A.$sL));return m.DataTransfer.from(ze)}async providePasteEdits(B,Y,se,oe,_){if(!this.f.provideDocumentPasteEdits)return;const ge=this.e.getDocument(Y),ve=se.map(tt=>m.Range.to(tt)),ze=m.DataTransfer.toDataTransfer(oe,async tt=>(await this.d.$resolvePasteFileData(this.g,B,tt)).buffer),We=await this.f.provideDocumentPasteEdits(ge,ve,ze,_);if(We)return{label:We.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(tt=>"mimeType"in tt?tt:{providerId:N.toInternalProviderId(tt.extensionId,tt.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?m.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class O{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentFormattingEdits(B,Y,se){const oe=this.d.getDocument(B),_=await this.e.provideDocumentFormattingEdits(oe,Y,se);if(Array.isArray(_))return _.map(m.TextEdit.from)}}class W{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentRangeFormattingEdits(B,Y,se,oe){const _=this.d.getDocument(B),ge=m.Range.to(Y),ve=await this.e.provideDocumentRangeFormattingEdits(_,ge,se,oe);if(Array.isArray(ve))return ve.map(m.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Y,se,oe){(0,P.$Mf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const _=this.d.getDocument(B),ge=Y.map(m.Range.to),ve=await this.e.provideDocumentRangesFormattingEdits(_,ge,se,oe);if(Array.isArray(ve))return ve.map(m.TextEdit.from)}}class x{constructor(B,Y){this.d=B,this.e=Y,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Y,se,oe,_){const ge=this.d.getDocument(B),ve=m.Position.to(Y),ze=await this.e.provideOnTypeFormattingEdits(ge,ve,se,oe,_);if(Array.isArray(ze))return ze.map(m.TextEdit.from)}}class ue{constructor(B,Y){this.e=B,this.f=Y,this.d=new i.$jec("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Y){const se=await this.e.provideWorkspaceSymbols(B,Y);if(!(0,L.$Kb)(se))return{symbols:[]};const oe=this.d.add(se),_={cacheId:oe,symbols:[]};for(let ge=0;ge<se.length;ge++){const ve=se[ge];if(!ve||!ve.name){this.f.warn("INVALID SymbolInformation",ve);continue}_.symbols.push({...m.WorkspaceSymbol.from(ve),cacheId:[oe,ge]})}return _}async resolveWorkspaceSymbol(B,Y){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const se=this.d.get(...B.cacheId);if(se){const oe=await this.e.resolveWorkspaceSymbol(se,Y);return oe&&(0,T.$hn)(B,m.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class X{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Y,se){this.d=B,this.e=Y,this.f=se}async provideRenameEdits(B,Y,se,oe){const _=this.d.getDocument(B),ge=m.Position.to(Y);try{const ve=await this.e.provideRenameEdits(_,ge,se,oe);return ve?m.WorkspaceEdit.from(ve):void 0}catch(ve){const ze=X.g(ve);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(B,Y,se){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const oe=this.d.getDocument(B),_=m.Position.to(Y);try{const ge=await this.e.prepareRename(oe,_,se);let ve,ze;if(A.$GK.isRange(ge)?(ve=ge,ze=oe.getText(ge)):(0,P.$Ef)(ge)&&(ve=ge.range,ze=ge.placeholder),!ve||!ze)return;if(ve.start.line>_.line||ve.end.line<_.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:m.Range.from(ve),text:ze}}catch(ge){const ve=X.g(ge);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(ge)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class J{constructor(B,Y){this.resultId=B,this.tokens=Y}}class Q{constructor(B,Y){this.f=B,this.g=Y,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Y,se){const oe=this.f.getDocument(B),_=Y!==0?this.d.get(Y):null;let ge=typeof _?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(oe,_.resultId,se):await this.g.provideDocumentSemanticTokens(oe,se);return _&&this.d.delete(Y),ge?(ge=Q.h(ge),this.o(Q.n(_,ge),ge)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return Q.j(B)?Q.k(B)?B:new A.$VL(new Uint32Array(B.data),B.resultId):Q.l(B)?Q.m(B)?B:new A.$XL(B.edits.map(Y=>new A.$WL(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Y of B.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static n(B,Y){if(!Q.j(Y)||!B||!B.tokens)return Y;const se=B.tokens,oe=se.length,_=Y.data,ge=_.length;let ve=0;const ze=Math.min(oe,ge);for(;ve<ze&&se[ve]===_[ve];)ve++;if(ve===oe&&ve===ge)return new A.$XL([],Y.resultId);let We=0;const tt=ze-ve;for(;We<tt&&se[oe-We-1]===_[ge-We-1];)We++;return new A.$XL([{start:ve,deleteCount:oe-ve-We,data:_.subarray(ve,ge-We)}],Y.resultId)}o(B,Y){if(Q.j(B)){const se=this.e++;return this.d.set(se,new J(B.resultId,B.data)),(0,d.$80)({id:se,type:"full",data:B.data})}if(Q.l(B)){const se=this.e++;return Q.j(Y)?this.d.set(se,new J(Y.resultId,Y.data)):this.d.set(se,new J(B.resultId)),(0,d.$80)({id:se,type:"delta",deltas:(B.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}class he{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentRangeSemanticTokens(B,Y,se){const oe=this.d.getDocument(B),_=await this.e.provideDocumentRangeSemanticTokens(oe,m.Range.to(Y),se);return _?this.f(_):null}f(B){return(0,d.$80)({id:0,type:"full",data:B.data})}}class Z{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Y,se,oe,_){this.f=B,this.g=Y,this.h=se,this.j=oe,this.k=_,this.d=new i.$jec("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Y,se,oe){const _=this.f.getDocument(B),ge=m.Position.to(Y),ve=_.getWordRangeAtPosition(ge)||new A.$GK(ge,ge),ze=ve.with({end:ge}),We=new n.$Nd,tt=await this.h.provideCompletionItems(_,ge,oe,m.CompletionContext.to(se));if(!tt||oe.isCancellationRequested)return;const Ye=Array.isArray(tt)?new A.$_K(tt):tt,rt=Z.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),nt=new g.$Qc;this.e.set(rt,nt);const Ae=[],Oe={x:rt,b:Ae,a:{replace:m.Range.from(ve),insert:m.Range.from(ze)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let qe=0;qe<Ye.items.length;qe++){const Me=Ye.items[qe],Xe=this.l(Me,[rt,qe],ze,ve);Ae.push(Xe)}return Oe}async resolveCompletionItem(B,Y){if(typeof this.h.resolveCompletionItem!="function")return;const se=this.d.get(...B);if(!se)return;const oe=this.l(se,B),_=await this.h.resolveCompletionItem(se,Y);if(!_)return;const ge=this.l(_,B);return(oe.h!==ge.h||oe.i!==ge.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(oe.n!==ge.n||oe.o!==ge.o||!(0,T.$in)(oe.p,ge.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...oe,d:ge.d,c:ge.c,l:ge.l,h:ge.h,i:ge.i,n:ge.n,o:ge.o,p:ge.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Y,se,oe){const _=this.e.get(Y[0]);if(!_)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(B.command,_),ve={x:Y,a:B.label,b:B.kind!==void 0?m.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(m.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:m.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(m.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ve.h=B.textEdit.newText):typeof B.insertText=="string"?ve.h=B.insertText:B.insertText instanceof A.$PK&&(ve.h=B.insertText.value,ve.i|=4);let ze;return B.textEdit?ze=B.textEdit.range:B.range&&(ze=B.range),A.$GK.isRange(ze)?ve.j=m.Range.from(ze):ze&&(!se?.isEqual(ze.inserting)||!oe?.isEqual(ze.replacing))&&(ve.j={insert:m.Range.from(ze.inserting),replace:m.Range.from(ze.replacing)}),ve}}class ye{async provideInlineCompletions(B,Y,se,oe){}disposeCompletions(B){}handleDidShowCompletionItem(B,Y,se){}handlePartialAccept(B,Y,se){}}class de extends ye{constructor(B,Y,se,oe){super(),this.f=B,this.g=Y,this.h=se,this.j=oe,this.d=new H,this.e=(0,t.$PF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$PF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Y,se,oe){const _=this.g.getDocument(B),ge=m.Position.to(Y),ve=await this.h.provideInlineCompletionItems(_,ge,{selectedCompletionInfo:se.selectedSuggestionInfo?{range:m.Range.to(se.selectedSuggestionInfo.range),text:se.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[se.triggerKind]},oe);if(!ve||oe.isCancellationRequested)return;const ze=Array.isArray(ve)?ve:ve.items,We=this.e?Array.isArray(ve)?[]:ve.commands||[]:[],tt=this.e&&!Array.isArray(ve)?ve.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:ze}),items:ze.map((nt,Ae)=>{let Oe;nt.command&&(Ye||(Ye=new g.$Qc),Oe=this.j.toInternal(nt.command,Ye));const qe=nt.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:nt.filterText,range:nt.range?m.Range.from(nt.range):void 0,command:Oe,idx:Ae,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:We.map(nt=>(Ye||(Ye=new g.$Qc),this.j.toInternal(nt,Ye))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Y,se){const oe=this.d.get(B)?.items[Y];oe&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(oe,se)}handlePartialAccept(B,Y,se){const oe=this.d.get(B)?.items[Y];oe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(oe,se)}}class H{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Y=this.e++;return this.d.set(Y,B),Y}disposeReferenceId(B){const Y=this.d.get(B);return this.d.delete(B),Y}get(B){return this.d.get(B)}}class U{constructor(B,Y){this.e=B,this.f=Y,this.d=new i.$jec("SignatureHelp")}async provideSignatureHelp(B,Y,se,oe){const _=this.e.getDocument(B),ge=m.Position.to(Y),ve=this.g(se),ze=await this.f.provideSignatureHelp(_,ge,oe,ve);if(ze){const We=this.d.add([ze]);return{...m.SignatureHelp.from(ze),id:We}}}g(B){let Y;if(B.activeSignatureHelp){const se=m.SignatureHelp.to(B.activeSignatureHelp),oe=this.d.get(B.activeSignatureHelp.id,0);oe?(Y=oe,Y.activeSignature=se.activeSignature,Y.activeParameter=se.activeParameter):Y=se}return{...B,activeSignatureHelp:Y}}releaseSignatureHelp(B){this.d.delete(B)}}class ne{constructor(B,Y,se,oe,_){this.f=B,this.g=Y,this.h=se,this.j=oe,this.k=_,this.d=new i.$jec("InlayHints"),this.e=new Map}async provideInlayHints(B,Y,se){const oe=this.f.getDocument(B),_=m.Range.to(Y),ge=await this.h.provideInlayHints(oe,_,se);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Y)}`);return}if(se.isCancellationRequested)return;const ve=this.d.add(ge);this.e.set(ve,new g.$Qc);const ze={hints:[],cacheId:ve};for(let We=0;We<ge.length;We++)this.l(ge[We],_)&&ze.hints.push(this.m(ge[We],[ve,We]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Y)}`),ze}async resolveInlayHint(B,Y){if(typeof this.h.resolveInlayHint!="function")return;const se=this.d.get(...B);if(!se)return;const oe=await this.h.resolveInlayHint(se,Y);if(oe&&this.l(oe))return this.m(oe,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Y){return B.label.length===0||Array.isArray(B.label)&&B.label.every(se=>se.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Y&&!Y.contains(B.position))}m(B,Y){const se=this.e.get(Y[0]);if(!se)throw Error("DisposableStore is missing...");const oe={label:"",cacheId:Y,tooltip:m.MarkdownString.fromStrict(B.tooltip),position:m.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(m.TextEdit.from),kind:B.kind&&m.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?oe.label=B.label:oe.label=B.label.map(_=>{const ge={label:_.value};return ge.tooltip=m.MarkdownString.fromStrict(_.tooltip),A.$QK.isLocation(_.location)&&(ge.location=m.location.from(_.location)),_.command&&(ge.command=this.g.toInternal(_.command,se)),ge}),oe}}class Ee{constructor(B,Y){this.e=B,this.f=Y,this.d=new i.$jec("DocumentLink")}async provideLinks(B,Y){const se=this.e.getDocument(B),oe=await this.f.provideDocumentLinks(se,Y);if(!(!Array.isArray(oe)||oe.length===0)&&!Y.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:oe.filter(Ee.g).map(m.DocumentLink.from)};{const _=this.d.add(oe),ge={links:[],cacheId:_};for(let ve=0;ve<oe.length;ve++){if(!Ee.g(oe[ve]))continue;const ze=m.DocumentLink.from(oe[ve]);ze.cacheId=[_,ve],ge.links.push(ze)}return ge}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Y){if(typeof this.f.resolveDocumentLink!="function")return;const se=this.d.get(...B);if(!se)return;const oe=await this.f.resolveDocumentLink(se,Y);if(!(!oe||!Ee.g(oe)))return m.DocumentLink.from(oe)}releaseLinks(B){this.d.delete(B)}}class fe{constructor(B,Y){this.d=B,this.e=Y}async provideColors(B,Y){const se=this.d.getDocument(B),oe=await this.e.provideDocumentColors(se,Y);return Array.isArray(oe)?oe.map(ge=>({color:m.Color.from(ge.color),range:m.Range.from(ge.range)})):[]}async provideColorPresentations(B,Y,se){const oe=this.d.getDocument(B),_=m.Range.to(Y.range),ge=m.Color.to(Y.color),ve=await this.e.provideColorPresentations(ge,{document:oe,range:_},se);if(Array.isArray(ve))return ve.map(m.ColorPresentation.from)}}class me{constructor(B,Y){this.d=B,this.e=Y}async provideFoldingRanges(B,Y,se){const oe=this.d.getDocument(B),_=await this.e.provideFoldingRanges(oe,Y,se);if(Array.isArray(_))return _.map(m.FoldingRange.from)}}class ee{constructor(B,Y,se){this.d=B,this.e=Y,this.f=se}async provideSelectionRanges(B,Y,se){const oe=this.d.getDocument(B),_=Y.map(m.Position.to),ge=await this.e.provideSelectionRanges(oe,_,se);if(!(0,L.$Kb)(ge))return[];if(ge.length!==_.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let ze=0;ze<_.length;ze++){const We=[];ve.push(We);let tt=_[ze],Ye=ge[ze];for(;;){if(!Ye.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(We.push(m.SelectionRange.from(Ye)),!Ye.parent)break;tt=Ye.range,Ye=Ye.parent}}return ve}}class te{constructor(B,Y){this.f=B,this.g=Y,this.d=new o.$JM(""),this.e=new Map}async prepareSession(B,Y,se){const oe=this.f.getDocument(B),_=m.Position.to(Y),ge=await this.g.prepareCallHierarchy(oe,_,se);if(!ge)return;const ve=this.d.nextId();return this.e.set(ve,new Map),Array.isArray(ge)?ge.map(ze=>this.h(ve,ze)):[this.h(ve,ge)]}async provideCallsTo(B,Y,se){const oe=this.j(B,Y);if(!oe)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyIncomingCalls(oe,se);if(_)return _.map(ge=>({from:this.h(B,ge.from),fromRanges:ge.fromRanges.map(ve=>m.Range.from(ve))}))}async provideCallsFrom(B,Y,se){const oe=this.j(B,Y);if(!oe)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyOutgoingCalls(oe,se);if(_)return _.map(ge=>({to:this.h(B,ge.to),fromRanges:ge.fromRanges.map(ve=>m.Range.from(ve))}))}releaseSession(B){this.e.delete(B)}h(B,Y){const se=this.e.get(B),oe=m.CallHierarchyItem.from(Y,B,se.size.toString(36));return se.set(oe._itemId,Y),oe}j(B,Y){return this.e.get(B)?.get(Y)}}class K{constructor(B,Y){this.f=B,this.g=Y,this.d=new o.$JM(""),this.e=new Map}async prepareSession(B,Y,se){const oe=this.f.getDocument(B),_=m.Position.to(Y),ge=await this.g.prepareTypeHierarchy(oe,_,se);if(!ge)return;const ve=this.d.nextId();return this.e.set(ve,new Map),Array.isArray(ge)?ge.map(ze=>this.h(ve,ze)):[this.h(ve,ge)]}async provideSupertypes(B,Y,se){const oe=this.j(B,Y);if(!oe)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySupertypes(oe,se);if(_)return _.map(ge=>this.h(B,ge))}async provideSubtypes(B,Y,se){const oe=this.j(B,Y);if(!oe)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySubtypes(oe,se);if(_)return _.map(ge=>this.h(B,ge))}releaseSession(B){this.e.delete(B)}h(B,Y){const se=this.e.get(B),oe=m.TypeHierarchyItem.from(Y,B,se.size.toString(36));return se.set(oe._itemId,Y),oe}j(B,Y){return this.e.get(B)?.get(Y)}}class ie{static toInternalProviderId(B,Y){return B+"."+Y}constructor(B,Y,se,oe,_){this.d=B,this.e=Y,this.f=se,this.g=oe,this.h=_}async provideDocumentOnDropEdits(B,Y,se,oe,_){const ge=this.e.getDocument(Y),ve=m.Position.to(se),ze=m.DataTransfer.toDataTransfer(oe,async tt=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,tt)).buffer),We=await this.f.provideDocumentDropEdits(ge,ve,ze,_);if(We)return{label:We.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(tt=>"mimeType"in tt?tt:{providerId:ie.toInternalProviderId(tt.extensionId,tt.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?m.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class G{constructor(B,Y){this.d=B,this.e=Y}async provideMappedEdits(B,Y,se,oe){const _=D.URI.revive(B),ge=this.d.getDocument(_),ve=se.documents.map(tt=>tt.map(Ye=>({uri:D.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(rt=>m.Range.to(rt))}))),ze={documents:ve,selections:ve[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(ge,Y,ze,oe);return We?m.WorkspaceEdit.from(We):null}}class ae{constructor(B,Y){this.adapter=B,this.extension=Y}}class $e{static{this.d=0}constructor(B,Y,se,oe,_,ge,ve,ze){this.g=Y,this.h=se,this.j=oe,this.k=_,this.l=ge,this.m=ve,this.n=ze,this.f=new Map,this.e=B.getProxy(w.$CK.MainThreadLanguageFeatures)}o(B,Y){return m.DocumentSelector.from(B,this.g,Y)}p(B){return new A.$EK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return $e.d++}async s(B,Y,se,oe,_,ge=!1){const ve=this.f.get(B);if(!ve||!(ve.adapter instanceof Y))return oe;const ze=Date.now();ge||this.l.trace(`[${ve.extension.identifier.value}] INVOKE provider '${se.toString().replace(/[\r\n]/g,"")}'`);const We=se(ve.adapter,ve.extension);return Promise.resolve(We).catch(tt=>{(0,s.$3)(tt)||(this.l.error(`[${ve.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(ve.extension.identifier,tt))}).finally(()=>{ge||this.l.trace(`[${ve.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),v.CancellationToken.isCancellationToken(_)?(0,a.$Pg)(We,_):We}t(B,Y){const se=this.q();return this.f.set(se,new ae(B,Y)),se}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Y,se,oe){const _=this.t(new h(this.h,se),B),ge=oe&&oe.label||$e.u(B);return this.e.$registerDocumentSymbolProvider(_,this.o(Y,B),ge),this.p(_)}$provideDocumentSymbols(B,Y,se){return this.s(B,h,oe=>oe.provideDocumentSymbols(D.URI.revive(Y),se),void 0,se)}registerCodeLensProvider(B,Y,se){const oe=this.q(),_=typeof se.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(oe,new ae(new u(this.h,this.j.converter,se),B)),this.e.$registerCodeLensSupport(oe,this.o(Y,B),_);let ge=this.p(oe);if(_!==void 0){const ve=se.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(_));ge=A.$EK.from(ge,ve)}return ge}$provideCodeLenses(B,Y,se){return this.s(B,u,oe=>oe.provideCodeLenses(D.URI.revive(Y),se),void 0,se)}$resolveCodeLens(B,Y,se){return this.s(B,u,oe=>oe.resolveCodeLens(Y,se),void 0,void 0)}$releaseCodeLenses(B,Y){this.s(B,u,se=>Promise.resolve(se.releaseCodeLenses(Y)),void 0,void 0)}registerDefinitionProvider(B,Y,se){const oe=this.t(new l(this.h,se),B);return this.e.$registerDefinitionSupport(oe,this.o(Y,B)),this.p(oe)}$provideDefinition(B,Y,se,oe){return this.s(B,l,_=>_.provideDefinition(D.URI.revive(Y),se,oe),[],oe)}registerDeclarationProvider(B,Y,se){const oe=this.t(new E(this.h,se),B);return this.e.$registerDeclarationSupport(oe,this.o(Y,B)),this.p(oe)}$provideDeclaration(B,Y,se,oe){return this.s(B,E,_=>_.provideDeclaration(D.URI.revive(Y),se,oe),[],oe)}registerImplementationProvider(B,Y,se){const oe=this.t(new C(this.h,se),B);return this.e.$registerImplementationSupport(oe,this.o(Y,B)),this.p(oe)}$provideImplementation(B,Y,se,oe){return this.s(B,C,_=>_.provideImplementation(D.URI.revive(Y),se,oe),[],oe)}registerTypeDefinitionProvider(B,Y,se){const oe=this.t(new f(this.h,se),B);return this.e.$registerTypeDefinitionSupport(oe,this.o(Y,B)),this.p(oe)}$provideTypeDefinition(B,Y,se,oe){return this.s(B,f,_=>_.provideTypeDefinition(D.URI.revive(Y),se,oe),[],oe)}registerHoverProvider(B,Y,se,oe){const _=this.t(new p(this.h,se),B);return this.e.$registerHoverProvider(_,this.o(Y,B)),this.p(_)}$provideHover(B,Y,se,oe){return this.s(B,p,_=>_.provideHover(D.URI.revive(Y),se,oe),void 0,oe)}registerEvaluatableExpressionProvider(B,Y,se,oe){const _=this.t(new k(this.h,se),B);return this.e.$registerEvaluatableExpressionProvider(_,this.o(Y,B)),this.p(_)}$provideEvaluatableExpression(B,Y,se,oe){return this.s(B,k,_=>_.provideEvaluatableExpression(D.URI.revive(Y),se,oe),void 0,oe)}registerInlineValuesProvider(B,Y,se,oe){const _=typeof se.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new I(this.h,se),B);this.e.$registerInlineValuesProvider(ge,this.o(Y,B),_);let ve=this.p(ge);if(_!==void 0){const ze=se.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(_));ve=A.$EK.from(ve,ze)}return ve}$provideInlineValues(B,Y,se,oe,_){return this.s(B,I,ge=>ge.provideInlineValues(D.URI.revive(Y),se,oe,_),void 0,_)}registerDocumentHighlightProvider(B,Y,se){const oe=this.t(new j(this.h,se),B);return this.e.$registerDocumentHighlightProvider(oe,this.o(Y,B)),this.p(oe)}$provideDocumentHighlights(B,Y,se,oe){return this.s(B,j,_=>_.provideDocumentHighlights(D.URI.revive(Y),se,oe),void 0,oe)}registerLinkedEditingRangeProvider(B,Y,se){const oe=this.t(new z(this.h,se),B);return this.e.$registerLinkedEditingRangeProvider(oe,this.o(Y,B)),this.p(oe)}$provideLinkedEditingRanges(B,Y,se,oe){return this.s(B,z,async _=>{const ge=await _.provideLinkedEditingRanges(D.URI.revive(Y),se,oe);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?$e.w(ge.wordPattern):void 0}},void 0,oe)}registerReferenceProvider(B,Y,se){const oe=this.t(new M(this.h,se),B);return this.e.$registerReferenceSupport(oe,this.o(Y,B)),this.p(oe)}$provideReferences(B,Y,se,oe,_){return this.s(B,M,ge=>ge.provideReferences(D.URI.revive(Y),se,oe,_),void 0,_)}registerCodeActionProvider(B,Y,se,oe){const _=new g.$Qc,ge=this.t(new F(this.h,this.j.converter,this.k,se,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(ge,this.o(Y,B),{providedKinds:oe?.providedCodeActionKinds?.map(ve=>ve.value),documentation:oe?.documentation?.map(ve=>({kind:ve.kind.value,command:this.j.converter.toInternal(ve.command,_)}))},$e.u(B),!!se.resolveCodeAction),_.add(this.p(ge)),_}$provideCodeActions(B,Y,se,oe,_){return this.s(B,F,ge=>ge.provideCodeActions(D.URI.revive(Y),se,oe,_),void 0,_)}$resolveCodeAction(B,Y,se){return this.s(B,F,oe=>oe.resolveCodeAction(Y,se),{},void 0)}$releaseCodeActions(B,Y){this.s(B,F,se=>Promise.resolve(se.releaseCodeActions(Y)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Y,se){const oe=this.t(new O(this.h,se),B);return this.e.$registerDocumentFormattingSupport(oe,this.o(Y,B),B.identifier,B.displayName||B.name),this.p(oe)}$provideDocumentFormattingEdits(B,Y,se,oe){return this.s(B,O,_=>_.provideDocumentFormattingEdits(D.URI.revive(Y),se,oe),void 0,oe)}registerDocumentRangeFormattingEditProvider(B,Y,se){const oe=typeof se.provideDocumentRangesFormattingEdits=="function",_=this.t(new W(this.h,se),B);return this.e.$registerRangeFormattingSupport(_,this.o(Y,B),B.identifier,B.displayName||B.name,oe),this.p(_)}$provideDocumentRangeFormattingEdits(B,Y,se,oe,_){return this.s(B,W,ge=>ge.provideDocumentRangeFormattingEdits(D.URI.revive(Y),se,oe,_),void 0,_)}$provideDocumentRangesFormattingEdits(B,Y,se,oe,_){return this.s(B,W,ge=>ge.provideDocumentRangesFormattingEdits(D.URI.revive(Y),se,oe,_),void 0,_)}registerOnTypeFormattingEditProvider(B,Y,se,oe){const _=this.t(new x(this.h,se),B);return this.e.$registerOnTypeFormattingSupport(_,this.o(Y,B),oe,B.identifier),this.p(_)}$provideOnTypeFormattingEdits(B,Y,se,oe,_,ge){return this.s(B,x,ve=>ve.provideOnTypeFormattingEdits(D.URI.revive(Y),se,oe,_,ge),void 0,ge)}registerWorkspaceSymbolProvider(B,Y){const se=this.t(new ue(Y,this.l),B);return this.e.$registerNavigateTypeSupport(se,typeof Y.resolveWorkspaceSymbol=="function"),this.p(se)}$provideWorkspaceSymbols(B,Y,se){return this.s(B,ue,oe=>oe.provideWorkspaceSymbols(Y,se),{symbols:[]},se)}$resolveWorkspaceSymbol(B,Y,se){return this.s(B,ue,oe=>oe.resolveWorkspaceSymbol(Y,se),void 0,void 0)}$releaseWorkspaceSymbols(B,Y){this.s(B,ue,se=>se.releaseWorkspaceSymbols(Y),void 0,void 0)}registerRenameProvider(B,Y,se){const oe=this.t(new X(this.h,se,this.l),B);return this.e.$registerRenameSupport(oe,this.o(Y,B),X.supportsResolving(se)),this.p(oe)}$provideRenameEdits(B,Y,se,oe,_){return this.s(B,X,ge=>ge.provideRenameEdits(D.URI.revive(Y),se,oe,_),void 0,_)}$resolveRenameLocation(B,Y,se,oe){return this.s(B,X,_=>_.resolveRenameLocation(D.URI.revive(Y),se,oe),void 0,oe)}registerDocumentSemanticTokensProvider(B,Y,se,oe){const _=this.t(new Q(this.h,se),B),ge=typeof se.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(_,this.o(Y,B),oe,ge);let ve=this.p(_);if(ge){const ze=se.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(ge));ve=A.$EK.from(ve,ze)}return ve}$provideDocumentSemanticTokens(B,Y,se,oe){return this.s(B,Q,_=>_.provideDocumentSemanticTokens(D.URI.revive(Y),se,oe),null,oe)}$releaseDocumentSemanticTokens(B,Y){this.s(B,Q,se=>se.releaseDocumentSemanticColoring(Y),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Y,se,oe){const _=this.t(new he(this.h,se),B);return this.e.$registerDocumentRangeSemanticTokensProvider(_,this.o(Y,B),oe),this.p(_)}$provideDocumentRangeSemanticTokens(B,Y,se,oe){return this.s(B,he,_=>_.provideDocumentRangeSemanticTokens(D.URI.revive(Y),se,oe),null,oe)}registerCompletionItemProvider(B,Y,se,oe){const _=this.t(new Z(this.h,this.j.converter,se,this.m,B),B);return this.e.$registerCompletionsProvider(_,this.o(Y,B),oe,Z.supportsResolving(se),B.identifier),this.p(_)}$provideCompletionItems(B,Y,se,oe,_){return this.s(B,Z,ge=>ge.provideCompletionItems(D.URI.revive(Y),se,oe,_),void 0,_)}$resolveCompletionItem(B,Y,se){return this.s(B,Z,oe=>oe.resolveCompletionItem(Y,se),void 0,se)}$releaseCompletionItems(B,Y){this.s(B,Z,se=>se.releaseCompletionItems(Y),void 0,void 0)}registerInlineCompletionsProvider(B,Y,se,oe){const _=new de(B,this.h,se,this.j.converter),ge=this.t(_,B);return this.e.$registerInlineCompletionsSupport(ge,this.o(Y,B),_.supportsHandleEvents,S.$dm.toKey(B.identifier.value),oe?.yieldTo?.map(ve=>S.$dm.toKey(ve))||[]),this.p(ge)}$provideInlineCompletions(B,Y,se,oe,_){return this.s(B,ye,ge=>ge.provideInlineCompletions(D.URI.revive(Y),se,oe,_),void 0,_)}$handleInlineCompletionDidShow(B,Y,se,oe){this.s(B,ye,async _=>{_.handleDidShowCompletionItem(Y,se,oe)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Y,se,oe){this.s(B,ye,async _=>{_.handlePartialAccept(Y,se,oe)},void 0,void 0)}$freeInlineCompletionsList(B,Y){this.s(B,ye,async se=>{se.disposeCompletions(Y)},void 0,void 0)}registerSignatureHelpProvider(B,Y,se,oe){const _=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ge=this.t(new U(this.h,se),B);return this.e.$registerSignatureHelpProvider(ge,this.o(Y,B),_),this.p(ge)}$provideSignatureHelp(B,Y,se,oe,_){return this.s(B,U,ge=>ge.provideSignatureHelp(D.URI.revive(Y),se,oe,_),void 0,_)}$releaseSignatureHelp(B,Y){this.s(B,U,se=>se.releaseSignatureHelp(Y),void 0,void 0)}registerInlayHintsProvider(B,Y,se){const oe=typeof se.onDidChangeInlayHints=="function"?this.q():void 0,_=this.t(new ne(this.h,this.j.converter,se,this.l,B),B);this.e.$registerInlayHintsProvider(_,this.o(Y,B),typeof se.resolveInlayHint=="function",oe,$e.u(B));let ge=this.p(_);if(oe!==void 0){const ve=se.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(oe));ge=A.$EK.from(ge,ve)}return ge}$provideInlayHints(B,Y,se,oe){return this.s(B,ne,_=>_.provideInlayHints(D.URI.revive(Y),se,oe),void 0,oe)}$resolveInlayHint(B,Y,se){return this.s(B,ne,oe=>oe.resolveInlayHint(Y,se),void 0,se)}$releaseInlayHints(B,Y){this.s(B,ne,se=>se.releaseHints(Y),void 0,void 0)}registerDocumentLinkProvider(B,Y,se){const oe=this.t(new Ee(this.h,se),B);return this.e.$registerDocumentLinkProvider(oe,this.o(Y,B),typeof se.resolveDocumentLink=="function"),this.p(oe)}$provideDocumentLinks(B,Y,se){return this.s(B,Ee,oe=>oe.provideLinks(D.URI.revive(Y),se),void 0,se,Y.scheme==="output")}$resolveDocumentLink(B,Y,se){return this.s(B,Ee,oe=>oe.resolveLink(Y,se),void 0,void 0,!0)}$releaseDocumentLinks(B,Y){this.s(B,Ee,se=>se.releaseLinks(Y),void 0,void 0,!0)}registerColorProvider(B,Y,se){const oe=this.t(new fe(this.h,se),B);return this.e.$registerDocumentColorProvider(oe,this.o(Y,B)),this.p(oe)}$provideDocumentColors(B,Y,se){return this.s(B,fe,oe=>oe.provideColors(D.URI.revive(Y),se),[],se)}$provideColorPresentations(B,Y,se,oe){return this.s(B,fe,_=>_.provideColorPresentations(D.URI.revive(Y),se,oe),void 0,oe)}registerFoldingRangeProvider(B,Y,se){const oe=this.q(),_=typeof se.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(oe,new ae(new me(this.h,se),B)),this.e.$registerFoldingRangeProvider(oe,this.o(Y,B),B.identifier,_);let ge=this.p(oe);if(_!==void 0){const ve=se.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(_));ge=A.$EK.from(ge,ve)}return ge}$provideFoldingRanges(B,Y,se,oe){return this.s(B,me,_=>_.provideFoldingRanges(D.URI.revive(Y),se,oe),void 0,oe)}registerSelectionRangeProvider(B,Y,se){const oe=this.t(new ee(this.h,se,this.l),B);return this.e.$registerSelectionRangeProvider(oe,this.o(Y,B)),this.p(oe)}$provideSelectionRanges(B,Y,se,oe){return this.s(B,ee,_=>_.provideSelectionRanges(D.URI.revive(Y),se,oe),[],oe)}registerCallHierarchyProvider(B,Y,se){const oe=this.t(new te(this.h,se),B);return this.e.$registerCallHierarchyProvider(oe,this.o(Y,B)),this.p(oe)}$prepareCallHierarchy(B,Y,se,oe){return this.s(B,te,_=>Promise.resolve(_.prepareSession(D.URI.revive(Y),se,oe)),void 0,oe)}$provideCallHierarchyIncomingCalls(B,Y,se,oe){return this.s(B,te,_=>_.provideCallsTo(Y,se,oe),void 0,oe)}$provideCallHierarchyOutgoingCalls(B,Y,se,oe){return this.s(B,te,_=>_.provideCallsFrom(Y,se,oe),void 0,oe)}$releaseCallHierarchy(B,Y){this.s(B,te,se=>Promise.resolve(se.releaseSession(Y)),void 0,void 0)}registerTypeHierarchyProvider(B,Y,se){const oe=this.t(new K(this.h,se),B);return this.e.$registerTypeHierarchyProvider(oe,this.o(Y,B)),this.p(oe)}$prepareTypeHierarchy(B,Y,se,oe){return this.s(B,K,_=>Promise.resolve(_.prepareSession(D.URI.revive(Y),se,oe)),void 0,oe)}$provideTypeHierarchySupertypes(B,Y,se,oe){return this.s(B,K,_=>_.provideSupertypes(Y,se,oe),void 0,oe)}$provideTypeHierarchySubtypes(B,Y,se,oe){return this.s(B,K,_=>_.provideSubtypes(Y,se,oe),void 0,oe)}$releaseTypeHierarchy(B,Y){this.s(B,K,se=>Promise.resolve(se.releaseSession(Y)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Y,se,oe){const _=this.q();this.f.set(_,new ae(new ie(this.e,this.h,se,_,B),B));const ge=(0,t.$PF)(B,"dropMetadata")&&oe?ie.toInternalProviderId(B.identifier.value,oe.id):void 0;return this.e.$registerDocumentOnDropEditProvider(_,this.o(Y,B),ge,(0,t.$PF)(B,"dropMetadata")?oe:void 0),this.p(_)}$provideDocumentOnDropEdits(B,Y,se,oe,_,ge){return this.s(B,ie,ve=>Promise.resolve(ve.provideDocumentOnDropEdits(Y,D.URI.revive(se),oe,_,ge)),void 0,void 0)}registerMappedEditsProvider(B,Y,se){const oe=this.t(new G(this.h,se),B);return this.e.$registerMappedEditsProvider(oe,this.o(Y,B)),this.p(oe)}$provideMappedEdits(B,Y,se,oe,_){return this.s(B,G,ge=>Promise.resolve(ge.provideMappedEdits(Y,se,oe,_)),null,_)}registerDocumentPasteEditProvider(B,Y,se,oe){const _=this.q();this.f.set(_,new ae(new N(this.e,this.h,se,_,B),B));const ge=N.toInternalProviderId(B.identifier.value,oe.id);return this.e.$registerPasteEditProvider(_,this.o(Y,B),ge,{supportsCopy:!!se.prepareDocumentPaste,supportsPaste:!!se.provideDocumentPasteEdits,copyMimeTypes:oe.copyMimeTypes,pasteMimeTypes:oe.pasteMimeTypes}),this.p(_)}$prepareDocumentPaste(B,Y,se,oe,_){return this.s(B,N,ge=>ge.prepareDocumentPaste(D.URI.revive(Y),se,oe,_),void 0,_)}$providePasteEdits(B,Y,se,oe,_,ge){return this.s(B,N,ve=>ve.providePasteEdits(Y,D.URI.revive(se),oe,_,ge),void 0,ge)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:$e.w(B.decreaseIndentPattern),increaseIndentPattern:$e.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?$e.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?$e.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:$e.w(B.beforeText),afterText:B.afterText?$e.w(B.afterText):void 0,previousLineText:B.previousLineText?$e.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map($e.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(Y=>A.SyntaxTokenType.toString(Y)):void 0}}static D(B){return B.map($e.C)}setLanguageConfiguration(B,Y,se){const{wordPattern:oe}=se;if(oe&&(0,b.$Se)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this.h.setWordDefinitionFor(Y,oe):this.h.setWordDefinitionFor(Y,void 0),se.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),se.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const _=this.q(),ge={comments:se.comments,brackets:se.brackets,wordPattern:se.wordPattern?$e.w(se.wordPattern):void 0,indentationRules:se.indentationRules?$e.y(se.indentationRules):void 0,onEnterRules:se.onEnterRules?$e.B(se.onEnterRules):void 0,__electricCharacterSupport:se.__electricCharacterSupport,__characterPairSupport:se.__characterPairSupport,autoClosingPairs:se.autoClosingPairs?$e.D(se.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(_,Y,ge),this.p(_)}$setWordDefinitions(B){for(const Y of B)this.h.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.$tec=$e}),define(ke[327],Se([1,0,6,15,7,39,12,3,25]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;class y{constructor(P,$,v,S){this.c=$,this.d=v,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(D.$CK.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,$){await this.a.$changeLanguage(P,$);const v=this.c.getDocumentData(P);if(!v)throw new Error(`document '${P.toString()}' NOT found`);return v.document}async tokenAtPosition(P,$){const v=P.version,S=T.Position.from($),g=await this.a.$tokensAtPosition(P.uri,S),d={type:m.StandardTokenType.Other,range:P.getWordRangeAtPosition($)??new m.$GK($.line,$.character,$.line,$.character)};if(!g)return d;const o={range:T.Range.to(g.range),type:T.TokenType.to(g.type)};return!o.range.contains($)||v!==P.version?d:o}createLanguageStatusItem(P,$,v){const S=this.f++,g=this.a,d=this.g,o=`${P.identifier.value}/${$}`;if(d.has(o))throw new Error(`LanguageStatusItem with id '${$}' ALREADY exists`);d.add(o);const i={selector:v,id:$,name:P.displayName??P.name,severity:m.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const s=new w.$Qc,a=()=>{if(n?.dispose(),!d.has(o)){console.warn(`LanguageStatusItem (${$}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$2g)(()=>{s.clear(),this.a.$setLanguageStatus(S,{id:o,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:T.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===m.LanguageStatusSeverity.Error?A.default.Error:i.severity===m.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:i.command&&this.d.toInternal(i.command,s),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){s.dispose(),n?.dispose(),g.$removeLanguageStatus(S),d.delete(o)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,a()},get selector(){return i.selector},set selector(r){i.selector=r,a()},get text(){return i.text},set text(r){i.text=r,a()},set text2(r){(0,b.$QF)(P,"languageStatusText"),i.text=r,a()},get text2(){return(0,b.$QF)(P,"languageStatusText"),i.text},get detail(){return i.detail},set detail(r){i.detail=r,a()},get severity(){return i.severity},set severity(r){i.severity=r,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,a()},get command(){return i.command},set command(r){i.command=r,a()},get busy(){return i.busy},set busy(r){i.busy=r,a()}};return a(),t}}e.$Sfc=y}),define(ke[115],Se([1,0,11,13,2,5,14,6,27,20]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=e.$efc=void 0;let L=class{constructor($,v,S){this.f=S,this.d=new Map,this.a=v.getProxy(w.$CK.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===D.$g}getMessage($,v){const{message:S,args:g,comment:d}=v;if(this.c)return(0,T.$He)(S,g??{});let o=S;d&&d.length>0&&(o+=`/${Array.isArray(d)?d.join(""):d}`);const i=this.d.get($)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,T.$He)(i??S,g??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let v;const S=await this.g($);if(!S){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const g=await this.a.$fetchBundleContents(S),d=JSON.parse(g);v=$.isBuiltin?d.contents?.bundle:d}catch(g){this.f.error(`Failed to load translations for ${$.identifier.value} from ${S}: ${g.message}`);return}v&&this.d.set($.identifier.value,{contents:v,uri:S})}async g($){if($.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return m.URI.revive(v)}return $.l10n?m.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$efc=L,e.$efc=L=Ke([Be(0,b.$UM),Be(1,y.$EM),Be(2,R.$hj)],L),e.$ffc=(0,A.$Zh)("IExtHostLocalizationService")}),define(ke[151],Se([1,0,14,6,27,20,2,54]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;let b=class extends D.$sj{constructor(P,$){super($.logLevel,$.logsLocation,$.loggers.map(v=>(0,w.$wh)(v))),this.r=P.getProxy(T.$CK.MainThreadLogger)}$setLogLevel(P,$){$?this.setLogLevel(R.URI.revive($),P):this.setLogLevel(P)}setVisibility(P,$){super.setVisibility(P,$),this.r.$setVisibility(P,$)}s(P,$,v){return new y(this.r,P,$,v)}};e.$rgc=b,e.$rgc=b=Ke([Be(0,A.$EM),Be(1,m.$UM)],b);class y extends D.$nj{constructor(P,$,v,S){super(S?.logLevel==="always"),this.r=P,this.s=$,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger($,S).then(()=>{this.u(this.n),this.m=!0})}g(P,$){const v=[[P,$]];this.m?this.u(v):this.n.push(...v)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Se([1,0,6,5,3,20,22]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=e.$gfc=void 0,e.$gfc=(0,T.$Zh)("IExtHostManagedSockets");let w=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(D.$CK.MainThreadManagedSockets)}setFactory(P,$){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new b(P,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const $=++this.b,v=await this.c.makeConnection(),S=new m.$Qc;return this.d.set($,new y($,v,S)),S.add((0,m.$Pc)(()=>this.d.delete($))),S.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),S.dispose()})),S.add(v.onDidClose(g=>{this.a.$onDidManagedSocketClose($,g?.stack??g?.message),S.dispose()})),S.add(v.onDidReceiveMessage(g=>this.a.$onDidManagedSocketHaveData($,R.$fe.wrap(g)))),$}$remoteSocketWrite(P,$){this.d.get(P)?.actual.send($.buffer)}$remoteSocketEnd(P){const $=this.d.get(P);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$hfc=w,e.$hfc=w=Ke([Be(0,A.$EM)],w);class b{constructor(P,$){this.socketFactoryId=P,this.makeConnection=$}}class y extends m.$Rc{constructor(P,$,v){super(),this.socketId=P,this.actual=$,this.B(v)}}}),define(ke[328],Se([1,0,6,14,25]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=void 0;function A(w){return w&&w.title}let R=class{constructor(b,y){this.b=y,this.a=b.getProxy(D.$CK.MainThreadMessageService)}showMessage(b,y,L,P,$){const v={source:{identifier:b.identifier,label:b.displayName||b.name}};let S;typeof P=="string"||A(P)?S=[P,...$]:(v.modal=P?.modal,v.useCustom=P?.useCustom,v.detail=P?.detail,S=$),v.useCustom&&(0,m.$QF)(b,"resolvers");const g=[];for(let d=0;d<S.length;d++){const o=S[d];if(typeof o=="string")g.push({title:o,handle:d,isCloseAffordance:!1});else if(typeof o=="object"){const{title:i,isCloseAffordance:n}=o;g.push({title:i,isCloseAffordance:!!n,handle:d})}else this.b.warn("Invalid message item:",o)}return this.a.$showMessage(y,L,v,g).then(d=>{if(typeof d=="number")return S[d]})}};e.$Tfc=R,e.$Tfc=R=Ke([Be(1,T.$hj)],R)}),define(ke[329],Se([1,0,19,12,21,4,3,28,2,26,14,6,35,15,7,113,285,25,68]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=e.$Xfc=void 0;let n=class{constructor(l,E,C,f,p){this.m=E,this.n=C,this.o=f,this.q=p,this.b=new w.$zc,this.c=new w.$zc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$Rd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=l.getProxy(P.$CK.MainThreadNotebookKernels);const k=new $.$5M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new $.$3M("options","Select kernel options",I=>!0,I=>{if(I&&"notebookEditor"in I&&"id"in I){const j=this.n.getIdByEditor(I.notebookEditor);return{id:I.id,extension:I.extension,notebookEditorId:j}}else if(I&&"notebookEditor"in I){const j=this.n.getIdByEditor(I.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${I.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return I})],$.$4M.Void);this.o.registerApiCommand(k)}createNotebookController(l,E,C,f,p,k){for(const Z of this.j.values())if(Z.controller.id===E&&y.$dm.equals(l.identifier,Z.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const I=this.k++,j=this;this.q.trace(`NotebookController[${I}], CREATED by ${l.identifier.value}, ${E}`);const z=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${l.identifier}'`);let M=!1;const F=new A.$Rd,N=new A.$Rd,O={id:u(l.identifier,E),notebookType:C,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:f||l.identifier.value,preloads:k?k.map(v.NotebookRendererScript.from):[]};let W=p??z,x,ue;this.a.$addKernel(I,O).catch(Z=>{console.log(Z),M=!0});let X=0;const J=()=>{if(M)return;const Z=++X;Promise.resolve().then(()=>{Z===X&&this.a.$updateKernel(I,O)})},Q=new w.$zc,he={get id(){return E},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return O.label},set label(Z){O.label=Z??l.displayName??l.name,J()},get detail(){return O.detail??""},set detail(Z){O.detail=Z,J()},get description(){return O.description??""},set description(Z){O.description=Z,J()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(Z){O.supportedLanguages=Z,J()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){O.supportsExecutionOrder=Z,J()},get rendererScripts(){return O.preloads?O.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(Z){W=Z??z},get interruptHandler(){return x},set interruptHandler(Z){x=Z,O.supportsInterrupt=!!Z,J()},set variableProvider(Z){(0,o.$QF)(l,"notebookVariableProvider"),ue=Z,O.hasVariableProvider=!!Z,Z?.onDidChangeVariables(ye=>j.a.$variablesUpdated(ye.uri)),J()},get variableProvider(){return ue},createNotebookCellExecution(Z){if(M)throw new Error("notebook controller is DISPOSED");if(!Q.has(Z.notebook.uri))throw j.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return j._createNotebookCellExecution(Z,u(l.identifier,this.id))},createNotebookExecution(Z){if((0,o.$QF)(l,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!Q.has(Z.uri))throw j.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.uri.toString()}`);return j._createNotebookExecution(Z,u(l.identifier,this.id))},dispose:()=>{M||(this.q.trace(`NotebookController[${I}], DISPOSED`),M=!0,this.j.delete(I),F.dispose(),N.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(Z,ye){ye===S.NotebookControllerAffinity2.Hidden&&(0,o.$QF)(l,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(I,Z.uri,ye)},onDidReceiveMessage:N.event,postMessage(Z,ye){return(0,o.$QF)(l,"notebookMessaging"),j.a.$postMessage(I,ye&&j.n.getIdByEditor(ye),Z)},asWebviewUri(Z){return(0,o.$QF)(l,"notebookMessaging"),(0,g.$Nub)(Z,j.m.remote)}};return this.j.set(I,{extensionId:l.identifier,controller:he,onDidReceiveMessage:N,onDidChangeSelection:F,associatedNotebooks:Q}),he}getIdByController(l){for(const[E,C]of this.j)if(C.controller===l)return u(C.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,E){const C=this.g++,f=this;this.q.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(C,E);const p={dispose:()=>{this.f.delete(C),f.a.$removeKernelDetectionTask(C)}};return this.f.set(C,p),p}registerKernelSourceActionProvider(l,E,C){const f=this.i++,p=typeof C.onDidChangeNotebookKernelSourceActions=="function"?f:void 0,k=this;this.h.set(f,C),this.q.trace(`NotebookKernelSourceActionProvider[${f}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(f,f,E);let I;return p!==void 0&&(I=C.onDidChangeNotebookKernelSourceActions(j=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(f),k.a.$removeKernelSourceActionProvider(f,f),I?.dispose()}}}async $provideKernelSourceActions(l,E){const C=this.h.get(l);if(C){const f=new R.$Qc;return(await C.provideNotebookKernelSourceActions(E)??[]).map(k=>v.NotebookKernelSourceAction.from(k,this.o.converter,f))}return[]}$acceptNotebookAssociation(l,E,C){const f=this.j.get(l);if(f){const p=this.n.getNotebookDocument(b.URI.revive(E));C?f.associatedNotebooks.set(p.uri,!0):f.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,p.uri.toString(),C),f.onDidChangeSelection.fire({selected:C,notebook:p.apiNotebook})}}async $executeCells(l,E,C){const f=this.j.get(l);if(!f)return;const p=this.n.getNotebookDocument(b.URI.revive(E)),k=[];for(const I of C){const j=p.getCell(I);j&&k.push(j.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,p.uri.toString(),k.length),await f.controller.executeHandler.call(f.controller,k,p.apiNotebook,f.controller)}catch(I){this.q.error(`NotebookController[${l}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(l,E,C){const f=this.j.get(l);if(!f)return;const p=this.n.getNotebookDocument(b.URI.revive(E));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,p.apiNotebook);else for(const k of C){const I=p.getCell(k);I&&this.b.get(I.uri)?.cancel()}if(f.controller.interruptHandler){const k=this.c.get(p.uri);C.length&&Array.isArray(k)&&k.length&&k.forEach(I=>I.dispose())}}async $provideVariables(l,E,C,f,p,k,I){const j=this.j.get(l);if(!j)return;const z=this.n.getNotebookDocument(b.URI.revive(C)),M=j.controller.variableProvider;if(!M)return;const F=f?{name:f,value:""}:void 0,N=p==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,O=M.provideVariables(z.apiNotebook,F,N,k,I);for await(const W of O){if(I.isCancellationRequested)return;this.a.$receiveVariable(E,W)}}$acceptKernelMessageFromRenderer(l,E,C){const f=this.j.get(l);if(!f)return;const p=this.n.getEditorById(E);f.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:C}))}$cellExecutionChanged(l,E,C){const p=this.n.getNotebookDocument(b.URI.revive(l)).getCell(E);if(p){const k=C?v.NotebookCellExecutionState.to(C):S.NotebookCellExecutionState.Idle;k!==void 0&&this.l.fire({cell:p.apiCell,state:k})}}_createNotebookCellExecution(l,E){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!f)throw new Error("invalid cell");if(this.b.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const p=new a(E,f,this.a);this.b.set(f.uri,p);const k=p.onDidChangeState(()=>{p.state===s.Resolved&&(p.dispose(),k.dispose(),this.b.delete(f.uri))});return p.asApiObject()}_createNotebookExecution(l,E){const C=this.n.getNotebookDocument(l.uri),f=l.getCells().find(I=>{const j=C.getCellFromApiCell(I);return j&&this.b.has(j.uri)});if(f)throw new Error(`duplicate cell execution for ${f.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const p=new r(E,C,this.a),k=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),k.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[p,k]),p.asApiObject()}};e.$Xfc=n,e.$Xfc=n=Ke([Be(4,L.$hj)],n);var s;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(s||(s={}));class a extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(l,E,C){super(),this.m=E,this.n=C,this.b=a.a++,this.c=new A.$Rd,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new m.$2d),this.h=new h(10,f=>this.s(f)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const E=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new i.$Av(E))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let E=this.m;if(l&&(E=this.m.notebook.getCellFromApiCell(l)),!E)throw new Error("INVALID cell");return E.handle}y(l){return l.map(E=>{const C=S.$6L.ensureUniqueMimeTypes(E.items,!0);return C===E.items?v.NotebookCellOutput.from(E):v.NotebookCellOutput.from({items:C,id:E.id,metadata:E.metadata})})}async z(l,E,C){const f=this.w(E),p=this.y((0,D.$2b)(l));return this.r({editType:d.CellExecutionUpdateType.Output,cellHandle:f,append:C,outputs:p})}async C(l,E,C){return l=S.$6L.ensureUniqueMimeTypes((0,D.$2b)(l),!0),this.r({editType:d.CellExecutionUpdateType.OutputItems,items:l.map(v.NotebookCellOutputItem.from),outputId:E.id,append:C})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(C){l.j=C,l.s([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(C){if(l.f===s.Resolved||l.f===s.Started)throw new Error("Cannot call start again");l.f=s.Started,l.c.fire(),l.s({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,f){if(l.f===s.Resolved)throw new Error("Cannot call resolve twice");l.f=s.Resolved,l.c.fire(),l.h.flush(),l.n.$completeExecution(l.b,new i.$Av({runEndTime:f,lastRunSuccess:C}))},clearOutput(C){return l.t(),l.z([],C,!1)},appendOutput(C,f){return l.t(),l.z(C,f,!0)},replaceOutput(C,f){return l.t(),l.z(C,f,!1)},appendOutputItems(C,f){return l.t(),l.C(C,f,!0)},replaceOutputItems(C,f){return l.t(),l.C(C,f,!1)}})}}var t;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(t||(t={}));class r extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(l,E,C){super(),this.h=E,this.j=C,this.b=r.a++,this.c=new A.$Rd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new m.$2d),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class h{constructor(l,E){this.f=l,this.g=E,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new T.$kh,this.b=Date.now(),(0,T.$1g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const E=this.a;return this.a=[],this.g(E).finally(()=>l.complete())}}function u(c,l){return`${c.value}/${l}`}e.$Yfc=u}),define(ke[330],Se([1,0,4,6,147]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=void 0;class A{constructor(w,b){this.c=b,this.a=new Map,this.b=w.getProxy(T.$CK.MainThreadNotebookRenderers)}$postRendererMessage(w,b,y){const L=this.c.getEditorById(w);this.a.get(b)?.fire({editor:L.apiEditor,message:y})}createRendererMessaging(w,b){if(!w.contributes?.notebookRenderer?.some(L=>L.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(L,P,$)=>this.d(b).event(L,P,$),postMessage:(L,P)=>{m.$Ffc.apiEditorsToExtHost.has(L)&&([L,P]=[P,L]);const $=P&&m.$Ffc.apiEditorsToExtHost.get(P);return this.b.$postMessage($?.id,b,L)}}}d(w){let b=this.a.get(w);return b||(b=new D.$Rd({onDidRemoveLastListener:()=>{b?.dispose(),this.a.delete(w)}}),this.a.set(w,b),b)}}e.$Zfc=A}),define(ke[331],Se([1,0,3,18,2,25,6]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;class w{constructor(y){this.b=new Map,this.a=y.getProxy(R.$CK.MainThreadProfileContentHandlers)}registrProfileContentHandler(y,L,P){if((0,A.$QF)(y,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,P),this.a.$registerProfileContentHandler(L,P.name,P.description,y.identifier.value),(0,D.$Pc)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(y,L,P,$){const v=this.b.get(y);if(!v)throw new Error(`Unknown handler with id: ${y}`);return v.saveProfile(L,P,$)}async $readProfile(y,L,P){const $=this.b.get(y);if(!$)throw new Error(`Unknown handler with id: ${y}`);return $.readProfile((0,T.$Cf)(L)?L:m.URI.revive(L),P)}}e.$3fc=w}),define(ke[332],Se([1,0,2,6,12,15]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class R{static{this.a=0}constructor(b,y){this.d=y,this.c=new Map,this.b=b.getProxy(T.$CK.MainThreadQuickDiff)}$provideOriginalResource(b,y,L){const P=D.URI.revive(y),$=this.c.get(b);return $?(0,m.$Sg)(()=>$.provideOriginalResource(P,L)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(b,y,L,P){const $=R.a++;return this.c.set($,y),this.b.$registerQuickDiffProvider($,A.DocumentSelector.from(b,this.d),L,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$5fc=R}),define(ke[333],Se([1,0,21,4,3,6,2,7,8,19,39,61,25,15]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;function S(g,d,o){const i=g.getProxy(A.$CK.MainThreadQuickOpen);class n{constructor(E,C){this.e=new Map,this.f=0,this.a=E,this.b=C}showQuickPick(E,C,f,p=D.CancellationToken.None){this.c=void 0;const k=Promise.resolve(C),I=++this.f,j=i.$show(I,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},p),z={},M=j.then(()=>z);return Promise.race([M,k]).then(F=>{if(F===z)return;const N=(0,$.$PF)(E,"quickPickItemTooltip");return k.then(O=>{const W=[];for(let x=0;x<O.length;x++){const ue=O[x];if(typeof ue=="string")W.push({label:ue,handle:x});else if(ue.kind===w.QuickPickItemKind.Separator)W.push({type:"separator",label:ue.label});else{ue.tooltip&&!N&&console.warn(`Extension '${E.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`);const X=ue.iconPath?h(ue.iconPath):void 0;W.push({label:ue.label,iconPath:X?.iconPath,iconClass:X?.iconClass,description:ue.description,detail:ue.detail,picked:ue.picked,alwaysShow:ue.alwaysShow,tooltip:N?v.MarkdownString.fromStrict(ue.tooltip):void 0,handle:x})}}return f&&typeof f.onDidSelectItem=="function"&&(this.c=x=>{f.onDidSelectItem(O[x])}),i.$setItems(I,W),j.then(x=>{if(typeof x=="number")return O[x];if(Array.isArray(x))return x.map(ue=>O[ue])})})}).then(void 0,F=>{if(!(0,b.$3)(F))return i.$setError(I,F),Promise.reject(F)})}$onItemSelected(E){this.c?.(E)}showInput(E,C=D.CancellationToken.None){return this.d=E?.validateInput,i.$input(E,typeof this.d=="function",C).then(void 0,f=>{if(!(0,b.$3)(f))return Promise.reject(f)})}async $validateInput(E){if(!this.d)return;const C=await this.d(E);if(!C||typeof C=="string")return C;let f;switch(C.severity){case w.InputBoxValidationSeverity.Info:f=L.default.Info;break;case w.InputBoxValidationSeverity.Warning:f=L.default.Warning;break;case w.InputBoxValidationSeverity.Error:f=L.default.Error;break;default:f=C.message?L.default.Error:L.default.Ignore;break}return{content:C.message,severity:f}}async showWorkspaceFolderPick(E,C=D.CancellationToken.None){const f=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[E]);if(!f)return;const p=await this.a.getWorkspaceFolders2();if(p)return p.find(k=>k.uri.toString()===f.uri.toString())}createQuickPick(E){const C=new u(E,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}createInputBox(E){const C=new c(E,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}$onDidChangeValue(E,C){this.e.get(E)?._fireDidChangeValue(C)}$onDidAccept(E){this.e.get(E)?._fireDidAccept()}$onDidChangeActive(E,C){const f=this.e.get(E);f instanceof u&&f._fireDidChangeActive(C)}$onDidChangeSelection(E,C){const f=this.e.get(E);f instanceof u&&f._fireDidChangeSelection(C)}$onDidTriggerButton(E,C){this.e.get(E)?._fireDidTriggerButton(C)}$onDidTriggerItemButton(E,C,f){const p=this.e.get(E);p instanceof u&&p._fireDidTriggerItemButton(C,f)}$onDidHide(E){this.e.get(E)?._fireDidHide()}}class s{static{this.a=1}constructor(E,C){this.x=E,this.y=C,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Rd,this.q=new T.$Rd,this.r=new T.$Rd,this.s=new T.$Rd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(E){this.b=E,this.z({title:E})}get step(){return this.c}set step(E){this.c=E,this.z({step:E})}get totalSteps(){return this.d}set totalSteps(E){this.d=E,this.z({totalSteps:E})}get enabled(){return this.g}set enabled(E){this.g=E,this.z({enabled:E})}get busy(){return this.j}set busy(E){this.j=E,this.z({busy:E})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(E){this.k=E,this.z({ignoreFocusOut:E})}get value(){return this.l}set value(E){this.l=E,this.z({value:E})}get placeholder(){return this.m}set placeholder(E){this.m=E,this.z({placeholder:E})}get buttons(){return this.n}set buttons(E){this.n=E.slice(),this.o.clear(),E.forEach((C,f)=>{const p=C===w.$YL.Back?-1:f;this.o.set(p,C)}),this.z({buttons:E.map((C,f)=>({...h(C.iconPath),tooltip:C.tooltip,handle:C===w.$YL.Back?-1:f}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(E){this.l=E,this.q.fire(E)}_fireDidTriggerButton(E){const C=this.o.get(E);C&&this.r.fire(C)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,m.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(E){if(!this.v){for(const C of Object.keys(E)){const f=E[C];this.u[C]=f===void 0?null:f}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(l){if(l instanceof w.$yL)return{id:l.id};const E=r(l),C=t(l);return{dark:typeof E=="string"?R.URI.file(E):E,light:typeof C=="string"?R.URI.file(C):C}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function r(l){return typeof l=="object"&&"dark"in l?l.dark:l}function h(l){const E=a(l);let C,f;return"id"in E?f=P.ThemeIcon.asClassName(E):C=E,{iconPath:C,iconClass:f}}class u extends s{constructor(E,C){super(E.identifier,C),this.O=E,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Rd,this.L=[],this.M=new T.$Rd,this.N=new T.$Rd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(E){this.B=E.slice(),this.C.clear(),this.D.clear(),E.forEach((p,k)=>{this.C.set(k,p),this.D.set(p,k)});const C=(0,$.$PF)(this.O,"quickPickItemTooltip"),f=[];for(let p=0;p<E.length;p++){const k=E[p];if(k.kind===w.QuickPickItemKind.Separator)f.push({type:"separator",label:k.label});else{k.tooltip&&!C&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const I=k.iconPath?h(k.iconPath):void 0;f.push({handle:p,label:k.label,iconPath:I?.iconPath,iconClass:I?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:C?v.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((j,z)=>({...h(j.iconPath),tooltip:j.tooltip,handle:z}))})}}this.z({items:f})}get canSelectMany(){return this.E}set canSelectMany(E){this.E=E,this.z({canSelectMany:E})}get matchOnDescription(){return this.F}set matchOnDescription(E){this.F=E,this.z({matchOnDescription:E})}get matchOnDetail(){return this.G}set matchOnDetail(E){this.G=E,this.z({matchOnDetail:E})}get sortByLabel(){return this.H}set sortByLabel(E){this.H=E,this.z({sortByLabel:E})}get keepScrollPosition(){return this.I}set keepScrollPosition(E){this.I=E,this.z({keepScrollPosition:E})}get activeItems(){return this.J}set activeItems(E){this.J=E.filter(C=>this.D.has(C)),this.z({activeItems:this.J.map(C=>this.D.get(C))})}get selectedItems(){return this.L}set selectedItems(E){this.L=E.filter(C=>this.D.has(C)),this.z({selectedItems:this.L.map(C=>this.D.get(C))})}_fireDidChangeActive(E){const C=(0,y.$Gb)(E.map(f=>this.C.get(f)));this.J=C,this.K.fire(C)}_fireDidChangeSelection(E){const C=(0,y.$Gb)(E.map(f=>this.C.get(f)));this.L=C,this.M.fire(C)}_fireDidTriggerItemButton(E,C){const f=this.C.get(E);if(!f||!f.buttons||!f.buttons.length)return;const p=f.buttons[C];p&&this.N.fire({button:p,item:f})}}class c extends s{constructor(E,C){super(E.identifier,C),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(E){this.B=E,this.z({password:E})}get prompt(){return this.C}set prompt(E){this.C=E,this.z({prompt:E})}get valueSelection(){return this.D}set valueSelection(E){this.D=E,this.z({valueSelection:E})}get validationMessage(){return this.E}set validationMessage(E){this.E=E,E?typeof E=="string"?this.z({validationMessage:E,severity:L.default.Error}):this.z({validationMessage:E.message,severity:E.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new n(d,o)}e.$6fc=S}),define(ke[334],Se([1,0,2,4,59,3,12,6,19,129,14,21,26,61,15,25,17,11]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=e.$7fc=void 0;function n(M){return M instanceof D.URI}function s(M,F){return M.scheme===d.Schemas.file&&F.scheme===d.Schemas.file&&o.$k?M.toString()===F.toString():M.toString().toLowerCase()===F.toString().toLowerCase()}function a(M){if(M)return typeof M.iconPath=="string"?D.URI.file(M.iconPath):D.URI.isUri(M.iconPath)||v.ThemeIcon.isThemeIcon(M.iconPath)?M.iconPath:void 0}function t(M){if(M?.icon){if(D.URI.isUri(M.icon))return M.icon;if(v.ThemeIcon.isThemeIcon(M.icon))return M.icon;{const F=M.icon;return{light:F.light,dark:F.dark}}}else return}function r(M){if(M.icon){if(D.URI.isUri(M.icon))return M.icon;if(v.ThemeIcon.isThemeIcon(M.icon))return M.icon;{const F=M.icon;return{light:F.light,dark:F.dark}}}else return}function h(M){if(M.icon){if(D.URI.isUri(M.icon))return M.icon;if(v.ThemeIcon.isThemeIcon(M.icon))return M.icon;{const F=M.icon;return{light:F.light,dark:F.dark}}}else return}function u(M,F){if(!M.iconPath&&!F.iconPath)return 0;if(M.iconPath){if(!F.iconPath)return 1}else return-1;const N=typeof M.iconPath=="string"?M.iconPath:D.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id,O=typeof F.iconPath=="string"?F.iconPath:D.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,y.$Bq)(N,O)}function c(M,F){let N=0;if(M.strikeThrough!==F.strikeThrough)return M.strikeThrough?1:-1;if(M.faded!==F.faded)return M.faded?1:-1;if(M.tooltip!==F.tooltip)return(M.tooltip||"").localeCompare(F.tooltip||"");if(N=u(M,F),N!==0)return N;if(M.light&&F.light)N=u(M.light,F.light);else{if(M.light)return 1;if(F.light)return-1}if(N!==0)return N;if(M.dark&&F.dark)N=u(M.dark,F.dark);else{if(M.dark)return 1;if(F.dark)return-1}return N}function l(M,F){if(M.command!==F.command)return M.command<F.command?-1:1;if(M.title!==F.title)return M.title<F.title?-1:1;if(M.tooltip!==F.tooltip){if(M.tooltip!==void 0&&F.tooltip!==void 0)return M.tooltip<F.tooltip?-1:1;if(M.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(M.arguments===F.arguments)return 0;if(M.arguments)if(F.arguments){if(M.arguments.length!==F.arguments.length)return M.arguments.length-F.arguments.length}else return 1;else return-1;for(let N=0;N<M.arguments.length;N++){const O=M.arguments[N],W=F.arguments[N];if(O!==W&&!(n(O)&&n(W)&&s(O,W)))return O<W?-1:1}return 0}function E(M,F){let N=(0,y.$Bq)(M.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(N!==0)return N;if(M.command&&F.command)N=l(M.command,F.command);else{if(M.command)return 1;if(F.command)return-1}if(N!==0)return N;if(M.decorations&&F.decorations)N=c(M.decorations,F.decorations);else{if(M.decorations)return 1;if(F.decorations)return-1}return N}function C(M,F){for(let N=0;N<M.length;N++)if(M[N]!==F[N])return!1;return!0}function f(M,F){return M.command===F.command&&M.title===F.title&&M.tooltip===F.tooltip&&(M.arguments&&F.arguments?C(M.arguments,F.arguments):M.arguments===F.arguments)}function p(M,F){return(0,b.$tb)(M,F,f)}class k{#e;#t;get value(){return this.d}set value(F){F=F??"",this.#e.$setInputBoxValue(this.o,F),this.q(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){this.#e.$setInputBoxPlaceholder(this.o,F),this.f=F}get validateInput(){return(0,g.$QF)(this.m,"scmValidation"),this.g}set validateInput(F){if((0,g.$QF)(this.m,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=F,this.#e.$setValidationProviderIsEnabled(this.o,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,this.#e.$setInputBoxEnablement(this.o,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,this.#e.$setInputBoxVisibility(this.o,F))}get actionButton(){return(0,g.$QF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(F){(0,g.$QF)(this.m,"scmInputBoxActionButton"),this.l.value=new A.$Qc,this.k=F;const N=F!==void 0?{command:this.n.converter.toInternal(F.command,this.l.value),icon:t(F),enabled:F.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,N??null)}get document(){return(0,g.$QF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(F,N,O,W,x,ue){this.m=F,this.n=N,this.o=x,this.p=ue,this.d="",this.e=new T.$Rd,this.f="",this.h=!0,this.j=!0,this.l=new A.$Sc,this.#t=O,this.#e=W}showValidationMessage(F,N){(0,g.$QF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,F,N)}$onInputBoxValueChange(F){this.q(F)}q(F){this.d=F,this.e.fire(F)}}e.$7fc=k;class I{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(F){this.v=F,this.q.$updateGroupLabel(this.t,this.handle,F)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(F){this.p=F,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,N,O,W,x){this.q=F,this.s=N,this.t=O,this.u=W,this.v=x,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Rd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Rd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=I.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,N){const O=this.h.get(F);return O?(0,R.$Sg)(()=>this.s.executeCommand(O.command,...O.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(E),O=(0,b.$Cb)(this.o,F,E).map(ue=>{const X=ue.toInsert.map(J=>{const Q=this.e++;this.g.set(Q,J);const he=J.resourceUri;let Z;if(J.command)if(J.command.command==="vscode.open"||J.command.command==="vscode.diff"||J.command.command==="vscode.changes"){const te=new A.$Qc;Z=this.s.converter.toInternal(J.command,te),this.j.set(Q,te)}else this.h.set(Q,J.command);const ye=a(J.decorations),de=J.decorations&&a(J.decorations.light)||ye,H=J.decorations&&a(J.decorations.dark)||ye,U=[de,H],ne=J.decorations&&J.decorations.tooltip||"",Ee=J.decorations&&!!J.decorations.strikeThrough,fe=J.decorations&&!!J.decorations.faded,me=J.contextValue||"";return{rawResource:[Q,he,U,ne,Ee,fe,me,Z],handle:Q}});return{start:ue.start,deleteCount:ue.deleteCount,toInsert:X}}),W=O.map(({start:ue,deleteCount:X,toInsert:J})=>[ue,X,J.map(Q=>Q.rawResource)]),x=O.reverse();for(const{start:ue,deleteCount:X,toInsert:J}of x){const Q=J.map(Z=>Z.handle),he=this.n.splice(ue,X,...Q);for(const Z of he)this.g.delete(Z),this.h.delete(Z),this.j.get(Z)?.dispose(),this.j.delete(Z)}return this.o=F,W}dispose(){this.l=!0,this.m.fire()}}class j{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,this.#e.$updateSourceControl(this.x,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let N;(0,g.$PF)(this.y,"quickDiffProvider")&&(N=F?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!F,quickDiffLabel:N})}get historyProvider(){return(0,g.$QF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(F){(0,g.$QF)(this.y,"scmHistoryProvider"),this.j=F,this.k.value=new A.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!F}),F&&(this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{this.l=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(F.onDidChangeActionButton(()=>{(0,g.$QF)(this.y,"scmActionButton"),this.m.value=new A.$Qc;const N=F.actionButton!==void 0?{command:this.z.converter.toInternal(F.actionButton.command,this.m.value),description:F.actionButton.description,enabled:F.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,N??null)})))}get commitTemplate(){return this.n}set commitTemplate(F){F!==this.n&&(this.n=F,this.#e.$updateSourceControl(this.x,{commitTemplate:F}))}get acceptInputCommand(){return this.p}set acceptInputCommand(F){this.o.value=new A.$Qc,this.p=F;const N=this.z.converter.toInternal(F,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:N})}get actionButton(){return(0,g.$QF)(this.y,"scmActionButton"),this.s}set actionButton(F){(0,g.$QF)(this.y,"scmActionButton"),this.q.value=new A.$Qc,this.s=F;const N=F!==void 0?{command:this.z.converter.toInternal(F.command,this.q.value),secondaryCommands:F.secondaryCommands?.map(O=>O.map(W=>this.z.converter.toInternal(W,this.q.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:N??null})}get statusBarCommands(){return this.u}set statusBarCommands(F){if(this.u&&F&&p(this.u,F))return;this.t.value=new A.$Qc,this.u=F;const N=(F||[]).map(O=>this.z.converter.toInternal(O,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:N})}get selected(){return this.v}constructor(F,N,O,W,x,ue,X){this.y=F,this.z=W,this.A=x,this.B=ue,this.C=X,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Sc,this.m=new A.$Sc,this.n=void 0,this.o=new A.$Sc,this.p=void 0,this.q=new A.$Sc,this.t=new A.$Sc,this.u=void 0,this.v=!1,this.w=new T.$Rd,this.onDidChangeSelection=this.w.event,this.x=j.d++,this.D=new Map,this.E=new Set,this.#e=O;const J=D.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${x}/scm${this.x}/input`,query:X?`rootUri=${encodeURIComponent(X.toString())}`:void 0});this.f=new k(F,W,N,this.#e,this.x,J),this.#e.$registerSourceControl(this.x,x,ue,X,J)}createResourceGroup(F,N){const O=new I(this.#e,this.z,this.x,F,N),W=T.Event.once(O.onDidDispose)(()=>this.D.delete(O));return this.D.set(O,W),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const F=[],N=[];for(const[O,W]of this.D){W.dispose();const x=O.onDidUpdateResourceStates(()=>{this.E.add(O),this.eventuallyUpdateResourceStates()});T.Event.once(O.onDidDispose)(()=>{this.E.delete(O),x.dispose(),this.e.delete(O.handle),this.#e.$unregisterGroup(this.x,O.handle)}),F.push([O.handle,O.id,O.label,O.features]);const ue=O._takeResourceStateSnapshot();ue.length>0&&N.push([O.handle,ue]),this.e.set(O.handle,O)}this.#e.$registerGroups(this.x,F,N),this.D.clear()}eventuallyUpdateResourceStates(){const F=[];this.E.forEach(N=>{const O=N._takeResourceStateSnapshot();O.length!==0&&F.push([N.handle,O])}),F.length>0&&this.#e.$spliceResourceStates(this.x,F),this.E.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.v=F,this.w.fire(F)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,m.$sh)(100)],j.prototype,"eventuallyAddResourceGroups",null),Ke([(0,m.$sh)(100)],j.prototype,"eventuallyUpdateResourceStates",null);let z=class{static{i=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(F,N,O,W){this.n=N,this.o=O,this.p=W,this.h=new Map,this.j=new $.$fm,this.k=new T.$Rd,this.l=new Map,this.f=F.getProxy(w.$CK.MainThreadSCM),this.g=F.getProxy(w.$CK.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:x=>{if(x&&x.$mid===3){const ue=this.h.get(x.sourceControlHandle);if(!ue)return x;const X=ue.getResourceGroup(x.groupHandle);return X?X.getResourceState(x.handle):x}else if(x&&x.$mid===4){const ue=this.h.get(x.sourceControlHandle);return ue?ue.getResourceGroup(x.groupHandle):x}else if(x&&x.$mid===5){const ue=this.h.get(x.handle);return ue||x}return x}})}createSourceControl(F,N,O,W){this.p.trace("ExtHostSCM#createSourceControl",F.identifier.value,N,O,W),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const x=i.d++,ue=new j(F,this.o,this.f,this.n,N,O,W);this.h.set(x,ue);const X=this.j.get(F.identifier)||[];return X.push(ue),this.j.set(F.identifier,X),ue}registerSourceControlInputBoxValueProvider(F,N){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",F.identifier.value,N.label);const O=i.e++;return this.l.set(O,N),this.f.$registerSourceControlInputBoxValueProvider(O,N.label,h(N)),(0,A.$Pc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(O),this.l.delete(O)})}async $provideInputBoxValue(F,N,O){const W=this.l.get(F);if(W)return await W.provideValue(N,O,P.CancellationToken.None)??void 0}getLastInputBox(F){this.p.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const N=this.j.get(F.identifier),O=N&&N[N.length-1];return O&&O.inputBox}$provideOriginalResource(F,N,O){const W=D.URI.revive(N);this.p.trace("ExtHostSCM#$provideOriginalResource",F,W.toString());const x=this.h.get(F);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Sg)(()=>x.quickDiffProvider.provideOriginalResource(W,O)).then(ue=>ue||null)}$onInputBoxValueChange(F,N){this.p.trace("ExtHostSCM#$onInputBoxValueChange",F);const O=this.h.get(F);return O&&O.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(F,N,O,W){this.p.trace("ExtHostSCM#$executeResourceCommand",F,N,O);const x=this.h.get(F);if(!x)return Promise.resolve(void 0);const ue=x.getResourceGroup(N);return ue?ue.$executeResourceCommand(O,W):Promise.resolve(void 0)}$validateInput(F,N,O){this.p.trace("ExtHostSCM#$validateInput",F);const W=this.h.get(F);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Sg)(()=>W.inputBox.validateInput(N,O)).then(x=>{if(!x)return Promise.resolve(void 0);const ue=S.MarkdownString.fromStrict(x.message);return ue?Promise.resolve([ue,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.h.get(F)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(F,N,O){return await this.h.get(F)?.historyProvider?.resolveHistoryItemGroupBase(N,O)??void 0}async $resolveHistoryItemGroupCommonAncestor(F,N,O,W){return await this.h.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(N,O,W)??void 0}async $provideHistoryItems(F,N,O,W){return(await this.h.get(F)?.historyProvider?.provideHistoryItems(N,O,W))?.map(X=>({...X,icon:r(X)}))??void 0}async $provideHistoryItemChanges(F,N,O){return await this.h.get(F)?.historyProvider?.provideHistoryItemChanges(N,O)??void 0}};e.$8fc=z,e.$8fc=z=i=Ke([Be(3,L.$hj)],z)}),define(ke[117],Se([1,0,6,4,5]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=e.$bfc=void 0;class A{constructor(w){this.b=new T.$Rd,this.onDidChangePassword=this.b.event,this.a=w.getProxy(D.$CK.MainThreadSecretState)}async $onDidChangePassword(w){this.b.fire(w)}get(w,b){return this.a.$getPassword(w,b)}store(w,b,y){return this.a.$setPassword(w,b,y)}delete(w,b){return this.a.$deletePassword(w,b)}}e.$bfc=A,e.$cfc=(0,m.$Zh)("IExtHostSecretState")}),define(ke[335],Se([1,0,6,15,2]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;class A{static{this.a=0}constructor(w,b){this.d=b,this.c=new Map,this.b=w.getProxy(D.$CK.MainThreadShare)}async $provideShare(w,b,y){return await this.c.get(w)?.provideShare({selection:T.Range.to(b.selection),resourceUri:m.URI.revive(b.resourceUri)},y)??void 0}registerShareProvider(w,b){const y=A.a++;return this.c.set(y,b),this.b.$registerShareProvider(y,T.DocumentSelector.from(w,this.d),b.id,b.label,b.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$9fc=A}),define(ke[336],Se([1,0,21,3,6]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class A{static{this.a=1}constructor(w){this.c=new Map,this.d=new Map,this.b=w.getProxy(m.$CK.MainThreadSpeech)}async $createSpeechToTextSession(w,b){const y=this.c.get(w);if(!y)return;const L=new T.$Qc,P=new D.$2d;this.d.set(b,P);const $=L.add(y.provideSpeechToTextSession(P.token));L.add($.onDidChange(v=>{P.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(b,v)})),L.add(P.token.onCancellationRequested(()=>L.dispose()))}async $cancelSpeechToTextSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}registerProvider(w,b,y){const L=A.a++;return this.c.set(L,y),this.b.$registerProvider(L,b,{extension:w,displayName:w.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(L),this.c.delete(L)})}}e.$0fc=A}),define(ke[337],Se([1,0,7,6,216,3,15,18]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=e.$$fc=void 0;class b{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$zL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$zL("statusBarItem.warningForeground")]])}#e;#t;constructor($,v,S,g,d,o=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new A.$Qc,this.#e=$,this.#t=v,d&&g){this.c=(0,D.$cL)(g.identifier,d);const n=S.get(this.c);n&&(o=n.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(b.a++);this.e=g,this.f=d,this.g=o,this.h=this.u(i)}u($){if((0,w.$Gf)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!b.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new A.$Qc,typeof $=="string"?this.r={fromApi:$,internal:this.#t.toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:this.#t.toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let v;this.m?v=this.m:v=(0,m.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=b.b.get(this.o.id));const g=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,$,this.e?.identifier.value,v,this.k,g,this.r?.internal,S,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$$fc=b;class y{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,m.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const v={message:$};return this.b.unshift(v),this.c(),new D.$EK(()=>{const S=this.b.indexOf(v);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class L{constructor($,v){this.e=new Map,this.a=$.getProxy(T.$CK.MainThreadStatusBar),this.b=v,this.c=new y(this)}$acceptStaticEntries($){for(const v of $)this.e.set(v.entryId,v)}createStatusBarEntry($,v,S,g){return new b(this.a,this.b,this.e,$,v,S,g)}setStatusBarMessage($,v){const S=this.c.setMessage($);let g;return typeof v=="number"?g=setTimeout(()=>S.dispose(),v):typeof v<"u"&&v.then(()=>S.dispose(),()=>S.dispose()),new D.$EK(()=>{S.dispose(),clearTimeout(g)})}}e.$_fc=L}),define(ke[118],Se([1,0,6,4,5]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=e.$6ec=void 0;class A{constructor(w,b){this.c=b,this.b=new T.$Rd,this.onDidChangeStorage=this.b.event,this.a=w.getProxy(D.$CK.MainThreadStorage)}registerExtensionStorageKeysToSync(w,b){this.a.$registerExtensionStorageKeysToSync(w,b)}async initializeExtensionStorage(w,b,y){const L=await this.a.$initializeExtensionStorage(w,b);let P;return L&&(P=this.d(w,b,L)),P||y}setValue(w,b,y){return this.a.$setValue(w,b,y)}$acceptValue(w,b,y){const L=this.d(w,b,y);L&&this.b.fire({shared:w,key:b,value:L})}d(w,b,y){try{return JSON.parse(y)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${b}, global: ${w}): ${L}`)}}}e.$6ec=A,e.$7ec=(0,m.$Zh)("IExtHostStorage")}),define(ke[92],Se([1,0,5,27,14,71,2]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=e.$Oec=void 0,e.$Oec=(0,D.$Zh)("IExtensionStoragePaths");let w=class{constructor(y,L,P){this.d=L,this.f=P,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then($=>this.c=$)}async g(y){return R.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,L=await this.g(y);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(R.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(y){if(this.c)return R.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return R.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Pec=w,e.$Pec=w=Ke([Be(0,T.$UM),Be(1,m.$hj),Be(2,A.$Nec)],w)}),define(ke[47],Se([1,0,4,6,5,2,20,3,7,218,8,262,21,30,263,61,12,15,35]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=e.$_ec=e.$$ec=e.$0ec=void 0,e.$0ec=(0,m.$Zh)("IExtHostTerminalService");class n{constructor(f,p,k,I){this.l=f,this._id=p,this.m=k,this.n=I,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const j=this;this.value={get name(){return j.n||""},get processId(){return j.b},get creationOptions(){return j.m},get exitStatus(){return j.h},get state(){return j.j},get selection(){return j.k},sendText(z,M=!0){j.q(),j.l.$sendText(j._id,z,M)},show(z){j.q(),j.l.$show(j._id,z)},hide(){j.q(),j.l.$hide(j._id)},dispose(){j.a||(j.a=!0,j.l.$dispose(j._id))},get dimensions(){if(!(j.d===void 0||j.g===void 0))return{columns:j.d,rows:j.g}}}}async create(f,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??p?.cwd??void 0,env:f.env??void 0,icon:c(f.iconPath)??void 0,color:g.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,isFeatureTerminal:p?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:p?.useShellEnvironment??void 0,location:p?.location||this.o(f.location,p?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,p,k,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:k,color:g.ThemeColor.isThemeColor(I)?I.id:void 0,location:this.o(f,p),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(f,p){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&p?{parentTerminal:p}:"viewColumn"in f?{viewColumn:o.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.n=f}setExitStatus(f,p){this.h=Object.freeze({code:f,reason:p})}setDimensions(f,p){return f===this.d&&p===this.g||f===0||p===0?!1:(this.d=f,this.g=p,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(f){this.k=f}_setProcessId(f){this.f?(this.f(f),this.f=void 0):this.b.then(p=>{p!==f&&(this.b=Promise.resolve(f))})}}e.$$ec=n;class s{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new D.$Rd,this.onProcessData=this.a.event,this.b=new D.$Rd,this.d=new D.$Rd,this.onDidChangeProperty=this.d.event,this.f=new D.$Rd,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,p){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${p}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,p){this.g.setDimensions?.({columns:f,rows:p})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(p=>this.a.fire(p)),this.g.onDidClose?.((p=void 0)=>{this.f.fire(p===void 0?void 0:p)}),this.g.onDidOverrideDimensions?.(p=>{p&&this.d.fire({type:"overrideDimensions",value:{cols:p.columns,rows:p.rows}})}),this.g.onDidChangeName?.(p=>{this.d.fire({type:"title",value:p})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends w.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,p,k){super(),this.Q=p,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new w.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Rd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Rd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Rd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Rd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Rd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Rd,this.onDidChangeShell=this.N.event,this.O=new D.$Rd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Rd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(T.$CK.MainThreadTerminalService),this.y=new S.$2qb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:I=>{const j=z=>{const M=z;return this.W(M.instanceId)?.value};switch(I?.$mid){case 15:return j(I);default:{if(Array.isArray(I))for(let z=0;z<I.length&&I[z].$mid===15;z++)I[z]=j(I[z]);return I}}}}),this.B({dispose:()=>{for(const[I,j]of this.g)j.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,p){const k=new n(this.a,(0,v.$kg)(),f,f.name),I=new s(f.pty);return k.createExtensionTerminal(f.location,this.R(f,p).resolvedExtHostIdentifier,c(f.iconPath),l(f.color)).then(j=>{const z=this.S(j,I);this.h[j]=z}),this.f.push(k),k.value}R(f,p){if(p=p||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const k=f.location.parentTerminal;if(k){const I=this.f.find(j=>j.value===k);I&&(p.resolvedExtHostIdentifier=I._id)}}else f.location&&typeof f.location!="object"?p.location=f.location:p.location&&typeof p.location=="object"&&"splitActiveTerminal"in p.location&&(p.location={splitActiveTerminal:!0});return p}attachPtyToTerminal(f,p){if(!this.W(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const I=new s(p),j=this.S(f,I);this.h[f]=j}async $acceptActiveTerminalChanged(f){const p=this.b;if(f===null){this.b=void 0,p!==this.b&&this.J.fire(this.b);return}const k=this.W(f);k&&(this.b=k,p!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,p){const k=this.W(f);k&&this.O.fire({terminal:k.value,data:p})}async $acceptTerminalDimensions(f,p,k){const I=this.W(f);I&&I.setDimensions(p,k)&&this.L.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptDidExecuteCommand(f,p){const k=this.W(f);k&&this.P.fire({terminal:k.value,...p})}async $acceptTerminalMaximumDimensions(f,p,k){this.g.get(f)?.resize(p,k)}async $acceptTerminalTitleChange(f,p){const k=this.W(f);k&&(k.name=p)}async $acceptTerminalClosed(f,p,k){const I=this.Y(this.f,f);if(I!==null){const j=this.f.splice(I,1)[0];j.setExitStatus(p,k),this.H.fire(j.value)}}$acceptTerminalOpened(f,p,k,I){if(p){const M=this.Y(this.f,p);if(M!==null){this.f[M]._id=f,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const j={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:A.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},z=new n(this.a,f,j,k);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(f,p){this.W(f)?._setProcessId(p)}async $startExtensionTerminal(f,p){const k=this.W(f);if(!k)return{message:(0,y.localize)(0,null,f)};k.isOpen||await new Promise(j=>{const z=this.onDidOpenTerminal(async M=>{M===k.value&&(z.dispose(),j())})});const I=this.g.get(f);I?I.startSendingEvents(p):this.j[f]={initialDimensions:p}}S(f,p){const k=new w.$Qc;k.add(p.onProcessReady(j=>this.a.$sendProcessReady(f,j.pid,j.cwd,j.windowsPty))),k.add(p.onDidChangeProperty(j=>this.a.$sendProcessProperty(f,j))),this.y.startBuffering(f,p.onProcessData),k.add(p.onProcessExit(j=>this.U(f,j))),this.g.set(f,p);const I=this.j[f];return I&&p instanceof s&&(p.startSendingEvents(I.initialDimensions),delete this.j[f]),k}$acceptProcessAckDataEvent(f,p){this.g.get(f)?.acknowledgeDataEvent(p)}$acceptProcessInput(f,p){this.g.get(f)?.input(p)}$acceptTerminalInteraction(f){const p=this.W(f);p?.setInteractedWith()&&this.M.fire(p.value)}$acceptTerminalSelection(f,p){this.W(f)?.setSelection(p)}$acceptProcessResize(f,p,k){try{this.g.get(f)?.resize(p,k)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(f,p){this.g.get(f)?.shutdown(p)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(p=>this.a.$sendProcessProperty(f,{type:"initialCwd",value:p}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(p=>this.a.$sendProcessProperty(f,{type:"cwd",value:p}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new b.$EK(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,p,k){if(this.C.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this.C.set(p,k),this.a.$registerProfileProvider(p,f.identifier.value),new b.$EK(()=>{this.C.delete(p),this.a.$unregisterProfileProvider(p)})}registerTerminalQuickFixProvider(f,p,k){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,k),this.a.$registerQuickFixProvider(f,p),new b.$EK(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,p){const k=new $.$2d().token;if(k.isCancellationRequested)return;const I=this.D.get(f);if(!I)return;const j=await I.provideTerminalQuickFixes(p,k);if(j===null||Array.isArray(j)&&j.length===0)return;const z=new w.$Qc;if(this.w.value=z,!Array.isArray(j))return j?o.TerminalQuickFix.from(j,this.Q.converter,z):void 0;const M=[];for(const F of j){const N=o.TerminalQuickFix.from(F,this.Q.converter,z);N&&M.push(N)}return M}async $createContributedProfileTerminal(f,p){const k=new $.$2d().token;let I=await this.C.get(f)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(I&&!("options"in I)&&(I={options:I}),!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,p);return}this.createTerminalFromOptions(I.options,p)}}async $provideLinks(f,p){const k=this.W(f);if(!k)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const j=new $.$2d;this.G.set(f,j);const z=[],M={terminal:k.value,line:p},F=[];for(const W of this.z)F.push(d.Promises.withAsyncBody(async x=>{j.token.onCancellationRequested(()=>x({provider:W,links:[]}));const ue=await W.provideTerminalLinks(M,j.token)||[];j.token.isCancellationRequested||x({provider:W,links:ue})}));const N=await Promise.all(F);if(j.token.isCancellationRequested)return[];const O=new Map;for(const W of N)W&&W.links.length>0&&z.push(...W.links.map(x=>{const ue={id:a++,startIndex:x.startIndex,length:x.length,label:x.tooltip};return O.set(ue.id,{provider:W.provider,link:x}),ue}));return this.F.set(f,O),z}$activateLink(f,p){const k=this.F.get(f)?.get(p);k&&k.provider.handleTerminalLink(k.link)}U(f,p){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const k=this.h[f];k&&(k.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,p)}W(f){return this.X(this.f,f)}X(f,p){const k=this.Y(f,p);return k!==null?f[k]:null}Y(f,p){const k=f.findIndex(I=>I._id===p);return k===-1?null:k}getEnvironmentVariableCollection(f){let p=this.n.get(f.identifier.value);return p||(p=new r,this.$(f.identifier.value,p)),p.getScopedEnvironmentVariableCollection(void 0)}Z(f,p){const k=(0,P.$ur)(p.map),I=(0,P.$vr)(p.descriptionMap);this.a.$setEnvironmentVariableCollection(f,p.persistent,k.length===0?void 0:k,I)}$initEnvironmentVariableCollections(f){f.forEach(p=>{const k=p[0],I=new r(p[1]);this.$(k,I)})}$acceptDefaultProfile(f,p){const k=this.s;this.s=f,this.u=p,k?.path!==f.path&&this.N.fire(f.path)}$(f,p){this.n.set(f,p),p.onDidChangeCollection(()=>{this.Z(f,p)})}};e.$_ec=t,e.$_ec=t=Ke([Be(1,i.$1M),Be(2,R.$EM)],t);class r{get persistent(){return this.b}set persistent(f){this.b=f,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(f){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Rd,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const p=this.h(f);let k=this.a.get(p);return k||(k=new h(this,f),this.a.set(p,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(f,p,k,I){this.f(f,{value:p,type:b.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:I})}append(f,p,k,I){this.f(f,{value:p,type:b.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:I})}prepend(f,p,k,I){this.f(f,{value:p,type:b.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:I})}f(f,p){if(p.options&&p.options.applyAtProcessCreation===!1&&!p.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(f,p.scope),I=this.map.get(k),j=p.options?{applyAtProcessCreation:p.options.applyAtProcessCreation??!1,applyAtShellIntegration:p.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!I||I.value!==p.value||I.type!==p.type||I.options?.applyAtProcessCreation!==j.applyAtProcessCreation||I.options?.applyAtShellIntegration!==j.applyAtShellIntegration||I.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index){const z=this.g(f,p.scope),M={variable:f,...p,options:j};this.map.set(z,M),this.d.fire()}}get(f,p){const k=this.g(f,p),I=this.map.get(k);return I?E(I):void 0}g(f,p){const k=this.h(p);return k.length?`${f}:::${k}`:f}h(f){return this.j(f?.workspaceFolder)??""}j(f){return f?f.uri.toString():void 0}getVariableMap(f){const p=new Map;for(const[k,I]of this.map)this.h(I.scope)===this.h(f)&&p.set(I.variable,E(I));return p}delete(f,p){const k=this.g(f,p);this.map.delete(k),this.d.fire()}clear(f){if(f?.workspaceFolder){for(const[p,k]of this.map)k.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(p);this.k(f)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(f,p){const k=this.h(p),I=this.descriptionMap.get(k);if(!I||I.description!==f){let j;typeof f=="string"?j=f:j=f?.value.split(`

`)[0];const z={description:j,scope:p};this.descriptionMap.set(k,z),this.d.fire()}}getDescription(f){const p=this.h(f);return this.descriptionMap.get(p)?.description}k(f){const p=this.h(f);this.descriptionMap.delete(p)}}class h{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,p){this.b=f,this.d=p,this.a=new D.$Rd}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,p,k){this.b.replace(f,p,k,this.d)}append(f,p,k){this.b.append(f,p,k,this.d)}prepend(f,p,k){this.b.prepend(f,p,k,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,p){this.b.getVariableMap(this.d).forEach((k,I)=>f.call(p,I,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let u=class extends t{constructor(f,p){super(!1,f,p)}createTerminal(f,p,k){throw new L.$$}createTerminalFromOptions(f,p){throw new L.$$}};e.$afc=u,e.$afc=u=Ke([Be(0,i.$1M),Be(1,R.$EM)],u);function c(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function l(C){return g.ThemeColor.isThemeColor(C)?C:void 0}function E(C){const f={...C};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(ke[338],Se([1,0,121,12,22,21,4,74,52,3,24,18,30,6,20,148,15,7,67,112,89,25]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=e.$fgc=e.$egc=e.$dgc=void 0;let t=class extends y.$Rc{constructor(M,F,N){super(),this.u=N,this.f=this.B(new R.$Rd),this.g=new Map,this.s=this.B(new R.$Rd),this.onResultsChanged=this.f.event,this.results=[],this.h=M.getProxy(v.$CK.MainThreadTesting),this.m=new k(this.h),this.j=new c(this.h),F.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const W=O,x=W.tests[W.tests.length-1].item.extId;return this.g.get(i.$vJ.root(x))?.collection.tree.get(x)?.actual??(0,g.$QM)(O)}case 18:{const{extId:W,message:x}=O;return{test:this.g.get(i.$vJ.root(W))?.collection.tree.get(W)?.actual,message:d.TestMessage.to(x)}}default:return O}}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await F.executeCommand("_testing.getExplorerSelection"),W=x=>{const ue=this.g.get(i.$vJ.root(x));if(ue)return i.$vJ.isRoot(x)?ue.controller:ue.collection.tree.get(x)?.actual};return{include:O?.include.map(W).filter(P.$Kf)||[],exclude:O?.exclude.map(W).filter(P.$Kf)||[]}})}createTestController(M,F,N,O){if(this.g.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const W=new y.$Qc,x=W.add(new g.$TM(F,N,this.u));x.root.label=N;const ue=new Map,X=new Set,J=this.h,Q={items:x.root.children,get label(){return N},set label(Z){N=Z,x.root.label=Z,J.$updateController(F,{label:N})},get refreshHandler(){return O},set refreshHandler(Z){O=Z,J.$updateController(F,{canRefresh:!!Z})},get id(){return F},createRunProfile:(Z,ye,de,H,U,ne)=>{let Ee=(0,b.$Ni)(Z);for(;ue.has(Ee);)Ee++;return new I(this.h,ue,M,X,this.s.event,F,Ee,Z,ye,de,H,U,ne)},createTestItem(Z,ye,de){return new g.$RM(F,Z,ye,de)},createTestRun:(Z,ye,de=!0)=>this.j.createTestRun(M,F,x,Z,ye,de),invalidateTestResults:Z=>{if(Z===void 0)this.h.$markTestRetired(void 0);else{const ye=Z instanceof Array?Z:[Z];this.h.$markTestRetired(ye.map(de=>i.$vJ.fromExtHostTestItem(de,F).toString()))}},set resolveHandler(Z){x.resolveHandler=Z},get resolveHandler(){return x.resolveHandler},dispose:()=>{W.dispose()}};J.$registerTestController(F,N,!!O),W.add((0,y.$Pc)(()=>J.$unregisterTestController(F)));const he={controller:Q,collection:x,profiles:ue,extension:M,activeProfiles:X};return this.g.set(F,he),W.add((0,y.$Pc)(()=>this.g.delete(F))),W.add(x.onDidGenerateDiff(Z=>J.$publishDiff(F,Z.map(s.TestsDiffOp.serialize)))),Q}createTestObserver(){return this.m.checkout()}async runTests(M,F=A.CancellationToken.None){const N=l(M);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.g.get(N.controllerId);if(!O)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(W=>i.$vJ.fromExtHostTestItem(W,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:j[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:M.exclude?.map(W=>W.id)},F)}$syncTests(){for(const{collection:M}of this.g.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,F,N){return(0,D.$qb)(this.j.trackers,W=>W.id===M?W.getCoverage(F):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(M,F,N,O){return(0,D.$qb)(this.j.trackers,x=>x.id===M?x.getCoverage(F):void 0)?.resolveFileCoverage(N,O)??Promise.resolve([])}$configureRunProfile(M,F){this.g.get(M)?.profiles.get(F)?.configureHandler?.()}$setActiveRunProfiles(M){const F=new Map;for(const[N,O]of Object.entries(M)){const W=this.g.get(N);if(!W)continue;const x=new Map,ue=O.filter(J=>!W.activeProfiles.has(J)),X=[...W.activeProfiles].filter(J=>!O.includes(J));for(const J of ue)x.set(J,!0),W.activeProfiles.add(J);for(const J of X)x.set(J,!1),W.activeProfiles.delete(J);x.size&&F.set(N,x)}this.s.fire(F)}async $refreshTests(M,F){await this.g.get(M)?.controller.refreshHandler?.(F)}$publishTestResults(M){this.results=Object.freeze(M.map(F=>(0,L.$fn)(d.TestResults.to(F))).concat(this.results).sort((F,N)=>N.completedAt-F.completedAt).slice(0,32)),this.f.fire()}async $expandTest(M,F){const N=this.g.get(i.$vJ.fromString(M).controllerId)?.collection;N&&(await N.expand(M,F<0?1/0:F),N.flushDiff())}$acceptDiff(M){this.m.applyDiff(M.map(s.TestsDiffOp.deserialize))}async $runControllerTests(M,F){return Promise.all(M.map(N=>this.w(N,!1,F)))}async $startContinuousRun(M,F){const N=new A.$2d(F),O=await Promise.all(M.map(W=>this.w(W,!0,N.token)));return!F.isCancellationRequested&&!O.some(W=>W.error)&&await new Promise(W=>F.onCancellationRequested(W)),N.dispose(!0),O}async w(M,F,N){const O=this.g.get(M.controllerId);if(!O)return{};const{collection:W,profiles:x,extension:ue}=O,X=x.get(M.profileId);if(!X)return{};const J=M.testIds.map(ye=>W.tree.get(ye)).filter(P.$Kf),Q=M.excludeExtIds.map(ye=>O.collection.tree.get(ye)).filter(P.$Kf).filter(ye=>J.some(de=>de.fullId.compare(ye.fullId)===2));if(!J.length)return{};const he=new o.$aM(J.some(ye=>ye.actual instanceof g.$SM)?void 0:J.map(ye=>ye.actual),Q.map(ye=>ye.actual),X,F),Z=(0,s.$xJ)(M)&&this.j.prepareForMainThreadTestRun(he,E.fromInternal(M,O.collection),ue,N);try{return await X.runHandler(he,N),{}}catch(ye){return{error:String(ye)}}finally{Z&&(Z.hasRunningTasks&&!N.isCancellationRequested&&await R.Event.toPromise(Z.onEnd),Z.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.j.cancelAllRuns():this.j.cancelRunById(M)}};e.$dgc=t,e.$dgc=t=Ke([Be(0,S.$EM)],t);const r=1e4;var h;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(h||(h={}));class u extends y.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(M,F,N){super(),this.m=M,this.s=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Rd),this.onEnd=this.j.event,this.h=this.B(new A.$2d(N));const O=this.B(new T.$_g(()=>this.u(),r));this.B(this.h.token.onCancellationRequested(()=>O.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const F=this.m.id,N=this.m.controllerId,O=(0,$.$kg)(),W=new C(this.s,F,O),x=Q=>(he,...Z)=>{if(X){console.warn(`Setting the state of test "${he.id}" is a no-op after the run ends.`);return}this.m.isIncluded(he)&&(this.y(he),Q(he,...Z))},ue=(Q,he)=>{const Z=he instanceof Array?he.map(d.TestMessage.from):[d.TestMessage.from(he)];if(Q.uri&&Q.range){const ye={range:d.Range.from(Q.range),uri:Q.uri};for(const de of Z)de.location=de.location||ye}this.s.$appendTestMessagesInRun(F,O,i.$vJ.fromExtHostTestItem(Q,N).toString(),Z)};let X=!1;const J={isPersisted:this.m.isPersisted,token:this.h.token,name:M,get coverageProvider(){return W.coverageProvider},set coverageProvider(Q){W.coverageProvider=Q},enqueued:x(Q=>{this.s.$updateTestStateInRun(F,O,i.$vJ.fromExtHostTestItem(Q,N).toString(),1)}),skipped:x(Q=>{this.s.$updateTestStateInRun(F,O,i.$vJ.fromExtHostTestItem(Q,N).toString(),5)}),started:x(Q=>{this.s.$updateTestStateInRun(F,O,i.$vJ.fromExtHostTestItem(Q,N).toString(),2)}),errored:x((Q,he,Z)=>{ue(Q,he),this.s.$updateTestStateInRun(F,O,i.$vJ.fromExtHostTestItem(Q,N).toString(),6,Z)}),failed:x((Q,he,Z)=>{ue(Q,he),this.s.$updateTestStateInRun(F,O,i.$vJ.fromExtHostTestItem(Q,N).toString(),4,Z)}),passed:x((Q,he)=>{this.s.$updateTestStateInRun(F,O,i.$vJ.fromExtHostTestItem(Q,this.m.controllerId).toString(),3,he)}),appendOutput:(Q,he,Z)=>{X||(Z&&(this.m.isIncluded(Z)?this.y(Z):Z=void 0),this.s.$appendOutputToRun(F,O,m.$fe.fromString(Q),he&&d.location.from(he),Z&&i.$vJ.fromExtHostTestItem(Z,N).toString()))},end:()=>{X||(X=!0,this.s.$finishedTestRunTask(F,O),this.f.delete(O),this.f.size||this.w())}};return this.f.set(O,{run:J,coverage:W}),this.s.$startedTestRunTask(F,{id:O,name:M,running:!0}),J}u(){for(const{run:M}of this.f.values())M.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(M){if(!(M instanceof g.$RM))throw new n.$wM(M.id);if(this.g.has(i.$vJ.fromExtHostTestItem(M,this.m.controllerId).toString()))return;const F=[],N=this.m.colllection.root;for(;;){const O=d.TestItem.from(M);if(F.unshift(O),this.g.has(O.extId)||(this.g.add(O.extId),M===N))break;M=M.parent||N}this.s.$addTestsToRun(this.m.controllerId,this.m.id,F)}dispose(){this.w(),super.dispose()}}class c{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,F,N,O){return this.f(M,F,N,O)}cancelRunById(M){for(const F of this.c.values())if(F.id===M){F.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,F,N,O,W,x){const ue=this.c.get(O);if(ue)return ue.createRun(W);const X=E.fromPublic(F,N,O,x),J=l(O);this.d.$startedExtensionTestRun({controllerId:F,continuous:!!O.continuous,profile:J&&{group:j[J.kind],id:J.profileId},exclude:O.exclude?.map(he=>i.$vJ.fromExtHostTestItem(he,N.root.id).toString())??[],id:X.id,include:O.include?.map(he=>i.$vJ.fromExtHostTestItem(he,N.root.id).toString())??[N.root.id],persist:x});const Q=this.f(O,X,M);return R.Event.once(Q.onEnd)(()=>{this.d.$finishedExtensionTestRun(X.id),Q.dispose()}),Q.createRun(W)}f(M,F,N,O){const W=new u(F,this.d,O);return this.c.set(M,W),R.Event.once(W.onEnd)(()=>this.c.delete(M)),W}}e.$egc=c;const l=z=>{if(z.profile){if(!(z.profile instanceof I))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class E{static fromPublic(M,F,N,O){return new E(M,(0,$.$kg)(),N.include?.map(W=>i.$vJ.fromExtHostTestItem(W,M).toString())??[M],N.exclude?.map(W=>i.$vJ.fromExtHostTestItem(W,M).toString())??[],O,F)}static fromInternal(M,F){return new E(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,F)}constructor(M,F,N,O,W,x){this.controllerId=M,this.id=F,this.isPersisted=W,this.colllection=x,this.c=N.map(ue=>ue+"\0"),this.d=O.map(ue=>ue+"\0")}isIncluded(M){const F=i.$vJ.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const N of this.d)if(F===N||F.startsWith(N))return!1;for(const N of this.c)if(F===N||F.startsWith(N))return!0;return!1}}e.$fgc=E;class C{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,F,N){this.f=M,this.g=F,this.h=N}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(d.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(M,F){const N=await this.d;let O=N?.[M];return!this.c||!N||!O?[]:(O.detailedCoverage||(O=N[M]=await this.c.resolveFileCoverage?.(O,F)??O),O.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class f{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,d.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const F=i.$vJ.parentId(M.item.extId);if(F&&this.g.has(F.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:F,f:N}=this;return{get added(){return[...M].map(O=>O.revived)},get updated(){return[...F].map(O=>O.revived)},get removed(){return[...N].map(O=>O.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class p extends s.$CJ{constructor(){super(...arguments),this.q=new R.$Rd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,F){return{...M,revived:d.TestItem.toPlain(M.item),depth:F?F.depth+1:0,children:new Set}}o(){return new f(this.q)}}class k{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(F=>F.revived)},dispose:(0,w.$cb)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new p;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class I{#e;#t;#i;#o;#r;get label(){return this.d}set label(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?d.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}get isSelected(){return(0,a.$QF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,a.$QF)(this.#t,"testingActiveProfile"),R.Event.chain(this.#o,M=>M.map(F=>F.get(this.controllerId)?.get(this.profileId)).filter(P.$Kf))}constructor(M,F,N,O,W,x,ue,X,J,Q,he=!1,Z=void 0,ye=!1){this.controllerId=x,this.profileId=ue,this.d=X,this.kind=J,this.runHandler=Q,this.f=he,this._tag=Z,this.g=ye,this.#e=M,this.#r=F,this.#t=N,this.#i=O,this.#o=W,F.set(ue,this);const de=j[J];if(typeof de!="number")throw new Error(`Unknown TestRunProfile.group ${J}`);this.#e.$publishTestRunProfile({profileId:ue,controllerId:x,tag:Z?d.TestTag.namespace(this.controllerId,Z.id):null,label:X,group:de,isDefault:he,hasConfigurationHandler:!1,supportsContinuousRun:ye})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$ggc=I;const j={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(ke[339],Se([1,0,19,8,4,6,149,15,7]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0;class y{constructor(P,$){this.i=$,this.a=new m.$Rd({onListenerError:T.$1}),this.b=new m.$Rd({onListenerError:T.$1}),this.c=new m.$Rd({onListenerError:T.$1}),this.d=new m.$Rd({onListenerError:T.$1}),this.f=new m.$Rd({onListenerError:T.$1}),this.g=new m.$Rd({onListenerError:T.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=P.getProxy(A.$CK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(P){const $=this.i.allEditors();return P?$:$.map(v=>v.value)}async showTextDocument(P,$,v){let S;typeof $=="number"?S={position:w.ViewColumn.from($),preserveFocus:v}:typeof $=="object"?S={position:w.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus,selection:typeof $.selection=="object"?w.Range.from($.selection):void 0,pinned:typeof $.preview=="boolean"?!$.preview:void 0}:S={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(P.uri,S),d=g&&this.i.getEditor(g);if(d)return d.value;throw g?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,$){return new R.$LM(this.h,P,$).value}$acceptEditorPropertiesChanged(P,$){const v=this.i.getEditor(P);if(!v)throw new Error("unknown text editor");if($.options&&v._acceptOptions($.options),$.selections){const S=$.selections.selections.map(w.Selection.to);v._acceptSelections(S)}if($.visibleRanges){const S=D.$Gb($.visibleRanges.map(w.Range.to));v._acceptVisibleRanges(S)}if($.options&&this.b.fire({textEditor:v.value,options:{...$.options,lineNumbers:w.TextEditorLineNumbersStyle.to($.options.lineNumbers)}}),$.selections){const S=b.TextEditorSelectionChangeKind.fromValue($.selections.source),g=$.selections.selections.map(w.Selection.to);this.a.fire({textEditor:v.value,selections:g,kind:S})}if($.visibleRanges){const S=D.$Gb($.visibleRanges.map(w.Range.to));this.c.fire({textEditor:v.value,visibleRanges:S})}}$acceptEditorPositionData(P){for(const $ in P){const v=this.i.getEditor($);if(!v)throw new Error("Unknown text editor");const S=w.ViewColumn.to(P[$]);v.value.viewColumn!==S&&(v._acceptViewColumn(S),this.d.fire({textEditor:v.value,viewColumn:S}))}}getDiffInformation(P){return Promise.resolve(this.h.$getDiffInformation(P))}}e.$Cec=y}),define(ke[340],Se([1,0,2,5,6,3,7,15,26,18]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=e.$igc=void 0,e.$igc=(0,T.$Zh)("IExtHostTimeline");class L{constructor(v,S){this.b=new Map,this.c=new Map,this.a=v.getProxy(m.$CK.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(g,d)=>{if(g&&g.$mid===12)if(this.b.get(g.source)&&b.$dm.equals(d,this.b.get(g.source)?.extension)){const o=g.uri===void 0?void 0:D.URI.revive(g.uri);return this.c.get(g.source)?.get(P(o))?.get(g.handle)}else return;return g}})}async $getTimeline(v,S,g,d){return this.b.get(v)?.provider.provideTimeline(D.URI.revive(S),g,d)}registerTimelineProvider(v,S,g,d){const o=new A.$Qc,i=this.d(S.id,d,o).bind(this);let n;S.onDidChange&&(n=S.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:S.id}),this));const s=this.c;return this.f({...S,scheme:v,onDidChange:void 0,async provideTimeline(a,t,r){t?.resetCache&&(o.clear(),s.get(S.id)?.clear());const h=await S.provideTimeline(a,t,r);if(h==null)return;const u=i(a,t);return{...h,source:S.id,items:h.items.map(u)}},dispose(){for(const a of s.values())a.get(S.id)?.clear();n?.dispose(),o.dispose()}},g)}d(v,S,g){return(d,o)=>{let i;if(o?.cacheResults){let n=this.c.get(v);n===void 0&&(n=new Map,this.c.set(v,n));const s=P(d);i=n.get(s),i===void 0&&(i=new Map,n.set(s,i))}return n=>{const{iconPath:s,...a}=n,t=`${v}|${n.id??n.timestamp}`;i?.set(t,n);let r,h,u;n.iconPath&&(s instanceof R.$yL?u={id:s.id,color:s.color}:D.URI.isUri(s)?(r=s,h=s):{light:r,dark:h}=s);let c;return R.$5K.isMarkdownString(a.tooltip)?c=w.MarkdownString.from(a.tooltip):(0,y.$Cf)(a.tooltip)?c=a.tooltip:R.$5K.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=w.MarkdownString.from(a.detail)):(0,y.$Cf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=a.detail),{...a,id:a.id??void 0,handle:t,source:v,command:n.command?S.toInternal(n.command,g):void 0,icon:r,iconDark:h,themeIcon:u,tooltip:c,accessibilityInformation:n.accessibilityInformation}}}}f(v,S){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:S}),(0,A.$Pc)(()=>{for(const d of this.c.values())d.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$jgc=L;function P($){return $?.toString()}}),define(ke[72],Se([1,0,21,4,3,220,5,14,88,6,27,20,7]),function(be,e,D,T,m,A,R,w,b,y,L,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fxb=e.$Exb=e.TunnelDtoConverter=void 0;class v extends b.$qv{}var S;(function(d){function o(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?b.TunnelPrivacyId.Public:b.TunnelPrivacyId.Private),protocol:n.protocol}}d.fromApiTunnel=o;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==b.TunnelPrivacyId.ConstantPrivate&&n.privacy!==b.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}d.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$Exb=(0,R.$Zh)("IExtHostTunnelService");let g=class extends m.$Rc{constructor(o,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Rd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(y.$CK.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,o.displayName);if(n){const s=new v(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){const n=this.u();return this.r.set(n,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,n),new $.$EK(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(o,i,n,s,a){const t=[];for(const h of o){const u=this.r.get(h);if(!u)return[];t.push(...await Promise.all(i.map(async c=>{let l;try{l=await u.provider.providePortAttributes({port:c,pid:n,commandLine:s},a)}catch{l=await u.provider.providePortAttributes(c,n,s,a)}return{providedAttributes:l,port:c}})))}const r=t.filter(h=>!!h.providedAttributes);return r.length>0?r.map(h=>({autoForwardAction:h.providedAttributes.autoForwardAction,port:h.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,a)=>await o.provideTunnel(s,a,new D.$2d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,m.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const n=o.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let s=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const a=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:s}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,m.$Pc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const n=this.g.get(o.host);n.has(o.port)&&(i&&n.get(o.port).disposeListener.dispose(),await n.get(o.port).tunnel.dispose(),n.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const s=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const a=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:s,disposeListener:a}),S.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(s=>this.f(s.host,s.port,s.detail??""))),n=o.filter((s,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(s=>s.port).join(", ")} to ${n.map(s=>s.port).join(", ")}`),n}};e.$Fxb=g,e.$Fxb=g=Ke([Be(0,P.$EM),Be(1,L.$UM),Be(2,w.$hj)],g)}),define(ke[341],Se([1,0,3,17,2,6]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;class R{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(b){this.c=new Map,this.b=b.getProxy(A.$CK.MainThreadUriOpeners)}registerExternalUriOpener(b,y,L,P){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const $=P.schemes.find(v=>!R.a.has(v));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(y,L),this.b.$registerUriOpener(y,P.schemes,b,P.label),(0,D.$Pc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri(b,y,L){const P=this.c.get(b);if(!P)throw new Error(`Unknown opener with id: ${b}`);const $=m.URI.revive(y);return P.canOpenExternalUri($,L)}async $openUri(b,y,L){const P=this.c.get(b);if(!P)throw new Error(`Unknown opener id: '${b}'`);return P.openExternalUri(m.URI.revive(y.resolvedUri),{sourceUri:m.URI.revive(y.sourceUri)},L)}}e.$lgc=R}),define(ke[342],Se([1,0,6,2,3,8,26]),function(be,e,D,T,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class w{static{this.a=0}constructor(y){this.c=new R.$em,this.d=new Map,this.b=y.getProxy(D.$CK.MainThreadUrls)}registerUriHandler(y,L){const P=y.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const $=w.a++;return this.c.add(P),this.d.set($,L),this.b.$registerUriHandler($,P,y.displayName||y.name),(0,m.$Pc)(()=>{this.c.delete(P),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(y,L){const P=this.d.get(y);if(!P)return Promise.resolve(void 0);try{P.handleUri(T.URI.revive(L))}catch($){(0,A.$Z)($)}return Promise.resolve(void 0)}async createAppUri(y){return T.URI.revive(await this.b.$createAppUri(y))}}e.$mgc=w}),define(ke[93],Se([1,0,4,3,17,24,2,237,274,113,6]),function(be,e,D,T,m,A,R,w,b,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=e.$Tec=e.$Sec=e.$Rec=e.$Qec=void 0;class P{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(s,a,t,r,h,u,c){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new D.$Rd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Rd,this._onDidDispose=this.#h.event,this.#e=s,this.#t=a,this.#s=t,this.#o=r,this.#r=h,this.#n=u,this.#l=$(u),this.#d=v(u),this.#i=c}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#u=!0,(0,y.$Nub)(s,this.#o)}get cspSource(){const s=this.#n.extensionLocation;if(s.scheme===m.Schemas.https||s.scheme===m.Schemas.http){let a=s.toString();return a.endsWith("/")||(a+="/"),a+" "+y.$Mub}return y.$Mub}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#s}set options(s){this.a(),A.$in(this.#s,s)||this.#t.$setOptions(this.#e,d(this.#n,this.#r,s)),this.#s=s}async postMessage(s){if(this.#c)return!1;const a=(0,b.$gfb)(s,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const a=this.#n.extensionLocation?.scheme===m.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===m.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,h,u,c,l,E)=>{const C=R.URI.from({scheme:c||"file",path:decodeURIComponent(l)}),f=(0,y.$Nub)(C,{isRemote:a,authority:t}).toString();return`${h}${f}${E}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,h,u,c,l,E)=>{const C=R.URI.from({scheme:c||"file",path:decodeURIComponent(l)}),f=(0,y.$Nub)(C,{isRemote:a,authority:t}).toString();return`${h}${f}${E}`})}}e.$Qec=P;function $(n){try{const s=(0,w.$Xo)((0,w.$Wo)(n.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}e.$Rec=$;function v(n){try{const s=(0,w.$Xo)((0,w.$Wo)(n.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class S extends T.$Rc{constructor(s,a,t,r,h){super(),this.c=a,this.f=t,this.g=r,this.h=h,this.b=new Map,this.a=s.getProxy(L.$CK.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,a,t){const r=this.j(s);if(r){const{message:h}=(0,b.$hfb)(a,t.value);r._onMessageEmitter.fire(h)}}$onMissingCsp(s,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,a,t){const r=new P(s,this.a,o(a),this.c,this.f,t,this.h);this.b.set(s,r);const h=r._onDidDispose(()=>{h.dispose(),this.deleteWebview(s)});return r}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$Sec=S;function g(n){return{id:n.identifier,location:n.extensionLocation}}e.$Tec=g;function d(n,s,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,s)}}e.$Uec=d;function o(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(s=>R.URI.from(s))}}function i(n,s){return[...(s?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(ke[343],Se([1,0,21,52,3,17,23,2,15,93,110,6,7]),function(be,e,D,T,m,A,R,w,b,y,L,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class v{constructor(r,h){this.document=r,this.b=h,this.a=1,this.c=new L.$jec("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,h){await this.f(r).undo(),h||this.disposeBackup()}async redo(r,h){await this.f(r).redo(),h||this.disposeBackup()}disposeEdits(r){for(const h of r)this.c.delete(h)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=a(this.document.uri)+this.a++;return(0,R.$Bg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const h=this.c.get(r,0);if(!h)throw new Error("No edit found");return h}}class S{constructor(){this.a=new Map}get(r,h){return this.a.get(this.b(r,h))}add(r,h,u){const c=this.b(r,h.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${r} resource:${h.uri}`);const l=new v(h,u);return this.a.set(c,l),l}delete(r,h){const u=this.b(r,h.uri);this.a.delete(u)}b(r,h){return`${r}@@@${h}`}}var g;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(g||(g={}));class d{constructor(){this.a=new Map}addTextProvider(r,h,u){return this.b(0,r,h,u)}addCustomProvider(r,h,u){return this.b(1,r,h,u)}get(r){return this.a.get(r)}b(r,h,u,c){if(this.a.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this.a.set(h,{type:r,extension:u,provider:c}),new $.$EK(()=>this.a.delete(h))}}class o{constructor(r,h,u,c,l){this.d=h,this.f=u,this.g=c,this.h=l,this.b=new d,this.c=new S,this.a=r.getProxy(P.$CK.MainThreadCustomEditors)}registerCustomEditorProvider(r,h,u,c){const l=new m.$Qc;return n(u)?(l.add(this.b.addTextProvider(h,r,u)),this.a.$registerTextEditorProvider((0,y.$Tec)(r),h,c.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,y.$Rec)(r))):(l.add(this.b.addCustomProvider(h,r,u)),i(u)&&l.add(u.onDidChangeCustomDocument(E=>{const C=this.i(h,E.document.uri);if(s(E)){const f=C.addEdit(E);this.a.$onDidEdit(E.document.uri,h,f,E.label)}else this.a.$onContentChange(E.document.uri,h)})),this.a.$registerCustomEditorProvider((0,y.$Tec)(r),h,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,y.$Rec)(r))),$.$EK.from(l,new $.$EK(()=>{this.a.$unregisterEditorProvider(h)}))}async $createCustomDocument(r,h,u,c,l){const E=this.b.get(h);if(!E)throw new Error(`No provider found for '${h}'`);if(E.type!==1)throw new Error(`Invalid provide type for '${h}'`);const C=w.URI.revive(r),f=await E.provider.openCustomDocument(C,{backupId:u,untitledDocumentData:c?.buffer},l);let p;return i(E.provider)&&this.f&&(p=this.f.workspaceValue(E.extension)??this.f.globalValue(E.extension)),this.c.add(h,f,p),{editable:i(E.provider)}}async $disposeCustomDocument(r,h){const u=this.b.get(h);if(!u)throw new Error(`No provider found for '${h}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${h}'`);const c=w.URI.revive(r),{document:l}=this.i(h,c);this.c.delete(h,l),l.dispose()}async $resolveCustomEditor(r,h,u,c,l,E){const C=this.b.get(u);if(!C)throw new Error(`No provider found for '${u}'`);const f=b.ViewColumn.to(l),p=this.g.createNewWebview(h,c.contentOptions,C.extension),k=this.h.createNewWebviewPanel(h,u,c.title,f,c.options,p,c.active),I=w.URI.revive(r);switch(C.type){case 1:{const{document:j}=this.i(u,I);return C.provider.resolveCustomEditor(j,k,E)}case 0:{const j=this.d.getDocument(I);return C.provider.resolveCustomTextEditor(j,k,E)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,h,u){this.i(h,r).disposeEdits(u)}async $onMoveCustomEditor(r,h,u){const c=this.b.get(u);if(!c)throw new Error(`No provider found for '${u}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const l=this.h.getWebviewPanel(r);if(!l)throw new Error("No webview found");const E=w.URI.revive(h),C=this.d.getDocument(E);await c.provider.moveCustomTextEditor(C,l,D.CancellationToken.None)}async $undo(r,h,u,c){return this.i(h,r).undo(u,c)}async $redo(r,h,u,c){return this.i(h,r).redo(u,c)}async $revert(r,h,u){const c=this.i(h,r);await this.j(h).revertCustomDocument(c.document,u),c.disposeBackup()}async $onSave(r,h,u){const c=this.i(h,r);await this.j(h).saveCustomDocument(c.document,u),c.disposeBackup()}async $onSaveAs(r,h,u,c){const l=this.i(h,r);return this.j(h).saveCustomDocumentAs(l.document,w.URI.revive(u),c)}async $backup(r,h,u){const c=this.i(h,r),E=await this.j(h).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},u);return c.updateBackup(E),E.id}i(r,h){const u=this.c.get(r,w.URI.revive(h));if(!u)throw new Error("No custom document found");return u}j(r){const u=this.b.get(r)?.provider;if(!u||!i(u))throw new Error("Custom document is not editable");return u}}e.$Wec=o;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function s(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const r=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,T.$Ni)(r)+""}}),define(ke[344],Se([1,0,4,3,2,30,15,93,6,7]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0;class L extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(S,g,d,o){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new D.$Rd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Rd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=g,this.#o=d,this.#i=o.viewType,this.#r=o.panelOptions,this.#s=o.viewColumn,this.#n=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(S){this.c(),this.#n!==S&&(this.#n=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,m.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#s=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,g){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:R.ViewColumn.from(S),preserveFocus:!!g})}c(){if(this.#l)throw new Error("Webview is disposed")}}class P extends T.$Rc{static c(){return(0,A.$kg)()}constructor(S,g,d){super(),this.j=g,this.m=d,this.g=new Map,this.h=new Map,this.f=S.getProxy(b.$CK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,g,d,o,i={}){const n=typeof o=="object"?o.viewColumn:o,s={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof o=="object"&&!!o.preserveFocus},a=(0,w.$Rec)(S),t=P.c();this.f.$createWebviewPanel((0,w.$Tec)(S),t,g,{title:d,panelOptions:$(i),webviewOptions:(0,w.$Uec)(S,this.m,i),serializeBuffersForPostMessage:a},s);const r=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,g,d,n,i,r,!0)}$onDidChangeWebviewPanelViewStates(S){const g=Object.keys(S);g.sort((d,o)=>{const i=S[d],n=S[o];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const d of g){const o=this.getWebviewPanel(d);if(!o)continue;const i=S[d];o._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,g,d){if(this.h.has(g))throw new Error(`Serializer for '${g}' already registered`);return this.h.set(g,{serializer:d,extension:S}),this.f.$registerSerializer(g,{serializeBuffersForPostMessage:(0,w.$Rec)(S)}),new y.$EK(()=>{this.h.delete(g),this.f.$unregisterSerializer(g)})}async $deserializeWebviewPanel(S,g,d,o){const i=this.h.get(g);if(!i)throw new Error(`No serializer found for '${g}'`);const{serializer:n,extension:s}=i,a=this.j.createNewWebview(S,d.webviewOptions,s),t=this.createNewWebviewPanel(S,g,d.title,o,d.panelOptions,a,d.active);await n.deserializeWebviewPanel(t,d.state)}createNewWebviewPanel(S,g,d,o,i,n,s){const a=new L(S,this.f,n,{viewType:g,title:d,viewColumn:o,panelOptions:i,active:s});return this.g.set(S,a),a}getWebviewPanel(S){return this.g.get(S)}}e.$Vec=P;function $(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(ke[345],Se([1,0,4,3,93,15,6,7]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;class b extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(P,$,v,S,g,d){super(),this.#r=!1,this.#u=this.B(new D.$Rd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new D.$Rd),this.onDidDispose=this.#l.event,this.#i=v,this.#a=S,this.#e=P,this.#t=$,this.#o=g,this.#n=d}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(P){this.a(),this.#a!==P&&(this.#a=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.a(),this.#s}set description(P){this.a(),this.#s!==P&&(this.#s=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(P){P===this.#n||this.#r||(this.#n=P,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(P){this.a(),!(P?.value===this.#c?.value&&P?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.a(),this.#t.$show(this.#e,!!P)}a(){if(this.#r)throw new Error("Webview is disposed")}}class y{constructor(P,$){this.d=$,this.b=new Map,this.c=new Map,this.a=P.getProxy(R.$CK.MainThreadWebviewViews)}registerWebviewViewProvider(P,$,v,S){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:v,extension:P}),this.a.$registerWebviewViewProvider((0,m.$Tec)(P),$,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,m.$Rec)(P)}),new w.$EK(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(P,$,v,S,g){const d=this.b.get($);if(!d)throw new Error(`No view provider found for '${$}'`);const{provider:o,extension:i}=d,n=this.d.createNewWebview(P,{},i),s=new b(P,this.a,$,v,n,!0);this.c.set(P,s),await o.resolveWebviewView(s,{state:S},g)}async $onDidChangeWebviewViewVisibility(P,$){this.e(P)._setVisible($)}async $disposeWebviewView(P){const $=this.e(P);this.c.delete(P),$.dispose(),this.d.deleteWebview(P)}e(P){const $=this.c.get(P);if(!$)throw new Error("No webview found");return $}}e.$ngc=y}),define(ke[152],Se([1,0,4,6,2,17,13,5,20,25]),function(be,e,D,T,m,A,R,w,b,y){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=e.$ogc=void 0;let P=class{static{L=this}static{this.a={focused:!0,active:!0}}getState(v){const S=this.d;return{get focused(){return S.focused},get active(){return(0,y.$QF)(v,"windowActivity"),S.active}}}constructor(v){this.c=new D.$Rd,this.onDidChangeWindowState=this.c.event,this.d=L.a,this.b=v.getProxy(T.$CK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:g})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,S){S!==this.d[v]&&(this.d={...this.d,[v]:S},this.c.fire(this.d))}openUri(v,S){let g;if(typeof v=="string"){g=v;try{v=m.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,R.$Fe)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,g,S)}async asExternalUri(v,S){if((0,R.$Fe)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(v,S);return m.URI.from(g)}};e.$ogc=P,e.$ogc=P=L=Ke([Be(0,b.$EM)],P),e.$pgc=(0,w.$Zh)("IExtHostWindow")}),define(ke[346],Se([1,0,314,27,20]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;const A=1024*1024;let R=class extends D.$sgc{constructor(b,y){super(b,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(b,y,L){const P=b==="error"||b==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),y.apply(console,L),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(b,y){const L=process[b],P=L.write;let $="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(v,S,g)=>{if(!this.g){$+=v.toString(S);const d=$.length>A?$.length:$.lastIndexOf(`
`);d!==-1&&(console[y]($.slice(0,d)),$=$.slice(d+1))}P.call(L,v,S,g)}})}};e.$4gc=R,e.$4gc=R=Ke([Be(0,m.$EM),Be(1,T.$UM)],R)}),define(ke[347],Se([1,0,71,17,14,249,32,11]),function(be,e,D,T,m,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0;let b=class{constructor(P,$){P.addFileSystemProvider(T.Schemas.file,new y($),{isCaseSensitive:w.$k})}};e.$5gc=b,e.$5gc=b=Ke([Be(0,D.$Nec),Be(1,m.$hj)],b);class y{constructor(P){this.b=P,this.a=new A.$kq(this.b)}async stat(P){const $=await this.a.stat(P);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,$,v){return this.a.writeFile(P,$,{...v,unlock:!1,atomic:!1})}delete(P,$){return this.a.delete(P,{...$,useTrash:!1,atomic:!1})}rename(P,$,v){return this.a.rename(P,$,v)}copy(P,$,v){return this.a.copy(P,$,v)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,$){throw new Error("Method not implemented.")}}}),define(ke[348],Se([1,0,16,63,30,35,3,6,2,20]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=void 0;let L=class extends R.$Rc{constructor($,v){super();const S=$.getProxy(w.$CK.MainThreadDownloadService);v.registerCommand(!1,"_workbench.downloadResource",async g=>{const d=b.URI.file((0,D.$ic)((0,T.tmpdir)(),(0,m.$kg)()));return await S.$download(g,d),d})}};e.$3gc=L,e.$3gc=L=Ke([Be(0,y.$EM),Be(1,A.$1M)],L)}),define(ke[349],Se([1,0,151,17,251,30]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;class R extends D.$rgc{s(b,y,L){return b.scheme===T.Schemas.file?new m.$QN(L?.name||(0,A.$kg)(),b.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,y):super.s(b,y,L)}registerLogger(b){super.registerLogger(b),this.r.$registerLogger(b)}deregisterLogger(b){super.deregisterLogger(b),this.r.$deregisterLogger(b)}}e.$dhc=R}),define(ke[350],Se([1,0,55,16,2,92,3,17,12,31]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class L extends A.$Pec{constructor(){super(...arguments),this.i=null}async g(t){const r=await super.g(t);if(r.scheme!==w.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const h=r.fsPath;let u=0;do{let c;u===0?c=h:c=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${u}`:`${h}-${u}`,await P(c);const l=T.$ic(c,"vscode.lock"),E=await g(this.d,l,!1);if(E)return this.i=E,process.on("exit",()=>{E.dispose()}),m.URI.file(c);u++}while(u<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$chc=L;async function P(a){try{await y.Promises.stat(a);return}catch{}try{await y.Promises.mkdir(a,{recursive:!0})}catch{}}const $=1e3,v=10*60*1e3;class S extends R.$Rc{constructor(t,r){super(),this.b=t,this.c=r,this.a=this.B(new b.$$g),this.a.cancelAndSet(async()=>{const h=await d(t,r);(!h||h.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(r,new Date,new Date)}catch(u){t.error(u),t.info(`Lock '${r}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function g(a,t,r){try{const u={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(u),{flag:"wx"})}catch(u){a.error(u)}const h=await d(a,t);return!h||h.pid!==process.pid?r?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new S(a,t))}async function d(a,t){let r;try{r=await y.Promises.readFile(t)}catch(h){return a.error(h),null}try{return JSON.parse(String(r))}catch(h){return a.error(h),null}}async function o(a,t){let r;try{r=await y.Promises.stat(t)}catch(h){return a.error(h),0}return r.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const r=await d(a,t);if(!r)return a.info(`Lock '${t}': Could not read pid of lock holder.`),s(a,t);if(r.willReleaseAt){let E=r.willReleaseAt-Date.now();if(E<5e3){for(E>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${E} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);E>0;){if(await(0,b.$1g)(Math.min(100,E)),await o(a,t)===0)return s(a,t);E=r.willReleaseAt-Date.now()}return s(a,t)}}if(!i(r.pid))return a.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),s(a,t);const h=await o(a,t),u=Date.now()-h;if(u<=v)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,b.$1g)(2e3);const c=await o(a,t),l=Date.now()-c;return l<=v?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),s(a,t))}async function s(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return g(a,t,!0)}}),define(ke[351],Se([1,0,30,20,47,35]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;let R=class extends m.$_ec{constructor(b,y){super(!0,b,y)}createTerminal(b,y,L){return this.createTerminalFromOptions({name:b,shellPath:y,shellArgs:L})}createTerminalFromOptions(b,y){const L=new m.$$ec(this.a,(0,D.$kg)(),b,b.name);return this.f.push(L),L.create(b,this.R(b,y)),L.value}};e.$xgc=R,e.$xgc=R=Ke([Be(0,A.$1M),Be(1,T.$EM)],R)}),define(ke[352],Se([1,0,12,22,21,8,4,3,131,303,68]),function(be,e,D,T,m,A,R,w,b,y,L){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$F6b=e.ResponsiveState=e.RequestInitiator=e.$E6b=e.$D6b=void 0;function $(k,I){try{return JSON.stringify(k,I)}catch{return"null"}}const v="$$ref$$",S={[v]:-1};class g{constructor(I,j){this.jsonString=I,this.referencedBuffers=j}}function d(k,I=null,j=!1){const z=[];return{jsonString:(j?$:JSON.stringify)(k,(F,N)=>{if(typeof N>"u")return S;if(typeof N=="object"){if(N instanceof T.$fe){const O=z.push(N)-1;return{[v]:O}}if(I)return I(F,N)}return N}),referencedBuffers:z}}e.$D6b=d;function o(k,I,j){return JSON.parse(k,(z,M)=>{if(M){const F=M[v];if(typeof F=="number")return I[F];if(j&&M.$mid===1)return j.transformIncoming(M)}return M})}e.$E6b=o;function i(k,I){return JSON.stringify(k,I)}function n(k){return k?(I,j)=>j&&j.$mid===1?k.transformOutgoing(j):j:null}var s;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(s||(e.RequestInitiator=s={}));var a;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},r=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class u extends w.$Rc{static{P=r}static{this.a=3*1e3}constructor(I,j=null,z=null){super(),this[P]=!0,this.b=this.B(new R.$Rd),this.onDidChangeResponsiveState=this.b.event,this.c=I,this.f=j,this.g=z,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,F=L.$xv.count;M<F;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$_g(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(I=>{const j=this.w[I];delete this.w[I],j.resolveErr(A.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(I){this.z===0&&(this.C=Date.now()+u.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(I){this.C=Date.now()+u.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(I){this.y!==I&&(this.y=I,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(I){return this.g?(0,b.$Ym)(I,this.g):I}getProxy(I){const{nid:j,sid:z}=I;return this.s[j]||(this.s[j]=this.J(j,z)),this.s[j]}J(I,j){const z={get:(M,F)=>(typeof F=="string"&&!M[F]&&F.charCodeAt(0)===36&&(M[F]=(...N)=>this.U(I,F,N)),F===h?j:M[F])};return new Proxy(Object.create(null),z)}set(I,j){return this.m[I.nid]=j,j}assertRegistered(I){for(let j=0,z=I.length;j<z;j++){const M=I[j];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(I){if(this.j)return;const j=I.byteLength,z=l.read(I,0),M=z.readUInt8(),F=z.readUInt32();switch(M){case 1:case 2:{let{rpcId:N,method:O,args:W}=C.deserializeRequestJSONArgs(z);this.g&&(W=(0,b.$Ym)(W,this.g)),this.M(j,F,N,O,W,M===2);break}case 3:case 4:{let{rpcId:N,method:O,args:W}=C.deserializeRequestMixedArgs(z);this.g&&(W=(0,b.$Ym)(W,this.g)),this.M(j,F,N,O,W,M===4);break}case 5:{this.f?.logIncoming(j,F,0,"ack"),this.G(F);break}case 6:{this.N(j,F);break}case 7:{this.O(j,F,void 0);break}case 9:{let N=C.deserializeReplyOKJSON(z);this.g&&(N=(0,b.$Ym)(N,this.g)),this.O(j,F,N);break}case 10:{const N=C.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(j,F,N);break}case 8:{const N=C.deserializeReplyOKVSBuffer(z);this.O(j,F,N);break}case 11:{let N=C.deserializeReplyErrError(z);this.g&&(N=(0,b.$Ym)(N,this.g)),this.P(j,F,N);break}case 12:{this.P(j,F,void 0);break}default:console.error("received unexpected message"),console.error(I)}}M(I,j,z,M,F,N){this.f?.logIncoming(I,j,1,`receiveRequest ${(0,L.$zv)(z)}.${M}(`,F);const O=String(j);let W,x;if(N){const X=new m.$2d;F.push(X.token),W=this.Q(z,M,F),x=()=>X.cancel()}else W=this.Q(z,M,F),x=t;this.u[O]=x;const ue=C.serializeAcknowledged(j);this.f?.logOutgoing(ue.byteLength,j,1,"ack"),this.c.send(ue),W.then(X=>{delete this.u[O];const J=C.serializeReplyOK(j,X,this.h);this.f?.logOutgoing(J.byteLength,j,1,"reply:",X),this.c.send(J)},X=>{delete this.u[O];const J=C.serializeReplyErr(j,X);this.f?.logOutgoing(J.byteLength,j,1,"replyErr:",X),this.c.send(J)})}N(I,j){this.f?.logIncoming(I,j,1,"receiveCancel");const z=String(j);this.u[z]?.()}O(I,j,z){this.f?.logIncoming(I,j,0,"receiveReply:",z);const M=String(j);if(!this.w.hasOwnProperty(M))return;const F=this.w[M];delete this.w[M],F.resolveOk(z)}P(I,j,z){this.f?.logIncoming(I,j,0,"receiveReplyErr:",z);const M=String(j);if(!this.w.hasOwnProperty(M))return;const F=this.w[M];delete this.w[M];let N;z&&(z.$isError?(N=new Error,N.name=z.name,N.message=z.message,N.stack=z.stack):N=z),F.resolveErr(N)}Q(I,j,z){try{return Promise.resolve(this.S(I,j,z))}catch(M){return Promise.reject(M)}}S(I,j,z){const M=this.m[I];if(!M)throw new Error("Unknown actor "+(0,L.$zv)(I));const F=M[j];if(typeof F!="function")throw new Error("Unknown method "+j+" on actor "+(0,L.$zv)(I));return F.apply(M,z)}U(I,j,z){if(this.j)return new y.$C6b;let M=null;if(z.length>0&&m.CancellationToken.isCancellationToken(z[z.length-1])&&(M=z.pop()),M&&M.isCancellationRequested)return Promise.reject(A.$5());const F=C.serializeRequestArguments(z,this.h),N=++this.t,O=String(N),W=new y.$B6b,x=new w.$Qc;M&&x.add(M.onCancellationRequested(()=>{const X=C.serializeCancel(N);this.f?.logOutgoing(X.byteLength,N,0,"cancel"),this.c.send(C.serializeCancel(N))})),this.w[O]=new c(W,x),this.F(N);const ue=C.serializeRequest(N,I,j,F,!!M);return this.f?.logOutgoing(ue.byteLength,N,0,`request: ${(0,L.$zv)(I)}.${j}(`,z),this.c.send(ue),W}}e.$F6b=u;class c{constructor(I,j){this.a=I,this.b=j}resolveOk(I){this.a.resolveOk(I),this.b.dispose()}resolveErr(I){this.a.resolveErr(I),this.b.dispose()}}class l{static alloc(I,j,z){const M=new l(T.$fe.alloc(z+1+4),0);return M.writeUInt8(I),M.writeUInt32(j),M}static read(I,j){return new l(I,j)}get buffer(){return this.a}constructor(I,j){this.a=I,this.b=j}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(I){this.a.writeUInt8(I,this.b),this.b+=1}readUInt8(){const I=this.a.readUInt8(this.b);return this.b+=1,I}writeUInt32(I){this.a.writeUInt32BE(I,this.b),this.b+=4}readUInt32(){const I=this.a.readUInt32BE(this.b);return this.b+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this.a.writeUInt8(I.byteLength,this.b),this.b+=1,this.a.set(I,this.b),this.b+=I.byteLength}readShortString(){const I=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+I).toString();return this.b+=I,z}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readLongString(){const I=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+I).toString();return this.b+=I,z}writeBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readVSBuffer(){const I=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+I);return this.b+=I,j}static sizeMixedArray(I){let j=0;j+=1;for(let z=0,M=I.length;z<M;z++){const F=I[z];switch(j+=1,F.type){case 1:j+=this.sizeLongString(F.value);break;case 2:j+=this.sizeVSBuffer(F.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(F.value);for(let N=0;N<F.buffers.length;++N)j+=this.sizeVSBuffer(F.buffers[N]);break;case 4:break}}return j}writeMixedArray(I){this.a.writeUInt8(I.length,this.b),this.b+=1;for(let j=0,z=I.length;j<z;j++){const M=I[j];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let F=0;F<M.buffers.length;++F)this.writeBuffer(M.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this.a.readUInt8(this.b);this.b+=1;const j=new Array(I);for(let z=0;z<I;z++)switch(this.readUInt8()){case 1:j[z]=this.readLongString();break;case 2:j[z]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),N=this.readLongString(),O=[];for(let W=0;W<F;++W)O.push(this.readVSBuffer());j[z]=new L.$Av(o(N,O,null));break}case 4:j[z]=void 0;break}return j}}var E;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(E||(E={}));class C{static a(I){for(let j=0,z=I.length;j<z;j++)if(I[j]instanceof T.$fe||I[j]instanceof L.$Av||typeof I[j]>"u")return!0;return!1}static serializeRequestArguments(I,j){if(this.a(I)){const z=[];for(let M=0,F=I.length;M<F;M++){const N=I[M];if(N instanceof T.$fe)z[M]={type:2,value:N};else if(typeof N>"u")z[M]={type:4};else if(N instanceof L.$Av){const{jsonString:O,referencedBuffers:W}=d(N.value,j);z[M]={type:3,value:T.$fe.fromString(O),buffers:W}}else z[M]={type:1,value:T.$fe.fromString(i(N,j))}}return{type:1,args:z}}return{type:0,args:i(I,j)}}static serializeRequest(I,j,z,M,F){switch(M.type){case 0:return this.b(I,j,z,M.args,F);case 1:return this.c(I,j,z,M.args,F)}}static b(I,j,z,M,F){const N=T.$fe.fromString(z),O=T.$fe.fromString(M);let W=0;W+=l.sizeUInt8(),W+=l.sizeShortString(N),W+=l.sizeLongString(O);const x=l.alloc(F?2:1,I,W);return x.writeUInt8(j),x.writeShortString(N),x.writeLongString(O),x.buffer}static deserializeRequestJSONArgs(I){const j=I.readUInt8(),z=I.readShortString(),M=I.readLongString();return{rpcId:j,method:z,args:JSON.parse(M)}}static c(I,j,z,M,F){const N=T.$fe.fromString(z);let O=0;O+=l.sizeUInt8(),O+=l.sizeShortString(N),O+=l.sizeMixedArray(M);const W=l.alloc(F?4:3,I,O);return W.writeUInt8(j),W.writeShortString(N),W.writeMixedArray(M),W.buffer}static deserializeRequestMixedArgs(I){const j=I.readUInt8(),z=I.readShortString(),M=I.readMixedArray(),F=new Array(M.length);for(let N=0,O=M.length;N<O;N++){const W=M[N];typeof W=="string"?F[N]=JSON.parse(W):F[N]=W}return{rpcId:j,method:z,args:F}}static serializeAcknowledged(I){return l.alloc(5,I,0).buffer}static serializeCancel(I){return l.alloc(6,I,0).buffer}static serializeReplyOK(I,j,z){if(typeof j>"u")return this.d(I);if(j instanceof T.$fe)return this.e(I,j);if(j instanceof L.$Av){const{jsonString:M,referencedBuffers:F}=d(j.value,z,!0);return this.g(I,M,F)}else return this.f(I,$(j,z))}static d(I){return l.alloc(7,I,0).buffer}static e(I,j){let z=0;z+=l.sizeVSBuffer(j);const M=l.alloc(8,I,z);return M.writeVSBuffer(j),M.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static f(I,j){const z=T.$fe.fromString(j);let M=0;M+=l.sizeLongString(z);const F=l.alloc(9,I,M);return F.writeLongString(z),F.buffer}static g(I,j,z){const M=T.$fe.fromString(j);let F=0;F+=l.sizeUInt32,F+=l.sizeLongString(M);for(const O of z)F+=l.sizeVSBuffer(O);const N=l.alloc(10,I,F);N.writeUInt32(z.length),N.writeLongString(M);for(const O of z)N.writeBuffer(O);return N.buffer}static deserializeReplyOKJSON(I){const j=I.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(I,j){const z=I.readUInt32(),M=I.readLongString(),F=[];for(let N=0;N<z;++N)F.push(I.readVSBuffer());return new L.$Av(o(M,F,j))}static serializeReplyErr(I,j){const z=j?$(A.$2(j),null):void 0;if(typeof z!="string")return this.h(I);const M=T.$fe.fromString(z);let F=0;F+=l.sizeLongString(M);const N=l.alloc(11,I,F);return N.writeLongString(M),N.buffer}static deserializeReplyErrError(I){const j=I.readLongString();return JSON.parse(j)}static h(I){return l.alloc(12,I,0).buffer}}var f;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var p;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(p||(p={}))}),define(ke[353],Se([1,0,4,37,46,5]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YJ=e.$XJ=e.OutputChannelUpdateMode=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=void 0,e.$NJ="text/x-code-output",e.$OJ="output",e.$PJ="Log",e.$QJ="text/x-code-log-output",e.$RJ="log",e.$SJ="workbench.panel.output",e.$TJ=new m.$ej("inOutput",!1),e.$UJ=new m.$ej("activeLogOutput",!1),e.$VJ=new m.$ej("outputView.scrollLock",!1),e.$WJ=(0,A.$Zh)("outputService");var R;(function(b){b[b.Append=1]="Append",b[b.Replace=2]="Replace",b[b.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$XJ={OutputChannels:"workbench.contributions.outputChannels"};class w{constructor(){this.a=new Map,this.b=new D.$Rd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Rd,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(L=>y.push(L)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}T.$qn.add(e.$XJ.OutputChannels,new w),e.$YJ=new m.$ej("activeOutputChannel","")}),define(ke[153],Se([1,0,6,5,20,26,14,353,71,27,57,181,22,18,32,4,3]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=void 0;class o extends R.$nj{get disposed(){return this.n}constructor(a,t,r,h,u){super(),this.id=a,this.name=t,this.r=r,this.s=h,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,w.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=$.$fe.fromString(t).byteLength,(0,R.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(a){this.append(a)}}let n=class{constructor(a,t,r,h,u,c){this.i=t,this.j=r,this.k=h,this.l=u,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(D.$CK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$om)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(a,t,r){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const h=typeof t=="object"&&t.log,u=(0,v.$Cf)(t)?t:void 0;if((0,v.$Cf)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const l=this.i.environment.extensionLogLevel?.find(([C])=>A.$dm.equals(r.identifier,C))?.[1];l&&(c=(0,R.$xj)(l));const E=h?this.o(a,c,r):this.n(a,u,r);return E.then(C=>{this.g.set(C.id,C),C.visible=C.id===this.h}),h?this.r(a,c??this.m.getLevel(),E):this.q(a,E)}async n(a,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const h=await this.c,u=this.k.extUri.joinPath(h,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.a.$register(a,u,t,r.identifier.value);return new o(l,a,c,this.a,r)}async o(a,t,r){const h=await this.p(r),u=a.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(h,`${u}.log`),l=`${r.identifier.value}.${u}`,E=this.l.createLogger(c,{id:l,name:a,logLevel:t,extensionId:r.identifier.value});return new i(l,a,E,this.a,r)}p(a){let t=this.d.get(a.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(h){if((0,S.$yk)(h)!==S.FileSystemProviderErrorCode.FileExists)throw h}return r})())}return t}q(a,t){let r=!1;const h=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return a},append(u){h(),t.then(c=>c.append(u))},appendLine(u){h(),t.then(c=>c.appendLine(u))},clear(){h(),t.then(u=>u.clear())},replace(u){h(),t.then(c=>c.replace(u))},show(u,c){h(),t.then(l=>l.show(u,c))},hide(){h(),t.then(u=>u.hide())},dispose(){r=!0,t.then(u=>u.dispose())}}}r(a,t,r){const h=new d.$Qc,u=()=>{if(h.isDisposed)throw new Error("Channel has been closed")},c=h.add(new g.$Rd);function l(E){t=E,c.fire(E)}return r.then(E=>{h.add(E),E.logLevel!==t&&l(E.logLevel),h.add(E.onDidChangeLogLevel(C=>l(C)))}),{...this.q(a,r),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(E,...C){u(),r.then(f=>f.trace(E,...C))},debug(E,...C){u(),r.then(f=>f.debug(E,...C))},info(E,...C){u(),r.then(f=>f.info(E,...C))},warn(E,...C){u(),r.then(f=>f.warn(E,...C))},error(E,...C){u(),r.then(f=>f.error(E,...C))},dispose(){h.dispose()}}}};e.$1fc=n,e.$1fc=n=Ke([Be(0,m.$EM),Be(1,y.$UM),Be(2,b.$Nec),Be(3,L.$nec),Be(4,R.$ij),Be(5,R.$hj)],n),e.$2fc=(0,T.$Zh)("IExtHostOutputService")}),define(ke[154],Se([1,0,5,12]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=void 0,e.$Dm=(0,D.$Zh)("remoteAgentService"),e.$Em=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(m){let A=1/0;for(let w=0;w<this.maxSampleCount;w++){const b=await m.getRoundTripTime();if(b===void 0)return;A=Math.min(A,b/2),await(0,T.$1g)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(A):R=this.initial.reduce((w,b)=>w+b,0)/this.initial.length,this.lastMeasurement={initial:R,current:A,average:this.average.reduce((w,b)=>w+b,0)/this.average.length,high:(()=>typeof R>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[354],Se([1,0,223,86,37,40,45,3,4,154,11,24]),function(be,e,D,T,m,A,R,w,b,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=void 0,e.$sH=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$tH=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$uH=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$vH={ConfigurationMigration:"base.contributions.configuration.migration"};class ${constructor(){this.migrations=[],this.a=new b.$Rd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const v=new $;m.$qn.add(e.$vH.ConfigurationMigration,v);let S=class extends w.$Rc{constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const s of n.added)await this.f(s,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(n=>this.g(n,o?.uri))])}async g(o,i){const n=this.a.inspect(o.key,{resource:i}),s=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[a,t]of s){const r=[];for(const u of n.overrideIdentifiers??[]){const c=await this.h(o,{resource:i,overrideIdentifier:u},a);for(const l of c??[]){let E=r.find(([[C,f]])=>C===l[0]&&(0,P.$in)(f.value,l[1].value));E||r.push(E=[l,[]]),E[1].push(u)}}const h=await this.h(o,{resource:i},a,n);for(const u of h??[])r.push([u,[]]);r.length&&await Promise.allSettled(r.map(async([[u,c],l])=>this.a.updateValue(u,c.value,{resource:i,overrideIdentifiers:l},t)))}}async h(o,i,n,s){const a=(s??this.a.inspect(o.key,i))[n];if(a===void 0)return;const t=h=>this.a.inspect(h,i)[n],r=await o.migrateFn(a,t);return Array.isArray(r)?r:[[o.key,r]]}};e.$wH=S,e.$wH=S=Ke([Be(0,R.$ti),Be(1,A.$9h)],S);let g=class extends w.$Rc{constructor(o){super(),(async()=>{if(!L.$i&&(await o.getEnvironment())?.os!==1)return;m.$qn.as(T.$vn.Configuration).registerConfiguration({...e.$uH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(3,null)},default:[],markdownDescription:(0,D.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(5,null),scope:2}}})})()}};e.$xH=g,e.$xH=g=Ke([Be(0,y.$Dm)],g)}),define(ke[355],Se([1,0,34,17,16,23,232,354,86,5,37]),function(be,e,D,T,m,A,R,w,b,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scb=e.$Rcb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Qcb=e.$Pcb=void 0,e.$Pcb=(0,y.$Zh)("editorResolverService"),e.$Qcb="workbench.editorAssociations";const P=L.$qn.as(b.$vn.Configuration),$={...w.$tH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};P.registerConfiguration($);var v;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(v||(e.RegisteredEditorPriority=v={}));var S;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function g(o){switch(o){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$Rcb=g;function d(o,i){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof o=="string"&&o.indexOf(m.$fc.sep)>=0?`${i.scheme}:${i.path}`:(0,A.$yg)(i);return D.$Fj(typeof o=="string"?o.toLowerCase():o,a.toLowerCase())}e.$Scb=d}),define(ke[356],Se([1,0,33,17,16,11,23,2,5,267,40,145,154]),function(be,e,D,T,m,A,R,w,b,y,L,P,$){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$fK=e.$eK=void 0,e.$eK=(0,b.$Zh)("pathService");let S=v=class{constructor(d,o,i,n){this.d=d,this.e=o,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??d})()}hasValidBasename(d,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(n=>this.h(d,n,o)):this.h(d,o,i)}h(d,o,i){return d.scheme===T.Schemas.file||d.scheme===T.Schemas.vscodeRemote?(0,D.$Zf)(i??(0,R.$yg)(d),o===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,o){if(d.remoteAuthority)return T.Schemas.vscodeRemote;const i=(0,y.$bK)(o.getWorkspace());if(i)return i;const n=o.getWorkspace().folders[0];if(n)return n.uri.scheme;const s=o.getWorkspace().configuration;return s?s.scheme:T.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?m.$ec:m.$fc)}async fileURI(d){let o="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const n=d.indexOf("/",2);n===-1?(o=d.substring(2),d="/"):(o=d.substring(2,n),d=d.substring(n)||"/")}return w.URI.from({scheme:T.Schemas.file,authority:o,path:d,query:"",fragment:""})}};e.$fK=S,e.$fK=S=v=Ke([Be(1,$.$Dm),Be(2,P.$ZJ),Be(3,L.$9h)],S)}),define(ke[357],Se([1,0,234,19,59,4,52,3,2,45,239,14,64,269,88,40,145,25,21,18,24,46]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.$0J=e.$9J=e.OnPortForward=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.TunnelSource=e.TunnelCloseReason=e.$3J=e.$2J=e.$1J=void 0;const t=10*1e3,r="remote.tunnels.toRestore";e.$1J="onTunnel",e.$2J=new a.$ej("forwardedPortsViewEnabled",!1,D.localize(0,null));function h(j){const z=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}e.$3J=h;var u;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(u||(e.TunnelCloseReason=u={}));var c;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(c||(e.TunnelSource=c={})),e.$4J={source:c.User,description:D.localize(1,null)},e.$5J={source:c.Auto,description:D.localize(2,null)};function l(j,z,M){const F=j.get(C(z,M));if(F)return F;if((0,S.$mv)(z))for(const N of S.$lv){const O=C(N,M);if(j.has(O))return j.get(O)}else if((0,S.$ov)(z))for(const N of S.$nv){const O=C(N,M);if(j.has(O))return j.get(O)}}e.$6J=l;function E(j,z,M){const F=l(j,z,M);if(F)return F;const N=(0,S.$ov)(z)?"localhost":(0,S.$mv)(z)?"0.0.0.0":void 0;if(N)return l(j,N,M)}e.$7J=E;function C(j,z){return j+":"+z}e.$8J=C;var f;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(f||(e.OnPortForward=f={}));function p(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}e.$9J=p;class k extends w.$Rc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new A.$Rd,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(M=>{(M.affectsConfiguration(k.c)||M.affectsConfiguration(k.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,M,F){let N=this.w(z,M,F,this.j,0);const O={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;N>=0;){const W=this.j[N];W.key===z?(O.onAutoForward=W.onAutoForward??O.onAutoForward,O.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:O.elevateIfNeeded,O.label=W.label??O.label,O.requireLocalPort=W.requireLocalPort,O.protocol=W.protocol):(O.onAutoForward=O.onAutoForward??W.onAutoForward,O.elevateIfNeeded=O.elevateIfNeeded!==void 0?O.elevateIfNeeded:W.elevateIfNeeded,O.label=O.label??W.label,O.requireLocalPort=O.requireLocalPort!==void 0?O.requireLocalPort:void 0,O.protocol=O.protocol??W.protocol),N=this.w(z,M,F,this.j,N+1)}return O.onAutoForward!==void 0||O.elevateIfNeeded!==void 0||O.label!==void 0||O.requireLocalPort!==void 0||O.protocol!==void 0?O:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,n.$Cf)(z.host)&&(0,n.$Gf)(z.port)}w(z,M,F,N,O){if(O>=N.length)return-1;const W=!(0,S.$mv)(M)&&!(0,S.$ov)(M),ue=N.slice(O).findIndex(X=>(0,n.$Gf)(X.key)?W?!1:X.key===z:this.t(X.key)?W?!1:z>=X.key.start&&z<=X.key.end:this.u(X.key)?z===X.key.port&&M===X.key.host:F?X.key.test(F):!1);return ue>=0?ue+O:-1}y(){const z=this.r.getValue(k.c);if(!z||!(0,n.$Ef)(z))return[];const M=[];for(const N in z){if(N===void 0)continue;const O=z[N];let W;if(Number(N))W=Number(N);else if((0,n.$Cf)(N))if(k.g.test(N)){const x=N.match(k.g);W={start:Number(x[1]),end:Number(x[2])}}else if(k.h.test(N)){const x=N.match(k.h);W={host:x[1],port:Number(x[2])}}else{let x;try{x=RegExp(N)}catch{}x&&(W=x)}W&&M.push({key:W,elevateIfNeeded:O.elevateIfNeeded,onAutoForward:O.onAutoForward,label:O.label,requireLocalPort:O.requireLocalPort,protocol:O.protocol})}const F=this.r.getValue(k.f);return F&&(this.m={elevateIfNeeded:F.elevateIfNeeded,label:F.label,onAutoForward:F.onAutoForward,requireLocalPort:F.requireLocalPort,protocol:F.protocol}),this.z(M)}z(z){function M(F,N){return(0,n.$Gf)(F.key)?F.key:N.t(F.key)?F.key.start:N.u(F.key)?F.key.port:Number.MAX_VALUE}return z.sort((F,N)=>M(F,this)-M(N,this))}C(){return this.m}static providedActionToAction(z){switch(z){case S.ProvidedOnAutoForward.Notify:return f.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return f.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return f.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return f.OpenPreview;case S.ProvidedOnAutoForward.Silent:return f.Silent;case S.ProvidedOnAutoForward.Ignore:return f.Ignore;default:return}}async addAttributes(z,M,F){const O=this.r.inspect(k.c).userRemoteValue;let W;!O||!(0,n.$Ef)(O)?W={}:W=(0,s.$en)(O),W[`${z}`]||(W[`${z}`]={});for(const x in M)W[`${z}`][x]=M[x];return this.r.updateValue(k.c,W,F)}}e.$0J=k;let I=class extends w.$Rc{constructor(z,M,F,N,O,W,x,ue,X,J){super(),this.H=z,this.I=M,this.J=F,this.L=N,this.M=O,this.N=W,this.O=x,this.P=ue,this.Q=X,this.R=J,this.c=new Map,this.g=new A.$Rd,this.onForwardPort=this.g.event,this.h=new A.$Rd,this.onClosePort=this.h.event,this.j=new A.$Rd,this.onPortName=this.j.event,this.n=new A.$Rd,this.onCandidatesChanged=this.n.event,this.t=new A.$Rd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$Rd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new k(F),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async Q=>{const he=await this.getAttributes(Q.map(Z=>({port:Z.tunnelRemotePort,host:Z.tunnelRemoteHost})));for(const Z of Q)if(Z.localAddress){const ye=C(Z.tunnelRemoteHost,Z.tunnelRemotePort),de=E(this.m??new Map,Z.tunnelRemoteHost,Z.tunnelRemotePort);this.forwarded.set(ye,{remotePort:Z.tunnelRemotePort,remoteHost:Z.tunnelRemoteHost,localAddress:Z.localAddress,protocol:he?.get(Z.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(Z.localAddress,he?.get(Z.tunnelRemotePort)),localPort:Z.tunnelLocalPort,runningProcess:de?.detail,hasRunningProcess:!!de,pid:de?.pid,privacy:Z.privacy,source:e.$4J}),this.f.set(ye,Z)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async Q=>{const he=C(Q.tunnelRemoteHost,Q.tunnelRemotePort);if(!E(this.forwarded,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&!E(this.detected,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&!E(this.c,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&Q.localAddress){const Z=E(this.m??new Map,Q.tunnelRemoteHost,Q.tunnelRemotePort),ye=(await this.getAttributes([{port:Q.tunnelRemotePort,host:Q.tunnelRemoteHost}]))?.get(Q.tunnelRemotePort);this.forwarded.set(he,{remoteHost:Q.tunnelRemoteHost,remotePort:Q.tunnelRemotePort,localAddress:Q.localAddress,protocol:ye?.protocol??S.TunnelProtocol.Http,localUri:await this.X(Q.localAddress,ye),localPort:Q.tunnelLocalPort,closeable:!0,runningProcess:Z?.detail,hasRunningProcess:!!Z,pid:Z?.pid,privacy:Q.privacy,source:e.$4J})}await this.$(),this.f.set(he,Q),this.g.fire(this.forwarded.get(he))})),this.B(this.H.onTunnelClosed(Q=>this.W(Q,u.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$1J))?(this.R.createKey(e.$2J.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,M){const F=C(z.host,z.port);this.forwarded.has(F)&&(this.forwarded.delete(F),await this.$(),this.h.fire(z))}X(z,M){if(z.startsWith("http"))return b.URI.parse(z);const F=M?.protocol??"http";return b.URI.parse(`${F}://${z}`)}async Y(){const z=this.N.getWorkspace(),M=z.configuration?(0,R.$Ni)(z.configuration.path):z.folders.length>0?(0,R.$Ni)(z.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${r}.${this.L.remoteAuthority}.${M}`}async Z(){const z=this.I.get(r,1);if(z)return this.I.remove(r,1),await this.$(),z;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const M=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(F=>F.remotePort).join(", ")}`);for(const F of M){const N=E(this.detected,F.remoteHost,F.remotePort);F.source.source!==c.Extension&&!N||F.source.source===c.Extension&&N?await this.cb({remote:{host:F.remoteHost,port:F.remotePort},local:F.localPort,name:F.name,privacy:F.privacy,elevateIfNeeded:!0,source:F.source}):F.source.source===c.Extension&&!N&&this.D.set(C(F.remoteHost,F.remotePort),F)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Y();this.w=this.B(new w.$Qc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=JSON.stringify(Array.from(this.forwarded.values()));if(z!==this.y){this.y=z;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(z,M,F){if(!z.tunnelLocalPort||!F?.requireLocalPort||z.tunnelLocalPort===M)return;const N=new Date;if(this.ab.getTime()+t>N.getTime())return;this.ab=N;const O=D.localize(3,null,M,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(O)}async forward(z,M){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.cb(z,M)}async cb(z,M){await this.Q.activateByEvent(e.$1J);const F=E(this.forwarded,z.remote.host,z.remote.port);M=M??(M!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const N=z.local!==void 0?z.local:z.remote.port;let O;if(F)return this.eb(F,z,M);{const W=this.L.remoteAuthority,x=W?{getAddress:async()=>(await this.M.resolveAuthority(W)).authority}:void 0,ue=C(z.remote.host,z.remote.port);this.c.set(ue,!0),z=this.db(ue,z);const X=await this.H.openTunnel(x,z.remote.host,z.remote.port,void 0,N,z.elevateIfNeeded?z.elevateIfNeeded:M?.elevateIfNeeded,z.privacy,M?.protocol);if(typeof X=="string")O=X;else if(X&&X.localAddress){const J=E(this.m??new Map,z.remote.host,z.remote.port),Q=X.protocol?X.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:M?.protocol??S.TunnelProtocol.Http,he={remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localPort:X.tunnelLocalPort,name:M?.label??z.name,closeable:!0,localAddress:X.localAddress,protocol:Q,localUri:await this.X(X.localAddress,M),runningProcess:J?.detail,hasRunningProcess:!!J,pid:J?.pid,source:z.source??e.$4J,privacy:X.privacy};return this.forwarded.set(ue,he),this.f.set(ue,X),this.c.delete(ue),await this.$(),await this.bb(X,N,M),this.g.fire(he),X}this.c.delete(ue)}return O}db(z,M){const F=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(F){const N=F.get(z);F.delete(z),N&&(M.name=N.name??M.name,M.local=("local"in N?N.local:"localPort"in N?N.localPort:void 0)??M.local,M.privacy=N.privacy??M.privacy)}return M}async eb(z,M,F){const N=F?.label??M.name;let O;(function(x){x[x.None=0]="None",x[x.Fire=1]="Fire",x[x.Reopen=2]="Reopen"})(O||(O={}));let W=O.None;switch(N!==z.name&&(z.name=N,W=O.Fire),(F?.protocol||z.protocol!==S.TunnelProtocol.Http)&&F?.protocol!==z.protocol&&(M.source=z.source,W=O.Reopen),M.privacy&&z.privacy!==M.privacy&&(W=O.Reopen),W){case O.Fire:{this.g.fire();break}case O.Reopen:await this.close(z.remoteHost,z.remotePort,u.User),await this.cb(M,F)}return E(this.f,M.remote.host,M.remote.port)}async name(z,M,F){const N=E(this.forwarded,z,M),O=C(z,M);if(N){N.name=F,await this.$(),this.j.fire({host:z,port:M});return}else this.detected.has(O)&&(this.detected.get(O).name=F,this.j.fire({host:z,port:M}))}async close(z,M,F){const N=C(z,M),O=this.forwarded.get(N);return F===u.AutoForwardEnd&&O&&O.source.source===c.Auto&&this.F.set(N,{local:O.localPort,name:O.name,privacy:O.privacy}),await this.H.closeTunnel(z,M),this.W({host:z,port:M},F)}address(z,M){const F=C(z,M);return(this.forwarded.get(F)||this.detected.get(F))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const M of z){const F=E(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),N=typeof M.localAddress=="string"?M.localAddress:C(M.localAddress.host,M.localAddress.port);this.detected.set(C(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:N,protocol:S.TunnelProtocol.Http,localUri:this.X(N),closeable:!1,runningProcess:F?.detail,hasRunningProcess:!!F,pid:F?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:c.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,N,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let M=z;this.r&&(M=await this.r(z));const F=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(F.values()).map(N=>N.port).join(", ")}`),this.n.fire(F)}fb(z){const M=this.m??new Map,F=new Map;return this.m=F,z.forEach(N=>{const O=C(N.host,N.port);F.set(O,{host:N.host,port:N.port,detail:N.detail,pid:N.pid}),M.has(O)&&M.delete(O);const W=E(this.forwarded,N.host,N.port);W&&(W.runningProcess=N.detail,W.hasRunningProcess=!0,W.pid=N.pid)}),M.forEach((N,O)=>{const W=h(O);if(!W)return;const x=E(this.forwarded,W.host,W.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0);const ue=E(this.detected,W.host,W.port);ue&&(ue.runningProcess=void 0,ue.hasRunningProcess=!1,ue.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const z=Array.from(this.forwarded.values()),M=await this.getAttributes(z.map(F=>({port:F.remotePort,host:F.remoteHost})),!1);if(M)for(const F of z){const N=M.get(F.remotePort);(N?.protocol||F.protocol!==S.TunnelProtocol.Http)&&N?.protocol!==F.protocol&&await this.cb({remote:{host:F.remoteHost,port:F.remotePort},local:F.localPort,name:F.name,source:F.source},N),N&&N.label&&N.label!==F.name&&await this.name(F.remoteHost,F.remotePort,N.label)}}async getAttributes(z,M=!0){const F=new Map,N=new Map;z.forEach(X=>{const J=E(this.m??new Map,S.$lv[0],X.port)??X;if(J){F.set(X.port,J);const Q=p(J)?J.pid:void 0;N.has(Q)||N.set(Q,[]),N.get(Q)?.push(X.port)}});const O=new Map;if(z.forEach(X=>{const J=this.configPortsAttributes.getAttributes(X.port,X.host,F.get(X.port)?.detail);J&&O.set(X.port,J)}),this.G.length===0||!M)return O.size>0?O:void 0;const W=await Promise.all((0,T.$Qb)(this.G.map(X=>Array.from(N.entries()).map(J=>{const Q=J[1],he=F.get(Q[0]);return X.providePortAttributes(Q,he?.pid,he?.detail,new i.$2d().token)})))),x=new Map;if(W.forEach(X=>X.forEach(J=>{J&&x.set(J.port,J)})),!O&&!x)return;const ue=new Map;return z.forEach(X=>{const J=O.get(X.port),Q=x.get(X.port);ue.set(X.port,{elevateIfNeeded:J?.elevateIfNeeded,label:J?.label,onAutoForward:J?.onAutoForward??k.providedActionToAction(Q?.autoForwardAction),requireLocalPort:J?.requireLocalPort,protocol:J?.protocol})}),ue}addAttributesProvider(z){this.G.push(z)}};e.$$J=I,Ke([(0,m.$sh)(1e3)],I.prototype,"$",null),e.$$J=I=Ke([Be(0,S.$hv),Be(1,v.$dp),Be(2,y.$ti),Be(3,d.$ZJ),Be(4,$.$Zk),Be(5,g.$9h),Be(6,P.$hj),Be(7,L.$Mv),Be(8,o.$MF),Be(9,a.$fj)],I)}),define(ke[94],Se([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$UI=e.$TI=void 0;class D{constructor(R,w){this.line=R,this.character=w}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,w){return new D(0,0)}with(R){return new D(0,0)}}e.$TI=D;class T{constructor(R,w,b,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(R,w),this.end=new D(b,y)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new T(0,0,0,0)}with(R){return new T(0,0,0,0)}}e.$UI=T;var m;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(m||(e.TextSearchCompleteMessageType=m={}))}),define(ke[36],Se([1,0,19,34,24,33,13,5,16,8,94,12]),function(be,e,D,T,m,A,R,w,b,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.SearchErrorCode=e.$0I=e.$9I=e.SearchSortOrder=e.ViewMode=e.$8I=e.$7I=e.$6I=e.$5I=e.SearchCompletionExitCode=e.$4I=e.$3I=e.$2I=e.QueryType=e.SearchProviderType=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.$VI="workbench.view.search",e.$WI="workbench.panel.search",e.$XI="workbench.view.search",e.$YI="search-result",e.$ZI="search.exclude";const $="\u27EA ",v=" characters skipped \u27EB",S=($.length+v.length+5)*2;e.$1I=(0,w.$Zh)("searchService");var g;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(g||(e.SearchProviderType=g={}));var d;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(d||(e.QueryType=d={}));function o(Q){return!!Q.preview}e.$2I=o;function i(Q){return!!Q.resource}e.$3I=i;function n(Q){return!!Q.message}e.$4I=n;var s;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class a{constructor(he){this.resource=he,this.results=[]}}e.$5I=a;class t{constructor(he,Z,ye,de){this.ranges=Z,this.webviewIndex=de;const H=Array.isArray(Z)?Z:[Z];if(ye&&ye.matchLines===1&&r(H)){he=(0,R.$vf)(he,ye.matchLines);let U="",ne=0,Ee=0;const fe=Math.floor(ye.charsPerLine/5),me=[];for(const ee of H){const te=Math.max(ee.startColumn-fe,0),K=ee.startColumn+ye.charsPerLine;if(te>Ee+fe+S){const ie=$+(te-Ee)+v;U+=ie+he.slice(te,K),ne+=te-(Ee+ie.length)}else U+=he.slice(Ee,K);me.push(new u(0,ee.startColumn-ne,ee.endColumn-ne)),Ee=K}this.preview={text:U,matches:Array.isArray(this.ranges)?me:me[0]}}else{const U=Array.isArray(Z)?Z[0].startLineNumber:Z.startLineNumber;this.preview={text:he,matches:(0,D.$1b)(Z,ne=>new h(ne.startLineNumber-U,ne.startColumn,ne.endLineNumber-U,ne.endColumn))}}}}e.$6I=t;function r(Q){const he=Q[0].startLineNumber;for(const Z of Q)if(Z.startLineNumber!==he||Z.endLineNumber!==he)return!1;return!0}class h{constructor(he,Z,ye,de){this.startLineNumber=he,this.startColumn=Z,this.endLineNumber=ye,this.endColumn=de}}e.$7I=h;class u extends h{constructor(he,Z,ye){super(he,Z,he,ye)}}e.$8I=u;var c;(function(Q){Q.List="list",Q.Tree="tree"})(c||(e.ViewMode=c={}));var l;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function E(Q,he=!0){const Z=Q&&Q.files&&Q.files.exclude,ye=he&&Q&&Q.search&&Q.search.exclude;if(!Z&&!ye)return;if(!Z||!ye)return Z||ye;let de=Object.create(null);return de=m.$hn(de,m.$en(Z)),de=m.$hn(de,m.$en(ye),!0),de}e.$9I=E;function C(Q,he){return Q.excludePattern&&T.$Fj(Q.excludePattern,he)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&T.$Fj(Q.includePattern,he)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(Z=>{const ye=Z.folder.fsPath;if(A.$2f(he,ye)){const de=b.$kc(ye,he);return!Z.includePattern||!!T.$Fj(Z.includePattern,de)}else return!1}):!1:!0}e.$0I=C;var f;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(f||(e.SearchErrorCode=f={}));class p extends Error{constructor(he,Z){super(he),this.code=Z}}e.$$I=p;function k(Q){const he=Q.message;if((0,y.$3)(Q))return new p(he,f.canceled);try{const Z=JSON.parse(he);return new p(Z.message,Z.code)}catch{return new p(he,f.other)}}e.$_I=k;function I(Q){const he={message:Q.message,code:Q.code};return new Error(JSON.stringify(he))}e.$aJ=I;function j(Q){return Q.type==="error"?!0:Q.type==="success"}e.$bJ=j;function z(Q){return Q.type==="success"}e.$cJ=z;function M(Q){return!!Q.path}e.$dJ=M;function F(Q,he){const Z=Q.searchPath?Q.searchPath:Q.relativePath;return(0,R.$sf)(Z,he)}e.$eJ=F;class N{constructor(he){this.path=he,this.results=[]}addMatch(he){this.results.push(he)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$fJ=N;function O(Q,he){const Z={...Q||{},...he||{}};return Object.keys(Z).filter(ye=>{const de=Z[ye];return typeof de=="boolean"&&de})}e.$gJ=O;class W{constructor(he,Z){this.c=null,this.a={...he.excludePattern||{},...Z.excludePattern||{}},this.b=T.$Gj(this.a);let ye=he.includePattern;Z.includePattern&&(ye?ye={...ye,...Z.includePattern}:ye=Z.includePattern),ye&&(this.c=T.$Gj(ye))}matchesExcludesSync(he,Z,ye){return!!(this.b&&this.b(he,Z,ye))}includedInQuerySync(he,Z,ye){return!(this.b&&this.b(he,Z,ye)||this.c&&!this.c(he,Z,ye))}includedInQuery(he,Z,ye){const de=this.b(he,Z,ye),H=()=>this.c?!!this.c(he,Z,ye):!0;return(0,P.$Mg)(de)?de.then(U=>U?!1:H()):H()}hasSiblingExcludeClauses(){return x(this.a)}}e.$hJ=W;function x(Q){for(const he in Q)if(typeof Q[he]!="boolean")return!0;return!1}function ue(Q){if(!Q)return;let he;return Z=>(he||(he=(Q()||Promise.resolve([])).then(ye=>ye?J(ye):{})),he.then(ye=>!!ye[Z]))}e.$iJ=ue;function X(Q){if(!Q)return;let he;return Z=>{if(!he){const ye=Q();he=ye?J(ye):{}}return!!he[Z]}}e.$jJ=X;function J(Q){const he={};for(const Z of Q)he[Z]=!0;return he}}),define(ke[41],Se([1,0,19,12,21,4,3,77,17,123,23,13,2,221,5,14,252,40,57,27,20,15,7,66,36,6,54]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s,a,t,r,h,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=e.$Hec=void 0;function l(z,M,F){return new L.$qg(N=>p(N,F)).isEqual(z,M)}function E(z,M,F){return l(z.uri,M.uri,F)?0:(0,P.$Ye)(z.uri.toString(),M.uri.toString())}function C(z,M,F){return z.index!==M.index?z.index<M.index?-1:1:l(z.uri,M.uri,F)?(0,P.$Ye)(z.name,M.name):(0,P.$Ye)(z.uri.toString(),M.uri.toString())}function f(z,M,F,N){const O=z.slice(0).sort((x,ue)=>F(x,ue,N)),W=M.slice(0).sort((x,ue)=>F(x,ue,N));return(0,D.$Db)(O,W,(x,ue)=>F(x,ue,N))}function p(z,M){const F=M.getCapabilities(z.scheme);return!(F&&F&1024)}class k extends o.$gi{static toExtHostWorkspace(M,F,N,O){if(!M)return{workspace:null,added:[],removed:[]};const{id:W,name:x,folders:ue,configuration:X,transient:J,isUntitled:Q}=M,he=[],Z=F;F?ue.forEach((U,ne)=>{const Ee=$.URI.revive(U.uri),fe=k.o(N||F,Ee,O);fe?(fe.name=U.name,fe.index=U.index,he.push(fe)):he.push({uri:Ee,name:U.name,index:ne})}):he.push(...ue.map(({uri:U,name:ne,index:Ee})=>({uri:$.URI.revive(U),name:ne,index:Ee}))),he.sort((U,ne)=>U.index<ne.index?-1:1);const ye=new k(W,x,he,!!J,X?$.URI.revive(X):null,!!Q,U=>p(U,O)),{added:de,removed:H}=f(Z?Z.workspaceFolders:[],ye.workspaceFolders,E,O);return{workspace:ye,added:de,removed:H}}static o(M,F,N){for(let O=0;O<M.folders.length;O++){const W=M.workspaceFolders[O];if(l(W.uri,F,N))return W}}constructor(M,F,N,O,W,x,ue){super(M,N.map(X=>new o.$hi(X)),O,W,ue),this.t=F,this.u=x,this.q=[],this.s=w.$6h.forUris(ue),N.forEach(X=>{this.q.push(X),this.s.set(X.uri,X)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,F){return F&&this.s.get(M)&&(M=(0,L.$Ag)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let I=class{constructor(M,F,N,O,W){this.c=new A.$Rd,this.onDidChangeWorkspace=this.c.event,this.g=new A.$Rd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new A.$Td,this.B=new Map,this.h=O,this.s=N,this.t=W,this.j=new y.$1l,this.k=new T.$Yg,this.o=M.getProxy(u.$CK.MainThreadWorkspace),this.q=M.getProxy(u.$CK.MainThreadMessageService);const x=F.workspace;this.l=x?new k(x.id,x.name,[],!!x.transient,x.configuration?$.URI.revive(x.configuration):null,!!x.isUntitled,ue=>p(ue,N)):void 0}$initializeWorkspace(M,F){this.v=F,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?$.URI.from({scheme:b.Schemas.untitled,path:(0,L.$yg)((0,L.$Ag)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,F,N,...O){const W=[];if(Array.isArray(O)&&O.forEach(Q=>{$.URI.isUri(Q.uri)&&!W.some(he=>l(he.uri,Q.uri,this.s))&&W.push({uri:Q.uri,name:Q.name||(0,L.$xg)(Q.uri)})}),this.n||[F,N].some(Q=>typeof Q!="number"||Q<0)||N===0&&W.length===0)return!1;const x=this.x?this.x.workspaceFolders:[];if(F+N>x.length)return!1;const ue=x.slice(0);ue.splice(F,N,...W.map(Q=>({uri:Q.uri,name:Q.name||(0,L.$xg)(Q.uri),index:void 0})));for(let Q=0;Q<ue.length;Q++){const he=ue[Q];if(ue.some((Z,ye)=>ye!==Q&&l(he.uri,Z.uri,this.s)))return!1}ue.forEach((Q,he)=>Q.index=he);const{added:X,removed:J}=f(x,ue,C,this.s);if(X.length===0&&J.length===0)return!1;if(this.o){const Q=M.displayName||M.name;this.o.$updateWorkspaceFolders(Q,F,N,W).then(void 0,he=>{this.n=void 0;const Z={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(d.Severity.Error,(0,v.localize)(0,null,Q,he.toString()),Z,[])})}return this.y(ue),!0}getWorkspaceFolder(M,F){if(this.x)return this.x.getWorkspaceFolder(M,F)}async getWorkspaceFolder2(M,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,F)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,F){let N,O="";if(typeof M=="string"?(N=$.URI.file(M),O=M):typeof M<"u"&&(N=M,O=M.fsPath),!N)return O;const W=this.getWorkspaceFolder(N,!0);if(!W)return O;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let x=(0,L.$Dg)(W.uri,N);return F&&W.name&&(x=`${W.name}/${x}`),x}y(M){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:F,added:N,removed:O}=k.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:O}))}findFiles(M,F,N,O,W=m.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let x;if(F===null?x=!1:F&&(typeof F=="string"?x=F:x=F.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:ue,folder:X}=j(a.GlobPattern.from(M));return this.o.$startFileSearch(ue??null,X??null,x??null,N??null,W).then(J=>Array.isArray(J)?J.map(Q=>$.URI.revive(Q)):[])}async findTextInFiles(M,F,N,O,W=m.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const x=this.j.getNext(),ue=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:X,folder:J}=j(a.GlobPattern.from(F.include)),Q=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,he={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:ue,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:X,excludePattern:Q},Z=!1;if(this.u[x]=ye=>{if(Z)return;const de=$.URI.revive(ye.resource);ye.results.forEach(H=>{const U=(0,c.$wh)(H);(0,h.$2I)(U)?N({uri:de,preview:{text:U.preview.text,matches:(0,D.$1b)(U.preview.matches,ne=>new t.$GK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,D.$1b)(U.ranges,ne=>new t.$GK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):N({uri:de,text:U.text,lineNumber:U.lineNumber})})},W.isCancellationRequested)return{};try{const ye=await this.o.$startTextSearch(M,J??null,he,x,W);return delete this.u[x],ye||{}}catch(ye){throw delete this.u[x],ye}}$handleTextSearchResult(M,F){this.u[F]?.(M)}async save(M){const F=await this.o.$save(M,{saveAs:!1});return $.URI.revive(F)}async saveAs(M){const F=await this.o.$save(M,{saveAs:!0});return $.URI.revive(F)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,F){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,F);const N=this.t.transformOutgoingScheme(M),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,N),(0,R.$Pc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(M,F){this.h.info("Getting edit session identifier for workspaceFolder",M);const N=await this.resolveWorkspaceFolder($.URI.revive(M));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const O=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!O),!O)return;const W=await O.provideEditSessionIdentity(N,F);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(M,F,N,O){this.h.info("Getting edit session identifier for workspaceFolder",M);const W=await this.resolveWorkspaceFolder($.URI.revive(M));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const x=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!x),!x)return;const ue=await x.provideEditSessionIdentityMatch?.(F,N,O);if(this.h.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}getOnWillCreateEditSessionIdentityEvent(M){return(F,N,O)=>{const W=function(ue){F.call(N,ue)};return W.extension=M,this.A.event(W,void 0,O)}}async $onWillCreateEditSessionIdentity(M,F,N){const O=await this.resolveWorkspaceFolder($.URI.revive(M));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},F,async(W,x)=>{const ue=Date.now();await Promise.resolve(W),Date.now()-ue>N&&this.h.warn("SLOW edit session create-participant",x.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(M,F){if(this.B.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.B.set(M,F);const N=this.t.transformOutgoingScheme(M),O=this.z++;return this.o.$registerCanonicalUriProvider(O,N),(0,R.$Pc)(()=>{this.B.delete(M),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(M,F,N){const O=this.B.get(M.scheme);if(!O)return;const W=await O.provideCanonicalUri?.($.URI.revive(M),F,N);if(W)return W}async $provideCanonicalUri(M,F,N){return this.provideCanonicalUri($.URI.revive(M),{targetScheme:F},N)}};e.$Hec=I,e.$Hec=I=Ke([Be(0,s.$EM),Be(1,n.$UM),Be(2,i.$nec),Be(3,g.$hj),Be(4,r.$Fec)],I),e.$Iec=(0,S.$Zh)("IExtHostWorkspace");function j(z){let M,F;return z&&(typeof z=="string"?M=z:(M=z.pattern,F=$.URI.revive(z.baseUri))),{includePattern:M,folder:F}}}),define(ke[42],Se([1,0,24,4,41,6,7,254,86,18,12,5,20,14,2]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=e.$Kec=e.$Jec=void 0;function g(r,h){if(h){const u=h.split(".");let c=r;for(let l=0;c&&l<u.length;l++)c=c[u[l]];return c}}function d(r){return r instanceof S.URI}function o(r){return r&&r.uri instanceof S.URI&&r.languageId&&typeof r.languageId=="string"}function i(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&r.uri instanceof S.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function s(r){if(d(r))return{resource:r};if(o(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(i(r))return{overrideIdentifier:r.languageId};if(n(r))return{resource:r.uri};if(r===null)return{resource:null}}let a=class{constructor(h,u,c){this.a=h.getProxy(A.$CK.MainThreadConfiguration),this.c=u,this.b=c,this.d=new L.$Yg,this.e=null}getConfigProvider(){return this.d.wait().then(h=>this.e)}$initializeConfiguration(h){this.e=new t(this.a,this.c,h,this.b),this.d.open()}$acceptConfigurationChanged(h,u){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(h,u))}};e.$Jec=a,e.$Jec=a=Ke([Be(0,$.$EM),Be(1,m.$Iec),Be(2,v.$hj)],a);class t{constructor(h,u,c,l){this.a=new T.$Rd,this.b=h,this.f=l,this.c=u,this.e=w.$On.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(h,u){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=w.$On.parse(h),this.d=this.k(h.configurationScopes),this.a.fire(this.j(u,c))}getConfiguration(h,u,c){const l=s(u)||{},E=this.g(h?g(this.e.getValue(void 0,l,this.c.workspace),h):this.e.getValue(void 0,l,this.c.workspace));h&&this.h(h,l,c?.identifier);function C(p){if(p==null)return null;if(typeof p=="boolean")return p?2:5;switch(p){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(p){return typeof g(E,p)<"u"},get:(p,k)=>{this.h(h?`${h}.${p}`:p,l,c?.identifier);let I=g(E,p);if(typeof I>"u")I=k;else{let j;const z=(M,F)=>{if((0,y.$Ef)(M)){let N;const O=()=>{j=j||(0,D.$en)(E),N=N||g(j,F)};return new Proxy(M,{get:(W,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return O(),()=>N;if(j)return N=N||g(j,F),N[x];const ue=W[x];return typeof x=="string"?z(ue,`${F}.${x}`):ue},set:(W,x,ue)=>(O(),N&&(N[x]=ue),!0),deleteProperty:(W,x)=>(O(),N&&delete N[x],!0),defineProperty:(W,x,ue)=>(O(),N&&Object.defineProperty(N,x,ue),!0)})}return Array.isArray(M)?(0,D.$en)(M):M};I=z(I,p)}return I},update:(p,k,I,j)=>{p=h?`${h}.${p}`:p;const z=C(I);return k!==void 0?this.b.$updateConfigurationOption(z,p,k,l,j):this.b.$removeConfigurationOption(z,p,l,j)},inspect:p=>{p=h?`${h}.${p}`:p;const k=this.e.inspect(p,l,this.c.workspace);if(k)return{key:p,defaultValue:(0,D.$en)(k.policy?.value??k.default?.value),globalValue:(0,D.$en)(k.user?.value??k.application?.value),workspaceValue:(0,D.$en)(k.workspace?.value),workspaceFolderValue:(0,D.$en)(k.workspaceFolder?.value),defaultLanguageValue:(0,D.$en)(k.default?.override),globalLanguageValue:(0,D.$en)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,D.$en)(k.workspace?.override),workspaceFolderLanguageValue:(0,D.$en)(k.workspaceFolder?.override),languageIds:(0,D.$en)(k.overrideIdentifiers)}}};return typeof E=="object"&&(0,D.$hn)(f,E,!1),Object.freeze(f)}g(h){const u=c=>(0,y.$Ef)(c)?new Proxy(c,{get:(l,E)=>u(l[E]),set:(l,E,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(E)}' of object`)},deleteProperty:(l,E)=>{throw new Error(`TypeError: Cannot delete read only property '${String(E)}' of object`)},defineProperty:(l,E)=>{throw new Error(`TypeError: Cannot define property '${String(E)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return u(h)}h(h,u,c){const l=b.$Fn.test(h)?4:this.d.get(h),E=c?`[${c.value}] `:"";if(l===4){typeof u?.resource>"u"&&this.f.warn(`${E}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${h}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){u?.resource&&this.f.warn(`${E}Accessing a window scoped configuration for a resource is not expected. To associate '${h}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(h,u){const c=new w.$Qn(h,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,E)=>c.affectsConfiguration(l,s(E))})}k(h){return h.reduce((u,c)=>(u.set(c[0],c[1]),u),new Map)}}e.$Kec=t,e.$Lec=(0,P.$Zh)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,12,4,6,7,41,69,42,21,47,20,27,5,17,11,14,91,302,8]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=e.$bgc=e.$agc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(z){function M(N){if(N!=null)return N}z.from=M;function F(N){if(N!=null)return N}z.to=F})(a||(a={}));var t;(function(z){function M(N){if(N!=null)return N}z.from=M;function F(N){if(N!=null)return N}z.to=F})(t||(t={}));var r;(function(z){function M(N){if(N!=null)return N}z.from=M;function F(N){if(N!=null)return N}z.to=F})(r||(r={}));var h;(function(z){function M(O){if(O){const W=O;return W&&!!W.process}else return!1}z.is=M;function F(O){if(O==null)return;const W={process:O.process,args:O.args};return O.options&&(W.options=r.from(O.options)),W}z.from=F;function N(O){if(O!=null)return new R.$mL(O.process,O.args,O.options)}z.to=N})(h||(h={}));var u;(function(z){function M(N){if(N!=null)return N}z.from=M;function F(N){if(N!=null)return N}z.to=F})(u||(u={}));var c;(function(z){function M(O){if(O){const W=O;return W&&(!!W.commandLine||!!W.command)}else return!1}z.is=M;function F(O){if(O==null)return;const W={};return O.commandLine!==void 0?W.commandLine=O.commandLine:(W.command=O.command,W.args=O.args),O.options&&(W.options=u.from(O.options)),W}z.from=F;function N(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$nL(O.commandLine,O.options):new R.$nL(O.command,O.args?O.args:[],O.options)}z.to=N})(c||(c={}));var l;(function(z){function M(O){if(O){const W=O;return W&&W.customExecution==="customExecution"}else return!1}z.is=M;function F(O){return{customExecution:"customExecution"}}z.from=F;function N(O,W){return W.get(O)}z.to=N})(l||(e.CustomExecutionDTO=l={}));var E;(function(z){function M(F,N){let O;return F.scope!==void 0&&typeof F.scope!="number"?O=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===R.TaskScope.Workspace&&N&&N.workspaceFile?O=N.workspaceFile:O=n.$_F),{id:F._id,workspaceFolder:O}}z.from=M})(E||(e.TaskHandleDTO=E={}));var C;(function(z){function M(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}z.from=M})(C||(C={}));var f;(function(z){function M(O,W){if(O==null)return[];const x=[];for(const ue of O){const X=F(ue,W);X&&x.push(X)}return x}z.fromMany=M;function F(O,W){if(O==null)return;let x;O.execution instanceof R.$mL?x=h.from(O.execution):O.execution instanceof R.$nL?x=c.from(O.execution):O.execution&&O.execution instanceof R.$oL&&(x=l.from(O.execution));const ue=a.from(O.definition);let X;return O.scope?typeof O.scope=="number"?X=O.scope:X=O.scope.uri:X=R.TaskScope.Workspace,!ue||!X?void 0:{_id:O._id,definition:ue,name:O.name,source:{extensionId:W.identifier.value,label:O.source,scope:X},execution:x,isBackground:O.isBackground,group:C.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}z.from=F;async function N(O,W,x){if(O==null)return;let ue;h.is(O.execution)?ue=h.to(O.execution):c.is(O.execution)?ue=c.to(O.execution):l.is(O.execution)&&(ue=l.to(O._id,x));const X=a.to(O.definition);let J;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?J=O.source.scope:J=await W.resolveWorkspaceFolder(D.URI.revive(O.source.scope)):J=R.TaskScope.Workspace),!X||!J)return;const Q=new R.$pL(X,J,O.name,O.source.label,ue,O.problemMatchers);return O.isBackground!==void 0&&(Q.isBackground=O.isBackground),O.group!==void 0&&(Q.group=R.$lL.from(O.group._id),Q.group&&O.group.isDefault&&(Q.group=new R.$lL(Q.group.id,Q.group.label),O.group.isDefault===!0&&(Q.group.isDefault=O.group.isDefault))),O.presentationOptions&&(Q.presentationOptions=t.to(O.presentationOptions)),O._id&&(Q._id=O._id),O.detail&&(Q.detail=O.detail),Q}z.to=N})(f||(e.TaskDTO=f={}));var p;(function(z){function M(N){return N}z.from=M;function F(N){if(N)return Object.assign(Object.create(null),N)}z.to=F})(p||(p={}));class k{#e;constructor(M,F,N){this._id=F,this.a=N,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let I=class{constructor(M,F,N,O,W,x,ue,X){this.q=new m.$Rd,this.r=new m.$Rd,this.s=new m.$Rd,this.t=new m.$Rd,this.a=M.getProxy(A.$CK.MainThreadTask),this.b=N,this.c=O,this.d=W,this.e=x,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ue,this.g=X,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,F,N){if(!N)return new R.$EK(()=>{});const O=this.w();return this.j.set(O,{type:F,provider:N,extension:M}),this.a.$registerTaskProvider(O,F),new R.$EK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(M,F){this.a.$registerTaskSystem(M,F)}fetchTasks(M){return this.a.$fetchTasks(p.from(M)).then(async F=>{const N=[];for(const O of F){const W=await f.to(O,this.b,this.m);W&&N.push(W)}return N})}get taskExecutions(){const M=[];return this.k.forEach(F=>M.push(F)),M}terminateTask(M){if(!(M instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,F,N){const O=this.m.get(M.id);O&&(this.o.set(M.id,O),this.e.attachPtyToTerminal(F,await O.callback(N))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const F=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const F=await this.y(M.id);this.s.fire({execution:F,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const F=await this.y(M.id);this.t.fire({execution:F,exitCode:M.exitCode})}$provideTasks(M,F){const N=this.j.get(M);if(!N)return Promise.reject(new Error("no handler found"));const O=[],W=(0,T.$Sg)(()=>N.provider.provideTasks(L.CancellationToken.None)).then(x=>this.u(F,O,N,x));return new Promise(x=>{W.then(ue=>{Promise.all(O).then(()=>{x(ue)})})})}async $resolveTask(M,F){const N=this.j.get(M);if(!N)return Promise.reject(new Error("no handler found"));if(F.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${N.type}].`);const O=await f.to(F,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const W=await N.provider.resolveTask(O,L.CancellationToken.None);if(!W)return;this.z(W,N);const x=f.from(W,N.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(x.execution)&&await this.x(x,W,!0),await this.v(x)}w(){return this.h++}async x(M,F,N){const O=await this.a.$createTaskId(M);!N&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,F.execution)),this.m.set(O,F.execution)}async y(M,F){if(typeof M=="string"){const W=this.l.get(M);if(!W)throw new s.$ab("Unexpected: The specified task is missing an execution");return W}const N=this.l.get(M.id);if(N)return N;const O=new Promise((W,x)=>{function ue(X,J,Q){Q?W(new k(X,J.id,Q)):x("Unexpected: Task does not exist.")}F?ue(this,M,F):f.to(M.task,this.b,this.m).then(X=>ue(this,M,X))});return this.l.set(M.id,O),O.then(W=>(this.k.set(M.id,W),W),W=>Promise.reject(W))}z(M,F){M._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const N=this.n.values();let O=N.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=N.next()}};e.$agc=I,e.$agc=I=Ke([Be(0,$.$EM),Be(1,v.$UM),Be(2,w.$Iec),Be(3,b.$PM),Be(4,y.$Lec),Be(5,P.$0ec),Be(6,o.$hj),Be(7,i.$qec)],I);let j=class extends I{constructor(M,F,N,O,W,x,ue,X){super(M,F,N,O,W,x,ue,X),this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:d.$h(0)})}async executeTask(M,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const N=f.from(F,M);if(N===void 0)throw new Error("Task is not valid");if(l.is(N.execution))await this.x(N,F,!1);else throw new s.$$;const O=await this.y(await this.a.$getTaskExecution(N),F);return this.a.$executeTask(N).catch(W=>{throw new Error(W)}),O}u(M,F,N,O){const W=[];if(O)for(const x of O){if(this.z(x,N),!x.definition||!M[x.definition.type]){const X=x.source?x.source:"No task source";this.f.warn(`The task [${X}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`)}const ue=f.from(x,N.extension);ue&&l.is(ue.execution)?(W.push(ue),F.push(this.x(ue,x,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:N.extension}}async v(M){if(l.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,F,N){}};e.$bgc=j,e.$bgc=j=Ke([Be(0,$.$EM),Be(1,v.$UM),Be(2,w.$Iec),Be(3,b.$PM),Be(4,y.$Lec),Be(5,P.$0ec),Be(6,o.$hj),Be(7,i.$qec)],j),e.$cgc=(0,S.$Zh)("IExtHostTask")}),define(ke[358],Se([1,0,36,29]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.$qJ=e.$pJ=void 0;function m(R){return"cellResults"in R}e.$pJ=m,e.$qJ="rawCell#";function A(R,w){let b=-1;const y=[];let L=[];return R.forEach($=>{$.range.startLineNumber!==b&&L.length>0&&(y.push([...L]),L=[]),L.push($),b=$.range.endLineNumber}),L.length>0&&y.push([...L]),y.map($=>{const v=[],S=$[0].range.startLineNumber,g=$[$.length-1].range.endLineNumber;for(let d=S;d<=g;d++)v.push(w.getLineContent(d));return new D.$6I(v.join(`
`)+`
`,$.map(d=>new T.$Ds(d.range.startLineNumber-1,d.range.startColumn-1,d.range.endLineNumber-1,d.range.endColumn-1)))})}e.$rJ=A}),define(ke[359],Se([1,0,214,22,4,3,28,13,18,2,32,110,6,35,15,7,68,294,147,8,24,17,286,358,355]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s,a,t,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(l=>l.apiEditor)}constructor(l,E,C,f,p,k){this.q=C,this.r=f,this.s=p,this.t=k,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new m.$Rd({onListenerError:n.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new m.$Rd({onListenerError:n.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new m.$Rd({onListenerError:n.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new m.$Rd({onListenerError:n.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$jec("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=l.getProxy($.$CK.MainThreadNotebook),this.c=l.getProxy($.$CK.MainThreadNotebookDocuments),this.d=l.getProxy($.$CK.MainThreadNotebookEditors),this.i=E.converter,E.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===13){const j=I.notebookEditor?.notebookUri,z=I.cell.handle,F=this.g.get(j)?.getCell(z);if(F)return F.apiCell}if(I&&I.$mid===14){const j=I.uri,z=this.g.get(j);if(z)return z.apiNotebook}return I}}),u.B(E)}getEditorById(l){const E=this.h.get(l);if(!E)throw new Error(`unknown text editor: ${l}. known editors: ${[...this.h.keys()]} `);return E}getIdByEditor(l){for(const[E,C]of this.h)if(C.apiEditor===l)return E}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(l,E){const C=this.g.get(l);if(!C&&!E)throw new Error(`NO notebook document for '${l}'`);return C}static u(l,E){if(!E)return;const C=E.filenamePattern.map(f=>S.NotebookExclusiveDocumentPattern.from(f)).filter(f=>f!==void 0);if(E.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${E.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:E.displayName,filenamePattern:C,exclusive:E.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,E,C){const f=u.a++,p=typeof C.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(f,C),this.b.$registerNotebookCellStatusBarItemProvider(f,p,E);let k;return p!==void 0&&(k=C.onDidChangeCellStatusBarItems(I=>this.b.$emitCellStatusBarEvent(p))),new g.$EK(()=>{this.f.delete(f),this.b.$unregisterNotebookCellStatusBarItemProvider(f,p),k?.dispose()})}async createNotebookDocument(l){const E=await this.c.$tryCreateNotebook({viewType:l.viewType,content:l.content&&S.NotebookData.from(l.content)});return y.URI.revive(E)}async openNotebookDocument(l){const E=this.g.get(l);if(E)return E.apiNotebook;const C=await this.c.$tryOpenNotebook(l),f=this.g.get(y.URI.revive(C));return(0,b.$Nf)(f?.apiNotebook)}async showNotebookDocument(l,E){y.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let C;typeof E=="object"?C={position:S.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selections:E.selections&&E.selections.map(S.NotebookRange.from),pinned:typeof E.preview=="boolean"?!E.preview:void 0}:C={preserveFocus:!1};const f=await this.d.$tryShowNotebookDocument(l.uri,l.notebookType,C),p=f&&this.h.get(f)?.apiEditor;if(p)return p;throw f?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,E,C,f){const p=this.f.get(l),k=y.URI.revive(E),I=this.g.get(k);if(!I||!p)return;const j=I.getCellFromIndex(C);if(!j)return;const z=await p.provideCellStatusBarItems(j.apiCell,f);if(!z)return;const M=new A.$Qc,F=this.p.add([M]),O=(Array.isArray(z)?z:[z]).map(W=>S.NotebookStatusBarItem.from(W,this.i,M));return{cacheId:F,items:O}}$releaseNotebookCellStatusBarItems(l){this.p.delete(l)}registerNotebookSerializer(l,E,C,f,p){if((0,w.$Fe)(E))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:E,serializer:C,options:f}),this.b.$registerNotebookSerializer(k,{id:l.identifier,location:l.extensionLocation},E,S.NotebookDocumentContentOptions.from(f),u.u(l,p)),(0,A.$Pc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(l,E,C){const f=this.x.get(l);if(!f)throw new Error("NO serializer found");const p=await f.serializer.deserializeNotebook(E.buffer,C);return new d.$Av(S.NotebookData.from(p))}async $notebookToData(l,E,C){const f=this.x.get(l);if(!f)throw new Error("NO serializer found");const p=await f.serializer.serializeNotebook(S.NotebookData.to(E.value),C);return T.$fe.wrap(p)}async $saveNotebook(l,E,C,f,p){const k=y.URI.revive(E),I=this.x.get(l);if(!I)throw new Error("NO serializer found");const j=this.g.get(k);if(!j)throw new Error("Document NOT found");if(j.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new L.$Dk((0,D.localize)(0,null,this.z(k)),6);await this.y(k,f);const z={metadata:(0,s.$mn)(j.apiNotebook.metadata,W=>!(I.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of j.apiNotebook.getCells()){const x=new g.$3L(W.kind,W.document.getText(),W.document.languageId,W.mime,I.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);x.metadata=(0,s.$mn)(W.metadata,ue=>!(I.options?.transientCellMetadata??{})[ue]),z.cells.push(x)}const M=await I.serializer.serializeNotebook(z,p);await this.s.value.writeFile(k,M);const F=this.s.getFileSystemProviderExtUri(k.scheme),N=await this.s.value.stat(k);return{name:F.basename(k),isFile:(N.type&L.FileType.File)!==0,isDirectory:(N.type&L.FileType.Directory)!==0,isSymbolicLink:(N.type&L.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&L.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((N.permissions??0)&L.FilePermission.Locked),etag:L.$Ok({mtime:N.mtime,size:N.size}),children:void 0}}async $searchInNotebooks(l,E,C,f,p){const k=this.x.get(l)?.serializer;if(!k)return{limitHit:!1,results:[]};const I=new R.$Ac;await(async(N,O,W)=>{await Promise.all(N.map(async x=>await Promise.all(x.filenamePatterns.map(ue=>{const X={...W,type:1,filePattern:ue};return this.t.doInternalFileSearchWithCustomCallback(X,O,J=>{J.forEach(Q=>{I.has(Q)||f.some(Z=>x.isFromSettings&&!Z.isFromSettings?!1:Z.filenamePatterns.some(ye=>(0,h.$Scb)(ye,Q)))||I.add(Q)})})}))))})(C,p,E);const z=new R.$zc;let M=!1;const F=Array.from(I).map(async N=>{const O=[];try{if(p.isCancellationRequested)return;if(E.maxResults&&[...z.values()].reduce((X,J)=>X+J.cellResults.length,0)>E.maxResults){M=!0;return}const W=[],x=this.g.get(N);if(x)x.apiNotebook.getCells().forEach(J=>W.push({input:J.document.getText(),outputs:J.outputs.flatMap(Q=>Q.items.map(he=>he.data.toString()))}));else{const X=await this.s.value.readFile(N),J=T.$fe.fromString(X.toString()),Q=await k.deserializeNotebook(J.buffer,p);if(p.isCancellationRequested)return;S.NotebookData.from(Q).cells.forEach(Z=>W.push({input:Z.source,outputs:Z.outputs.flatMap(ye=>ye.items.map(de=>de.valueBytes.toString()))}))}if(p.isCancellationRequested)return;W.forEach((X,J)=>{const Q=E.contentPattern.pattern,he=new t.$oPb(X.input,void 0,X.outputs),Z=he.findInInputs(Q),ye=he.findInOutputs(Q),de=ye.flatMap(H=>(0,r.$rJ)(H.matches,H.textBuffer)).map((H,U)=>(H.webviewIndex=U,H));if(Z.length>0||ye.length>0){const H={index:J,contentResults:(0,r.$rJ)(Z,he.inputTextBuffer),webviewResults:de};O.push(H)}});const ue={resource:N,cellResults:O};z.set(N,ue);return}catch{return}});return await Promise.all(F),{limitHit:M,results:[...z.values()]}}async y(l,E){const C=await this.s.value.stat(l);if(typeof E?.mtime=="number"&&typeof E.etag=="string"&&E.etag!==L.$Nk&&typeof C.mtime=="number"&&typeof C.size=="number"&&E.mtime<C.mtime&&E.etag!==L.$Ok({mtime:E.mtime,size:C.size}))throw new L.$Dk((0,D.localize)(1,null),3,E)}z(l){return l.scheme===a.Schemas.file?l.fsPath:l.toString()}A(l,E,C){if(this.h.has(E))throw new Error(`editor with id ALREADY EXSIST: ${E}`);const f=new i.$Ffc(E,this.d,l,C.visibleRanges.map(S.NotebookRange.to),C.selections.map(S.NotebookRange.to),typeof C.viewColumn=="number"?S.ViewColumn.to(C.viewColumn):void 0);this.h.set(E,f)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const C of l.value.removedDocuments){const f=y.URI.revive(C),p=this.g.get(f);p&&(p.dispose(),this.g.delete(f),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(p.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===f.toString()&&this.h.delete(k.id)}if(l.value.addedDocuments){const C=[];for(const f of l.value.addedDocuments){const p=y.URI.revive(f.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const k=new o.$Efc(this.c,this.q,this.r,p,f);C.push(...f.cells.map(I=>o.$Dfc.asModelAddData(k.apiNotebook,I))),this.g.get(p)?.dispose(),this.g.set(p,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(k.apiNotebook)}}if(l.value.addedEditors)for(const C of l.value.addedEditors){if(this.h.has(C.id))return;const f=y.URI.revive(C.documentUri),p=this.g.get(f);p&&this.A(p,C.id,C)}const E=[];if(l.value.removedEditors)for(const C of l.value.removedEditors){const f=this.h.get(C);f&&(this.h.delete(C),this.k?.id===f.id&&(this.k=void 0),E.push(f))}if(l.value.visibleEditors){this.l=l.value.visibleEditors.map(f=>this.h.get(f)).filter(f=>!!f);const C=new Set;this.l.forEach(f=>C.add(f.id));for(const f of this.h.values()){const p=C.has(f.id);f._acceptVisibility(p)}this.l=[...this.h.values()].map(f=>f).filter(f=>f.visible),this.o.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this.k=void 0:l.value.newActiveEditor&&(this.h.get(l.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${l.value.newActiveEditor}`),this.k=this.h.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(l){const E=v.$3M.String.with("notebookType","A notebook type"),C=new v.$5M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[E,new v.$3M("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>T.$fe.wrap(p))],new v.$4M("Notebook Data",p=>S.NotebookData.to(p.value))),f=new v.$5M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[E,new v.$3M("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new d.$Av(S.NotebookData.from(p)))],new v.$4M("Bytes",p=>p.buffer));l.registerApiCommand(C),l.registerApiCommand(f)}}e.$Ofc=u}),define(ke[360],Se([1,0,16,21,44,34,23,38,36]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=void 0;class y{constructor($,v,S){this.k=$,this.l=v,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&A.$Gj($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&A.$Gj($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const v=this.k.folderQueries||[];return new Promise((S,g)=>{const d=o=>{this.f++,$(o)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),n=D.$mc(i);this.j&&this.j(i,n)||this.v(d,{base:o,basename:n})}),Promise.all(v.map(o=>this.p(o,d))).then(o=>{S({limitHit:this.e,stats:o[0]||void 0})},o=>{g(new Error((0,m.$Ki)(o)))})})}async p($,v){const S=new T.$2d,g=this.q($),d=this.r(),o=new b.$hJ(this.k,$),i=!o.hasSiblingExcludeClauses();let n;try{this.h.add(S),n=w.$Nd.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},g,S.token),a=n.elapsed(),t=w.$Nd.create();return this.g&&!this.e||(s&&s.forEach(r=>{const h=D.$fc.relative($.folder.path,r.path);if(i){const u=D.$mc(r.path);this.v(v,{base:$.folder,relativePath:h,basename:u});return}this.s(d,$.folder,h,v)}),this.g&&!this.e)?null:(this.u(d,o,v),{providerTime:a,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q($){const v=(0,b.$gJ)(this.k.includePattern,$.includePattern),S=(0,b.$gJ)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:S,includes:v,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},v,S,g){if(S===this.a){const o=D.$mc(this.a);this.v(g,{base:v,relativePath:this.a,basename:o})}function d(o){const i=D.$mc(o),n=D.$lc(o);let s=$[n];s||(s=$[n]=[],d(n)),s.push({base:v,relativePath:o,basename:i})}d(S)}u({rootEntries:$,pathToEntries:v},S,g){const d=this,o=this.a;function i(n){const s=(0,b.$jJ)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const r=n[a],{relativePath:h,basename:u}=r;if(S.matchesExcludesSync(h,u,o!==u?s:void 0))continue;const c=v[h];if(c)i(c);else{if(h===o)continue;d.v(g,r)}if(d.e)break}}i($)}v($,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(v))}}class L{constructor(){this.b=new Map}static{this.a=512}fileSearch($,v,S,g){const d=this.c($.cacheKey),o=new y($,v,d&&d.token);let i=0;const n=s=>{i+=s.length,S(s.map(a=>this.d(a)))};return this.e(o,L.a,n,g).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:s.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new T.$2d),this.b.get($)}d($){return $.relativePath?{resource:R.$Bg($.base,$.relativePath)}:{resource:$.base}}e($,v,S,g){const d=g.onCancellationRequested(()=>{$.cancel()}),o=n=>{n&&(i.push(n),v>0&&i.length>=v&&(S(i),i=[]))};let i=[];return $.search(o).then(n=>(i.length&&S(i),d.dispose(),n),n=>(i.length&&S(i),d.dispose(),Promise.reject(n)))}}e.$Gfc=L}),define(ke[361],Se([1,0,19,73,34,102,28,17,16,23,13,18,2,99,235,45,14,40,144,356,36]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hK=e.$gK=void 0;let a=class{constructor(p,k,I,j,z){this.a=p,this.b=k,this.c=I,this.d=j,this.e=z}text(p,k,I={}){p=this.f(p,I);const j=this.a.getValue(),z=k&&k.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(k?.map(o.$ii),I),type:2,contentPattern:p,previewOptions:I.previewOptions,maxFileSize:I.maxFileSize,usePCRE2:j.search.usePCRE2||z||!1,beforeContext:I.beforeContext,afterContext:I.afterContext,userDisabledExcludesAndIgnoreFiles:I.disregardExcludeSettings&&I.disregardIgnoreFiles}}f(p,k){const I=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const j={...p,wordSeparators:I.editor.wordSeparators};return this.j(p,k)&&(j.isCaseSensitive=!0),this.k(p)&&(j.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),j}file(p,k={}){return{...this.h(p,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(p,k){return p?(p=Array.isArray(p)?p.map(c):c(p),k?this.parseSearchPaths(p):{pattern:r(...Array.isArray(p)?p:[p])}):{}}h(p=[],k={}){const I=this.g(k.includePattern,k.expandPatterns),j=this.g(k.excludePattern,k.expandPatterns),z=p.length>1,M=(I.searchPaths&&I.searchPaths.length?I.searchPaths.map(O=>this.q(O,k,j)):p.map(O=>this.r(O,k,j,z))).filter(O=>!!O),F={_reason:k._reason,folderQueries:M,usingSearchPaths:!!(I.searchPaths&&I.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:j.pattern,includePattern:I.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const O=D.$Gb(D.$Qb(this.c.groups.map(ue=>ue.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const W=O.filter(ue=>(0,s.$0I)(F,ue.fsPath)),x=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(x)),{...F,...x}}const N=k.extraFileResources&&k.extraFileResources.filter(O=>(0,s.$0I)(F,O.fsPath));return F.extraFileResources=N&&N.length?N:void 0,F}i(p){const k=[],I=new R.$zc,j={};let z=!1;return p.forEach(M=>{if(M.scheme===w.Schemas.walkThrough)return;if((0,y.$Fg)(M)){const N=this.b.getWorkspaceFolder(M)?.uri??M.with({path:b.$lc(M.fsPath)});let O=I.get(N);O||(z=!0,O={folder:N,includePattern:{}},k.push(O),I.set(N,O));const W=b.$kc(N.fsPath,M.fsPath);(0,P.$Nf)(O.includePattern)[W.replace(/\\/g,"/")]=!0}else M.fsPath&&(z=!0,j[M.fsPath]=!0)}),{folderQueries:k,includePattern:j,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(p,k){if(k.isSmartCase){if(p.isRegExp){if(L.$tf(p.pattern,!0))return!0}else if(L.$tf(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,v.$GB)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const k=x=>b.$hc(x)||/^\.\.?([\/\\]|$)/.test(x),j=(Array.isArray(p)?p:h(p)).map(x=>{const ue=this.e.resolvedUserHome;return ue?(0,A.$Fv)(x,ue.scheme===w.Schemas.file?ue.fsPath:ue.path):x}),z=T.$J(j,x=>k(x)?"searchPaths":"exprSegments"),M=(z.exprSegments||[]).map(x=>L.$Oe(x,"/")).map(x=>L.$Oe(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),u(x))),F={},N=this.m(z.searchPaths||[]);N&&N.length&&(F.searchPaths=N);const O=D.$Qb(M),W=r(...O);return W&&(F.pattern=W),F}l(p,k){return k.disregardExcludeSettings?void 0:(0,s.$9I)(p,!k.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const k=p.flatMap(j=>{let{pathPortion:z,globPortion:M}=t(j);return M&&(M=l(M)),this.n(z).flatMap(N=>this.o(N,M))}),I=new Map;return k.forEach(j=>{const z=j.searchPath.toString(),M=I.get(z);M?j.pattern&&(M.pattern=M.pattern||{},M.pattern[j.pattern]=!0):I.set(z,{searchPath:j.searchPath,pattern:j.pattern?r(j.pattern):void 0})}),Array.from(I.values())}n(p){if(b.$hc(p)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==w.Schemas.file?[{searchPath:k[0].uri.with({path:p})}]:[{searchPath:$.URI.file(b.$gc(p))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(p=c(p),p.startsWith("../")||p===".."){const j=b.$fc.resolve(k.path,p);return[{searchPath:k.with({path:j})}]}const I=l(p);return[{searchPath:k,pattern:I}]}else{if(p==="./"||p===".\\")return[];{const k=p.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(z=>{const M=k.match(new RegExp(`^${L.$Je(z.name)}(?:/(.*)|$)`));return M?{match:M,folder:z}:null}).filter(P.$Kf);if(j.length)return j.map(z=>{const M=z.match[1];return{searchPath:z.folder.uri,pattern:M&&l(M)}});{const z=p.match(/\.[\/\\](.+)[\/\\]?/),M=z?z[1]:p,F=S.localize(0,null,M);throw new Error(F)}}}}o(p,k){const I=p.pattern&&k?`${p.pattern}/${k}`:p.pattern||k,j=[{searchPath:p.searchPath,pattern:I}];return I&&!I.endsWith("**")&&j.push({searchPath:p.searchPath,pattern:I+"/**"}),j}q(p,k,I){const j=this.r((0,o.$ii)(p.searchPath),k,I,!1);return j?{...j,includePattern:p.pattern}:null}r(p,k,I,j){let z;const M=$.URI.isUri(p)?p:p.uri;if(I.searchPaths){const x=I.searchPaths.filter(ue=>(0,y.$ug)(ue.searchPath,M))[0];if(x&&!x.pattern)return null;x&&(z=x.pattern)}const F=this.a.getValue({resource:M}),O={...this.l(F,k)||{},...z||{}},W=$.URI.isUri(p)?(0,y.$yg)(p):p.name;return{folder:M,folderName:j?W:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!F.search.followSymlinks}}};e.$gK=a,e.$gK=a=Ke([Be(0,g.$ti),Be(1,o.$9h),Be(2,i.$KC),Be(3,d.$hj),Be(4,n.$eK)],a);function t(f){const p=f.match(/[\*\{\}\(\)\[\]\?]/);if(p){const k=p.index,I=f.substr(0,k).match(/[/|\\][^/\\]*$/);if(I){let j=f.substr(0,I.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:f.substr((I.index||0)+1)}}}return{pathPortion:f}}function r(...f){return f.length?f.reduce((p,k)=>(p[k]=!0,p),Object.create(null)):void 0}function h(f){return m.$Ej(f,",").map(p=>p.trim()).filter(p=>!!p.length)}function u(f){return[`**/${f}/**`,`**/${f}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function c(f){return f.replace(/\\/g,"/")}function l(f){return c(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function E(f){return f.replace(/([?*[\]])/g,"[$1]")}function C(f,p){f=D.$Lb(f,j=>j.toString());const k=[],I=p.getWorkspace();return f&&f.forEach(j=>{let z;if(p.getWorkbenchState()===2)z=(0,y.$Dg)(I.folders[0].uri,j),z&&z!=="."&&(z="./"+z);else{const M=p.getWorkspaceFolder(j);if(M){const F=M.name;if(I.folders.filter(O=>O.name===F).length===1){const O=(0,y.$Dg)(M.uri,j);O===""?z=`./${M.name}`:z=`./${M.name}/${O}`}else z=j.fsPath}}z&&k.push(E(z))}),k}e.$hK=C}),define(ke[362],Se([1,0,23,2,21,8,5,361,36,40]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Irb=e.$Hrb=void 0;const L=7e3;function P(g,d){const o=d.activationEvents;if(!o)return Promise.resolve(void 0);const i=[],n=[];for(const u of o)if(/^workspaceContains:/.test(u)){const c=u.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||g.forceUsingSearch?n.push(c):i.push(c)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let s;const a=new Promise((u,c)=>{s=u}),t=u=>s({activationEvent:u}),r=Promise.all(i.map(u=>$(g,u,t))).then(()=>{}),h=v(g,d.identifier,n,t);return Promise.all([r,h]).then(()=>{s(void 0)}),a}e.$Hrb=P;async function $(g,d,o){for(const i of g.folders)if(await g.exists(D.$Bg(T.URI.revive(i),d))){o(`workspaceContains:${d}`);return}}async function v(g,d,o,i){if(o.length===0)return Promise.resolve(void 0);const n=new m.$2d,s=g.checkExists(g.folders,o,n.token),a=setTimeout(async()=>{n.cancel(),g.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},L);let t=!1;try{t=await s}catch(r){A.$3(r)||A.$Z(r)}n.dispose(),clearTimeout(a),t&&i(`workspaceContains:${o.join(",")}`)}function S(g,d,o,i){const n=g.get(R.$Yh),s=g.get(b.$1I),t=n.createInstance(w.$gK).file(d.map(r=>(0,y.$ii)(T.URI.revive(r))),{_reason:"checkExists",includePattern:o,exists:!0});return s.fileSearch(t,i).then(r=>!!r.limitHit,r=>A.$3(r)?!1:Promise.reject(r))}e.$Irb=S}),define(ke[48],Se([1,0,211,16,56,23,12,3,77,2,14,6,42,292,118,41,25,146,8,26,22,271,7,64,5,27,92,20,107,72,47,4,362,117,273,17,115,38,11,116]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s,a,t,r,h,u,c,l,E,C,f,p,k,I,j,z,M,F,N,O){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=e.$kfc=e.$jfc=e.$ifc=void 0,e.$ifc=(0,h.$Zh)("IHostUtils");let x=W=class extends w.$Rc{constructor(H,U,ne,Ee,fe,me,ee,te,K,ie,G,ae){super(),this.X=ae,this.a=this.B(new p.$Rd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=ne,this.f=ee,this.j=Ee,this.m=fe,this.s=me,this.t=K,this.u=ie,this.w=G,this.y=this.g.getProxy(P.$CK.MainThreadWorkspace),this.z=this.g.getProxy(P.$CK.MainThreadTelemetry),this.C=this.g.getProxy(P.$CK.MainThreadExtensionService),this.D=new R.$Yg,this.F=new R.$Yg,this.G=new R.$Yg,this.H=new R.$Yg,this.I=new ye(this.f.extensions.activationEvents),this.L=new o.$x6b(this.I,this.f.extensions.allExtensions);const $e=new n.$em(this.f.extensions.myExtensions);this.J=new o.$x6b(this.I,he(this.L,$e)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${J(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${J(this.J)}`)),this.M=new S.$6ec(this.g,this.s),this.N=new I.$bfc(this.g),this.O=te,this.h=H.createChild(new E.$Xh([S.$7ec,this.M],[I.$cfc,this.N])),this.P=this.B(new v.$5ec(this.J,this.L,{onExtensionActivationError:(Ce,B,Y)=>{this.C.$onExtensionActivationError(Ce,i.$2(B),Y)},actualActivateExtension:async(Ce,B)=>{if(o.$x6b.isHostExtension(Ce,this.J,this.L))return await this.C.$activateExtension(Ce,B),new v.$4ec;const Y=this.J.getExtensionDescription(Ce);return this.db(Y,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),m.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(H){i.$Z(H)}}async Y(){this.O.onWillDeactivateAll();let H=[];try{H=this.J.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this.cb(fe))}catch{}await Promise.all(H)}terminate(H,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${H}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Ee=>{this.s.error(Ee)}),this.g.dispose();const ne=this.Y();Promise.race([(0,R.$1g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(H){return this.G.isOpen()?this.P.isActivated(H):!1}async getExtension(H){const U=await this.C.$getExtension(H);return U&&{...U,identifier:new n.$dm(U.identifier.value),extensionLocation:y.URI.revive(U.extensionLocation)}}Z(H,U){return this.P.activateByEvent(H,U)}$(H,U){return this.P.activateById(H,U)}activateByIdWithErrors(H,U){return this.$(H,U).then(()=>{const ne=this.P.getActivatedExtension(H);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(H=>this.J)}getExtensionExports(H){if(this.G.isOpen())return this.P.getActivatedExtension(H).exports;try{return this.P.getActivatedExtension(H).exports}catch{return null}}async ab(H){if(H.scheme===z.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(H.fsPath);return y.URI.file(U)}return H}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(H=>new Z(H))),this.Q}async bb(H){const U=b.$6h.forUris(ne=>A.$sg.ignorePathCasing(ne));return await Promise.all(H.map(async ne=>{if(this.ub(ne)){const Ee=await this.ab(ne.extensionLocation);U.set(Ee,ne)}})),U}cb(H){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(H))return U;const ne=this.P.getActivatedExtension(H);if(!ne)return U;try{typeof ne.module.deactivate=="function"&&(U=Promise.resolve(ne.module.deactivate()).then(void 0,Ee=>(this.s.error(Ee),Promise.resolve(void 0))))}catch(Ee){this.s.error(`An error occurred when deactivating the extension '${H.value}':`),this.s.error(Ee)}try{(0,w.$Mc)(ne.subscriptions)}catch(Ee){this.s.error(`An error occurred when deactivating the subscriptions for extension '${H.value}':`),this.s.error(Ee)}return U}async db(H,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(H.identifier):await this.C.$onWillActivateExtension(H.identifier),this.fb(H,U).then(ne=>{const Ee=ne.activationTimes;return this.C.$onDidActivateExtension(H.identifier,Ee.codeLoadingTime,Ee.activateCallTime,Ee.activateResolvedTime,U),this.eb(H,U,"success",Ee),ne},ne=>{throw this.eb(H,U,"failure"),ne})}eb(H,U,ne,Ee){const fe=X(H,U);this.z.$publicLog2("extensionActivationTimes",{...fe,...Ee||{},outcome:ne})}fb(H,U){const ne=X(H,U);this.z.$publicLog2("activatePlugin",ne);const Ee=this.ub(H);if(!Ee)return Promise.resolve(new v.$3ec(v.$Zec.NONE));this.s.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${H.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const fe=new v.$1ec(U.startup);return Promise.all([this.vb(H,(0,A.$Bg)(H.extensionLocation,Ee),fe),this.gb(H)]).then(me=>(m.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),W.hb(this.s,H.identifier,me[0],me[1],fe))).then(me=>(m.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),me))}gb(H){const U=new a.$9ec(H,this.M),ne=new a.$8ec(H.identifier.value,!1,this.M),Ee=new j.$dfc(H,this.N),fe=H.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,me=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([U.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ee=this;let te,K;const ie=(0,d.$PF)(H,"ipc")?this.f.messagePorts?.get(n.$dm.toKey(H.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:ne,secrets:Ee,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(G){return T.$ic(H.extensionLocation.fsPath,G)},get storagePath(){return ee.O.workspaceValue(H)?.fsPath},get globalStoragePath(){return ee.O.globalValue(H).fsPath},get logPath(){return T.$ic(ee.f.logsLocation.fsPath,H.identifier.value)},get logUri(){return y.URI.joinPath(ee.f.logsLocation,H.identifier.value)},get storageUri(){return ee.O.workspaceValue(H)},get globalStorageUri(){return ee.O.globalValue(H)},get extensionMode(){return fe},get extension(){return te===void 0&&(te=new Q(ee,H.identifier,H,me,!1)),te},get extensionRuntime(){return(0,d.$QF)(H,"extensionRuntime"),ee.extensionRuntime},get environmentVariableCollection(){return ee.u.getEnvironmentVariableCollection(H)},get messagePassingProtocol(){if(!K){if(!ie)return;const G=p.Event.buffer(p.Event.fromDOMEventEmitter(ie,"message",ae=>ae.data));ie.start(),K={onDidReceiveMessage:G,postMessage:ie.postMessage.bind(ie)}}return K}})})}static hb(H,U,ne,Ee,fe){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(H,U,ne,Ee,fe).then(me=>new v.$2ec(!1,null,fe.build(),ne,me,Ee.subscriptions))}static ib(H,U,ne,Ee,fe){if(typeof ne.activate=="function")try{fe.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${U.value}`);const me=typeof global=="object"?global:self,ee=ne.activate.apply(me,[Ee]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(ee).then(te=>(fe.activateResolveStop(),te))}catch(me){return Promise.reject(me)}else return Promise.resolve(ne)}jb(H,U){this.$(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:U}).then(void 0,ne=>{this.s.error(ne)})}kb(H,U=0){const Ee=Date.now();(0,N.$B)(()=>{for(let fe=U;fe<H.length;fe+=1){const me=H[fe];for(const ee of me.activationEvents??[])if(ee==="onStartupFinished")if(Date.now()-Ee>50){this.kb(H,fe);break}else this.jb(me,ee)}})}lb(){this.C.$setPerformanceMarks(m.getMarks()),this.m.getConfigProvider().then(H=>{const U=H.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(U)this.kb(ne);else for(const Ee of ne)if(Ee.activationEvents)for(const fe of Ee.activationEvents)fe==="onStartupFinished"&&this.jb(Ee,fe)})}mb(){const H=this.Z("*",!0).then(void 0,me=>{this.s.error(me)});this.B(this.j.onDidChangeWorkspace(me=>this.nb(me.added)));const U=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(U),Ee=this.pb(),fe=Promise.all([Ee,H,ne]).then(()=>{});return Promise.race([fe,(0,R.$1g)(1e4)]).then(()=>{this.lb()}),fe}nb(H){return H.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(H,U))).then(()=>{})}async ob(H,U){if(this.isActivated(U.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Ee={logService:this.s,folders:H.map(me=>me.uri),forceUsingSearch:ne||!this.c.fsExists,exists:me=>this.c.fsExists(me.fsPath),checkExists:(me,ee,te)=>this.y.$checkExists(me,ee,te)},fe=await(0,k.$Hrb)(Ee,U);if(fe)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:fe.activationEvent}).then(void 0,me=>this.s.error(me))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(H){throw console.error(H),H}}async qb(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:U}=this.f.environment;if(!H||!U)throw new Error(D.localize(0,null));const ne=await this.vb(null,U,new v.$1ec(!1));if(!ne||typeof ne.run!="function")throw new Error(D.localize(1,null,U.toString()));return new Promise((Ee,fe)=>{const me=(K,ie)=>{K?(N.$t&&this.s.error("Test runner called back with error",K),fe(K)):(N.$t&&(ie?this.s.info(`Test runner called back with ${ie} failures.`):this.s.info("Test runner called back with successful outcome.")),Ee(typeof ie=="number"&&ie>0?1:0))},ee=(0,A.$pg)(U),te=ne.run(ee,me);te&&te.then&&te.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),Ee(0)}).catch(K=>{N.$t&&this.s.error("Test runner finished with error",K),fe(K instanceof Error&&K.stack?K.stack:String(K))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$1g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(H,U){return this.R[H]=U,(0,w.$Pc)(()=>{delete this.R[H]})}async getRemoteExecServer(H){const{resolver:U}=await this.sb(H);return U?.resolveExecServer?.(H,{resolveAttempt:0})}async sb(H){const U=H.indexOf("+");if(U===-1)throw new t.$KK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=H.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(H,U){const ne=F.$Nd.create(!1),Ee=()=>`[resolveAuthority(${(0,r.$4k)(H)},${U})][${ne.elapsed()}ms] `,fe=oe=>this.s.info(`${Ee()}${oe}`),me=oe=>this.s.warn(`${Ee()}${oe}`),ee=(oe,_=void 0)=>this.s.error(`${Ee()}${oe}`,_),te=oe=>{if(oe instanceof t.$KK)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe},K=async oe=>{fe(`activating resolver for ${oe}...`);const{resolver:_,authorityPrefix:ge}=await this.sb(oe);if(!_)throw ee(`no resolver for ${ge}`),new t.$KK(`No remote extension installed to resolve ${ge}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:_,authorityPrefix:ge,remoteAuthority:oe}},ie=H.split(/@|%40/g).reverse();fe(`activating remote resolvers ${ie.join(" -> ")}`);let G;try{G=await Promise.all(ie.map(K)).catch(async oe=>{if(!(oe instanceof t.$KK)||oe._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw oe;return me(`resolving nested authorities failed: ${oe.message}`),[await K(H)]})}catch(oe){return te(oe)}const ae=new R.$$g;ae.cancelAndSet(()=>fe("waiting..."),1e3);let $e,Ce;for(const[oe,{authorityPrefix:_,resolver:ge,remoteAuthority:ve}]of G.entries())try{if(oe===G.length-1)fe("invoking final resolve()..."),m.mark(`code/extHost/willResolveAuthority/${_}`),$e=await ge.resolve(ve,{resolveAttempt:U,execServer:Ce}),m.mark(`code/extHost/didResolveAuthorityOK/${_}`),fe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ge,t.$JK.isManagedResolvedAuthority($e)?$e:void 0));else{if(fe(`invoking resolveExecServer() for ${ve}`),m.mark(`code/extHost/willResolveExecServer/${_}`),Ce=await ge.resolveExecServer?.(ve,{resolveAttempt:U,execServer:Ce}),!Ce)throw new t.$KK(`Exec server was not available for ${ve}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);m.mark(`code/extHost/didResolveExecServerOK/${_}`)}}catch(ze){return m.mark(`code/extHost/didResolveAuthorityError/${_}`),ee("returned an error",ze),ae.dispose(),te(ze)}ae.dispose();const B={environmentTunnels:$e.environmentTunnels,features:$e.tunnelFeatures},Y={extensionHostEnv:$e.extensionHostEnv,isTrusted:$e.isTrusted,authenticationSession:$e.authenticationSessionForInitializingExtensions?{id:$e.authenticationSessionForInitializingExtensions.id,providerId:$e.authenticationSessionForInitializingExtensions.providerId}:void 0};fe(`returned ${t.$JK.isManagedResolvedAuthority($e)?"managed authority":`${$e.host}:${$e.port}`}`);let se;if(t.$JK.isManagedResolvedAuthority($e)){const oe=U;this.X.setFactory(oe,$e.makeConnection),se={authority:H,connectTo:new r.$1k(oe),connectionToken:$e.connectionToken}}else se={authority:H,connectTo:new r.$2k($e.host,$e.port),connectionToken:$e.connectionToken};return{type:"ok",value:{authority:se,options:Y,tunnelInformation:B}}}async $getCanonicalURI(H,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$4k)(H)})`);const{resolver:ne}=await this.sb(H);if(!ne)return null;const Ee=y.URI.revive(U);if(typeof ne.getCanonicalURI>"u")return Ee;const fe=await(0,R.$Sg)(()=>ne.getCanonicalURI(Ee));return fe||Ee}$startExtensionHost(H){H.toAdd.forEach(Ee=>Ee.extensionLocation=y.URI.revive(Ee.extensionLocation));const{globalRegistry:U,myExtensions:ne}=ue(this.I,this.L,this.J,H);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(ne),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${J(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${J(this.J)}`)),this.rb()}$activateByEvent(H,U){return U===1?this.D.wait().then(ne=>this.Z(H,!1)):this.G.wait().then(ne=>this.Z(H,!1))}async $activate(H,U){return await this.G.wait(),this.J.getExtensionDescription(H)?(await this.$(H,U),!0):!1}async $deltaExtensions(H){H.toAdd.forEach(me=>me.extensionLocation=y.URI.revive(me.extensionLocation));const{globalRegistry:U,myExtensions:ne}=ue(this.I,this.L,this.J,H),Ee=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ee),this.L.set(U.getAllExtensionDescriptions()),this.J.set(ne),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${J(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${J(this.J)}`)),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){const U=s.$fe.alloc(H),ne=Math.random()%256;for(let Ee=0;Ee<H;Ee++)U.writeUInt8(ne,Ee);return U}async $updateRemoteConnectionData(H){this.W=H,this.a.fire()}};e.$jfc=x,e.$jfc=x=W=Ke([Be(0,h.$Yh),Be(1,e.$ifc),Be(2,l.$EM),Be(3,g.$Iec),Be(4,$.$Lec),Be(5,L.$hj),Be(6,u.$UM),Be(7,c.$Oec),Be(8,C.$Exb),Be(9,f.$0ec),Be(10,M.$ffc),Be(11,O.$gfc)],x);function ue(de,H,U,ne){de.addActivationEvents(ne.addActivationEvents);const Ee=new o.$x6b(de,H.getAllExtensionDescriptions());Ee.deltaExtensions(ne.toAdd,ne.toRemove);const fe=new n.$em(U.getAllExtensionDescriptions().map(ee=>ee.identifier));for(const ee of ne.myToRemove)fe.delete(ee);for(const ee of ne.myToAdd)fe.add(ee);const me=he(Ee,fe);return{globalRegistry:Ee,myExtensions:me}}function X(de,H){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}function J(de){return de.getAllExtensionDescriptions().map(H=>H.identifier.value).join(",")}e.$kfc=(0,h.$Zh)("IExtHostExtensionService");class Q{#e;#t;#i;constructor(H,U,ne,Ee,fe){this.#e=H,this.#t=U,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=T.$gc((0,A.$pg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ee,this.isFromDifferentExtensionHost=fe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$lfc=Q;function he(de,H){return de.getAllExtensionDescriptions().filter(U=>H.has(U.identifier))}class Z{constructor(H){this.a=H}setSearchTree(H){this.a=H}findSubstr(H){return this.a.findSubstr(H)}forEach(H){return this.a.forEach(H)}}e.$mfc=Z;class ye{constructor(H){this.a=new n.$fm,this.addActivationEvents(H)}readActivationEvents(H){return this.a.get(H.identifier)??[]}addActivationEvents(H){for(const U of Object.keys(H))this.a.set(U,H[U])}}}),define(ke[363],Se([1,0,56,2,6,42,25,26,20,27,5,48,14,13]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;let g=class{constructor(s,a,t,r,h,u,c){this.c=s,this.d=a,this.e=t,this.f=r,this.g=h,this.h=u,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new o(this.c,a,this.d,s,this.i)),this.register(this.e.createInstance(d)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const a of s.nodeModuleName)this.a.set(a,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(a=>s.alternativeModuleName(a))}};e.$ugc=g,e.$ugc=g=Ke([Be(2,L.$Yh),Be(3,A.$Lec),Be(4,P.$kfc),Be(5,y.$UM),Be(6,$.$hj)],g);let d=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&S.a.size){const a=(0,v.$Je)(this.c(s.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${h}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const a=this.b.exec(this.c(s));if(!a)return;const[,t,r,h]=a,u=S.a.get(r);if(u!==void 0)return console.warn(`${r} as been renamed to ${u}, please update your imports`),t+u+h}c(s){return s.replace(/\\/g,"/")}};d=S=Ke([Be(0,y.$UM)],d);class o{constructor(s,a,t,r,h){this.c=s,this.d=a,this.e=t,this.f=r,this.g=h,this.nodeModuleName="vscode",this.a=new w.$fm}load(s,a){const t=this.d.findSubstr(a);if(t){let r=this.a.get(t.identifier);return r||(r=this.c(t,this.e,this.f),this.a.set(t.identifier,r)),r}if(!this.b){let r="";this.d.forEach((h,u)=>r+=`	${u} -> ${h.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${r}`),this.b=this.c(R.$KF,this.e,this.f)}return this.b}}let i=class{constructor(s,a,t){this.e=s,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(m.$CK.MainThreadTelemetry);const r=t.getProxy(m.$CK.MainThreadWindow);this.c=(h,u)=>{const c=T.URI.parse(h);return u?this.g(h,u):c.scheme==="http"||c.scheme==="https"?r.$openUri(c,h,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?r.$openUri(c,h,{}):this.g(h,u)}}load(s,a,t){const r=this.e.findSubstr(a);return r&&(this.a=r.identifier.value,this.h()),this.b=t(s),this.c}g(s,a){return this.i(),this.b(s,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ke([Be(2,b.$EM)],i)}),define(ke[58],Se([1,0,43,3,16,49,5,69,70,48,7,41,289,42]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=e.$nfc=void 0,e.$nfc=(0,R.$Zh)("IExtHostVariableResolverProvider");class S extends $.$FN{constructor(o,i,n,s,a,t,r){function h(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const c=s.tabGroups.all.find(l=>l.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof L.$kM||c.input instanceof L.$pM)return c.input.modified;if(c.input instanceof L.$jM||c.input instanceof L.$oM||c.input instanceof L.$mM)return c.input.uri}}}super({getFolderUri:u=>{const c=t.folders.filter(l=>l.name===u);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,c)=>a.getConfiguration(void 0,u).get(c),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=h();if(u)return m.$gc(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const u=h();if(u){const c=i.getWorkspaceFolder(u);if(c)return m.$gc(c.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>o.getExtension(u)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(A.env))}}let g=class extends T.$Rc{constructor(o,i,n,s,a){super(),this.b=o,this.c=i,this.g=n,this.h=s,this.j=a,this.a=new D.$U(async()=>{const t=await this.h.getConfigProvider(),h={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{h.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,h,this.m())})}getResolver(){return this.a.value}m(){}};e.$ofc=g,e.$ofc=g=Ke([Be(0,y.$kfc),Be(1,P.$Iec),Be(2,w.$PM),Be(3,v.$Lec),Be(4,b.$Xec)],g)}),define(ke[96],Se([1,0,12,4,2,5,6,70,48,20,7,41,141,281,42,58]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=e.$rfc=e.$qfc=e.$pfc=void 0,e.$pfc=(0,A.$Zh)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,h,u,c,l,E){this.E=h,this.F=u,this.G=c,this.H=l,this.I=E,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Rd,this.n=new T.$Rd,this.o=new T.$Rd,this.u=new T.$Rd,this.k=r.getProxy(R.$CK.MainThreadDebugService),this.y=new T.$Rd,this.A=new T.$Rd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(C=>{C.onDidChange(f=>{this.J(C)}),this.J(C)})}asDebugSourceUri(r,h){const u=r;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let c=`debug:${encodeURIComponent(u.path||"")}`,l="?";return h&&(c+=`${l}session=${encodeURIComponent(h.id)}`,l="&"),c+=`${l}ref=${u.sourceReference}`,m.URI.parse(c)}else{if(u.path)return m.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const h=[];for(const u of r.getAllExtensionDescriptions())if(u.contributes){const c=u.contributes.debuggers;if(c&&c.length>0)for(const l of c)(0,v.$mF)(l)&&h.push(l.type)}this.k.$registerDebugTypes(h)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(h=>r.push(h)),r}addBreakpoints(r){const h=r.filter(l=>{const E=l.id;return this.w.has(E)?!1:(this.w.set(E,l),!0)});this.U(h,[],[]);const u=[],c=new Map;for(const l of h)if(l instanceof L.$DL){let E=c.get(l.location.uri.toString());E||(E={type:"sourceMulti",uri:l.location.uri,lines:[]},c.set(l.location.uri.toString(),E),u.push(E)),E.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof L.$EL&&u.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this.k.$registerBreakpoints(u)}removeBreakpoints(r){const h=r.filter(E=>this.w.delete(E.id));this.U([],h,[]);const u=h.filter(E=>E instanceof L.$DL).map(E=>E.id),c=h.filter(E=>E instanceof L.$EL).map(E=>E.id),l=h.filter(E=>E instanceof L.$FL).map(E=>E.id);return this.k.$unregisterBreakpoints(u,c,l)}startDebugging(r,h,u){return this.k.$startDebugging(r?r.uri:void 0,h,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===L.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,suppressSaveBeforeStart:u.suppressSaveBeforeStart,suppressDebugStatusbar:u.suppressDebugStatusbar??u.debugUI?.simple,suppressDebugToolbar:u.suppressDebugToolbar??u.debugUI?.simple,suppressDebugView:u.suppressDebugView??u.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,h,u){if(!h)return new L.$EK(()=>{});const c=this.d++;return this.f.push({type:r,handle:c,provider:h}),this.k.$registerDebugConfigurationProvider(r,u,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,c),new L.$EK(()=>{this.f=this.f.filter(l=>l.provider!==h),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(r,h,u){if(!u)return new L.$EK(()=>{});if(!this.Q(r,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.N(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:h,handle:c,factory:u}),this.k.$registerDebugAdapterDescriptorFactory(h,c),new L.$EK(()=>{this.h=this.h.filter(l=>l.factory!==u),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(r,h){if(!h)return new L.$EK(()=>{});const u=this.i++;return this.j.push({type:r,handle:u,factory:h}),new L.$EK(()=>{this.j=this.j.filter(c=>c.factory!==h)})}async $runInTerminal(r,h){return Promise.resolve(void 0)}async $substituteVariables(r,h){let u;const c=await this.W(r);return c&&(u={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(u,h)}K(r,h){if(r.type==="implementation")return new s(r.implementation)}L(){}async $startDASession(r,h){const u=this,c=await this.V(h);return this.S(this.N(c.type),c).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const E=this.M(l),C=this.K(E,c);if(!C)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const f=C;return this.B.set(r,f),this.R(c).then(p=>(p&&this.C.set(r,p),f.onMessage(async k=>{if(k.type==="request"&&k.command==="handshake"){const I=k,j={type:"response",seq:0,command:I.command,request_seq:I.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const z=await this.D.sign(I.arguments.value);j.body={signature:z},f.sendResponse(j)}else throw new Error("no signer")}catch(z){j.success=!1,j.message=z.message,f.sendResponse(j)}}else p&&p.onDidSendMessage&&p.onDidSendMessage(k),k=(0,v.$rF)(k,!0),u.k.$acceptDAMessage(r,k)}),f.onError(k=>{p&&p.onError&&p.onError(k),this.k.$acceptDAError(r,k.name,k.message,k.stack)}),f.onExit(k=>{p&&p.onExit&&p.onExit(k??void 0,void 0),this.k.$acceptDAExit(r,k??void 0,void 0)}),p&&p.onWillStartSession&&p.onWillStartSession(),f.startSession()))})}$sendDAMessage(r,h){h=(0,v.$qF)(h,!1);const u=this.C.get(r);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(h),this.B.get(r)?.sendMessage(h)}$stopDASession(r){const h=this.C.get(r);this.C.delete(r),h&&h.onWillStopSession&&h.onWillStopSession();const u=this.B.get(r);return this.B.delete(r),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const h=[],u=[],c=[];if(r.added)for(const l of r.added){const E=l.id;if(E&&!this.w.has(E)){let C;if(l.type==="function")C=new L.$EL(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")C=new L.$FL(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const f=m.URI.revive(l.uri);C=new L.$DL(new L.$QK(f,new L.$FK(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,L.$BL)(C,E),this.w.set(E,C),h.push(C)}}if(r.removed)for(const l of r.removed){const E=this.w.get(l);E&&(this.w.delete(l),u.push(E))}if(r.changed){for(const l of r.changed)if(l.id){const E=this.w.get(l.id);if(E){if(E instanceof L.$EL&&l.type==="function"){const C=E;C.enabled=l.enabled,C.condition=l.condition,C.hitCondition=l.hitCondition,C.logMessage=l.logMessage,C.functionName=l.functionName}else if(E instanceof L.$DL&&l.type==="source"){const C=E;C.enabled=l.enabled,C.condition=l.condition,C.hitCondition=l.hitCondition,C.logMessage=l.logMessage,C.location=new L.$QK(m.URI.revive(l.uri),new L.$FK(l.line,l.character))}c.push(E)}}}this.U(h,u,c)}async $acceptStackFrameFocus(r){let h;const u=r.sessionId?await this.V(r.sessionId):void 0;if(!u)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?h=new L.$LL(u,r.threadId):h=new L.$KL(u,r.threadId,r.frameId),this.z=h,this.A.fire(this.z)}$provideDebugConfigurations(r,h,u){return(0,D.$Sg)(async()=>{const c=this.P(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.W(h);return c.provideDebugConfigurations(l,u)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(r,h,u,c){return(0,D.$Sg)(async()=>{const l=this.P(r);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const E=await this.W(h);return l.resolveDebugConfiguration(E,u,c)})}$resolveDebugConfigurationWithSubstitutedVariables(r,h,u,c){return(0,D.$Sg)(async()=>{const l=this.P(r);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const E=await this.W(h);return l.resolveDebugConfigurationWithSubstitutedVariables(E,u,c)})}async $provideDebugAdapter(r,h){const u=this.O(r);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(h);return this.S(u,c).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.M(l)})}async $acceptDebugSessionStarted(r){const h=await this.V(r);this.m.fire(h)}async $acceptDebugSessionTerminated(r){const h=await this.V(r);h&&(this.n.fire(h),this.l.delete(h.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,h){(await this.V(r))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(r,h){const c={session:await this.V(r),event:h.event,body:h.body};this.u.fire(c)}M(r){if(r instanceof L.$GL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof L.$HL)return{type:"server",port:r.port,host:r.host};if(r instanceof L.$IL)return{type:"pipeServer",path:r.path};if(r instanceof L.$JL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const h=this.h.filter(u=>u.type===r);if(h.length>0)return h[0].factory}O(r){const h=this.h.filter(u=>u.handle===r);if(h.length>0)return h[0].factory}P(r){const h=this.f.filter(u=>u.handle===r);if(h.length>0)return h[0].provider}Q(r,h){if(r.contributes){const u=r.contributes.debuggers;if(u&&u.length>0){for(const c of u)if(c.label&&c.type&&c.type===h)return!0}}return!1}R(r){const u=r.configuration.type,c=this.j.filter(l=>l.type===u||l.type==="*").map(l=>(0,D.$Sg)(()=>l.factory.createDebugAdapterTracker(r)).then(E=>E,E=>null));return Promise.race([Promise.all(c).then(l=>{const E=l.filter(C=>!!C);if(E.length>0)return new n(E)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async S(r,h){const u=h.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new L.$HL(u));if(r){const l=await this.F.getExtensionRegistry();return(0,D.$Sg)(()=>r.createDebugAdapterDescriptor(h,this.T(h,l))).then(E=>{if(E)return E})}const c=await this.F.getExtensionRegistry();return Promise.resolve(this.T(h,c))}T(r,h){}U(r,h,u){(r.length>0||h.length>0||u.length>0)&&this.y.fire(Object.freeze({added:r,removed:h,changed:u}))}async V(r){if(r)if(typeof r=="string"){const h=this.l.get(r);if(h)return h}else{let h=this.l.get(r.id);if(!h){const u=await this.W(r.folderUri),c=r.parent?this.l.get(r.parent):void 0;h=new o(this.k,r.id,r.type,r.name,u,r.configuration,c),this.l.set(h.id,h),this.k.$sessionCached(h.id)}return h}throw new Error("cannot find session")}W(r){if(r){const h=m.URI.revive(r);return this.E.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};e.$qfc=d,e.$qfc=d=Ke([Be(0,y.$EM),Be(1,P.$Iec),Be(2,b.$kfc),Be(3,S.$Lec),Be(4,w.$Xec),Be(5,g.$nfc)],d);class o{constructor(r,h,u,c,l,E,C){this.d=r,this.f=h,this.g=u,this.h=c,this.i=l,this.j=E,this.k=C}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,h){return this.d.$customDebugAdapterRequest(this.f,r,h)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$rfc=o;class i{constructor(r){this.value=Object.freeze({append(h){r.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.$sfc=i;class n{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(h=>h.onError?h.onError(r):void 0)}onExit(r,h){this.d.forEach(u=>u.onExit?u.onExit(r,h):void 0)}}class s extends $.$Mfb{constructor(r){super(),this.h=r,r.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends d{constructor(r,h,u,c,l,E){super(r,h,u,c,l,E)}};e.$tfc=a,e.$tfc=a=Ke([Be(0,y.$EM),Be(1,P.$Iec),Be(2,b.$kfc),Be(3,S.$Lec),Be(4,w.$Xec),Be(5,g.$nfc)],a)}),define(ke[364],Se([1,0,8,56,2,6,352,14,106,107,27,247,20,66,48,90]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=e.$vgc=void 0;class d{static async installEarlyHandler(n){Error.stackTraceLimit=100;const s=n.get(w.$hj),t=n.get($.$EM).getProxy(A.$CK.MainThreadErrors);D.setUnexpectedErrorHandler(r=>{s.error(r);const h=D.$2(r);t.$onUnexpectedError(h)})}static async installFullHandler(n){const s=n.get(w.$hj),a=n.get($.$EM),t=n.get(S.$kfc),r=n.get(g.$YM),h=a.getProxy(A.$CK.MainThreadExtensionService),u=a.getProxy(A.$CK.MainThreadErrors),c=await t.getExtensionPathIndex(),l=new WeakMap;function E(p,k){if(l.has(p))return l.get(p).stack;let I="",j,z;for(const F of k)I+=`
	at ${F.toString()}`,z=F.getFileName(),!j&&z&&(j=c.findSubstr(m.URI.file(z)));const M=`${p.name||"Error"}: ${p.message||""}${I}`;return l.set(p,{extensionIdentifier:j?.identifier,stack:M}),M}const C=Symbol("prepareStackTrace wrapped");let f=E;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return f},set(p){if(p===E||!p||p[C]){f=p||E;return}f=function(k,I){return E(k,I),p.call(Error,k,I)},Object.assign(f,{[C]:!0})}}),D.setUnexpectedErrorHandler(p=>{s.error(p);const k=D.$2(p),I=l.get(p);if(!I?.extensionIdentifier){u.$onUnexpectedError(k);return}h.$onExtensionRuntimeError(I.extensionIdentifier,k);const j=r.onExtensionError(I.extensionIdentifier,p);s.trace("forwarded error to extension?",j,I)})}}e.$vgc=d;class o{constructor(n,s,a,t,r){this.a=a,this.b=new R.$F6b(n,null,t),s=o.e(s,this.b);const h=new y.$Xh(...(0,b.$Hr)());h.set(L.$UM,{_serviceBrand:void 0,...s,messagePorts:r}),h.set($.$EM,new $.$FM(this.b)),h.set(v.$Fec,new v.$Gec(t)),h.set(S.$ifc,a);const u=new P.$nq(h,!0);u.invokeFunction(d.installEarlyHandler),this.d=u.invokeFunction(c=>c.get(w.$hj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=u.invokeFunction(c=>c.get(S.$kfc)),this.c.initialize(),u.invokeFunction(d.installFullHandler)}async asBrowserUri(n){const s=this.b.getProxy(A.$CK.MainThreadExtensionService);return m.URI.revive(await s.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,s){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=m.URI.revive(s.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=m.URI.revive(s.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>m.URI.revive(s.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=m.URI.revive(s.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=m.URI.revive(s.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=m.URI.revive(s.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=m.URI.revive(s.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=m.URI.revive(s.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=m.URI.revive(s.transformIncomingURIs(n.logsLocation)),n.workspace=s.transformIncomingURIs(n.workspace),n}}e.$wgc=o}),define(ke[365],Se([1,0,12,11,222,241,139,96,70,48,20,47,7,58,41,282,283,42]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;let i=class extends w.$qfc{constructor(r,h,u,c,l,E,C){super(r,h,u,c,E,C),this.Z=l,this.X=new a}K(r,h){switch(r.type){case"server":return new g.$Bgc(r);case"pipeServer":return new g.$Cgc(r);case"executable":return new g.$Dgc(r,h.type)}return super.K(r,h)}T(r,h){const u=g.$Dgc.platformAdapterExecutable(h.getAllExtensionDescriptions(),r.type);if(u)return new $.$GL(u.command,u.args,u.options)}L(){return new R.$u0b}async $runInTerminal(r,h){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const u=await this.G.getConfigProvider(),c=this.Z.getDefaultShell(!0),l=this.Z.getDefaultShellArgs(!0),E=r.title||m.localize(0,null),C=JSON.stringify({shell:c,shellArgs:l});let f=await this.X.checkout(C,E),p,k=!1;if(f)p=r.cwd;else{const M={shellPath:c,shellArgs:l,cwd:r.cwd,name:E,iconPath:new $.$yL("debug")};k=!0,f=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(f,C)}f.show(!0);const I=await f.processId;k?await new Promise(M=>setTimeout(M,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?f.sendText("cls"):c.indexOf("bash")>=0?f.sendText("clear"):T.$i?f.sendText("cls"):f.sendText("clear"));const j=(0,d.$Fgc)(c,r.args,!!r.argsCanBeInterpretedByShell,p,r.env);f.sendText(j);const z=this.onDidTerminateDebugSession(M=>{M.id===h&&(this.X.free(f),z.dispose())});return I}else if(r.kind==="external")return s(r,await this.G.getConfigProvider());return super.$runInTerminal(r,h)}};e.$Ggc=i,e.$Ggc=i=Ke([Be(0,L.$EM),Be(1,S.$Iec),Be(2,y.$kfc),Be(3,o.$Lec),Be(4,P.$0ec),Be(5,b.$Xec),Be(6,v.$nfc)],i);let n;function s(t,r){if(!n)if(T.$i)n=new A.$g9b;else if(T.$j)n=new A.$h9b;else if(T.$k)n=new A.$i9b;else throw new Error("external terminals not supported on this platform");const h=r.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},h.external||{})}class a{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,h){const c=[...this.b.entries()].map(([l,E])=>(0,D.$Ng)(async C=>{if(l.name!==h||E.lastUsedAt!==-1&&await(0,d.$Egc)(await l.processId))return null;const f=Date.now();return E.lastUsedAt+a.a>f||C.isCancellationRequested||E.config!==r?null:(E.lastUsedAt=f,l)}));return await(0,D.$5g)(c,l=>!!l)}insert(r,h){this.b.set(r,{lastUsedAt:Date.now(),config:h})}free(r){const h=this.b.get(r);h&&(h.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(ke[366],Se([1,0,16,2,104,41,69,42,40,47,20,27,95,17,14,91,23,63,58]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=void 0;let n=class extends $.$agc{constructor(a,t,r,h,u,c,l,E,C){super(a,t,r,h,u,c,l,E),this.B=r,this.C=C,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(v.Schemas.file,{scheme:v.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const h=$.TaskHandleDTO.from(r,this.B),u=await this.a.$getTaskExecution(h);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(u,t);return this.a.$executeTask(h).catch(()=>{}),c}else{const h=$.TaskDTO.from(t,a);if(h===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(h.execution)&&await this.x(h,t,!1);const u=await this.y(await this.a.$getTaskExecution(h),t);return this.a.$executeTask(h).catch(()=>{}),u}}u(a,t,r,h){const u=[];if(h)for(const c of h){this.z(c,r),(!c.definition||!a[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const l=$.TaskDTO.from(c,r.extension);l&&(u.push(l),$.CustomExecutionDTO.is(l.execution)&&t.push(this.x(l,c,!0)))}return{tasks:u,extension:r.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const r=T.URI.file((0,o.homedir)());t=new b.$hi({uri:r,name:d.$yg(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const r=T.URI.revive(a),h={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(r),c=await this.b.getWorkspaceFolders2()??[],l=await this.C.getResolver(),E=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const C of t.variables)h.variables[C]=await l.resolveAsync(E,C);if(t.process!==void 0){let C;if(t.process.path!==void 0){C=t.process.path.split(D.$sc);for(let f=0;f<C.length;f++)C[f]=await l.resolveAsync(E,C[f])}h.process=await m.win32.findExecutable(await l.resolveAsync(E,t.process.name),t.process.cwd!==void 0?await l.resolveAsync(E,t.process.cwd):void 0,C)}return h}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,r){return m.win32.findExecutable(a,t,r)}};e.$ygc=n,e.$ygc=n=Ke([Be(0,L.$EM),Be(1,P.$UM),Be(2,A.$Iec),Be(3,R.$PM),Be(4,w.$Lec),Be(5,y.$0ec),Be(6,S.$hj),Be(7,g.$qec),Be(8,i.$nfc)],n)}),define(ke[367],Se([1,0,63,58]),function(be,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;class m extends T.$ofc{m(){return(0,D.homedir)()}}e.$ehc=m}),define(ke[155],Se([1,0,19,12,21,44,17,16,23,2,36]),function(be,e,D,T,m,A,R,w,b,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=e.$Jfc=e.$Ifc=e.$Hfc=void 0;class P{constructor(i,n,s,a){this.d=i,this.e=n,this.f=s,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const s=this.d.folderQueries||[],a=new m.$2d(n);return new Promise((t,r)=>{this.a=new v(i);let h=!1;const u=(c,l)=>{if(!h&&!this.b){const E=this.h(c);g(c)&&typeof this.d.maxResults=="number"&&this.c+E>this.d.maxResults&&(this.b=!0,h=!0,a.cancel(),c=this.j(c,this.d.maxResults-this.c));const C=this.h(c);this.c+=C,(C>0||!g(c))&&this.a.add(c,l)}};Promise.all(s.map((c,l)=>this.k(c,E=>u(E,l),a.token))).then(c=>{a.dispose(),this.a.flush();const l=c.some(E=>!!E&&!!E.limitHit);t({limitHit:this.b||l,messages:(0,D.$Qb)(c.map(E=>E?.message?Array.isArray(E.message)?E.message:[E.message]:[])),stats:{type:this.g}})},c=>{a.dispose();const l=(0,A.$Ki)(c);r(new Error(l))})})}h(i){return g(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const s=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:s.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,s){const a=new L.$hJ(this.d,i),t=[],r={report:c=>{if(!this.l(c))return;const l=i.folder.scheme===R.Schemas.file?(0,L.$iJ)(()=>this.f.readdir(b.$Ag(c.uri))):void 0,E=b.$Dg(i.folder,c.uri);if(E){const C=a.includedInQuery(E,w.$mc(E),l);(0,T.$Mg)(C)?t.push(C.then(f=>{f&&n(c)})):C&&n(c)}}},h=this.n(i),u=await this.e.provideTextSearchResults($(this.d.contentPattern),h,r,s);return t.length&&await Promise.all(t),u}l(i){if(g(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,L.$gJ)(this.d.includePattern,i.includePattern),s=(0,L.$gJ)(this.d.excludePattern,i.excludePattern),a={folder:y.URI.from(i.folder),excludes:s,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$Hfc=P;function $(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class v{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new d(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!b.$ug(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Ifc=v;function S(o){return g(o)?{preview:{matches:(0,D.$1b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,D.$1b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function g(o){return!!o.preview}e.$Jfc=g;class d{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Kfc=d}),define(ke[97],Se([1,0,3,6,5,360,20,66,14,2,155]),function(be,e,D,T,m,A,R,w,b,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=e.$Lfc=void 0,e.$Lfc=(0,m.$Zh)("IExtHostSearch");let P=class{constructor(g,d,o){this.k=g,this.l=d,this.n=o,this.c=this.k.getProxy(T.$CK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new A.$Gfc}o(g){return this.l.transformOutgoingScheme(g)}registerTextSearchProvider(g,d){if(this.g.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this.g.add(g);const o=this.d++;return this.e.set(o,d),this.c.$registerTextSearchProvider(o,this.o(g)),(0,D.$Pc)(()=>{this.g.delete(g),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(g,d){if(this.i.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this.i.add(g);const o=this.d++;return this.h.set(o,d),this.c.$registerFileSearchProvider(o,this.o(g)),(0,D.$Pc)(()=>{this.i.delete(g),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(g,d,o,i){const n=$(o),s=this.h.get(g);if(s)return this.j.fileSearch(n,s,a=>{this.c.$handleFileMatch(g,d,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+g)}async doInternalFileSearchWithCustomCallback(g,d,o){return{messages:[]}}$clearCache(g){return this.j.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,d,o,i){const n=this.e.get(g);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const s=$(o);return this.q(s,n).search(t=>this.c.$handleTextMatch(g,d,t),i)}$enableExtensionHostSearch(){}q(g,d){return new L.$Hfc(g,d,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$Mfc=P,e.$Mfc=P=Ke([Be(0,R.$EM),Be(1,w.$Fec),Be(2,b.$hj)],P);function $(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(v),extraFileResources:S.extraFileResources&&S.extraFileResources.map(g=>y.URI.revive(g))}}e.$Nfc=$;function v(S){return{...S,folder:y.URI.revive(S.folder)}}}),define(ke[368],Se([1,0,21,8,4,3,17,39,2,133,190,171,79,26,32,14,65,87,266,6,304,312,91,305,306,307,308,309,310,311,287,35,313,42,343,96,150,315,316,317,293,318,69,70,319,48,320,71,321,57,27,322,323,324,325,326,327,115,116,328,359,295,272,296,329,330,153,331,297,332,333,20,334,97,117,335,336,337,118,92,95,90,47,338,339,284,340,298,72,15,7,341,66,342,93,344,345,152,41,280,114,25,94]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s,a,t,r,h,u,c,l,E,C,f,p,k,I,j,z,M,F,N,O,W,x,ue,X,J,Q,he,Z,ye,de,H,U,ne,Ee,fe,me,ee,te,K,ie,G,ae,$e,Ce,B,Y,se,oe,_,ge,ve,ze,We,tt,Ye,rt,nt,Ae,Oe,qe,Me,Xe,le,ce,Pe,He,Ge,xe,ot,lt,Ne,St,Ht,Kt,vt,Ut,Ot,Gt,Bt,Dt,Tt,et,Jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;function Wt(ut){const gt=ut.get(H.$UM),qt=ut.get(de.$nec),Rt=ut.get(Z.$Nec),kt=ut.get(Q.$kfc),mt=ut.get(Bt.$Iec),Lt=ut.get(Xe.$YM),At=ut.get(I.$Lec),Ct=ut.get(Ht.$Fec),Je=ut.get(ze.$EM),Nt=ut.get(Oe.$7ec),jt=ut.get(qe.$Oec),Qt=ut.get(g.$ij),Re=ut.get(g.$hj),Fe=ut.get(ot.$Exb),Ie=ut.get(t.$qec),re=ut.get(Gt.$pgc),Te=ut.get(Ye.$cfc),Ve=ut.get(X.$Xec),_e=ut.get(K.$gfc);Je.set(n.$DK.ExtHostFileSystemInfo,qt),Je.set(n.$DK.ExtHostLogLevelServiceShape,Qt),Je.set(n.$DK.ExtHostWorkspace,mt),Je.set(n.$DK.ExtHostConfiguration,At),Je.set(n.$DK.ExtHostExtensionService,kt),Je.set(n.$DK.ExtHostStorage,Nt),Je.set(n.$DK.ExtHostTunnelService,Fe),Je.set(n.$DK.ExtHostWindow,re),Je.set(n.$DK.ExtHostSecretState,Te),Je.set(n.$DK.ExtHostTelemetry,Lt),Je.set(n.$DK.ExtHostEditorTabs,Ve),Je.set(n.$DK.ExtHostManagedSockets,_e);const Qe=Je.set(n.$DK.ExtHostDecorations,ut.get(M.$vfc)),st=Je.set(n.$DK.ExtHostDocumentsAndEditors,ut.get(ue.$PM)),ht=Je.set(n.$DK.ExtHostCommands,ut.get(p.$1M)),wt=Je.set(n.$DK.ExtHostTerminalService,ut.get(le.$0ec)),bt=Je.set(n.$DK.ExtHostDebugService,ut.get(z.$pfc)),Et=Je.set(n.$DK.ExtHostSearch,ut.get(tt.$Lfc)),yt=Je.set(n.$DK.ExtHostTask,ut.get(Me.$cgc)),ki=Je.set(n.$DK.ExtHostOutputService,ut.get(se.$2fc)),Vt=Je.set(n.$DK.ExtHostLocalization,ut.get(te.$ffc)),mi=Je.set(n.$DK.ExtHostUrls,new Kt.$mgc(Je)),Pt=Je.set(n.$DK.ExtHostDocuments,new x.$lec(Je,st)),Si=Je.set(n.$DK.ExtHostDocumentContentProviders,new O.$xfc(Je,st,Re)),Hi=Je.set(n.$DK.ExtHostDocumentSaveParticipant,new W.$yfc(Re,Pt,Je.getProxy(n.$CK.MainThreadBulkEdits))),It=Je.set(n.$DK.ExtHostNotebook,new G.$Ofc(Je,ht,st,Pt,Rt,Et)),ii=Je.set(n.$DK.ExtHostNotebookDocuments,new $e.$Vfc(It)),$i=Je.set(n.$DK.ExtHostNotebookEditors,new Ce.$Wfc(Re,It)),oi=Je.set(n.$DK.ExtHostNotebookKernels,new B.$Xfc(Je,gt,It,ht,Re)),Di=Je.set(n.$DK.ExtHostNotebookRenderers,new Y.$Zfc(Je,It)),Ci=Je.set(n.$DK.ExtHostNotebookDocumentSaveParticipant,new ae.$Ufc(Re,It,Je.getProxy(n.$CK.MainThreadBulkEdits))),Mt=Je.set(n.$DK.ExtHostEditors,new Pe.$Cec(Je,st)),bi=Je.set(n.$DK.ExtHostTreeViews,new xe.$kgc(Je.getProxy(n.$CK.MainThreadTreeViews),ht,Re)),Ii=Je.set(n.$DK.ExtHostEditorInsets,new f.$Dec(Je.getProxy(n.$CK.MainThreadEditorInsets),Mt,gt.remote)),ai=Je.set(n.$DK.ExtHostDiagnostics,new F.$pec(Je,Re,qt,st)),ci=Je.set(n.$DK.ExtHostLanguages,new ee.$Sfc(Je,Pt,ht.converter,Ct)),dt=Je.set(n.$DK.ExtHostLanguageFeatures,new me.$tec(Je,Ct,Pt,ht,ai,Re,Ie,Lt)),Ki=Je.set(n.$DK.ExtHostFileSystem,new he.$Afc(Je,dt)),Xt=Je.set(n.$DK.ExtHostFileSystemEventService,new ye.$Bfc(Je,Re,st)),ni=Je.set(n.$DK.ExtHostQuickOpen,(0,ve.$6fc)(Je,mt,ht)),di=Je.set(n.$DK.ExtHostSCM,new We.$8fc(Je,ht,Pt,Re)),Pi=Je.set(n.$DK.ExtHostQuickDiff,new ge.$5fc(Je,Ct)),Gi=Je.set(n.$DK.ExtHostShare,new rt.$9fc(Je,Ct)),Ai=Je.set(n.$DK.ExtHostComments,(0,k.$Eec)(Je,ht,Pt)),wi=Je.set(n.$DK.ExtHostProgress,new _.$4fc(Je.getProxy(n.$CK.MainThreadProgress))),Ji=Je.set(n.$DK.ExtHosLabelService,new fe.$Rfc(Je)),Ri=Je.set(n.$DK.ExtHostTheming,new He.$hgc(Je)),ui=Je.set(n.$DK.ExtHostAuthentication,new r.$vec(Je)),Qi=Je.set(n.$DK.ExtHostTimeline,new Ge.$jgc(Je,ht)),pi=Je.set(n.$DK.ExtHostWebviews,new vt.$Sec(Je,gt.remote,mt,Re,Ie)),Li=Je.set(n.$DK.ExtHostWebviewPanels,new Ut.$Vec(Je,pi,mt)),ln=Je.set(n.$DK.ExtHostCustomEditors,new j.$Wec(Je,Pt,jt,pi,Li)),Mi=Je.set(n.$DK.ExtHostWebviewViews,new Ot.$ngc(Je,pi)),ri=Je.set(n.$DK.ExtHostTesting,new ce.$dgc(Je,ht,st)),hn=Je.set(n.$DK.ExtHostUriOpeners,new St.$lgc(Je)),dn=Je.set(n.$DK.ExtHostProfileContentHandlers,new oe.$3fc(Je));Je.set(n.$DK.ExtHostInteractive,new ne.$Pfc(Je,It,st,ht,Re));const Zi=Je.set(n.$DK.ExtHostInlineChat,new U.$Cfc(Je,ht,Pt,Re)),fi=Je.set(n.$DK.ExtHostChatProvider,new l.$yec(Je,Re)),Yi=Je.set(n.$DK.ExtHostChatAgents2,new c.$zec(Je,fi,Re)),Xi=Je.set(n.$DK.ExtHostChatVariables,new E.$Aec(Je)),gi=Je.set(n.$DK.ExtHostChat,new u.$xec(Je)),xi=Je.set(n.$DK.ExtHostAiRelatedInformation,new s.$kec(Je)),Fi=Je.set(n.$DK.ExtHostAiEmbeddingVector,new J.$zfc(Je)),Ti=Je.set(n.$DK.ExtHostIssueReporter,new Ee.$Qfc(Je)),xt=Je.set(n.$DK.ExtHostStatusBar,new Ae.$_fc(Je,ht.converter)),vi=Je.set(n.$DK.ExtHostSpeech,new nt.$0fc(Je)),fn=Object.values(n.$DK);Je.assertRegistered(fn);const Zt=new h.$wec(Je,st),yi=new C.$Bec(Je),Ei=new ie.$Tfc(Je,Re),Oi=new N.$wfc(Je);return a.$uec.register(ht),function(Ue,_t,_i){const $t=function(){let we=!Ue.isUnderDevelopment;function De(){we||(Re.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),we=!0)}return function je(at){if(Array.isArray(at))at.forEach(je);else if(typeof at=="string")De();else{const pt=at;typeof pt.scheme>"u"&&De(),typeof pt.exclusive=="boolean"&&(0,et.$QF)(Ue,"documentFiltersExclusive")}return at}}(),en={getSession(we,De,je){return ui.getSession(Ue,we,De,je)},getSessions(we,De){return(0,et.$QF)(Ue,"authGetSessions"),ui.getSessions(Ue,we,De)},async hasSession(we,De){return(0,et.$QF)(Ue,"authSession"),!!await ui.getSession(Ue,we,De,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(we,De,je,at){return ui.registerAuthenticationProvider(we,De,je,at)}},gn={registerCommand(we,De,je){return ht.registerCommand(!0,we,De,je,void 0,Ue)},registerTextEditorCommand(we,De,je){return ht.registerCommand(!0,we,(...at)=>{const pt=Mt.getActiveTextEditor();if(!pt){Re.warn("Cannot execute "+we+" because there is no active text editor.");return}return pt.edit(Ft=>{De.apply(je,[pt,Ft,...at])}).then(Ft=>{Ft||Re.warn("Edits from command "+we+" were not applied.")},Ft=>{Re.warn("An error occurred while running command "+we,Ft)})},void 0,void 0,Ue)},registerDiffInformationCommand:(we,De,je)=>((0,et.$QF)(Ue,"diffCommand"),ht.registerCommand(!0,we,async(...at)=>{const pt=st.activeEditor(!0);if(!pt){Re.warn("Cannot execute "+we+" because there is no active text editor.");return}const Ft=await Mt.getDiffInformation(pt.id);De.apply(je,[Ft,...at])},void 0,void 0,Ue)),executeCommand(we,...De){return ht.executeCommand(we,...De)},getCommands(we=!1){return ht.getCommands(we)}},tn={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return yi.value},get shell(){return wt.getDefaultShell(!1)},get onDidChangeShell(){return wt.onDidChangeShell},get isTelemetryEnabled(){return Lt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Lt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,et.$QF)(Ue,"telemetry"),Lt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$QF)(Ue,"telemetry"),Lt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Xe.$XM)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(we,De){return Xe.$WM.validateSender(we),Lt.instantiateLogger(Ue,we,De)},openExternal(we,De){return re.openUri(we,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:De?.allowContributedOpeners})},async asExternalUri(we){if(we.scheme===gt.environment.appUriScheme)return mi.createAppUri(we);try{return await re.asExternalUri(we,{allowTunneling:!!gt.remote.authority})}catch(De){if((0,R.$$f)(we,R.Schemas.http)||(0,R.$$f)(we,R.Schemas.https))return we;throw De}},get remoteName(){return(0,d.$6k)(gt.remote.authority)},get remoteAuthority(){return(0,et.$QF)(Ue,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return Re.getLevel()},get onDidChangeLogLevel(){return Re.onDidChangeLogLevel},registerIssueUriRequestHandler(we){return(0,et.$QF)(Ue,"handleIssueUri"),Ti.registerIssueUriRequestHandler(Ue,we)},registerIssueDataProvider(we){return(0,et.$QF)(Ue,"handleIssueUri"),Ti.registerIssueDataProvider(Ue,we)},get appQuality(){return(0,et.$QF)(Ue,"resolvers"),gt.quality},get appCommit(){return(0,et.$QF)(Ue,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(tn);const nn={createTestController(we,De,je){return ri.createTestController(Ue,we,De,je)},createTestObserver(){return(0,et.$QF)(Ue,"testObserver"),ri.createTestObserver()},runTests(we){return(0,et.$QF)(Ue,"testObserver"),ri.runTests(we)},get onDidChangeTestResults(){return(0,et.$QF)(Ue,"testObserver"),ri.onResultsChanged},get testResults(){return(0,et.$QF)(Ue,"testObserver"),ri.results}},li=gt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,rn={getExtension(we,De){(0,et.$PF)(Ue,"extensionsAny")||(De=!1);const je=_t.mine.getExtensionDescription(we);if(je)return new Q.$lfc(kt,Ue.identifier,je,li,!1);if(De){const at=_t.all.getExtensionDescription(we);if(at)return new Q.$lfc(kt,Ue.identifier,at,li,!0)}},get all(){const we=[];for(const De of _t.mine.getAllExtensionDescriptions())we.push(new Q.$lfc(kt,Ue.identifier,De,li,!1));return we},get allAcrossExtensionHosts(){(0,et.$QF)(Ue,"extensionsAny");const we=new v.$em(_t.mine.getAllExtensionDescriptions().map(je=>je.identifier)),De=[];for(const je of _t.all.getAllExtensionDescriptions()){const at=!we.has(je.identifier);De.push(new Q.$lfc(kt,Ue.identifier,je,li,at))}return De},get onDidChange(){return(0,et.$PF)(Ue,"extensionsAny")?m.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},sn={createDiagnosticCollection(we){return ai.createDiagnosticCollection(Ue.identifier,we)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:we=>ai.getDiagnostics(we),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(we,De){return ci.changeLanguage(we.uri,De)},match(we,De){const je=Pt.getDocumentData(De.uri)?.notebook;return(0,L.$PE)(lt.LanguageSelector.from(we),De.uri,De.languageId,!0,je?.uri,je?.notebookType)},registerCodeActionsProvider(we,De,je){return dt.registerCodeActionProvider(Ue,$t(we),De,je)},registerDocumentPasteEditProvider(we,De,je){return(0,et.$QF)(Ue,"documentPaste"),dt.registerDocumentPasteEditProvider(Ue,$t(we),De,je)},registerCodeLensProvider(we,De){return dt.registerCodeLensProvider(Ue,$t(we),De)},registerDefinitionProvider(we,De){return dt.registerDefinitionProvider(Ue,$t(we),De)},registerDeclarationProvider(we,De){return dt.registerDeclarationProvider(Ue,$t(we),De)},registerImplementationProvider(we,De){return dt.registerImplementationProvider(Ue,$t(we),De)},registerTypeDefinitionProvider(we,De){return dt.registerTypeDefinitionProvider(Ue,$t(we),De)},registerHoverProvider(we,De){return dt.registerHoverProvider(Ue,$t(we),De,Ue.identifier)},registerEvaluatableExpressionProvider(we,De){return dt.registerEvaluatableExpressionProvider(Ue,$t(we),De,Ue.identifier)},registerInlineValuesProvider(we,De){return dt.registerInlineValuesProvider(Ue,$t(we),De,Ue.identifier)},registerDocumentHighlightProvider(we,De){return dt.registerDocumentHighlightProvider(Ue,$t(we),De)},registerLinkedEditingRangeProvider(we,De){return dt.registerLinkedEditingRangeProvider(Ue,$t(we),De)},registerReferenceProvider(we,De){return dt.registerReferenceProvider(Ue,$t(we),De)},registerRenameProvider(we,De){return dt.registerRenameProvider(Ue,$t(we),De)},registerDocumentSymbolProvider(we,De,je){return dt.registerDocumentSymbolProvider(Ue,$t(we),De,je)},registerWorkspaceSymbolProvider(we){return dt.registerWorkspaceSymbolProvider(Ue,we)},registerDocumentFormattingEditProvider(we,De){return dt.registerDocumentFormattingEditProvider(Ue,$t(we),De)},registerDocumentRangeFormattingEditProvider(we,De){return dt.registerDocumentRangeFormattingEditProvider(Ue,$t(we),De)},registerOnTypeFormattingEditProvider(we,De,je,...at){return dt.registerOnTypeFormattingEditProvider(Ue,$t(we),De,[je].concat(at))},registerDocumentSemanticTokensProvider(we,De,je){return dt.registerDocumentSemanticTokensProvider(Ue,$t(we),De,je)},registerDocumentRangeSemanticTokensProvider(we,De,je){return dt.registerDocumentRangeSemanticTokensProvider(Ue,$t(we),De,je)},registerSignatureHelpProvider(we,De,je,...at){return typeof je=="object"?dt.registerSignatureHelpProvider(Ue,$t(we),De,je):dt.registerSignatureHelpProvider(Ue,$t(we),De,typeof je>"u"?[]:[je,...at])},registerCompletionItemProvider(we,De,...je){return dt.registerCompletionItemProvider(Ue,$t(we),De,je)},registerInlineCompletionItemProvider(we,De,je){return De.handleDidShowCompletionItem&&(0,et.$QF)(Ue,"inlineCompletionsAdditions"),De.handleDidPartiallyAcceptCompletionItem&&(0,et.$QF)(Ue,"inlineCompletionsAdditions"),je&&(0,et.$QF)(Ue,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Ue,$t(we),De,je)},registerDocumentLinkProvider(we,De){return dt.registerDocumentLinkProvider(Ue,$t(we),De)},registerColorProvider(we,De){return dt.registerColorProvider(Ue,$t(we),De)},registerFoldingRangeProvider(we,De){return dt.registerFoldingRangeProvider(Ue,$t(we),De)},registerSelectionRangeProvider(we,De){return dt.registerSelectionRangeProvider(Ue,we,De)},registerCallHierarchyProvider(we,De){return dt.registerCallHierarchyProvider(Ue,we,De)},registerTypeHierarchyProvider(we,De){return dt.registerTypeHierarchyProvider(Ue,we,De)},setLanguageConfiguration:(we,De)=>dt.setLanguageConfiguration(Ue,we,De),getTokenInformationAtPosition(we,De){return(0,et.$QF)(Ue,"tokenInformation"),ci.tokenAtPosition(we,De)},registerInlayHintsProvider(we,De){return dt.registerInlayHintsProvider(Ue,we,De)},createLanguageStatusItem(we,De){return ci.createLanguageStatusItem(Ue,we,De)},registerDocumentDropEditProvider(we,De,je){return dt.registerDocumentOnDropEditProvider(Ue,we,De,(0,et.$PF)(Ue,"dropMetadata")?je:void 0)}},on={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(we,De,je){const at=await(b.URI.isUri(we)?Promise.resolve(an.openTextDocument(we)):Promise.resolve(we));return Mt.showTextDocument(at,De,je)},createTextEditorDecorationType(we){return Mt.createTextEditorDecorationType(Ue,we)},onDidChangeActiveTextEditor(we,De,je){return Mt.onDidChangeActiveTextEditor(we,De,je)},onDidChangeVisibleTextEditors(we,De,je){return Mt.onDidChangeVisibleTextEditors(we,De,je)},onDidChangeTextEditorSelection(we,De,je){return Mt.onDidChangeTextEditorSelection(we,De,je)},onDidChangeTextEditorOptions(we,De,je){return Mt.onDidChangeTextEditorOptions(we,De,je)},onDidChangeTextEditorVisibleRanges(we,De,je){return Mt.onDidChangeTextEditorVisibleRanges(we,De,je)},onDidChangeTextEditorViewColumn(we,De,je){return Mt.onDidChangeTextEditorViewColumn(we,De,je)},onDidCloseTerminal(we,De,je){return wt.onDidCloseTerminal(we,De,je)},onDidOpenTerminal(we,De,je){return wt.onDidOpenTerminal(we,De,je)},onDidChangeActiveTerminal(we,De,je){return wt.onDidChangeActiveTerminal(we,De,je)},onDidChangeTerminalDimensions(we,De,je){return(0,et.$QF)(Ue,"terminalDimensions"),wt.onDidChangeTerminalDimensions(we,De,je)},onDidChangeTerminalState(we,De,je){return wt.onDidChangeTerminalState(we,De,je)},onDidWriteTerminalData(we,De,je){return(0,et.$QF)(Ue,"terminalDataWriteEvent"),wt.onDidWriteTerminalData(we,De,je)},onDidExecuteTerminalCommand(we,De,je){return(0,et.$QF)(Ue,"terminalExecuteCommandEvent"),wt.onDidExecuteTerminalCommand(we,De,je)},get state(){return re.getState(Ue)},onDidChangeWindowState(we,De,je){return re.onDidChangeWindowState(we,De,je)},showInformationMessage(we,...De){return Ei.showMessage(Ue,w.default.Info,we,De[0],De.slice(1))},showWarningMessage(we,...De){return Ei.showMessage(Ue,w.default.Warning,we,De[0],De.slice(1))},showErrorMessage(we,...De){return Ei.showMessage(Ue,w.default.Error,we,De[0],De.slice(1))},showQuickPick(we,De,je){return ni.showQuickPick(Ue,we,De,je)},showWorkspaceFolderPick(we){return ni.showWorkspaceFolderPick(we)},showInputBox(we,De){return ni.showInput(we,De)},showOpenDialog(we){return Oi.showOpenDialog(Ue,we)},showSaveDialog(we){return Oi.showSaveDialog(we)},createStatusBarItem(we,De,je){let at,pt,Ft;return typeof we=="string"?(at=we,pt=De,Ft=je):(pt=we,Ft=De),xt.createStatusBarEntry(Ue,at,pt,Ft)},setStatusBarMessage(we,De){return xt.setStatusBarMessage(we,De)},withScmProgress(we){return Ie.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),wi.withProgress(Ue,{location:Ne.ProgressLocation.SourceControl},(De,je)=>we({report(at){}}))},withProgress(we,De){return wi.withProgress(Ue,we,De)},createOutputChannel(we,De){return ki.createOutputChannel(we,De,Ue)},createWebviewPanel(we,De,je,at){return Li.createWebviewPanel(Ue,we,De,je,at)},createWebviewTextEditorInset(we,De,je,at){return(0,et.$QF)(Ue,"editorInsets"),Ii.createWebviewEditorInset(we,De,je,at,Ue)},createTerminal(we,De,je){return typeof we=="object"?"pty"in we?wt.createExtensionTerminal(we):wt.createTerminalFromOptions(we):wt.createTerminal(we,De,je)},registerTerminalLinkProvider(we){return wt.registerLinkProvider(we)},registerTerminalProfileProvider(we,De){return wt.registerProfileProvider(Ue,we,De)},registerTerminalQuickFixProvider(we,De){return(0,et.$QF)(Ue,"terminalQuickFixProvider"),wt.registerTerminalQuickFixProvider(we,Ue.identifier.value,De)},registerTreeDataProvider(we,De){return bi.registerTreeDataProvider(we,De,Ue)},createTreeView(we,De){return bi.createTreeView(we,De,Ue)},registerWebviewPanelSerializer:(we,De)=>Li.registerWebviewPanelSerializer(Ue,we,De),registerCustomEditorProvider:(we,De,je={})=>ln.registerCustomEditorProvider(Ue,we,De,je),registerFileDecorationProvider(we){return Qe.registerFileDecorationProvider(we,Ue)},registerUriHandler(we){return mi.registerUriHandler(Ue,we)},createQuickPick(){return ni.createQuickPick(Ue)},createInputBox(){return ni.createInputBox(Ue)},get activeColorTheme(){return Ri.activeColorTheme},onDidChangeActiveColorTheme(we,De,je){return Ri.onDidChangeActiveColorTheme(we,De,je)},registerWebviewViewProvider(we,De,je){return Mi.registerWebviewViewProvider(Ue,we,De,je?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(we,De,je){return It.onDidChangeActiveNotebookEditor(we,De,je)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return It.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(we,De,je){return $i.onDidChangeNotebookEditorSelection(we,De,je)},onDidChangeNotebookEditorVisibleRanges(we,De,je){return $i.onDidChangeNotebookEditorVisibleRanges(we,De,je)},showNotebookDocument(we,De){return It.showNotebookDocument(we,De)},registerExternalUriOpener(we,De,je){return(0,et.$QF)(Ue,"externalUriOpener"),hn.registerExternalUriOpener(Ue.identifier,we,De,je)},registerProfileContentHandler(we,De){return(0,et.$QF)(Ue,"profileContentHandlers"),dn.registrProfileContentHandler(Ue,we,De)},registerQuickDiffProvider(we,De,je,at){return(0,et.$QF)(Ue,"quickDiffProvider"),Pi.registerQuickDiffProvider($t(we),De,je,at)},get tabGroups(){return Ve.tabGroups},registerShareProvider(we,De){return(0,et.$QF)(Ue,"shareProvider"),Gi.registerShareProvider($t(we),De)}},an={get rootPath(){return Ie.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(we){throw new T.$8("rootPath")},getWorkspaceFolder(we){return mt.getWorkspaceFolder(we)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(we){throw new T.$8("name")},get workspaceFile(){return mt.workspaceFile},set workspaceFile(we){throw new T.$8("workspaceFile")},updateWorkspaceFolders:(we,De,...je)=>mt.updateWorkspaceFolders(Ue,we,De||0,...je),onDidChangeWorkspaceFolders:function(we,De,je){return mt.onDidChangeWorkspace(we,De,je)},asRelativePath:(we,De)=>mt.getRelativePath(we,De),findFiles:(we,De,je,at)=>mt.findFiles(we,De,je,Ue.identifier,at),findTextInFiles:(we,De,je,at)=>{(0,et.$QF)(Ue,"findTextInFiles");let pt,Ft;return typeof De=="object"?(pt=De,Ft=je):(pt={},Ft=De,at=je),mt.findTextInFiles(we,pt||{},Ft,Ue.identifier,at)},save:we=>((0,et.$QF)(Ue,"saveEditor"),mt.save(we)),saveAs:we=>((0,et.$QF)(Ue,"saveEditor"),mt.saveAs(we)),saveAll:we=>mt.saveAll(we),applyEdit(we,De){return Zt.applyWorkspaceEdit(we,Ue,De)},createFileSystemWatcher:(we,De,je,at)=>{let pt;return typeof De=="boolean"?pt={ignoreCreateEvents:!!De,ignoreChangeEvents:!!je,ignoreDeleteEvents:!!at,correlate:!1}:De&&((0,et.$QF)(Ue,"createFileSystemWatcher"),pt={...De,correlate:!0}),Xt.createFileSystemWatcher(mt,Ue,we,pt)},get textDocuments(){return Pt.getAllDocumentData().map(we=>we.document)},set textDocuments(we){throw new T.$8("textDocuments")},openTextDocument(we){let De;const je=we;if(typeof we=="string")De=Promise.resolve(b.URI.file(we));else if(b.URI.isUri(we))De=Promise.resolve(we);else if(!je||typeof je=="object")De=Pt.createDocumentData(je);else throw new Error("illegal argument - uriOrFileNameOrOptions");return De.then(at=>Pt.ensureDocumentData(at).then(pt=>pt.document))},onDidOpenTextDocument:(we,De,je)=>Pt.onDidAddDocument(we,De,je),onDidCloseTextDocument:(we,De,je)=>Pt.onDidRemoveDocument(we,De,je),onDidChangeTextDocument:(we,De,je)=>Pt.onDidChangeDocument(we,De,je),onDidSaveTextDocument:(we,De,je)=>Pt.onDidSaveDocument(we,De,je),onWillSaveTextDocument:(we,De,je)=>Hi.getOnWillSaveTextDocumentEvent(Ue)(we,De,je),get notebookDocuments(){return It.notebookDocuments.map(we=>we.apiNotebook)},async openNotebookDocument(we,De){let je;if(b.URI.isUri(we))je=we,await It.openNotebookDocument(we);else if(typeof we=="string")je=b.URI.revive(await It.createNotebookDocument({viewType:we,content:De}));else throw new Error("Invalid arguments");return It.getNotebookDocument(je).apiNotebook},onDidSaveNotebookDocument(we,De,je){return ii.onDidSaveNotebookDocument(we,De,je)},onDidChangeNotebookDocument(we,De,je){return ii.onDidChangeNotebookDocument(we,De,je)},onWillSaveNotebookDocument(we,De,je){return Ci.getOnWillSaveNotebookDocumentEvent(Ue)(we,De,je)},get onDidOpenNotebookDocument(){return It.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return It.onDidCloseNotebookDocument},registerNotebookSerializer(we,De,je,at){return It.registerNotebookSerializer(Ue,we,De,je,(0,et.$PF)(Ue,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(we,De,je)=>_i.onDidChangeConfiguration(we,De,je),getConfiguration(we,De){return De=arguments.length===1?void 0:De,_i.getConfiguration(we,De,Ue)},registerTextDocumentContentProvider(we,De){return Si.registerTextDocumentContentProvider(we,De)},registerTaskProvider:(we,De)=>(Ie.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Ue,we,De)),registerFileSystemProvider(we,De,je){return(0,A.$Oc)(Ki.registerFileSystemProvider(Ue,we,De,je),Rt.addFileSystemProvider(we,De,je))},get fs(){return Rt.value},registerFileSearchProvider:(we,De)=>((0,et.$QF)(Ue,"fileSearchProvider"),Et.registerFileSearchProvider(we,De)),registerTextSearchProvider:(we,De)=>((0,et.$QF)(Ue,"textSearchProvider"),Et.registerTextSearchProvider(we,De)),registerRemoteAuthorityResolver:(we,De)=>((0,et.$QF)(Ue,"resolvers"),kt.registerRemoteAuthorityResolver(we,De)),registerResourceLabelFormatter:we=>((0,et.$QF)(Ue,"resolvers"),Ji.$registerResourceLabelFormatter(we)),getRemoteExecServer:we=>((0,et.$QF)(Ue,"resolvers"),kt.getRemoteExecServer(we)),onDidCreateFiles:(we,De,je)=>Xt.onDidCreateFile(we,De,je),onDidDeleteFiles:(we,De,je)=>Xt.onDidDeleteFile(we,De,je),onDidRenameFiles:(we,De,je)=>Xt.onDidRenameFile(we,De,je),onWillCreateFiles:(we,De,je)=>Xt.getOnWillCreateFileEvent(Ue)(we,De,je),onWillDeleteFiles:(we,De,je)=>Xt.getOnWillDeleteFileEvent(Ue)(we,De,je),onWillRenameFiles:(we,De,je)=>Xt.getOnWillRenameFileEvent(Ue)(we,De,je),openTunnel:we=>((0,et.$QF)(Ue,"tunnels"),Fe.openTunnel(Ue,we).then(De=>{if(!De)throw new Error("cannot open tunnel");return De})),get tunnels(){return(0,et.$QF)(Ue,"tunnels"),Fe.getTunnels()},onDidChangeTunnels:(we,De,je)=>((0,et.$QF)(Ue,"tunnels"),Fe.onDidChangeTunnels(we,De,je)),registerPortAttributesProvider:(we,De)=>((0,et.$QF)(Ue,"portsAttributes"),Fe.registerPortsAttributesProvider(we,De)),registerTunnelProvider:(we,De)=>((0,et.$QF)(Ue,"tunnelFactory"),Fe.registerTunnelProvider(we,De)),registerTimelineProvider:(we,De)=>((0,et.$QF)(Ue,"timeline"),Qi.registerTimelineProvider(we,De,Ue.identifier,ht.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:we=>((0,et.$QF)(Ue,"workspaceTrust"),mt.requestWorkspaceTrust(we)),onDidGrantWorkspaceTrust:(we,De,je)=>mt.onDidGrantWorkspaceTrust(we,De,je),registerEditSessionIdentityProvider:(we,De)=>((0,et.$QF)(Ue,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(we,De)),onWillCreateEditSessionIdentity:(we,De,je)=>((0,et.$QF)(Ue,"editSessionIdentityProvider"),mt.getOnWillCreateEditSessionIdentityEvent(Ue)(we,De,je)),registerCanonicalUriProvider:(we,De)=>((0,et.$QF)(Ue,"canonicalUriProvider"),mt.registerCanonicalUriProvider(we,De)),getCanonicalUri:(we,De,je)=>((0,et.$QF)(Ue,"canonicalUriProvider"),mt.provideCanonicalUri(we,De,je))},mn={get inputBox(){return Ie.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(Ue)},createSourceControl(we,De,je){return di.createSourceControl(Ue,we,De,je)},registerSourceControlInputBoxValueProvider(we){return(0,et.$QF)(Ue,"scmInputBoxValueProvider"),di.registerSourceControlInputBoxValueProvider(Ue,we)}},cn={createCommentController(we,De){return Ai.createCommentController(Ue,we,De)}},un={get activeDebugSession(){return bt.activeDebugSession},get activeDebugConsole(){return bt.activeDebugConsole},get breakpoints(){return bt.breakpoints},get stackFrameFocus(){return bt.stackFrameFocus},onDidStartDebugSession(we,De,je){return bt.onDidStartDebugSession(we,De,je)},onDidTerminateDebugSession(we,De,je){return bt.onDidTerminateDebugSession(we,De,je)},onDidChangeActiveDebugSession(we,De,je){return bt.onDidChangeActiveDebugSession(we,De,je)},onDidReceiveDebugSessionCustomEvent(we,De,je){return bt.onDidReceiveDebugSessionCustomEvent(we,De,je)},onDidChangeBreakpoints(we,De,je){return bt.onDidChangeBreakpoints(we,De,je)},onDidChangeStackFrameFocus(we,De,je){return(0,et.$QF)(Ue,"debugFocus"),bt.onDidChangeStackFrameFocus(we,De,je)},registerDebugConfigurationProvider(we,De,je){return bt.registerDebugConfigurationProvider(we,De,je||Dt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(we,De){return bt.registerDebugAdapterDescriptorFactory(Ue,we,De)},registerDebugAdapterTrackerFactory(we,De){return bt.registerDebugAdapterTrackerFactory(we,De)},startDebugging(we,De,je){return!je||typeof je=="object"&&"configuration"in je?bt.startDebugging(we,De,{parentSession:je}):bt.startDebugging(we,De,je||{})},stopDebugging(we){return bt.stopDebugging(we)},addBreakpoints(we){return bt.addBreakpoints(we)},removeBreakpoints(we){return bt.removeBreakpoints(we)},asDebugSourceUri(we,De){return bt.asDebugSourceUri(we,De)}},Ni={registerTaskProvider:(we,De)=>yt.registerTaskProvider(Ue,we,De),fetchTasks:we=>yt.fetchTasks(we),executeTask:we=>yt.executeTask(Ue,we),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(we,De,je)=>yt.onDidStartTask(we,De,je),onDidEndTask:(we,De,je)=>yt.onDidEndTask(we,De,je),onDidStartTaskProcess:(we,De,je)=>yt.onDidStartTaskProcess(we,De,je),onDidEndTaskProcess:(we,De,je)=>yt.onDidEndTaskProcess(we,De,je)},ji={createNotebookController(we,De,je,at,pt){return oi.createNotebookController(Ue,we,De,je,at,(0,et.$PF)(Ue,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(we,De)=>It.registerNotebookCellStatusBarItemProvider(Ue,we,De),createRendererMessaging(we){return Di.createRendererMessaging(Ue,we)},createNotebookControllerDetectionTask(we){return(0,et.$QF)(Ue,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Ue,we)},registerKernelSourceActionProvider(we,De){return(0,et.$QF)(Ue,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Ue,we,De)},onDidChangeNotebookCellExecutionState(we,De,je){return(0,et.$QF)(Ue,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(we,De,je)}},zi={t(...we){if(typeof we[0]=="string"){const De=we.shift(),je=!we||typeof we[0]!="object"?we:we[0];return Vt.getMessage(Ue.identifier.value,{message:De,args:je})}return Vt.getMessage(Ue.identifier.value,we[0])},get bundle(){return Vt.getBundle(Ue.identifier.value)},get uri(){return Vt.getBundleUri(Ue.identifier.value)}},hi={_version:1,registerInteractiveEditorSessionProvider(we,De){return(0,et.$QF)(Ue,"interactive"),Zi.registerProvider(Ue,we,De)},registerInteractiveSessionProvider(we,De){return(0,et.$QF)(Ue,"interactive"),gi.registerChatProvider(Ue,we,De)},sendInteractiveRequestToProvider(we,De){return(0,et.$QF)(Ue,"interactive"),gi.sendInteractiveRequestToProvider(we,De)},get onDidPerformUserAction(){return(0,et.$QF)(Ue,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(we,De){return(0,et.$QF)(Ue,"interactive"),gi.transferChatSession(we,De)}},Ui={getRelatedInformation(we,De){return(0,et.$QF)(Ue,"aiRelatedInformation"),xi.getRelatedInformation(Ue,we,De)},registerRelatedInformationProvider(we,De){return(0,et.$QF)(Ue,"aiRelatedInformation"),xi.registerRelatedInformationProvider(Ue,we,De)},registerEmbeddingVectorProvider(we,De){return(0,et.$QF)(Ue,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(Ue,we,De)}},Bi={registerChatResponseProvider(we,De,je){return(0,et.$QF)(Ue,"chatProvider"),fi.registerProvider(Ue.identifier,we,De,je)},requestChatAccess(we){return(0,et.$QF)(Ue,"chatRequestAccess"),fi.requestChatResponseProvider(Ue.identifier,we)},registerVariable(we,De,je){return(0,et.$QF)(Ue,"chatVariables"),Xi.registerVariableResolver(Ue,we,De,je)},registerMappedEditsProvider(we,De){return(0,et.$QF)(Ue,"mappedEditsProvider"),dt.registerMappedEditsProvider(Ue,we,De)},createChatAgent(we,De){return(0,et.$QF)(Ue,"chatAgents2"),Yi.createChatAgent(Ue,we,De)}},Wi={registerSpeechProvider(we,De){return(0,et.$QF)(Ue,"speech"),vi.registerProvider(Ue.identifier,we,De)}};return{version:gt.version,ai:Ui,authentication:en,commands:gn,comments:cn,chat:Bi,debug:un,env:tn,extensions:rn,interactive:hi,l10n:zi,languages:sn,notebooks:ji,scm:mn,speech:Wi,tasks:Ni,tests:nn,window:on,workspace:an,Breakpoint:Ne.$CL,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$tM,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,CallHierarchyIncomingCall:Ne.$2K,CallHierarchyItem:Ne.$1K,CallHierarchyOutgoingCall:Ne.$3K,CancellationError:T.$4,CancellationTokenSource:D.$2d,CandidatePortSource:n.CandidatePortSource,CodeAction:Ne.$XK,CodeActionKind:Ne.$YK,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$4K,Color:Ne.$eL,ColorInformation:Ne.$fL,ColorPresentation:Ne.$gL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$$K,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$_K,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$oL,DebugAdapterExecutable:Ne.$GL,DebugAdapterInlineImplementation:Ne.$JL,DebugAdapterNamedPipeServer:Ne.$IL,DebugAdapterServer:Ne.$HL,DebugConfigurationProviderTriggerKind:Dt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$SK,DiagnosticRelatedInformation:Ne.$RK,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$EK,DocumentHighlight:Ne.$UK,DocumentHighlightKind:Ne.DocumentHighlightKind,DocumentLink:Ne.$dL,DocumentSymbol:Ne.$WK,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$ML,InlineValueText:Ne.$NL,InlineValueVariableLookup:Ne.$OL,InlineValueEvaluatableExpression:Ne.$PL,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:m.$Rd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$ZL,FileDecoration2:Ne.$ZL,FileSystemError:Ne.$RL,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Ne.$SL,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$EL,InlineCompletionItem:Ne.$aL,InlineCompletionList:Ne.$bL,Hover:Ne.$TK,IndentAction:P.IndentAction,Location:Ne.$QK,MarkdownString:Ne.$5K,OverviewRulerLane:$.OverviewRulerLane,ParameterInformation:Ne.$6K,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$FK,ProcessExecution:Ne.$mL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$YL,Range:Ne.$GK,RelativePattern:Ne.$AL,Selection:Ne.$HK,SelectionRange:Ne.$ZK,SemanticTokens:Ne.$VL,SemanticTokensBuilder:Ne.$UL,SemanticTokensEdit:Ne.$WL,SemanticTokensEdits:Ne.$XL,SemanticTokensLegend:Ne.$TL,ShellExecution:Ne.$nL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$8K,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$7K,SnippetString:Ne.$PK,SourceBreakpoint:Ne.$DL,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$VK,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$pL,TaskGroup:Ne.$lL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$hL,TerminalQuickFixTerminalCommand:Ne.$jL,TerminalQuickFixOpener:Ne.$iL,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$kL,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$LK,SnippetTextEdit:Ne.$NK,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$zL,ThemeIcon:Ne.$yL,TreeItem:Ne.$qL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$iM,UIKind:Tt.UIKind,Uri:b.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$OK,DocumentDropEdit:Ne.$wL,DocumentPasteEdit:Ne.$xL,InlayHint:Ne.$0K,InlayHintLabelPart:Ne.$9K,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$KK,ResolvedAuthority:Ne.$IK,ManagedResolvedAuthority:Ne.$JK,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$0L,NotebookRange:Ne.$2L,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$3L,NotebookData:Ne.$4L,NotebookRendererScript:Ne.$8L,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$6L,NotebookCellOutputItem:Ne.$5L,NotebookCellStatusBarItem:Ne.$7L,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$MK,NotebookKernelSourceAction:Ne.$9L,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$_L,LinkedEditingRanges:Ne.$$L,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$aM,TestMessage:Ne.$bM,TestMessage2:Ne.$bM,TestTag:Ne.$cM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Jt.TextSearchCompleteMessageType,DataTransfer:Ne.$vL,DataTransferItem:Ne.$rL,CoveredCount:Ne.$dM,FileCoverage:Ne.$eM,StatementCoverage:Ne.$fM,BranchCoverage:Ne.$gM,FunctionCoverage:Ne.$hM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$jM,TabInputTextDiff:Ne.$kM,TabInputTextMerge:Ne.$lM,TabInputCustom:Ne.$mM,TabInputNotebook:Ne.$oM,TabInputNotebookDiff:Ne.$pM,TabInputWebview:Ne.$nM,TabInputTerminal:Ne.$qM,TabInputInteractiveWindow:Ne.$rM,TabInputChat:Ne.$sM,TelemetryTrustedValue:o.$to,LogLevel:g.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Ne.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$KL,ThreadFocus:Ne.$LL,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$qgc=Wt}),define(ke[369],Se([1,0,106,153,41,150,42,35,69,47,95,96,97,118,72,91,152,71,57,117,90,70,151,14,58,115,116]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s,a,t,r,h,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Gr)(u.$ffc,u.$efc,1),(0,D.$Gr)(r.$ij,t.$rgc,1),(0,D.$Gr)(g.$qec,g.$rec,1),(0,D.$Gr)(w.$1M,w.$ZM,0),(0,D.$Gr)(R.$Lec,R.$Jec,0),(0,D.$Gr)(o.$Nec,o.$Mec,0),(0,D.$Gr)(P.$pfc,P.$tfc,0),(0,D.$Gr)(A.$vfc,A.$ufc,0),(0,D.$Gr)(b.$PM,b.$OM,0),(0,D.$Gr)(c.$gfc,c.$hfc,0),(0,D.$Gr)(i.$nec,i.$mec,0),(0,D.$Gr)(T.$2fc,T.$1fc,1),(0,D.$Gr)($.$Lfc,$.$Mfc,0),(0,D.$Gr)(v.$7ec,v.$6ec,0),(0,D.$Gr)(L.$cgc,L.$bgc,0),(0,D.$Gr)(y.$0ec,y.$afc,0),(0,D.$Gr)(S.$Exb,S.$Fxb,0),(0,D.$Gr)(d.$pgc,d.$ogc,0),(0,D.$Gr)(m.$Iec,m.$Hec,0),(0,D.$Gr)(n.$cfc,n.$bfc,0),(0,D.$Gr)(s.$YM,s.$VM,0),(0,D.$Gr)(a.$Xec,a.$Yec,0),(0,D.$Gr)(h.$nfc,h.$ofc,0)}),define(ke[119],Se([1,0,19,14,36,94]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=e.$Igc=e.$Hgc=void 0;function R(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.$Hgc=R;function w(P,$,v,S){const g=(0,D.$1b)(v,b),d=new m.$6I($,g,S),o=d.preview.matches;return{ranges:(0,D.$1b)(g,y),uri:P,preview:{text:d.preview.text,matches:(0,D.$1b)(o,y)}}}e.$Igc=w;function b(P){return new m.$7I(P.start.line,P.start.character,P.end.line,P.end.character)}function y(P){return new A.$UI(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let L=class{constructor($,v){this.a=$,this.b=v}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$Jgc=L,e.$Jgc=L=Ke([Be(1,T.$hj)],L)}),define(ke[370],Se([1,0,50,16,76,33,11,13,119,371]),function(be,e,D,T,m,A,R,w,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=e.$Lgc=e.$Kgc=void 0;const L=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(n,s,a,t){const r=$(n,s,a,t),h=s.folder.fsPath;return{cmd:D.spawn(L,r.args,{cwd:h}),rgDiskPath:L,siblingClauses:r.siblingClauses,rgArgs:r,cwd:h}}e.$Kgc=P;function $(n,s,a,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];S([s],a,!1).forEach(u=>{const c=(0,b.$Hgc)(u);if(r.push("-g",c),R.$j){const l=(0,m.$zl)(c);l!==c&&r.push("-g",l)}});const h=v([s],t,void 0,!1);return h.globArgs.forEach(u=>{const c=`!${(0,b.$Hgc)(u)}`;if(r.push("-g",c),R.$j){const l=(0,m.$zl)(c);l!==c&&r.push("-g",l)}}),s.disregardIgnoreFiles!==!1?r.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),s.ignoreSymlinks||r.push("--follow"),n.exists&&r.push("--quiet"),r.push("--no-config"),s.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:h.siblingClauses}}function v(n,s,a,t=!0){const r=[];let h={};return n.forEach(u=>{const c=Object.assign({},u.excludePattern||{},s||{}),l=g(c,t?u.folder.fsPath:void 0,a);r.push(...l.globArgs),l.siblingClauses&&(h=Object.assign(h,l.siblingClauses))}),{globArgs:r,siblingClauses:h}}function S(n,s,a=!0){const t=[];return n.forEach(r=>{const h=Object.assign({},s||{},r.includePattern||{}),u=g(h,a?r.folder.fsPath:void 0);t.push(...u.globArgs)}),t}function g(n,s,a){const t=[],r={};return Object.keys(n).forEach(h=>{if(a&&a.has(h)||!h)return;const u=n[h];h=o(s?d(s,h):h),h.startsWith("\\\\")?h="\\\\"+h.substr(2).replace(/\\/g,"/"):h=h.replace(/\\/g,"/"),typeof u=="boolean"&&u?(h.startsWith("\\\\")&&(h+="**"),t.push(i(h))):u&&u.when&&(r[h]=u)}),{globArgs:t,siblingClauses:r}}function d(n,s){return T.$hc(s)?s:T.$ic(n,s)}e.$Lgc=d;function o(n){return n=w.$Oe(n,"\\"),w.$Oe(n,"/")}function i(n){return A.$Xf(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$Mgc=i}),define(ke[372],Se([1,0,50,55,16,373,19,44,34,76,33,11,38,13,18,31,36,370,130]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(h=>h())});class s{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&b.$Gj(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Iq)(this.b).normalizedLowercase),this.u=u.excludePattern&&b.$Gj(u.excludePattern),this.t=new Map,u.folderQueries.forEach(c=>{const l=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),E=c.folder.fsPath;u.folderQueries.map(C=>C.folder.fsPath).filter(C=>C!==E).forEach(C=>{(0,L.$2f)(C,E)&&(l[m.$kc(E,C)]=!0)}),this.t.set(E,new t(l,E))})}cancel(){this.l=!0,n.forEach(u=>u())}walk(u,c,l,E,C){if(this.m=$.$Nd.create(!1),this.l)return C(null,this.j);c.forEach(f=>{const p=m.$mc(f.fsPath);this.u&&this.u(f.fsPath,p)||this.J(l,{relativePath:f.fsPath,searchPath:void 0})}),this.r=$.$Nd.create(!1),this.w(u,(f,p)=>{this.x(this.y,this,f,l,E,k=>{if(k){const I=(0,w.$Ki)(k);console.error(I),this.q.push(I),p(k,void 0)}else p(null,void 0)})},(f,p)=>{this.m.stop();const k=f?R.$Gb(f)[0]:null;C(k,this.j)})}w(u,c,l){const E=new Array(u.length),C=new Array(u.length);let f=!1,p=0;if(u.length===0)return l(null,[]);u.forEach((k,I)=>{c(k,(j,z)=>{if(j?(f=!0,E[I]=null,C[I]=j):(E[I]=z,C[I]=null),++p===u.length)return l(f?C:null,E)})})}x(u,c,...l){try{u.apply(c,l)}catch(E){l[l.length-1](E)}}y(u,c,l,E){const C=u.folder.fsPath,f=P.$j,p=()=>M&&M.kill();n.add(p);let k=W=>{n.delete(p),k=()=>{},E(W)},I="";const j=this.D(),z=(0,o.$Kgc)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),M=z.cmd,F=!Object.keys(z.siblingClauses).length,N=z.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let O=`${z.rgDiskPath} ${N}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),l({message:O}),this.s=0,this.z(M,"utf8",l,(W,x,ue)=>{if(W){k(W);return}if(this.j){k();return}const J=(I+(f?y.$yl(x||""):x)).split(`
`);if(ue){const Q=J.length;J[Q-1]=J[Q-1].trim(),J[Q-1]||J.pop()}else I=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.s+=J.length,F){for(const Q of J)if(this.J(c,{base:C,relativePath:Q,searchPath:this.N(u,Q)}),this.j){p();break}(ue||this.j)&&k();return}this.G(u,j,C,J,c),ue&&(this.H(j,C,c),k())})}spawnFindCmd(u){const c=this.t.get(u.folder.fsPath),l=c.getBasenameTerms(),E=c.getPathTerms(),C=["-L","."];if(l.length||E.length){C.push("-not","(","(");for(const f of l)C.push("-name",f),C.push("-o");for(const f of E)C.push("-path",f),C.push("-o");C.pop(),C.push(")","-prune",")")}return C.push("-type","f"),D.spawn("find",C,{cwd:u.folder.fsPath})}readStdout(u,c,l){let E="";this.z(u,c,()=>{},(C,f,p)=>{if(C){l(C);return}E+=f,p&&l(null,E)})}z(u,c,l,E){let C=(k,I,j)=>{(k||j)&&(C=()=>{},this.r?.stop()),E(k,I,j)},f=!1;u.stdout?(this.A(u.stdout,c,C),u.stdout.once("data",()=>f=!0)):l({message:"stdout is null"});let p;u.stderr?p=this.B(u.stderr):l({message:"stderr is null"}),u.on("error",k=>{C(k)}),u.on("close",k=>{let I;!f&&(I=this.C(p,c))&&r(I)?C(new Error(`command failed with error code ${k}: ${this.C(p,c)}`)):(this.g&&k===0&&(this.j=!0),C(null,"",!0))})}A(u,c,l){const E=new A.StringDecoder(c);return u.on("data",C=>{l(null,E.write(C))}),E}B(u){const c=[];return u.on("data",l=>{c.push(l)}),c}C(u,c){const l=new A.StringDecoder(c);return u.map(E=>l.write(E)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:c},l,E,C){E.indexOf(this.b)!==-1&&this.J(C,{base:l,relativePath:this.b,searchPath:this.N(u,this.b)});const f=p=>{const k=m.$mc(p),I=m.$lc(p);let j=c[I];j||(j=c[I]=[],f(I)),j.push({base:l,relativePath:p,basename:k,searchPath:this.N(u,p)})};E.forEach(f)}H({rootEntries:u,pathToEntries:c},l,E){const C=this,f=this.t.get(l),p=this.b;function k(I){C.o++;const j=(0,d.$jJ)(()=>I.map(z=>z.basename));for(let z=0,M=I.length;z<M;z++){const F=I[z],{relativePath:N,basename:O}=F;if(f.test(N,O,p!==O?j:void 0))continue;const W=c[N];if(W)k(W);else{if(C.p++,N===p)continue;C.J(E,F)}if(C.j)break}}k(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,c,l,E,C){const f=u.folder,p=(0,d.$jJ)(()=>l);this.w(l,(k,I)=>{if(this.l||this.j)return I(null);const j=c?[c,k].join(m.sep):k;if(this.t.get(u.folder.fsPath).test(j,k,this.a.filePattern!==k?p:void 0))return I(null);const z=[f.fsPath,j].join(m.sep);T.lstat(z,(M,F)=>{if(M||this.l||this.j)return I(null);this.L(z,F,(N,O)=>N||this.l||this.j?I(null):O.isDirectory()?(this.o++,this.M(z,F,(W,x)=>W||this.l||this.j||(x=x||"",this.v[x])?I(null):(this.v[x]=!0,g.Promises.readdir(z).then(ue=>{if(this.l||this.j)return I(null);this.I(u,j,ue,E,X=>I(X||null))},ue=>{I(null)})))):(this.p++,j===this.b||this.h&&S.$Gf(O.size)&&O.size>this.h||this.J(E,{base:f.fsPath,relativePath:j,searchPath:this.N(u,j)}),I(null,void 0)))})},k=>{const I=k&&R.$Gb(k);return C(I&&I.length>0?I[0]:void 0)})}J(u,c){this.K(c)&&(!this.d||this.d(c.relativePath,m.$mc(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(c))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.$eJ)(u,this.c)}return!0}L(u,c,l){return c.isSymbolicLink()?T.stat(u,l):l(null,c)}M(u,c,l){return c.isSymbolicLink()?T.realpath(u,(E,C)=>E?l(E):l(null,C)):l(null,u)}N(u,c){return u.folderName?m.$ic(u.folderName,c):c}}e.$Ngc=s;class a{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new s(u)}search(u,c,l){this.c.walk(this.a,this.b,u,c,(E,C)=>{l(E,{limitHit:C,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Ogc=a;class t{constructor(u,c){this.expression=u,this.c=c,this.d(u)}d(u){let c,l;Object.keys(u).filter(E=>u[E]).forEach(E=>{m.$hc(E)?(c=c||b.$Bj(),c[E]=u[E]):(l=l||b.$Bj(),l[E]=u[E])}),this.a=c&&b.$Gj(c,{trimForExclusions:!0}),this.b=l&&b.$Gj(l,{trimForExclusions:!0})}test(u,c,l){return this.b&&this.b(u,c,l)||this.a&&this.a(m.$ic(this.c,u),c,l)}getBasenameTerms(){const u=[];return this.a&&u.push(...b.$Ij(this.a)),this.b&&u.push(...b.$Ij(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...b.$Jj(this.a)),this.b&&u.push(...b.$Jj(this.b)),u}}function r(h){const u=h.trim().split(`
`),c=u[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return v.$uf(u[u.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(ke[374],Se([1,0,98,22,185,21]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0C=e.$9C=e.$8C=e.$7C=e.$6C=e.$5C=e.$4C=e.$3C=e.$2C=e.DecodeStreamErrorKind=e.$1C=e.$ZC=e.$YC=e.$XC=e.$WC=e.$VC=e.$UC=e.$TC=void 0,e.$TC="utf8",e.$UC="utf8bom",e.$VC="utf16be",e.$WC="utf16le";function R(c){return[e.$TC,e.$UC,e.$VC,e.$WC].some(l=>l===c)}e.$XC=R,e.$YC=[254,255],e.$ZC=[255,254],e.$1C=[239,187,191];const w=512,b=512,y=512*8,L=512*128;var P;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class $ extends Error{constructor(l,E){super(l),this.decodeStreamErrorKind=E}}e.$2C=$;class v{static async create(l){let E;if(l!==e.$TC)E=(await(0,m.$SC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(l));else{const C=new TextDecoder;E={write(f){return C.decode(f,{stream:!0})},end(){return C.decode()}}}return new v(E)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function S(c,l){const E=l.minBytesRequiredForDetection??l.guessEncoding?y:b;return new Promise((C,f)=>{const p=(0,D.$6d)(F=>F.join("")),k=[];let I=0,j;const z=new A.$2d,M=async()=>{try{const F=await u({buffer:T.$fe.concat(k),bytesRead:I},l.guessEncoding);if(F.seemsBinary&&l.acceptTextOnly)throw new $("Stream is binary but only text is accepted for decoding",1);F.encoding=await l.overwriteEncoding(F.encoding),j=await v.create(F.encoding);const N=j.write(T.$fe.concat(k).buffer);p.write(N),k.length=0,I=0,C({stream:p,detected:F})}catch(F){z.cancel(),p.destroy(),f(F)}};(0,D.$0d)(c,{onData:async F=>{j?p.write(j.write(F.buffer)):(k.push(F),I+=F.byteLength,I>=E&&(c.pause(),await M(),setTimeout(()=>c.resume())))},onError:F=>p.error(F),onEnd:async()=>{j||await M(),p.end(j?.end())}},z.token)})}e.$3C=S;async function g(c,l,E){const f=(await(0,m.$SC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(l),E);let p=!1,k=!1;return{read(){if(k)return null;const I=c.read();if(typeof I!="string"){if(k=!0,!p&&E?.addBOM)switch(l){case e.$TC:case e.$UC:return T.$fe.wrap(Uint8Array.from(e.$1C));case e.$VC:return T.$fe.wrap(Uint8Array.from(e.$YC));case e.$WC:return T.$fe.wrap(Uint8Array.from(e.$ZC))}const j=f.end();return j&&j.length>0?(p=!0,T.$fe.wrap(j)):null}return p=!0,T.$fe.wrap(f.write(I))}}}e.$4C=g;async function d(c){return(await(0,m.$SC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(c))}e.$5C=d;function o(c){return c===e.$UC||c===null?e.$TC:c}e.$6C=o;function i(c,l){if(!c||l<e.$YC.length)return null;const E=c.readUInt8(0),C=c.readUInt8(1);if(E===e.$YC[0]&&C===e.$YC[1])return e.$VC;if(E===e.$ZC[0]&&C===e.$ZC[1])return e.$WC;if(l<e.$1C.length)return null;const f=c.readUInt8(2);return E===e.$1C[0]&&C===e.$1C[1]&&f===e.$1C[2]?e.$UC:null}e.$7C=i;const n=["ascii","utf-16","utf-32"];async function s(c){const l=await(0,m.$SC)("jschardet","dist/jschardet.min.js"),E=c.slice(0,L),C=r(E.buffer),f=l.detect(C);if(!f||!f.encoding)return null;const p=f.encoding.toLowerCase();return 0<=n.indexOf(p)?null:t(f.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(c){const l=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[l]||l}function r(c){let l="";for(let E=0;E<c.length;E++)l+=String.fromCharCode(c[E]);return l}function h(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=c.match(/windows(\d+)/);return l?"windows-"+l[1]:c}}}e.$8C=h;function u({buffer:c,bytesRead:l},E){let C=i(c,l),f=!1;if(C!==e.$VC&&C!==e.$WC&&c){let p=!0,k=!0,I=!1;for(let j=0;j<l&&j<w;j++){const z=j%2===1,M=c.readUInt8(j)===0;if(M&&(I=!0),p&&(z&&!M||!z&&M)&&(p=!1),k&&(z&&M||!z&&!M)&&(k=!1),M&&!p&&!k)break}I&&(p?C=e.$WC:k?C=e.$VC:f=!0)}return E&&!f&&!C&&c?s(c.slice(0,l)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:f,encoding:C}}e.$9C=u,e.$0C={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[156],Se([1,0,374,31,155]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class A extends m.$Hfc{constructor(w,b,y=T,L="searchProcess"){super(w,b,{readdir:P=>y.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,D.$8C)(P)},L)}}e.$Wgc=A}),define(ke[157],Se([1,0,50,390,373,19,73,34,16,13,2,36,94,391,371,119]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=e.$Qgc=e.$Pgc=void 0;const d=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class o{constructor(k){this.a=k}provideTextSearchResults(k,I,j,z){return this.a.appendLine(`provideTextSearchResults ${k.pattern}, ${JSON.stringify({...I,folder:I.folder.toString()})}`),new Promise((M,F)=>{z.onCancellationRequested(()=>Q());const N=r(k,I),O=I.folder.fsPath,W=N.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");this.a.appendLine(`${d} ${W}
 - cwd: ${O}`);let x=D.spawn(d,N,{cwd:O});x.on("error",H=>{console.error(H),this.a.appendLine("Error: "+(H&&H.message)),F((0,P.$aJ)(new P.$$I(H&&H.message,P.SearchErrorCode.rgProcessError)))});let ue=!1;const X=new s(I.maxResults,O,I.previewOptions);X.on("result",H=>{ue=!0,Z="",j.report(H)});let J=!1;const Q=()=>{J=!0,x?.kill(),X?.cancel()};let he=!1;X.on("hitLimit",()=>{he=!0,Q()});let Z="";x.stdout.on("data",H=>{X.handleData(H),ue||(Z+=H)});let ye=!1;x.stdout.once("data",()=>ye=!0);let de="";x.stderr.on("data",H=>{const U=H.toString();this.a.appendLine(U),de.length+U.length<1e6&&(de+=U)}),x.on("close",()=>{if(this.a.appendLine(ye?"Got data from stdout":"No data from stdout"),this.a.appendLine(ue?"Got result from parser":"No result from parser"),Z&&this.a.appendLine(`Got data without result: ${Z}`),this.a.appendLine(""),J)M({limitHit:he});else{X.flush(),x=null;let H;de&&!ye&&(H=i(de))?F((0,P.$aJ)(new P.$$I(H.message,H.code))):M({limitHit:he})}})})}}e.$Pgc=o;function i(p){const k=p.split(`
`),I=k[0].trim();if(k.some(z=>z.startsWith("regex parse error")))return new P.$$I(n(k),P.SearchErrorCode.regexParseError);const j=I.match(/grep config error: unknown encoding: (.*)/);if(j)return new P.$$I(`Unknown encoding: ${j[1]}`,P.SearchErrorCode.unknownEncoding);if(I.startsWith("error parsing glob"))return new P.$$I(I.charAt(0).toUpperCase()+I.substr(1),P.SearchErrorCode.globParseError);if(I.startsWith("the literal"))return new P.$$I(I.charAt(0).toUpperCase()+I.substr(1),P.SearchErrorCode.invalidLiteral);if(I.startsWith("PCRE2: error compiling pattern"))return new P.$$I(I,P.SearchErrorCode.regexParseError)}function n(p){const k=["Regex parse error"],I=p.filter(j=>j.startsWith("PCRE2:"));if(I.length>=1){const j=I[0].replace("PCRE2:","");if(j.indexOf(":")!==-1&&j.split(":").length>=2){const z=j.split(":")[1];k.push(":"+z)}}return k.join("")}class s extends T.EventEmitter{constructor(k,I,j){super(),this.g=k,this.h=I,this.j=j,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new m.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(k,I){return super.on(k,I),this}handleData(k){if(this.b)return;const I=typeof k=="string"?k:this.d.write(k);this.k(I)}k(k){let I=k.indexOf(`
`);const j=this.a+k;if(I>=0)I+=this.a.length;else{this.a=j;return}let z=0;for(;I>=0;)this.m(j.substring(z,I).trim()),z=I+1,I=j.indexOf(`
`,z);this.a=j.substring(z)}m(k){if(this.b||!k)return;let I;try{I=JSON.parse(k)}catch{throw new Error(`malformed line from rg: ${k}`)}if(I.type==="match"){const j=a(I.data.path),z=L.URI.file(b.$ic(this.h,j)),M=this.n(I.data,z);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(I.type==="context"){const j=a(I.data.path),z=L.URI.file(b.$ic(this.h,j));this.o(I.data,z).forEach(F=>this.p(F))}}n(k,I){const j=k.line_number-1,z=a(k.lines),M=Buffer.from(z);let F=0,N=0,O=j;k.submatches.length===0&&k.submatches.push(z.length?{start:0,end:1,match:{text:z[0]}}:{start:0,end:0,match:{text:""}});const W=(0,A.$Gb)(k.submatches.map((x,ue)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const X=a(x.match),J=M.slice(F,x.start).toString(),Q=t(J),he=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+N,Z=t(X),ye=Q.numLines+O,de=Z.numLines+ye,H=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+he;return F=x.end,N=H,O=de,new $.$UI(ye,he,de,H)}));return(0,g.$Igc)(I,z,W,this.j)}o(k,I){const j=a(k.lines),z=k.line_number;return j.replace(/\r?\n$/,"").split(`
`).map((M,F)=>({text:M,uri:I,lineNumber:z+F}))}p(k){this.emit("result",k)}}e.$Qgc=s;function a(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function t(p){const k=/\n/g;let I=0,j=-1,z;for(;z=k.exec(p);)I++,j=z.index;const M=j>=0?p.length-j-1:p.length;return{numLines:I,lastLineLength:M}}function r(p,k){const I=["--hidden","--no-require-git"];I.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:j,otherIncludes:z}=(0,R.$J)(k.includes,F=>F.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(z&&z.length){const F=new Set;z.forEach(N=>{F.add(N)}),I.push("-g","!*"),F.forEach(N=>{h(N).map(g.$Hgc).forEach(O=>{I.push("-g",O)})})}j&&j.length&&j.forEach(F=>{I.push("-g",F)}),k.excludes.map(g.$Hgc).forEach(F=>I.push("-g",`!${F}`)),k.maxFileSize&&I.push("--max-filesize",k.maxFileSize+""),k.useIgnoreFiles?k.useParentIgnoreFiles||I.push("--no-ignore-parent"):I.push("--no-ignore"),k.followSymlinks&&I.push("--follow"),k.encoding&&k.encoding!=="utf8"&&I.push("--encoding",k.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,y.$Je)(p.pattern),p.isRegExp=!0),k.usePCRE2&&I.push("--pcre2"),I.push("--crlf"),p.isRegExp&&(p.pattern=u(p.pattern),I.push("--engine","auto"));let M;if(p.isWordMatch){const N=(0,y.$Re)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");I.push("--regexp",N)}else if(p.isRegExp){let F=l(p.pattern);F=E(F),I.push("--regexp",F)}else M=p.pattern,I.push("--fixed-strings");return I.push("--no-config"),k.useGlobalIgnoreFiles||I.push("--no-ignore-global"),I.push("--json"),p.isMultiline&&I.push("--multiline"),k.beforeContext&&I.push("--before-context",k.beforeContext+""),k.afterContext&&I.push("--after-context",k.afterContext+""),I.push("--"),M&&I.push(M),I.push("."),I}e.$Rgc=r;function h(p){return f(p).flatMap(I=>{const j=(0,w.$Ej)(I,"/");return j.map((z,M)=>j.slice(0,M+1).join("/"))})}function u(p){const k=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(k);)p=p.replace(k,"$1\\x{$2}");const I=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(I);)p=p.replace(I,"$1\\x{$2}");return p}e.$Sgc=u;const c=p=>p.type==="Assertion"&&p.kind==="lookbehind";function l(p){let k;try{k=new v.RegExpParser().parsePattern(p)}catch{return p}let I="",j=0;const z=(N,O,W)=>{I+=p.slice(j,N)+W,j=O},M=[];return new v.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const O=M[0];if(!O)z(N.start,N.end,"\\r?\\n");else if(!M.some(c))if(O.type==="CharacterClass")if(O.negate){const W=p.slice(O.start+2,N.start)+p.slice(N.end,O.end-1);O.parent?.type==="Quantifier"?z(O.start,O.end,W?`[^${W}]`:"."):z(O.start,O.end,"(?!\\r?\\n"+(W?`|[${W}]`:"")+")")}else{const W=p.slice(O.start+1,N.start)+p.slice(N.end,O.end-1);z(O.start,O.end,W===""?"\\r?\\n":`(?:[${W}]|\\r?\\n)`)}else O.type==="Quantifier"&&z(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){M.unshift(N)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(N){M.unshift(N)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(N){M.unshift(N)},onCharacterClassLeave(){M.shift()},onAssertionEnter(N){c(N)&&M.push(N)},onAssertionLeave(N){M[0]===N&&M.shift()}}).visit(k),I+=p.slice(j),I}e.$Tgc=l;function E(p){return p.replace(/\n/g,"\\r?\\n")}e.$Ugc=E;function C(p){let k=!1,I=!1,j="",z="";for(let M=0;M<p.length;M++){const F=p[M];switch(F){case"\\":I?(k?z+="\\"+F:j+="\\"+F,I=!1):I=!0;break;case"{":if(I)k?z+=F:j+=F,I=!1;else{if(k)return{strInBraces:j+"{"+z+"{"+p.substring(M+1)};k=!0}break;case"}":if(I)k?z+=F:j+=F,I=!1;else{if(k)return{fixedStart:j,strInBraces:z,fixedEnd:p.substring(M+1)};j+=F}break;default:k?z+=(I?"\\":"")+F:j+=(I?"\\":"")+F,I=!1;break}}return{strInBraces:j+(k?"{"+z:"")}}function f(p){const{fixedStart:k,strInBraces:I,fixedEnd:j}=C(p);if(k===void 0||j===void 0)return[I];let z=(0,w.$Ej)(I,",");z.length||(z=[""]);const M=f(j);return z.flatMap(F=>{const N=k+F;return M.map(O=>N+O)})}e.$Vgc=f}),define(ke[375],Se([1,0,21,157,85,17]),function(be,e,D,T,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;class R{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,L,P,$){const v=new T.$Pgc(this.b);if(L.folder.scheme===A.Schemas.vscodeUserData){const S={...L,folder:L.folder.with({scheme:A.Schemas.file})},g=new m.$cv(d=>P.report({...d,uri:d.uri.with({scheme:L.folder.scheme})}));return this.c($,d=>v.provideTextSearchResults(y,S,g,d))}else return this.c($,S=>v.provideTextSearchResults(y,L,P,S))}async c(y,L){const P=w(y);this.a.add(P);const $=await L(P.token);return this.a.delete(P),$}d(){this.a.forEach(y=>y.cancel())}}e.$Zgc=R;function w(b){const y=new D.$2d;return b.onCancellationRequested(()=>y.cancel()),y}}),define(ke[376],Se([1,0,31,157,156]),function(be,e,D,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class A{constructor(b){this.a=b}search(b,y,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(v){L({message:v})}},$=new m.$Wgc(this.a,new T.$Pgc(P),D);return new Promise((v,S)=>$.search(g=>{y(g.map(R))},b).then(g=>v({limitHit:g.limitHit,type:"success",stats:g.stats}),S))}}e.$Xgc=A;function R(w){return{path:w.resource&&w.resource.fsPath,results:w.results,numMatches:(w.results||[]).reduce((b,y)=>{if(y.ranges){const L=y;return b+(Array.isArray(L.ranges)?L.ranges.length:1)}else return b+1},0)}}}),define(ke[377],Se([1,0,19,12,8,4,130,16,38,2,32,36,372,376]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;class S{static{this.a=512}constructor(s="searchProcess"){this.d=s,this.b=Object.create(null)}fileSearch(s){let a;const t=o(s),r=new A.$Rd({onDidAddFirstListener:()=>{a=(0,T.$Ng)(h=>this.doFileSearchWithEngine($.$Ogc,t,u=>r.fire(u),h)),a.then(h=>r.fire(h),h=>r.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}textSearch(s){let a;const t=o(s),r=new A.$Rd({onDidAddFirstListener:()=>{a=(0,T.$Ng)(h=>this.f(t,u=>r.fire(u),h)),a.then(h=>r.fire(h),h=>r.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}f(s,a,t){return s.maxFileSize=this.g().maxFileSize,new v.$Xgc(s).search(t,a,a)}g(){return{maxFileSize:16*L.$Qk.GB}}doFileSearch(s,a,t){return this.doFileSearchWithEngine($.$Ogc,s,a,t)}doFileSearchWithEngine(s,a,t,r,h=S.a){let u=0;const c=E=>{Array.isArray(E)?(u+=E.length,t(E.map(C=>this.h(C)))):E.relativePath?(u++,t(this.h(E))):t(E)};if(a.sortByScore){let E=this.l(a,c,r);if(!E){const C=a.maxResults?Object.assign({},a,{maxResults:null}):a,f=new s(C);E=this.j(f,a,t,c,r)}return new Promise((C,f)=>{E.then(([p,k])=>{const I=k.map(j=>this.h(j));this.o(I,t,h),C(p)},f)})}const l=new s(a);return this.r(l,c,h,r).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}h(s){return{path:s.base?(0,w.$ic)(s.base,s.relativePath):s.relativePath}}j(s,a,t,r,h){const u=new A.$Rd;let c=(0,T.$Ng)(E=>{let C=[];const f=p=>{Array.isArray(p)?C=p:(r(p),u.fire(p))};return this.r(s,f,-1,E).then(p=>[p,C])}),l;if(a.cacheKey){l=this.k(a.cacheKey);const E={promise:c,event:u.event,resolved:!1};l.resultsToSearchCache[a.filePattern||""]=E,c.then(()=>{E.resolved=!0},C=>{delete l.resultsToSearchCache[a.filePattern||""]}),c=this.s(c)}return c.then(([E,C])=>{const f=l?l.scorerCache:Object.create(null),p=(typeof a.maxResults!="number"||a.maxResults>0)&&b.$Nd.create(!1);return this.n(a,C,f,h).then(k=>{const I=p?p.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:I,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:k.length},messages:E.messages,limitHit:E.limitHit||typeof a.maxResults=="number"&&C.length>a.maxResults},k]})})}k(s){const a=this.b[s];return a||(this.b[s]=new g)}l(s,a,t){const r=s.cacheKey&&this.b[s.cacheKey];if(!r)return;const h=this.q(r,s.filePattern||"",a,t);if(h)return h.then(([u,c,l])=>{const E=b.$Nd.create(!1);return this.n(s,c,r.scorerCache,t).then(C=>{const f=E.elapsed(),p={fromCache:!0,detailStats:l,type:this.d,resultCount:c.length,sortingTime:f};return[{type:"success",limitHit:u.limitHit||typeof s.maxResults=="number"&&c.length>s.maxResults,stats:p},C]})})}n(s,a,t,r){const h=(0,R.$Iq)(s.filePattern||""),u=(l,E)=>(0,R.$Hq)(l,E,h,!0,d,t),c=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return D.$Fb(a,u,c,1e4,r)}o(s,a,t){if(t&&t>0)for(let r=0;r<s.length;r+=t)a(s.slice(r,r+t));else a(s)}q(s,a,t,r){const h=b.$Nd.create(!1),u=a.indexOf(w.sep)>=0;let c;for(const f in s.resultsToSearchCache)if(a.startsWith(f)){if(u&&f.indexOf(w.sep)<0&&f!=="")continue;const p=s.resultsToSearchCache[f];c={promise:this.s(p.promise),event:p.event,resolved:p.resolved};break}if(!c)return null;const l=h.elapsed(),E=b.$Nd.create(!1),C=c.event(t);return r&&r.onCancellationRequested(()=>{C.dispose()}),c.promise.then(([f,p])=>{if(r&&r.isCancellationRequested)throw(0,m.$5)();const k=[],I=(0,R.$Iq)(a).normalizedLowercase;for(const j of p)(0,P.$eJ)(j,I)&&k.push(j);return[f,k,{cacheWasResolved:c.resolved,cacheLookupTime:l,cacheFilterTime:E.elapsed(),cacheEntryCount:p.length}]})}r(s,a,t,r){return new Promise((h,u)=>{let c=[];r?.onCancellationRequested(()=>s.cancel()),s.search(l=>{l&&(t?(c.push(l),t>0&&c.length>=t&&(a(c),c=[])):a(l))},l=>{a(l)},(l,E)=>{c.length&&a(c),l?u(l):h(E)})})}clearCache(s){return delete this.b[s],Promise.resolve(void 0)}s(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return s.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return s.finally(a)}}}}e.$Ygc=S;class g{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(n){return(0,w.$mc)(n.relativePath)}getItemDescription(n){return(0,w.$lc)(n.relativePath)}getItemPath(n){return n.relativePath}};function o(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(s=>y.URI.revive(s))}}function i(n){return{...n,folder:y.URI.revive(n.folder)}}}),define(ke[378],Se([1,0,3,17,2,31,14,27,20,97,66,36,377,375,119,156]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=void 0;let d=class extends y.$Mfc{constructor(i,n,s,a){super(i,s,a),this.s=A,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Qc;const t=new S.$Jgc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.vscodeUserData,new v.$Zgc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$Jgc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.file,new v.$Zgc(i))),this.x.add(this.z(T.Schemas.file,new $.$Ygc("fileSearchProvider")))}z(i,n){const s=this.d++;return this.v=n,this.t=s,this.c.$registerFileSearchProvider(s,this.o(i)),(0,D.$Pc)(()=>{this.v=null,this.c.$unregisterProvider(s)})}$provideFileSearchResults(i,n,s,a){const t=(0,y.$Nfc)(s);return i===this.t?this.A(i,n,t,a):super.$provideFileSearchResults(i,n,s,a)}doInternalFileSearchWithCustomCallback(i,n,s){const a=t=>{if((0,P.$dJ)(t)&&(t=[t]),Array.isArray(t)){s(t.map(r=>m.URI.file(r.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,s,a){return this.doInternalFileSearchWithCustomCallback(s,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new g.$Wgc(i,n,void 0,"textSearchProvider")}};e.$1gc=d,e.$1gc=d=Ke([Be(0,b.$EM),Be(1,w.$UM),Be(2,L.$Fec),Be(3,R.$hj)],d)}),define(ke[120],Se([1,0,392,62,63,393,22,8,4,3,16,11,30,81,82]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=void 0;class g{traceSocketEvent(p,k){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,k)}constructor(p,k=""){this.f=!0,this.debugLabel=k,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=I=>{if(this.traceSocketEvent("error",{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,w.$Z)(I)}},this.socket.on("error",this.a),this.b=I=>{this.traceSocketEvent("close",{hadError:I}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const k=I=>{this.traceSocketEvent("read",I),p(R.$fe.wrap(I))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(p){const k=I=>{p({type:0,hadError:I,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(p){const k=()=>{p()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,w.$Z)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,w.$Z)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.$Oh=g;var d;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize",f[f.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var o;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(o||(o={}));class i extends y.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,k){this.socket.traceSocketEvent(p,k)}constructor(p,k,I,j){super(),this.f=this.B(new b.$Rd),this.g=this.B(new b.$Rd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:I?.byteLength||0,recordInflateBytes:j}),this.a=this.B(new n(this,k,I,j,this.f,(z,M)=>this.m(z,M))),this.B(this.a.onError(z=>{console.error(z),(0,w.$Z)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new S.$Jh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let k=0;for(;k<p.byteLength;)this.a.writeMessage(p.slice(k,Math.min(k+262144,p.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(p,{compressed:k,opcode:I}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let j=2;p.byteLength<126?j+=0:p.byteLength<2**16?j+=2:j+=8;const z=R.$fe.alloc(j),M=k?64:0,F=I&15;if(z.writeUInt8(128|M|F,0),p.byteLength<126)z.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){z.writeUInt8(126,1);let N=1;z.writeUInt8(p.byteLength>>>8&255,++N),z.writeUInt8(p.byteLength>>>0&255,++N)}else{z.writeUInt8(127,1);let N=1;z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(p.byteLength>>>24&255,++N),z.writeUInt8(p.byteLength>>>16&255,++N),z.writeUInt8(p.byteLength>>>8&255,++N),z.writeUInt8(p.byteLength>>>0&255,++N)}this.socket.write(R.$fe.concat([z,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),I=k.readUInt8(0),j=(I&128)>>>7,z=(I&64)>>>6,M=I&15,F=k.readUInt8(1),N=(F&128)>>>7,O=F&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=j,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!j,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),I=k.readUInt8(1),j=(I&128)>>>7;let z=I&127,M=1;z===126?z=k.readUInt8(++M)*2**8+k.readUInt8(++M):z===127&&(z=k.readUInt8(++M)*0+k.readUInt8(++M)*0+k.readUInt8(++M)*0+k.readUInt8(++M)*0+k.readUInt8(++M)*2**24+k.readUInt8(++M)*2**16+k.readUInt8(++M)*2**8+k.readUInt8(++M));let F=0;j&&(F=k.readUInt8(++M)*2**24+k.readUInt8(++M)*2**16+k.readUInt8(++M)*2**8+k.readUInt8(++M)),this.j.state=3,this.j.readLen=z,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Ph=i;class n extends y.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$fe.alloc(0)}constructor(p,k,I,j,z,M){super(),this.n=p,this.r=z,this.s=M,this.a=this.B(new b.$Rd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$Rd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$Rd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new s(this.n,j,I,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(p,k){this.g.push({data:p,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:k}=this.g.shift();if(this.f&&k.compressed){const I=await this.w(this.f,p);this.s(I,k)}else this.s(p,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,k){return new Promise((I,j)=>{p.write(k),p.flush(z=>I(z))})}acceptFrame(p,k,I){this.h.push({data:p,isCompressed:k,isLastFrameOfMessage:I}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const k=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,k,I){return new Promise((j,z)=>{p.write(k),I&&p.write(R.$fe.fromByteArray([0,0,255,255])),p.flush(M=>j(M))})}}class s extends y.$Rc{get recordedInflateBytes(){return this.j?R.$fe.concat(this.f):R.$fe.alloc(0)}constructor(p,k,I,j){super(),this.h=p,this.j=k,this.a=this.B(new b.$Rd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(j),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(R.$fe.wrap(z))}),I&&(this.h.traceSocketEvent("zlibInflateInitialWrite",I.buffer),this.b.write(I.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent("zlibInflateWrite",p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=R.$fe.concat(this.g);this.g.length=0,p(k)})}}class a extends y.$Rc{constructor(p,k){super(),this.g=p,this.a=this.B(new b.$Rd),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",I=>{this.g.traceSocketEvent("zlibDeflateError",{message:I?.message,code:I?.code}),this.a.fire(I)}),this.b.on("data",I=>{this.g.traceSocketEvent("zlibDeflateData",I),this.f.push(R.$fe.wrap(I))})}write(p){this.g.traceSocketEvent("zlibDeflateWrite",p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=R.$fe.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),p(k)})}}function t(f,p){if(p===0)return;const k=f.byteLength>>>2;for(let N=0;N<k;N++){const O=f.readUInt32BE(N*4);f.writeUInt32BE(O^p,N*4)}const I=k*4,j=f.byteLength-I,z=p>>>24&255,M=p>>>16&255,F=p>>>8&255;j>=1&&f.writeUInt8(f.readUInt8(I)^z,I),j>=2&&f.writeUInt8(f.readUInt8(I+1)^M,I+1),j>=3&&f.writeUInt8(f.readUInt8(I+2)^F,I+2)}e.$Qh=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function h(){const f=(0,$.$kg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;const p=process.platform!=="darwin"&&e.$Qh?e.$Qh:(0,m.tmpdir)(),k=(0,L.$ic)(p,`vscode-ipc-${f}.sock`);return c(k),k}e.$Rh=h;function u(f,p,k){const I=(0,D.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${k}-${p}-sock`;const j=k.substr(0,4),z=p.substr(0,6),M=I.substr(0,8);let F;return process.platform!=="darwin"&&e.$Qh&&!process.env.VSCODE_PORTABLE?F=(0,L.$ic)(e.$Qh,`vscode-${M}-${j}-${z}.sock`):F=(0,L.$ic)(f,`${j}-${z}.sock`),c(F),F}e.$Sh=u;function c(f){const p=r[P.$u];typeof p=="number"&&f.length>=p&&console.warn(`WARNING: IPC handle "${f}" is longer than ${p} chars, try a shorter --user-data-dir`)}class l extends v.$Dh{static b(p){const k=b.Event.fromNodeEventEmitter(p,"connection");return b.Event.map(k,I=>({protocol:new S.$Kh(new g(I,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(I,"close"))}))}constructor(p){super(l.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Th=l;function E(f){return new Promise((p,k)=>{const I=(0,T.createServer)();I.on("error",k),I.listen(f,()=>{I.removeListener("error",k),p(new l(I))})})}e.$Uh=E;function C(f,p){return new Promise((k,I)=>{const j=(0,T.createConnection)(f,()=>{j.removeListener("error",I),k(S.$Lh.fromSocket(new g(j,`ipc-client${p}`),p))});j.once("error",I)})}e.$Vh=C}),define(ke[379],Se([1,0,62,63,165,120,12,3,11,45,14,137,256,257,109,88,22]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s0b=e.$r0b=e.$q0b=e.$p0b=void 0;async function o(t,r,h,u,c){let l;for(let E=3;E&&(l?.dispose(),l=await new i(t,r,h,u,c).waitForReady(),!(c&&m.$ng[c]||!m.$ng[l.tunnelLocalPort]));E--);return l}class i extends w.$Rc{constructor(r,h,u,c,l){super(),this.m=h,this.n=l,this.privacy=g.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=D.createServer(),this.c=new R.$Yg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=E=>this.r(E),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(h=>{h()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,h=(0,g.$ov)(this.m)?"0.0.0.0":"127.0.0.1";let u=await(0,m.$og)(r,2,1e3,h),c=null;return this.b.listen(u,this.m),await this.c.wait(),c=this.b.address(),c||(u=0,this.b.listen(u,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(r){r.pause();const h=(0,g.$mv)(this.tunnelRemoteHost)||(0,g.$ov)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,$.$dl)(this.a,h,this.tunnelRemotePort),c=u.getSocket(),l=u.readEntireBuffer();u.dispose(),l.byteLength>0&&r.write(l.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),c.end()}),r.on("close",()=>c.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),c instanceof A.$Oh?c.socket.destroy():c.end()}),c instanceof A.$Oh?this.t(r,c):this.s(r,c),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),c.end()})}s(r,h){h.onClose(()=>r.destroy()),h.onEnd(()=>r.end()),h.onData(u=>r.write(u.buffer)),r.on("data",u=>h.write(d.$fe.wrap(u))),r.resume()}t(r,h){const u=h.socket;u.on("end",()=>r.end()),u.on("close",()=>r.end()),u.on("error",()=>{r.destroy()}),u.pipe(r),r.pipe(u)}}e.$p0b=i;let n=class extends g.$rv{constructor(r,h,u,c,l){super(h,l),this.u=r,this.v=u,this.w=c}isPortPrivileged(r){return(0,g.$pv)(r,this.l,b.OS,T.release())}s(r,h,u,c,l,E,C,f){const p=this.r(h,u);if(p)return++p.refcount,p.value;if((0,g.$jv)(r))return this.t(r,h,u,l,E,C,f);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${u} on local port ${l}.`);const k={commit:this.w.commit,quality:this.w.quality,addressProvider:r,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},I=o(k,c,h,u,l);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(h,u,I),I}}};e.$q0b=n,e.$q0b=n=Ke([Be(0,v.$0k),Be(1,L.$hj),Be(2,S.$al),Be(3,P.$zj),Be(4,y.$ti)],n);let s=class extends n{constructor(r,h,u,c,l){super(r,h,u,c,l)}};e.$r0b=s,e.$r0b=s=Ke([Be(0,v.$0k),Be(1,L.$hj),Be(2,S.$al),Be(3,P.$zj),Be(4,y.$ti)],s);let a=class extends w.$Rc{constructor(r,h,u,c,l){super(),this.b=r,this.c=h,this.f=u,this.g=c,this.h=l,this.a=new Map}async openTunnel(r,h,u,c,l,E,C,f,p){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${c} on local port ${E}.`),!this.a.has(r)){const k=new s(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(r,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(h,u,c,l,E,C,f,p)}};e.$s0b=a,e.$s0b=a=Ke([Be(0,v.$0k),Be(1,L.$hj),Be(2,P.$zj),Be(3,S.$al),Be(4,y.$ti)],a)}),define(ke[380],Se([1,0,120,276,55,35,2,14,40]),function(be,e,D,T,m,A,R,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=e.$6M=void 0;class y{constructor($,v,S){this.b=$,this.c=v,this.f=S,this.a=T.createServer((g,d)=>this.h(g,d)),this.g().catch(g=>(v.error(g),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,v){const S=(d,o)=>{v.writeHead(d,{"content-type":"application/json"}),v.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},g=[];$.setEncoding("utf8"),$.on("data",d=>g.push(d)),$.on("end",async()=>{try{const d=JSON.parse(g.join(""));let o;switch(d.type){case"open":o=await this.i(d);break;case"openExternal":o=await this.j(d);break;case"status":o=await this.l(d);break;case"extensionManagement":o=await this.k(d);break;default:S(404,`Unknown message type: ${d.type}`);break}S(200,o)}catch(d){const o=d instanceof Error?d.message:JSON.stringify(d);S(500,o),this.c.error("Error while processing pipe request",d)}})}async i($){const{fileURIs:v,folderURIs:S,forceNewWindow:g,diffMode:d,mergeMode:o,addMode:i,forceReuseWindow:n,gotoLineMode:s,waitMarkerFilePath:a,remoteAuthority:t}=$,r=[];if(Array.isArray(S))for(const l of S)try{r.push({folderUri:R.URI.parse(l)})}catch{}if(Array.isArray(v))for(const l of v)try{(0,b.$si)(l)?r.push({workspaceUri:R.URI.parse(l)}):r.push({fileUri:R.URI.parse(l)})}catch{}const h=a?R.URI.file(a):void 0,c={forceNewWindow:g,diffMode:d,mergeMode:o,addMode:i,gotoLineMode:s,forceReuseWindow:n,preferNewWindow:!n&&!h&&!i,waitMarkerFileURI:h,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,c)}async j($){for(const v of $.uris){const S=R.URI.parse(v),g=S.scheme==="file"?S:v;await this.b.executeCommand("_remoteCLI.openExternal",g)}}async k($){const v=g=>g?.map(d=>/\.vsix$/i.test(d)?R.URI.parse(d):d),S={list:$.list,install:v($.install),uninstall:v($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&m.existsSync(this.f)&&m.unlinkSync(this.f)}}e.$6M=y;let L=class extends y{constructor($,v){super($,v,(0,D.$Rh)())}};e.$7M=L,e.$7M=L=Ke([Be(0,A.$1M),Be(1,w.$hj)],L)}),define(ke[381],Se([1,0,56,368,363,275,48,348,2,17,7,380,103,346,347]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;class g extends m.$ugc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,s=n._load;n._load=function(h,u,c){return h=t(h),i.a.has(h)?i.a.get(h).load(h,b.URI.file((0,$.$fq)(u.filename)),l=>s.apply(this,[l,u,c])):s.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(r,h)=>a.call(this,t(r),h);const t=r=>{for(const h of i.b){const u=h(r);if(u){r=u;break}}return r}}}class d extends R.$jfc{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async tb(){this.h.createInstance(v.$4gc);const i=this.h.invokeFunction(T.$qgc);if(this.h.createInstance(w.$3gc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(P.$7M);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(S.$5gc),await this.h.createInstance(g,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const s=await this.m.getConfigProvider();await(0,A.$2gc)(this.j,s,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,s){if(n.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;s.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),a=be.__$__nodeRequire(n.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),s.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const s=i[n];s===null?delete process.env[n]:process.env[n]=s}}}e.$6gc=d}),define(ke[382],Se([1,0,50,22,4,3,123,11,23,2,31,14,255,64,109,88,379,27,20,72,357]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=e.$ahc=e.$_gc=e.$$gc=e.$0gc=e.$9gc=e.$8gc=e.$7gc=void 0;function a(p){const k=p.trim().split(`
`),I=[];return k.forEach(z=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);M&&M.length>=3&&I.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),I.reduce((z,M)=>(z[M.socket]=M,z),{})}e.$7gc=a;function t(...p){const k=[].concat(...p.map(h));return[...new Map(k.filter(I=>I.st==="0A").map(I=>{const j=I.local_address.split(":");return{socket:parseInt(I.inode,10),ip:r(j[0]),port:parseInt(j[1],16)}}).map(I=>[I.ip+":"+I.port,I])).values()]}e.$8gc=t;function r(p){let k="";if(p.length===8)for(let I=p.length-2;I>=0;I-=2)k+=parseInt(p.substr(I,2),16),I!==0&&(k+=".");else for(let I=0;I<p.length;I+=8){const j=p.substring(I,I+8);let z="";for(let M=8;M>=2;M-=2)z+=j.substring(M-2,M),(M===6||M===2)&&(z=parseInt(z,16).toString(16),k+=`${z}`,z="",I+M!==p.length-6&&(k+=":"))}return k}e.$9gc=r;function h(p){const k=p.trim().split(`
`),I=k.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return k.map(z=>z.trim().split(/\s+/).reduce((M,F,N)=>(M[I[N]||N]=F,M),{}))}e.$0gc=h;function u(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/server-main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function c(p){const k=p.trim().split(`
`),I=[];return k.forEach(j=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(j);z&&z.length>=4&&I.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),I}e.$$gc=c;async function l(p,k,I){const j=I.reduce((M,F)=>(M[F.pid]=F,M),{}),z=[];return p.forEach(({socket:M,ip:F,port:N})=>{const O=k[M]?k[M].pid:void 0,W=O?j[O]?.cmd:void 0;O&&W&&!u(W)&&z.push({host:F,port:N,detail:W,pid:O})}),z}e.$_gc=l;function E(p,k,I){const j=new Map,z=c(k);for(const M of p){const F=I.get(M.port);if(F){j.set(M.port,F);continue}const N=z.find(O=>O.cmd.includes(`${M.port}`));if(N){let O=N,W;do W=z.find(x=>x.ppid===O.pid),W&&(O=W);while(W);j.set(M.port,{host:M.ip,port:M.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else j.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return j}e.$ahc=E;let C=class extends n.$Fxb{constructor(k,I,j,z){super(k,I,j),this.D=I,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,w.$k&&I.remote.isRemote&&I.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(k){if(k&&this.C)return;this.C=k;let I;this.y&&(I=this.y,await this.a.$onFoundNewCandidates(this.y));const j=new R.$2l;let z=0;for(;this.C;){const M=new Date().getTime(),F=(await this.I()).filter(W=>(0,g.$mv)(W.host)||(0,g.$ov)(W.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(W=>W.port).join(", ")}`);const N=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),z++>3&&j.update(N),(!I||JSON.stringify(I)!==JSON.stringify(F))&&(I=F,await this.a.$onFoundNewCandidates(I));const O=this.G(j.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(W=>setTimeout(()=>W(),O))}}G(k){return Math.max(k*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(k=>k.port).join(", ")}`)}async I(){let k="",I="";try{k=await L.Promises.readFile("/proc/net/tcp","utf8"),I=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const j=t(k,I),z=await new Promise(X=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,Q,he)=>{X(Q)})}),M=a(z),F=await L.Promises.readdir("/proc"),N=[];for(const X of F)try{const J=Number(X),Q=b.$Bg(y.URI.file("/proc"),X);if((await L.Promises.stat(Q.fsPath)).isDirectory()&&!isNaN(J)){const Z=await L.Promises.readlink(b.$Bg(Q,"cwd").fsPath),ye=await L.Promises.readFile(b.$Bg(Q,"cmdline").fsPath,"utf8");N.push({pid:J,cwd:Z,cmd:ye})}}catch{}const O=[],W=j.filter(X=>{const J=M[X.socket];return J||O.push(X),J}),x=l(W,M,N);let ue;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const X=await new Promise(J=>{(0,D.exec)("ps -F -A -l | grep root",(Q,he,Z)=>{J(he)})});this.z=E(O,X,this.z),ue=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ue.map(J=>J.port).join(", ")}`)}return x.then(X=>ue?X.concat(ue):X)}w(k){return async I=>{const j=new d.$p0b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,F,N,O){const W=await k.makeConnection();return f.connect(W,F,N,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new v.$1k(0),connectionToken:k.connectionToken})}},signService:this.F},"localhost",I.remoteAddress.host||"localhost",I.remoteAddress.port,I.localAddressPort);await j.waitForReady();const z=new m.$Rd;return{localAddress:(0,s.$3J)(j.localAddress)??j.localAddress,remoteAddress:{port:j.tunnelRemotePort,host:j.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{j.dispose(),z.fire(),z.dispose()}}}}};e.$bhc=C,e.$bhc=C=Ke([Be(0,i.$EM),Be(1,o.$UM),Be(2,P.$hj),Be(3,S.$al)],C);class f extends $.$Kqb{static connect(k,I,j,z){const M=new A.$Qc,F={onClose:M.add(new m.$Rd),onData:M.add(new m.$Rd),onEnd:M.add(new m.$Rd)};M.add(k.onDidReceiveMessage(O=>F.onData.fire(T.$fe.wrap(O)))),M.add(k.onDidEnd(()=>F.onEnd.fire())),M.add(k.onDidClose(O=>F.onClose.fire({type:0,error:O,hadError:!!O})));const N=new f(k,z,F);return N.B(M),(0,$.$Jqb)(N,I,j,z,F)}constructor(k,I,j){super(I,j),this.n=k}write(k){this.n.send(k.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[383],Se([1,0,106,351,366,365,378,381,382,96,48,97,95,47,72,92,350,349,14,367,58,270,105,109,139]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o,i,n,s,a,t,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Gr)(L.$kfc,w.$6gc,0),(0,D.$Gr)(i.$ij,o.$dhc,1),(0,D.$Gr)(i.$hj,new t.$Wh(a.$tgc,[!1],!0)),(0,D.$Gr)(r.$al,h.$u0b,1),(0,D.$Gr)(g.$Oec,d.$chc,0),(0,D.$Gr)(y.$pfc,A.$Ggc,0),(0,D.$Gr)(P.$Lfc,R.$1gc,0),(0,D.$Gr)($.$cgc,m.$ygc,0),(0,D.$Gr)(v.$0ec,T.$xgc,0),(0,D.$Gr)(S.$Exb,b.$bhc,0),(0,D.$Gr)(s.$nfc,n.$ehc,0)}),define(ke[394],Se([1,0,62,395,56,8,82,120,253,114,364,22,31,103,12,133,277,291,369,383]),function(be,e,D,T,m,A,R,w,b,y,L,P,$,v,S,g,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const i=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,l=c._load;c._load=function(E){if(E==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const n=process.exit.bind(process);function s(c){process.exit=function(l){if(c)n(l);else{const E=new Error("An extension called process.exit() and this was prevented.");console.warn(E.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(c){n()};function t(){const c=(0,o.$Lm)(process.env);if(c.type===3)return new Promise((l,E)=>{const C=f=>{const p=f[0],k=new R.$Mh;p.on("message",I=>k.fire(P.$fe.wrap(I.data))),p.on("close",()=>{a("renderer closed the MessagePort")}),p.start(),l({onMessage:k.event,send:I=>p.postMessage(I.buffer)})};process.parentPort.on("message",f=>C(f.ports))});if(c.type===2)return new Promise((l,E)=>{let C=null;const f=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=108e5,k=3e5,I=new S.$ah(()=>a("renderer disconnected for too long (1)"),p),j=new S.$ah(()=>a("renderer disconnected for too long (2)"),k);process.on("message",(M,F)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){F.setNoDelay(!0);const N=P.$fe.wrap(Buffer.from(M.initialDataChunk,"base64"));let O;if(M.skipWebSocketFrames)O=new w.$Oh(F,"extHost-socket");else{const W=P.$fe.wrap(Buffer.from(M.inflateBytes,"base64"));O=new w.$Ph(new w.$Oh(F,"extHost-socket"),M.permessageDeflate,W,!1)}C?(I.cancel(),j.cancel(),C.beginAcceptReconnection(O,N),C.endAcceptReconnection(),C.sendResume()):(clearTimeout(f),C=new R.$Nh({socket:O,initialChunk:N}),C.sendResume(),C.onDidDispose(()=>a("renderer disconnected")),l(C),C.onSocketClose(()=>{I.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(j.isScheduled())return;I.isScheduled()&&j.schedule()}});const z={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(z)});{const l=c.pipeName;return new Promise((E,C)=>{const f=D.createConnection(l,()=>{f.removeListener("error",C);const p=new R.$Nh({socket:new w.$Oh(f,"extHost-renderer")});p.sendResume(),E(p)});f.once("error",C),f.on("close",()=>{a("renderer closed the socket")})})}}async function r(){const c=await t();return new class{constructor(){this.a=new R.$Mh,this.onMessage=this.a.event,this.b=!1,c.onMessage(l=>{(0,y.$mm)(l,2)?(this.b=!0,a("received terminate message from renderer")):this.a.fire(l)})}send(l){this.b||c.send(l)}async drain(){if(c.drain)return c.drain()}}}function h(c){return new Promise(l=>{const E=c.onMessage(C=>{E.dispose();const f=JSON.parse(C.toString()),p=f.commit,k=b.default.commit;if(p&&k&&p!==k&&n(55),f.parentPid){let I=0;setInterval(function(){try{process.kill(f.parentPid,0),I=0}catch(z){z&&z.code==="EPERM"?(I++,I>=3&&a(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${z.message} (code: ${z.code}) (errno: ${z.errno})`)):a(`parent process ${f.parentPid} does not exist anymore: ${z.message} (code: ${z.code}) (errno: ${z.errno})`)}},1e3);let j;try{j=globalThis._VSCODE_NODE_MODULES["native-watchdog"],j.start(f.parentPid)}catch(z){(0,A.$Z)(z)}}c.send((0,y.$lm)(0)),l({protocol:c,initData:f})});c.send((0,y.$lm)(1))})}async function u(){const c=[];process.on("unhandledRejection",(I,j)=>{c.push(j),setTimeout(()=>{const z=c.indexOf(j);z>=0&&j.catch(M=>{c.splice(z,1),(0,A.$3)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),I&&(0,A.$Z)(I))})},1e3)}),process.on("rejectionHandled",I=>{const j=c.indexOf(I);j>=0&&c.splice(j,1)}),process.on("uncaughtException",function(I){(0,A.$Y)(I)||(0,A.$Z)(I)}),m.mark("code/extHost/willConnectToRenderer");const l=await r();m.mark("code/extHost/didConnectToRenderer");const E=await h(l);m.mark("code/extHost/didWaitForInitData");const{initData:C}=E;s(!!C.environment.extensionTestsLocationURI),C.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,C.environment.skipWorkspaceStorageLock=(0,g.boolean)(i.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(j){n(j)}fsExists(j){return $.Promises.exists(j)}fsRealpath(j){return(0,v.$eq)(j)}};let p=null;C.remote.authority&&i.transformURIs&&(p=(0,d.$Kr)(C.remote.authority));const k=new L.$wgc(E.protocol,C,f,p);a=I=>k.terminate(I)}u().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f3da7cb46a8ffbea21998420dc673777715e55cf/core/vs/workbench/api/node/extensionHostProcess.js.map
