/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/path","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/core/position","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/workbench/api/worker/extensionHostWorker"],Re=function(pe){for(var e=[],E=0,T=pe.length;E<T;E++)e[E]=Pe[pe[E]];return e};define(Pe[66],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=e.$rh=void 0;function E(P){return($,m,y)=>{let R=null,S=null;if(typeof y.value=="function"?(R="value",S=y.value):typeof y.get=="function"&&(R="get",S=y.get),!S)throw new Error("not supported");y[R]=P(S,m)}}function T(P,$,m){let y=null,R=null;if(typeof m.value=="function"?(y="value",R=m.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(y="get",R=m.get),!R)throw new Error("not supported");const S=`$memoize$${$}`;m[y]=function(...l){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,l)}),this[S]}}e.$rh=T;function C(P,$,m){return E((y,R)=>{const S=`$debounce$${R}`,l=`$debounce$result$${R}`;return function(...p){this[l]||(this[l]=m?m():void 0),clearTimeout(this[S]),$&&(this[l]=$(this[l],...p),p=[this[l]]),this[S]=setTimeout(()=>{y.apply(this,p),this[l]=m?m():void 0},P)}})}e.$sh=C;function M(P,$,m){return E((y,R)=>{const S=`$throttle$timer$${R}`,l=`$throttle$result$${R}`,p=`$throttle$lastRun$${R}`,b=`$throttle$pending$${R}`;return function(...a){if(this[l]||(this[l]=m?m():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),$&&(this[l]=$(this[l],...a)),this[b])return;const s=this[p]+P;s<=Date.now()?(this[p]=Date.now(),y.apply(this,[this[l]]),this[l]=m?m():void 0):(this[b]=!0,this[S]=setTimeout(()=>{this[b]=!1,this[p]=Date.now(),y.apply(this,[this[l]]),this[l]=m?m():void 0},s-Date.now()))}})}e.$th=M}),define(Pe[89],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=void 0;class E{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$JM=E,e.$KM=new E("id#")}),define(Pe[118],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var C;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function P(i,r=!1){let u=0;const f=i.length;let v="",g=0,D=16,I=0;function h(A){let L=0,O=0;for(;L<A;){const x=i.charCodeAt(u);if(x>=48&&x<=57)O=O*16+x-48;else if(x>=65&&x<=70)O=O*16+x-65+10;else if(x>=97&&x<=102)O=O*16+x-97+10;else break;u++,L++}return L<A&&(O=-1),O}function w(A){u=A,v="",g=0,D=16,I=0}function k(){const A=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&y(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&y(i.charCodeAt(u)))for(u++;u<i.length&&y(i.charCodeAt(u));)u++;else return I=3,i.substring(A,u);let L=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&y(i.charCodeAt(u))){for(u++;u<i.length&&y(i.charCodeAt(u));)u++;L=u}else I=3;return i.substring(A,L)}function F(){let A="",L=u;for(;;){if(u>=f){A+=i.substring(L,u),I=2;break}const O=i.charCodeAt(u);if(O===34){A+=i.substring(L,u),u++;break}if(O===92){if(A+=i.substring(L,u),u++,u>=f){I=2;break}switch(i.charCodeAt(u++)){case 34:A+='"';break;case 92:A+="\\";break;case 47:A+="/";break;case 98:A+="\b";break;case 102:A+="\f";break;case 110:A+=`
`;break;case 114:A+="\r";break;case 116:A+="	";break;case 117:{const le=h(4);le>=0?A+=String.fromCharCode(le):I=4;break}default:I=5}L=u;continue}if(O>=0&&O<=31)if(m(O)){A+=i.substring(L,u),I=2;break}else I=6;u++}return A}function W(){if(v="",I=0,g=u,u>=f)return g=f,D=17;let A=i.charCodeAt(u);if($(A)){do u++,v+=String.fromCharCode(A),A=i.charCodeAt(u);while($(A));return D=15}if(m(A))return u++,v+=String.fromCharCode(A),A===13&&i.charCodeAt(u)===10&&(u++,v+=`
`),D=14;switch(A){case 123:return u++,D=1;case 125:return u++,D=2;case 91:return u++,D=3;case 93:return u++,D=4;case 58:return u++,D=6;case 44:return u++,D=5;case 34:return u++,v=F(),D=10;case 47:{const L=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<f&&!m(i.charCodeAt(u));)u++;return v=i.substring(L,u),D=12}if(i.charCodeAt(u+1)===42){u+=2;const O=f-1;let x=!1;for(;u<O;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,x=!0;break}u++}return x||(u++,I=1),v=i.substring(L,u),D=13}return v+=String.fromCharCode(A),u++,D=16}case 45:if(v+=String.fromCharCode(A),u++,u===f||!y(i.charCodeAt(u)))return D=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=k(),D=11;default:for(;u<f&&Q(A);)u++,A=i.charCodeAt(u);if(g!==u){switch(v=i.substring(g,u),v){case"true":return D=8;case"false":return D=9;case"null":return D=7}return D=16}return v+=String.fromCharCode(A),u++,D=16}}function Q(A){if($(A)||m(A))return!1;switch(A){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let A;do A=W();while(A>=12&&A<=15);return A}return{setPosition:w,getPosition:()=>u,scan:r?N:W,getToken:()=>D,getTokenValue:()=>v,getTokenOffset:()=>g,getTokenLength:()=>u-g,getTokenError:()=>I}}e.$5m=P;function $(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function m(i){return i===10||i===13||i===8232||i===8233}function y(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function S(i,r){const u=[],f=new Object;let v;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function I(h,w,k,F){g.value=h,g.offset=w,g.length=k,g.type=F,g.colonOffset=void 0,v=g}try{o(i,{onObjectBegin:(h,w)=>{if(r<=h)throw f;v=void 0,D=r>h,u.push("")},onObjectProperty:(h,w,k)=>{if(r<w||(I(h,w,k,"property"),u[u.length-1]=h,r<=w+k))throw f},onObjectEnd:(h,w)=>{if(r<=h)throw f;v=void 0,u.pop()},onArrayBegin:(h,w)=>{if(r<=h)throw f;v=void 0,u.push(0)},onArrayEnd:(h,w)=>{if(r<=h)throw f;v=void 0,u.pop()},onLiteralValue:(h,w,k)=>{if(r<w||(I(h,w,k,d(h)),r<=w+k))throw f},onSeparator:(h,w,k)=>{if(r<=w)throw f;if(h===":"&&v&&v.type==="property")v.colonOffset=w,D=!1,v=void 0;else if(h===","){const F=u[u.length-1];typeof F=="number"?u[u.length-1]=F+1:(D=!0,u[u.length-1]=""),v=void 0}}})}catch(h){if(h!==f)throw h}return{path:u,previousNode:v,isAtPropertyKey:D,matches:h=>{let w=0;for(let k=0;w<h.length&&k<u.length;k++)if(h[w]===u[k]||h[w]==="*")w++;else if(h[w]!=="**")return!1;return w===h.length}}}e.$6m=S;function l(i,r=[],u=M.DEFAULT){let f=null,v=[];const g=[];function D(h){Array.isArray(v)?v.push(h):f!==null&&(v[f]=h)}return o(i,{onObjectBegin:()=>{const h={};D(h),g.push(v),v=h,f=null},onObjectProperty:h=>{f=h},onObjectEnd:()=>{v=g.pop()},onArrayBegin:()=>{const h=[];D(h),g.push(v),v=h,f=null},onArrayEnd:()=>{v=g.pop()},onLiteralValue:D,onError:(h,w,k)=>{r.push({error:h,offset:w,length:k})}},u),v[0]}e.$7m=l;function p(i,r=[],u=M.DEFAULT){let f={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(h){f.type==="property"&&(f.length=h-f.offset,f=f.parent)}function g(h){return f.children.push(h),h}o(i,{onObjectBegin:h=>{f=g({type:"object",offset:h,length:-1,parent:f,children:[]})},onObjectProperty:(h,w,k)=>{f=g({type:"property",offset:w,length:-1,parent:f,children:[]}),f.children.push({type:"string",value:h,offset:w,length:k,parent:f})},onObjectEnd:(h,w)=>{f.length=h+w-f.offset,f=f.parent,v(h+w)},onArrayBegin:(h,w)=>{f=g({type:"array",offset:h,length:-1,parent:f,children:[]})},onArrayEnd:(h,w)=>{f.length=h+w-f.offset,f=f.parent,v(h+w)},onLiteralValue:(h,w,k)=>{g({type:d(h),offset:w,length:k,parent:f,value:h}),v(w+k)},onSeparator:(h,w,k)=>{f.type==="property"&&(h===":"?f.colonOffset=w:h===","&&v(w))},onError:(h,w,k)=>{r.push({error:h,offset:w,length:k})}},u);const I=f.children[0];return I&&delete I.parent,I}e.$8m=p;function b(i,r){if(!i)return;let u=i;for(const f of r)if(typeof f=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let v=!1;for(const g of u.children)if(Array.isArray(g.children)&&g.children[0].value===f){u=g.children[1],v=!0;break}if(!v)return}else{const v=f;if(u.type!=="array"||v<0||!Array.isArray(u.children)||v>=u.children.length)return;u=u.children[v]}return u}e.$9m=b;function a(i){if(!i.parent||!i.parent.children)return[];const r=a(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;r.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&r.push(u)}return r}e.$0m=a;function s(i){switch(i.type){case"array":return i.children.map(s);case"object":{const r=Object.create(null);for(const u of i.children){const f=u.children[1];f&&(r[u.children[0].value]=s(f))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$$m=s;function t(i,r,u=!1){return r>=i.offset&&r<i.offset+i.length||u&&r===i.offset+i.length}e.$_m=t;function n(i,r,u=!1){if(t(i,r,u)){const f=i.children;if(Array.isArray(f))for(let v=0;v<f.length&&f[v].offset<=r;v++){const g=n(f[v],r,u);if(g)return g}return i}}e.$an=n;function o(i,r,u=M.DEFAULT){const f=P(i,!1);function v(ie){return ie?()=>ie(f.getTokenOffset(),f.getTokenLength()):()=>!0}function g(ie){return ie?Ie=>ie(Ie,f.getTokenOffset(),f.getTokenLength()):()=>!0}const D=v(r.onObjectBegin),I=g(r.onObjectProperty),h=v(r.onObjectEnd),w=v(r.onArrayBegin),k=v(r.onArrayEnd),F=g(r.onLiteralValue),W=g(r.onSeparator),Q=v(r.onComment),N=g(r.onError),A=u&&u.disallowComments,L=u&&u.allowTrailingComma;function O(){for(;;){const ie=f.scan();switch(f.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:A||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(ie){case 12:case 13:A?x(10):Q();break;case 16:x(1);break;case 15:case 14:break;default:return ie}}}function x(ie,Ie=[],ce=[]){if(N(ie),Ie.length+ce.length>0){let Y=f.getToken();for(;Y!==17;){if(Ie.indexOf(Y)!==-1){O();break}else if(ce.indexOf(Y)!==-1)break;Y=O()}}}function le(ie){const Ie=f.getTokenValue();return ie?F(Ie):I(Ie),O(),!0}function me(){switch(f.getToken()){case 11:{let ie=0;try{ie=JSON.parse(f.getTokenValue()),typeof ie!="number"&&(x(2),ie=0)}catch{x(2)}F(ie);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return O(),!0}function ye(){return f.getToken()!==10?(x(3,[],[2,5]),!1):(le(!1),f.getToken()===6?(W(":"),O(),be()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function we(){D(),O();let ie=!1;for(;f.getToken()!==2&&f.getToken()!==17;){if(f.getToken()===5){if(ie||x(4,[],[]),W(","),O(),f.getToken()===2&&L)break}else ie&&x(6,[],[]);ye()||x(4,[],[2,5]),ie=!0}return h(),f.getToken()!==2?x(7,[2],[]):O(),!0}function de(){w(),O();let ie=!1;for(;f.getToken()!==4&&f.getToken()!==17;){if(f.getToken()===5){if(ie||x(4,[],[]),W(","),O(),f.getToken()===4&&L)break}else ie&&x(6,[],[]);be()||x(4,[],[4,5]),ie=!0}return k(),f.getToken()!==4?x(8,[4],[]):O(),!0}function be(){switch(f.getToken()){case 3:return de();case 1:return we();case 10:return le(!0);default:return me()}}return O(),f.getToken()===17?u.allowEmptyContent?!0:(x(4,[],[]),!1):be()?(f.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$bn=o;function c(i,r){const u=P(i),f=[];let v,g=0,D;do switch(D=u.getPosition(),v=u.scan(),v){case 12:case 13:case 17:g!==D&&f.push(i.substring(g,D)),r!==void 0&&f.push(u.getTokenValue().replace(/[^\r\n]/g,r)),g=u.getPosition();break}while(v!==17);return f.join("")}e.$cn=c;function d(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$dn=d}),function(pe,e){typeof define=="function"&&define.amd?define(Pe[119],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(pe=typeof globalThis<"u"?globalThis:pe||self,e(pe.marked={}))}(this,function(pe){"use strict";function e(Ce,fe){for(var ne=0;ne<fe.length;ne++){var H=fe[ne];H.enumerable=H.enumerable||!1,H.configurable=!0,"value"in H&&(H.writable=!0),Object.defineProperty(Ce,H.key,H)}}function E(Ce,fe,ne){return fe&&e(Ce.prototype,fe),ne&&e(Ce,ne),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function T(Ce,fe){if(Ce){if(typeof Ce=="string")return C(Ce,fe);var ne=Object.prototype.toString.call(Ce).slice(8,-1);if(ne==="Object"&&Ce.constructor&&(ne=Ce.constructor.name),ne==="Map"||ne==="Set")return Array.from(Ce);if(ne==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ne))return C(Ce,fe)}}function C(Ce,fe){(fe==null||fe>Ce.length)&&(fe=Ce.length);for(var ne=0,H=new Array(fe);ne<fe;ne++)H[ne]=Ce[ne];return H}function M(Ce,fe){var ne=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(ne)return(ne=ne.call(Ce)).next.bind(ne);if(Array.isArray(Ce)||(ne=T(Ce))||fe&&Ce&&typeof Ce.length=="number"){ne&&(Ce=ne);var H=0;return function(){return H>=Ce.length?{done:!0}:{done:!1,value:Ce[H++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function P(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}pe.defaults=P();function $(Ce){pe.defaults=Ce}var m=/[&<>"']/,y=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(fe){return l[fe]};function b(Ce,fe){if(fe){if(m.test(Ce))return Ce.replace(y,p)}else if(R.test(Ce))return Ce.replace(S,p);return Ce}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(Ce){return Ce.replace(a,function(fe,ne){return ne=ne.toLowerCase(),ne==="colon"?":":ne.charAt(0)==="#"?ne.charAt(1)==="x"?String.fromCharCode(parseInt(ne.substring(2),16)):String.fromCharCode(+ne.substring(1)):""})}var t=/(^|[^\[])\^/g;function n(Ce,fe){Ce=typeof Ce=="string"?Ce:Ce.source,fe=fe||"";var ne={replace:function(te,X){return X=X.source||X,X=X.replace(t,"$1"),Ce=Ce.replace(te,X),ne},getRegex:function(){return new RegExp(Ce,fe)}};return ne}var o=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(Ce,fe,ne){if(Ce){var H;try{H=decodeURIComponent(s(ne)).replace(o,"").toLowerCase()}catch{return null}if(H.indexOf("javascript:")===0||H.indexOf("vbscript:")===0||H.indexOf("data:")===0)return null}fe&&!c.test(ne)&&(ne=v(fe,ne));try{ne=encodeURI(ne).replace(/%25/g,"%")}catch{return null}return ne}var i={},r=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,f=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Ce,fe){i[" "+Ce]||(r.test(Ce)?i[" "+Ce]=Ce+"/":i[" "+Ce]=h(Ce,"/",!0)),Ce=i[" "+Ce];var ne=Ce.indexOf(":")===-1;return fe.substring(0,2)==="//"?ne?fe:Ce.replace(u,"$1")+fe:fe.charAt(0)==="/"?ne?fe:Ce.replace(f,"$1")+fe:Ce+fe}var g={exec:function(){}};function D(Ce){for(var fe=1,ne,H;fe<arguments.length;fe++){ne=arguments[fe];for(H in ne)Object.prototype.hasOwnProperty.call(ne,H)&&(Ce[H]=ne[H])}return Ce}function I(Ce,fe){var ne=Ce.replace(/\|/g,function(X,re,he){for(var De=!1,z=re;--z>=0&&he[z]==="\\";)De=!De;return De?"|":" |"}),H=ne.split(/ \|/),te=0;if(H[0].trim()||H.shift(),H.length>0&&!H[H.length-1].trim()&&H.pop(),H.length>fe)H.splice(fe);else for(;H.length<fe;)H.push("");for(;te<H.length;te++)H[te]=H[te].trim().replace(/\\\|/g,"|");return H}function h(Ce,fe,ne){var H=Ce.length;if(H===0)return"";for(var te=0;te<H;){var X=Ce.charAt(H-te-1);if(X===fe&&!ne)te++;else if(X!==fe&&ne)te++;else break}return Ce.slice(0,H-te)}function w(Ce,fe){if(Ce.indexOf(fe[1])===-1)return-1;for(var ne=Ce.length,H=0,te=0;te<ne;te++)if(Ce[te]==="\\")te++;else if(Ce[te]===fe[0])H++;else if(Ce[te]===fe[1]&&(H--,H<0))return te;return-1}function k(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(Ce,fe){if(fe<1)return"";for(var ne="";fe>1;)fe&1&&(ne+=Ce),fe>>=1,Ce+=Ce;return ne+Ce}function W(Ce,fe,ne,H){var te=fe.href,X=fe.title?b(fe.title):null,re=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){H.state.inLink=!0;var he={type:"link",raw:ne,href:te,title:X,text:re,tokens:H.inlineTokens(re)};return H.state.inLink=!1,he}return{type:"image",raw:ne,href:te,title:X,text:b(re)}}function Q(Ce,fe){var ne=Ce.match(/^(\s+)(?:```)/);if(ne===null)return fe;var H=ne[1];return fe.split(`
`).map(function(te){var X=te.match(/^\s+/);if(X===null)return te;var re=X[0];return re.length>=H.length?te.slice(H.length):te}).join(`
`)}var N=function(){function Ce(ne){this.options=ne||pe.defaults}var fe=Ce.prototype;return fe.space=function(H){var te=this.rules.block.newline.exec(H);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},fe.code=function(H){var te=this.rules.block.code.exec(H);if(te){var X=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?X:h(X,`
`)}}},fe.fences=function(H){var te=this.rules.block.fences.exec(H);if(te){var X=te[0],re=Q(X,te[3]||"");return{type:"code",raw:X,lang:te[2]?te[2].trim():te[2],text:re}}},fe.heading=function(H){var te=this.rules.block.heading.exec(H);if(te){var X=te[2].trim();if(/#$/.test(X)){var re=h(X,"#");(this.options.pedantic||!re||/ $/.test(re))&&(X=re.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:X,tokens:this.lexer.inline(X)}}},fe.hr=function(H){var te=this.rules.block.hr.exec(H);if(te)return{type:"hr",raw:te[0]}},fe.blockquote=function(H){var te=this.rules.block.blockquote.exec(H);if(te){var X=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(X,[]),text:X}}},fe.list=function(H){var te=this.rules.block.list.exec(H);if(te){var X,re,he,De,z,V,G,J,q,ee,ue,Ne,je=te[1].trim(),Ye=je.length>1,Je={type:"list",raw:"",ordered:Ye,start:Ye?+je.slice(0,-1):"",loose:!1,items:[]};je=Ye?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Ye?je:"[*+-]");for(var it=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");H&&(Ne=!1,!(!(te=it.exec(H))||this.rules.block.hr.test(H)));){if(X=te[0],H=H.substring(X.length),J=te[2].split(`
`,1)[0],q=H.split(`
`,1)[0],this.options.pedantic?(De=2,ue=J.trimLeft()):(De=te[2].search(/[^ ]/),De=De>4?1:De,ue=J.slice(De),De+=te[1].length),V=!1,!J&&/^ *$/.test(q)&&(X+=q+`
`,H=H.substring(q.length+1),Ne=!0),!Ne)for(var _e=new RegExp("^ {0,"+Math.min(3,De-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,De-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,De-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,De-1)+"}#");H&&(ee=H.split(`
`,1)[0],J=ee,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(J)||nt.test(J)||_e.test(J)||tt.test(H)));){if(J.search(/[^ ]/)>=De||!J.trim())ue+=`
`+J.slice(De);else if(!V)ue+=`
`+J;else break;!V&&!J.trim()&&(V=!0),X+=ee+`
`,H=H.substring(ee.length+1)}Je.loose||(G?Je.loose=!0:/\n *\n *$/.test(X)&&(G=!0)),this.options.gfm&&(re=/^\[[ xX]\] /.exec(ue),re&&(he=re[0]!=="[ ] ",ue=ue.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:X,task:!!re,checked:he,loose:!1,text:ue}),Je.raw+=X}Je.items[Je.items.length-1].raw=X.trimRight(),Je.items[Je.items.length-1].text=ue.trimRight(),Je.raw=Je.raw.trimRight();var ze=Je.items.length;for(z=0;z<ze;z++){this.lexer.state.top=!1,Je.items[z].tokens=this.lexer.blockTokens(Je.items[z].text,[]);var ht=Je.items[z].tokens.filter(function(Z){return Z.type==="space"}),_=ht.every(function(Z){for(var ve=Z.raw.split(""),Be=0,He=M(ve),Xe;!(Xe=He()).done;){var st=Xe.value;if(st===`
`&&(Be+=1),Be>1)return!0}return!1});!Je.loose&&ht.length&&_&&(Je.loose=!0,Je.items[z].loose=!0)}return Je}},fe.html=function(H){var te=this.rules.block.html.exec(H);if(te){var X={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var re=this.options.sanitizer?this.options.sanitizer(te[0]):b(te[0]);X.type="paragraph",X.text=re,X.tokens=this.lexer.inline(re)}return X}},fe.def=function(H){var te=this.rules.block.def.exec(H);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var X=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:X,raw:te[0],href:te[2],title:te[3]}}},fe.table=function(H){var te=this.rules.block.table.exec(H);if(te){var X={type:"table",header:I(te[1]).map(function(G){return{text:G}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(X.header.length===X.align.length){X.raw=te[0];var re=X.align.length,he,De,z,V;for(he=0;he<re;he++)/^ *-+: *$/.test(X.align[he])?X.align[he]="right":/^ *:-+: *$/.test(X.align[he])?X.align[he]="center":/^ *:-+ *$/.test(X.align[he])?X.align[he]="left":X.align[he]=null;for(re=X.rows.length,he=0;he<re;he++)X.rows[he]=I(X.rows[he],X.header.length).map(function(G){return{text:G}});for(re=X.header.length,De=0;De<re;De++)X.header[De].tokens=this.lexer.inline(X.header[De].text);for(re=X.rows.length,De=0;De<re;De++)for(V=X.rows[De],z=0;z<V.length;z++)V[z].tokens=this.lexer.inline(V[z].text);return X}}},fe.lheading=function(H){var te=this.rules.block.lheading.exec(H);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},fe.paragraph=function(H){var te=this.rules.block.paragraph.exec(H);if(te){var X=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:X,tokens:this.lexer.inline(X)}}},fe.text=function(H){var te=this.rules.block.text.exec(H);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},fe.escape=function(H){var te=this.rules.inline.escape.exec(H);if(te)return{type:"escape",raw:te[0],text:b(te[1])}},fe.tag=function(H){var te=this.rules.inline.tag.exec(H);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):b(te[0]):te[0]}},fe.link=function(H){var te=this.rules.inline.link.exec(H);if(te){var X=te[2].trim();if(!this.options.pedantic&&/^</.test(X)){if(!/>$/.test(X))return;var re=h(X.slice(0,-1),"\\");if((X.length-re.length)%2===0)return}else{var he=w(te[2],"()");if(he>-1){var De=te[0].indexOf("!")===0?5:4,z=De+te[1].length+he;te[2]=te[2].substring(0,he),te[0]=te[0].substring(0,z).trim(),te[3]=""}}var V=te[2],G="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);J&&(V=J[1],G=J[3])}else G=te[3]?te[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(X)?V=V.slice(1):V=V.slice(1,-1)),W(te,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},fe.reflink=function(H,te){var X;if((X=this.rules.inline.reflink.exec(H))||(X=this.rules.inline.nolink.exec(H))){var re=(X[2]||X[1]).replace(/\s+/g," ");if(re=te[re.toLowerCase()],!re||!re.href){var he=X[0].charAt(0);return{type:"text",raw:he,text:he}}return W(X,re,X[0],this.lexer)}},fe.emStrong=function(H,te,X){X===void 0&&(X="");var re=this.rules.inline.emStrong.lDelim.exec(H);if(re&&!(re[3]&&X.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var he=re[1]||re[2]||"";if(!he||he&&(X===""||this.rules.inline.punctuation.exec(X))){var De=re[0].length-1,z,V,G=De,J=0,q=re[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,te=te.slice(-1*H.length+De);(re=q.exec(te))!=null;)if(z=re[1]||re[2]||re[3]||re[4]||re[5]||re[6],!!z){if(V=z.length,re[3]||re[4]){G+=V;continue}else if((re[5]||re[6])&&De%3&&!((De+V)%3)){J+=V;continue}if(G-=V,!(G>0)){if(V=Math.min(V,V+G+J),Math.min(De,V)%2){var ee=H.slice(1,De+re.index+V);return{type:"em",raw:H.slice(0,De+re.index+V+1),text:ee,tokens:this.lexer.inlineTokens(ee)}}var ue=H.slice(2,De+re.index+V-1);return{type:"strong",raw:H.slice(0,De+re.index+V+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}}}}},fe.codespan=function(H){var te=this.rules.inline.code.exec(H);if(te){var X=te[2].replace(/\n/g," "),re=/[^ ]/.test(X),he=/^ /.test(X)&&/ $/.test(X);return re&&he&&(X=X.substring(1,X.length-1)),X=b(X,!0),{type:"codespan",raw:te[0],text:X}}},fe.br=function(H){var te=this.rules.inline.br.exec(H);if(te)return{type:"br",raw:te[0]}},fe.del=function(H){var te=this.rules.inline.del.exec(H);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},fe.autolink=function(H,te){var X=this.rules.inline.autolink.exec(H);if(X){var re,he;return X[2]==="@"?(re=b(this.options.mangle?te(X[1]):X[1]),he="mailto:"+re):(re=b(X[1]),he=re),{type:"link",raw:X[0],text:re,href:he,tokens:[{type:"text",raw:re,text:re}]}}},fe.url=function(H,te){var X;if(X=this.rules.inline.url.exec(H)){var re,he;if(X[2]==="@")re=b(this.options.mangle?te(X[0]):X[0]),he="mailto:"+re;else{var De;do De=X[0],X[0]=this.rules.inline._backpedal.exec(X[0])[0];while(De!==X[0]);re=b(X[0]),X[1]==="www."?he="http://"+re:he=re}return{type:"link",raw:X[0],text:re,href:he,tokens:[{type:"text",raw:re,text:re}]}}},fe.inlineText=function(H,te){var X=this.rules.inline.text.exec(H);if(X){var re;return this.lexer.state.inRawBlock?re=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):b(X[0]):X[0]:re=b(this.options.smartypants?te(X[0]):X[0]),{type:"text",raw:X[0],text:re}}},Ce}(),A={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};A._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,A._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,A.def=n(A.def).replace("label",A._label).replace("title",A._title).getRegex(),A.bullet=/(?:[*+-]|\d{1,9}[.)])/,A.listItemStart=n(/^( *)(bull) */).replace("bull",A.bullet).getRegex(),A.list=n(A.list).replace(/bull/g,A.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+A.def.source+")").getRegex(),A._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",A._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,A.html=n(A.html,"i").replace("comment",A._comment).replace("tag",A._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),A.paragraph=n(A._paragraph).replace("hr",A.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",A._tag).getRegex(),A.blockquote=n(A.blockquote).replace("paragraph",A.paragraph).getRegex(),A.normal=D({},A),A.gfm=D({},A.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),A.gfm.table=n(A.gfm.table).replace("hr",A.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",A._tag).getRegex(),A.gfm.paragraph=n(A._paragraph).replace("hr",A.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",A.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",A._tag).getRegex(),A.pedantic=D({},A.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",A._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:n(A.normal._paragraph).replace("hr",A.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",A.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var L={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};L._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",L.punctuation=n(L.punctuation).replace(/punctuation/g,L._punctuation).getRegex(),L.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,L.escapedEmSt=/\\\*|\\_/g,L._comment=n(A._comment).replace("(?:-->|$)","-->").getRegex(),L.emStrong.lDelim=n(L.emStrong.lDelim).replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimAst=n(L.emStrong.rDelimAst,"g").replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimUnd=n(L.emStrong.rDelimUnd,"g").replace(/punct/g,L._punctuation).getRegex(),L._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,L._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,L._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,L.autolink=n(L.autolink).replace("scheme",L._scheme).replace("email",L._email).getRegex(),L._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,L.tag=n(L.tag).replace("comment",L._comment).replace("attribute",L._attribute).getRegex(),L._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,L._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,L._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,L.link=n(L.link).replace("label",L._label).replace("href",L._href).replace("title",L._title).getRegex(),L.reflink=n(L.reflink).replace("label",L._label).replace("ref",A._label).getRegex(),L.nolink=n(L.nolink).replace("ref",A._label).getRegex(),L.reflinkSearch=n(L.reflinkSearch,"g").replace("reflink",L.reflink).replace("nolink",L.nolink).getRegex(),L.normal=D({},L),L.pedantic=D({},L.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",L._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",L._label).getRegex()}),L.gfm=D({},L.normal,{escape:n(L.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),L.gfm.url=n(L.gfm.url,"i").replace("email",L.gfm._extended_email).getRegex(),L.breaks=D({},L.gfm,{br:n(L.br).replace("{2,}","*").getRegex(),text:n(L.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(Ce){var fe="",ne,H,te=Ce.length;for(ne=0;ne<te;ne++)H=Ce.charCodeAt(ne),Math.random()>.5&&(H="x"+H.toString(16)),fe+="&#"+H+";";return fe}var le=function(){function Ce(ne){this.tokens=[],this.tokens.links=Object.create(null),this.options=ne||pe.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var H={block:A.normal,inline:L.normal};this.options.pedantic?(H.block=A.pedantic,H.inline=L.pedantic):this.options.gfm&&(H.block=A.gfm,this.options.breaks?H.inline=L.breaks:H.inline=L.gfm),this.tokenizer.rules=H}Ce.lex=function(H,te){var X=new Ce(te);return X.lex(H)},Ce.lexInline=function(H,te){var X=new Ce(te);return X.inlineTokens(H)};var fe=Ce.prototype;return fe.lex=function(H){H=H.replace(/\r\n|\r/g,`
`),this.blockTokens(H,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},fe.blockTokens=function(H,te){var X=this;te===void 0&&(te=[]),this.options.pedantic?H=H.replace(/\t/g,"    ").replace(/^ +$/gm,""):H=H.replace(/^( *)(\t+)/gm,function(G,J,q){return J+"    ".repeat(q.length)});for(var re,he,De,z;H;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(re=G.call({lexer:X},H,te))?(H=H.substring(re.raw.length),te.push(re),!0):!1}))){if(re=this.tokenizer.space(H)){H=H.substring(re.raw.length),re.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(re);continue}if(re=this.tokenizer.code(H)){H=H.substring(re.raw.length),he=te[te.length-1],he&&(he.type==="paragraph"||he.type==="text")?(he.raw+=`
`+re.raw,he.text+=`
`+re.text,this.inlineQueue[this.inlineQueue.length-1].src=he.text):te.push(re);continue}if(re=this.tokenizer.fences(H)){H=H.substring(re.raw.length),te.push(re);continue}if(re=this.tokenizer.heading(H)){H=H.substring(re.raw.length),te.push(re);continue}if(re=this.tokenizer.hr(H)){H=H.substring(re.raw.length),te.push(re);continue}if(re=this.tokenizer.blockquote(H)){H=H.substring(re.raw.length),te.push(re);continue}if(re=this.tokenizer.list(H)){H=H.substring(re.raw.length),te.push(re);continue}if(re=this.tokenizer.html(H)){H=H.substring(re.raw.length),te.push(re);continue}if(re=this.tokenizer.def(H)){H=H.substring(re.raw.length),he=te[te.length-1],he&&(he.type==="paragraph"||he.type==="text")?(he.raw+=`
`+re.raw,he.text+=`
`+re.raw,this.inlineQueue[this.inlineQueue.length-1].src=he.text):this.tokens.links[re.tag]||(this.tokens.links[re.tag]={href:re.href,title:re.title});continue}if(re=this.tokenizer.table(H)){H=H.substring(re.raw.length),te.push(re);continue}if(re=this.tokenizer.lheading(H)){H=H.substring(re.raw.length),te.push(re);continue}if(De=H,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,J=H.slice(1),q=void 0;X.options.extensions.startBlock.forEach(function(ee){q=ee.call({lexer:this},J),typeof q=="number"&&q>=0&&(G=Math.min(G,q))}),G<1/0&&G>=0&&(De=H.substring(0,G+1))}(),this.state.top&&(re=this.tokenizer.paragraph(De))){he=te[te.length-1],z&&he.type==="paragraph"?(he.raw+=`
`+re.raw,he.text+=`
`+re.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=he.text):te.push(re),z=De.length!==H.length,H=H.substring(re.raw.length);continue}if(re=this.tokenizer.text(H)){H=H.substring(re.raw.length),he=te[te.length-1],he&&he.type==="text"?(he.raw+=`
`+re.raw,he.text+=`
`+re.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=he.text):te.push(re);continue}if(H){var V="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,te},fe.inline=function(H,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:H,tokens:te}),te},fe.inlineTokens=function(H,te){var X=this;te===void 0&&(te=[]);var re,he,De,z=H,V,G,J;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(z))!=null;)q.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(z=z.slice(0,V.index)+"["+F("a",V[0].length-2)+"]"+z.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(z))!=null;)z=z.slice(0,V.index)+"["+F("a",V[0].length-2)+"]"+z.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(z))!=null;)z=z.slice(0,V.index)+"++"+z.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;H;)if(G||(J=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(re=ue.call({lexer:X},H,te))?(H=H.substring(re.raw.length),te.push(re),!0):!1}))){if(re=this.tokenizer.escape(H)){H=H.substring(re.raw.length),te.push(re);continue}if(re=this.tokenizer.tag(H)){H=H.substring(re.raw.length),he=te[te.length-1],he&&re.type==="text"&&he.type==="text"?(he.raw+=re.raw,he.text+=re.text):te.push(re);continue}if(re=this.tokenizer.link(H)){H=H.substring(re.raw.length),te.push(re);continue}if(re=this.tokenizer.reflink(H,this.tokens.links)){H=H.substring(re.raw.length),he=te[te.length-1],he&&re.type==="text"&&he.type==="text"?(he.raw+=re.raw,he.text+=re.text):te.push(re);continue}if(re=this.tokenizer.emStrong(H,z,J)){H=H.substring(re.raw.length),te.push(re);continue}if(re=this.tokenizer.codespan(H)){H=H.substring(re.raw.length),te.push(re);continue}if(re=this.tokenizer.br(H)){H=H.substring(re.raw.length),te.push(re);continue}if(re=this.tokenizer.del(H)){H=H.substring(re.raw.length),te.push(re);continue}if(re=this.tokenizer.autolink(H,x)){H=H.substring(re.raw.length),te.push(re);continue}if(!this.state.inLink&&(re=this.tokenizer.url(H,x))){H=H.substring(re.raw.length),te.push(re);continue}if(De=H,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Ne=H.slice(1),je=void 0;X.options.extensions.startInline.forEach(function(Ye){je=Ye.call({lexer:this},Ne),typeof je=="number"&&je>=0&&(ue=Math.min(ue,je))}),ue<1/0&&ue>=0&&(De=H.substring(0,ue+1))}(),re=this.tokenizer.inlineText(De,O)){H=H.substring(re.raw.length),re.raw.slice(-1)!=="_"&&(J=re.raw.slice(-1)),G=!0,he=te[te.length-1],he&&he.type==="text"?(he.raw+=re.raw,he.text+=re.text):te.push(re);continue}if(H){var ee="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return te},E(Ce,null,[{key:"rules",get:function(){return{block:A,inline:L}}}]),Ce}(),me=function(){function Ce(ne){this.options=ne||pe.defaults}var fe=Ce.prototype;return fe.code=function(H,te,X){var re=(te||"").match(/\S*/)[0];if(this.options.highlight){var he=this.options.highlight(H,re);he!=null&&he!==H&&(X=!0,H=he)}return H=H.replace(/\n$/,"")+`
`,re?'<pre><code class="'+this.options.langPrefix+b(re,!0)+'">'+(X?H:b(H,!0))+`</code></pre>
`:"<pre><code>"+(X?H:b(H,!0))+`</code></pre>
`},fe.blockquote=function(H){return`<blockquote>
`+H+`</blockquote>
`},fe.html=function(H){return H},fe.heading=function(H,te,X,re){if(this.options.headerIds){var he=this.options.headerPrefix+re.slug(X);return"<h"+te+' id="'+he+'">'+H+"</h"+te+`>
`}return"<h"+te+">"+H+"</h"+te+`>
`},fe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},fe.list=function(H,te,X){var re=te?"ol":"ul",he=te&&X!==1?' start="'+X+'"':"";return"<"+re+he+`>
`+H+"</"+re+`>
`},fe.listitem=function(H){return"<li>"+H+`</li>
`},fe.checkbox=function(H){return"<input "+(H?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},fe.paragraph=function(H){return"<p>"+H+`</p>
`},fe.table=function(H,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+H+`</thead>
`+te+`</table>
`},fe.tablerow=function(H){return`<tr>
`+H+`</tr>
`},fe.tablecell=function(H,te){var X=te.header?"th":"td",re=te.align?"<"+X+' align="'+te.align+'">':"<"+X+">";return re+H+("</"+X+`>
`)},fe.strong=function(H){return"<strong>"+H+"</strong>"},fe.em=function(H){return"<em>"+H+"</em>"},fe.codespan=function(H){return"<code>"+H+"</code>"},fe.br=function(){return this.options.xhtml?"<br/>":"<br>"},fe.del=function(H){return"<del>"+H+"</del>"},fe.link=function(H,te,X){if(H=d(this.options.sanitize,this.options.baseUrl,H),H===null)return X;var re='<a href="'+b(H)+'"';return te&&(re+=' title="'+te+'"'),re+=">"+X+"</a>",re},fe.image=function(H,te,X){if(H=d(this.options.sanitize,this.options.baseUrl,H),H===null)return X;var re='<img src="'+H+'" alt="'+X+'"';return te&&(re+=' title="'+te+'"'),re+=this.options.xhtml?"/>":">",re},fe.text=function(H){return H},Ce}(),ye=function(){function Ce(){}var fe=Ce.prototype;return fe.strong=function(H){return H},fe.em=function(H){return H},fe.codespan=function(H){return H},fe.del=function(H){return H},fe.html=function(H){return H},fe.text=function(H){return H},fe.link=function(H,te,X){return""+X},fe.image=function(H,te,X){return""+X},fe.br=function(){return""},Ce}(),we=function(){function Ce(){this.seen={}}var fe=Ce.prototype;return fe.serialize=function(H){return H.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},fe.getNextSafeSlug=function(H,te){var X=H,re=0;if(this.seen.hasOwnProperty(X)){re=this.seen[H];do re++,X=H+"-"+re;while(this.seen.hasOwnProperty(X))}return te||(this.seen[H]=re,this.seen[X]=0),X},fe.slug=function(H,te){te===void 0&&(te={});var X=this.serialize(H);return this.getNextSafeSlug(X,te.dryrun)},Ce}(),de=function(){function Ce(ne){this.options=ne||pe.defaults,this.options.renderer=this.options.renderer||new me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new we}Ce.parse=function(H,te){var X=new Ce(te);return X.parse(H)},Ce.parseInline=function(H,te){var X=new Ce(te);return X.parseInline(H)};var fe=Ce.prototype;return fe.parse=function(H,te){te===void 0&&(te=!0);var X="",re,he,De,z,V,G,J,q,ee,ue,Ne,je,Ye,Je,it,_e,tt,rt,nt,ze=H.length;for(re=0;re<ze;re++){if(ue=H[re],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(nt=this.options.extensions.renderers[ue.type].call({parser:this},ue),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){X+=nt||"";continue}switch(ue.type){case"space":continue;case"hr":{X+=this.renderer.hr();continue}case"heading":{X+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,s(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{X+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(q="",J="",z=ue.header.length,he=0;he<z;he++)J+=this.renderer.tablecell(this.parseInline(ue.header[he].tokens),{header:!0,align:ue.align[he]});for(q+=this.renderer.tablerow(J),ee="",z=ue.rows.length,he=0;he<z;he++){for(G=ue.rows[he],J="",V=G.length,De=0;De<V;De++)J+=this.renderer.tablecell(this.parseInline(G[De].tokens),{header:!1,align:ue.align[De]});ee+=this.renderer.tablerow(J)}X+=this.renderer.table(q,ee);continue}case"blockquote":{ee=this.parse(ue.tokens),X+=this.renderer.blockquote(ee);continue}case"list":{for(Ne=ue.ordered,je=ue.start,Ye=ue.loose,z=ue.items.length,ee="",he=0;he<z;he++)it=ue.items[he],_e=it.checked,tt=it.task,Je="",it.task&&(rt=this.renderer.checkbox(_e),Ye?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=rt+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=rt+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:rt}):Je+=rt),Je+=this.parse(it.tokens,Ye),ee+=this.renderer.listitem(Je,tt,_e);X+=this.renderer.list(ee,Ne,je);continue}case"html":{X+=this.renderer.html(ue.text);continue}case"paragraph":{X+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for(ee=ue.tokens?this.parseInline(ue.tokens):ue.text;re+1<ze&&H[re+1].type==="text";)ue=H[++re],ee+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);X+=te?this.renderer.paragraph(ee):ee;continue}default:{var ht='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(ht);return}else throw new Error(ht)}}}return X},fe.parseInline=function(H,te){te=te||this.renderer;var X="",re,he,De,z=H.length;for(re=0;re<z;re++){if(he=H[re],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(De=this.options.extensions.renderers[he.type].call({parser:this},he),De!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(he.type))){X+=De||"";continue}switch(he.type){case"escape":{X+=te.text(he.text);break}case"html":{X+=te.html(he.text);break}case"link":{X+=te.link(he.href,he.title,this.parseInline(he.tokens,te));break}case"image":{X+=te.image(he.href,he.title,he.text);break}case"strong":{X+=te.strong(this.parseInline(he.tokens,te));break}case"em":{X+=te.em(this.parseInline(he.tokens,te));break}case"codespan":{X+=te.codespan(he.text);break}case"br":{X+=te.br();break}case"del":{X+=te.del(this.parseInline(he.tokens,te));break}case"text":{X+=te.text(he.text);break}default:{var V='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return X},Ce}();function be(Ce,fe,ne){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof fe=="function"&&(ne=fe,fe=null),fe=D({},be.defaults,fe||{}),k(fe),ne){var H=fe.highlight,te;try{te=le.lex(Ce,fe)}catch(z){return ne(z)}var X=function(V){var G;if(!V)try{fe.walkTokens&&be.walkTokens(te,fe.walkTokens),G=de.parse(te,fe)}catch(J){V=J}return fe.highlight=H,V?ne(V):ne(null,G)};if(!H||H.length<3||(delete fe.highlight,!te.length))return X();var re=0;be.walkTokens(te,function(z){z.type==="code"&&(re++,setTimeout(function(){H(z.text,z.lang,function(V,G){if(V)return X(V);G!=null&&G!==z.text&&(z.text=G,z.escaped=!0),re--,re===0&&X()})},0))}),re===0&&X();return}function he(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+b(z.message+"",!0)+"</pre>";throw z}try{var De=le.lex(Ce,fe);if(fe.walkTokens){if(fe.async)return Promise.all(be.walkTokens(De,fe.walkTokens)).then(function(){return de.parse(De,fe)}).catch(he);be.walkTokens(De,fe.walkTokens)}return de.parse(De,fe)}catch(z){he(z)}}be.options=be.setOptions=function(Ce){return D(be.defaults,Ce),$(be.defaults),be},be.getDefaults=P,be.defaults=pe.defaults,be.use=function(){for(var Ce=arguments.length,fe=new Array(Ce),ne=0;ne<Ce;ne++)fe[ne]=arguments[ne];var H=D.apply(void 0,[{}].concat(fe)),te=be.defaults.extensions||{renderers:{},childTokens:{}},X;fe.forEach(function(re){if(re.extensions&&(X=!0,re.extensions.forEach(function(De){if(!De.name)throw new Error("extension name required");if(De.renderer){var z=te.renderers?te.renderers[De.name]:null;z?te.renderers[De.name]=function(){for(var V=arguments.length,G=new Array(V),J=0;J<V;J++)G[J]=arguments[J];var q=De.renderer.apply(this,G);return q===!1&&(q=z.apply(this,G)),q}:te.renderers[De.name]=De.renderer}if(De.tokenizer){if(!De.level||De.level!=="block"&&De.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[De.level]?te[De.level].unshift(De.tokenizer):te[De.level]=[De.tokenizer],De.start&&(De.level==="block"?te.startBlock?te.startBlock.push(De.start):te.startBlock=[De.start]:De.level==="inline"&&(te.startInline?te.startInline.push(De.start):te.startInline=[De.start]))}De.childTokens&&(te.childTokens[De.name]=De.childTokens)})),re.renderer&&function(){var De=be.defaults.renderer||new me,z=function(J){var q=De[J];De[J]=function(){for(var ee=arguments.length,ue=new Array(ee),Ne=0;Ne<ee;Ne++)ue[Ne]=arguments[Ne];var je=re.renderer[J].apply(De,ue);return je===!1&&(je=q.apply(De,ue)),je}};for(var V in re.renderer)z(V);H.renderer=De}(),re.tokenizer&&function(){var De=be.defaults.tokenizer||new N,z=function(J){var q=De[J];De[J]=function(){for(var ee=arguments.length,ue=new Array(ee),Ne=0;Ne<ee;Ne++)ue[Ne]=arguments[Ne];var je=re.tokenizer[J].apply(De,ue);return je===!1&&(je=q.apply(De,ue)),je}};for(var V in re.tokenizer)z(V);H.tokenizer=De}(),re.walkTokens){var he=be.defaults.walkTokens;H.walkTokens=function(De){var z=[];return z.push(re.walkTokens.call(this,De)),he&&(z=z.concat(he.call(this,De))),z}}X&&(H.extensions=te),be.setOptions(H)})},be.walkTokens=function(Ce,fe){for(var ne=[],H=function(){var he=X.value;switch(ne=ne.concat(fe.call(be,he)),he.type){case"table":{for(var De=M(he.header),z;!(z=De()).done;){var V=z.value;ne=ne.concat(be.walkTokens(V.tokens,fe))}for(var G=M(he.rows),J;!(J=G()).done;)for(var q=J.value,ee=M(q),ue;!(ue=ee()).done;){var Ne=ue.value;ne=ne.concat(be.walkTokens(Ne.tokens,fe))}break}case"list":{ne=ne.concat(be.walkTokens(he.items,fe));break}default:be.defaults.extensions&&be.defaults.extensions.childTokens&&be.defaults.extensions.childTokens[he.type]?be.defaults.extensions.childTokens[he.type].forEach(function(je){ne=ne.concat(be.walkTokens(he[je],fe))}):he.tokens&&(ne=ne.concat(be.walkTokens(he.tokens,fe)))}},te=M(Ce),X;!(X=te()).done;)H();return ne},be.parseInline=function(Ce,fe){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");fe=D({},be.defaults,fe||{}),k(fe);try{var ne=le.lexInline(Ce,fe);return fe.walkTokens&&be.walkTokens(ne,fe.walkTokens),de.parseInline(ne,fe)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+b(H.message+"",!0)+"</pre>";throw H}},be.Parser=de,be.parser=de.parse,be.Renderer=me,be.TextRenderer=ye,be.Lexer=le,be.lexer=le.lex,be.Tokenizer=N,be.Slugger=we,be.parse=be;var ie=be.options,Ie=be.setOptions,ce=be.use,Y=be.walkTokens,B=be.parseInline,se=be,Se=de.parse,Ae=le.lex;pe.Lexer=le,pe.Parser=de,pe.Renderer=me,pe.Slugger=we,pe.TextRenderer=ye,pe.Tokenizer=N,pe.getDefaults=P,pe.lexer=Ae,pe.marked=be,pe.options=ie,pe.parse=se,pe.parseInline=B,pe.parser=Se,pe.setOptions=Ie,pe.use=ce,pe.walkTokens=Y,Object.defineProperty(pe,"__esModule",{value:!0})}),define(Pe[120],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.rot=e.$Yl=void 0;function E($,m,y){return Math.min(Math.max($,m),y)}e.$Yl=E;function T($,m){return(m+$%m)%m}e.rot=T;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$1l=C;class M{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$2l=M;class P{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const y=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$3l=P}),function(){function pe(C){const M=[];typeof C=="number"&&M.push("code/timeOrigin",C);function P(m){M.push(m,Date.now())}function $(){const m=[];for(let y=0;y<M.length;y+=2)m.push({name:M[y],startTime:M[y+1]});return m}return{mark:P,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?pe():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const P of performance.getEntriesByType("mark"))M.push({name:P.name,startTime:Math.round(C+P.startTime)});return M}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return pe(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),pe()}function E(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=E(T))}(),function(pe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var T in E)(typeof exports=="object"?exports:pe)[T]=E[T]}}(typeof self<"u"?self:this,function(){return function(pe){var e={};function E(T){if(e[T])return e[T].exports;var C=e[T]={i:T,l:!1,exports:{}};return pe[T].call(C.exports,C,C.exports,E),C.l=!0,C.exports}return E.m=pe,E.c=e,E.d=function(T,C,M){E.o(T,C)||Object.defineProperty(T,C,{enumerable:!0,get:M})},E.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},E.t=function(T,C){if(1&C&&(T=E(T)),8&C||4&C&&typeof T=="object"&&T&&T.__esModule)return T;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:T}),2&C&&typeof T!="string")for(var P in T)E.d(M,P,function($){return T[$]}.bind(null,P));return M},E.n=function(T){var C=T&&T.__esModule?function(){return T.default}:function(){return T};return E.d(C,"a",C),C},E.o=function(T,C){return Object.prototype.hasOwnProperty.call(T,C)},E.p="",E(E.s=0)}([function(pe,e,E){(function(T){var C;e=pe.exports=ce,C=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],m=e.src=[],y=0,R=y++;m[R]="0|[1-9]\\d*";var S=y++;m[S]="[0-9]+";var l=y++;m[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=y++;m[p]="("+m[R]+")\\.("+m[R]+")\\.("+m[R]+")";var b=y++;m[b]="("+m[S]+")\\.("+m[S]+")\\.("+m[S]+")";var a=y++;m[a]="(?:"+m[R]+"|"+m[l]+")";var s=y++;m[s]="(?:"+m[S]+"|"+m[l]+")";var t=y++;m[t]="(?:-("+m[a]+"(?:\\."+m[a]+")*))";var n=y++;m[n]="(?:-?("+m[s]+"(?:\\."+m[s]+")*))";var o=y++;m[o]="[0-9A-Za-z-]+";var c=y++;m[c]="(?:\\+("+m[o]+"(?:\\."+m[o]+")*))";var d=y++,i="v?"+m[p]+m[t]+"?"+m[c]+"?";m[d]="^"+i+"$";var r="[v=\\s]*"+m[b]+m[n]+"?"+m[c]+"?",u=y++;m[u]="^"+r+"$";var f=y++;m[f]="((?:<|>)?=?)";var v=y++;m[v]=m[S]+"|x|X|\\*";var g=y++;m[g]=m[R]+"|x|X|\\*";var D=y++;m[D]="[v=\\s]*("+m[g]+")(?:\\.("+m[g]+")(?:\\.("+m[g]+")(?:"+m[t]+")?"+m[c]+"?)?)?";var I=y++;m[I]="[v=\\s]*("+m[v]+")(?:\\.("+m[v]+")(?:\\.("+m[v]+")(?:"+m[n]+")?"+m[c]+"?)?)?";var h=y++;m[h]="^"+m[f]+"\\s*"+m[D]+"$";var w=y++;m[w]="^"+m[f]+"\\s*"+m[I]+"$";var k=y++;m[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=y++;m[F]="(?:~>?)";var W=y++;m[W]="(\\s*)"+m[F]+"\\s+",$[W]=new RegExp(m[W],"g");var Q=y++;m[Q]="^"+m[F]+m[D]+"$";var N=y++;m[N]="^"+m[F]+m[I]+"$";var A=y++;m[A]="(?:\\^)";var L=y++;m[L]="(\\s*)"+m[A]+"\\s+",$[L]=new RegExp(m[L],"g");var O=y++;m[O]="^"+m[A]+m[D]+"$";var x=y++;m[x]="^"+m[A]+m[I]+"$";var le=y++;m[le]="^"+m[f]+"\\s*("+r+")$|^$";var me=y++;m[me]="^"+m[f]+"\\s*("+i+")$|^$";var ye=y++;m[ye]="(\\s*)"+m[f]+"\\s*("+r+"|"+m[D]+")",$[ye]=new RegExp(m[ye],"g");var we=y++;m[we]="^\\s*("+m[D]+")\\s+-\\s+("+m[D]+")\\s*$";var de=y++;m[de]="^\\s*("+m[I]+")\\s+-\\s+("+m[I]+")\\s*$";var be=y++;m[be]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)C(ie,m[ie]),$[ie]||($[ie]=new RegExp(m[ie]));function Ie(q,ee){if(q instanceof ce)return q;if(typeof q!="string"||q.length>M||!(ee?$[u]:$[d]).test(q))return null;try{return new ce(q,ee)}catch{return null}}function ce(q,ee){if(q instanceof ce){if(q.loose===ee)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ce))return new ce(q,ee);C("SemVer",q,ee),this.loose=ee;var ue=q.trim().match(ee?$[u]:$[d]);if(!ue)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var je=+Ne;if(je>=0&&je<P)return je}return Ne}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=Ie,e.valid=function(q,ee){var ue=Ie(q,ee);return ue?ue.version:null},e.clean=function(q,ee){var ue=Ie(q.trim().replace(/^[=v]+/,""),ee);return ue?ue.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(q){return C("SemVer.compare",this.version,this.loose,q),q instanceof ce||(q=new ce(q,this.loose)),this.compareMain(q)||this.comparePre(q)},ce.prototype.compareMain=function(q){return q instanceof ce||(q=new ce(q,this.loose)),B(this.major,q.major)||B(this.minor,q.minor)||B(this.patch,q.patch)},ce.prototype.comparePre=function(q){if(q instanceof ce||(q=new ce(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var ee=0;do{var ue=this.prerelease[ee],Ne=q.prerelease[ee];if(C("prerelease compare",ee,ue,Ne),ue===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ue===void 0)return-1;if(ue!==Ne)return B(ue,Ne)}while(++ee)},ce.prototype.inc=function(q,ee){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,ee,ue,Ne){typeof ue=="string"&&(Ne=ue,ue=void 0);try{return new ce(q,ue).inc(ee,Ne).version}catch{return null}},e.diff=function(q,ee){if(Ce(q,ee))return null;var ue=Ie(q),Ne=Ie(ee);if(ue.prerelease.length||Ne.prerelease.length){for(var je in ue)if((je==="major"||je==="minor"||je==="patch")&&ue[je]!==Ne[je])return"pre"+je;return"prerelease"}for(var je in ue)if((je==="major"||je==="minor"||je==="patch")&&ue[je]!==Ne[je])return je},e.compareIdentifiers=B;var Y=/^[0-9]+$/;function B(q,ee){var ue=Y.test(q),Ne=Y.test(ee);return ue&&Ne&&(q=+q,ee=+ee),ue&&!Ne?-1:Ne&&!ue?1:q<ee?-1:q>ee?1:0}function se(q,ee,ue){return new ce(q,ue).compare(new ce(ee,ue))}function Se(q,ee,ue){return se(q,ee,ue)>0}function Ae(q,ee,ue){return se(q,ee,ue)<0}function Ce(q,ee,ue){return se(q,ee,ue)===0}function fe(q,ee,ue){return se(q,ee,ue)!==0}function ne(q,ee,ue){return se(q,ee,ue)>=0}function H(q,ee,ue){return se(q,ee,ue)<=0}function te(q,ee,ue,Ne){var je;switch(ee){case"===":typeof q=="object"&&(q=q.version),typeof ue=="object"&&(ue=ue.version),je=q===ue;break;case"!==":typeof q=="object"&&(q=q.version),typeof ue=="object"&&(ue=ue.version),je=q!==ue;break;case"":case"=":case"==":je=Ce(q,ue,Ne);break;case"!=":je=fe(q,ue,Ne);break;case">":je=Se(q,ue,Ne);break;case">=":je=ne(q,ue,Ne);break;case"<":je=Ae(q,ue,Ne);break;case"<=":je=H(q,ue,Ne);break;default:throw new TypeError("Invalid operator: "+ee)}return je}function X(q,ee){if(q instanceof X){if(q.loose===ee)return q;q=q.value}if(!(this instanceof X))return new X(q,ee);C("comparator",q,ee),this.loose=ee,this.parse(q),this.semver===re?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(q,ee){return B(ee,q)},e.major=function(q,ee){return new ce(q,ee).major},e.minor=function(q,ee){return new ce(q,ee).minor},e.patch=function(q,ee){return new ce(q,ee).patch},e.compare=se,e.compareLoose=function(q,ee){return se(q,ee,!0)},e.rcompare=function(q,ee,ue){return se(ee,q,ue)},e.sort=function(q,ee){return q.sort(function(ue,Ne){return e.compare(ue,Ne,ee)})},e.rsort=function(q,ee){return q.sort(function(ue,Ne){return e.rcompare(ue,Ne,ee)})},e.gt=Se,e.lt=Ae,e.eq=Ce,e.neq=fe,e.gte=ne,e.lte=H,e.cmp=te,e.Comparator=X;var re={};function he(q,ee){if(q instanceof he)return q.loose===ee?q:new he(q.raw,ee);if(q instanceof X)return new he(q.value,ee);if(!(this instanceof he))return new he(q,ee);if(this.loose=ee,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function De(q){return!q||q.toLowerCase()==="x"||q==="*"}function z(q,ee,ue,Ne,je,Ye,Je,it,_e,tt,rt,nt,ze){return((ee=De(ue)?"":De(Ne)?">="+ue+".0.0":De(je)?">="+ue+"."+Ne+".0":">="+ee)+" "+(it=De(_e)?"":De(tt)?"<"+(+_e+1)+".0.0":De(rt)?"<"+_e+"."+(+tt+1)+".0":nt?"<="+_e+"."+tt+"."+rt+"-"+nt:"<="+it)).trim()}function V(q,ee){for(var ue=0;ue<q.length;ue++)if(!q[ue].test(ee))return!1;if(ee.prerelease.length){for(ue=0;ue<q.length;ue++)if(C(q[ue].semver),q[ue].semver!==re&&q[ue].semver.prerelease.length>0){var Ne=q[ue].semver;if(Ne.major===ee.major&&Ne.minor===ee.minor&&Ne.patch===ee.patch)return!0}return!1}return!0}function G(q,ee,ue){try{ee=new he(ee,ue)}catch{return!1}return ee.test(q)}function J(q,ee,ue,Ne){var je,Ye,Je,it,_e;switch(q=new ce(q,Ne),ee=new he(ee,Ne),ue){case">":je=Se,Ye=H,Je=Ae,it=">",_e=">=";break;case"<":je=Ae,Ye=ne,Je=Se,it="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(q,ee,Ne))return!1;for(var tt=0;tt<ee.set.length;++tt){var rt=ee.set[tt],nt=null,ze=null;if(rt.forEach(function(ht){ht.semver===re&&(ht=new X(">=0.0.0")),nt=nt||ht,ze=ze||ht,je(ht.semver,nt.semver,Ne)?nt=ht:Je(ht.semver,ze.semver,Ne)&&(ze=ht)}),nt.operator===it||nt.operator===_e||(!ze.operator||ze.operator===it)&&Ye(q,ze.semver)||ze.operator===_e&&Je(q,ze.semver))return!1}return!0}X.prototype.parse=function(q){var ee=this.loose?$[le]:$[me],ue=q.match(ee);if(!ue)throw new TypeError("Invalid comparator: "+q);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new ce(ue[2],this.loose):this.semver=re},X.prototype.toString=function(){return this.value},X.prototype.test=function(q){return C("Comparator.test",q,this.loose),this.semver===re||(typeof q=="string"&&(q=new ce(q,this.loose)),te(q,this.operator,this.semver,this.loose))},X.prototype.intersects=function(q,ee){if(!(q instanceof X))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new he(q.value,ee),G(this.value,ue,ee);if(q.operator==="")return ue=new he(this.value,ee),G(q.semver,ue,ee);var Ne=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Ye=this.semver.version===q.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),it=te(this.semver,"<",q.semver,ee)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),_e=te(this.semver,">",q.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Ne||je||Ye&&Je||it||_e},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(q){var ee=this.loose;q=q.trim(),C("range",q,ee);var ue=ee?$[de]:$[we];q=q.replace(ue,z),C("hyphen replace",q),q=q.replace($[ye],"$1$2$3"),C("comparator trim",q,$[ye]),q=(q=(q=q.replace($[W],"$1~")).replace($[L],"$1^")).split(/\s+/).join(" ");var Ne=ee?$[le]:$[me],je=q.split(" ").map(function(Ye){return function(Je,it){return C("comp",Je),Je=function(_e,tt){return _e.trim().split(/\s+/).map(function(rt){return function(nt,ze){C("caret",nt,ze);var ht=ze?$[x]:$[O];return nt.replace(ht,function(_,Z,ve,Be,He){var Xe;return C("caret",nt,_,Z,ve,Be,He),De(Z)?Xe="":De(ve)?Xe=">="+Z+".0.0 <"+(+Z+1)+".0.0":De(Be)?Xe=Z==="0"?">="+Z+"."+ve+".0 <"+Z+"."+(+ve+1)+".0":">="+Z+"."+ve+".0 <"+(+Z+1)+".0.0":He?(C("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Xe=Z==="0"?ve==="0"?">="+Z+"."+ve+"."+Be+He+" <"+Z+"."+ve+"."+(+Be+1):">="+Z+"."+ve+"."+Be+He+" <"+Z+"."+(+ve+1)+".0":">="+Z+"."+ve+"."+Be+He+" <"+(+Z+1)+".0.0"):(C("no pr"),Xe=Z==="0"?ve==="0"?">="+Z+"."+ve+"."+Be+" <"+Z+"."+ve+"."+(+Be+1):">="+Z+"."+ve+"."+Be+" <"+Z+"."+(+ve+1)+".0":">="+Z+"."+ve+"."+Be+" <"+(+Z+1)+".0.0"),C("caret return",Xe),Xe})}(rt,tt)}).join(" ")}(Je,it),C("caret",Je),Je=function(_e,tt){return _e.trim().split(/\s+/).map(function(rt){return function(nt,ze){var ht=ze?$[N]:$[Q];return nt.replace(ht,function(_,Z,ve,Be,He){var Xe;return C("tilde",nt,_,Z,ve,Be,He),De(Z)?Xe="":De(ve)?Xe=">="+Z+".0.0 <"+(+Z+1)+".0.0":De(Be)?Xe=">="+Z+"."+ve+".0 <"+Z+"."+(+ve+1)+".0":He?(C("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Xe=">="+Z+"."+ve+"."+Be+He+" <"+Z+"."+(+ve+1)+".0"):Xe=">="+Z+"."+ve+"."+Be+" <"+Z+"."+(+ve+1)+".0",C("tilde return",Xe),Xe})}(rt,tt)}).join(" ")}(Je,it),C("tildes",Je),Je=function(_e,tt){return C("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(rt){return function(nt,ze){nt=nt.trim();var ht=ze?$[w]:$[h];return nt.replace(ht,function(_,Z,ve,Be,He,Xe){C("xRange",nt,_,Z,ve,Be,He,Xe);var st=De(ve),pt=st||De(Be),Te=pt||De(He);return Z==="="&&Te&&(Z=""),st?_=Z===">"||Z==="<"?"<0.0.0":"*":Z&&Te?(pt&&(Be=0),Te&&(He=0),Z===">"?(Z=">=",pt?(ve=+ve+1,Be=0,He=0):Te&&(Be=+Be+1,He=0)):Z==="<="&&(Z="<",pt?ve=+ve+1:Be=+Be+1),_=Z+ve+"."+Be+"."+He):pt?_=">="+ve+".0.0 <"+(+ve+1)+".0.0":Te&&(_=">="+ve+"."+Be+".0 <"+ve+"."+(+Be+1)+".0"),C("xRange return",_),_})}(rt,tt)}).join(" ")}(Je,it),C("xrange",Je),Je=function(_e,tt){return C("replaceStars",_e,tt),_e.trim().replace($[be],"")}(Je,it),C("stars",Je),Je}(Ye,ee)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Ye){return!!Ye.match(Ne)})),je=je.map(function(Ye){return new X(Ye,ee)})},he.prototype.intersects=function(q,ee){if(!(q instanceof he))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(Ne){return q.set.some(function(je){return je.every(function(Ye){return Ne.intersects(Ye,ee)})})})})},e.toComparators=function(q,ee){return new he(q,ee).set.map(function(ue){return ue.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},he.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new ce(q,this.loose));for(var ee=0;ee<this.set.length;ee++)if(V(this.set[ee],q))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(q,ee,ue){var Ne=null,je=null;try{var Ye=new he(ee,ue)}catch{return null}return q.forEach(function(Je){Ye.test(Je)&&(Ne&&je.compare(Je)!==-1||(je=new ce(Ne=Je,ue)))}),Ne},e.minSatisfying=function(q,ee,ue){var Ne=null,je=null;try{var Ye=new he(ee,ue)}catch{return null}return q.forEach(function(Je){Ye.test(Je)&&(Ne&&je.compare(Je)!==1||(je=new ce(Ne=Je,ue)))}),Ne},e.validRange=function(q,ee){try{return new he(q,ee).range||"*"}catch{return null}},e.ltr=function(q,ee,ue){return J(q,ee,"<",ue)},e.gtr=function(q,ee,ue){return J(q,ee,">",ue)},e.outside=J,e.prerelease=function(q,ee){var ue=Ie(q,ee);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(q,ee,ue){return q=new he(q,ue),ee=new he(ee,ue),q.intersects(ee)},e.coerce=function(q){if(q instanceof ce)return q;if(typeof q!="string")return null;var ee=q.match($[k]);return ee==null?null:Ie((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,E(1))},function(pe,e){var E,T,C=pe.exports={};function M(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function $(s){if(E===setTimeout)return setTimeout(s,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(s,0);try{return E(s,0)}catch{try{return E.call(null,s,0)}catch{return E.call(this,s,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{T=typeof clearTimeout=="function"?clearTimeout:P}catch{T=P}})();var m,y=[],R=!1,S=-1;function l(){R&&m&&(R=!1,m.length?y=m.concat(y):S=-1,y.length&&p())}function p(){if(!R){var s=$(l);R=!0;for(var t=y.length;t;){for(m=y,y=[];++S<t;)m&&m[S].run();S=-1,t=y.length}m=null,R=!1,function(n){if(T===clearTimeout)return clearTimeout(n);if((T===P||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(n);try{T(n)}catch{try{return T.call(null,n)}catch{return T.call(this,n)}}}(s)}}function b(s,t){this.fun=s,this.array=t}function a(){}C.nextTick=function(s){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];y.push(new b(s,t)),y.length!==1||R||$(p)},b.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=a,C.addListener=a,C.once=a,C.off=a,C.removeListener=a,C.removeAllListeners=a,C.emit=a,C.prependListener=a,C.prependOnceListener=a,C.listeners=function(s){return[]},C.binding=function(s){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(s){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Pe[121],Re([1,0,11,6]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function C(c){const d=c;return d?typeof d.read=="function":!1}e.$3d=C;function M(c){const d=c;return d?[d.on,d.pause,d.resume,d.destroy].every(i=>typeof i=="function"):!1}e.$4d=M;function P(c){const d=c;return d?M(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.$5d=P;function $(c,d){return new m(c,d)}e.$6d=$;class m{constructor(d,i){this.e=d,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(i=>i(d))}h(d){this.c.error.length===0?(0,E.$Z)(d):this.c.error.slice(0).forEach(i=>i(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,i){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(d,i){if(this.a.destroyed)return;let r;switch(d){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const u=r.indexOf(i);u>=0&&r.splice(u,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(c,d){const i=[];let r;for(;(r=c.read())!==null;)i.push(r);return d(i)}e.$7d=y;function R(c,d,i){const r=[];let u;for(;(u=c.read())!==null&&r.length<i;)r.push(u);return u===null&&r.length>0?d(r):{read:()=>{if(r.length>0)return r.shift();if(typeof u<"u"){const f=u;return u=void 0,f}return c.read()}}}e.$8d=R;function S(c,d){return new Promise((i,r)=>{const u=[];l(c,{onData:f=>{d&&u.push(f)},onError:f=>{d?r(f):i(void 0)},onEnd:()=>{i(d?d(u):void 0)}})})}e.$9d=S;function l(c,d,i){c.on("error",r=>{i?.isCancellationRequested||d.onError(r)}),c.on("end",()=>{i?.isCancellationRequested||d.onEnd()}),c.on("data",r=>{i?.isCancellationRequested||d.onData(r)})}e.$0d=l;function p(c,d){return new Promise((i,r)=>{const u=new T.$Qc,f=[],v=I=>{if(f.push(I),f.length>d)return u.dispose(),c.pause(),i({stream:c,buffer:f,ended:!1})},g=I=>(u.dispose(),r(I)),D=()=>(u.dispose(),i({stream:c,buffer:f,ended:!0}));u.add((0,T.$Pc)(()=>c.removeListener("error",g))),c.on("error",g),u.add((0,T.$Pc)(()=>c.removeListener("end",D))),c.on("end",D),u.add((0,T.$Pc)(()=>c.removeListener("data",v))),c.on("data",v)})}e.$$d=p;function b(c,d){const i=$(d);return i.end(c),i}e.$_d=b;function a(){const c=$(()=>{throw new Error("not supported")});return c.end(),c}e.$ae=a;function s(c){let d=!1;return{read:()=>d?null:(d=!0,c)}}e.$be=s;function t(c,d,i){const r=$(i);return l(c,{onData:u=>r.write(d.data(u)),onError:u=>r.error(d.error?d.error(u):u),onEnd:()=>r.end()}),r}e.$ce=t;function n(c,d,i){let r=!1;return{read:()=>{const u=d.read();return r?u:(r=!0,u!==null?i([c,u]):c)}}}e.$de=n;function o(c,d,i){let r=!1;const u=$(i);return l(d,{onData:f=>r?u.write(f):(r=!0,u.write(i([c,f]))),onError:f=>u.error(f),onEnd:()=>{r||(r=!0,u.write(c)),u.end()}}),u}e.$ee=o}),define(Pe[24],Re([1,0,39,121]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const C=typeof Buffer<"u",M=new E.$U(()=>new Uint8Array(256));let P,$;class m{static alloc(k){return C?new m(Buffer.allocUnsafe(k)):new m(new Uint8Array(k))}static wrap(k){return C&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new m(k)}static fromString(k,F){return!(F?.dontUseNodeBuffer||!1)&&C?new m(Buffer.from(k)):(P||(P=new TextEncoder),new m(P.encode(k)))}static fromByteArray(k){const F=m.alloc(k.length);for(let W=0,Q=k.length;W<Q;W++)F.buffer[W]=k[W];return F}static concat(k,F){if(typeof F>"u"){F=0;for(let N=0,A=k.length;N<A;N++)F+=k[N].byteLength}const W=m.alloc(F);let Q=0;for(let N=0,A=k.length;N<A;N++){const L=k[N];W.set(L,Q),Q+=L.byteLength}return W}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=m.alloc(this.byteLength);return k.set(this),k}toString(){return C?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(k,F){return new m(this.buffer.subarray(k,F))}set(k,F){if(k instanceof m)this.buffer.set(k.buffer,F);else if(k instanceof Uint8Array)this.buffer.set(k,F);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),F);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return l(this.buffer,k)}writeUInt32BE(k,F){p(this.buffer,k,F)}readUInt32LE(k){return b(this.buffer,k)}writeUInt32LE(k,F){a(this.buffer,k,F)}readUInt8(k){return s(this.buffer,k)}writeUInt8(k,F){t(this.buffer,k,F)}indexOf(k,F=0){return y(this.buffer,k instanceof m?k.buffer:k,F)}}e.$fe=m;function y(w,k,F=0){const W=k.byteLength,Q=w.byteLength;if(W===0)return 0;if(W===1)return w.indexOf(k[0]);if(W>Q-F)return-1;const N=M.value;N.fill(k.length);for(let x=0;x<k.length;x++)N[k[x]]=k.length-x-1;let A=F+k.length-1,L=A,O=-1;for(;A<Q;)if(w[A]===k[L]){if(L===0){O=A;break}A--,L--}else A+=Math.max(k.length-L,N[w[A]]),L=k.length-1;return O}e.$ge=y;function R(w,k){return w[k+0]<<0>>>0|w[k+1]<<8>>>0}e.$he=R;function S(w,k,F){w[F+0]=k&255,k=k>>>8,w[F+1]=k&255}e.$ie=S;function l(w,k){return w[k]*2**24+w[k+1]*2**16+w[k+2]*2**8+w[k+3]}e.$je=l;function p(w,k,F){w[F+3]=k,k=k>>>8,w[F+2]=k,k=k>>>8,w[F+1]=k,k=k>>>8,w[F]=k}e.$ke=p;function b(w,k){return w[k+0]<<0>>>0|w[k+1]<<8>>>0|w[k+2]<<16>>>0|w[k+3]<<24>>>0}e.$le=b;function a(w,k,F){w[F+0]=k&255,k=k>>>8,w[F+1]=k&255,k=k>>>8,w[F+2]=k&255,k=k>>>8,w[F+3]=k&255}e.$me=a;function s(w,k){return w[k]}e.$ne=s;function t(w,k,F){w[F]=k}e.$oe=t;function n(w){return T.$7d(w,k=>m.concat(k))}e.$pe=n;function o(w){return T.$be(w)}e.$qe=o;function c(w){return T.$9d(w,k=>m.concat(k))}e.$re=c;async function d(w){return w.ended?m.concat(w.buffer):m.concat([...w.buffer,await c(w.stream)])}e.$se=d;function i(w){return T.$_d(w,k=>m.concat(k))}e.$te=i;function r(w){return T.$ce(w,{data:k=>typeof k=="string"?m.fromString(k):m.wrap(k)},k=>m.concat(k))}e.$ue=r;function u(w){return T.$6d(k=>m.concat(k),w)}e.$ve=u;function f(w,k){return T.$de(w,k,F=>m.concat(F))}e.$we=f;function v(w,k){return T.$ee(w,k,F=>m.concat(F))}e.$xe=v;function g(w){let k=0,F=0,W=0;const Q=new Uint8Array(Math.floor(w.length/4*3)),N=L=>{switch(F){case 3:Q[W++]=k|L,F=0;break;case 2:Q[W++]=k|L>>>2,k=L<<6,F=3;break;case 1:Q[W++]=k|L>>>4,k=L<<4,F=2;break;default:k=L<<2,F=1}};for(let L=0;L<w.length;L++){const O=w.charCodeAt(L);if(O>=65&&O<=90)N(O-65);else if(O>=97&&O<=122)N(O-97+26);else if(O>=48&&O<=57)N(O-48+52);else if(O===43||O===45)N(62);else if(O===47||O===95)N(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${w[L]}`)}}const A=W;for(;F>0;)N(0);return m.wrap(Q).slice(0,A)}e.$ye=g;const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:w},k=!0,F=!1){const W=F?I:D;let Q="";const N=w.byteLength%3;let A=0;for(;A<w.byteLength-N;A+=3){const L=w[A+0],O=w[A+1],x=w[A+2];Q+=W[L>>>2],Q+=W[(L<<4|O>>>4)&63],Q+=W[(O<<2|x>>>6)&63],Q+=W[x&63]}if(N===1){const L=w[A+0];Q+=W[L>>>2],Q+=W[L<<4&63],k&&(Q+="==")}else if(N===2){const L=w[A+0],O=w[A+1];Q+=W[L>>>2],Q+=W[(L<<4|O>>>4)&63],Q+=W[O<<2&63],k&&(Q+="=")}return Q}e.$ze=h}),define(Pe[122],Re([1,0,28,12]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.FuzzyScore=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.or=void 0;function C(...X){return function(re,he){for(let De=0,z=X.length;De<z;De++){const V=X[De](re,he);if(V)return V}return null}}e.or=C,e.$Mj=M.bind(void 0,!1),e.$Nj=M.bind(void 0,!0);function M(X,re,he){if(!he||he.length<re.length)return null;let De;return X?De=T.$7e(he,re):De=he.indexOf(re)===0,De?re.length>0?[{start:0,end:re.length}]:[]:null}function P(X,re){const he=re.toLowerCase().indexOf(X.toLowerCase());return he===-1?null:[{start:he,end:he+X.length}]}e.$Oj=P;function $(X,re){return m(X.toLowerCase(),re.toLowerCase(),0,0)}e.$Pj=$;function m(X,re,he,De){if(he===X.length)return[];if(De===re.length)return null;if(X[he]===re[De]){let z=null;return(z=m(X,re,he+1,De+1))?t({start:De,end:De+1},z):null}return m(X,re,he,De+1)}function y(X){return 97<=X&&X<=122}function R(X){return 65<=X&&X<=90}e.$Qj=R;function S(X){return 48<=X&&X<=57}function l(X){return X===32||X===9||X===10||X===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(X=>p.add(X.charCodeAt(0)));function b(X){return l(X)||p.has(X)}function a(X,re){return X===re||b(X)&&b(re)}function s(X){return y(X)||R(X)||S(X)}function t(X,re){return re.length===0?re=[X]:X.end===re[0].start?re[0].start=X.start:re.unshift(X),re}function n(X,re){for(let he=re;he<X.length;he++){const De=X.charCodeAt(he);if(R(De)||S(De)||he>0&&!s(X.charCodeAt(he-1)))return he}return X.length}function o(X,re,he,De){if(he===X.length)return[];if(De===re.length)return null;if(X[he]!==re[De].toLowerCase())return null;{let z=null,V=De+1;for(z=o(X,re,he+1,De+1);!z&&(V=n(re,V))<re.length;)z=o(X,re,he+1,V),V++;return z===null?null:t({start:De,end:De+1},z)}}function c(X){let re=0,he=0,De=0,z=0,V=0;for(let ue=0;ue<X.length;ue++)V=X.charCodeAt(ue),R(V)&&re++,y(V)&&he++,s(V)&&De++,S(V)&&z++;const G=re/X.length,J=he/X.length,q=De/X.length,ee=z/X.length;return{upperPercent:G,lowerPercent:J,alphaPercent:q,numericPercent:ee}}function d(X){const{upperPercent:re,lowerPercent:he}=X;return he===0&&re>.6}function i(X){const{upperPercent:re,lowerPercent:he,alphaPercent:De,numericPercent:z}=X;return he>.2&&re<.8&&De>.6&&z<.2}function r(X){let re=0,he=0,De=0,z=0;for(let V=0;V<X.length;V++)De=X.charCodeAt(V),R(De)&&re++,y(De)&&he++,l(De)&&z++;return(re===0||he===0)&&z===0?X.length<=30:re<=5}function u(X,re){if(!re||(re=re.trim(),re.length===0)||!r(X)||re.length>60)return null;const he=c(re);if(!i(he)){if(!d(he))return null;re=re.toLowerCase()}let De=null,z=0;for(X=X.toLowerCase();z<re.length&&(De=o(X,re,0,z))===null;)z=n(re,z+1);return De}e.$Rj=u;function f(X,re,he=!1){if(!re||re.length===0)return null;let De=null,z=0;for(X=X.toLowerCase(),re=re.toLowerCase();z<re.length&&(De=v(X,re,0,z,he))===null;)z=g(re,z+1);return De}e.$Sj=f;function v(X,re,he,De,z){if(he===X.length)return[];if(De===re.length)return null;if(a(X.charCodeAt(he),re.charCodeAt(De))){let V=null,G=De+1;if(V=v(X,re,he+1,De+1,z),!z)for(;!V&&(G=g(re,G))<re.length;)V=v(X,re,he+1,G,z),G++;return V?X.charCodeAt(he)!==re.charCodeAt(De)?V:t({start:De,end:De+1},V):null}else return null}function g(X,re){for(let he=re;he<X.length;he++)if(b(X.charCodeAt(he))||he>0&&b(X.charCodeAt(he-1)))return he;return X.length}const D=C(e.$Nj,u,P),I=C(e.$Nj,u,$),h=new E.$Cc(1e4);function w(X,re,he=!1){if(typeof X!="string"||typeof re!="string")return null;let De=h.get(X);De||(De=new RegExp(T.$Pe(X),"i"),h.set(X,De));const z=De.exec(re);return z?[{start:z.index,end:z.index+z[0].length}]:he?I(X,re):D(X,re)}e.$Tj=w;function k(X,re){const he=Se(X,X.toLowerCase(),0,re,re.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return he?W(he):null}e.$Uj=k;function F(X,re,he,De,z,V){const G=Math.min(13,X.length);for(;he<G;he++){const J=Se(X,re,he,De,z,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,V]}e.$Vj=F;function W(X){if(typeof X>"u")return[];const re=[],he=X[1];for(let De=X.length-1;De>1;De--){const z=X[De]+he,V=re[re.length-1];V&&V.end===z?V.end=z+1:re.push({start:z,end:z+1})}return re}e.$Wj=W;const Q=128;function N(){const X=[],re=[];for(let he=0;he<=Q;he++)re[he]=0;for(let he=0;he<=Q;he++)X.push(re.slice(0));return X}function A(X){const re=[];for(let he=0;he<=X;he++)re[he]=0;return re}const L=A(2*Q),O=A(2*Q),x=N(),le=N(),me=N(),ye=!1;function we(X,re,he,De,z){function V(J,q,ee=" "){for(;J.length<q;)J=ee+J;return J}let G=` |   |${De.split("").map(J=>V(J,3)).join("|")}
`;for(let J=0;J<=he;J++)J===0?G+=" |":G+=`${re[J-1]}|`,G+=X[J].slice(0,z+1).map(q=>V(q.toString(),3)).join("|")+`
`;return G}function de(X,re,he,De){X=X.substr(re),he=he.substr(De),console.log(we(le,X,X.length,he,he.length)),console.log(we(me,X,X.length,he,he.length)),console.log(we(x,X,X.length,he,he.length))}function be(X,re){if(re<0||re>=X.length)return!1;const he=X.codePointAt(re);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$mf(he)}}function ie(X,re){if(re<0||re>=X.length)return!1;switch(X.charCodeAt(re)){case 32:case 9:return!0;default:return!1}}function Ie(X,re,he){return re[X]!==he[X]}function ce(X,re,he,De,z,V,G=!1){for(;re<he&&z<V;)X[re]===De[z]&&(G&&(L[re]=z),re+=1),z+=1;return re===he}e.$Xj=ce;var Y;(function(X){X[X.Diag=1]="Diag",X[X.Left=2]="Left",X[X.LeftLeft=3]="LeftLeft"})(Y||(Y={}));var B;(function(X){X.Default=[-100,0];function re(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}X.isDefault=re})(B||(e.FuzzyScore=B={}));class se{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(re,he){this.firstMatchCanBeWeak=re,this.boostFullMatch=he}}e.$Yj=se;function Se(X,re,he,De,z,V,G=se.default){const J=X.length>Q?Q:X.length,q=De.length>Q?Q:De.length;if(he>=J||V>=q||J-he>q-V||!ce(re,he,J,z,V,q,!0))return;Ae(J,q,he,V,re,z);let ee=1,ue=1,Ne=he,je=V;const Ye=[!1];for(ee=1,Ne=he;Ne<J;ee++,Ne++){const rt=L[Ne],nt=O[Ne],ze=Ne+1<J?O[Ne+1]:q;for(ue=rt-V+1,je=rt;je<ze;ue++,je++){let ht=Number.MIN_SAFE_INTEGER,_=!1;je<=nt&&(ht=Ce(X,re,Ne,he,De,z,je,q,V,x[ee-1][ue-1]===0,Ye));let Z=0;ht!==Number.MAX_SAFE_INTEGER&&(_=!0,Z=ht+le[ee-1][ue-1]);const ve=je>rt,Be=ve?le[ee][ue-1]+(x[ee][ue-1]>0?-5:0):0,He=je>rt+1&&x[ee][ue-1]>0,Xe=He?le[ee][ue-2]+(x[ee][ue-2]>0?-5:0):0;if(He&&(!ve||Xe>=Be)&&(!_||Xe>=Z))le[ee][ue]=Xe,me[ee][ue]=3,x[ee][ue]=0;else if(ve&&(!_||Be>=Z))le[ee][ue]=Be,me[ee][ue]=2,x[ee][ue]=0;else if(_)le[ee][ue]=Z,me[ee][ue]=1,x[ee][ue]=x[ee-1][ue-1]+1;else throw new Error("not possible")}}if(ye&&de(X,he,De,V),!Ye[0]&&!G.firstMatchCanBeWeak)return;ee--,ue--;const Je=[le[ee][ue],V];let it=0,_e=0;for(;ee>=1;){let rt=ue;do{const nt=me[ee][rt];if(nt===3)rt=rt-2;else if(nt===2)rt=rt-1;else break}while(rt>=1);it>1&&re[he+ee-1]===z[V+ue-1]&&!Ie(rt+V-1,De,z)&&it+1>x[ee][rt]&&(rt=ue),rt===ue?it++:it=1,_e||(_e=rt),ee--,ue=rt-1,Je.push(ue)}q===J&&G.boostFullMatch&&(Je[0]+=2);const tt=_e-J;return Je[0]-=tt,Je}e.$Zj=Se;function Ae(X,re,he,De,z,V){let G=X-1,J=re-1;for(;G>=he&&J>=De;)z[G]===V[J]&&(O[G]=J,G--),J--}function Ce(X,re,he,De,z,V,G,J,q,ee,ue){if(re[he]!==V[G])return Number.MIN_SAFE_INTEGER;let Ne=1,je=!1;return G===he-De?Ne=X[he]===z[G]?7:5:Ie(G,z,V)&&(G===0||!Ie(G-1,z,V))?(Ne=X[he]===z[G]?7:5,je=!0):be(V,G)&&(G===0||!be(V,G-1))?Ne=5:(be(V,G-1)||ie(V,G-1))&&(Ne=5,je=!0),Ne>1&&he===De&&(ue[0]=!0),je||(je=Ie(G,z,V)||be(V,G-1)||ie(V,G-1)),he===De?G>q&&(Ne-=je?3:5):ee?Ne+=je?2:0:Ne+=je?0:1,G+1===J&&(Ne-=je?3:5),Ne}function fe(X,re,he,De,z,V,G){return H(X,re,he,De,z,V,!0,G)}e.$1j=fe;function ne(X,re,he,De,z,V,G){return H(X,re,he,De,z,V,!1,G)}e.$2j=ne;function H(X,re,he,De,z,V,G,J){let q=Se(X,re,he,De,z,V,J);if(q&&!G)return q;if(X.length>=3){const ee=Math.min(7,X.length-1);for(let ue=he+1;ue<ee;ue++){const Ne=te(X,ue);if(Ne){const je=Se(Ne,Ne.toLowerCase(),he,De,z,V,J);je&&(je[0]-=3,(!q||je[0]>q[0])&&(q=je))}}}return q}function te(X,re){if(re+1>=X.length)return;const he=X[re],De=X[re+1];if(he!==De)return X.slice(0,re)+De+he+X.slice(re+2)}}),define(Pe[31],Re([1,0,12]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(T||(T={})),function(C){const M="error",P="warning",$="warn",m="info",y="ignore";function R(l){return l?E.$6e(M,l)?C.Error:E.$6e(P,l)||E.$6e($,l)?C.Warning:E.$6e(m,l)?C.Info:C.Ignore:C.Ignore}C.fromValue=R;function S(l){switch(l){case C.Error:return M;case C.Warning:return P;case C.Info:return m;default:return y}}C.toString=S}(T||(T={})),e.default=T}),define(Pe[123],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(Pe[50],Re([1,0,18,12]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const b=p.charCodeAt(0),a=this.b.charCodeAt(this.c);return b-a}value(){return this.b[this.c]}}e.$2h=C;class M{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,T.$Ze)(p,this.b,0,p.length,this.c,this.d):(0,T.$2e)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$3h=M;class P{constructor(p=!0,b=!0){this.f=p,this.g=b}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let b=p.length-1;b>=0;b--,this.c--){const a=this.b.charCodeAt(b);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===47||this.f&&b===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,T.$Ze)(p,this.b,0,p.length,this.d,this.e):(0,T.$2e)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$4h=P;var $;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})($||($={}));class m{constructor(p,b){this.f=p,this.g=b,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,T.$1e)(p,this.c.scheme);if(this.d[this.e]===2)return(0,T.$1e)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,T.$Ye)(p,this.c.query);if(this.d[this.e]===5)return(0,T.$Ye)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$5h=m;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(R||(R={}));class S{static forUris(p=()=>!1,b=()=>!1){return new S(new m(p,b))}static forPaths(p=!1){return new S(new P(void 0,!p))}static forStrings(){return new S(new C)}static forConfigKeys(){return new S(new M)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,b){if(b){const a=b.slice(0);(0,E.$Wb)(a);for(const s of a)this.set(s,p)}else{const a=p.slice(0);(0,E.$Wb)(a);for(const s of a)this.set(s[0],s[1])}}set(p,b){const a=this.b.reset(p);let s;this.c||(this.c=new y,this.c.segment=a.value());const t=[];for(s=this.c;;){const o=a.cmp(s.segment);if(o>0)s.left||(s.left=new y,s.left.segment=a.value()),t.push([-1,s]),s=s.left;else if(o<0)s.right||(s.right=new y,s.right.segment=a.value()),t.push([1,s]),s=s.right;else if(a.hasNext())a.next(),s.mid||(s.mid=new y,s.mid.segment=a.value()),t.push([0,s]),s=s.mid;else break}const n=s.value;s.value=b,s.key=p;for(let o=t.length-1;o>=0;o--){const c=t[o][1];c.updateHeight();const d=c.balanceFactor();if(d<-1||d>1){const i=t[o][0],r=t[o+1][0];if(i===1&&r===1)t[o][1]=c.rotateLeft();else if(i===-1&&r===-1)t[o][1]=c.rotateRight();else if(i===1&&r===-1)c.right=t[o+1][1]=t[o+1][1].rotateRight(),t[o][1]=c.rotateLeft();else if(i===-1&&r===1)c.left=t[o+1][1]=t[o+1][1].rotateLeft(),t[o][1]=c.rotateRight();else throw new Error;if(o>0)switch(t[o-1][0]){case-1:t[o-1][1].left=t[o][1];break;case 1:t[o-1][1].right=t[o][1];break;case 0:t[o-1][1].mid=t[o][1];break}else this.c=t[0][1]}}return n}get(p){return this.d(p)?.value}d(p){const b=this.b.reset(p);let a=this.c;for(;a;){const s=b.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(b.hasNext())b.next(),a=a.mid;else break}return a}has(p){const b=this.d(p);return!(b?.value===void 0&&b?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,b){const a=this.b.reset(p),s=[];let t=this.c;for(;t;){const n=a.cmp(t.segment);if(n>0)s.push([-1,t]),t=t.left;else if(n<0)s.push([1,t]),t=t.right;else if(a.hasNext())a.next(),s.push([0,t]),t=t.mid;else break}if(t){if(b?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this.f(t.right);if(n.key){const{key:o,value:c,segment:d}=n;this.e(n.key,!1),t.key=o,t.value=c,t.segment=d}}else{const n=t.left??t.right;if(s.length>0){const[o,c]=s[s.length-1];switch(o){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=s.length-1;n>=0;n--){const o=s[n][1];o.updateHeight();const c=o.balanceFactor();if(c>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),s[n][1]=o.rotateLeft()):c<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),s[n][1]=o.rotateRight()),n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const b=this.b.reset(p);let a=this.c,s;for(;a;){const t=b.cmp(a.segment);if(t>0)a=a.left;else if(t<0)a=a.right;else if(b.hasNext())b.next(),s=a.value||s,a=a.mid;else break}return a&&a.value||s}findSuperstr(p){return this.g(p,!1)}g(p,b){const a=this.b.reset(p);let s=this.c;for(;s;){const t=a.cmp(s.segment);if(t>0)s=s.left;else if(t<0)s=s.right;else if(a.hasNext())a.next(),s=s.mid;else return s.mid?this.h(s.mid):b?s.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[b,a]of this)p(a,b)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const b=[];return this.j(p,b),b[Symbol.iterator]()}j(p,b){p&&(p.left&&this.j(p.left,b),p.value&&b.push([p.key,p.value]),p.mid&&this.j(p.mid,b),p.right&&this.j(p.right,b))}_isBalanced(){const p=b=>{if(!b)return!0;const a=b.balanceFactor();return a<-1||a>1?!1:p(b.left)&&p(b.right)};return p(this.c)}}e.$6h=S}),define(Pe[45],Re([1,0,90]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$6j=e.ThemeColor=void 0;var T;(function(P){function $(m){return m&&typeof m=="object"&&typeof m.id=="string"}P.isThemeColor=$})(T||(e.ThemeColor=T={}));function C(P){return{id:P}}e.$6j=C;var M;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function m(n){const o=$.exec(n.id);if(!o)return m(E.$5j.error);const[,c,d]=o,i=["codicon","codicon-"+c];return d&&i.push("codicon-modifier-"+d.substring(1)),i}P.asClassNameArray=m;function y(n){return m(n).join(" ")}P.asClassName=y;function R(n){return"."+m(n).join(".")}P.asCSSSelector=R;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}P.isThemeIcon=S;const l=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function p(n){const o=l.exec(n);if(!o)return;const[,c]=o;return{id:c}}P.fromString=p;function b(n){return{id:n}}P.fromId=b;function a(n,o){let c=n.id;const d=c.lastIndexOf("~");return d!==-1&&(c=c.substring(0,d)),o&&(c=`${c}~${o}`),{id:c}}P.modify=a;function s(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}P.getModifier=s;function t(n,o){return n.id===o.id&&n.color?.id===o.color?.id}P.isEqual=t})(M||(e.ThemeIcon=M={}))}),define(Pe[124],Re([1,0,122,12,45]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=void 0;const M="$(",P=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${P.source}`,"g");function m(t){return t.replace($,(n,o)=>o?n:`\\${n}`)}e.$7j=m;const y=new RegExp(`\\\\${P.source}`,"g");function R(t){return t.replace(y,n=>`\\${n}`)}e.$8j=R;const S=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function l(t){return t.indexOf(M)===-1?t:t.replace(S,(n,o,c,d)=>c?n:o||d||"")}e.$9j=l;function p(t){return t?t.replace(/\$\((.*?)\)/g,(n,o)=>` ${o} `).trim():""}e.$0j=p;const b=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(t){b.lastIndex=0;let n="";const o=[];let c=0;for(;;){const d=b.lastIndex,i=b.exec(t),r=t.substring(d,i?.index);if(r.length>0){n+=r;for(let u=0;u<r.length;u++)o.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:o}}e.$$j=a;function s(t,n,o=!1){const{text:c,iconOffsets:d}=n;if(!d||d.length===0)return(0,E.$Tj)(t,c,o);const i=(0,T.$Ne)(c," "),r=c.length-i.length,u=(0,E.$Tj)(t,i,o);if(u)for(const f of u){const v=d[f.start+r]+r;f.start+=v,f.end+=v}return u}e.$_j=s}),define(Pe[33],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kg=e.$jg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(C){return E.test(C)}e.$jg=T,e.$kg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function($){for(let m=0;m<$.length;m++)$[m]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),P=[];for(let $=0;$<256;$++)P.push($.toString(16).padStart(2,"0"));return function(){C(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let m=0,y="";return y+=P[M[m++]],y+=P[M[m++]],y+=P[M[m++]],y+=P[M[m++]],y+="-",y+=P[M[m++]],y+=P[M[m++]],y+="-",y+=P[M[m++]],y+=P[M[m++]],y+="-",y+=P[M[m++]],y+=P[M[m++]],y+="-",y+=P[M[m++]],y+=P[M[m++]],y+=P[M[m++]],y+=P[M[m++]],y+=P[M[m++]],y+=P[M[m++]],y}}()}),define(Pe[125],Re([1,0,18,67,33]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.$_s=e.$$s=e.$0s=e.$9s=void 0;function M(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$9s=M;function P(S,l,p){const b={id:(0,C.$kg)(),name:S,uri:l,data:p};return{asString:async()=>"",asFile:()=>b,value:void 0}}e.$0s=P;class ${constructor(){this.a=new Map}get size(){let l=0;for(const p of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const p=[...this.a.keys()];return T.Iterable.some(this,([b,a])=>a.asFile())&&p.push("files"),R(m(l),p)}get(l){return this.a.get(this.b(l))?.[0]}append(l,p){const b=this.a.get(l);b?b.push(p):this.a.set(this.b(l),[p])}replace(l,p){this.a.set(this.b(l),[p])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,p]of this.a)for(const b of p)yield[l,b]}b(l){return m(l)}}e.$$s=$;function m(S){return S.toLowerCase()}function y(S,l){return R(m(S),l.map(m))}e.$_s=y;function R(S,l){if(S==="*/*")return l.length>0;if(l.includes(S))return!0;const p=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[b,a,s]=p;return s==="*"?l.some(t=>t.startsWith(a+"/")):!1}e.$at=Object.freeze({create:S=>(0,E.$Lb)(S.map(l=>l.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$at.split(S).filter(l=>!l.startsWith("#"))})}),define(Pe[126],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.StringEOL=void 0;var E;(function(C){C[C.Unknown=0]="Unknown",C[C.Invalid=3]="Invalid",C[C.LF=1]="LF",C[C.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function T(C){let M=0,P=0,$=0,m=0;for(let y=0,R=C.length;y<R;y++){const S=C.charCodeAt(y);S===13?(M===0&&(P=y),M++,y+1<R&&C.charCodeAt(y+1)===10?(m|=2,y++):m|=3,$=y+1):S===10&&(m|=1,M===0&&(P=y),M++,$=y+1)}return M===0&&(P=C.length),[M,P,C.length-$,m]}e.$dt=T}),define(Pe[127],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0,e.$as={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[128],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.$zt=e.IndentAction=void 0;var E;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class T{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let m=0,y=$.notIn.length;m<y;m++)switch($.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,m){if($.getTokenCount()===0)return!0;const y=$.findTokenIndexAtOffset(m-2),R=$.getStandardTokenType(y);return this.isOK(R)}g($,m){for(let y=$;y<=m;y++){const R=String.fromCharCode(y);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$zt=T;class C{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of $)M(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),M(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),M(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),M(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&M(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$At=C;function M(P,$,m){P.has($)?P.get($).push(m):P.set($,[m])}}),define(Pe[129],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EB=e.$DB=e.$CB=e.$BB=e.$AB=e.$zB=e.$yB=e.$xB=e.$wB=e.NodeColor=e.$vB=void 0;class E{constructor(s,t){this.piece=s,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$wB)return C(this.right);let s=this;for(;s.parent!==e.$wB&&s.parent.left!==s;)s=s.parent;return s.parent===e.$wB?e.$wB:s.parent}prev(){if(this.left!==e.$wB)return M(this.left);let s=this;for(;s.parent!==e.$wB&&s.parent.right!==s;)s=s.parent;return s.parent===e.$wB?e.$wB:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$vB=E;var T;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$wB=new E(null,0),e.$wB.parent=e.$wB,e.$wB.left=e.$wB,e.$wB.right=e.$wB,e.$wB.color=0;function C(a){for(;a.left!==e.$wB;)a=a.left;return a}e.$xB=C;function M(a){for(;a.right!==e.$wB;)a=a.right;return a}e.$yB=M;function P(a){return a===e.$wB?0:a.size_left+a.piece.length+P(a.right)}function $(a){return a===e.$wB?0:a.lf_left+a.piece.lineFeedCnt+$(a.right)}function m(){e.$wB.parent=e.$wB}function y(a,s){const t=s.right;t.size_left+=s.size_left+(s.piece?s.piece.length:0),t.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=t.left,t.left!==e.$wB&&(t.left.parent=s),t.parent=s.parent,s.parent===e.$wB?a.root=t:s.parent.left===s?s.parent.left=t:s.parent.right=t,t.left=s,s.parent=t}e.$zB=y;function R(a,s){const t=s.left;s.left=t.right,t.right!==e.$wB&&(t.right.parent=s),t.parent=s.parent,s.size_left-=t.size_left+(t.piece?t.piece.length:0),s.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),s.parent===e.$wB?a.root=t:s===s.parent.right?s.parent.right=t:s.parent.left=t,t.right=s,s.parent=t}e.$AB=R;function S(a,s){let t,n;if(s.left===e.$wB?(n=s,t=n.right):s.right===e.$wB?(n=s,t=n.left):(n=C(s.right),t=n.right),n===a.root){a.root=t,t.color=0,s.detach(),m(),a.root.parent=e.$wB;return}const o=n.color===1;if(n===n.parent.left?n.parent.left=t:n.parent.right=t,n===s?(t.parent=n.parent,b(a,t)):(n.parent===s?t.parent=n:t.parent=n.parent,b(a,t),n.left=s.left,n.right=s.right,n.parent=s.parent,n.color=s.color,s===a.root?a.root=n:s===s.parent.left?s.parent.left=n:s.parent.right=n,n.left!==e.$wB&&(n.left.parent=n),n.right!==e.$wB&&(n.right.parent=n),n.size_left=s.size_left,n.lf_left=s.lf_left,b(a,n)),s.detach(),t.parent.left===t){const d=P(t),i=$(t);if(d!==t.parent.size_left||i!==t.parent.lf_left){const r=d-t.parent.size_left,u=i-t.parent.lf_left;t.parent.size_left=d,t.parent.lf_left=i,p(a,t.parent,r,u)}}if(b(a,t.parent),o){m();return}let c;for(;t!==a.root&&t.color===0;)t===t.parent.left?(c=t.parent.right,c.color===1&&(c.color=0,t.parent.color=1,y(a,t.parent),c=t.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.right.color===0&&(c.left.color=0,c.color=1,R(a,c),c=t.parent.right),c.color=t.parent.color,t.parent.color=0,c.right.color=0,y(a,t.parent),t=a.root)):(c=t.parent.left,c.color===1&&(c.color=0,t.parent.color=1,R(a,t.parent),c=t.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.left.color===0&&(c.right.color=0,c.color=1,y(a,c),c=t.parent.left),c.color=t.parent.color,t.parent.color=0,c.left.color=0,R(a,t.parent),t=a.root));t.color=0,m()}e.$BB=S;function l(a,s){for(b(a,s);s!==a.root&&s.parent.color===1;)if(s.parent===s.parent.parent.left){const t=s.parent.parent.right;t.color===1?(s.parent.color=0,t.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,y(a,s)),s.parent.color=0,s.parent.parent.color=1,R(a,s.parent.parent))}else{const t=s.parent.parent.left;t.color===1?(s.parent.color=0,t.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,R(a,s)),s.parent.color=0,s.parent.parent.color=1,y(a,s.parent.parent))}a.root.color=0}e.$CB=l;function p(a,s,t,n){for(;s!==a.root&&s!==e.$wB;)s.parent.left===s&&(s.parent.size_left+=t,s.parent.lf_left+=n),s=s.parent}e.$DB=p;function b(a,s){let t=0,n=0;if(s!==a.root){for(;s!==a.root&&s===s.parent.right;)s=s.parent;if(s!==a.root)for(s=s.parent,t=P(s.left)-s.size_left,n=$(s.left)-s.lf_left,s.size_left+=t,s.lf_left+=n;s!==a.root&&(t!==0||n!==0);)s.parent.left===s&&(s.parent.size_left+=t,s.parent.lf_left+=n),s=s.parent}}e.$EB=b}),define(Pe[91],Re([1,0,130,29,92,129,93]),function(pe,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PB=e.$OB=e.$NB=e.$MB=e.$LB=void 0;const $=65535;function m(t){let n;return t[t.length-1]<65536?n=new Uint16Array(t.length):n=new Uint32Array(t.length),n.set(t,0),n}class y{constructor(n,o,c,d,i){this.lineStarts=n,this.cr=o,this.lf=c,this.crlf=d,this.isBasicASCII=i}}function R(t,n=!0){const o=[0];let c=1;for(let d=0,i=t.length;d<i;d++){const r=t.charCodeAt(d);r===13?d+1<i&&t.charCodeAt(d+1)===10?(o[c++]=d+2,d++):o[c++]=d+1:r===10&&(o[c++]=d+1)}return n?m(o):o}e.$LB=R;function S(t,n){t.length=0,t[0]=0;let o=1,c=0,d=0,i=0,r=!0;for(let f=0,v=n.length;f<v;f++){const g=n.charCodeAt(f);g===13?f+1<v&&n.charCodeAt(f+1)===10?(i++,t[o++]=f+2,f++):(c++,t[o++]=f+1):g===10?(d++,t[o++]=f+1):r&&g!==9&&(g<32||g>126)&&(r=!1)}const u=new y(m(t),c,d,i,r);return t.length=0,u}e.$MB=S;class l{constructor(n,o,c,d,i){this.bufferIndex=n,this.start=o,this.end=c,this.lineFeedCnt=d,this.length=i}}e.$NB=l;class p{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$OB=p;class b{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==M.$wB&&n.iterate(n.root,c=>(c!==M.$wB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class a{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const c=this.b;for(let d=0;d<c.length;d++){const i=c[d];if(i.node.parent===null||i.nodeStartOffset>=n){c[d]=null,o=!0;continue}}if(o){const d=[];for(const i of c)i!==null&&d.push(i);this.b=d}}}class s{constructor(n,o,c){this.create(n,o,c)}create(n,o,c){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=M.$wB,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=c;let d=null;for(let i=0,r=n.length;i<r;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=R(n[i].buffer));const u=new l(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),d=this.S(d,u)}this.h=new a(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=$,c=o-Math.floor(o/3),d=c*2;let i="",r=0;const u=[];if(this.iterate(this.root,f=>{const v=this.R(f),g=v.length;if(r<=c||r+g<d)return i+=v,r+=g,!0;const D=i.replace(/\r\n|\r|\n/g,n);return u.push(new p(D,R(D))),i=v,r=g,!0}),r>0){const f=i.replace(/\r\n|\r|\n/g,n);u.push(new p(f,R(f)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new b(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,d=>{if(d===M.$wB)return!0;const i=this.R(d),r=i.length,u=n.G(o),f=n.G(o+r),v=n.getValueInRange2(u,f);return o+=r,i===v})}getOffsetAt(n,o){let c=0,d=this.root;for(;d!==M.$wB;)if(d.left!==M.$wB&&d.lf_left+1>=n)d=d.left;else if(d.lf_left+d.piece.lineFeedCnt+1>=n){c+=d.size_left;const i=this.B(d,n-d.lf_left-2);return c+=i+o-1}else n-=d.lf_left+d.piece.lineFeedCnt,c+=d.size_left+d.piece.length,d=d.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,c=0;const d=n;for(;o!==M.$wB;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const i=this.A(o,n-o.size_left);if(c+=o.lf_left+i.index,i.index===0){const r=this.getOffsetAt(c+1,1),u=d-r;return new E.$Cs(c+1,u+1)}return new E.$Cs(c+1,i.remainder+1)}else if(n-=o.size_left+o.piece.length,c+=o.lf_left+o.piece.lineFeedCnt,o.right===M.$wB){const i=this.getOffsetAt(c+1,1),r=d-n-i;return new E.$Cs(c+1,r+1)}else o=o.right;return new E.$Cs(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),d=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,d);return o?o!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,o):i}getValueInRange2(n,o){if(n.node===o.node){const u=n.node,f=this.a[u.piece.bufferIndex].buffer,v=this.u(u.piece.bufferIndex,u.piece.start);return f.substring(v+n.remainder,v+o.remainder)}let c=n.node;const d=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let r=d.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==M.$wB;){const u=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);if(c===o.node){r+=u.substring(f,f+o.remainder);break}else r+=u.substr(f,c.piece.length);c=c.next()}return r}getLinesContent(){const n=[];let o=0,c="",d=!1;return this.iterate(this.root,i=>{if(i===M.$wB)return!0;const r=i.piece;let u=r.length;if(u===0)return!0;const f=this.a[r.bufferIndex].buffer,v=this.a[r.bufferIndex].lineStarts,g=r.start.line,D=r.end.line;let I=v[g]+r.start.column;if(d&&(f.charCodeAt(I)===10&&(I++,u--),n[o++]=c,c="",d=!1,u===0))return!0;if(g===D)return!this.f&&f.charCodeAt(I+u-1)===13?(d=!0,c+=f.substr(I,u-1)):c+=f.substr(I,u),!0;c+=this.f?f.substring(I,Math.max(I,v[g+1]-this.e)):f.substring(I,v[g+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;for(let h=g+1;h<D;h++)c=this.f?f.substring(v[h],v[h+1]-this.e):f.substring(v[h],v[h+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;return!this.f&&f.charCodeAt(v[D]+r.end.column-1)===13?(d=!0,r.end.column===0?o--:c=f.substr(v[D],r.end.column-1)):c=f.substr(v[D],r.end.column),!0}),d&&(n[o++]=c,c=""),n[o++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const c=this.a[o.piece.bufferIndex],d=this.u(o.piece.bufferIndex,o.piece.start);return c.buffer.charCodeAt(d)}else{const o=this.a[n.node.piece.bufferIndex],d=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(d)}}getLineCharCode(n,o){const c=this.H(n,o+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}findMatchesInNode(n,o,c,d,i,r,u,f,v,g,D){const I=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start),w=this.u(n.piece.bufferIndex,i),k=this.u(n.piece.bufferIndex,r);let F;const W={line:0,column:0};let Q,N;o._wordSeparators?(Q=I.buffer.substring(w,k),N=A=>A+w,o.reset(0)):(Q=I.buffer,N=A=>A,o.reset(w));do if(F=o.next(Q),F){if(N(F.index)>=k)return g;this.s(n,N(F.index)-h,W);const A=this.t(n.piece.bufferIndex,i,W),L=W.line===i.line?W.column-i.column+d:W.column+1,O=L+F[0].length;if(D[g++]=(0,P.$HB)(new T.$Ds(c+A,L,c+A,O),F,f),N(F.index)+F[0].length>=k||g>=v)return g}while(F);return g}findMatchesLineByLine(n,o,c,d){const i=[];let r=0;const u=new P.$KB(o.wordSeparators,o.regex);let f=this.H(n.startLineNumber,n.startColumn);if(f===null)return[];const v=this.H(n.endLineNumber,n.endColumn);if(v===null)return[];let g=this.s(f.node,f.remainder);const D=this.s(v.node,v.remainder);if(f.node===v.node)return this.findMatchesInNode(f.node,u,n.startLineNumber,n.startColumn,g,D,o,c,d,r,i),i;let I=n.startLineNumber,h=f.node;for(;h!==v.node;){const k=this.t(h.piece.bufferIndex,g,h.piece.end);if(k>=1){const W=this.a[h.piece.bufferIndex].lineStarts,Q=this.u(h.piece.bufferIndex,h.piece.start),N=W[g.line+k],A=I===n.startLineNumber?n.startColumn:1;if(r=this.findMatchesInNode(h,u,I,A,g,this.s(h,N-Q),o,c,d,r,i),r>=d)return i;I+=k}const F=I===n.startLineNumber?n.startColumn-1:0;if(I===n.endLineNumber){const W=this.getLineContent(I).substring(F,n.endColumn-1);return r=this.n(o,u,W,n.endLineNumber,F,r,i,c,d),i}if(r=this.n(o,u,this.getLineContent(I).substr(F),I,F,r,i,c,d),r>=d)return i;I++,f=this.H(I,1),h=f.node,g=this.s(f.node,f.remainder)}if(I===n.endLineNumber){const k=I===n.startLineNumber?n.startColumn-1:0,F=this.getLineContent(I).substring(k,n.endColumn-1);return r=this.n(o,u,F,n.endLineNumber,k,r,i,c,d),i}const w=I===n.startLineNumber?n.startColumn:1;return r=this.findMatchesInNode(v.node,u,I,w,g,D,o,c,d,r,i),i}n(n,o,c,d,i,r,u,f,v){const g=n.wordSeparators;if(!f&&n.simpleSearch){const I=n.simpleSearch,h=I.length,w=c.length;let k=-h;for(;(k=c.indexOf(I,k+h))!==-1;)if((!g||(0,P.$JB)(g,c,w,k,h))&&(u[r++]=new C.$Uu(new T.$Ds(d,k+1+i,d,k+1+h+i),null),r>=v))return r;return r}let D;o.reset(0);do if(D=o.next(c),D&&(u[r++]=(0,P.$HB)(new T.$Ds(d,D.index+1+i,d,D.index+1+D[0].length+i),D,f),r>=v))return r;while(D);return r}insert(n,o,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==M.$wB){const{node:d,remainder:i,nodeStartOffset:r}=this.G(n),u=d.piece,f=u.bufferIndex,v=this.s(d,i);if(d.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&r+u.length===n&&o.length<$){this.F(d,o),this.y();return}if(r===n)this.o(o,d),this.h.validate(n);else if(r+d.piece.length>n){const g=[];let D=new l(u.bufferIndex,v,u.end,this.t(u.bufferIndex,v,u.end),this.u(f,u.end)-this.u(f,v));if(this.K()&&this.M(o)&&this.I(d,i)===10){const k={line:D.start.line+1,column:0};D=new l(D.bufferIndex,k,D.end,this.t(D.bufferIndex,k,D.end),D.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(d,i-1)===13){const k=this.s(d,i-1);this.C(d,k),o="\r"+o,d.piece.length===0&&g.push(d)}else this.C(d,v);else this.C(d,v);const I=this.w(o);D.length>0&&this.S(d,D);let h=d;for(let w=0;w<I.length;w++)h=this.S(h,I[w]);this.v(g)}else this.q(o,d)}else{const d=this.w(o);let i=this.T(null,d[0]);for(let r=1;r<d.length;r++)i=this.S(i,d[r])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===M.$wB)return;const c=this.G(n),d=this.G(n+o),i=c.node,r=d.node;if(i===r){const I=this.s(i,c.remainder),h=this.s(i,d.remainder);if(c.nodeStartOffset===n){if(o===i.piece.length){const w=i.next();(0,M.$BB)(this,i),this.N(w),this.y();return}this.D(i,h),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+o){this.C(i,I),this.O(i),this.y();return}this.E(i,I,h),this.y();return}const u=[],f=this.s(i,c.remainder);this.C(i,f),this.h.validate(n),i.piece.length===0&&u.push(i);const v=this.s(r,d.remainder);this.D(r,v),r.piece.length===0&&u.push(r);const g=i.next();for(let I=g;I!==M.$wB&&I!==r;I=I.next())u.push(I);const D=i.piece.length===0?i.prev():i;this.v(u),this.O(D),this.y()}o(n,o){const c=[];if(this.K()&&this.M(n)&&this.L(o)){const r=o.piece,u={line:r.start.line+1,column:0},f=new l(r.bufferIndex,u,r.end,this.t(r.bufferIndex,u,r.end),r.length-1);o.piece=f,n+=`
`,(0,M.$DB)(this,o,-1,-1),o.piece.length===0&&c.push(o)}const d=this.w(n);let i=this.T(o,d[d.length-1]);for(let r=d.length-2;r>=0;r--)i=this.T(i,d[r]);this.N(i),this.v(c)}q(n,o){this.Q(n,o)&&(n+=`
`);const c=this.w(n),d=this.S(o,c[0]);let i=d;for(let r=1;r<c.length;r++)i=this.S(i,c[r]);this.N(d)}s(n,o,c){const d=n.piece,i=n.piece.bufferIndex,r=this.a[i].lineStarts,f=r[d.start.line]+d.start.column+o;let v=d.start.line,g=d.end.line,D=0,I=0,h=0;for(;v<=g&&(D=v+(g-v)/2|0,h=r[D],D!==g);)if(I=r[D+1],f<h)g=D-1;else if(f>=I)v=D+1;else break;return c?(c.line=D,c.column=f-h,null):{line:D,column:f-h}}t(n,o,c){if(c.column===0)return c.line-o.line;const d=this.a[n].lineStarts;if(c.line===d.length-1)return c.line-o.line;const i=d[c.line+1],r=d[c.line]+c.column;if(i>r+1)return c.line-o.line;const u=r-1;return this.a[n].buffer.charCodeAt(u)===13?c.line-o.line+1:c.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,M.$BB)(this,n[o])}w(n){if(n.length>$){const g=[];for(;n.length>$;){const I=n.charCodeAt($-1);let h;I===13||I>=55296&&I<=56319?(h=n.substring(0,$-1),n=n.substring($-1)):(h=n.substring(0,$),n=n.substring($));const w=R(h);g.push(new l(this.a.length,{line:0,column:0},{line:w.length-1,column:h.length-w[w.length-1]},w.length-1,h.length)),this.a.push(new p(h,w))}const D=R(n);return g.push(new l(this.a.length,{line:0,column:0},{line:D.length-1,column:n.length-D[D.length-1]},D.length-1,n.length)),this.a.push(new p(n,D)),g}let o=this.a[0].buffer.length;const c=R(n,!1);let d=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},d=this.g;for(let g=0;g<c.length;g++)c[g]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let g=0;g<c.length;g++)c[g]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,u=i-this.a[0].lineStarts[r],f={line:r,column:u},v=new l(0,d,f,this.t(0,d,f),i-o);return this.g=f,[v]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let c=this.root,d="";const i=this.h.get2(n);if(i){c=i.node;const r=this.B(c,n-i.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)d=u.substring(f+r,f+c.piece.length);else{const v=this.B(c,n-i.nodeStartLineNumber);return u.substring(f+r,f+v-o)}}else{let r=0;const u=n;for(;c!==M.$wB;)if(c.left!==M.$wB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const f=this.B(c,n-c.lf_left-2),v=this.B(c,n-c.lf_left-1),g=this.a[c.piece.bufferIndex].buffer,D=this.u(c.piece.bufferIndex,c.piece.start);return r+=c.size_left,this.h.set({node:c,nodeStartOffset:r,nodeStartLineNumber:u-(n-1-c.lf_left)}),g.substring(D+f,D+v-o)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const f=this.B(c,n-c.lf_left-2),v=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);d=v.substring(g+f,g+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,r+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==M.$wB;){const r=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),f=this.u(c.piece.bufferIndex,c.piece.start);return d+=r.substring(f,f+u-o),d}else{const u=this.u(c.piece.bufferIndex,c.piece.start);d+=r.substr(u,c.piece.length)}c=c.next()}return d}y(){let n=this.root,o=1,c=0;for(;n!==M.$wB;)o+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=c,this.h.validate(this.c)}A(n,o){const c=n.piece,d=this.s(n,o),i=d.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===o){const r=this.t(n.piece.bufferIndex,c.start,d);if(r!==i)return{index:r,remainder:0}}return{index:i,remainder:d.column}}B(n,o){if(o<0)return 0;const c=n.piece,d=this.a[c.bufferIndex].lineStarts,i=c.start.line+o+1;return i>c.end.line?d[c.end.line]+c.end.column-d[c.start.line]-c.start.column:d[i]-d[c.start.line]-c.start.column}C(n,o){const c=n.piece,d=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),r=o,u=this.u(c.bufferIndex,r),f=this.t(c.bufferIndex,c.start,r),v=f-d,g=u-i,D=c.length+g;n.piece=new l(c.bufferIndex,c.start,r,f,D),(0,M.$DB)(this,n,g,v)}D(n,o){const c=n.piece,d=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),r=o,u=this.t(c.bufferIndex,r,c.end),f=this.u(c.bufferIndex,r),v=u-d,g=i-f,D=c.length+g;n.piece=new l(c.bufferIndex,r,c.end,u,D),(0,M.$DB)(this,n,g,v)}E(n,o,c){const d=n.piece,i=d.start,r=d.end,u=d.length,f=d.lineFeedCnt,v=o,g=this.t(d.bufferIndex,d.start,v),D=this.u(d.bufferIndex,o)-this.u(d.bufferIndex,i);n.piece=new l(d.bufferIndex,d.start,v,g,D),(0,M.$DB)(this,n,D-u,g-f);const I=new l(d.bufferIndex,c,r,this.t(d.bufferIndex,c,r),this.u(d.bufferIndex,r)-this.u(d.bufferIndex,c)),h=this.S(n,I);this.N(h)}F(n,o){this.Q(o,n)&&(o+=`
`);const c=this.K()&&this.L(o)&&this.M(n),d=this.a[0].buffer.length;this.a[0].buffer+=o;const i=R(o,!1);for(let h=0;h<i.length;h++)i[h]+=d;if(c){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:d-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const r=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[r],f={line:r,column:u},v=n.piece.length+o.length,g=n.piece.lineFeedCnt,D=this.t(0,n.piece.start,f),I=D-g;n.piece=new l(n.piece.bufferIndex,n.piece.start,f,D,v),this.g=f,(0,M.$DB)(this,n,o.length,I)}G(n){let o=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let d=0;for(;o!==M.$wB;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){d+=o.size_left;const i={node:o,remainder:n-o.size_left,nodeStartOffset:d};return this.h.set(i),i}else n-=o.size_left+o.piece.length,d+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let c=this.root,d=0;for(;c!==M.$wB;)if(c.left!==M.$wB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),r=this.B(c,n-c.lf_left-1);return d+=c.size_left,{node:c,remainder:Math.min(i+o-1,r),nodeStartOffset:d}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+o-1<=c.piece.length)return{node:c,remainder:i+o-1,nodeStartOffset:d};o-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,d+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==M.$wB;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),r=this.J(c);return{node:c,remainder:Math.min(o-1,i),nodeStartOffset:r}}else if(c.piece.length>=o-1){const i=this.J(c);return{node:c,remainder:o-1,nodeStartOffset:i}}else o-=c.piece.length;c=c.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],d=this.u(n.piece.bufferIndex,n.piece.start)+o;return c.buffer.charCodeAt(d)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===M.$wB||n.piece.lineFeedCnt===0)return!1;const o=n.piece,c=this.a[o.bufferIndex].lineStarts,d=o.start.line,i=c[d]+o.start.column;return d===c.length-1||c[d+1]>i+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===M.$wB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const c=[],d=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:d[n.piece.end.line]-d[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const r=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,i,u,r),(0,M.$DB)(this,n,-1,-1),n.piece.length===0&&c.push(n);const f={line:o.piece.start.line+1,column:0},v=o.piece.length-1,g=this.t(o.piece.bufferIndex,f,o.piece.end);o.piece=new l(o.piece.bufferIndex,f,o.piece.end,g,v),(0,M.$DB)(this,o,-1,-1),o.piece.length===0&&c.push(o);const D=this.w(`\r
`);this.S(n,D[0]);for(let I=0;I<c.length;I++)(0,M.$BB)(this,c[I])}Q(n,o){if(this.K()&&this.M(n)){const c=o.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,M.$BB)(this,c);else{const d=c.piece,i={line:d.start.line+1,column:0},r=d.length-1,u=this.t(d.bufferIndex,i,d.end);c.piece=new l(d.bufferIndex,i,d.end,u,r),(0,M.$DB)(this,c,-1,-1)}return!0}}return!1}iterate(n,o){if(n===M.$wB)return o(M.$wB);const c=this.iterate(n.left,o);return c&&o(n)&&this.iterate(n.right,o)}R(n){if(n===M.$wB)return"";const o=this.a[n.piece.bufferIndex],c=n.piece,d=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return o.buffer.substring(d,i)}getPieceContent(n){const o=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),d=this.u(n.bufferIndex,n.end);return o.buffer.substring(c,d)}S(n,o){const c=new M.$vB(o,1);if(c.left=M.$wB,c.right=M.$wB,c.parent=M.$wB,c.size_left=0,c.lf_left=0,this.root===M.$wB)this.root=c,c.color=0;else if(n.right===M.$wB)n.right=c,c.parent=n;else{const i=(0,M.$xB)(n.right);i.left=c,c.parent=i}return(0,M.$CB)(this,c),c}T(n,o){const c=new M.$vB(o,1);if(c.left=M.$wB,c.right=M.$wB,c.parent=M.$wB,c.size_left=0,c.lf_left=0,this.root===M.$wB)this.root=c,c.color=0;else if(n.left===M.$wB)n.left=c,c.parent=n;else{const d=(0,M.$yB)(n.left);d.right=c,c.parent=d}return(0,M.$CB)(this,c),c}U(n){let o="";return this.iterate(n,c=>(o+=this.R(c),!0)),o}}e.$PB=s}),define(Pe[131],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z7=e.$Y7=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const P=this.a.get(M);return this.a.delete(M),P}}addDragOperationTransfer(M,P){this.a.set(M,P)}}e.$Y7=E;class T{constructor(M){this.identifier=M}}e.$Z7=T}),define(Pe[132],Re([9,10]),function(pe,e){return pe.create("vs/base/common/actions",e)}),define(Pe[133],Re([1,0,5,6,132]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class M extends T.$Rc{constructor(l,p="",b="",a=!0,s){super(),this.h=this.B(new E.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=p,this.u=b,this.w=a,this.C=s}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,p){this.C&&await this.C(l)}}e.$Ei=M;class P extends T.$Rc{constructor(){super(...arguments),this.f=this.B(new E.$Rd),this.onWillRun=this.f.event,this.m=this.B(new E.$Rd),this.onDidRun=this.m.event}async run(l,p){if(!l.enabled)return;this.f.fire({action:l});let b;try{await this.u(l,p)}catch(a){b=a}this.m.fire({action:l,error:b})}async u(l,p){await l.run(p)}}e.$Fi=P;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let p=[];for(const b of l)b.length&&(p.length?p=[...p,new $,...b]:p=b);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$Gi=$;class m{get actions(){return this.a}constructor(l,p,b,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=p,this.class=a,this.a=b}async run(){}}e.$Hi=m;class y extends M{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,C.localize(0,null),void 0,!1)}}e.$Ii=y;function R(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async(...l)=>S.run(...l),tooltip:S.label}}e.$Ji=R}),define(Pe[134],Re([9,10]),function(pe,e){return pe.create("vs/base/common/date",e)}),define(Pe[135],Re([1,0,134]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=void 0;const T=60,C=T*60,M=C*24,P=M*7,$=M*30,m=M*365;function y(S,l,p,b){typeof S!="number"&&(S=S.getTime());const a=Math.round((new Date().getTime()-S)/1e3);if(a<-30)return(0,E.localize)(0,null,y(new Date().getTime()+a*1e3,!1));if(!b&&a<30)return(0,E.localize)(1,null);let s;return a<T?(s=a,l?s===1?p?(0,E.localize)(2,null,s):(0,E.localize)(3,null,s):p?(0,E.localize)(4,null,s):(0,E.localize)(5,null,s):s===1?p?(0,E.localize)(6,null,s):(0,E.localize)(7,null,s):p?(0,E.localize)(8,null,s):(0,E.localize)(9,null,s)):a<C?(s=Math.floor(a/T),l?s===1?p?(0,E.localize)(10,null,s):(0,E.localize)(11,null,s):p?(0,E.localize)(12,null,s):(0,E.localize)(13,null,s):s===1?p?(0,E.localize)(14,null,s):(0,E.localize)(15,null,s):p?(0,E.localize)(16,null,s):(0,E.localize)(17,null,s)):a<M?(s=Math.floor(a/C),l?s===1?p?(0,E.localize)(18,null,s):(0,E.localize)(19,null,s):p?(0,E.localize)(20,null,s):(0,E.localize)(21,null,s):s===1?p?(0,E.localize)(22,null,s):(0,E.localize)(23,null,s):p?(0,E.localize)(24,null,s):(0,E.localize)(25,null,s)):a<P?(s=Math.floor(a/M),l?s===1?(0,E.localize)(26,null,s):(0,E.localize)(27,null,s):s===1?(0,E.localize)(28,null,s):(0,E.localize)(29,null,s)):a<$?(s=Math.floor(a/P),l?s===1?p?(0,E.localize)(30,null,s):(0,E.localize)(31,null,s):p?(0,E.localize)(32,null,s):(0,E.localize)(33,null,s):s===1?p?(0,E.localize)(34,null,s):(0,E.localize)(35,null,s):p?(0,E.localize)(36,null,s):(0,E.localize)(37,null,s)):a<m?(s=Math.floor(a/$),l?s===1?p?(0,E.localize)(38,null,s):(0,E.localize)(39,null,s):p?(0,E.localize)(40,null,s):(0,E.localize)(41,null,s):s===1?p?(0,E.localize)(42,null,s):(0,E.localize)(43,null,s):p?(0,E.localize)(44,null,s):(0,E.localize)(45,null,s)):(s=Math.floor(a/m),l?s===1?p?(0,E.localize)(46,null,s):(0,E.localize)(47,null,s):p?(0,E.localize)(48,null,s):(0,E.localize)(49,null,s):s===1?p?(0,E.localize)(50,null,s):(0,E.localize)(51,null,s):p?(0,E.localize)(52,null,s):(0,E.localize)(53,null,s))}e.$nm=y;function R(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$om=R}),define(Pe[136],Re([9,10]),function(pe,e){return pe.create("vs/base/common/errorMessage",e)}),define(Pe[40],Re([1,0,18,16,136]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=void 0;function M(S,l){return l&&(S.stack||S.stacktrace)?C.localize(0,null,$(S),P(S.stack)||P(S.stacktrace)):$(S)}function P(S){return Array.isArray(S)?S.join(`
`):S}function $(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?C.localize(1,null,S.message):S.message||C.localize(2,null)}function m(S=null,l=!1){if(!S)return C.localize(3,null);if(Array.isArray(S)){const p=E.$Gb(S),b=m(p[0],l);return p.length>1?C.localize(4,null,b,p.length):b}if(T.$Cf(S))return S;if(S.detail){const p=S.detail;if(p.error)return M(p.error,l);if(p.exception)return M(p.exception,l)}return S.stack?M(S,l):S.message?S.message:C.localize(5,null)}e.$Ki=m;function y(S){const l=S;return l instanceof Error&&Array.isArray(l.actions)}e.$Li=y;function R(S,l){let p;return typeof S=="string"?p=new Error(S):p=S,p.actions=l,p}e.$Mi=R}),define(Pe[137],Re([1,0,39,20]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=void 0;const C=new E.$U(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),M=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(I,h,w=!1){const k=I||"",F=h||"",W=C.value.collator.compare(k,F);return C.value.collatorIsNumeric&&W===0&&k!==F?k<F?-1:1:W}e.$rq=$;function m(I,h){const w=M.value.collator;return I=I||"",h=h||"",c(w,I,h)}e.$sq=m;function y(I,h){const w=M.value.collator;return I=I||"",h=h||"",u(I,h)||c(w,I,h)}e.$tq=y;function R(I,h){const w=M.value.collator;return I=I||"",h=h||"",r(I,h)||c(w,I,h)}e.$uq=R;function S(I,h){return I=I||"",h=h||"",I===h?0:I<h?-1:1}e.$vq=S;function l(I,h){const[w,k]=n(I),[F,W]=n(h);let Q=C.value.collator.compare(k,W);if(Q===0){if(C.value.collatorIsNumeric&&k!==W)return k<W?-1:1;if(Q=C.value.collator.compare(w,F),C.value.collatorIsNumeric&&Q===0&&w!==F)return w<F?-1:1}return Q}e.$wq=l;function p(I,h){I=I||"",h=h||"";const w=o(I),k=o(h),F=M.value.collator,W=P.value.collator;return c(W,w,k)||c(F,I,h)}e.$xq=p;function b(I,h){I=I||"",h=h||"";const w=o(I),k=o(h),F=M.value.collator,W=P.value.collator;return c(W,w,k)||u(I,h)||c(F,I,h)}e.$yq=b;function a(I,h){I=I||"",h=h||"";const w=o(I),k=o(h),F=M.value.collator,W=P.value.collator;return c(W,w,k)||r(I,h)||c(F,I,h)}e.$zq=a;function s(I,h){I=I||"",h=h||"";const w=o(I).toLowerCase(),k=o(h).toLowerCase();return w!==k?w<k?-1:1:I!==h?I<h?-1:1:0}e.$Aq=s;const t=/^(.*?)(\.([^.]*))?$/;function n(I,h=!1){const w=I?t.exec(I):[];let k=[w&&w[1]||"",w&&w[3]||""];return h&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function o(I){const h=I?t.exec(I):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function c(I,h,w){const k=I.compare(h,w);return k!==0?k:h.length!==w.length?h.length<w.length?-1:1:0}function d(I){const h=I.charAt(0);return h.toLocaleUpperCase()!==h}function i(I){const h=I.charAt(0);return h.toLocaleLowerCase()!==h}function r(I,h){return d(I)&&i(h)?-1:i(I)&&d(h)?1:0}function u(I,h){return i(I)&&d(h)?-1:d(I)&&i(h)?1:0}function f(I,h,w=!1){return w||(I=I&&I.toLowerCase(),h=h&&h.toLowerCase()),I===h?0:I<h?-1:1}function v(I,h,w=!1){const k=I.split(T.sep),F=h.split(T.sep),W=k.length-1,Q=F.length-1;let N,A;for(let L=0;;L++){if(N=W===L,A=Q===L,N&&A)return $(k[L],F[L],w);if(N)return-1;if(A)return 1;const O=f(k[L],F[L],w);if(O!==0)return O}}e.$Bq=v;function g(I,h,w){const k=I.toLowerCase(),F=h.toLowerCase(),W=D(I,h,w);if(W)return W;const Q=k.endsWith(w),N=F.endsWith(w);if(Q!==N)return Q?-1:1;const A=$(k,F);return A!==0?A:k.localeCompare(F)}e.$Cq=g;function D(I,h,w){const k=I.toLowerCase(),F=h.toLowerCase(),W=k.startsWith(w),Q=F.startsWith(w);if(W!==Q)return W?-1:1;if(W&&Q){if(k.length<F.length)return-1;if(k.length>F.length)return 1}return 0}e.$Dq=D}),define(Pe[46],Re([1,0,20,21,12,16]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function P(g){return g===47||g===92}e.$Uf=P;function $(g){return g.replace(/[\\/]/g,E.$fc.sep)}e.$Vf=$;function m(g){return g.indexOf("/")===-1&&(g=$(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}e.$Wf=m;function y(g,D=E.$fc.sep){if(!g)return"";const I=g.length,h=g.charCodeAt(0);if(P(h)){if(P(g.charCodeAt(1))&&!P(g.charCodeAt(2))){let k=3;const F=k;for(;k<I&&!P(g.charCodeAt(k));k++);if(F!==k&&!P(g.charCodeAt(k+1))){for(k+=1;k<I;k++)if(P(g.charCodeAt(k)))return g.slice(0,k+1).replace(/[\\/]/g,D)}}return D}else if(t(h)&&g.charCodeAt(1)===58)return P(g.charCodeAt(2))?g.slice(0,2)+D:g.slice(0,2);let w=g.indexOf("://");if(w!==-1){for(w+=3;w<I;w++)if(P(g.charCodeAt(w)))return g.slice(0,w+1)}return""}e.$Xf=y;function R(g){if(!T.$i||!g||g.length<5)return!1;let D=g.charCodeAt(0);if(D!==92||(D=g.charCodeAt(1),D!==92))return!1;let I=2;const h=I;for(;I<g.length&&(D=g.charCodeAt(I),D!==92);I++);return!(h===I||(D=g.charCodeAt(I+1),isNaN(D)||D===92))}e.$Yf=R;const S=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(g,D=T.$i){const I=D?S:l;return!(!g||g.length===0||/^\s+$/.test(g)||(I.lastIndex=0,I.test(g))||D&&p.test(g)||g==="."||g===".."||D&&g[g.length-1]==="."||D&&g.length!==g.trim().length||g.length>255)}e.$Zf=b;function a(g,D,I){const h=g===D;return!I||h?h:!g||!D?!1:(0,C.$6e)(g,D)}e.$1f=a;function s(g,D,I,h=E.sep){if(g===D)return!0;if(!g||!D||D.length>g.length)return!1;if(I){if(!(0,C.$7e)(g,D))return!1;if(D.length===g.length)return!0;let k=D.length;return D.charAt(D.length-1)===h&&k--,g.charAt(k)===h}return D.charAt(D.length-1)!==h&&(D+=h),g.indexOf(D)===0}e.$2f=s;function t(g){return g>=65&&g<=90||g>=97&&g<=122}e.$3f=t;function n(g,D){return T.$i&&g.endsWith(":")&&(g+=E.sep),(0,E.$hc)(g)||(g=(0,E.$ic)(D,g)),g=(0,E.$gc)(g),T.$i?(g=(0,C.$Oe)(g,E.sep),g.endsWith(":")&&(g+=E.sep)):(g=(0,C.$Oe)(g,E.sep),g||(g=E.sep)),g}e.$4f=n;function o(g){const D=(0,E.$gc)(g);return T.$i?g.length>3?!1:c(D)&&(g.length===2||D.charCodeAt(2)===92):D===E.$fc.sep}e.$5f=o;function c(g,D=T.$i){return D?t(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}e.$6f=c;function d(g,D=T.$i){return c(g,D)?g[0]:void 0}e.$7f=d;function i(g,D,I){return D.length>g.length?-1:g===D?0:(I&&(g=g.toLowerCase(),D=D.toLowerCase()),g.indexOf(D))}e.$8f=i;function r(g){const D=g.split(":");let I,h,w;for(const k of D){const F=Number(k);(0,M.$Gf)(F)?h===void 0?h=F:w===void 0&&(w=F):I=I?[I,k].join(":"):k}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:h!==void 0?h:void 0,column:w!==void 0?w:h!==void 0?1:void 0}}e.$9f=r;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",f="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(g,D,I=8){let h="";for(let k=0;k<I;k++){let F;k===0&&T.$i&&!D&&(I===3||I===4)?F=f:F=u,h+=F.charAt(Math.floor(Math.random()*F.length))}let w;return D?w=`${D}-${h}`:w=h,g?(0,E.$ic)(g,w):w}e.$0f=v}),define(Pe[68],Re([1,0,20]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=e.$2r=e.$1r=e.$Zr=void 0,e.$Zr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(R){const S=(0,E.$nc)(R),l=T[S.toLowerCase()];return l!==void 0?l:P(R)}e.$1r=M;function P(R){const S=(0,E.$nc)(R);return C[S.toLowerCase()]}e.$2r=P;function $(R){for(const S in C)if(C[S]===R)return S}e.$3r=$;const m=/^(.+)\/(.+?)(;.+)?$/;function y(R,S){const l=m.exec(R);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:S?void 0:R}e.$4r=y}),define(Pe[51],Re([1,0,24,2]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=void 0;function C(m){return JSON.stringify(m,P)}e.$uh=C;function M(m){let y=JSON.parse(m);return y=$(y),y}e.$vh=M;function P(m,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function $(m,y=0){if(!m||y>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return T.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof E.$fe||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let R=0;R<m.length;++R)m[R]=$(m[R],y+1);else for(const R in m)Object.hasOwnProperty.call(m,R)&&(m[R]=$(m[R],y+1))}return m}e.$wh=$}),define(Pe[13],Re([1,0,11,21,12,2]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var P;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(P||(e.Schemas=P={}));function $(l,p){return M.URI.isUri(l)?(0,C.$6e)(l.scheme,p):(0,C.$7e)(l,p+":")}e.$$f=$;function m(l,...p){return p.some(b=>$(l,b))}e.$_f=m,e.$ag="vscode-tkn",e.$bg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${P.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${P.vscodeRemoteResource}`}set(p,b,a){this.a[p]=b,this.b[p]=a}setConnectionToken(p,b){this.c[p]=b}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(o){return E.$Z(o),p}const b=p.authority;let a=this.a[b];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const s=this.b[b],t=this.c[b];let n=`path=${encodeURIComponent(p.path)}`;return typeof t=="string"&&(n+=`&${e.$bg}=${encodeURIComponent(t)}`),M.URI.from({scheme:T.$o?this.d:P.vscodeRemoteResource,authority:`${a}:${s}`,path:this.f,query:n})}}e.$cg=new y,e.$dg="vs/../../extensions",e.$eg="vs/../../node_modules",e.$fg="vs/../../node_modules.asar",e.$gg="vs/../../node_modules.asar.unpacked",e.$hg="vscode-app";class R{static{this.a=e.$hg}asBrowserUri(p){const b=this.b(p,pe);return this.uriToBrowserUri(b)}uriToBrowserUri(p){return p.scheme===P.vscodeRemote?e.$cg.rewrite(p):p.scheme===P.file&&(T.$m||T.$q===`${P.vscodeFileResource}://${R.a}`)?p.with({scheme:P.vscodeFileResource,authority:p.authority||R.a,query:null,fragment:null}):p}asFileUri(p){const b=this.b(p,pe);return this.uriToFileUri(b)}uriToFileUri(p){return p.scheme===P.vscodeFileResource?p.with({scheme:P.file,authority:p.authority!==R.a?p.authority:null,query:null,fragment:null}):p}b(p,b){return M.URI.isUri(p)?p:M.URI.parse(b.toUrl(p))}}e.$ig=new R;var S;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const b="vscode-coi";function a(t){let n;typeof t=="string"?n=new URL(t).searchParams:t instanceof URL?n=t.searchParams:M.URI.isUri(t)&&(n=new URL(t.toString(!0)).searchParams);const o=n?.get(b);if(o)return p.get(o)}l.getHeadersFromQuery=a;function s(t,n,o){if(!globalThis.crossOriginIsolated)return;const c=n&&o?"3":o?"2":"1";t instanceof URLSearchParams?t.set(b,c):t[b]=c}l.addSearchParam=s})(S||(e.COI=S={}))}),define(Pe[25],Re([1,0,46,13,20,21,12,2]),function(pe,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lg=e.DataUri=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=void 0;function m(p){return(0,$.$vc)(p,!0)}e.$pg=m;class y{constructor(b){this.a=b}compare(b,a,s=!1){return b===a?0:(0,P.$Ye)(this.getComparisonKey(b,s),this.getComparisonKey(a,s))}isEqual(b,a,s=!1){return b===a?!0:!b||!a?!1:this.getComparisonKey(b,s)===this.getComparisonKey(a,s)}getComparisonKey(b,a=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,a,s=!1){if(b.scheme===a.scheme){if(b.scheme===T.Schemas.file)return E.$2f(m(b),m(a),this.a(b))&&b.query===a.query&&(s||b.fragment===a.fragment);if((0,e.$Gg)(b.authority,a.authority))return E.$2f(b.path,a.path,this.a(b),"/")&&b.query===a.query&&(s||b.fragment===a.fragment)}return!1}joinPath(b,...a){return $.URI.joinPath(b,...a)}basenameOrAuthority(b){return(0,e.$yg)(b)||b.authority}basename(b){return C.$fc.basename(b.path)}extname(b){return C.$fc.extname(b.path)}dirname(b){if(b.path.length===0)return b;let a;return b.scheme===T.Schemas.file?a=$.URI.file(C.$lc(m(b))).path:(a=C.$fc.dirname(b.path),b.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),a="/")),b.with({path:a})}normalizePath(b){if(!b.path.length)return b;let a;return b.scheme===T.Schemas.file?a=$.URI.file(C.$gc(m(b))).path:a=C.$fc.normalize(b.path),b.with({path:a})}relativePath(b,a){if(b.scheme!==a.scheme||!(0,e.$Gg)(b.authority,a.authority))return;if(b.scheme===T.Schemas.file){const n=C.$kc(m(b),m(a));return M.$i?E.$Vf(n):n}let s=b.path||"/";const t=a.path||"/";if(this.a(b)){let n=0;for(const o=Math.min(s.length,t.length);n<o&&!(s.charCodeAt(n)!==t.charCodeAt(n)&&s.charAt(n).toLowerCase()!==t.charAt(n).toLowerCase());n++);s=t.substr(0,n)+s.substr(n)}return C.$fc.relative(s,t)}resolvePath(b,a){if(b.scheme===T.Schemas.file){const s=$.URI.file(C.$jc(m(b),a));return b.with({authority:s.authority,path:s.path})}return a=E.$Wf(a),b.with({path:C.$fc.resolve(b.path,a)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,a){return b===a||b!==void 0&&a!==void 0&&(0,P.$6e)(b,a)}hasTrailingPathSeparator(b,a=C.sep){if(b.scheme===T.Schemas.file){const s=m(b);return s.length>E.$Xf(s).length&&s[s.length-1]===a}else{const s=b.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,a=C.sep){return(0,e.$Hg)(b,a)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,a=C.sep){let s=!1;if(b.scheme===T.Schemas.file){const t=m(b);s=t!==void 0&&t.length===E.$Xf(t).length&&t[t.length-1]===a}else{a="/";const t=b.path;s=t.length===1&&t.charCodeAt(t.length-1)===47}return!s&&!(0,e.$Hg)(b,a)?b.with({path:b.path+"/"}):b}}e.$qg=y,e.$rg=new y(()=>!1),e.$sg=new y(p=>p.scheme===T.Schemas.file?!M.$k:!0),e.$tg=new y(p=>!0),e.$ug=e.$rg.isEqual.bind(e.$rg),e.$vg=e.$rg.isEqualOrParent.bind(e.$rg),e.$wg=e.$rg.getComparisonKey.bind(e.$rg),e.$xg=e.$rg.basenameOrAuthority.bind(e.$rg),e.$yg=e.$rg.basename.bind(e.$rg),e.$zg=e.$rg.extname.bind(e.$rg),e.$Ag=e.$rg.dirname.bind(e.$rg),e.$Bg=e.$rg.joinPath.bind(e.$rg),e.$Cg=e.$rg.normalizePath.bind(e.$rg),e.$Dg=e.$rg.relativePath.bind(e.$rg),e.$Eg=e.$rg.resolvePath.bind(e.$rg),e.$Fg=e.$rg.isAbsolutePath.bind(e.$rg),e.$Gg=e.$rg.isEqualAuthority.bind(e.$rg),e.$Hg=e.$rg.hasTrailingPathSeparator.bind(e.$rg),e.$Ig=e.$rg.removeTrailingPathSeparator.bind(e.$rg),e.$Jg=e.$rg.addTrailingPathSeparator.bind(e.$rg);function R(p,b){const a=[];for(let s=0;s<p.length;s++){const t=b(p[s]);p.some((n,o)=>o===s?!1:(0,e.$vg)(t,b(n)))||a.push(p[s])}return a}e.$Kg=R;var S;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function b(a){const s=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(o=>{const[c,d]=o.split(":");c&&d&&s.set(c,d)});const n=a.path.substring(0,a.path.indexOf(";"));return n&&s.set(p.META_DATA_MIME,n),s}p.parseMetaData=b})(S||(e.DataUri=S={}));function l(p,b,a){if(b){let s=p.path;return s&&s[0]!==C.$fc.sep&&(s=C.$fc.sep+s),p.with({scheme:a,authority:b,path:s})}return p.with({scheme:a})}e.$Lg=l}),define(Pe[14],Re([1,0,19,11,5,6,25,21,123,39]),function(pe,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.Promises=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=void 0;function R(fe){return!!fe&&typeof fe.then=="function"}e.$Mg=R;function S(fe){const ne=new E.$2d,H=fe(ne.token),te=new Promise((X,re)=>{const he=ne.token.onCancellationRequested(()=>{he.dispose(),ne.dispose(),re(new T.$4)});Promise.resolve(H).then(De=>{he.dispose(),ne.dispose(),X(De)},De=>{he.dispose(),ne.dispose(),re(De)})});return new class{cancel(){ne.cancel()}then(X,re){return te.then(X,re)}catch(X){return this.then(void 0,X)}finally(X){return te.finally(X)}}}e.$Ng=S;function l(fe,ne,H){return new Promise((te,X)=>{const re=ne.onCancellationRequested(()=>{re.dispose(),te(H)});fe.then(te,X).finally(()=>re.dispose())})}e.$Og=l;function p(fe,ne){return new Promise((H,te)=>{const X=ne.onCancellationRequested(()=>{X.dispose(),te(new T.$4)});fe.then(H,te).finally(()=>X.dispose())})}e.$Pg=p;async function b(fe){let ne=-1;const H=fe.map((te,X)=>te.then(re=>(ne=X,re)));try{return await Promise.race(H)}finally{fe.forEach((te,X)=>{X!==ne&&te.cancel()})}}e.$Qg=b;function a(fe,ne,H){let te;const X=setTimeout(()=>{te?.(void 0),H?.()},ne);return Promise.race([fe.finally(()=>clearTimeout(X)),new Promise(re=>te=re)])}e.$Rg=a;function s(fe){return new Promise((ne,H)=>{const te=fe();R(te)?te.then(ne,H):ne(te)})}e.$Sg=s;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ne){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ne,!this.b){const H=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(H,H).then(te)})}return new Promise((H,te)=>{this.b.then(H,te)})}return this.a=ne(),new Promise((H,te)=>{this.a.then(X=>{this.a=null,H(X)},X=>{this.a=null,te(X)})})}dispose(){this.f=!0}}e.$Tg=t;class n{constructor(){this.a=Promise.resolve(null)}queue(ne){return this.a=this.a.then(()=>ne(),()=>ne())}}e.$Ug=n;class o{constructor(){this.a=new Map}queue(ne,H){const X=(this.a.get(ne)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.a.get(ne)===X&&this.a.delete(ne)});return this.a.set(ne,X),X}}e.$Vg=o;const c=(fe,ne)=>{let H=!0;const te=setTimeout(()=>{H=!1,ne()},fe);return{isTriggered:()=>H,dispose:()=>{clearTimeout(te),H=!1}}},d=fe=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,fe())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};class i{constructor(ne){this.defaultDelay=ne,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ne,H=this.defaultDelay){this.g=ne,this.h(),this.b||(this.b=new Promise((X,re)=>{this.d=X,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const X=this.g;return this.g=null,X()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=H===m.$Od?d(te):c(H,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Wg=i;class r{constructor(ne){this.a=new i(ne),this.b=new t}trigger(ne,H){return this.a.trigger(()=>this.b.queue(ne),H)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Xg=r;class u{constructor(){this.a=!1,this.b=new Promise((ne,H)=>{this.d=ne})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Yg=u;class f extends u{constructor(ne){super(),this.f=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this.f),super.open()}}e.$Zg=f;function v(fe,ne){return ne?new Promise((H,te)=>{const X=setTimeout(()=>{re.dispose(),H()},fe),re=ne.onCancellationRequested(()=>{clearTimeout(X),re.dispose(),te(new T.$4)})}):S(H=>v(fe,H))}e.$1g=v;function g(fe,ne=0,H){const te=setTimeout(()=>{fe(),H&&X.dispose()},ne),X=(0,M.$Pc)(()=>{clearTimeout(te),H?.deleteAndLeak(X)});return H?.add(X),X}e.$2g=g;function D(fe){const ne=[];let H=0;const te=fe.length;function X(){return H<te?fe[H++]():null}function re(he){he!=null&&ne.push(he);const De=X();return De?De.then(re):Promise.resolve(ne)}return Promise.resolve(null).then(re)}e.$3g=D;function I(fe,ne=te=>!!te,H=null){let te=0;const X=fe.length,re=()=>{if(te>=X)return Promise.resolve(H);const he=fe[te++];return Promise.resolve(he()).then(z=>ne(z)?Promise.resolve(z):re())};return re()}e.$4g=I;function h(fe,ne=te=>!!te,H=null){if(fe.length===0)return Promise.resolve(H);let te=fe.length;const X=()=>{te=-1;for(const re of fe)re.cancel?.()};return new Promise((re,he)=>{for(const De of fe)De.then(z=>{--te>=0&&ne(z)?(X(),re(z)):te===0&&re(H)}).catch(z=>{--te>=0&&(X(),he(z))})})}e.$5g=h;class w{constructor(ne){this.a=0,this.d=ne,this.f=[],this.b=0,this.g=new C.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(ne){return this.a++,new Promise((H,te)=>{this.f.push({factory:ne,c:H,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ne=this.f.shift();this.b++;const H=ne.factory();H.then(ne.c,ne.e),H.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$6g=w;class k extends w{constructor(){super(1)}}e.$7g=k;class F{constructor(){this.a=new we,this.b=0}queue(ne){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ne())):this.a.run(this.b++,ne())}}e.$8g=F;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ne=new ie;return this.b.add(ne),ne.p}g(){for(const[,ne]of this.a)if(ne.size>0)return!1;return!0}queueFor(ne,H=P.$rg){const te=H.getComparisonKey(ne);let X=this.a.get(te);if(!X){X=new k;const re=this.f++,he=C.Event.once(X.onDrained)(()=>{X?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$1c),this.d.set(re,he),this.a.set(te,X)}return X}h(){this.g()&&this.j()}j(){for(const ne of this.b)ne.complete();this.b.clear()}dispose(){for(const[,ne]of this.a)ne.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$9g=W;class Q{constructor(ne,H){this.a=-1,typeof ne=="function"&&typeof H=="number"&&this.setIfNotSet(ne,H)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ne,H){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ne()},H)}setIfNotSet(ne,H){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ne()},H))}}e.$0g=Q;class N{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ne,H,te=globalThis){this.cancel();const X=te.setInterval(()=>{ne()},H);this.d=(0,M.$Pc)(()=>{te.clearInterval(X),this.d=void 0})}dispose(){this.cancel()}}e.$$g=N;class A{constructor(ne,H){this.b=-1,this.a=ne,this.d=H,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ne=this.d){this.cancel(),this.b=setTimeout(this.f,ne)}get delay(){return this.d}set delay(ne){this.d=ne}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$_g=A;class L{constructor(ne,H){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.a=ne,this.b=H,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ne=this.b){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ne/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ah=L;class O extends A{constructor(ne,H){super(ne,H),this.j=[]}work(ne){this.j.push(ne),this.isScheduled()||this.schedule()}h(){const ne=this.j;this.j=[],this.a?.(ne)}dispose(){this.j=[],super.dispose()}}e.$bh=O;class x extends M.$Rc{constructor(ne,H){super(),this.g=ne,this.h=H,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(ne){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ne.length>this.g.maxBufferedWork)return!1}else if(this.pending+ne.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const H of ne)this.a.push(H);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new A(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ch=x,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$eh=(fe,ne)=>{(0,$.$B)(()=>{if(H)return;const te=Date.now()+15;ne(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.$eh=(fe,ne,H)=>{const te=fe.requestIdleCallback(ne,typeof H=="number"?{timeout:H}:void 0);let X=!1;return{dispose(){X||(X=!0,fe.cancelIdleCallback(te))}}},e.$dh=fe=>(0,e.$eh)(globalThis,fe)}();class le{constructor(ne,H){this.g=!1,this.d=()=>{try{this.j=H()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$eh)(ne,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$fh=le;class me extends le{constructor(ne){super(globalThis,ne)}}e.$gh=me;async function ye(fe,ne,H){let te;for(let X=0;X<H;X++)try{return await fe()}catch(re){te=re,await v(ne)}throw te}e.$hh=ye;class we{isRunning(ne){return typeof ne=="number"?this.a?.taskId===ne:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ne,H,te){return this.a={taskId:ne,cancel:()=>te?.(),promise:H},H.then(()=>this.d(ne),()=>this.d(ne)),H}d(ne){this.a&&ne===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ne=this.b;this.b=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}queue(ne){if(this.b)this.b.run=ne;else{let H,te;const X=new Promise((re,he)=>{H=re,te=he});this.b={run:ne,promise:X,promiseResolve:H,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ih=we;class de{constructor(ne,H=()=>Date.now()){this.d=ne,this.f=H,this.a=0,this.b=0}increment(){const ne=this.f();return ne-this.a>this.d&&(this.a=ne,this.b=0),this.b++,this.b}}e.$jh=de;var be;(function(fe){fe[fe.Resolved=0]="Resolved",fe[fe.Rejected=1]="Rejected"})(be||(be={}));class ie{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ne,H)=>{this.a=ne,this.b=H})}complete(ne){return new Promise(H=>{this.a(ne),this.d={outcome:0,value:ne},H()})}error(ne){return new Promise(H=>{this.b(ne),this.d={outcome:1,value:ne},H()})}cancel(){return this.error(new T.$4)}}e.$kh=ie;var Ie;(function(fe){async function ne(te){let X;const re=await Promise.all(te.map(he=>he.then(De=>De,De=>{X||(X=De)})));if(typeof X<"u")throw X;return re}fe.settled=ne;function H(te){return new Promise(async(X,re)=>{try{await te(X,re)}catch(he){re(he)}})}fe.withAsyncBody=H})(Ie||(e.Promises=Ie={}));class ce{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ne){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ne.then(H=>(this.a=H,this.d=!0,H),H=>{throw this.b=H,this.d=!0,H})}requireValue(){if(!this.d)throw new T.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$lh=ce;class Y{constructor(ne){this.b=ne,this.a=new y.$U(()=>new ce(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$mh=Y;var B;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(B||(B={}));class se{static fromArray(ne){return new se(H=>{H.emitMany(ne)})}static fromPromise(ne){return new se(async H=>{H.emitMany(await ne)})}static fromPromises(ne){return new se(async H=>{await Promise.all(ne.map(async te=>H.emitOne(await te)))})}static merge(ne){return new se(async H=>{await Promise.all(ne.map(async te=>{for await(const X of te)H.emitOne(X)}))})}static{this.EMPTY=se.fromArray([])}constructor(ne){this.a=0,this.b=[],this.d=null,this.f=new C.$Rd,queueMicrotask(async()=>{const H={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(ne(H)),this.j()}catch(te){this.k(te)}finally{H.emitOne=void 0,H.emitMany=void 0,H.reject=void 0}})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ne<this.b.length)return{done:!1,value:this.b[ne++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(ne,H){return new se(async te=>{for await(const X of ne)te.emitOne(H(X))})}map(ne){return se.map(this,ne)}static filter(ne,H){return new se(async te=>{for await(const X of ne)H(X)&&te.emitOne(X)})}filter(ne){return se.filter(this,ne)}static coalesce(ne){return se.filter(ne,H=>!!H)}coalesce(){return se.coalesce(this)}static async toPromise(ne){const H=[];for await(const te of ne)H.push(te);return H}toPromise(){return se.toPromise(this)}g(ne){this.a===0&&(this.b.push(ne),this.f.fire())}h(ne){this.a===0&&(this.b=this.b.concat(ne),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ne){this.a===0&&(this.a=2,this.d=ne,this.f.fire())}}e.$nh=se;class Se extends se{constructor(ne,H){super(H),this.l=ne}cancel(){this.l.cancel()}}e.$oh=Se;function Ae(fe){const ne=new E.$2d,H=fe(ne.token);return new Se(ne,async te=>{const X=ne.token.onCancellationRequested(()=>{X.dispose(),ne.dispose(),te.reject(new T.$4)});try{for await(const re of H){if(ne.token.isCancellationRequested)return;te.emitOne(re)}X.dispose(),ne.dispose()}catch(re){X.dispose(),ne.dispose(),te.reject(re)}})}e.$ph=Ae;class Ce{constructor(){this.a=new ie,this.b=new se(te=>{if(ne){te.reject(ne);return}return H&&te.emitMany(H),this.d=X=>te.reject(X),this.f=X=>te.emitOne(X),this.a.p});let ne,H;this.f=te=>{H||(H=[]),H.push(te)},this.d=te=>{ne||(ne=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ne){this.d(ne),this.a.complete()}emitOne(ne){this.f(ne)}}e.$qh=Ce}),define(Pe[34],Re([1,0,18,14,46,28,20,21,12]),function(pe,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=void 0;function y(){return Object.create(null)}e.$Bj=y,e.$Cj="**",e.$Dj="/";const R="[/\\\\]",S="[^/\\\\]",l=/\//g;function p(me,ye){switch(me){case 0:return"";case 1:return`${S}*?`;default:return`(?:${R}|${S}+${R}${ye?`|${R}${S}+`:""})*?`}}function b(me,ye){if(!me)return[];const we=[];let de=!1,be=!1,ie="";for(const Ie of me){switch(Ie){case ye:if(!de&&!be){we.push(ie),ie="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":be=!0;break;case"]":be=!1;break}ie+=Ie}return ie&&we.push(ie),we}e.$Ej=b;function a(me){if(!me)return"";let ye="";const we=b(me,e.$Dj);if(we.every(de=>de===e.$Cj))ye=".*";else{let de=!1;we.forEach((be,ie)=>{if(be===e.$Cj){if(de)return;ye+=p(2,ie===we.length-1)}else{let Ie=!1,ce="",Y=!1,B="";for(const se of be){if(se!=="}"&&Ie){ce+=se;continue}if(Y&&(se!=="]"||!B)){let Se;se==="-"?Se=se:(se==="^"||se==="!")&&!B?Se="^":se===e.$Dj?Se="":Se=(0,m.$Je)(se),B+=Se;continue}switch(se){case"{":Ie=!0;continue;case"[":Y=!0;continue;case"}":{const Ae=`(?:${b(ce,",").map(Ce=>a(Ce)).join("|")})`;ye+=Ae,Ie=!1,ce="";break}case"]":{ye+="["+B+"]",Y=!1,B="";break}case"?":ye+=S;continue;case"*":ye+=p(1);continue;default:ye+=(0,m.$Je)(se)}}ie<we.length-1&&(we[ie+1]!==e.$Cj||ie+2<we.length)&&(ye+=R)}de=be===e.$Cj})}return ye}const s=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.$Cc(1e4),r=function(){return!1},u=function(){return null};function f(me,ye){if(!me)return u;let we;typeof me!="string"?we=me.pattern:we=me,we=we.trim();const de=`${we}_${!!ye.trimForExclusions}`;let be=i.get(de);if(be)return v(be,me);let ie;return s.test(we)?be=D(we.substr(4),we):(ie=t.exec(g(we,ye)))?be=I(ie[1],we):(ye.trimForExclusions?o:n).test(we)?be=h(we,ye):(ie=c.exec(g(we,ye)))?be=w(ie[1].substr(1),we,!0):(ie=d.exec(g(we,ye)))?be=w(ie[1],we,!1):be=k(we),i.set(de,be),v(be,me)}function v(me,ye){if(typeof ye=="string")return me;const we=function(de,be){return(0,C.$2f)(de,ye.base,!$.$k)?me((0,m.$Ne)(de.substr(ye.base.length),P.sep),be):null};return we.allBasenames=me.allBasenames,we.allPaths=me.allPaths,we.basenames=me.basenames,we.patterns=me.patterns,we}function g(me,ye){return ye.trimForExclusions&&me.endsWith("/**")?me.substr(0,me.length-2):me}function D(me,ye){return function(we,de){return typeof we=="string"&&we.endsWith(me)?ye:null}}function I(me,ye){const we=`/${me}`,de=`\\${me}`,be=function(Ie,ce){return typeof Ie!="string"?null:ce?ce===me?ye:null:Ie===me||Ie.endsWith(we)||Ie.endsWith(de)?ye:null},ie=[me];return be.basenames=ie,be.patterns=[ye],be.allBasenames=ie,be}function h(me,ye){const we=x(me.slice(1,-1).split(",").map(ce=>f(ce,ye)).filter(ce=>ce!==u),me),de=we.length;if(!de)return u;if(de===1)return we[0];const be=function(ce,Y){for(let B=0,se=we.length;B<se;B++)if(we[B](ce,Y))return me;return null},ie=we.find(ce=>!!ce.allBasenames);ie&&(be.allBasenames=ie.allBasenames);const Ie=we.reduce((ce,Y)=>Y.allPaths?ce.concat(Y.allPaths):ce,[]);return Ie.length&&(be.allPaths=Ie),be}function w(me,ye,we){const de=P.sep===P.$fc.sep,be=de?me:me.replace(l,P.sep),ie=P.sep+be,Ie=P.$fc.sep+me;let ce;return we?ce=function(Y,B){return typeof Y=="string"&&(Y===be||Y.endsWith(ie)||!de&&(Y===me||Y.endsWith(Ie)))?ye:null}:ce=function(Y,B){return typeof Y=="string"&&(Y===be||!de&&Y===me)?ye:null},ce.allPaths=[(we?"*/":"./")+me],ce}function k(me){try{const ye=new RegExp(`^${a(me)}$`);return function(we){return ye.lastIndex=0,typeof we=="string"&&ye.test(we)?me:null}}catch{return u}}function F(me,ye,we){return!me||typeof ye!="string"?!1:W(me)(ye,void 0,we)}e.$Fj=F;function W(me,ye={}){if(!me)return r;if(typeof me=="string"||Q(me)){const we=f(me,ye);if(we===u)return r;const de=function(be,ie){return!!we(be,ie)};return we.allBasenames&&(de.allBasenames=we.allBasenames),we.allPaths&&(de.allPaths=we.allPaths),de}return L(me,ye)}e.$Gj=W;function Q(me){const ye=me;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}e.$Hj=Q;function N(me){return me.allBasenames||[]}e.$Ij=N;function A(me){return me.allPaths||[]}e.$Jj=A;function L(me,ye){const we=x(Object.getOwnPropertyNames(me).map(ce=>O(ce,me[ce],ye)).filter(ce=>ce!==u)),de=we.length;if(!de)return u;if(!we.some(ce=>!!ce.requiresSiblings)){if(de===1)return we[0];const ce=function(se,Se){let Ae;for(let Ce=0,fe=we.length;Ce<fe;Ce++){const ne=we[Ce](se,Se);if(typeof ne=="string")return ne;(0,T.$Mg)(ne)&&(Ae||(Ae=[]),Ae.push(ne))}return Ae?(async()=>{for(const Ce of Ae){const fe=await Ce;if(typeof fe=="string")return fe}return null})():null},Y=we.find(se=>!!se.allBasenames);Y&&(ce.allBasenames=Y.allBasenames);const B=we.reduce((se,Se)=>Se.allPaths?se.concat(Se.allPaths):se,[]);return B.length&&(ce.allPaths=B),ce}const be=function(ce,Y,B){let se,Se;for(let Ae=0,Ce=we.length;Ae<Ce;Ae++){const fe=we[Ae];fe.requiresSiblings&&B&&(Y||(Y=(0,P.$mc)(ce)),se||(se=Y.substr(0,Y.length-(0,P.$nc)(ce).length)));const ne=fe(ce,Y,se,B);if(typeof ne=="string")return ne;(0,T.$Mg)(ne)&&(Se||(Se=[]),Se.push(ne))}return Se?(async()=>{for(const Ae of Se){const Ce=await Ae;if(typeof Ce=="string")return Ce}return null})():null},ie=we.find(ce=>!!ce.allBasenames);ie&&(be.allBasenames=ie.allBasenames);const Ie=we.reduce((ce,Y)=>Y.allPaths?ce.concat(Y.allPaths):ce,[]);return Ie.length&&(be.allPaths=Ie),be}function O(me,ye,we){if(ye===!1)return u;const de=f(me,we);if(de===u)return u;if(typeof ye=="boolean")return de;if(ye){const be=ye.when;if(typeof be=="string"){const ie=(Ie,ce,Y,B)=>{if(!B||!de(Ie,ce))return null;const se=be.replace("$(basename)",()=>Y),Se=B(se);return(0,T.$Mg)(Se)?Se.then(Ae=>Ae?me:null):Se?me:null};return ie.requiresSiblings=!0,ie}}return de}function x(me,ye){const we=me.filter(ce=>!!ce.basenames);if(we.length<2)return me;const de=we.reduce((ce,Y)=>{const B=Y.basenames;return B?ce.concat(B):ce},[]);let be;if(ye){be=[];for(let ce=0,Y=de.length;ce<Y;ce++)be.push(ye)}else be=we.reduce((ce,Y)=>{const B=Y.patterns;return B?ce.concat(B):ce},[]);const ie=function(ce,Y){if(typeof ce!="string")return null;if(!Y){let se;for(se=ce.length;se>0;se--){const Se=ce.charCodeAt(se-1);if(Se===47||Se===92)break}Y=ce.substr(se)}const B=de.indexOf(Y);return B!==-1?be[B]:null};ie.basenames=de,ie.patterns=be,ie.allBasenames=de;const Ie=me.filter(ce=>!ce.basenames);return Ie.push(ie),Ie}function le(me,ye){return(0,E.$tb)(me,ye,(we,de)=>typeof we=="string"&&typeof de=="string"?we===de:typeof we!="string"&&typeof de!="string"?we.base===de.base&&we.pattern===de.pattern:!1)}e.$Kj=le}),define(Pe[52],Re([1,0,11,124,25,12,2]),function(pe,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class m{constructor(t="",n=!1){if(this.value=t,typeof this.value!="string")throw(0,E.$6)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(t,n=0){return this.value+=l(this.supportThemeIcons?(0,T.$7j)(t):t).replace(/([ \t]+)/g,(o,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(t){return this.value+=t,this}appendCodeblock(t,n){return this.value+="\n```",this.value+=t,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(t,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(t),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(t,n){const o=new RegExp((0,M.$Je)(n),"g");return t.replace(o,(c,d)=>t.charAt(d-1)!=="\\"?`\\${c}`:c)}}e.$ak=m;function y(s){return R(s)?!s.value:Array.isArray(s)?s.every(y):!0}e.$bk=y;function R(s){return s instanceof m?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.$ck=R;function S(s,t){return s===t?!0:!s||!t?!1:s.value===t.value&&s.isTrusted===t.isTrusted&&s.supportThemeIcons===t.supportThemeIcons&&s.supportHtml===t.supportHtml&&(s.baseUri===t.baseUri||!!s.baseUri&&!!t.baseUri&&(0,C.$ug)(P.URI.from(s.baseUri),P.URI.from(t.baseUri)))}e.$dk=S;function l(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ek=l;function p(s){return s.replace(/"/g,"&quot;")}e.$fk=p;function b(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$gk=b;function a(s){const t=[],n=s.split("|").map(c=>c.trim());s=n[0];const o=n[1];if(o){const c=/height=(\d+)/.exec(o),d=/width=(\d+)/.exec(o),i=c?c[1]:"",r=d?d[1]:"",u=isFinite(parseInt(r)),f=isFinite(parseInt(i));u&&t.push(`width="${r}"`),f&&t.push(`height="${i}"`)}return{href:s,dimensions:t}}e.$hk=a}),define(Pe[94],Re([1,0,18,46,20,21,25,12]),function(pe,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=void 0;function m(f,v){const{os:g,tildify:D,relative:I}=v;if(I){const k=y(f,I,g);if(typeof k=="string")return k}let h=f.fsPath;if(g===1&&!M.$i?h=h.replace(/\//g,"\\"):g!==1&&M.$i&&(h=h.replace(/\\/g,"/")),g!==1&&D?.userHome){const k=D.userHome.fsPath;let F;f.scheme!==D.userHome.scheme&&f.path[0]===C.$fc.sep&&f.path[1]!==C.$fc.sep?F=D.userHome.with({path:f.path}).fsPath:F=h,h=l(F,k,g)}return(g===1?C.$ec:C.$fc).normalize(R(h,g===1))}e.$Cv=m;function y(f,v,g){const D=g===1?C.$ec:C.$fc,I=g===3?P.$rg:P.$tg,h=v.getWorkspace(),w=(0,E.$Nb)(h.folders);if(!w)return;f.scheme!==w.uri.scheme&&f.path[0]===C.$fc.sep&&f.path[1]!==C.$fc.sep&&(f=w.uri.with({path:f.path}));const k=v.getWorkspaceFolder(f);if(!k)return;let F;if(I.isEqual(k.uri,f)?F="":F=I.relativePath(k.uri,f)??"",F&&(F=D.normalize(F)),h.folders.length>1&&!v.noPrefix){const W=k.name?k.name:I.basenameOrAuthority(k.uri);F=F?`${W} \u2022 ${F}`:W}return F}function R(f,v=M.$i){return(0,T.$6f)(f,v)?f.charAt(0).toUpperCase()+f.slice(1):f}e.$Dv=R;let S=Object.create(null);function l(f,v,g=M.OS){if(g===1||!f||!v)return f;let D=S.original===v?S.normalized:void 0;D||(D=v,M.$i&&(D=(0,T.$Vf)(D)),D=`${(0,$.$Oe)(D,C.$fc.sep)}${C.$fc.sep}`,S={original:v,normalized:D});let I=f;return M.$i&&(I=(0,T.$Vf)(I)),(g===3?I.startsWith(D):(0,$.$7e)(I,D))?`~/${I.substr(D.length)}`:f}e.$Ev=l;function p(f,v){return f.replace(/^~($|\/|\\)/,`${v}$1`)}e.$Fv=p;const b="\u2026",a="\\\\",s="~";function t(f,v=C.sep){const g=new Array(f.length);let D=!1;for(let I=0;I<f.length;I++){const h=f[I];if(h===""){g[I]=`.${v}`;continue}if(!h){g[I]=h;continue}D=!0;let w="",k=h;k.indexOf(a)===0?(w=k.substr(0,k.indexOf(a)+a.length),k=k.substr(k.indexOf(a)+a.length)):k.indexOf(v)===0?(w=k.substr(0,k.indexOf(v)+v.length),k=k.substr(k.indexOf(v)+v.length)):k.indexOf(s)===0&&(w=k.substr(0,k.indexOf(s)+s.length),k=k.substr(k.indexOf(s)+s.length));const F=k.split(v);for(let W=1;D&&W<=F.length;W++)for(let Q=F.length-W;D&&Q>=0;Q--){D=!1;let N=F.slice(Q,Q+W).join(v);for(let A=0;!D&&A<f.length;A++)if(A!==I&&f[A]&&f[A].indexOf(N)>-1){const L=Q+W===F.length,O=Q>0&&f[A].indexOf(v)>-1?v+N:N,x=f[A].endsWith(O);D=!L||x}if(!D){let A="";(F[0].endsWith(":")||w!=="")&&(Q===1&&(Q=0,W++,N=F[0]+v+N),Q>0&&(A=F[0]+v),A=w+A),Q>0&&(A=A+b+v),A=A+N,Q+W<F.length&&(A=A+v+b),g[I]=A}}D&&(g[I]=h)}return g}e.$Gv=t;var n;(function(f){f[f.TEXT=0]="TEXT",f[f.VARIABLE=1]="VARIABLE",f[f.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function o(f,v=Object.create(null)){const g=[];let D=!1,I="";for(const h of f)if(h==="$"||D&&h==="{")I&&g.push({value:I,type:n.TEXT}),I="",D=!0;else if(h==="}"&&D){const w=v[I];if(typeof w=="string")w.length&&g.push({value:w,type:n.VARIABLE});else if(w){const k=g[g.length-1];(!k||k.type!==n.SEPARATOR)&&g.push({value:w.label,type:n.SEPARATOR})}I="",D=!1}else I+=h;return I&&!D&&g.push({value:I,type:n.TEXT}),g.filter((h,w)=>{if(h.type===n.SEPARATOR){const k=g[w-1],F=g[w+1];return[k,F].every(W=>W&&(W.type===n.VARIABLE||W.type===n.TEXT)&&W.value.length>0)}return!0}).map(h=>h.value).join("")}e.$Hv=o;function c(f,v){return M.$j||v?f.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):f.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.$Iv=c;function d(f,v){return M.$j||v?f.replace(/\(&&\w\)|&&/g,""):M.$i?f.replace(/&&|&/g,g=>g==="&"?"&&":"&"):f.replace(/&&/g,"_")}e.$Jv=d;function i(f){return f.replace(/&/g,"&&")}e.$Kv=i;function r(f){if(f.endsWith("]")){const v=f.lastIndexOf(" [",f.length-2);if(v!==-1){const g=u(f.substring(0,v));return{name:g.name,parentPath:g.parentPath+f.substring(v)}}}return u(f)}e.$Lv=r;function u(f){const v=f.indexOf("/")!==-1?C.$fc:C.$ec,g=v.basename(f),D=v.dirname(f);return g.length?{name:g,parentPath:D}:{name:D,parentPath:""}}}),define(Pe[138],Re([1,0,24,2]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=void 0;function C(S){return S.toJSON()}class M{constructor(l){this.a=l}transformIncoming(l){const p=this.a.transformIncoming(l);return p===l?l:C(T.URI.from(p))}transformOutgoing(l){const p=this.a.transformOutgoing(l);return p===l?l:C(T.URI.from(p))}transformOutgoingURI(l){const p=this.a.transformOutgoing(l);return p===l?l:T.URI.from(p)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$Vm=M,e.$Wm=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function P(S,l,p){if(!S||p>200)return null;if(typeof S=="object"){if(S instanceof T.URI)return l.transformOutgoing(S);for(const b in S)if(Object.hasOwnProperty.call(S,b)){const a=P(S[b],l,p+1);a!==null&&(S[b]=a)}}return null}function $(S,l){const p=P(S,l,0);return p===null?S:p}e.$Xm=$;function m(S,l,p,b){if(!S||b>200)return null;if(typeof S=="object"){if(S.$mid===1)return p?T.URI.revive(l.transformIncoming(S)):l.transformIncoming(S);if(S instanceof E.$fe)return null;for(const a in S)if(Object.hasOwnProperty.call(S,a)){const s=m(S[a],l,p,b+1);s!==null&&(S[a]=s)}}return null}function y(S,l){const p=m(S,l,!1,0);return p===null?S:p}e.$Ym=y;function R(S,l){const p=m(S,l,!0,0);return p===null?S:p}e.$Zm=R}),define(Pe[139],Re([1,0,12,21,24]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=e.$Vs=void 0;let M;function P(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function m(){return $||($=new TextDecoder("UTF-16BE")),$}let y;function R(){return y||(y=T.$D()?P():m()),y}e.$Vs=R;function S(b,a,s){const t=new Uint16Array(b.buffer,a,s);return s>0&&(t[0]===65279||t[0]===65534)?l(b,a,s):P().decode(t)}e.$Ws=S;function l(b,a,s){const t=[];let n=0;for(let o=0;o<s;o++){const c=C.$he(b,a);a+=2,t[n++]=String.fromCharCode(c)}return t.join("")}class p{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return R().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const s=this.a-this.d;s<=1&&(s===0||E.$0e(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const s=a.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=a;return}for(let t=0;t<s;t++)this.b[this.d++]=a.charCodeAt(t)}}e.$Xs=p}),define(Pe[140],Re([1,0,24,139]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.$Ys=void 0;function C(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,R,S,l){this.oldPosition=y,this.oldText=R,this.newPosition=S,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${C(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${C(this.oldText)}")`:`(replace@${this.oldPosition} "${C(this.oldText)}" with "${C(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,R,S){const l=R.length;E.$ke(y,l,S),S+=4;for(let p=0;p<l;p++)E.$ie(y,R.charCodeAt(p),S),S+=2;return S}static d(y,R){const S=E.$je(y,R);return R+=4,(0,T.$Ws)(y,R,S)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(y,R){return E.$ke(y,this.oldPosition,R),R+=4,E.$ke(y,this.newPosition,R),R+=4,R=M.c(y,this.oldText,R),R=M.c(y,this.newText,R),R}static read(y,R,S){const l=E.$je(y,R);R+=4;const p=E.$je(y,R);R+=4;const b=M.d(y,R);R+=M.a(b);const a=M.d(y,R);return R+=M.a(a),S.push(new M(l,b,p,a)),R}}e.$Ys=M;function P(m,y){return m===null||m.length===0?y:new $(m,y).compress()}e.$Zs=P;class ${constructor(y,R){this.a=y,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,R=0,S=this.n(y),l=this.l(R);for(;y<this.f||R<this.h;){if(S===null){this.k(l),l=this.l(++R);continue}if(l===null){this.m(S),S=this.n(++y);continue}if(l.oldEnd<=S.newPosition){this.k(l),l=this.l(++R);continue}if(S.newEnd<=l.oldPosition){this.m(S),S=this.n(++y);continue}if(l.oldPosition<S.newPosition){const[t,n]=$.r(l,S.newPosition-l.oldPosition);this.k(t),l=n;continue}if(S.newPosition<l.oldPosition){const[t,n]=$.q(S,l.oldPosition-S.newPosition);this.m(t),S=n;continue}let a,s;if(l.oldEnd===S.newEnd)a=S,s=l,S=this.n(++y),l=this.l(++R);else if(l.oldEnd<S.newEnd){const[t,n]=$.q(S,l.oldLength);a=t,s=l,S=n,l=this.l(++R)}else{const[t,n]=$.r(l,S.newLength);a=S,s=t,S=this.n(++y),l=n}this.d[this.e++]=new M(a.oldPosition,a.oldText,s.newPosition,s.newText),this.g+=a.newLength-a.oldLength,this.j+=s.newLength-s.oldLength}const p=$.s(this.d);return $.t(p)}k(y){this.d[this.e++]=$.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=$.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,R){return new M(R.oldPosition-y,R.oldText,R.newPosition,R.newText)}static p(y,R){return new M(R.oldPosition,R.oldText,R.newPosition+y,R.newText)}static q(y,R){const S=y.newText.substr(0,R),l=y.newText.substr(R);return[new M(y.oldPosition,y.oldText,y.newPosition,S),new M(y.oldEnd,"",y.newPosition+R,l)]}static r(y,R){const S=y.oldText.substr(0,R),l=y.oldText.substr(R);return[new M(y.oldPosition,S,y.newPosition,y.newText),new M(y.oldPosition+R,l,y.newEnd,"")]}static s(y){if(y.length===0)return y;const R=[];let S=0,l=y[0];for(let p=1;p<y.length;p++){const b=y[p];l.oldEnd===b.oldPosition?l=new M(l.oldPosition,l.oldText+b.oldText,l.newPosition,l.newText+b.newText):(R[S++]=l,l=b)}return R[S++]=l,R}static t(y){if(y.length===0)return y;const R=[];let S=0;for(let l=0;l<y.length;l++){const p=y[l];p.oldText!==p.newText&&(R[S++]=p)}return R}}}),define(Pe[141],Re([1,0,34,20]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PE=void 0;function C(M,P,$,m,y,R){if(Array.isArray(M)){let S=0;for(const l of M){const p=C(l,P,$,m,y,R);if(p===10)return p;p>S&&(S=p)}return S}else{if(typeof M=="string")return m?M==="*"?5:M===$?10:0:0;if(M){const{language:S,pattern:l,scheme:p,hasAccessToAllModels:b,notebookType:a}=M;if(!m&&!b)return 0;a&&y&&(P=y);let s=0;if(p)if(p===P.scheme)s=10;else if(p==="*")s=5;else return 0;if(S)if(S===$)s=10;else if(S==="*")s=Math.max(s,5);else return 0;if(a)if(a===R)s=10;else if(a==="*"&&R!==void 0)s=Math.max(s,5);else return 0;if(l){let t;if(typeof l=="string"?t=l:t={...l,base:(0,T.$gc)(l.base)},t===P.fsPath||(0,E.$Fj)(t,P.fsPath))s=10;else return 0}return s}else return 0}}e.$PE=C}),define(Pe[142],Re([1,0,5,12,29,92,91,126,140,6]),function(pe,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QB=void 0;class R extends y.$Rc{constructor(l,p,b,a,s,t,n){super(),this.m=this.B(new E.$Rd),this.onDidChangeContent=this.m.event,this.f=p,this.j=!t,this.g=a,this.h=s,this.c=new P.$PB(l,b,n)}equals(l){return!(l instanceof R)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,p){return this.c.getOffsetAt(l,p)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,p){const b=l+p,a=this.getPositionAt(l),s=this.getPositionAt(b);return new C.$Ds(a.lineNumber,a.column,s.lineNumber,s.column)}getValueInRange(l,p=0){if(l.isEmpty())return"";const b=this.n(p);return this.c.getValueInRange(l,b)}getValueLengthInRange(l,p=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const b=this.getOffsetAt(l.startLineNumber,l.startColumn),a=this.getOffsetAt(l.endLineNumber,l.endColumn);let s=0;const t=this.n(p),n=this.getEOL();if(t.length!==n.length){const o=t.length-n.length,c=l.endLineNumber-l.startLineNumber;s=o*c}return a-b+s}getCharacterCountInRange(l,p=0){if(this.j){let b=0;const a=l.startLineNumber,s=l.endLineNumber;for(let t=a;t<=s;t++){const n=this.getLineContent(t),o=t===a?l.startColumn-1:0,c=t===s?l.endColumn-1:n.length;for(let d=o;d<c;d++)T.$0e(n.charCodeAt(d))?(b=b+1,d=d+1):b=b+1}return b+=this.n(p).length*(s-a),b}return this.getValueLengthInRange(l,p)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,p){return this.c.getLineCharCode(l,p)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const p=T.$Ue(this.getLineContent(l));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(l){const p=T.$We(this.getLineContent(l));return p===-1?0:p+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,p,b){let a=this.g,s=this.h,t=this.j,n=!0,o=[];for(let v=0;v<l.length;v++){const g=l[v];n&&g._isTracked&&(n=!1);const D=g.range;if(g.text){let F=!0;t||(F=!T.$if(g.text),t=F),!a&&F&&(a=T.$hf(g.text)),!s&&F&&(s=T.$kf(g.text))}let I="",h=0,w=0,k=0;if(g.text){let F;[h,w,k,F]=(0,$.$dt)(g.text);const W=this.getEOL();F===0||F===(W===`\r
`?2:1)?I=g.text:I=g.text.replace(/\r\n|\r|\n/g,W)}o[v]={sortIndex:v,identifier:g.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:I,eolCount:h,firstLineLength:w,lastLineLength:k,forceMoveMarkers:!!g.forceMoveMarkers,isAutoWhitespaceEdit:g.isAutoWhitespaceEdit||!1}}o.sort(R.u);let c=!1;for(let v=0,g=o.length-1;v<g;v++){const D=o[v].range.getEndPosition(),I=o[v+1].range.getStartPosition();if(I.isBeforeOrEqual(D)){if(I.isBefore(D))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(o=this.s(o));const d=b||p?R._getInverseEditRanges(o):[],i=[];if(p)for(let v=0;v<o.length;v++){const g=o[v],D=d[v];if(g.isAutoWhitespaceEdit&&g.range.isEmpty())for(let I=D.startLineNumber;I<=D.endLineNumber;I++){let h="";I===D.startLineNumber&&(h=this.getLineContent(g.range.startLineNumber),T.$Ue(h)!==-1)||i.push({lineNumber:I,oldContent:h})}}let r=null;if(b){let v=0;r=[];for(let g=0;g<o.length;g++){const D=o[g],I=d[g],h=this.getValueInRange(D.range),w=D.rangeOffset+v;v+=D.text.length-h.length,r[g]={sortIndex:D.sortIndex,identifier:D.identifier,range:I,text:h,textChange:new m.$Ys(D.rangeOffset,h,w,D.text)}}c||r.sort((g,D)=>g.sortIndex-D.sortIndex)}this.g=a,this.h=s,this.j=t;const u=this.t(o);let f=null;if(p&&i.length>0){i.sort((v,g)=>g.lineNumber-v.lineNumber),f=[];for(let v=0,g=i.length;v<g;v++){const D=i[v].lineNumber;if(v>0&&i[v-1].lineNumber===D)continue;const I=i[v].oldContent,h=this.getLineContent(D);h.length===0||h===I||T.$Ue(h)!==-1||f.push(D)}}return this.m.fire(),new M.$Yu(r,u,f)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let p=!1;const b=l[0].range,a=l[l.length-1].range,s=new C.$Ds(b.startLineNumber,b.startColumn,a.endLineNumber,a.endColumn);let t=b.startLineNumber,n=b.startColumn;const o=[];for(let u=0,f=l.length;u<f;u++){const v=l[u],g=v.range;p=p||v.forceMoveMarkers,o.push(this.getValueInRange(new C.$Ds(t,n,g.startLineNumber,g.startColumn))),v.text.length>0&&o.push(v.text),t=g.endLineNumber,n=g.endColumn}const c=o.join(""),[d,i,r]=(0,$.$dt)(c);return{sortIndex:0,identifier:l[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,0),text:c,eolCount:d,firstLineLength:i,lastLineLength:r,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}t(l){l.sort(R.w);const p=[];for(let b=0;b<l.length;b++){const a=l[b],s=a.range.startLineNumber,t=a.range.startColumn,n=a.range.endLineNumber,o=a.range.endColumn;if(s===n&&t===o&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const c=new C.$Ds(s,t,n,o);p.push({range:c,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return p}findMatchesLineByLine(l,p,b,a){return this.c.findMatchesLineByLine(l,p,b,a)}getPieceTree(){return this.c}static _getInverseEditRange(l,p){const b=l.startLineNumber,a=l.startColumn,[s,t,n]=(0,$.$dt)(p);let o;if(p.length>0){const c=s+1;c===1?o=new C.$Ds(b,a,b,a+t):o=new C.$Ds(b,a,b+c-1,n+1)}else o=new C.$Ds(b,a,b,a);return o}static _getInverseEditRanges(l){const p=[];let b=0,a=0,s=null;for(let t=0,n=l.length;t<n;t++){const o=l[t];let c,d;s?s.range.endLineNumber===o.range.startLineNumber?(c=b,d=a+(o.range.startColumn-s.range.endColumn)):(c=b+(o.range.startLineNumber-s.range.endLineNumber),d=o.range.startColumn):(c=o.range.startLineNumber,d=o.range.startColumn);let i;if(o.text.length>0){const r=o.eolCount+1;r===1?i=new C.$Ds(c,d,c,d+o.firstLineLength):i=new C.$Ds(c,d,c+r-1,o.lastLineLength+1)}else i=new C.$Ds(c,d,c,d);b=i.endLineNumber,a=i.endColumn,p.push(i),s=o}return p}static u(l,p){const b=C.$Ds.compareRangesUsingEnds(l.range,p.range);return b===0?l.sortIndex-p.sortIndex:b}static w(l,p){const b=C.$Ds.compareRangesUsingEnds(l.range,p.range);return b===0?p.sortIndex-l.sortIndex:-b}}e.$QB=R}),define(Pe[143],Re([1,0,12,91,142]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RB=void 0;class M{constructor(m,y,R,S,l,p,b,a,s){this.a=m,this.b=y,this.c=R,this.d=S,this.e=l,this.f=p,this.g=b,this.h=a,this.j=s}k(m){const y=this.c+this.d+this.e,R=this.c+this.e;return y===0?m===1?`
`:`\r
`:R>y/2?`\r
`:`
`}create(m){const y=this.k(m),R=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let l=0,p=R.length;l<p;l++){const b=R[l].buffer.replace(/\r\n|\r|\n/g,y),a=(0,T.$LB)(b);R[l]=new T.$OB(b,a)}const S=new C.$QB(R,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class P{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&E.$qf(m)&&(this.b=E.$pf,m=m.substr(1));const y=m.charCodeAt(m.length-1);y===13||y>=55296&&y<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=y):(this.m(m,!1),this.c=!1,this.d=y)}m(m,y){!y&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const y=(0,T.$MB)(this.e,m);this.a.push(new T.$OB(m,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=E.$hf(m)),this.k||(this.k=E.$kf(m)))}finish(m=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const y=(0,T.$LB)(m.buffer);m.lineStarts=y,this.d===13&&this.f++}}}e.$RB=P}),define(Pe[95],Re([1,0,24,21]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$90=e.$80=void 0;var C;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(C||(C={}));function M(S){for(let l=0,p=S.length;l<p;l+=4){const b=S[l+0],a=S[l+1],s=S[l+2],t=S[l+3];S[l+0]=t,S[l+1]=s,S[l+2]=a,S[l+3]=b}}function P(S){const l=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return T.$D()||M(l),E.$fe.wrap(l)}function $(S){const l=S.buffer;if(T.$D()||M(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const p=new Uint8Array(l.byteLength);return p.set(l),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function m(S){const l=new Uint32Array(y(S));let p=0;if(l[p++]=S.id,S.type==="full")l[p++]=1,l[p++]=S.data.length,l.set(S.data,p),p+=S.data.length;else{l[p++]=2,l[p++]=S.deltas.length;for(const b of S.deltas)l[p++]=b.start,l[p++]=b.deleteCount,b.data?(l[p++]=b.data.length,l.set(b.data,p),p+=b.data.length):l[p++]=0}return P(l)}e.$80=m;function y(S){let l=0;if(l+=1+1,S.type==="full")l+=1+S.data.length;else{l+=1,l+=(1+1+1)*S.deltas.length;for(const p of S.deltas)p.data&&(l+=p.data.length)}return l}function R(S){const l=$(S);let p=0;const b=l[p++];if(l[p++]===1){const n=l[p++],o=l.subarray(p,p+n);return p+=n,{id:b,type:"full",data:o}}const s=l[p++],t=[];for(let n=0;n<s;n++){const o=l[p++],c=l[p++],d=l[p++];let i;d>0&&(i=l.subarray(p,p+d),p+=d),t[n]={start:o,deleteCount:c,data:i}}return{id:b,type:"delta",deltas:t}}e.$90=R}),define(Pe[144],Re([9,10]),function(pe,e){return pe.create("vs/editor/common/config/editorOptions",e)}),define(Pe[145],Re([1,0,18,26,21,127,146,144]),function(pe,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var m;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=y;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class S{constructor(Z,ve,Be,He){this.id=Z,this.name=ve,this.defaultValue=Be,this.schema=He}applyUpdate(Z,ve){return p(Z,ve)}compute(Z,ve,Be){return Be}}class l{constructor(Z,ve){this.newValue=Z,this.didChange=ve}}e.ApplyUpdateResult=l;function p(_,Z){if(typeof _!="object"||typeof Z!="object"||!_||!Z)return new l(Z,_!==Z);if(Array.isArray(_)||Array.isArray(Z)){const Be=Array.isArray(_)&&Array.isArray(Z)&&E.$tb(_,Z);return new l(Z,!Be)}let ve=!1;for(const Be in Z)if(Z.hasOwnProperty(Be)){const He=p(_[Be],Z[Be]);He.didChange&&(_[Be]=He.newValue,ve=!0)}return new l(_,ve)}class b{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,ve){return p(Z,ve)}validate(Z){return this.defaultValue}}class a{constructor(Z,ve,Be,He){this.id=Z,this.name=ve,this.defaultValue=Be,this.schema=He}applyUpdate(Z,ve){return p(Z,ve)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,ve,Be){return Be}}function s(_,Z){return typeof _>"u"?Z:_==="false"?!1:!!_}e.boolean=s;class t extends a{constructor(Z,ve,Be,He=void 0){typeof He<"u"&&(He.type="boolean",He.default=Be),super(Z,ve,Be,He)}validate(Z){return s(Z,this.defaultValue)}}function n(_,Z,ve,Be){if(typeof _>"u")return Z;let He=parseInt(_,10);return isNaN(He)?Z:(He=Math.max(ve,He),He=Math.min(Be,He),He|0)}e.clampedInt=n;class o extends a{static clampedInt(Z,ve,Be,He){return n(Z,ve,Be,He)}constructor(Z,ve,Be,He,Xe,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Be,st.minimum=He,st.maximum=Xe),super(Z,ve,Be,st),this.minimum=He,this.maximum=Xe}validate(Z){return o.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function c(_,Z,ve,Be){if(typeof _>"u")return Z;const He=d.float(_,Z);return d.clamp(He,ve,Be)}e.clampedFloat=c;class d extends a{static clamp(Z,ve,Be){return Z<ve?ve:Z>Be?Be:Z}static float(Z,ve){if(typeof Z=="number")return Z;if(typeof Z>"u")return ve;const Be=parseFloat(Z);return isNaN(Be)?ve:Be}constructor(Z,ve,Be,He,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(Z,ve,Be,Xe),this.validationFn=He}validate(Z){return this.validationFn(d.float(Z,this.defaultValue))}}class i extends a{static string(Z,ve){return typeof Z!="string"?ve:Z}constructor(Z,ve,Be,He=void 0){typeof He<"u"&&(He.type="string",He.default=Be),super(Z,ve,Be,He)}validate(Z){return i.string(Z,this.defaultValue)}}function r(_,Z,ve,Be){return typeof _!="string"?Z:Be&&_ in Be?Be[_]:ve.indexOf(_)===-1?Z:_}e.stringSet=r;class u extends a{constructor(Z,ve,Be,He,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=He,Xe.default=Be),super(Z,ve,Be,Xe),this.c=He}validate(Z){return r(Z,this.defaultValue,this.c)}}class f extends S{constructor(Z,ve,Be,He,Xe,st,pt=void 0){typeof pt<"u"&&(pt.type="string",pt.enum=Xe,pt.default=He),super(Z,ve,Be,pt),this.c=Xe,this.d=st}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function v(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,ve,Be){return Be===0?Z.accessibilitySupport:Be}}class D extends S{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:$.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{insertSpace:s(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function h(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function k(_){switch(_){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function F(_){switch(_){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class W extends b{constructor(){super(140)}compute(Z,ve,Be){const He=["monaco-editor"];return ve.get(39)&&He.push(ve.get(39)),Z.extraEditorClassName&&He.push(Z.extraEditorClassName),ve.get(73)==="default"?He.push("mouse-default"):ve.get(73)==="copy"&&He.push("mouse-copy"),ve.get(110)&&He.push("showUnused"),ve.get(138)&&He.push("showDeprecated"),He.join(" ")}}class Q extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(Z,ve,Be){return Be&&Z.emptySelectionClipboard}}class N extends S{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:$.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:$.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{cursorMoveOnType:s(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":r(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":r(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(ve.loop,this.defaultValue.loop)}}}class A extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",A.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?A.OFF:Z==="true"?A.ON:Z:Z?A.ON:A.OFF}}e.EditorFontLigatures=A;class L extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",L.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?L.OFF:Z==="true"?L.TRANSLATE:Z:Z?L.TRANSLATE:L.OFF}compute(Z,ve,Be){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=L;class O extends b{constructor(){super(50)}compute(Z,ve,Be){return Z.fontInfo}}class x extends a{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(Z){const ve=d.float(Z,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(ve,6,100)}compute(Z,ve,Be){return Z.fontInfo.fontSize}}class le extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:le.d,maximum:le.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:le.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(o.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,le.d,le.e))}}class me extends S{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Be,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Be,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Be,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Be,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Be,description:$.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{multiple:r(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??r(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??r(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??r(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??r(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??r(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends S{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:$.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),delay:o.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:s(ve.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(ve.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:s(ve.above,this.defaultValue.above)}}}var we;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(we||(e.RenderMinimap=we={}));class de extends b{constructor(){super(143)}compute(Z,ve,Be){return de.computeLayout(ve,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const ve=Z.height/Z.lineHeight,Be=Math.floor(Z.paddingTop/Z.lineHeight);let He=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(He=Math.max(He,ve-1));const Xe=(Be+Z.viewLineCount+He)/(Z.pixelRatio*Z.height),st=Math.floor(Z.viewLineCount/Xe);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:He,desiredRatio:Xe,minimapLineCount:st}}static c(Z,ve){const Be=Z.outerWidth,He=Z.outerHeight,Xe=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const st=ve.stableMinimapLayoutInput,pt=st&&Z.outerHeight===st.outerHeight&&Z.lineHeight===st.lineHeight&&Z.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&Z.pixelRatio===st.pixelRatio&&Z.scrollBeyondLastLine===st.scrollBeyondLastLine&&Z.paddingTop===st.paddingTop&&Z.paddingBottom===st.paddingBottom&&Z.minimap.enabled===st.minimap.enabled&&Z.minimap.side===st.minimap.side&&Z.minimap.size===st.minimap.size&&Z.minimap.showSlider===st.minimap.showSlider&&Z.minimap.renderCharacters===st.minimap.renderCharacters&&Z.minimap.maxColumn===st.minimap.maxColumn&&Z.minimap.scale===st.minimap.scale&&Z.verticalScrollbarWidth===st.verticalScrollbarWidth&&Z.isViewportWrapping===st.isViewportWrapping,Te=Z.lineHeight,Rt=Z.typicalHalfwidthCharacterWidth,Kt=Z.scrollBeyondLastLine,Ht=Z.minimap.renderCharacters;let wt=Xe>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Ut=Z.minimap.maxColumn,Ot=Z.minimap.size,Gt=Z.minimap.side,Bt=Z.verticalScrollbarWidth,kt=Z.viewLineCount,Tt=Z.remainingWidth,Ze=Z.isViewportWrapping,Jt=Ht?2:3;let Wt=Math.floor(Xe*He);const ct=Wt/Xe;let ft=!1,Vt=!1,At=Jt*wt,Dt=wt/Xe,gt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:Ee,extraLinesBeyondLastLine:Me,desiredRatio:$e,minimapLineCount:K}=de.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:Kt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:He,lineHeight:Te,pixelRatio:Xe});if(kt/K>1)ft=!0,Vt=!0,wt=1,At=1,Dt=wt/Xe;else{let Ue=!1,Qe=wt+1;if(Ot==="fit"){const qe=Math.ceil((Ee+kt+Me)*At);Ze&&pt&&Tt<=ve.stableFitRemainingWidth?(Ue=!0,Qe=ve.stableFitMaxMinimapScale):Ue=qe>Wt}if(Ot==="fill"||Ue){ft=!0;const qe=wt;At=Math.min(Te*Xe,Math.max(1,Math.floor(1/$e))),Ze&&pt&&Tt<=ve.stableFitRemainingWidth&&(Qe=ve.stableFitMaxMinimapScale),wt=Math.min(Qe,Math.max(1,Math.floor(At/Jt))),wt>qe&&(gt=Math.min(2,wt/qe)),Dt=wt/Xe/gt,Wt=Math.ceil(Math.max(Qt,Ee+kt+Me)*At),Ze?(ve.stableMinimapLayoutInput=Z,ve.stableFitRemainingWidth=Tt,ve.stableFitMaxMinimapScale=wt):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const Mt=Math.floor(Ut*Dt),Pt=Math.min(Mt,Math.max(0,Math.floor((Tt-Bt-2)*Dt/(Rt+Dt)))+e.MINIMAP_GUTTER_WIDTH);let St=Math.floor(Xe*Pt);const Ve=St/Xe;St=Math.floor(St*gt);const Nt=Ht?1:2,zt=Gt==="left"?0:Be-Pt-Bt;return{renderMinimap:Nt,minimapLeft:zt,minimapWidth:Pt,minimapHeightIsEditorHeight:ft,minimapIsSampling:Vt,minimapScale:wt,minimapLineHeight:At,minimapCanvasInnerWidth:St,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Ve,minimapCanvasOuterHeight:ct}}static computeLayout(Z,ve){const Be=ve.outerWidth|0,He=ve.outerHeight|0,Xe=ve.lineHeight|0,st=ve.lineNumbersDigitCount|0,pt=ve.typicalHalfwidthCharacterWidth,Te=ve.maxDigitWidth,Rt=ve.pixelRatio,Kt=ve.viewLineCount,Ht=Z.get(135),wt=Ht==="inherit"?Z.get(134):Ht,Ut=wt==="inherit"?Z.get(130):wt,Ot=Z.get(133),Gt=ve.isDominatedByLongLines,Bt=Z.get(57),kt=Z.get(67).renderType!==0,Tt=Z.get(68),Ze=Z.get(104),Jt=Z.get(83),Wt=Z.get(72),ct=Z.get(102),ft=ct.verticalScrollbarSize,Vt=ct.verticalHasArrows,At=ct.arrowSize,Dt=ct.horizontalScrollbarSize,gt=Z.get(43),Mt=Z.get(109)!=="never";let Pt=Z.get(65);gt&&Mt&&(Pt+=16);let St=0;if(kt){const ut=Math.max(st,Tt);St=Math.round(ut*Te)}let Ve=0;Bt&&(Ve=Xe*ve.glyphMarginDecorationLaneCount);let Nt=0,zt=Nt+Ve,Qt=zt+St,Ee=Qt+Pt;const Me=Be-Ve-St-Pt;let $e=!1,K=!1,Le=-1;wt==="inherit"&&Gt?($e=!0,K=!0):Ut==="on"||Ut==="bounded"?K=!0:Ut==="wordWrapColumn"&&(Le=Ot);const Ue=de.c({outerWidth:Be,outerHeight:He,lineHeight:Xe,typicalHalfwidthCharacterWidth:pt,pixelRatio:Rt,scrollBeyondLastLine:Ze,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Wt,verticalScrollbarWidth:ft,viewLineCount:Kt,remainingWidth:Me,isViewportWrapping:K},ve.memory||new R);Ue.renderMinimap!==0&&Ue.minimapLeft===0&&(Nt+=Ue.minimapWidth,zt+=Ue.minimapWidth,Qt+=Ue.minimapWidth,Ee+=Ue.minimapWidth);const Qe=Me-Ue.minimapWidth,qe=Math.max(1,Math.floor((Qe-ft-2)/pt)),et=Vt?At:0;return K&&(Le=Math.max(1,qe),Ut==="bounded"&&(Le=Math.min(Le,Ot))),{width:Be,height:He,glyphMarginLeft:Nt,glyphMarginWidth:Ve,glyphMarginDecorationLaneCount:ve.glyphMarginDecorationLaneCount,lineNumbersLeft:zt,lineNumbersWidth:St,decorationsLeft:Qt,decorationsWidth:Pt,contentLeft:Ee,contentWidth:Qe,minimap:Ue,viewportColumn:qe,isWordWrapMinified:$e,isViewportWrapping:K,wrappingColumn:Le,verticalScrollbarWidth:ft,horizontalScrollbarHeight:Dt,overviewRuler:{top:et,width:ft,height:He-2*et,right:0}}}}e.EditorLayoutInfoComputer=de;class be extends S{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(Z){return r(Z,"simple",["simple","advanced"])}compute(Z,ve,Be){return ve.get(2)===2?"advanced":Be}}class ie extends S{constructor(){const Z={enabled:!0};super(64,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:$.localize(50,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:s(Z.enabled,this.defaultValue.enabled)}}}class Ie extends S{constructor(){const Z={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:$.localize(54,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(ve.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:s(ve.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ce extends S{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:$.localize(62,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:r(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(ve.fontFamily,this.defaultValue.fontFamily),padding:s(ve.padding,this.defaultValue.padding)}}}class Y extends S{constructor(){super(65,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):o.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,ve,Be){return Be<0?o.clampedInt(-Be*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class B extends d{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>d.clamp(Z,0,150),{markdownDescription:$.localize(63,null)})}compute(Z,ve,Be){return Z.fontInfo.lineHeight}}class se extends S{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:Z.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:$.localize(74,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),autohide:s(ve.autohide,this.defaultValue.autohide),size:r(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(ve.side,this.defaultValue.side,["right","left"]),showSlider:r(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(ve.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(ve.scale,1,1,3),maxColumn:o.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Se(_){return _==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class Ae extends S{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{top:o.clampedInt(ve.top,0,0,1e3),bottom:o.clampedInt(ve.bottom,0,0,1e3)}}}class Ce extends S{constructor(){const Z={enabled:!0,cycle:!0};super(85,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:$.localize(78,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),cycle:s(ve.cycle,this.defaultValue.cycle)}}}class fe extends b{constructor(){super(141)}compute(Z,ve,Be){return Z.pixelRatio}}class ne extends S{constructor(){const Z={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(88,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:Z.strings,description:$.localize(82,null)},comments:{anyOf:ve,default:Z.comments,description:$.localize(83,null)},other:{anyOf:ve,default:Z.other,description:$.localize(84,null)}},default:Z,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Rt=Z?"on":"off";return{comments:Rt,strings:Rt,other:Rt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:ve,comments:Be,strings:He}=Z,Xe=["on","inline","off"];let st,pt,Te;return typeof ve=="boolean"?st=ve?"on":"off":st=r(ve,this.defaultValue.other,Xe),typeof Be=="boolean"?pt=Be?"on":"off":pt=r(Be,this.defaultValue.comments,Xe),typeof He=="boolean"?Te=He?"on":"off":Te=r(He,this.defaultValue.strings,Xe),{other:st,comments:pt,strings:Te}}}var H;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(H||(e.RenderLineNumbersType=H={}));class te extends S{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(Z){let ve=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(ve=4,Be=Z):Z==="interval"?ve=3:Z==="relative"?ve=2:Z==="on"?ve=1:ve=0),{renderType:ve,renderFn:Be}}}function X(_){const Z=_.get(97);return Z==="editable"?_.get(90):Z!=="on"}e.filterValidationDecorations=X;class re extends S{constructor(){const Z=[],ve={type:"number",description:$.localize(91,null)};super(101,"rulers",Z,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:Z,description:$.localize(93,null)})}validate(Z){if(Array.isArray(Z)){const ve=[];for(const Be of Z)if(typeof Be=="number")ve.push({column:o.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const He=Be;ve.push({column:o.clampedInt(He.column,0,0,1e4),color:He.color})}return ve.sort((Be,He)=>Be.column-He.column),ve}return this.defaultValue}}class he extends S{constructor(){super(91,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function De(_,Z){if(typeof _!="string")return Z;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends S{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:$.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:$.localize(105,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z,Be=o.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=o.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(ve.vertical,this.defaultValue.vertical),horizontal:De(ve.horizontal,this.defaultValue.horizontal),useShadows:s(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:o.clampedInt(ve.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:He,verticalSliderSize:o.clampedInt(ve.verticalSliderSize,He,0,1e3),scrollByPage:s(ve.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:s(ve.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends S{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:$.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:$.localize(112,null)}})}applyUpdate(Z,ve){let Be=!1;ve.allowedCharacters&&Z&&(T.$in(Z.allowedCharacters,ve.allowedCharacters)||(Z={...Z,allowedCharacters:ve.allowedCharacters},Be=!0)),ve.allowedLocales&&Z&&(T.$in(Z.allowedLocales,ve.allowedLocales)||(Z={...Z,allowedLocales:ve.allowedLocales},Be=!0));const He=super.applyUpdate(Z,ve);return Be?new l(He.newValue,!0):He}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{nonBasicASCII:ee(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,ve){if(typeof Z!="object"||!Z)return ve;const Be={};for(const[He,Xe]of Object.entries(Z))Xe===!0&&(Be[He]=!0);return Be}}class G extends S{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:$.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(114,null),$.localize(115,null),$.localize(116,null)],description:$.localize(117,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:$.localize(118,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),mode:r(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:s(ve.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:s(ve.keepOnBlur,this.defaultValue.keepOnBlur)}}}class J extends S{constructor(){const Z={enabled:M.$as.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$as.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(119,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:$.localize(120,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends S{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(121,null),$.localize(122,null),$.localize(123,null)],default:Z.bracketPairs,description:$.localize(124,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(125,null),$.localize(126,null),$.localize(127,null)],default:Z.bracketPairsHorizontal,description:$.localize(128,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:$.localize(129,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:$.localize(130,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(131,null),$.localize(132,null),$.localize(133,null)],default:Z.highlightActiveIndentation,description:$.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{bracketPairs:ee(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(_,Z,ve){const Be=ve.indexOf(_);return Be===-1?Z:ve[Be]}class ue extends S{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(135,null),$.localize(136,null)],default:Z.insertMode,description:$.localize(137,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:$.localize(138,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:$.localize(139,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:$.localize(140,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(141,null),$.localize(142,null),$.localize(143,null),$.localize(144,null)],default:Z.selectionMode,markdownDescription:$.localize(145,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:$.localize(146,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:$.localize(147,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:$.localize(148,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:$.localize(149,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:$.localize(150,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(151,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(152,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(182,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{insertMode:r(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s(ve.showIcons,this.defaultValue.showIcons),showStatusBar:s(ve.showStatusBar,this.defaultValue.showStatusBar),preview:s(ve.preview,this.defaultValue.preview),previewMode:r(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(ve.showMethods,this.defaultValue.showMethods),showFunctions:s(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:s(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s(ve.showFields,this.defaultValue.showFields),showVariables:s(ve.showVariables,this.defaultValue.showVariables),showClasses:s(ve.showClasses,this.defaultValue.showClasses),showStructs:s(ve.showStructs,this.defaultValue.showStructs),showInterfaces:s(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:s(ve.showModules,this.defaultValue.showModules),showProperties:s(ve.showProperties,this.defaultValue.showProperties),showEvents:s(ve.showEvents,this.defaultValue.showEvents),showOperators:s(ve.showOperators,this.defaultValue.showOperators),showUnits:s(ve.showUnits,this.defaultValue.showUnits),showValues:s(ve.showValues,this.defaultValue.showValues),showConstants:s(ve.showConstants,this.defaultValue.showConstants),showEnums:s(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:s(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(ve.showKeywords,this.defaultValue.showKeywords),showWords:s(ve.showWords,this.defaultValue.showWords),showColors:s(ve.showColors,this.defaultValue.showColors),showFiles:s(ve.showFiles,this.defaultValue.showFiles),showReferences:s(ve.showReferences,this.defaultValue.showReferences),showFolders:s(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:s(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(ve.showSnippets,this.defaultValue.showSnippets),showUsers:s(ve.showUsers,this.defaultValue.showUsers),showIssues:s(ve.showIssues,this.defaultValue.showIssues)}}}class Ne extends S{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(183,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(184,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:s(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var je;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(je||(e.WrappingIndent=je={}));class Ye extends S{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(185,null),$.localize(186,null),$.localize(187,null),$.localize(188,null)],description:$.localize(189,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,ve,Be){return ve.get(2)===2?0:Be}}class Je extends b{constructor(){super(144)}compute(Z,ve,Be){const He=ve.get(143);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class it extends S{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(190,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(191,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(192,null),$.localize(193,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),showDropSelector:r(ve.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class _e extends S{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(194,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(195,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(196,null),$.localize(197,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),showPasteSelector:r(ve.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const tt="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?rt:C.$k?nt:tt,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(_){return e.editorOptionsRegistry[_.id]=_,_}var ht;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.letterSpacing=63]="letterSpacing",_[_.lightbulb=64]="lightbulb",_[_.lineDecorationsWidth=65]="lineDecorationsWidth",_[_.lineHeight=66]="lineHeight",_[_.lineNumbers=67]="lineNumbers",_[_.lineNumbersMinChars=68]="lineNumbersMinChars",_[_.linkedEditing=69]="linkedEditing",_[_.links=70]="links",_[_.matchBrackets=71]="matchBrackets",_[_.minimap=72]="minimap",_[_.mouseStyle=73]="mouseStyle",_[_.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=75]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",_[_.multiCursorModifier=77]="multiCursorModifier",_[_.multiCursorPaste=78]="multiCursorPaste",_[_.multiCursorLimit=79]="multiCursorLimit",_[_.occurrencesHighlight=80]="occurrencesHighlight",_[_.overviewRulerBorder=81]="overviewRulerBorder",_[_.overviewRulerLanes=82]="overviewRulerLanes",_[_.padding=83]="padding",_[_.pasteAs=84]="pasteAs",_[_.parameterHints=85]="parameterHints",_[_.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",_[_.quickSuggestions=88]="quickSuggestions",_[_.quickSuggestionsDelay=89]="quickSuggestionsDelay",_[_.readOnly=90]="readOnly",_[_.readOnlyMessage=91]="readOnlyMessage",_[_.renameOnType=92]="renameOnType",_[_.renderControlCharacters=93]="renderControlCharacters",_[_.renderFinalNewline=94]="renderFinalNewline",_[_.renderLineHighlight=95]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=97]="renderValidationDecorations",_[_.renderWhitespace=98]="renderWhitespace",_[_.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",_[_.roundedSelection=100]="roundedSelection",_[_.rulers=101]="rulers",_[_.scrollbar=102]="scrollbar",_[_.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=104]="scrollBeyondLastLine",_[_.scrollPredominantAxis=105]="scrollPredominantAxis",_[_.selectionClipboard=106]="selectionClipboard",_[_.selectionHighlight=107]="selectionHighlight",_[_.selectOnLineNumbers=108]="selectOnLineNumbers",_[_.showFoldingControls=109]="showFoldingControls",_[_.showUnused=110]="showUnused",_[_.snippetSuggestions=111]="snippetSuggestions",_[_.smartSelect=112]="smartSelect",_[_.smoothScrolling=113]="smoothScrolling",_[_.stickyScroll=114]="stickyScroll",_[_.stickyTabStops=115]="stickyTabStops",_[_.stopRenderingLineAfter=116]="stopRenderingLineAfter",_[_.suggest=117]="suggest",_[_.suggestFontSize=118]="suggestFontSize",_[_.suggestLineHeight=119]="suggestLineHeight",_[_.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",_[_.suggestSelection=121]="suggestSelection",_[_.tabCompletion=122]="tabCompletion",_[_.tabIndex=123]="tabIndex",_[_.unicodeHighlighting=124]="unicodeHighlighting",_[_.unusualLineTerminators=125]="unusualLineTerminators",_[_.useShadowDOM=126]="useShadowDOM",_[_.useTabStops=127]="useTabStops",_[_.wordBreak=128]="wordBreak",_[_.wordSeparators=129]="wordSeparators",_[_.wordWrap=130]="wordWrap",_[_.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=133]="wordWrapColumn",_[_.wordWrapOverride1=134]="wordWrapOverride1",_[_.wordWrapOverride2=135]="wordWrapOverride2",_[_.wrappingIndent=136]="wrappingIndent",_[_.wrappingStrategy=137]="wrappingStrategy",_[_.showDeprecated=138]="showDeprecated",_[_.inlayHints=139]="inlayHints",_[_.editorClassName=140]="editorClassName",_[_.pixelRatio=141]="pixelRatio",_[_.tabFocusMode=142]="tabFocusMode",_[_.layoutInfo=143]="layoutInfo",_[_.wrappingInfo=144]="wrappingInfo",_[_.defaultColorDecorators=145]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(ht||(e.EditorOption=ht={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(198,null)})),acceptSuggestionOnEnter:ze(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(199,null),""],markdownDescription:$.localize(200,null)})),accessibilitySupport:ze(new g),accessibilityPageSize:ze(new o(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(201,null),tags:["accessibility"]})),ariaLabel:ze(new i(4,"ariaLabel",$.localize(202,null))),ariaRequired:ze(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(203,null),tags:["accessibility"]})),autoClosingBrackets:ze(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(204,null),$.localize(205,null),""],description:$.localize(206,null)})),autoClosingComments:ze(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(207,null),$.localize(208,null),""],description:$.localize(209,null)})),autoClosingDelete:ze(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(210,null),""],description:$.localize(211,null)})),autoClosingOvertype:ze(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(212,null),""],description:$.localize(213,null)})),autoClosingQuotes:ze(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(214,null),$.localize(215,null),""],description:$.localize(216,null)})),autoIndent:ze(new f(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[$.localize(217,null),$.localize(218,null),$.localize(219,null),$.localize(220,null),$.localize(221,null)],description:$.localize(222,null)})),automaticLayout:ze(new t(13,"automaticLayout",!1)),autoSurround:ze(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(223,null),$.localize(224,null),$.localize(225,null),""],description:$.localize(226,null)})),bracketPairColorization:ze(new J),bracketPairGuides:ze(new q),stickyTabStops:ze(new t(115,"stickyTabStops",!1,{description:$.localize(227,null)})),codeLens:ze(new t(17,"codeLens",!0,{description:$.localize(228,null)})),codeLensFontFamily:ze(new i(18,"codeLensFontFamily","",{description:$.localize(229,null)})),codeLensFontSize:ze(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(230,null)})),colorDecorators:ze(new t(20,"colorDecorators",!0,{description:$.localize(231,null)})),colorDecoratorActivatedOn:ze(new u(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(232,null),$.localize(233,null),$.localize(234,null)],description:$.localize(235,null)})),colorDecoratorsLimit:ze(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(236,null)})),columnSelection:ze(new t(22,"columnSelection",!1,{description:$.localize(237,null)})),comments:ze(new D),contextmenu:ze(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new t(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(238,null)})),cursorBlinking:ze(new f(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:$.localize(239,null)})),cursorSmoothCaretAnimation:ze(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(240,null),$.localize(241,null),$.localize(242,null)],description:$.localize(243,null)})),cursorStyle:ze(new f(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:$.localize(244,null)})),cursorSurroundingLines:ze(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(245,null)})),cursorSurroundingLinesStyle:ze(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(246,null),$.localize(247,null)],markdownDescription:$.localize(248,null)})),cursorWidth:ze(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(249,null)})),disableLayerHinting:ze(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new t(34,"domReadOnly",!1)),dragAndDrop:ze(new t(35,"dragAndDrop",!0,{description:$.localize(250,null)})),emptySelectionClipboard:ze(new Q),dropIntoEditor:ze(new it),stickyScroll:ze(new Ie),experimentalWhitespaceRendering:ze(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(251,null),$.localize(252,null),$.localize(253,null)],description:$.localize(254,null)})),extraEditorClassName:ze(new i(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new d(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:$.localize(255,null)})),find:ze(new N),fixedOverflowWidgets:ze(new t(42,"fixedOverflowWidgets",!1)),folding:ze(new t(43,"folding",!0,{description:$.localize(256,null)})),foldingStrategy:ze(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(257,null),$.localize(258,null)],description:$.localize(259,null)})),foldingHighlight:ze(new t(45,"foldingHighlight",!0,{description:$.localize(260,null)})),foldingImportsByDefault:ze(new t(46,"foldingImportsByDefault",!1,{description:$.localize(261,null)})),foldingMaximumRegions:ze(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(262,null)})),unfoldOnClickAfterEndOfLine:ze(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(263,null)})),fontFamily:ze(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(264,null)})),fontInfo:ze(new O),fontLigatures2:ze(new A),fontSize:ze(new x),fontWeight:ze(new le),fontVariations:ze(new L),formatOnPaste:ze(new t(55,"formatOnPaste",!1,{description:$.localize(265,null)})),formatOnType:ze(new t(56,"formatOnType",!1,{description:$.localize(266,null)})),glyphMargin:ze(new t(57,"glyphMargin",!0,{description:$.localize(267,null)})),gotoLocation:ze(new me),hideCursorInOverviewRuler:ze(new t(59,"hideCursorInOverviewRuler",!1,{description:$.localize(268,null)})),hover:ze(new ye),inDiffEditor:ze(new t(61,"inDiffEditor",!1)),letterSpacing:ze(new d(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>d.clamp(_,-5,20),{description:$.localize(269,null)})),lightbulb:ze(new ie),lineDecorationsWidth:ze(new Y),lineHeight:ze(new B),lineNumbers:ze(new te),lineNumbersMinChars:ze(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new t(69,"linkedEditing",!1,{description:$.localize(270,null)})),links:ze(new t(70,"links",!0,{description:$.localize(271,null)})),matchBrackets:ze(new u(71,"matchBrackets","always",["always","near","never"],{description:$.localize(272,null)})),minimap:ze(new se),mouseStyle:ze(new u(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new d(74,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:$.localize(273,null)})),mouseWheelZoom:ze(new t(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(274,null)})),multiCursorMergeOverlapping:ze(new t(76,"multiCursorMergeOverlapping",!0,{description:$.localize(275,null)})),multiCursorModifier:ze(new f(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Se,{markdownEnumDescriptions:[$.localize(276,null),$.localize(277,null)],markdownDescription:$.localize(278,null)})),multiCursorPaste:ze(new u(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(279,null),$.localize(280,null)],markdownDescription:$.localize(281,null)})),multiCursorLimit:ze(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(282,null)})),occurrencesHighlight:ze(new u(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(283,null),$.localize(284,null),$.localize(285,null)],markdownDescription:$.localize(286,null)})),overviewRulerBorder:ze(new t(81,"overviewRulerBorder",!0,{description:$.localize(287,null)})),overviewRulerLanes:ze(new o(82,"overviewRulerLanes",3,0,3)),padding:ze(new Ae),pasteAs:ze(new _e),parameterHints:ze(new Ce),peekWidgetDefaultFocus:ze(new u(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(288,null),$.localize(289,null)],description:$.localize(290,null)})),definitionLinkOpensInPeek:ze(new t(87,"definitionLinkOpensInPeek",!1,{description:$.localize(291,null)})),quickSuggestions:ze(new ne),quickSuggestionsDelay:ze(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(292,null)})),readOnly:ze(new t(90,"readOnly",!1)),readOnlyMessage:ze(new he),renameOnType:ze(new t(92,"renameOnType",!1,{description:$.localize(293,null),markdownDeprecationMessage:$.localize(294,null)})),renderControlCharacters:ze(new t(93,"renderControlCharacters",!0,{description:$.localize(295,null),restricted:!0})),renderFinalNewline:ze(new u(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(296,null)})),renderLineHighlight:ze(new u(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(297,null)],description:$.localize(298,null)})),renderLineHighlightOnlyWhenFocus:ze(new t(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(299,null)})),renderValidationDecorations:ze(new u(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new u(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(300,null),$.localize(301,null),$.localize(302,null),""],description:$.localize(303,null)})),revealHorizontalRightPadding:ze(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new t(100,"roundedSelection",!0,{description:$.localize(304,null)})),rulers:ze(new re),scrollbar:ze(new z),scrollBeyondLastColumn:ze(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(305,null)})),scrollBeyondLastLine:ze(new t(104,"scrollBeyondLastLine",!0,{description:$.localize(306,null)})),scrollPredominantAxis:ze(new t(105,"scrollPredominantAxis",!0,{description:$.localize(307,null)})),selectionClipboard:ze(new t(106,"selectionClipboard",!0,{description:$.localize(308,null),included:C.$k})),selectionHighlight:ze(new t(107,"selectionHighlight",!0,{description:$.localize(309,null)})),selectOnLineNumbers:ze(new t(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new u(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(310,null),$.localize(311,null),$.localize(312,null)],description:$.localize(313,null)})),showUnused:ze(new t(110,"showUnused",!0,{description:$.localize(314,null)})),showDeprecated:ze(new t(138,"showDeprecated",!0,{description:$.localize(315,null)})),inlayHints:ze(new ce),snippetSuggestions:ze(new u(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(316,null),$.localize(317,null),$.localize(318,null),$.localize(319,null)],description:$.localize(320,null)})),smartSelect:ze(new Ne),smoothScrolling:ze(new t(113,"smoothScrolling",!1,{description:$.localize(321,null)})),stopRenderingLineAfter:ze(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ue),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new t(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(322,null)})),suggestFontSize:ze(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(323,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(324,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new t(120,"suggestOnTriggerCharacters",!0,{description:$.localize(325,null)})),suggestSelection:ze(new u(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(326,null),$.localize(327,null),$.localize(328,null)],description:$.localize(329,null)})),tabCompletion:ze(new u(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(330,null),$.localize(331,null),$.localize(332,null)],description:$.localize(333,null)})),tabIndex:ze(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new V),unusualLineTerminators:ze(new u(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(334,null),$.localize(335,null),$.localize(336,null)],description:$.localize(337,null)})),useShadowDOM:ze(new t(126,"useShadowDOM",!0)),useTabStops:ze(new t(127,"useTabStops",!0,{description:$.localize(338,null)})),wordBreak:ze(new u(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(339,null),$.localize(340,null)],description:$.localize(341,null)})),wordSeparators:ze(new i(129,"wordSeparators",P.$bs,{description:$.localize(342,null)})),wordWrap:ze(new u(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(343,null),$.localize(344,null),$.localize(345,null),$.localize(346,null)],description:$.localize(347,null)})),wordWrapBreakAfterCharacters:ze(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(348,null)})),wordWrapOverride1:ze(new u(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new u(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new W),defaultColorDecorators:ze(new t(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(349,null)})),pixelRatio:ze(new fe),tabFocusMode:ze(new t(142,"tabFocusMode",!1,{markdownDescription:$.localize(350,null)})),layoutInfo:ze(new de),wrappingInfo:ze(new Je),wrappingIndent:ze(new Ye),wrappingStrategy:ze(new be)}}),define(Pe[147],Re([9,10]),function(pe,e){return pe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[148],Re([9,10]),function(pe,e){return pe.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[149],Re([9,10]),function(pe,e){return pe.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[150],Re([9,10]),function(pe,e){return pe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[151],Re([9,10]),function(pe,e){return pe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[152],Re([9,10]),function(pe,e){return pe.create("vs/platform/files/common/files",e)}),define(Pe[153],Re([9,10]),function(pe,e){return pe.create("vs/platform/markers/common/markers",e)}),define(Pe[154],Re([9,10]),function(pe,e){return pe.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[155],Re([9,10]),function(pe,e){return pe.create("vs/platform/workspace/common/workspace",e)}),define(Pe[156],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[157],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[158],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[159],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[160],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[161],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[162],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[163],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[164],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[165],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[166],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[167],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[168],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[169],Re([9,10]),function(pe,e){return pe.create("vs/workbench/common/configuration",e)}),define(Pe[170],Re([9,10]),function(pe,e){return pe.create("vs/workbench/common/editor",e)}),define(Pe[171],Re([9,10]),function(pe,e){return pe.create("vs/workbench/common/views",e)}),define(Pe[172],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[173],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[174],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[175],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[176],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[177],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[178],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[179],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[180],Re([1,0,11,149]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.TokenType=void 0;var C;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(C||(e.TokenType=C={}));function M(...y){switch(y.length){case 1:return(0,T.localize)(0,null,y[0]);case 2:return(0,T.localize)(1,null,y[0],y[1]);case 3:return(0,T.localize)(2,null,y[0],y[1],y[2]);default:return}}const P=(0,T.localize)(3,null),$=(0,T.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,E.$7)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const S=this.d,l=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:l};this.g.push({offset:S,lexeme:l,additionalInfo:R}),this.f.push(p)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const S=this.c.substring(this.d,this.e),l=m.b.get(S);l?this.k(l):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,S=!1,l=!1;for(;;){if(R>=this.c.length){this.e=R,this.l($);return}const b=this.c.charCodeAt(R);if(S)S=!1;else if(b===47&&!l){R++;break}else b===91?l=!0:b===92?S=!0:b===93&&(l=!1);R++}for(;R<this.c.length&&m.a.has(this.c.charCodeAt(R));)R++;this.e=R;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ui=m}),define(Pe[181],Re([1,0,25,31,151,293]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function m(t){return t=t.trim(),t==="*"||P.test(t)}e.$Vo=m;function y(t){if(!m(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=t.match(P);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$Wo=y;function R(t){if(!t)return null;const n=t.majorBase,o=t.majorMustEqual,c=t.minorBase;let d=t.minorMustEqual;const i=t.patchBase;let r=t.patchMustEqual;t.hasCaret&&(n===0||(d=!1),r=!1);let u=0;if(t.preRelease){const f=$.exec(t.preRelease);if(f){const[,v,g,D]=f;u=Date.UTC(Number(v),Number(g)-1,Number(D))}}return{majorBase:n,majorMustEqual:o,minorBase:c,minorMustEqual:d,patchBase:i,patchMustEqual:r,isMinimum:t.hasGreaterEquals,notBefore:u}}e.$Xo=R;function S(t,n,o){let c;typeof t=="string"?c=R(y(t)):c=t;let d;n instanceof Date?d=n.getTime():typeof n=="string"&&(d=new Date(n).getTime());let i;if(typeof o=="string"?i=R(y(o)):i=o,!c||!i)return!1;const r=c.majorBase,u=c.minorBase,f=c.patchBase;let v=i.majorBase,g=i.minorBase,D=i.patchBase;const I=i.notBefore;let h=i.majorMustEqual,w=i.minorMustEqual,k=i.patchMustEqual;return i.isMinimum?r>v?!0:r<v?!1:u>g?!0:u<g||d&&d<I?!1:f>=D:(r===1&&v===0&&(!h||!w||!k)&&(v=1,g=0,D=0,h=!0,w=!1,k=!1),r<v?!1:r>v?!h:u<g?!1:u>g?!w:f<D?!1:f>D?!k:!(d&&d<I))}e.$Yo=S;function l(t,n,o,c,d){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([T.default.Error,C.localize(0,null)]),i;if(typeof c.name!="string")return i.push([T.default.Error,C.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([T.default.Error,C.localize(2,null,"version")]),i;if(!c.engines)return i.push([T.default.Error,C.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([T.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!s(c.extensionDependencies))return i.push([T.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!s(c.activationEvents))return i.push([T.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([T.default.Error,C.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([T.default.Warning,C.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([T.default.Error,C.localize(9,null,"main")]),i;{const f=(0,E.$Bg)(o,c.main);(0,E.$vg)(f,o)||i.push([T.default.Warning,C.localize(10,null,f.path,o.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([T.default.Error,C.localize(11,null,"browser")]),i;{const f=(0,E.$Bg)(o,c.browser);(0,E.$vg)(f,o)||i.push([T.default.Warning,C.localize(12,null,f.path,o.path)])}}if(!M.valid(c.version))return i.push([T.default.Error,C.localize(13,null)]),i;const r=[];if(!p(t,n,c,d,r))for(const f of r)i.push([T.default.Error,f]);return i}e.$Zo=l;function p(t,n,o,c,d){return c||typeof o.main>"u"&&typeof o.browser>"u"?!0:a(t,n,o.engines.vscode,d)}e.$1o=p;function b(t,n,o){return t==="*"||a(n,o,t)}e.$2o=b;function a(t,n,o,c=[]){const d=R(y(o));if(!d)return c.push(C.localize(14,null,o)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return c.push(C.localize(15,null,o)),!1}else if(!d.majorMustEqual)return c.push(C.localize(16,null,o)),!1;return S(t,n,d)?!0:(c.push(C.localize(17,null,t,o)),!1)}function s(t){if(!Array.isArray(t))return!1;for(let n=0,o=t.length;n<o;n++)if(typeof t[n]!="string")return!1;return!0}}),define(Pe[69],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=void 0;class E{constructor(C,M=[],P=!1){this.ctor=C,this.staticArguments=M,this.supportsDelayedInstantiation=P}}e.$Wh=E}),define(Pe[70],Re([1,0,69]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=e.InstantiationType=void 0;const T=[];var C;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function M($,m,y){m instanceof E.$Wh||(m=new E.$Wh(m,[],!!y)),T.push([$,m])}e.$Gr=M;function P(){return T}e.$Hr=P}),define(Pe[182],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=void 0;class E{constructor(M,P){this.key=M,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.$lq=E;class T{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const P of this.a.values())P.outgoing.size===0&&M.push(P);return M}insertEdge(M,P){const $=this.lookupOrInsertNode(M),m=this.lookupOrInsertNode(P);$.outgoing.set(m.key,m),m.incoming.set($.key,$)}removeNode(M){const P=this.b(M);this.a.delete(P);for(const $ of this.a.values())$.outgoing.delete(P),$.incoming.delete(P)}lookupOrInsertNode(M){const P=this.b(M);let $=this.a.get(P);return $||($=new E(P,M),this.a.set(P,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[P,$]of this.a)M.push(`${P}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,P]of this.a){const $=new Set([M]),m=this.c(P,$);if(m)return m}}c(M,P){for(const[$,m]of M.outgoing){if(P.has($))return[...P,$].join(" -> ");P.add($);const y=this.c(m,P);if(y)return y;P.delete($)}}}e.$mq=T}),define(Pe[4],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.$Zh=e.$Yh=e._util=void 0;var E;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function $(m){return m[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=$})(E||(e._util=E={})),e.$Yh=C("instantiationService");function T(P,$,m){$[E.DI_TARGET]===$?$[E.DI_DEPENDENCIES].push({id:P,index:m}):($[E.DI_DEPENDENCIES]=[{id:P,index:m}],$[E.DI_TARGET]=$)}function C(P){if(E.serviceIds.has(P))return E.serviceIds.get(P);const $=function(m,y,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T($,m,R)};return $.toString=()=>P,E.serviceIds.set(P,$),$}e.$Zh=C;function M(P){return P}e.$1h=M}),define(Pe[41],Re([1,0,16,2,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.ConfigurationTarget=e.$vi=e.$ui=e.$ti=void 0,e.$ti=(0,C.$Zh)("configurationService");function M(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.$ui=M;function P(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof T.URI)}e.$vi=P;var $;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function m(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$wi=m;function y(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$xi=y;function R(t,n){const o=Object.create(null);for(const c in t)S(o,c,t[c],n);return o}e.$yi=R;function S(t,n,o,c){const d=n.split("."),i=d.pop();let r=t;for(let u=0;u<d.length;u++){const f=d[u];let v=r[f];switch(typeof v){case"undefined":v=r[f]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${d.slice(0,u+1).join(".")} is ${JSON.stringify(v)}`);return}r=v}if(typeof r=="object"&&r!==null)try{r[i]=o}catch{c(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(r)}`)}else c(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(r)}`)}e.$zi=S;function l(t,n){const o=n.split(".");p(t,o)}e.$Ai=l;function p(t,n){const o=n.shift();if(n.length===0){delete t[o];return}if(Object.keys(t).indexOf(o)!==-1){const c=t[o];typeof c=="object"&&!Array.isArray(c)&&(p(c,n),Object.keys(c).length===0&&delete t[o])}}function b(t,n,o){function c(r,u){let f=r;for(const v of u){if(typeof f!="object"||f===null)return;f=f[v]}return f}const d=n.split("."),i=c(t,d);return typeof i>"u"?o:i}e.$Bi=b;function a(t,n,o){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in t?E.$Ef(t[c])&&E.$Ef(n[c])?a(t[c],n[c],o):o&&(t[c]=n[c]):t[c]=n[c])})}e.$Ci=a;function s(t){return t.replace(/[\[\]]/g,"")}e.$Di=s}),define(Pe[35],Re([1,0,21,12,180,4,148,11]),function(pe,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.ContextKeyExprType=e.$Vi=void 0;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",E.$j),m.set("isLinux",E.$k),m.set("isWindows",E.$i),m.set("isWeb",E.$o),m.set("isMacNative",E.$j&&!E.$o),m.set("isEdge",E.$H),m.set("isFirefox",E.$F),m.set("isChrome",E.$E),m.set("isSafari",E.$G);function y(Y,B){if(m.get(Y)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(Y,B)}e.$Vi=y;const R=Object.prototype.hasOwnProperty;var S;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const l={regexParsingWithErrorRecovery:!0},p=(0,P.localize)(0,null),b=(0,P.localize)(1,null),a=(0,P.localize)(2,null),s=(0,P.localize)(3,null),t=(0,P.localize)(4,null),n=(0,P.localize)(5,null),o=(0,P.localize)(6,null),c=(0,P.localize)(7,null);class d{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=l){this.k=B,this.d=new C.$Ui,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const se=this.l();if(!this.E()){const Se=this.D(),Ae=Se.type===17?n:void 0;throw this.h.push({message:t,offset:Se.offset,lexeme:C.$Ui.getLexeme(Se),additionalInfo:Ae}),d.c}return se}catch(se){if(se!==d.c)throw se;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const se=this.o();B.push(se)}return B.length===1?B[0]:i.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const se=this.s();B.push(se)}return B.length===1?B[0]:i.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),v.INSTANCE;case 12:return this.z(),g.INSTANCE;case 0:{this.z();const se=this.l();return this.A(1,s),se?.negate()}case 17:return this.z(),F.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const se=this.l();return this.A(1,s),se}case 17:{const se=B.lexeme;if(this.z(),this.y(9)){const Ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ae.type!==10)throw this.B("REGEX",Ae);const Ce=Ae.lexeme,fe=Ce.lastIndexOf("/"),ne=fe===Ce.length-1?void 0:this.w(Ce.substring(fe+1));let H;try{H=new RegExp(Ce.substring(1,fe),ne)}catch{throw this.B("REGEX",Ae)}return O.create(se,H)}switch(Ae.type){case 10:case 19:{const Ce=[Ae.lexeme];this.z();let fe=this.D(),ne=0;for(let he=0;he<Ae.lexeme.length;he++)Ae.lexeme.charCodeAt(he)===40?ne++:Ae.lexeme.charCodeAt(he)===41&&ne--;for(;!this.E()&&fe.type!==15&&fe.type!==16;){switch(fe.type){case 0:ne++;break;case 1:ne--;break;case 10:case 18:for(let he=0;he<fe.lexeme.length;he++)fe.lexeme.charCodeAt(he)===40?ne++:Ae.lexeme.charCodeAt(he)===41&&ne--}if(ne<0)break;Ce.push(C.$Ui.getLexeme(fe)),this.z(),fe=this.D()}const H=Ce.join(""),te=H.lastIndexOf("/"),X=te===H.length-1?void 0:this.w(H.substring(te+1));let re;try{re=new RegExp(H.substring(1,te),X)}catch{throw this.B("REGEX",Ae)}return i.regex(se,re)}case 18:{const Ce=Ae.lexeme;this.z();let fe=null;if(!(0,T.$Fe)(Ce)){const ne=Ce.indexOf("/"),H=Ce.lastIndexOf("/");if(ne!==H&&ne>=0){const te=Ce.slice(ne+1,H),X=Ce[H+1]==="i"?"i":"";try{fe=new RegExp(te,X)}catch{throw this.B("REGEX",Ae)}}}if(fe===null)throw this.B("REGEX",Ae);return O.create(se,fe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,a);const Ae=this.u();return i.notIn(se,Ae)}switch(this.D().type){case 3:{this.z();const Ae=this.u();if(this.x().type===18)return i.equals(se,Ae);switch(Ae){case"true":return i.has(se);case"false":return i.not(se);default:return i.equals(se,Ae)}}case 4:{this.z();const Ae=this.u();if(this.x().type===18)return i.notEquals(se,Ae);switch(Ae){case"true":return i.not(se);case"false":return i.has(se);default:return i.notEquals(se,Ae)}}case 5:return this.z(),A.create(se,this.u());case 6:return this.z(),L.create(se,this.u());case 7:return this.z(),Q.create(se,this.u());case 8:return this.z(),N.create(se,this.u());case 13:return this.z(),i.in(se,this.u());default:return i.has(se)}}case 20:throw this.h.push({message:o,offset:B.offset,lexeme:"",additionalInfo:c}),d.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,se){if(this.C(B))return this.z();throw this.B(se,this.D())}B(B,se,Se){const Ae=(0,P.localize)(8,null,B,C.$Ui.getLexeme(se)),Ce=se.offset,fe=C.$Ui.getLexeme(se);return this.h.push({message:Ae,offset:Ce,lexeme:fe,additionalInfo:Se}),d.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Wi=d;class i{static false(){return v.INSTANCE}static true(){return g.INSTANCE}static has(B){return D.create(B)}static equals(B,se){return I.create(B,se)}static notEquals(B,se){return k.create(B,se)}static regex(B,se){return O.create(B,se)}static in(B,se){return h.create(B,se)}static notIn(B,se){return w.create(B,se)}static not(B){return F.create(B)}static and(...B){return me.create(B,null,!0)}static or(...B){return ye.create(B,null,!0)}static greater(B,se){return Q.create(B,se)}static greaterEquals(B,se){return N.create(B,se)}static smaller(B,se){return A.create(B,se)}static smallerEquals(B,se){return L.create(B,se)}static{this.c=new d({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Xi=i;function r(Y){const B=new d({regexParsingWithErrorRecovery:!1});return Y.map(se=>(B.parse(se),B.lexingErrors.length>0?B.lexingErrors.map(Se=>({errorMessage:Se.additionalInfo?(0,P.localize)(9,null,Se.additionalInfo):(0,P.localize)(10,null),offset:Se.offset,length:Se.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(Se=>({errorMessage:Se.additionalInfo?`${Se.message}. ${Se.additionalInfo}`:Se.message,offset:Se.offset,length:Se.lexeme.length})):[]))}e.$Yi=r;function u(Y,B){const se=Y?Y.substituteConstants():void 0,Se=B?B.substituteConstants():void 0;return!se&&!Se?!0:!se||!Se?!1:se.equals(Se)}e.$Zi=u;function f(Y,B){return Y.cmp(B)}class v{static{this.INSTANCE=new v}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return g.INSTANCE}}e.$1i=v;class g{static{this.INSTANCE=new g}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return v.INSTANCE}}e.$2i=g;class D{static create(B,se=null){const Se=m.get(B);return typeof Se=="boolean"?Se?g.INSTANCE:v.INSTANCE:new D(B,se)}constructor(B,se){this.key=B,this.c=se,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:de(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=m.get(this.key);return typeof B=="boolean"?B?g.INSTANCE:v.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$3i=D;class I{static create(B,se,Se=null){if(typeof se=="boolean")return se?D.create(B,Se):F.create(B,Se);const Ae=m.get(B);return typeof Ae=="boolean"?se===(Ae?"true":"false")?g.INSTANCE:v.INSTANCE:new I(B,se,Se)}constructor(B,se,Se){this.c=B,this.d=se,this.f=Se,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=m.get(this.c);if(typeof B=="boolean"){const se=B?"true":"false";return this.d===se?g.INSTANCE:v.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$4i=I;class h{static create(B,se){return new h(B,se)}constructor(B,se){this.d=B,this.f=se,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:be(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const se=B.getValue(this.f),Se=B.getValue(this.d);return Array.isArray(se)?se.includes(Se):typeof Se=="string"&&typeof se=="object"&&se!==null?R.call(se,Se):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$5i=h;class w{static create(B,se){return new w(B,se)}constructor(B,se){this.d=B,this.f=se,this.type=11,this.c=h.create(B,se)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$6i=w;class k{static create(B,se,Se=null){if(typeof se=="boolean")return se?F.create(B,Se):D.create(B,Se);const Ae=m.get(B);return typeof Ae=="boolean"?se===(Ae?"true":"false")?v.INSTANCE:g.INSTANCE:new k(B,se,Se)}constructor(B,se,Se){this.c=B,this.d=se,this.f=Se,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=m.get(this.c);if(typeof B=="boolean"){const se=B?"true":"false";return this.d===se?v.INSTANCE:g.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$7i=k;class F{static create(B,se=null){const Se=m.get(B);return typeof Se=="boolean"?Se?v.INSTANCE:g.INSTANCE:new F(B,se)}constructor(B,se){this.c=B,this.d=se,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:de(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=m.get(this.c);return typeof B=="boolean"?B?v.INSTANCE:g.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.$8i=F;function W(Y,B){if(typeof Y=="string"){const se=parseFloat(Y);isNaN(se)||(Y=se)}return typeof Y=="string"||typeof Y=="number"?B(Y):v.INSTANCE}class Q{static create(B,se,Se=null){return W(se,Ae=>new Q(B,Ae,Se))}constructor(B,se,Se){this.c=B,this.d=se,this.f=Se,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$9i=Q;class N{static create(B,se,Se=null){return W(se,Ae=>new N(B,Ae,Se))}constructor(B,se,Se){this.c=B,this.d=se,this.f=Se,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$0i=N;class A{static create(B,se,Se=null){return W(se,Ae=>new A(B,Ae,Se))}constructor(B,se,Se){this.c=B,this.d=se,this.f=Se,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$$i=A;class L{static create(B,se,Se=null){return W(se,Ae=>new L(B,Ae,Se))}constructor(B,se,Se){this.c=B,this.d=se,this.f=Se,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$_i=L;class O{static create(B,se){return new O(B,se)}constructor(B,se){this.d=B,this.f=se,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const se=this.f?this.f.source:"",Se=B.f?B.f.source:"";return se<Se?-1:se>Se?1:0}equals(B){if(B.type===this.type){const se=this.f?this.f.source:"",Se=B.f?B.f.source:"";return this.d===B.d&&se===Se}return!1}substituteConstants(){return this}evaluate(B){const se=B.getValue(this.d);return this.f?this.f.test(se):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$aj=O;class x{static create(B){return new x(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new x(this.c.map(B))}negate(){return this.c}}e.$bj=x;function le(Y){let B=null;for(let se=0,Se=Y.length;se<Se;se++){const Ae=Y[se].substituteConstants();if(Y[se]!==Ae&&B===null){B=[];for(let Ce=0;Ce<se;Ce++)B[Ce]=Y[Ce]}B!==null&&(B[se]=Ae)}return B===null?Y:B}class me{static create(B,se,Se){return me.d(B,se,Se)}constructor(B,se){this.expr=B,this.c=se,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let se=0,Se=this.expr.length;se<Se;se++){const Ae=f(this.expr[se],B.expr[se]);if(Ae!==0)return Ae}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let se=0,Se=this.expr.length;se<Se;se++)if(!this.expr[se].equals(B.expr[se]))return!1;return!0}return!1}substituteConstants(){const B=le(this.expr);return B===this.expr?this:me.create(B,this.c,!1)}evaluate(B){for(let se=0,Se=this.expr.length;se<Se;se++)if(!this.expr[se].evaluate(B))return!1;return!0}static d(B,se,Se){const Ae=[];let Ce=!1;for(const fe of B)if(fe){if(fe.type===1){Ce=!0;continue}if(fe.type===0)return v.INSTANCE;if(fe.type===6){Ae.push(...fe.expr);continue}Ae.push(fe)}if(Ae.length===0&&Ce)return g.INSTANCE;if(Ae.length!==0){if(Ae.length===1)return Ae[0];Ae.sort(f);for(let fe=1;fe<Ae.length;fe++)Ae[fe-1].equals(Ae[fe])&&(Ae.splice(fe,1),fe--);if(Ae.length===1)return Ae[0];for(;Ae.length>1;){const fe=Ae[Ae.length-1];if(fe.type!==9)break;Ae.pop();const ne=Ae.pop(),H=Ae.length===0,te=ye.create(fe.expr.map(X=>me.create([X,ne],null,Se)),null,H);te&&(Ae.push(te),Ae.sort(f))}if(Ae.length===1)return Ae[0];if(Se){for(let fe=0;fe<Ae.length;fe++)for(let ne=fe+1;ne<Ae.length;ne++)if(Ae[fe].negate().equals(Ae[ne]))return v.INSTANCE;if(Ae.length===1)return Ae[0]}return new me(Ae,se)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const se of this.expr)B.push(...se.keys());return B}map(B){return new me(this.expr.map(se=>se.map(B)),null)}negate(){if(!this.c){const B=[];for(const se of this.expr)B.push(se.negate());this.c=ye.create(B,this,!0)}return this.c}}e.$cj=me;class ye{static create(B,se,Se){return ye.d(B,se,Se)}constructor(B,se){this.expr=B,this.c=se,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let se=0,Se=this.expr.length;se<Se;se++){const Ae=f(this.expr[se],B.expr[se]);if(Ae!==0)return Ae}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let se=0,Se=this.expr.length;se<Se;se++)if(!this.expr[se].equals(B.expr[se]))return!1;return!0}return!1}substituteConstants(){const B=le(this.expr);return B===this.expr?this:ye.create(B,this.c,!1)}evaluate(B){for(let se=0,Se=this.expr.length;se<Se;se++)if(this.expr[se].evaluate(B))return!0;return!1}static d(B,se,Se){let Ae=[],Ce=!1;if(B){for(let fe=0,ne=B.length;fe<ne;fe++){const H=B[fe];if(H){if(H.type===0){Ce=!0;continue}if(H.type===1)return g.INSTANCE;if(H.type===9){Ae=Ae.concat(H.expr);continue}Ae.push(H)}}if(Ae.length===0&&Ce)return v.INSTANCE;Ae.sort(f)}if(Ae.length!==0){if(Ae.length===1)return Ae[0];for(let fe=1;fe<Ae.length;fe++)Ae[fe-1].equals(Ae[fe])&&(Ae.splice(fe,1),fe--);if(Ae.length===1)return Ae[0];if(Se){for(let fe=0;fe<Ae.length;fe++)for(let ne=fe+1;ne<Ae.length;ne++)if(Ae[fe].negate().equals(Ae[ne]))return g.INSTANCE;if(Ae.length===1)return Ae[0]}return new ye(Ae,se)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const se of this.expr)B.push(...se.keys());return B}map(B){return new ye(this.expr.map(se=>se.map(B)),null)}negate(){if(!this.c){const B=[];for(const se of this.expr)B.push(se.negate());for(;B.length>1;){const se=B.shift(),Se=B.shift(),Ae=[];for(const Ce of ce(se))for(const fe of ce(Se))Ae.push(me.create([Ce,fe],null,!1));B.unshift(ye.create(Ae,null,!1))}this.c=ye.create(B,this,!0)}return this.c}}e.$dj=ye;class we extends D{static{this.d=[]}static all(){return we.d.values()}constructor(B,se,Se){super(B,null),this.f=se,typeof Se=="object"?we.d.push({...Se,key:B}):Se!==!0&&we.d.push({key:B,description:Se,type:se!=null?typeof se:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return I.create(this.key,B)}notEqualsTo(B){return k.create(this.key,B)}}e.$ej=we,e.$fj=(0,M.$Zh)("contextKeyService");function de(Y,B){return Y<B?-1:Y>B?1:0}function be(Y,B,se,Se){return Y<se?-1:Y>se?1:B<Se?-1:B>Se?1:0}function ie(Y,B){if(Y.type===0||B.type===1)return!0;if(Y.type===9)return B.type===9?Ie(Y.expr,B.expr):!1;if(B.type===9){for(const se of B.expr)if(ie(Y,se))return!0;return!1}if(Y.type===6){if(B.type===6)return Ie(B.expr,Y.expr);for(const se of Y.expr)if(ie(se,B))return!0;return!1}return Y.equals(B)}e.$gj=ie;function Ie(Y,B){let se=0,Se=0;for(;se<Y.length&&Se<B.length;){const Ae=Y[se].cmp(B[Se]);if(Ae<0)return!1;Ae===0&&se++,Se++}return se===Y.length}function ce(Y){return Y.type===9?Y.expr:[Y]}}),define(Pe[183],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=void 0,e.$7h=(0,E.$Zh)("environmentService"),e.$8h=(0,E.$1h)(e.$7h)}),define(Pe[96],Re([1,0,150,4]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ho=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=void 0,e.$8n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9n=new RegExp(e.$8n),e.$0n="__web_extension",e.$$n="skipWalkthrough",e.$_n="extensionsSync",e.$ao="dependecyOrPackExtensionInstall";function C(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$bo=C;function M(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$co=M;function P(t,n){switch(t){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$do=P;function $(t,n){return n==="web"&&!t.includes("web")}e.$eo=$;function m(t,n,o){return $(n,o)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===o}e.$fo=m;function y(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.$go=y;var R;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var S;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var p;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$ho=(0,T.$Zh)("extensionGalleryService");var b;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var a;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class s extends Error{constructor(n,o){super(n),this.code=o,this.name=o}}e.$io=s,e.$jo=(0,T.$Zh)("extensionManagementService"),e.$ko="extensionsIdentifiers/disabled",e.$lo="extensionsIdentifiers/enabled",e.$mo=(0,T.$Zh)("IGlobalExtensionEnablementService"),e.$no=(0,T.$Zh)("IExtensionTipsService"),e.$oo=(0,E.localize)(0,null),e.$po={value:e.$oo,original:"Extensions"},e.$qo={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Pe[42],Re([1,0,50,20,12,16,2,152,4,21,13,39]),function(pe,e,E,T,C,M,P,$,m,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileKind=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.FileOperationResult=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileChangeType=e.$Ak=e.FileOperation=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileSystemProviderErrorCode=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderCapabilities=e.$kk=e.FilePermission=e.FileType=e.$jk=e.$ik=void 0,e.$ik=(0,m.$Zh)("fileService");function l(ie){return ie.create===!0}e.$jk=l;var p;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var b;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(b||(e.FilePermission=b={}));function a(ie){const Ie=ie;return!!Ie&&typeof Ie.onDidChange=="function"}e.$kk=a;var s;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function t(ie){return!!(ie.capabilities&2)}e.$lk=t;function n(ie){return!!(ie.capabilities&8)}e.$mk=n;function o(ie){return!!(ie.capabilities&131072)}e.$nk=o;function c(ie){return!!(ie.capabilities&4)}e.$ok=c;function d(ie){return!!(ie.capabilities&16)}e.$pk=d;function i(ie){return t(ie)?!!(ie.capabilities&16384):!1}e.$qk=i;function r(ie){return t(ie)?!!(ie.capabilities&32768):!1}e.$rk=r;function u(ie){return!!(ie.capabilities&65536)}e.$sk=u;function f(ie){return!!(ie.capabilities&2048)}e.$tk=f;var v;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class g extends Error{static create(Ie,ce){const Y=new g(Ie.toString(),ce);return h(Y,ce),Y}constructor(Ie,ce){super(Ie),this.code=ce}}e.$uk=g;function D(ie,Ie){return g.create(ie,Ie)}e.$vk=D;function I(ie){return ie||D((0,$.localize)(0,null),v.Unknown)}e.$wk=I;function h(ie,Ie){return ie.name=Ie?`${Ie} (FileSystemError)`:"FileSystemError",ie}e.$xk=h;function w(ie){if(!ie)return v.Unknown;if(ie instanceof g)return ie.code;const Ie=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!Ie)return v.Unknown;switch(Ie[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.$yk=w;function k(ie){if(ie instanceof L)return ie.fileOperationResult;switch(w(ie)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}e.$zk=k;var F;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class W{constructor(Ie,ce,Y){this.resource=Ie,this.operation=ce,this.target=Y}isOperation(Ie){return this.operation===Ie}}e.$Ak=W;var Q;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(Q||(e.FileChangeType=Q={}));class N{static{this.a=null}constructor(Ie,ce){this.c=ce,this.b=void 0,this.d=new S.$U(()=>{const Y=E.$6h.forUris(()=>this.c);return Y.fill(this.rawAdded.map(B=>[B,!0])),Y}),this.f=new S.$U(()=>{const Y=E.$6h.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(B=>[B,!0])),Y}),this.g=new S.$U(()=>{const Y=E.$6h.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(B=>[B,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of Ie){switch(Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}this.b!==N.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=N.a):this.b!==void 0&&(this.b=N.a))}}contains(Ie,...ce){return this.h(Ie,{includeChildren:!1},...ce)}affects(Ie,...ce){return this.h(Ie,{includeChildren:!0},...ce)}h(Ie,ce,...Y){if(!Ie)return!1;const B=Y.length>0;return!!((!B||Y.includes(1))&&(this.d.value.get(Ie)||ce.includeChildren&&this.d.value.findSuperstr(Ie))||(!B||Y.includes(0))&&(this.f.value.get(Ie)||ce.includeChildren&&this.f.value.findSuperstr(Ie))||(!B||Y.includes(2))&&(this.g.value.findSubstr(Ie)||ce.includeChildren&&this.g.value.findSuperstr(Ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ie){return this.b===Ie}hasCorrelation(){return typeof this.b=="number"}}e.$Bk=N;function A(ie,Ie,ce){return!ie||!Ie||ie===Ie||Ie.length>ie.length?!1:(Ie.charAt(Ie.length-1)!==T.sep&&(Ie+=T.sep),ce?(0,C.$7e)(ie,Ie):ie.indexOf(Ie)===0)}e.$Ck=A;class L extends Error{constructor(Ie,ce,Y){super(Ie),this.fileOperationResult=ce,this.options=Y}}e.$Dk=L;class O extends L{constructor(Ie,ce,Y,B){super(Ie,ce,B),this.fileOperationResult=ce,this.size=Y}}e.$Ek=O;class x extends L{constructor(Ie,ce,Y){super(Ie,2,Y),this.stat=ce}}e.$Fk=x;var le;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(le||(e.FileOperationResult=le={})),e.$Gk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Hk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ik="files.associations",e.$Jk="files.exclude",e.$Kk="files.readonlyInclude",e.$Lk="files.readonlyExclude",e.$Mk="files.readonlyFromPermissions";var me;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(me||(e.FileKind=me={})),e.$Nk="";function ye(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.$Ok=ye;async function we(ie,Ie){if(!Ie.hasProvider(P.URI.from({scheme:ie.scheme})))return new Promise(ce=>{const Y=Ie.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===ie.scheme&&B.added&&(Y.dispose(),ce())})})}e.$Pk=we;class de{static{this.KB=1024}static{this.MB=de.KB*de.KB}static{this.GB=de.MB*de.KB}static{this.TB=de.GB*de.KB}static formatSize(Ie){return(0,M.$Gf)(Ie)||(Ie=0),Ie<de.KB?(0,$.localize)(1,null,Ie.toFixed(0)):Ie<de.MB?(0,$.localize)(2,null,(Ie/de.KB).toFixed(2)):Ie<de.GB?(0,$.localize)(3,null,(Ie/de.MB).toFixed(2)):Ie<de.TB?(0,$.localize)(4,null,(Ie/de.GB).toFixed(2)):(0,$.localize)(5,null,(Ie/de.TB).toFixed(2))}}e.$Qk=de;function be(ie){const Ie=typeof ie=="string"||ie?.scheme===R.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===R.Schemas.file?1024*de.MB:Ie?10*de.MB:y.$o?50*de.MB:1024*de.MB}e.$Rk=be}),define(Pe[71],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=void 0;class E{constructor(...C){this.a=new Map;for(const[M,P]of C)this.set(M,P)}set(C,M){const P=this.a.get(C);return this.a.set(C,M),P}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Xh=E}),define(Pe[184],Re([1,0,14,11,6,69,182,4,71,185]),function(pe,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$nq=void 0;const R=!1;class S extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class l{constructor(s=new m.$Xh,t=!1,n,o=R){this.f=s,this.g=t,this.h=n,this.i=o,this.o=new Set,this.f.set($.$Yh,this),this._globalGraph=o?n?._globalGraph??new P.$mq(c=>c):void 0}createChild(s){return new l(s,this.g,this,this.i)}invokeFunction(s,...t){const n=b.traceInvocation(this.i,s);let o=!1;try{return s({get:d=>{if(o)throw(0,T.$7)("service accessor is only valid during the invocation of its target method");const i=this.m(d,n);if(!i)throw new Error(`[invokeFunction] unknown service '${d}'`);return i}},...t)}finally{o=!0,n.stop()}}createInstance(s,...t){let n,o;return s instanceof M.$Wh?(n=b.traceCreation(this.i,s.ctor),o=this.j(s.ctor,s.staticArguments.concat(t),n)):(n=b.traceCreation(this.i,s),o=this.j(s,t,n)),n.stop(),o}j(s,t=[],n){const o=$._util.getServiceDependencies(s).sort((i,r)=>i.index-r.index),c=[];for(const i of o){const r=this.m(i.id,n);r||this.u(`[createInstance] ${s.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(r)}const d=o.length>0?o[0].index:t.length;if(t.length!==d){console.trace(`[createInstance] First service dependency of ${s.name} at position ${d+1} conflicts with ${t.length} static arguments`);const i=d-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,d)}return Reflect.construct(s,t.concat(c))}k(s,t){if(this.f.get(s)instanceof M.$Wh)this.f.set(s,t);else if(this.h)this.h.k(s,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(s){const t=this.f.get(s);return!t&&this.h?this.h.l(s):t}m(s,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const n=this.l(s);return n instanceof M.$Wh?this.q(s,n,t.branch(s,!0)):(t.branch(s,!1),n)}q(s,t,n){if(this.o.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.o.add(s);try{return this.r(s,t,n)}finally{this.o.delete(s)}}r(s,t,n){const o=new P.$mq(i=>i.id.toString());let c=0;const d=[{id:s,desc:t,_trace:n}];for(;d.length;){const i=d.pop();if(o.lookupOrInsertNode(i),c++>1e3)throw new S(o);for(const r of $._util.getServiceDependencies(i.desc.ctor)){const u=this.l(r.id);if(u||this.u(`[createInstance] ${s} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),u instanceof M.$Wh){const f={id:r.id,desc:u,_trace:i._trace.branch(r.id,!0)};o.insertEdge(i,f),d.push(f)}}}for(;;){const i=o.roots();if(i.length===0){if(!o.isEmpty())throw new S(o);break}for(const{data:r}of i){if(this.l(r.id)instanceof M.$Wh){const f=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,f)}o.removeNode(r)}}return this.l(s)}s(s,t,n=[],o,c){if(this.f.get(s)instanceof M.$Wh)return this.t(s,t,n,o,c);if(this.h)return this.h.s(s,t,n,o,c);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(s,t,n=[],o,c){if(o){const d=new l(void 0,this.g,this,this.i);d.c=String(s);const i=new Map,r=new E.$gh(()=>{const u=d.j(t,n,c);for(const[f,v]of i){const g=u[f];if(typeof g=="function")for(const D of v)g.apply(u,D)}return i.clear(),u});return new Proxy(Object.create(null),{get(u,f){if(!r.isInitialized&&typeof f=="string"&&(f.startsWith("onDid")||f.startsWith("onWill"))){let D=i.get(f);return D||(D=new y.$2c,i.set(f,D)),(h,w,k)=>{const F=D.push([h,w,k]);return(0,C.$Pc)(F)}}if(f in u)return u[f];const v=r.value;let g=v[f];return typeof g!="function"||(g=g.bind(v),u[f]=g),g},set(u,f,v){return r.value[f]=v,!0},getPrototypeOf(u){return t.prototype}})}else return this.j(t,n,c)}u(s,t){if(t&&console.warn(s),this.g)throw new Error(s)}}e.$nq=l;var p;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(p||(p={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(s,t){return s?new b(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(s,t){return s?new b(1,t.name):b.c}static{this.f=0}constructor(s,t){this.type=s,this.name=t,this.g=Date.now(),this.h=[]}branch(s,t){const n=new b(3,s.toString());return this.h.push([s,t,n]),n}stop(){const s=Date.now()-this.g;b.f+=s;let t=!1;function n(c,d){const i=[],r=new Array(c+1).join("	");for(const[u,f,v]of d.h)if(f&&v){t=!0,i.push(`${r}CREATES -> ${u}`);const g=n(c+1,v);g&&i.push(g)}else i.push(`${r}uses -> ${u}`);return i.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(s>2||t)&&b.all.add(o.join(`
`))}}e.$oq=b}),define(Pe[15],Re([1,0,40,5,97,6,28,21,25,16,2,35,4]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.log=e.$kj=e.LogLevel=e.$jj=e.$ij=e.$hj=void 0,e.$hj=(0,l.$Zh)("logService"),e.$ij=(0,l.$Zh)("loggerService");function p(){return new Date().toISOString()}function b(h){return(0,y.$Gf)(h)}e.$jj=b;var a;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(a||(e.LogLevel=a={})),e.$kj=a.Info;function s(h,w,k){switch(w){case a.Trace:h.trace(k);break;case a.Debug:h.debug(k);break;case a.Info:h.info(k);break;case a.Warning:h.warn(k);break;case a.Error:h.error(k);break;case a.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=s;function t(h,w=!1){let k="";for(let F=0;F<h.length;F++){let W=h[F];if(W instanceof Error&&(W=(0,E.$Ki)(W,w)),typeof W=="object")try{W=JSON.stringify(W)}catch{}k+=(F>0?" ":"")+W}return k}class n extends M.$Rc{constructor(){super(...arguments),this.b=e.$kj,this.c=this.B(new T.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==a.Off&&this.b<=w}}e.$mj=n;class o extends n{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...k){this.f(a.Trace)&&this.g(a.Trace,t([w,...k],!0))}debug(w,...k){this.f(a.Debug)&&this.g(a.Debug,t([w,...k]))}info(w,...k){this.f(a.Info)&&this.g(a.Info,t([w,...k]))}warn(w,...k){this.f(a.Warning)&&this.g(a.Warning,t([w,...k]))}error(w,...k){if(this.f(a.Error))if(w instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=w.stack,this.g(a.Error,t(F))}else this.g(a.Error,t([w,...k]))}flush(){}}e.$nj=o;class c extends n{constructor(w=e.$kj){super(),this.setLevel(w),this.g=!$.$i}trace(w,...k){this.f(a.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,w,...k):console.log(`[main ${p()}]`,w,...k))}debug(w,...k){this.f(a.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,w,...k):console.log(`[main ${p()}]`,w,...k))}info(w,...k){this.f(a.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,w,...k):console.log(`[main ${p()}]`,w,...k))}warn(w,...k){this.f(a.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,w,...k):console.warn(`[main ${p()}]`,w,...k))}error(w,...k){this.f(a.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,w,...k):console.error(`[main ${p()}]`,w,...k))}dispose(){}flush(){}}e.$oj=c;class d extends n{constructor(w=e.$kj,k=!0){super(),this.g=k,this.setLevel(w)}trace(w,...k){this.f(a.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...k):console.log(w,...k))}debug(w,...k){this.f(a.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...k):console.log(w,...k))}info(w,...k){this.f(a.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...k):console.log(w,...k))}warn(w,...k){this.f(a.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...k):console.log(w,...k))}error(w,...k){this.f(a.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...k):console.error(w,...k))}dispose(){}flush(){}}e.$pj=d;class i extends n{constructor(w,k=e.$kj){super(),this.g=w,this.setLevel(k)}trace(w,...k){this.f(a.Trace)&&this.g.log(a.Trace,[this.h(w),...k])}debug(w,...k){this.f(a.Debug)&&this.g.log(a.Debug,[this.h(w),...k])}info(w,...k){this.f(a.Info)&&this.g.log(a.Info,[this.h(w),...k])}warn(w,...k){this.f(a.Warning)&&this.g.log(a.Warning,[this.h(w),...k])}error(w,...k){this.f(a.Error)&&this.g.log(a.Error,[this.h(w),...k])}h(w){return typeof w=="string"?w:(0,E.$Ki)(w,this.f(a.Trace))}dispose(){}flush(){}}e.$qj=i;class r extends n{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const k of this.g)k.setLevel(w);super.setLevel(w)}trace(w,...k){for(const F of this.g)F.trace(w,...k)}debug(w,...k){for(const F of this.g)F.debug(w,...k)}info(w,...k){for(const F of this.g)F.info(w,...k)}warn(w,...k){for(const F of this.g)F.warn(w,...k)}error(w,...k){for(const F of this.g)F.error(w,...k)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$rj=r;class u extends M.$Rc{constructor(w,k,F){if(super(),this.h=w,this.j=k,this.b=new P.$zc,this.c=this.B(new T.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Rd),this.onDidChangeVisibility=this.g.event,F)for(const W of F)this.b.set(W.resource,{logger:void 0,info:W})}m(w){return(0,y.$Cf)(w)?[...this.b.values()].find(k=>k.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,k){const F=this.n(w),W=(0,y.$Cf)(w)?w:k?.id??(0,C.$Ni)(F.toString()).toString(16);let Q=this.b.get(F)?.logger;const N=k?.logLevel==="always"?a.Trace:k?.logLevel;Q||(Q=this.s(F,N??this.getLogLevel(F)??this.h,{...k,id:W}));const A={logger:Q,info:{resource:F,id:W,logLevel:N,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(A.info),this.b.set(F,A),Q}n(w){return(0,y.$Cf)(w)?(0,m.$Bg)(this.j,`${w}.log`):w}setLogLevel(w,k){if(R.URI.isUri(w)){const F=w,W=k,Q=this.b.get(F);Q&&W!==Q.info.logLevel&&(Q.info.logLevel=W===this.h?void 0:W,Q.logger?.setLevel(W),this.b.set(Q.info.resource,Q),this.f.fire([F,W]))}else{this.h=w;for(const[F,W]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,k){const F=this.m(w);F&&k!==!F.info.hidden&&(F.info.hidden=!k,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,k]))}getLogLevel(w){let k;return w&&(k=this.b.get(w)?.info.logLevel),k??this.h}registerLogger(w){const k=this.b.get(w.resource);k?k.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const k=this.b.get(w);k&&(k.logger&&k.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$sj=u;class f{constructor(){this.onDidChangeLogLevel=new T.$Rd().event}setLevel(w){}getLevel(){return a.Info}trace(w,...k){}debug(w,...k){}info(w,...k){}warn(w,...k){}error(w,...k){}critical(w,...k){}dispose(){}flush(){}}e.$tj=f;class v extends f{}e.$uj=v;function g(h){if(h.verbose)return a.Trace;if(typeof h.logLevel=="string"){const w=I(h.logLevel.toLowerCase());if(w!==void 0)return w}return e.$kj}e.$vj=g;function D(h){switch(h){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Off:return"off"}}e.$wj=D;function I(h){switch(h){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Error;case"off":return a.Off}}e.$xj=I,e.$yj=new S.$ej("logLevel",D(a.Info))}),define(Pe[186],Re([1,0,6,15]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2N=void 0;class C extends E.$Rc{constructor(P,$=[]){super(),this.a=new T.$rj([P,...$]),this.B(P.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...$){this.a.trace(P,...$)}debug(P,...$){this.a.debug(P,...$)}info(P,...$){this.a.info(P,...$)}warn(P,...$){this.a.warn(P,...$)}error(P,...$){this.a.error(P,...$)}flush(){this.a.flush()}}e.$2N=C}),define(Pe[98],Re([1,0,31,153,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var P;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(P||(e.MarkerSeverity=P={})),function(m){function y(b,a){return a-b}m.compare=y;const R=Object.create(null);R[m.Error]=(0,T.localize)(0,null),R[m.Warning]=(0,T.localize)(1,null),R[m.Info]=(0,T.localize)(2,null);function S(b){return R[b]||""}m.toString=S;function l(b){switch(b){case E.default.Error:return m.Error;case E.default.Warning:return m.Warning;case E.default.Info:return m.Info;case E.default.Ignore:return m.Hint}}m.fromSeverity=l;function p(b){switch(b){case m.Error:return E.default.Error;case m.Warning:return E.default.Warning;case m.Info:return E.default.Info;case m.Hint:return E.default.Ignore}}m.toSeverity=p}(P||(e.MarkerSeverity=P={}));var $;(function(m){const y="";function R(l){return S(l,!0)}m.makeKey=R;function S(l,p){const b=[y];return l.source?b.push(l.source.replace("\xA6","\\\xA6")):b.push(y),l.code?typeof l.code=="string"?b.push(l.code.replace("\xA6","\\\xA6")):b.push(l.code.value.replace("\xA6","\\\xA6")):b.push(y),l.severity!==void 0&&l.severity!==null?b.push(P.toString(l.severity)):b.push(y),l.message&&p?b.push(l.message.replace("\xA6","\\\xA6")):b.push(y),l.startLineNumber!==void 0&&l.startLineNumber!==null?b.push(l.startLineNumber.toString()):b.push(y),l.startColumn!==void 0&&l.startColumn!==null?b.push(l.startColumn.toString()):b.push(y),l.endLineNumber!==void 0&&l.endLineNumber!==null?b.push(l.endLineNumber.toString()):b.push(y),l.endColumn!==void 0&&l.endColumn!==null?b.push(l.endColumn.toString()):b.push(y),b.push(y),b.join("\xA6")}m.makeKeyOptionalMessage=S})($||(e.IMarkerData=$={})),e.$jt=(0,C.$Zh)("markerService")}),define(Pe[187],Re([1,0,5,31,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_u=e.$$u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$0u=e.Severity=void 0,e.Severity=T.default,e.$0u=(0,C.$Zh)("notificationService");var M;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var P;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(P||(e.NeverShowAgainScope=P={}));var $;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class m{constructor(){this.progress=new y,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(S){}updateMessage(S){}updateActions(S){}close(){}}e.$$u=m;class y{infinite(){}done(){}total(S){}worked(S){}}e.$_u=y}),define(Pe[188],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=void 0,e.$zj=(0,E.$Zh)("productService"),e.$Aj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(pe,e,E,T){var C=arguments.length,M=C<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,E):T,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(pe,e,E,T);else for(var $=pe.length-1;$>=0;$--)(P=pe[$])&&(M=(C<3?P(M):C>3?P(e,E,M):P(e,E))||M);return C>3&&M&&Object.defineProperty(e,E,M),M},We=this&&this.__param||function(pe,e){return function(E,T){e(E,T,pe)}};define(Pe[72],Re([1,0,14,19,6,4]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.ProgressLocation=e.$av=void 0,e.$av=(0,M.$Zh)("progressService");var P;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(P||(e.ProgressLocation=P={})),e.$bv=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$cv=$;class m{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const p=this.d;this.d=()=>{p?.(),l()}}):Promise.resolve()}}e.$dv=m;let y=class extends C.$Rc{constructor(l,p){super(),this.a=new E.$kh,p.withProgress(l,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,C.$Pc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$ev=y,e.$ev=y=Ke([We(1,e.$av)],y);class R extends C.$Rc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new C.$Qc)}start(l){this.stop();const p=++this.a,b=new T.$2d;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,C.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Pc)(()=>b.cancel())),this.b.add((0,C.$Pc)(()=>this.c?this.c.done():void 0)),{id:p,token:b.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$fv=R,e.$gv=(0,M.$Zh)("editorProgressService")}),define(Pe[30],Re([1,0,53,16]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0;class C{constructor(){this.a=new Map}add(P,$){E.ok(T.$Cf(P)),E.ok(T.$Ef($)),E.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,$)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.$qn=new C}),define(Pe[73],Re([1,0,5,30]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=void 0,e.$rn={JSONContribution:"base.contributions.json"};function C($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new E.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,y){this.a[C(m)]=y,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const P=new M;T.$qn.add(e.$rn.JSONContribution,P)}),define(Pe[54],Re([1,0,18,5,16,147,41,73,30]),function(pe,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.ConfigurationScope=e.$vn=e.EditPresentationTypes=void 0;var y;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$vn={Configuration:"base.contributions.configuration"};var R;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn={properties:{},patternProperties:{}},e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn="vscode://schemas/settings/resourceLanguage",e.$Dn="vscode://schemas/settings/configurationDefaults";const S=m.$qn.as($.$rn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new T.$Rd,this.onDidSchemaChange=this.i.event,this.j=new T.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$Cn,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const u=new Set;this.n(i,r,u),S.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(i){const r=new Set;this.o(i,r),S.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const u=new Set;this.o(r,u),this.n(i,!1,u),S.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const u=[];for(const{overrides:f,source:v}of i)for(const g in f)if(r.add(g),e.$Fn.test(g)){const D=this.a.get(g),I=D?.valuesSources??new Map;if(v)for(const F of Object.keys(f[g]))I.set(F,v);const h={...D?.value||{},...f[g]};this.a.set(g,{source:v,value:h,valuesSources:I});const w=(0,P.$Di)(g),k={type:"object",default:h,description:M.localize(1,null,w),$ref:e.$Cn,defaultDefaultValue:h,source:C.$Cf(v)?void 0:v,defaultValueSource:v};u.push(...a(g)),this.d[g]=k,this.b.properties[g]=k}else{this.a.set(g,{value:f[g],source:v});const D=this.d[g];D&&(this.w(g,D),this.r(g,D))}this.m(u)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:u,source:f}of i)for(const v in u){const g=this.a.get(v),D=C.$Cf(f)?f:f?.id,I=C.$Cf(g?.source)?g?.source:g?.source?.id;if(D===I)if(r.add(v),this.a.delete(v),e.$Fn.test(v))delete this.d[v],delete this.b.properties[v];else{const h=this.d[v];h&&(this.w(v,h),this.r(v,h))}}this.u()}deltaConfiguration(i){let r=!1;const u=new Set;i.removedDefaults&&(this.l(i.removedDefaults,u),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,u),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,u),i.addedConfigurations&&this.n(i.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,u){i.forEach(f=>{this.p(f,r,f.extensionInfo,f.restrictedProperties,void 0,u),this.c.push(f),this.q(f)})}o(i,r){const u=f=>{if(f.properties)for(const v in f.properties){r.add(v);const g=this.d[v];g?.policy?.name&&this.e.delete(g.policy.name),delete this.d[v],this.s(v,f.properties[v])}f.allOf?.forEach(v=>u(v))};for(const f of i){u(f);const v=this.c.indexOf(f);v!==-1&&this.c.splice(v,1)}}p(i,r=!0,u,f,v=3,g){v=C.$Lf(i.scope)?v:i.scope;const D=i.properties;if(D)for(const h in D){const w=D[h];if(r&&o(h,w)){delete D[h];continue}if(w.source=u,w.defaultDefaultValue=D[h].default,this.w(h,w),e.$Fn.test(h)?w.scope=void 0:(w.scope=C.$Lf(w.scope)?v:w.scope,w.restricted=C.$Lf(w.restricted)?!!f?.includes(h):w.restricted),D[h].hasOwnProperty("included")&&!D[h].included){this.f[h]=D[h],delete D[h];continue}else this.d[h]=D[h],D[h].policy?.name&&this.e.set(D[h].policy.name,h);!D[h].deprecationMessage&&D[h].markdownDeprecationMessage&&(D[h].deprecationMessage=D[h].markdownDeprecationMessage),g.add(h)}const I=i.allOf;if(I)for(const h of I)this.p(h,r,u,f,v,g)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=u=>{const f=u.properties;if(f)for(const g in f)this.r(g,f[g]);u.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$wn.properties[i]=r,r.scope){case 1:e.$xn.properties[i]=r;break;case 2:e.$yn.properties[i]=r;break;case 6:e.$zn.properties[i]=r;break;case 3:e.$An.properties[i]=r;break;case 4:e.$Bn.properties[i]=r;break;case 5:e.$Bn.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$wn.properties[i],r.scope){case 1:delete e.$xn.properties[i];break;case 2:delete e.$yn.properties[i];break;case 6:delete e.$zn.properties[i];break;case 3:delete e.$An.properties[i];break;case 4:case 5:delete e.$Bn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,u={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$Cn};this.w(r,u),e.$wn.properties[r]=u,e.$xn.properties[r]=u,e.$yn.properties[r]=u,e.$zn.properties[r]=u,e.$An.properties[r]=u,e.$Bn.properties[r]=u}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$Cn};e.$wn.patternProperties[e.$En]=i,e.$xn.patternProperties[e.$En]=i,e.$yn.patternProperties[e.$En]=i,e.$zn.patternProperties[e.$En]=i,e.$An.patternProperties[e.$En]=i,e.$Bn.patternProperties[e.$En]=i,this.i.fire()}w(i,r){const u=this.a.get(i);let f=u?.value,v=u?.source;C.$Jf(f)&&(f=r.defaultDefaultValue,v=void 0),C.$Jf(f)&&(f=t(r.type)),r.default=f,r.defaultValueSource=v}}const p="\\[([^\\]]+)\\]",b=new RegExp(p,"g");e.$En=`^(${p})+$`,e.$Fn=new RegExp(e.$En);function a(d){const i=[];if(e.$Fn.test(d)){let r=b.exec(d);for(;r?.length;){const u=r[1].trim();u&&i.push(u),r=b.exec(d)}}return(0,E.$Lb)(i)}e.$Gn=a;function s(d){return d.reduce((i,r)=>`${i}[${r}]`,"")}e.$Hn=s;function t(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$In=t;const n=new l;m.$qn.add(e.$vn.Configuration,n);function o(d,i){return d.trim()?e.$Fn.test(d)?M.localize(7,null,d):n.getConfigurationProperties()[d]!==void 0?M.localize(8,null,d):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,d,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.$Jn=o;function c(){const d=[],i=n.getConfigurationProperties();for(const r of Object.keys(i))d.push([r,i[r].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.$Kn=c}),define(Pe[189],Re([1,0,18,5,118,6,28,26,16,2,41,54,30]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0;function p(r){return Object.isFrozen(r)?r:$.$fn(r)}class b{constructor(u={},f=[],v=[],g){this.b=u,this.c=f,this.d=v,this.raw=g,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(f=>{if(f instanceof b)return f;const v=new a("");return v.parseRaw(f),v.configurationModel});this.f=u.reduce((f,v)=>v===f?v:f.merge(v),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,R.$Bi)(this.contents,u):this.contents}inspect(u,f){const v=this.rawConfiguration.getValue(u),g=f?this.rawConfiguration.getOverrideValue(u,f):void 0,D=f?this.rawConfiguration.override(f).getValue(u):v;return{value:v,override:g,merged:D}}getOverrideValue(u,f){const v=this.i(f);return v?u?(0,R.$Bi)(v,u):v:void 0}getKeysForOverrideIdentifier(u){const f=[];for(const v of this.overrides)v.identifiers.includes(u)&&f.push(...v.keys);return E.$Lb(f)}getAllOverrideIdentifiers(){const u=[];for(const f of this.overrides)u.push(...f.identifiers);return E.$Lb(u)}override(u){let f=this.a.get(u);return f||(f=this.g(u),this.a.set(u,f)),f}merge(...u){const f=$.$en(this.contents),v=$.$en(this.overrides),g=[...this.keys],D=this.raw?.length?[...this.raw]:[this];for(const I of u)if(D.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(f,I.contents);for(const h of I.overrides){const[w]=v.filter(k=>E.$tb(k.identifiers,h.identifiers));w?(this.h(w.contents,h.contents),w.keys.push(...h.keys),w.keys=E.$Lb(w.keys)):v.push($.$en(h))}for(const h of I.keys)g.indexOf(h)===-1&&g.push(h)}return new b(f,g,v,D.every(I=>I instanceof b)?void 0:D)}g(u){const f=this.i(u);if(!f||typeof f!="object"||!Object.keys(f).length)return this;const v={};for(const g of E.$Lb([...Object.keys(this.contents),...Object.keys(f)])){let D=this.contents[g];const I=f[g];I&&(typeof D=="object"&&typeof I=="object"?(D=$.$en(D),this.h(D,I)):D=I),v[g]=D}return new b(v,this.keys,this.overrides)}h(u,f){for(const v of Object.keys(f)){if(v in u&&m.$Ef(u[v])&&m.$Ef(f[v])){this.h(u[v],f[v]);continue}u[v]=$.$en(f[v])}}i(u){let f=null,v=null;const g=D=>{D&&(v?this.h(v,D):v=$.$en(D))};for(const D of this.overrides)D.identifiers.length===1&&D.identifiers[0]===u?f=D.contents:D.identifiers.includes(u)&&g(D.contents);return g(f),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,f){this.j(u,f,!0)}setValue(u,f){this.j(u,f,!1)}removeValue(u){const f=this.keys.indexOf(u);f!==-1&&(this.keys.splice(f,1),(0,R.$Ai)(this.contents,u),S.$Fn.test(u)&&this.overrides.splice(this.overrides.findIndex(v=>E.$tb(v.identifiers,(0,S.$Gn)(u))),1))}j(u,f,v){(0,R.$zi)(this.contents,u,f,g=>console.error(g)),v=v||this.keys.indexOf(u)===-1,v&&this.keys.push(u),S.$Fn.test(u)&&this.overrides.push({identifiers:(0,S.$Gn)(u),keys:Object.keys(this.contents[u]),contents:(0,R.$yi)(this.contents[u],g=>console.error(g))})}}e.$Ln=b;class a{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,f){if(!m.$Lf(u)){const v=this.g(u);this.parseRaw(v,f)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,f){this.a=u;const{contents:v,keys:g,overrides:D,restricted:I,hasExcludedProperties:h}=this.h(u,f);this.b=new b(v,g,D,h?[u]:void 0),this.c=I||[]}g(u){let f={},v=null,g=[];const D=[],I=[];function h(k){Array.isArray(g)?g.push(k):v!==null&&(g[v]=k)}const w={onObjectBegin:()=>{const k={};h(k),D.push(g),g=k,v=null},onObjectProperty:k=>{v=k},onObjectEnd:()=>{g=D.pop()},onArrayBegin:()=>{const k=[];h(k),D.push(g),g=k,v=null},onArrayEnd:()=>{g=D.pop()},onLiteralValue:h,onError:(k,F,W)=>{I.push({error:k,offset:F,length:W})}};if(u)try{C.$bn(u,w),f=g[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return f}h(u,f){const v=l.$qn.as(S.$vn.Configuration).getConfigurationProperties(),g=this.i(u,v,!0,f);u=g.raw;const D=(0,R.$yi)(u,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),I=Object.keys(u),h=this.j(u,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:D,keys:I,overrides:h,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}i(u,f,v,g){let D=!1;if(!g?.scopes&&!g?.skipRestricted&&!g?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:D};const I={},h=[];for(const w in u)if(S.$Fn.test(w)&&v){const k=this.i(u[w],f,!1,g);I[w]=k.raw,D=D||k.hasExcludedProperties,h.push(...k.restricted)}else{const k=f[w],F=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&h.push(w),!g.exclude?.includes(w)&&(g.include?.includes(w)||(F===void 0||g.scopes===void 0||g.scopes.includes(F))&&!(g.skipRestricted&&k?.restricted))?I[w]=u[w]:D=!0}return{raw:I,restricted:h,hasExcludedProperties:D}}j(u,f){const v=[];for(const g of Object.keys(u))if(S.$Fn.test(g)){const D={};for(const I in u[g])D[I]=u[g][I];v.push({identifiers:(0,S.$Gn)(g),keys:Object.keys(D),contents:(0,R.$yi)(D,f)})}return v}}e.$Mn=a;class s extends M.$Rc{constructor(u,f,v,g){super(),this.c=u,this.f=f,this.g=g,this.b=this.B(new T.$Rd),this.onDidChange=this.b.event,this.a=new a(this.c.toString()),this.B(this.g.watch(v.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&v.isEqual(D.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Nn=s;class t{constructor(u,f,v,g,D,I,h,w,k,F,W,Q,N){this.a=u,this.b=f,this.c=v,this.overrideIdentifiers=g,this.d=D,this.f=I,this.g=h,this.h=w,this.i=k,this.j=F,this.k=W,this.l=Q,this.m=N}get value(){return p(this.c)}n(u,f,v){const g=u.inspect(f,v);return{get value(){return p(g.value)},get override(){return p(g.override)},get merged(){return p(g.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(u,f,v,g,D=new b,I=new b,h=new P.$zc,w=new b,k=new P.$zc){this.c=u,this.d=f,this.f=v,this.g=g,this.h=D,this.i=I,this.j=h,this.l=w,this.m=k,this.a=null,this.b=new P.$zc,this.n=null}getValue(u,f,v){return this.p(u,f,v).getValue(u)}updateValue(u,f,v={}){let g;v.resource?(g=this.m.get(v.resource),g||(g=new b,this.m.set(v.resource,g))):g=this.l,f===void 0?g.removeValue(u):g.setValue(u,f),v.resource||(this.a=null)}inspect(u,f,v){const g=this.p(u,f,v),D=this.t(f.resource,v),I=f.resource?this.m.get(f.resource)||this.l:this.l,h=new Set;for(const w of g.overrides)for(const k of w.identifiers)g.getOverrideValue(u,k)!==void 0&&h.add(k);return new t(u,f,g.getValue(u),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this.i:void 0,D||void 0,I)}keys(u){const f=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:f?f.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,f){this.j.set(u,f),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,f){const v=[];if(!f){const{added:g,updated:D,removed:I}=d(this.c,u);f=[...g,...D,...I]}for(const g of f)for(const D of(0,S.$Gn)(g)){const I=this.c.getKeysForOverrideIdentifier(D),h=u.getKeysForOverrideIdentifier(D),w=[...h.filter(k=>I.indexOf(k)===-1),...I.filter(k=>h.indexOf(k)===-1),...I.filter(k=>!$.$in(this.c.override(D).getValue(k),u.override(D).getValue(k)))];v.push([D,w])}return this.updateDefaultConfiguration(u),{keys:f,overrides:v}}compareAndUpdatePolicyConfiguration(u){const{added:f,updated:v,removed:g}=d(this.d,u),D=[...f,...v,...g];return D.length&&this.updatePolicyConfiguration(u),{keys:D,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:f,updated:v,removed:g,overrides:D}=d(this.applicationConfiguration,u),I=[...f,...v,...g];return I.length&&this.updateApplicationConfiguration(u),{keys:I,overrides:D}}compareAndUpdateLocalUserConfiguration(u){const{added:f,updated:v,removed:g,overrides:D}=d(this.localUserConfiguration,u),I=[...f,...v,...g];return I.length&&this.updateLocalUserConfiguration(u),{keys:I,overrides:D}}compareAndUpdateRemoteUserConfiguration(u){const{added:f,updated:v,removed:g,overrides:D}=d(this.remoteUserConfiguration,u),I=[...f,...v,...g];return I.length&&this.updateRemoteUserConfiguration(u),{keys:I,overrides:D}}compareAndUpdateWorkspaceConfiguration(u){const{added:f,updated:v,removed:g,overrides:D}=d(this.workspaceConfiguration,u),I=[...f,...v,...g];return I.length&&this.updateWorkspaceConfiguration(u),{keys:I,overrides:D}}compareAndUpdateFolderConfiguration(u,f){const v=this.folderConfigurations.get(u),{added:g,updated:D,removed:I,overrides:h}=d(v,f),w=[...g,...D,...I];return(w.length||!v)&&this.updateFolderConfiguration(u,f),{keys:w,overrides:h}}compareAndDeleteFolderConfiguration(u){const f=this.folderConfigurations.get(u);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:v,updated:g,removed:D,overrides:I}=d(f,void 0);return{keys:[...v,...g,...D],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,f,v){let g=this.q(f,v);return f.overrideIdentifier&&(g=g.override(f.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(g=g.merge(this.d)),g}q({resource:u},f){let v=this.r();if(f&&u){const g=f.getFolder(u);g&&(v=this.s(g.uri)||v);const D=this.m.get(u);D&&(v=v.merge(D))}return v}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let f=this.b.get(u);if(!f){const v=this.r(),g=this.j.get(u);g?(f=v.merge(g),this.b.set(u,f)):f=v}return f}t(u,f){if(f&&u){const v=f.getFolder(u);if(v)return this.j.get(v.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,f)=>{const{contents:v,overrides:g,keys:D}=this.j.get(f);return u.push([f,{contents:v,overrides:g,keys:D}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(f=>u.add(f)),this.userConfiguration.keys.forEach(f=>u.add(f)),this.i.keys.forEach(f=>u.add(f)),this.j.forEach(f=>f.keys.forEach(v=>u.add(v))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(f=>u.add(f)),this.userConfiguration.getAllOverrideIdentifiers().forEach(f=>u.add(f)),this.i.getAllOverrideIdentifiers().forEach(f=>u.add(f)),this.j.forEach(f=>f.getAllOverrideIdentifiers().forEach(v=>u.add(v))),[...u.values()]}v(u){const f=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(v=>f.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(v=>f.add(v)),this.i.getKeysForOverrideIdentifier(u).forEach(v=>f.add(v)),this.j.forEach(v=>v.getKeysForOverrideIdentifier(u).forEach(g=>f.add(g))),[...f.values()]}static parse(u){const f=this.w(u.defaults),v=this.w(u.policy),g=this.w(u.application),D=this.w(u.user),I=this.w(u.workspace),h=u.folders.reduce((w,k)=>(w.set(y.URI.revive(k[0]),this.w(k[1])),w),new P.$zc);return new n(f,v,g,D,new b,I,h,new b,new P.$zc)}static w(u){return new b(u.contents,u.keys,u.overrides)}}e.$On=n;function o(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const u=new Set,f=new Map;for(const g of r)g.keys.forEach(D=>u.add(D)),g.overrides.forEach(([D,I])=>{const h=(0,P.$wc)(f,D,new Set);I.forEach(w=>h.add(w))});const v=[];return f.forEach((g,D)=>v.push([D,[...g.values()]])),{keys:[...u.values()],overrides:v}}e.$Pn=o;class c{constructor(u,f,v,g){this.change=u,this.f=f,this.g=v,this.h=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const D of u.keys)this.affectedKeys.add(D);for(const[,D]of u.overrides)for(const I of D)this.affectedKeys.add(I);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(u,f){const v=this.a+u,g=this.d.indexOf(v);if(g<0)return!1;const D=g+v.length;if(D>=this.d.length)return!1;const I=this.d.charCodeAt(D);if(I!==this.b&&I!==this.c)return!1;if(f){const h=this.previousConfiguration?this.previousConfiguration.getValue(u,f,this.f?.workspace):void 0,w=this.g.getValue(u,f,this.h);return!$.$in(h,w)}return!0}}e.$Qn=c;function d(r,u){const{added:f,removed:v,updated:g}=i(u?.rawConfiguration,r?.rawConfiguration),D=[],I=r?.getAllOverrideIdentifiers()||[],h=u?.getAllOverrideIdentifiers()||[];if(u){const w=h.filter(k=>!I.includes(k));for(const k of w)D.push([k,u.getKeysForOverrideIdentifier(k)])}if(r){const w=I.filter(k=>!h.includes(k));for(const k of w)D.push([k,r.getKeysForOverrideIdentifier(k)])}if(u&&r){for(const w of I)if(h.includes(w)){const k=i({contents:r.getOverrideValue(void 0,w)||{},keys:r.getKeysForOverrideIdentifier(w)},{contents:u.getOverrideValue(void 0,w)||{},keys:u.getKeysForOverrideIdentifier(w)});D.push([w,[...k.added,...k.removed,...k.updated]])}}return{added:f,removed:v,updated:g,overrides:D}}function i(r,u){const f=r?u?r.keys.filter(D=>u.keys.indexOf(D)===-1):[...r.keys]:[],v=u?r?u.keys.filter(D=>r.keys.indexOf(D)===-1):[...u.keys]:[],g=[];if(r&&u){for(const D of u.keys)if(r.keys.indexOf(D)!==-1){const I=(0,R.$Bi)(u.contents,D),h=(0,R.$Bi)(r.contents,D);$.$in(I,h)||g.push(D)}}return{added:f,removed:v,updated:g}}}),define(Pe[99],Re([1,0,11,4]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=e.RemoteAuthorityResolverErrorCode=e.$2k=e.$1k=e.RemoteConnectionType=e.$Zk=void 0,e.$Zk=(0,T.$Zh)("remoteAuthorityResolverService");var C;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class M{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$1k=M;class P{constructor(S,l){this.host=S,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$2k=P;var $;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class m extends E.$ab{static isNotAvailable(S){return S instanceof m&&S._code===$.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof m&&S._code===$.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof m&&S._code===$.NoResolverFound}static isInvalidAuthority(S){return S instanceof m&&S._code===$.InvalidAuthority}static isHandled(S){return S instanceof m&&S.isHandled}constructor(S,l=$.Unknown,p){super(S),this._message=S,this._code=l,this._detail=p,this.isHandled=l===$.NotAvailable&&p===!0,Object.setPrototypeOf(this,m.prototype)}}e.$3k=m;function y(R){const S=R.indexOf("+");return S===-1?R:R.substring(0,S)}e.$4k=y}),define(Pe[55],Re([1,0,13]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=void 0;function T(y){return y.scheme===E.Schemas.vscodeRemote?y.authority:void 0}e.$5k=T;function C(y){if(!y)return;const R=y.indexOf("+");return R<0?y:y.substr(0,R)}e.$6k=C;function M(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$7k=M;function P(y){const{host:R,port:S}=m(y);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:S}}e.$8k=P;function $(y,R){let{host:S,port:l}=m(y);return typeof l>"u"&&(l=R),{host:S,port:l}}e.$9k=$;function m(y){const R=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const S=y.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const l=y.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:y,port:void 0}}}),define(Pe[22],Re([1,0,12,4,55]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.TargetPlatform=e.ExtensionType=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l="extensions.user.cache",e.$$l="extensions.builtin.cache",e.$_l="undefined_publisher",e.$am=["ui","workspace","web"];function M(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$bm=M,e.$cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(P||(e.ExtensionType=P={}));var $;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class m{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,t){if(typeof s>"u"||s===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof s=="string"||typeof t=="string"){const n=typeof s=="string"?s:s.value,o=typeof t=="string"?t:t.value;return E.$6e(n,o)}return s._lower===t._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.$dm=m;class y{get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const t of s)this.add(t)}add(s){this.c.add(m.toKey(s))}delete(s){return this.c.delete(m.toKey(s))}has(s){return this.c.has(m.toKey(s))}}e.$em=y;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(m.toKey(s))}get(s){return this.c.get(m.toKey(s))}has(s){return this.c.has(m.toKey(s))}set(s,t){this.c.set(m.toKey(s),t)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$fm=R;function S(a){return l(a)}e.$gm=S;function l(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}e.$hm=l;function p(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}e.$im=p;function b(a,s){if(s){const t=`onResolveRemoteAuthority:${(0,C.$6k)(s)}`;return!!a.activationEvents?.includes(t)}return!1}e.$jm=b,e.$km=(0,T.$Zh)("IBuiltinExtensionsScannerService")}),define(Pe[100],Re([1,0,11,22]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BF=e.$AF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(P,$){this.a.set(P,$)}readActivationEvents(P){return this.b.has(P)||this.b.set(P,this.c(P)),this.b.get(P)}createActivationEventsMap(P){const $=Object.create(null);for(const m of P){const y=this.readActivationEvents(m);y.length>0&&($[T.$dm.toKey(m.identifier)]=y)}return $}c(P){if(typeof P.main>"u"&&typeof P.browser>"u")return[];const $=Array.isArray(P.activationEvents)?P.activationEvents.slice(0):[];for(let m=0;m<$.length;m++)$[m]==="onUri"&&($[m]=`onUri:${T.$dm.toKey(P.identifier)}`);if(!P.contributes)return $;for(const m in P.contributes){const y=this.a.get(m);if(!y)continue;const R=P.contributes[m],S=Array.isArray(R)?R:[R];try{y(S,$)}catch(l){(0,E.$Z)(l)}}return $}}e.$AF=C,e.$BF=new C}),define(Pe[190],Re([1,0,21,74,33]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=void 0;function M(m){if(E.$u===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function P(m,y,R,S,l,p,b,a,s){const t=Object.create(null);t["common.machineId"]=p,t["common.sqmId"]=b,t.sessionID=(0,C.$kg)()+Date.now(),t.commitHash=S,t.version=l,t["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,E.$h)(E.$u),t["common.nodePlatform"]=T.$cc,t["common.nodeArch"]=R,t["common.product"]=s||"desktop",a&&(t["common.msftInternal"]=a);let n=0;const o=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$l&&(t["common.snap"]="true");const c=M(y);return c&&(t["common.platformDetail"]=c),t}e.$ro=P;function $(m){const y=T.env.USERDNSDOMAIN;if(!y)return!1;const R=y.toLowerCase();return m.some(S=>R===S)}e.$so=$}),define(Pe[191],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=void 0,e.$ml=(0,E.$Zh)("telemetryService"),e.$nl=(0,E.$Zh)("customEndpointTelemetryService"),e.$ol="telemetry.currentSessionDate",e.$pl="telemetry.firstSessionDate",e.$ql="telemetry.lastSessionDate",e.$rl="telemetry.machineId",e.$sl="telemetry.sqmId",e.$tl="telemetry",e.$ul="telemetry.telemetryLevel",e.$vl="telemetry.enableCrashReporter",e.$wl="telemetry.enableTelemetry";var T;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var C;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Pe[56],Re([1,0,26,16,5,41,55,190,191]),function(pe,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=void 0;class y{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.$to=y;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$uo=R,e.$vo=new R;class S{async publicLog(v,g,D){}async publicLogError(v,g,D){}}e.$wo=S,e.$xo="telemetry",e.$yo="extensionTelemetryLog",e.$zo={log:()=>null,flush:()=>Promise.resolve(null)};function l(f,v){return C.Event.debounce(v.onDidChangeConfiguration,(D,I)=>{const h=D?new Set([...D.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:h}},1e3,!0)(D=>{D.source!==7&&f.publicLog2("updateConfiguration",{configurationSource:(0,M.$wi)(D.source),configurationKeys:Array.from(D.affectedKeys)})})}e.$Ao=l;function p(f,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!f.enableTelemetry)}e.$Bo=p;function b(f,v){return v.extensionTestsLocationURI?!0:!(v.isBuilt||v.disableTelemetry||f.enableTelemetry&&f.aiConfig?.ariaKey)}e.$Co=b;function a(f){const v=f.getValue(m.$ul),g=f.getValue(m.$vl);if(f.getValue(m.$wl)===!1||g===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Do=a;function s(f){const v={},g={},D={};o(f,D);for(let I in D){I=I.length>150?I.substr(I.length-149):I;const h=D[I];typeof h=="number"?g[I]=h:typeof h=="boolean"?g[I]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${h.length}`),v[I]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(v[I]=h)}return{properties:v,measurements:g}}e.$Eo=s;const t=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(f){if(!f)return"none";const v=(0,P.$6k)(f);return t.has(v)?v:"other"}e.$Fo=n;function o(f,v,g=0,D){if(f)for(const I of Object.getOwnPropertyNames(f)){const h=f[I],w=D?D+I:I;Array.isArray(h)?v[w]=(0,E.$jn)(h):h instanceof Date?v[w]=h.toISOString():(0,T.$Ef)(h)?g<2?o(h,v,g+1,w+"."):v[w]=(0,E.$jn)(h):v[w]=h}}function c(f,v){const g=f.msftInternalDomains||[],D=v.getValue("telemetry.internalTesting");return(0,$.$so)(g)||D}e.$Go=c;function d(f){return[f.appRoot,f.extensionsPath,f.userHome.fsPath,f.tmpDir.fsPath,f.userDataPath]}e.$Ho=d;function i(f,v){if(!f||!f.includes("/")&&!f.includes("\\"))return f;let g=f;const D=[];for(const k of v)for(;;){const F=k.exec(f);if(!F)break;D.push([F.index,k.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(g="";;){const k=h.exec(f);if(!k)break;const F=D.some(([W,Q])=>k.index<Q&&W<h.lastIndex);!I.test(k[0])&&!F&&(g+=f.substring(w,k.index)+"<REDACTED: user-file-path>",w=h.lastIndex)}return w<f.length&&(g+=f.substr(w)),g}function r(f){if(!f)return f;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of v)if(g.regex.test(f))return`<REDACTED: ${g.label}>`;return f}function u(f,v){return(0,E.$gn)(f,g=>{if(g instanceof y||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let D=g.replaceAll("%20"," ");D=i(D,v);for(const I of v)D=D.replace(I,"");return D=r(D),D}})}e.$Io=u}),define(Pe[192],Re([1,0,12,96,22,21,2,11,74,56]),function(pe,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0;function R(u,f){return u.uuid&&f.uuid?u.uuid===f.uuid:u.id===f.id?!0:(0,E.$1e)(u.id,f.id)===0}e.$Jo=R;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(f){const v=f.manifest?f.manifest.version:f.version,g=f.manifest?f.targetPlatform:f.properties.targetPlatform;return new l(f.identifier,v,g)}static parse(f){const v=S.exec(f);return v&&v[1]&&v[2]?new l({id:v[1]},v[2],v[4]||void 0):null}constructor(f,v,g="undefined"){this.version=v,this.targetPlatform=g,this.id=f.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(f){return f instanceof l?R(this,f)&&this.version===f.version&&this.targetPlatform===f.targetPlatform:!1}}e.$Ko=l;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(u){const f=p.exec(u);return f&&f[1]?[s(f[1]),f[2]]:[s(u),void 0]}e.$Lo=b;function a(u,f){return`${u}.${f}`}e.$Mo=a;function s(u){return u.toLowerCase()}e.$No=s;function t(u,f){return s(a(u??C.$_l,f))}e.$Oo=t;function n(u,f){const v=[],g=D=>{for(const I of v)if(I.some(h=>R(f(h),f(D))))return I;return null};for(const D of u){const I=g(D);I?I.push(D):v.push([D])}return v}e.$Po=n;function o(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.$Qo=o;function c(u){return{id:new y.$to(u.identifier.id),name:new y.$to(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$Ro=c,e.$So=new C.$dm("pprice.better-merge");function d(u,f){const v=[],g=f.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const D=g.shift();if(D&&v.every(I=>!R(I.identifier,{id:D}))){const I=u.filter(h=>R(h.identifier,{id:D}));I.length===1&&(v.push(I[0]),g.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.$To=d;async function i(u,f){if(!M.$k)return!1;let v;try{v=(await u.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await u.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){f.debug("Error while getting the os-release file.",(0,$.$9)(D))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(u,f){const v=await i(u,f),g=(0,T.$do)(v?"alpine":M.$u,m.$dc);return f.debug("ComputeTargetPlatform:",g),g}e.$Uo=r}),define(Pe[193],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=e.$yr=e.$xr=e.$wr=e.$vr=e.$ur=void 0;function E(m){return[...m.entries()]}e.$ur=E;function T(m){return m?[...m.entries()]:[]}e.$vr=T;function C(m){return new Map(m)}e.$wr=C;function M(m){return new Map(m??[])}e.$xr=M;function P(m){return Array.from(m.entries()).map(y=>[y[0],E(y[1].map),T(y[1].descriptionMap)])}e.$yr=P;function $(m){return new Map(m.map(y=>[y[0],{map:C(y[1]),descriptionMap:M(y[2])}]))}e.$zr=$}),define(Pe[194],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qb=void 0;class E{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,M,P=5){const $=M(m=>{const y=typeof m=="string"?m:m.data;let R=this.a.get(C);if(R){R.data.push(y);return}const S=setTimeout(()=>this.flushBuffer(C),P);R={data:[y],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(C),$.dispose()}},this.a.set(C,R)});return $}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const M=this.a.get(C);M&&(this.a.delete(C),this.b(C,M.data.join("")))}}e.$2qb=E}),define(Pe[195],Re([1,0,14,90,45,5,16,2,154,73,30]),function(pe,e,E,T,C,M,P,$,m,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lw=e.$kw=e.$jw=e.$iw=e.$hw=e.$gw=e.$fw=e.$ew=e.IconFontDefinition=e.IconContribution=e.$dw=void 0,e.$dw={IconContribution:"base.contributions.icons"};var S;(function(c){function d(i,r){let u=i.defaults;for(;C.ThemeIcon.isThemeIcon(u);){const f=b.getIcon(u.id);if(!f)return;u=f.defaults}return u}c.getDefinition=d})(S||(e.IconContribution=S={}));var l;(function(c){function d(r){return{weight:r.weight,style:r.style,src:r.src.map(u=>({format:u.format,location:u.location.toString()}))}}c.toJSONObject=d;function i(r){const u=f=>(0,P.$Cf)(f)?f:void 0;if(r&&Array.isArray(r.src)&&r.src.every(f=>(0,P.$Cf)(f.format)&&(0,P.$Cf)(f.location)))return{weight:u(r.weight),style:u(r.style),src:r.src.map(f=>({format:f.format,location:$.URI.parse(f.location)}))}}c.fromJSONObject=i})(l||(e.IconFontDefinition=l={}));class p{constructor(){this.a=new M.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,m.localize)(0,null)},fontCharacter:{type:"string",description:(0,m.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(d,i,r,u){const f=this.b[d];if(f){if(r&&!f.description){f.description=r,this.d.properties[d].markdownDescription=`${r} $(${d})`;const D=this.e.enum.indexOf(d);D!==-1&&(this.e.enumDescriptions[D]=r),this.a.fire()}return f}const v={id:d,description:r,defaults:i,deprecationMessage:u};this.b[d]=v;const g={$ref:"#/definitions/icons"};return u&&(g.deprecationMessage=u),r&&(g.markdownDescription=`${r}: $(${d})`),this.d.properties[d]=g,this.e.enum.push(d),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:d}}deregisterIcon(d){delete this.b[d],delete this.d.properties[d];const i=this.e.enum.indexOf(d);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(d=>this.b[d])}getIcon(d){return this.b[d]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(d,i){const r=this.f[d];return r||(this.f[d]=i,this.a.fire(),i)}deregisterIconFont(d){delete this.f[d]}getIconFont(d){return this.f[d]}toString(){const d=(f,v)=>f.id.localeCompare(v.id),i=f=>{for(;C.ThemeIcon.isThemeIcon(f.defaults);)f=this.b[f.defaults.id];return`codicon codicon-${f?f.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(f=>this.b[f]);for(const f of u.filter(v=>!!v.description).sort(d))r.push(`|<i class="${i(f)}"></i>|${f.id}|${C.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const f of u.filter(v=>!C.ThemeIcon.isThemeIcon(v.defaults)).sort(d))r.push(`|<i class="${i(f)}"></i>|${f.id}|`);return r.join(`
`)}}const b=new p;R.$qn.add(e.$dw.IconContribution,b);function a(c,d,i,r){return b.registerIcon(c,d,i,r)}e.$ew=a;function s(){return b}e.$fw=s;function t(){const c=(0,T.$3j)();for(const d in c){const i="\\"+c[d].toString(16);b.registerIcon(d,{fontCharacter:i})}}t(),e.$gw="vscode://schemas/icons";const n=R.$qn.as(y.$rn.JSONContribution);n.registerSchema(e.$gw,b.getIconSchema());const o=new E.$_g(()=>n.notifySchemaChanged(e.$gw),200);b.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$hw=a("widget-close",T.$5j.close,(0,m.localize)(2,null)),e.$iw=a("goto-previous-location",T.$5j.arrowUp,(0,m.localize)(3,null)),e.$jw=a("goto-next-location",T.$5j.arrowDown,(0,m.localize)(4,null)),e.$kw=C.ThemeIcon.modify(T.$5j.sync,"spin"),e.$lw=C.ThemeIcon.modify(T.$5j.loading,"spin")}),define(Pe[196],Re([1,0,5,41,4,15]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.ProvidedOnAutoForward=e.$jv=e.TunnelPrivacyId=e.TunnelProtocol=e.$iv=e.$hv=void 0,e.$hv=(0,C.$Zh)("tunnelService"),e.$iv=(0,C.$Zh)("sharedTunnelsService");var P;(function(s){s.Http="http",s.Https="https"})(P||(e.TunnelProtocol=P={}));var $;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})($||(e.TunnelPrivacyId=$={}));function m(s){return!!s.forwardPort}e.$jv=m;var y;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function R(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(t)return{address:t[1],port:+t[2]}}e.$kv=R,e.$lv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(s){return e.$lv.indexOf(s)>=0}e.$mv=S,e.$nv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(s){return e.$nv.indexOf(s)>=0}e.$ov=l;function p(s,t,n,o){if(n===1)return!1;if(n===2&&l(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(c?.length===4&&parseInt(c[1])>=18)return!1}return s<1024}e.$pv=p;class b{constructor(t,n,o){this.remoteAddress=t,this.localAddress=n,this.b=o,this.a=new E.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$qv=b;let a=class{constructor(t,n){this.j=t,this.k=n,this.a=new E.$Rd,this.onTunnelOpened=this.a.event,this.b=new E.$Rd,this.onTunnelClosed=this.b.event,this.c=new E.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const t=this.k.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.h=t.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const t=[],n=Array.from(this.e.values());for(const o of n){const c=Array.from(o.values());for(const d of c){const i=await d.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:n}of t.values())await n.then(o=>typeof o!="string"?o?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,n,o,c,d){this.p(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:o,privacy:c,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){(l(t)||S(t))&&(t=e.$lv[0]);const o=this.r(t,n);if(o)return++o.refcount,o.value}openTunnel(t,n,o,c,d,i=!1,r,u){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${o} on local port ${d}.`);const f=this.f??t;if(!f)return;if(n||(n="localhost"),c||(c=this.l),this.f&&this.i.has(o)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.s(f,n,o,c,d,i,r,u);return v?v.then(g=>{if(g){if(typeof g=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(n,o),g}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(n,o);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.n(g);return(g.tunnelRemoteHost!==n||g.tunnelRemotePort!==o)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&g.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}n(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this.e.get(t.tunnelRemoteHost);if(n){const o=n.get(t.tunnelRemotePort);o&&(o.refcount--,await this.o(t.tunnelRemoteHost,t.tunnelRemotePort,o))}}}}async o(t,n,o){if(o.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const c=o.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(n),c}}async closeTunnel(t,n){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const o=this.e.get(t);if(o&&o.has(n)){const c=o.get(n);c.refcount=0,await this.o(t,n,c)}}p(t,n,o){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(n,{refcount:1,value:o})}async q(t,n){const o=this.e.get(t);if(o){const c=o.get(n),d=c?await c.value:void 0;(!d||typeof d=="string")&&o.delete(n),o.size===0&&this.e.delete(t)}}r(t,n){const o=[t];S(t)?(o.push(...e.$lv),o.push(...e.$nv)):l(t)&&o.push(...e.$nv);const c=o.map(d=>this.e.get(d));for(const d of c){const i=d?.get(n);if(i)return i}}canTunnel(t){return!!R(t)}t(t,n,o,c,d,i,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${o} on local port ${c}.`);const u=o;this.i.add(u);const f=c===void 0?o:c,v={elevationRequired:d?this.isPortPrivileged(f):!1},g={remoteAddress:{host:n,port:o},localAddressPort:c,privacy:i,public:i?i!==$.Private:void 0,protocol:r},D=t.forwardPort(g,v);return D?(this.p(n,o,D),D.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(u)})):this.i.delete(u),D}};e.$rv=a,e.$rv=a=Ke([We(0,M.$hj),We(1,T.$ti)],a)}),define(Pe[197],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$sv=void 0,e.$sv=(0,E.$Zh)("editSessionIdentityService");var T;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Pe[198],Re([1,0,13]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=void 0;function T(m){return m.scheme!==E.Schemas.file&&m.scheme!==E.Schemas.vscodeRemote}e.$_J=T;function C(m){if(m.folders.length)return m.folders.every(y=>T(y.uri))?m.folders[0].uri:void 0;if(m.configuration&&T(m.configuration))return m.configuration}e.$aK=C;function M(m){return C(m)?.scheme}e.$bK=M;function P(m){return C(m)?.authority}e.$cK=P;function $(m){return C(m)!==void 0}e.$dK=$}),define(Pe[47],Re([1,0,155,20,50,25,2,4,13]),function(pe,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.WorkbenchState=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=void 0,e.$9h=(0,$.$Zh)("contextService");function y(f){const v=f;return typeof v?.id=="string"&&P.URI.isUri(v.uri)}e.$0h=y;function R(f){return typeof f?.id=="string"&&!y(f)&&!l(f)}e.$$h=R,e.$_h={id:"ext-dev"},e.$ai={id:"empty-window"};function S(f,v){if(typeof f=="string"||typeof f>"u")return typeof f=="string"?{id:(0,T.$mc)(f)}:v?e.$_h:e.$ai;const g=f;return g.configuration?{id:g.id,configPath:g.configuration}:g.folders.length===1?{id:g.id,uri:g.folders[0].uri}:{id:g.id}}e.$bi=S;function l(f){const v=f;return typeof v?.id=="string"&&P.URI.isUri(v.configPath)}e.$ci=l;function p(f){const v=f;if(v?.uri)return{id:v.id,uri:P.URI.revive(v.uri)};const g=f;if(g?.configPath)return{id:g.id,configPath:P.URI.revive(g.configPath)};if(f?.id)return{id:f.id}}e.$di=p;var b;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function a(f){const v=f;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.$ei=a;function s(f){const v=f;return!!(v&&typeof v=="object"&&P.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.$fi=s;class t{constructor(v,g,D,I,h){this.h=v,this.j=D,this.k=I,this.l=h,this.c=C.$6h.forUris(this.l,()=>!0),this.folders=g}update(v){this.h=v.id,this.k=v.configuration,this.j=v.transient,this.l=v.l,this.folders=v.folders}get folders(){return this.g}set folders(v){this.g=v,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(v){this.k=v}getFolder(v){return v&&this.c.findSubstr(v)||null}n(){this.c=C.$6h.forUris(this.l,()=>!0);for(const v of this.folders)this.c.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$gi=t;class n{constructor(v,g){this.raw=g,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,M.$Bg)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$hi=n;function o(f){return new n({uri:f,index:0,name:(0,M.$xg)(f)},{uri:f.toString()})}e.$ii=o,e.$ji="code-workspace",e.$ki=`.${e.$ji}`,e.$li=[{name:(0,E.localize)(0,null),extensions:[e.$ji]}],e.$mi="workspace.json";function c(f,v){return M.$sg.isEqualOrParent(f,v.untitledWorkspacesHome)}e.$ni=c;function d(f){let v;return P.URI.isUri(f)?v=f:v=f.configuration,v?.scheme===m.Schemas.tmp}e.$oi=d,e.$pi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(f){return f.id===e.$pi}e.$qi=i;function r(f,v){return!c(f,v)&&!d(f)}e.$ri=r;function u(f){return(typeof f=="string"?(0,T.$nc)(f):(0,M.$zg)(f))===e.$ki}e.$si=u}),define(Pe[75],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class E{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const M=this.c++;return this.b.set(M,C),this.e(),M}get(C,M){return this.b.has(C)?this.b.get(C)[M]:void 0}delete(C){this.b.delete(C),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$jec=E}),define(Pe[43],Re([1,0,13,25,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=e.$mec=void 0;class M{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new T.$qg($=>{const m=this.b.get($.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos($,m){m===null?this.b.delete($.scheme):this.b.set($.scheme,m)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$mec=M,e.$nec=(0,C.$Zh)("IExtHostFileSystemInfo")}),define(Pe[27],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=void 0,e.$UM=(0,E.$Zh)("IExtHostInitDataService")}),define(Pe[199],Re([1,0,160,15,186,27]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;let P=class extends C.$2N{constructor(m,y,R){const S=R.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",l=R.remote.isRemote?(0,E.localize)(0,null):m?(0,E.localize)(1,null):(0,E.localize)(2,null);super(y.createLogger(S,{name:l}))}};e.$tgc=P,e.$tgc=P=Ke([We(1,T.$ij),We(2,M.$UM)],P)}),define(Pe[200],Re([1,0,14]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=e.$8ec=void 0;class T{constructor(P,$,m){this.h=new Map,this.a=P,this.b=$,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new E.$_g(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of y.values())R.complete()}catch(R){for(const S of y.values())S.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this.d}get(P,$){let m=this.f[P];return typeof m>"u"&&(m=$),m}update(P,$){this.f[P]=$;const m=this.h.get(P);if(m!==void 0)return m.p;const y=new E.$kh;return this.h.set(P,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$8ec=T;class C extends T{setKeysForSync(P){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},P)}constructor(P,$){super(P.identifier.value,!0,$),this.j=P}}e.$9ec=C}),define(Pe[201],Re([1,0,5,2]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=void 0;class C{constructor(P){this.c=P,this.a=new E.$Rd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Rd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(P,$,m,y){const S=this.c.getNotebookDocument(T.URI.revive(P)).acceptModelChanged($.value,m,y);this.b.fire(S)}$acceptDirtyStateChanged(P,$){this.c.getNotebookDocument(T.URI.revive(P)).acceptDirty($)}$acceptModelSaved(P){const $=this.c.getNotebookDocument(T.URI.revive(P));this.a.fire($.apiNotebook)}}e.$Vfc=C}),define(Pe[17],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0,e.$EM=(0,E.$Zh)("IExtHostRpcService");class T{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$FM=T}),define(Pe[202],Re([1,0,22,5]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class C{#e;constructor(P,$){this.b=new T.$Rd,this.onDidChange=this.b.event,this.a=E.$dm.toKey(P.identifier),this.#e=$,this.#e.onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(P){return this.#e.get(this.a,P)}store(P,$){return this.#e.store(this.a,P,$)}delete(P){return this.#e.delete(this.a,P)}}e.$dfc=C}),define(Pe[57],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=e.$Fec=void 0,e.$Fec=(0,E.$Zh)("IURITransformerService");class T{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.$Gec=T}),define(Pe[203],Re([1,0,24]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfb=e.$gfb=void 0;class T{constructor(){this.buffers=[]}add(m){let y=this.buffers.indexOf(m);return y<0&&(y=this.buffers.length,this.buffers.push(m)),y}}function C($,m){if(m.serializeBuffersForPostMessage){const y=new T,S=JSON.stringify($,(p,b)=>{if(b instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(b)};if(ArrayBuffer.isView(b)){const a=M(b);if(a)return{$$vscode_array_buffer_reference$$:!0,index:y.add(b.buffer),view:{type:a,byteLength:b.byteLength,byteOffset:b.byteOffset}}}return b}),l=y.buffers.map(p=>{const b=new Uint8Array(p);return E.$fe.wrap(b)});return{message:S,buffers:l}}else return{message:JSON.stringify($),buffers:[]}}e.$gfb=C;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P($,m){const y=m.map(l=>{const p=new ArrayBuffer(l.byteLength);return new Uint8Array(p).set(l.buffer),p}),R=m.length?(l,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const b=p,{index:a}=b,s=y[a];if(b.view)switch(b.view.type){case 1:return new Int8Array(s,b.view.byteOffset,b.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,b.view.byteOffset,b.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,b.view.byteOffset,b.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,b.view.byteOffset,b.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,b.view.byteOffset,b.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,b.view.byteOffset,b.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,b.view.byteOffset,b.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,b.view.byteOffset,b.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,b.view.byteOffset,b.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,b.view.byteOffset,b.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,b.view.byteOffset,b.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return p}:void 0;return{message:JSON.parse($,R),arrayBuffers:y}}e.$hfb=P}),define(Pe[101],Re([1,0,170,16,2,6,4,30,42,13,40,133,31]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FE=e.$EE=e.$DE=e.EditorsOrder=e.$CE=e.CloseDirection=e.$BE=e.$AE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.$uE=e.$tE=e.$sE=e.EditorInputCapabilities=e.$rE=e.SaveReason=e.Verbosity=e.$qE=e.$pE=e.$oE=e.$nE=e.$mE=e.$lE=e.$kE=e.$jE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$iE=e.$hE=e.$gE=e.$fE=e.$eE=void 0,e.$eE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$fE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$gE="workbench.editor.sidebysideEditor",e.$hE="workbench.editors.textDiffEditor",e.$iE="workbench.editors.binaryResourceDiffEditor";var p;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var b;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function a(ce){const Y=ce;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.$jE=a;function s(ce,Y,B){for(const se of B.visibleEditorPanes)if(se.group.id===Y&&ce.matches(se.input))return se.getViewState()}e.$kE=s;function t(ce){if(D(ce))return!1;const Y=ce;return C.URI.isUri(Y?.resource)}e.$lE=t;function n(ce){if(D(ce))return!1;const Y=ce;return Y?.original!==void 0&&Y.modified!==void 0}e.$mE=n;function o(ce){if(D(ce))return!1;const Y=ce;return Array.isArray(Y?.resources)}e.$nE=o;function c(ce){if(D(ce)||n(ce))return!1;const Y=ce;return Y?.primary!==void 0&&Y.secondary!==void 0}e.$oE=c;function d(ce){if(D(ce))return!1;const Y=ce;return Y?Y.resource===void 0||Y.resource.scheme===y.Schemas.untitled||Y.forceUntitled===!0:!1}e.$pE=d;function i(ce){if(D(ce))return!1;const Y=ce;return C.URI.isUri(Y?.base?.resource)&&C.URI.isUri(Y?.input1?.resource)&&C.URI.isUri(Y?.input2?.resource)&&C.URI.isUri(Y?.result?.resource)}e.$qE=i;var r;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var u;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class f{constructor(){this.a=new Map}registerSource(Y,B){let se=this.a.get(Y);return se||(se={source:Y,label:B},this.a.set(Y,se)),se.source}getSourceLabel(Y){return this.a.get(Y)?.label??Y}}e.$rE=new f;var v;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad",ce[ce.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(v||(e.EditorInputCapabilities=v={}));class g extends M.$Rc{}e.$sE=g;function D(ce){return ce instanceof g}e.$tE=D;function I(ce){const Y=ce;return C.URI.isUri(Y?.preferredResource)}function h(ce){const Y=ce;return D(Y?.primary)&&D(Y?.secondary)}e.$uE=h;function w(ce){const Y=ce;return D(Y?.modified)&&D(Y?.original)}e.$vE=w;function k(ce,Y,B,se,Se){return Ie(se,[(0,S.$Ji)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const Ae={...B,limits:{size:Number.MAX_VALUE}};ce.openEditor(Y,Ae)}}),(0,S.$Ji)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>Se.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$wE=k;function F(ce){return D(ce?.editor)}e.$xE=F;function W(ce){const Y=ce;return F(ce)&&Y?.group!==void 0}e.$yE=W;function Q(ce){const Y=ce;return typeof Y?.groupId=="number"&&D(Y.editor)}e.$zE=Q;var N;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var A;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LABEL=2]="GROUP_LABEL",ce[ce.GROUP_LOCKED=3]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=4]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=5]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=6]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=8]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=10]="EDITOR_PIN",ce[ce.EDITOR_STICKY=11]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=12]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(A||(e.GroupModelChangeKind=A={}));var L;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(L||(e.SideBySideEditor=L={}));class O{getOriginalUri(Y,B){if(!Y)return;if(i(Y))return e.$BE.getOriginalUri(Y.result,B);if(B?.supportSideBySide){const{primary:Se,secondary:Ae}=this.a(Y);if(Se&&Ae){if(B?.supportSideBySide===L.BOTH)return{primary:this.getOriginalUri(Se,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(Ae,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===L.ANY)return this.getOriginalUri(Se,{filterByScheme:B.filterByScheme})??this.getOriginalUri(Ae,{filterByScheme:B.filterByScheme});Y=B.supportSideBySide===L.PRIMARY?Se:Ae}}if(n(Y)||o(Y)||c(Y)||i(Y))return;const se=I(Y)?Y.preferredResource:Y.resource;return!se||!B||!B.filterByScheme?se:this.b(se,B.filterByScheme)}a(Y){return h(Y)||c(Y)?{primary:Y.primary,secondary:Y.secondary}:w(Y)||n(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,B){if(!Y)return;if(i(Y))return e.$BE.getCanonicalUri(Y.result,B);if(B?.supportSideBySide){const{primary:Se,secondary:Ae}=this.a(Y);if(Se&&Ae){if(B?.supportSideBySide===L.BOTH)return{primary:this.getCanonicalUri(Se,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(Ae,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===L.ANY)return this.getCanonicalUri(Se,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(Ae,{filterByScheme:B.filterByScheme});Y=B.supportSideBySide===L.PRIMARY?Se:Ae}}if(n(Y)||o(Y)||c(Y)||i(Y))return;const se=Y.resource;return!se||!B||!B.filterByScheme?se:this.b(se,B.filterByScheme)}b(Y,B){if(Array.isArray(B)){if(B.some(se=>Y.scheme===se))return Y}else if(B===Y.scheme)return Y}}var x;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(x||(e.EditorCloseMethod=x={}));function le(ce,Y,B,se){if(!ce.isSticky(Y))return!1;switch(se.preventPinnedEditorClose){case"keyboardAndMouse":return B===x.MOUSE||B===x.KEYBOARD;case"mouse":return B===x.MOUSE;case"keyboard":return B===x.KEYBOARD}return!1}e.$AE=le,e.$BE=new O;var me;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(Y){const B=this.a=Y.get(P.$Yh);for(const[se,Se]of this.c)this.e(se,Se,B);this.c.clear()}e(Y,B,se){const Se=se.createInstance(B);this.d.set(Y,Se)}registerFileEditorFactory(Y){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Y}getFileEditorFactory(){return(0,T.$Nf)(this.b)}registerEditorSerializer(Y,B){if(this.c.has(Y)||this.d.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.a?this.e(Y,B,this.a):this.c.set(Y,B),(0,M.$Pc)(()=>{this.c.delete(Y),this.d.delete(Y)})}getEditorSerializer(Y){return this.d.get(typeof Y=="string"?Y:Y.typeId)}}$.$qn.add(e.$eE.EditorFactory,new ye);async function we(ce,Y,B){return!ce||!ce.length?[]:await Promise.all(ce.map(async se=>{const Se=C.URI.revive(se.fileUri);if(!Se){B.info("Cannot resolve the path because it is not valid.",se);return}if(!await Y.canHandleResource(Se)){B.info("Cannot resolve the path because it cannot be handled",se);return}let Ce=se.exists,fe=se.type;if(typeof Ce!="boolean"||typeof fe!="number")try{fe=(await Y.stat(Se)).isDirectory?m.FileType.Directory:m.FileType.Unknown,Ce=!0}catch(H){B.error(H),Ce=!1}if(!Ce&&se.openOnlyIfExists){B.info("Cannot resolve the path because it does not exist",se);return}if(fe===m.FileType.Directory){B.info("Cannot resolve the path because it is a directory",se);return}const ne={...se.options,pinned:!0};return Ce?{resource:Se,options:ne}:{resource:Se,options:ne,forceUntitled:!0}}))}e.$CE=we;var de;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(de||(e.EditorsOrder=de={}));function be(ce){const Y=ce;if(!Y)return!1;const B=Y;if(B.modified)return be(B.modified);const se=Y;return!!(se.contributionsState&&se.viewState&&Array.isArray(se.cursorState))}e.$DE=be;function ie(ce){return(0,R.$Li)(ce)}e.$EE=ie;function Ie(ce,Y,B){const se=(0,R.$Mi)(ce,Y);return se.forceMessage=B?.forceMessage,se.forceSeverity=B?.forceSeverity,se.allowDialog=B?.allowDialog,se}e.$FE=Ie}),define(Pe[204],Re([1,0,5,171,4,6,28,30,18,26,90,195]),function(pe,e,E,T,C,M,P,$,m,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OE=e.$NE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$ME=e.$LE=e.ViewContentGroups=e.$KE=e.$JE=e.ViewContainerLocation=e.Extensions=e.$IE=e.$HE=e.$GE=void 0,e.$GE="views",e.$HE=(0,T.localize)(0,null),e.$IE=(0,S.$ew)("default-view-icon",R.$5j.window,(0,T.localize)(1,null));var l;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var p;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$JE=[0,1,2];function b(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$KE=b;class a extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Rd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Rd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,m.$Qb)([...this.g.values()])}registerViewContainer(u,f,v){const g=this.get(u.id);if(g)return g;const D=u;return D.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:D.openCommandActionDescriptor??{id:D.id},(0,P.$wc)(this.g,f,[]).push(D),v?.isDefault&&this.h.push(D),this.c.fire({viewContainer:D,viewContainerLocation:f}),D}deregisterViewContainer(u){for(const f of this.g.keys()){const v=this.g.get(f),g=v?.indexOf(u);if(g!==-1){v?.splice(g,1),v.length===0&&this.g.delete(f),this.f.fire({viewContainer:u,viewContainerLocation:f});return}}}get(u){return this.all.filter(f=>f.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(v=>v?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(f=>this.getViewContainerLocation(f)===u)}}$.$qn.add(l.ViewContainersRegistry,new a);var s;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(s||(e.ViewContentGroups=s={}));function t(r,u){const f=r.group??s.More,v=u.group??s.More;return f!==v?f.localeCompare(v):(r.order??5)-(u.order??5)}class n extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Rd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Rd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Rd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Rd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new P.$Fc}registerViews(u,f){this.registerViews2([{views:u,viewContainer:f}])}registerViews2(u){u.forEach(({views:f,viewContainer:v})=>this.r(f,v)),this.c.fire(u)}deregisterViews(u,f){const v=this.s(u,f);v.length&&this.f.fire({views:v,viewContainer:f})}moveViews(u,f){for(const v of this.m.keys())if(v!==f){const g=this.s(u,v);g.length&&(this.r(g,f),this.g.fire({views:g,from:v,to:f}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const f of this.j){const v=(this.m.get(f)||[]).filter(g=>g.id===u)[0];if(v)return v}return null}getViewContainer(u){for(const f of this.j)if((this.m.get(f)||[]).filter(g=>g.id===u)[0])return f;return null}registerViewWelcomeContent(u,f){return this.n.add(u,f),this.h.fire(u),(0,M.$Pc)(()=>{this.n.delete(u,f),this.h.fire(u)})}registerViewWelcomeContent2(u,f){const v=new Map;for(const[g,D]of f)this.n.add(u,D),v.set(g,(0,M.$Pc)(()=>{this.n.delete(u,D),this.h.fire(u)}));return this.h.fire(u),v}getViewWelcomeContent(u){const f=[];return this.n.forEach(u,v=>f.push(v)),f.sort(t)}r(u,f){let v=this.m.get(f);v||(v=[],this.m.set(f,v),this.j.push(f));for(const g of u){if(this.getView(g.id)!==null)throw new Error((0,T.localize)(2,null,g.id));v.push(g)}}s(u,f){const v=this.m.get(f);if(!v)return[];const g=[],D=[];for(const I of v)u.includes(I)?g.push(I):D.push(I);return g.length&&(D.length?this.m.set(f,D):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),g}}$.$qn.add(l.ViewsRegistry,new n),e.$LE=(0,C.$Zh)("viewsService"),e.$ME=(0,C.$Zh)("viewDescriptorService");var o;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var c;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class d{constructor(u,f){this.c=!1,this.d=!1,(0,y.$hn)(this,u),this.d=!!f,this.resolve=async v=>{if(f&&!this.c){const g=await f(v);g&&(this.tooltip=this.tooltip??g.tooltip,this.command=this.command??g.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$NE=d;class i extends Error{constructor(u){super((0,T.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$OE=i}),define(Pe[205],Re([1,0,2,29,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$cF=e.$bF=void 0;function M(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof E.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(T.$Ds.isIRange)}e.$bF=M;function P(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(M)}e.$cF=P;var $;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var m;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})(m||(e.InteractiveSessionCopyKind=m={})),e.$dF=(0,C.$Zh)("IChatService")}),define(Pe[206],Re([1,0,5,14,172]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new E.$Rd,this.n=new E.$Rd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,m,y,R){const S={command:$};if(m&&Object.keys(m).length>0&&(S.arguments=m),this.s("request",S),typeof R=="number"){const l=setTimeout(()=>{clearTimeout(l);const p=this.f.get(S.seq);if(p){this.f.delete(S.seq);const b={type:"response",seq:0,request_seq:S.seq,success:!1,command:$,message:(0,C.localize)(0,null,R,$)};p(b)}},R)}return y&&this.f.set(S.seq,y),S.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,m){return $.type!=="event"||m.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,T.$1g)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const m=$,y=this.f.get(m.request_seq);y&&(this.f.delete(m.request_seq),y(m));break}}}}s($,m){m.type=$,m.seq=this.d++,this.sendMessage(m)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((m,y)=>$.set(y,m)),await(0,T.$1g)(500),$.forEach((m,y)=>{m({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Mfb=M}),define(Pe[207],Re([1,0,173,35,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$oH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$nH=e.MemoryRangeType=e.$mH=e.State=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=void 0,e.$jG="workbench.view.debug",e.$kG="workbench.debug.variablesView",e.$lG="workbench.debug.watchExpressionsView",e.$mG="workbench.debug.callStackView",e.$nG="workbench.debug.loadedScriptsView",e.$oG="workbench.debug.breakPointsView",e.$pG="workbench.debug.disassemblyView",e.$qG="workbench.panel.repl",e.$rG="workbench.panel.repl.view",e.$sG=new T.$ej("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$tG=new T.$ej("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$uG=new T.$ej("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$vG="debugUx",e.$wG=new T.$ej(e.$vG,"default",{type:"string",description:E.localize(3,null)}),e.$xG=new T.$ej("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$yG=new T.$ej("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$zG=new T.$ej("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$AG=new T.$ej("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$BG=new T.$ej("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$CG=new T.$ej("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$DG=new T.$ej("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$EG=new T.$ej("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$FG=new T.$ej("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$GG=new T.$ej("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$HG=new T.$ej("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$IG=new T.$ej("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$JG=new T.$ej("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$KG=new T.$ej("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$LG=new T.$ej("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$MG=new T.$ej("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$NG=new T.$ej("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$OG=new T.$ej("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$PG=new T.$ej("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$QG=new T.$ej("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$RG=new T.$ej("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$SG=new T.$ej("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$TG=new T.$ej("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$UG=new T.$ej("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$VG=new T.$ej("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$WG=new T.$ej("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$XG=new T.$ej("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$YG=new T.$ej("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$ZG=new T.$ej("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$1G=new T.$ej("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$2G=new T.$ej("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$3G=new T.$ej("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$4G=new T.$ej("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$5G=new T.$ej("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$6G=new T.$ej("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$7G=new T.$ej("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$8G=new T.$ej("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$9G=new T.$ej("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$0G=new T.$ej("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$$G=new T.$ej("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$_G=new T.$ej("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$aH=new T.$ej("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$bH=new T.$ej("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$cH=new T.$ej("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$dH=new T.$ej("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$eH=new T.$ej("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$fH=new T.$ej("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$gH=new T.$ej("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const M=l=>E.localize(52,null,l);e.$hH=M,e.$iH="editor.contrib.debug",e.$jH="editor.contrib.breakpoint",e.$kH="debug",e.$lH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var P;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(P||(e.State=P={}));function $(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$mH=$;var m;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(m||(e.MemoryRangeType=m={})),e.$nH="vscode-debug-memory";var y;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(y||(e.DebugConfigurationProviderTriggerKind=y={}));var R;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$oH=(0,C.$Zh)("debugService");var S;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE"})(S||(e.BreakpointWidgetContext=S={}))}),define(Pe[208],Re([1,0,12,2,20,26,13,29,19,18]),function(pe,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=void 0;const R=/{([^}]+)}/g;function S(I,h,w){return I.replace(R,function(k,F){return h&&F.length>0&&F[0]!=="_"?k:w&&w.hasOwnProperty(F)?w[F]:k})}e.$iF=S;function l(I){const h={};for(const w of Object.keys(I))w.startsWith("!")||(h[w]=I[w]);return h}e.$jF=l;function p(I){return I.configuration.request==="attach"&&!b(I)&&(!I.parentSession||p(I.parentSession))}e.$kF=p;function b(I){let h=I.configuration.type;if(h)return h==="vslsShare"&&(h=I.configuration.adapterProxy.configuration.type),(0,E.$6e)(h,"extensionhost")||(0,E.$6e)(h,"pwa-extensionhost")?I:I.parentSession?b(I.parentSession):void 0}e.$lF=b;function a(I){return I.type&&(I.label||I.program||I.runtime)}e.$mF=a;function s(I,h,w){let k,F=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let Q=null;for(;Q=W.exec(I);){const N=Q.index+1,A=N+Q[0].length;if(N<=h&&A>=w){k=Q[0],F=N;break}}if(k){const N=/\w+/g;let A=null;for(;(A=N.exec(k))&&!(A.index+1+F+A[0].length>=w););A&&(k=k.substring(0,N.lastIndex))}return k?{start:F,end:F+k.length-1}:{start:0,end:0}}e.$nF=s;async function t(I,h,w,k){if(I.evaluatableExpressionProvider.has(h)){const F=I.evaluatableExpressionProvider.ordered(h),W=(0,y.$Gb)(await Promise.all(F.map(async Q=>{try{return await Q.provideEvaluatableExpression(h,w,k??m.CancellationToken.None)}catch{return}})));if(W.length>0){let Q=W[0].expression;const N=W[0].range;return Q||(Q=h.getLineContent(w.lineNumber).substring(N.startColumn-1,N.endColumn-1)),{range:N,matchingExpression:Q}}}else{const F=h.getLineContent(w.lineNumber),{start:W,end:Q}=s(F,w.column,w.column),N=F.substring(W-1,Q);return{matchingExpression:N,range:new $.$Ds(w.lineNumber,W,w.lineNumber,W+N.length)}}return null}e.$oF=t;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(I){return!!(I&&I.match(n))}e.$pF=o;function c(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(o(I.path))return T.URI.parse(I.path);if((0,C.$hc)(I.path))return T.URI.file(I.path)}return I.path}function d(I){if(typeof I.path=="object"){const h=T.URI.revive(I.path);if(h)return h.scheme===P.Schemas.file?h.fsPath:h.toString()}return I.path}function i(I,h){const w=h?c:d,k=(0,M.$en)(I);return u(k,(F,W)=>{F&&W&&(W.path=w(W))}),k}e.$qF=i;function r(I,h){const w=h?c:d,k=(0,M.$en)(I);return u(k,(F,W)=>{!F&&W&&(W.path=w(W))}),k}e.$rF=r;function u(I,h){switch(I.type){case"event":{const w=I;switch(w.event){case"output":h(!1,w.body.source);break;case"loadedSource":h(!1,w.body.source);break;case"breakpoint":h(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=I;switch(w.command){case"setBreakpoints":h(!0,w.arguments.source);break;case"breakpointLocations":h(!0,w.arguments.source);break;case"source":h(!0,w.arguments.source);break;case"gotoTargets":h(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(k=>h(!1,k));break;default:break}break}case"response":{const w=I;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(k=>h(!1,k.source));break;case"loadedSources":w.body.sources.forEach(k=>h(!1,k));break;case"scopes":w.body.scopes.forEach(k=>h(!1,k.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(k=>h(!1,k.source));break;case"setBreakpoints":w.body.breakpoints.forEach(k=>h(!1,k.source));break;case"disassemble":w.body?.instructions.forEach(F=>h(!1,F.location));break;default:break}break}}}function f(I){return I.filter(h=>!h.presentation?.hidden).sort((h,w)=>h.presentation?w.presentation?h.presentation.group?w.presentation.group?h.presentation.group!==w.presentation.group?h.presentation.group.localeCompare(w.presentation.group):v(h.presentation.order,w.presentation.order):-1:w.presentation.group?1:v(h.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$sF=f;function v(I,h){return typeof I!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:I-h}async function g(I,h){const w=I.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(w!=="none"&&(await h.saveAll(),w==="allEditorsInActiveGroup")){const k=h.activeEditorPane;k&&k.input.resource?.scheme===P.Schemas.untitled&&await h.save({editor:k.input,groupId:k.group.id})}await I.reloadConfiguration()}e.$tF=g;const D=(I,h)=>!I||!h?I===h:I.name===h.name&&I.path===h.path&&I.sourceReference===h.sourceReference;e.$uF=D}),define(Pe[76],Re([1,0,24,34,67,68,13,20,21,35]),function(pe,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JI=e.$II=e.$HI=e.$GI=e.CellStatusbarAlignment=e.$FI=e.$EI=e.$DI=e.NotebookEditorPriority=e.$CI=e.$BI=e.$AI=e.$zI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$yI=e.$xI=e.$wI=e.$vI=e.CellKind=e.$uI=e.$tI=e.$sI=void 0,e.$sI="workbench.editor.notebook",e.$tI="workbench.editor.notebookTextDiffEditor",e.$uI="workbench.editor.interactive";var R;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(R||(e.CellKind=R={})),e.$vI=["application/json","application/javascript","text/html","image/svg+xml",M.$Zr.latex,M.$Zr.markdown,"image/png","image/jpeg",M.$Zr.text],e.$wI=[M.$Zr.latex,M.$Zr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Zr.text],e.$xI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$yI="_notAvailable";var S;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var l;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var p;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var b;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(b||(e.NotebookRendererMatch=b={}));var a;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var s;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var t;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var n;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(O){O.scheme=P.Schemas.vscodeNotebookCell;const x=["W","X","Y","Z","a","b","c","d","e","f"],le=new RegExp(`^[${x.join("")}]+`),me=7;function ye(ce,Y){const B=Y.toString(me),Se=`${B.length<x.length?x[B.length-1]:"z"}${B}s${(0,E.$ze)(E.$fe.fromString(ce.scheme),!0,!0)}`;return ce.with({scheme:O.scheme,fragment:Se})}O.generate=ye;function we(ce){if(ce.scheme!==O.scheme)return;const Y=ce.fragment.indexOf("s");if(Y<0)return;const B=parseInt(ce.fragment.substring(0,Y).replace(le,""),me),se=(0,E.$ye)(ce.fragment.substring(Y+1)).toString();if(!isNaN(B))return{handle:B,notebook:ce.with({scheme:se,fragment:null})}}O.parse=we;function de(ce,Y){return ce.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${Y??""},${ce.scheme!==P.Schemas.file?ce.scheme:""}`})}O.generateCellOutputUri=de;function be(ce){if(ce.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const Y=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ce.fragment);if(!Y)return;const B=Y[1]&&Y[1]!==""?Y[1]:void 0,se=Y[2];return{outputId:B,notebook:ce.with({scheme:se||P.Schemas.file,fragment:null})}}O.parseCellOutputUri=be;function ie(ce,Y,B){return O.generate(ce,Y).with({scheme:B})}O.generateCellPropertyUri=ie;function Ie(ce,Y){if(ce.scheme===Y)return O.parse(ce.with({scheme:O.scheme}))}O.parseCellPropertyUri=Ie})(o||(e.CellUri=o={}));const c=O=>m.$i?O.replace(/\//g,"\\"):O;class d{constructor(x=[],le=e.$vI){this.e=le,this.d=[...new Set(x)].map(me=>({pattern:me,matches:T.$Gj(c(me))}))}sort(x){const le=new Map(C.Iterable.map(x,ye=>[ye,c(ye)]));let me=[];for(const{matches:ye}of this.d)for(const[we,de]of le)if(ye(de)){me.push(we),le.delete(we);break}return le.size&&(me=me.concat([...le.keys()].sort((ye,we)=>this.e.indexOf(ye)-this.e.indexOf(we)))),me}prioritize(x,le){const me=this.f(x);if(me===-1){this.d.unshift({pattern:x,matches:T.$Gj(c(x))});return}const ye=new Set(le.map(de=>this.f(de,me)));ye.delete(-1);const we=Array.from(ye).sort();this.d.splice(me+1,0,...we.map(de=>this.d[de]));for(let de=we.length-1;de>=0;de--)this.d.splice(we[de],1)}toArray(){return this.d.map(x=>x.pattern)}f(x,le=this.d.length){const me=c(x);for(let ye=0;ye<le;ye++)if(this.d[ye].matches(me))return ye;return-1}}e.$zI=d;function i(O,x,le,me=(ye,we)=>ye===we){const ye=[];function we(ie,Ie,ce){if(Ie===0&&ce.length===0)return;const Y=ye[ye.length-1];Y&&Y.start+Y.deleteCount===ie?(Y.deleteCount+=Ie,Y.toInsert.push(...ce)):ye.push({start:ie,deleteCount:Ie,toInsert:ce})}let de=0,be=0;for(;;){if(de===O.length){we(de,0,x.slice(be));break}if(be===x.length){we(de,O.length-de,[]);break}const ie=O[de],Ie=x[be];if(me(ie,Ie)){de+=1,be+=1;continue}le(Ie)?(we(de,1,[]),de+=1):(we(de,0,[Ie]),be+=1)}return ye}e.$AI=i,e.$BI=new y.$ej("notebookEditorCursorAtBoundary","none"),e.$CI=new y.$ej("notebookEditorCursorAtLineBoundary","none");var r;(function(O){O.default="default",O.option="option"})(r||(e.NotebookEditorPriority=r={}));function u(O){const x=O;return!!((typeof x.include=="string"||T.$Hj(x.include))&&(typeof x.exclude=="string"||T.$Hj(x.exclude)))}e.$DI=u;function f(O,x,le){if(Array.isArray(O.viewType)&&O.viewType.indexOf(x)>=0||O.viewType===x)return!0;if(O.filenamePattern){const me=u(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,ye=u(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(T.$Fj(me,(0,$.$mc)(le.fsPath).toLowerCase()))return!(ye&&T.$Fj(ye,(0,$.$mc)(le.fsPath).toLowerCase()))}return!1}e.$EI=f,e.$FI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var v;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class g{static{this.d="notebook/"}static create(x){return`${g.d}${x}`}static parse(x){if(x.startsWith(g.d))return x.substring(g.d.length)}}e.$GI=g;function D(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$HI=D;const I=new TextDecoder;function h(O){const x=[];let le=!1;for(const de of O)(x.length===0||le)&&(x.push(de),le=!0);let me=F(x);const ye=E.$fe.concat(x.map(de=>E.$fe.wrap(de))),we=L(ye);return me=me||we.byteLength!==ye.byteLength,{data:we,didCompression:me}}e.$II=h,e.$JI=`${String.fromCharCode(27)}[A`;const w=e.$JI.split("").map(O=>O.charCodeAt(0)),k=10;function F(O){let x=!1;return O.forEach((le,me)=>{if(me===0||le.length<e.$JI.length)return;const ye=O[me-1],we=le.subarray(0,e.$JI.length);if(we[0]===w[0]&&we[1]===w[1]&&we[2]===w[2]){const de=ye.lastIndexOf(k);if(de===-1)return;x=!0,O[me-1]=ye.subarray(0,de),O[me]=le.subarray(e.$JI.length)}}),x}function W(O){let x=O;do O=x,x=O.replace(/[^\n]\x08/gm,"");while(x.length<O.length);return O}function Q(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const x=O.match(/^(.*)\r+/m)[1];let le=O.match(/\r+(.*)$/m)[1];le=le+x.slice(le.length,x.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,le)}return O}const N="\b".charCodeAt(0),A="\r".charCodeAt(0);function L(O){return!O.buffer.includes(N)&&!O.buffer.includes(A)?O:E.$fe.fromString(Q(W(I.decode(O.buffer))))}}),define(Pe[7],Re([1,0,18,11,52,28,68,12,16,2,33,22,42,99,76]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b){"use strict";var a,s,t,n,o,c,d,i,r,u,f,v,g,D,I,h,w,k;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$tM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.TestRunProfileKind=e.TestResultState=e.$_L=e.$$L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$0L=e.NotebookVariablesRequestKind=e.$9L=e.$8L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$7L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.ColorThemeKind=e.$1L=e.$ZL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$YL=e.DebugConsoleMode=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$SL=e.$RL=e.FileChangeType=e.$QL=e.$PL=e.$OL=e.$NL=e.InlineCompletionTriggerKind=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.ConfigurationTarget=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$qL=e.ViewBadge=e.ProgressLocation=e.$pL=e.$oL=e.TaskScope=e.ShellQuoting=e.$nL=e.$mL=e.$lL=e.TaskPanelKind=e.TaskRevealKind=e.$kL=e.TerminalLocation=e.$jL=e.$iL=e.$hL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$gL=e.$fL=e.$eL=e.$dL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$cL=e.StatusBarAlignment=e.ViewColumn=e.$bL=e.$aL=e.$_K=e.$$K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$0K=e.$9K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.LanguageStatusSeverity=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.CodeActionTriggerKind=e.$WK=e.$VK=e.SymbolTag=e.SymbolKind=e.$UK=e.DocumentHighlightKind=e.$TK=e.$SK=e.$RK=e.$QK=e.DiagnosticSeverity=e.DiagnosticTag=e.$PK=e.$OK=e.FileEditType=e.$NK=e.$MK=e.$LK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(U){return Object.assign(U,{apply:function(...ae){if(ae.length===0)return Reflect.construct(U,[]);{const ke=ae.length===1?[]:ae[1];return Reflect.construct(U,ke,ae[0].constructor)}},call:function(...ae){if(ae.length===0)return Reflect.construct(U,[]);{const[ke,...Ge]=ae;return Reflect.construct(U,Ge,ke.constructor)}}})}var W;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var Q;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(Q||(e.TerminalQuickFixType=Q={}));let N=a=class{static from(...j){let ae=j;return new a(function(){if(ae){for(const ke of ae)ke&&typeof ke.dispose=="function"&&ke.dispose();ae=void 0}})}#e;constructor(j){this.#e=j}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$EK=N,e.$EK=N=a=Ke([F],N);let A=s=class{static Min(...j){if(j.length===0)throw new TypeError;let ae=j[0];for(let ke=1;ke<j.length;ke++){const Ge=j[ke];Ge.isBefore(ae)&&(ae=Ge)}return ae}static Max(...j){if(j.length===0)throw new TypeError;let ae=j[0];for(let ke=1;ke<j.length;ke++){const Ge=j[ke];Ge.isAfter(ae)&&(ae=Ge)}return ae}static isPosition(j){if(!j)return!1;if(j instanceof s)return!0;const{line:ae,character:ke}=j;return typeof ae=="number"&&typeof ke=="number"}static of(j){if(j instanceof s)return j;if(this.isPosition(j))return new s(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,ae){if(j<0)throw(0,T.$6)("line must be non-negative");if(ae<0)throw(0,T.$6)("character must be non-negative");this.c=j,this.e=ae}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,ae=0){if(j===null||ae===null)throw(0,T.$6)();let ke;return typeof j>"u"?ke=0:typeof j=="number"?ke=j:(ke=typeof j.lineDelta=="number"?j.lineDelta:0,ae=typeof j.characterDelta=="number"?j.characterDelta:0),ke===0&&ae===0?this:new s(this.line+ke,this.character+ae)}with(j,ae=this.character){if(j===null||ae===null)throw(0,T.$6)();let ke;return typeof j>"u"?ke=this.line:typeof j=="number"?ke=j:(ke=typeof j.line=="number"?j.line:this.line,ae=typeof j.character=="number"?j.character:this.character),ke===this.line&&ae===this.character?this:new s(ke,ae)}toJSON(){return{line:this.line,character:this.character}}};e.$FK=A,e.$FK=A=s=Ke([F],A);let L=t=class{static isRange(j){return j instanceof t?!0:j?A.isPosition(j.start)&&A.isPosition(j.end):!1}static of(j){if(j instanceof t)return j;if(this.isRange(j))return new t(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,ae,ke,Ge){let xe,at;if(typeof j=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Ge=="number"?(xe=new A(j,ae),at=new A(ke,Ge)):A.isPosition(j)&&A.isPosition(ae)&&(xe=A.of(j),at=A.of(ae)),!xe||!at)throw new Error("Invalid arguments");xe.isBefore(at)?(this.c=xe,this.e=at):(this.c=at,this.e=xe)}contains(j){return t.isRange(j)?this.contains(j.start)&&this.contains(j.end):A.isPosition(j)?!(A.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const ae=A.Max(j.start,this.c),ke=A.Min(j.end,this.e);if(!ae.isAfter(ke))return new t(ae,ke)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const ae=A.Min(j.start,this.c),ke=A.Max(j.end,this.end);return new t(ae,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,ae=this.end){if(j===null||ae===null)throw(0,T.$6)();let ke;return j?A.isPosition(j)?ke=j:(ke=j.start||this.start,ae=j.end||this.end):ke=this.start,ke.isEqual(this.c)&&ae.isEqual(this.end)?this:new t(ke,ae)}toJSON(){return[this.start,this.end]}};e.$GK=L,e.$GK=L=t=Ke([F],L);let O=n=class extends L{static isSelection(j){return j instanceof n?!0:j?L.isRange(j)&&A.isPosition(j.anchor)&&A.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,ae,ke,Ge){let xe,at;if(typeof j=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Ge=="number"?(xe=new A(j,ae),at=new A(ke,Ge)):A.isPosition(j)&&A.isPosition(ae)&&(xe=A.of(j),at=A.of(ae)),!xe||!at)throw new Error("Invalid arguments");super(xe,at),this.f=xe,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$HK=O,e.$HK=O=n=Ke([F],O);const x=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,T.$6)("connectionToken")};class le{static isResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.host=="string"&&typeof j.port=="number"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,ae,ke){if(typeof j!="string"||j.length===0)throw(0,T.$6)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,T.$6)("port");typeof ke<"u"&&x(ke),this.host=j,this.port=Math.round(ae),this.connectionToken=ke}}e.$IK=le;class me{static isManagedResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.makeConnection=="function"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,ae){this.makeConnection=j,this.connectionToken=ae,typeof ae<"u"&&x(ae)}}e.$JK=me;class ye extends Error{static NotAvailable(j,ae){return new ye(j,p.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(j){return new ye(j,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,ae=p.RemoteAuthorityResolverErrorCode.Unknown,ke){super(j),this._message=j,this._code=ae,this._detail=ke,Object.setPrototypeOf(this,ye.prototype)}}e.$KK=ye;var we;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(we||(e.EndOfLine=we={}));var de;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(de||(e.EnvironmentVariableMutatorType=de={}));let be=o=class{static isTextEdit(j){return j instanceof o?!0:j?L.isRange(j)&&typeof j.newText=="string":!1}static replace(j,ae){return new o(j,ae)}static insert(j,ae){return o.replace(new L(j,j),ae)}static delete(j){return o.replace(j,"")}static setEndOfLine(j){const ae=new o(new L(new A(0,0),new A(0,0)),"");return ae.newEol=j,ae}get range(){return this.c}set range(j){if(j&&!L.isRange(j))throw(0,T.$6)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,T.$6)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,T.$6)("newEol");this.f=j}constructor(j,ae){this.c=j,this.e=ae}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$LK=be,e.$LK=be=o=Ke([F],be);let ie=c=class{static isNotebookCellEdit(j){return j instanceof c?!0:j?xt.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,ae){return new c(j,ae)}static insertCells(j,ae){return new c(new xt(j,j),ae)}static deleteCells(j){return new c(j,[])}static updateCellMetadata(j,ae){const ke=new c(new xt(j,j),[]);return ke.newCellMetadata=ae,ke}static updateNotebookMetadata(j){const ae=new c(new xt(0,0),[]);return ae.newNotebookMetadata=j,ae}constructor(j,ae){this.range=j,this.newCells=ae}};e.$MK=ie,e.$MK=ie=c=Ke([F],ie);class Ie{static isSnippetTextEdit(j){return j instanceof Ie?!0:j?L.isRange(j.range)&&B.isSnippetString(j.snippet):!1}static replace(j,ae){return new Ie(j,ae)}static insert(j,ae){return Ie.replace(new L(j,j),ae)}constructor(j,ae){this.range=j,this.snippet=ae}}e.$NK=Ie;var ce;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(ce||(e.FileEditType=ce={}));let Y=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,ae,ke,Ge){this.c.push({_type:1,from:j,to:ae,options:ke,metadata:Ge})}createFile(j,ae,ke){this.c.push({_type:1,from:void 0,to:j,options:ae,metadata:ke})}deleteFile(j,ae,ke){this.c.push({_type:1,from:j,to:void 0,options:ae,metadata:ke})}e(j,ae,ke){this.c.push({_type:3,metadata:ke,uri:j,edit:{editType:5,metadata:ae},notebookMetadata:ae})}f(j,ae,ke,Ge){const xe=ae.start,at=ae.end;(xe!==at||ke.length>0)&&this.c.push({_type:5,uri:j,index:xe,count:at-xe,cells:ke,metadata:Ge})}g(j,ae,ke,Ge){this.c.push({_type:3,metadata:Ge,uri:j,edit:{editType:3,index:ae,metadata:ke}})}replace(j,ae,ke,Ge){this.c.push({_type:2,uri:j,edit:new be(ae,ke),metadata:Ge})}insert(j,ae,ke,Ge){this.replace(j,new L(ae,ae),ke,Ge)}delete(j,ae,ke){this.replace(j,ae,"",ke)}has(j){return this.c.some(ae=>ae._type===2&&ae.uri.toString()===j.toString())}set(j,ae){if(ae)for(const ke of ae){if(!ke)continue;let Ge,xe;Array.isArray(ke)?(Ge=ke[0],xe=ke[1]):Ge=ke,ie.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(j,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(j,Ge.newNotebookMetadata,xe):this.f(j,Ge.range,Ge.newCells,xe):Ie.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:j,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:j,edit:Ge,metadata:xe})}else{for(let ke=0;ke<this.c.length;ke++){const Ge=this.c[ke];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===j.toString()&&(this.c[ke]=void 0);break}}(0,E.$Hb)(this.c)}}get(j){const ae=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===j.toString()&&ae.push(ke.edit);return ae}entries(){const j=new M.$zc;for(const ae of this.c)if(ae._type===2){let ke=j.get(ae.uri);ke||(ke=[ae.uri,[]],j.set(ae.uri,ke)),ke[1].push(ae.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$OK=Y,e.$OK=Y=Ke([F],Y);let B=d=class{static isSnippetString(j){return j instanceof d?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=d.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,ae=this.e++){if(typeof j=="function"){const ke=new d;ke.e=this.e,j(ke),this.e=ke.e,j=ke.value}else j=d.c(j);return this.value+="${",this.value+=ae,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,ae=this.e++){const ke=j.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(j,ae){if(typeof ae=="function"){const ke=new d;ke.e=this.e,ae(ke),this.e=ke.e,ae=ke.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};e.$PK=B,e.$PK=B=d=Ke([F],B);var se;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(se||(e.DiagnosticTag=se={}));var Se;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(Se||(e.DiagnosticSeverity=Se={}));let Ae=i=class{static isLocation(j){return j instanceof i?!0:j?L.isRange(j.range)&&y.URI.isUri(j.uri):!1}constructor(j,ae){if(this.uri=j,ae)if(L.isRange(ae))this.range=L.of(ae);else if(A.isPosition(ae))this.range=new L(ae,ae);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$QK=Ae,e.$QK=Ae=i=Ke([F],Ae);let Ce=class{static is(j){return j?typeof j.message=="string"&&j.location&&L.isRange(j.location.range)&&y.URI.isUri(j.location.uri):!1}constructor(j,ae){this.location=j,this.message=ae}static isEqual(j,ae){return j===ae?!0:!j||!ae?!1:j.message===ae.message&&j.location.range.isEqual(ae.location.range)&&j.location.uri.toString()===ae.location.uri.toString()}};e.$RK=Ce,e.$RK=Ce=Ke([F],Ce);let fe=class{constructor(j,ae,ke=Se.Error){if(!L.isRange(j))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=j,this.message=ae,this.severity=ke}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,ae){return j===ae?!0:!j||!ae?!1:j.message===ae.message&&j.severity===ae.severity&&j.code===ae.code&&j.severity===ae.severity&&j.source===ae.source&&j.range.isEqual(ae.range)&&(0,E.$tb)(j.tags,ae.tags)&&(0,E.$tb)(j.relatedInformation,ae.relatedInformation,Ce.isEqual)}};e.$SK=fe,e.$SK=fe=Ke([F],fe);let ne=class{constructor(j,ae){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=ae}};e.$TK=ne,e.$TK=ne=Ke([F],ne);var H;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(H||(e.DocumentHighlightKind=H={}));let te=class{constructor(j,ae=H.Text){this.range=j,this.kind=ae}toJSON(){return{range:this.range,kind:H[this.kind]}}};e.$UK=te,e.$UK=te=Ke([F],te);var X;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(X||(e.SymbolKind=X={}));var re;(function(U){U[U.Deprecated=1]="Deprecated"})(re||(e.SymbolTag=re={}));let he=r=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,ae,ke,Ge,xe){this.name=j,this.kind=ae,this.containerName=xe,typeof ke=="string"&&(this.containerName=ke),Ge instanceof Ae?this.location=Ge:ke instanceof L&&(this.location=new Ae(Ge,ke)),r.validate(this)}toJSON(){return{name:this.name,kind:X[this.kind],location:this.location,containerName:this.containerName}}};e.$VK=he,e.$VK=he=r=Ke([F],he);let De=u=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(u.validate)}constructor(j,ae,ke,Ge,xe){this.name=j,this.detail=ae,this.kind=ke,this.range=Ge,this.selectionRange=xe,this.children=[],u.validate(this)}};e.$WK=De,e.$WK=De=u=Ke([F],De);var z;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(z||(e.CodeActionTriggerKind=z={}));let V=class{constructor(j,ae){this.title=j,this.kind=ae}};e.$XK=V,e.$XK=V=Ke([F],V);let G=class{static{f=this}static{this.c="."}constructor(j){this.value=j}append(j){return new f(this.value?this.value+f.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+f.c)}};e.$YK=G,e.$YK=G=f=Ke([F],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let J=class{constructor(j,ae){if(this.range=j,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$ZK=J,e.$ZK=J=Ke([F],J);class q{constructor(j,ae,ke,Ge,xe,at){this.kind=j,this.name=ae,this.detail=ke,this.uri=Ge,this.range=xe,this.selectionRange=at}}e.$1K=q;class ee{constructor(j,ae){this.fromRanges=ae,this.from=j}}e.$2K=ee;class ue{constructor(j,ae){this.fromRanges=ae,this.to=j}}e.$3K=ue;var Ne;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let je=class{constructor(j,ae){this.range=j,this.command=ae}get isResolved(){return!!this.command}};e.$4K=je,e.$4K=je=Ke([F],je);let Ye=v=class{#e;static isMarkdownString(j){return j instanceof v?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,ae=!1){this.#e=new C.$ak(j,{supportThemeIcons:ae})}get value(){return this.#e.value}set value(j){this.#e.value=j}get isTrusted(){return this.#e.isTrusted}set isTrusted(j){this.#e.isTrusted=j}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(j){this.#e.supportThemeIcons=j}get supportHtml(){return this.#e.supportHtml}set supportHtml(j){this.#e.supportHtml=j}get baseUri(){return this.#e.baseUri}set baseUri(j){this.#e.baseUri=j}appendText(j){return this.#e.appendText(j),this}appendMarkdown(j){return this.#e.appendMarkdown(j),this}appendCodeblock(j,ae){return this.#e.appendCodeblock(ae??"",j),this}};e.$5K=Ye,e.$5K=Ye=v=Ke([F],Ye);let Je=class{constructor(j,ae){this.label=j,this.documentation=ae}};e.$6K=Je,e.$6K=Je=Ke([F],Je);let it=class{constructor(j,ae){this.label=j,this.documentation=ae,this.parameters=[]}};e.$7K=it,e.$7K=it=Ke([F],it);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$8K=_e,e.$8K=_e=Ke([F],_e);var tt;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var rt;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let nt=class{constructor(j){this.value=j}};e.$9K=nt,e.$9K=nt=Ke([F],nt);let ze=class{constructor(j,ae,ke){this.position=j,this.label=ae,this.kind=ke}};e.$0K=ze,e.$0K=ze=Ke([F],ze);var ht;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ht||(e.CompletionTriggerKind=ht={}));var _;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(_||(e.CompletionItemKind=_={}));var Z;(function(U){U[U.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let ve=class{constructor(j,ae){this.label=j,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&_[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$$K=ve,e.$$K=ve=Ke([F],ve);let Be=class{constructor(j=[],ae=!1){this.items=j,this.isIncomplete=ae}};e.$_K=Be,e.$_K=Be=Ke([F],Be);let He=class{constructor(j,ae,ke){this.insertText=j,this.range=ae,this.command=ke}};e.$aL=He,e.$aL=He=Ke([F],He);let Xe=class{constructor(j){this.commands=void 0,this.suppressSuggestions=void 0,this.items=j}};e.$bL=Xe,e.$bL=Xe=Ke([F],Xe);var st;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var pt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(pt||(e.StatusBarAlignment=pt={}));function Te(U,j){return`${S.$dm.toKey(U)}.${j}`}e.$cL=Te;var Rt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Rt||(e.TextEditorLineNumbersStyle=Rt={}));var Kt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var wt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(wt||(e.TextEditorSelectionChangeKind=wt={}));var Ut;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Ot;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(U){function j(ae){switch(ae){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=j}(wt||(e.TextEditorSelectionChangeKind=wt={}));var Gt;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(U){function j(ae){switch(ae){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=j}(Gt||(e.SyntaxTokenType=Gt={}));let Bt=class{constructor(j,ae){if(ae&&!y.URI.isUri(ae))throw(0,T.$6)("target");if(!L.isRange(j)||j.isEmpty)throw(0,T.$6)("range");this.range=j,this.target=ae}};e.$dL=Bt,e.$dL=Bt=Ke([F],Bt);let kt=class{constructor(j,ae,ke,Ge){this.red=j,this.green=ae,this.blue=ke,this.alpha=Ge}};e.$eL=kt,e.$eL=kt=Ke([F],kt);let Tt=class{constructor(j,ae){if(ae&&!(ae instanceof kt))throw(0,T.$6)("color");if(!L.isRange(j)||j.isEmpty)throw(0,T.$6)("range");this.range=j,this.color=ae}};e.$fL=Tt,e.$fL=Tt=Ke([F],Tt);let Ze=class{constructor(j){if(!j||typeof j!="string")throw(0,T.$6)("label");this.label=j}};e.$gL=Ze,e.$gL=Ze=Ke([F],Ze);var Jt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Wt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var ct;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(ct||(e.TerminalExitReason=ct={}));class ft{constructor(j,ae,ke){if(this.startIndex=j,this.length=ae,this.tooltip=ke,typeof j!="number"||j<0)throw(0,T.$6)("startIndex");if(typeof ae!="number"||ae<1)throw(0,T.$6)("length");if(ke!==void 0&&typeof ke!="string")throw(0,T.$6)("tooltip")}}e.$hL=ft;class Vt{constructor(j){this.uri=j}}e.$iL=Vt;class At{constructor(j){this.terminalCommand=j}}e.$jL=At;var Dt;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Dt||(e.TerminalLocation=Dt={}));class gt{constructor(j){if(this.options=j,typeof j!="object")throw(0,T.$6)("options")}}e.$kL=gt;var Mt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(Mt||(e.TaskRevealKind=Mt={}));var Pt;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(Pt||(e.TaskPanelKind=Pt={}));let St=class{static{g=this}static{this.Clean=new g("clean","Clean")}static{this.Build=new g("build","Build")}static{this.Rebuild=new g("rebuild","Rebuild")}static{this.Test=new g("test","Test")}static from(j){switch(j){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}constructor(j,ae){if(this.label=ae,typeof j!="string"||typeof ae!="string")throw(0,T.$6)("name");this.c=j}get id(){return this.c}};e.$lL=St,e.$lL=St=g=Ke([F],St);function Ve(U){let j="";for(let ae=0;ae<U.length;ae++)j+=U[ae].replace(/,/g,",,")+",";return j}let Nt=class{constructor(j,ae,ke){if(typeof j!="string")throw(0,T.$6)("process");this.e=[],this.c=j,ae!==void 0&&(Array.isArray(ae)?(this.e=ae,this.f=ke):this.f=ae)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,T.$6)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const ae of this.e)j.push(ae);return Ve(j)}};e.$mL=Nt,e.$mL=Nt=Ke([F],Nt);let zt=class{constructor(j,ae,ke){if(this.f=[],Array.isArray(ae)){if(!j)throw(0,T.$6)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,T.$6)("command");this.e=j,this.f=ae,this.g=ke}else{if(typeof j!="string")throw(0,T.$6)("commandLine");this.c=j,this.g=ae}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,T.$6)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,T.$6)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ae of this.f)j.push(typeof ae=="string"?ae:ae.value);return Ve(j)}};e.$nL=zt,e.$nL=zt=Ke([F],zt);var Qt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var Ee;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Ee||(e.TaskScope=Ee={}));class Me{constructor(j){this.c=j}computeId(){return"customExecution"+(0,R.$kg)()}set callback(j){this.c=j}get callback(){return this.c}}e.$oL=Me;let $e=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(j,ae,ke,Ge,xe,at){this.j=!1,this.k=this.definition=j;let dt;typeof ae=="string"?(this.m=this.name=ae,this.t=this.source=ke,this.execution=Ge,dt=xe,this.j=!0):ae===Ee.Global||ae===Ee.Workspace?(this.target=ae,this.m=this.name=ke,this.t=this.source=Ge,this.execution=xe,dt=at):(this.target=ae,this.m=this.name=ke,this.t=this.source=Ge,this.execution=xe,dt=at),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(j){this.h=j}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Nt?this.k={type:D.e,id:this.n.computeId()}:this.n instanceof zt?this.k={type:D.f,id:this.n.computeId()}:this.n instanceof Me?this.k={type:D.c,id:this.n.computeId()}:this.k={type:D.g,id:(0,R.$kg)()}}get definition(){return this.k}set definition(j){if(j==null)throw(0,T.$6)("Kind can't be undefined or null");this.z(),this.k=j}get scope(){return this.l}set target(j){this.z(),this.l=j}get name(){return this.m}set name(j){if(typeof j!="string")throw(0,T.$6)("name");this.z(),this.m=j}get execution(){return this.n}set execution(j){j===null&&(j=void 0),this.z(),this.n=j;const ae=this.k.type;(D.g===ae||D.e===ae||D.f===ae||D.c===ae)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(j){if(Array.isArray(j))this.z(),this.o=j,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.z(),this.r=j}get source(){return this.t}set source(j){if(typeof j!="string"||j.length===0)throw(0,T.$6)("source must be a string of length > 0");this.z(),this.t=j}get group(){return this.u}set group(j){j===null&&(j=void 0),this.z(),this.u=j}get detail(){return this.y}set detail(j){j===null&&(j=void 0),this.y=j}get presentationOptions(){return this.w}set presentationOptions(j){j==null&&(j=Object.create(null)),this.z(),this.w=j}get runOptions(){return this.x}set runOptions(j){j==null&&(j=Object.create(null)),this.z(),this.x=j}};e.$pL=$e,e.$pL=$e=D=Ke([F],$e);var K;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(K||(e.ProgressLocation=K={}));var Le;(function(U){function j(ae){const ke=ae;return(0,m.$Gf)(ke.value)?ke.tooltip&&!(0,m.$Cf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}U.isViewBadge=j})(Le||(e.ViewBadge=Le={}));let Ue=I=class{static isTreeItem(j,ae){const ke=j;if(ke.checkboxState!==void 0){const Ge=(0,m.$Gf)(ke.checkboxState)?ke.checkboxState:(0,m.$Ef)(ke.checkboxState)&&(0,m.$Gf)(ke.checkboxState.state)?ke.checkboxState.state:void 0,xe=!(0,m.$Gf)(ke.checkboxState)&&(0,m.$Ef)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==qe.Checked&&Ge!==qe.Unchecked||xe!==void 0&&!(0,m.$Cf)(xe))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(j instanceof I)return!0;if(ke.label!==void 0&&!(0,m.$Cf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,m.$Cf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,m.$Cf)(ke.iconPath)&&!y.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,m.$Cf)(ke.iconPath.id))){const Ge=ke.iconPath;if(!Ge||!(0,m.$Cf)(Ge.light)&&!y.URI.isUri(Ge.light)&&!(0,m.$Cf)(Ge.dark)&&!y.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,m.$Cf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!y.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,m.$Cf)(ke.tooltip)&&!(ke.tooltip instanceof Ye)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Qe.None&&ke.collapsibleState>Qe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,m.$Cf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(j,ae=Qe.None){this.collapsibleState=ae,y.URI.isUri(j)?this.resourceUri=j:this.label=j}};e.$qL=Ue,e.$qL=Ue=I=Ke([F],Ue);var Qe;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Qe||(e.TreeItemCollapsibleState=Qe={}));var qe;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(qe||(e.TreeItemCheckboxState=qe={}));let et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j){this.value=j}};e.$rL=et,e.$rL=et=Ke([F],et);class ut extends et{}e.$sL=ut;class vt extends ut{#e;constructor(j){super(""),this.#e=j}asFile(){return this.#e}}e.$tL=vt;class $t{constructor(j,ae,ke,Ge){this.name=j,this.uri=ae,this._itemId=ke,this.c=Ge}data(){return this.c()}}e.$uL=$t;let Et=class{#e=new Map;constructor(j){for(const[ae,ke]of j??[]){const Ge=this.#e.get(this.#t(ae));Ge?Ge.push(ke):this.#e.set(this.#t(ae),[ke])}}get(j){return this.#e.get(this.#t(j))?.[0]}set(j,ae){this.#e.set(this.#t(j),[ae])}forEach(j,ae){for(const[ke,Ge]of this.#e)for(const xe of Ge)j.call(ae,xe,ke,this)}*[Symbol.iterator](){for(const[j,ae]of this.#e)for(const ke of ae)yield[j,ke]}#t(j){return j.toLowerCase()}};e.$vL=Et,e.$vL=Et=Ke([F],Et);let yt=class{constructor(j){this.insertText=j}};e.$wL=yt,e.$wL=yt=Ke([F],yt);let Di=class{constructor(j,ae){this.label=ae,this.insertText=j}};e.$xL=Di,e.$xL=Di=Ke([F],Di);let qt=class{constructor(j,ae){this.id=j,this.color=ae}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};e.$yL=qt,e.$yL=qt=Ke([F],qt),qt.File=new qt("file"),qt.Folder=new qt("folder");let mi=class{constructor(j){this.id=j}};e.$zL=mi,e.$zL=mi=Ke([F],mi);var Ct;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Ct||(e.ConfigurationTarget=Ct={}));let ki=class{get base(){return this.c}set base(j){this.c=j,this.e=y.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,ae){if(typeof j!="string"&&(!j||!y.URI.isUri(j)&&!y.URI.isUri(j.uri)))throw(0,T.$6)("base");if(typeof ae!="string")throw(0,T.$6)("pattern");typeof j=="string"?this.baseUri=y.URI.file(j):y.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=ae}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$AL=ki,e.$AL=ki=Ke([F],ki);const Ki=new WeakMap;function It(U,j){Ki.set(U,j)}e.$BL=It;let ii=class{constructor(j,ae,ke,Ge){this.enabled=typeof j=="boolean"?j:!0,typeof ae=="string"&&(this.condition=ae),typeof ke=="string"&&(this.hitCondition=ke),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Ki.get(this)??(0,R.$kg)()),this.c}};e.$CL=ii,e.$CL=ii=Ke([F],ii);let $i=class extends ii{constructor(j,ae,ke,Ge,xe){if(super(ae,ke,Ge,xe),j===null)throw(0,T.$6)("location");this.location=j}};e.$DL=$i,e.$DL=$i=Ke([F],$i);let oi=class extends ii{constructor(j,ae,ke,Ge,xe){super(ae,ke,Ge,xe),this.functionName=j}};e.$EL=oi,e.$EL=oi=Ke([F],oi);let Si=class extends ii{constructor(j,ae,ke,Ge,xe,at,dt){if(super(Ge,xe,at,dt),!ae)throw(0,T.$6)("dataId");this.label=j,this.dataId=ae,this.canPersist=ke}};e.$FL=Si,e.$FL=Si=Ke([F],Si);let Ii=class{constructor(j,ae,ke){this.command=j,this.args=ae||[],this.options=ke}};e.$GL=Ii,e.$GL=Ii=Ke([F],Ii);let Lt=class{constructor(j,ae){this.port=j,this.host=ae}};e.$HL=Lt,e.$HL=Lt=Ke([F],Lt);let pi=class{constructor(j){this.path=j}};e.$IL=pi,e.$IL=pi=Ke([F],pi);let Ci=class{constructor(j){this.implementation=j}};e.$JL=Ci,e.$JL=Ci=Ke([F],Ci);let ai=class{constructor(j,ae,ke){this.session=j,this.threadId=ae,this.frameId=ke}};e.$KL=ai,e.$KL=ai=Ke([F],ai);let ci=class{constructor(j,ae){this.session=j,this.threadId=ae}};e.$LL=ci,e.$LL=ci=Ke([F],ci);let lt=class{constructor(j,ae){this.range=j,this.expression=ae}};e.$ML=lt,e.$ML=lt=Ke([F],lt);var Hi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Hi||(e.InlineCompletionTriggerKind=Hi={}));let Xt=class{constructor(j,ae){this.range=j,this.text=ae}};e.$NL=Xt,e.$NL=Xt=Ke([F],Xt);let ni=class{constructor(j,ae,ke=!0){this.range=j,this.variableName=ae,this.caseSensitiveLookup=ke}};e.$OL=ni,e.$OL=ni=Ke([F],ni);let di=class{constructor(j,ae){this.range=j,this.expression=ae}};e.$PL=di,e.$PL=di=Ke([F],di);let Pi=class{constructor(j,ae){this.frameId=j,this.stoppedLocation=ae}};e.$QL=Pi,e.$QL=Pi=Ke([F],Pi);var Gi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Gi||(e.FileChangeType=Gi={}));let Ri=h=class extends Error{static FileExists(j){return new h(j,l.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(j){return new h(j,l.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(j){return new h(j,l.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(j){return new h(j,l.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(j){return new h(j,l.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(j){return new h(j,l.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(j,ae=l.FileSystemProviderErrorCode.Unknown,ke){super(y.URI.isUri(j)?j.toString(!0):j),this.code=ke?.name??"Unknown",(0,l.$xk)(this,ae),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$RL=Ri,e.$RL=Ri=h=Ke([F],Ri);let vi=class{constructor(j,ae,ke){this.start=j,this.end=ae,this.kind=ke}};e.$SL=vi,e.$SL=vi=Ke([F],vi);var Ji;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Ji||(e.FoldingRangeKind=Ji={}));var Ai;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ui;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(ui||(e.CommentMode=ui={}));var Qi;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Qi||(e.CommentState=Qi={}));var bi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));class Mi{constructor(j,ae=[]){this.tokenTypes=j,this.tokenModifiers=ae}}e.$TL=Mi;function ln(U){return typeof U>"u"||(0,m.$Df)(U)}class Li{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,j){this.l=!0;for(let ae=0,ke=j.tokenTypes.length;ae<ke;ae++)this.j.set(j.tokenTypes[ae],ae);for(let ae=0,ke=j.tokenModifiers.length;ae<ke;ae++)this.k.set(j.tokenModifiers[ae],ae)}}push(j,ae,ke,Ge,xe){if(typeof j=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.n(j,ae,ke,Ge,xe);if(L.isRange(j)&&typeof ae=="string"&&ln(ke))return this.m(j,ae,ke);throw(0,T.$6)()}m(j,ae,ke){if(!this.l)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ae))throw new Error("`tokenType` is not in the provided legend");const Ge=j.start.line,xe=j.start.character,at=j.end.character-j.start.character,dt=this.j.get(ae);let jt=0;if(ke)for(const Yt of ke){if(!this.k.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Yt);jt|=1<<ei>>>0}this.n(Ge,xe,at,dt,jt)}n(j,ae,ke,Ge,xe){if(this.f&&(j<this.c||j===this.c&&ae<this.e)){this.f=!1;const jt=this.g.length/5|0;let Yt=0,ei=0;for(let ti=0;ti<jt;ti++){let si=this.g[5*ti],Vi=this.g[5*ti+1];si===0?(si=Yt,Vi+=ei):si+=Yt,this.g[5*ti]=si,this.g[5*ti+1]=Vi,Yt=si,ei=Vi}}let at=j,dt=ae;this.f&&this.h>0&&(at-=this.c,at===0&&(dt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=dt,this.g[this.h++]=ke,this.g[this.h++]=Ge,this.g[this.h++]=xe,this.c=j,this.e=ae}static o(j){const ae=[],ke=j.length/5|0;for(let dt=0;dt<ke;dt++)ae[dt]=dt;ae.sort((dt,jt)=>{const Yt=j[5*dt],ei=j[5*jt];if(Yt===ei){const ti=j[5*dt+1],si=j[5*jt+1];return ti-si}return Yt-ei});const Ge=new Uint32Array(j.length);let xe=0,at=0;for(let dt=0;dt<ke;dt++){const jt=5*ae[dt],Yt=j[jt+0],ei=j[jt+1],ti=j[jt+2],si=j[jt+3],Vi=j[jt+4],kn=Yt-xe,On=kn===0?ei-at:ei,qi=5*dt;Ge[qi+0]=kn,Ge[qi+1]=On,Ge[qi+2]=ti,Ge[qi+3]=si,Ge[qi+4]=Vi,xe=Yt,at=ei}return Ge}build(j){return this.f?new ri(new Uint32Array(this.g),j):new ri(Li.o(this.g),j)}}e.$UL=Li;class ri{constructor(j,ae){this.resultId=ae,this.data=j}}e.$VL=ri;class hn{constructor(j,ae,ke){this.start=j,this.deleteCount=ae,this.data=ke}}e.$WL=hn;class dn{constructor(j,ae){this.resultId=ae,this.edits=j}}e.$XL=dn;var Zi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let fi=class{static{this.Back={iconPath:new qt("arrow-left")}}constructor(){}};e.$YL=fi,e.$YL=fi=Ke([F],fi);var Yi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var Xi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var gi;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class xi{static validate(j){if(typeof j.badge=="string"){let ae=(0,$.$df)(j.badge,0);if(ae<j.badge.length&&(ae+=(0,$.$df)(j.badge,ae)),j.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!qt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,ae,ke){this.badge=j,this.tooltip=ae,this.color=ke}}e.$ZL=xi;let Fi=class{constructor(j){this.kind=j}};e.$1L=Fi,e.$1L=Fi=Ke([F],Fi);var Ti;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(Ti||(e.ColorThemeKind=Ti={}));class xt{static isNotebookRange(j){return j instanceof xt?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,ae){if(j<0)throw(0,T.$6)("start must be positive");if(ae<0)throw(0,T.$6)("end must be positive");j<=ae?(this.c=j,this.e=ae):(this.c=ae,this.e=j)}with(j){let ae=this.c,ke=this.e;return j.start!==void 0&&(ae=j.start),j.end!==void 0&&(ke=j.end),ae===this.c&&ke===this.e?this:new xt(ae,ke)}}e.$2L=xt;class wi{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(ae=>wi.isNotebookCellData(ae))}static isNotebookCellData(j){return!0}constructor(j,ae,ke,Ge,xe,at,dt){this.kind=j,this.value=ae,this.languageId=ke,this.mime=Ge,this.outputs=xe??[],this.metadata=at,this.executionSummary=dt,wi.validate(this)}}e.$3L=wi;class fn{constructor(j){this.cells=j}}e.$4L=fn;class Zt{static isNotebookCellOutputItem(j){return j instanceof Zt?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const ae={name:j.name,message:j.message,stack:j.stack};return Zt.json(ae,"application/vnd.code.notebook.error")}static stdout(j){return Zt.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return Zt.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,ae="application/octet-stream"){return new Zt(j,ae)}static#e=new TextEncoder;static text(j,ae=P.$Zr.text){const ke=Zt.#e.encode(String(j));return new Zt(ke,ae)}static json(j,ae="text/x-json"){const ke=JSON.stringify(j,void 0,"	");return Zt.text(ke,ae)}constructor(j,ae){this.data=j,this.mime=ae;const ke=(0,P.$4r)(ae,!0);if(!ke)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$5L=Zt;class yi{static isNotebookCellOutput(j){return j instanceof yi?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,ae=!1){const ke=new Set,Ge=new Set;for(let xe=0;xe<j.length;xe++){const at=j[xe],dt=(0,P.$4r)(at.mime);if(!ke.has(dt)||(0,b.$HI)(dt)){ke.add(dt);continue}Ge.add(xe),ae&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?j:j.filter((xe,at)=>!Ge.has(at))}constructor(j,ae,ke){this.items=yi.ensureUniqueMimeTypes(j,!0),typeof ae=="string"?(this.id=ae,this.metadata=ke):(this.id=(0,R.$kg)(),this.metadata=ae??ke)}}e.$6L=yi;var Ei;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Ei||(e.NotebookCellKind=Ei={}));var Oi;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Oe;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Oe||(e.NotebookCellStatusBarAlignment=Oe={}));var _t;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(_t||(e.NotebookEditorRevealType=_t={}));class _i{constructor(j,ae){this.text=j,this.alignment=ae}}e.$7L=_i;var mt;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(mt||(e.NotebookControllerAffinity=mt={}));var en;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(en||(e.NotebookControllerAffinity2=en={}));class gn{constructor(j,ae=[]){this.uri=j,this.provides=(0,E.$2b)(ae)}}e.$8L=gn;class tn{constructor(j){this.label=j}}e.$9L=tn;var nn;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let li=class{constructor(j,ae){this.label=j,this.timestamp=ae}};e.$0L=li,e.$0L=li=Ke([F],li);var rn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class an{constructor(j,ae){this.ranges=j,this.wordPattern=ae}}e.$$L=an;class mn{constructor(j){this.c=j}get autoForwardAction(){return this.c}}e.$_L=mn;var cn;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Ni=class{constructor(j=void 0,ae=void 0,ke=void 0,Ge=!1){this.include=j,this.exclude=ae,this.profile=ke,this.continuous=Ge}};e.$aM=Ni,e.$aM=Ni=Ke([F],Ni);let zi=w=class{static diff(j,ae,ke){const Ge=new w(j);return Ge.expectedOutput=ae,Ge.actualOutput=ke,Ge}constructor(j){this.message=j}};e.$bM=zi,e.$bM=zi=w=Ke([F],zi);let ji=class{constructor(j){this.id=j}};e.$cM=ji,e.$cM=ji=Ke([F],ji);let hi=class{constructor(j,ae){this.covered=j,this.total=ae}};e.$dM=hi,e.$dM=hi=Ke([F],hi);let Ui=k=class{static fromDetails(j,ae){const ke=new hi(0,0),Ge=new hi(0,0),xe=new hi(0,0);for(const dt of ae)if("branches"in dt){ke.total+=1,ke.covered+=dt.executionCount>0?1:0;for(const jt of dt.branches)Ge.total+=1,Ge.covered+=jt.executionCount>0?1:0}else xe.total+=1,xe.covered+=dt.executionCount>0?1:0;const at=new k(j,ke,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return at.detailedCoverage=ae,at}constructor(j,ae,ke,Ge){this.uri=j,this.statementCoverage=ae,this.branchCoverage=ke,this.functionCoverage=Ge}};e.$eM=Ui,e.$eM=Ui=k=Ke([F],Ui);let Bi=class{constructor(j,ae,ke=[]){this.executionCount=j,this.location=ae,this.branches=ke}};e.$fM=Bi,e.$fM=Bi=Ke([F],Bi);let Wi=class{constructor(j,ae){this.executionCount=j,this.location=ae}};e.$gM=Wi,e.$gM=Wi=Ke([F],Wi);let oe=class{constructor(j,ae){this.executionCount=j,this.location=ae}};e.$hM=oe,e.$hM=oe=Ke([F],oe);var ge;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(ge||(e.ExternalUriOpenerPriority=ge={}));var Fe;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Fe||(e.WorkspaceTrustState=Fe={}));var ot;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(ot||(e.PortAutoForwardAction=ot={}));class bt{constructor(j,ae,ke,Ge,xe,at){this.kind=j,this.name=ae,this.detail=ke,this.uri=Ge,this.range=xe,this.selectionRange=at}}e.$iM=bt;class Ft{constructor(j){this.uri=j}}e.$jM=Ft;class Sn{constructor(j,ae){this.original=j,this.modified=ae}}e.$kM=Sn;class In{constructor(j,ae,ke,Ge){this.base=j,this.input1=ae,this.input2=ke,this.result=Ge}}e.$lM=In;class Cn{constructor(j,ae){this.uri=j,this.viewType=ae}}e.$mM=Cn;class Pn{constructor(j){this.viewType=j}}e.$nM=Pn;class Rn{constructor(j,ae){this.uri=j,this.notebookType=ae}}e.$oM=Rn;class An{constructor(j,ae,ke){this.original=j,this.modified=ae,this.notebookType=ke}}e.$pM=An;class Mn{constructor(){}}e.$qM=Mn;class Ln{constructor(j,ae){this.uri=j,this.inputBoxUri=ae}}e.$rM=Ln;class Fn{constructor(j){this.providerId=j}}e.$sM=Fn;var $n;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})($n||(e.InteractiveSessionVoteDirection=$n={}));var pn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var vn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(vn||(e.InteractiveEditorResponseFeedbackKind=vn={}));var bn;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(bn||(e.ChatMessageRole=bn={}));var wn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Tn{constructor(j,ae){this.role=j,this.content=ae}}e.$tM=Tn;var yn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(yn||(e.ChatAgentResultFeedbackKind=yn={}));var En;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(En||(e.RelatedInformationType=En={}));var Dn;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}))}),define(Pe[102],Re([1,0,53,13,12,294,146,7,18]),function(pe,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.$HM=e.$GM=void 0;const y=new Map;function R(b,a){a?y.set(b,a):y.delete(b)}e.$GM=R;function S(b){return y.get(b)}class l extends M.$6u{constructor(a,s,t,n,o,c,d,i){super(s,t,n,o),this.c=a,this.m=c,this.q=d,this.notebook=i,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,m.$tb)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===T.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(s){return s?a.s(s):a.getText()},get eol(){return a.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(s){return a.t(s)},offsetAt(s){return a.u(s)},positionAt(s){return a.v(s)},validateRange(s){return a.w(s)},validatePosition(s){return a.x(s)},getWordRangeAtPosition(s,t){return a.y(s,t)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,E.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,E.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const s=this.w(a);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const t=this.g,n=s.start.line,o=s.end.line,c=[];c.push(this.f[n].substring(s.start.character));for(let d=n+1;d<o;d++)c.push(this.f[d]);return c.push(this.f[o].substring(0,s.end.character)),c.join(t)}t(a){let s;if(a instanceof $.$FK?s=a.line:typeof a=="number"&&(s=a),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new p(s,this.f[s],s===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const s=this.j.getIndexOf(a),t=this.f[s.index].length;return new $.$FK(s.index,Math.min(s.remainder,t))}w(a){if(!(a instanceof $.$GK))throw new Error("Invalid argument");const s=this.x(a.start),t=this.x(a.end);return s===a.start&&t===a.end?a:new $.$GK(s.line,s.character,t.line,t.character)}x(a){if(!(a instanceof $.$FK))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:s,character:t}=a,n=!1;if(s<0)s=0,t=0,n=!0;else if(s>=this.f.length)s=this.f.length-1,t=this.f[s].length,n=!0;else{const o=this.f[s].length;t<0?(t=0,n=!0):t>o&&(t=o,n=!0)}return n?new $.$FK(s,t):a}y(a,s){const t=this.x(a);if(!s)s=S(this.m);else if((0,C.$Se)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const n=(0,P.$fs)(t.character+1,(0,P.$ds)(s),this.f[t.line],0);if(n)return new $.$GK(t.line,n.startColumn-1,t.line,n.endColumn-1)}}e.$HM=l;class p{constructor(a,s,t){this.a=a,this.b=s,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$GK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$GK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$IM=p}),define(Pe[209],Re([1,0,7,17,5]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;let M=class{constructor($){this.a=new E.$1L(E.ColorThemeKind.Dark),this.b=new C.$Rd}get activeColorTheme(){return this.a}$onColorThemeChange($){let m;switch($){case"light":m=E.ColorThemeKind.Light;break;case"hcDark":m=E.ColorThemeKind.HighContrast;break;case"hcLight":m=E.ColorThemeKind.HighContrastLight;break;default:m=E.ColorThemeKind.Dark}this.a=new E.$1L(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$hgc=M,e.$hgc=M=Ke([We(0,T.$EM)],M)}),define(Pe[210],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LI=e.CellExecutionUpdateType=void 0;var T;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$LI=(0,E.$Zh)("INotebookExecutionService")}),define(Pe[211],Re([1,0,6,29,143,93]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oPb=void 0;class P extends E.$Rc{constructor(m,y,R){super(),this._source=m,this.b=y,this.c=R,this.a=void 0}f(m){const y=m.getLineCount();return new T.$Ds(1,1,y,this.g(m,y))}g(m,y){if(y<1||y>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const m=new C.$RB;m.acceptChunk(this._source);const y=m.finish(!0),{textBuffer:R,disposable:S}=y.create(1);this.b=R,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const y=new C.$RB;y.acceptChunk(m);const R=y.finish(!0),{textBuffer:S,disposable:l}=R.create(1);return this.B(l),S})),this.a}findInInputs(m){const R=new M.$FB(m,!1,!1,null).parseSearchRequest();if(!R)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,R,!0,5e3)}findInOutputs(m){const R=new M.$FB(m,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(S=>{const l=S.findMatchesLineByLine(this.f(S),R,!0,5e3);if(l.length!==0)return{textBuffer:S,matches:l}}).filter(S=>!!S):[]}}e.$oPb=P}),define(Pe[48],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(M){M.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var T;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class C{static fromExtHostTestItem(P,$,m=P.parent){if(P._isRoot)return new C([$]);const y=[P.id];for(let R=m;R&&R.id!==$;R=R.parent)y.push(R.id);return y.push($),new C(y.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const $=P.indexOf("\0");return $===-1?P:P.slice(0,$)}static fromString(P){return new C(P.split("\0"))}static join(P,$){return new C([...P.path,$])}static joinToString(P,$){return P.toString()+"\0"+$}static parentId(P){const $=P.lastIndexOf("\0");return $===-1?void 0:P.slice(0,$)}static localId(P){const $=P.lastIndexOf("\0");return $===-1?P:P.slice($+1)}static isChild(P,$){return $.startsWith(P)&&$[P.length]==="\0"}static compare(P,$){return P===$?0:C.isChild(P,$)?2:C.isChild($,P)?3:1}constructor(P,$=P.length){if(this.path=P,this.d=$,P.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let P=1;P<=this.d;P++)yield new C(this.path,P)}*idsToRoot(){for(let P=this.d;P>0;P--)yield new C(this.path,P)}compare(P){if(typeof P=="string")return C.compare(this.toString(),P);for(let $=0;$<P.d&&$<this.d;$++)if(P.path[$]!==this.path[$])return 1;return P.d>this.d?2:P.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let P=1;P<this.d;P++)this.c+="\0",this.c+=this.path[P]}return this.c}}e.$vJ=C}),define(Pe[58],Re([1,0,2,29,48]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$BJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$AJ=e.$zJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$yJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$xJ=e.$wJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var P;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(P||(e.ExtTestRunProfileKind=P={}));var $;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$wJ=[2,4,8,16,32,64];const m=I=>"runId"in I;e.$xJ=m;var y;(function(I){I.serialize=h=>({range:h.range.toJSON(),uri:h.uri.toJSON()}),I.deserialize=h=>({range:T.$Ds.lift(h.range),uri:E.URI.revive(h.uri)})})(y||(e.IRichLocation=y={}));var R;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(R||(e.TestMessageType=R={}));var S;(function(I){I.serialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&y.serialize(h.location)}),I.deserialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&y.deserialize(h.location)})})(S||(e.ITestErrorMessage=S={}));const l=(I,h)=>`${h?"s":"e"}${I}`;e.$yJ=l;var p;(function(I){I.serialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&y.serialize(h.location)}),I.deserialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&y.deserialize(h.location)})})(p||(e.ITestOutputMessage=p={}));var b;(function(I){I.serialize=h=>h.type===0?S.serialize(h):p.serialize(h),I.deserialize=h=>h.type===0?S.deserialize(h):p.deserialize(h)})(b||(e.ITestMessage=b={}));var a;(function(I){I.serializeWithoutMessages=h=>({state:h.state,duration:h.duration,messages:[]}),I.serialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(b.serialize)}),I.deserialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(b.deserialize)})})(a||(e.ITestTaskState=a={}));const s="\0",t=(I,h)=>I+s+h;e.$zJ=t;const n=I=>{const h=I.indexOf(s);return{ctrlId:I.slice(0,h),tagId:I.slice(h+1)}};e.$AJ=n;var o;(function(I){I.serialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?.toJSON(),range:h.range?.toJSON()||null,description:h.description,error:h.error,sortText:h.sortText}),I.deserialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?E.URI.revive(h.uri):void 0,range:h.range?T.$Ds.lift(h.range):null,description:h.description,error:h.error,sortText:h.sortText})})(o||(e.ITestItem=o={}));var c;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(c||(e.TestItemExpandState=c={}));var d;(function(I){I.serialize=h=>({expand:h.expand,item:o.serialize(h.item)}),I.deserialize=h=>({controllerId:C.$vJ.root(h.item.extId),expand:h.expand,item:o.deserialize(h.item)})})(d||(e.InternalTestItem=d={}));var i;(function(I){I.serialize=h=>{let w;return h.item&&(w={},h.item.label!==void 0&&(w.label=h.item.label),h.item.tags!==void 0&&(w.tags=h.item.tags),h.item.busy!==void 0&&(w.busy=h.item.busy),h.item.uri!==void 0&&(w.uri=h.item.uri?.toJSON()),h.item.range!==void 0&&(w.range=h.item.range?.toJSON()),h.item.description!==void 0&&(w.description=h.item.description),h.item.error!==void 0&&(w.error=h.item.error),h.item.sortText!==void 0&&(w.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:w}},I.deserialize=h=>{let w;return h.item&&(w={},h.item.label!==void 0&&(w.label=h.item.label),h.item.tags!==void 0&&(w.tags=h.item.tags),h.item.busy!==void 0&&(w.busy=h.item.busy),h.item.range!==void 0&&(w.range=h.item.range?T.$Ds.lift(h.item.range):null),h.item.description!==void 0&&(w.description=h.item.description),h.item.error!==void 0&&(w.error=h.item.error),h.item.sortText!==void 0&&(w.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:w}}})(i||(e.ITestItemUpdate=i={}));const r=(I,h)=>{h.expand!==void 0&&(I.expand=h.expand),h.item!==void 0&&(I.item=I.item?Object.assign(I.item,h.item):h.item)};e.$BJ=r;var u;(function(I){I.serializeWithoutMessages=h=>({...d.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(a.serializeWithoutMessages)}),I.serialize=h=>({...d.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(a.serialize)}),I.deserialize=h=>({...d.deserialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(a.deserialize),retired:!0})})(u||(e.TestResultItem=u={}));var f;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(f||(e.DetailType=f={}));var v;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(v||(e.TestDiffOpType=v={}));var g;(function(I){I.deserialize=h=>h.op===0?{op:h.op,item:d.deserialize(h.item)}:h.op===1?{op:h.op,item:i.deserialize(h.item)}:h.op===2?{op:h.op,uri:E.URI.revive(h.uri),docv:h.docv}:h,I.serialize=h=>h.op===0?{op:h.op,item:d.serialize(h.item)}:h.op===1?{op:h.op,item:i.serialize(h.item)}:h})(g||(e.TestsDiffOp=g={}));class D{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(h){const w=this.o();for(const k of h)switch(k.op){case 0:this.j(d.deserialize(k.item),w);break;case 1:this.k(i.deserialize(k.item),w);break;case 3:this.l(k.itemId,w);break;case 5:this.m(k.itemId);break;case 4:this.updatePendingRoots(k.amount);break;case 6:this.c.set(k.tag.id,k.tag);break;case 7:this.c.delete(k.id);break}w.complete?.()}j(h,w){const k=C.$vJ.parentId(h.item.extId)?.toString();let F;if(!k)F=this.p(h),this.f.add(F),this.d.set(h.item.extId,F);else if(this.d.has(k)){const W=this.d.get(k);W.children.add(h.item.extId),F=this.p(h,W),this.d.set(h.item.extId,F)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(h)}`);return}return w.add?.(F),h.expand===2&&this.g++,F}k(h,w){const k=this.d.get(h.extId);if(k)return h.expand!==void 0&&(k.expand===2&&this.g--,h.expand===2&&this.g++),(0,e.$BJ)(k,h),w.update?.(k),k}l(h,w){const k=this.d.get(h);if(!k)return;const F=C.$vJ.parentId(k.item.extId)?.toString();F?this.d.get(F).children.delete(k.item.extId):this.f.delete(k);const W=[[h]];for(;W.length;)for(const Q of W.pop()){const N=this.d.get(Q);N&&(W.push(N.children),this.d.delete(Q),w.remove?.(N,N!==k),N.expand===2&&this.g--)}}m(h){}updatePendingRoots(h){this.h+=h}o(){return{}}}e.$CJ=D}),define(Pe[77],Re([1,0,14,5,6,53,58,48]),function(pe,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.TestItemEventOp=void 0;var m;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const y=(n,o)=>n===o,S=Object.entries({range:(n,o)=>n===o?!0:!n||!o?!1:n.equalsRange(o),busy:y,label:y,description:y,error:y,sortText:y,tags:(n,o)=>!(n.length!==o.length||n.some(c=>!o.includes(c)))}),l=(n,o)=>{let c;for(const[d,i]of S)i(n[d],o[d])||(c?c[d]=o[d]:c={[d]:o[d]});return c};class p extends C.$Rc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new E.$_g(()=>this.flushDiff(),200)),this.g=this.B(new T.$Rd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(o){this.h=o;for(const c of this.tree.values())this.I(c)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===o.uri){c.docv=o.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===o.item.extId){(0,P.$BJ)(c.item,o.item);return}if(c.op===0&&c.item.item.extId===o.item.extId){(0,P.$BJ)(c.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,c){const d=this.tree.get(o);if(d){if((d.expandLevels===void 0||c>d.expandLevels)&&(d.expandLevels=c),d.expand===1){const i=this.L(d);return i.isOpen()?this.J(d,c-1):i.wait().then(()=>this.J(d,c-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.J(d,c-1)):this.J(d,c-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(o,c){switch(c.op){case 3:this.N($.$vJ.joinToString(o.fullId,c.id));break;case 0:this.y(c.item,o);break;case 5:for(const d of c.ops)this.u(o,d);break;case 1:this.z(c.new,c.old,o.fullId.toString());break;case 2:this.I(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:c.update}});break;case 6:this.w(o.actual.uri);break;default:(0,M.$4c)(c)}}w(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}y(o,c){const d=$.$vJ.fromExtHostTestItem(o,this.root.id,c?.actual),i=this.s.getApiFor(o);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(o.id);let r=this.tree.get(d.toString());if(!r){r={fullId:d,actual:o,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},o.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(o,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(o)}}),this.H(o,r,c);return}if(r.actual===o){this.G(o,r,c);return}if(r.actual.uri?.toString()!==o.uri?.toString())return this.N(d.toString()),this.y(o,c);const u=this.s.getChildren(r.actual),f=r.actual,v=l(this.s.toITestItem(f),this.s.toITestItem(o));this.s.getApiFor(f).listener=void 0,r.actual=o,r.expand=0,v&&(v.hasOwnProperty("tags")&&(this.z(o.tags,f.tags,d.toString()),delete v.tags),this.u(r,{op:4,update:v})),this.H(o,r,c);for(const[g,D]of u)this.s.getChildren(o).get(D.id)||this.N($.$vJ.joinToString(d,D.id));this.w(r.actual.uri)}z(o,c,d){const i=new Set(c.map(r=>r.id));for(const r of o)i.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:d,item:{tags:o.map(r=>(0,P.$zJ)(this.s.controllerId,r.id))}}}),i.forEach(this.D,this)}C(o){const c=this.j.get(o.id);c?c.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,P.$zJ)(this.s.controllerId,o.id)}}))}D(o){const c=this.j.get(o);c&&!--c.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,P.$zJ)(this.s.controllerId,o)}))}F(o,c){this.s.getApiFor(o).parent=c&&c.actual!==this.root?c.actual:void 0}G(o,c,d){this.F(o,d);const i=this.s.getApiFor(o);i.parent=d?.actual,i.listener=r=>this.u(c,r),this.I(c)}H(o,c,d){this.G(o,c,d);for(const[i,r]of this.s.getChildren(o))this.y(r,c)}I(o){let c;this.h?o.resolveBarrier?c=o.resolveBarrier.isOpen()?3:2:c=o.actual.canResolveChildren?1:0:c=0,c!==o.expand&&(o.expand=c,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:c}}),c===1&&o.expandLevels!==void 0&&this.L(o))}J(o,c){if(c<0)return;const d=[];for(const[i,r]of this.s.getChildren(o.actual)){const u=this.expand($.$vJ.joinToString(o.fullId,r.id),c);(0,E.$Mg)(u)&&d.push(u)}if(d.length)return Promise.all(d).then(()=>{})}L(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const r=new E.$Yg;return r.open(),r}o.expand=2,this.M(o);const c=o.resolveBarrier=new E.$Yg,d=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let i;try{i=this.h(o.actual===this.root?void 0:o.actual)}catch(r){d(r)}return(0,E.$Mg)(i)?i.catch(d).then(()=>{c.open(),this.I(o)}):(c.open(),this.I(o)),o.resolveBarrier}M(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}N(o){const c=this.tree.get(o);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const d=[c];for(;d.length;){const i=d.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const r of i.actual.tags)this.D(r.id);this.tree.delete(i.fullId.toString());for(const[r,u]of this.s.getChildren(i.actual))d.push(this.tree.get($.$vJ.joinToString(i.fullId,u.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$uM=p;class b extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$vM=b;class a extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$wM=a;class s extends Error{constructor(o,c,d){super(`TestItem with ID "${o}" is from controller "${c}" and cannot be added as a child of an item from controller "${d}".`)}}e.$xM=s;const t=(n,o,c)=>{let d=new Map;return{get size(){return d.size},forEach(i,r){for(const u of d.values())i.call(r,u,this)},[Symbol.iterator](){return d.entries()},replace(i){const r=new Map,u=new Set(d.keys()),f={op:5,ops:[]};for(const v of i){if(!(v instanceof c))throw new a(v.id);const g=o(v).controllerId;if(g!==n.controllerId)throw new s(v.id,g,n.controllerId);if(r.has(v.id))throw new b(v.id);r.set(v.id,v),u.delete(v.id),f.ops.push({op:0,item:v})}for(const v of u.keys())f.ops.push({op:3,id:v});n.listener?.(f),d=r},add(i){if(!(i instanceof c))throw new a(i.id);d.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){d.delete(i)&&n.listener?.({op:3,id:i})},get(i){return d.get(i)},toJSON(){return Array.from(d.values())}}};e.$yM=t}),define(Pe[103],Re([1,0,77]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=void 0;const T=new WeakMap,C=(P,$)=>{const m={controllerId:$};return T.set(P,m),m};e.$zM=C;const M=P=>{const $=T.get(P);if(!$)throw new E.$wM(P?.id||"<unknown>");return $};e.$AM=M}),define(Pe[78],Re([1,0,13,2]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oub=e.$Nub=e.$Mub=e.$Lub=e.$Kub=void 0,e.$Kub="vscode-cdn.net",e.$Lub=`vscode-resource.${e.$Kub}`,e.$Mub=`'self' https://*.${e.$Kub}`;function C($,m){return $.scheme===E.Schemas.http||$.scheme===E.Schemas.https?$:(m&&m.authority&&m.isRemote&&$.scheme===E.Schemas.file&&($=T.URI.from({scheme:E.Schemas.vscodeRemote,authority:m.authority,path:$.path})),T.URI.from({scheme:E.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$Lub}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$Nub=C;function M($){return $.replace(/./g,m=>{const y=m.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?m:"-"+y.toString(16).padStart(4,"0")})}function P($){return $.replace(/-([0-9a-f]{4})/g,(m,y)=>String.fromCharCode(parseInt(y,16)))}e.$Oub=P}),define(Pe[212],Re([1,0,5,6,78]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0;class M{constructor($,m,y){this.d=$,this.e=m,this.f=y,this.a=0,this.b=new T.$Qc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const R=m.getVisibleTextEditors();for(const S of this.c.values())R.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,m,y,R,S){let l;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===$){l=o;break}if(!l)throw new Error("not a visible editor");const p=this,b=this.a++,a=new E.$Rd,s=new E.$Rd,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,C.$Nub)(o,p.f)}get cspSource(){return C.$Mub}set options(o){this.b=o,p.d.$setOptions(b,o)}get options(){return this.b}set html(o){this.a=o,p.d.$setHtml(b,o)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(o){return p.d.$postMessage(b,o)}},n=new class{constructor(){this.editor=$,this.line=m,this.height=y,this.webview=t,this.onDidDispose=s.event}dispose(){p.c.has(b)&&(p.c.delete(b),p.d.$disposeEditorInset(b),s.fire(),s.dispose(),a.dispose())}};return this.d.$createEditorInset(b,l.id,l.value.document.uri,m+1,y,R||{},S.identifier,S.extensionLocation),this.c.set(b,{editor:$,inset:n,onDidReceiveMessage:a}),n}$onDidDispose($){const m=this.c.get($);m&&m.inset.dispose()}$onDidReceiveMessage($,m){this.c.get($)?.onDidReceiveMessage.fire(m)}}e.$Dec=M}),define(Pe[213],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.VariableKind=e.$qN=void 0,e.$qN=(0,E.$Zh)("configurationResolverService");var T;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class C extends Error{constructor(P,$){super($),this.variable=P}}e.$rN=C}),define(Pe[214],Re([1,0,20,74,16,26,21,94,176,213,12]),function(pe,e,E,T,C,M,P,$,m,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,b,a,s){this.h=new Map,this.a=p,this.b=b,this.g=a,s&&(this.c=s.then(t=>this.i(t)))}i(p){if(P.$i){const b=Object.create(null);return Object.keys(p).forEach(a=>{b[a.toLowerCase()]=p[a]}),b}return p}resolveWithEnvironment(p,b,a){return this.l({env:this.i(p),userHome:void 0},b?b.uri:void 0,a)}async resolveAsync(p,b){const a={env:await this.c,userHome:await this.g};return this.l(a,p?p.uri:void 0,b)}async j(p,b,a,s){const t=M.$en(b);P.$i&&t.windows?Object.keys(t.windows).forEach(o=>t[o]=t.windows[o]):P.$j&&t.osx?Object.keys(t.osx).forEach(o=>t[o]=t.osx[o]):P.$k&&t.linux&&Object.keys(t.linux).forEach(o=>t[o]=t.linux[o]),delete t.windows,delete t.osx,delete t.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,p?p.uri:void 0,t,a,s)}async resolveAnyAsync(p,b,a){return this.j(p,b,a)}async resolveAnyMap(p,b,a){const s=new Map;return{newConfig:await this.j(p,b,a,s),resolvedVariables:s}}resolveWithInteractionReplace(p,b,a,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,b,a,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,b){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,b)}async l(p,b,a,s,t){if(C.$Cf(a))return this.m(p,b,a,s,t);if(Array.isArray(a))return Promise.all(a.map(n=>this.l(p,b,n,s,t)));if(C.$Ef(a)){const n=Object.create(null),o=await Promise.all(Object.keys(a).map(async c=>[await this.m(p,b,c,s,t),await this.l(p,b,a[c],s,t)]));for(const[c,d]of o)n[c]=d;return n}return a}m(p,b,a,s,t){return(0,R.$Xe)(a,S.VARIABLE_REGEXP,async(n,o)=>{if(o.includes(S.VARIABLE_LHS))return n;let c=await this.o(p,n,o,b,s);return t?.set(o,c),c!==n&&C.$Cf(c)&&c.match(S.VARIABLE_REGEXP)&&(c=await this.m(p,b,c,s,t)),c})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,b,a,s,t){let n;const o=a.split(":");o.length>1&&(a=o[0],n=o[1]);const c=r=>{const u=this.a.getFilePath();if(u)return(0,$.$Dv)(u);throw new y.$rN(r,(0,m.localize)(0,null,b))},d=r=>{const u=c(r);if(this.a.getWorkspaceFolderPathForFile){const f=this.a.getWorkspaceFolderPathForFile();if(f)return(0,$.$Dv)(f)}throw new y.$rN(r,(0,m.localize)(1,null,b,E.$mc(u)))},i=r=>{if(n){const u=this.a.getFolderUri(n);if(u)return u;throw new y.$rN(r,(0,m.localize)(2,null,b,n))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new y.$rN(r,(0,m.localize)(3,null,b)):new y.$rN(r,(0,m.localize)(4,null,b))};switch(a){case"env":if(n){if(p.env){const r=p.env[P.$i?n.toLowerCase():n];if(C.$Cf(r))return r}return""}throw new y.$rN(y.VariableKind.Env,(0,m.localize)(5,null,b));case"config":if(n){const r=this.a.getConfigurationValue(s,n);if(C.$Lf(r))throw new y.$rN(y.VariableKind.Config,(0,m.localize)(6,null,b,n));if(C.$Ef(r))throw new y.$rN(y.VariableKind.Config,(0,m.localize)(7,null,b,n));return r}throw new y.$rN(y.VariableKind.Config,(0,m.localize)(8,null,b));case"command":return this.p(y.VariableKind.Command,b,n,t,"command");case"input":return this.p(y.VariableKind.Input,b,n,t,"input");case"extensionInstallFolder":if(n){const r=await this.a.getExtension(n);if(!r)throw new y.$rN(y.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,b,n));return this.n(r.extensionLocation)}throw new y.$rN(y.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,b));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,$.$Dv)(this.n(i(y.VariableKind.WorkspaceFolder)));case"cwd":return s||n?(0,$.$Dv)(this.n(i(y.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$Dv)(E.$mc(this.n(i(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new y.$rN(y.VariableKind.UserHome,(0,m.localize)(11,null,b))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new y.$rN(y.VariableKind.LineNumber,(0,m.localize)(12,null,b))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new y.$rN(y.VariableKind.SelectedText,(0,m.localize)(13,null,b))}case"file":return c(y.VariableKind.File);case"fileWorkspaceFolder":return d(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$mc(d(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||n?E.$kc(this.n(i(y.VariableKind.RelativeFile)),c(y.VariableKind.RelativeFile)):c(y.VariableKind.RelativeFile);case"relativeFileDirname":{const r=E.$lc(c(y.VariableKind.RelativeFileDirname));if(s||n){const u=E.$kc(this.n(i(y.VariableKind.RelativeFileDirname)),r);return u.length===0?".":u}return r}case"fileDirname":return E.$lc(c(y.VariableKind.FileDirname));case"fileExtname":return E.$nc(c(y.VariableKind.FileExtname));case"fileBasename":return E.$mc(c(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=E.$mc(c(y.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-E.$nc(r).length)}case"fileDirnameBasename":return E.$mc(E.$lc(c(y.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||b}case"execInstallFolder":{const r=this.a.getAppRoot();return r||b}case"pathSeparator":return E.sep;default:try{const r=n?`${a}:${n}`:a;return this.p(y.VariableKind.Unknown,b,r,t,void 0)}catch{return b}}}}p(p,b,a,s,t){if(a&&s){const n=t===void 0?s[a]:s[t+":"+a];if(typeof n=="string")return n;throw new y.$rN(p,(0,m.localize)(14,null,b))}return b}}e.$FN=S}),define(Pe[104],Re([1,0,4,101]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=e.$MC=e.OpenEditorContext=e.GroupsOrder=e.$LC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$KC=void 0,e.$KC=(0,E.$Zh)("editorGroupsService");var C;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var M;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var P;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(P||(e.GroupLocation=P={}));var $;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var m;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function y(b){const a=b;return(0,T.$tE)(a?.editor)&&(0,T.$tE)(a?.replacement)}e.$LC=y;var R;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var S;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function l(b){const a=b;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.$MC=l;function p(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$NC=p}),define(Pe[215],Re([1,0,4,104]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RC=e.$QC=e.$PC=e.$OC=void 0,e.$OC=(0,E.$Zh)("editorService"),e.$PC=-1,e.$QC=-2;function C(M){const P=M;return typeof M=="number"||(0,T.$MC)(P)}e.$RC=C}),define(Pe[216],Re([1,0,4,183]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZJ=void 0,e.$ZJ=(0,E.$1h)(T.$7h)}),define(Pe[105],Re([1,0,22,5,20,6]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=e.$z6b=e.$y6b=e.$x6b=e.$w6b=void 0;class P{constructor(t,n){this.versionId=t,this.removedDueToLooping=n}}e.$w6b=P;class ${static isHostExtension(t,n,o){if(n.getExtensionDescription(t))return!1;const c=o.getExtensionDescription(t);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(t,n){this.j=t,this.c=new T.$Rd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(b),this.f=new E.$fm,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const n=this.j.readActivationEvents(t);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,n){this.e=a(this.e,n),this.e=this.e.concat(t);const o=$.l(this.e);return this.e=a(this.e,o.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new P(this.d,o)}static l(t){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,u){this.addNode(r),this.addNode(u),this.c.has(r)?this.c.get(r).push(u):this.c.set(r,[u])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,u){const f=n.getArcs(r);for(let v=0;v<f.length;v++)if(!u.has(f[v]))return!1;return!0}getNodes(){return this.e}},o=new E.$fm;for(const r of t)if(o.set(r.identifier,r),r.extensionDependencies)for(const u of r.extensionDependencies)n.addArc(E.$dm.toKey(r.identifier),E.$dm.toKey(u));const c=new Set;n.getNodes().filter(r=>n.getArcs(r).length===0).forEach(r=>c.add(r));const d=n.getNodes().filter(r=>!c.has(r));let i;do{i=!1;for(let r=0;r<d.length;r++){const u=d[r];n.hasOnlyGoodArcs(u,c)&&(d.splice(r,1),r--,c.add(u),i=!0)}}while(i);return d.map(r=>o.get(r))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const n=this.h.get(t);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new m(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const n=this.f.get(t);return n||void 0}getExtensionDescriptionByUUID(t){for(const n of this.g)if(n.uuid===t)return n}getExtensionDescriptionByIdOrUUID(t,n){return this.getExtensionDescription(t)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$x6b=$;class m{constructor(t,n){this.versionId=t,this.extensions=n}}e.$y6b=m;class y{constructor(t){this.d=new l,this.c=new $(t,[])}async acquireLock(t){const n=await this.d.acquire(t);return new R(this,n)}deltaExtensions(t,n,o){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,n){return this.c.getExtensionDescriptionByIdOrUUID(t,n)}}e.$z6b=y;class R extends M.$Rc{constructor(t,n){super(),this.f=t,this.c=!1,this.B(n)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$A6b=R;class S{constructor(t){this.name=t,this.promise=new Promise((n,o)=>{this.c=n})}resolve(t){this.c(t)}}class l{constructor(){this.c=[],this.d=!1}async acquire(t){const n=new S(t);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};t.resolve((0,M.$Pc)(c))}}var p;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(p||(p={}));function b(s,t){const n=s.isBuiltin?0:s.isUnderDevelopment?2:1,o=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(n!==o)return n-o;const c=C.$fc.basename(s.extensionLocation.path),d=C.$fc.basename(t.extensionLocation.path);return c<d?-1:c>d?1:0}function a(s,t){const n=new E.$em(t);return s.filter(o=>!n.has(o.identifier))}}),define(Pe[79],Re([1,0,24]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$mm=e.$lm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(T||(e.UIKind=T={}));var C;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var M;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function P(y){const R=E.$fe.alloc(1);switch(y){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$lm=P;function $(y,R){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$mm=$;var m;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Pe[59],Re([1,0,4,5,15,27,79,55,56,26,2,6,164]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=e.$XM=e.$WM=e.$VM=void 0;let p=class extends S.$Rc{constructor(t,n){super(),this.s=t,this.t=n,this.a=this.B(new T.$Rd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Rd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:m.$yo,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(n.onDidChangeLogLevel(o=>{(0,C.$jj)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,n,o){const c=this.getTelemetryDetails(),d=new b(n,o,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...i,d]),d.apiTelemetryLogger}$initializeTelemetryLevel(t,n,o){this.f=t,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const n=Object.create(null);switch(n["common.extname"]=`${t.publisher}.${t.name}`,n["common.extversion"]=t.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case P.UIKind.Web:n["common.uikind"]="web";break;case P.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$6k)((0,m.$Fo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const n=this.getTelemetryDetails();this.r.forEach((o,c)=>{const d=o.filter(i=>!i.isDisposed);d.length===0?this.r.delete(c):this.r.set(c,d)}),this.r.forEach(o=>{for(const c of o)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,n){const c=this.r.get(t.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(t.value),!1;let d=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),d=!0);return d}};e.$VM=p,e.$VM=p=Ke([We(0,M.$UM),We(1,C.$ij)],p);class b{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,n,o,c,d,i,r){this.g=o,this.h=c,this.i=d,this.j=i,this.a=new T.$Rd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(t,n){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let n="properties"in t?t.properties??{}:t;return n=(0,m.$Io)(n,[]),this.c&&(n=(0,y.$hn)(n,this.c)),this.b||(n=(0,y.$hn)(n,this.j)),"properties"in t?t.properties=n:t=n,t}k(t,n){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(t,n),this.h.trace(t,n))}logUsage(t,n){this.d.isUsageEnabled&&this.k(t,n)}logError(t,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,n);else{const o={name:t.name,message:t.message,stack:t.stack,cause:t.cause},c=(0,m.$Io)(o,[]),d=new Error(c.message,{cause:c.cause});d.stack=c.stack,d.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(d,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const t=this,n={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$WM=b;function a(s){const t=Date.now()-new Date(s).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$XM=a,e.$YM=(0,E.$Zh)("IExtHostTelemetry")}),define(Pe[23],Re([1,0,5,2,192,100,22,4]),function(pe,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VF=e.$UF=e.$TF=e.ActivationKind=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.ExtensionHostStartup=e.$NF=e.$MF=e.$LF=e.$KF=void 0,e.$KF=Object.freeze({identifier:new P.$dm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$LF="extensions.webWorker",e.$MF=(0,$.$Zh)("extensionService");class m{constructor(d){this.dependency=d}}e.$NF=m;var y;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(d,i,r){this.c=d,this.d=i.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$BF.createActivationEventsMap(this.d)}}set(d,i,r){if(this.c>d)throw new Error(`ExtensionHostExtensions: invalid versionId ${d} (current: ${this.c})`);const u=[],f=[],v=[],g=[],D=S(this.d),I=S(i),h=(Q,N)=>Q.extensionLocation.toString()===N.extensionLocation.toString()||Q.isBuiltin===N.isBuiltin||Q.isUserBuiltin===N.isUserBuiltin||Q.isUnderDevelopment===N.isUnderDevelopment;for(const Q of this.d){const N=I.get(Q.identifier);if(!N){u.push(Q.identifier),D.delete(Q.identifier);continue}if(!h(Q,N)){u.push(Q.identifier),D.delete(Q.identifier);continue}}for(const Q of i){const N=D.get(Q.identifier);if(!N){f.push(Q);continue}if(!h(N,Q)){u.push(N.identifier),D.delete(N.identifier);continue}}const w=new P.$em(this.e),k=new P.$em(r);for(const Q of this.e)k.has(Q)||v.push(Q);for(const Q of r)w.has(Q)||g.push(Q);const F=M.$BF.createActivationEventsMap(f),W={versionId:d,toRemove:u,toAdd:f,addActivationEvents:F,myToRemove:v,myToAdd:g};return this.delta(W),W}delta(d){if(this.c>=d.versionId)return null;const{toRemove:i,toAdd:r,myToRemove:u,myToAdd:f}=d,v=new P.$em(i),g=new P.$em(u);for(let D=0;D<this.d.length;D++)v.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)g.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of r)this.d.push(D);for(const D of f)this.e.push(D);return this.f=null,d}containsExtension(d){for(const i of this.e)if(P.$dm.equals(i,d))return!0;return!1}containsActivationEvent(d){return this.f||(this.f=this.g()),this.f.has(d)}g(){const d=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const r=M.$BF.readActivationEvents(i);for(const u of r)d.add(u)}return d}}e.$OF=R;function S(c){const d=new P.$fm;for(const i of c)d.set(i.identifier,i);return d}function l(c,d){return c.enabledApiProposals?c.enabledApiProposals.includes(d):!1}e.$PF=l;function p(c,d){if(!l(c,d))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$QF=p;class b{constructor(d,i,r,u){this.codeLoadingTime=d,this.activateCallTime=i,this.activateResolvedTime=r,this.activationReason=u}}e.$RF=b;class a{constructor(d,i){this.description=d,this.value=i}}e.$SF=a;var s;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function t(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.$Oo)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$TF=t;function n(c,d){return{identifier:new P.$dm((0,C.$Mo)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!d,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$UF=n;class o{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activateById(d,i){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(d,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$VF=o}),define(Pe[217],Re([1,0,11,105,22,23,15,14]),function(pe,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=e.$4ec=e.$3ec=e.$2ec=e.$1ec=e.$Zec=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(t,n,o,c){this.startup=t,this.codeLoadingTime=n,this.activateCallTime=o,this.activateResolvedTime=c}}e.$Zec=m;class y{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,n){return t===-1||n===-1?-1:n-t}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$1ec=y;class R{constructor(t,n,o,c,d,i){this.activationFailed=t,this.activationFailedError=n,this.activationTimes=o,this.module=c,this.exports=d,this.subscriptions=i}}e.$2ec=R;class S extends R{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$3ec=S;class l extends R{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$4ec=l;class p extends R{constructor(t){super(!0,t,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(t,n,o,c){this.g=c,this.a=t,this.b=n,this.c=o,this.d=new C.$fm,this.f=Object.create(null)}dispose(){for(const[t,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const t=[];for(const[n,o]of this.d)t.push(o.wait());await Promise.all(t)}isActivated(t){const n=this.d.get(t);return!!(n&&n.value)}getActivatedExtension(t){const n=this.d.get(t);if(!n||!n.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return n.value}async activateByEvent(t,n){if(this.f[t])return;const o=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(o.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,n){const o=this.a.getExtensionDescription(t);if(!o)throw new Error(`Extension '${t}' is not known`);return this.h([{id:o.identifier,reason:n}])}async h(t){const n=t.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(n.map(o=>o.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const n=this.a.getExtensionDescription(t.id);if(!n){const d=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this.k(t,null,[],new p(d));return this.c.onExtensionActivationError(t.id,d,new M.$NF(t.id.value)),i}const o=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const d of c){if(this.m(d))continue;const i=this.d.get(d);if(i){o.push(i);continue}if(this.l(d)){o.push(this.j({id:this.b.getExtensionDescription(d).identifier,reason:t.reason}));continue}const r=this.a.getExtensionDescription(d);if(r){if(!r.main&&!r.browser)continue;o.push(this.j({id:r.identifier,reason:t.reason}));continue}const u=n.displayName||n.identifier.value,f=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${d}'`),v=this.k(t,n.displayName,[],new p(f));return this.c.onExtensionActivationError(n.identifier,f,new M.$NF(d)),v}return this.k(t,n.displayName,o,null)}k(t,n,o,c){const d=new a(t.id,n,t.reason,o,c,this.c,this.g);return this.d.set(t.id,d),d}l(t){return T.$x6b.isHostExtension(t,this.a,this.b)}m(t){const n=this.b.getExtensionDescription(t);return n?!n.main&&!n.browser:!1}};e.$5ec=b,e.$5ec=b=Ke([We(3,P.$hj)],b);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,n,o,c,d,i,r){this.c=t,this.d=n,this.f=o,this.g=c,this.h=d,this.j=i,this.k=r,this.a=new $.$Yg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const n=this.g[t];if(n.value&&!n.value.activationFailed){this.g.splice(t,1),t--;continue}if(n.value&&n.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);o.detail=n.value.activationFailedError,this.h=new p(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const n=new Error;if(t&&t.name&&(n.name=t.name),t&&t.message?n.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(n.stack=t.stack),this.h=new p(n),this.b&&E.$3(t))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};a=Ke([We(6,P.$hj)],a)}),define(Pe[8],Re([1,0,18,24,125,218,52,28,119,51,68,26,16,2,29,80,98,103,101,76,48,58,215,7,23]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s,t,n,o,c,d,i,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$DM=e.$CM=e.MarkdownString=e.$BM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var f;(function(Ee){function Me(K){const{selectionStartLineNumber:Le,selectionStartColumn:Ue,positionLineNumber:Qe,positionColumn:qe}=K,et=new r.$FK(Le-1,Ue-1),ut=new r.$FK(Qe-1,qe-1);return new r.$HK(et,ut)}Ee.to=Me;function $e(K){const{anchor:Le,active:Ue}=K;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Ee.from=$e})(f||(e.Selection=f={}));var v;(function(Ee){function Me(K){if(!K)return;const{start:Le,end:Ue}=K;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Ee.from=Me;function $e(K){if(!K)return;const{startLineNumber:Le,startColumn:Ue,endLineNumber:Qe,endColumn:qe}=K;return new r.$GK(Le-1,Ue-1,Qe-1,qe-1)}Ee.to=$e})(v||(e.Range=v={}));var g;(function(Ee){function Me($e){switch($e){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Ee.to=Me})(g||(e.TokenType=g={}));var D;(function(Ee){function Me(K){return new r.$FK(K.lineNumber-1,K.column-1)}Ee.to=Me;function $e(K){return{lineNumber:K.line+1,column:K.character+1}}Ee.from=$e})(D||(e.Position=D={}));var I;(function(Ee){function Me(Le,Ue,Qe){return(0,E.$Gb)((0,E.$2b)(Le).map(qe=>$e(qe,Ue,Qe)))}Ee.from=Me;function $e(Le,Ue,Qe){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Qe?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:K(Le.scheme,Ue),pattern:_.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Qe?.isBuiltin}}function K(Le,Ue){return Ue&&typeof Le=="string"?Ue.transformOutgoingScheme(Le):Le}})(I||(e.DocumentSelector=I={}));var h;(function(Ee){function Me(K){switch(K){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Ee.from=Me;function $e(K){switch(K){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Ee.to=$e})(h||(e.DiagnosticTag=h={}));var w;(function(Ee){function Me(K){let Le;return K.code&&((0,l.$Cf)(K.code)||(0,l.$Gf)(K.code)?Le=String(K.code):Le={value:String(K.code.value),target:K.code.target}),{...v.from(K.range),message:K.message,source:K.source,code:Le,severity:F.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(k.from),tags:Array.isArray(K.tags)?(0,E.$Gb)(K.tags.map(h.from)):void 0}}Ee.from=Me;function $e(K){const Le=new r.$SK(v.to(K),K.message,F.to(K.severity));return Le.source=K.source,Le.code=(0,l.$Cf)(K.code)?K.code:K.code?.value,Le.relatedInformation=K.relatedInformation&&K.relatedInformation.map(k.to),Le.tags=K.tags&&(0,E.$Gb)(K.tags.map(h.to)),Le}Ee.to=$e})(w||(e.Diagnostic=w={}));var k;(function(Ee){function Me(K){return{...v.from(K.location.range),message:K.message,resource:K.location.uri}}Ee.from=Me;function $e(K){return new r.$RK(new r.$QK(K.resource,v.to(K)),K.message)}Ee.to=$e})(k||(e.DiagnosticRelatedInformation=k={}));var F;(function(Ee){function Me(K){switch(K){case r.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}Ee.from=Me;function $e(K){switch(K){case s.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Ee.to=$e})(F||(e.DiagnosticSeverity=F={}));var W;(function(Ee){function Me(K){return typeof K=="number"&&K>=r.ViewColumn.One?K-1:K===r.ViewColumn.Beside?i.$QC:i.$PC}Ee.from=Me;function $e(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=$e})(W||(e.ViewColumn=W={}));function Q(Ee){return typeof Ee.range<"u"}function N(Ee){return Ee.length===0?!0:!!Q(Ee[0])}e.$BM=N;var A;(function(Ee){function Me(qe){return qe.map(Ee.from)}Ee.fromMany=Me;function $e(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function K(qe){let et;if($e(qe)){const{language:Et,value:yt}=qe;et={value:"```"+Et+`
`+yt+"\n```\n"}}else r.$5K.isMarkdownString(qe)?et={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?et={value:qe}:et={value:""};const ut=Object.create(null);et.uris=ut;const vt=Et=>{try{let yt=p.URI.parse(Et,!0);yt=yt.with({query:Le(yt.query,ut)}),ut[Et]=yt}catch{}return""},$t=new m.marked.Renderer;return $t.link=vt,$t.image=Et=>typeof Et=="string"?vt(P.$hk(Et).href):"",(0,m.marked)(et.value,{renderer:$t}),et}Ee.from=K;function Le(qe,et){if(!qe)return qe;let ut;try{ut=(0,y.$vh)(qe)}catch{}if(!ut)return qe;let vt=!1;return ut=(0,S.$gn)(ut,$t=>{if(p.URI.isUri($t)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[Et]=$t,vt=!0,Et}else return}),vt?JSON.stringify(ut):qe}function Ue(qe){const et=new r.$5K(qe.value,qe.supportThemeIcons);return et.isTrusted=qe.isTrusted,et.supportHtml=qe.supportHtml,et.baseUri=qe.baseUri?p.URI.from(qe.baseUri):void 0,et}Ee.to=Ue;function Qe(qe){if(qe)return typeof qe=="string"?qe:Ee.from(qe)}Ee.fromStrict=Qe})(A||(e.MarkdownString=A={}));function L(Ee){return N(Ee)?Ee.map(Me=>({range:v.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?A.fromMany(Me.hoverMessage):Me.hoverMessage?A.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ee.map(Me=>({range:v.from(Me)}))}e.$CM=L;function O(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?p.URI.file(Ee):Ee}e.$DM=O;var x;(function(Ee){function Me($e){return typeof $e>"u"?$e:{contentText:$e.contentText,contentIconPath:$e.contentIconPath?O($e.contentIconPath):void 0,border:$e.border,borderColor:$e.borderColor,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,color:$e.color,backgroundColor:$e.backgroundColor,margin:$e.margin,width:$e.width,height:$e.height}}Ee.from=Me})(x||(e.ThemableDecorationAttachmentRenderOptions=x={}));var le;(function(Ee){function Me($e){return typeof $e>"u"?$e:{backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?O($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?x.from($e.before):void 0,after:$e.after?x.from($e.after):void 0}}Ee.from=Me})(le||(e.ThemableDecorationRenderOptions=le={}));var me;(function(Ee){function Me($e){if(typeof $e>"u")return $e;switch($e){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Me})(me||(e.DecorationRangeBehavior=me={}));var ye;(function(Ee){function Me($e){return{isWholeLine:$e.isWholeLine,rangeBehavior:$e.rangeBehavior?me.from($e.rangeBehavior):void 0,overviewRulerLane:$e.overviewRulerLane,light:$e.light?le.from($e.light):void 0,dark:$e.dark?le.from($e.dark):void 0,backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?O($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?x.from($e.before):void 0,after:$e.after?x.from($e.after):void 0}}Ee.from=Me})(ye||(e.DecorationRenderOptions=ye={}));var we;(function(Ee){function Me(K){return{text:K.newText,eol:K.newEol&&tt.from(K.newEol),range:v.from(K.range)}}Ee.from=Me;function $e(K){const Le=new r.$LK(v.to(K.range),K.text);return Le.newEol=typeof K.eol>"u"?void 0:tt.to(K.eol),Le}Ee.to=$e})(we||(e.TextEdit=we={}));var de;(function(Ee){function Me(K,Le){const Ue={edits:[]};if(K instanceof r.$OK){const Qe=new $.$Ac;for(const qe of K._allEntries())qe._type===1&&p.URI.isUri(qe.to)&&qe.from===void 0&&Qe.add(qe.to);for(const qe of K._allEntries())if(qe._type===1){let et;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?et={type:"base64",value:(0,T.$ze)(T.$fe.wrap(qe.options.contents))}:et={type:"dataTransferItem",id:qe.options.contents._itemId}),Ue.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:et},metadata:qe.metadata})}else qe._type===2?Ue.edits.push({resource:qe.uri,textEdit:we.from(qe.edit),versionId:Qe.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ue.edits.push({resource:qe.uri,textEdit:{range:v.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Qe.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ue.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ue.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Te.from)}})}return Ue}Ee.from=Me;function $e(K){const Le=new r.$OK,Ue=new $.$zc;for(const Qe of K.edits)if(Qe.textEdit){const qe=Qe,et=p.URI.revive(qe.resource),ut=v.to(qe.textEdit.range),vt=qe.textEdit.text,$t=qe.textEdit.insertAsSnippet;let Et;$t?Et=r.$NK.replace(ut,new r.$PK(vt)):Et=r.$LK.replace(ut,vt);const yt=Ue.get(et);yt?yt.push(Et):Ue.set(et,[Et])}else Le.renameFile(p.URI.revive(Qe.oldResource),p.URI.revive(Qe.newResource),Qe.options);for(const[Qe,qe]of Ue)Le.set(Qe,qe);return Le}Ee.to=$e})(de||(e.WorkspaceEdit=de={}));var be;(function(Ee){const Me=Object.create(null);Me[r.SymbolKind.File]=0,Me[r.SymbolKind.Module]=1,Me[r.SymbolKind.Namespace]=2,Me[r.SymbolKind.Package]=3,Me[r.SymbolKind.Class]=4,Me[r.SymbolKind.Method]=5,Me[r.SymbolKind.Property]=6,Me[r.SymbolKind.Field]=7,Me[r.SymbolKind.Constructor]=8,Me[r.SymbolKind.Enum]=9,Me[r.SymbolKind.Interface]=10,Me[r.SymbolKind.Function]=11,Me[r.SymbolKind.Variable]=12,Me[r.SymbolKind.Constant]=13,Me[r.SymbolKind.String]=14,Me[r.SymbolKind.Number]=15,Me[r.SymbolKind.Boolean]=16,Me[r.SymbolKind.Array]=17,Me[r.SymbolKind.Object]=18,Me[r.SymbolKind.Key]=19,Me[r.SymbolKind.Null]=20,Me[r.SymbolKind.EnumMember]=21,Me[r.SymbolKind.Struct]=22,Me[r.SymbolKind.Event]=23,Me[r.SymbolKind.Operator]=24,Me[r.SymbolKind.TypeParameter]=25;function $e(Le){return typeof Me[Le]=="number"?Me[Le]:6}Ee.from=$e;function K(Le){for(const Ue in Me)if(Me[Ue]===Le)return Number(Ue);return r.SymbolKind.Property}Ee.to=K})(be||(e.SymbolKind=be={}));var ie;(function(Ee){function Me(K){switch(K){case r.SymbolTag.Deprecated:return 1}}Ee.from=Me;function $e(K){switch(K){case 1:return r.SymbolTag.Deprecated}}Ee.to=$e})(ie||(e.SymbolTag=ie={}));var Ie;(function(Ee){function Me(K){return{name:K.name,kind:be.from(K.kind),tags:K.tags&&K.tags.map(ie.from),containerName:K.containerName,location:Se.from(K.location)}}Ee.from=Me;function $e(K){const Le=new r.$VK(K.name,be.to(K.kind),K.containerName,Se.to(K.location));return Le.tags=K.tags&&K.tags.map(ie.to),Le}Ee.to=$e})(Ie||(e.WorkspaceSymbol=Ie={}));var ce;(function(Ee){function Me(K){const Le={name:K.name||"!!MISSING: name!!",detail:K.detail,range:v.from(K.range),selectionRange:v.from(K.selectionRange),kind:be.from(K.kind),tags:K.tags?.map(ie.from)??[]};return K.children&&(Le.children=K.children.map(Me)),Le}Ee.from=Me;function $e(K){const Le=new r.$WK(K.name,K.detail,be.to(K.kind),v.to(K.range),v.to(K.selectionRange));return(0,E.$Kb)(K.tags)&&(Le.tags=K.tags.map(ie.to)),K.children&&(Le.children=K.children.map($e)),Le}Ee.to=$e})(ce||(e.DocumentSymbol=ce={}));var Y;(function(Ee){function Me(K){const Le=new r.$1K(be.to(K.kind),K.name,K.detail||"",p.URI.revive(K.uri),v.to(K.range),v.to(K.selectionRange));return Le._sessionId=K._sessionId,Le._itemId=K._itemId,Le}Ee.to=Me;function $e(K,Le,Ue){if(Le=Le??K._sessionId,Ue=Ue??K._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,name:K.name,detail:K.detail,kind:be.from(K.kind),uri:K.uri,range:v.from(K.range),selectionRange:v.from(K.selectionRange),tags:K.tags?.map(ie.from)}}Ee.from=$e})(Y||(e.CallHierarchyItem=Y={}));var B;(function(Ee){function Me($e){return new r.$2K(Y.to($e.from),$e.fromRanges.map(K=>v.to(K)))}Ee.to=Me})(B||(e.CallHierarchyIncomingCall=B={}));var se;(function(Ee){function Me($e){return new r.$3K(Y.to($e.to),$e.fromRanges.map(K=>v.to(K)))}Ee.to=Me})(se||(e.CallHierarchyOutgoingCall=se={}));var Se;(function(Ee){function Me(K){return{range:K.range&&v.from(K.range),uri:K.uri}}Ee.from=Me;function $e(K){return new r.$QK(p.URI.revive(K.uri),v.to(K.range))}Ee.to=$e})(Se||(e.location=Se={}));var Ae;(function(Ee){function Me(K){const Le=K,Ue=K;return{originSelectionRange:Le.originSelectionRange?v.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ue.uri,range:v.from(Le.targetRange?Le.targetRange:Ue.range),targetSelectionRange:Le.targetSelectionRange?v.from(Le.targetSelectionRange):void 0}}Ee.from=Me;function $e(K){return{targetUri:p.URI.revive(K.uri),targetRange:v.to(K.range),targetSelectionRange:K.targetSelectionRange?v.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?v.to(K.originSelectionRange):void 0}}Ee.to=$e})(Ae||(e.DefinitionLink=Ae={}));var Ce;(function(Ee){function Me(K){return{range:v.from(K.range),contents:A.fromMany(K.contents)}}Ee.from=Me;function $e(K){return new r.$TK(K.contents.map(A.to),v.to(K.range))}Ee.to=$e})(Ce||(e.Hover=Ce={}));var fe;(function(Ee){function Me(K){return{range:v.from(K.range),expression:K.expression}}Ee.from=Me;function $e(K){return new r.$ML(v.to(K.range),K.expression)}Ee.to=$e})(fe||(e.EvaluatableExpression=fe={}));var ne;(function(Ee){function Me(K){if(K instanceof r.$NL)return{type:"text",range:v.from(K.range),text:K.text};if(K instanceof r.$OL)return{type:"variable",range:v.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof r.$PL)return{type:"expression",range:v.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Me;function $e(K){switch(K.type){case"text":return{range:v.to(K.range),text:K.text};case"variable":return{range:v.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:v.to(K.range),expression:K.expression}}}Ee.to=$e})(ne||(e.InlineValue=ne={}));var H;(function(Ee){function Me(K){return{frameId:K.frameId,stoppedLocation:v.from(K.stoppedLocation)}}Ee.from=Me;function $e(K){return new r.$QL(K.frameId,v.to(K.stoppedLocation))}Ee.to=$e})(H||(e.InlineValueContext=H={}));var te;(function(Ee){function Me(K){return{range:v.from(K.range),kind:K.kind}}Ee.from=Me;function $e(K){return new r.$UK(v.to(K.range),K.kind)}Ee.to=$e})(te||(e.DocumentHighlight=te={}));var X;(function(Ee){function Me($e){switch($e){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Ee.to=Me})(X||(e.CompletionTriggerKind=X={}));var re;(function(Ee){function Me($e){return{triggerKind:X.to($e.triggerKind),triggerCharacter:$e.triggerCharacter}}Ee.to=Me})(re||(e.CompletionContext=re={}));var he;(function(Ee){function Me(K){switch(K){case r.CompletionItemTag.Deprecated:return 1}}Ee.from=Me;function $e(K){switch(K){case 1:return r.CompletionItemTag.Deprecated}}Ee.to=$e})(he||(e.CompletionItemTag=he={}));var De;(function(Ee){const Me=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function $e(Ue){return Me.get(Ue)??9}Ee.from=$e;const K=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Le(Ue){return K.get(Ue)??r.CompletionItemKind.Property}Ee.to=Le})(De||(e.CompletionItemKind=De={}));var z;(function(Ee){function Me($e,K){const Le=new r.$$K($e.label);return Le.insertText=$e.insertText,Le.kind=De.to($e.kind),Le.tags=$e.tags?.map(he.to),Le.detail=$e.detail,Le.documentation=P.$ck($e.documentation)?A.to($e.documentation):$e.documentation,Le.sortText=$e.sortText,Le.filterText=$e.filterText,Le.preselect=$e.preselect,Le.commitCharacters=$e.commitCharacters,b.$Ds.isIRange($e.range)?Le.range=v.to($e.range):typeof $e.range=="object"&&(Le.range={inserting:v.to($e.range.insert),replacing:v.to($e.range.replace)}),Le.keepWhitespace=typeof $e.insertTextRules>"u"?!1:!!($e.insertTextRules&1),typeof $e.insertTextRules<"u"&&$e.insertTextRules&4?Le.insertText=new r.$PK($e.insertText):(Le.insertText=$e.insertText,Le.textEdit=Le.range instanceof r.$GK?new r.$LK(Le.range,Le.insertText):void 0),$e.additionalTextEdits&&$e.additionalTextEdits.length>0&&(Le.additionalTextEdits=$e.additionalTextEdits.map(Ue=>we.to(Ue))),Le.command=K&&$e.command?K.fromInternal($e.command):void 0,Le}Ee.to=Me})(z||(e.CompletionItem=z={}));var V;(function(Ee){function Me(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:A.fromStrict(K.documentation)}}Ee.from=Me;function $e(K){return{label:K.label,documentation:P.$ck(K.documentation)?A.to(K.documentation):K.documentation}}Ee.to=$e})(V||(e.ParameterInformation=V={}));var G;(function(Ee){function Me(K){return{label:K.label,documentation:A.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(V.from):[],activeParameter:K.activeParameter}}Ee.from=Me;function $e(K){return{label:K.label,documentation:P.$ck(K.documentation)?A.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(V.to):[],activeParameter:K.activeParameter}}Ee.to=$e})(G||(e.SignatureInformation=G={}));var J;(function(Ee){function Me(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(G.from):[]}}Ee.from=Me;function $e(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(G.to):[]}}Ee.to=$e})(J||(e.SignatureHelp=J={}));var q;(function(Ee){function Me($e,K){const Le=new r.$0K(D.to(K.position),typeof K.label=="string"?K.label:K.label.map(ee.to.bind(void 0,$e)),K.kind&&ue.to(K.kind));return Le.textEdits=K.textEdits&&K.textEdits.map(we.to),Le.tooltip=P.$ck(K.tooltip)?A.to(K.tooltip):K.tooltip,Le.paddingLeft=K.paddingLeft,Le.paddingRight=K.paddingRight,Le}Ee.to=Me})(q||(e.InlayHint=q={}));var ee;(function(Ee){function Me($e,K){const Le=new r.$9K(K.label);return Le.tooltip=P.$ck(K.tooltip)?A.to(K.tooltip):K.tooltip,a.Command.is(K.command)&&(Le.command=$e.fromInternal(K.command)),K.location&&(Le.location=Se.to(K.location)),Le}Ee.to=Me})(ee||(e.InlayHintLabelPart=ee={}));var ue;(function(Ee){function Me(K){return K}Ee.from=Me;function $e(K){return K}Ee.to=$e})(ue||(e.InlayHintKind=ue={}));var Ne;(function(Ee){function Me(K){return{range:v.from(K.range),url:K.target,tooltip:K.tooltip}}Ee.from=Me;function $e(K){let Le;if(K.url)try{Le=typeof K.url=="string"?p.URI.parse(K.url,!0):p.URI.revive(K.url)}catch{}return new r.$dL(v.to(K.range),Le)}Ee.to=$e})(Ne||(e.DocumentLink=Ne={}));var je;(function(Ee){function Me(K){const Le=new r.$gL(K.label);return K.textEdit&&(Le.textEdit=we.to(K.textEdit)),K.additionalTextEdits&&(Le.additionalTextEdits=K.additionalTextEdits.map(Ue=>we.to(Ue))),Le}Ee.to=Me;function $e(K){return{label:K.label,textEdit:K.textEdit?we.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Le=>we.from(Le)):void 0}}Ee.from=$e})(je||(e.ColorPresentation=je={}));var Ye;(function(Ee){function Me(K){return new r.$eL(K[0],K[1],K[2],K[3])}Ee.to=Me;function $e(K){return[K.red,K.green,K.blue,K.alpha]}Ee.from=$e})(Ye||(e.Color=Ye={}));var Je;(function(Ee){function Me(K){return{range:v.from(K.range)}}Ee.from=Me;function $e(K){return new r.$ZK(v.to(K.range))}Ee.to=$e})(Je||(e.SelectionRange=Je={}));var it;(function(Ee){function Me($e){switch($e){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Ee.to=Me})(it||(e.TextDocumentSaveReason=it={}));var _e;(function(Ee){function Me(K){switch(K){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Me;function $e(K){switch(K){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Ee.to=$e})(_e||(e.TextEditorLineNumbersStyle=_e={}));var tt;(function(Ee){function Me(K){if(K===r.EndOfLine.CRLF)return 1;if(K===r.EndOfLine.LF)return 0}Ee.from=Me;function $e(K){if(K===1)return r.EndOfLine.CRLF;if(K===0)return r.EndOfLine.LF}Ee.to=$e})(tt||(e.EndOfLine=tt={}));var rt;(function(Ee){function Me($e){if(typeof $e=="object")return $e.viewId;switch($e){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Me})(rt||(e.ProgressLocation=rt={}));var nt;(function(Ee){function Me(K){const Le={start:K.start+1,end:K.end+1};return K.kind&&(Le.kind=ze.from(K.kind)),Le}Ee.from=Me;function $e(K){const Le={start:K.start-1,end:K.end-1};return K.kind&&(Le.kind=ze.to(K.kind)),Le}Ee.to=$e})(nt||(e.FoldingRange=nt={}));var ze;(function(Ee){function Me(K){if(K)switch(K){case r.FoldingRangeKind.Comment:return a.$st.Comment;case r.FoldingRangeKind.Imports:return a.$st.Imports;case r.FoldingRangeKind.Region:return a.$st.Region}}Ee.from=Me;function $e(K){if(K)switch(K.value){case a.$st.Comment.value:return r.FoldingRangeKind.Comment;case a.$st.Imports.value:return r.FoldingRangeKind.Imports;case a.$st.Region.value:return r.FoldingRangeKind.Region}}Ee.to=$e})(ze||(e.FoldingRangeKind=ze={}));var ht;(function(Ee){function Me($e){if($e)return{pinned:typeof $e.preview=="boolean"?!$e.preview:void 0,inactive:$e.background,preserveFocus:$e.preserveFocus,selection:typeof $e.selection=="object"?v.from($e.selection):void 0,override:typeof $e.override=="boolean"?n.$fE.id:void 0}}Ee.from=Me})(ht||(e.TextEditorOpenOptions=ht={}));var _;(function(Ee){function Me(Ue){return Ue instanceof r.$AL?Ue.toJSON():typeof Ue=="string"?Ue:$e(Ue)||K(Ue)?new r.$AL(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Ee.from=Me;function $e(Ue){const Qe=Ue;return Qe?p.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function K(Ue){const Qe=Ue;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Le(Ue){return typeof Ue=="string"?Ue:new r.$AL(p.URI.revive(Ue.baseUri),Ue.pattern)}Ee.to=Le})(_||(e.GlobPattern=_={}));var Z;(function(Ee){function Me($e){if($e){if(Array.isArray($e))return $e.map(Me);if(typeof $e=="string")return $e;{const K=$e;return{language:K.language,scheme:K.scheme,pattern:_.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Ee.from=Me})(Z||(e.LanguageSelector=Z={}));var ve;(function(Ee){function Me(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Le=>Array.isArray(Le)&&Le.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&p.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Qe=>Qe instanceof r.$GK)))}Ee.is=Me;function $e(K){return{documents:K.documents.map(Le=>Le.map(Ue=>({uri:p.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Qe=>v.from(Qe))})))}}Ee.from=$e})(ve||(e.MappedEditsContext=ve={}));var Be;(function(Ee){function Me(K){return{start:K.start,end:K.end}}Ee.from=Me;function $e(K){return new r.$2L(K.start,K.end)}Ee.to=$e})(Be||(e.NotebookRange=Be={}));var He;(function(Ee){function Me(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Ee.to=Me;function $e(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Ee.from=$e})(He||(e.NotebookCellExecutionSummary=He={}));var Xe;(function(Ee){function Me($e){if($e===o.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if($e===o.NotebookCellExecutionState.Pending)return;if($e===o.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${$e}`)}Ee.to=Me})(Xe||(e.NotebookCellExecutionState=Xe={}));var st;(function(Ee){function Me(K){switch(K){case r.NotebookCellKind.Markup:return o.CellKind.Markup;case r.NotebookCellKind.Code:default:return o.CellKind.Code}}Ee.from=Me;function $e(K){switch(K){case o.CellKind.Markup:return r.NotebookCellKind.Markup;case o.CellKind.Code:default:return r.NotebookCellKind.Code}}Ee.to=$e})(st||(e.NotebookCellKind=st={}));var pt;(function(Ee){function Me(K){const Le={metadata:K.metadata??Object.create(null),cells:[]};for(const Ue of K.cells)r.$3L.validate(Ue),Le.cells.push(Te.from(Ue));return Le}Ee.from=Me;function $e(K){const Le=new r.$4L(K.cells.map(Te.to));return(0,l.$Pf)(K.metadata)||(Le.metadata=K.metadata),Le}Ee.to=$e})(pt||(e.NotebookData=pt={}));var Te;(function(Ee){function Me(K){return{cellKind:st.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:He.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Kt.from):[]}}Ee.from=Me;function $e(K){return new r.$3L(st.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Kt.to):void 0,K.metadata,K.internalMetadata?He.to(K.internalMetadata):void 0)}Ee.to=$e})(Te||(e.NotebookCellData=Te={}));var Rt;(function(Ee){function Me(K){return{mime:K.mime,valueBytes:T.$fe.wrap(K.data)}}Ee.from=Me;function $e(K){return new r.$5L(K.valueBytes.buffer,K.mime)}Ee.to=$e})(Rt||(e.NotebookCellOutputItem=Rt={}));var Kt;(function(Ee){function Me(K){return{outputId:K.id,items:K.items.map(Rt.from),metadata:K.metadata}}Ee.from=Me;function $e(K){const Le=K.items.map(Rt.to);return new r.$6L(Le,K.outputId,K.metadata)}Ee.to=$e})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Ee){function Me(Le){return K(Le)?{include:_.from(Le.include)??void 0,exclude:_.from(Le.exclude)??void 0}:_.from(Le)??void 0}Ee.from=Me;function $e(Le){return K(Le)?{include:_.to(Le.include),exclude:_.to(Le.exclude)}:_.to(Le)}Ee.to=$e;function K(Le){const Ue=Le;return Ue?!(0,l.$Lf)(Ue.include)&&!(0,l.$Lf)(Ue.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var wt;(function(Ee){function Me($e,K,Le){const Ue=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{alignment:$e.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ue,Le),text:$e.text,tooltip:$e.tooltip,accessibilityInformation:$e.accessibilityInformation,priority:$e.priority}}Ee.from=Me})(wt||(e.NotebookStatusBarItem=wt={}));var Ut;(function(Ee){function Me($e,K,Le){const Ue=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{command:K.toInternal(Ue,Le),label:$e.label,description:$e.description,detail:$e.detail,documentation:$e.documentation}}Ee.from=Me})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Ot;(function(Ee){function Me($e){return{transientOutputs:$e?.transientOutputs??!1,transientCellMetadata:$e?.transientCellMetadata??{},transientDocumentMetadata:$e?.transientDocumentMetadata??{},cellContentMetadata:$e?.cellContentMetadata??{}}}Ee.from=Me})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Gt;(function(Ee){function Me(K){return{uri:K.uri,provides:K.provides}}Ee.from=Me;function $e(K){return new r.$8L(p.URI.revive(K.uri),K.provides)}Ee.to=$e})(Gt||(e.NotebookRendererScript=Gt={}));var Bt;(function(Ee){function Me(K){return{message:A.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:v.from(K.location.range),uri:K.location.uri}}}Ee.from=Me;function $e(K){const Le=new r.$bM(typeof K.message=="string"?K.message:A.to(K.message));return Le.actualOutput=K.actual,Le.expectedOutput=K.expected,Le.contextValue=K.contextValue,Le.location=K.location?Se.to(K.location):void 0,Le}Ee.to=$e})(Bt||(e.TestMessage=Bt={}));var kt;(function(Ee){Ee.namespace=d.$zJ,Ee.denamespace=d.$AJ})(kt||(e.TestTag=kt={}));var Tt;(function(Ee){function Me(K){const Le=(0,t.$AM)(K).controllerId;return{extId:c.$vJ.fromExtHostTestItem(K,Le).toString(),label:K.label,uri:p.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Ue=>kt.namespace(Le,Ue.id)),range:b.$Ds.lift(v.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&A.fromStrict(K.error)||null}}Ee.from=Me;function $e(K){return{parent:void 0,error:void 0,id:c.$vJ.fromString(K.extId).localId,label:K.label,uri:p.URI.revive(K.uri),tags:(K.tags||[]).map(Le=>{const{tagId:Ue}=kt.denamespace(Le);return new r.$cM(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:v.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Ee.toPlain=$e})(Tt||(e.TestItem=Tt={})),function(Ee){function Me(K){return{id:K.id}}Ee.from=Me;function $e(K){return new r.$cM(K.id)}Ee.to=$e}(kt||(e.TestTag=kt={}));var Ze;(function(Ee){const Me=(K,Le)=>{const Ue=[];for(const[qe,et]of Le)c.$vJ.compare(et.item.extId,qe)===2&&(Le.delete(qe),Ue.push(et));const Qe={...Tt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(et=>et.type===0).map(Bt.to)})),children:Ue.map(qe=>Me(qe,Le))};for(const qe of Qe.children)qe.parent=Qe;return Qe};function $e(K){const Le=[],Ue=new Map;for(const Qe of K.items){Ue.set(Qe.item.extId,Qe);const qe=c.$vJ.root(Qe.item.extId);K.request.targets.some(et=>et.controllerId===qe&&et.testIds.includes(Qe.item.extId))&&Le.push(Qe)}return{completedAt:K.completedAt,results:Le.map(Qe=>Me(Qe,Ue))}}Ee.to=$e})(Ze||(e.TestResults=Ze={}));var Jt;(function(Ee){function Me(Ue){return{covered:Ue.covered,total:Ue.covered}}function $e(Ue){return"line"in Ue?D.from(Ue):v.from(Ue)}function K(Ue){return"branches"in Ue?{count:Ue.executionCount,location:$e(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&$e(Qe.location)})):void 0}:{type:0,count:Ue.executionCount,location:$e(Ue.location)}}Ee.fromDetailed=K;function Le(Ue){return{uri:Ue.uri,statement:Me(Ue.statementCoverage),branch:Ue.branchCoverage&&Me(Ue.branchCoverage),function:Ue.functionCoverage&&Me(Ue.functionCoverage),details:Ue.detailedCoverage?.map(K)}}Ee.fromFile=Le})(Jt||(e.TestCoverage=Jt={}));var Wt;(function(Ee){function Me($e){switch($e){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Ee.to=Me})(Wt||(e.CodeActionTriggerKind=Wt={}));var ct;(function(Ee){function Me(K){const Le=new r.$iM(be.to(K.kind),K.name,K.detail||"",p.URI.revive(K.uri),v.to(K.range),v.to(K.selectionRange));return Le._sessionId=K._sessionId,Le._itemId=K._itemId,Le}Ee.to=Me;function $e(K,Le,Ue){if(Le=Le??K._sessionId,Ue=Ue??K._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,kind:be.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:v.from(K.range),selectionRange:v.from(K.selectionRange),tags:K.tags?.map(ie.from)}}Ee.from=$e})(ct||(e.TypeHierarchyItem=ct={}));var ft;(function(Ee){function Me($e){if($e)return{value:$e.value,tooltip:$e.tooltip}}Ee.from=Me})(ft||(e.ViewBadge=ft={}));var Vt;(function(Ee){function Me(Ue,Qe,qe){const et=Qe.fileData;return et?new r.$tL(new r.$uL(et.name,p.URI.revive(et.uri),et.id,(0,M.$cb)(()=>qe(et.id)))):Ue===R.$Zr.uriList&&Qe.uriListData?new r.$sL(Le(Qe.uriListData)):new r.$sL(Qe.asString)}Ee.to=Me;async function $e(Ue,Qe){const qe=await Qe.asString();if(Ue===R.$Zr.uriList)return{asString:qe,fileData:void 0,uriListData:K(qe)};const et=Qe.asFile();return{asString:qe,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ee.from=$e;function K(Ue){return C.$at.split(Ue).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return p.URI.parse(Qe)}catch{}return Qe})}function Le(Ue){return C.$at.create(Ue.map(Qe=>typeof Qe=="string"?Qe:p.URI.revive(Qe)))}})(Vt||(e.DataTransferItem=Vt={}));var At;(function(Ee){function Me(K,Le){const Ue=K.items.map(([Qe,qe])=>[Qe,Vt.to(Qe,qe,Le)]);return new r.$vL(Ue)}Ee.toDataTransfer=Me;async function $e(K){const Le={items:[]},Ue=[];for(const[Qe,qe]of K)Ue.push((async()=>{Le.items.push([Qe,await Vt.from(Qe,qe)])})());return await Promise.all(Ue),Le}Ee.from=$e})(At||(e.DataTransfer=At={}));var Dt;(function(Ee){function Me($e){return{kind:"reply",message:$e.message,title:$e.title,tooltip:$e.tooltip}}Ee.from=Me})(Dt||(e.ChatReplyFollowup=Dt={}));var gt;(function(Ee){function Me($e){return typeof $e=="string"?{title:$e,message:$e,kind:"reply"}:"commandId"in $e?{kind:"command",title:$e.title??"",commandId:$e.commandId??"",when:$e.when??"",args:$e.args}:Dt.from($e)}Ee.from=Me})(gt||(e.ChatFollowup=gt={}));var Mt;(function(Ee){function Me(K){const Le=new r.$tM(Pt.to(K.role),K.content);return Le.name=K.name,Le}Ee.to=Me;function $e(K){return{role:Pt.from(K.role),content:K.content,name:K.name}}Ee.from=$e})(Mt||(e.ChatMessage=Mt={}));var Pt;(function(Ee){function Me(K){switch(K){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Ee.to=Me;function $e(K){switch(K){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Ee.from=$e})(Pt||(e.ChatMessageRole=Pt={}));var St;(function(Ee){function Me(Le){const Ue={};for(const Qe of Object.keys(Le))Ue[Qe]=Le[Qe].map(Ee.to);return Ue}Ee.objectTo=Me;function $e(Le){return{level:Ve.to(Le.level),value:Le.value,description:Le.description}}Ee.to=$e;function K(Le){return{level:Ve.from(Le.level),value:Le.value,description:Le.description}}Ee.from=K})(St||(e.ChatVariable=St={}));var Ve;(function(Ee){function Me(K){switch(K){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Ee.to=Me;function $e(K){switch(K){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Ee.from=$e})(Ve||(e.ChatVariableLevel=Ve={}));var Nt;(function(Ee){function Me($e){switch($e){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Ee.to=Me})(Nt||(e.InteractiveEditorResponseFeedbackKind=Nt={}));var zt;(function(Ee){function Me($e,K){return"placeholder"in K&&"resolvedContent"in K?{content:K.placeholder,kind:"asyncContent"}:"markdownContent"in K?((0,u.$QF)($e,"chatAgents2Additions"),{content:A.from(K.markdownContent),kind:"markdownContent"}):"content"in K?"vulnerabilities"in K&&K.vulnerabilities?((0,u.$QF)($e,"chatAgents2Additions"),{content:K.content,vulnerabilities:K.vulnerabilities,kind:"vulnerability"}):typeof K.content=="string"?{content:K.content,kind:"content"}:((0,u.$QF)($e,"chatAgents2Additions"),{content:A.from(K.content),kind:"markdownContent"}):"documents"in K?{documents:K.documents.map(Le=>({uri:Le.uri,version:Le.version,ranges:Le.ranges.map(Ue=>v.from(Ue))})),kind:"usedContext"}:"reference"in K?{reference:"uri"in K.reference?{uri:K.reference.uri,range:v.from(K.reference.range)}:K.reference,kind:"reference"}:"inlineReference"in K?{inlineReference:"uri"in K.inlineReference?{uri:K.inlineReference.uri,range:v.from(K.inlineReference.range)}:K.inlineReference,name:K.title,kind:"inlineReference"}:"agentName"in K?((0,u.$QF)($e,"chatAgents2Additions"),{agentName:K.agentName,command:K.command,kind:"agentDetection"}):"treeData"in K?{treeData:K.treeData,kind:"treeData"}:"message"in K?{content:K.message,kind:"progressMessage"}:void 0}Ee.from=Me})(zt||(e.ChatResponseProgress=zt={}));var Qt;(function(Ee){function Me($e,K,Le){return"terminalCommand"in $e?{terminalCommand:$e.terminalCommand,shouldExecute:$e.shouldExecute}:"uri"in $e?{uri:$e.uri}:K.toInternal($e,Le)}Ee.from=Me})(Qt||(e.TerminalQuickFix=Qt={}))}),define(Pe[219],Re([1,0,2,11,7,8,185]),function(pe,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;class ${constructor(y,R,S,l={timeout:1500,errors:3}){this.c=y,this.d=R,this.f=S,this.g=l,this.a=new P.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(R,S,l)=>{const b={dispose:this.a.push([R,S,y])};return Array.isArray(l)&&l.push(b),b}}async $participateInSave(y,R){const S=E.URI.revive(y);let l=!1;const p=setTimeout(()=>l=!0,this.g.timeout),b=[];try{for(const a of[...this.a]){if(l)break;const s=this.d.getDocument(S),t=await this.h(a,{document:s,reason:M.TextDocumentSaveReason.to(R)});b.push(t)}}finally{clearTimeout(p)}return b}h([y,R,S],l){const p=this.b.get(y);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(S,y,R,l).then(()=>!0,b=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(b),!(b instanceof Error)||b.message!=="concurrent_edits"){const a=this.b.get(y);this.b.set(y,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,R,S,l){const p=[],b=Date.now(),{document:a,reason:s}=l,{version:t}=a,n=Object.freeze({document:a,reason:s,waitUntil(o){if(Object.isFrozen(p))throw(0,T.$7)("waitUntil can not be called async");p.push(Promise.resolve(o))}});try{R.apply(S,[n])}catch(o){return Promise.reject(o)}return Object.freeze(p),new Promise((o,c)=>{const d=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(p).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-b}ms`),clearTimeout(d),o(i)}).catch(i=>{clearTimeout(d),c(i)})}).then(o=>{const c={edits:[]};for(const d of o)if(Array.isArray(d)&&d.every(i=>i instanceof C.$LK))for(const{newText:i,newEol:r,range:u}of d)c.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:u&&M.Range.from(u),text:i,eol:r&&M.EndOfLine.from(r)}});if(c.edits.length!==0)return t===a.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$yfc=$}),define(Pe[220],Re([1,0,13,2,8,7,76]),function(pe,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=void 0;class ${constructor(S,l,p,b){this.start=S,this.deletedCount=l,this.deletedItems=p,this.items=b}asApiEvent(){return{range:new M.$2L(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(S,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,l,p){this.notebook=S,this.h=l,this.j=p,this.handle=p.handle,this.uri=T.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return S.g},set mime(b){S.g=b},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(p)}return this.f}setOutputs(S){this.a=S.map(C.NotebookCellOutput.to)}setOutputItems(S,l,p){const b=p.map(C.NotebookCellOutputItem.to),a=this.a.find(s=>s.id===S);if(a&&(l||(a.items.length=0),a.items.push(...b),a.items.length>1&&a.items.every(s=>P.$HI(s.mime)))){const s=new Map,t=[];a.items.forEach(n=>{let o;s.has(n.mime)?o=s.get(n.mime):(o=[],s.set(n.mime,o),t.push(n.mime)),o.push(n.data)}),a.items.length=0,t.forEach(n=>{const o=P.$II(s.get(n));a.items.push({mime:n,data:o.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$Dfc=m;class y{static{this.a=0}constructor(S,l,p,b,a){this.k=S,this.l=l,this.m=p,this.uri=b,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,l={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===E.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(p){return p=S.n(p),S.b[p].apiCell},getCells(p){return(p?S.p(p):S.b).map(a=>a.apiCell)},save(){return S.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,l,p){this.g=S.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:p});const b={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},a=[];for(const t of S.rawEvents)t.kind===P.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,b.contentChanges):t.kind===P.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,b.contentChanges):t.kind===P.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),a.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===P.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),a.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===P.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),a.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===P.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===P.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===P.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),a.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),a.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const s=new Map;for(let t=0;t<a.length;t++){const n=a[t],o=s.get(n.cell);if(o===void 0){const c=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});s.set(n.cell,c-1)}else b.cellChanges[o]={...b.cellChanges[o],...n}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let l=S.start|0,p=S.end|0;return l<0&&(l=0),p>this.b.length&&(p=this.b.length),S.with({start:l,end:p})}p(S){S=this.o(S);const l=[];for(let p=S.start;p<S.end;p++)l.push(this.b[p]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,l,p){if(this.j)return;const b=[],a=[],s=[];if(S.reverse().forEach(t=>{const o=t[2].map(i=>{const r=new m(this,this.l,i);return l||a.push(m.asModelAddData(this.apiNotebook,i)),r}),c=new $(t[0],t[1],[],o),d=this.b.splice(t[0],t[1],...o);for(const i of d)s.push(i.uri),c.deletedItems.push(i.apiCell);b.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:s}),p)for(const t of b)p.push(t.asApiEvent())}s(S,l,p,b){const a=this.b.splice(S,l);this.b.splice(p,0,...a);const s=[new $(S,l,a.map(t=>t.apiCell),[]),new $(p,0,[],a)];for(const t of s)b.push(t.asApiEvent())}t(S,l){this.b[S].setOutputs(l)}u(S,l,p,b){this.b[S].setOutputItems(l,p,b)}v(S,l){const p=this.b[S];p.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(p.uri,l)}w(S,l){const p=this.b[S];p.apiCell.mime=l}x(S,l){this.b[S].setMetadata(l)}y(S,l){this.b[S].setInternalMetadata(l)}getCellFromApiCell(S){return this.b.find(l=>l.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(l=>l.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$Efc=y}),define(Pe[221],Re([1,0,5,2,8,7]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=void 0;class P{constructor(m,y,R,S={timeout:1500,errors:3}){this.b=m,this.c=y,this.d=R,this.f=S,this.a=new E.$Td}dispose(){}getOnWillSaveNotebookDocumentEvent(m){return(y,R,S)=>{const l=function(b){y.call(R,b)};return l.extension=m,this.a.event(l,void 0,S)}}async $participateInSave(m,y,R){const S=T.URI.revive(m),l=this.c.getNotebookDocument(S);if(!l)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:C.TextDocumentSaveReason.to(y)},R,async(a,s)=>{const t=Date.now(),n=await await Promise.resolve(a);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!R.isCancellationRequested&&n&&(n instanceof M.$OK?p.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(p.length===0)return!0;const b={edits:[]};for(const a of p){const{edits:s}=C.WorkspaceEdit.from(a);b.edits=b.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(b)}}e.$Ufc=P}),define(Pe[106],Re([1,0,11,8,7]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,m,y,R,S,l){this.id=$,this.f=m,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=R,this.c=l}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(m){this.selections=[m]},get selections(){return $.a},set selections(m){if(!Array.isArray(m)||!m.every(C.$2L.isNotebookRange))throw(0,E.$6)("selections");$.a=m,$.g(m)},get visibleRanges(){return $.b},revealRange(m,y){$.f.$tryRevealRange($.id,T.NotebookRange.from(m),y??C.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(T.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$Ffc=M}),define(Pe[222],Re([1,0,11,5,15,8]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=void 0;let P=class{constructor(m,y){this.c=m,this.d=y,this.a=new T.$Rd({onListenerError:E.$1}),this.b=new T.$Rd({onListenerError:E.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,y);const R=this.d.getEditorById(m);y.visibleRanges&&R._acceptVisibleRanges(y.visibleRanges.ranges.map(M.NotebookRange.to)),y.selections&&R._acceptSelections(y.selections.selections.map(M.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const y in m)this.d.getEditorById(y)._acceptViewColumn(M.ViewColumn.to(m[y]))}};e.$Wfc=P,e.$Wfc=P=Ke([We(0,C.$hj)],P)}),define(Pe[223],Re([1,0,8,72,162,19,66,11]),function(pe,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;class m{constructor(l){this.b=0,this.c=new Map,this.a=l}async withProgress(l,p,b){const a=this.b++,{title:s,location:t,cancellable:n}=p,o={label:(0,C.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this.a.$startProgress(a,{location:E.ProgressLocation.from(t),title:s,source:o,cancellable:n},l.isUnderDevelopment?void 0:l.identifier.value).catch($.$1),this.d(a,b,!!n)}d(l,p,b){let a;b&&(a=new M.$2d,this.c.set(l,a));const s=n=>{this.a.$progressEnd(n),this.c.delete(n),a?.dispose()};let t;try{t=p(new R(this.a,l),b&&a?a.token:M.CancellationToken.None)}catch(n){throw s(l),n}return t.then(n=>s(l),n=>s(l)),t}$acceptProgressCanceled(l){const p=this.c.get(l);p&&(p.cancel(),this.c.delete(l))}}e.$4fc=m;function y(S,l){return S.message=l.message,typeof l.increment=="number"&&(typeof S.increment=="number"?S.increment+=l.increment:S.increment=l.increment),S}class R extends T.$cv{constructor(l,p){super(b=>this.throttledReport(b)),this.c=l,this.d=p}throttledReport(l){this.c.$progressReport(this.d,l)}}Ke([(0,P.$th)(100,(S,l)=>y(S,l),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Pe[107],Re([1,0,29,103,48,77,58,8,2]),function(pe,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=e.$SM=e.$RM=e.$QM=void 0;const y=(o,c,d,i)=>{let r=c;return{enumerable:!0,configurable:!1,get(){return r},set(u){if(!d(r,u)){const f=r;r=u,o.listener?.(i(u,f))}}}},R=(o,c)=>o===c,S={range:(o,c)=>o===c?!0:!o||!c?!1:o.isEqual(c),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(o,c)=>!(o.length!==c.length||o.some(d=>!c.find(i=>d.id===i.id)))},l=o=>c=>({op:4,update:o(c)}),p=(o,c)=>({range:(()=>{let d;const i=l(r=>({range:E.$Ds.lift($.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return d},set(r){o.listener?.({op:6}),S.range(d,r)||(d=r,o.listener?.(i(r)))}}})(),label:y(o,c,S.label,l(d=>({label:d}))),description:y(o,void 0,S.description,l(d=>({description:d}))),sortText:y(o,void 0,S.sortText,l(d=>({sortText:d}))),canResolveChildren:y(o,!1,S.canResolveChildren,d=>({op:2,state:d})),busy:y(o,!1,S.busy,l(d=>({busy:d}))),error:y(o,void 0,S.error,l(d=>({error:$.MarkdownString.fromStrict(d)||null}))),tags:y(o,[],S.tags,(d,i)=>({op:1,new:d.map($.TestTag.from),old:i.map($.TestTag.from)}))}),b=o=>{const c=C.$vJ.fromString(o.extId),d=new s(c.controllerId,c.localId,o.label,m.URI.revive(o.uri)||void 0);return d.range=$.Range.to(o.range||void 0),d.description=o.description||void 0,d.sortText=o.sortText||void 0,d.tags=o.tags.map(i=>$.TestTag.to({id:(0,P.$AJ)(i).tagId})),d},a=o=>{let c;for(const d of o.tests){const i=b(d.item);(0,T.$AM)(i).parent=c,c=i}return c};e.$QM=a;class s{constructor(c,d,i,r){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const u=(0,T.$zM)(this,c);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof t?void 0:u.parent}},children:{value:(0,M.$yM)(u,T.$AM,s),enumerable:!0,writable:!1},...p(u,i)})}}e.$RM=s;class t extends s{constructor(c,d){super(c,c,d,void 0),this._isRoot=!0}}e.$SM=t;class n extends M.$uM{constructor(c,d,i){super({controllerId:c,getDocumentVersion:r=>r&&i.getDocument(r)?.version,getApiFor:T.$AM,getChildren:r=>r.children,root:new t(c,d),toITestItem:$.TestItem.from})}}e.$TM=n}),define(Pe[108],Re([1,0,53,11,89,8,7]),function(pe,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=e.$LM=void 0;class ${static{this.c=new C.$JM("TextEditorDecorationType")}constructor(l,p,b){const a=$.c.nextId();l.$registerTextEditorDecorationType(p.identifier,a,M.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:a,dispose(){l.$removeTextEditorDecorationType(a)}})}}e.$LM=$;class m{constructor(l,p){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,p){this.k();let b=null;if(l instanceof P.$FK)b=new P.$GK(l,l);else if(l instanceof P.$GK)b=l;else throw new Error("Unrecognized location");this.l(b,p,!1)}insert(l,p){this.k(),this.l(new P.$GK(l,l),p,!0)}delete(l){this.k();let p=null;if(l instanceof P.$GK)p=l;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(l,p,b){const a=this.c.validateRange(l);this.g.push({range:a,text:p,forceMoveMarkers:b})}setEndOfLine(l){if(this.k(),l!==P.EndOfLine.LF&&l!==P.EndOfLine.CRLF)throw(0,T.$6)("endOfLine");this.h=l}}class y{constructor(l,p,b,a){this.c=l,this.d=p,this._accept(b),this.e=a;const s=this;this.value={get tabSize(){return s.f},set tabSize(t){s.m(t)},get indentSize(){return s.g},set indentSize(t){s.o(t)},get insertSpaces(){return s.h},set insertSpaces(t){s.q(t)},get cursorStyle(){return s.j},set cursorStyle(t){s.s(t)},get lineNumbers(){return s.k},set lineNumbers(t){s.t(t)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.insertSpaces,this.j=l.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(l.lineNumbers)}l(l){if(l==="auto")return"auto";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}m(l){const p=this.l(l);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}o(l){const p=this.n(l);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(l){return l==="auto"?"auto":l==="false"?!1:!!l}q(l){const p=this.p(l);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(l){this.j!==l&&(this.j=l,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}t(l){this.k!==l&&(this.k=l,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(l)})))}assign(l){const p={};let b=!1;if(typeof l.tabSize<"u"){const a=this.l(l.tabSize);a==="auto"?(b=!0,p.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,b=!0,p.tabSize=a)}if(typeof l.indentSize<"u"){const a=this.n(l.indentSize);a==="tabSize"?(b=!0,p.indentSize=a):typeof a=="number"&&this.g!==a&&(this.g=a,b=!0,p.indentSize=a)}if(typeof l.insertSpaces<"u"){const a=this.p(l.insertSpaces);a==="auto"?(b=!0,p.insertSpaces=a):this.h!==a&&(this.h=a,b=!0,p.insertSpaces=a)}typeof l.cursorStyle<"u"&&this.j!==l.cursorStyle&&(this.j=l.cursorStyle,b=!0,p.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.k!==l.lineNumbers&&(this.k=l.lineNumbers,b=!0,p.lineNumbers=M.TextEditorLineNumbersStyle.from(l.lineNumbers)),b&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(l,p){p.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(b)})}}e.$MM=y;class R{constructor(l,p,b,a,s,t,n,o){this.id=l,this.j=p,this.k=b,this.g=!1,this.h=new Set,this.c=s,this.d=new y(this.j,this.id,t,b),this.e=n,this.f=o;const c=this;this.value=Object.freeze({get document(){return a.value},set document(d){throw new T.$8("document")},get selection(){return c.c&&c.c[0]},set selection(d){if(!(d instanceof P.$HK))throw(0,T.$6)("selection");c.c=[d],c.l()},get selections(){return c.c},set selections(d){if(!Array.isArray(d)||d.some(i=>!(i instanceof P.$HK)))throw(0,T.$6)("selections");c.c=d,c.l()},get visibleRanges(){return c.e},set visibleRanges(d){throw new T.$8("visibleRanges")},get options(){return c.d.value},set options(d){c.g||c.d.assign(d)},get viewColumn(){return c.f},set viewColumn(d){throw new T.$8("viewColumn")},edit(d,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new m(a.value,i);return d(r),c.m(r)},insertSnippet(d,i,r={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=c.c.map(f=>M.Range.from(f));else if(i instanceof P.$FK){const{lineNumber:f,column:v}=M.Position.from(i);u=[{startLineNumber:f,startColumn:v,endLineNumber:f,endColumn:v}]}else if(i instanceof P.$GK)u=[M.Range.from(i)];else{u=[];for(const f of i)if(f instanceof P.$GK)u.push(M.Range.from(f));else{const{lineNumber:v,column:g}=M.Position.from(f);u.push({startLineNumber:v,startColumn:g,endLineNumber:v,endColumn:g})}}return p.$tryInsertSnippet(l,a.value.version,d.value,u,r)},setDecorations(d,i){const r=i.length===0;r&&!c.h.has(d.key)||(r?c.h.delete(d.key):c.h.add(d.key),c.n(()=>{if(M.$BM(i))return p.$trySetDecorations(l,d.key,M.$CM(i));{const u=new Array(4*i.length);for(let f=0,v=i.length;f<v;f++){const g=i[f];u[4*f]=g.start.line+1,u[4*f+1]=g.start.character+1,u[4*f+2]=g.end.line+1,u[4*f+3]=g.end.character+1}return p.$trySetDecorationsFast(l,d.key,u)}}))},revealRange(d,i){c.n(()=>p.$tryRevealRange(l,M.Range.from(d),i||P.TextEditorRevealType.Default))},show(d){p.$tryShowEditor(l,M.ViewColumn.from(d))},hide(){p.$tryHideEditor(l)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,E.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,E.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,E.ok)(!this.g),this.f=l}_acceptSelections(l){(0,E.ok)(!this.g),this.c=l}async l(){const l=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const p=l.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const b=p.edits.map(s=>s.range);b.sort((s,t)=>s.end.line===t.end.line?s.end.character===t.end.character?s.start.line===t.start.line?s.start.character-t.start.character:s.start.line-t.start.line:s.end.character-t.end.character:s.end.line-t.end.line);for(let s=0,t=b.length-1;s<t;s++){const n=b[s].end;if(b[s+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=p.edits.map(s=>({range:M.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,a,{setEndOfLine:typeof p.setEndOfLine=="number"?M.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$NM=R}),define(Pe[224],Re([1,0,166,25,2,5,6,204,14,7,16,18,8,52,19,131,23]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;function t(c,d){if((0,R.$Cf)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends P.$Rc{constructor(d,i,r){super(),this.f=d,this.g=i,this.h=r,this.a=new Map,this.b=new a.$Y7;function u(f){return f&&f.$treeViewId&&(f.$treeItemHandle||f.$selectedTreeItems||f.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:f=>u(f)?this.r(f):Array.isArray(f)&&f.length>0?f.map(v=>u(v)?this.r(v):v):f})}registerTreeDataProvider(d,i,r){const u=this.createTreeView(d,{treeDataProvider:i},r);return{dispose:()=>u.dispose()}}createTreeView(d,i,r){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=i.dragAndDropController?.dropMimeTypes??[],f=i.dragAndDropController?.dragMimeTypes??[],v=!!i.dragAndDropController?.handleDrag,g=!!i.dragAndDropController?.handleDrop,D=this.m(d,i,r),I={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:u,dragMimeTypes:f,hasHandleDrag:v,hasHandleDrop:g,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(d,I),w={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,s.$QF)(r,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,s.$QF)(r,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(k){(0,p.$ck)(k)&&(0,s.$QF)(r,"treeViewMarkdownMessage"),D.message=k},get title(){return D.title},set title(k){D.title=k},get description(){return D.description},set description(k){D.description=k},get badge(){return D.badge},set badge(k){k!==void 0&&y.ViewBadge.isViewBadge(k)?D.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(D.badge=void 0)},reveal:(k,F)=>D.reveal(k,F),dispose:async()=>{await h,this.a.delete(d),D.dispose()}};return this.B(w),w}$getChildren(d,i){const r=this.a.get(d);return r?r.getChildren(i):Promise.reject(new $.$OE(d))}async $handleDrop(d,i,r,u,f,v,g,D){const I=this.a.get(d);if(!I)return Promise.reject(new $.$OE(d));const h=l.DataTransfer.toDataTransfer(r,async w=>(await this.f.$resolveDropFileData(d,i,w)).buffer);return g===d&&D&&await this.j(h,I,D,f,v),I.onDrop(h,u,f)}async j(d,i,r,u,f){const v=this.b.removeDragOperationTransfer(f);if(v)(await v)?.forEach((g,D)=>{g&&d.set(D,g)});else if(f&&i.handleDrag){const g=i.handleDrag(r,d,u);this.b.addDragOperationTransfer(f,g),await g}return d}async $handleDrag(d,i,r,u){const f=this.a.get(d);if(!f)return Promise.reject(new $.$OE(d));const v=await this.j(new y.$vL,f,i,u,r);if(!(!v||u.isCancellationRequested))return l.DataTransfer.from(v)}async $hasResolve(d){const i=this.a.get(d);if(!i)throw new $.$OE(d);return i.hasResolve}$resolve(d,i,r){const u=this.a.get(d);if(!u)throw new $.$OE(d);return u.resolveTreeItem(i,r)}$setExpanded(d,i,r){const u=this.a.get(d);if(!u)throw new $.$OE(d);u.setExpanded(i,r)}$setSelectionAndFocus(d,i,r){const u=this.a.get(d);if(!u)throw new $.$OE(d);u.setSelectionAndFocus(i,r)}$setVisible(d,i){const r=this.a.get(d);if(!r){if(!i)return;throw new $.$OE(d)}r.setVisible(i)}$changeCheckboxState(d,i){const r=this.a.get(d);if(!r)throw new $.$OE(d);r.setCheckboxState(i)}m(d,i,r){const u=this.B(new o(d,i,this.f,this.g.converter,this.h,r));return this.a.set(d,u),u}r(d){const i=this.a.get(d.$treeViewId);return i&&"$treeItemHandle"in d?i.getExtensionElement(d.$treeItemHandle):i&&"$focusedTreeItem"in d&&d.$focusedTreeItem?i.focusedElement:null}}e.$kgc=n;class o extends P.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(d=>this.getExtensionElement(d)).filter(d=>!(0,R.$Lf)(d))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(d,i,r,u,f,v){if(super(),this.I=d,this.J=r,this.L=u,this.M=f,this.N=v,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Rd),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Rd),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Rd),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Rd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Rd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Rd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Rd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new b.$2d,v.contributes&&v.contributes.views)for(const h in v.contributes.views)for(const w of v.contributes.views[h])w.id===d&&(this.P=w.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>this.F.fire({message:!1,element:h})));let g,D;const I=M.Event.debounce(this.F.event,(h,w)=>(h||(h={message:!1,elements:[]}),w.element!==!1&&(g||(g=new Promise(k=>D=k),this.G=this.G.then(()=>g)),Array.isArray(w.element)?h.elements.push(...w.element):h.elements.push(w.element)),w.message&&(h.message=!0),h),200,!0);this.B(I(({message:h,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const k=D;return g=null,this.$(w).then(()=>k())})),h&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(d){const i=d?this.getExtensionElement(d):void 0;if(d&&!i)return this.M.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let r=this.X(d);return r||(r=await this.Y(i)),r?r.map(u=>u.item):void 0}getExtensionElement(d){return this.j.get(d)}reveal(d,i){i=i||{select:!0,focus:!1};const r=(0,R.$Lf)(i.select)?!0:i.select,u=(0,R.$Lf)(i.focus)?!1:i.focus,f=(0,R.$Lf)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.G.then(()=>this.S(d)).then(v=>this.W(d,v[v.length-1]).then(g=>this.J.$reveal(this.I,{item:g.item,parentChain:v.map(D=>D.item)},{select:r,focus:u,expand:f})),v=>this.M.error(v)):this.J.$reveal(this.I,void 0,{select:r,focus:u,expand:f})}get message(){return this.O}set message(d){this.O=d,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(d){this.P=d,this.J.$setTitle(this.I,d,this.Q)}get description(){return this.Q}set description(d){this.Q=d,this.J.$setTitle(this.I,this.P,d)}get badge(){return this.R}set badge(d){this.R?.value===d?.value&&this.R?.tooltip===d?.tooltip||(this.R=l.ViewBadge.from(d),this.J.$setBadge(this.I,d))}setExpanded(d,i){const r=this.getExtensionElement(d);r&&(i?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(d,i){const r=!(0,S.$tb)(this.s,d);this.s=d;const u=this.t!==i;this.t=i,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(d){d!==this.r&&(this.r=d,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(d){const i=(await Promise.all(d.map(async r=>{const u=this.getExtensionElement(r.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);i.forEach(r=>{r.treeItem.checkboxState=r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(r=>[r.extensionItem,r.newState])})}async handleDrag(d,i,r){const u=[];for(const f of d){const v=this.getExtensionElement(f);v&&u.push(v)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,i,r),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(d,i,r){const u=i?this.getExtensionElement(i):void 0;if(!(!u&&i||!this.g?.handleDrop))return(0,m.$Sg)(()=>this.g?.handleDrop?this.g.handleDrop(u,d,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(d,i){if(!this.f.resolveTreeItem)return;const r=this.j.get(d);if(r){const u=this.m.get(r);if(u){const f=await this.f.resolveTreeItem(u.extensionItem,r,i)??u.extensionItem;return this.hb(f),u.item.tooltip=this.eb(f.tooltip),u.item.command=this.fb(u.disposableStore,f.command),u.item}}}S(d){return this.U(d).then(i=>i?this.S(i).then(r=>this.W(i,r[r.length-1]).then(u=>(r.push(u),r))):Promise.resolve([]))}U(d){const i=this.m.get(d);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,m.$Sg)(()=>this.f.getParent(d))}W(d,i){const r=this.m.get(d);return r?Promise.resolve(r):(0,m.$Sg)(()=>this.f.getTreeItem(d)).then(u=>this.kb(d,u,i,!0)).then(u=>this.getChildren(i?i.item.handle:void 0).then(()=>{const f=this.getExtensionElement(u);if(f){const v=this.m.get(f);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(d){if(d){let i;if(typeof d=="string"){const r=this.getExtensionElement(d);i=r?this.m.get(r):void 0}else i=d;return i&&i.children||void 0}return this.h}async Y(d){this.rb(d);const i=new b.$2d(this.Z.token);try{const r=d?this.m.get(d):void 0,u=await this.f.getChildren(d);if(i.token.isCancellationRequested)return;const f=await Promise.all((0,S.$Gb)(u||[]).map(async v=>{const g=await this.f.getTreeItem(v);return g&&!i.token.isCancellationRequested?this.db(v,g,r):null}));return i.token.isCancellationRequested?void 0:(0,S.$Gb)(f)}finally{i.dispose()}}$(d){if(d.some(r=>!r))return this.Z.dispose(!0),this.Z=new b.$2d,this.tb(),this.J.$refresh(this.I);{const r=this.ab(d);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(d){const i=new Set,r=d.map(f=>this.m.get(f));for(const f of r)if(f&&!i.has(f.item.handle)){let v=f;for(;v&&v.parent&&r.findIndex(g=>v&&v.parent&&g&&g.item.handle===v.parent.item.handle)===-1;){const g=this.j.get(v.parent.item.handle);v=g?this.m.get(g):void 0}v&&!v.parent&&i.add(f.item.handle)}const u=[];return i.forEach(f=>{const v=this.j.get(f);if(v){const g=this.m.get(v);g&&(!g.parent||!i.has(g.parent.item.handle))&&u.push(f)}}),u}bb(d){const i={};return Promise.all(d.map(r=>this.cb(r).then(u=>{u&&(i[r]=u.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(d){const i=this.getExtensionElement(d);if(i){const r=this.m.get(i);if(r)return this.rb(i),(0,m.$Sg)(()=>this.f.getTreeItem(i)).then(u=>{if(u){const f=this.ib(i,u,r.parent);return this.pb(i,f,r,r.parent),r.dispose(),f}return null})}return Promise.resolve(null)}db(d,i,r){const u=this.ib(d,i,r);if(i.id&&this.j.has(u.item.handle))throw new Error((0,E.localize)(0,null,i.id));return this.ob(d,u),this.qb(u,r),u}eb(d){return y.$5K.isMarkdownString(d)?l.MarkdownString.from(d):d}fb(d,i){return i?{...this.L.toInternal(i,d),originalId:i.command}:void 0}gb(d){if(d.checkboxState===void 0)return;let i,r,u;return typeof d.checkboxState=="number"?i=d.checkboxState:(i=d.checkboxState.state,r=d.checkboxState.tooltip,u=d.checkboxState.accessibilityInformation),{isChecked:i===y.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:u}}hb(d){if(!y.$qL.isTreeItem(d,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(d,i,r){this.hb(i);const u=this.B(new P.$Qc),f=this.kb(d,i,r),v=this.lb(i);return{item:{handle:f,parentHandle:r?r.item.handle:void 0,label:t(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(u,i.command),contextValue:i.contextValue,icon:v,iconDark:this.mb(i)||v,themeIcon:this.jb(i),collapsibleState:(0,R.$Lf)(i.collapsibleState)?y.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:r,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(d){return d.iconPath instanceof y.$yL?d.iconPath:void 0}kb(d,{id:i,label:r,resourceUri:u},f,v){if(i)return`${o.b}/${i}`;const g=t(r,this.N),D=f?f.item.handle:o.a;let I=g?g.label:u?(0,T.$yg)(u):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const h=this.m.has(d)?this.m.get(d).item.handle:void 0,w=this.X(f)||[];let k,F=0;do{if(k=`${D}/${F}:${I}`,v||!this.j.has(k)||h===k)break;F++}while(F<=w.length);return k}lb(d){if(d.iconPath&&!(d.iconPath instanceof y.$yL))return typeof d.iconPath=="string"||C.URI.isUri(d.iconPath)?this.nb(d.iconPath):this.nb(d.iconPath.light)}mb(d){if(d.iconPath&&!(d.iconPath instanceof y.$yL)&&d.iconPath.dark)return this.nb(d.iconPath.dark)}nb(d){return C.URI.isUri(d)?d:C.URI.file(d)}ob(d,i){this.j.set(i.item.handle,d),this.m.set(d,i)}pb(d,i,r,u){this.j.delete(i.item.handle),this.m.delete(d),i.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(d,i);const f=this.X(u)||[],v=f.filter(g=>g.item.handle===r.item.handle)[0];v&&f.splice(f.indexOf(v),1,i)}qb(d,i){i?(i.children||(i.children=[]),i.children.push(d)):(this.h||(this.h=[]),this.h.push(d))}rb(d){if(d){const i=this.m.get(d);if(i){if(i.children)for(const r of i.children){const u=this.j.get(r.item.handle);u&&this.sb(u)}i.children=void 0}}else this.tb()}sb(d){const i=this.m.get(d);if(i){if(i.children)for(const r of i.children){const u=this.j.get(r.item.handle);u&&this.sb(u)}this.m.delete(d),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(d=>d.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[225],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[226],Re([1,0,178,11,31,96,73,30,22,225,188,100]),function(pe,e,E,T,C,M,P,$,m,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=void 0;const l=$.$qn.as(P.$rn.JSONContribution);class p{constructor(d,i,r){this.a=d,this.b=i,this.c=r}d(d,i){this.a({type:d,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(d){this.d(C.default.Error,d)}warn(d){this.d(C.default.Warning,d)}info(d){this.d(C.default.Info,d)}}e.$WF=p;class b{static a(d){const i=new m.$em;for(let r=0,u=d.length;r<u;r++)i.add(d[r].description.identifier);return i}static compute(d,i){if(!d||!d.length)return new b(i,[]);if(!i||!i.length)return new b([],d);const r=this.a(d),u=this.a(i),f=i.filter(g=>!r.has(g.description.identifier)),v=d.filter(g=>!u.has(g.description.identifier));return new b(f,v)}constructor(d,i){this.added=d,this.removed=i}}e.$XF=b;class a{constructor(d,i){this.name=d,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(d){if(this.a!==null)throw new Error("Handler already set!");this.a=d,this.d()}acceptUsers(d){this.c=b.compute(this.b,d),this.b=d,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(d){(0,T.$Z)(d)}}}e.$YF=a;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$ZF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$cm},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$8n}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$8n}},extensionKind:{description:E.localize(52,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(d){if(this.a.has(d.extensionPoint))throw new Error("Duplicate extension point: "+d.extensionPoint);const i=new a(d.extensionPoint,d.defaultExtensionKind);return this.a.set(d.extensionPoint,i),d.activationEventsGenerator&&S.$BF.register(d.extensionPoint,d.activationEventsGenerator),e.$ZF.properties.contributes.properties[d.extensionPoint]=d.jsonSchema,l.registerSchema(t,e.$ZF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$1F=n;const o={ExtensionsRegistry:"ExtensionsRegistry"};$.$qn.add(o.ExtensionsRegistry,new n),e.$2F=$.$qn.as(o.ExtensionsRegistry),l.registerSchema(t,e.$ZF),l.registerSchema(R.$Aj,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Pe[227],Re([1,0,174,16,26,226,35,5]),function(pe,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$F=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var y;(function(l){function p(b,a,s){if(!b)return;const t=T.$Cf(b.type)?b.type:void 0;if(!t||t.length===0){s.error(E.localize(3,null));return}const n=[];if(Array.isArray(b.required))for(const o of b.required)T.$Cf(o)&&n.push(o);return{extensionId:a.value,taskType:t,required:n,properties:b.properties?C.$en(b.properties):{},when:b.when?P.$Xi.deserialize(b.when):void 0}}l.from=p})(y||(y={}));const R=M.$2F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,p)=>{for(const b of l)b.type&&p.push(`onTaskType:${b.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:m}});class S{constructor(){this.d=new $.$Rd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,b)=>{R.setHandler((a,s)=>{this.c=void 0;try{for(const t of s.removed){const n=t.value;for(const o of n)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const t of s.added){const n=t.value;for(const o of n){const c=y.from(o,t.description.identifier,t.collector);c&&(this.a[c.taskType]=c)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const b of this.all()){const a={type:"object",additionalProperties:!1};b.required.length>0&&(a.required=b.required.slice(0)),b.properties!==void 0?a.properties=C.$en(b.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[b.taskType]},p.push(a)}this.c={oneOf:p}}return this.c}}e.$$F=new S}),define(Pe[228],Re([1,0,175,16,25,26,35,227]),function(pe,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$iG=e.JsonSchemaVersion=e.ExecutionEngine=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$cG=e.ShellQuoting=e.$bG=e.$aG=e.$_F=void 0,e.$_F="settings",e.$aG=new P.$ej("taskRunning",!1,E.localize(0,null)),e.$bG={value:E.localize(1,null),original:"Tasks"};var m;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$cG="$customized",function(L){function O(x){if(!x)return L.Strong;switch(x.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=O}(m||(e.ShellQuoting=m={}));var y;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var R;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(R||(e.RevealKind=R={})),function(L){function O(x){switch(x.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=O}(R||(e.RevealKind=R={}));var S;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(L){function O(x){switch(x.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=O}(S||(e.RevealProblemKind=S={}));var l;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(l||(e.PanelKind=l={})),function(L){function O(x){switch(x.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=O}(l||(e.PanelKind=l={}));var p;(function(L){L.defaults={echo:!0,reveal:R.Always,revealProblems:S.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var b;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(b||(e.RuntimeType=b={})),function(L){function O(le){switch(le.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=O;function x(le){switch(le){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=x}(b||(e.RuntimeType=b={}));var a;(function(L){function O(x){return T.$Cf(x)?x:x.value}L.value=O})(a||(e.CommandString=a={}));var s;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function O(le){return le===L.Clean._id||le===L.Build._id||le===L.Rebuild._id||le===L.Test._id}L.is=O;function x(le){if(le!==void 0)return T.$Cf(le)?O(le)?{_id:le,isDefault:!1}:void 0:le}L.from=x})(s||(e.TaskGroup=s={}));var t;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var n;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function O(x){switch(x){case L.User:return 2;case L.WorkspaceFile:return 5;default:return 6}}L.toConfigurationTarget=O})(n||(e.TaskSourceKind=n={}));var o;(function(L){L.parallel="parallel",L.sequence="sequence"})(o||(e.DependsOrder=o={}));var c;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var d;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(d||(e.RunOptions=d={}));class i{constructor(O,x,le,me,ye,we){this._label="",this._id=O,x&&(this._label=x),le&&(this.type=le),this.runOptions=me,this.configurationProperties=ye,this._source=we}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,x=!1){if(O===void 0)return!1;if(T.$Cf(O))return O===this._label||O===this.configurationProperties.identifier||x&&O===this._id;const le=this.getDefinition(!0);return le!==void 0&&le._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$dG=i;class r extends i{constructor(O,x,le,me,ye,we,de,be){super(O,le,void 0,de,be,x),this.command={},this._source=x,this.hasDefinedMatchers=we,ye&&(this.command=ye)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let x;switch(this.command?this.command.runtime:void 0){case b.Shell:x="shell";break;case b.Process:x="process";break;case b.CustomExecution:x="customExecution";break;case void 0:x="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:x,_key:this._id,id:this._id}}}static is(O){return O instanceof r}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$_F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let x=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(x+=this._source.kind);const le={type:e.$cG,folder:O,id:x};return JSON.stringify(le)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$yg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new r(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$eG=r;class u extends i{constructor(O,x,le,me,ye,we,de){super(O,le,me,we,de,x),this._source=x,this.configures=ye}static is(O){return O instanceof u}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$yg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$_F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let x=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(x+=this._source.kind);const le={type:e.$cG,folder:O,id:x};return JSON.stringify(le)}}e.$fG=u;class f extends i{constructor(O,x,le,me,ye,we,de,be,ie){super(O,le,me,be,ie,x),this.defines=ye,this.hasDefinedMatchers=de,this.command=we,this.icon=ie.icon,this.hide=ie.hide}clone(){return new f(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof f}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new f(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$gG=f;class v extends i{constructor(O,x,le,me,ye,we){super(O,le,me,ye,we,x),this._source=x}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new v(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$hG=v;var g;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(g||(e.ExecutionEngine=g={})),function(L){L._default=L.Terminal}(g||(e.ExecutionEngine=g={}));var D;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(D||(e.JsonSchemaVersion=D={}));class I{constructor(O){this.c=new Map;for(let x=0;x<O.length;x++)this.c.set(O[x].uri.toString(),x)}compare(O,x){const le=O.getWorkspaceFolder(),me=x.getWorkspaceFolder();if(le&&me){let ye=this.c.get(le.uri.toString());ye=ye===void 0?0:ye+1;let we=this.c.get(me.uri.toString());return we=we===void 0?0:we+1,ye===we?O._label.localeCompare(x._label):ye-we}else return!le&&me?-1:le&&!me?1:0}}e.$iG=I;var h;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(h||(e.TaskEventKind=h={}));var w;(function(L){L.SingleRun="singleRun",L.Background="background"})(w||(e.TaskRunType=w={}));var k;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var F;(function(L){function O(be){return{taskId:be._id,taskName:be.configurationProperties.name,runType:be.configurationProperties.isBackground?"background":"singleRun",group:be.configurationProperties.group,__task:be}}function x(be,ie,Ie){return{...O(be),kind:"start",terminalId:ie,resolvedVariables:Ie}}L.start=x;function le(be,ie,Ie){return{...O(be),kind:"processStarted",terminalId:ie,processId:Ie}}L.processStarted=le;function me(be,ie,Ie){return{...O(be),kind:"processEnded",terminalId:ie,exitCode:Ie}}L.processEnded=me;function ye(be,ie,Ie){return{...O(be),kind:"terminated",exitReason:Ie,terminalId:ie}}L.terminated=ye;function we(be,ie,Ie){return{...O(ie),kind:be,terminalId:Ie}}L.general=we;function de(){return{kind:"changed"}}L.changed=de})(F||(e.TaskEvent=F={}));var W;(function(L){function O(le){const me=Object.keys(le).sort();let ye="";for(const we of me){let de=le[we];de instanceof Object?de=O(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),ye+=we+","+de+","}return ye}function x(le){const ye={_key:O(le),type:le.taskType};return Object.assign(ye,le),ye}L.create=x})(W||(e.KeyedTaskIdentifier=W={}));var Q;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection",L.VerboseLogging="task.verboseLogging"})(Q||(e.TaskSettingId=Q={}));var N;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(N||(e.TasksSchemaProperties=N={}));var A;(function(L){function O(x,le){const me=$.$$F.get(x.type);if(me===void 0){const be=M.$en(x);return delete be._key,W.create(be)}const ye=Object.create(null);ye.type=me.taskType;const we=new Set;me.required.forEach(be=>we.add(be));const de=me.properties;for(const be of Object.keys(de)){const ie=x[be];if(ie!=null)ye[be]=ie;else if(we.has(be)){const Ie=de[be];if(Ie.default!==void 0)ye[be]=M.$en(Ie.default);else switch(Ie.type){case"boolean":ye[be]=!1;break;case"number":case"integer":ye[be]=0;break;case"string":ye[be]="";break;default:le.error(E.localize(2,null,JSON.stringify(x,void 0,0),be));return}}}return W.create(ye)}L.createTaskIdentifier=O})(A||(e.TaskDefinition=A={}))}),define(Pe[229],Re([1,0,11]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C6b=e.$B6b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((P,$)=>{this.b=P,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(P){this.f||this.h||(this.f=!0,this.g=P,this.a&&this.b(P))}resolveErr(P){this.f||this.h||(this.h=!0,this.i=P,this.a?this.d(P):(0,E.$Z)(P))}then(P,$){return this.j().then(P,$)}catch(P){return this.j().then(void 0,P)}finally(P){return this.j().finally(P)}}e.$B6b=T;class C extends T{constructor(){super(),this.h=!0,this.i=new E.$4}}e.$C6b=C}),define(Pe[49],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.$xv=void 0;class E{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++E.count}}e.$xv=E;const T=[];function C($){const m=new E($);return T[m.nid]=m,m}e.$yv=C;function M($){return T[$].sid}e.$zv=M;class P{constructor(m){this.value=m}}e.$Av=P}),define(Pe[3],Re([1,0,49]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DK=e.$CK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$BK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var C;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput"})(C||(e.TabInputKind=C={}));var M;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var P;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(P||(e.WebviewEditorCapabilities=P={}));var $;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var m;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var y;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var R;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class S{static{this.a=0}static mixin(s){return s._id=S.a++,s}}e.$BK=S;var l;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var p;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var b;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$CK={MainThreadAuthentication:(0,E.$yv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$yv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$yv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$yv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$yv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$yv)("MainThreadClipboard"),MainThreadCommands:(0,E.$yv)("MainThreadCommands"),MainThreadComments:(0,E.$yv)("MainThreadComments"),MainThreadConfiguration:(0,E.$yv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$yv)("MainThreadConsole"),MainThreadDebugService:(0,E.$yv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$yv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$yv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$yv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$yv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$yv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$yv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$yv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$yv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$yv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$yv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$yv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$yv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$yv)("MainThreadLanguages"),MainThreadLogger:(0,E.$yv)("MainThreadLogger"),MainThreadMessageService:(0,E.$yv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$yv)("MainThreadOutputService"),MainThreadProgress:(0,E.$yv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$yv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$yv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$yv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$yv)("MainThreadSecretState"),MainThreadStorage:(0,E.$yv)("MainThreadStorage"),MainThreadSpeech:(0,E.$yv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$yv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$yv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$yv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$yv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$yv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$yv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$yv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$yv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$yv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$yv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$yv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$yv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$yv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$yv)("MainThreadSCM"),MainThreadSearch:(0,E.$yv)("MainThreadSearch"),MainThreadShare:(0,E.$yv)("MainThreadShare"),MainThreadTask:(0,E.$yv)("MainThreadTask"),MainThreadWindow:(0,E.$yv)("MainThreadWindow"),MainThreadLabelService:(0,E.$yv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$yv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$yv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$yv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$yv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$yv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$yv)("MainThreadInteractive"),MainThreadChat:(0,E.$yv)("MainThreadChat"),MainThreadInlineChat:(0,E.$yv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$yv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$yv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$yv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$yv)("MainThreadTimeline"),MainThreadTesting:(0,E.$yv)("MainThreadTesting"),MainThreadLocalization:(0,E.$yv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$yv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$yv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$yv)("MainThreadIssueReporter")},e.$DK={ExtHostCommands:(0,E.$yv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$yv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$yv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$yv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$yv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$yv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$yv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$yv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$yv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$yv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$yv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$yv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$yv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$yv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$yv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$yv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$yv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$yv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$yv)("ExtHostStatusBar"),ExtHostShare:(0,E.$yv)("ExtHostShare"),ExtHostExtensionService:(0,E.$yv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$yv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$yv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$yv)("ExtHostSCM"),ExtHostSearch:(0,E.$yv)("ExtHostSearch"),ExtHostTask:(0,E.$yv)("ExtHostTask"),ExtHostWorkspace:(0,E.$yv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$yv)("ExtHostWindow"),ExtHostWebviews:(0,E.$yv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$yv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$yv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$yv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$yv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$yv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$yv)("ExtHostProgress"),ExtHostComments:(0,E.$yv)("ExtHostComments"),ExtHostSecretState:(0,E.$yv)("ExtHostSecretState"),ExtHostStorage:(0,E.$yv)("ExtHostStorage"),ExtHostUrls:(0,E.$yv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$yv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$yv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$yv)("ExtHostOutputService"),ExtHosLabelService:(0,E.$yv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$yv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$yv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$yv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$yv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$yv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$yv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$yv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$yv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$yv)("ExtHostChat"),ExtHostChatAgents2:(0,E.$yv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$yv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$yv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$yv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$yv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$yv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$yv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$yv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$yv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$yv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$yv)("ExtHostTimeline"),ExtHostTesting:(0,E.$yv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$yv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$yv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$yv)("ExtHostIssueReporter")}}),define(Pe[230],Re([1,0,3,7]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;class C{constructor(P){this.a=new Map,this.b=0,this.c=P.getProxy(E.$CK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(P,$,m){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(P);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation($,m)??[]}getRelatedInformation(P,$,m){return this.c.$getAiRelatedInformation($,m)}registerRelatedInformationProvider(P,$,m){const y=this.b;return this.b++,this.a.set(y,m),this.c.$registerAiRelatedInformationProvider(y,$),new T.$EK(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$kec=C}),define(Pe[81],Re([1,0,4,15,3,17]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=e.$rec=e.$qec=void 0,e.$qec=(0,E.$Zh)("IExtHostApiDeprecationService");let P=class{constructor(m,y){this.c=y,this.a=new Set,this.b=m.getProxy(C.$CK.MainThreadTelemetry)}report(m,y,R){const S=this.d(m,y);this.a.has(S)||(this.a.add(S),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:m}))}d(m,y){return`${m}-${y.identifier.value}`}};e.$rec=P,e.$rec=P=Ke([We(0,M.$EM),We(1,T.$hj)],P),e.$sec=Object.freeze(new class{report($,m,y){}})}),define(Pe[231],Re([1,0,5,3,7,22]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=void 0;class P{constructor(y){this.b=new Map,this.c=[],this.d=new E.$Rd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=y.getProxy(T.$CK.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,R,S,l={}){const p=M.$dm.toKey(y.identifier),b=[...S].sort().join(" ");return await this.f.getOrCreate(`${p} ${R} ${b}`,async()=>{await this.a.$ensureProvider(R);const a=y.displayName||y.name;return this.a.$getSession(R,S,p,a,l)})}async getSessions(y,R,S){const l=M.$dm.toKey(y.identifier),p=[...S].sort().join(" ");return await this.g.getOrCreate(`${l} ${p}`,async()=>{await this.a.$ensureProvider(R);const b=y.displayName||y.name;return this.a.$getSessions(R,S,l,b)})}async removeSession(y,R){const S=this.b.get(y);return S?S.provider.removeSession(R):this.a.$removeSession(y,R)}registerAuthenticationProvider(y,R,S,l){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:R,provider:S,options:l??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===y)||this.c.push({id:y,label:R});const p=S.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(y,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(y,R,l?.supportsMultipleAccounts??!1),new C.$EK(()=>{p.dispose(),this.b.delete(y);const b=this.c.findIndex(a=>a.id===y);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,R,S){const l=this.b.get(y);if(l)return Promise.resolve(l.provider.createSession(R,S));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,R){const S=this.b.get(y);if(S)return Promise.resolve(S.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,R){const S=this.b.get(y);if(S)return Promise.resolve(S.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,R){return this.d.fire({provider:{id:y,label:R}}),Promise.resolve()}}e.$vec=P;class ${constructor(){this.a=new Map}getOrCreate(y,R){const S=this.a.get(y);if(S)return S;const l=R().finally(()=>this.a.delete(y));return this.a.set(y,l),l}}}),define(Pe[232],Re([1,0,3,17,8]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0;let M=class{constructor($,m){this.a=$.getProxy(E.$CK.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>m.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,m,y){const R=C.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,y?.isRefactoring??!1)}};e.$wec=M,e.$wec=M=Ke([We(0,T.$EM)],M)}),define(Pe[233],Re([1,0,5,67,6,3,8]),function(pe,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class ${static{this.a=0}constructor(R,S){this.extension=R,this.provider=S,this.handle=$.a++}}class m{static{this.a=0}constructor(R){this.b=new Map,this.c=new Map,this.d=new E.$Rd,this.onDidPerformUserAction=this.d.event,this.e=R.getProxy(M.$CK.MainThreadChat)}registerChatProvider(R,S,l){const p=new $(R,l);return this.b.set(p.handle,p),this.e.$registerChatProvider(p.handle,S),(0,C.$Pc)(()=>{this.e.$unregisterChatProvider(p.handle),this.b.delete(p.handle)})}transferChatSession(R,S){const l=T.Iterable.find(this.c.keys(),p=>this.c.get(p)===R)??0;typeof l=="number"&&this.e.$transferChatSession(l,S)}sendInteractiveRequestToProvider(R,S){this.e.$sendRequestToProvider(R,S)}async $prepareChat(R,S){const l=this.b.get(R);if(!l)return;const p=await l.provider.prepareSession(S);if(!p)return;const b=m.a++;return this.c.set(b,p),{id:b,requesterUsername:p.requester?.name,requesterAvatarIconUri:p.requester?.icon,responderUsername:p.responder?.name,responderAvatarIconUri:p.responder?.icon,inputPlaceholder:p.inputPlaceholder}}async $provideWelcomeMessage(R,S){const l=this.b.get(R);if(!l||!l.provider.provideWelcomeMessage)return;const p=await l.provider.provideWelcomeMessage(S);if(p)return p.map(b=>typeof b=="string"?b:Array.isArray(b)?b.map(a=>P.ChatReplyFollowup.from(a)):P.MarkdownString.from(b))}async $provideSampleQuestions(R,S){const l=this.b.get(R);if(!l||!l.provider.provideSampleQuestions)return;const p=await l.provider.provideSampleQuestions(S);if(p)return p?.map(b=>P.ChatReplyFollowup.from(b))}$releaseSession(R){this.c.delete(R)}async $onDidPerformUserAction(R){this.d.fire(R)}}e.$xec=m}),define(Pe[234],Re([1,0,14,19,40,5,60,16,2,156,72,3,8,7,205,23]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;class s{static{this.a=0}constructor(o,c,d){this.i=c,this.j=d,this.b=new Map,this.g=new Map,this.h=new Map,this.d=o.getProxy(S.$CK.MainThreadChatAgents2)}createChatAgent(o,c,d){const i=s.a++,r=new t(o,c,this.d,i,d);return this.b.set(i,r),this.d.$registerAgent(i,c,{}),r.apiAgent}async $invokeAgent(o,c,d,i,r,u){this.g.delete(c);const f=this.b.get(o);if(!f)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let v=!1;function g(){if(v)throw new Error("Only valid while executing the command")}const D=new E.$kh;u.onCancellationRequested(()=>D.complete()),setTimeout(()=>D.complete(),10*1e3),this.i.allowListExtensionWhile(f.extension.identifier,D.p);const I=i.command?await f.validateSlashCommand(i.command):void 0,h=P.$Nd.create(!1);let w;try{const k=f.invoke({prompt:i.message,variables:l.ChatVariable.objectTo(i.variables),slashCommand:I},{history:r.history.map(l.ChatMessage.to)},new R.$cv(F=>{g(),typeof w>"u"&&"content"in F&&(w=h.elapsed());const W=l.ChatResponseProgress.from(f.extension,F);if(!W){this.j.error("Unknown progress type: "+JSON.stringify(F));return}if("placeholder"in F&&"resolvedContent"in F){const Q=Promise.all([this.d.$handleProgressChunk(d,W),F.resolvedContent]);(0,E.$Og)(Q,u).then(N=>{if(!N)return;const[A,L]=N,O=l.ChatResponseProgress.from(f.extension,L);if(!O){this.j.error("Unknown progress type: "+JSON.stringify(L));return}this.d.$handleProgressChunk(d,O,A??void 0)})}else this.d.$handleProgressChunk(d,W)}),u);return await(0,E.$Og)(Promise.resolve(k).then(F=>{if(F){this.g.set(c,F);let W=this.h.get(c);W||(W=new Map,this.h.set(c,W)),W.set(d,F);const Q={firstProgress:w,totalElapsed:h.elapsed()};return{errorDetails:F.errorDetails,timings:Q}}else this.g.delete(c)}),u)}catch(k){return this.j.error(k,f.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,C.$Ki)(k)),responseIsIncomplete:!0}}}finally{v=!0,D.complete()}}$releaseSession(o){this.g.delete(o),this.h.delete(o)}async $provideSlashCommands(o,c){const d=this.b.get(o);return d?d.provideSlashCommand(c):[]}$provideFollowups(o,c,d){const i=this.b.get(o);if(!i)return Promise.resolve([]);const r=this.g.get(c);return r?i.provideFollowups(r,d):Promise.resolve([])}$acceptFeedback(o,c,d,i,r){const u=this.b.get(o);if(!u)return;const f=this.h.get(c)?.get(d);if(!f)return;let v;switch(i){case b.InteractiveSessionVoteDirection.Down:v=p.ChatAgentResultFeedbackKind.Unhelpful;break;case b.InteractiveSessionVoteDirection.Up:v=p.ChatAgentResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(r?{result:f,kind:v,reportIssue:r}:{result:f,kind:v}))}$acceptAction(o,c,d,i){const r=this.b.get(o);if(!r)return;const u=this.h.get(c)?.get(d);u&&i.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:i.action,result:u}))}}e.$zec=s;class t{constructor(o,c,d,i,r){this.extension=o,this.s=c,this.t=d,this.u=i,this.w=r,this.o=new M.$Rd,this.q=new M.$Rd}acceptFeedback(o){this.o.fire(o)}acceptAction(o){this.q.fire(o)}async validateSlashCommand(o){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,$.$Mf)(this.b));const c=this.b.find(d=>d.name===o);if(!c)throw new Error(`Unknown slashCommand: ${o}`);return c}async provideSlashCommand(o){if(!this.a)return[];const c=await this.a.provideSlashCommands(o);return c?(this.b=c,c.map(d=>({name:d.name,description:d.description,followupPlaceholder:d.followupPlaceholder,shouldRepopulate:d.shouldRepopulate,sampleRequest:d.sampleRequest}))):[]}async provideFollowups(o,c){if(!this.d)return[];const d=await this.d.provideFollowups(o,c);return d?d.map(i=>l.ChatFollowup.from(i)):[]}get apiAgent(){let o=!1,c=!1;const d=()=>{o||c||(c=!0,queueMicrotask(()=>{this.t.$updateAgent(this.u,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof m.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof p.$yL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),c=!1}))},i=this;return{get name(){return i.s},get description(){return i.g??""},set description(r){i.g=r,d()},get fullName(){return i.h??i.extension.displayName??i.extension.name},set fullName(r){i.h=r,d()},get iconPath(){return i.i},set iconPath(r){i.i=r,d()},get slashCommandProvider(){return i.a},set slashCommandProvider(r){i.a=r,d()},get followupProvider(){return i.d},set followupProvider(r){i.d=r,d()},get isDefault(){return(0,a.$QF)(i.extension,"defaultChatAgent"),i.j},set isDefault(r){(0,a.$QF)(i.extension,"defaultChatAgent"),i.j=r,d()},get helpTextPrefix(){return(0,a.$QF)(i.extension,"defaultChatAgent"),i.k},set helpTextPrefix(r){if((0,a.$QF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPrefix is only available on the default chat agent");i.k=r,d()},get helpTextPostfix(){return(0,a.$QF)(i.extension,"defaultChatAgent"),i.l},set helpTextPostfix(r){if((0,a.$QF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPostfix is only available on the default chat agent");i.l=r,d()},get isSecondary(){return(0,a.$QF)(i.extension,"defaultChatAgent"),i.n},set isSecondary(r){(0,a.$QF)(i.extension,"defaultChatAgent"),i.n=r,d()},get sampleRequest(){return i.m},set sampleRequest(r){i.m=r,d()},get supportIssueReporting(){return(0,a.$QF)(i.extension,"chatAgents2Additions"),i.r},set supportIssueReporting(r){(0,a.$QF)(i.extension,"chatAgents2Additions"),i.r=r,d()},get onDidReceiveFeedback(){return i.o.event},onDidPerformAction:(0,a.$PF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){o=!0,i.a=void 0,i.d=void 0,i.o.dispose(),i.t.$unregisterAgent(i.u)}}}invoke(o,c,d,i){return this.w(o,c,d,i)}}}),define(Pe[235],Re([1,0,19,6,3,8,72,22,14,5]),function(pe,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;class R{constructor(b,a){this.stream=new m.$qh,this.stream=a??new m.$qh;const s=this;this.apiObj={option:b,response:s.stream.asyncIterable}}}class S{constructor(b,a){this.a=new y.$Rd,this.b=new Map,this.c=new m.$qh,this.d=!1;const s=this;this.apiObject={result:b,response:s.c.asyncIterable,onDidStartResponseStream:s.a.event,cancel(){a.cancel()}},b.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,t]of this.b)t.stream.resolve();else this.c.resolve()})}handleFragment(b){if(this.d)return;let a=this.b.get(b.index);a||(this.b.size===0?a=new R(b.index,this.c):a=new R(b.index),this.b.set(b.index,a),this.a.fire(a.apiObj)),a.stream.emitOne(b.part)}}class l{static{this.a=1}constructor(b,a){this.d=a,this.c=new Map,this.e=new Map,this.f=new $.$fm,this.b=b.getProxy(C.$CK.MainThreadChatProvider)}registerProvider(b,a,s,t){const n=l.a++;return this.c.set(n,{extension:b,provider:s}),this.b.$registerProvider(n,a,{extension:b,displayName:t.name??b.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(b,a,s,t,n){const o=this.c.get(b);if(!o)return;const c=new P.$cv(async d=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${o.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(a,{index:d.index,part:d.part})});return o.provider.provideChatResponse(s.map(M.ChatMessage.to),t,c,n)}allowListExtensionWhile(b,a){this.f.set(b,a),a.finally(()=>this.f.delete(b))}async requestChatResponseProvider(b,a){if(!this.f.has(b))throw new Error("Extension is NOT allowed to make chat requests");const s=this;return{get isRevoked(){return!s.f.has(b)},makeRequest(t,n,o){if(!s.f.has(b))throw new Error("Access to chat has been revoked");const c=new E.$2d(o),d=Math.random()*1e6|0,i=s.b.$fetchResponse(b,a,d,t.map(M.ChatMessage.from),n??{},c.token),r=new S(i,c);return s.e.set(d,{res:r}),i.finally(()=>{s.e.delete(d)}),r.apiObject}}}async $handleResponseFragment(b,a){const s=this.e.get(b);s&&s.res.handleFragment(a)}}e.$yec=l}),define(Pe[236],Re([1,0,6,3,11,8]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;class P{static{this.a=0}constructor(m){this.b=new Map,this.c=m.getProxy(T.$CK.MainThreadChatVariables)}async $resolveVariable(m,y,R){const S=this.b.get(m);if(S)try{const l=await S.resolver.resolve(S.data.name,{message:y},R);if(l)return l.map(M.ChatVariable.from)}catch(l){(0,C.$1)(l)}}registerVariableResolver(m,y,R,S){const l=P.a++;return this.b.set(l,{extension:m.identifier,data:{name:y,description:R},resolver:S}),this.c.$registerVariable(l,{name:y,description:R}),(0,E.$Pc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$Aec=P}),define(Pe[237],Re([1,0,3]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=void 0;class T{constructor(M){const P=M.getProxy(E.$CK.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText($){return P.$writeText($)}})}}e.$Bec=T}),define(Pe[32],Re([1,0,16,7,8,26,3,18,15,51,29,130,2,6,4,17,107,24,49,40,60,56,59,33]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s,t,n,o,c,d,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=void 0;let u=class{#e;#t;#i;constructor(h,w,k){this.b=new Map,this.c=new Map,this.#e=h.getProxy(P.$CK.MainThreadCommands),this.d=w,this.#i=k,this.#t=h.getProxy(P.$CK.MainThreadTelemetry),this.converter=new f(this,F=>{const W=this.c.get(F);return W?.result===g.Void?W:void 0},w),this.f=[{processArgument(F){return(0,y.$wh)(F)}},{processArgument(F){return(0,M.$gn)(F,function(W){if(R.$Ds.isIRange(W))return C.Range.to(W);if(S.$Cs.isIPosition(W))return C.Position.to(W);if(R.$Ds.isIRange(W.range)&&l.URI.isUri(W.uri))return C.location.to(W);if(W instanceof t.$fe)return W.buffer.buffer;if(!Array.isArray(W))return W})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const w=this.registerCommand(!1,h.id,async(...k)=>{const F=h.args.map((Q,N)=>{if(!Q.validate(k[N]))throw new Error(`Invalid argument '${Q.name}' when running '${h.id}', received: ${typeof k[N]=="object"?JSON.stringify(k[N],null,"	"):k[N]} `);return Q.convert(k[N])}),W=await this.executeCommand(h.internalId,...F);return h.result.convert(W,k,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new T.$EK(()=>{w.dispose(),this.c.delete(h.id)})}registerCommand(h,w,k,F,W,Q){if(this.d.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this.b.has(w))throw new Error(`command '${w}' already exists`);return this.b.set(w,{callback:k,thisArg:F,metadata:W,extension:Q}),h&&this.#e.$registerCommand(w),new T.$EK(()=>{this.b.delete(w)&&h&&this.#e.$unregisterCommand(w)})}executeCommand(h,...w){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,w,!0)}async g(h,w,k){if(this.b.has(h))return this.#e.$fireCommandActivationEvent(h),this.h(h,w,!1);{let F=!1;const W=(0,M.$gn)(w,function(Q){if(Q instanceof T.$FK)return C.Position.from(Q);if(Q instanceof T.$GK)return C.Range.from(Q);if(Q instanceof T.$QK)return C.location.from(Q);if(T.$2L.isNotebookRange(Q))return C.NotebookRange.from(Q);if(Q instanceof ArrayBuffer)return F=!0,t.$fe.wrap(new Uint8Array(Q));if(Q instanceof Uint8Array)return F=!0,t.$fe.wrap(Q);if(Q instanceof t.$fe)return F=!0,Q;if(!Array.isArray(Q))return Q});try{const Q=await this.#e.$executeCommand(h,F?new n.$Av(W):W,k);return(0,y.$wh)(Q)}catch(Q){if(Q instanceof Error&&Q.message==="$executeCommand:retry")return this.g(h,w,!1);throw Q}}}async h(h,w,k){const F=this.b.get(h);if(!F)throw new Error("Unknown command");const{callback:W,thisArg:Q,metadata:N}=F;if(N?.args)for(let L=0;L<N.args.length;L++)try{(0,E.$Tf)(w[L],N.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${N.args[L].name}' - ${N.args[L].description}`)}const A=c.$Nd.create();try{return await W.apply(Q,w)}catch(L){if(h===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...w);O&&(h=O.command)}if(this.d.error(L,h,F.extension?.identifier),!k)throw L;if(F.extension?.identifier){const O=this.#i.onExtensionError(F.extension.identifier,L);this.d.trace("forwarded error to extension?",O,F.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$Ki)(L)),this.id=h,this.source=F.extension?.displayName??F.extension?.name}}}finally{this.j(F,h,A.elapsed())}}j(h,w,k){h.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new d.$to(w),duration:k})}$executeContributedCommand(h,...w){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const k=this.b.get(h);return k?(w=w.map(F=>this.f.reduce((W,Q)=>Q.processArgument(W,k.extension?.identifier),F)),this.h(h,w,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),this.#e.$getCommands().then(w=>(h&&(w=w.filter(k=>k[0]!=="_")),w))}$getContributedCommandMetadata(){const h=Object.create(null);for(const[w,k]of this.b){const{metadata:F}=k;F&&(h[w]=F)}return Promise.resolve(h)}};e.$ZM=u,e.$ZM=u=Ke([We(0,a.$EM),We(1,m.$hj),We(2,i.$YM)],u),e.$1M=(0,b.$Zh)("IExtHostCommands");class f{constructor(h,w,k){this.d=h,this.f=w,this.g=k,this.delegatingCommandId=`__vsc${(0,r.$kg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,w){if(!h)return;const k={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return k;const F=this.f(h.command);if(F)k.id=F.internalId,k.arguments=F.args.map((W,Q)=>W.convert(h.arguments&&h.arguments[Q]));else if((0,$.$Kb)(h.arguments)){const W=`${h.command} /${++this.c}`;this.b.set(W,h),w.add((0,p.$Pc)(()=>{this.b.delete(W),this.g.trace("CommandsConverter#DISPOSE",W)})),k.$ident=W,k.id=this.delegatingCommandId,k.arguments=[W],this.g.trace("CommandsConverter#CREATE",h.command,W)}return k}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const w=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],w?w.command:"MISSING"),w?this.d.executeCommand(w.command,...w.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.$2M=f;class v{static{this.Uri=new v("uri","Uri of a text document",h=>l.URI.isUri(h),h=>h)}static{this.Position=new v("position","A position in a text document",h=>T.$FK.isPosition(h),C.Position.from)}static{this.Range=new v("range","A range in a text document",h=>T.$GK.isRange(h),C.Range.from)}static{this.Selection=new v("selection","A selection in a text document",h=>T.$HK.isSelection(h),C.Selection.from)}static{this.Number=new v("number","",h=>typeof h=="number",h=>h)}static{this.String=new v("string","",h=>typeof h=="string",h=>h)}static{this.StringArray=v.Arr(v.String)}static Arr(h){return new v(`${h.name}_array`,`Array of ${h.name}, ${h.description}`,w=>Array.isArray(w)&&w.every(k=>h.validate(k)),w=>w.map(k=>h.convert(k)))}static{this.CallHierarchyItem=new v("item","A call hierarchy item",h=>h instanceof T.$1K,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new v("item","A type hierarchy item",h=>h instanceof T.$iM,C.TypeHierarchyItem.from)}static{this.TestItem=new v("testItem","A VS Code TestItem",h=>h instanceof s.$RM,C.TestItem.from)}constructor(h,w,k,F){this.name=h,this.description=w,this.validate=k,this.convert=F}optional(){return new v(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,w){return new v(h??this.name,w??this.description,this.validate,this.convert)}}e.$3M=v;class g{static{this.Void=new g("no result",h=>h)}constructor(h,w){this.description=h,this.convert=w}}e.$4M=g;class D{constructor(h,w,k,F,W){this.id=h,this.internalId=w,this.description=k,this.args=F,this.result=W}}e.$5M=D}),define(Pe[238],Re([1,0,18,13,2,80,95,35,32,8,7]),function(pe,e,E,T,C,M,P,$,m,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;const S=[new m.$5M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$3M.Uri,m.$3M.Position],new m.$4M("A promise that resolves to an array of DocumentHighlight-instances.",p(y.DocumentHighlight.to))),new m.$5M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$3M.Uri],new m.$4M("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,s)=>{if((0,E.$Jb)(a))return;class t extends R.$VK{static to(o){const c=new t(o.name,y.SymbolKind.to(o.kind),o.containerName||"",new R.$QK(s[0],y.Range.to(o.range)));return c.detail=o.detail,c.range=c.location.range,c.selectionRange=y.Range.to(o.selectionRange),c.children=o.children?o.children.map(t.to):[],c}}return a.map(t.to)})),new m.$5M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$3M.Uri,new m.$3M("options","Formatting options",a=>!0,a=>a)],new m.$4M("A promise that resolves to an array of TextEdits.",p(y.TextEdit.to))),new m.$5M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$3M.Uri,m.$3M.Range,new m.$3M("options","Formatting options",a=>!0,a=>a)],new m.$4M("A promise that resolves to an array of TextEdits.",p(y.TextEdit.to))),new m.$5M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$3M.Uri,m.$3M.Position,new m.$3M("ch","Trigger character",a=>typeof a=="string",a=>a),new m.$3M("options","Formatting options",a=>!0,a=>a)],new m.$4M("A promise that resolves to an array of TextEdits.",p(y.TextEdit.to))),new m.$5M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$3M.Uri,m.$3M.Position],new m.$4M("A promise that resolves to an array of Location or LocationLink instances.",b)),new m.$5M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$3M.Uri,m.$3M.Position],new m.$4M("A promise that resolves to an array of Location or LocationLink instances.",b)),new m.$5M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$3M.Uri,m.$3M.Position],new m.$4M("A promise that resolves to an array of Location or LocationLink instances.",b)),new m.$5M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$3M.Uri,m.$3M.Position],new m.$4M("A promise that resolves to an array of Location or LocationLink instances.",b)),new m.$5M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$3M.Uri,m.$3M.Position],new m.$4M("A promise that resolves to an array of Location-instances.",p(y.location.to))),new m.$5M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$3M.Uri,m.$3M.Position],new m.$4M("A promise that resolves to an array of Hover-instances.",p(y.Hover.to))),new m.$5M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$3M.Uri,new m.$3M("position","A position in a text document",a=>Array.isArray(a)&&a.every(s=>R.$FK.isPosition(s)),a=>a.map(y.Position.from))],new m.$4M("A promise that resolves to an array of ranges.",a=>a.map(s=>{let t;for(const n of s.reverse())t=new R.$ZK(y.Range.to(n),t);return t}))),new m.$5M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$3M.String.with("query","Search string")],new m.$4M("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(y.WorkspaceSymbol.to))),new m.$5M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$3M.Uri,m.$3M.Position],new m.$4M("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(y.CallHierarchyItem.to))),new m.$5M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$3M.CallHierarchyItem],new m.$4M("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(y.CallHierarchyIncomingCall.to))),new m.$5M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$3M.CallHierarchyItem],new m.$4M("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(y.CallHierarchyOutgoingCall.to))),new m.$5M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$3M.Uri,m.$3M.Position],new m.$4M("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:y.Range.to(a.range),placeholder:a.text}})),new m.$5M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$3M.Uri,m.$3M.Position,m.$3M.String.with("newName","The new symbol name")],new m.$4M("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return y.WorkspaceEdit.to(a)}})),new m.$5M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$3M.Uri,m.$3M.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$4M("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(y.DocumentLink.to))),new m.$5M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$3M.Uri],new m.$4M("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new R.$TL(a.tokenTypes,a.tokenModifiers)})),new m.$5M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$3M.Uri],new m.$4M("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const s=(0,P.$90)(a);if(s.type==="full")return new R.$VL(s.data,void 0)})),new m.$5M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$3M.Uri,m.$3M.Range.optional()],new m.$4M("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new R.$TL(a.tokenTypes,a.tokenModifiers)})),new m.$5M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$3M.Uri,m.$3M.Range],new m.$4M("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const s=(0,P.$90)(a);if(s.type==="full")return new R.$VL(s.data,void 0)})),new m.$5M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$3M.Uri,m.$3M.Position,m.$3M.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$3M.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$4M("A promise that resolves to a CompletionList-instance.",(a,s,t)=>{if(!a)return new R.$_K([]);const n=a.suggestions.map(o=>y.CompletionItem.to(o,t));return new R.$_K(n,a.incomplete)})),new m.$5M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$3M.Uri,m.$3M.Position,m.$3M.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$4M("A promise that resolves to SignatureHelp.",a=>{if(a)return y.SignatureHelp.to(a)})),new m.$5M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$3M.Uri,m.$3M.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$4M("A promise that resolves to an array of CodeLens-instances.",(a,s,t)=>p(n=>new R.$4K(y.Range.to(n.range),n.command&&t.fromInternal(n.command)))(a))),new m.$5M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$3M.Uri,new m.$3M("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>R.$GK.isRange(a),a=>R.$HK.isSelection(a)?y.Selection.from(a):y.Range.from(a)),m.$3M.String.with("kind","Code action kind to return code actions for").optional(),m.$3M.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$4M("A promise that resolves to an array of Command-instances.",(a,s,t)=>p(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(n.command)}else{const o=new R.$XK(n.title,n.kind?new R.$YK(n.kind):void 0);return n.edit&&(o.edit=y.WorkspaceEdit.to(n.edit)),n.command&&(o.command=t.fromInternal(n.command)),o.isPreferred=n.isPreferred,o}})(a))),new m.$5M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$3M.Uri],new m.$4M("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(s=>new R.$fL(y.Range.to(s.range),y.Color.to(s.color))):[])),new m.$5M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$3M("color","The color to show and insert",a=>a instanceof R.$eL,y.Color.from),new m.$3M("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:y.Range.from(a.range)}))],new m.$4M("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(y.ColorPresentation.to):[])),new m.$5M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$3M.Uri,m.$3M.Range],new m.$4M("A promise that resolves to an array of Inlay objects",(a,s,t)=>a.map(y.InlayHint.to.bind(void 0,t)))),new m.$5M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$3M.Uri],new m.$4M("A promise that resolves to an array of FoldingRange objects",(a,s)=>{if(a)return a.map(y.FoldingRange.to)})),new m.$5M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$4M("A promise that resolves to an array of NotebookContentProvider static info objects.",p(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(s=>y.NotebookExclusiveDocumentPattern.to(s))})))),new m.$5M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$3M.Uri,m.$3M.Range,new m.$3M("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof R.$GK,a=>y.InlineValueContext.from(a))],new m.$4M("A promise that resolves to an array of InlineValue objects",a=>a.map(y.InlineValue.to))),new m.$5M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$3M("uriOrString","Uri-instance or string (only http/https)",a=>C.URI.isUri(a)||typeof a=="string"&&(0,T.$_f)(a,T.Schemas.http,T.Schemas.https),a=>a),new m.$3M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[y.ViewColumn.from(a),void 0]:[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)])).optional(),m.$3M.String.with("label","").optional()],m.$4M.Void),new m.$5M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$3M.Uri.with("resource","Resource to open"),m.$3M.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$3M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[y.ViewColumn.from(a),void 0]:[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)])).optional()],m.$4M.Void),new m.$5M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$3M.Uri.with("left","Left-hand side resource of the diff editor"),m.$3M.Uri.with("right","Right-hand side resource of the diff editor"),m.$3M.String.with("title","Human readable title for the diff editor").optional(),new m.$3M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)]).optional()],m.$4M.Void),new m.$5M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$3M.String.with("title","Human readable title for the changes editor"),new m.$3M("resourceList","List of resources to compare",a=>{for(const s of a){if(s.length!==3)return!1;const[t,n,o]=s;if(!C.URI.isUri(t)||!C.URI.isUri(n)&&n!==void 0&&n!==null||!C.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},a=>a)],m.$4M.Void),new m.$5M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$3M.Uri,m.$3M.Position],new m.$4M("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(y.TypeHierarchyItem.to))),new m.$5M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$3M.TypeHierarchyItem],new m.$4M("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(y.TypeHierarchyItem.to))),new m.$5M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$3M.TypeHierarchyItem],new m.$4M("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(y.TypeHierarchyItem.to))),new m.$5M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$3M.TestItem],m.$4M.Void),new m.$5M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$3M.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$4M.Void),new m.$5M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$3M.String.with("name","The context key name"),new m.$3M("value","The context key value",()=>!0,a=>a)],m.$4M.Void),new m.$5M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$3M.Uri,m.$3M.StringArray,new m.$3M("MappedEditsContext","Mapped Edits Context",a=>y.MappedEditsContext.is(a),a=>y.MappedEditsContext.from(a))],new m.$4M("A promise that resolves to a workspace edit or null",a=>a?y.WorkspaceEdit.to(a):null))];class l{static register(s){S.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",$.$Yi)}}e.$uec=l;function p(a){return s=>{if(Array.isArray(s))return s.map(a)}}function b(a){if(!Array.isArray(a))return;const s=[];for(const t of a)M.$ot(t)?s.push(y.DefinitionLink.to(t)):s.push(y.location.to(t));return s}}),define(Pe[239],Re([1,0,14,66,5,6,2,80,22,8,7,3,23]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;function p(b,a,s){const t=b.getProxy(S.$CK.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new m.$fm,a.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===6){const D=this.b.get(g.handle);return D?D.value:g}else if(g&&g.$mid===7){const D=this.b.get(g.commentControlHandle);if(!D)return g;const I=D.getCommentThread(g.commentThreadHandle);return I?I.value:g}else if(g&&(g.$mid===9||g.$mid===8)){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const I=D.getCommentThread(g.thread.commentThreadHandle);return I?g.$mid===8?I.value:{thread:I.value,text:g.text}:g}else if(g&&g.$mid===10){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const I=D.getCommentThread(g.thread.commentThreadHandle);if(!I)return g;const h=g.commentUniqueId,w=I.getCommentByUniqueId(h);return w||g}else if(g&&g.$mid===11){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const I=D.getCommentThread(g.thread.commentThreadHandle);if(!I)return g;const h=g.text,w=g.commentUniqueId,k=I.getCommentByUniqueId(w);return k?(typeof k.body=="string"?k.body=h:k.body=new R.$5K(h),k):g}return g}})}createCommentController(g,D,I){const h=n.a++,w=new c(g,h,D,I);this.b.set(w.handle,w);const k=this.c.get(g.identifier)||[];return k.push(w),this.c.set(g.identifier,k),w.value}async $createCommentThreadTemplate(g,D,I){const h=this.b.get(g);h&&h.$createCommentThreadTemplate(D,I)}async $updateCommentThreadTemplate(g,D,I){const h=this.b.get(g);h&&h.$updateCommentThreadTemplate(D,I)}$deleteCommentThread(g,D){this.b.get(g)?.$deleteCommentThread(D)}$provideCommentingRanges(g,D,I){const h=this.b.get(g);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const w=s.getDocument(P.URI.revive(D));return(0,E.$Sg)(async()=>{const k=await h.commentingRangeProvider.provideCommentingRanges(w,I);let F;return Array.isArray(k)?F={ranges:k,fileComments:!1}:k?F={ranges:k.ranges||[],fileComments:k.fileComments||!1}:F=k??void 0,F}).then(k=>{let F;return k&&(F={ranges:k.ranges.map(W=>y.Range.from(W)),fileComments:k.fileComments}),F})}$toggleReaction(g,D,I,h,w){const k=this.b.get(g);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,E.$Sg)(()=>{const F=k.getCommentThread(D);if(F){const W=F.getCommentByUniqueId(h.uniqueIdInThread);if(k!==void 0&&W&&k.reactionHandler)return k.reactionHandler(W,r(w))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(g){this.n=g}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(g){(g===void 0!=(this.p===void 0)||!g||!this.p||!g.isEqual(this.p))&&(this.p=g,this.b.range=g,this.c.fire())}get range(){return this.p}set canReply(g){this.d!==g&&(this.d=g,this.b.canReply=g,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(g){this.e=g,this.b.label=g,this.c.fire()}get contextValue(){return this.f}set contextValue(g){this.f=g,this.b.contextValue=g,this.c.fire()}get comments(){return this.q}set comments(g){this.q=g,this.b.comments=g,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(g){this.g=g,this.b.collapsibleState=g,this.c.fire()}get state(){return this.h}set state(g){this.h=g,this.b.state=g,this.c.fire()}get isDisposed(){return this.j}constructor(g,D,I,h,w,k,F,W){this.m=D,this.n=I,this.o=h,this.p=w,this.q=k,this.extensionDescription=F,this.r=W,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Rd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${g}.${this.handle}`),t.$createCommentThread(D,this.handle,this.n,this.o,y.Range.from(this.p),F.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{t.$deleteCommentThread(D,this.handle)}});const Q=this;this.value={get uri(){return Q.uri},get range(){return Q.range},set range(N){Q.range=N},get comments(){return Q.comments},set comments(N){Q.comments=N},get collapsibleState(){return Q.collapsibleState},set collapsibleState(N){Q.collapsibleState=N},get canReply(){return Q.canReply},set canReply(N){Q.canReply=N},get contextValue(){return Q.contextValue},set contextValue(N){Q.contextValue=N},get label(){return Q.label},set label(N){Q.label=N},get state(){return Q.state},set state(N){Q.state=N},dispose:()=>{Q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const g=I=>Object.prototype.hasOwnProperty.call(this.b,I),D={};g("range")&&(D.range=y.Range.from(this.p)),g("label")&&(D.label=this.label),g("contextValue")&&(D.contextValue=this.contextValue??null),g("comments")&&(D.comments=this.q.map(I=>d(this,I,this.k,this.extensionDescription))),g("collapsibleState")&&(D.collapseState=u(this.g)),g("canReply")&&(D.canReply=this.canReply),g("state")&&(D.state=f(this.h)),g("isTemplate")&&(D.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(g){for(const D of this.k){const I=D[0],h=D[1];if(g===h)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(g=>g.dispose())}}Ke([(0,T.$sh)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(g){this.b=g,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(g){this.c=g,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!g})}get options(){return this.d}set options(g){this.d=g,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(g,D,I,h){this.f=g,this.g=D,this.h=I,this.i=h,this.a=new Map,t.$registerCommentController(this.handle,I,h,this.f.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(k){w.options=k},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(k){w.commentingRangeProvider=k},get reactionHandler(){return w.reactionHandler},set reactionHandler(k){w.reactionHandler=k},createCommentThread(k,F,W){return w.createCommentThread(k,F,W).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(g,D,I){D===void 0&&(0,l.$QF)(this.f,"fileComments");const h=new o(this.id,this.handle,void 0,g,D,I,this.f,!1);return this.a.set(h.handle,h),h}$createCommentThreadTemplate(g,D){const I=new o(this.id,this.handle,void 0,P.URI.revive(g),y.Range.to(D),[],this.f,!0);return I.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(g,D){const I=this.a.get(g);I&&(I.range=y.Range.to(D))}$deleteCommentThread(g){this.a.get(g)?.dispose(),this.a.delete(g)}getCommentThread(g){return this.a.get(g)}dispose(){this.a.forEach(g=>{g.dispose()}),this.e.forEach(g=>g.dispose())}}function d(v,g,D,I){let h=D.get(g);return h||(h=++v.commentHandle,D.set(g,h)),g.state!==void 0&&(0,l.$QF)(I,"commentsDraftState"),{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:h,body:typeof g.body=="string"?g.body:y.MarkdownString.from(g.body),userName:g.author.name,userIconPath:g.author.iconPath,label:g.label,commentReactions:g.reactions?g.reactions.map(w=>i(w)):void 0,state:g.state,timestamp:g.timestamp?.toJSON()}}function i(v){return{label:v.label,iconPath:v.iconPath?y.$DM(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted}}function r(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?P.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1}}function u(v){if(v!==void 0)switch(v){case R.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function f(v){if(v!==void 0)switch(v){case R.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new n}e.$Eec=p}),define(Pe[240],Re([1,0,26,3,27,17]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;let P=class{constructor(R,S){this.a=R.getProxy(T.$CK.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,S){const l=this,p=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){l.e(R,S,p,arguments)}})}e(R,S,l,p){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:m(p,this.b)}),this.c&&this.f(R,l,p)}};e.$sgc=P,e.$sgc=P=Ke([We(0,M.$EM),We(1,C.$UM)],P);const $=1e5;function m(y,R){const S=[];if(y.length)for(let l=0;l<y.length;l++){let p=y[l];if(typeof p>"u")p="undefined";else if(p instanceof Error){const b=p;b.stack?p=b.stack:p=b.toString()}S.push(p)}if(R){const l=new Error().stack;l&&S.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,E.$jn)(S);return l.length>$?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[109],Re([1,0,2,3,7,4,17,15,18,12,20,23]),function(pe,e,E,T,C,M,P,$,m,y,R,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=e.$ufc=void 0;let p=class{static{l=this}static{this.c=0}static{this.d=250}constructor(a,s){this.h=s,this.f=new Map,this.g=a.getProxy(T.$CK.MainThreadDecorations)}registerFileDecorationProvider(a,s){const t=l.c++;this.f.set(t,{provider:a,extensionDescription:s}),this.g.$registerDecorationProvider(t,s.identifier.value);const n=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(t,null);return}const c=(0,m.$2b)(o);if(c.length<=l.d){this.g.$onDidChange(t,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,c.length);const d=c.map(u=>({uri:u,rank:(0,y.$Ke)(u.path,"/")})),i=(0,m.$yb)(d,(u,f)=>u.rank-f.rank||(0,y.$Ye)(u.uri.path,f.uri.path)),r=[];e:for(const u of i){let f;for(const v of u){const g=(0,R.$lc)(v.uri.path);if(f!==g&&(f=g,r.push(v.uri)>=l.d))break e}}this.g.$onDidChange(t,r)});return new C.$EK(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(a,s,t){if(!this.f.has(a))return Object.create(null);const n=Object.create(null),{provider:o,extensionDescription:c}=this.f.get(a);return await Promise.all(s.map(async d=>{try{const{uri:i,id:r}=d,u=await Promise.resolve(o.provideFileDecoration(E.URI.revive(i),t));if(!u)return;try{C.$ZL.validate(u),u.badge&&typeof u.badge!="string"&&(0,S.$QF)(c,"codiconDecoration"),n[r]=[u.propagate,u.tooltip,u.badge,u.color]}catch(f){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${f}`)}}catch(i){this.h.error(i)}})),n}};e.$ufc=p,e.$ufc=p=l=Ke([We(0,P.$EM),We(1,$.$hj)],p),e.$vfc=(0,M.$Zh)("IExtHostDecorations")}),define(Pe[241],Re([1,0,157,98,2,3,7,8,5,15,28,43]),function(pe,e,E,T,C,M,P,$,m,y,R,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=e.$oec=void 0;class p{#e;#t;#i;constructor(s,t,n,o,c,d,i,r){this.d=s,this.e=t,this.f=n,this.g=o,this.h=c,this.c=!1,this.f=Math.max(o,n),this.#i=new R.$zc(u=>d.getComparisonKey(u)),this.#e=i,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,t){if(!s){this.clear();return}this.j();let n=[];if(C.URI.isUri(s)){if(!t){this.delete(s);return}this.#i.set(s,t.slice()),n=[s]}else if(Array.isArray(s)){n=[];let d;s=[...s].sort(p.k);for(const i of s){const[r,u]=i;if((!d||r.toString()!==d.toString())&&(d&&this.#i.get(d).length===0&&this.#i.delete(d),d=r,n.push(r),this.#i.set(r,[])),u)this.#i.get(r)?.push(...u);else{const f=this.#i.get(r);f&&(f.length=0)}}}if(this.#t.fire(n),!this.#e)return;const o=[];let c=0;for(const d of n){let i=[];const r=this.#i.get(d);if(r)if(r.length>this.g){i=[];const u=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const v of r)if(v.severity===u[f]&&i.push({...$.Diagnostic.from(v),modelVersionId:this.h(d)})===this.g)break e;i.push({severity:T.MarkerSeverity.Info,message:(0,E.localize)(0,null,r.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=r.map(u=>({...$.Diagnostic.from(u),modelVersionId:this.h(d)}));if(o.push([d,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,o)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,t){this.j();for(const[n,o]of this)s.call(t,n,o,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const t=this.#i.get(s);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,t){return s[0].toString()<t[0].toString()?-1:s[0].toString()>t[0].toString()?1:0}}e.$oec=p;let b=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(s){const t=new R.$zc;for(const n of s)t.set(n,n);return{uris:Object.freeze(Array.from(t.values()))}}constructor(s,t,n,o){this.j=t,this.k=n,this.l=o,this.g=new Map,this.h=new m.$Vd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,l._mapper),this.f=s.getProxy(M.$CK.MainThreadDiagnostics)}createDiagnosticCollection(s,t){const{g:n,f:o,h:c,j:d,k:i,l:r}=this,u=new class{$changeMany(g,D){o.$changeMany(g,D),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,g,D.length===0?"CLEARING":D)}$clear(g){o.$clear(g),d.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,g)}dispose(){o.dispose()}};let f;if(!t)t="_generated_diagnostic_collection_name_#"+l.c++,f=t;else if(!n.has(t))f=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do f=t+l.c++;while(n.has(f))}return new class extends p{constructor(){super(t,f,l.e,l.d,g=>r.getDocument(g)?.version,i.extUri,u,c),n.set(f,this)}dispose(){super.dispose(),n.delete(f)}}}getDiagnostics(s){if(s)return this.m(s);{const t=new Map,n=[];for(const o of this.g.values())o.forEach((c,d)=>{let i=t.get(c.toString());typeof i>"u"&&(i=n.length,t.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...d)});return n}}m(s){let t=[];for(const n of this.g.values())n.has(s)&&(t=t.concat(n.get(s)));return t}$acceptMarkersChange(s){if(!this.n){const t="_generated_mirror",n=new p(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(t,n),this.n=n}for(const[t,n]of s)this.n.set(C.URI.revive(t),n.map($.Diagnostic.to))}};e.$pec=b,e.$pec=b=l=Ke([We(1,y.$hj),We(2,S.$nec)],b)}),define(Pe[242],Re([1,0,2,3,23]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;class M{constructor($){this.a=$.getProxy(T.$CK.MainThreadDialogs)}showOpenDialog($,m){return m?.allowUIResources&&(0,C.$QF)($,"showLocal"),this.a.$showOpenDialog(m).then(y=>y?y.map(R=>E.URI.revive(R)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(m=>m?E.URI.revive(m):void 0)}}e.$wfc=M}),define(Pe[243],Re([1,0,11,2,7,3,13,19,12]),function(pe,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;class y{static{this.a=0}constructor(S,l,p){this.d=l,this.e=p,this.b=new Map,this.c=S.getProxy(M.$CK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,l){if(Object.keys(P.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const p=y.a++;this.b.set(p,l),this.c.$registerTextContentProvider(p,S);let b;return typeof l.onDidChange=="function"&&(b=l.onDidChange(a=>{if(a.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this.d.getDocument(a)&&this.$provideTextDocumentContent(p,a).then(s=>{if(!s&&typeof s!="string")return;const t=this.d.getDocument(a);if(!t)return;const n=(0,m.$Te)(s);if(!t.equalLines(n))return this.c.$onVirtualDocumentChange(a,s)},E.$Z)})),new C.$EK(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(S,l){const p=this.b.get(S);return p?Promise.resolve(p.provideTextDocumentContent(T.URI.revive(l),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$xfc=y}),define(Pe[244],Re([1,0,5,6,2,3,102,8,16,26,7,11]),function(pe,e,E,T,C,M,P,$,m,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;class l{constructor(b,a){this.a=new E.$Rd({onListenerError:S.$1}),this.b=new E.$Rd({onListenerError:S.$1}),this.c=new E.$Rd({onListenerError:S.$1}),this.d=new E.$Rd({onListenerError:S.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Qc,this.h=new Map,this.f=b.getProxy(M.$CK.MainThreadDocuments),this.g=a,this.g.onDidRemoveDocuments(s=>{for(const t of s)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const t of s)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const a=this.g.getDocument(b);if(a)return a}getDocument(b){const a=this.getDocumentData(b);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return a.document}ensureDocumentData(b){const a=this.g.getDocument(b);if(a)return Promise.resolve(a);let s=this.h.get(b.toString());return s||(s=this.f.$tryOpenDocument(b).then(t=>{this.h.delete(b.toString());const n=C.URI.revive(t);return(0,m.$Nf)(this.g.getDocument(n))},t=>(this.h.delete(b.toString()),Promise.reject(t))),this.h.set(b.toString(),s)),s}createDocumentData(b){return this.f.$tryCreateDocument(b).then(a=>C.URI.revive(a))}$acceptModelLanguageChanged(b,a){const s=C.URI.revive(b),t=this.g.getDocument(s);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(a),this.a.fire(t.document)}$acceptModelSaved(b){const a=C.URI.revive(b),s=this.g.getDocument(a);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(b,a){const s=C.URI.revive(b),t=this.g.getDocument(s);if(!t)throw new Error("unknown document");t._acceptIsDirty(a),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,a,s){const t=C.URI.revive(b),n=this.g.getDocument(t);if(!n)throw new Error("unknown document");n._acceptIsDirty(s),n.onEvents(a);let o;a.isUndoing?o=R.TextDocumentChangeReason.Undo:a.isRedoing&&(o=R.TextDocumentChangeReason.Redo),this.c.fire((0,y.$fn)({document:n.document,contentChanges:a.changes.map(c=>({range:$.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:o}))}setWordDefinitionFor(b,a){(0,P.$GM)(b,a)}}e.$lec=l}),define(Pe[61],Re([1,0,53,5,6,2,4,3,102,17,108,8,15,28,13,67,39]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=e.$OM=void 0;class t{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,d){this.h=c,this.i=d,this.a=null,this.b=new Map,this.c=new p.$zc,this.d=new T.$Rd,this.e=new T.$Rd,this.f=new T.$Rd,this.g=new T.$Rd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const d=[],i=[],r=[];if(c.removedDocuments)for(const u of c.removedDocuments){const f=M.URI.revive(u),v=this.c.get(f);v?.unref()&&(this.c.delete(f),d.push(v.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const f=M.URI.revive(u.uri);let v=this.c.get(f);if(v&&f.scheme!==b.Schemas.vscodeNotebookCell&&f.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${f} already exists!'`);v||(v=new t(new m.$HM(this.h.getProxy($.$CK.MainThreadDocuments),f,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty,u.notebook)),this.c.set(f,v),i.push(v.value)),v.ref()}if(c.removedEditors)for(const u of c.removedEditors){const f=this.b.get(u);this.b.delete(u),f&&r.push(f)}if(c.addedEditors)for(const u of c.addedEditors){const f=M.URI.revive(u.documentUri);E.ok(this.c.has(f),`document '${f}' does not exist`),E.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const v=this.c.get(f).value,g=new R.$NM(u.id,this.h.getProxy($.$CK.MainThreadTextEditors),this.i,new s.$U(()=>v.document),u.selections.map(S.Selection.to),u.options,u.visibleRanges.map(D=>S.Range.to(D)),typeof u.editorPosition=="number"?S.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,g)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,C.$Mc)(d),(0,C.$Mc)(r),c.removedDocuments&&this.e.fire(d),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return a.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const d=this.b.get(this.a);return c?d:d?.value}allEditors(){return[...this.b.values()]}};e.$OM=n,e.$OM=n=Ke([We(0,y.$EM),We(1,l.$hj)],n),e.$PM=(0,P.$Zh)("IExtHostDocumentsAndEditors")}),define(Pe[62],Re([1,0,245,5,16,2,4,3,17,8,7]),function(pe,e,E,T,C,M,P,$,m,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=e.$Xec=void 0,e.$Xec=(0,P.$Zh)("IExtHostEditorTabs");class S{constructor(s,t,n){this.e=n,this.d=t,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,t={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$jM(M.URI.revive(this.b.input.uri));case 2:return new R.$kM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new R.$lM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new R.$mM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$nM(this.b.input.viewType);case 4:return new R.$oM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$pM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$qM;case 9:return new R.$rM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$sM(this.b.input.providerId);default:return}}}class l{constructor(s,t){this.c=[],this.d="",this.b=s,this.e=t;for(const n of s.tabs)n.isActive&&(this.d=n.id),this.c.push(new S(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,t={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return y.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(n=>n.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(n=>n.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===0){const n=new S(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,n),s.tabDto.isActive&&(this.d=n.tabId),n}else if(s.kind===1){const n=this.c.splice(s.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(s.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,n),n}const t=this.c.find(n=>n.tabId===s.tabDto.id);if(!t)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(s.tabDto),t}activeTabId(){return this.d}}let p=class{constructor(s){this.b=new T.$Rd,this.c=new T.$Rd,this.e=[],this.a=s.getProxy($.$CK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,t={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(n=>n.apiObject))},get activeTabGroup(){const n=s.d;return(0,C.$Nf)(s.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,o)=>{const c=Array.isArray(n)?n:[n];return c.length?b(c[0])?this.j(c,o):this.i(c,o):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(s){const t=new Set(this.e.map(u=>u.groupId)),n=new Set(s.map(u=>u.groupId)),o=(0,E.$K)(t,n),c=this.e.filter(u=>o.removed.includes(u.groupId)).map(u=>u.apiObject),d=[],i=[];this.e=s.map(u=>{const f=new l(u,()=>this.d);return o.added.includes(f.groupId)?d.push(f.apiObject):i.push(f.apiObject),f});const r=(0,C.$Nf)(s.find(u=>u.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:d,closed:c,changed:i}))}$acceptTabGroupUpdate(s){const t=this.e.find(n=>n.groupId===s.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const t=this.e.find(o=>o.groupId===s.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const n=t.acceptTabOperation(s);switch(s.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(s){for(const t of this.e)for(const n of t.tabs)if(n.apiObject===s)return n}h(s){return this.e.find(t=>t.apiObject===s)}async i(s,t){const n=[];for(const o of s){const c=this.g(o);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,t)}async j(s,t){const n=[];for(const o of s){const c=this.h(o);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,t)}};e.$Yec=p,e.$Yec=p=Ke([We(0,m.$EM)],p);function b(a){return a.tabs!==void 0}}),define(Pe[246],Re([1,0,3,7]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=void 0;class C{constructor(P){this.a=new Map,this.b=0,this.c=P.getProxy(E.$CK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(P,$,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(P);if(!y)throw new Error("Embedding vector provider not found");const R=await y.provideEmbeddingVector($,m);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(P,$,m){const y=this.b;return this.b++,this.a.set(y,m),this.c.$registerAiEmbeddingVectorProvider($,y),new T.$EK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$zfc=C}),define(Pe[247],Re([1,0,2,3,6,7,8,295,12,24,23,52]),function(pe,e,E,T,C,M,P,$,m,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=void 0;class l{constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const s=this.a.indexOf(a);s>=0&&(this.a.splice(s,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),s=[];let t,n,o=14,c=14;for(const d of a){let i=t?(0,m.$8e)(t,d):0;for(i===0?n=1:n=c;i<d.length;i++)i+1===d.length?(o=c,c=9):c+=1,s.push([n,d.toUpperCase().charCodeAt(i),c]),s.push([n,d.toLowerCase().charCodeAt(i),c]),n=c;t=d,c=o}s.push([9,58,10]),s.push([10,47,12]),this.b=new $.$$Y(s)}}provideDocumentLinks(a){this.c();const s=[],t=$.$_Y.computeLinks({getLineContent(n){return a.lineAt(n-1).text},getLineCount(){return a.lineCount}},this.b);for(const n of t){const o=P.DocumentLink.to(n);o.target&&s.push(o)}return s}}class p{constructor(a,s){this.i=s,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(T.$CK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,s,t,n={}){if(p.j(t),this.d.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const o=this.h++;this.b.add(s),this.d.add(s),this.c.set(o,t);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof t.copy=="function"&&(c+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,R.$QF)(a,"fsChunks"),c+=4);let d;n.isReadonly&&(0,S.$ck)(n.isReadonly)&&((0,R.$QF)(a,"readonlyMessage"),d={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(o,s,c,d).catch(r=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${s}`),console.error(r)});const i=t.onDidChangeFile(r=>{const u=[];for(const f of r){const{uri:v,type:g}=f;if(v.scheme!==s)continue;let D;switch(g){case M.FileChangeType.Changed:D=0;break;case M.FileChangeType.Created:D=1;break;case M.FileChangeType.Deleted:D=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:v,type:D})}this.a.$onFileSystemChange(o,u)});return(0,C.$Pc)(()=>{i.dispose(),this.b.delete(s),this.d.delete(s),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:s,ctime:t,mtime:n,size:o,permissions:c}=a;return{type:s,ctime:t,mtime:n,size:o,permissions:c}}$stat(a,s){return Promise.resolve(this.l(a).stat(E.URI.revive(s))).then(t=>p.k(t))}$readdir(a,s){return Promise.resolve(this.l(a).readDirectory(E.URI.revive(s)))}$readFile(a,s){return Promise.resolve(this.l(a).readFile(E.URI.revive(s))).then(t=>y.$fe.wrap(t))}$writeFile(a,s,t,n){return Promise.resolve(this.l(a).writeFile(E.URI.revive(s),t.buffer,n))}$delete(a,s,t){return Promise.resolve(this.l(a).delete(E.URI.revive(s),t))}$rename(a,s,t,n){return Promise.resolve(this.l(a).rename(E.URI.revive(s),E.URI.revive(t),n))}$copy(a,s,t,n){const o=this.l(a);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(E.URI.revive(s),E.URI.revive(t),n))}$mkdir(a,s){return Promise.resolve(this.l(a).createDirectory(E.URI.revive(s)))}$watch(a,s,t,n){const o=this.l(a).watch(E.URI.revive(t),n);this.f.set(s,o)}$unwatch(a,s){const t=this.f.get(s);t&&(t.dispose(),this.f.delete(s))}$open(a,s,t){const n=this.l(a);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(s),t))}$close(a,s){const t=this.l(a);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(s))}$read(a,s,t,n){const o=this.l(a);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const c=y.$fe.alloc(n);return Promise.resolve(o.read(s,t,c.buffer,0,n)).then(d=>c.slice(0,d))}$write(a,s,t,n){const o=this.l(a);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(s,t,n.buffer,0,n.byteLength))}l(a){const s=this.c.get(a);if(!s){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return s}}e.$Afc=p}),define(Pe[63],Re([1,0,3,42,7,24,4,17,43,6,14,25,13]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=e.$Mec=void 0;let b=p=class{constructor(s,t){this.b=new Map,this.c=new R.$9g,this.a=s.getProxy(E.$CK.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(o){try{let c;const d=n.b.get(o.scheme);return d?(await n.a.$ensureActivation(o.scheme),c=await d.impl.stat(o)):c=await n.a.$stat(o),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===T.FilePermission.Readonly?1:void 0}}catch(c){p.e(c)}},async readDirectory(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readDirectory(o)).slice()):await n.a.$readdir(o)}catch(c){return p.e(c)}},async createDirectory(o){try{const c=n.b.get(o.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(c.impl,c.extUri,o)):await n.a.$mkdir(o)}catch(c){return p.e(c)}},async readFile(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readFile(o)).slice()):(await n.a.$readFile(o)).buffer}catch(c){return p.e(c)}},async writeFile(o,c){try{const d=n.b.get(o.scheme);return d&&!d.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(d.impl,d.extUri,d.extUri.dirname(o)),await n.c.queueFor(o).queue(()=>Promise.resolve(d.impl.writeFile(o,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(o,M.$fe.wrap(c))}catch(d){return p.e(d)}},async delete(o,c){try{const d=n.b.get(o.scheme);return d&&!d.isReadonly?(await n.a.$ensureActivation(o.scheme),await d.impl.delete(o,{recursive:!1,...c})):await n.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(d){return p.e(d)}},async rename(o,c,d){try{return await n.a.$rename(o,c,{overwrite:!1,...d})}catch(i){return p.e(i)}},async copy(o,c,d){try{return await n.a.$copy(o,c,{overwrite:!1,...d})}catch(i){return p.e(i)}},isWritableFileSystem(o){const c=t.getCapabilities(o);if(typeof c=="number")return!(c&2048)}})}async d(s,t,n){const o=[];for(;!t.isEqual(n,t.dirname(n));)try{if(!((await s.stat(n)).type&T.FileType.Directory))throw C.$RL.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(T.$yk(c)!==T.FileSystemProviderErrorCode.FileNotFound)throw c;o.push(t.basename(n)),n=t.dirname(n)}for(let c=o.length-1;c>=0;c--){n=t.joinPath(n,o[c]);try{await s.createDirectory(n)}catch(d){if(T.$yk(d)!==T.FileSystemProviderErrorCode.FileExists)throw d}}}static e(s){if(s instanceof C.$RL)throw s;if(s instanceof T.$uk)switch(s.code){case T.FileSystemProviderErrorCode.FileExists:throw C.$RL.FileExists(s.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$RL.FileNotFound(s.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$RL.FileNotADirectory(s.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$RL.FileIsADirectory(s.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$RL.NoPermissions(s.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$RL.Unavailable(s.message);default:throw new C.$RL(s.message,s.name)}if(!(s instanceof Error))throw new C.$RL(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw C.$RL.Unavailable(s.message);switch(s.name){case T.FileSystemProviderErrorCode.FileExists:throw C.$RL.FileExists(s.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.$RL.FileNotFound(s.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.$RL.FileNotADirectory(s.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.$RL.FileIsADirectory(s.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.$RL.NoPermissions(s.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.$RL.Unavailable(s.message);default:throw new C.$RL(s.message,s.name)}}addFileSystemProvider(s,t,n){return this.b.set(s,{impl:t,extUri:n?.isCaseSensitive?S.$rg:S.$tg,isReadonly:!!n?.isReadonly}),(0,y.$Pc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??S.$rg}};e.$Mec=b,e.$Mec=b=p=Ke([We(0,$.$EM),We(1,m.$nec)],b),e.$Nec=(0,P.$Zh)("IExtHostConsumerFileSystem")}),define(Pe[248],Re([1,0,5,34,2,3,8,7,39]),function(pe,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,b,a,s,t,n){this.a=Math.random(),this.b=new E.$Rd,this.c=new E.$Rd,this.d=new E.$Rd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,T.$Gj)(t),c=typeof t=="string",d=n?.correlate,i=s(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(d&&typeof r.session>"u")){if(!n?.ignoreCreateEvents)for(const u of r.created){const f=C.URI.revive(u);o(f.fsPath)&&(!c||b.getWorkspaceFolder(f))&&this.b.fire(f)}if(!n?.ignoreChangeEvents)for(const u of r.changed){const f=C.URI.revive(u);o(f.fsPath)&&(!c||b.getWorkspaceFolder(f))&&this.c.fire(f)}if(!n?.ignoreDeleteEvents)for(const u of r.deleted){const f=C.URI.revive(u);o(f.fsPath)&&(!c||b.getWorkspaceFolder(f))&&this.d.fire(f)}}});this.g=$.$EK.from(this.i(p,a,t,n,n?.correlate),this.b,this.c,this.d,i)}i(p,b,a,s,t){const n=$.$EK.from();if(typeof a=="string")return n;const o=p.getProxy(M.$CK.MainThreadFileSystemEventService);let c=!1;return(a.pattern.includes(T.$Cj)||a.pattern.includes(T.$Dj))&&(c=!0),o.$watch(b.identifier.value,this.a,a.baseUri,{recursive:c,excludes:s?.excludes??[]},!!t),$.$EK.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(p){this.a=p,this.session=this.a.session,this.b=new m.$U(()=>this.a.created.map(C.URI.revive)),this.c=new m.$U(()=>this.a.changed.map(C.URI.revive)),this.d=new m.$U(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(p,b,a){this.j=p,this.k=b,this.l=a,this.a=new E.$Rd,this.b=new E.$Rd,this.c=new E.$Rd,this.d=new E.$Rd,this.g=new E.$Td,this.h=new E.$Td,this.i=new E.$Td,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,b,a,s){return new y(this.j,p,b,this.a.event,P.GlobPattern.from(a),s)}$onFileEvent(p){this.a.fire(new R(p))}$onDidRunFileOperation(p,b){switch(p){case 2:this.b.fire(Object.freeze({files:b.map(a=>({oldUri:C.URI.revive(a.source),newUri:C.URI.revive(a.target)}))}));break;case 1:this.d.fire(Object.freeze({files:b.map(a=>C.URI.revive(a.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:b.map(a=>C.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,b){return(a,s,t)=>{const n=function(c){a.call(s,c)};return n.extension=p,b.event(n,void 0,t)}}async $onWillRunFileOperation(p,b,a,s){switch(p){case 2:return await this.n(this.g,{files:b.map(t=>({oldUri:C.URI.revive(t.source),newUri:C.URI.revive(t.target)}))},a,s);case 1:return await this.n(this.i,{files:b.map(t=>C.URI.revive(t.target))},a,s);case 0:case 3:return await this.n(this.h,{files:b.map(t=>C.URI.revive(t.target))},a,s)}}async n(p,b,a,s){const t=new Set,n=[];if(await p.fireAsync(b,s,async(c,d)=>{const i=Date.now(),r=await Promise.resolve(c);r instanceof $.$OK&&(n.push([d.extension,r]),t.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-i>a&&this.k.warn("SLOW file-participant",d.extension.identifier)}),s.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,c]of n){const{edits:d}=P.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(d)}return{edit:o,extensionNames:Array.from(t)}}}e.$Bfc=S}),define(Pe[249],Re([1,0,6,2,3,8,7,32,14]),function(pe,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=void 0;class y{static{this.a=0}constructor(p,b){this.extension=p,this.provider=b,this.handle=y.a++}}class R{constructor(p){this.session=p,this.responses=[]}}class S{static{this.a=0}constructor(p,b,a,s){this.f=a,this.g=s,this.b=new Map,this.d=new Map,this.e=p.getProxy(C.$CK.MainThreadInlineChat),b.registerApiCommand(new $.$5M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$3M("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?M.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?M.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?M.Position.from(t.position):void 0}})],$.$4M.Void))}registerProvider(p,b,a){const s=new y(p,b);return this.b.set(s.handle,s),this.e.$registerInteractiveEditorProvider(s.handle,a?.label??p.displayName??p.name,p.identifier.value,typeof b.handleInteractiveEditorResponseFeedback=="function",typeof b.provideFollowups=="function",a?.supportReportIssue??!1),(0,E.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(s.handle),this.b.delete(s.handle)})}async $prepareSession(p,b,a,s){const t=this.b.get(p);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(T.URI.revive(b)),o=M.Selection.to(a),c=await t.provider.prepareInteractiveEditorSession({document:n,selection:o},s);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const d=S.a++;return this.d.set(d,new R(c)),{id:d,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:M.Range.from(c.wholeRange),message:c.message}}async $provideResponse(p,b,a,s){const t=this.b.get(p);if(!t)return;const n=this.d.get(b.id);if(!n)return;const o={prompt:a.prompt,selection:M.Selection.to(a.selection),wholeRange:M.Range.to(a.wholeRange),attempt:a.attempt,live:a.live};let c=!1;const d={report:async v=>{if(!a.live&&v.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||s.isCancellationRequested||await this.e.$handleProgressChunk(a.requestId,{message:v.message,edits:v.edits?.map(M.TextEdit.from),editsShouldBeInstant:v.editsShouldBeInstant,slashCommand:v.slashCommand?.command,markdownFragment:P.$5K.isMarkdownString(v.content)?v.content.value:v.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(n.session,o,d,s));let r;try{r=await(0,m.$Og)(i,s)}finally{c=!0}if(!r)return;const u=n.responses.push(r)-1,f={wholeRange:M.Range.from(r.wholeRange),placeholder:r.placeholder};if(S.h(r)){const{edits:v,contents:g}=r,D=g!==void 0?M.MarkdownString.from(g):void 0;return v instanceof P.$OK?{...f,id:u,type:"bulkEdit",edits:M.WorkspaceEdit.from(v),message:D}:{...f,id:u,type:"editorEdit",edits:v.map(M.TextEdit.from),message:D}}return{...f,id:u,type:"message",message:M.MarkdownString.from(r.contents)}}async $provideFollowups(p,b,a,s){const t=this.b.get(p),n=this.d.get(b),o=n?.responses[a];if(t&&o&&t.provider.provideFollowups){const c=Promise.resolve(t.provider.provideFollowups(n.session,o,s));return(await(0,m.$Og)(c,s))?.map(M.ChatReplyFollowup.from)}}$handleFeedback(p,b,a,s){const t=this.b.get(p),n=this.d.get(b),o=n?.responses[a];if(t&&o){const c=M.InteractiveEditorResponseFeedbackKind.to(s);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,o,c)}}$releaseSession(p,b){}static h(p){return typeof p=="object"&&typeof p.edits=="object"}}e.$Cfc=S}),define(Pe[250],Re([1,0,2,32]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=void 0;class C{constructor(P,$,m,y,R){this.a=$,this.b=m,this.c=y;const S=new T.$5M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$3M("showOptions","Show Options",l=>!0,l=>l),new T.$3M("resource","Interactive resource Uri",l=>!0,l=>l),new T.$3M("controllerId","Notebook controller Id",l=>!0,l=>l),new T.$3M("title","Interactive editor title",l=>!0,l=>l)],new T.$4M("Notebook and input URI",l=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const p=this.a.getEditorById(l.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri),notebookEditor:p.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(P,$,m,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:m,uri:P,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.$Pfc=C}),define(Pe[251],Re([1,0,3,7]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=void 0;class C{constructor(P){this.a=new Map,this.b=new Map,this.c=P.getProxy(E.$CK.MainThreadIssueReporter)}async $getIssueReporterUri(P,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const m=this.a.get(P);if(!m)throw new Error("Issue request handler not found");const y=await m.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(P,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const m=this.b.get(P);if(!m)throw new Error("Issue data provider not found");const y=await m.provideIssueData($);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(P,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const m=this.b.get(P);if(!m)throw new Error("Issue data provider not found");const y=await m.provideIssueTemplate($);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(P,$){const m=P.identifier.value;return this.a.set(m,$),this.c.$registerIssueUriRequestHandler(m),new T.$EK(()=>{this.c.$unregisterIssueUriRequestHandler(m),this.a.delete(m)})}registerIssueDataProvider(P,$){const m=P.identifier.value;return this.b.set(m,$),this.c.$registerIssueDataProvider(m),new T.$EK(()=>{this.c.$unregisterIssueDataProvider(m),this.b.delete(m)})}}e.$Qfc=C}),define(Pe[252],Re([1,0,6,3]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0;class C{constructor(P){this.b=0,this.a=P.getProxy(T.$CK.MainThreadLabelService)}$registerResourceLabelFormatter(P){const $=this.b++;return this.a.$registerResourceLabelFormatter($,P),(0,E.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$Rfc=C}),define(Pe[253],Re([1,0,2,26,8,7,80,3,12,29,18,16,296,19,22,6,95,89,75,60,11,14,23,159]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s,t,n,o,c,d,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=void 0;class u{constructor(z,V){this.d=z,this.e=V}async provideDocumentSymbols(z,V){const G=this.d.getDocument(z),J=await this.e.provideDocumentSymbols(G,V);if(!(0,R.$Jb)(J))return J[0]instanceof M.$WK?J.map(C.DocumentSymbol.from):u.f(J)}static f(z){z=z.slice(0).sort((J,q)=>{let ee=J.location.range.start.compareTo(q.location.range.start);return ee===0&&(ee=q.location.range.end.compareTo(J.location.range.end)),ee});const V=[],G=[];for(const J of z){const q={name:J.name||"!!MISSING: name!!",kind:C.SymbolKind.from(J.kind),tags:J.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:C.Range.from(J.location.range),selectionRange:C.Range.from(J.location.range),children:[]};for(;;){if(G.length===0){G.push(q),V.push(q);break}const ee=G[G.length-1];if(y.$Ds.containsRange(ee.range,q.range)&&!y.$Ds.equalsRange(ee.range,q.range)){ee.children?.push(q),G.push(q);break}G.pop()}}return V}}class f{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(z,V,G){this.g=z,this.h=V,this.j=G,this.e=new n.$jec("CodeLens"),this.f=new Map}async provideCodeLenses(z,V){const G=this.g.getDocument(z),J=await this.j.provideCodeLenses(G,V);if(!J||V.isCancellationRequested)return;const q=this.e.add(J),ee=new a.$Qc;this.f.set(q,ee);const ue={cacheId:q,lenses:[]};for(let Ne=0;Ne<J.length;Ne++)ue.lenses.push({cacheId:[q,Ne],range:C.Range.from(J[Ne].range),command:this.h.toInternal(J[Ne].command,ee)});return ue}async resolveCodeLens(z,V){const G=z.cacheId&&this.e.get(...z.cacheId);if(!G)return;let J;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?J=G:J=await this.j.resolveCodeLens(G,V),J||(J=G),V.isCancellationRequested)return;const q=z.cacheId&&this.f.get(z.cacheId[0]);if(q)return z.command=this.h.toInternal(J.command??f.d,q),z}releaseCodeLenses(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}}function v(De){return Array.isArray(De)?De.map(C.DefinitionLink.from):De?[C.DefinitionLink.from(De)]:[]}class g{constructor(z,V){this.d=z,this.e=V}async provideDefinition(z,V,G){const J=this.d.getDocument(z),q=C.Position.to(V),ee=await this.e.provideDefinition(J,q,G);return v(ee)}}class D{constructor(z,V){this.d=z,this.e=V}async provideDeclaration(z,V,G){const J=this.d.getDocument(z),q=C.Position.to(V),ee=await this.e.provideDeclaration(J,q,G);return v(ee)}}class I{constructor(z,V){this.d=z,this.e=V}async provideImplementation(z,V,G){const J=this.d.getDocument(z),q=C.Position.to(V),ee=await this.e.provideImplementation(J,q,G);return v(ee)}}class h{constructor(z,V){this.d=z,this.e=V}async provideTypeDefinition(z,V,G){const J=this.d.getDocument(z),q=C.Position.to(V),ee=await this.e.provideTypeDefinition(J,q,G);return v(ee)}}class w{constructor(z,V){this.d=z,this.e=V}async provideHover(z,V,G){const J=this.d.getDocument(z),q=C.Position.to(V),ee=await this.e.provideHover(J,q,G);if(!(!ee||(0,R.$Jb)(ee.contents)))return ee.range||(ee.range=J.getWordRangeAtPosition(q)),ee.range||(ee.range=new M.$GK(q,q)),C.Hover.from(ee)}}class k{constructor(z,V){this.d=z,this.e=V}async provideEvaluatableExpression(z,V,G){const J=this.d.getDocument(z),q=C.Position.to(V),ee=await this.e.provideEvaluatableExpression(J,q,G);if(ee)return C.EvaluatableExpression.from(ee)}}class F{constructor(z,V){this.d=z,this.e=V}async provideInlineValues(z,V,G,J){const q=this.d.getDocument(z),ee=await this.e.provideInlineValues(q,C.Range.to(V),C.InlineValueContext.to(G),J);if(Array.isArray(ee))return ee.map(ue=>C.InlineValue.from(ue))}}class W{constructor(z,V){this.d=z,this.e=V}async provideDocumentHighlights(z,V,G){const J=this.d.getDocument(z),q=C.Position.to(V),ee=await this.e.provideDocumentHighlights(J,q,G);if(Array.isArray(ee))return ee.map(C.DocumentHighlight.from)}}class Q{constructor(z,V){this.d=z,this.e=V}async provideLinkedEditingRanges(z,V,G){const J=this.d.getDocument(z),q=C.Position.to(V),ee=await this.e.provideLinkedEditingRanges(J,q,G);if(ee&&Array.isArray(ee.ranges))return{ranges:(0,R.$Gb)(ee.ranges.map(C.Range.from)),wordPattern:ee.wordPattern}}}class N{constructor(z,V){this.d=z,this.e=V}async provideReferences(z,V,G,J){const q=this.d.getDocument(z),ee=C.Position.to(V),ue=await this.e.provideReferences(q,ee,G,J);if(Array.isArray(ue))return ue.map(C.location.from)}}class A{static{this.d=1e3}constructor(z,V,G,J,q,ee,ue){this.g=z,this.h=V,this.j=G,this.k=J,this.l=q,this.m=ee,this.n=ue,this.e=new n.$jec("CodeAction"),this.f=new Map}async provideCodeActions(z,V,G,J){const q=this.g.getDocument(z),ee=l.$Fs.isISelection(V)?C.Selection.to(V):C.Range.to(V),ue=[];for(const _e of this.j.getDiagnostics(z))if(ee.intersection(_e.range)&&ue.push(_e)>A.d)break;const Ne={diagnostics:ue,only:G.only?new M.$YK(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},je=await this.k.provideCodeActions(q,ee,Ne,J);if(!(0,R.$Kb)(je)||J.isCancellationRequested)return;const Ye=this.e.add(je),Je=new a.$Qc;this.f.set(Ye,Je);const it=[];for(let _e=0;_e<je.length;_e++){const tt=je[_e];tt&&(A.o(tt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:tt.title,command:this.h.toInternal(tt,Je)})):(Ne.only&&(tt.kind?Ne.only.contains(tt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${tt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[Ye,_e],title:tt.title,command:tt.command&&this.h.toInternal(tt.command,Je),diagnostics:tt.diagnostics&&tt.diagnostics.map(C.Diagnostic.from),edit:tt.edit&&C.WorkspaceEdit.from(tt.edit,void 0),kind:tt.kind&&tt.kind.value,isPreferred:tt.isPreferred,isAI:(0,i.$PF)(this.m,"codeActionAI")?tt.isAI:!1,disabled:tt.disabled?.reason})))}return{cacheId:Ye,actions:it}}async resolveCodeAction(z,V){const[G,J]=z,q=this.e.get(G,J);if(!q||A.o(q))return{};if(!this.k.resolveCodeAction)return{};const ee=await this.k.resolveCodeAction(q,V)??q;let ue;ee.edit&&(ue=C.WorkspaceEdit.from(ee.edit,void 0));let Ne;if(ee.command){const je=this.f.get(G);je&&(Ne=this.h.toInternal(ee.command,je))}return{edit:ue,command:Ne}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class L{static toInternalProviderId(z,V){return z+"."+V}constructor(z,V,G,J,q){this.d=z,this.e=V,this.f=G,this.g=J,this.h=q}async prepareDocumentPaste(z,V,G,J){if(!this.f.prepareDocumentPaste)return;const q=this.e.getDocument(z),ee=V.map(je=>C.Range.to(je)),ue=C.DataTransfer.toDataTransfer(G,()=>{throw new c.$0});if(await this.f.prepareDocumentPaste(q,ee,ue,J),J.isCancellationRequested)return;const Ne=Array.from(ue).filter(([,je])=>!(je instanceof M.$sL));return C.DataTransfer.from(Ne)}async providePasteEdits(z,V,G,J,q){if(!this.f.provideDocumentPasteEdits)return;const ee=this.e.getDocument(V),ue=G.map(Ye=>C.Range.to(Ye)),Ne=C.DataTransfer.toDataTransfer(J,async Ye=>(await this.d.$resolvePasteFileData(this.g,z,Ye)).buffer),je=await this.f.provideDocumentPasteEdits(ee,ue,Ne,q);if(je)return{label:je.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:je.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:L.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?C.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class O{constructor(z,V){this.d=z,this.e=V}async provideDocumentFormattingEdits(z,V,G){const J=this.d.getDocument(z),q=await this.e.provideDocumentFormattingEdits(J,V,G);if(Array.isArray(q))return q.map(C.TextEdit.from)}}class x{constructor(z,V){this.d=z,this.e=V}async provideDocumentRangeFormattingEdits(z,V,G,J){const q=this.d.getDocument(z),ee=C.Range.to(V),ue=await this.e.provideDocumentRangeFormattingEdits(q,ee,G,J);if(Array.isArray(ue))return ue.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,V,G,J){(0,S.$Mf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this.d.getDocument(z),ee=V.map(C.Range.to),ue=await this.e.provideDocumentRangesFormattingEdits(q,ee,G,J);if(Array.isArray(ue))return ue.map(C.TextEdit.from)}}class le{constructor(z,V){this.d=z,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,V,G,J,q){const ee=this.d.getDocument(z),ue=C.Position.to(V),Ne=await this.e.provideOnTypeFormattingEdits(ee,ue,G,J,q);if(Array.isArray(Ne))return Ne.map(C.TextEdit.from)}}class me{constructor(z,V){this.e=z,this.f=V,this.d=new n.$jec("WorkspaceSymbols")}async provideWorkspaceSymbols(z,V){const G=await this.e.provideWorkspaceSymbols(z,V);if(!(0,R.$Kb)(G))return{symbols:[]};const J=this.d.add(G),q={cacheId:J,symbols:[]};for(let ee=0;ee<G.length;ee++){const ue=G[ee];if(!ue||!ue.name){this.f.warn("INVALID SymbolInformation",ue);continue}q.symbols.push({...C.WorkspaceSymbol.from(ue),cacheId:[J,ee]})}return q}async resolveWorkspaceSymbol(z,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const G=this.d.get(...z.cacheId);if(G){const J=await this.e.resolveWorkspaceSymbol(G,V);return J&&(0,T.$hn)(z,C.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class ye{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,V,G){this.d=z,this.e=V,this.f=G}async provideRenameEdits(z,V,G,J){const q=this.d.getDocument(z),ee=C.Position.to(V);try{const ue=await this.e.provideRenameEdits(q,ee,G,J);return ue?C.WorkspaceEdit.from(ue):void 0}catch(ue){const Ne=ye.g(ue);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(ue)}}async resolveRenameLocation(z,V,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(z),q=C.Position.to(V);try{const ee=await this.e.prepareRename(J,q,G);let ue,Ne;if(M.$GK.isRange(ee)?(ue=ee,Ne=J.getText(ee)):(0,S.$Ef)(ee)&&(ue=ee.range,Ne=ee.placeholder),!ue||!Ne)return;if(ue.start.line>q.line||ue.end.line<q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ue),text:Ne}}catch(ee){const ue=ye.g(ee);return ue?{rejectReason:ue,range:void 0,text:void 0}:Promise.reject(ee)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class we{constructor(z,V){this.resultId=z,this.tokens=V}}class de{constructor(z,V){this.f=z,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,V,G){const J=this.f.getDocument(z),q=V!==0?this.d.get(V):null;let ee=typeof q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,q.resultId,G):await this.g.provideDocumentSemanticTokens(J,G);return q&&this.d.delete(V),ee?(ee=de.h(ee),this.o(de.n(q,ee),ee)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return de.j(z)?de.k(z)?z:new M.$VL(new Uint32Array(z.data),z.resultId):de.l(z)?de.m(z)?z:new M.$XL(z.edits.map(V=>new M.$WL(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const V of z.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(z,V){if(!de.j(V)||!z||!z.tokens)return V;const G=z.tokens,J=G.length,q=V.data,ee=q.length;let ue=0;const Ne=Math.min(J,ee);for(;ue<Ne&&G[ue]===q[ue];)ue++;if(ue===J&&ue===ee)return new M.$XL([],V.resultId);let je=0;const Ye=Ne-ue;for(;je<Ye&&G[J-je-1]===q[ee-je-1];)je++;return new M.$XL([{start:ue,deleteCount:J-ue-je,data:q.subarray(ue,ee-je)}],V.resultId)}o(z,V){if(de.j(z)){const G=this.e++;return this.d.set(G,new we(z.resultId,z.data)),(0,s.$80)({id:G,type:"full",data:z.data})}if(de.l(z)){const G=this.e++;return de.j(V)?this.d.set(G,new we(V.resultId,V.data)):this.d.set(G,new we(z.resultId)),(0,s.$80)({id:G,type:"delta",deltas:(z.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class be{constructor(z,V){this.d=z,this.e=V}async provideDocumentRangeSemanticTokens(z,V,G){const J=this.d.getDocument(z),q=await this.e.provideDocumentRangeSemanticTokens(J,C.Range.to(V),G);return q?this.f(q):null}f(z){return(0,s.$80)({id:0,type:"full",data:z.data})}}class ie{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,V,G,J,q){this.f=z,this.g=V,this.h=G,this.j=J,this.k=q,this.d=new n.$jec("CompletionItem"),this.e=new Map}async provideCompletionItems(z,V,G,J){const q=this.f.getDocument(z),ee=C.Position.to(V),ue=q.getWordRangeAtPosition(ee)||new M.$GK(ee,ee),Ne=ue.with({end:ee}),je=new o.$Nd,Ye=await this.h.provideCompletionItems(q,ee,J,C.CompletionContext.to(G));if(!Ye||J.isCancellationRequested)return;const Je=Array.isArray(Ye)?new M.$_K(Ye):Ye,it=ie.supportsResolving(this.h)?this.d.add(Je.items):this.d.add([]),_e=new a.$Qc;this.e.set(it,_e);const tt=[],rt={x:it,b:tt,a:{replace:C.Range.from(ue),insert:C.Range.from(Ne)},c:Je.isIncomplete||void 0,d:je.elapsed()};for(let nt=0;nt<Je.items.length;nt++){const ze=Je.items[nt],ht=this.l(ze,[it,nt],Ne,ue);tt.push(ht)}return rt}async resolveCompletionItem(z,V){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...z);if(!G)return;const J=this.l(G,z),q=await this.h.resolveCompletionItem(G,V);if(!q)return;const ee=this.l(q,z);return(J.h!==ee.h||J.i!==ee.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==ee.n||J.o!==ee.o||!(0,T.$in)(J.p,ee.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:ee.d,c:ee.c,l:ee.l,h:ee.h,i:ee.i,n:ee.n,o:ee.o,p:ee.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,V,G,J){const q=this.e.get(V[0]);if(!q)throw Error("DisposableStore is missing...");const ee=this.g.toInternal(z.command,q),ue={x:V,a:z.label,b:z.kind!==void 0?C.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(C.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:C.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(C.TextEdit.from),n:ee?.$ident,o:ee?.id,p:ee?.$ident?void 0:ee?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ue.h=z.textEdit.newText):typeof z.insertText=="string"?ue.h=z.insertText:z.insertText instanceof M.$PK&&(ue.h=z.insertText.value,ue.i|=4);let Ne;return z.textEdit?Ne=z.textEdit.range:z.range&&(Ne=z.range),M.$GK.isRange(Ne)?ue.j=C.Range.from(Ne):Ne&&(!G?.isEqual(Ne.inserting)||!J?.isEqual(Ne.replacing))&&(ue.j={insert:C.Range.from(Ne.inserting),replace:C.Range.from(Ne.replacing)}),ue}}class Ie{async provideInlineCompletions(z,V,G,J){}disposeCompletions(z){}handleDidShowCompletionItem(z,V,G){}handlePartialAccept(z,V,G){}}class ce extends Ie{constructor(z,V,G,J){super(),this.f=z,this.g=V,this.h=G,this.j=J,this.d=new Y,this.e=(0,i.$PF)(this.f,"inlineCompletionsAdditions"),this.k={[P.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[P.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$PF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,V,G,J){const q=this.g.getDocument(z),ee=C.Position.to(V),ue=await this.h.provideInlineCompletionItems(q,ee,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},J);if(!ue||J.isCancellationRequested)return;const Ne=Array.isArray(ue)?ue:ue.items,je=this.e?Array.isArray(ue)?[]:ue.commands||[]:[],Ye=this.e&&!Array.isArray(ue)?ue.enableForwardStability:void 0;let Je;return{pid:this.d.createReferenceId({dispose(){Je?.dispose()},items:Ne}),items:Ne.map((_e,tt)=>{let rt;_e.command&&(Je||(Je=new a.$Qc),rt=this.j.toInternal(_e.command,Je));const nt=_e.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:_e.filterText,range:_e.range?C.Range.from(_e.range):void 0,command:rt,idx:tt,completeBracketPairs:this.e?_e.completeBracketPairs:!1}}),commands:je.map(_e=>(Je||(Je=new a.$Qc),this.j.toInternal(_e,Je))),suppressSuggestions:!1,enableForwardStability:Ye}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,V,G){const J=this.d.get(z)?.items[V];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,G)}handlePartialAccept(z,V,G){const J=this.d.get(z)?.items[V];J&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(J,G)}}class Y{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const V=this.e++;return this.d.set(V,z),V}disposeReferenceId(z){const V=this.d.get(z);return this.d.delete(z),V}get(z){return this.d.get(z)}}class B{constructor(z,V){this.e=z,this.f=V,this.d=new n.$jec("SignatureHelp")}async provideSignatureHelp(z,V,G,J){const q=this.e.getDocument(z),ee=C.Position.to(V),ue=this.g(G),Ne=await this.f.provideSignatureHelp(q,ee,J,ue);if(Ne){const je=this.d.add([Ne]);return{...C.SignatureHelp.from(Ne),id:je}}}g(z){let V;if(z.activeSignatureHelp){const G=C.SignatureHelp.to(z.activeSignatureHelp),J=this.d.get(z.activeSignatureHelp.id,0);J?(V=J,V.activeSignature=G.activeSignature,V.activeParameter=G.activeParameter):V=G}return{...z,activeSignatureHelp:V}}releaseSignatureHelp(z){this.d.delete(z)}}class se{constructor(z,V,G,J,q){this.f=z,this.g=V,this.h=G,this.j=J,this.k=q,this.d=new n.$jec("InlayHints"),this.e=new Map}async provideInlayHints(z,V,G){const J=this.f.getDocument(z),q=C.Range.to(V),ee=await this.h.provideInlayHints(J,q,G);if(!Array.isArray(ee)||ee.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(G.isCancellationRequested)return;const ue=this.d.add(ee);this.e.set(ue,new a.$Qc);const Ne={hints:[],cacheId:ue};for(let je=0;je<ee.length;je++)this.l(ee[je],q)&&Ne.hints.push(this.m(ee[je],[ue,je]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),Ne}async resolveInlayHint(z,V){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...z);if(!G)return;const J=await this.h.resolveInlayHint(G,V);if(J&&this.l(J))return this.m(J,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,V){return z.label.length===0||Array.isArray(z.label)&&z.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(V&&!V.contains(z.position))}m(z,V){const G=this.e.get(V[0]);if(!G)throw Error("DisposableStore is missing...");const J={label:"",cacheId:V,tooltip:C.MarkdownString.fromStrict(z.tooltip),position:C.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(C.TextEdit.from),kind:z.kind&&C.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};return typeof z.label=="string"?J.label=z.label:J.label=z.label.map(q=>{const ee={label:q.value};return ee.tooltip=C.MarkdownString.fromStrict(q.tooltip),M.$QK.isLocation(q.location)&&(ee.location=C.location.from(q.location)),q.command&&(ee.command=this.g.toInternal(q.command,G)),ee}),J}}class Se{constructor(z,V){this.e=z,this.f=V,this.d=new n.$jec("DocumentLink")}async provideLinks(z,V){const G=this.e.getDocument(z),J=await this.f.provideDocumentLinks(G,V);if(!(!Array.isArray(J)||J.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(Se.g).map(C.DocumentLink.from)};{const q=this.d.add(J),ee={links:[],cacheId:q};for(let ue=0;ue<J.length;ue++){if(!Se.g(J[ue]))continue;const Ne=C.DocumentLink.from(J[ue]);Ne.cacheId=[q,ue],ee.links.push(Ne)}return ee}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,V){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...z);if(!G)return;const J=await this.f.resolveDocumentLink(G,V);if(!(!J||!Se.g(J)))return C.DocumentLink.from(J)}releaseLinks(z){this.d.delete(z)}}class Ae{constructor(z,V){this.d=z,this.e=V}async provideColors(z,V){const G=this.d.getDocument(z),J=await this.e.provideDocumentColors(G,V);return Array.isArray(J)?J.map(ee=>({color:C.Color.from(ee.color),range:C.Range.from(ee.range)})):[]}async provideColorPresentations(z,V,G){const J=this.d.getDocument(z),q=C.Range.to(V.range),ee=C.Color.to(V.color),ue=await this.e.provideColorPresentations(ee,{document:J,range:q},G);if(Array.isArray(ue))return ue.map(C.ColorPresentation.from)}}class Ce{constructor(z,V){this.d=z,this.e=V}async provideFoldingRanges(z,V,G){const J=this.d.getDocument(z),q=await this.e.provideFoldingRanges(J,V,G);if(Array.isArray(q))return q.map(C.FoldingRange.from)}}class fe{constructor(z,V,G){this.d=z,this.e=V,this.f=G}async provideSelectionRanges(z,V,G){const J=this.d.getDocument(z),q=V.map(C.Position.to),ee=await this.e.provideSelectionRanges(J,q,G);if(!(0,R.$Kb)(ee))return[];if(ee.length!==q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ue=[];for(let Ne=0;Ne<q.length;Ne++){const je=[];ue.push(je);let Ye=q[Ne],Je=ee[Ne];for(;;){if(!Je.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(je.push(C.SelectionRange.from(Je)),!Je.parent)break;Ye=Je.range,Je=Je.parent}}return ue}}class ne{constructor(z,V){this.f=z,this.g=V,this.d=new t.$JM(""),this.e=new Map}async prepareSession(z,V,G){const J=this.f.getDocument(z),q=C.Position.to(V),ee=await this.g.prepareCallHierarchy(J,q,G);if(!ee)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(ee)?ee.map(Ne=>this.h(ue,Ne)):[this.h(ue,ee)]}async provideCallsTo(z,V,G){const J=this.j(z,V);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyIncomingCalls(J,G);if(q)return q.map(ee=>({from:this.h(z,ee.from),fromRanges:ee.fromRanges.map(ue=>C.Range.from(ue))}))}async provideCallsFrom(z,V,G){const J=this.j(z,V);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyOutgoingCalls(J,G);if(q)return q.map(ee=>({to:this.h(z,ee.to),fromRanges:ee.fromRanges.map(ue=>C.Range.from(ue))}))}releaseSession(z){this.e.delete(z)}h(z,V){const G=this.e.get(z),J=C.CallHierarchyItem.from(V,z,G.size.toString(36));return G.set(J._itemId,V),J}j(z,V){return this.e.get(z)?.get(V)}}class H{constructor(z,V){this.f=z,this.g=V,this.d=new t.$JM(""),this.e=new Map}async prepareSession(z,V,G){const J=this.f.getDocument(z),q=C.Position.to(V),ee=await this.g.prepareTypeHierarchy(J,q,G);if(!ee)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(ee)?ee.map(Ne=>this.h(ue,Ne)):[this.h(ue,ee)]}async provideSupertypes(z,V,G){const J=this.j(z,V);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySupertypes(J,G);if(q)return q.map(ee=>this.h(z,ee))}async provideSubtypes(z,V,G){const J=this.j(z,V);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySubtypes(J,G);if(q)return q.map(ee=>this.h(z,ee))}releaseSession(z){this.e.delete(z)}h(z,V){const G=this.e.get(z),J=C.TypeHierarchyItem.from(V,z,G.size.toString(36));return G.set(J._itemId,V),J}j(z,V){return this.e.get(z)?.get(V)}}class te{static toInternalProviderId(z,V){return z+"."+V}constructor(z,V,G,J,q){this.d=z,this.e=V,this.f=G,this.g=J,this.h=q}async provideDocumentOnDropEdits(z,V,G,J,q){const ee=this.e.getDocument(V),ue=C.Position.to(G),Ne=C.DataTransfer.toDataTransfer(J,async Ye=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,Ye)).buffer),je=await this.f.provideDocumentDropEdits(ee,ue,Ne,q);if(je)return{label:je.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:je.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:te.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?C.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class X{constructor(z,V){this.d=z,this.e=V}async provideMappedEdits(z,V,G,J){const q=E.URI.revive(z),ee=this.d.getDocument(q),ue=G.documents.map(Ye=>Ye.map(Je=>({uri:E.URI.revive(Je.uri),version:Je.version,ranges:Je.ranges.map(it=>C.Range.to(it))}))),Ne={documents:ue,selections:ue[0]?.[0]?.ranges??[]},je=await this.e.provideMappedEdits(ee,V,Ne,J);return je?C.WorkspaceEdit.from(je):null}}class re{constructor(z,V){this.adapter=z,this.extension=V}}class he{static{this.d=0}constructor(z,V,G,J,q,ee,ue,Ne){this.g=V,this.h=G,this.j=J,this.k=q,this.l=ee,this.m=ue,this.n=Ne,this.f=new Map,this.e=z.getProxy($.$CK.MainThreadLanguageFeatures)}o(z,V){return C.DocumentSelector.from(z,this.g,V)}p(z){return new M.$EK(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return he.d++}async s(z,V,G,J,q,ee=!1){const ue=this.f.get(z);if(!ue||!(ue.adapter instanceof V))return J;const Ne=Date.now();ee||this.l.trace(`[${ue.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const je=G(ue.adapter,ue.extension);return Promise.resolve(je).catch(Ye=>{(0,c.$3)(Ye)||(this.l.error(`[${ue.extension.identifier.value}] provider FAILED`),this.l.error(Ye),this.n.onExtensionError(ue.extension.identifier,Ye))}).finally(()=>{ee||this.l.trace(`[${ue.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),p.CancellationToken.isCancellationToken(q)?(0,d.$Pg)(je,q):je}t(z,V){const G=this.q();return this.f.set(G,new re(z,V)),G}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,V,G,J){const q=this.t(new u(this.h,G),z),ee=J&&J.label||he.u(z);return this.e.$registerDocumentSymbolProvider(q,this.o(V,z),ee),this.p(q)}$provideDocumentSymbols(z,V,G){return this.s(z,u,J=>J.provideDocumentSymbols(E.URI.revive(V),G),void 0,G)}registerCodeLensProvider(z,V,G){const J=this.q(),q=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new re(new f(this.h,this.j.converter,G),z)),this.e.$registerCodeLensSupport(J,this.o(V,z),q);let ee=this.p(J);if(q!==void 0){const ue=G.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(q));ee=M.$EK.from(ee,ue)}return ee}$provideCodeLenses(z,V,G){return this.s(z,f,J=>J.provideCodeLenses(E.URI.revive(V),G),void 0,G)}$resolveCodeLens(z,V,G){return this.s(z,f,J=>J.resolveCodeLens(V,G),void 0,void 0)}$releaseCodeLenses(z,V){this.s(z,f,G=>Promise.resolve(G.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(z,V,G){const J=this.t(new g(this.h,G),z);return this.e.$registerDefinitionSupport(J,this.o(V,z)),this.p(J)}$provideDefinition(z,V,G,J){return this.s(z,g,q=>q.provideDefinition(E.URI.revive(V),G,J),[],J)}registerDeclarationProvider(z,V,G){const J=this.t(new D(this.h,G),z);return this.e.$registerDeclarationSupport(J,this.o(V,z)),this.p(J)}$provideDeclaration(z,V,G,J){return this.s(z,D,q=>q.provideDeclaration(E.URI.revive(V),G,J),[],J)}registerImplementationProvider(z,V,G){const J=this.t(new I(this.h,G),z);return this.e.$registerImplementationSupport(J,this.o(V,z)),this.p(J)}$provideImplementation(z,V,G,J){return this.s(z,I,q=>q.provideImplementation(E.URI.revive(V),G,J),[],J)}registerTypeDefinitionProvider(z,V,G){const J=this.t(new h(this.h,G),z);return this.e.$registerTypeDefinitionSupport(J,this.o(V,z)),this.p(J)}$provideTypeDefinition(z,V,G,J){return this.s(z,h,q=>q.provideTypeDefinition(E.URI.revive(V),G,J),[],J)}registerHoverProvider(z,V,G,J){const q=this.t(new w(this.h,G),z);return this.e.$registerHoverProvider(q,this.o(V,z)),this.p(q)}$provideHover(z,V,G,J){return this.s(z,w,q=>q.provideHover(E.URI.revive(V),G,J),void 0,J)}registerEvaluatableExpressionProvider(z,V,G,J){const q=this.t(new k(this.h,G),z);return this.e.$registerEvaluatableExpressionProvider(q,this.o(V,z)),this.p(q)}$provideEvaluatableExpression(z,V,G,J){return this.s(z,k,q=>q.provideEvaluatableExpression(E.URI.revive(V),G,J),void 0,J)}registerInlineValuesProvider(z,V,G,J){const q=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,ee=this.t(new F(this.h,G),z);this.e.$registerInlineValuesProvider(ee,this.o(V,z),q);let ue=this.p(ee);if(q!==void 0){const Ne=G.onDidChangeInlineValues(je=>this.e.$emitInlineValuesEvent(q));ue=M.$EK.from(ue,Ne)}return ue}$provideInlineValues(z,V,G,J,q){return this.s(z,F,ee=>ee.provideInlineValues(E.URI.revive(V),G,J,q),void 0,q)}registerDocumentHighlightProvider(z,V,G){const J=this.t(new W(this.h,G),z);return this.e.$registerDocumentHighlightProvider(J,this.o(V,z)),this.p(J)}$provideDocumentHighlights(z,V,G,J){return this.s(z,W,q=>q.provideDocumentHighlights(E.URI.revive(V),G,J),void 0,J)}registerLinkedEditingRangeProvider(z,V,G){const J=this.t(new Q(this.h,G),z);return this.e.$registerLinkedEditingRangeProvider(J,this.o(V,z)),this.p(J)}$provideLinkedEditingRanges(z,V,G,J){return this.s(z,Q,async q=>{const ee=await q.provideLinkedEditingRanges(E.URI.revive(V),G,J);if(ee)return{ranges:ee.ranges,wordPattern:ee.wordPattern?he.w(ee.wordPattern):void 0}},void 0,J)}registerReferenceProvider(z,V,G){const J=this.t(new N(this.h,G),z);return this.e.$registerReferenceSupport(J,this.o(V,z)),this.p(J)}$provideReferences(z,V,G,J,q){return this.s(z,N,ee=>ee.provideReferences(E.URI.revive(V),G,J,q),void 0,q)}registerCodeActionProvider(z,V,G,J){const q=new a.$Qc,ee=this.t(new A(this.h,this.j.converter,this.k,G,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(ee,this.o(V,z),{providedKinds:J?.providedCodeActionKinds?.map(ue=>ue.value),documentation:J?.documentation?.map(ue=>({kind:ue.kind.value,command:this.j.converter.toInternal(ue.command,q)}))},he.u(z),!!G.resolveCodeAction),q.add(this.p(ee)),q}$provideCodeActions(z,V,G,J,q){return this.s(z,A,ee=>ee.provideCodeActions(E.URI.revive(V),G,J,q),void 0,q)}$resolveCodeAction(z,V,G){return this.s(z,A,J=>J.resolveCodeAction(V,G),{},void 0)}$releaseCodeActions(z,V){this.s(z,A,G=>Promise.resolve(G.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(z,V,G){const J=this.t(new O(this.h,G),z);return this.e.$registerDocumentFormattingSupport(J,this.o(V,z),z.identifier,z.displayName||z.name),this.p(J)}$provideDocumentFormattingEdits(z,V,G,J){return this.s(z,O,q=>q.provideDocumentFormattingEdits(E.URI.revive(V),G,J),void 0,J)}registerDocumentRangeFormattingEditProvider(z,V,G){const J=typeof G.provideDocumentRangesFormattingEdits=="function",q=this.t(new x(this.h,G),z);return this.e.$registerRangeFormattingSupport(q,this.o(V,z),z.identifier,z.displayName||z.name,J),this.p(q)}$provideDocumentRangeFormattingEdits(z,V,G,J,q){return this.s(z,x,ee=>ee.provideDocumentRangeFormattingEdits(E.URI.revive(V),G,J,q),void 0,q)}$provideDocumentRangesFormattingEdits(z,V,G,J,q){return this.s(z,x,ee=>ee.provideDocumentRangesFormattingEdits(E.URI.revive(V),G,J,q),void 0,q)}registerOnTypeFormattingEditProvider(z,V,G,J){const q=this.t(new le(this.h,G),z);return this.e.$registerOnTypeFormattingSupport(q,this.o(V,z),J,z.identifier),this.p(q)}$provideOnTypeFormattingEdits(z,V,G,J,q,ee){return this.s(z,le,ue=>ue.provideOnTypeFormattingEdits(E.URI.revive(V),G,J,q,ee),void 0,ee)}registerWorkspaceSymbolProvider(z,V){const G=this.t(new me(V,this.l),z);return this.e.$registerNavigateTypeSupport(G,typeof V.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(z,V,G){return this.s(z,me,J=>J.provideWorkspaceSymbols(V,G),{symbols:[]},G)}$resolveWorkspaceSymbol(z,V,G){return this.s(z,me,J=>J.resolveWorkspaceSymbol(V,G),void 0,void 0)}$releaseWorkspaceSymbols(z,V){this.s(z,me,G=>G.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(z,V,G){const J=this.t(new ye(this.h,G,this.l),z);return this.e.$registerRenameSupport(J,this.o(V,z),ye.supportsResolving(G)),this.p(J)}$provideRenameEdits(z,V,G,J,q){return this.s(z,ye,ee=>ee.provideRenameEdits(E.URI.revive(V),G,J,q),void 0,q)}$resolveRenameLocation(z,V,G,J){return this.s(z,ye,q=>q.resolveRenameLocation(E.URI.revive(V),G,J),void 0,J)}registerDocumentSemanticTokensProvider(z,V,G,J){const q=this.t(new de(this.h,G),z),ee=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(q,this.o(V,z),J,ee);let ue=this.p(q);if(ee){const Ne=G.onDidChangeSemanticTokens(je=>this.e.$emitDocumentSemanticTokensEvent(ee));ue=M.$EK.from(ue,Ne)}return ue}$provideDocumentSemanticTokens(z,V,G,J){return this.s(z,de,q=>q.provideDocumentSemanticTokens(E.URI.revive(V),G,J),null,J)}$releaseDocumentSemanticTokens(z,V){this.s(z,de,G=>G.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,V,G,J){const q=this.t(new be(this.h,G),z);return this.e.$registerDocumentRangeSemanticTokensProvider(q,this.o(V,z),J),this.p(q)}$provideDocumentRangeSemanticTokens(z,V,G,J){return this.s(z,be,q=>q.provideDocumentRangeSemanticTokens(E.URI.revive(V),G,J),null,J)}registerCompletionItemProvider(z,V,G,J){const q=this.t(new ie(this.h,this.j.converter,G,this.m,z),z);return this.e.$registerCompletionsProvider(q,this.o(V,z),J,ie.supportsResolving(G),z.identifier),this.p(q)}$provideCompletionItems(z,V,G,J,q){return this.s(z,ie,ee=>ee.provideCompletionItems(E.URI.revive(V),G,J,q),void 0,q)}$resolveCompletionItem(z,V,G){return this.s(z,ie,J=>J.resolveCompletionItem(V,G),void 0,G)}$releaseCompletionItems(z,V){this.s(z,ie,G=>G.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(z,V,G,J){const q=new ce(z,this.h,G,this.j.converter),ee=this.t(q,z);return this.e.$registerInlineCompletionsSupport(ee,this.o(V,z),q.supportsHandleEvents,b.$dm.toKey(z.identifier.value),J?.yieldTo?.map(ue=>b.$dm.toKey(ue))||[]),this.p(ee)}$provideInlineCompletions(z,V,G,J,q){return this.s(z,Ie,ee=>ee.provideInlineCompletions(E.URI.revive(V),G,J,q),void 0,q)}$handleInlineCompletionDidShow(z,V,G,J){this.s(z,Ie,async q=>{q.handleDidShowCompletionItem(V,G,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,V,G,J){this.s(z,Ie,async q=>{q.handlePartialAccept(V,G,J)},void 0,void 0)}$freeInlineCompletionsList(z,V){this.s(z,Ie,async G=>{G.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(z,V,G,J){const q=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,ee=this.t(new B(this.h,G),z);return this.e.$registerSignatureHelpProvider(ee,this.o(V,z),q),this.p(ee)}$provideSignatureHelp(z,V,G,J,q){return this.s(z,B,ee=>ee.provideSignatureHelp(E.URI.revive(V),G,J,q),void 0,q)}$releaseSignatureHelp(z,V){this.s(z,B,G=>G.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(z,V,G){const J=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,q=this.t(new se(this.h,this.j.converter,G,this.l,z),z);this.e.$registerInlayHintsProvider(q,this.o(V,z),typeof G.resolveInlayHint=="function",J,he.u(z));let ee=this.p(q);if(J!==void 0){const ue=G.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(J));ee=M.$EK.from(ee,ue)}return ee}$provideInlayHints(z,V,G,J){return this.s(z,se,q=>q.provideInlayHints(E.URI.revive(V),G,J),void 0,J)}$resolveInlayHint(z,V,G){return this.s(z,se,J=>J.resolveInlayHint(V,G),void 0,G)}$releaseInlayHints(z,V){this.s(z,se,G=>G.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(z,V,G){const J=this.t(new Se(this.h,G),z);return this.e.$registerDocumentLinkProvider(J,this.o(V,z),typeof G.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(z,V,G){return this.s(z,Se,J=>J.provideLinks(E.URI.revive(V),G),void 0,G,V.scheme==="output")}$resolveDocumentLink(z,V,G){return this.s(z,Se,J=>J.resolveLink(V,G),void 0,void 0,!0)}$releaseDocumentLinks(z,V){this.s(z,Se,G=>G.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(z,V,G){const J=this.t(new Ae(this.h,G),z);return this.e.$registerDocumentColorProvider(J,this.o(V,z)),this.p(J)}$provideDocumentColors(z,V,G){return this.s(z,Ae,J=>J.provideColors(E.URI.revive(V),G),[],G)}$provideColorPresentations(z,V,G,J){return this.s(z,Ae,q=>q.provideColorPresentations(E.URI.revive(V),G,J),void 0,J)}registerFoldingRangeProvider(z,V,G){const J=this.q(),q=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new re(new Ce(this.h,G),z)),this.e.$registerFoldingRangeProvider(J,this.o(V,z),z.identifier,q);let ee=this.p(J);if(q!==void 0){const ue=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(q));ee=M.$EK.from(ee,ue)}return ee}$provideFoldingRanges(z,V,G,J){return this.s(z,Ce,q=>q.provideFoldingRanges(E.URI.revive(V),G,J),void 0,J)}registerSelectionRangeProvider(z,V,G){const J=this.t(new fe(this.h,G,this.l),z);return this.e.$registerSelectionRangeProvider(J,this.o(V,z)),this.p(J)}$provideSelectionRanges(z,V,G,J){return this.s(z,fe,q=>q.provideSelectionRanges(E.URI.revive(V),G,J),[],J)}registerCallHierarchyProvider(z,V,G){const J=this.t(new ne(this.h,G),z);return this.e.$registerCallHierarchyProvider(J,this.o(V,z)),this.p(J)}$prepareCallHierarchy(z,V,G,J){return this.s(z,ne,q=>Promise.resolve(q.prepareSession(E.URI.revive(V),G,J)),void 0,J)}$provideCallHierarchyIncomingCalls(z,V,G,J){return this.s(z,ne,q=>q.provideCallsTo(V,G,J),void 0,J)}$provideCallHierarchyOutgoingCalls(z,V,G,J){return this.s(z,ne,q=>q.provideCallsFrom(V,G,J),void 0,J)}$releaseCallHierarchy(z,V){this.s(z,ne,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(z,V,G){const J=this.t(new H(this.h,G),z);return this.e.$registerTypeHierarchyProvider(J,this.o(V,z)),this.p(J)}$prepareTypeHierarchy(z,V,G,J){return this.s(z,H,q=>Promise.resolve(q.prepareSession(E.URI.revive(V),G,J)),void 0,J)}$provideTypeHierarchySupertypes(z,V,G,J){return this.s(z,H,q=>q.provideSupertypes(V,G,J),void 0,J)}$provideTypeHierarchySubtypes(z,V,G,J){return this.s(z,H,q=>q.provideSubtypes(V,G,J),void 0,J)}$releaseTypeHierarchy(z,V){this.s(z,H,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(z,V,G,J){const q=this.q();this.f.set(q,new re(new te(this.e,this.h,G,q,z),z));const ee=(0,i.$PF)(z,"dropMetadata")&&J?te.toInternalProviderId(z.identifier.value,J.id):void 0;return this.e.$registerDocumentOnDropEditProvider(q,this.o(V,z),ee,(0,i.$PF)(z,"dropMetadata")?J:void 0),this.p(q)}$provideDocumentOnDropEdits(z,V,G,J,q,ee){return this.s(z,te,ue=>Promise.resolve(ue.provideDocumentOnDropEdits(V,E.URI.revive(G),J,q,ee)),void 0,void 0)}registerMappedEditsProvider(z,V,G){const J=this.t(new X(this.h,G),z);return this.e.$registerMappedEditsProvider(J,this.o(V,z)),this.p(J)}$provideMappedEdits(z,V,G,J,q){return this.s(z,X,ee=>Promise.resolve(ee.provideMappedEdits(V,G,J,q)),null,q)}registerDocumentPasteEditProvider(z,V,G,J){const q=this.q();this.f.set(q,new re(new L(this.e,this.h,G,q,z),z));const ee=L.toInternalProviderId(z.identifier.value,J.id);return this.e.$registerPasteEditProvider(q,this.o(V,z),ee,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(q)}$prepareDocumentPaste(z,V,G,J,q){return this.s(z,L,ee=>ee.prepareDocumentPaste(E.URI.revive(V),G,J,q),void 0,q)}$providePasteEdits(z,V,G,J,q,ee){return this.s(z,L,ue=>ue.providePasteEdits(V,E.URI.revive(G),J,q,ee),void 0,ee)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:he.w(z.decreaseIndentPattern),increaseIndentPattern:he.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?he.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?he.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:he.w(z.beforeText),afterText:z.afterText?he.w(z.afterText):void 0,previousLineText:z.previousLineText?he.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(he.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(V=>M.SyntaxTokenType.toString(V)):void 0}}static D(z){return z.map(he.C)}setLanguageConfiguration(z,V,G){const{wordPattern:J}=G;if(J&&(0,m.$Se)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(V,J):this.h.setWordDefinitionFor(V,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const q=this.q(),ee={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?he.w(G.wordPattern):void 0,indentationRules:G.indentationRules?he.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?he.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?he.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(q,V,ee),this.p(q)}$setWordDefinitions(z){for(const V of z)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$tec=he}),define(Pe[254],Re([1,0,3,8,7,31,14,6,23]),function(pe,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;class y{constructor(S,l,p,b){this.c=l,this.d=p,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(E.$CK.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,l){await this.a.$changeLanguage(S,l);const p=this.c.getDocumentData(S);if(!p)throw new Error(`document '${S.toString()}' NOT found`);return p.document}async tokenAtPosition(S,l){const p=S.version,b=T.Position.from(l),a=await this.a.$tokensAtPosition(S.uri,b),s={type:C.StandardTokenType.Other,range:S.getWordRangeAtPosition(l)??new C.$GK(l.line,l.character,l.line,l.character)};if(!a)return s;const t={range:T.Range.to(a.range),type:T.TokenType.to(a.type)};return!t.range.contains(l)||p!==S.version?s:t}createLanguageStatusItem(S,l,p){const b=this.f++,a=this.a,s=this.g,t=`${S.identifier.value}/${l}`;if(s.has(t))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);s.add(t);const n={selector:p,id:l,name:S.displayName??S.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const c=new $.$Qc,d=()=>{if(o?.dispose(),!s.has(t)){console.warn(`LanguageStatusItem (${l}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,P.$2g)(()=>{c.clear(),this.a.$setLanguageStatus(b,{id:t,name:n.name??S.displayName??S.name,source:S.displayName??S.name,selector:T.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===C.LanguageStatusSeverity.Error?M.default.Error:n.severity===C.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),o?.dispose(),a.$removeLanguageStatus(b),s.delete(t)},get id(){return n.id},get name(){return n.name},set name(r){n.name=r,d()},get selector(){return n.selector},set selector(r){n.selector=r,d()},get text(){return n.text},set text(r){n.text=r,d()},set text2(r){(0,m.$QF)(S,"languageStatusText"),n.text=r,d()},get text2(){return(0,m.$QF)(S,"languageStatusText"),n.text},get detail(){return n.detail},set detail(r){n.detail=r,d()},get severity(){return n.severity},set severity(r){n.severity=r,d()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(r){n.accessibilityInformation=r,d()},get command(){return n.command},set command(r){n.command=r,d()},get busy(){return n.busy},set busy(r){n.busy=r,d()}};return d(),i}}e.$Sfc=y}),define(Pe[82],Re([1,0,21,12,2,4,15,3,27,17]),function(pe,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=e.$efc=void 0;let R=class{constructor(l,p,b){this.f=b,this.d=new Map,this.a=p.getProxy($.$CK.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===E.$g}getMessage(l,p){const{message:b,args:a,comment:s}=p;if(this.c)return(0,T.$He)(b,a??{});let t=b;s&&s.length>0&&(t+=`/${Array.isArray(s)?s.join(""):s}`);const n=this.d.get(l)?.contents[t];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,T.$He)(n??b,a??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let p;const b=await this.g(l);if(!b){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(b),s=JSON.parse(a);p=l.isBuiltin?s.contents?.bundle:s}catch(a){this.f.error(`Failed to load translations for ${l.identifier.value} from ${b}: ${a.message}`);return}p&&this.d.set(l.identifier.value,{contents:p,uri:b})}async g(l){if(l.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return C.URI.revive(p)}return l.l10n?C.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$efc=R,e.$efc=R=Ke([We(0,m.$UM),We(1,y.$EM),We(2,P.$hj)],R),e.$ffc=(0,M.$Zh)("IExtHostLocalizationService")}),define(Pe[255],Re([1,0,15,3,27,17,2,51]),function(pe,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;let m=class extends E.$sj{constructor(S,l){super(l.logLevel,l.logsLocation,l.loggers.map(p=>(0,$.$wh)(p))),this.r=S.getProxy(T.$CK.MainThreadLogger)}$setLogLevel(S,l){l?this.setLogLevel(P.URI.revive(l),S):this.setLogLevel(S)}setVisibility(S,l){super.setVisibility(S,l),this.r.$setVisibility(S,l)}s(S,l,p){return new y(this.r,S,l,p)}};e.$rgc=m,e.$rgc=m=Ke([We(0,M.$EM),We(1,C.$UM)],m);class y extends E.$nj{constructor(S,l,p,b){super(b?.logLevel==="always"),this.r=S,this.s=l,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(l,b).then(()=>{this.u(this.n),this.m=!0})}g(S,l){const p=[[S,l]];this.m?this.u(p):this.n.push(...p)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Pe[83],Re([1,0,3,4,6,17,24]),function(pe,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=e.$gfc=void 0,e.$gfc=(0,T.$Zh)("IExtHostManagedSockets");let $=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(E.$CK.MainThreadManagedSockets)}setFactory(S,l){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(S,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const l=++this.b,p=await this.c.makeConnection(),b=new C.$Qc;return this.d.set(l,new y(l,p,b)),b.add((0,C.$Pc)(()=>this.d.delete(l))),b.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),b.dispose()})),b.add(p.onDidClose(a=>{this.a.$onDidManagedSocketClose(l,a?.stack??a?.message),b.dispose()})),b.add(p.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(l,P.$fe.wrap(a)))),l}$remoteSocketWrite(S,l){this.d.get(S)?.actual.send(l.buffer)}$remoteSocketEnd(S){const l=this.d.get(S);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$hfc=$,e.$hfc=$=Ke([We(0,M.$EM)],$);class m{constructor(S,l){this.socketFactoryId=S,this.makeConnection=l}}class y extends C.$Rc{constructor(S,l,p){super(),this.socketId=S,this.actual=l,this.B(p)}}}),define(Pe[256],Re([1,0,3,15,23]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=void 0;function M($){return $&&$.title}let P=class{constructor(m,y){this.b=y,this.a=m.getProxy(E.$CK.MainThreadMessageService)}showMessage(m,y,R,S,l){const p={source:{identifier:m.identifier,label:m.displayName||m.name}};let b;typeof S=="string"||M(S)?b=[S,...l]:(p.modal=S?.modal,p.useCustom=S?.useCustom,p.detail=S?.detail,b=l),p.useCustom&&(0,C.$QF)(m,"resolvers");const a=[];for(let s=0;s<b.length;s++){const t=b[s];if(typeof t=="string")a.push({title:t,handle:s,isCloseAffordance:!1});else if(typeof t=="object"){const{title:n,isCloseAffordance:o}=t;a.push({title:n,isCloseAffordance:!!o,handle:s})}else this.b.warn("Invalid message item:",t)}return this.a.$showMessage(y,R,p,a).then(s=>{if(typeof s=="number")return b[s]})}};e.$Tfc=P,e.$Tfc=P=Ke([We(1,T.$hj)],P)}),define(Pe[257],Re([1,0,18,14,19,5,6,28,2,22,15,3,32,8,7,78,210,23,49]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=e.$Xfc=void 0;let o=class{constructor(g,D,I,h,w){this.m=D,this.n=I,this.o=h,this.q=w,this.b=new $.$zc,this.c=new $.$zc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new M.$Rd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=g.getProxy(S.$CK.MainThreadNotebookKernels);const k=new l.$5M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$3M("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const W=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:W}}else if(F&&"notebookEditor"in F){const W=this.n.getIdByEditor(F.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return F})],l.$4M.Void);this.o.registerApiCommand(k)}createNotebookController(g,D,I,h,w,k){for(const ie of this.j.values())if(ie.controller.id===D&&y.$dm.equals(g.identifier,ie.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const F=this.k++,W=this;this.q.trace(`NotebookController[${F}], CREATED by ${g.identifier.value}, ${D}`);const Q=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${g.identifier}'`);let N=!1;const A=new M.$Rd,L=new M.$Rd,O={id:f(g.identifier,D),notebookType:I,extensionId:g.identifier,extensionLocation:g.extensionLocation,label:h||g.identifier.value,preloads:k?k.map(p.NotebookRendererScript.from):[]};let x=w??Q,le,me;this.a.$addKernel(F,O).catch(ie=>{console.log(ie),N=!0});let ye=0;const we=()=>{if(N)return;const ie=++ye;Promise.resolve().then(()=>{ie===ye&&this.a.$updateKernel(F,O)})},de=new $.$zc,be={get id(){return D},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return O.label},set label(ie){O.label=ie??g.displayName??g.name,we()},get detail(){return O.detail??""},set detail(ie){O.detail=ie,we()},get description(){return O.description??""},set description(ie){O.description=ie,we()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(ie){O.supportedLanguages=ie,we()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){O.supportsExecutionOrder=ie,we()},get rendererScripts(){return O.preloads?O.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return x},set executeHandler(ie){x=ie??Q},get interruptHandler(){return le},set interruptHandler(ie){le=ie,O.supportsInterrupt=!!ie,we()},set variableProvider(ie){(0,t.$QF)(g,"notebookVariableProvider"),me=ie,O.hasVariableProvider=!!ie,ie?.onDidChangeVariables(Ie=>W.a.$variablesUpdated(Ie.uri)),we()},get variableProvider(){return me},createNotebookCellExecution(ie){if(N)throw new Error("notebook controller is DISPOSED");if(!de.has(ie.notebook.uri))throw W.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return W._createNotebookCellExecution(ie,f(g.identifier,this.id))},createNotebookExecution(ie){if((0,t.$QF)(g,"notebookExecution"),N)throw new Error("notebook controller is DISPOSED");if(!de.has(ie.uri))throw W.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.uri.toString()}`);return W._createNotebookExecution(ie,f(g.identifier,this.id))},dispose:()=>{N||(this.q.trace(`NotebookController[${F}], DISPOSED`),N=!0,this.j.delete(F),A.dispose(),L.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(ie,Ie){Ie===b.NotebookControllerAffinity2.Hidden&&(0,t.$QF)(g,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(F,ie.uri,Ie)},onDidReceiveMessage:L.event,postMessage(ie,Ie){return(0,t.$QF)(g,"notebookMessaging"),W.a.$postMessage(F,Ie&&W.n.getIdByEditor(Ie),ie)},asWebviewUri(ie){return(0,t.$QF)(g,"notebookMessaging"),(0,a.$Nub)(ie,W.m.remote)}};return this.j.set(F,{extensionId:g.identifier,controller:be,onDidReceiveMessage:L,onDidChangeSelection:A,associatedNotebooks:de}),be}getIdByController(g){for(const[D,I]of this.j)if(I.controller===g)return f(I.extensionId,g.id);return null}createNotebookControllerDetectionTask(g,D){const I=this.g++,h=this;this.q.trace(`NotebookControllerDetectionTask[${I}], CREATED by ${g.identifier.value}`),this.a.$addKernelDetectionTask(I,D);const w={dispose:()=>{this.f.delete(I),h.a.$removeKernelDetectionTask(I)}};return this.f.set(I,w),w}registerKernelSourceActionProvider(g,D,I){const h=this.i++,w=typeof I.onDidChangeNotebookKernelSourceActions=="function"?h:void 0,k=this;this.h.set(h,I),this.q.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${g.identifier.value}`),this.a.$addKernelSourceActionProvider(h,h,D);let F;return w!==void 0&&(F=I.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(h),k.a.$removeKernelSourceActionProvider(h,h),F?.dispose()}}}async $provideKernelSourceActions(g,D){const I=this.h.get(g);if(I){const h=new P.$Qc;return(await I.provideNotebookKernelSourceActions(D)??[]).map(k=>p.NotebookKernelSourceAction.from(k,this.o.converter,h))}return[]}$acceptNotebookAssociation(g,D,I){const h=this.j.get(g);if(h){const w=this.n.getNotebookDocument(m.URI.revive(D));I?h.associatedNotebooks.set(w.uri,!0):h.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${g}] ASSOCIATE notebook`,w.uri.toString(),I),h.onDidChangeSelection.fire({selected:I,notebook:w.apiNotebook})}}async $executeCells(g,D,I){const h=this.j.get(g);if(!h)return;const w=this.n.getNotebookDocument(m.URI.revive(D)),k=[];for(const F of I){const W=w.getCell(F);W&&k.push(W.apiCell)}try{this.q.trace(`NotebookController[${g}] EXECUTE cells`,w.uri.toString(),k.length),await h.controller.executeHandler.call(h.controller,k,w.apiNotebook,h.controller)}catch(F){this.q.error(`NotebookController[${g}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(g,D,I){const h=this.j.get(g);if(!h)return;const w=this.n.getNotebookDocument(m.URI.revive(D));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,w.apiNotebook);else for(const k of I){const F=w.getCell(k);F&&this.b.get(F.uri)?.cancel()}if(h.controller.interruptHandler){const k=this.c.get(w.uri);I.length&&Array.isArray(k)&&k.length&&k.forEach(F=>F.dispose())}}async $provideVariables(g,D,I,h,w,k,F){const W=this.j.get(g);if(!W)return;const Q=this.n.getNotebookDocument(m.URI.revive(I)),N=W.controller.variableProvider;if(!N)return;const A=h?{name:h,value:""}:void 0,L=w==="named"?b.NotebookVariablesRequestKind.Named:b.NotebookVariablesRequestKind.Indexed,O=N.provideVariables(Q.apiNotebook,A,L,k,F);for await(const x of O){if(F.isCancellationRequested)return;this.a.$receiveVariable(D,x)}}$acceptKernelMessageFromRenderer(g,D,I){const h=this.j.get(g);if(!h)return;const w=this.n.getEditorById(D);h.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:I}))}$cellExecutionChanged(g,D,I){const w=this.n.getNotebookDocument(m.URI.revive(g)).getCell(D);if(w){const k=I?p.NotebookCellExecutionState.to(I):b.NotebookCellExecutionState.Idle;k!==void 0&&this.l.fire({cell:w.apiCell,state:k})}}_createNotebookCellExecution(g,D){if(g.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.n.getNotebookDocument(g.notebook.uri).getCellFromApiCell(g);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const w=new d(D,h,this.a);this.b.set(h.uri,w);const k=w.onDidChangeState(()=>{w.state===c.Resolved&&(w.dispose(),k.dispose(),this.b.delete(h.uri))});return w.asApiObject()}_createNotebookExecution(g,D){const I=this.n.getNotebookDocument(g.uri),h=g.getCells().find(F=>{const W=I.getCellFromApiCell(F);return W&&this.b.has(W.uri)});if(h)throw new Error(`duplicate cell execution for ${h.document.uri}`);if(this.c.has(I.uri))throw new Error(`duplicate notebook execution for ${I.uri}`);const w=new r(D,I,this.a),k=w.onDidChangeState(()=>{w.state===i.Resolved&&(w.dispose(),k.dispose(),this.c.delete(I.uri))});return this.c.set(I.uri,[w,k]),w.asApiObject()}};e.$Xfc=o,e.$Xfc=o=Ke([We(4,R.$hj)],o);var c;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(c||(c={}));class d extends P.$Rc{static{this.a=0}get state(){return this.f}constructor(g,D,I){super(),this.m=D,this.n=I,this.b=d.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new C.$2d),this.h=new u(10,h=>this.s(h)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,g,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(g){await this.h.addItem(g)}async s(g){const D=Array.isArray(g)?g:[g];return this.n.$updateExecution(this.b,new n.$Av(D))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(g){let D=this.m;if(g&&(D=this.m.notebook.getCellFromApiCell(g)),!D)throw new Error("INVALID cell");return D.handle}y(g){return g.map(D=>{const I=b.$6L.ensureUniqueMimeTypes(D.items,!0);return I===D.items?p.NotebookCellOutput.from(D):p.NotebookCellOutput.from({items:I,id:D.id,metadata:D.metadata})})}async z(g,D,I){const h=this.w(D),w=this.y((0,E.$2b)(g));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:h,append:I,outputs:w})}async C(g,D,I){return g=b.$6L.ensureUniqueMimeTypes((0,E.$2b)(g),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:g.map(p.NotebookCellOutputItem.from),outputId:D.id,append:I})}asApiObject(){const g=this;return Object.freeze({get token(){return g.g.token},get cell(){return g.m.apiCell},get executionOrder(){return g.j},set executionOrder(I){g.j=I,g.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:g.j}])},start(I){if(g.f===c.Resolved||g.f===c.Started)throw new Error("Cannot call start again");g.f=c.Started,g.c.fire(),g.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:I})},end(I,h){if(g.f===c.Resolved)throw new Error("Cannot call resolve twice");g.f=c.Resolved,g.c.fire(),g.h.flush(),g.n.$completeExecution(g.b,new n.$Av({runEndTime:h,lastRunSuccess:I}))},clearOutput(I){return g.t(),g.z([],I,!1)},appendOutput(I,h){return g.t(),g.z(I,h,!0)},replaceOutput(I,h){return g.t(),g.z(I,h,!1)},appendOutputItems(I,h){return g.t(),g.C(I,h,!0)},replaceOutputItems(I,h){return g.t(),g.C(I,h,!1)}})}}var i;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(i||(i={}));class r extends P.$Rc{static{this.a=0}get state(){return this.f}constructor(g,D,I){super(),this.h=D,this.j=I,this.b=r.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new C.$2d),this.j.$createNotebookExecution(this.b,g,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===i.Resolved||this.f===i.Started)throw new Error("Cannot call start again");this.f=i.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===i.Resolved)throw new Error("Cannot call resolve twice");this.f=i.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(g,D){this.f=g,this.g=D,this.a=[],this.b=Date.now()}addItem(g){return this.a.push(g),this.c||(this.c=new T.$kh,this.b=Date.now(),(0,T.$1g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const g=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>g.complete())}}function f(v,g){return`${v.value}/${g}`}e.$Yfc=f}),define(Pe[258],Re([1,0,5,3,106]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=void 0;class M{constructor($,m){this.c=m,this.a=new Map,this.b=$.getProxy(T.$CK.MainThreadNotebookRenderers)}$postRendererMessage($,m,y){const R=this.c.getEditorById($);this.a.get(m)?.fire({editor:R.apiEditor,message:y})}createRendererMessaging($,m){if(!$.contributes?.notebookRenderer?.some(R=>R.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(R,S,l)=>this.d(m).event(R,S,l),postMessage:(R,S)=>{C.$Ffc.apiEditorsToExtHost.has(R)&&([R,S]=[S,R]);const l=S&&C.$Ffc.apiEditorsToExtHost.get(S);return this.b.$postMessage(l?.id,m,R)}}}d($){let m=this.a.get($);return m||(m=new E.$Rd({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete($)}}),this.a.set($,m),m)}}e.$Zfc=M}),define(Pe[259],Re([1,0,6,16,2,23,3]),function(pe,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;class ${constructor(y){this.b=new Map,this.a=y.getProxy(P.$CK.MainThreadProfileContentHandlers)}registrProfileContentHandler(y,R,S){if((0,M.$QF)(y,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,S),this.a.$registerProfileContentHandler(R,S.name,S.description,y.identifier.value),(0,E.$Pc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(y,R,S,l){const p=this.b.get(y);if(!p)throw new Error(`Unknown handler with id: ${y}`);return p.saveProfile(R,S,l)}async $readProfile(y,R,S){const l=this.b.get(y);if(!l)throw new Error(`Unknown handler with id: ${y}`);return l.readProfile((0,T.$Cf)(R)?R:C.URI.revive(R),S)}}e.$3fc=$}),define(Pe[260],Re([1,0,2,3,14,8]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class P{static{this.a=0}constructor(m,y){this.d=y,this.c=new Map,this.b=m.getProxy(T.$CK.MainThreadQuickDiff)}$provideOriginalResource(m,y,R){const S=E.URI.revive(y),l=this.c.get(m);return l?(0,C.$Sg)(()=>l.provideOriginalResource(S,R)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(m,y,R,S){const l=P.a++;return this.c.set(l,y),this.b.$registerQuickDiffProvider(l,M.DocumentSelector.from(m,this.d),R,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$5fc=P}),define(Pe[261],Re([1,0,19,5,6,3,2,7,11,18,31,45,23,8]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;function b(a,s,t){const n=a.getProxy(M.$CK.MainThreadQuickOpen);class o{constructor(D,I){this.e=new Map,this.f=0,this.a=D,this.b=I}showQuickPick(D,I,h,w=E.CancellationToken.None){this.c=void 0;const k=Promise.resolve(I),F=++this.f,W=n.$show(F,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},w),Q={},N=W.then(()=>Q);return Promise.race([N,k]).then(A=>{if(A===Q)return;const L=(0,l.$PF)(D,"quickPickItemTooltip");return k.then(O=>{const x=[];for(let le=0;le<O.length;le++){const me=O[le];if(typeof me=="string")x.push({label:me,handle:le});else if(me.kind===$.QuickPickItemKind.Separator)x.push({type:"separator",label:me.label});else{me.tooltip&&!L&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const ye=me.iconPath?u(me.iconPath):void 0;x.push({label:me.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:me.description,detail:me.detail,picked:me.picked,alwaysShow:me.alwaysShow,tooltip:L?p.MarkdownString.fromStrict(me.tooltip):void 0,handle:le})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=le=>{h.onDidSelectItem(O[le])}),n.$setItems(F,x),W.then(le=>{if(typeof le=="number")return O[le];if(Array.isArray(le))return le.map(me=>O[me])})})}).then(void 0,A=>{if(!(0,m.$3)(A))return n.$setError(F,A),Promise.reject(A)})}$onItemSelected(D){this.c?.(D)}showInput(D,I=E.CancellationToken.None){return this.d=D?.validateInput,n.$input(D,typeof this.d=="function",I).then(void 0,h=>{if(!(0,m.$3)(h))return Promise.reject(h)})}async $validateInput(D){if(!this.d)return;const I=await this.d(D);if(!I||typeof I=="string")return I;let h;switch(I.severity){case $.InputBoxValidationSeverity.Info:h=R.default.Info;break;case $.InputBoxValidationSeverity.Warning:h=R.default.Warning;break;case $.InputBoxValidationSeverity.Error:h=R.default.Error;break;default:h=I.message?R.default.Error:R.default.Ignore;break}return{content:I.message,severity:h}}async showWorkspaceFolderPick(D,I=E.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!h)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(k=>k.uri.toString()===h.uri.toString())}createQuickPick(D){const I=new f(D,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(D){const I=new v(D,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(D,I){this.e.get(D)?._fireDidChangeValue(I)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,I){const h=this.e.get(D);h instanceof f&&h._fireDidChangeActive(I)}$onDidChangeSelection(D,I){const h=this.e.get(D);h instanceof f&&h._fireDidChangeSelection(I)}$onDidTriggerButton(D,I){this.e.get(D)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(D,I,h){const w=this.e.get(D);w instanceof f&&w._fireDidTriggerItemButton(I,h)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class c{static{this.a=1}constructor(D,I){this.x=D,this.y=I,this._id=f.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Rd,this.q=new T.$Rd,this.r=new T.$Rd,this.s=new T.$Rd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((I,h)=>{const w=I===$.$YL.Back?-1:h;this.o.set(w,I)}),this.z({buttons:D.map((I,h)=>({...u(I.iconPath),tooltip:I.tooltip,handle:I===$.$YL.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const I=this.o.get(D);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(D){if(!this.v){for(const I of Object.keys(D)){const h=D[I];this.u[I]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function d(g){if(g instanceof $.$yL)return{id:g.id};const D=r(g),I=i(g);return{dark:typeof D=="string"?P.URI.file(D):D,light:typeof I=="string"?P.URI.file(I):I}}function i(g){return typeof g=="object"&&"light"in g?g.light:g}function r(g){return typeof g=="object"&&"dark"in g?g.dark:g}function u(g){const D=d(g);let I,h;return"id"in D?h=S.ThemeIcon.asClassName(D):I=D,{iconPath:I,iconClass:h}}class f extends c{constructor(D,I){super(D.identifier,I),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Rd,this.L=[],this.M=new T.$Rd,this.N=new T.$Rd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((w,k)=>{this.C.set(k,w),this.D.set(w,k)});const I=(0,l.$PF)(this.O,"quickPickItemTooltip"),h=[];for(let w=0;w<D.length;w++){const k=D[w];if(k.kind===$.QuickPickItemKind.Separator)h.push({type:"separator",label:k.label});else{k.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const F=k.iconPath?u(k.iconPath):void 0;h.push({handle:w,label:k.label,iconPath:F?.iconPath,iconClass:F?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:I?p.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((W,Q)=>({...u(W.iconPath),tooltip:W.tooltip,handle:Q}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(D){const I=(0,y.$Gb)(D.map(h=>this.C.get(h)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(D){const I=(0,y.$Gb)(D.map(h=>this.C.get(h)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(D,I){const h=this.C.get(D);if(!h||!h.buttons||!h.buttons.length)return;const w=h.buttons[I];w&&this.N.fire({button:w,item:h})}}class v extends c{constructor(D,I){super(D.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:R.default.Error}):this.z({validationMessage:D.message,severity:D.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new o(s,t)}e.$6fc=b}),define(Pe[262],Re([1,0,2,5,66,6,14,3,18,137,15,19,22,45,8,23,13,21]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s,t){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=e.$7fc=void 0;function o(N){return N instanceof E.URI}function c(N,A){return N.scheme===s.Schemas.file&&A.scheme===s.Schemas.file&&t.$k?N.toString()===A.toString():N.toString().toLowerCase()===A.toString().toLowerCase()}function d(N){if(N)return typeof N.iconPath=="string"?E.URI.file(N.iconPath):E.URI.isUri(N.iconPath)||p.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function i(N){if(N?.icon){if(E.URI.isUri(N.icon))return N.icon;if(p.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const A=N.icon;return{light:A.light,dark:A.dark}}}else return}function r(N){if(N.icon){if(E.URI.isUri(N.icon))return N.icon;if(p.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const A=N.icon;return{light:A.light,dark:A.dark}}}else return}function u(N){if(N.icon){if(E.URI.isUri(N.icon))return N.icon;if(p.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const A=N.icon;return{light:A.light,dark:A.dark}}}else return}function f(N,A){if(!N.iconPath&&!A.iconPath)return 0;if(N.iconPath){if(!A.iconPath)return 1}else return-1;const L=typeof N.iconPath=="string"?N.iconPath:E.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,O=typeof A.iconPath=="string"?A.iconPath:E.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id;return(0,y.$Bq)(L,O)}function v(N,A){let L=0;if(N.strikeThrough!==A.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==A.faded)return N.faded?1:-1;if(N.tooltip!==A.tooltip)return(N.tooltip||"").localeCompare(A.tooltip||"");if(L=f(N,A),L!==0)return L;if(N.light&&A.light)L=f(N.light,A.light);else{if(N.light)return 1;if(A.light)return-1}if(L!==0)return L;if(N.dark&&A.dark)L=f(N.dark,A.dark);else{if(N.dark)return 1;if(A.dark)return-1}return L}function g(N,A){if(N.command!==A.command)return N.command<A.command?-1:1;if(N.title!==A.title)return N.title<A.title?-1:1;if(N.tooltip!==A.tooltip){if(N.tooltip!==void 0&&A.tooltip!==void 0)return N.tooltip<A.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(A.tooltip!==void 0)return-1}if(N.arguments===A.arguments)return 0;if(N.arguments)if(A.arguments){if(N.arguments.length!==A.arguments.length)return N.arguments.length-A.arguments.length}else return 1;else return-1;for(let L=0;L<N.arguments.length;L++){const O=N.arguments[L],x=A.arguments[L];if(O!==x&&!(o(O)&&o(x)&&c(O,x)))return O<x?-1:1}return 0}function D(N,A){let L=(0,y.$Bq)(N.resourceUri.fsPath,A.resourceUri.fsPath,!0);if(L!==0)return L;if(N.command&&A.command)L=g(N.command,A.command);else{if(N.command)return 1;if(A.command)return-1}if(L!==0)return L;if(N.decorations&&A.decorations)L=v(N.decorations,A.decorations);else{if(N.decorations)return 1;if(A.decorations)return-1}return L}function I(N,A){for(let L=0;L<N.length;L++)if(N[L]!==A[L])return!1;return!0}function h(N,A){return N.command===A.command&&N.title===A.title&&N.tooltip===A.tooltip&&(N.arguments&&A.arguments?I(N.arguments,A.arguments):N.arguments===A.arguments)}function w(N,A){return(0,m.$tb)(N,A,h)}class k{#e;#t;get value(){return this.d}set value(A){A=A??"",this.#e.$setInputBoxValue(this.o,A),this.q(A)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(A){this.#e.$setInputBoxPlaceholder(this.o,A),this.f=A}get validateInput(){return(0,a.$QF)(this.m,"scmValidation"),this.g}set validateInput(A){if((0,a.$QF)(this.m,"scmValidation"),A&&typeof A!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=A,this.#e.$setValidationProviderIsEnabled(this.o,!!A)}get enabled(){return this.h}set enabled(A){A=!!A,this.h!==A&&(this.h=A,this.#e.$setInputBoxEnablement(this.o,A))}get visible(){return this.j}set visible(A){A=!!A,this.j!==A&&(this.j=A,this.#e.$setInputBoxVisibility(this.o,A))}get actionButton(){return(0,a.$QF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(A){(0,a.$QF)(this.m,"scmInputBoxActionButton"),this.l.value=new M.$Qc,this.k=A;const L=A!==void 0?{command:this.n.converter.toInternal(A.command,this.l.value),icon:i(A),enabled:A.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,L??null)}get document(){return(0,a.$QF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(A,L,O,x,le,me){this.m=A,this.n=L,this.o=le,this.p=me,this.d="",this.e=new T.$Rd,this.f="",this.h=!0,this.j=!0,this.l=new M.$Sc,this.#t=O,this.#e=x}showValidationMessage(A,L){(0,a.$QF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,A,L)}$onInputBoxValueChange(A){this.q(A)}q(A){this.d=A,this.e.fire(A)}}e.$7fc=k;class F{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(A){this.v=A,this.q.$updateGroupLabel(this.t,this.handle,A)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(A){this.p=A,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(A){this.f=[...A],this.k.fire()}constructor(A,L,O,x,le){this.q=A,this.s=L,this.t=O,this.u=x,this.v=le,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Rd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Rd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=F.d++}getResourceState(A){return this.g.get(A)}$executeResourceCommand(A,L){const O=this.h.get(A);return O?(0,P.$Sg)(()=>this.s.executeCommand(O.command,...O.arguments||[],L)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const A=[...this.f].sort(D),O=(0,m.$Cb)(this.o,A,D).map(me=>{const ye=me.toInsert.map(we=>{const de=this.e++;this.g.set(de,we);const be=we.resourceUri;let ie;if(we.command)if(we.command.command==="vscode.open"||we.command.command==="vscode.diff"||we.command.command==="vscode.changes"){const ne=new M.$Qc;ie=this.s.converter.toInternal(we.command,ne),this.j.set(de,ne)}else this.h.set(de,we.command);const Ie=d(we.decorations),ce=we.decorations&&d(we.decorations.light)||Ie,Y=we.decorations&&d(we.decorations.dark)||Ie,B=[ce,Y],se=we.decorations&&we.decorations.tooltip||"",Se=we.decorations&&!!we.decorations.strikeThrough,Ae=we.decorations&&!!we.decorations.faded,Ce=we.contextValue||"";return{rawResource:[de,be,B,se,Se,Ae,Ce,ie],handle:de}});return{start:me.start,deleteCount:me.deleteCount,toInsert:ye}}),x=O.map(({start:me,deleteCount:ye,toInsert:we})=>[me,ye,we.map(de=>de.rawResource)]),le=O.reverse();for(const{start:me,deleteCount:ye,toInsert:we}of le){const de=we.map(ie=>ie.handle),be=this.n.splice(me,ye,...de);for(const ie of be)this.g.delete(ie),this.h.delete(ie),this.j.get(ie)?.dispose(),this.j.delete(ie)}return this.o=A,x}dispose(){this.l=!0,this.m.fire()}}class W{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(A){this.g!==A&&(this.g=A,this.#e.$updateSourceControl(this.x,{count:A}))}get quickDiffProvider(){return this.h}set quickDiffProvider(A){this.h=A;let L;(0,a.$PF)(this.y,"quickDiffProvider")&&(L=A?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!A,quickDiffLabel:L})}get historyProvider(){return(0,a.$QF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(A){(0,a.$QF)(this.y,"scmHistoryProvider"),this.j=A,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!A}),A&&(this.k.value.add(A.onDidChangeCurrentHistoryItemGroup(()=>{this.l=A?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(A.onDidChangeActionButton(()=>{(0,a.$QF)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const L=A.actionButton!==void 0?{command:this.z.converter.toInternal(A.actionButton.command,this.m.value),description:A.actionButton.description,enabled:A.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,L??null)})))}get commitTemplate(){return this.n}set commitTemplate(A){A!==this.n&&(this.n=A,this.#e.$updateSourceControl(this.x,{commitTemplate:A}))}get acceptInputCommand(){return this.p}set acceptInputCommand(A){this.o.value=new M.$Qc,this.p=A;const L=this.z.converter.toInternal(A,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:L})}get actionButton(){return(0,a.$QF)(this.y,"scmActionButton"),this.s}set actionButton(A){(0,a.$QF)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=A;const L=A!==void 0?{command:this.z.converter.toInternal(A.command,this.q.value),secondaryCommands:A.secondaryCommands?.map(O=>O.map(x=>this.z.converter.toInternal(x,this.q.value))),description:A.description,enabled:A.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:L??null})}get statusBarCommands(){return this.u}set statusBarCommands(A){if(this.u&&A&&w(this.u,A))return;this.t.value=new M.$Qc,this.u=A;const L=(A||[]).map(O=>this.z.converter.toInternal(O,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:L})}get selected(){return this.v}constructor(A,L,O,x,le,me,ye){this.y=A,this.z=x,this.A=le,this.B=me,this.C=ye,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new T.$Rd,this.onDidChangeSelection=this.w.event,this.x=W.d++,this.D=new Map,this.E=new Set,this.#e=O;const we=E.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${le}/scm${this.x}/input`,query:ye?`rootUri=${encodeURIComponent(ye.toString())}`:void 0});this.f=new k(A,x,L,this.#e,this.x,we),this.#e.$registerSourceControl(this.x,le,me,ye,we)}createResourceGroup(A,L){const O=new F(this.#e,this.z,this.x,A,L),x=T.Event.once(O.onDidDispose)(()=>this.D.delete(O));return this.D.set(O,x),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const A=[],L=[];for(const[O,x]of this.D){x.dispose();const le=O.onDidUpdateResourceStates(()=>{this.E.add(O),this.eventuallyUpdateResourceStates()});T.Event.once(O.onDidDispose)(()=>{this.E.delete(O),le.dispose(),this.e.delete(O.handle),this.#e.$unregisterGroup(this.x,O.handle)}),A.push([O.handle,O.id,O.label,O.features]);const me=O._takeResourceStateSnapshot();me.length>0&&L.push([O.handle,me]),this.e.set(O.handle,O)}this.#e.$registerGroups(this.x,A,L),this.D.clear()}eventuallyUpdateResourceStates(){const A=[];this.E.forEach(L=>{const O=L._takeResourceStateSnapshot();O.length!==0&&A.push([L.handle,O])}),A.length>0&&this.#e.$spliceResourceStates(this.x,A),this.E.clear()}getResourceGroup(A){return this.e.get(A)}setSelectionState(A){this.v=A,this.w.fire(A)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(A=>A.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,C.$sh)(100)],W.prototype,"eventuallyAddResourceGroups",null),Ke([(0,C.$sh)(100)],W.prototype,"eventuallyUpdateResourceStates",null);let Q=class{static{n=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(A,L,O,x){this.n=L,this.o=O,this.p=x,this.h=new Map,this.j=new l.$fm,this.k=new T.$Rd,this.l=new Map,this.f=A.getProxy($.$CK.MainThreadSCM),this.g=A.getProxy($.$CK.MainThreadTelemetry),L.registerArgumentProcessor({processArgument:le=>{if(le&&le.$mid===3){const me=this.h.get(le.sourceControlHandle);if(!me)return le;const ye=me.getResourceGroup(le.groupHandle);return ye?ye.getResourceState(le.handle):le}else if(le&&le.$mid===4){const me=this.h.get(le.sourceControlHandle);return me?me.getResourceGroup(le.groupHandle):le}else if(le&&le.$mid===5){const me=this.h.get(le.handle);return me||le}return le}})}createSourceControl(A,L,O,x){this.p.trace("ExtHostSCM#createSourceControl",A.identifier.value,L,O,x),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:A.identifier.value});const le=n.d++,me=new W(A,this.o,this.f,this.n,L,O,x);this.h.set(le,me);const ye=this.j.get(A.identifier)||[];return ye.push(me),this.j.set(A.identifier,ye),me}registerSourceControlInputBoxValueProvider(A,L){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",A.identifier.value,L.label);const O=n.e++;return this.l.set(O,L),this.f.$registerSourceControlInputBoxValueProvider(O,L.label,u(L)),(0,M.$Pc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(O),this.l.delete(O)})}async $provideInputBoxValue(A,L,O){const x=this.l.get(A);if(x)return await x.provideValue(L,O,S.CancellationToken.None)??void 0}getLastInputBox(A){this.p.trace("ExtHostSCM#getLastInputBox",A.identifier.value);const L=this.j.get(A.identifier),O=L&&L[L.length-1];return O&&O.inputBox}$provideOriginalResource(A,L,O){const x=E.URI.revive(L);this.p.trace("ExtHostSCM#$provideOriginalResource",A,x.toString());const le=this.h.get(A);return!le||!le.quickDiffProvider||!le.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.$Sg)(()=>le.quickDiffProvider.provideOriginalResource(x,O)).then(me=>me||null)}$onInputBoxValueChange(A,L){this.p.trace("ExtHostSCM#$onInputBoxValueChange",A);const O=this.h.get(A);return O&&O.inputBox.$onInputBoxValueChange(L),Promise.resolve(void 0)}$executeResourceCommand(A,L,O,x){this.p.trace("ExtHostSCM#$executeResourceCommand",A,L,O);const le=this.h.get(A);if(!le)return Promise.resolve(void 0);const me=le.getResourceGroup(L);return me?me.$executeResourceCommand(O,x):Promise.resolve(void 0)}$validateInput(A,L,O){this.p.trace("ExtHostSCM#$validateInput",A);const x=this.h.get(A);return!x||!x.inputBox.validateInput?Promise.resolve(void 0):(0,P.$Sg)(()=>x.inputBox.validateInput(L,O)).then(le=>{if(!le)return Promise.resolve(void 0);const me=b.MarkdownString.fromStrict(le.message);return me?Promise.resolve([me,le.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(A){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",A),A!==void 0&&this.h.get(A)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=A,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(A,L,O){return await this.h.get(A)?.historyProvider?.resolveHistoryItemGroupBase(L,O)??void 0}async $resolveHistoryItemGroupCommonAncestor(A,L,O,x){return await this.h.get(A)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(L,O,x)??void 0}async $provideHistoryItems(A,L,O,x){return(await this.h.get(A)?.historyProvider?.provideHistoryItems(L,O,x))?.map(ye=>({...ye,icon:r(ye)}))??void 0}async $provideHistoryItemChanges(A,L,O){return await this.h.get(A)?.historyProvider?.provideHistoryItemChanges(L,O)??void 0}};e.$8fc=Q,e.$8fc=Q=n=Ke([We(3,R.$hj)],Q)}),define(Pe[84],Re([1,0,3,5,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=e.$bfc=void 0;class M{constructor($){this.b=new T.$Rd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(E.$CK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,m){return this.a.$getPassword($,m)}store($,m,y){return this.a.$setPassword($,m,y)}delete($,m){return this.a.$deletePassword($,m)}}e.$bfc=M,e.$cfc=(0,C.$Zh)("IExtHostSecretState")}),define(Pe[263],Re([1,0,3,8,2]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;class M{static{this.a=0}constructor($,m){this.d=m,this.c=new Map,this.b=$.getProxy(E.$CK.MainThreadShare)}async $provideShare($,m,y){return await this.c.get($)?.provideShare({selection:T.Range.to(m.selection),resourceUri:C.URI.revive(m.resourceUri)},y)??void 0}registerShareProvider($,m){const y=M.a++;return this.c.set(y,m),this.b.$registerShareProvider(y,T.DocumentSelector.from($,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$9fc=M}),define(Pe[264],Re([1,0,19,6,3]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(C.$CK.MainThreadSpeech)}async $createSpeechToTextSession($,m){const y=this.c.get($);if(!y)return;const R=new T.$Qc,S=new E.$2d;this.d.set(m,S);const l=R.add(y.provideSpeechToTextSession(S.token));R.add(l.onDidChange(p=>{S.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,p)})),R.add(S.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,m,y){const R=M.a++;return this.c.set(R,y),this.b.$registerProvider(R,m,{extension:$,displayName:$.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$0fc=M}),define(Pe[265],Re([1,0,7,3,163,6,8,16]),function(pe,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=e.$$fc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$zL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$zL("statusBarItem.warningForeground")]])}#e;#t;constructor(l,p,b,a,s,t=E.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=l,this.#t=p,s&&a){this.c=(0,E.$cL)(a.identifier,s);const o=b.get(this.c);o&&(t=o.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,n=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(m.a++);this.e=a,this.f=s,this.g=t,this.h=this.u(n)}u(l){if((0,$.$Gf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!m.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=m.b.get(this.o.id));const a=P.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,p,this.k,a,this.r?.internal,b,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$$fc=m;class y{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const p={message:l};return this.b.unshift(p),this.c(),new E.$EK(()=>{const b=this.b.indexOf(p);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(l,p){this.e=new Map,this.a=l.getProxy(T.$CK.MainThreadStatusBar),this.b=p,this.c=new y(this)}$acceptStaticEntries(l){for(const p of l)this.e.set(p.entryId,p)}createStatusBarEntry(l,p,b,a){return new m(this.a,this.b,this.e,l,p,b,a)}setStatusBarMessage(l,p){const b=this.c.setMessage(l);let a;return typeof p=="number"?a=setTimeout(()=>b.dispose(),p):typeof p<"u"&&p.then(()=>b.dispose(),()=>b.dispose()),new E.$EK(()=>{b.dispose(),clearTimeout(a)})}}e.$_fc=R}),define(Pe[85],Re([1,0,3,5,4]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=e.$6ec=void 0;class M{constructor($,m){this.c=m,this.b=new T.$Rd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(E.$CK.MainThreadStorage)}registerExtensionStorageKeysToSync($,m){this.a.$registerExtensionStorageKeysToSync($,m)}async initializeExtensionStorage($,m,y){const R=await this.a.$initializeExtensionStorage($,m);let S;return R&&(S=this.d($,m,R)),S||y}setValue($,m,y){return this.a.$setValue($,m,y)}$acceptValue($,m,y){const R=this.d($,m,y);R&&this.b.fire({shared:$,key:m,value:R})}d($,m,y){try{return JSON.parse(y)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${$}): ${R}`)}}}e.$6ec=M,e.$7ec=(0,C.$Zh)("IExtHostStorage")}),define(Pe[86],Re([1,0,4,27,15,63,2]),function(pe,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=e.$Oec=void 0,e.$Oec=(0,E.$Zh)("IExtensionStoragePaths");let $=class{constructor(y,R,S){this.d=R,this.f=S,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(y){return P.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,R=await this.g(y);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(P.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:P.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(y){if(this.c)return P.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return P.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Pec=$,e.$Pec=$=Ke([We(0,T.$UM),We(1,C.$hj),We(2,M.$Nec)],$)}),define(Pe[64],Re([1,0,5,3,4,2,17,6,7,165,11,193,19,33,194,45,14,8,32]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=e.$_ec=e.$$ec=e.$0ec=void 0,e.$0ec=(0,C.$Zh)("IExtHostTerminalService");class o{constructor(h,w,k,F){this.l=h,this._id=w,this.m=k,this.n=F,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(Q=>this.f=Q);const W=this;this.value={get name(){return W.n||""},get processId(){return W.b},get creationOptions(){return W.m},get exitStatus(){return W.h},get state(){return W.j},get selection(){return W.k},sendText(Q,N=!0){W.q(),W.l.$sendText(W._id,Q,N)},show(Q){W.q(),W.l.$show(W._id,Q)},hide(){W.q(),W.l.$hide(W._id)},dispose(){W.a||(W.a=!0,W.l.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(h,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??w?.cwd??void 0,env:h.env??void 0,icon:v(h.iconPath)??void 0,color:a.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(h.location,w?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,w,k,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:k,color:a.ThemeColor.isThemeColor(F)?F.id:void 0,location:this.o(h,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(h,w){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in h?{viewColumn:t.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.n=h}setExitStatus(h,w){this.h=Object.freeze({code:h,reason:w})}setDimensions(h,w){return h===this.d&&w===this.g||h===0||w===0?!1:(this.d=h,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(h){this.k=h}_setProcessId(h){this.f?(this.f(h),this.f=void 0):this.b.then(w=>{w!==h&&(this.b=Promise.resolve(h))})}}e.$$ec=o;class c{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new E.$Rd,this.onProcessData=this.a.event,this.b=new E.$Rd,this.d=new E.$Rd,this.onDidChangeProperty=this.d.event,this.f=new E.$Rd,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,w){this.g.setDimensions?.({columns:h,rows:w})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let d=1,i=class extends $.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,w,k){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Rd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Rd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Rd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Rd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Rd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Rd,this.onDidChangeShell=this.N.event,this.O=new E.$Rd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Rd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(T.$CK.MainThreadTerminalService),this.y=new b.$2qb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:F=>{const W=Q=>{const N=Q;return this.W(N.instanceId)?.value};switch(F?.$mid){case 15:return W(F);default:{if(Array.isArray(F))for(let Q=0;Q<F.length&&F[Q].$mid===15;Q++)F[Q]=W(F[Q]);return F}}}}),this.B({dispose:()=>{for(const[F,W]of this.g)W.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,w){const k=new o(this.a,(0,p.$kg)(),h,h.name),F=new c(h.pty);return k.createExtensionTerminal(h.location,this.R(h,w).resolvedExtHostIdentifier,v(h.iconPath),g(h.color)).then(W=>{const Q=this.S(W,F);this.h[W]=Q}),this.f.push(k),k.value}R(h,w){if(w=w||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const k=h.location.parentTerminal;if(k){const F=this.f.find(W=>W.value===k);F&&(w.resolvedExtHostIdentifier=F._id)}}else h.location&&typeof h.location!="object"?w.location=h.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(h,w){if(!this.W(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const F=new c(w),W=this.S(h,F);this.h[h]=W}async $acceptActiveTerminalChanged(h){const w=this.b;if(h===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const k=this.W(h);k&&(this.b=k,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,w){const k=this.W(h);k&&this.O.fire({terminal:k.value,data:w})}async $acceptTerminalDimensions(h,w,k){const F=this.W(h);F&&F.setDimensions(w,k)&&this.L.fire({terminal:F.value,dimensions:F.value.dimensions})}async $acceptDidExecuteCommand(h,w){const k=this.W(h);k&&this.P.fire({terminal:k.value,...w})}async $acceptTerminalMaximumDimensions(h,w,k){this.g.get(h)?.resize(w,k)}async $acceptTerminalTitleChange(h,w){const k=this.W(h);k&&(k.name=w)}async $acceptTerminalClosed(h,w,k){const F=this.Y(this.f,h);if(F!==null){const W=this.f.splice(F,1)[0];W.setExitStatus(w,k),this.H.fire(W.value)}}$acceptTerminalOpened(h,w,k,F){if(w){const N=this.Y(this.f,w);if(N!==null){this.f[N]._id=h,this.I.fire(this.terminals[N]),this.f[N].isOpen=!0;return}}const W={name:F.name,shellPath:F.executable,shellArgs:F.args,cwd:typeof F.cwd=="string"?F.cwd:M.URI.revive(F.cwd),env:F.env,hideFromUser:F.hideFromUser},Q=new o(this.a,h,W,k);this.f.push(Q),this.I.fire(Q.value),Q.isOpen=!0}async $acceptTerminalProcessId(h,w){this.W(h)?._setProcessId(w)}async $startExtensionTerminal(h,w){const k=this.W(h);if(!k)return{message:(0,y.localize)(0,null,h)};k.isOpen||await new Promise(W=>{const Q=this.onDidOpenTerminal(async N=>{N===k.value&&(Q.dispose(),W())})});const F=this.g.get(h);F?F.startSendingEvents(w):this.j[h]={initialDimensions:w}}S(h,w){const k=new $.$Qc;k.add(w.onProcessReady(W=>this.a.$sendProcessReady(h,W.pid,W.cwd,W.windowsPty))),k.add(w.onDidChangeProperty(W=>this.a.$sendProcessProperty(h,W))),this.y.startBuffering(h,w.onProcessData),k.add(w.onProcessExit(W=>this.U(h,W))),this.g.set(h,w);const F=this.j[h];return F&&w instanceof c&&(w.startSendingEvents(F.initialDimensions),delete this.j[h]),k}$acceptProcessAckDataEvent(h,w){this.g.get(h)?.acknowledgeDataEvent(w)}$acceptProcessInput(h,w){this.g.get(h)?.input(w)}$acceptTerminalInteraction(h){const w=this.W(h);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(h,w){this.W(h)?.setSelection(w)}$acceptProcessResize(h,w,k){try{this.g.get(h)?.resize(w,k)}catch(F){if(F.code!=="EPIPE"&&F.code!=="ERR_IPC_CHANNEL_CLOSED")throw F}}$acceptProcessShutdown(h,w){this.g.get(h)?.shutdown(w)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(w=>this.a.$sendProcessProperty(h,{type:"cwd",value:w}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new m.$EK(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,w,k){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,k),this.a.$registerProfileProvider(w,h.identifier.value),new m.$EK(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(h,w,k){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,k),this.a.$registerQuickFixProvider(h,w),new m.$EK(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,w){const k=new l.$2d().token;if(k.isCancellationRequested)return;const F=this.D.get(h);if(!F)return;const W=await F.provideTerminalQuickFixes(w,k);if(W===null||Array.isArray(W)&&W.length===0)return;const Q=new $.$Qc;if(this.w.value=Q,!Array.isArray(W))return W?t.TerminalQuickFix.from(W,this.Q.converter,Q):void 0;const N=[];for(const A of W){const L=t.TerminalQuickFix.from(A,this.Q.converter,Q);L&&N.push(L)}return N}async $createContributedProfileTerminal(h,w){const k=new l.$2d().token;let F=await this.C.get(h)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(F&&!("options"in F)&&(F={options:F}),!F||!("options"in F))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in F.options){this.createExtensionTerminal(F.options,w);return}this.createTerminalFromOptions(F.options,w)}}async $provideLinks(h,w){const k=this.W(h);if(!k)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const W=new l.$2d;this.G.set(h,W);const Q=[],N={terminal:k.value,line:w},A=[];for(const x of this.z)A.push(s.Promises.withAsyncBody(async le=>{W.token.onCancellationRequested(()=>le({provider:x,links:[]}));const me=await x.provideTerminalLinks(N,W.token)||[];W.token.isCancellationRequested||le({provider:x,links:me})}));const L=await Promise.all(A);if(W.token.isCancellationRequested)return[];const O=new Map;for(const x of L)x&&x.links.length>0&&Q.push(...x.links.map(le=>{const me={id:d++,startIndex:le.startIndex,length:le.length,label:le.tooltip};return O.set(me.id,{provider:x.provider,link:le}),me}));return this.F.set(h,O),Q}$activateLink(h,w){const k=this.F.get(h)?.get(w);k&&k.provider.handleTerminalLink(k.link)}U(h,w){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const k=this.h[h];k&&(k.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,w)}W(h){return this.X(this.f,h)}X(h,w){const k=this.Y(h,w);return k!==null?h[k]:null}Y(h,w){const k=h.findIndex(F=>F._id===w);return k===-1?null:k}getEnvironmentVariableCollection(h){let w=this.n.get(h.identifier.value);return w||(w=new r,this.$(h.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(h,w){const k=(0,S.$ur)(w.map),F=(0,S.$vr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(h,w.persistent,k.length===0?void 0:k,F)}$initEnvironmentVariableCollections(h){h.forEach(w=>{const k=w[0],F=new r(w[1]);this.$(k,F)})}$acceptDefaultProfile(h,w){const k=this.s;this.s=h,this.u=w,k?.path!==h.path&&this.N.fire(h.path)}$(h,w){this.n.set(h,w),w.onDidChangeCollection(()=>{this.Z(h,w)})}};e.$_ec=i,e.$_ec=i=Ke([We(1,n.$1M),We(2,P.$EM)],i);class r{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Rd,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const w=this.h(h);let k=this.a.get(w);return k||(k=new u(this,h),this.a.set(w,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(h,w,k,F){this.f(h,{value:w,type:m.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:F})}append(h,w,k,F){this.f(h,{value:w,type:m.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:F})}prepend(h,w,k,F){this.f(h,{value:w,type:m.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:F})}f(h,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(h,w.scope),F=this.map.get(k),W=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!F||F.value!==w.value||F.type!==w.type||F.options?.applyAtProcessCreation!==W.applyAtProcessCreation||F.options?.applyAtShellIntegration!==W.applyAtShellIntegration||F.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const Q=this.g(h,w.scope),N={variable:h,...w,options:W};this.map.set(Q,N),this.d.fire()}}get(h,w){const k=this.g(h,w),F=this.map.get(k);return F?D(F):void 0}g(h,w){const k=this.h(w);return k.length?`${h}:::${k}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const w=new Map;for(const[k,F]of this.map)this.h(F.scope)===this.h(h)&&w.set(F.variable,D(F));return w}delete(h,w){const k=this.g(h,w);this.map.delete(k),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[w,k]of this.map)k.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(w);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,w){const k=this.h(w),F=this.descriptionMap.get(k);if(!F||F.description!==h){let W;typeof h=="string"?W=h:W=h?.value.split(`

`)[0];const Q={description:W,scope:w};this.descriptionMap.set(k,Q),this.d.fire()}}getDescription(h){const w=this.h(h);return this.descriptionMap.get(w)?.description}k(h){const w=this.h(h);this.descriptionMap.delete(w)}}class u{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,w){this.b=h,this.d=w,this.a=new E.$Rd}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,w,k){this.b.replace(h,w,k,this.d)}append(h,w,k){this.b.append(h,w,k,this.d)}prepend(h,w,k){this.b.prepend(h,w,k,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,w){this.b.getVariableMap(this.d).forEach((k,F)=>h.call(w,F,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let f=class extends i{constructor(h,w){super(!1,h,w)}createTerminal(h,w,k){throw new R.$$}createTerminalFromOptions(h,w){throw new R.$$}};e.$afc=f,e.$afc=f=Ke([We(0,n.$1M),We(1,P.$EM)],f);function v(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function g(I){return a.ThemeColor.isThemeColor(I)?I:void 0}function D(I){const h={...I};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Pe[266],Re([1,0,297,14,24,19,5,218,97,6,26,16,33,3,17,107,8,7,48,77,58,23]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s,t,n,o,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=e.$fgc=e.$egc=e.$dgc=void 0;let i=class extends y.$Rc{constructor(N,A,L){super(),this.u=L,this.f=this.B(new P.$Rd),this.g=new Map,this.s=this.B(new P.$Rd),this.onResultsChanged=this.f.event,this.results=[],this.h=N.getProxy(p.$CK.MainThreadTesting),this.m=new k(this.h),this.j=new v(this.h),A.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const x=O,le=x.tests[x.tests.length-1].item.extId;return this.g.get(n.$vJ.root(le))?.collection.tree.get(le)?.actual??(0,a.$QM)(O)}case 18:{const{extId:x,message:le}=O;return{test:this.g.get(n.$vJ.root(x))?.collection.tree.get(x)?.actual,message:s.TestMessage.to(le)}}default:return O}}}),A.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await A.executeCommand("_testing.getExplorerSelection"),x=le=>{const me=this.g.get(n.$vJ.root(le));if(me)return n.$vJ.isRoot(le)?me.controller:me.collection.tree.get(le)?.actual};return{include:O?.include.map(x).filter(S.$Kf)||[],exclude:O?.exclude.map(x).filter(S.$Kf)||[]}})}createTestController(N,A,L,O){if(this.g.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const x=new y.$Qc,le=x.add(new a.$TM(A,L,this.u));le.root.label=L;const me=new Map,ye=new Set,we=this.h,de={items:le.root.children,get label(){return L},set label(ie){L=ie,le.root.label=ie,we.$updateController(A,{label:L})},get refreshHandler(){return O},set refreshHandler(ie){O=ie,we.$updateController(A,{canRefresh:!!ie})},get id(){return A},createRunProfile:(ie,Ie,ce,Y,B,se)=>{let Se=(0,m.$Ni)(ie);for(;me.has(Se);)Se++;return new F(this.h,me,N,ye,this.s.event,A,Se,ie,Ie,ce,Y,B,se)},createTestItem(ie,Ie,ce){return new a.$RM(A,ie,Ie,ce)},createTestRun:(ie,Ie,ce=!0)=>this.j.createTestRun(N,A,le,ie,Ie,ce),invalidateTestResults:ie=>{if(ie===void 0)this.h.$markTestRetired(void 0);else{const Ie=ie instanceof Array?ie:[ie];this.h.$markTestRetired(Ie.map(ce=>n.$vJ.fromExtHostTestItem(ce,A).toString()))}},set resolveHandler(ie){le.resolveHandler=ie},get resolveHandler(){return le.resolveHandler},dispose:()=>{x.dispose()}};we.$registerTestController(A,L,!!O),x.add((0,y.$Pc)(()=>we.$unregisterTestController(A)));const be={controller:de,collection:le,profiles:me,extension:N,activeProfiles:ye};return this.g.set(A,be),x.add((0,y.$Pc)(()=>this.g.delete(A))),x.add(le.onDidGenerateDiff(ie=>we.$publishDiff(A,ie.map(c.TestsDiffOp.serialize)))),de}createTestObserver(){return this.m.checkout()}async runTests(N,A=M.CancellationToken.None){const L=g(N);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.g.get(L.controllerId);if(!O)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(x=>n.$vJ.fromExtHostTestItem(x,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:W[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:N.exclude?.map(x=>x.id)},A)}$syncTests(){for(const{collection:N}of this.g.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,A,L){return(0,E.$qb)(this.j.trackers,x=>x.id===N?x.getCoverage(A):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(N,A,L,O){return(0,E.$qb)(this.j.trackers,le=>le.id===N?le.getCoverage(A):void 0)?.resolveFileCoverage(L,O)??Promise.resolve([])}$configureRunProfile(N,A){this.g.get(N)?.profiles.get(A)?.configureHandler?.()}$setActiveRunProfiles(N){const A=new Map;for(const[L,O]of Object.entries(N)){const x=this.g.get(L);if(!x)continue;const le=new Map,me=O.filter(we=>!x.activeProfiles.has(we)),ye=[...x.activeProfiles].filter(we=>!O.includes(we));for(const we of me)le.set(we,!0),x.activeProfiles.add(we);for(const we of ye)le.set(we,!1),x.activeProfiles.delete(we);le.size&&A.set(L,le)}this.s.fire(A)}async $refreshTests(N,A){await this.g.get(N)?.controller.refreshHandler?.(A)}$publishTestResults(N){this.results=Object.freeze(N.map(A=>(0,R.$fn)(s.TestResults.to(A))).concat(this.results).sort((A,L)=>L.completedAt-A.completedAt).slice(0,32)),this.f.fire()}async $expandTest(N,A){const L=this.g.get(n.$vJ.fromString(N).controllerId)?.collection;L&&(await L.expand(N,A<0?1/0:A),L.flushDiff())}$acceptDiff(N){this.m.applyDiff(N.map(c.TestsDiffOp.deserialize))}async $runControllerTests(N,A){return Promise.all(N.map(L=>this.w(L,!1,A)))}async $startContinuousRun(N,A){const L=new M.$2d(A),O=await Promise.all(N.map(x=>this.w(x,!0,L.token)));return!A.isCancellationRequested&&!O.some(x=>x.error)&&await new Promise(x=>A.onCancellationRequested(x)),L.dispose(!0),O}async w(N,A,L){const O=this.g.get(N.controllerId);if(!O)return{};const{collection:x,profiles:le,extension:me}=O,ye=le.get(N.profileId);if(!ye)return{};const we=N.testIds.map(Ie=>x.tree.get(Ie)).filter(S.$Kf),de=N.excludeExtIds.map(Ie=>O.collection.tree.get(Ie)).filter(S.$Kf).filter(Ie=>we.some(ce=>ce.fullId.compare(Ie.fullId)===2));if(!we.length)return{};const be=new t.$aM(we.some(Ie=>Ie.actual instanceof a.$SM)?void 0:we.map(Ie=>Ie.actual),de.map(Ie=>Ie.actual),ye,A),ie=(0,c.$xJ)(N)&&this.j.prepareForMainThreadTestRun(be,D.fromInternal(N,O.collection),me,L);try{return await ye.runHandler(be,L),{}}catch(Ie){return{error:String(Ie)}}finally{ie&&(ie.hasRunningTasks&&!L.isCancellationRequested&&await P.Event.toPromise(ie.onEnd),ie.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.j.cancelAllRuns():this.j.cancelRunById(N)}};e.$dgc=i,e.$dgc=i=Ke([We(0,b.$EM)],i);const r=1e4;var u;(function(Q){Q[Q.Running=0]="Running",Q[Q.Cancelling=1]="Cancelling",Q[Q.Ended=2]="Ended"})(u||(u={}));class f extends y.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(N,A,L){super(),this.m=N,this.s=A,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.$Rd),this.onEnd=this.j.event,this.h=this.B(new M.$2d(L));const O=this.B(new T.$_g(()=>this.u(),r));this.B(this.h.token.onCancellationRequested(()=>O.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(N){return this.f.get(N)?.coverage}createRun(N){const A=this.m.id,L=this.m.controllerId,O=(0,l.$kg)(),x=new I(this.s,A,O),le=de=>(be,...ie)=>{if(ye){console.warn(`Setting the state of test "${be.id}" is a no-op after the run ends.`);return}this.m.isIncluded(be)&&(this.y(be),de(be,...ie))},me=(de,be)=>{const ie=be instanceof Array?be.map(s.TestMessage.from):[s.TestMessage.from(be)];if(de.uri&&de.range){const Ie={range:s.Range.from(de.range),uri:de.uri};for(const ce of ie)ce.location=ce.location||Ie}this.s.$appendTestMessagesInRun(A,O,n.$vJ.fromExtHostTestItem(de,L).toString(),ie)};let ye=!1;const we={isPersisted:this.m.isPersisted,token:this.h.token,name:N,get coverageProvider(){return x.coverageProvider},set coverageProvider(de){x.coverageProvider=de},enqueued:le(de=>{this.s.$updateTestStateInRun(A,O,n.$vJ.fromExtHostTestItem(de,L).toString(),1)}),skipped:le(de=>{this.s.$updateTestStateInRun(A,O,n.$vJ.fromExtHostTestItem(de,L).toString(),5)}),started:le(de=>{this.s.$updateTestStateInRun(A,O,n.$vJ.fromExtHostTestItem(de,L).toString(),2)}),errored:le((de,be,ie)=>{me(de,be),this.s.$updateTestStateInRun(A,O,n.$vJ.fromExtHostTestItem(de,L).toString(),6,ie)}),failed:le((de,be,ie)=>{me(de,be),this.s.$updateTestStateInRun(A,O,n.$vJ.fromExtHostTestItem(de,L).toString(),4,ie)}),passed:le((de,be)=>{this.s.$updateTestStateInRun(A,O,n.$vJ.fromExtHostTestItem(de,this.m.controllerId).toString(),3,be)}),appendOutput:(de,be,ie)=>{ye||(ie&&(this.m.isIncluded(ie)?this.y(ie):ie=void 0),this.s.$appendOutputToRun(A,O,C.$fe.fromString(de),be&&s.location.from(be),ie&&n.$vJ.fromExtHostTestItem(ie,L).toString()))},end:()=>{ye||(ye=!0,this.s.$finishedTestRunTask(A,O),this.f.delete(O),this.f.size||this.w())}};return this.f.set(O,{run:we,coverage:x}),this.s.$startedTestRunTask(A,{id:O,name:N,running:!0}),we}u(){for(const{run:N}of this.f.values())N.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(N){if(!(N instanceof a.$RM))throw new o.$wM(N.id);if(this.g.has(n.$vJ.fromExtHostTestItem(N,this.m.controllerId).toString()))return;const A=[],L=this.m.colllection.root;for(;;){const O=s.TestItem.from(N);if(A.unshift(O),this.g.has(O.extId)||(this.g.add(O.extId),N===L))break;N=N.parent||L}this.s.$addTestsToRun(this.m.controllerId,this.m.id,A)}dispose(){this.w(),super.dispose()}}class v{get trackers(){return this.c.values()}constructor(N){this.d=N,this.c=new Map}prepareForMainThreadTestRun(N,A,L,O){return this.f(N,A,L,O)}cancelRunById(N){for(const A of this.c.values())if(A.id===N){A.cancel();return}}cancelAllRuns(){for(const N of this.c.values())N.cancel()}createTestRun(N,A,L,O,x,le){const me=this.c.get(O);if(me)return me.createRun(x);const ye=D.fromPublic(A,L,O,le),we=g(O);this.d.$startedExtensionTestRun({controllerId:A,continuous:!!O.continuous,profile:we&&{group:W[we.kind],id:we.profileId},exclude:O.exclude?.map(be=>n.$vJ.fromExtHostTestItem(be,L.root.id).toString())??[],id:ye.id,include:O.include?.map(be=>n.$vJ.fromExtHostTestItem(be,L.root.id).toString())??[L.root.id],persist:le});const de=this.f(O,ye,N);return P.Event.once(de.onEnd)(()=>{this.d.$finishedExtensionTestRun(ye.id),de.dispose()}),de.createRun(x)}f(N,A,L,O){const x=new f(A,this.d,O);return this.c.set(N,x),P.Event.once(x.onEnd)(()=>this.c.delete(N)),x}}e.$egc=v;const g=Q=>{if(Q.profile){if(!(Q.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return Q.profile}};class D{static fromPublic(N,A,L,O){return new D(N,(0,l.$kg)(),L.include?.map(x=>n.$vJ.fromExtHostTestItem(x,N).toString())??[N],L.exclude?.map(x=>n.$vJ.fromExtHostTestItem(x,N).toString())??[],O,A)}static fromInternal(N,A){return new D(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,A)}constructor(N,A,L,O,x,le){this.controllerId=N,this.id=A,this.isPersisted=x,this.colllection=le,this.c=L.map(me=>me+"\0"),this.d=O.map(me=>me+"\0")}isIncluded(N){const A=n.$vJ.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const L of this.d)if(A===L||A.startsWith(L))return!1;for(const L of this.c)if(A===L||A.startsWith(L))return!0;return!1}}e.$fgc=D;class I{set coverageProvider(N){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this.c=N,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(N,A,L){this.f=N,this.g=A,this.h=L}async provideFileCoverage(N){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(N))());try{return(await this.d)?.map(s.TestCoverage.fromFile)??[]}catch(A){throw this.d=void 0,A}}async resolveFileCoverage(N,A){const L=await this.d;let O=L?.[N];return!this.c||!L||!O?[]:(O.detailedCoverage||(O=L[N]=await this.c.resolveFileCoverage?.(O,A)??O),O.detailedCoverage?.map(s.TestCoverage.fromDetailed)??[])}}class h{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(N){this.h=N,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(N){this.c.add(N)}update(N){Object.assign(N.revived,s.TestItem.toPlain(N.item)),this.c.has(N)||this.d.add(N)}remove(N){if(this.c.has(N)){this.c.delete(N);return}this.d.delete(N);const A=n.$vJ.parentId(N.item.extId);if(A&&this.g.has(A.toString())){this.g.add(N.item.extId);return}this.f.add(N)}getChangeEvent(){const{c:N,d:A,f:L}=this;return{get added(){return[...N].map(O=>O.revived)},get updated(){return[...A].map(O=>O.revived)},get removed(){return[...L].map(O=>O.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class w extends c.$CJ{constructor(){super(...arguments),this.q=new P.$Rd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(N){return this.d.get(N)}getMirroredTestDataByReference(N){return this.d.get(N.id)}p(N,A){return{...N,revived:s.TestItem.toPlain(N.item),depth:A?A.depth+1:0,children:new Set}}o(){return new h(this.q)}}class k{constructor(N){this.d=N}checkout(){this.c||(this.c=this.f());const N=this.c;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(A=>A.revived)},dispose:(0,$.$cb)(()=>{--N.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(N){return this.c?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.c?.tests.apply(N)}f(){const N=new w;return this.d.$subscribeToDiffs(),{observers:0,tests:N}}}class F{#e;#t;#i;#o;#r;get label(){return this.d}set label(N){N!==this.d&&(this.d=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(N){N!==this.g&&(this.g=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this.f}set isDefault(N){N!==this.f&&(this.f=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?s.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this.c}set configureHandler(N){N!==this.c&&(this.c=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}get isSelected(){return(0,d.$QF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,d.$QF)(this.#t,"testingActiveProfile"),P.Event.chain(this.#o,N=>N.map(A=>A.get(this.controllerId)?.get(this.profileId)).filter(S.$Kf))}constructor(N,A,L,O,x,le,me,ye,we,de,be=!1,ie=void 0,Ie=!1){this.controllerId=le,this.profileId=me,this.d=ye,this.kind=we,this.runHandler=de,this.f=be,this._tag=ie,this.g=Ie,this.#e=N,this.#r=A,this.#t=L,this.#i=O,this.#o=x,A.set(me,this);const ce=W[we];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${we}`);this.#e.$publishTestRunProfile({profileId:me,controllerId:le,tag:ie?s.TestTag.namespace(this.controllerId,ie.id):null,label:ye,group:ce,isDefault:be,hasConfigurationHandler:!1,supportsContinuousRun:Ie})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$ggc=F;const W={[t.TestRunProfileKind.Coverage]:8,[t.TestRunProfileKind.Debug]:4,[t.TestRunProfileKind.Run]:2}}),define(Pe[267],Re([1,0,18,11,5,3,108,8,7]),function(pe,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0;class y{constructor(S,l){this.i=l,this.a=new C.$Rd({onListenerError:T.$1}),this.b=new C.$Rd({onListenerError:T.$1}),this.c=new C.$Rd({onListenerError:T.$1}),this.d=new C.$Rd({onListenerError:T.$1}),this.f=new C.$Rd({onListenerError:T.$1}),this.g=new C.$Rd({onListenerError:T.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=S.getProxy(M.$CK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(S){const l=this.i.allEditors();return S?l:l.map(p=>p.value)}async showTextDocument(S,l,p){let b;typeof l=="number"?b={position:$.ViewColumn.from(l),preserveFocus:p}:typeof l=="object"?b={position:$.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selection:typeof l.selection=="object"?$.Range.from(l.selection):void 0,pinned:typeof l.preview=="boolean"?!l.preview:void 0}:b={preserveFocus:!1};const a=await this.h.$tryShowTextDocument(S.uri,b),s=a&&this.i.getEditor(a);if(s)return s.value;throw a?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,l){return new P.$LM(this.h,S,l).value}$acceptEditorPropertiesChanged(S,l){const p=this.i.getEditor(S);if(!p)throw new Error("unknown text editor");if(l.options&&p._acceptOptions(l.options),l.selections){const b=l.selections.selections.map($.Selection.to);p._acceptSelections(b)}if(l.visibleRanges){const b=E.$Gb(l.visibleRanges.map($.Range.to));p._acceptVisibleRanges(b)}if(l.options&&this.b.fire({textEditor:p.value,options:{...l.options,lineNumbers:$.TextEditorLineNumbersStyle.to(l.options.lineNumbers)}}),l.selections){const b=m.TextEditorSelectionChangeKind.fromValue(l.selections.source),a=l.selections.selections.map($.Selection.to);this.a.fire({textEditor:p.value,selections:a,kind:b})}if(l.visibleRanges){const b=E.$Gb(l.visibleRanges.map($.Range.to));this.c.fire({textEditor:p.value,visibleRanges:b})}}$acceptEditorPositionData(S){for(const l in S){const p=this.i.getEditor(l);if(!p)throw new Error("Unknown text editor");const b=$.ViewColumn.to(S[l]);p.value.viewColumn!==b&&(p._acceptViewColumn(b),this.d.fire({textEditor:p.value,viewColumn:b}))}}getDiffInformation(S){return Promise.resolve(this.h.$getDiffInformation(S))}}e.$Cec=y}),define(Pe[268],Re([1,0,2,4,3,6,7,8,22,16]),function(pe,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=e.$igc=void 0,e.$igc=(0,T.$Zh)("IExtHostTimeline");class R{constructor(p,b){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$CK.MainThreadTimeline),b.registerArgumentProcessor({processArgument:(a,s)=>{if(a&&a.$mid===12)if(this.b.get(a.source)&&m.$dm.equals(s,this.b.get(a.source)?.extension)){const t=a.uri===void 0?void 0:E.URI.revive(a.uri);return this.c.get(a.source)?.get(S(t))?.get(a.handle)}else return;return a}})}async $getTimeline(p,b,a,s){return this.b.get(p)?.provider.provideTimeline(E.URI.revive(b),a,s)}registerTimelineProvider(p,b,a,s){const t=new M.$Qc,n=this.d(b.id,s,t).bind(this);let o;b.onDidChange&&(o=b.onDidChange(d=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:b.id}),this));const c=this.c;return this.f({...b,scheme:p,onDidChange:void 0,async provideTimeline(d,i,r){i?.resetCache&&(t.clear(),c.get(b.id)?.clear());const u=await b.provideTimeline(d,i,r);if(u==null)return;const f=n(d,i);return{...u,source:b.id,items:u.items.map(f)}},dispose(){for(const d of c.values())d.get(b.id)?.clear();o?.dispose(),t.dispose()}},a)}d(p,b,a){return(s,t)=>{let n;if(t?.cacheResults){let o=this.c.get(p);o===void 0&&(o=new Map,this.c.set(p,o));const c=S(s);n=o.get(c),n===void 0&&(n=new Map,o.set(c,n))}return o=>{const{iconPath:c,...d}=o,i=`${p}|${o.id??o.timestamp}`;n?.set(i,o);let r,u,f;o.iconPath&&(c instanceof P.$yL?f={id:c.id,color:c.color}:E.URI.isUri(c)?(r=c,u=c):{light:r,dark:u}=c);let v;return P.$5K.isMarkdownString(d.tooltip)?v=$.MarkdownString.from(d.tooltip):(0,y.$Cf)(d.tooltip)?v=d.tooltip:P.$5K.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=$.MarkdownString.from(d.detail)):(0,y.$Cf)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=d.detail),{...d,id:d.id??void 0,handle:i,source:p,command:o.command?b.toInternal(o.command,a):void 0,icon:r,iconDark:u,themeIcon:f,tooltip:v,accessibilityInformation:o.accessibilityInformation}}}}f(p,b){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:b}),(0,M.$Pc)(()=>{for(const s of this.c.values())s.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$jgc=R;function S(l){return l?.toString()}}),define(Pe[87],Re([1,0,19,5,6,167,4,15,196,3,27,17,7]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fxb=e.$Exb=e.TunnelDtoConverter=void 0;class p extends m.$qv{}var b;(function(s){function t(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:o.protocol}}s.fromApiTunnel=t;function n(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==m.TunnelPrivacyId.ConstantPrivate&&o.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}s.fromServiceTunnel=n})(b||(e.TunnelDtoConverter=b={})),e.$Exb=(0,P.$Zh)("IExtHostTunnelService");let a=class extends C.$Rc{constructor(t,n,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Rd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(y.$CK.MainThreadTunnelService)}async openTunnel(t,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const o=await this.a.$openTunnel(n,t.displayName);if(o){const c=new p(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,n){const o=this.u();return this.r.set(o,{selector:t,provider:n}),this.a.$registerPortsAttributesProvider(t,o),new l.$EK(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(t,n,o,c,d){const i=[];for(const u of t){const f=this.r.get(u);if(!f)return[];i.push(...await Promise.all(n.map(async v=>{let g;try{g=await f.provider.providePortAttributes({port:v,pid:o,commandLine:c},d)}catch{g=await f.provider.providePortAttributes(v,o,c,d)}return{providedAttributes:g,port:v}})))}const r=i.filter(u=>!!u.providedAttributes);return r.length>0?r.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,d)=>await t.provideTunnel(c,d,new E.$2d().token)??void 0;const o=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,C.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,n){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const o=t.tunnelFactory??(n?this.w(n):void 0);if(o){this.b=o;let c=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const d=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:c}:void 0;this.a.$setTunnelProvider(d)}}else this.b=void 0;return(0,C.$Pc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,n){if(this.g.has(t.host)){const o=this.g.get(t.host);o.has(t.port)&&(n&&o.get(t.port).disposeListener.dispose(),await o.get(t.port).tunnel.dispose(),o.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(t,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const c=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const d=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:c,disposeListener:d}),b.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(t){const n=await Promise.all(t.map(c=>this.f(c.host,c.port,c.detail??""))),o=t.filter((c,d)=>n[d]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(c=>c.port).join(", ")} to ${o.map(c=>c.port).join(", ")}`),o}};e.$Fxb=a,e.$Fxb=a=Ke([We(0,S.$EM),We(1,R.$UM),We(2,$.$hj)],a)}),define(Pe[269],Re([1,0,6,13,2,3]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;class P{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(M.$CK.MainThreadUriOpeners)}registerExternalUriOpener(m,y,R,S){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const l=S.schemes.find(p=>!P.a.has(p));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(y,R),this.b.$registerUriOpener(y,S.schemes,m,S.label),(0,E.$Pc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri(m,y,R){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener with id: ${m}`);const l=C.URI.revive(y);return S.canOpenExternalUri(l,R)}async $openUri(m,y,R){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener id: '${m}'`);return S.openExternalUri(C.URI.revive(y.resolvedUri),{sourceUri:C.URI.revive(y.sourceUri)},R)}}e.$lgc=P}),define(Pe[270],Re([1,0,3,2,6,11,22]),function(pe,e,E,T,C,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class ${static{this.a=0}constructor(y){this.c=new P.$em,this.d=new Map,this.b=y.getProxy(E.$CK.MainThreadUrls)}registerUriHandler(y,R){const S=y.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const l=$.a++;return this.c.add(S),this.d.set(l,R),this.b.$registerUriHandler(l,S,y.displayName||y.name),(0,C.$Pc)(()=>{this.c.delete(S),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(y,R){const S=this.d.get(y);if(!S)return Promise.resolve(void 0);try{S.handleUri(T.URI.revive(R))}catch(l){(0,M.$Z)(l)}return Promise.resolve(void 0)}async createAppUri(y){return T.URI.revive(await this.b.$createAppUri(y))}}e.$mgc=$}),define(Pe[65],Re([1,0,5,6,13,26,2,181,203,78,3]),function(pe,e,E,T,C,M,P,$,m,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=e.$Tec=e.$Sec=e.$Rec=e.$Qec=void 0;class S{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(c,d,i,r,u,f,v){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Rd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Rd,this._onDidDispose=this.#h.event,this.#e=c,this.#t=d,this.#s=i,this.#o=r,this.#r=u,this.#n=f,this.#l=l(f),this.#d=p(f),this.#i=v}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,y.$Nub)(c,this.#o)}get cspSource(){const c=this.#n.extensionLocation;if(c.scheme===C.Schemas.https||c.scheme===C.Schemas.http){let d=c.toString();return d.endsWith("/")||(d+="/"),d+" "+y.$Mub}return y.$Mub}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),M.$in(this.#s,c)||this.#t.$setOptions(this.#e,s(this.#n,this.#r,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const d=(0,m.$gfb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,d.message,...d.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const d=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,i=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,u,f,v,g,D)=>{const I=P.URI.from({scheme:v||"file",path:decodeURIComponent(g)}),h=(0,y.$Nub)(I,{isRemote:d,authority:i}).toString();return`${u}${h}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,u,f,v,g,D)=>{const I=P.URI.from({scheme:v||"file",path:decodeURIComponent(g)}),h=(0,y.$Nub)(I,{isRemote:d,authority:i}).toString();return`${u}${h}${D}`})}}e.$Qec=S;function l(o){try{const c=(0,$.$Xo)((0,$.$Wo)(o.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$Rec=l;function p(o){try{const c=(0,$.$Xo)((0,$.$Wo)(o.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class b extends T.$Rc{constructor(c,d,i,r,u){super(),this.c=d,this.f=i,this.g=r,this.h=u,this.b=new Map,this.a=c.getProxy(R.$CK.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,d,i){const r=this.j(c);if(r){const{message:u}=(0,m.$hfb)(d,i.value);r._onMessageEmitter.fire(u)}}$onMissingCsp(c,d){this.g.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,d,i){const r=new S(c,this.a,t(d),this.c,this.f,i,this.h);this.b.set(c,r);const u=r._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return r}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Sec=b;function a(o){return{id:o.identifier,location:o.extensionLocation}}e.$Tec=a;function s(o,c,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||n(o,c)}}e.$Uec=s;function t(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(c=>P.URI.from(c))}}function n(o,c){return[...(c?.getWorkspaceFolders()||[]).map(d=>d.uri),o.extensionLocation]}}),define(Pe[271],Re([1,0,19,97,6,13,25,2,8,65,75,3,7]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class p{constructor(r,u){this.document=r,this.b=u,this.a=1,this.c=new R.$jec("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,u){await this.f(r).undo(),u||this.disposeBackup()}async redo(r,u){await this.f(r).redo(),u||this.disposeBackup()}disposeEdits(r){for(const u of r)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=d(this.document.uri)+this.a++;return(0,P.$Bg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const u=this.c.get(r,0);if(!u)throw new Error("No edit found");return u}}class b{constructor(){this.a=new Map}get(r,u){return this.a.get(this.b(r,u))}add(r,u,f){const v=this.b(r,u.uri);if(this.a.has(v))throw new Error(`Document already exists for viewType:${r} resource:${u.uri}`);const g=new p(u,f);return this.a.set(v,g),g}delete(r,u){const f=this.b(r,u.uri);this.a.delete(f)}b(r,u){return`${r}@@@${u}`}}var a;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(a||(a={}));class s{constructor(){this.a=new Map}addTextProvider(r,u,f){return this.b(0,r,u,f)}addCustomProvider(r,u,f){return this.b(1,r,u,f)}get(r){return this.a.get(r)}b(r,u,f,v){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:r,extension:f,provider:v}),new l.$EK(()=>this.a.delete(u))}}class t{constructor(r,u,f,v,g){this.d=u,this.f=f,this.g=v,this.h=g,this.b=new s,this.c=new b,this.a=r.getProxy(S.$CK.MainThreadCustomEditors)}registerCustomEditorProvider(r,u,f,v){const g=new C.$Qc;return o(f)?(g.add(this.b.addTextProvider(u,r,f)),this.a.$registerTextEditorProvider((0,y.$Tec)(r),u,v.webviewOptions||{},{supportsMove:!!f.moveCustomTextEditor},(0,y.$Rec)(r))):(g.add(this.b.addCustomProvider(u,r,f)),n(f)&&g.add(f.onDidChangeCustomDocument(D=>{const I=this.i(u,D.document.uri);if(c(D)){const h=I.addEdit(D);this.a.$onDidEdit(D.document.uri,u,h,D.label)}else this.a.$onContentChange(D.document.uri,u)})),this.a.$registerCustomEditorProvider((0,y.$Tec)(r),u,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,y.$Rec)(r))),l.$EK.from(g,new l.$EK(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(r,u,f,v,g){const D=this.b.get(u);if(!D)throw new Error(`No provider found for '${u}'`);if(D.type!==1)throw new Error(`Invalid provide type for '${u}'`);const I=$.URI.revive(r),h=await D.provider.openCustomDocument(I,{backupId:f,untitledDocumentData:v?.buffer},g);let w;return n(D.provider)&&this.f&&(w=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(u,h,w),{editable:n(D.provider)}}async $disposeCustomDocument(r,u){const f=this.b.get(u);if(!f)throw new Error(`No provider found for '${u}'`);if(f.type!==1)throw new Error(`Invalid provider type for '${u}'`);const v=$.URI.revive(r),{document:g}=this.i(u,v);this.c.delete(u,g),g.dispose()}async $resolveCustomEditor(r,u,f,v,g,D){const I=this.b.get(f);if(!I)throw new Error(`No provider found for '${f}'`);const h=m.ViewColumn.to(g),w=this.g.createNewWebview(u,v.contentOptions,I.extension),k=this.h.createNewWebviewPanel(u,f,v.title,h,v.options,w,v.active),F=$.URI.revive(r);switch(I.type){case 1:{const{document:W}=this.i(f,F);return I.provider.resolveCustomEditor(W,k,D)}case 0:{const W=this.d.getDocument(F);return I.provider.resolveCustomTextEditor(W,k,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,u,f){this.i(u,r).disposeEdits(f)}async $onMoveCustomEditor(r,u,f){const v=this.b.get(f);if(!v)throw new Error(`No provider found for '${f}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${f}'`);const g=this.h.getWebviewPanel(r);if(!g)throw new Error("No webview found");const D=$.URI.revive(u),I=this.d.getDocument(D);await v.provider.moveCustomTextEditor(I,g,E.CancellationToken.None)}async $undo(r,u,f,v){return this.i(u,r).undo(f,v)}async $redo(r,u,f,v){return this.i(u,r).redo(f,v)}async $revert(r,u,f){const v=this.i(u,r);await this.j(u).revertCustomDocument(v.document,f),v.disposeBackup()}async $onSave(r,u,f){const v=this.i(u,r);await this.j(u).saveCustomDocument(v.document,f),v.disposeBackup()}async $onSaveAs(r,u,f,v){const g=this.i(u,r);return this.j(u).saveCustomDocumentAs(g.document,$.URI.revive(f),v)}async $backup(r,u,f){const v=this.i(u,r),D=await this.j(u).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},f);return v.updateBackup(D),D.id}i(r,u){const f=this.c.get(r,$.URI.revive(u));if(!f)throw new Error("No custom document found");return f}j(r){const f=this.b.get(r)?.provider;if(!f||!n(f))throw new Error("Custom document is not editable");return f}}e.$Wec=t;function n(i){return!!i.onDidChangeCustomDocument}function o(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function d(i){const r=i.scheme===M.Schemas.file||i.scheme===M.Schemas.untitled?i.fsPath:i.toString();return(0,T.$Ni)(r)+""}}),define(Pe[272],Re([1,0,5,6,2,33,8,65,3,7]),function(pe,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0;class R extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(b,a,s,t){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Rd),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Rd),this.onDidChangeViewState=this.#h.event,this.#e=b,this.#t=a,this.#o=s,this.#i=t.viewType,this.#r=t.panelOptions,this.#s=t.viewColumn,this.#n=t.title,this.#u=t.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(b){this.c(),this.#n!==b&&(this.#n=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.c(),this.#a}set iconPath(b){this.c(),this.#a!==b&&(this.#a=b,this.#t.$setIconPath(this.#e,C.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(b){this.#l||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#u=b.active,this.#c=b.visible,this.#s=b.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(b,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:P.ViewColumn.from(b),preserveFocus:!!a})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends T.$Rc{static c(){return(0,M.$kg)()}constructor(b,a,s){super(),this.j=a,this.m=s,this.g=new Map,this.h=new Map,this.f=b.getProxy(m.$CK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(b=>b.dispose()),this.g.clear()}createWebviewPanel(b,a,s,t,n={}){const o=typeof t=="object"?t.viewColumn:t,c={viewColumn:P.ViewColumn.from(o),preserveFocus:typeof t=="object"&&!!t.preserveFocus},d=(0,$.$Rec)(b),i=S.c();this.f.$createWebviewPanel((0,$.$Tec)(b),i,a,{title:s,panelOptions:l(n),webviewOptions:(0,$.$Uec)(b,this.m,n),serializeBuffersForPostMessage:d},c);const r=this.j.createNewWebview(i,n,b);return this.createNewWebviewPanel(i,a,s,o,n,r,!0)}$onDidChangeWebviewPanelViewStates(b){const a=Object.keys(b);a.sort((s,t)=>{const n=b[s],o=b[t];return n.active?1:o.active?-1:+n.visible-+o.visible});for(const s of a){const t=this.getWebviewPanel(s);if(!t)continue;const n=b[s];t._updateViewState({active:n.active,visible:n.visible,viewColumn:P.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.g.delete(b),this.j.deleteWebview(b)}registerWebviewPanelSerializer(b,a,s){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:s,extension:b}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,$.$Rec)(b)}),new y.$EK(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(b,a,s,t){const n=this.h.get(a);if(!n)throw new Error(`No serializer found for '${a}'`);const{serializer:o,extension:c}=n,d=this.j.createNewWebview(b,s.webviewOptions,c),i=this.createNewWebviewPanel(b,a,s.title,t,s.panelOptions,d,s.active);await o.deserializeWebviewPanel(i,s.state)}createNewWebviewPanel(b,a,s,t,n,o,c){const d=new R(b,this.f,o,{viewType:a,title:s,viewColumn:t,panelOptions:n,active:c});return this.g.set(b,d),d}getWebviewPanel(b){return this.g.get(b)}}e.$Vec=S;function l(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Pe[273],Re([1,0,5,6,65,8,3,7]),function(pe,e,E,T,C,M,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;class m extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(S,l,p,b,a,s){super(),this.#r=!1,this.#u=this.B(new E.$Rd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Rd),this.onDidDispose=this.#l.event,this.#i=p,this.#a=b,this.#e=S,this.#t=l,this.#o=a,this.#n=s}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#s}set description(S){this.a(),this.#s!==S&&(this.#s=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(S){S===this.#n||this.#r||(this.#n=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#r)throw new Error("Webview is disposed")}}class y{constructor(S,l){this.d=l,this.b=new Map,this.c=new Map,this.a=S.getProxy(P.$CK.MainThreadWebviewViews)}registerWebviewViewProvider(S,l,p,b){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:p,extension:S}),this.a.$registerWebviewViewProvider((0,C.$Tec)(S),l,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Rec)(S)}),new $.$EK(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(S,l,p,b,a){const s=this.b.get(l);if(!s)throw new Error(`No view provider found for '${l}'`);const{provider:t,extension:n}=s,o=this.d.createNewWebview(S,{},n),c=new m(S,this.a,l,p,o,!0);this.c.set(S,c),await t.resolveWebviewView(c,{state:b},a)}async $onDidChangeWebviewViewVisibility(S,l){this.e(S)._setVisible(l)}async $disposeWebviewView(S){const l=this.e(S);this.c.delete(S),l.dispose(),this.d.deleteWebview(S)}e(S){const l=this.c.get(S);if(!l)throw new Error("No webview found");return l}}e.$ngc=y}),define(Pe[110],Re([1,0,5,3,2,13,12,4,17,23]),function(pe,e,E,T,C,M,P,$,m,y){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=e.$ogc=void 0;let S=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(p){const b=this.d;return{get focused(){return b.focused},get active(){return(0,y.$QF)(p,"windowActivity"),b.active}}}constructor(p){this.c=new E.$Rd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=p.getProxy(T.$CK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:b,isActive:a})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",a)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,b){b!==this.d[p]&&(this.d={...this.d,[p]:b},this.c.fire(this.d))}openUri(p,b){let a;if(typeof p=="string"){a=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,P.$Fe)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,a,b)}async asExternalUri(p,b){if((0,P.$Fe)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const a=await this.b.$asExternalUri(p,b);return C.URI.from(a)}};e.$ogc=S,e.$ogc=S=R=Ke([We(0,m.$EM)],S),e.$pgc=(0,$.$Zh)("IExtHostWindow")}),define(Pe[274],Re([1,0,240,27,17]),function(pe,e,E,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0;let M=class extends E.$sgc{constructor($,m){super($,m)}f($,m,y){m.apply(console,y)}};e.$Aic=M,e.$Aic=M=Ke([We(0,C.$EM),We(1,T.$UM)],M)}),define(Pe[275],Re([1,0,14,24,19,11,5,6,138,229,49]),function(pe,e,E,T,C,M,P,$,m,y,R){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$F6b=e.ResponsiveState=e.RequestInitiator=e.$E6b=e.$D6b=void 0;function l(k,F){try{return JSON.stringify(k,F)}catch{return"null"}}const p="$$ref$$",b={[p]:-1};class a{constructor(F,W){this.jsonString=F,this.referencedBuffers=W}}function s(k,F=null,W=!1){const Q=[];return{jsonString:(W?l:JSON.stringify)(k,(A,L)=>{if(typeof L>"u")return b;if(typeof L=="object"){if(L instanceof T.$fe){const O=Q.push(L)-1;return{[p]:O}}if(F)return F(A,L)}return L}),referencedBuffers:Q}}e.$D6b=s;function t(k,F,W){return JSON.parse(k,(Q,N)=>{if(N){const A=N[p];if(typeof A=="number")return F[A];if(W&&N.$mid===1)return W.transformIncoming(N)}return N})}e.$E6b=t;function n(k,F){return JSON.stringify(k,F)}function o(k){return k?(F,W)=>W&&W.$mid===1?k.transformOutgoing(W):W:null}var c;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var d;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(d||(e.ResponsiveState=d={}));const i=()=>{},r=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class f extends $.$Rc{static{S=r}static{this.a=3*1e3}constructor(F,W=null,Q=null){super(),this[S]=!0,this.b=this.B(new P.$Rd),this.onDidChangeResponsiveState=this.b.event,this.c=F,this.f=W,this.g=Q,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let N=0,A=R.$xv.count;N<A;N++)this.m[N]=null,this.s[N]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$_g(()=>this.H(),1e3)),this.c.onMessage(N=>this.L(N))}dispose(){this.j=!0,Object.keys(this.w).forEach(F=>{const W=this.w[F];delete this.w[F],W.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(F){this.z===0&&(this.C=Date.now()+f.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(F){this.C=Date.now()+f.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(F){this.y!==F&&(this.y=F,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(F){return this.g?(0,m.$Ym)(F,this.g):F}getProxy(F){const{nid:W,sid:Q}=F;return this.s[W]||(this.s[W]=this.J(W,Q)),this.s[W]}J(F,W){const Q={get:(N,A)=>(typeof A=="string"&&!N[A]&&A.charCodeAt(0)===36&&(N[A]=(...L)=>this.U(F,A,L)),A===u?W:N[A])};return new Proxy(Object.create(null),Q)}set(F,W){return this.m[F.nid]=W,W}assertRegistered(F){for(let W=0,Q=F.length;W<Q;W++){const N=F[W];if(!this.m[N.nid])throw new Error(`Missing proxy instance ${N.sid}`)}}L(F){if(this.j)return;const W=F.byteLength,Q=g.read(F,0),N=Q.readUInt8(),A=Q.readUInt32();switch(N){case 1:case 2:{let{rpcId:L,method:O,args:x}=I.deserializeRequestJSONArgs(Q);this.g&&(x=(0,m.$Ym)(x,this.g)),this.M(W,A,L,O,x,N===2);break}case 3:case 4:{let{rpcId:L,method:O,args:x}=I.deserializeRequestMixedArgs(Q);this.g&&(x=(0,m.$Ym)(x,this.g)),this.M(W,A,L,O,x,N===4);break}case 5:{this.f?.logIncoming(W,A,0,"ack"),this.G(A);break}case 6:{this.N(W,A);break}case 7:{this.O(W,A,void 0);break}case 9:{let L=I.deserializeReplyOKJSON(Q);this.g&&(L=(0,m.$Ym)(L,this.g)),this.O(W,A,L);break}case 10:{const L=I.deserializeReplyOKJSONWithBuffers(Q,this.g);this.O(W,A,L);break}case 8:{const L=I.deserializeReplyOKVSBuffer(Q);this.O(W,A,L);break}case 11:{let L=I.deserializeReplyErrError(Q);this.g&&(L=(0,m.$Ym)(L,this.g)),this.P(W,A,L);break}case 12:{this.P(W,A,void 0);break}default:console.error("received unexpected message"),console.error(F)}}M(F,W,Q,N,A,L){this.f?.logIncoming(F,W,1,`receiveRequest ${(0,R.$zv)(Q)}.${N}(`,A);const O=String(W);let x,le;if(L){const ye=new C.$2d;A.push(ye.token),x=this.Q(Q,N,A),le=()=>ye.cancel()}else x=this.Q(Q,N,A),le=i;this.u[O]=le;const me=I.serializeAcknowledged(W);this.f?.logOutgoing(me.byteLength,W,1,"ack"),this.c.send(me),x.then(ye=>{delete this.u[O];const we=I.serializeReplyOK(W,ye,this.h);this.f?.logOutgoing(we.byteLength,W,1,"reply:",ye),this.c.send(we)},ye=>{delete this.u[O];const we=I.serializeReplyErr(W,ye);this.f?.logOutgoing(we.byteLength,W,1,"replyErr:",ye),this.c.send(we)})}N(F,W){this.f?.logIncoming(F,W,1,"receiveCancel");const Q=String(W);this.u[Q]?.()}O(F,W,Q){this.f?.logIncoming(F,W,0,"receiveReply:",Q);const N=String(W);if(!this.w.hasOwnProperty(N))return;const A=this.w[N];delete this.w[N],A.resolveOk(Q)}P(F,W,Q){this.f?.logIncoming(F,W,0,"receiveReplyErr:",Q);const N=String(W);if(!this.w.hasOwnProperty(N))return;const A=this.w[N];delete this.w[N];let L;Q&&(Q.$isError?(L=new Error,L.name=Q.name,L.message=Q.message,L.stack=Q.stack):L=Q),A.resolveErr(L)}Q(F,W,Q){try{return Promise.resolve(this.S(F,W,Q))}catch(N){return Promise.reject(N)}}S(F,W,Q){const N=this.m[F];if(!N)throw new Error("Unknown actor "+(0,R.$zv)(F));const A=N[W];if(typeof A!="function")throw new Error("Unknown method "+W+" on actor "+(0,R.$zv)(F));return A.apply(N,Q)}U(F,W,Q){if(this.j)return new y.$C6b;let N=null;if(Q.length>0&&C.CancellationToken.isCancellationToken(Q[Q.length-1])&&(N=Q.pop()),N&&N.isCancellationRequested)return Promise.reject(M.$5());const A=I.serializeRequestArguments(Q,this.h),L=++this.t,O=String(L),x=new y.$B6b,le=new $.$Qc;N&&le.add(N.onCancellationRequested(()=>{const ye=I.serializeCancel(L);this.f?.logOutgoing(ye.byteLength,L,0,"cancel"),this.c.send(I.serializeCancel(L))})),this.w[O]=new v(x,le),this.F(L);const me=I.serializeRequest(L,F,W,A,!!N);return this.f?.logOutgoing(me.byteLength,L,0,`request: ${(0,R.$zv)(F)}.${W}(`,Q),this.c.send(me),x}}e.$F6b=f;class v{constructor(F,W){this.a=F,this.b=W}resolveOk(F){this.a.resolveOk(F),this.b.dispose()}resolveErr(F){this.a.resolveErr(F),this.b.dispose()}}class g{static alloc(F,W,Q){const N=new g(T.$fe.alloc(Q+1+4),0);return N.writeUInt8(F),N.writeUInt32(W),N}static read(F,W){return new g(F,W)}get buffer(){return this.a}constructor(F,W){this.a=F,this.b=W}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(F){this.a.writeUInt8(F,this.b),this.b+=1}readUInt8(){const F=this.a.readUInt8(this.b);return this.b+=1,F}writeUInt32(F){this.a.writeUInt32BE(F,this.b),this.b+=4}readUInt32(){const F=this.a.readUInt32BE(this.b);return this.b+=4,F}static sizeShortString(F){return 1+F.byteLength}writeShortString(F){this.a.writeUInt8(F.byteLength,this.b),this.b+=1,this.a.set(F,this.b),this.b+=F.byteLength}readShortString(){const F=this.a.readUInt8(this.b);this.b+=1;const Q=this.a.slice(this.b,this.b+F).toString();return this.b+=F,Q}static sizeLongString(F){return 4+F.byteLength}writeLongString(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readLongString(){const F=this.a.readUInt32BE(this.b);this.b+=4;const Q=this.a.slice(this.b,this.b+F).toString();return this.b+=F,Q}writeBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}static sizeVSBuffer(F){return 4+F.byteLength}writeVSBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readVSBuffer(){const F=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+F);return this.b+=F,W}static sizeMixedArray(F){let W=0;W+=1;for(let Q=0,N=F.length;Q<N;Q++){const A=F[Q];switch(W+=1,A.type){case 1:W+=this.sizeLongString(A.value);break;case 2:W+=this.sizeVSBuffer(A.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(A.value);for(let L=0;L<A.buffers.length;++L)W+=this.sizeVSBuffer(A.buffers[L]);break;case 4:break}}return W}writeMixedArray(F){this.a.writeUInt8(F.length,this.b),this.b+=1;for(let W=0,Q=F.length;W<Q;W++){const N=F[W];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let A=0;A<N.buffers.length;++A)this.writeBuffer(N.buffers[A]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const F=this.a.readUInt8(this.b);this.b+=1;const W=new Array(F);for(let Q=0;Q<F;Q++)switch(this.readUInt8()){case 1:W[Q]=this.readLongString();break;case 2:W[Q]=this.readVSBuffer();break;case 3:{const A=this.readUInt32(),L=this.readLongString(),O=[];for(let x=0;x<A;++x)O.push(this.readVSBuffer());W[Q]=new R.$Av(t(L,O,null));break}case 4:W[Q]=void 0;break}return W}}var D;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(D||(D={}));class I{static a(F){for(let W=0,Q=F.length;W<Q;W++)if(F[W]instanceof T.$fe||F[W]instanceof R.$Av||typeof F[W]>"u")return!0;return!1}static serializeRequestArguments(F,W){if(this.a(F)){const Q=[];for(let N=0,A=F.length;N<A;N++){const L=F[N];if(L instanceof T.$fe)Q[N]={type:2,value:L};else if(typeof L>"u")Q[N]={type:4};else if(L instanceof R.$Av){const{jsonString:O,referencedBuffers:x}=s(L.value,W);Q[N]={type:3,value:T.$fe.fromString(O),buffers:x}}else Q[N]={type:1,value:T.$fe.fromString(n(L,W))}}return{type:1,args:Q}}return{type:0,args:n(F,W)}}static serializeRequest(F,W,Q,N,A){switch(N.type){case 0:return this.b(F,W,Q,N.args,A);case 1:return this.c(F,W,Q,N.args,A)}}static b(F,W,Q,N,A){const L=T.$fe.fromString(Q),O=T.$fe.fromString(N);let x=0;x+=g.sizeUInt8(),x+=g.sizeShortString(L),x+=g.sizeLongString(O);const le=g.alloc(A?2:1,F,x);return le.writeUInt8(W),le.writeShortString(L),le.writeLongString(O),le.buffer}static deserializeRequestJSONArgs(F){const W=F.readUInt8(),Q=F.readShortString(),N=F.readLongString();return{rpcId:W,method:Q,args:JSON.parse(N)}}static c(F,W,Q,N,A){const L=T.$fe.fromString(Q);let O=0;O+=g.sizeUInt8(),O+=g.sizeShortString(L),O+=g.sizeMixedArray(N);const x=g.alloc(A?4:3,F,O);return x.writeUInt8(W),x.writeShortString(L),x.writeMixedArray(N),x.buffer}static deserializeRequestMixedArgs(F){const W=F.readUInt8(),Q=F.readShortString(),N=F.readMixedArray(),A=new Array(N.length);for(let L=0,O=N.length;L<O;L++){const x=N[L];typeof x=="string"?A[L]=JSON.parse(x):A[L]=x}return{rpcId:W,method:Q,args:A}}static serializeAcknowledged(F){return g.alloc(5,F,0).buffer}static serializeCancel(F){return g.alloc(6,F,0).buffer}static serializeReplyOK(F,W,Q){if(typeof W>"u")return this.d(F);if(W instanceof T.$fe)return this.e(F,W);if(W instanceof R.$Av){const{jsonString:N,referencedBuffers:A}=s(W.value,Q,!0);return this.g(F,N,A)}else return this.f(F,l(W,Q))}static d(F){return g.alloc(7,F,0).buffer}static e(F,W){let Q=0;Q+=g.sizeVSBuffer(W);const N=g.alloc(8,F,Q);return N.writeVSBuffer(W),N.buffer}static deserializeReplyOKVSBuffer(F){return F.readVSBuffer()}static f(F,W){const Q=T.$fe.fromString(W);let N=0;N+=g.sizeLongString(Q);const A=g.alloc(9,F,N);return A.writeLongString(Q),A.buffer}static g(F,W,Q){const N=T.$fe.fromString(W);let A=0;A+=g.sizeUInt32,A+=g.sizeLongString(N);for(const O of Q)A+=g.sizeVSBuffer(O);const L=g.alloc(10,F,A);L.writeUInt32(Q.length),L.writeLongString(N);for(const O of Q)L.writeBuffer(O);return L.buffer}static deserializeReplyOKJSON(F){const W=F.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(F,W){const Q=F.readUInt32(),N=F.readLongString(),A=[];for(let L=0;L<Q;++L)A.push(F.readVSBuffer());return new R.$Av(t(N,A,W))}static serializeReplyErr(F,W){const Q=W?l(M.$2(W),null):void 0;if(typeof Q!="string")return this.h(F);const N=T.$fe.fromString(Q);let A=0;A+=g.sizeLongString(N);const L=g.alloc(11,F,A);return L.writeLongString(N),L.buffer}static deserializeReplyErrError(F){const W=F.readLongString();return JSON.parse(W)}static h(F){return g.alloc(12,F,0).buffer}}var h;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var w;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(w||(w={}))}),define(Pe[276],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;const E=function(M){const P=$=>{globalThis.removeEventListener("message",P);const m=$.data;Object.defineProperties(globalThis,{postMessage:{value(y,R){m.postMessage(y,R)}},onmessage:{get(){return m.onmessage},set(y){m.onmessage=y}}}),m.addEventListener("message",y=>{globalThis.dispatchEvent(new MessageEvent("message",{data:y.data,ports:y.ports?[...y.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",P)}.toString();class T extends EventTarget{constructor(M,P,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${E})('${P}'))`,y=new Blob([m],{type:"application/javascript"}),R=URL.createObjectURL(y),S=new MessageChannel,l=R,p={type:"_newWorker",id:l,port:S.port2,url:R,options:$};M(p,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{M({type:"_terminateWorker",id:l}),URL.revokeObjectURL(R),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(b){S.port1.onmessage=b}},onmessageerror:{get(){return S.port1.onmessageerror},set(b){S.port1.onmessageerror=b}}}),S.port1.addEventListener("messageerror",b=>{const a=new MessageEvent("messageerror",{data:b.data});this.dispatchEvent(a)}),S.port1.addEventListener("message",b=>{const a=new MessageEvent("message",{data:b.data});this.dispatchEvent(a)}),S.port1.start()}}e.$Cic=T}),define(Pe[277],Re([1,0,5,30,35,4]),function(pe,e,E,T,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YJ=e.$XJ=e.OutputChannelUpdateMode=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=void 0,e.$NJ="text/x-code-output",e.$OJ="output",e.$PJ="Log",e.$QJ="text/x-code-log-output",e.$RJ="log",e.$SJ="workbench.panel.output",e.$TJ=new C.$ej("inOutput",!1),e.$UJ=new C.$ej("activeLogOutput",!1),e.$VJ=new C.$ej("outputView.scrollLock",!1),e.$WJ=(0,M.$Zh)("outputService");var P;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(P||(e.OutputChannelUpdateMode=P={})),e.$XJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new E.$Rd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Rd,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(R=>y.push(R)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}T.$qn.add(e.$XJ.OutputChannels,new $),e.$YJ=new C.$ej("activeOutputChannel","")}),define(Pe[111],Re([1,0,3,4,17,22,15,277,63,27,43,135,24,16,42,5,6]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=void 0;class t extends P.$nj{get disposed(){return this.n}constructor(d,i,r,u,f){super(),this.id=d,this.name=i,this.r=r,this.s=u,this.extension=f,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(d){this.append(d+`
`)}append(d){this.info(d)}clear(){const d=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,d)}replace(d){const i=this.m;this.info(d),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(d,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof d=="boolean"?d:i))}hide(){this.s.$close(this.id)}g(d,i){this.m+=l.$fe.fromString(i).byteLength,(0,P.log)(this.r,d,i),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends t{appendLine(d){this.append(d)}}let o=class{constructor(d,i,r,u,f,v){this.i=i,this.j=r,this.k=u,this.l=f,this.m=v,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=d.getProxy(E.$CK.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,S.$om)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.h=d;for(const[i,r]of this.g)r.visible=i===this.h}createOutputChannel(d,i,r){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const u=typeof i=="object"&&i.log,f=(0,p.$Cf)(i)?i:void 0;if((0,p.$Cf)(f)&&!f.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const g=this.i.environment.extensionLogLevel?.find(([I])=>M.$dm.equals(r.identifier,I))?.[1];g&&(v=(0,P.$xj)(g));const D=u?this.o(d,v,r):this.n(d,f,r);return D.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),u?this.r(d,v??this.m.getLevel(),D):this.q(d,D)}async n(d,i,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,f=this.k.extUri.joinPath(u,`${this.f++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.l.createLogger(f,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.a.$register(d,f,i,r.identifier.value);return new t(g,d,v,this.a,r)}async o(d,i,r){const u=await this.p(r),f=d.replace(/[\\/:\*\?"<>\|]/g,""),v=this.k.extUri.joinPath(u,`${f}.log`),g=`${r.identifier.value}.${f}`,D=this.l.createLogger(v,{id:g,name:d,logLevel:i,extensionId:r.identifier.value});return new n(g,d,D,this.a,r)}p(d){let i=this.d.get(d.identifier.value);if(!i){const r=this.k.extUri.joinPath(this.i.logsLocation,d.identifier.value);this.d.set(d.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(r)}catch(u){if((0,b.$yk)(u)!==b.FileSystemProviderErrorCode.FileExists)throw u}return r})())}return i}q(d,i){let r=!1;const u=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return d},append(f){u(),i.then(v=>v.append(f))},appendLine(f){u(),i.then(v=>v.appendLine(f))},clear(){u(),i.then(f=>f.clear())},replace(f){u(),i.then(v=>v.replace(f))},show(f,v){u(),i.then(g=>g.show(f,v))},hide(){u(),i.then(f=>f.hide())},dispose(){r=!0,i.then(f=>f.dispose())}}}r(d,i,r){const u=new s.$Qc,f=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},v=u.add(new a.$Rd);function g(D){i=D,v.fire(D)}return r.then(D=>{u.add(D),D.logLevel!==i&&g(D.logLevel),u.add(D.onDidChangeLogLevel(I=>g(I)))}),{...this.q(d,r),get logLevel(){return i},onDidChangeLogLevel:v.event,trace(D,...I){f(),r.then(h=>h.trace(D,...I))},debug(D,...I){f(),r.then(h=>h.debug(D,...I))},info(D,...I){f(),r.then(h=>h.info(D,...I))},warn(D,...I){f(),r.then(h=>h.warn(D,...I))},error(D,...I){f(),r.then(h=>h.error(D,...I))},dispose(){u.dispose()}}}};e.$1fc=o,e.$1fc=o=Ke([We(0,C.$EM),We(1,y.$UM),We(2,m.$Nec),We(3,R.$nec),We(4,P.$ij),We(5,P.$hj)],o),e.$2fc=(0,T.$Zh)("IExtHostOutputService")}),define(Pe[112],Re([1,0,4,14]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=void 0,e.$Dm=(0,E.$Zh)("remoteAgentService"),e.$Em=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const m=await C.getRoundTripTime();if(m===void 0)return;M=Math.min(M,m/2),await(0,T.$1g)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let P;return this.initial.length<this.maxInitialCount?this.initial.push(M):P=this.initial.reduce(($,m)=>$+m,0)/this.initial.length,this.lastMeasurement={initial:P,current:M,average:this.average.reduce(($,m)=>$+m,0)/this.average.length,high:(()=>typeof P>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>P*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[278],Re([1,0,169,54,30,47,41,6,5,112,21,26]),function(pe,e,E,T,C,M,P,$,m,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=void 0,e.$sH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$tH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$uH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$vH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new m.$Rd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const p=new l;C.$qn.add(e.$vH.ConfigurationMigration,p);let b=class extends $.$Rc{constructor(t,n){super(),this.a=t,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const c of o.added)await this.f(c,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(t){await this.f(void 0,t);for(const n of this.b.getWorkspace().folders)await this.f(n,t)}async f(t,n){await Promise.all([n.map(o=>this.g(o,t?.uri))])}async g(t,n){const o=this.a.inspect(t.key,{resource:n}),c=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[d,i]of c){const r=[];for(const f of o.overrideIdentifiers??[]){const v=await this.h(t,{resource:n,overrideIdentifier:f},d);for(const g of v??[]){let D=r.find(([[I,h]])=>I===g[0]&&(0,S.$in)(h.value,g[1].value));D||r.push(D=[g,[]]),D[1].push(f)}}const u=await this.h(t,{resource:n},d,o);for(const f of u??[])r.push([f,[]]);r.length&&await Promise.allSettled(r.map(async([[f,v],g])=>this.a.updateValue(f,v.value,{resource:n,overrideIdentifiers:g},i)))}}async h(t,n,o,c){const d=(c??this.a.inspect(t.key,n))[o];if(d===void 0)return;const i=u=>this.a.inspect(u,n)[o],r=await t.migrateFn(d,i);return Array.isArray(r)?r:[[t.key,r]]}};e.$wH=b,e.$wH=b=Ke([We(0,P.$ti),We(1,M.$9h)],b);let a=class extends $.$Rc{constructor(t){super(),(async()=>{if(!R.$i&&(await t.getEnvironment())?.os!==1)return;C.$qn.as(T.$vn.Configuration).registerConfiguration({...e.$uH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$xH=a,e.$xH=a=Ke([We(0,y.$Dm)],a)}),define(Pe[279],Re([1,0,34,13,20,25,177,278,54,4,30]),function(pe,e,E,T,C,M,P,$,m,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scb=e.$Rcb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Qcb=e.$Pcb=void 0,e.$Pcb=(0,y.$Zh)("editorResolverService"),e.$Qcb="workbench.editorAssociations";const S=R.$qn.as(m.$vn.Configuration),l={...$.$tH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,P.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(l);var p;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})(p||(e.RegisteredEditorPriority=p={}));var b;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(b||(e.ResolvedStatus=b={}));function a(t){switch(t){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.$Rcb=a;function s(t,n){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(n.scheme))return!1;const d=typeof t=="string"&&t.indexOf(C.$fc.sep)>=0?`${n.scheme}:${n.path}`:(0,M.$yg)(n);return E.$Fj(typeof t=="string"?t.toLowerCase():t,d.toLowerCase())}e.$Scb=s}),define(Pe[280],Re([1,0,46,13,20,21,25,2,4,198,47,216,112]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$fK=e.$eK=void 0,e.$eK=(0,m.$Zh)("pathService");let b=p=class{constructor(s,t,n,o){this.d=s,this.e=t,this.f=n,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??s})()}hasValidBasename(s,t,n){return typeof t=="string"||typeof t>"u"?this.a.then(o=>this.h(s,o,t)):this.h(s,t,n)}h(s,t,n){return s.scheme===T.Schemas.file||s.scheme===T.Schemas.vscodeRemote?(0,E.$Zf)(n??(0,P.$yg)(s),t===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,t){if(s.remoteAuthority)return T.Schemas.vscodeRemote;const n=(0,y.$bK)(t.getWorkspace());if(n)return n;const o=t.getWorkspace().folders[0];if(o)return o.uri.scheme;const c=t.getWorkspace().configuration;return c?c.scheme:T.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===1?C.$ec:C.$fc)}async fileURI(s){let t="";if(await this.a===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const o=s.indexOf("/",2);o===-1?(t=s.substring(2),s="/"):(t=s.substring(2,o),s=s.substring(o)||"/")}return $.URI.from({scheme:T.Schemas.file,authority:t,path:s,query:"",fragment:""})}};e.$fK=b,e.$fK=b=p=Ke([We(1,l.$Dm),We(2,S.$ZJ),We(3,R.$9h)],b)}),define(Pe[113],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$UI=e.$TI=void 0;class E{constructor(P,$){this.line=P,this.character=$}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,$){return new E(0,0)}with(P){return new E(0,0)}}e.$TI=E;class T{constructor(P,$,m,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(P,$),this.end=new E(m,y)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new T(0,0,0,0)}with(P){return new T(0,0,0,0)}}e.$UI=T;var C;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Pe[44],Re([1,0,18,34,26,46,12,4,20,11,113,14]),function(pe,e,E,T,C,M,P,$,m,y,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.SearchErrorCode=e.$0I=e.$9I=e.SearchSortOrder=e.ViewMode=e.$8I=e.$7I=e.$6I=e.$5I=e.SearchCompletionExitCode=e.$4I=e.$3I=e.$2I=e.QueryType=e.SearchProviderType=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$VI="workbench.view.search",e.$WI="workbench.panel.search",e.$XI="workbench.view.search",e.$YI="search-result",e.$ZI="search.exclude";const l="\u27EA ",p=" characters skipped \u27EB",b=(l.length+p.length+5)*2;e.$1I=(0,$.$Zh)("searchService");var a;(function(de){de[de.file=0]="file",de[de.text=1]="text"})(a||(e.SearchProviderType=a={}));var s;(function(de){de[de.File=1]="File",de[de.Text=2]="Text"})(s||(e.QueryType=s={}));function t(de){return!!de.preview}e.$2I=t;function n(de){return!!de.resource}e.$3I=n;function o(de){return!!de.message}e.$4I=o;var c;(function(de){de[de.Normal=0]="Normal",de[de.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class d{constructor(be){this.resource=be,this.results=[]}}e.$5I=d;class i{constructor(be,ie,Ie,ce){this.ranges=ie,this.webviewIndex=ce;const Y=Array.isArray(ie)?ie:[ie];if(Ie&&Ie.matchLines===1&&r(Y)){be=(0,P.$vf)(be,Ie.matchLines);let B="",se=0,Se=0;const Ae=Math.floor(Ie.charsPerLine/5),Ce=[];for(const fe of Y){const ne=Math.max(fe.startColumn-Ae,0),H=fe.startColumn+Ie.charsPerLine;if(ne>Se+Ae+b){const te=l+(ne-Se)+p;B+=te+be.slice(ne,H),se+=ne-(Se+te.length)}else B+=be.slice(Se,H);Ce.push(new f(0,fe.startColumn-se,fe.endColumn-se)),Se=H}this.preview={text:B,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const B=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:be,matches:(0,E.$1b)(ie,se=>new u(se.startLineNumber-B,se.startColumn,se.endLineNumber-B,se.endColumn))}}}}e.$6I=i;function r(de){const be=de[0].startLineNumber;for(const ie of de)if(ie.startLineNumber!==be||ie.endLineNumber!==be)return!1;return!0}class u{constructor(be,ie,Ie,ce){this.startLineNumber=be,this.startColumn=ie,this.endLineNumber=Ie,this.endColumn=ce}}e.$7I=u;class f extends u{constructor(be,ie,Ie){super(be,ie,be,Ie)}}e.$8I=f;var v;(function(de){de.List="list",de.Tree="tree"})(v||(e.ViewMode=v={}));var g;(function(de){de.Default="default",de.FileNames="fileNames",de.Type="type",de.Modified="modified",de.CountDescending="countDescending",de.CountAscending="countAscending"})(g||(e.SearchSortOrder=g={}));function D(de,be=!0){const ie=de&&de.files&&de.files.exclude,Ie=be&&de&&de.search&&de.search.exclude;if(!ie&&!Ie)return;if(!ie||!Ie)return ie||Ie;let ce=Object.create(null);return ce=C.$hn(ce,C.$en(ie)),ce=C.$hn(ce,C.$en(Ie),!0),ce}e.$9I=D;function I(de,be){return de.excludePattern&&T.$Fj(de.excludePattern,be)?!1:de.includePattern||de.usingSearchPaths?de.includePattern&&T.$Fj(de.includePattern,be)?!0:de.usingSearchPaths?!!de.folderQueries&&de.folderQueries.some(ie=>{const Ie=ie.folder.fsPath;if(M.$2f(be,Ie)){const ce=m.$kc(Ie,be);return!ie.includePattern||!!T.$Fj(ie.includePattern,ce)}else return!1}):!1:!0}e.$0I=I;var h;(function(de){de[de.unknownEncoding=1]="unknownEncoding",de[de.regexParseError=2]="regexParseError",de[de.globParseError=3]="globParseError",de[de.invalidLiteral=4]="invalidLiteral",de[de.rgProcessError=5]="rgProcessError",de[de.other=6]="other",de[de.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class w extends Error{constructor(be,ie){super(be),this.code=ie}}e.$$I=w;function k(de){const be=de.message;if((0,y.$3)(de))return new w(be,h.canceled);try{const ie=JSON.parse(be);return new w(ie.message,ie.code)}catch{return new w(be,h.other)}}e.$_I=k;function F(de){const be={message:de.message,code:de.code};return new Error(JSON.stringify(be))}e.$aJ=F;function W(de){return de.type==="error"?!0:de.type==="success"}e.$bJ=W;function Q(de){return de.type==="success"}e.$cJ=Q;function N(de){return!!de.path}e.$dJ=N;function A(de,be){const ie=de.searchPath?de.searchPath:de.relativePath;return(0,P.$sf)(ie,be)}e.$eJ=A;class L{constructor(be){this.path=be,this.results=[]}addMatch(be){this.results.push(be)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$fJ=L;function O(de,be){const ie={...de||{},...be||{}};return Object.keys(ie).filter(Ie=>{const ce=ie[Ie];return typeof ce=="boolean"&&ce})}e.$gJ=O;class x{constructor(be,ie){this.c=null,this.a={...be.excludePattern||{},...ie.excludePattern||{}},this.b=T.$Gj(this.a);let Ie=be.includePattern;ie.includePattern&&(Ie?Ie={...Ie,...ie.includePattern}:Ie=ie.includePattern),Ie&&(this.c=T.$Gj(Ie))}matchesExcludesSync(be,ie,Ie){return!!(this.b&&this.b(be,ie,Ie))}includedInQuerySync(be,ie,Ie){return!(this.b&&this.b(be,ie,Ie)||this.c&&!this.c(be,ie,Ie))}includedInQuery(be,ie,Ie){const ce=this.b(be,ie,Ie),Y=()=>this.c?!!this.c(be,ie,Ie):!0;return(0,S.$Mg)(ce)?ce.then(B=>B?!1:Y()):Y()}hasSiblingExcludeClauses(){return le(this.a)}}e.$hJ=x;function le(de){for(const be in de)if(typeof de[be]!="boolean")return!0;return!1}function me(de){if(!de)return;let be;return ie=>(be||(be=(de()||Promise.resolve([])).then(Ie=>Ie?we(Ie):{})),be.then(Ie=>!!Ie[ie]))}e.$iJ=me;function ye(de){if(!de)return;let be;return ie=>{if(!be){const Ie=de();be=Ie?we(Ie):{}}return!!be[ie]}}e.$jJ=ye;function we(de){const be={};for(const ie of de)be[ie]=!0;return be}}),define(Pe[36],Re([1,0,18,14,19,5,6,50,13,120,25,12,2,168,4,15,187,47,43,27,17,8,7,57,44,3,51]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s,t,n,o,c,d,i,r,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=e.$Hec=void 0;function g(Q,N,A){return new R.$qg(L=>w(L,A)).isEqual(Q,N)}function D(Q,N,A){return g(Q.uri,N.uri,A)?0:(0,S.$Ye)(Q.uri.toString(),N.uri.toString())}function I(Q,N,A){return Q.index!==N.index?Q.index<N.index?-1:1:g(Q.uri,N.uri,A)?(0,S.$Ye)(Q.name,N.name):(0,S.$Ye)(Q.uri.toString(),N.uri.toString())}function h(Q,N,A,L){const O=Q.slice(0).sort((le,me)=>A(le,me,L)),x=N.slice(0).sort((le,me)=>A(le,me,L));return(0,E.$Db)(O,x,(le,me)=>A(le,me,L))}function w(Q,N){const A=N.getCapabilities(Q.scheme);return!(A&&A&1024)}class k extends t.$gi{static toExtHostWorkspace(N,A,L,O){if(!N)return{workspace:null,added:[],removed:[]};const{id:x,name:le,folders:me,configuration:ye,transient:we,isUntitled:de}=N,be=[],ie=A;A?me.forEach((B,se)=>{const Se=l.URI.revive(B.uri),Ae=k.o(L||A,Se,O);Ae?(Ae.name=B.name,Ae.index=B.index,be.push(Ae)):be.push({uri:Se,name:B.name,index:se})}):be.push(...me.map(({uri:B,name:se,index:Se})=>({uri:l.URI.revive(B),name:se,index:Se}))),be.sort((B,se)=>B.index<se.index?-1:1);const Ie=new k(x,le,be,!!we,ye?l.URI.revive(ye):null,!!de,B=>w(B,O)),{added:ce,removed:Y}=h(ie?ie.workspaceFolders:[],Ie.workspaceFolders,D,O);return{workspace:Ie,added:ce,removed:Y}}static o(N,A,L){for(let O=0;O<N.folders.length;O++){const x=N.workspaceFolders[O];if(g(x.uri,A,L))return x}}constructor(N,A,L,O,x,le,me){super(N,L.map(ye=>new t.$hi(ye)),O,x,me),this.t=A,this.u=le,this.q=[],this.s=$.$6h.forUris(me),L.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(N,A){return A&&this.s.get(N)&&(N=(0,R.$Ag)(N)),this.s.findSubstr(N)}resolveWorkspaceFolder(N){return this.s.get(N)}}let F=class{constructor(N,A,L,O,x){this.c=new M.$Rd,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Rd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Td,this.B=new Map,this.h=O,this.s=L,this.t=x,this.j=new y.$1l,this.k=new T.$Yg,this.o=N.getProxy(f.$CK.MainThreadWorkspace),this.q=N.getProxy(f.$CK.MainThreadMessageService);const le=A.workspace;this.l=le?new k(le.id,le.name,[],!!le.transient,le.configuration?l.URI.revive(le.configuration):null,!!le.isUntitled,me=>w(me,L)):void 0}$initializeWorkspace(N,A){this.v=A,this.$acceptWorkspaceData(N),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:m.Schemas.untitled,path:(0,R.$yg)((0,R.$Ag)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(N,A,L,...O){const x=[];if(Array.isArray(O)&&O.forEach(de=>{l.URI.isUri(de.uri)&&!x.some(be=>g(be.uri,de.uri,this.s))&&x.push({uri:de.uri,name:de.name||(0,R.$xg)(de.uri)})}),this.n||[A,L].some(de=>typeof de!="number"||de<0)||L===0&&x.length===0)return!1;const le=this.x?this.x.workspaceFolders:[];if(A+L>le.length)return!1;const me=le.slice(0);me.splice(A,L,...x.map(de=>({uri:de.uri,name:de.name||(0,R.$xg)(de.uri),index:void 0})));for(let de=0;de<me.length;de++){const be=me[de];if(me.some((ie,Ie)=>Ie!==de&&g(be.uri,ie.uri,this.s)))return!1}me.forEach((de,be)=>de.index=be);const{added:ye,removed:we}=h(le,me,I,this.s);if(ye.length===0&&we.length===0)return!1;if(this.o){const de=N.displayName||N.name;this.o.$updateWorkspaceFolders(de,A,L,x).then(void 0,be=>{this.n=void 0;const ie={source:{identifier:N.identifier,label:N.displayName||N.name}};this.q.$showMessage(s.Severity.Error,(0,p.localize)(0,null,de,be.toString()),ie,[])})}return this.y(me),!0}getWorkspaceFolder(N,A){if(this.x)return this.x.getWorkspaceFolder(N,A)}async getWorkspaceFolder2(N,A){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(N,A)}async resolveWorkspaceFolder(N){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(N)}getPath(){if(!this.x)return;const{folders:N}=this.x;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,A){let L,O="";if(typeof N=="string"?(L=l.URI.file(N),O=N):typeof N<"u"&&(L=N,O=N.fsPath),!L)return O;const x=this.getWorkspaceFolder(L,!0);if(!x)return O;typeof A>"u"&&this.x&&(A=this.x.folders.length>1);let le=(0,R.$Dg)(x.uri,L);return A&&x.name&&(le=`${x.name}/${le}`),le}y(N){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:N,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:A,added:L,removed:O}=k.toExtHostWorkspace(N,this.l,this.n,this.s);this.l=A||void 0,this.n=void 0,this.c.fire(Object.freeze({added:L,removed:O}))}findFiles(N,A,L,O,x=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let le;if(A===null?le=!1:A&&(typeof A=="string"?le=A:le=A.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:me,folder:ye}=W(d.GlobPattern.from(N));return this.o.$startFileSearch(me??null,ye??null,le??null,L??null,x).then(we=>Array.isArray(we)?we.map(de=>l.URI.revive(de)):[])}async findTextInFiles(N,A,L,O,x=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const le=this.j.getNext(),me=typeof A.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:A.previewOptions,{includePattern:ye,folder:we}=W(d.GlobPattern.from(A.include)),de=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,be={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!0,fileEncoding:A.encoding,maxResults:A.maxResults,previewOptions:me,afterContext:A.afterContext,beforeContext:A.beforeContext,includePattern:ye,excludePattern:de},ie=!1;if(this.u[le]=Ie=>{if(ie)return;const ce=l.URI.revive(Ie.resource);Ie.results.forEach(Y=>{const B=(0,v.$wh)(Y);(0,u.$2I)(B)?L({uri:ce,preview:{text:B.preview.text,matches:(0,E.$1b)(B.preview.matches,se=>new i.$GK(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,E.$1b)(B.ranges,se=>new i.$GK(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):L({uri:ce,text:B.text,lineNumber:B.lineNumber})})},x.isCancellationRequested)return{};try{const Ie=await this.o.$startTextSearch(N,we??null,be,le,x);return delete this.u[le],Ie||{}}catch(Ie){throw delete this.u[le],Ie}}$handleTextSearchResult(N,A){this.u[A]?.(N)}async save(N){const A=await this.o.$save(N,{saveAs:!1});return l.URI.revive(A)}async saveAs(N){const A=await this.o.$save(N,{saveAs:!0});return l.URI.revive(A)}saveAll(N){return this.o.$saveAll(N)}resolveProxy(N){return this.o.$resolveProxy(N)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(N){return this.o.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(N,A){if(this.w.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.w.set(N,A);const L=this.t.transformOutgoingScheme(N),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,L),(0,P.$Pc)(()=>{this.w.delete(N),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(N,A){this.h.info("Getting edit session identifier for workspaceFolder",N);const L=await this.resolveWorkspaceFolder(l.URI.revive(N));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const O=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!O),!O)return;const x=await O.provideEditSessionIdentity(L,A);if(this.h.info("Provider returned edit session identifier: ",x),!!x)return x}async $provideEditSessionIdentityMatch(N,A,L,O){this.h.info("Getting edit session identifier for workspaceFolder",N);const x=await this.resolveWorkspaceFolder(l.URI.revive(N));if(!x){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",x);const le=this.w.get(x.uri.scheme);if(this.h.info(`Provider for scheme ${x.uri.scheme} is defined: `,!!le),!le)return;const me=await le.provideEditSessionIdentityMatch?.(A,L,O);if(this.h.info("Provider returned edit session identifier match result: ",me),!!me)return me}getOnWillCreateEditSessionIdentityEvent(N){return(A,L,O)=>{const x=function(me){A.call(L,me)};return x.extension=N,this.A.event(x,void 0,O)}}async $onWillCreateEditSessionIdentity(N,A,L){const O=await this.resolveWorkspaceFolder(l.URI.revive(N));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},A,async(x,le)=>{const me=Date.now();await Promise.resolve(x),Date.now()-me>L&&this.h.warn("SLOW edit session create-participant",le.extension.identifier)}),A.isCancellationRequested}registerCanonicalUriProvider(N,A){if(this.B.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.B.set(N,A);const L=this.t.transformOutgoingScheme(N),O=this.z++;return this.o.$registerCanonicalUriProvider(O,L),(0,P.$Pc)(()=>{this.B.delete(N),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(N,A,L){const O=this.B.get(N.scheme);if(!O)return;const x=await O.provideCanonicalUri?.(l.URI.revive(N),A,L);if(x)return x}async $provideCanonicalUri(N,A,L){return this.provideCanonicalUri(l.URI.revive(N),{targetScheme:A},L)}};e.$Hec=F,e.$Hec=F=Ke([We(0,c.$EM),We(1,o.$UM),We(2,n.$nec),We(3,a.$hj),We(4,r.$Fec)],F),e.$Iec=(0,b.$Zh)("IExtHostWorkspace");function W(Q){let N,A;return Q&&(typeof Q=="string"?N=Q:(N=Q.pattern,A=l.URI.revive(Q.baseUri))),{includePattern:N,folder:A}}}),define(Pe[37],Re([1,0,26,5,36,3,7,189,54,16,14,4,17,15,2]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=e.$Kec=e.$Jec=void 0;function a(r,u){if(u){const f=u.split(".");let v=r;for(let g=0;v&&g<f.length;g++)v=v[f[g]];return v}}function s(r){return r instanceof b.URI}function t(r){return r&&r.uri instanceof b.URI&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function o(r){return r&&r.uri instanceof b.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function c(r){if(s(r))return{resource:r};if(t(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(n(r))return{overrideIdentifier:r.languageId};if(o(r))return{resource:r.uri};if(r===null)return{resource:null}}let d=class{constructor(u,f,v){this.a=u.getProxy(M.$CK.MainThreadConfiguration),this.c=f,this.b=v,this.d=new R.$Yg,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new i(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,f){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(u,f))}};e.$Jec=d,e.$Jec=d=Ke([We(0,l.$EM),We(1,C.$Iec),We(2,p.$hj)],d);class i{constructor(u,f,v,g){this.a=new T.$Rd,this.b=u,this.f=g,this.c=f,this.e=$.$On.parse(v),this.d=this.k(v.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,f){const v={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$On.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(f,v))}getConfiguration(u,f,v){const g=c(f)||{},D=this.g(u?a(this.e.getValue(void 0,g,this.c.workspace),u):this.e.getValue(void 0,g,this.c.workspace));u&&this.h(u,g,v?.identifier);function I(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case P.ConfigurationTarget.Global:return 2;case P.ConfigurationTarget.Workspace:return 5;case P.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(w){return typeof a(D,w)<"u"},get:(w,k)=>{this.h(u?`${u}.${w}`:w,g,v?.identifier);let F=a(D,w);if(typeof F>"u")F=k;else{let W;const Q=(N,A)=>{if((0,y.$Ef)(N)){let L;const O=()=>{W=W||(0,E.$en)(D),L=L||a(W,A)};return new Proxy(N,{get:(x,le)=>{if(typeof le=="string"&&le.toLowerCase()==="tojson")return O(),()=>L;if(W)return L=L||a(W,A),L[le];const me=x[le];return typeof le=="string"?Q(me,`${A}.${le}`):me},set:(x,le,me)=>(O(),L&&(L[le]=me),!0),deleteProperty:(x,le)=>(O(),L&&delete L[le],!0),defineProperty:(x,le,me)=>(O(),L&&Object.defineProperty(L,le,me),!0)})}return Array.isArray(N)?(0,E.$en)(N):N};F=Q(F,w)}return F},update:(w,k,F,W)=>{w=u?`${u}.${w}`:w;const Q=I(F);return k!==void 0?this.b.$updateConfigurationOption(Q,w,k,g,W):this.b.$removeConfigurationOption(Q,w,g,W)},inspect:w=>{w=u?`${u}.${w}`:w;const k=this.e.inspect(w,g,this.c.workspace);if(k)return{key:w,defaultValue:(0,E.$en)(k.policy?.value??k.default?.value),globalValue:(0,E.$en)(k.user?.value??k.application?.value),workspaceValue:(0,E.$en)(k.workspace?.value),workspaceFolderValue:(0,E.$en)(k.workspaceFolder?.value),defaultLanguageValue:(0,E.$en)(k.default?.override),globalLanguageValue:(0,E.$en)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,E.$en)(k.workspace?.override),workspaceFolderLanguageValue:(0,E.$en)(k.workspaceFolder?.override),languageIds:(0,E.$en)(k.overrideIdentifiers)}}};return typeof D=="object"&&(0,E.$hn)(h,D,!1),Object.freeze(h)}g(u){const f=v=>(0,y.$Ef)(v)?new Proxy(v,{get:(g,D)=>f(g[D]),set:(g,D,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(D)}' of object`)},deleteProperty:(g,D)=>{throw new Error(`TypeError: Cannot delete read only property '${String(D)}' of object`)},defineProperty:(g,D)=>{throw new Error(`TypeError: Cannot define property '${String(D)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return f(u)}h(u,f,v){const g=m.$Fn.test(u)?4:this.d.get(u),D=v?`[${v.value}] `:"";if(g===4){typeof f?.resource>"u"&&this.f.warn(`${D}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){f?.resource&&this.f.warn(`${D}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,f){const v=new $.$Qn(u,f,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(g,D)=>v.affectsConfiguration(g,c(D))})}k(u){return u.reduce((f,v)=>(f.set(v[0],v[1]),f),new Map)}}e.$Kec=i,e.$Lec=(0,S.$Zh)("IExtHostConfiguration")}),define(Pe[114],Re([1,0,2,14,5,3,7,36,61,37,19,64,17,27,4,13,21,15,81,228,11]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s,t,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=e.$bgc=e.$agc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var d;(function(Q){function N(L){if(L!=null)return L}Q.from=N;function A(L){if(L!=null)return L}Q.to=A})(d||(d={}));var i;(function(Q){function N(L){if(L!=null)return L}Q.from=N;function A(L){if(L!=null)return L}Q.to=A})(i||(i={}));var r;(function(Q){function N(L){if(L!=null)return L}Q.from=N;function A(L){if(L!=null)return L}Q.to=A})(r||(r={}));var u;(function(Q){function N(O){if(O){const x=O;return x&&!!x.process}else return!1}Q.is=N;function A(O){if(O==null)return;const x={process:O.process,args:O.args};return O.options&&(x.options=r.from(O.options)),x}Q.from=A;function L(O){if(O!=null)return new P.$mL(O.process,O.args,O.options)}Q.to=L})(u||(u={}));var f;(function(Q){function N(L){if(L!=null)return L}Q.from=N;function A(L){if(L!=null)return L}Q.to=A})(f||(f={}));var v;(function(Q){function N(O){if(O){const x=O;return x&&(!!x.commandLine||!!x.command)}else return!1}Q.is=N;function A(O){if(O==null)return;const x={};return O.commandLine!==void 0?x.commandLine=O.commandLine:(x.command=O.command,x.args=O.args),O.options&&(x.options=f.from(O.options)),x}Q.from=A;function L(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new P.$nL(O.commandLine,O.options):new P.$nL(O.command,O.args?O.args:[],O.options)}Q.to=L})(v||(v={}));var g;(function(Q){function N(O){if(O){const x=O;return x&&x.customExecution==="customExecution"}else return!1}Q.is=N;function A(O){return{customExecution:"customExecution"}}Q.from=A;function L(O,x){return x.get(O)}Q.to=L})(g||(e.CustomExecutionDTO=g={}));var D;(function(Q){function N(A,L){let O;return A.scope!==void 0&&typeof A.scope!="number"?O=A.scope.uri:A.scope!==void 0&&typeof A.scope=="number"&&(A.scope===P.TaskScope.Workspace&&L&&L.workspaceFile?O=L.workspaceFile:O=o.$_F),{id:A._id,workspaceFolder:O}}Q.from=N})(D||(e.TaskHandleDTO=D={}));var I;(function(Q){function N(A){if(A!=null)return{_id:A.id,isDefault:A.isDefault}}Q.from=N})(I||(I={}));var h;(function(Q){function N(O,x){if(O==null)return[];const le=[];for(const me of O){const ye=A(me,x);ye&&le.push(ye)}return le}Q.fromMany=N;function A(O,x){if(O==null)return;let le;O.execution instanceof P.$mL?le=u.from(O.execution):O.execution instanceof P.$nL?le=v.from(O.execution):O.execution&&O.execution instanceof P.$oL&&(le=g.from(O.execution));const me=d.from(O.definition);let ye;return O.scope?typeof O.scope=="number"?ye=O.scope:ye=O.scope.uri:ye=P.TaskScope.Workspace,!me||!ye?void 0:{_id:O._id,definition:me,name:O.name,source:{extensionId:x.identifier.value,label:O.source,scope:ye},execution:le,isBackground:O.isBackground,group:I.from(O.group),presentationOptions:i.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}Q.from=A;async function L(O,x,le){if(O==null)return;let me;u.is(O.execution)?me=u.to(O.execution):v.is(O.execution)?me=v.to(O.execution):g.is(O.execution)&&(me=g.to(O._id,le));const ye=d.to(O.definition);let we;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?we=O.source.scope:we=await x.resolveWorkspaceFolder(E.URI.revive(O.source.scope)):we=P.TaskScope.Workspace),!ye||!we)return;const de=new P.$pL(ye,we,O.name,O.source.label,me,O.problemMatchers);return O.isBackground!==void 0&&(de.isBackground=O.isBackground),O.group!==void 0&&(de.group=P.$lL.from(O.group._id),de.group&&O.group.isDefault&&(de.group=new P.$lL(de.group.id,de.group.label),O.group.isDefault===!0&&(de.group.isDefault=O.group.isDefault))),O.presentationOptions&&(de.presentationOptions=i.to(O.presentationOptions)),O._id&&(de._id=O._id),O.detail&&(de.detail=O.detail),de}Q.to=L})(h||(e.TaskDTO=h={}));var w;(function(Q){function N(L){return L}Q.from=N;function A(L){if(L)return Object.assign(Object.create(null),L)}Q.to=A})(w||(w={}));class k{#e;constructor(N,A,L){this._id=A,this.a=L,this.#e=N}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}let F=class{constructor(N,A,L,O,x,le,me,ye){this.q=new C.$Rd,this.r=new C.$Rd,this.s=new C.$Rd,this.t=new C.$Rd,this.a=N.getProxy(M.$CK.MainThreadTask),this.b=L,this.c=O,this.d=x,this.e=le,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(N,A,L){if(!L)return new P.$EK(()=>{});const O=this.w();return this.j.set(O,{type:A,provider:L,extension:N}),this.a.$registerTaskProvider(O,A),new P.$EK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(N,A){this.a.$registerTaskSystem(N,A)}fetchTasks(N){return this.a.$fetchTasks(w.from(N)).then(async A=>{const L=[];for(const O of A){const x=await h.to(O,this.b,this.m);x&&L.push(x)}return L})}get taskExecutions(){const N=[];return this.k.forEach(A=>N.push(A)),N}terminateTask(N){if(!(N instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(N._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(N,A,L){const O=this.m.get(N.id);O&&(this.o.set(N.id,O),this.e.attachPtyToTerminal(A,await O.callback(L))),this.p=N.id,this.q.fire({execution:await this.y(N)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(N){const A=await this.y(N);this.l.delete(N.id),this.k.delete(N.id),this.A(N),this.r.fire({execution:A})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(N){const A=await this.y(N.id);this.s.fire({execution:A,processId:N.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(N){const A=await this.y(N.id);this.t.fire({execution:A,exitCode:N.exitCode})}$provideTasks(N,A){const L=this.j.get(N);if(!L)return Promise.reject(new Error("no handler found"));const O=[],x=(0,T.$Sg)(()=>L.provider.provideTasks(R.CancellationToken.None)).then(le=>this.u(A,O,L,le));return new Promise(le=>{x.then(me=>{Promise.all(O).then(()=>{le(me)})})})}async $resolveTask(N,A){const L=this.j.get(N);if(!L)return Promise.reject(new Error("no handler found"));if(A.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${A.definition.type}] cannot be resolved by provider of type [${L.type}].`);const O=await h.to(A,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const x=await L.provider.resolveTask(O,R.CancellationToken.None);if(!x)return;this.z(x,L);const le=h.from(x,L.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(le.execution)&&await this.x(le,x,!0),await this.v(le)}w(){return this.h++}async x(N,A,L){const O=await this.a.$createTaskId(N);!L&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,A.execution)),this.m.set(O,A.execution)}async y(N,A){if(typeof N=="string"){const x=this.l.get(N);if(!x)throw new c.$ab("Unexpected: The specified task is missing an execution");return x}const L=this.l.get(N.id);if(L)return L;const O=new Promise((x,le)=>{function me(ye,we,de){de?x(new k(ye,we.id,de)):le("Unexpected: Task does not exist.")}A?me(this,N,A):h.to(N.task,this.b,this.m).then(ye=>me(this,N,ye))});return this.l.set(N.id,O),O.then(x=>(this.k.set(N.id,x),x),x=>Promise.reject(x))}z(N,A){N._deprecated&&this.g.report("Task.constructor",A.extension,"Use the Task constructor that takes a `scope` instead.")}A(N){this.o.get(N.id)&&this.o.delete(N.id),this.n.has(N.id)&&this.p!==N.id&&(this.m.delete(N.id),this.n.delete(N.id));const L=this.n.values();let O=L.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=L.next()}};e.$agc=F,e.$agc=F=Ke([We(0,l.$EM),We(1,p.$UM),We(2,$.$Iec),We(3,m.$PM),We(4,y.$Lec),We(5,S.$0ec),We(6,t.$hj),We(7,n.$qec)],F);let W=class extends F{constructor(N,A,L,O,x,le,me,ye){super(N,A,L,O,x,le,me,ye),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:s.$h(0)})}async executeTask(N,A){if(!A.execution)throw new Error("Tasks to execute must include an execution");const L=h.from(A,N);if(L===void 0)throw new Error("Task is not valid");if(g.is(L.execution))await this.x(L,A,!1);else throw new c.$$;const O=await this.y(await this.a.$getTaskExecution(L),A);return this.a.$executeTask(L).catch(x=>{throw new Error(x)}),O}u(N,A,L,O){const x=[];if(O)for(const le of O){if(this.z(le,L),!le.definition||!N[le.definition.type]){const ye=le.source?le.source:"No task source";this.f.warn(`The task [${ye}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`)}const me=h.from(le,L.extension);me&&g.is(me.execution)?(x.push(me),A.push(this.x(me,le,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:x,extension:L.extension}}async v(N){if(g.is(N.execution))return N;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(N,A){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,A,L){}};e.$bgc=W,e.$bgc=W=Ke([We(0,l.$EM),We(1,p.$UM),We(2,$.$Iec),We(3,m.$PM),We(4,y.$Lec),We(5,S.$0ec),We(6,t.$hj),We(7,n.$qec)],W),e.$cgc=(0,b.$Zh)("IExtHostTask")}),define(Pe[281],Re([1,0,44,29]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.$qJ=e.$pJ=void 0;function C(P){return"cellResults"in P}e.$pJ=C,e.$qJ="rawCell#";function M(P,$){let m=-1;const y=[];let R=[];return P.forEach(l=>{l.range.startLineNumber!==m&&R.length>0&&(y.push([...R]),R=[]),R.push(l),m=l.range.endLineNumber}),R.length>0&&y.push([...R]),y.map(l=>{const p=[],b=l[0].range.startLineNumber,a=l[l.length-1].range.endLineNumber;for(let s=b;s<=a;s++)p.push($.getLineContent(s));return new E.$6I(p.join(`
`)+`
`,l.map(s=>new T.$Ds(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}e.$rJ=M}),define(Pe[282],Re([1,0,161,24,5,6,28,12,16,2,42,75,3,32,8,7,49,220,106,11,26,13,211,281,279]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s,t,n,o,c,d,i,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0;class f{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(g=>g.apiEditor)}constructor(g,D,I,h,w,k){this.q=I,this.r=h,this.s=w,this.t=k,this.f=new Map,this.g=new P.$zc,this.h=new Map,this.j=new C.$Rd({onListenerError:o.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Rd({onListenerError:o.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Rd({onListenerError:o.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Rd({onListenerError:o.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$jec("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=g.getProxy(l.$CK.MainThreadNotebook),this.c=g.getProxy(l.$CK.MainThreadNotebookDocuments),this.d=g.getProxy(l.$CK.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===13){const W=F.notebookEditor?.notebookUri,Q=F.cell.handle,A=this.g.get(W)?.getCell(Q);if(A)return A.apiCell}if(F&&F.$mid===14){const W=F.uri,Q=this.g.get(W);if(Q)return Q.apiNotebook}return F}}),f.B(D)}getEditorById(g){const D=this.h.get(g);if(!D)throw new Error(`unknown text editor: ${g}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(g){for(const[D,I]of this.h)if(I.apiEditor===g)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(g,D){const I=this.g.get(g);if(!I&&!D)throw new Error(`NO notebook document for '${g}'`);return I}static u(g,D){if(!D)return;const I=D.filenamePattern.map(h=>b.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(D.filenamePattern&&!I){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:g.identifier,providerDisplayName:g.displayName||g.name,displayName:D.displayName,filenamePattern:I,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(g,D,I){const h=f.a++,w=typeof I.onDidChangeCellStatusBarItems=="function"?f.a++:void 0;this.f.set(h,I),this.b.$registerNotebookCellStatusBarItemProvider(h,w,D);let k;return w!==void 0&&(k=I.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(w))),new a.$EK(()=>{this.f.delete(h),this.b.$unregisterNotebookCellStatusBarItemProvider(h,w),k?.dispose()})}async createNotebookDocument(g){const D=await this.c.$tryCreateNotebook({viewType:g.viewType,content:g.content&&b.NotebookData.from(g.content)});return y.URI.revive(D)}async openNotebookDocument(g){const D=this.g.get(g);if(D)return D.apiNotebook;const I=await this.c.$tryOpenNotebook(g),h=this.g.get(y.URI.revive(I));return(0,m.$Nf)(h?.apiNotebook)}async showNotebookDocument(g,D){y.URI.isUri(g)&&(g=await this.openNotebookDocument(g));let I;typeof D=="object"?I={position:b.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(b.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:I={preserveFocus:!1};const h=await this.d.$tryShowNotebookDocument(g.uri,g.notebookType,I),w=h&&this.h.get(h)?.apiEditor;if(w)return w;throw h?new Error(`Could NOT open editor for "${g.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${g.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(g,D,I,h){const w=this.f.get(g),k=y.URI.revive(D),F=this.g.get(k);if(!F||!w)return;const W=F.getCellFromIndex(I);if(!W)return;const Q=await w.provideCellStatusBarItems(W.apiCell,h);if(!Q)return;const N=new M.$Qc,A=this.p.add([N]),O=(Array.isArray(Q)?Q:[Q]).map(x=>b.NotebookStatusBarItem.from(x,this.i,N));return{cacheId:A,items:O}}$releaseNotebookCellStatusBarItems(g){this.p.delete(g)}registerNotebookSerializer(g,D,I,h,w){if((0,$.$Fe)(D))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:D,serializer:I,options:h}),this.b.$registerNotebookSerializer(k,{id:g.identifier,location:g.extensionLocation},D,b.NotebookDocumentContentOptions.from(h),f.u(g,w)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(g,D,I){const h=this.x.get(g);if(!h)throw new Error("NO serializer found");const w=await h.serializer.deserializeNotebook(D.buffer,I);return new s.$Av(b.NotebookData.from(w))}async $notebookToData(g,D,I){const h=this.x.get(g);if(!h)throw new Error("NO serializer found");const w=await h.serializer.serializeNotebook(b.NotebookData.to(D.value),I);return T.$fe.wrap(w)}async $saveNotebook(g,D,I,h,w){const k=y.URI.revive(D),F=this.x.get(g);if(!F)throw new Error("NO serializer found");const W=this.g.get(k);if(!W)throw new Error("Document NOT found");if(W.versionId!==I)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new R.$Dk((0,E.localize)(0,null,this.z(k)),6);await this.y(k,h);const Q={metadata:(0,c.$mn)(W.apiNotebook.metadata,x=>!(F.options?.transientDocumentMetadata??{})[x]),cells:[]};for(const x of W.apiNotebook.getCells()){const le=new a.$3L(x.kind,x.document.getText(),x.document.languageId,x.mime,F.options?.transientOutputs?[]:[...x.outputs],x.metadata,x.executionSummary);le.metadata=(0,c.$mn)(x.metadata,me=>!(F.options?.transientCellMetadata??{})[me]),Q.cells.push(le)}const N=await F.serializer.serializeNotebook(Q,w);await this.s.value.writeFile(k,N);const A=this.s.getFileSystemProviderExtUri(k.scheme),L=await this.s.value.stat(k);return{name:A.basename(k),isFile:(L.type&R.FileType.File)!==0,isDirectory:(L.type&R.FileType.Directory)!==0,isSymbolicLink:(L.type&R.FileType.SymbolicLink)!==0,mtime:L.mtime,ctime:L.ctime,size:L.size,readonly:!!((L.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((L.permissions??0)&R.FilePermission.Locked),etag:R.$Ok({mtime:L.mtime,size:L.size}),children:void 0}}async $searchInNotebooks(g,D,I,h,w){const k=this.x.get(g)?.serializer;if(!k)return{limitHit:!1,results:[]};const F=new P.$Ac;await(async(L,O,x)=>{await Promise.all(L.map(async le=>await Promise.all(le.filenamePatterns.map(me=>{const ye={...x,type:1,filePattern:me};return this.t.doInternalFileSearchWithCustomCallback(ye,O,we=>{we.forEach(de=>{F.has(de)||h.some(ie=>le.isFromSettings&&!ie.isFromSettings?!1:ie.filenamePatterns.some(Ie=>(0,u.$Scb)(Ie,de)))||F.add(de)})})}))))})(I,w,D);const Q=new P.$zc;let N=!1;const A=Array.from(F).map(async L=>{const O=[];try{if(w.isCancellationRequested)return;if(D.maxResults&&[...Q.values()].reduce((ye,we)=>ye+we.cellResults.length,0)>D.maxResults){N=!0;return}const x=[],le=this.g.get(L);if(le)le.apiNotebook.getCells().forEach(we=>x.push({input:we.document.getText(),outputs:we.outputs.flatMap(de=>de.items.map(be=>be.data.toString()))}));else{const ye=await this.s.value.readFile(L),we=T.$fe.fromString(ye.toString()),de=await k.deserializeNotebook(we.buffer,w);if(w.isCancellationRequested)return;b.NotebookData.from(de).cells.forEach(ie=>x.push({input:ie.source,outputs:ie.outputs.flatMap(Ie=>Ie.items.map(ce=>ce.valueBytes.toString()))}))}if(w.isCancellationRequested)return;x.forEach((ye,we)=>{const de=D.contentPattern.pattern,be=new i.$oPb(ye.input,void 0,ye.outputs),ie=be.findInInputs(de),Ie=be.findInOutputs(de),ce=Ie.flatMap(Y=>(0,r.$rJ)(Y.matches,Y.textBuffer)).map((Y,B)=>(Y.webviewIndex=B,Y));if(ie.length>0||Ie.length>0){const Y={index:we,contentResults:(0,r.$rJ)(ie,be.inputTextBuffer),webviewResults:ce};O.push(Y)}});const me={resource:L,cellResults:O};Q.set(L,me);return}catch{return}});return await Promise.all(A),{limitHit:N,results:[...Q.values()]}}async y(g,D){const I=await this.s.value.stat(g);if(typeof D?.mtime=="number"&&typeof D.etag=="string"&&D.etag!==R.$Nk&&typeof I.mtime=="number"&&typeof I.size=="number"&&D.mtime<I.mtime&&D.etag!==R.$Ok({mtime:D.mtime,size:I.size}))throw new R.$Dk((0,E.localize)(1,null),3,D)}z(g){return g.scheme===d.Schemas.file?g.fsPath:g.toString()}A(g,D,I){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const h=new n.$Ffc(D,this.d,g,I.visibleRanges.map(b.NotebookRange.to),I.selections.map(b.NotebookRange.to),typeof I.viewColumn=="number"?b.ViewColumn.to(I.viewColumn):void 0);this.h.set(D,h)}$acceptDocumentAndEditorsDelta(g){if(g.value.removedDocuments)for(const I of g.value.removedDocuments){const h=y.URI.revive(I),w=this.g.get(h);w&&(w.dispose(),this.g.delete(h),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(w.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===h.toString()&&this.h.delete(k.id)}if(g.value.addedDocuments){const I=[];for(const h of g.value.addedDocuments){const w=y.URI.revive(h.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const k=new t.$Efc(this.c,this.q,this.r,w,h);I.push(...h.cells.map(F=>t.$Dfc.asModelAddData(k.apiNotebook,F))),this.g.get(w)?.dispose(),this.g.set(w,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:I}),this.m.fire(k.apiNotebook)}}if(g.value.addedEditors)for(const I of g.value.addedEditors){if(this.h.has(I.id))return;const h=y.URI.revive(I.documentUri),w=this.g.get(h);w&&this.A(w,I.id,I)}const D=[];if(g.value.removedEditors)for(const I of g.value.removedEditors){const h=this.h.get(I);h&&(this.h.delete(I),this.k?.id===h.id&&(this.k=void 0),D.push(h))}if(g.value.visibleEditors){this.l=g.value.visibleEditors.map(h=>this.h.get(h)).filter(h=>!!h);const I=new Set;this.l.forEach(h=>I.add(h.id));for(const h of this.h.values()){const w=I.has(h.id);h._acceptVisibility(w)}this.l=[...this.h.values()].map(h=>h).filter(h=>h.visible),this.o.fire(this.visibleNotebookEditors)}g.value.newActiveEditor===null?this.k=void 0:g.value.newActiveEditor&&(this.h.get(g.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${g.value.newActiveEditor}`),this.k=this.h.get(g.value.newActiveEditor)),g.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(g){const D=p.$3M.String.with("notebookType","A notebook type"),I=new p.$5M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new p.$3M("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>T.$fe.wrap(w))],new p.$4M("Notebook Data",w=>b.NotebookData.to(w.value))),h=new p.$5M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new p.$3M("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new s.$Av(b.NotebookData.from(w)))],new p.$4M("Bytes",w=>w.buffer));g.registerApiCommand(I),g.registerApiCommand(h)}}e.$Ofc=f}),define(Pe[283],Re([1,0,20,19,40,34,25,60,44]),function(pe,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=void 0;class y{constructor(l,p,b){this.k=l,this.l=p,this.o=b,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&M.$Gj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&M.$Gj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const p=this.k.folderQueries||[];return new Promise((b,a)=>{const s=t=>{this.f++,l(t)};if(this.g)return b({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const n=t.toString(),o=E.$mc(n);this.j&&this.j(n,o)||this.v(s,{base:t,basename:o})}),Promise.all(p.map(t=>this.p(t,s))).then(t=>{b({limitHit:this.e,stats:t[0]||void 0})},t=>{a(new Error((0,C.$Ki)(t)))})})}async p(l,p){const b=new T.$2d,a=this.q(l),s=this.r(),t=new m.$hJ(this.k,l),n=!t.hasSiblingExcludeClauses();let o;try{this.h.add(b),o=$.$Nd.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,b.token),d=o.elapsed(),i=$.$Nd.create();return this.g&&!this.e||(c&&c.forEach(r=>{const u=E.$fc.relative(l.folder.path,r.path);if(n){const f=E.$mc(r.path);this.v(p,{base:l.folder,relativePath:u,basename:f});return}this.s(s,l.folder,u,p)}),this.g&&!this.e)?null:(this.u(s,t,p),{providerTime:d,postProcessTime:i.elapsed()})}finally{b.dispose(),this.h.delete(b)}}q(l){const p=(0,m.$gJ)(this.k.includePattern,l.includePattern),b=(0,m.$gJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:b,includes:p,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},p,b,a){if(b===this.a){const t=E.$mc(this.a);this.v(a,{base:p,relativePath:this.a,basename:t})}function s(t){const n=E.$mc(t),o=E.$lc(t);let c=l[o];c||(c=l[o]=[],s(o)),c.push({base:p,relativePath:t,basename:n})}s(b)}u({rootEntries:l,pathToEntries:p},b,a){const s=this,t=this.a;function n(o){const c=(0,m.$jJ)(()=>o.map(d=>d.basename));for(let d=0,i=o.length;d<i;d++){const r=o[d],{relativePath:u,basename:f}=r;if(b.matchesExcludesSync(u,f,t!==f?c:void 0))continue;const v=p[u];if(v)n(v);else{if(u===t)continue;s.v(a,r)}if(s.e)break}}n(l)}v(l,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(p))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,p,b,a){const s=this.c(l.cacheKey),t=new y(l,p,s&&s.token);let n=0;const o=c=>{n+=c.length,b(c.map(d=>this.d(d)))};return this.e(t,R.a,o,a).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new T.$2d),this.b.get(l)}d(l){return l.relativePath?{resource:P.$Bg(l.base,l.relativePath)}:{resource:l.base}}e(l,p,b,a){const s=a.onCancellationRequested(()=>{l.cancel()}),t=o=>{o&&(n.push(o),p>0&&n.length>=p&&(b(n),n=[]))};let n=[];return l.search(t).then(o=>(n.length&&b(n),s.dispose(),o),o=>(n.length&&b(n),s.dispose(),Promise.reject(o)))}}e.$Gfc=R}),define(Pe[284],Re([1,0,18,245,34,94,28,13,20,25,12,16,2,93,179,41,15,47,104,280,44]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s,t,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hK=e.$gK=void 0;let d=class{constructor(w,k,F,W,Q){this.a=w,this.b=k,this.c=F,this.d=W,this.e=Q}text(w,k,F={}){w=this.f(w,F);const W=this.a.getValue(),Q=k&&k.some(A=>!this.a.getValue({resource:A}).search.useRipgrep);return{...this.h(k?.map(t.$ii),F),type:2,contentPattern:w,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:W.search.usePCRE2||Q||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}f(w,k){const F=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const W={...w,wordSeparators:F.editor.wordSeparators};return this.j(w,k)&&(W.isCaseSensitive=!0),this.k(w)&&(W.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),W}file(w,k={}){return{...this.h(w,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(w,k){return w?(w=Array.isArray(w)?w.map(v):v(w),k?this.parseSearchPaths(w):{pattern:r(...Array.isArray(w)?w:[w])}):{}}h(w=[],k={}){const F=this.g(k.includePattern,k.expandPatterns),W=this.g(k.excludePattern,k.expandPatterns),Q=w.length>1,N=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(O=>this.q(O,k,W)):w.map(O=>this.r(O,k,W,Q))).filter(O=>!!O),A={_reason:k._reason,folderQueries:N,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:W.pattern,includePattern:F.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const O=E.$Gb(E.$Qb(this.c.groups.map(me=>me.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const x=O.filter(me=>(0,c.$0I)(A,me.fsPath)),le=this.i(x);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(le)),{...A,...le}}const L=k.extraFileResources&&k.extraFileResources.filter(O=>(0,c.$0I)(A,O.fsPath));return A.extraFileResources=L&&L.length?L:void 0,A}i(w){const k=[],F=new P.$zc,W={};let Q=!1;return w.forEach(N=>{if(N.scheme===$.Schemas.walkThrough)return;if((0,y.$Fg)(N)){const L=this.b.getWorkspaceFolder(N)?.uri??N.with({path:m.$lc(N.fsPath)});let O=F.get(L);O||(Q=!0,O={folder:L,includePattern:{}},k.push(O),F.set(L,O));const x=m.$kc(L.fsPath,N.fsPath);(0,S.$Nf)(O.includePattern)[x.replace(/\\/g,"/")]=!0}else N.fsPath&&(Q=!0,W[N.fsPath]=!0)}),{folderQueries:k,includePattern:W,usingSearchPaths:!0,excludePattern:Q?void 0:{"**/*":!0}}}j(w,k){if(k.isSmartCase){if(w.isRegExp){if(R.$tf(w.pattern,!0))return!0}else if(R.$tf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,p.$GB)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const k=le=>m.$hc(le)||/^\.\.?([\/\\]|$)/.test(le),W=(Array.isArray(w)?w:u(w)).map(le=>{const me=this.e.resolvedUserHome;return me?(0,M.$Fv)(le,me.scheme===$.Schemas.file?me.fsPath:me.path):le}),Q=T.$J(W,le=>k(le)?"searchPaths":"exprSegments"),N=(Q.exprSegments||[]).map(le=>R.$Oe(le,"/")).map(le=>R.$Oe(le,"\\")).map(le=>(le[0]==="."&&(le="*"+le),f(le))),A={},L=this.m(Q.searchPaths||[]);L&&L.length&&(A.searchPaths=L);const O=E.$Qb(N),x=r(...O);return x&&(A.pattern=x),A}l(w,k){return k.disregardExcludeSettings?void 0:(0,c.$9I)(w,!k.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const k=w.flatMap(W=>{let{pathPortion:Q,globPortion:N}=i(W);return N&&(N=g(N)),this.n(Q).flatMap(L=>this.o(L,N))}),F=new Map;return k.forEach(W=>{const Q=W.searchPath.toString(),N=F.get(Q);N?W.pattern&&(N.pattern=N.pattern||{},N.pattern[W.pattern]=!0):F.set(Q,{searchPath:W.searchPath,pattern:W.pattern?r(W.pattern):void 0})}),Array.from(F.values())}n(w){if(m.$hc(w)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==$.Schemas.file?[{searchPath:k[0].uri.with({path:w})}]:[{searchPath:l.URI.file(m.$gc(w))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(w=v(w),w.startsWith("../")||w===".."){const W=m.$fc.resolve(k.path,w);return[{searchPath:k.with({path:W})}]}const F=g(w);return[{searchPath:k,pattern:F}]}else{if(w==="./"||w===".\\")return[];{const k=w.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(Q=>{const N=k.match(new RegExp(`^${R.$Je(Q.name)}(?:/(.*)|$)`));return N?{match:N,folder:Q}:null}).filter(S.$Kf);if(W.length)return W.map(Q=>{const N=Q.match[1];return{searchPath:Q.folder.uri,pattern:N&&g(N)}});{const Q=w.match(/\.[\/\\](.+)[\/\\]?/),N=Q?Q[1]:w,A=b.localize(0,null,N);throw new Error(A)}}}}o(w,k){const F=w.pattern&&k?`${w.pattern}/${k}`:w.pattern||k,W=[{searchPath:w.searchPath,pattern:F}];return F&&!F.endsWith("**")&&W.push({searchPath:w.searchPath,pattern:F+"/**"}),W}q(w,k,F){const W=this.r((0,t.$ii)(w.searchPath),k,F,!1);return W?{...W,includePattern:w.pattern}:null}r(w,k,F,W){let Q;const N=l.URI.isUri(w)?w:w.uri;if(F.searchPaths){const le=F.searchPaths.filter(me=>(0,y.$ug)(me.searchPath,N))[0];if(le&&!le.pattern)return null;le&&(Q=le.pattern)}const A=this.a.getValue({resource:N}),O={...this.l(A,k)||{},...Q||{}},x=l.URI.isUri(w)?(0,y.$yg)(w):w.name;return{folder:N,folderName:W?x:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:A.files&&A.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!A.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!A.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!A.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!A.search.followSymlinks}}};e.$gK=d,e.$gK=d=Ke([We(0,a.$ti),We(1,t.$9h),We(2,n.$KC),We(3,s.$hj),We(4,o.$eK)],d);function i(h){const w=h.match(/[\*\{\}\(\)\[\]\?]/);if(w){const k=w.index,F=h.substr(0,k).match(/[/|\\][^/\\]*$/);if(F){let W=h.substr(0,F.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:h.substr((F.index||0)+1)}}}return{pathPortion:h}}function r(...h){return h.length?h.reduce((w,k)=>(w[k]=!0,w),Object.create(null)):void 0}function u(h){return C.$Ej(h,",").map(w=>w.trim()).filter(w=>!!w.length)}function f(h){return[`**/${h}/**`,`**/${h}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function v(h){return h.replace(/\\/g,"/")}function g(h){return v(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(h){return h.replace(/([?*[\]])/g,"[$1]")}function I(h,w){h=E.$Lb(h,W=>W.toString());const k=[],F=w.getWorkspace();return h&&h.forEach(W=>{let Q;if(w.getWorkbenchState()===2)Q=(0,y.$Dg)(F.folders[0].uri,W),Q&&Q!=="."&&(Q="./"+Q);else{const N=w.getWorkspaceFolder(W);if(N){const A=N.name;if(F.folders.filter(O=>O.name===A).length===1){const O=(0,y.$Dg)(N.uri,W);O===""?Q=`./${N.name}`:Q=`./${N.name}/${O}`}else Q=W.fsPath}}Q&&k.push(D(Q))}),k}e.$hK=I}),define(Pe[285],Re([1,0,25,2,19,11,4,284,44,47]),function(pe,e,E,T,C,M,P,$,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Irb=e.$Hrb=void 0;const R=7e3;function S(a,s){const t=s.activationEvents;if(!t)return Promise.resolve(void 0);const n=[],o=[];for(const f of t)if(/^workspaceContains:/.test(f)){const v=f.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||a.forceUsingSearch?o.push(v):n.push(v)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);let c;const d=new Promise((f,v)=>{c=f}),i=f=>c({activationEvent:f}),r=Promise.all(n.map(f=>l(a,f,i))).then(()=>{}),u=p(a,s.identifier,o,i);return Promise.all([r,u]).then(()=>{c(void 0)}),d}e.$Hrb=S;async function l(a,s,t){for(const n of a.folders)if(await a.exists(E.$Bg(T.URI.revive(n),s))){t(`workspaceContains:${s}`);return}}async function p(a,s,t,n){if(t.length===0)return Promise.resolve(void 0);const o=new C.$2d,c=a.checkExists(a.folders,t,o.token),d=setTimeout(async()=>{o.cancel(),a.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},R);let i=!1;try{i=await c}catch(r){M.$3(r)||M.$Z(r)}o.dispose(),clearTimeout(d),i&&n(`workspaceContains:${t.join(",")}`)}function b(a,s,t,n){const o=a.get(P.$Yh),c=a.get(m.$1I),i=o.createInstance($.$gK).file(s.map(r=>(0,y.$ii)(T.URI.revive(r))),{_reason:"checkExists",includePattern:t,exists:!0});return c.fileSearch(i,n).then(r=>!!r.limitHit,r=>M.$3(r)?!1:Promise.reject(r))}e.$Irb=b}),define(Pe[38],Re([1,0,158,20,88,25,14,6,50,2,15,3,37,217,85,36,23,105,11,22,24,200,7,99,4,27,86,17,71,87,64,5,285,84,202,13,82,60,21,83]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s,t,n,o,c,d,i,r,u,f,v,g,D,I,h,w,k,F,W,Q,N,A,L,O){"use strict";var x;Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=e.$kfc=e.$jfc=e.$ifc=void 0,e.$ifc=(0,u.$Zh)("IHostUtils");let le=x=class extends $.$Rc{constructor(Y,B,se,Se,Ae,Ce,fe,ne,H,te,X,re){super(),this.X=re,this.a=this.B(new w.$Rd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=se,this.f=fe,this.j=Se,this.m=Ae,this.s=Ce,this.t=H,this.u=te,this.w=X,this.y=this.g.getProxy(S.$CK.MainThreadWorkspace),this.z=this.g.getProxy(S.$CK.MainThreadTelemetry),this.C=this.g.getProxy(S.$CK.MainThreadExtensionService),this.D=new P.$Yg,this.F=new P.$Yg,this.G=new P.$Yg,this.H=new P.$Yg,this.I=new Ie(this.f.extensions.activationEvents),this.L=new t.$x6b(this.I,this.f.extensions.allExtensions);const he=new o.$em(this.f.extensions.myExtensions);this.J=new t.$x6b(this.I,be(this.L,he)),L.$t&&(this.s.info(`Creating extension host with the following global extensions: ${we(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${we(this.J)}`)),this.M=new b.$6ec(this.g,this.s),this.N=new F.$bfc(this.g),this.O=ne,this.h=Y.createChild(new D.$Xh([b.$7ec,this.M],[F.$cfc,this.N])),this.P=this.B(new p.$5ec(this.J,this.L,{onExtensionActivationError:(De,z,V)=>{this.C.$onExtensionActivationError(De,n.$2(z),V)},actualActivateExtension:async(De,z)=>{if(t.$x6b.isHostExtension(De,this.J,this.L))return await this.C.$activateExtension(De,z),new p.$4ec;const V=this.J.getExtensionDescription(De);return this.db(V,z)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Y){n.$Z(Y)}}async Y(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(Ae=>Ae.identifier).filter(Ae=>this.isActivated(Ae)).map(Ae=>this.cb(Ae))}catch{}await Promise.all(Y)}terminate(Y,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Se=>{this.s.error(Se)}),this.g.dispose();const se=this.Y();Promise.race([(0,P.$1g)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const B=await this.C.$getExtension(Y);return B&&{...B,identifier:new o.$dm(B.identifier.value),extensionLocation:y.URI.revive(B.extensionLocation)}}Z(Y,B){return this.P.activateByEvent(Y,B)}$(Y,B){return this.P.activateById(Y,B)}activateByIdWithErrors(Y,B){return this.$(Y,B).then(()=>{const se=this.P.getActivatedExtension(Y);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async ab(Y){if(Y.scheme===Q.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(Y.fsPath);return y.URI.file(B)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Y=>new ie(Y))),this.Q}async bb(Y){const B=m.$6h.forUris(se=>M.$sg.ignorePathCasing(se));return await Promise.all(Y.map(async se=>{if(this.ub(se)){const Se=await this.ab(se.extensionLocation);B.set(Se,se)}})),B}cb(Y){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return B;const se=this.P.getActivatedExtension(Y);if(!se)return B;try{typeof se.module.deactivate=="function"&&(B=Promise.resolve(se.module.deactivate()).then(void 0,Se=>(this.s.error(Se),Promise.resolve(void 0))))}catch(Se){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(Se)}try{(0,$.$Mc)(se.subscriptions)}catch(Se){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(Se)}return B}async db(Y,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.fb(Y,B).then(se=>{const Se=se.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,B),this.eb(Y,B,"success",Se),se},se=>{throw this.eb(Y,B,"failure"),se})}eb(Y,B,se,Se){const Ae=ye(Y,B);this.z.$publicLog2("extensionActivationTimes",{...Ae,...Se||{},outcome:se})}fb(Y,B){const se=ye(Y,B);this.z.$publicLog2("activatePlugin",se);const Se=this.ub(Y);if(!Se)return Promise.resolve(new p.$3ec(p.$Zec.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${Y.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const Ae=new p.$1ec(B.startup);return Promise.all([this.vb(Y,(0,M.$Bg)(Y.extensionLocation,Se),Ae),this.gb(Y)]).then(Ce=>(C.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),x.hb(this.s,Y.identifier,Ce[0],Ce[1],Ae))).then(Ce=>(C.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),Ce))}gb(Y){const B=new d.$9ec(Y,this.M),se=new d.$8ec(Y.identifier.value,!1,this.M),Se=new W.$dfc(Y,this.N),Ae=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ce=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([B.whenReady,se.whenReady,this.O.whenReady]).then(()=>{const fe=this;let ne,H;const te=(0,s.$PF)(Y,"ipc")?this.f.messagePorts?.get(o.$dm.toKey(Y.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:se,secrets:Se,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(X){return T.$ic(Y.extensionLocation.fsPath,X)},get storagePath(){return fe.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return fe.O.globalValue(Y).fsPath},get logPath(){return T.$ic(fe.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return y.URI.joinPath(fe.f.logsLocation,Y.identifier.value)},get storageUri(){return fe.O.workspaceValue(Y)},get globalStorageUri(){return fe.O.globalValue(Y)},get extensionMode(){return Ae},get extension(){return ne===void 0&&(ne=new de(fe,Y.identifier,Y,Ce,!1)),ne},get extensionRuntime(){return(0,s.$QF)(Y,"extensionRuntime"),fe.extensionRuntime},get environmentVariableCollection(){return fe.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!H){if(!te)return;const X=w.Event.buffer(w.Event.fromDOMEventEmitter(te,"message",re=>re.data));te.start(),H={onDidReceiveMessage:X,postMessage:te.postMessage.bind(te)}}return H}})})}static hb(Y,B,se,Se,Ae){return se=se||{activate:void 0,deactivate:void 0},this.ib(Y,B,se,Se,Ae).then(Ce=>new p.$2ec(!1,null,Ae.build(),se,Ce,Se.subscriptions))}static ib(Y,B,se,Se,Ae){if(typeof se.activate=="function")try{Ae.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${B.value}`);const Ce=typeof global=="object"?global:self,fe=se.activate.apply(Ce,[Se]);return Ae.activateCallStop(),Ae.activateResolveStart(),Promise.resolve(fe).then(ne=>(Ae.activateResolveStop(),ne))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(se)}jb(Y,B){this.$(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:B}).then(void 0,se=>{this.s.error(se)})}kb(Y,B=0){const Se=Date.now();(0,L.$B)(()=>{for(let Ae=B;Ae<Y.length;Ae+=1){const Ce=Y[Ae];for(const fe of Ce.activationEvents??[])if(fe==="onStartupFinished")if(Date.now()-Se>50){this.kb(Y,Ae);break}else this.jb(Ce,fe)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(Y=>{const B=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(B)this.kb(se);else for(const Se of se)if(Se.activationEvents)for(const Ae of Se.activationEvents)Ae==="onStartupFinished"&&this.jb(Se,Ae)})}mb(){const Y=this.Z("*",!0).then(void 0,Ce=>{this.s.error(Ce)});this.B(this.j.onDidChangeWorkspace(Ce=>this.nb(Ce.added)));const B=this.j.workspace?this.j.workspace.folders:[],se=this.nb(B),Se=this.pb(),Ae=Promise.all([Se,Y,se]).then(()=>{});return Promise.race([Ae,(0,P.$1g)(1e4)]).then(()=>{this.lb()}),Ae}nb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(Y,B))).then(()=>{})}async ob(Y,B){if(this.isActivated(B.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,Se={logService:this.s,folders:Y.map(Ce=>Ce.uri),forceUsingSearch:se||!this.c.fsExists,exists:Ce=>this.c.fsExists(Ce.fsPath),checkExists:(Ce,fe,ne)=>this.y.$checkExists(Ce,fe,ne)},Ae=await(0,k.$Hrb)(Se,B);if(Ae)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:Ae.activationEvent}).then(void 0,Ce=>this.s.error(Ce))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Y){throw console.error(Y),Y}}async qb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:B}=this.f.environment;if(!Y||!B)throw new Error(E.localize(0,null));const se=await this.vb(null,B,new p.$1ec(!1));if(!se||typeof se.run!="function")throw new Error(E.localize(1,null,B.toString()));return new Promise((Se,Ae)=>{const Ce=(H,te)=>{H?(L.$t&&this.s.error("Test runner called back with error",H),Ae(H)):(L.$t&&(te?this.s.info(`Test runner called back with ${te} failures.`):this.s.info("Test runner called back with successful outcome.")),Se(typeof te=="number"&&te>0?1:0))},fe=(0,M.$pg)(B),ne=se.run(fe,Ce);ne&&ne.then&&ne.then(()=>{L.$t&&this.s.info("Test runner finished successfully."),Se(0)}).catch(H=>{L.$t&&this.s.error("Test runner finished with error",H),Ae(H instanceof Error&&H.stack?H.stack:String(H))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,P.$1g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,B){return this.R[Y]=B,(0,$.$Pc)(()=>{delete this.R[Y]})}async getRemoteExecServer(Y){const{resolver:B}=await this.sb(Y);return B?.resolveExecServer?.(Y,{resolveAttempt:0})}async sb(Y){const B=Y.indexOf("+");if(B===-1)throw new i.$KK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=Y.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.R[se]}}async $resolveAuthority(Y,B){const se=A.$Nd.create(!1),Se=()=>`[resolveAuthority(${(0,r.$4k)(Y)},${B})][${se.elapsed()}ms] `,Ae=J=>this.s.info(`${Se()}${J}`),Ce=J=>this.s.warn(`${Se()}${J}`),fe=(J,q=void 0)=>this.s.error(`${Se()}${J}`,q),ne=J=>{if(J instanceof i.$KK)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},H=async J=>{Ae(`activating resolver for ${J}...`);const{resolver:q,authorityPrefix:ee}=await this.sb(J);if(!q)throw fe(`no resolver for ${ee}`),new i.$KK(`No remote extension installed to resolve ${ee}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:ee,remoteAuthority:J}},te=Y.split(/@|%40/g).reverse();Ae(`activating remote resolvers ${te.join(" -> ")}`);let X;try{X=await Promise.all(te.map(H)).catch(async J=>{if(!(J instanceof i.$KK)||J._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return Ce(`resolving nested authorities failed: ${J.message}`),[await H(Y)]})}catch(J){return ne(J)}const re=new P.$$g;re.cancelAndSet(()=>Ae("waiting..."),1e3);let he,De;for(const[J,{authorityPrefix:q,resolver:ee,remoteAuthority:ue}]of X.entries())try{if(J===X.length-1)Ae("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${q}`),he=await ee.resolve(ue,{resolveAttempt:B,execServer:De}),C.mark(`code/extHost/didResolveAuthorityOK/${q}`),Ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ee,i.$JK.isManagedResolvedAuthority(he)?he:void 0));else{if(Ae(`invoking resolveExecServer() for ${ue}`),C.mark(`code/extHost/willResolveExecServer/${q}`),De=await ee.resolveExecServer?.(ue,{resolveAttempt:B,execServer:De}),!De)throw new i.$KK(`Exec server was not available for ${ue}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Ne){return C.mark(`code/extHost/didResolveAuthorityError/${q}`),fe("returned an error",Ne),re.dispose(),ne(Ne)}re.dispose();const z={environmentTunnels:he.environmentTunnels,features:he.tunnelFeatures},V={extensionHostEnv:he.extensionHostEnv,isTrusted:he.isTrusted,authenticationSession:he.authenticationSessionForInitializingExtensions?{id:he.authenticationSessionForInitializingExtensions.id,providerId:he.authenticationSessionForInitializingExtensions.providerId}:void 0};Ae(`returned ${i.$JK.isManagedResolvedAuthority(he)?"managed authority":`${he.host}:${he.port}`}`);let G;if(i.$JK.isManagedResolvedAuthority(he)){const J=B;this.X.setFactory(J,he.makeConnection),G={authority:Y,connectTo:new r.$1k(J),connectionToken:he.connectionToken}}else G={authority:Y,connectTo:new r.$2k(he.host,he.port),connectionToken:he.connectionToken};return{type:"ok",value:{authority:G,options:V,tunnelInformation:z}}}async $getCanonicalURI(Y,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$4k)(Y)})`);const{resolver:se}=await this.sb(Y);if(!se)return null;const Se=y.URI.revive(B);if(typeof se.getCanonicalURI>"u")return Se;const Ae=await(0,P.$Sg)(()=>se.getCanonicalURI(Se));return Ae||Se}$startExtensionHost(Y){Y.toAdd.forEach(Se=>Se.extensionLocation=y.URI.revive(Se.extensionLocation));const{globalRegistry:B,myExtensions:se}=me(this.I,this.L,this.J,Y);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(se),L.$t&&(this.s.info(`$startExtensionHost: global extensions: ${we(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${we(this.J)}`)),this.rb()}$activateByEvent(Y,B){return B===1?this.D.wait().then(se=>this.Z(Y,!1)):this.G.wait().then(se=>this.Z(Y,!1))}async $activate(Y,B){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.$(Y,B),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(Ce=>Ce.extensionLocation=y.URI.revive(Ce.extensionLocation));const{globalRegistry:B,myExtensions:se}=me(this.I,this.L,this.J,Y),Se=await this.bb(se);return(await this.getExtensionPathIndex()).setSearchTree(Se),this.L.set(B.getAllExtensionDescriptions()),this.J.set(se),L.$t&&(this.s.info(`$deltaExtensions: global extensions: ${we(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${we(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const B=c.$fe.alloc(Y),se=Math.random()%256;for(let Se=0;Se<Y;Se++)B.writeUInt8(se,Se);return B}async $updateRemoteConnectionData(Y){this.W=Y,this.a.fire()}};e.$jfc=le,e.$jfc=le=x=Ke([We(0,u.$Yh),We(1,e.$ifc),We(2,g.$EM),We(3,a.$Iec),We(4,l.$Lec),We(5,R.$hj),We(6,f.$UM),We(7,v.$Oec),We(8,I.$Exb),We(9,h.$0ec),We(10,N.$ffc),We(11,O.$gfc)],le);function me(ce,Y,B,se){ce.addActivationEvents(se.addActivationEvents);const Se=new t.$x6b(ce,Y.getAllExtensionDescriptions());Se.deltaExtensions(se.toAdd,se.toRemove);const Ae=new o.$em(B.getAllExtensionDescriptions().map(fe=>fe.identifier));for(const fe of se.myToRemove)Ae.delete(fe);for(const fe of se.myToAdd)Ae.add(fe);const Ce=be(Se,Ae);return{globalRegistry:Se,myExtensions:Ce}}function ye(ce,Y){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function we(ce){return ce.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$kfc=(0,u.$Zh)("IExtHostExtensionService");class de{#e;#t;#i;constructor(Y,B,se,Se,Ae){this.#e=Y,this.#t=B,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=T.$gc((0,M.$pg)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=Se,this.isFromDifferentExtensionHost=Ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$lfc=de;function be(ce,Y){return ce.getAllExtensionDescriptions().filter(B=>Y.has(B.identifier))}class ie{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$mfc=ie;class Ie{constructor(Y){this.a=new o.$fm,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const B of Object.keys(Y))this.a.set(B,Y[B])}}}),define(Pe[286],Re([1,0,88,2,3,37,23,22,17,27,4,38,15,12]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;let a=class{constructor(c,d,i,r,u,f,v){this.c=c,this.d=d,this.e=i,this.f=r,this.g=u,this.h=f,this.i=v,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const d=await this.g.getExtensionPathIndex();this.register(new t(this.c,d,this.d,c,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,d,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const d of c.nodeModuleName)this.a.set(d,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(d=>c.alternativeModuleName(d))}};e.$ugc=a,e.$ugc=a=Ke([We(2,R.$Yh),We(3,M.$Lec),We(4,S.$kfc),We(5,y.$UM),We(6,l.$hj)],a);let s=class{static{b=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&b.a.size){const d=(0,p.$Je)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",r=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${d}/${u}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const d=this.b.exec(this.c(c));if(!d)return;const[,i,r,u]=d,f=b.a.get(r);if(f!==void 0)return console.warn(`${r} as been renamed to ${f}, please update your imports`),i+f+u}c(c){return c.replace(/\\/g,"/")}};s=b=Ke([We(0,y.$UM)],s);class t{constructor(c,d,i,r,u){this.c=c,this.d=d,this.e=i,this.f=r,this.g=u,this.nodeModuleName="vscode",this.a=new $.$fm}load(c,d){const i=this.d.findSubstr(d);if(i){let r=this.a.get(i.identifier);return r||(r=this.c(i,this.e,this.f),this.a.set(i.identifier,r)),r}if(!this.b){let r="";this.d.forEach((u,f)=>r+=`	${f} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${r}`),this.b=this.c(P.$KF,this.e,this.f)}return this.b}}let n=class{constructor(c,d,i){this.e=c,this.f=d,this.nodeModuleName=["open","opn"],this.d=i.getProxy(C.$CK.MainThreadTelemetry);const r=i.getProxy(C.$CK.MainThreadWindow);this.c=(u,f)=>{const v=T.URI.parse(u);return f?this.g(u,f):v.scheme==="http"||v.scheme==="https"?r.$openUri(v,u,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?r.$openUri(v,u,{}):this.g(u,f)}}load(c,d,i){const r=this.e.findSubstr(d);return r&&(this.a=r.identifier.value,this.h()),this.b=i(c),this.c}g(c,d){return this.i(),this.b(c,d)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ke([We(2,m.$EM)],n)}),define(Pe[115],Re([1,0,39,6,20,74,4,61,62,38,7,36,214,37]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=e.$nfc=void 0,e.$nfc=(0,P.$Zh)("IExtHostVariableResolverProvider");class b extends l.$FN{constructor(t,n,o,c,d,i,r){function u(){if(o){const f=o.activeEditor();if(f)return f.document.uri;const v=c.tabGroups.all.find(g=>g.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof R.$kM||v.input instanceof R.$pM)return v.input.modified;if(v.input instanceof R.$jM||v.input instanceof R.$oM||v.input instanceof R.$mM)return v.input.uri}}}super({getFolderUri:f=>{const v=i.folders.filter(g=>g.name===f);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(f,v)=>d.getConfiguration(void 0,f).get(v),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const f=u();if(f)return C.$gc(f.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const f=u();if(f){const v=n.getWorkspaceFolder(f);if(v)return C.$gc(v.uri.fsPath)}}},getSelectedText:()=>{if(o){const f=o.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(o){const f=o.activeEditor();if(f)return String(f.selection.end.line+1)}},getExtension:f=>t.getExtension(f)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(M.env))}}let a=class extends T.$Rc{constructor(t,n,o,c,d){super(),this.b=t,this.c=n,this.g=o,this.h=c,this.j=d,this.a=new E.$U(async()=>{const i=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async f=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.j,i,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$ofc=a,e.$ofc=a=Ke([We(0,y.$kfc),We(1,S.$Iec),We(2,$.$PM),We(3,p.$Lec),We(4,m.$Xec)],a)}),define(Pe[116],Re([1,0,14,5,2,4,3,62,38,17,7,36,206,208,37,115]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=e.$rfc=e.$qfc=e.$pfc=void 0,e.$pfc=(0,M.$Zh)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,u,f,v,g,D){this.E=u,this.F=f,this.G=v,this.H=g,this.I=D,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Rd,this.n=new T.$Rd,this.o=new T.$Rd,this.u=new T.$Rd,this.k=r.getProxy(P.$CK.MainThreadDebugService),this.y=new T.$Rd,this.A=new T.$Rd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(I=>{I.onDidChange(h=>{this.J(I)}),this.J(I)})}asDebugSourceUri(r,u){const f=r;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let v=`debug:${encodeURIComponent(f.path||"")}`,g="?";return u&&(v+=`${g}session=${encodeURIComponent(u.id)}`,g="&"),v+=`${g}ref=${f.sourceReference}`,C.URI.parse(v)}else{if(f.path)return C.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const u=[];for(const f of r.getAllExtensionDescriptions())if(f.contributes){const v=f.contributes.debuggers;if(v&&v.length>0)for(const g of v)(0,p.$mF)(g)&&u.push(g.type)}this.k.$registerDebugTypes(u)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(u=>r.push(u)),r}addBreakpoints(r){const u=r.filter(g=>{const D=g.id;return this.w.has(D)?!1:(this.w.set(D,g),!0)});this.U(u,[],[]);const f=[],v=new Map;for(const g of u)if(g instanceof R.$DL){let D=v.get(g.location.uri.toString());D||(D={type:"sourceMulti",uri:g.location.uri,lines:[]},v.set(g.location.uri.toString(),D),f.push(D)),D.lines.push({id:g.id,enabled:g.enabled,condition:g.condition,hitCondition:g.hitCondition,logMessage:g.logMessage,line:g.location.range.start.line,character:g.location.range.start.character})}else g instanceof R.$EL&&f.push({type:"function",id:g.id,enabled:g.enabled,hitCondition:g.hitCondition,logMessage:g.logMessage,condition:g.condition,functionName:g.functionName});return this.k.$registerBreakpoints(f)}removeBreakpoints(r){const u=r.filter(D=>this.w.delete(D.id));this.U([],u,[]);const f=u.filter(D=>D instanceof R.$DL).map(D=>D.id),v=u.filter(D=>D instanceof R.$EL).map(D=>D.id),g=u.filter(D=>D instanceof R.$FL).map(D=>D.id);return this.k.$unregisterBreakpoints(f,v,g)}startDebugging(r,u,f){return this.k.$startDebugging(r?r.uri:void 0,u,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,u,f){if(!u)return new R.$EK(()=>{});const v=this.d++;return this.f.push({type:r,handle:v,provider:u}),this.k.$registerDebugConfigurationProvider(r,f,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,v),new R.$EK(()=>{this.f=this.f.filter(g=>g.provider!==u),this.k.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(r,u,f){if(!f)return new R.$EK(()=>{});if(!this.Q(r,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.N(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this.g++;return this.h.push({type:u,handle:v,factory:f}),this.k.$registerDebugAdapterDescriptorFactory(u,v),new R.$EK(()=>{this.h=this.h.filter(g=>g.factory!==f),this.k.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(r,u){if(!u)return new R.$EK(()=>{});const f=this.i++;return this.j.push({type:r,handle:f,factory:u}),new R.$EK(()=>{this.j=this.j.filter(v=>v.factory!==u)})}async $runInTerminal(r,u){return Promise.resolve(void 0)}async $substituteVariables(r,u){let f;const v=await this.W(r);return v&&(f={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(f,u)}K(r,u){if(r.type==="implementation")return new c(r.implementation)}L(){}async $startDASession(r,u){const f=this,v=await this.V(u);return this.S(this.N(v.type),v).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const D=this.M(g),I=this.K(D,v);if(!I)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const h=I;return this.B.set(r,h),this.R(v).then(w=>(w&&this.C.set(r,w),h.onMessage(async k=>{if(k.type==="request"&&k.command==="handshake"){const F=k,W={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const Q=await this.D.sign(F.arguments.value);W.body={signature:Q},h.sendResponse(W)}else throw new Error("no signer")}catch(Q){W.success=!1,W.message=Q.message,h.sendResponse(W)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(k),k=(0,p.$rF)(k,!0),f.k.$acceptDAMessage(r,k)}),h.onError(k=>{w&&w.onError&&w.onError(k),this.k.$acceptDAError(r,k.name,k.message,k.stack)}),h.onExit(k=>{w&&w.onExit&&w.onExit(k??void 0,void 0),this.k.$acceptDAExit(r,k??void 0,void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),h.startSession()))})}$sendDAMessage(r,u){u=(0,p.$qF)(u,!1);const f=this.C.get(r);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(u),this.B.get(r)?.sendMessage(u)}$stopDASession(r){const u=this.C.get(r);this.C.delete(r),u&&u.onWillStopSession&&u.onWillStopSession();const f=this.B.get(r);return this.B.delete(r),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const u=[],f=[],v=[];if(r.added)for(const g of r.added){const D=g.id;if(D&&!this.w.has(D)){let I;if(g.type==="function")I=new R.$EL(g.functionName,g.enabled,g.condition,g.hitCondition,g.logMessage);else if(g.type==="data")I=new R.$FL(g.label,g.dataId,g.canPersist,g.enabled,g.hitCondition,g.condition,g.logMessage);else{const h=C.URI.revive(g.uri);I=new R.$DL(new R.$QK(h,new R.$FK(g.line,g.character)),g.enabled,g.condition,g.hitCondition,g.logMessage)}(0,R.$BL)(I,D),this.w.set(D,I),u.push(I)}}if(r.removed)for(const g of r.removed){const D=this.w.get(g);D&&(this.w.delete(g),f.push(D))}if(r.changed){for(const g of r.changed)if(g.id){const D=this.w.get(g.id);if(D){if(D instanceof R.$EL&&g.type==="function"){const I=D;I.enabled=g.enabled,I.condition=g.condition,I.hitCondition=g.hitCondition,I.logMessage=g.logMessage,I.functionName=g.functionName}else if(D instanceof R.$DL&&g.type==="source"){const I=D;I.enabled=g.enabled,I.condition=g.condition,I.hitCondition=g.hitCondition,I.logMessage=g.logMessage,I.location=new R.$QK(C.URI.revive(g.uri),new R.$FK(g.line,g.character))}v.push(D)}}}this.U(u,f,v)}async $acceptStackFrameFocus(r){let u;const f=r.sessionId?await this.V(r.sessionId):void 0;if(!f)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?u=new R.$LL(f,r.threadId):u=new R.$KL(f,r.threadId,r.frameId),this.z=u,this.A.fire(this.z)}$provideDebugConfigurations(r,u,f){return(0,E.$Sg)(async()=>{const v=this.P(r);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const g=await this.W(u);return v.provideDebugConfigurations(g,f)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(r,u,f,v){return(0,E.$Sg)(async()=>{const g=this.P(r);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const D=await this.W(u);return g.resolveDebugConfiguration(D,f,v)})}$resolveDebugConfigurationWithSubstitutedVariables(r,u,f,v){return(0,E.$Sg)(async()=>{const g=this.P(r);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const D=await this.W(u);return g.resolveDebugConfigurationWithSubstitutedVariables(D,f,v)})}async $provideDebugAdapter(r,u){const f=this.O(r);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.V(u);return this.S(f,v).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.M(g)})}async $acceptDebugSessionStarted(r){const u=await this.V(r);this.m.fire(u)}async $acceptDebugSessionTerminated(r){const u=await this.V(r);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,u){(await this.V(r))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(r,u){const v={session:await this.V(r),event:u.event,body:u.body};this.u.fire(v)}M(r){if(r instanceof R.$GL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof R.$HL)return{type:"server",port:r.port,host:r.host};if(r instanceof R.$IL)return{type:"pipeServer",path:r.path};if(r instanceof R.$JL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const u=this.h.filter(f=>f.type===r);if(u.length>0)return u[0].factory}O(r){const u=this.h.filter(f=>f.handle===r);if(u.length>0)return u[0].factory}P(r){const u=this.f.filter(f=>f.handle===r);if(u.length>0)return u[0].provider}Q(r,u){if(r.contributes){const f=r.contributes.debuggers;if(f&&f.length>0){for(const v of f)if(v.label&&v.type&&v.type===u)return!0}}return!1}R(r){const f=r.configuration.type,v=this.j.filter(g=>g.type===f||g.type==="*").map(g=>(0,E.$Sg)(()=>g.factory.createDebugAdapterTracker(r)).then(D=>D,D=>null));return Promise.race([Promise.all(v).then(g=>{const D=g.filter(I=>!!I);if(D.length>0)return new o(D)}),new Promise(g=>setTimeout(()=>g(void 0),1e3))]).catch(g=>{})}async S(r,u){const f=u.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new R.$HL(f));if(r){const g=await this.F.getExtensionRegistry();return(0,E.$Sg)(()=>r.createDebugAdapterDescriptor(u,this.T(u,g))).then(D=>{if(D)return D})}const v=await this.F.getExtensionRegistry();return Promise.resolve(this.T(u,v))}T(r,u){}U(r,u,f){(r.length>0||u.length>0||f.length>0)&&this.y.fire(Object.freeze({added:r,removed:u,changed:f}))}async V(r){if(r)if(typeof r=="string"){const u=this.l.get(r);if(u)return u}else{let u=this.l.get(r.id);if(!u){const f=await this.W(r.folderUri),v=r.parent?this.l.get(r.parent):void 0;u=new t(this.k,r.id,r.type,r.name,f,r.configuration,v),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(r){if(r){const u=C.URI.revive(r);return this.E.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};e.$qfc=s,e.$qfc=s=Ke([We(0,y.$EM),We(1,S.$Iec),We(2,m.$kfc),We(3,b.$Lec),We(4,$.$Xec),We(5,a.$nfc)],s);class t{constructor(r,u,f,v,g,D,I){this.d=r,this.f=u,this.g=f,this.h=v,this.i=g,this.j=D,this.k=I}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,u){return this.d.$customDebugAdapterRequest(this.f,r,u)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$rfc=t;class n{constructor(r){this.value=Object.freeze({append(u){r.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.$sfc=n;class o{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(u=>u.onError?u.onError(r):void 0)}onExit(r,u){this.d.forEach(f=>f.onExit?f.onExit(r,u):void 0)}}class c extends l.$Mfb{constructor(r){super(),this.h=r,r.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let d=class extends s{constructor(r,u,f,v,g,D){super(r,u,f,v,g,D)}};e.$tfc=d,e.$tfc=d=Ke([We(0,y.$EM),We(1,S.$Iec),We(2,m.$kfc),We(3,b.$Lec),We(4,$.$Xec),We(5,a.$nfc)],d)}),define(Pe[287],Re([1,0,11,88,2,3,275,15,70,71,27,184,17,57,38,59]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=e.$vgc=void 0;class s{static async installEarlyHandler(o){Error.stackTraceLimit=100;const c=o.get($.$hj),i=o.get(l.$EM).getProxy(M.$CK.MainThreadErrors);E.setUnexpectedErrorHandler(r=>{c.error(r);const u=E.$2(r);i.$onUnexpectedError(u)})}static async installFullHandler(o){const c=o.get($.$hj),d=o.get(l.$EM),i=o.get(b.$kfc),r=o.get(a.$YM),u=d.getProxy(M.$CK.MainThreadExtensionService),f=d.getProxy(M.$CK.MainThreadErrors),v=await i.getExtensionPathIndex(),g=new WeakMap;function D(w,k){if(g.has(w))return g.get(w).stack;let F="",W,Q;for(const A of k)F+=`
	at ${A.toString()}`,Q=A.getFileName(),!W&&Q&&(W=v.findSubstr(C.URI.file(Q)));const N=`${w.name||"Error"}: ${w.message||""}${F}`;return g.set(w,{extensionIdentifier:W?.identifier,stack:N}),N}const I=Symbol("prepareStackTrace wrapped");let h=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(w){if(w===D||!w||w[I]){h=w||D;return}h=function(k,F){return D(k,F),w.call(Error,k,F)},Object.assign(h,{[I]:!0})}}),E.setUnexpectedErrorHandler(w=>{c.error(w);const k=E.$2(w),F=g.get(w);if(!F?.extensionIdentifier){f.$onUnexpectedError(k);return}u.$onExtensionRuntimeError(F.extensionIdentifier,k);const W=r.onExtensionError(F.extensionIdentifier,w);c.trace("forwarded error to extension?",W,F)})}}e.$vgc=s;class t{constructor(o,c,d,i,r){this.a=d,this.b=new P.$F6b(o,null,i),c=t.e(c,this.b);const u=new y.$Xh(...(0,m.$Hr)());u.set(R.$UM,{_serviceBrand:void 0,...c,messagePorts:r}),u.set(l.$EM,new l.$FM(this.b)),u.set(p.$Fec,new p.$Gec(i)),u.set(b.$ifc,d);const f=new S.$nq(u,!0);f.invokeFunction(s.installEarlyHandler),this.d=f.invokeFunction(v=>v.get($.$hj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=f.invokeFunction(v=>v.get(b.$kfc)),this.c.initialize(),f.invokeFunction(s.installFullHandler)}async asBrowserUri(o){const c=this.b.getProxy(M.$CK.MainThreadExtensionService);return C.URI.revive(await c.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,c){o.extensions.allExtensions.forEach(i=>{i.extensionLocation=C.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),o.environment.appRoot=C.URI.revive(c.transformIncomingURIs(o.environment.appRoot));const d=o.environment.extensionDevelopmentLocationURI;return d&&(o.environment.extensionDevelopmentLocationURI=d.map(i=>C.URI.revive(c.transformIncomingURIs(i)))),o.environment.extensionTestsLocationURI=C.URI.revive(c.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=C.URI.revive(c.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=C.URI.revive(c.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=C.URI.revive(c.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=C.URI.revive(c.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=C.URI.revive(c.transformIncomingURIs(o.logsLocation)),o.workspace=c.transformIncomingURIs(o.workspace),o}}e.$wgc=t}),define(Pe[288],Re([1,0,18,14,19,40,13,20,25,2,44]),function(pe,e,E,T,C,M,P,$,m,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=e.$Jfc=e.$Ifc=e.$Hfc=void 0;class S{constructor(n,o,c,d){this.d=n,this.e=o,this.f=c,this.g=d,this.a=null,this.b=!1,this.c=0}search(n,o){const c=this.d.folderQueries||[],d=new C.$2d(o);return new Promise((i,r)=>{this.a=new p(n);let u=!1;const f=(v,g)=>{if(!u&&!this.b){const D=this.h(v);a(v)&&typeof this.d.maxResults=="number"&&this.c+D>this.d.maxResults&&(this.b=!0,u=!0,d.cancel(),v=this.j(v,this.d.maxResults-this.c));const I=this.h(v);this.c+=I,(I>0||!a(v))&&this.a.add(v,g)}};Promise.all(c.map((v,g)=>this.k(v,D=>f(D,g),d.token))).then(v=>{d.dispose(),this.a.flush();const g=v.some(D=>!!D&&!!D.limitHit);i({limitHit:this.b||g,messages:(0,E.$Qb)(v.map(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[])),stats:{type:this.g}})},v=>{d.dispose();const g=(0,M.$Ki)(v);r(new Error(g))})})}h(n){return a(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,o){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],d=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,o),preview:{matches:d.slice(0,o),text:n.preview.text},uri:n.uri}}async k(n,o,c){const d=new R.$hJ(this.d,n),i=[],r={report:v=>{if(!this.l(v))return;const g=n.folder.scheme===P.Schemas.file?(0,R.$iJ)(()=>this.f.readdir(m.$Ag(v.uri))):void 0,D=m.$Dg(n.folder,v.uri);if(D){const I=d.includedInQuery(D,$.$mc(D),g);(0,T.$Mg)(I)?i.push(I.then(h=>{h&&o(v)})):I&&o(v)}}},u=this.n(n),f=await this.e.provideTextSearchResults(l(this.d.contentPattern),u,r,c);return i.length&&await Promise.all(i),f}l(n){if(a(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const o=(0,R.$gJ)(this.d.includePattern,n.includePattern),c=(0,R.$gJ)(this.d.excludePattern,n.excludePattern),d={folder:y.URI.from(n.folder),excludes:c,includes:o,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return d.usePCRE2=this.d.usePCRE2,d}}e.$Hfc=S;function l(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class p{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new s(512,o=>this.g(o))}add(n,o){this.d&&(this.b!==o||!m.$ug(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:n.uri,results:[]}),this.d.results.push(b(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Ifc=p;function b(t){return a(t)?{preview:{matches:(0,E.$1b)(t.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:t.preview.text},ranges:(0,E.$1b)(t.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function a(t){return!!t.preview}e.$Jfc=a;class s{static{this.a=4e3}static{this.b=50}constructor(n,o){this.g=n,this.h=o,this.c=0,this.d=[],this.e=0}addItem(n,o){n&&this.j(n,o)}addItems(n,o){n&&this.k(n,o)}j(n,o){this.d.push(n),this.e+=o,this.l()}k(n,o){this.d=this.d.concat(n),this.e+=o,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Kfc=s}),define(Pe[117],Re([1,0,6,3,4,283,17,57,15,2,288]),function(pe,e,E,T,C,M,P,$,m,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=e.$Lfc=void 0,e.$Lfc=(0,C.$Zh)("IExtHostSearch");let S=class{constructor(a,s,t){this.k=a,this.l=s,this.n=t,this.c=this.k.getProxy(T.$CK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$Gfc}o(a){return this.l.transformOutgoingScheme(a)}registerTextSearchProvider(a,s){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const t=this.d++;return this.e.set(t,s),this.c.$registerTextSearchProvider(t,this.o(a)),(0,E.$Pc)(()=>{this.g.delete(a),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(a,s){if(this.i.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.i.add(a);const t=this.d++;return this.h.set(t,s),this.c.$registerFileSearchProvider(t,this.o(a)),(0,E.$Pc)(()=>{this.i.delete(a),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(a,s,t,n){const o=l(t),c=this.h.get(a);if(c)return this.j.fileSearch(o,c,d=>{this.c.$handleFileMatch(a,s,d.map(i=>i.resource))},n);throw new Error("unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,s,t){return{messages:[]}}$clearCache(a){return this.j.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,s,t,n){const o=this.e.get(a);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const c=l(t);return this.q(c,o).search(i=>this.c.$handleTextMatch(a,s,i),n)}$enableExtensionHostSearch(){}q(a,s){return new R.$Hfc(a,s,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$Mfc=S,e.$Mfc=S=Ke([We(0,P.$EM),We(1,$.$Fec),We(2,m.$hj)],S);function l(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(p),extraFileResources:b.extraFileResources&&b.extraFileResources.map(a=>y.URI.revive(a))}}e.$Nfc=l;function p(b){return{...b,folder:y.URI.revive(b.folder)}}}),define(Pe[289],Re([1,0,19,11,5,6,13,31,2,145,141,128,92,22,42,15,55,56,197,3,230,238,81,231,232,233,234,235,236,237,212,32,239,37,271,116,109,241,242,243,219,244,61,62,246,38,247,63,248,43,27,249,250,251,252,253,254,82,83,256,282,221,201,222,257,258,111,259,223,260,261,17,262,117,84,263,264,265,85,86,114,59,64,266,267,209,268,224,87,8,7,269,57,270,65,272,273,110,36,207,79,23,113]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s,t,n,o,c,d,i,r,u,f,v,g,D,I,h,w,k,F,W,Q,N,A,L,O,x,le,me,ye,we,de,be,ie,Ie,ce,Y,B,se,Se,Ae,Ce,fe,ne,H,te,X,re,he,De,z,V,G,J,q,ee,ue,Ne,je,Ye,Je,it,_e,tt,rt,nt,ze,ht,_,Z,ve,Be,He,Xe,st,pt,Te,Rt,Kt,Ht,wt,Ut,Ot,Gt,Bt,kt,Tt,Ze,Jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;function Wt(ct){const ft=ct.get(Y.$UM),Vt=ct.get(ce.$nec),At=ct.get(ie.$Nec),Dt=ct.get(de.$kfc),gt=ct.get(Bt.$Iec),Mt=ct.get(ht.$YM),Pt=ct.get(F.$Lec),St=ct.get(Kt.$Fec),Ve=ct.get(Ne.$EM),Nt=ct.get(rt.$7ec),zt=ct.get(nt.$Oec),Qt=ct.get(a.$ij),Ee=ct.get(a.$hj),Me=ct.get(st.$Exb),$e=ct.get(i.$qec),K=ct.get(Gt.$pgc),Le=ct.get(Je.$cfc),Ue=ct.get(ye.$Xec),Qe=ct.get(H.$gfc);Ve.set(o.$DK.ExtHostFileSystemInfo,Vt),Ve.set(o.$DK.ExtHostLogLevelServiceShape,Qt),Ve.set(o.$DK.ExtHostWorkspace,gt),Ve.set(o.$DK.ExtHostConfiguration,Pt),Ve.set(o.$DK.ExtHostExtensionService,Dt),Ve.set(o.$DK.ExtHostStorage,Nt),Ve.set(o.$DK.ExtHostTunnelService,Me),Ve.set(o.$DK.ExtHostWindow,K),Ve.set(o.$DK.ExtHostSecretState,Le),Ve.set(o.$DK.ExtHostTelemetry,Mt),Ve.set(o.$DK.ExtHostEditorTabs,Ue),Ve.set(o.$DK.ExtHostManagedSockets,Qe);const qe=Ve.set(o.$DK.ExtHostDecorations,ct.get(N.$vfc)),et=Ve.set(o.$DK.ExtHostDocumentsAndEditors,ct.get(me.$PM)),ut=Ve.set(o.$DK.ExtHostCommands,ct.get(w.$1M)),vt=Ve.set(o.$DK.ExtHostTerminalService,ct.get(_.$0ec)),$t=Ve.set(o.$DK.ExtHostDebugService,ct.get(Q.$pfc)),Et=Ve.set(o.$DK.ExtHostSearch,ct.get(Ye.$Lfc)),yt=Ve.set(o.$DK.ExtHostTask,ct.get(ze.$cgc)),Di=Ve.set(o.$DK.ExtHostOutputService,ct.get(G.$2fc)),qt=Ve.set(o.$DK.ExtHostLocalization,ct.get(ne.$ffc)),mi=Ve.set(o.$DK.ExtHostUrls,new Ht.$mgc(Ve)),Ct=Ve.set(o.$DK.ExtHostDocuments,new le.$lec(Ve,et)),ki=Ve.set(o.$DK.ExtHostDocumentContentProviders,new O.$xfc(Ve,et,Ee)),Ki=Ve.set(o.$DK.ExtHostDocumentSaveParticipant,new x.$yfc(Ee,Ct,Ve.getProxy(o.$CK.MainThreadBulkEdits))),It=Ve.set(o.$DK.ExtHostNotebook,new X.$Ofc(Ve,ut,et,Ct,At,Et)),ii=Ve.set(o.$DK.ExtHostNotebookDocuments,new he.$Vfc(It)),$i=Ve.set(o.$DK.ExtHostNotebookEditors,new De.$Wfc(Ee,It)),oi=Ve.set(o.$DK.ExtHostNotebookKernels,new z.$Xfc(Ve,ft,It,ut,Ee)),Si=Ve.set(o.$DK.ExtHostNotebookRenderers,new V.$Zfc(Ve,It)),Ii=Ve.set(o.$DK.ExtHostNotebookDocumentSaveParticipant,new re.$Ufc(Ee,It,Ve.getProxy(o.$CK.MainThreadBulkEdits))),Lt=Ve.set(o.$DK.ExtHostEditors,new ve.$Cec(Ve,et)),pi=Ve.set(o.$DK.ExtHostTreeViews,new Xe.$kgc(Ve.getProxy(o.$CK.MainThreadTreeViews),ut,Ee)),Ci=Ve.set(o.$DK.ExtHostEditorInsets,new h.$Dec(Ve.getProxy(o.$CK.MainThreadEditorInsets),Lt,ft.remote)),ai=Ve.set(o.$DK.ExtHostDiagnostics,new A.$pec(Ve,Ee,Vt,et)),ci=Ve.set(o.$DK.ExtHostLanguages,new fe.$Sfc(Ve,Ct,ut.converter,St)),lt=Ve.set(o.$DK.ExtHostLanguageFeatures,new Ce.$tec(Ve,St,Ct,ut,ai,Ee,$e,Mt)),Hi=Ve.set(o.$DK.ExtHostFileSystem,new be.$Afc(Ve,lt)),Xt=Ve.set(o.$DK.ExtHostFileSystemEventService,new Ie.$Bfc(Ve,Ee,et)),ni=Ve.set(o.$DK.ExtHostQuickOpen,(0,ue.$6fc)(Ve,gt,ut)),di=Ve.set(o.$DK.ExtHostSCM,new je.$8fc(Ve,ut,Ct,Ee)),Pi=Ve.set(o.$DK.ExtHostQuickDiff,new ee.$5fc(Ve,St)),Gi=Ve.set(o.$DK.ExtHostShare,new it.$9fc(Ve,St)),Ri=Ve.set(o.$DK.ExtHostComments,(0,k.$Eec)(Ve,ut,Ct)),vi=Ve.set(o.$DK.ExtHostProgress,new q.$4fc(Ve.getProxy(o.$CK.MainThreadProgress))),Ji=Ve.set(o.$DK.ExtHosLabelService,new Ae.$Rfc(Ve)),Ai=Ve.set(o.$DK.ExtHostTheming,new Be.$hgc(Ve)),ui=Ve.set(o.$DK.ExtHostAuthentication,new r.$vec(Ve)),Qi=Ve.set(o.$DK.ExtHostTimeline,new He.$jgc(Ve,ut)),bi=Ve.set(o.$DK.ExtHostWebviews,new wt.$Sec(Ve,ft.remote,gt,Ee,$e)),Mi=Ve.set(o.$DK.ExtHostWebviewPanels,new Ut.$Vec(Ve,bi,gt)),ln=Ve.set(o.$DK.ExtHostCustomEditors,new W.$Wec(Ve,Ct,zt,bi,Mi)),Li=Ve.set(o.$DK.ExtHostWebviewViews,new Ot.$ngc(Ve,bi)),ri=Ve.set(o.$DK.ExtHostTesting,new Z.$dgc(Ve,ut,et)),hn=Ve.set(o.$DK.ExtHostUriOpeners,new Rt.$lgc(Ve)),dn=Ve.set(o.$DK.ExtHostProfileContentHandlers,new J.$3fc(Ve));Ve.set(o.$DK.ExtHostInteractive,new se.$Pfc(Ve,It,et,ut,Ee));const Zi=Ve.set(o.$DK.ExtHostInlineChat,new B.$Cfc(Ve,ut,Ct,Ee)),fi=Ve.set(o.$DK.ExtHostChatProvider,new g.$yec(Ve,Ee)),Yi=Ve.set(o.$DK.ExtHostChatAgents2,new v.$zec(Ve,fi,Ee)),Xi=Ve.set(o.$DK.ExtHostChatVariables,new D.$Aec(Ve)),gi=Ve.set(o.$DK.ExtHostChat,new f.$xec(Ve)),xi=Ve.set(o.$DK.ExtHostAiRelatedInformation,new c.$kec(Ve)),Fi=Ve.set(o.$DK.ExtHostAiEmbeddingVector,new we.$zfc(Ve)),Ti=Ve.set(o.$DK.ExtHostIssueReporter,new Se.$Qfc(Ve)),xt=Ve.set(o.$DK.ExtHostStatusBar,new tt.$_fc(Ve,ut.converter)),wi=Ve.set(o.$DK.ExtHostSpeech,new _e.$0fc(Ve)),fn=Object.values(o.$DK);Ve.assertRegistered(fn);const Zt=new u.$wec(Ve,et),yi=new I.$Bec(Ve),Ei=new te.$Tfc(Ve,Ee),Oi=new L.$wfc(Ve);return d.$uec.register(ut),function(Oe,_t,_i){const mt=function(){let oe=!Oe.isUnderDevelopment;function ge(){oe||(Ee.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),oe=!0)}return function Fe(ot){if(Array.isArray(ot))ot.forEach(Fe);else if(typeof ot=="string")ge();else{const bt=ot;typeof bt.scheme>"u"&&ge(),typeof bt.exclusive=="boolean"&&(0,Ze.$QF)(Oe,"documentFiltersExclusive")}return ot}}(),en={getSession(oe,ge,Fe){return ui.getSession(Oe,oe,ge,Fe)},getSessions(oe,ge){return(0,Ze.$QF)(Oe,"authGetSessions"),ui.getSessions(Oe,oe,ge)},async hasSession(oe,ge){return(0,Ze.$QF)(Oe,"authSession"),!!await ui.getSession(Oe,oe,ge,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(oe,ge,Fe,ot){return ui.registerAuthenticationProvider(oe,ge,Fe,ot)}},gn={registerCommand(oe,ge,Fe){return ut.registerCommand(!0,oe,ge,Fe,void 0,Oe)},registerTextEditorCommand(oe,ge,Fe){return ut.registerCommand(!0,oe,(...ot)=>{const bt=Lt.getActiveTextEditor();if(!bt){Ee.warn("Cannot execute "+oe+" because there is no active text editor.");return}return bt.edit(Ft=>{ge.apply(Fe,[bt,Ft,...ot])}).then(Ft=>{Ft||Ee.warn("Edits from command "+oe+" were not applied.")},Ft=>{Ee.warn("An error occurred while running command "+oe,Ft)})},void 0,void 0,Oe)},registerDiffInformationCommand:(oe,ge,Fe)=>((0,Ze.$QF)(Oe,"diffCommand"),ut.registerCommand(!0,oe,async(...ot)=>{const bt=et.activeEditor(!0);if(!bt){Ee.warn("Cannot execute "+oe+" because there is no active text editor.");return}const Ft=await Lt.getDiffInformation(bt.id);ge.apply(Fe,[Ft,...ot])},void 0,void 0,Oe)),executeCommand(oe,...ge){return ut.executeCommand(oe,...ge)},getCommands(oe=!1){return ut.getCommands(oe)}},tn={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return yi.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return vt.onDidChangeShell},get isTelemetryEnabled(){return Mt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Mt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ze.$QF)(Oe,"telemetry"),Mt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$QF)(Oe,"telemetry"),Mt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,ht.$XM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(oe,ge){return ht.$WM.validateSender(oe),Mt.instantiateLogger(Oe,oe,ge)},openExternal(oe,ge){return K.openUri(oe,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(oe){if(oe.scheme===ft.environment.appUriScheme)return mi.createAppUri(oe);try{return await K.asExternalUri(oe,{allowTunneling:!!ft.remote.authority})}catch(ge){if((0,P.$$f)(oe,P.Schemas.http)||(0,P.$$f)(oe,P.Schemas.https))return oe;throw ge}},get remoteName(){return(0,s.$6k)(ft.remote.authority)},get remoteAuthority(){return(0,Ze.$QF)(Oe,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return Ee.getLevel()},get onDidChangeLogLevel(){return Ee.onDidChangeLogLevel},registerIssueUriRequestHandler(oe){return(0,Ze.$QF)(Oe,"handleIssueUri"),Ti.registerIssueUriRequestHandler(Oe,oe)},registerIssueDataProvider(oe){return(0,Ze.$QF)(Oe,"handleIssueUri"),Ti.registerIssueDataProvider(Oe,oe)},get appQuality(){return(0,Ze.$QF)(Oe,"resolvers"),ft.quality},get appCommit(){return(0,Ze.$QF)(Oe,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(tn);const nn={createTestController(oe,ge,Fe){return ri.createTestController(Oe,oe,ge,Fe)},createTestObserver(){return(0,Ze.$QF)(Oe,"testObserver"),ri.createTestObserver()},runTests(oe){return(0,Ze.$QF)(Oe,"testObserver"),ri.runTests(oe)},get onDidChangeTestResults(){return(0,Ze.$QF)(Oe,"testObserver"),ri.onResultsChanged},get testResults(){return(0,Ze.$QF)(Oe,"testObserver"),ri.results}},li=ft.remote.isRemote?Te.ExtensionKind.Workspace:Te.ExtensionKind.UI,rn={getExtension(oe,ge){(0,Ze.$PF)(Oe,"extensionsAny")||(ge=!1);const Fe=_t.mine.getExtensionDescription(oe);if(Fe)return new de.$lfc(Dt,Oe.identifier,Fe,li,!1);if(ge){const ot=_t.all.getExtensionDescription(oe);if(ot)return new de.$lfc(Dt,Oe.identifier,ot,li,!0)}},get all(){const oe=[];for(const ge of _t.mine.getAllExtensionDescriptions())oe.push(new de.$lfc(Dt,Oe.identifier,ge,li,!1));return oe},get allAcrossExtensionHosts(){(0,Ze.$QF)(Oe,"extensionsAny");const oe=new p.$em(_t.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),ge=[];for(const Fe of _t.all.getAllExtensionDescriptions()){const ot=!oe.has(Fe.identifier);ge.push(new de.$lfc(Dt,Oe.identifier,Fe,li,ot))}return ge},get onDidChange(){return(0,Ze.$PF)(Oe,"extensionsAny")?C.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},sn={createDiagnosticCollection(oe){return ai.createDiagnosticCollection(Oe.identifier,oe)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:oe=>ai.getDiagnostics(oe),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(oe,ge){return ci.changeLanguage(oe.uri,ge)},match(oe,ge){const Fe=Ct.getDocumentData(ge.uri)?.notebook;return(0,R.$PE)(pt.LanguageSelector.from(oe),ge.uri,ge.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(oe,ge,Fe){return lt.registerCodeActionProvider(Oe,mt(oe),ge,Fe)},registerDocumentPasteEditProvider(oe,ge,Fe){return(0,Ze.$QF)(Oe,"documentPaste"),lt.registerDocumentPasteEditProvider(Oe,mt(oe),ge,Fe)},registerCodeLensProvider(oe,ge){return lt.registerCodeLensProvider(Oe,mt(oe),ge)},registerDefinitionProvider(oe,ge){return lt.registerDefinitionProvider(Oe,mt(oe),ge)},registerDeclarationProvider(oe,ge){return lt.registerDeclarationProvider(Oe,mt(oe),ge)},registerImplementationProvider(oe,ge){return lt.registerImplementationProvider(Oe,mt(oe),ge)},registerTypeDefinitionProvider(oe,ge){return lt.registerTypeDefinitionProvider(Oe,mt(oe),ge)},registerHoverProvider(oe,ge){return lt.registerHoverProvider(Oe,mt(oe),ge,Oe.identifier)},registerEvaluatableExpressionProvider(oe,ge){return lt.registerEvaluatableExpressionProvider(Oe,mt(oe),ge,Oe.identifier)},registerInlineValuesProvider(oe,ge){return lt.registerInlineValuesProvider(Oe,mt(oe),ge,Oe.identifier)},registerDocumentHighlightProvider(oe,ge){return lt.registerDocumentHighlightProvider(Oe,mt(oe),ge)},registerLinkedEditingRangeProvider(oe,ge){return lt.registerLinkedEditingRangeProvider(Oe,mt(oe),ge)},registerReferenceProvider(oe,ge){return lt.registerReferenceProvider(Oe,mt(oe),ge)},registerRenameProvider(oe,ge){return lt.registerRenameProvider(Oe,mt(oe),ge)},registerDocumentSymbolProvider(oe,ge,Fe){return lt.registerDocumentSymbolProvider(Oe,mt(oe),ge,Fe)},registerWorkspaceSymbolProvider(oe){return lt.registerWorkspaceSymbolProvider(Oe,oe)},registerDocumentFormattingEditProvider(oe,ge){return lt.registerDocumentFormattingEditProvider(Oe,mt(oe),ge)},registerDocumentRangeFormattingEditProvider(oe,ge){return lt.registerDocumentRangeFormattingEditProvider(Oe,mt(oe),ge)},registerOnTypeFormattingEditProvider(oe,ge,Fe,...ot){return lt.registerOnTypeFormattingEditProvider(Oe,mt(oe),ge,[Fe].concat(ot))},registerDocumentSemanticTokensProvider(oe,ge,Fe){return lt.registerDocumentSemanticTokensProvider(Oe,mt(oe),ge,Fe)},registerDocumentRangeSemanticTokensProvider(oe,ge,Fe){return lt.registerDocumentRangeSemanticTokensProvider(Oe,mt(oe),ge,Fe)},registerSignatureHelpProvider(oe,ge,Fe,...ot){return typeof Fe=="object"?lt.registerSignatureHelpProvider(Oe,mt(oe),ge,Fe):lt.registerSignatureHelpProvider(Oe,mt(oe),ge,typeof Fe>"u"?[]:[Fe,...ot])},registerCompletionItemProvider(oe,ge,...Fe){return lt.registerCompletionItemProvider(Oe,mt(oe),ge,Fe)},registerInlineCompletionItemProvider(oe,ge,Fe){return ge.handleDidShowCompletionItem&&(0,Ze.$QF)(Oe,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$QF)(Oe,"inlineCompletionsAdditions"),Fe&&(0,Ze.$QF)(Oe,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Oe,mt(oe),ge,Fe)},registerDocumentLinkProvider(oe,ge){return lt.registerDocumentLinkProvider(Oe,mt(oe),ge)},registerColorProvider(oe,ge){return lt.registerColorProvider(Oe,mt(oe),ge)},registerFoldingRangeProvider(oe,ge){return lt.registerFoldingRangeProvider(Oe,mt(oe),ge)},registerSelectionRangeProvider(oe,ge){return lt.registerSelectionRangeProvider(Oe,oe,ge)},registerCallHierarchyProvider(oe,ge){return lt.registerCallHierarchyProvider(Oe,oe,ge)},registerTypeHierarchyProvider(oe,ge){return lt.registerTypeHierarchyProvider(Oe,oe,ge)},setLanguageConfiguration:(oe,ge)=>lt.setLanguageConfiguration(Oe,oe,ge),getTokenInformationAtPosition(oe,ge){return(0,Ze.$QF)(Oe,"tokenInformation"),ci.tokenAtPosition(oe,ge)},registerInlayHintsProvider(oe,ge){return lt.registerInlayHintsProvider(Oe,oe,ge)},createLanguageStatusItem(oe,ge){return ci.createLanguageStatusItem(Oe,oe,ge)},registerDocumentDropEditProvider(oe,ge,Fe){return lt.registerDocumentOnDropEditProvider(Oe,oe,ge,(0,Ze.$PF)(Oe,"dropMetadata")?Fe:void 0)}},on={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(oe,ge,Fe){const ot=await(m.URI.isUri(oe)?Promise.resolve(an.openTextDocument(oe)):Promise.resolve(oe));return Lt.showTextDocument(ot,ge,Fe)},createTextEditorDecorationType(oe){return Lt.createTextEditorDecorationType(Oe,oe)},onDidChangeActiveTextEditor(oe,ge,Fe){return Lt.onDidChangeActiveTextEditor(oe,ge,Fe)},onDidChangeVisibleTextEditors(oe,ge,Fe){return Lt.onDidChangeVisibleTextEditors(oe,ge,Fe)},onDidChangeTextEditorSelection(oe,ge,Fe){return Lt.onDidChangeTextEditorSelection(oe,ge,Fe)},onDidChangeTextEditorOptions(oe,ge,Fe){return Lt.onDidChangeTextEditorOptions(oe,ge,Fe)},onDidChangeTextEditorVisibleRanges(oe,ge,Fe){return Lt.onDidChangeTextEditorVisibleRanges(oe,ge,Fe)},onDidChangeTextEditorViewColumn(oe,ge,Fe){return Lt.onDidChangeTextEditorViewColumn(oe,ge,Fe)},onDidCloseTerminal(oe,ge,Fe){return vt.onDidCloseTerminal(oe,ge,Fe)},onDidOpenTerminal(oe,ge,Fe){return vt.onDidOpenTerminal(oe,ge,Fe)},onDidChangeActiveTerminal(oe,ge,Fe){return vt.onDidChangeActiveTerminal(oe,ge,Fe)},onDidChangeTerminalDimensions(oe,ge,Fe){return(0,Ze.$QF)(Oe,"terminalDimensions"),vt.onDidChangeTerminalDimensions(oe,ge,Fe)},onDidChangeTerminalState(oe,ge,Fe){return vt.onDidChangeTerminalState(oe,ge,Fe)},onDidWriteTerminalData(oe,ge,Fe){return(0,Ze.$QF)(Oe,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(oe,ge,Fe)},onDidExecuteTerminalCommand(oe,ge,Fe){return(0,Ze.$QF)(Oe,"terminalExecuteCommandEvent"),vt.onDidExecuteTerminalCommand(oe,ge,Fe)},get state(){return K.getState(Oe)},onDidChangeWindowState(oe,ge,Fe){return K.onDidChangeWindowState(oe,ge,Fe)},showInformationMessage(oe,...ge){return Ei.showMessage(Oe,$.default.Info,oe,ge[0],ge.slice(1))},showWarningMessage(oe,...ge){return Ei.showMessage(Oe,$.default.Warning,oe,ge[0],ge.slice(1))},showErrorMessage(oe,...ge){return Ei.showMessage(Oe,$.default.Error,oe,ge[0],ge.slice(1))},showQuickPick(oe,ge,Fe){return ni.showQuickPick(Oe,oe,ge,Fe)},showWorkspaceFolderPick(oe){return ni.showWorkspaceFolderPick(oe)},showInputBox(oe,ge){return ni.showInput(oe,ge)},showOpenDialog(oe){return Oi.showOpenDialog(Oe,oe)},showSaveDialog(oe){return Oi.showSaveDialog(oe)},createStatusBarItem(oe,ge,Fe){let ot,bt,Ft;return typeof oe=="string"?(ot=oe,bt=ge,Ft=Fe):(bt=oe,Ft=ge),xt.createStatusBarEntry(Oe,ot,bt,Ft)},setStatusBarMessage(oe,ge){return xt.setStatusBarMessage(oe,ge)},withScmProgress(oe){return $e.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),vi.withProgress(Oe,{location:Te.ProgressLocation.SourceControl},(ge,Fe)=>oe({report(ot){}}))},withProgress(oe,ge){return vi.withProgress(Oe,oe,ge)},createOutputChannel(oe,ge){return Di.createOutputChannel(oe,ge,Oe)},createWebviewPanel(oe,ge,Fe,ot){return Mi.createWebviewPanel(Oe,oe,ge,Fe,ot)},createWebviewTextEditorInset(oe,ge,Fe,ot){return(0,Ze.$QF)(Oe,"editorInsets"),Ci.createWebviewEditorInset(oe,ge,Fe,ot,Oe)},createTerminal(oe,ge,Fe){return typeof oe=="object"?"pty"in oe?vt.createExtensionTerminal(oe):vt.createTerminalFromOptions(oe):vt.createTerminal(oe,ge,Fe)},registerTerminalLinkProvider(oe){return vt.registerLinkProvider(oe)},registerTerminalProfileProvider(oe,ge){return vt.registerProfileProvider(Oe,oe,ge)},registerTerminalQuickFixProvider(oe,ge){return(0,Ze.$QF)(Oe,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(oe,Oe.identifier.value,ge)},registerTreeDataProvider(oe,ge){return pi.registerTreeDataProvider(oe,ge,Oe)},createTreeView(oe,ge){return pi.createTreeView(oe,ge,Oe)},registerWebviewPanelSerializer:(oe,ge)=>Mi.registerWebviewPanelSerializer(Oe,oe,ge),registerCustomEditorProvider:(oe,ge,Fe={})=>ln.registerCustomEditorProvider(Oe,oe,ge,Fe),registerFileDecorationProvider(oe){return qe.registerFileDecorationProvider(oe,Oe)},registerUriHandler(oe){return mi.registerUriHandler(Oe,oe)},createQuickPick(){return ni.createQuickPick(Oe)},createInputBox(){return ni.createInputBox(Oe)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(oe,ge,Fe){return Ai.onDidChangeActiveColorTheme(oe,ge,Fe)},registerWebviewViewProvider(oe,ge,Fe){return Li.registerWebviewViewProvider(Oe,oe,ge,Fe?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor(oe,ge,Fe){return It.onDidChangeActiveNotebookEditor(oe,ge,Fe)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return It.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(oe,ge,Fe){return $i.onDidChangeNotebookEditorSelection(oe,ge,Fe)},onDidChangeNotebookEditorVisibleRanges(oe,ge,Fe){return $i.onDidChangeNotebookEditorVisibleRanges(oe,ge,Fe)},showNotebookDocument(oe,ge){return It.showNotebookDocument(oe,ge)},registerExternalUriOpener(oe,ge,Fe){return(0,Ze.$QF)(Oe,"externalUriOpener"),hn.registerExternalUriOpener(Oe.identifier,oe,ge,Fe)},registerProfileContentHandler(oe,ge){return(0,Ze.$QF)(Oe,"profileContentHandlers"),dn.registrProfileContentHandler(Oe,oe,ge)},registerQuickDiffProvider(oe,ge,Fe,ot){return(0,Ze.$QF)(Oe,"quickDiffProvider"),Pi.registerQuickDiffProvider(mt(oe),ge,Fe,ot)},get tabGroups(){return Ue.tabGroups},registerShareProvider(oe,ge){return(0,Ze.$QF)(Oe,"shareProvider"),Gi.registerShareProvider(mt(oe),ge)}},an={get rootPath(){return $e.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(oe){throw new T.$8("rootPath")},getWorkspaceFolder(oe){return gt.getWorkspaceFolder(oe)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(oe){throw new T.$8("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(oe){throw new T.$8("workspaceFile")},updateWorkspaceFolders:(oe,ge,...Fe)=>gt.updateWorkspaceFolders(Oe,oe,ge||0,...Fe),onDidChangeWorkspaceFolders:function(oe,ge,Fe){return gt.onDidChangeWorkspace(oe,ge,Fe)},asRelativePath:(oe,ge)=>gt.getRelativePath(oe,ge),findFiles:(oe,ge,Fe,ot)=>gt.findFiles(oe,ge,Fe,Oe.identifier,ot),findTextInFiles:(oe,ge,Fe,ot)=>{(0,Ze.$QF)(Oe,"findTextInFiles");let bt,Ft;return typeof ge=="object"?(bt=ge,Ft=Fe):(bt={},Ft=ge,ot=Fe),gt.findTextInFiles(oe,bt||{},Ft,Oe.identifier,ot)},save:oe=>((0,Ze.$QF)(Oe,"saveEditor"),gt.save(oe)),saveAs:oe=>((0,Ze.$QF)(Oe,"saveEditor"),gt.saveAs(oe)),saveAll:oe=>gt.saveAll(oe),applyEdit(oe,ge){return Zt.applyWorkspaceEdit(oe,Oe,ge)},createFileSystemWatcher:(oe,ge,Fe,ot)=>{let bt;return typeof ge=="boolean"?bt={ignoreCreateEvents:!!ge,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!ot,correlate:!1}:ge&&((0,Ze.$QF)(Oe,"createFileSystemWatcher"),bt={...ge,correlate:!0}),Xt.createFileSystemWatcher(gt,Oe,oe,bt)},get textDocuments(){return Ct.getAllDocumentData().map(oe=>oe.document)},set textDocuments(oe){throw new T.$8("textDocuments")},openTextDocument(oe){let ge;const Fe=oe;if(typeof oe=="string")ge=Promise.resolve(m.URI.file(oe));else if(m.URI.isUri(oe))ge=Promise.resolve(oe);else if(!Fe||typeof Fe=="object")ge=Ct.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(ot=>Ct.ensureDocumentData(ot).then(bt=>bt.document))},onDidOpenTextDocument:(oe,ge,Fe)=>Ct.onDidAddDocument(oe,ge,Fe),onDidCloseTextDocument:(oe,ge,Fe)=>Ct.onDidRemoveDocument(oe,ge,Fe),onDidChangeTextDocument:(oe,ge,Fe)=>Ct.onDidChangeDocument(oe,ge,Fe),onDidSaveTextDocument:(oe,ge,Fe)=>Ct.onDidSaveDocument(oe,ge,Fe),onWillSaveTextDocument:(oe,ge,Fe)=>Ki.getOnWillSaveTextDocumentEvent(Oe)(oe,ge,Fe),get notebookDocuments(){return It.notebookDocuments.map(oe=>oe.apiNotebook)},async openNotebookDocument(oe,ge){let Fe;if(m.URI.isUri(oe))Fe=oe,await It.openNotebookDocument(oe);else if(typeof oe=="string")Fe=m.URI.revive(await It.createNotebookDocument({viewType:oe,content:ge}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(oe,ge,Fe){return ii.onDidSaveNotebookDocument(oe,ge,Fe)},onDidChangeNotebookDocument(oe,ge,Fe){return ii.onDidChangeNotebookDocument(oe,ge,Fe)},onWillSaveNotebookDocument(oe,ge,Fe){return Ii.getOnWillSaveNotebookDocumentEvent(Oe)(oe,ge,Fe)},get onDidOpenNotebookDocument(){return It.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return It.onDidCloseNotebookDocument},registerNotebookSerializer(oe,ge,Fe,ot){return It.registerNotebookSerializer(Oe,oe,ge,Fe,(0,Ze.$PF)(Oe,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(oe,ge,Fe)=>_i.onDidChangeConfiguration(oe,ge,Fe),getConfiguration(oe,ge){return ge=arguments.length===1?void 0:ge,_i.getConfiguration(oe,ge,Oe)},registerTextDocumentContentProvider(oe,ge){return ki.registerTextDocumentContentProvider(oe,ge)},registerTaskProvider:(oe,ge)=>($e.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Oe,oe,ge)),registerFileSystemProvider(oe,ge,Fe){return(0,M.$Oc)(Hi.registerFileSystemProvider(Oe,oe,ge,Fe),At.addFileSystemProvider(oe,ge,Fe))},get fs(){return At.value},registerFileSearchProvider:(oe,ge)=>((0,Ze.$QF)(Oe,"fileSearchProvider"),Et.registerFileSearchProvider(oe,ge)),registerTextSearchProvider:(oe,ge)=>((0,Ze.$QF)(Oe,"textSearchProvider"),Et.registerTextSearchProvider(oe,ge)),registerRemoteAuthorityResolver:(oe,ge)=>((0,Ze.$QF)(Oe,"resolvers"),Dt.registerRemoteAuthorityResolver(oe,ge)),registerResourceLabelFormatter:oe=>((0,Ze.$QF)(Oe,"resolvers"),Ji.$registerResourceLabelFormatter(oe)),getRemoteExecServer:oe=>((0,Ze.$QF)(Oe,"resolvers"),Dt.getRemoteExecServer(oe)),onDidCreateFiles:(oe,ge,Fe)=>Xt.onDidCreateFile(oe,ge,Fe),onDidDeleteFiles:(oe,ge,Fe)=>Xt.onDidDeleteFile(oe,ge,Fe),onDidRenameFiles:(oe,ge,Fe)=>Xt.onDidRenameFile(oe,ge,Fe),onWillCreateFiles:(oe,ge,Fe)=>Xt.getOnWillCreateFileEvent(Oe)(oe,ge,Fe),onWillDeleteFiles:(oe,ge,Fe)=>Xt.getOnWillDeleteFileEvent(Oe)(oe,ge,Fe),onWillRenameFiles:(oe,ge,Fe)=>Xt.getOnWillRenameFileEvent(Oe)(oe,ge,Fe),openTunnel:oe=>((0,Ze.$QF)(Oe,"tunnels"),Me.openTunnel(Oe,oe).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,Ze.$QF)(Oe,"tunnels"),Me.getTunnels()},onDidChangeTunnels:(oe,ge,Fe)=>((0,Ze.$QF)(Oe,"tunnels"),Me.onDidChangeTunnels(oe,ge,Fe)),registerPortAttributesProvider:(oe,ge)=>((0,Ze.$QF)(Oe,"portsAttributes"),Me.registerPortsAttributesProvider(oe,ge)),registerTunnelProvider:(oe,ge)=>((0,Ze.$QF)(Oe,"tunnelFactory"),Me.registerTunnelProvider(oe,ge)),registerTimelineProvider:(oe,ge)=>((0,Ze.$QF)(Oe,"timeline"),Qi.registerTimelineProvider(oe,ge,Oe.identifier,ut.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:oe=>((0,Ze.$QF)(Oe,"workspaceTrust"),gt.requestWorkspaceTrust(oe)),onDidGrantWorkspaceTrust:(oe,ge,Fe)=>gt.onDidGrantWorkspaceTrust(oe,ge,Fe),registerEditSessionIdentityProvider:(oe,ge)=>((0,Ze.$QF)(Oe,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(oe,ge)),onWillCreateEditSessionIdentity:(oe,ge,Fe)=>((0,Ze.$QF)(Oe,"editSessionIdentityProvider"),gt.getOnWillCreateEditSessionIdentityEvent(Oe)(oe,ge,Fe)),registerCanonicalUriProvider:(oe,ge)=>((0,Ze.$QF)(Oe,"canonicalUriProvider"),gt.registerCanonicalUriProvider(oe,ge)),getCanonicalUri:(oe,ge,Fe)=>((0,Ze.$QF)(Oe,"canonicalUriProvider"),gt.provideCanonicalUri(oe,ge,Fe))},mn={get inputBox(){return $e.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(Oe)},createSourceControl(oe,ge,Fe){return di.createSourceControl(Oe,oe,ge,Fe)},registerSourceControlInputBoxValueProvider(oe){return(0,Ze.$QF)(Oe,"scmInputBoxValueProvider"),di.registerSourceControlInputBoxValueProvider(Oe,oe)}},cn={createCommentController(oe,ge){return Ri.createCommentController(Oe,oe,ge)}},un={get activeDebugSession(){return $t.activeDebugSession},get activeDebugConsole(){return $t.activeDebugConsole},get breakpoints(){return $t.breakpoints},get stackFrameFocus(){return $t.stackFrameFocus},onDidStartDebugSession(oe,ge,Fe){return $t.onDidStartDebugSession(oe,ge,Fe)},onDidTerminateDebugSession(oe,ge,Fe){return $t.onDidTerminateDebugSession(oe,ge,Fe)},onDidChangeActiveDebugSession(oe,ge,Fe){return $t.onDidChangeActiveDebugSession(oe,ge,Fe)},onDidReceiveDebugSessionCustomEvent(oe,ge,Fe){return $t.onDidReceiveDebugSessionCustomEvent(oe,ge,Fe)},onDidChangeBreakpoints(oe,ge,Fe){return $t.onDidChangeBreakpoints(oe,ge,Fe)},onDidChangeStackFrameFocus(oe,ge,Fe){return(0,Ze.$QF)(Oe,"debugFocus"),$t.onDidChangeStackFrameFocus(oe,ge,Fe)},registerDebugConfigurationProvider(oe,ge,Fe){return $t.registerDebugConfigurationProvider(oe,ge,Fe||kt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(oe,ge){return $t.registerDebugAdapterDescriptorFactory(Oe,oe,ge)},registerDebugAdapterTrackerFactory(oe,ge){return $t.registerDebugAdapterTrackerFactory(oe,ge)},startDebugging(oe,ge,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?$t.startDebugging(oe,ge,{parentSession:Fe}):$t.startDebugging(oe,ge,Fe||{})},stopDebugging(oe){return $t.stopDebugging(oe)},addBreakpoints(oe){return $t.addBreakpoints(oe)},removeBreakpoints(oe){return $t.removeBreakpoints(oe)},asDebugSourceUri(oe,ge){return $t.asDebugSourceUri(oe,ge)}},Ni={registerTaskProvider:(oe,ge)=>yt.registerTaskProvider(Oe,oe,ge),fetchTasks:oe=>yt.fetchTasks(oe),executeTask:oe=>yt.executeTask(Oe,oe),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(oe,ge,Fe)=>yt.onDidStartTask(oe,ge,Fe),onDidEndTask:(oe,ge,Fe)=>yt.onDidEndTask(oe,ge,Fe),onDidStartTaskProcess:(oe,ge,Fe)=>yt.onDidStartTaskProcess(oe,ge,Fe),onDidEndTaskProcess:(oe,ge,Fe)=>yt.onDidEndTaskProcess(oe,ge,Fe)},zi={createNotebookController(oe,ge,Fe,ot,bt){return oi.createNotebookController(Oe,oe,ge,Fe,ot,(0,Ze.$PF)(Oe,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(oe,ge)=>It.registerNotebookCellStatusBarItemProvider(Oe,oe,ge),createRendererMessaging(oe){return Si.createRendererMessaging(Oe,oe)},createNotebookControllerDetectionTask(oe){return(0,Ze.$QF)(Oe,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Oe,oe)},registerKernelSourceActionProvider(oe,ge){return(0,Ze.$QF)(Oe,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Oe,oe,ge)},onDidChangeNotebookCellExecutionState(oe,ge,Fe){return(0,Ze.$QF)(Oe,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(oe,ge,Fe)}},ji={t(...oe){if(typeof oe[0]=="string"){const ge=oe.shift(),Fe=!oe||typeof oe[0]!="object"?oe:oe[0];return qt.getMessage(Oe.identifier.value,{message:ge,args:Fe})}return qt.getMessage(Oe.identifier.value,oe[0])},get bundle(){return qt.getBundle(Oe.identifier.value)},get uri(){return qt.getBundleUri(Oe.identifier.value)}},hi={_version:1,registerInteractiveEditorSessionProvider(oe,ge){return(0,Ze.$QF)(Oe,"interactive"),Zi.registerProvider(Oe,oe,ge)},registerInteractiveSessionProvider(oe,ge){return(0,Ze.$QF)(Oe,"interactive"),gi.registerChatProvider(Oe,oe,ge)},sendInteractiveRequestToProvider(oe,ge){return(0,Ze.$QF)(Oe,"interactive"),gi.sendInteractiveRequestToProvider(oe,ge)},get onDidPerformUserAction(){return(0,Ze.$QF)(Oe,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(oe,ge){return(0,Ze.$QF)(Oe,"interactive"),gi.transferChatSession(oe,ge)}},Ui={getRelatedInformation(oe,ge){return(0,Ze.$QF)(Oe,"aiRelatedInformation"),xi.getRelatedInformation(Oe,oe,ge)},registerRelatedInformationProvider(oe,ge){return(0,Ze.$QF)(Oe,"aiRelatedInformation"),xi.registerRelatedInformationProvider(Oe,oe,ge)},registerEmbeddingVectorProvider(oe,ge){return(0,Ze.$QF)(Oe,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(Oe,oe,ge)}},Bi={registerChatResponseProvider(oe,ge,Fe){return(0,Ze.$QF)(Oe,"chatProvider"),fi.registerProvider(Oe.identifier,oe,ge,Fe)},requestChatAccess(oe){return(0,Ze.$QF)(Oe,"chatRequestAccess"),fi.requestChatResponseProvider(Oe.identifier,oe)},registerVariable(oe,ge,Fe){return(0,Ze.$QF)(Oe,"chatVariables"),Xi.registerVariableResolver(Oe,oe,ge,Fe)},registerMappedEditsProvider(oe,ge){return(0,Ze.$QF)(Oe,"mappedEditsProvider"),lt.registerMappedEditsProvider(Oe,oe,ge)},createChatAgent(oe,ge){return(0,Ze.$QF)(Oe,"chatAgents2"),Yi.createChatAgent(Oe,oe,ge)}},Wi={registerSpeechProvider(oe,ge){return(0,Ze.$QF)(Oe,"speech"),wi.registerProvider(Oe.identifier,oe,ge)}};return{version:ft.version,ai:Ui,authentication:en,commands:gn,comments:cn,chat:Bi,debug:un,env:tn,extensions:rn,interactive:hi,l10n:ji,languages:sn,notebooks:zi,scm:mn,speech:Wi,tasks:Ni,tests:nn,window:on,workspace:an,Breakpoint:Te.$CL,TerminalOutputAnchor:Te.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Te.ChatAgentResultFeedbackKind,ChatMessage:Te.$tM,ChatMessageRole:Te.ChatMessageRole,ChatVariableLevel:Te.ChatVariableLevel,CallHierarchyIncomingCall:Te.$2K,CallHierarchyItem:Te.$1K,CallHierarchyOutgoingCall:Te.$3K,CancellationError:T.$4,CancellationTokenSource:E.$2d,CandidatePortSource:o.CandidatePortSource,CodeAction:Te.$XK,CodeActionKind:Te.$YK,CodeActionTriggerKind:Te.CodeActionTriggerKind,CodeLens:Te.$4K,Color:Te.$eL,ColorInformation:Te.$fL,ColorPresentation:Te.$gL,ColorThemeKind:Te.ColorThemeKind,CommentMode:Te.CommentMode,CommentState:Te.CommentState,CommentThreadCollapsibleState:Te.CommentThreadCollapsibleState,CommentThreadState:Te.CommentThreadState,CompletionItem:Te.$$K,CompletionItemKind:Te.CompletionItemKind,CompletionItemTag:Te.CompletionItemTag,CompletionList:Te.$_K,CompletionTriggerKind:Te.CompletionTriggerKind,ConfigurationTarget:Te.ConfigurationTarget,CustomExecution:Te.$oL,DebugAdapterExecutable:Te.$GL,DebugAdapterInlineImplementation:Te.$JL,DebugAdapterNamedPipeServer:Te.$IL,DebugAdapterServer:Te.$HL,DebugConfigurationProviderTriggerKind:kt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Te.DebugConsoleMode,DecorationRangeBehavior:Te.DecorationRangeBehavior,Diagnostic:Te.$SK,DiagnosticRelatedInformation:Te.$RK,DiagnosticSeverity:Te.DiagnosticSeverity,DiagnosticTag:Te.DiagnosticTag,Disposable:Te.$EK,DocumentHighlight:Te.$UK,DocumentHighlightKind:Te.DocumentHighlightKind,DocumentLink:Te.$dL,DocumentSymbol:Te.$WK,EndOfLine:Te.EndOfLine,EnvironmentVariableMutatorType:Te.EnvironmentVariableMutatorType,EvaluatableExpression:Te.$ML,InlineValueText:Te.$NL,InlineValueVariableLookup:Te.$OL,InlineValueEvaluatableExpression:Te.$PL,InlineCompletionTriggerKind:Te.InlineCompletionTriggerKind,EventEmitter:C.$Rd,ExtensionKind:Te.ExtensionKind,ExtensionMode:Te.ExtensionMode,ExternalUriOpenerPriority:Te.ExternalUriOpenerPriority,FileChangeType:Te.FileChangeType,FileDecoration:Te.$ZL,FileDecoration2:Te.$ZL,FileSystemError:Te.$RL,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:Te.$SL,FoldingRangeKind:Te.FoldingRangeKind,FunctionBreakpoint:Te.$EL,InlineCompletionItem:Te.$aL,InlineCompletionList:Te.$bL,Hover:Te.$TK,IndentAction:S.IndentAction,Location:Te.$QK,MarkdownString:Te.$5K,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Te.$6K,PortAutoForwardAction:Te.PortAutoForwardAction,Position:Te.$FK,ProcessExecution:Te.$mL,ProgressLocation:Te.ProgressLocation,QuickInputButtons:Te.$YL,Range:Te.$GK,RelativePattern:Te.$AL,Selection:Te.$HK,SelectionRange:Te.$ZK,SemanticTokens:Te.$VL,SemanticTokensBuilder:Te.$UL,SemanticTokensEdit:Te.$WL,SemanticTokensEdits:Te.$XL,SemanticTokensLegend:Te.$TL,ShellExecution:Te.$nL,ShellQuoting:Te.ShellQuoting,SignatureHelp:Te.$8K,SignatureHelpTriggerKind:Te.SignatureHelpTriggerKind,SignatureInformation:Te.$7K,SnippetString:Te.$PK,SourceBreakpoint:Te.$DL,StandardTokenType:Te.StandardTokenType,StatusBarAlignment:Te.StatusBarAlignment,SymbolInformation:Te.$VK,SymbolKind:Te.SymbolKind,SymbolTag:Te.SymbolTag,Task:Te.$pL,TaskGroup:Te.$lL,TaskPanelKind:Te.TaskPanelKind,TaskRevealKind:Te.TaskRevealKind,TaskScope:Te.TaskScope,TerminalLink:Te.$hL,TerminalQuickFixTerminalCommand:Te.$jL,TerminalQuickFixOpener:Te.$iL,TerminalLocation:Te.TerminalLocation,TerminalProfile:Te.$kL,TerminalExitReason:Te.TerminalExitReason,TextDocumentSaveReason:Te.TextDocumentSaveReason,TextEdit:Te.$LK,SnippetTextEdit:Te.$NK,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Te.TextEditorLineNumbersStyle,TextEditorRevealType:Te.TextEditorRevealType,TextEditorSelectionChangeKind:Te.TextEditorSelectionChangeKind,SyntaxTokenType:Te.SyntaxTokenType,TextDocumentChangeReason:Te.TextDocumentChangeReason,ThemeColor:Te.$zL,ThemeIcon:Te.$yL,TreeItem:Te.$qL,TreeItemCheckboxState:Te.TreeItemCheckboxState,TreeItemCollapsibleState:Te.TreeItemCollapsibleState,TypeHierarchyItem:Te.$iM,UIKind:Tt.UIKind,Uri:m.URI,ViewColumn:Te.ViewColumn,WorkspaceEdit:Te.$OK,DocumentDropEdit:Te.$wL,DocumentPasteEdit:Te.$xL,InlayHint:Te.$0K,InlayHintLabelPart:Te.$9K,InlayHintKind:Te.InlayHintKind,RemoteAuthorityResolverError:Te.$KK,ResolvedAuthority:Te.$IK,ManagedResolvedAuthority:Te.$JK,SourceControlInputBoxValidationType:Te.SourceControlInputBoxValidationType,ExtensionRuntime:Te.ExtensionRuntime,TimelineItem:Te.$0L,NotebookRange:Te.$2L,NotebookCellKind:Te.NotebookCellKind,NotebookCellExecutionState:Te.NotebookCellExecutionState,NotebookCellData:Te.$3L,NotebookData:Te.$4L,NotebookRendererScript:Te.$8L,NotebookCellStatusBarAlignment:Te.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Te.NotebookEditorRevealType,NotebookCellOutput:Te.$6L,NotebookCellOutputItem:Te.$5L,NotebookCellStatusBarItem:Te.$7L,NotebookControllerAffinity:Te.NotebookControllerAffinity,NotebookControllerAffinity2:Te.NotebookControllerAffinity2,NotebookEdit:Te.$MK,NotebookKernelSourceAction:Te.$9L,NotebookVariablesRequestKind:Te.NotebookVariablesRequestKind,PortAttributes:Te.$_L,LinkedEditingRanges:Te.$$L,TestResultState:Te.TestResultState,TestRunRequest:Te.$aM,TestMessage:Te.$bM,TestMessage2:Te.$bM,TestTag:Te.$cM,TestRunProfileKind:Te.TestRunProfileKind,TextSearchCompleteMessageType:Jt.TextSearchCompleteMessageType,DataTransfer:Te.$vL,DataTransferItem:Te.$rL,CoveredCount:Te.$dM,FileCoverage:Te.$eM,StatementCoverage:Te.$fM,BranchCoverage:Te.$gM,FunctionCoverage:Te.$hM,WorkspaceTrustState:Te.WorkspaceTrustState,LanguageStatusSeverity:Te.LanguageStatusSeverity,QuickPickItemKind:Te.QuickPickItemKind,InputBoxValidationSeverity:Te.InputBoxValidationSeverity,TabInputText:Te.$jM,TabInputTextDiff:Te.$kM,TabInputTextMerge:Te.$lM,TabInputCustom:Te.$mM,TabInputNotebook:Te.$oM,TabInputNotebookDiff:Te.$pM,TabInputWebview:Te.$nM,TabInputTerminal:Te.$qM,TabInputInteractiveWindow:Te.$rM,TabInputChat:Te.$sM,TelemetryTrustedValue:t.$to,LogLevel:a.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Te.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Te.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Te.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Te.$KL,ThreadFocus:Te.$LL,RelatedInformationType:Te.RelatedInformationType,SpeechToTextStatus:Te.SpeechToTextStatus}}}e.$qgc=Wt}),define(Pe[290],Re([1,0,70,111,36,109,37,32,61,64,114,116,117,85,87,81,110,63,43,84,59,62,255,15,115,82,83]),function(pe,e,E,T,C,M,P,$,m,y,R,S,l,p,b,a,s,t,n,o,c,d,i,r,u,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Gr)(f.$ffc,f.$efc,1),(0,E.$Gr)(r.$ij,i.$rgc,1),(0,E.$Gr)(a.$qec,a.$rec,1),(0,E.$Gr)($.$1M,$.$ZM,0),(0,E.$Gr)(P.$Lec,P.$Jec,0),(0,E.$Gr)(t.$Nec,t.$Mec,0),(0,E.$Gr)(S.$pfc,S.$tfc,0),(0,E.$Gr)(M.$vfc,M.$ufc,0),(0,E.$Gr)(m.$PM,m.$OM,0),(0,E.$Gr)(v.$gfc,v.$hfc,0),(0,E.$Gr)(n.$nec,n.$mec,0),(0,E.$Gr)(T.$2fc,T.$1fc,1),(0,E.$Gr)(l.$Lfc,l.$Mfc,0),(0,E.$Gr)(p.$7ec,p.$6ec,0),(0,E.$Gr)(R.$cgc,R.$bgc,0),(0,E.$Gr)(y.$0ec,y.$afc,0),(0,E.$Gr)(b.$Exb,b.$Fxb,0),(0,E.$Gr)(s.$pgc,s.$ogc,0),(0,E.$Gr)(C.$Iec,C.$Hec,0),(0,E.$Gr)(o.$cfc,o.$bfc,0),(0,E.$Gr)(c.$YM,c.$VM,0),(0,E.$Gr)(d.$Xec,d.$Yec,0),(0,E.$Gr)(u.$nfc,u.$ofc,0)}),define(Pe[291],Re([1,0,289,38,2,286,7,14,274]),function(pe,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;class y extends M.$ugc{j(){}getModule(p,b){for(const a of this.b){const s=a(p);if(s){p=s;break}}if(this.a.has(p))return this.a.get(p).load(p,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends T.$jfc{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(m.$Aic);const p=this.h.invokeFunction(E.$qgc);this.r=this.h.createInstance(y,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,b,a){b=b.with({path:S(b.path,".js")});const s=p?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const t=C.URI.revive(await this.C.$asBrowserUri(b)),n=await fetch(t.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),n.status!==200)throw new Error(n.statusText);const o=await n.text(),c=`${b.toString(!0)}#vscode-extension`,d=`${o}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",d)}catch(v){throw console.error(s?`Loading code for extension ${s} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${b.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}p&&await this.w.initializeLocalizedMessages(p);const r={},u={exports:r},f=v=>{const g=this.r.getModule(v,b);if(g===void 0)throw new Error(`Cannot load module '${v}'`);return g};try{return a.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),i(u,r,f),u.exports!==r?u.exports:r}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),a.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+p;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,$.$1g)(10)}}e.$Bic=R;function S(l,p){return l.endsWith(p)?l:l+p}}),define(Pe[292],Re([1,0,69,70,15,38,199,86,291]),function(pe,e,E,T,C,M,P,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$Gr)(C.$hj,new E.$Wh(P.$tgc,[!0],!0)),(0,T.$Gr)(M.$kfc,m.$Bic,0),(0,T.$Gr)($.$Oec,$.$Pec,0)}),define(Pe[298],Re([1,0,24,5,79,287,276,20,88,13,2,290,292]),function(pe,e,E,T,C,M,P,$,m,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(i){return/^(file|vscode-remote):/i.test(i)}const b=fetch.bind(self);function a(i){self.fetch=async function(r,u){return r instanceof Request||p(String(r))&&(r=(await i(R.URI.parse(String(r)))).toString(!0)),b(r,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,u,f,v,g){(async()=>(p(u.toString())&&(u=(await i(R.URI.parse(u.toString()))).toString(!0)),super.open(r,u,f??!0,v,g)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(r,u){if(/^file:/i.test(r.toString()))r=y.$ig.uriToBrowserUri(R.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function(h){function w(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const k=fetch.bind(self);self.fetch=function(W,Q){return W instanceof Request?k(W,Q):k(w(W),Q)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,Q,N,A,L){return super.open(W,w(Q),N??!0,A,L)}};const F=importScripts.bind(self);self.importScripts=(...W)=>{F(...W.map(w))},F(h)}.toString()}('${r}'))`;u=u||{},u.name=u.name||$.$mc(r.toString());const g=new Blob([v],{type:"application/javascript"}),D=URL.createObjectURL(g);return new i(D,u)}}else self.Worker=class extends P.$Cic{constructor(i,r){super(l,i,{name:$.$mc(i.toString()),...r})}};const s=new class{constructor(){this.pid=void 0}exit(i){S()}};class t{constructor(){const r=new MessageChannel,u=new T.$Rd;let f=!1;l(r.port2,[r.port2]),r.port1.onmessage=v=>{const{data:g}=v;if(!(g instanceof ArrayBuffer)){console.warn("UNKNOWN data received",g);return}const D=E.$fe.wrap(new Uint8Array(g,0,g.byteLength));if((0,C.$mm)(D,2)){f=!0,o("received terminate message from renderer");return}u.fire(D)},this.protocol={onMessage:u.event,send:v=>{if(!f){const g=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);r.port1.postMessage(g,[g])}}}}}function n(i){return new Promise(r=>{const u=i.onMessage(f=>{u.dispose();const v=JSON.parse(f.toString());i.send((0,C.$lm)(0)),r({protocol:i,initData:v})});i.send((0,C.$lm)(1))})}let o=i=>S();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function d(){m.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(r){c(r)&&n(i.protocol).then(u=>{m.mark("code/extHost/didWaitForInitData");const f=new M.$wgc(u.protocol,u.initData,s,null,r.data);a(v=>f.asBrowserUri(v)),o=v=>f.terminate(v)})}}}e.create=d})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f3da7cb46a8ffbea21998420dc673777715e55cf/core/vs/workbench/api/worker/extensionHostWorker.js.map
